#ifndef ppaa02_AMPLITUDE_SET_HPP
#define ppaa02_AMPLITUDE_SET_HPP

void ppaa02_amplitude_initialization(munich * MUC);

double ppaa22_A0(double s, double t, double u);
double ppaa22_H1f(double s, double t, double u);
double ppaa22_H2f(double s, double t, double u, unsigned int Nf, double Qq);

using namespace std;

class ppaa02_amplitude_set : virtual public amplitude_set {
private:

public:
  ppaa02_amplitude_set();
  ~ppaa02_amplitude_set();
  
  void calculate_H2_QCD_2loop();
  void calculate_H1gg_QCD_2loop();

};


#ifdef OPENLOOPS

class ppaa02_amplitude_OpenLoops_set : public amplitude_OpenLoops_set, public ppaa02_amplitude_set {
private:

public:
  ppaa02_amplitude_OpenLoops_set();
  ~ppaa02_amplitude_OpenLoops_set();
  
};
#endif


#ifdef RECOLA
class ppaa02_amplitude_Recola_set : public amplitude_Recola_set, public ppaa02_amplitude_set {
private:

public:
  ppaa02_amplitude_Recola_set();
  ~ppaa02_amplitude_Recola_set();
  
};
#endif

#endif
