#ifndef ppllll04_DECAY_HPP
#define ppllll04_DECAY_HPP

class ppllll04_amplitude_set;

class ppllll04_decay_DR{
private:
  double I3_q;
  double I3_qp;
  double e_q;
  double e_qp;

  double total_q;

  vector<double_complex> Q_lep;
  vector<double_complex> I_lep;
  
  double_complex LAq1;
  double_complex LAq2;
  double_complex RAq1;
  double_complex RAq2;
  double_complex LBq1;
  double_complex LBq2;
  double_complex RBq1;
  double_complex RBq2;

  double_complex LZu;
  double_complex LZd;
  double_complex RZu;
  double_complex RZd;
  double_complex LW;

public:
  ppllll04_decay_DR();
  ppllll04_decay_DR(TypeV V1, TypeV V2, ppllll04_amplitude_set * asi, vector<int> permutation);
  ~ppllll04_decay_DR();

  TypeV V1;
  TypeV V2;

  vector<double_complex> LR56;
  vector<double_complex> LR78;

  double_complex c_P12;
  double_complex c_Z12;
  double_complex c_W12;

  double_complex L_P;
  double_complex L_Z;
  double_complex L_W;
  double_complex R_P;
  double_complex R_Z;
  double_complex R_W;

  double_complex N_VV;

  vector<double_complex> Q_A;
  vector<double_complex> Q_B;
  vector<double_complex> Q_C;

};


class ppllll04_decay_SR{
private:
  double I3_q;
  double I3_qp;
  double e_q;
  double e_qp;

  vector<double_complex> Q_lep;
  vector<double_complex> I_lep;
  
public:
  ppllll04_decay_SR();
  ppllll04_decay_SR(int resonant_V, TypeV V1, TypeV V2, ppllll04_amplitude_set * asi, vector<int> permutation);
  ~ppllll04_decay_SR();

  int resonant_V;
  TypeV V1;
  TypeV V2;

  vector<double_complex> LR56;
  vector<double_complex> LR78;

  // couplings of the on-shell VB to the lepton pairs
  vector<double_complex> LR5_2;
  vector<double_complex> LR7_1;
  vector<double_complex> LR6_2;
  vector<double_complex> LR8_1;

  vector<double_complex> LR_P5;
  vector<double_complex> LR_Z5;
  vector<double_complex> LR_W5;
  vector<double_complex> LR_P6;
  vector<double_complex> LR_Z6;
  vector<double_complex> LR_W6;
  vector<double_complex> LR_P7;
  vector<double_complex> LR_Z7;
  vector<double_complex> LR_W7;
  vector<double_complex> LR_P8;
  vector<double_complex> LR_Z8;
  vector<double_complex> LR_W8;

  double_complex L_P;
  double_complex L_Z;
  double_complex L_W;
  double_complex R_P;
  double_complex R_Z;
  double_complex R_W;

};

#endif
