#ifndef ppv01_AMPLITUDE_SET_HPP
#define ppv01_AMPLITUDE_SET_HPP

void ppv01_amplitude_initialization(munich * MUC);

using namespace std;

class ppv01_amplitude_set : virtual public amplitude_set {
private:

public:
  ppv01_amplitude_set();
  ~ppv01_amplitude_set();
  
  virtual void calculate_H2_QCD_2loop_initialization_ingredients();
  void calculate_H2_QCD_2loop();
  void calculate_H1gg_QCD_2loop();

  // QCD 2-loop amplitudes
  double_complex F1;
  double_complex F2;
  double delta_I1;
  double beta0;
  // QCD I-operator
  double K;
  double delta_qT;
  double D2a;
  double g1a;
  double delta_I2;
};


#ifdef OPENLOOPS

class ppv01_amplitude_OpenLoops_set : public amplitude_OpenLoops_set, public ppv01_amplitude_set {
private:

public:
  ppv01_amplitude_OpenLoops_set();
  ~ppv01_amplitude_OpenLoops_set();
  
  void initialization_process();

};
#endif


#ifdef RECOLA
class ppv01_amplitude_Recola_set : public amplitude_Recola_set, public ppv01_amplitude_set {
private:

public:
  ppv01_amplitude_Recola_set();
  ~ppv01_amplitude_Recola_set();
  
  void initialization_process();

};
#endif

#endif
