#ifndef pph21_PHASESPACE_SET_HPP
#define pph21_PHASESPACE_SET_HPP

using namespace std;

class pph21_phasespace_set : public phasespace_set {
private:

public:
  pph21_phasespace_set(){}
  ~pph21_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_210_gg_h(int x_a);
  void ac_psp_210_gg_h(int x_a, int channel);
  void ag_psp_210_gg_h(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_310_gg_hg(int x_a);
  void ac_psp_310_gg_hg(int x_a, int channel);
  void ag_psp_310_gg_hg(int x_a, int zero);
  void ax_psp_310_gd_hd(int x_a);
  void ac_psp_310_gd_hd(int x_a, int channel);
  void ag_psp_310_gd_hd(int x_a, int zero);
  void ax_psp_310_gu_hu(int x_a);
  void ac_psp_310_gu_hu(int x_a, int channel);
  void ag_psp_310_gu_hu(int x_a, int zero);
  void ax_psp_310_gdx_hdx(int x_a);
  void ac_psp_310_gdx_hdx(int x_a, int channel);
  void ag_psp_310_gdx_hdx(int x_a, int zero);
  void ax_psp_310_gux_hux(int x_a);
  void ac_psp_310_gux_hux(int x_a, int channel);
  void ag_psp_310_gux_hux(int x_a, int zero);
  void ax_psp_310_ddx_hg(int x_a);
  void ac_psp_310_ddx_hg(int x_a, int channel);
  void ag_psp_310_ddx_hg(int x_a, int zero);
  void ax_psp_310_uux_hg(int x_a);
  void ac_psp_310_uux_hg(int x_a, int channel);
  void ag_psp_310_uux_hg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_410_gg_hgg(int x_a);
  void ac_psp_410_gg_hgg(int x_a, int channel);
  void ag_psp_410_gg_hgg(int x_a, int zero);
  void ax_psp_410_gg_hddx(int x_a);
  void ac_psp_410_gg_hddx(int x_a, int channel);
  void ag_psp_410_gg_hddx(int x_a, int zero);
  void ax_psp_410_gg_huux(int x_a);
  void ac_psp_410_gg_huux(int x_a, int channel);
  void ag_psp_410_gg_huux(int x_a, int zero);
  void ax_psp_410_gd_hgd(int x_a);
  void ac_psp_410_gd_hgd(int x_a, int channel);
  void ag_psp_410_gd_hgd(int x_a, int zero);
  void ax_psp_410_gu_hgu(int x_a);
  void ac_psp_410_gu_hgu(int x_a, int channel);
  void ag_psp_410_gu_hgu(int x_a, int zero);
  void ax_psp_410_gdx_hgdx(int x_a);
  void ac_psp_410_gdx_hgdx(int x_a, int channel);
  void ag_psp_410_gdx_hgdx(int x_a, int zero);
  void ax_psp_410_gux_hgux(int x_a);
  void ac_psp_410_gux_hgux(int x_a, int channel);
  void ag_psp_410_gux_hgux(int x_a, int zero);
  void ax_psp_410_dd_hdd(int x_a);
  void ac_psp_410_dd_hdd(int x_a, int channel);
  void ag_psp_410_dd_hdd(int x_a, int zero);
  void ax_psp_410_du_hdu(int x_a);
  void ac_psp_410_du_hdu(int x_a, int channel);
  void ag_psp_410_du_hdu(int x_a, int zero);
  void ax_psp_410_ds_hds(int x_a);
  void ac_psp_410_ds_hds(int x_a, int channel);
  void ag_psp_410_ds_hds(int x_a, int zero);
  void ax_psp_410_dc_hdc(int x_a);
  void ac_psp_410_dc_hdc(int x_a, int channel);
  void ag_psp_410_dc_hdc(int x_a, int zero);
  void ax_psp_410_ddx_hgg(int x_a);
  void ac_psp_410_ddx_hgg(int x_a, int channel);
  void ag_psp_410_ddx_hgg(int x_a, int zero);
  void ax_psp_410_ddx_hddx(int x_a);
  void ac_psp_410_ddx_hddx(int x_a, int channel);
  void ag_psp_410_ddx_hddx(int x_a, int zero);
  void ax_psp_410_ddx_huux(int x_a);
  void ac_psp_410_ddx_huux(int x_a, int channel);
  void ag_psp_410_ddx_huux(int x_a, int zero);
  void ax_psp_410_ddx_hssx(int x_a);
  void ac_psp_410_ddx_hssx(int x_a, int channel);
  void ag_psp_410_ddx_hssx(int x_a, int zero);
  void ax_psp_410_ddx_hccx(int x_a);
  void ac_psp_410_ddx_hccx(int x_a, int channel);
  void ag_psp_410_ddx_hccx(int x_a, int zero);
  void ax_psp_410_dux_hdux(int x_a);
  void ac_psp_410_dux_hdux(int x_a, int channel);
  void ag_psp_410_dux_hdux(int x_a, int zero);
  void ax_psp_410_dsx_hdsx(int x_a);
  void ac_psp_410_dsx_hdsx(int x_a, int channel);
  void ag_psp_410_dsx_hdsx(int x_a, int zero);
  void ax_psp_410_dcx_hdcx(int x_a);
  void ac_psp_410_dcx_hdcx(int x_a, int channel);
  void ag_psp_410_dcx_hdcx(int x_a, int zero);
  void ax_psp_410_uu_huu(int x_a);
  void ac_psp_410_uu_huu(int x_a, int channel);
  void ag_psp_410_uu_huu(int x_a, int zero);
  void ax_psp_410_uc_huc(int x_a);
  void ac_psp_410_uc_huc(int x_a, int channel);
  void ag_psp_410_uc_huc(int x_a, int zero);
  void ax_psp_410_udx_hudx(int x_a);
  void ac_psp_410_udx_hudx(int x_a, int channel);
  void ag_psp_410_udx_hudx(int x_a, int zero);
  void ax_psp_410_uux_hgg(int x_a);
  void ac_psp_410_uux_hgg(int x_a, int channel);
  void ag_psp_410_uux_hgg(int x_a, int zero);
  void ax_psp_410_uux_hddx(int x_a);
  void ac_psp_410_uux_hddx(int x_a, int channel);
  void ag_psp_410_uux_hddx(int x_a, int zero);
  void ax_psp_410_uux_huux(int x_a);
  void ac_psp_410_uux_huux(int x_a, int channel);
  void ag_psp_410_uux_huux(int x_a, int zero);
  void ax_psp_410_uux_hssx(int x_a);
  void ac_psp_410_uux_hssx(int x_a, int channel);
  void ag_psp_410_uux_hssx(int x_a, int zero);
  void ax_psp_410_uux_hccx(int x_a);
  void ac_psp_410_uux_hccx(int x_a, int channel);
  void ag_psp_410_uux_hccx(int x_a, int zero);
  void ax_psp_410_usx_husx(int x_a);
  void ac_psp_410_usx_husx(int x_a, int channel);
  void ag_psp_410_usx_husx(int x_a, int zero);
  void ax_psp_410_ucx_hucx(int x_a);
  void ac_psp_410_ucx_hucx(int x_a, int channel);
  void ag_psp_410_ucx_hucx(int x_a, int zero);
  void ax_psp_410_dxdx_hdxdx(int x_a);
  void ac_psp_410_dxdx_hdxdx(int x_a, int channel);
  void ag_psp_410_dxdx_hdxdx(int x_a, int zero);
  void ax_psp_410_dxux_hdxux(int x_a);
  void ac_psp_410_dxux_hdxux(int x_a, int channel);
  void ag_psp_410_dxux_hdxux(int x_a, int zero);
  void ax_psp_410_dxsx_hdxsx(int x_a);
  void ac_psp_410_dxsx_hdxsx(int x_a, int channel);
  void ag_psp_410_dxsx_hdxsx(int x_a, int zero);
  void ax_psp_410_dxcx_hdxcx(int x_a);
  void ac_psp_410_dxcx_hdxcx(int x_a, int channel);
  void ag_psp_410_dxcx_hdxcx(int x_a, int zero);
  void ax_psp_410_uxux_huxux(int x_a);
  void ac_psp_410_uxux_huxux(int x_a, int channel);
  void ag_psp_410_uxux_huxux(int x_a, int zero);
  void ax_psp_410_uxcx_huxcx(int x_a);
  void ac_psp_410_uxcx_huxcx(int x_a, int channel);
  void ag_psp_410_uxcx_huxcx(int x_a, int zero);

};
#endif
