#ifndef ppw01_PHASESPACE_SET_HPP
#define ppw01_PHASESPACE_SET_HPP

using namespace std;

class ppw01_phasespace_set : public phasespace_set {
private:

public:
  ppw01_phasespace_set(){}
  ~ppw01_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_010_dux_wm(int x_a);
  void ac_psp_010_dux_wm(int x_a, int channel);
  void ag_psp_010_dux_wm(int x_a, int zero);
  void ax_psp_010_dcx_wm(int x_a);
  void ac_psp_010_dcx_wm(int x_a, int channel);
  void ag_psp_010_dcx_wm(int x_a, int zero);
  void ax_psp_010_sux_wm(int x_a);
  void ac_psp_010_sux_wm(int x_a, int channel);
  void ag_psp_010_sux_wm(int x_a, int zero);
  void ax_psp_010_scx_wm(int x_a);
  void ac_psp_010_scx_wm(int x_a, int channel);
  void ag_psp_010_scx_wm(int x_a, int zero);
  void ax_psp_010_bux_wm(int x_a);
  void ac_psp_010_bux_wm(int x_a, int channel);
  void ag_psp_010_bux_wm(int x_a, int zero);
  void ax_psp_010_bcx_wm(int x_a);
  void ac_psp_010_bcx_wm(int x_a, int channel);
  void ag_psp_010_bcx_wm(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_110_gd_wmu(int x_a);
  void ac_psp_110_gd_wmu(int x_a, int channel);
  void ag_psp_110_gd_wmu(int x_a, int zero);
  void ax_psp_110_gd_wmc(int x_a);
  void ac_psp_110_gd_wmc(int x_a, int channel);
  void ag_psp_110_gd_wmc(int x_a, int zero);
  void ax_psp_110_gs_wmu(int x_a);
  void ac_psp_110_gs_wmu(int x_a, int channel);
  void ag_psp_110_gs_wmu(int x_a, int zero);
  void ax_psp_110_gs_wmc(int x_a);
  void ac_psp_110_gs_wmc(int x_a, int channel);
  void ag_psp_110_gs_wmc(int x_a, int zero);
  void ax_psp_110_gb_wmu(int x_a);
  void ac_psp_110_gb_wmu(int x_a, int channel);
  void ag_psp_110_gb_wmu(int x_a, int zero);
  void ax_psp_110_gb_wmc(int x_a);
  void ac_psp_110_gb_wmc(int x_a, int channel);
  void ag_psp_110_gb_wmc(int x_a, int zero);
  void ax_psp_110_gux_wmdx(int x_a);
  void ac_psp_110_gux_wmdx(int x_a, int channel);
  void ag_psp_110_gux_wmdx(int x_a, int zero);
  void ax_psp_110_gux_wmsx(int x_a);
  void ac_psp_110_gux_wmsx(int x_a, int channel);
  void ag_psp_110_gux_wmsx(int x_a, int zero);
  void ax_psp_110_gux_wmbx(int x_a);
  void ac_psp_110_gux_wmbx(int x_a, int channel);
  void ag_psp_110_gux_wmbx(int x_a, int zero);
  void ax_psp_110_gcx_wmdx(int x_a);
  void ac_psp_110_gcx_wmdx(int x_a, int channel);
  void ag_psp_110_gcx_wmdx(int x_a, int zero);
  void ax_psp_110_gcx_wmsx(int x_a);
  void ac_psp_110_gcx_wmsx(int x_a, int channel);
  void ag_psp_110_gcx_wmsx(int x_a, int zero);
  void ax_psp_110_gcx_wmbx(int x_a);
  void ac_psp_110_gcx_wmbx(int x_a, int channel);
  void ag_psp_110_gcx_wmbx(int x_a, int zero);
  void ax_psp_110_dux_wmg(int x_a);
  void ac_psp_110_dux_wmg(int x_a, int channel);
  void ag_psp_110_dux_wmg(int x_a, int zero);
  void ax_psp_110_dcx_wmg(int x_a);
  void ac_psp_110_dcx_wmg(int x_a, int channel);
  void ag_psp_110_dcx_wmg(int x_a, int zero);
  void ax_psp_110_sux_wmg(int x_a);
  void ac_psp_110_sux_wmg(int x_a, int channel);
  void ag_psp_110_sux_wmg(int x_a, int zero);
  void ax_psp_110_scx_wmg(int x_a);
  void ac_psp_110_scx_wmg(int x_a, int channel);
  void ag_psp_110_scx_wmg(int x_a, int zero);
  void ax_psp_110_bux_wmg(int x_a);
  void ac_psp_110_bux_wmg(int x_a, int channel);
  void ag_psp_110_bux_wmg(int x_a, int zero);
  void ax_psp_110_bcx_wmg(int x_a);
  void ac_psp_110_bcx_wmg(int x_a, int channel);
  void ag_psp_110_bcx_wmg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_210_gg_wmudx(int x_a);
  void ac_psp_210_gg_wmudx(int x_a, int channel);
  void ag_psp_210_gg_wmudx(int x_a, int zero);
  void ax_psp_210_gg_wmusx(int x_a);
  void ac_psp_210_gg_wmusx(int x_a, int channel);
  void ag_psp_210_gg_wmusx(int x_a, int zero);
  void ax_psp_210_gg_wmubx(int x_a);
  void ac_psp_210_gg_wmubx(int x_a, int channel);
  void ag_psp_210_gg_wmubx(int x_a, int zero);
  void ax_psp_210_gg_wmcdx(int x_a);
  void ac_psp_210_gg_wmcdx(int x_a, int channel);
  void ag_psp_210_gg_wmcdx(int x_a, int zero);
  void ax_psp_210_gg_wmcsx(int x_a);
  void ac_psp_210_gg_wmcsx(int x_a, int channel);
  void ag_psp_210_gg_wmcsx(int x_a, int zero);
  void ax_psp_210_gg_wmcbx(int x_a);
  void ac_psp_210_gg_wmcbx(int x_a, int channel);
  void ag_psp_210_gg_wmcbx(int x_a, int zero);
  void ax_psp_210_gd_wmgu(int x_a);
  void ac_psp_210_gd_wmgu(int x_a, int channel);
  void ag_psp_210_gd_wmgu(int x_a, int zero);
  void ax_psp_210_gd_wmgc(int x_a);
  void ac_psp_210_gd_wmgc(int x_a, int channel);
  void ag_psp_210_gd_wmgc(int x_a, int zero);
  void ax_psp_210_gs_wmgu(int x_a);
  void ac_psp_210_gs_wmgu(int x_a, int channel);
  void ag_psp_210_gs_wmgu(int x_a, int zero);
  void ax_psp_210_gs_wmgc(int x_a);
  void ac_psp_210_gs_wmgc(int x_a, int channel);
  void ag_psp_210_gs_wmgc(int x_a, int zero);
  void ax_psp_210_gb_wmgu(int x_a);
  void ac_psp_210_gb_wmgu(int x_a, int channel);
  void ag_psp_210_gb_wmgu(int x_a, int zero);
  void ax_psp_210_gb_wmgc(int x_a);
  void ac_psp_210_gb_wmgc(int x_a, int channel);
  void ag_psp_210_gb_wmgc(int x_a, int zero);
  void ax_psp_210_gux_wmgdx(int x_a);
  void ac_psp_210_gux_wmgdx(int x_a, int channel);
  void ag_psp_210_gux_wmgdx(int x_a, int zero);
  void ax_psp_210_gux_wmgsx(int x_a);
  void ac_psp_210_gux_wmgsx(int x_a, int channel);
  void ag_psp_210_gux_wmgsx(int x_a, int zero);
  void ax_psp_210_gux_wmgbx(int x_a);
  void ac_psp_210_gux_wmgbx(int x_a, int channel);
  void ag_psp_210_gux_wmgbx(int x_a, int zero);
  void ax_psp_210_gcx_wmgdx(int x_a);
  void ac_psp_210_gcx_wmgdx(int x_a, int channel);
  void ag_psp_210_gcx_wmgdx(int x_a, int zero);
  void ax_psp_210_gcx_wmgsx(int x_a);
  void ac_psp_210_gcx_wmgsx(int x_a, int channel);
  void ag_psp_210_gcx_wmgsx(int x_a, int zero);
  void ax_psp_210_gcx_wmgbx(int x_a);
  void ac_psp_210_gcx_wmgbx(int x_a, int channel);
  void ag_psp_210_gcx_wmgbx(int x_a, int zero);
  void ax_psp_210_dd_wmdu(int x_a);
  void ac_psp_210_dd_wmdu(int x_a, int channel);
  void ag_psp_210_dd_wmdu(int x_a, int zero);
  void ax_psp_210_dd_wmdc(int x_a);
  void ac_psp_210_dd_wmdc(int x_a, int channel);
  void ag_psp_210_dd_wmdc(int x_a, int zero);
  void ax_psp_210_du_wmuu(int x_a);
  void ac_psp_210_du_wmuu(int x_a, int channel);
  void ag_psp_210_du_wmuu(int x_a, int zero);
  void ax_psp_210_du_wmuc(int x_a);
  void ac_psp_210_du_wmuc(int x_a, int channel);
  void ag_psp_210_du_wmuc(int x_a, int zero);
  void ax_psp_210_ds_wmdu(int x_a);
  void ac_psp_210_ds_wmdu(int x_a, int channel);
  void ag_psp_210_ds_wmdu(int x_a, int zero);
  void ax_psp_210_ds_wmdc(int x_a);
  void ac_psp_210_ds_wmdc(int x_a, int channel);
  void ag_psp_210_ds_wmdc(int x_a, int zero);
  void ax_psp_210_ds_wmus(int x_a);
  void ac_psp_210_ds_wmus(int x_a, int channel);
  void ag_psp_210_ds_wmus(int x_a, int zero);
  void ax_psp_210_ds_wmsc(int x_a);
  void ac_psp_210_ds_wmsc(int x_a, int channel);
  void ag_psp_210_ds_wmsc(int x_a, int zero);
  void ax_psp_210_dc_wmuc(int x_a);
  void ac_psp_210_dc_wmuc(int x_a, int channel);
  void ag_psp_210_dc_wmuc(int x_a, int zero);
  void ax_psp_210_dc_wmcc(int x_a);
  void ac_psp_210_dc_wmcc(int x_a, int channel);
  void ag_psp_210_dc_wmcc(int x_a, int zero);
  void ax_psp_210_db_wmdu(int x_a);
  void ac_psp_210_db_wmdu(int x_a, int channel);
  void ag_psp_210_db_wmdu(int x_a, int zero);
  void ax_psp_210_db_wmdc(int x_a);
  void ac_psp_210_db_wmdc(int x_a, int channel);
  void ag_psp_210_db_wmdc(int x_a, int zero);
  void ax_psp_210_db_wmub(int x_a);
  void ac_psp_210_db_wmub(int x_a, int channel);
  void ag_psp_210_db_wmub(int x_a, int zero);
  void ax_psp_210_db_wmcb(int x_a);
  void ac_psp_210_db_wmcb(int x_a, int channel);
  void ag_psp_210_db_wmcb(int x_a, int zero);
  void ax_psp_210_ddx_wmudx(int x_a);
  void ac_psp_210_ddx_wmudx(int x_a, int channel);
  void ag_psp_210_ddx_wmudx(int x_a, int zero);
  void ax_psp_210_ddx_wmusx(int x_a);
  void ac_psp_210_ddx_wmusx(int x_a, int channel);
  void ag_psp_210_ddx_wmusx(int x_a, int zero);
  void ax_psp_210_ddx_wmubx(int x_a);
  void ac_psp_210_ddx_wmubx(int x_a, int channel);
  void ag_psp_210_ddx_wmubx(int x_a, int zero);
  void ax_psp_210_ddx_wmcdx(int x_a);
  void ac_psp_210_ddx_wmcdx(int x_a, int channel);
  void ag_psp_210_ddx_wmcdx(int x_a, int zero);
  void ax_psp_210_ddx_wmcsx(int x_a);
  void ac_psp_210_ddx_wmcsx(int x_a, int channel);
  void ag_psp_210_ddx_wmcsx(int x_a, int zero);
  void ax_psp_210_ddx_wmcbx(int x_a);
  void ac_psp_210_ddx_wmcbx(int x_a, int channel);
  void ag_psp_210_ddx_wmcbx(int x_a, int zero);
  void ax_psp_210_dux_wmgg(int x_a);
  void ac_psp_210_dux_wmgg(int x_a, int channel);
  void ag_psp_210_dux_wmgg(int x_a, int zero);
  void ax_psp_210_dux_wmddx(int x_a);
  void ac_psp_210_dux_wmddx(int x_a, int channel);
  void ag_psp_210_dux_wmddx(int x_a, int zero);
  void ax_psp_210_dux_wmdsx(int x_a);
  void ac_psp_210_dux_wmdsx(int x_a, int channel);
  void ag_psp_210_dux_wmdsx(int x_a, int zero);
  void ax_psp_210_dux_wmdbx(int x_a);
  void ac_psp_210_dux_wmdbx(int x_a, int channel);
  void ag_psp_210_dux_wmdbx(int x_a, int zero);
  void ax_psp_210_dux_wmuux(int x_a);
  void ac_psp_210_dux_wmuux(int x_a, int channel);
  void ag_psp_210_dux_wmuux(int x_a, int zero);
  void ax_psp_210_dux_wmssx(int x_a);
  void ac_psp_210_dux_wmssx(int x_a, int channel);
  void ag_psp_210_dux_wmssx(int x_a, int zero);
  void ax_psp_210_dux_wmcux(int x_a);
  void ac_psp_210_dux_wmcux(int x_a, int channel);
  void ag_psp_210_dux_wmcux(int x_a, int zero);
  void ax_psp_210_dux_wmccx(int x_a);
  void ac_psp_210_dux_wmccx(int x_a, int channel);
  void ag_psp_210_dux_wmccx(int x_a, int zero);
  void ax_psp_210_dux_wmbbx(int x_a);
  void ac_psp_210_dux_wmbbx(int x_a, int channel);
  void ag_psp_210_dux_wmbbx(int x_a, int zero);
  void ax_psp_210_dsx_wmusx(int x_a);
  void ac_psp_210_dsx_wmusx(int x_a, int channel);
  void ag_psp_210_dsx_wmusx(int x_a, int zero);
  void ax_psp_210_dsx_wmcsx(int x_a);
  void ac_psp_210_dsx_wmcsx(int x_a, int channel);
  void ag_psp_210_dsx_wmcsx(int x_a, int zero);
  void ax_psp_210_dcx_wmgg(int x_a);
  void ac_psp_210_dcx_wmgg(int x_a, int channel);
  void ag_psp_210_dcx_wmgg(int x_a, int zero);
  void ax_psp_210_dcx_wmddx(int x_a);
  void ac_psp_210_dcx_wmddx(int x_a, int channel);
  void ag_psp_210_dcx_wmddx(int x_a, int zero);
  void ax_psp_210_dcx_wmdsx(int x_a);
  void ac_psp_210_dcx_wmdsx(int x_a, int channel);
  void ag_psp_210_dcx_wmdsx(int x_a, int zero);
  void ax_psp_210_dcx_wmdbx(int x_a);
  void ac_psp_210_dcx_wmdbx(int x_a, int channel);
  void ag_psp_210_dcx_wmdbx(int x_a, int zero);
  void ax_psp_210_dcx_wmuux(int x_a);
  void ac_psp_210_dcx_wmuux(int x_a, int channel);
  void ag_psp_210_dcx_wmuux(int x_a, int zero);
  void ax_psp_210_dcx_wmucx(int x_a);
  void ac_psp_210_dcx_wmucx(int x_a, int channel);
  void ag_psp_210_dcx_wmucx(int x_a, int zero);
  void ax_psp_210_dcx_wmssx(int x_a);
  void ac_psp_210_dcx_wmssx(int x_a, int channel);
  void ag_psp_210_dcx_wmssx(int x_a, int zero);
  void ax_psp_210_dcx_wmccx(int x_a);
  void ac_psp_210_dcx_wmccx(int x_a, int channel);
  void ag_psp_210_dcx_wmccx(int x_a, int zero);
  void ax_psp_210_dcx_wmbbx(int x_a);
  void ac_psp_210_dcx_wmbbx(int x_a, int channel);
  void ag_psp_210_dcx_wmbbx(int x_a, int zero);
  void ax_psp_210_dbx_wmubx(int x_a);
  void ac_psp_210_dbx_wmubx(int x_a, int channel);
  void ag_psp_210_dbx_wmubx(int x_a, int zero);
  void ax_psp_210_dbx_wmcbx(int x_a);
  void ac_psp_210_dbx_wmcbx(int x_a, int channel);
  void ag_psp_210_dbx_wmcbx(int x_a, int zero);
  void ax_psp_210_us_wmuu(int x_a);
  void ac_psp_210_us_wmuu(int x_a, int channel);
  void ag_psp_210_us_wmuu(int x_a, int zero);
  void ax_psp_210_us_wmuc(int x_a);
  void ac_psp_210_us_wmuc(int x_a, int channel);
  void ag_psp_210_us_wmuc(int x_a, int zero);
  void ax_psp_210_ub_wmuu(int x_a);
  void ac_psp_210_ub_wmuu(int x_a, int channel);
  void ag_psp_210_ub_wmuu(int x_a, int zero);
  void ax_psp_210_ub_wmuc(int x_a);
  void ac_psp_210_ub_wmuc(int x_a, int channel);
  void ag_psp_210_ub_wmuc(int x_a, int zero);
  void ax_psp_210_uux_wmudx(int x_a);
  void ac_psp_210_uux_wmudx(int x_a, int channel);
  void ag_psp_210_uux_wmudx(int x_a, int zero);
  void ax_psp_210_uux_wmusx(int x_a);
  void ac_psp_210_uux_wmusx(int x_a, int channel);
  void ag_psp_210_uux_wmusx(int x_a, int zero);
  void ax_psp_210_uux_wmubx(int x_a);
  void ac_psp_210_uux_wmubx(int x_a, int channel);
  void ag_psp_210_uux_wmubx(int x_a, int zero);
  void ax_psp_210_uux_wmcdx(int x_a);
  void ac_psp_210_uux_wmcdx(int x_a, int channel);
  void ag_psp_210_uux_wmcdx(int x_a, int zero);
  void ax_psp_210_uux_wmcsx(int x_a);
  void ac_psp_210_uux_wmcsx(int x_a, int channel);
  void ag_psp_210_uux_wmcsx(int x_a, int zero);
  void ax_psp_210_uux_wmcbx(int x_a);
  void ac_psp_210_uux_wmcbx(int x_a, int channel);
  void ag_psp_210_uux_wmcbx(int x_a, int zero);
  void ax_psp_210_ucx_wmudx(int x_a);
  void ac_psp_210_ucx_wmudx(int x_a, int channel);
  void ag_psp_210_ucx_wmudx(int x_a, int zero);
  void ax_psp_210_ucx_wmusx(int x_a);
  void ac_psp_210_ucx_wmusx(int x_a, int channel);
  void ag_psp_210_ucx_wmusx(int x_a, int zero);
  void ax_psp_210_ucx_wmubx(int x_a);
  void ac_psp_210_ucx_wmubx(int x_a, int channel);
  void ag_psp_210_ucx_wmubx(int x_a, int zero);
  void ax_psp_210_ss_wmus(int x_a);
  void ac_psp_210_ss_wmus(int x_a, int channel);
  void ag_psp_210_ss_wmus(int x_a, int zero);
  void ax_psp_210_ss_wmsc(int x_a);
  void ac_psp_210_ss_wmsc(int x_a, int channel);
  void ag_psp_210_ss_wmsc(int x_a, int zero);
  void ax_psp_210_sc_wmuc(int x_a);
  void ac_psp_210_sc_wmuc(int x_a, int channel);
  void ag_psp_210_sc_wmuc(int x_a, int zero);
  void ax_psp_210_sc_wmcc(int x_a);
  void ac_psp_210_sc_wmcc(int x_a, int channel);
  void ag_psp_210_sc_wmcc(int x_a, int zero);
  void ax_psp_210_sb_wmus(int x_a);
  void ac_psp_210_sb_wmus(int x_a, int channel);
  void ag_psp_210_sb_wmus(int x_a, int zero);
  void ax_psp_210_sb_wmub(int x_a);
  void ac_psp_210_sb_wmub(int x_a, int channel);
  void ag_psp_210_sb_wmub(int x_a, int zero);
  void ax_psp_210_sb_wmsc(int x_a);
  void ac_psp_210_sb_wmsc(int x_a, int channel);
  void ag_psp_210_sb_wmsc(int x_a, int zero);
  void ax_psp_210_sb_wmcb(int x_a);
  void ac_psp_210_sb_wmcb(int x_a, int channel);
  void ag_psp_210_sb_wmcb(int x_a, int zero);
  void ax_psp_210_sdx_wmudx(int x_a);
  void ac_psp_210_sdx_wmudx(int x_a, int channel);
  void ag_psp_210_sdx_wmudx(int x_a, int zero);
  void ax_psp_210_sdx_wmcdx(int x_a);
  void ac_psp_210_sdx_wmcdx(int x_a, int channel);
  void ag_psp_210_sdx_wmcdx(int x_a, int zero);
  void ax_psp_210_sux_wmgg(int x_a);
  void ac_psp_210_sux_wmgg(int x_a, int channel);
  void ag_psp_210_sux_wmgg(int x_a, int zero);
  void ax_psp_210_sux_wmddx(int x_a);
  void ac_psp_210_sux_wmddx(int x_a, int channel);
  void ag_psp_210_sux_wmddx(int x_a, int zero);
  void ax_psp_210_sux_wmuux(int x_a);
  void ac_psp_210_sux_wmuux(int x_a, int channel);
  void ag_psp_210_sux_wmuux(int x_a, int zero);
  void ax_psp_210_sux_wmsdx(int x_a);
  void ac_psp_210_sux_wmsdx(int x_a, int channel);
  void ag_psp_210_sux_wmsdx(int x_a, int zero);
  void ax_psp_210_sux_wmssx(int x_a);
  void ac_psp_210_sux_wmssx(int x_a, int channel);
  void ag_psp_210_sux_wmssx(int x_a, int zero);
  void ax_psp_210_sux_wmsbx(int x_a);
  void ac_psp_210_sux_wmsbx(int x_a, int channel);
  void ag_psp_210_sux_wmsbx(int x_a, int zero);
  void ax_psp_210_sux_wmcux(int x_a);
  void ac_psp_210_sux_wmcux(int x_a, int channel);
  void ag_psp_210_sux_wmcux(int x_a, int zero);
  void ax_psp_210_sux_wmccx(int x_a);
  void ac_psp_210_sux_wmccx(int x_a, int channel);
  void ag_psp_210_sux_wmccx(int x_a, int zero);
  void ax_psp_210_sux_wmbbx(int x_a);
  void ac_psp_210_sux_wmbbx(int x_a, int channel);
  void ag_psp_210_sux_wmbbx(int x_a, int zero);
  void ax_psp_210_ssx_wmudx(int x_a);
  void ac_psp_210_ssx_wmudx(int x_a, int channel);
  void ag_psp_210_ssx_wmudx(int x_a, int zero);
  void ax_psp_210_ssx_wmusx(int x_a);
  void ac_psp_210_ssx_wmusx(int x_a, int channel);
  void ag_psp_210_ssx_wmusx(int x_a, int zero);
  void ax_psp_210_ssx_wmubx(int x_a);
  void ac_psp_210_ssx_wmubx(int x_a, int channel);
  void ag_psp_210_ssx_wmubx(int x_a, int zero);
  void ax_psp_210_ssx_wmcdx(int x_a);
  void ac_psp_210_ssx_wmcdx(int x_a, int channel);
  void ag_psp_210_ssx_wmcdx(int x_a, int zero);
  void ax_psp_210_ssx_wmcsx(int x_a);
  void ac_psp_210_ssx_wmcsx(int x_a, int channel);
  void ag_psp_210_ssx_wmcsx(int x_a, int zero);
  void ax_psp_210_ssx_wmcbx(int x_a);
  void ac_psp_210_ssx_wmcbx(int x_a, int channel);
  void ag_psp_210_ssx_wmcbx(int x_a, int zero);
  void ax_psp_210_scx_wmgg(int x_a);
  void ac_psp_210_scx_wmgg(int x_a, int channel);
  void ag_psp_210_scx_wmgg(int x_a, int zero);
  void ax_psp_210_scx_wmddx(int x_a);
  void ac_psp_210_scx_wmddx(int x_a, int channel);
  void ag_psp_210_scx_wmddx(int x_a, int zero);
  void ax_psp_210_scx_wmuux(int x_a);
  void ac_psp_210_scx_wmuux(int x_a, int channel);
  void ag_psp_210_scx_wmuux(int x_a, int zero);
  void ax_psp_210_scx_wmucx(int x_a);
  void ac_psp_210_scx_wmucx(int x_a, int channel);
  void ag_psp_210_scx_wmucx(int x_a, int zero);
  void ax_psp_210_scx_wmsdx(int x_a);
  void ac_psp_210_scx_wmsdx(int x_a, int channel);
  void ag_psp_210_scx_wmsdx(int x_a, int zero);
  void ax_psp_210_scx_wmssx(int x_a);
  void ac_psp_210_scx_wmssx(int x_a, int channel);
  void ag_psp_210_scx_wmssx(int x_a, int zero);
  void ax_psp_210_scx_wmsbx(int x_a);
  void ac_psp_210_scx_wmsbx(int x_a, int channel);
  void ag_psp_210_scx_wmsbx(int x_a, int zero);
  void ax_psp_210_scx_wmccx(int x_a);
  void ac_psp_210_scx_wmccx(int x_a, int channel);
  void ag_psp_210_scx_wmccx(int x_a, int zero);
  void ax_psp_210_scx_wmbbx(int x_a);
  void ac_psp_210_scx_wmbbx(int x_a, int channel);
  void ag_psp_210_scx_wmbbx(int x_a, int zero);
  void ax_psp_210_sbx_wmubx(int x_a);
  void ac_psp_210_sbx_wmubx(int x_a, int channel);
  void ag_psp_210_sbx_wmubx(int x_a, int zero);
  void ax_psp_210_sbx_wmcbx(int x_a);
  void ac_psp_210_sbx_wmcbx(int x_a, int channel);
  void ag_psp_210_sbx_wmcbx(int x_a, int zero);
  void ax_psp_210_cb_wmuc(int x_a);
  void ac_psp_210_cb_wmuc(int x_a, int channel);
  void ag_psp_210_cb_wmuc(int x_a, int zero);
  void ax_psp_210_cb_wmcc(int x_a);
  void ac_psp_210_cb_wmcc(int x_a, int channel);
  void ag_psp_210_cb_wmcc(int x_a, int zero);
  void ax_psp_210_cux_wmcdx(int x_a);
  void ac_psp_210_cux_wmcdx(int x_a, int channel);
  void ag_psp_210_cux_wmcdx(int x_a, int zero);
  void ax_psp_210_cux_wmcsx(int x_a);
  void ac_psp_210_cux_wmcsx(int x_a, int channel);
  void ag_psp_210_cux_wmcsx(int x_a, int zero);
  void ax_psp_210_cux_wmcbx(int x_a);
  void ac_psp_210_cux_wmcbx(int x_a, int channel);
  void ag_psp_210_cux_wmcbx(int x_a, int zero);
  void ax_psp_210_ccx_wmudx(int x_a);
  void ac_psp_210_ccx_wmudx(int x_a, int channel);
  void ag_psp_210_ccx_wmudx(int x_a, int zero);
  void ax_psp_210_ccx_wmusx(int x_a);
  void ac_psp_210_ccx_wmusx(int x_a, int channel);
  void ag_psp_210_ccx_wmusx(int x_a, int zero);
  void ax_psp_210_ccx_wmubx(int x_a);
  void ac_psp_210_ccx_wmubx(int x_a, int channel);
  void ag_psp_210_ccx_wmubx(int x_a, int zero);
  void ax_psp_210_ccx_wmcdx(int x_a);
  void ac_psp_210_ccx_wmcdx(int x_a, int channel);
  void ag_psp_210_ccx_wmcdx(int x_a, int zero);
  void ax_psp_210_ccx_wmcsx(int x_a);
  void ac_psp_210_ccx_wmcsx(int x_a, int channel);
  void ag_psp_210_ccx_wmcsx(int x_a, int zero);
  void ax_psp_210_ccx_wmcbx(int x_a);
  void ac_psp_210_ccx_wmcbx(int x_a, int channel);
  void ag_psp_210_ccx_wmcbx(int x_a, int zero);
  void ax_psp_210_bb_wmub(int x_a);
  void ac_psp_210_bb_wmub(int x_a, int channel);
  void ag_psp_210_bb_wmub(int x_a, int zero);
  void ax_psp_210_bb_wmcb(int x_a);
  void ac_psp_210_bb_wmcb(int x_a, int channel);
  void ag_psp_210_bb_wmcb(int x_a, int zero);
  void ax_psp_210_bdx_wmudx(int x_a);
  void ac_psp_210_bdx_wmudx(int x_a, int channel);
  void ag_psp_210_bdx_wmudx(int x_a, int zero);
  void ax_psp_210_bdx_wmcdx(int x_a);
  void ac_psp_210_bdx_wmcdx(int x_a, int channel);
  void ag_psp_210_bdx_wmcdx(int x_a, int zero);
  void ax_psp_210_bux_wmgg(int x_a);
  void ac_psp_210_bux_wmgg(int x_a, int channel);
  void ag_psp_210_bux_wmgg(int x_a, int zero);
  void ax_psp_210_bux_wmddx(int x_a);
  void ac_psp_210_bux_wmddx(int x_a, int channel);
  void ag_psp_210_bux_wmddx(int x_a, int zero);
  void ax_psp_210_bux_wmuux(int x_a);
  void ac_psp_210_bux_wmuux(int x_a, int channel);
  void ag_psp_210_bux_wmuux(int x_a, int zero);
  void ax_psp_210_bux_wmssx(int x_a);
  void ac_psp_210_bux_wmssx(int x_a, int channel);
  void ag_psp_210_bux_wmssx(int x_a, int zero);
  void ax_psp_210_bux_wmcux(int x_a);
  void ac_psp_210_bux_wmcux(int x_a, int channel);
  void ag_psp_210_bux_wmcux(int x_a, int zero);
  void ax_psp_210_bux_wmccx(int x_a);
  void ac_psp_210_bux_wmccx(int x_a, int channel);
  void ag_psp_210_bux_wmccx(int x_a, int zero);
  void ax_psp_210_bux_wmbdx(int x_a);
  void ac_psp_210_bux_wmbdx(int x_a, int channel);
  void ag_psp_210_bux_wmbdx(int x_a, int zero);
  void ax_psp_210_bux_wmbsx(int x_a);
  void ac_psp_210_bux_wmbsx(int x_a, int channel);
  void ag_psp_210_bux_wmbsx(int x_a, int zero);
  void ax_psp_210_bux_wmbbx(int x_a);
  void ac_psp_210_bux_wmbbx(int x_a, int channel);
  void ag_psp_210_bux_wmbbx(int x_a, int zero);
  void ax_psp_210_bsx_wmusx(int x_a);
  void ac_psp_210_bsx_wmusx(int x_a, int channel);
  void ag_psp_210_bsx_wmusx(int x_a, int zero);
  void ax_psp_210_bsx_wmcsx(int x_a);
  void ac_psp_210_bsx_wmcsx(int x_a, int channel);
  void ag_psp_210_bsx_wmcsx(int x_a, int zero);
  void ax_psp_210_bcx_wmgg(int x_a);
  void ac_psp_210_bcx_wmgg(int x_a, int channel);
  void ag_psp_210_bcx_wmgg(int x_a, int zero);
  void ax_psp_210_bcx_wmddx(int x_a);
  void ac_psp_210_bcx_wmddx(int x_a, int channel);
  void ag_psp_210_bcx_wmddx(int x_a, int zero);
  void ax_psp_210_bcx_wmuux(int x_a);
  void ac_psp_210_bcx_wmuux(int x_a, int channel);
  void ag_psp_210_bcx_wmuux(int x_a, int zero);
  void ax_psp_210_bcx_wmucx(int x_a);
  void ac_psp_210_bcx_wmucx(int x_a, int channel);
  void ag_psp_210_bcx_wmucx(int x_a, int zero);
  void ax_psp_210_bcx_wmssx(int x_a);
  void ac_psp_210_bcx_wmssx(int x_a, int channel);
  void ag_psp_210_bcx_wmssx(int x_a, int zero);
  void ax_psp_210_bcx_wmccx(int x_a);
  void ac_psp_210_bcx_wmccx(int x_a, int channel);
  void ag_psp_210_bcx_wmccx(int x_a, int zero);
  void ax_psp_210_bcx_wmbdx(int x_a);
  void ac_psp_210_bcx_wmbdx(int x_a, int channel);
  void ag_psp_210_bcx_wmbdx(int x_a, int zero);
  void ax_psp_210_bcx_wmbsx(int x_a);
  void ac_psp_210_bcx_wmbsx(int x_a, int channel);
  void ag_psp_210_bcx_wmbsx(int x_a, int zero);
  void ax_psp_210_bcx_wmbbx(int x_a);
  void ac_psp_210_bcx_wmbbx(int x_a, int channel);
  void ag_psp_210_bcx_wmbbx(int x_a, int zero);
  void ax_psp_210_bbx_wmudx(int x_a);
  void ac_psp_210_bbx_wmudx(int x_a, int channel);
  void ag_psp_210_bbx_wmudx(int x_a, int zero);
  void ax_psp_210_bbx_wmusx(int x_a);
  void ac_psp_210_bbx_wmusx(int x_a, int channel);
  void ag_psp_210_bbx_wmusx(int x_a, int zero);
  void ax_psp_210_bbx_wmubx(int x_a);
  void ac_psp_210_bbx_wmubx(int x_a, int channel);
  void ag_psp_210_bbx_wmubx(int x_a, int zero);
  void ax_psp_210_bbx_wmcdx(int x_a);
  void ac_psp_210_bbx_wmcdx(int x_a, int channel);
  void ag_psp_210_bbx_wmcdx(int x_a, int zero);
  void ax_psp_210_bbx_wmcsx(int x_a);
  void ac_psp_210_bbx_wmcsx(int x_a, int channel);
  void ag_psp_210_bbx_wmcsx(int x_a, int zero);
  void ax_psp_210_bbx_wmcbx(int x_a);
  void ac_psp_210_bbx_wmcbx(int x_a, int channel);
  void ag_psp_210_bbx_wmcbx(int x_a, int zero);
  void ax_psp_210_dxux_wmdxdx(int x_a);
  void ac_psp_210_dxux_wmdxdx(int x_a, int channel);
  void ag_psp_210_dxux_wmdxdx(int x_a, int zero);
  void ax_psp_210_dxux_wmdxsx(int x_a);
  void ac_psp_210_dxux_wmdxsx(int x_a, int channel);
  void ag_psp_210_dxux_wmdxsx(int x_a, int zero);
  void ax_psp_210_dxux_wmdxbx(int x_a);
  void ac_psp_210_dxux_wmdxbx(int x_a, int channel);
  void ag_psp_210_dxux_wmdxbx(int x_a, int zero);
  void ax_psp_210_dxcx_wmdxdx(int x_a);
  void ac_psp_210_dxcx_wmdxdx(int x_a, int channel);
  void ag_psp_210_dxcx_wmdxdx(int x_a, int zero);
  void ax_psp_210_dxcx_wmdxsx(int x_a);
  void ac_psp_210_dxcx_wmdxsx(int x_a, int channel);
  void ag_psp_210_dxcx_wmdxsx(int x_a, int zero);
  void ax_psp_210_dxcx_wmdxbx(int x_a);
  void ac_psp_210_dxcx_wmdxbx(int x_a, int channel);
  void ag_psp_210_dxcx_wmdxbx(int x_a, int zero);
  void ax_psp_210_uxux_wmdxux(int x_a);
  void ac_psp_210_uxux_wmdxux(int x_a, int channel);
  void ag_psp_210_uxux_wmdxux(int x_a, int zero);
  void ax_psp_210_uxux_wmuxsx(int x_a);
  void ac_psp_210_uxux_wmuxsx(int x_a, int channel);
  void ag_psp_210_uxux_wmuxsx(int x_a, int zero);
  void ax_psp_210_uxux_wmuxbx(int x_a);
  void ac_psp_210_uxux_wmuxbx(int x_a, int channel);
  void ag_psp_210_uxux_wmuxbx(int x_a, int zero);
  void ax_psp_210_uxsx_wmdxsx(int x_a);
  void ac_psp_210_uxsx_wmdxsx(int x_a, int channel);
  void ag_psp_210_uxsx_wmdxsx(int x_a, int zero);
  void ax_psp_210_uxsx_wmsxsx(int x_a);
  void ac_psp_210_uxsx_wmsxsx(int x_a, int channel);
  void ag_psp_210_uxsx_wmsxsx(int x_a, int zero);
  void ax_psp_210_uxsx_wmsxbx(int x_a);
  void ac_psp_210_uxsx_wmsxbx(int x_a, int channel);
  void ag_psp_210_uxsx_wmsxbx(int x_a, int zero);
  void ax_psp_210_uxcx_wmdxux(int x_a);
  void ac_psp_210_uxcx_wmdxux(int x_a, int channel);
  void ag_psp_210_uxcx_wmdxux(int x_a, int zero);
  void ax_psp_210_uxcx_wmdxcx(int x_a);
  void ac_psp_210_uxcx_wmdxcx(int x_a, int channel);
  void ag_psp_210_uxcx_wmdxcx(int x_a, int zero);
  void ax_psp_210_uxcx_wmuxsx(int x_a);
  void ac_psp_210_uxcx_wmuxsx(int x_a, int channel);
  void ag_psp_210_uxcx_wmuxsx(int x_a, int zero);
  void ax_psp_210_uxcx_wmuxbx(int x_a);
  void ac_psp_210_uxcx_wmuxbx(int x_a, int channel);
  void ag_psp_210_uxcx_wmuxbx(int x_a, int zero);
  void ax_psp_210_uxcx_wmsxcx(int x_a);
  void ac_psp_210_uxcx_wmsxcx(int x_a, int channel);
  void ag_psp_210_uxcx_wmsxcx(int x_a, int zero);
  void ax_psp_210_uxcx_wmcxbx(int x_a);
  void ac_psp_210_uxcx_wmcxbx(int x_a, int channel);
  void ag_psp_210_uxcx_wmcxbx(int x_a, int zero);
  void ax_psp_210_uxbx_wmdxbx(int x_a);
  void ac_psp_210_uxbx_wmdxbx(int x_a, int channel);
  void ag_psp_210_uxbx_wmdxbx(int x_a, int zero);
  void ax_psp_210_uxbx_wmsxbx(int x_a);
  void ac_psp_210_uxbx_wmsxbx(int x_a, int channel);
  void ag_psp_210_uxbx_wmsxbx(int x_a, int zero);
  void ax_psp_210_uxbx_wmbxbx(int x_a);
  void ac_psp_210_uxbx_wmbxbx(int x_a, int channel);
  void ag_psp_210_uxbx_wmbxbx(int x_a, int zero);
  void ax_psp_210_sxcx_wmdxsx(int x_a);
  void ac_psp_210_sxcx_wmdxsx(int x_a, int channel);
  void ag_psp_210_sxcx_wmdxsx(int x_a, int zero);
  void ax_psp_210_sxcx_wmsxsx(int x_a);
  void ac_psp_210_sxcx_wmsxsx(int x_a, int channel);
  void ag_psp_210_sxcx_wmsxsx(int x_a, int zero);
  void ax_psp_210_sxcx_wmsxbx(int x_a);
  void ac_psp_210_sxcx_wmsxbx(int x_a, int channel);
  void ag_psp_210_sxcx_wmsxbx(int x_a, int zero);
  void ax_psp_210_cxcx_wmdxcx(int x_a);
  void ac_psp_210_cxcx_wmdxcx(int x_a, int channel);
  void ag_psp_210_cxcx_wmdxcx(int x_a, int zero);
  void ax_psp_210_cxcx_wmsxcx(int x_a);
  void ac_psp_210_cxcx_wmsxcx(int x_a, int channel);
  void ag_psp_210_cxcx_wmsxcx(int x_a, int zero);
  void ax_psp_210_cxcx_wmcxbx(int x_a);
  void ac_psp_210_cxcx_wmcxbx(int x_a, int channel);
  void ag_psp_210_cxcx_wmcxbx(int x_a, int zero);
  void ax_psp_210_cxbx_wmdxbx(int x_a);
  void ac_psp_210_cxbx_wmdxbx(int x_a, int channel);
  void ag_psp_210_cxbx_wmdxbx(int x_a, int zero);
  void ax_psp_210_cxbx_wmsxbx(int x_a);
  void ac_psp_210_cxbx_wmsxbx(int x_a, int channel);
  void ag_psp_210_cxbx_wmsxbx(int x_a, int zero);
  void ax_psp_210_cxbx_wmbxbx(int x_a);
  void ac_psp_210_cxbx_wmbxbx(int x_a, int channel);
  void ag_psp_210_cxbx_wmbxbx(int x_a, int zero);

};
#endif
