#ifndef ppzz02_PHASESPACE_SET_HPP
#define ppzz02_PHASESPACE_SET_HPP

using namespace std;

class ppzz02_phasespace_set : public phasespace_set {
private:

public:
  ppzz02_phasespace_set(){}
  ~ppzz02_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_020_ddx_zz(int x_a);
  void ac_psp_020_ddx_zz(int x_a, int channel);
  void ag_psp_020_ddx_zz(int x_a, int zero);
  void ax_psp_020_uux_zz(int x_a);
  void ac_psp_020_uux_zz(int x_a, int channel);
  void ag_psp_020_uux_zz(int x_a, int zero);
  void ax_psp_020_bbx_zz(int x_a);
  void ac_psp_020_bbx_zz(int x_a, int channel);
  void ag_psp_020_bbx_zz(int x_a, int zero);
  void ax_psp_220_gg_zz(int x_a);
  void ac_psp_220_gg_zz(int x_a, int channel);
  void ag_psp_220_gg_zz(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_120_gd_zzd(int x_a);
  void ac_psp_120_gd_zzd(int x_a, int channel);
  void ag_psp_120_gd_zzd(int x_a, int zero);
  void ax_psp_120_gu_zzu(int x_a);
  void ac_psp_120_gu_zzu(int x_a, int channel);
  void ag_psp_120_gu_zzu(int x_a, int zero);
  void ax_psp_120_gb_zzb(int x_a);
  void ac_psp_120_gb_zzb(int x_a, int channel);
  void ag_psp_120_gb_zzb(int x_a, int zero);
  void ax_psp_120_gdx_zzdx(int x_a);
  void ac_psp_120_gdx_zzdx(int x_a, int channel);
  void ag_psp_120_gdx_zzdx(int x_a, int zero);
  void ax_psp_120_gux_zzux(int x_a);
  void ac_psp_120_gux_zzux(int x_a, int channel);
  void ag_psp_120_gux_zzux(int x_a, int zero);
  void ax_psp_120_gbx_zzbx(int x_a);
  void ac_psp_120_gbx_zzbx(int x_a, int channel);
  void ag_psp_120_gbx_zzbx(int x_a, int zero);
  void ax_psp_120_ddx_zzg(int x_a);
  void ac_psp_120_ddx_zzg(int x_a, int channel);
  void ag_psp_120_ddx_zzg(int x_a, int zero);
  void ax_psp_030_da_zzd(int x_a);
  void ac_psp_030_da_zzd(int x_a, int channel);
  void ag_psp_030_da_zzd(int x_a, int zero);
  void ax_psp_120_uux_zzg(int x_a);
  void ac_psp_120_uux_zzg(int x_a, int channel);
  void ag_psp_120_uux_zzg(int x_a, int zero);
  void ax_psp_030_ua_zzu(int x_a);
  void ac_psp_030_ua_zzu(int x_a, int channel);
  void ag_psp_030_ua_zzu(int x_a, int zero);
  void ax_psp_120_bbx_zzg(int x_a);
  void ac_psp_120_bbx_zzg(int x_a, int channel);
  void ag_psp_120_bbx_zzg(int x_a, int zero);
  void ax_psp_030_ba_zzb(int x_a);
  void ac_psp_030_ba_zzb(int x_a, int channel);
  void ag_psp_030_ba_zzb(int x_a, int zero);
  void ax_psp_030_dxa_zzdx(int x_a);
  void ac_psp_030_dxa_zzdx(int x_a, int channel);
  void ag_psp_030_dxa_zzdx(int x_a, int zero);
  void ax_psp_030_uxa_zzux(int x_a);
  void ac_psp_030_uxa_zzux(int x_a, int channel);
  void ag_psp_030_uxa_zzux(int x_a, int zero);
  void ax_psp_030_bxa_zzbx(int x_a);
  void ac_psp_030_bxa_zzbx(int x_a, int channel);
  void ag_psp_030_bxa_zzbx(int x_a, int zero);
  void ax_psp_030_ddx_zza(int x_a);
  void ac_psp_030_ddx_zza(int x_a, int channel);
  void ag_psp_030_ddx_zza(int x_a, int zero);
  void ax_psp_030_uux_zza(int x_a);
  void ac_psp_030_uux_zza(int x_a, int channel);
  void ag_psp_030_uux_zza(int x_a, int zero);
  void ax_psp_030_bbx_zza(int x_a);
  void ac_psp_030_bbx_zza(int x_a, int channel);
  void ag_psp_030_bbx_zza(int x_a, int zero);
  void ax_psp_320_gg_zzg(int x_a);
  void ac_psp_320_gg_zzg(int x_a, int channel);
  void ag_psp_320_gg_zzg(int x_a, int zero);
  void ax_psp_320_gd_zzd(int x_a);
  void ac_psp_320_gd_zzd(int x_a, int channel);
  void ag_psp_320_gd_zzd(int x_a, int zero);
  void ax_psp_320_gu_zzu(int x_a);
  void ac_psp_320_gu_zzu(int x_a, int channel);
  void ag_psp_320_gu_zzu(int x_a, int zero);
  void ax_psp_320_gb_zzb(int x_a);
  void ac_psp_320_gb_zzb(int x_a, int channel);
  void ag_psp_320_gb_zzb(int x_a, int zero);
  void ax_psp_320_gdx_zzdx(int x_a);
  void ac_psp_320_gdx_zzdx(int x_a, int channel);
  void ag_psp_320_gdx_zzdx(int x_a, int zero);
  void ax_psp_320_gux_zzux(int x_a);
  void ac_psp_320_gux_zzux(int x_a, int channel);
  void ag_psp_320_gux_zzux(int x_a, int zero);
  void ax_psp_320_gbx_zzbx(int x_a);
  void ac_psp_320_gbx_zzbx(int x_a, int channel);
  void ag_psp_320_gbx_zzbx(int x_a, int zero);
  void ax_psp_320_ddx_zzg(int x_a);
  void ac_psp_320_ddx_zzg(int x_a, int channel);
  void ag_psp_320_ddx_zzg(int x_a, int zero);
  void ax_psp_320_uux_zzg(int x_a);
  void ac_psp_320_uux_zzg(int x_a, int channel);
  void ag_psp_320_uux_zzg(int x_a, int zero);
  void ax_psp_320_bbx_zzg(int x_a);
  void ac_psp_320_bbx_zzg(int x_a, int channel);
  void ag_psp_320_bbx_zzg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_220_gg_zzddx(int x_a);
  void ac_psp_220_gg_zzddx(int x_a, int channel);
  void ag_psp_220_gg_zzddx(int x_a, int zero);
  void ax_psp_220_gg_zzuux(int x_a);
  void ac_psp_220_gg_zzuux(int x_a, int channel);
  void ag_psp_220_gg_zzuux(int x_a, int zero);
  void ax_psp_220_gg_zzbbx(int x_a);
  void ac_psp_220_gg_zzbbx(int x_a, int channel);
  void ag_psp_220_gg_zzbbx(int x_a, int zero);
  void ax_psp_220_gd_zzgd(int x_a);
  void ac_psp_220_gd_zzgd(int x_a, int channel);
  void ag_psp_220_gd_zzgd(int x_a, int zero);
  void ax_psp_220_gu_zzgu(int x_a);
  void ac_psp_220_gu_zzgu(int x_a, int channel);
  void ag_psp_220_gu_zzgu(int x_a, int zero);
  void ax_psp_220_gb_zzgb(int x_a);
  void ac_psp_220_gb_zzgb(int x_a, int channel);
  void ag_psp_220_gb_zzgb(int x_a, int zero);
  void ax_psp_220_gdx_zzgdx(int x_a);
  void ac_psp_220_gdx_zzgdx(int x_a, int channel);
  void ag_psp_220_gdx_zzgdx(int x_a, int zero);
  void ax_psp_220_gux_zzgux(int x_a);
  void ac_psp_220_gux_zzgux(int x_a, int channel);
  void ag_psp_220_gux_zzgux(int x_a, int zero);
  void ax_psp_220_gbx_zzgbx(int x_a);
  void ac_psp_220_gbx_zzgbx(int x_a, int channel);
  void ag_psp_220_gbx_zzgbx(int x_a, int zero);
  void ax_psp_220_dd_zzdd(int x_a);
  void ac_psp_220_dd_zzdd(int x_a, int channel);
  void ag_psp_220_dd_zzdd(int x_a, int zero);
  void ax_psp_220_du_zzdu(int x_a);
  void ac_psp_220_du_zzdu(int x_a, int channel);
  void ag_psp_220_du_zzdu(int x_a, int zero);
  void ax_psp_220_ds_zzds(int x_a);
  void ac_psp_220_ds_zzds(int x_a, int channel);
  void ag_psp_220_ds_zzds(int x_a, int zero);
  void ax_psp_220_dc_zzdc(int x_a);
  void ac_psp_220_dc_zzdc(int x_a, int channel);
  void ag_psp_220_dc_zzdc(int x_a, int zero);
  void ax_psp_220_db_zzdb(int x_a);
  void ac_psp_220_db_zzdb(int x_a, int channel);
  void ag_psp_220_db_zzdb(int x_a, int zero);
  void ax_psp_220_ddx_zzgg(int x_a);
  void ac_psp_220_ddx_zzgg(int x_a, int channel);
  void ag_psp_220_ddx_zzgg(int x_a, int zero);
  void ax_psp_220_ddx_zzddx(int x_a);
  void ac_psp_220_ddx_zzddx(int x_a, int channel);
  void ag_psp_220_ddx_zzddx(int x_a, int zero);
  void ax_psp_220_ddx_zzuux(int x_a);
  void ac_psp_220_ddx_zzuux(int x_a, int channel);
  void ag_psp_220_ddx_zzuux(int x_a, int zero);
  void ax_psp_220_ddx_zzssx(int x_a);
  void ac_psp_220_ddx_zzssx(int x_a, int channel);
  void ag_psp_220_ddx_zzssx(int x_a, int zero);
  void ax_psp_220_ddx_zzccx(int x_a);
  void ac_psp_220_ddx_zzccx(int x_a, int channel);
  void ag_psp_220_ddx_zzccx(int x_a, int zero);
  void ax_psp_220_ddx_zzbbx(int x_a);
  void ac_psp_220_ddx_zzbbx(int x_a, int channel);
  void ag_psp_220_ddx_zzbbx(int x_a, int zero);
  void ax_psp_220_dux_zzdux(int x_a);
  void ac_psp_220_dux_zzdux(int x_a, int channel);
  void ag_psp_220_dux_zzdux(int x_a, int zero);
  void ax_psp_220_dsx_zzdsx(int x_a);
  void ac_psp_220_dsx_zzdsx(int x_a, int channel);
  void ag_psp_220_dsx_zzdsx(int x_a, int zero);
  void ax_psp_220_dcx_zzdcx(int x_a);
  void ac_psp_220_dcx_zzdcx(int x_a, int channel);
  void ag_psp_220_dcx_zzdcx(int x_a, int zero);
  void ax_psp_220_dbx_zzdbx(int x_a);
  void ac_psp_220_dbx_zzdbx(int x_a, int channel);
  void ag_psp_220_dbx_zzdbx(int x_a, int zero);
  void ax_psp_220_uu_zzuu(int x_a);
  void ac_psp_220_uu_zzuu(int x_a, int channel);
  void ag_psp_220_uu_zzuu(int x_a, int zero);
  void ax_psp_220_uc_zzuc(int x_a);
  void ac_psp_220_uc_zzuc(int x_a, int channel);
  void ag_psp_220_uc_zzuc(int x_a, int zero);
  void ax_psp_220_ub_zzub(int x_a);
  void ac_psp_220_ub_zzub(int x_a, int channel);
  void ag_psp_220_ub_zzub(int x_a, int zero);
  void ax_psp_220_udx_zzudx(int x_a);
  void ac_psp_220_udx_zzudx(int x_a, int channel);
  void ag_psp_220_udx_zzudx(int x_a, int zero);
  void ax_psp_220_uux_zzgg(int x_a);
  void ac_psp_220_uux_zzgg(int x_a, int channel);
  void ag_psp_220_uux_zzgg(int x_a, int zero);
  void ax_psp_220_uux_zzddx(int x_a);
  void ac_psp_220_uux_zzddx(int x_a, int channel);
  void ag_psp_220_uux_zzddx(int x_a, int zero);
  void ax_psp_220_uux_zzuux(int x_a);
  void ac_psp_220_uux_zzuux(int x_a, int channel);
  void ag_psp_220_uux_zzuux(int x_a, int zero);
  void ax_psp_220_uux_zzssx(int x_a);
  void ac_psp_220_uux_zzssx(int x_a, int channel);
  void ag_psp_220_uux_zzssx(int x_a, int zero);
  void ax_psp_220_uux_zzccx(int x_a);
  void ac_psp_220_uux_zzccx(int x_a, int channel);
  void ag_psp_220_uux_zzccx(int x_a, int zero);
  void ax_psp_220_uux_zzbbx(int x_a);
  void ac_psp_220_uux_zzbbx(int x_a, int channel);
  void ag_psp_220_uux_zzbbx(int x_a, int zero);
  void ax_psp_220_usx_zzusx(int x_a);
  void ac_psp_220_usx_zzusx(int x_a, int channel);
  void ag_psp_220_usx_zzusx(int x_a, int zero);
  void ax_psp_220_ucx_zzucx(int x_a);
  void ac_psp_220_ucx_zzucx(int x_a, int channel);
  void ag_psp_220_ucx_zzucx(int x_a, int zero);
  void ax_psp_220_ubx_zzubx(int x_a);
  void ac_psp_220_ubx_zzubx(int x_a, int channel);
  void ag_psp_220_ubx_zzubx(int x_a, int zero);
  void ax_psp_220_bb_zzbb(int x_a);
  void ac_psp_220_bb_zzbb(int x_a, int channel);
  void ag_psp_220_bb_zzbb(int x_a, int zero);
  void ax_psp_220_bdx_zzbdx(int x_a);
  void ac_psp_220_bdx_zzbdx(int x_a, int channel);
  void ag_psp_220_bdx_zzbdx(int x_a, int zero);
  void ax_psp_220_bux_zzbux(int x_a);
  void ac_psp_220_bux_zzbux(int x_a, int channel);
  void ag_psp_220_bux_zzbux(int x_a, int zero);
  void ax_psp_220_bbx_zzgg(int x_a);
  void ac_psp_220_bbx_zzgg(int x_a, int channel);
  void ag_psp_220_bbx_zzgg(int x_a, int zero);
  void ax_psp_220_bbx_zzddx(int x_a);
  void ac_psp_220_bbx_zzddx(int x_a, int channel);
  void ag_psp_220_bbx_zzddx(int x_a, int zero);
  void ax_psp_220_bbx_zzuux(int x_a);
  void ac_psp_220_bbx_zzuux(int x_a, int channel);
  void ag_psp_220_bbx_zzuux(int x_a, int zero);
  void ax_psp_220_bbx_zzbbx(int x_a);
  void ac_psp_220_bbx_zzbbx(int x_a, int channel);
  void ag_psp_220_bbx_zzbbx(int x_a, int zero);
  void ax_psp_220_dxdx_zzdxdx(int x_a);
  void ac_psp_220_dxdx_zzdxdx(int x_a, int channel);
  void ag_psp_220_dxdx_zzdxdx(int x_a, int zero);
  void ax_psp_220_dxux_zzdxux(int x_a);
  void ac_psp_220_dxux_zzdxux(int x_a, int channel);
  void ag_psp_220_dxux_zzdxux(int x_a, int zero);
  void ax_psp_220_dxsx_zzdxsx(int x_a);
  void ac_psp_220_dxsx_zzdxsx(int x_a, int channel);
  void ag_psp_220_dxsx_zzdxsx(int x_a, int zero);
  void ax_psp_220_dxcx_zzdxcx(int x_a);
  void ac_psp_220_dxcx_zzdxcx(int x_a, int channel);
  void ag_psp_220_dxcx_zzdxcx(int x_a, int zero);
  void ax_psp_220_dxbx_zzdxbx(int x_a);
  void ac_psp_220_dxbx_zzdxbx(int x_a, int channel);
  void ag_psp_220_dxbx_zzdxbx(int x_a, int zero);
  void ax_psp_220_uxux_zzuxux(int x_a);
  void ac_psp_220_uxux_zzuxux(int x_a, int channel);
  void ag_psp_220_uxux_zzuxux(int x_a, int zero);
  void ax_psp_220_uxcx_zzuxcx(int x_a);
  void ac_psp_220_uxcx_zzuxcx(int x_a, int channel);
  void ag_psp_220_uxcx_zzuxcx(int x_a, int zero);
  void ax_psp_220_uxbx_zzuxbx(int x_a);
  void ac_psp_220_uxbx_zzuxbx(int x_a, int channel);
  void ag_psp_220_uxbx_zzuxbx(int x_a, int zero);
  void ax_psp_220_bxbx_zzbxbx(int x_a);
  void ac_psp_220_bxbx_zzbxbx(int x_a, int channel);
  void ag_psp_220_bxbx_zzbxbx(int x_a, int zero);

};
#endif
