#ifndef INPUTPARAMETERSET_H
#define INPUTPARAMETERSET_H

class inputline;

class inputparameter_set{
private:

public:
  inputparameter_set();
  inputparameter_set(string basic_process_class, string subprocess);

  void initialization_default();
  void initialization(string subprocess);
  void initialization();
  void initialization_input_modification();

  // inputparameter.assignment.cpp
  void select_input_input_from_userinput();
  void select_event_input_from_userinput();
  void select_phasespace_input_from_userinput();
  void select_observable_input_from_userinput();
  void select_contribution_input_from_userinput();
  void select_amplitude_input_from_userinput();
  void select_amplitude_OpenLoops_input_from_userinput();
  void select_amplitude_Recola_input_from_userinput();
  void select_userdefined_input_from_userinput();

  void select_model_input_from_userinput();
  void select_distribution_input_from_userinput();
  void select_dddistribution_input_from_userinput();

  void select_leftover_input_from_userinput();

  void parameter_readin_file(string filename, vector<string> & readin, bool essential, int retry);
  void parameter_readin_reset(vector<string> & readin);

  void parameter_readin(string & subprocess, vector<string> & readin);
  void model_readin(string & subprocess, vector<string> & readin);
  void distribution_readin(string & subprocess, vector<string> & readin);

  void get_userinput_from_readin(vector<string> & user_variable, vector<string> & user_variable_additional, vector<string> & user_value, vector<string> & readin);

  void get_userinput_from_readin(vector<string> & readin, vector<inputline> & input);

  void reset_input_flag();
  bool check_input_flag(vector<inputline> & this_input, int i_i);
  
  friend std::ostream & operator << (std::ostream &, const inputparameter_set &);

  string path_MUNICH;

  string output_level;

  //////////////////////////////////////////////////
  //  parameters determined during input read-in  //
  //////////////////////////////////////////////////

  int max_perturbative_QCD_order;
  int present_type_perturbative_order;
  int temp_type_perturbative_order;
  int type_perturbative_order_counter;
  vector<string> collection_type_perturbative_order;
  int present_type_contribution;
  int temp_type_contribution;
  int type_contribution_counter;
  vector<string> collection_type_contribution;
  int present_type_correction;
  int temp_type_correction;
  int type_correction_counter;
  vector<string> collection_type_correction;
  int present_type_subprocess;
  int temp_type_subprocess;
  int type_subprocess_counter;
  vector<string> collection_type_subprocess;

  // Check if really needed in isi !!!
  vector<string> contribution_LHAPDFname;
  vector<int> contribution_LHAPDFsubset;
  string LHAPDFname;
  int LHAPDFsubset;

  vector<inputline> input_complete;
  vector<inputline> input_input;

  vector<inputline> input_phasespace;
  vector<inputline> input_observable;
  vector<inputline> input_contribution;
  vector<inputline> input_event;
  vector<inputline> input_amplitude;
  vector<inputline> input_amplitude_OpenLoops;
  vector<inputline> input_amplitude_Recola;
  vector<inputline> input_userdefined;

  vector<inputline> input_model;
  vector<inputline> input_distribution;
  vector<inputline> input_dddistribution;

  vector<inputline> input_leftover;

  map <string, bool> assigned_to_input;
  map <string, bool> assigned_to_phasespace;
  map <string, bool> assigned_to_observable;
  map <string, bool> assigned_to_contribution;
  map <string, bool> assigned_to_event;
  map <string, bool> assigned_to_amplitude;
  map <string, bool> assigned_to_amplitude_OpenLoops;
  map <string, bool> assigned_to_amplitude_Recola;
  map <string, bool> assigned_to_userdefined;

  // maybe also these ones:
  map <string, bool> assigned_to_model;
  map <string, bool> assigned_to_distribution;
  map <string, bool> assigned_to_dddistribution;
};
#endif
