// inline functions
inline bool munich_isnan(double & value){return std::isnan(value);}
inline bool munich_isinf(double & value){return std::isinf(value);}
inline bool munich_isinfnan(double & value){if (munich_isnan(value) || munich_isinf(value)){return true;} else {return false;}}

inline bool munich_isnan(fourvector & fv){return fv.isnan();}
inline bool munich_isinf(fourvector & fv){return fv.isinf();}
inline bool munich_isinfnan(fourvector & fv){return fv.isinfnan();}
template <typename T> bool munich_isnan(vector<T> & value){for (int i = 0; i < value.size(); i++){if (munich_isnan(value[i])){return true;}} return false;}
template <typename T> bool munich_isinf(vector<T> & value){for (int i = 0; i < value.size(); i++){if (munich_isinf(value[i])){return true;}} return false;}
template <typename T> bool munich_isinfnan(vector<T> & value){for (int i = 0; i < value.size(); i++){if (munich_isinfnan(value[i])){return true;}} return false;}
inline int intpow(int basis, int exponent){if (exponent < 0){return 0;} else {int result = 1; for (int i = 0; i < exponent; i++){result *= basis;} return result;}}
inline double lambda(double x, double y, double z){double t; if (x == 0.){t = pow(y - z, 2);} else if (y == 0.){t = pow(x - z, 2);} else if (z == 0.){t = pow(y - x, 2);} else {t = pow(x, 2) + pow(y, 2) + pow(z, 2) - 2 * x * y - 2 * x * z - 2 * y * z;} return t;}
// maybe numerically more stable ???
//inline double lambda(double x, double y, double z){double t; if (x == 0.){t = pow(y - z, 2);} else if (y == 0.){t = pow(x - z, 2);} else if (z == 0.){t = pow(y - x, 2);} else {t = pow(x - y - z, 2) - 4 * y * z;} return t;}
inline double g_from_alpha(double alpha){return sqrt(4 * M_PI * alpha);}

//  routines/routines.conversion.cpp
string double2hexastr(double d);
double hexastr2double(const string & s);
// -> general (amplitude, ...)
char * stch(string temp_s);
char stchar(string & temp_s);
// -> generator/create
vector<int> get_vector_from_array_int(int * temp_array, int size_array);
// -> general (summary, ...)
string time_hms_from_double(double & time);
// general (phasespace, generator)
double max_subset_from_binary(vector<double> & xbsqrtsmin_opt, int b);
vector<int> vectorint_from_binary(int b);
vector<int> vectorbinary_from_binary(int b);

//  routines/routines.system.cpp
void get_memory_usage_kb(Logger & logger, string label_position, long* vmrss_kb, long* vmsize_kb);
void output_memory_usage_kb(Logger & logger, string label_position);
// -> summary_subprocess
void output_memory_consumption(const string identifier);
// -> inputparameter
string get_path_executable();
string get_current_dir();
// general (observable, summary, phasespace)
void system_execute(Logger & logger, string xorder);
void system_execute(Logger & logger, string xorder, int isystem);

//  routines/routines.input.cpp
// -> inputparameter ???
void get_data(string & filename, vector<string> & readin_data);
// void get_data_remove_comment(string & filename, vector<string> & readin);
void get_data_split(string & filename, vector<vector<string> > & readin_data);
void get_userinput_from_readin(vector<string> & user_variable, vector<string> & user_variable_additional, vector<string> & user_value, vector<string> & readin);

//  routines/routines.output.cpp
//void output_weight_optimization(phasespace_set & psi, observable_set & oset, int & size_proc_generic, vector<int> & size_proceeding);
void fill_gnuplotname(map<int, string> & gnuplotname);
void output_gnuplotfile(string & filename, int icount, double reldeviation, int n_events_max);
string output_result_deviation(double av_result, double av_deviation, int digits_deviation);
string output_latex_percent(double av_result, double result, int digits_deviation);
// string output_percent(double av_result, double result, int digits_deviation);
// string output_commadigits(double result, int digits);
void write_infile_int(ofstream & out_file, string name, int value_i);
void write_infile_long_long(ofstream & out_file, string name, long long value_i);
void write_infile_double(ofstream & out_file, string name, double value_d);
void write_infile_string(ofstream & out_file, string name, string value_s);

// routines/routines.selection.parton.cpp
void fill_parton_content(vector<vector<int> > & content_parton);
void fill_relation_parton_content(vector<vector<int> > & content_parton, map<string, vector<int> > & relation_content_parton);
void determine_selection_content_particle(vector<int> & content_list, vector<string> & content_selection, vector<string> & content_disable);

