#include "header.hpp"

void amplitude_set::calculate_ME2_VA_MIX(){
  Logger logger("amplitude_set::calculate_ME2_VA_MIX");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_FATAL << "Basic amplitude_set function must be overwritten." << endline; exit(1);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void amplitude_set::calculate_ME2_ioperator_VA_MIX(){
  Logger logger("amplitude_set::calculate_ME2_ioperator_VA_MIX");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_FATAL << "Basic amplitude_set function must be overwritten." << endline; exit(1);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void amplitude_set::calculate_ME2check_VA_MIX(){
  static Logger logger("amplitude_set::calculate_ME2check_VA_MIX");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // Not yet updated to RECOLA and scale-dependent testpoint evaluation, etc.

  if (osi->switch_output_comparison && process_id != -1){
    esi->phasespacepoint();
    if (esi->p_parton[0][0].x0() == 0.){generate_testpoint();}
    if (esi->p_parton[0][0].x0() != 0.){
      ofstream out_comparison;
      out_comparison.open(osi->filename_comparison.c_str(), ofstream::out | ofstream::app);

      esi->perform_event_selection();
      osi->set_testpoint_scale_complete();
      vector<int> cut_ps_acc_all(csi->n_ps, 0);
      swap(esi->cut_ps, cut_ps_acc_all);

      osi->VA_delta_flag = 1;
      osi->VA_b_ME2 = 0.;
      osi->VA_V_ME2 = 0.;
      osi->VA_X_ME2 = 0.;
      osi->VA_I_ME2 = 0.;
      osi->VA_X_ME2_CV.resize(osi->n_scales_CV, 0.);
      if (osi->switch_output_comparison == 2){set_testpoint_alpha_S(osi->var_alpha_S_reference);}
      osi->VA_DeltaUV = 0.;
      osi->VA_DeltaIR1 = 0.;
      osi->VA_DeltaIR2 = 0.;
      logger << LOG_DEBUG << "osi->VA_DeltaUV  = " << osi->VA_DeltaUV << endline_flush;
      logger << LOG_DEBUG << "osi->VA_DeltaIR1 = " << osi->VA_DeltaIR1 << endline_flush;
      logger << LOG_DEBUG << "osi->VA_DeltaIR2 = " << osi->VA_DeltaIR2 << endline_flush;

      set_mu_reg();
      set_mu_and_delta_VA();
      output_parameter("testpoint");
      ///      ol_setparameter_double(OL_mu_ren, osi->var_mu_ren);
      ///    if (osi->user->double_value[osi->user->double_map["mu_reg"]] == 0.){ol_setparameter_double(OL_mu_reg, osi->var_mu_ren);}
      ///    else {ol_setparameter_double(OL_mu_reg, osi->user->double_value[osi->user->double_map["mu_reg"]]);}

      // temp_mu_reg not used !!!

      // not yet treated correctly  (mu_ren treatment needs to be improved anyway) !!!
      /*
     ///      double temp_mu_reg = 0.;
     ol_setparameter_double(OL_mu_ren, osi->var_mu_ren);
     //      ol_setparameter_double(OL_mu_reg, osi->var_mu_ren);
     if (osi->user->double_value[osi->user->double_map["mu_reg"]] == 0.){
     ol_setparameter_double(OL_mu_reg, osi->var_mu_ren);
     ///	temp_mu_reg = osi->var_mu_ren;
     }
     else {
     ol_setparameter_double(OL_mu_reg, osi->user->double_value[osi->user->double_map["mu_reg"]]);
     ///	temp_mu_reg = osi->user->double_value[osi->user->double_map["mu_reg"]];
     }
      */
      /*
	ol_setparameter_double(pole_uv, osi->VA_DeltaUV);
	ol_setparameter_double(pole_ir1, osi->VA_DeltaIR1);
	ol_setparameter_double(pole_ir2, osi->VA_DeltaIR2);

	OLP_PrintParameter(stch("log/olparameters." + csi->subprocess + ".txt"));
      */

      calculate_ME2_VA_MIX();

      out_comparison << output_amplitude_VA_MIX();

      osi->set_testpoint_x_pdf();
      if (osi->switch_TSV){
	//	osi->calculate_pdf_LHAPDF_TSV();
	osi->calculate_pdf_LHAPDF_list_TSV();
	out_comparison << osi->output_testpoint_VA_integrand_TSV() << endline;
	out_comparison << endline;
	out_comparison << osi->output_testpoint_integrand() << endline;
	out_comparison << endline;
      }
 
      swap(esi->cut_ps, cut_ps_acc_all);
      out_comparison << osi->output_testpoint_kinematics() << endline;
      out_comparison << osi->output_scales() << endline;
      out_comparison.close();
    }
    else {
      output_parameter("testpoint");
    }

    osi->switch_output_comparison = 0;
  }
  else {
    output_parameter("testpoint");
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


string amplitude_set::output_amplitude_VA_MIX(){
  static Logger logger("amplitude_set::output_amplitude_VA_MIX");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream out_comparison;

  /*
    out_comparison << "Settings: " << endl << endline;
    out_comparison << setw(12) << "  mu_reg  = " << setprecision(15) << setw(23) << osi->var_mu_ren << "  ( = mu_ren by default)" << endline;
    out_comparison << setw(12) << "  mu_ren  = " << setprecision(15) << setw(23) << osi->var_mu_ren << "  " << "alpha_S(mu_ren) = " << osi->alpha_S << endline;
    out_comparison << setw(12) << "  mu_fact = " << setprecision(15) << setw(23) << osi->var_mu_fact << endline;
    out_comparison << endline;
  */

  //  out_comparison << "Matrix elements (µreg = " << mu_reg << ", µR = " << osi->var_mu_ren << ", " << "alpha_S(µR) = " << setprecision(15) << osi->var_alpha_S_reference << "): " << endl << endline;
  out_comparison << "Matrix elements (µreg = " << mu_reg << ", µR = " << osi->scale_ren << ", " << "alpha_S(µR) = " << setprecision(15) << osi->alpha_S << "): " << endline << endline;
  out_comparison << osi->output_testpoint_VA_result() << endline;
  double OL_I_ME2 = osi->VA_I_ME2;
  if (osi->switch_VI != 2){
    osi->VA_I_ME2 = 0.;
    calculate_ME2_ioperator_VA_MIX();
    out_comparison << osi->output_testpoint_VA_ioperator() << endline;
    osi->VA_I_ME2 = OL_I_ME2;
  }
  // comment out this in the future !!!
  /*
    osi->VA_V_ME2 = osi->VA_V_ME2 / osi->VA_b_ME2;
    osi->VA_X_ME2 = osi->VA_X_ME2 / osi->VA_b_ME2;
    osi->VA_I_ME2 = osi->VA_I_ME2 / osi->VA_b_ME2;
    out_comparison << "Relative results (corrections devided by ME2_born, ME2_born divided by coupling constants): " << endl << endline;
    osi->output_testpoint_VA_result(out_comparison);
  */
  // until here...
  /*
    out_comparison << endline;
    out_comparison << "Particle momenta: " << endl << endline;
    osi->output_momenta(out_comparison);
  */
  ///    out_comparison << "On-shell-projected particle momenta: " << endl << endline;
  ///    output_momenta(out_comparison, *osi);

  string s_Delta;
  double i_Delta;

  out_comparison << "Numerical check of (UV and IR) finiteness: " << endl << endline;

  /*
  // Delta_UV =/= Delta_IR not allowed in CutTOols !!!
  int set_OL_stability_mode;
  ol_getparameter_int(stability_mode, &set_OL_stability_mode);
  int temp_OL_stability_mode = set_OL_stability_mode;
  int set_OL_redlib1;
  ol_getparameter_int(redlib1, &set_OL_redlib1);
  int temp_OL_redlib1 = set_OL_redlib1;
  int set_OL_redlib2;
  ol_getparameter_int(redlib2, &set_OL_redlib2);
  int temp_OL_redlib2 = set_OL_redlib2;
  //    char* set_OL_model;
  //    ol_getparameter_string("model", set_OL_model);
  string set_OL_model;
  for (int i_o = 0; i_o < osi->OL_parameter.size(); i_o++){
  if (osi->OL_parameter[i_o] == "model"){set_OL_model = osi->OL_value[i_o];}
  }
  string temp_OL_model = set_OL_model;

  logger << LOG_DEBUG << "set_OL_stability_mode  = " << set_OL_stability_mode << endline_flush;
  logger << LOG_DEBUG << "set_OL_redlib1         = " << set_OL_redlib1 << endline_flush;
  logger << LOG_DEBUG << "set_OL_redlib2         = " << set_OL_redlib2 << endline_flush;
  logger << LOG_DEBUG << "set_OL_model           = " << set_OL_model << endline_flush;
  */
  //      int temp_switch_check_IRneqUV = 1;
  /*
    if (set_OL_model == "heft"){temp_switch_check_IRneqUV = 0;}
    else if (set_OL_stability_mode < 20){temp_switch_check_IRneqUV = 0;}
    else {
    if (set_OL_stability_mode == 23){
    temp_OL_stability_mode = 21;
    if      (set_OL_redlib1 == 5 && set_OL_redlib2 == 1){temp_OL_redlib1 = 7;}
    else if (set_OL_redlib1 == 5 && set_OL_redlib2 == 7){temp_OL_redlib1 = 1;}
    else if (set_OL_redlib2 == 5 && set_OL_redlib1 == 1){temp_OL_redlib2 = 7;}
    else if (set_OL_redlib2 == 5 && set_OL_redlib1 == 7){temp_OL_redlib2 = 1;}

    ol_setparameter_int(stch(stability_mode), temp_OL_stability_mode);
    ol_setparameter_int(stch(redlib1), temp_OL_redlib1);
    ol_setparameter_int(stch(redlib2), temp_OL_redlib2);
    }
    logger << LOG_DEBUG << "temp_OL_stability_mode = " << temp_OL_stability_mode << endline_flush;
    logger << LOG_DEBUG << "temp_OL_redlib1        = " << temp_OL_redlib1 << endline_flush;
    logger << LOG_DEBUG << "temp_OL_redlib2        = " << temp_OL_redlib2 << endline_flush;
    logger << LOG_DEBUG << "temp_OL_model          = " << temp_OL_model << endline_flush;
    }
  */

  //      if (temp_switch_check_IRneqUV){
  if (allowed_Delta_IRneqUV){
    s_Delta = "Delta_UV";
    for (int i = 0; i < 3; i++){
      i_Delta = (double(i) - 1.) * 1.;
      osi->VA_DeltaUV = i_Delta;
      set_mu_and_delta_VA();
      calculate_ME2_VA_MIX();
      out_comparison << osi->output_testpoint_VA_Delta(i, i_Delta, s_Delta) << endline;
    }
    osi->VA_DeltaUV = 0.;
    out_comparison << endline;

    s_Delta = "Delta_IR_1";
    for (int i = 0; i < 3; i++){
      i_Delta = (double(i) - 1.) * 1.;
      osi->VA_DeltaIR1 = i_Delta;
      set_mu_and_delta_VA();
      calculate_ME2_VA_MIX();
      out_comparison << osi->output_testpoint_VA_Delta(i, i_Delta, s_Delta) << endline;
    }
    osi->VA_DeltaIR1 = 0.;
    out_comparison << endline;
  }

  s_Delta = "Delta_IR_2";
  for (int i = 0; i < 3; i++){
    i_Delta = (double(i) - 1.) * 1.;
    osi->VA_DeltaIR2 = i_Delta;
    set_mu_and_delta_VA();
    calculate_ME2_VA_MIX();
    out_comparison << osi->output_testpoint_VA_Delta(i, i_Delta, s_Delta) << endline;
  }
  osi->VA_DeltaIR2 = 0.;
  out_comparison << endline;
  s_Delta = "Delta_UV = Delta_IR_1";
  for (int i = 0; i < 3; i++){
    i_Delta = (double(i) - 1.) * 1.;
    osi->VA_DeltaUV = i_Delta;
    osi->VA_DeltaIR1 = i_Delta;
    set_mu_and_delta_VA();
    calculate_ME2_VA_MIX();
    out_comparison << osi->output_testpoint_VA_Delta(i, i_Delta, s_Delta) << endline;
  }
  osi->VA_DeltaUV = 0.;
  osi->VA_DeltaIR1 = 0.;
  out_comparison << endline;
  set_mu_and_delta_VA();
  /*
    ol_setparameter_double(OL_mu_ren, osi->var_mu_ren);
    if (osi->user->double_value[osi->user->double_map["mu_reg"]] == 0.){ol_setparameter_double(OL_mu_reg, osi->var_mu_ren);}
    else {ol_setparameter_double(OL_mu_reg, osi->user->double_value[osi->user->double_map["mu_reg"]]);}
  */
  calculate_ME2_VA_MIX();

  osi->VA_delta_flag = 0;
  if (osi->switch_output_comparison == 2){set_testpoint_alpha_S(osi->alpha_S);}

  logger << LOG_DEBUG_VERBOSE << "finished - return (string):" << endl << out_comparison.str() << endline_flush;
  return out_comparison.str();
}
