#include "header.hpp"

void amplitude_set::initialization(observable_set * _osi, contribution_set * _csi, model_set * _msi, event_set * _esi, inputparameter_set * isi){
  Logger logger("amplitude_set::initialization (osi, csi, msi, esi, isi)");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  osi = _osi;
  csi = _csi;
  msi = _msi;
  esi = _esi;

  initialization_set_default();
  initialization_input(isi);
  set_mu_reg();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

/*
// required ???
void amplitude_set::initialization_basic(observable_set * _osi, contribution_set * _csi, model_set * _msi, event_set * _esi, inputparameter_set * isi){
  Logger logger("amplitude_set::initialization_basic");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  initialization_input(isi);

  osi = _osi;
  csi = _csi;
  msi = _msi;
  esi = _esi;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
*/

void amplitude_set::initialization_set_default(){
  Logger logger("amplitude_set::initialization_set_default");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  switch_amplitude_not_required = 0;
  N_quarks = 6;

  switch_mu_reg = 0;
    
  failed_evaluation = 0;
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void amplitude_set::initialization_input(inputparameter_set * isi){
  Logger logger("amplitude_set::initialization_input");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int i_i = 0; i_i < isi->input_amplitude.size(); i_i++){
    logger << LOG_DEBUG_VERBOSE << "isi->input_amplitude[" << i_i << "] = " << isi->input_amplitude[i_i] << endline_flush;

    if (isi->input_amplitude[i_i].variable == ""){}

    else if (isi->input_amplitude[i_i].variable == "N_quarks"){N_quarks = atoi(isi->input_amplitude[i_i].value.c_str());}
    else if (isi->input_amplitude[i_i].variable == "switch_amplitude_not_required"){switch_amplitude_not_required = atoi(isi->input_amplitude[i_i].value.c_str());}
    else if (isi->input_amplitude[i_i].variable == "switch_mu_reg"){switch_mu_reg = atoi(isi->input_amplitude[i_i].value.c_str());}
    else if (isi->input_amplitude[i_i].variable == "scale_reg"){scale_reg = atof(isi->input_amplitude[i_i].value.c_str());}

  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
