#include "header.hpp"

contribution_set::contribution_set(){
  Logger logger("contribution_set::contribution_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::determination_subprocess_psp(int x_a){
  Logger logger("contribution_set::determination_subprocess_psp");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (type_contribution == "born"){determination_subprocess_born(x_a);}
  else if (type_contribution == "L2I"){determination_subprocess_born(x_a);}
  else if (type_contribution == "RT"){determination_subprocess_real(x_a);}
  else if (type_contribution == "L2RT"){determination_subprocess_real(x_a);}
  else if (type_contribution == "VA"){determination_subprocess_born(x_a);}
  else if (type_contribution == "RVA"){determination_subprocess_real(x_a);}
  else if (type_contribution == "L2VA"){determination_subprocess_born(x_a);}
  else if (type_contribution == "CA"){determination_subprocess_born(x_a);}
  else if (type_contribution == "RCA"){determination_subprocess_real(x_a);}
  else if (type_contribution == "L2CA"){determination_subprocess_born(x_a);}
  else if (type_contribution == "RA"){determination_subprocess_real(x_a);}
  else if (type_contribution == "RRA"){determination_subprocess_doublereal(x_a);}
  else if (type_contribution == "L2RA"){determination_subprocess_real(x_a);}
  else if (type_contribution == "VT"){determination_subprocess_born(x_a);}
  else if (type_contribution == "L2VT"){determination_subprocess_born(x_a);}
  else if (type_contribution == "CT"){determination_subprocess_born(x_a);}
  else if (type_contribution == "L2CT"){determination_subprocess_born(x_a);}
  else if (type_contribution == "VT2"){determination_subprocess_born(x_a);}
  else if (type_contribution == "CT2"){determination_subprocess_born(x_a);}

  // Maybe shift the csi initialization part about dipoles here as well ???
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::determination_subprocess_dipole(int x_a){
  Logger logger("contribution_set::determination_subprocess_dipole");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (type_contribution == "RA"){determination_subprocess_born(x_a);}
  else if (type_contribution == "RRA"){determination_subprocess_real(x_a);}
  else if (type_contribution == "L2RA"){determination_subprocess_born(x_a);}
  else if (type_contribution == "RT"){determination_subprocess_born(x_a);}
  else if (type_contribution == "L2RT"){determination_subprocess_born(x_a);}
  else if (type_contribution == "RVA"){determination_subprocess_born(x_a);}
  else if (type_contribution == "L2VA"){determination_subprocess_born(x_a);}
  else if (type_contribution == "RCA"){determination_subprocess_born(x_a);}
  else if (type_contribution == "L2CA"){determination_subprocess_born(x_a);}

  // Maybe shift the csi initialization part about dipoles here as well ???
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::combination_subprocess_psp(int x_a){
  Logger logger("contribution_set::combination_subprocess_psp");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (type_contribution == "born"){combination_subprocess_born(x_a);}
  else if (type_contribution == "RT"){combination_subprocess_real(x_a);}
  else if (type_contribution == "L2I"){combination_subprocess_born(x_a);}
  else if (type_contribution == "L2RT"){combination_subprocess_real(x_a);}
  else if (type_contribution == "VA"){combination_subprocess_born(x_a);}
  else if (type_contribution == "RVA"){combination_subprocess_real(x_a);}
  else if (type_contribution == "L2VA"){combination_subprocess_born(x_a);}
  else if (type_contribution == "CA"){combination_subprocess_born(x_a);}
  else if (type_contribution == "RCA"){combination_subprocess_real(x_a);}
  else if (type_contribution == "L2CA"){combination_subprocess_born(x_a);}
  else if (type_contribution == "RA"){combination_subprocess_real(x_a);}
  else if (type_contribution == "RRA"){combination_subprocess_doublereal(x_a);}
  else if (type_contribution == "L2RA"){combination_subprocess_real(x_a);}
  else if (type_contribution == "VT"){combination_subprocess_born(x_a);}
  else if (type_contribution == "L2VT"){combination_subprocess_born(x_a);}
  else if (type_contribution == "CT"){combination_subprocess_born(x_a);}
  else if (type_contribution == "L2CT"){combination_subprocess_born(x_a);}
  else if (type_contribution == "VT2"){combination_subprocess_born(x_a);}
  else if (type_contribution == "CT2"){combination_subprocess_born(x_a);}

  // Maybe shift the csi initialization part about dipoles here as well ???
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::determination_order_alpha_s_born(){
  Logger logger("contribution_set::order_alpha_s_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "type_contribution = " << type_contribution << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "type_correction = " << type_correction << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "contribution_order_alpha_s = " << contribution_order_alpha_s << endline_flush;

  if (type_contribution == ""){logger << LOG_FATAL << "No contribution chosen -> summary ?" << endline_flush;}
  
  if (type_contribution == "born"){
    order_alpha_s_born = contribution_order_alpha_s;
  } 
  else if ((type_contribution == "loop" ||
	    type_contribution == "LI2")){
    order_alpha_s_born = contribution_order_alpha_s;
    // The loop-induced process is the "Born" process here !!!
  }
  else if (type_correction == "QCD" && 
	   (type_contribution == "VT" ||
	    type_contribution == "CT")){
    order_alpha_s_born = contribution_order_alpha_s - 1;
  }
  else if (type_correction == "QCD" && 
	   (type_contribution == "VT2" ||
	    type_contribution == "CT2")){
    order_alpha_s_born = contribution_order_alpha_s - 2;
  }
  else if (type_correction == "QCD" && 
	   (type_contribution == "L2VT" ||
	    type_contribution == "L2CT")){
    order_alpha_s_born = contribution_order_alpha_s - 1;
    // The loop-induced process is the "Born" process here !!!
  }
  else if (type_correction == "QCD" && 
	   (type_contribution == "RA" ||
	    type_contribution == "VA" ||
	    type_contribution == "CA" ||
	    type_contribution == "RT")){
    order_alpha_s_born = contribution_order_alpha_s - 1;
  }
  else if (type_correction == "QEW" &&
	   (type_contribution == "RA" ||
	    type_contribution == "VA" ||
	    type_contribution == "CA")){
    order_alpha_s_born = contribution_order_alpha_s;
  }
  else if (type_correction == "QCD" && 
	   (type_contribution == "L2RA" ||
	    type_contribution == "L2VA" ||
	    type_contribution == "L2CA" ||
	    type_contribution == "L2RT")){
    order_alpha_s_born = contribution_order_alpha_s - 1;
    // The loop-induced process is the "Born" process here !!!
  }
  else if (type_correction == "QCD" && 
	   (type_contribution == "RVA" ||
	    type_contribution == "RCA" ||
	    type_contribution == "RRA")){
    order_alpha_s_born = contribution_order_alpha_s - 2;
  }
  else {
    // order_alpha_s_born is only required for CT(2)/VT(2) contributions and alike !!!
    //    logger << LOG_WARN << "Should not happen !!!" << endline_flush;
    order_alpha_s_born = contribution_order_alpha_s;
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::determination_class_contribution(){
  Logger logger("contribution_set::determination_class_contribution");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  class_contribution_born = 0;
  class_contribution_CS_collinear = 0;
  class_contribution_CS_virtual = 0;
  class_contribution_CS_real = 0;
  class_contribution_QT_collinear = 0;
  class_contribution_QT_virtual = 0;
  class_contribution_QT_real = 0;
  class_contribution_collinear = 0;
  class_contribution_virtual = 0;
  class_contribution_real = 0;
  class_contribution_loopinduced = 0;
  class_contribution_qTcut_implicit = 0;
  class_contribution_qTcut_explicit = 0;
  class_contribution_CS = 0;
  class_contribution_QT = 0;
  class_contribution_QT_CS = 0;
  class_contribution_order = -1;

  if (type_contribution == ""){logger << LOG_FATAL << "No contribution chosen -> summary ?" << endline_flush;}

  // class_contribution_... simplifies type_contribution-dependent statements for similar contributions
  
  if (type_contribution == "born"){
    class_contribution_born = 1;
    class_contribution_order = 0;
  }
  if (type_contribution == "loop" ||
      type_contribution == "L2I"){
      //    class_contribution_born = 1; // check !!!
    class_contribution_order = 0;
  }

  // contributions with implicit qTcut dependence
  if (type_contribution == "CT" ||
      type_contribution == "CT2" ||
      type_contribution == "L2CT"){
    class_contribution_qTcut_implicit = 1;
  }
  
  // contributions with explicit qTcut dependence
  if (type_contribution == "RT" ||
      type_contribution == "RVA" ||
      type_contribution == "RCA" ||
      type_contribution == "RRA" ||
      type_contribution == "L2RT"){
    class_contribution_qTcut_explicit = 1;
  }
  
  // dipolesubtraction
  if (type_contribution == "VA" ||
      type_contribution == "RVA" ||
      type_contribution == "L2VA"){
    class_contribution_CS_virtual = 1;
  }
  if (type_contribution == "CA" ||
      type_contribution == "RCA" ||
      type_contribution == "L2CA"){
    class_contribution_CS_collinear = 1;
  }
  if (type_contribution == "RA" ||
      type_contribution == "RRA" ||
      type_contribution == "L2RA"){
    class_contribution_CS_real = 1;
  }

  // qTsubtraction
  if (type_contribution == "VT" ||
      type_contribution == "VT2" ||
      type_contribution == "L2VT"){
    class_contribution_QT_virtual = 1;
  }
  if (type_contribution == "CT" ||
      type_contribution == "CT2" ||
      type_contribution == "L2CT"){
    class_contribution_QT_collinear = 1;
  }
  if (type_contribution == "RT" ||
      type_contribution == "L2RT"){
    class_contribution_QT_real = 1;
  }
  
  // virtual contributions
  if (class_contribution_CS_virtual ||
      class_contribution_QT_virtual){
    class_contribution_virtual = 1;
  }

  // contributions with collinear emissions
  if (class_contribution_CS_collinear ||
      class_contribution_QT_collinear ||
      class_contribution_QT_virtual){
    class_contribution_collinear = 1;
  }
 
  // loop-induced contributions
  if (type_contribution == "loop" ||
      type_contribution == "L2I" ||
      type_contribution == "L2VA" ||
      type_contribution == "L2CA" ||
      type_contribution == "L2RA" ||
      type_contribution == "L2VT" ||
      type_contribution == "L2CT" ||
      type_contribution == "L2RT"){
    class_contribution_loopinduced = 1;
  }

  // CS subtraction
  if (type_contribution == "VA" ||
      type_contribution == "CA" ||
      type_contribution == "RA" ||
      type_contribution == "L2VA" ||
      type_contribution == "L2CA" ||
      type_contribution == "L2RA"){
    class_contribution_CS = 1;
    class_contribution_order = 1;
  }

  // qTsubtraction
  if (type_contribution == "VT" ||
      type_contribution == "CT" ||
      type_contribution == "RT" ||
      type_contribution == "L2VT" ||
      type_contribution == "L2CT" ||
      type_contribution == "L2RT"){
    class_contribution_QT = 1;
    class_contribution_order = 1;
  }

  // qTsubtraction with CS for first emission
  if (type_contribution == "VT2" ||
      type_contribution == "CT2" ||
      type_contribution == "RVA" ||
      type_contribution == "RCA" ||
      type_contribution == "RRA"){
    class_contribution_QT_CS = 1;
    class_contribution_order = 2;
  }
  

  logger << LOG_DEBUG << setw(35) << "class_contribution_born" << " = " << class_contribution_born << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_CS" << " = " << class_contribution_CS << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_CS_virtual" << " = " << class_contribution_CS_virtual << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_CS_collinear" << " = " << class_contribution_CS_collinear << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_CS_real" << " = " << class_contribution_CS_real << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_QT" << " = " << class_contribution_QT << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_QT_virtual" << " = " << class_contribution_QT_virtual << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_QT_collinear" << " = " << class_contribution_QT_collinear << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_QT_real" << " = " << class_contribution_QT_real << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_virtual" << " = " << class_contribution_virtual << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_collinear" << " = " << class_contribution_collinear << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_real" << " = " << class_contribution_real << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_loopinduced" << " = " << class_contribution_loopinduced << endline_flush;
  logger << LOG_DEBUG << setw(35) << "class_contribution_QT_CS" << " = " << class_contribution_QT_CS << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}




void contribution_set::readin_hadronic_process(){
  Logger logger("contribution_set::readin_hadronic_process");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger.newLine(LOG_DEBUG);
  //  logger << LOG_DEBUG << "Hadronic process:" << endline_flush;
    
  vector<vector<string> > basic_hadron_particles_name(2);
  logger << LOG_DEBUG << setw(30) << left << "basic_process_class" << " = " << basic_process_class << endline_flush;
  //  logger << LOG_DEBUG << "basic_type_hadron.size() = " << basic_type_hadron.size() << endline_flush;
  
  readin_subprocess_from_name(basic_process_class, basic_type_hadron, 0);

  logger << LOG_DEBUG << left << setw(30) << "n_particle" << " = " << n_particle << "   (temporarily)" << endline_flush;
  logger << LOG_DEBUG << setw(30) << "process_type" << " = " << process_type << "   (temporarily)" << endline_flush;

  //  logger << LOG_DEBUG << "Basic hadronic process:" << endline_flush;
  for (int i_p = 1; i_p < basic_type_hadron.size(); i_p++){
    logger << LOG_DEBUG << setw(26) << "basic_type_hadron" << "[" << setw(2) << i_p << "]" << " = " << right << setw(5) << basic_type_hadron[i_p] << "   " << setw(5) << left << name_particle[basic_type_hadron[i_p]] << endline_flush;
  }

  logger.newLine(LOG_DEBUG);  

  //  logger << LOG_DEBUG << "Hadronic process:" << endline_flush;
  //  vector<vector<int> > hadron_type_parton(1);
  vector<vector<string> > hadron_particles_name(2);
  logger << LOG_DEBUG << setw(30) << "process_class" << " = " << process_class << endline_flush;
  readin_subprocess_from_name(process_class, type_hadron, 2);
  //  logger << LOG_DEBUG << setw(30) << "n_particle" << " = " << n_particle << "   (temporarily)" << endline_flush;
  //  logger << LOG_DEBUG << setw(30) << "process_type" << " = " << process_type << "   (temporarily)" << endline_flush;
  logger << LOG_DEBUG << setw(30) << "type_hadron.size() = " << type_hadron.size() << endline_flush;
  for (int i_p = 1; i_p < type_hadron.size(); i_p++){
    logger << LOG_DEBUG << setw(26) << "type_hadron" << "[" << setw(2) << i_p << "] = " << right << setw(5) << type_hadron[i_p] << endline_flush;
    logger << LOG_DEBUG << setw(26) << "type_hadron" << "[" << setw(2) << i_p << "] = " << right << setw(5) << type_hadron[i_p] << "   " << setw(5) << left << name_particle[type_hadron[i_p]] << endline_flush;
  }

  //  logger.newLine(LOG_DEBUG);
  
  map<int, int> lepton_counter;
  lepton_counter[11] = 1;
  lepton_counter[13] = 2;
  lepton_counter[15] = 3;
  lepton_counter[-11] = 4;
  lepton_counter[-13] = 5;
  lepton_counter[-15] = 6;
  lepton_counter[12] = 7;
  lepton_counter[14] = 8;
  lepton_counter[16] = 9;
  lepton_counter[-12] = 10;
  lepton_counter[-14] = 11;
  lepton_counter[-16] = 12;
  
  map<int, int> lepton_inverse;
  lepton_inverse[1] = 11;
  lepton_inverse[2] = 13;
  lepton_inverse[3] = 15;
  lepton_inverse[4] = -11;
  lepton_inverse[5] = -13;
  lepton_inverse[6] = -15;
  lepton_inverse[7] = 12;
  lepton_inverse[8] = 14;
  lepton_inverse[9] = 16;
  lepton_inverse[10] = -12;
  lepton_inverse[11] = -14;
  lepton_inverse[12] = -16;
  

  //  int use_basic_process = 0;
  
  vector<int> basic_process_counter(13, 0);
  for (int i_p = 1; i_p < basic_type_hadron.size(); i_p++){
    basic_process_counter[lepton_counter[basic_type_hadron[i_p]]]++;
  }
  /*
    for (int i_l = 0; i_l < 13; i_l++){
      logger << LOG_DEBUG_VERBOSE << "basic_process_counter[" << setw(2) <<  i_l << "] = " << setw(2) << basic_process_counter[i_l] << endline_flush;
    }
    logger << LOG_DEBUG_VERBOSE << endline_flush;
  */
  vector<int> process_exchange_counter(13, 0);
  vector<int> process_counter(13, 0);

  //  map<int, int> lepton_exchange;
  for (int i_l = 0; i_l < 7; i_l++){
    if (i_l == 0){
      for (int j_l = 1; j_l < 7; j_l++){
	lepton_exchange[10 + j_l] = 10 + j_l;
	lepton_exchange[-10 - j_l] = -10 - j_l;
      }
    }
    else if (i_l == 1){
      lepton_exchange[11] = 13;
      lepton_exchange[12] = 14;
      lepton_exchange[13] = 11;
      lepton_exchange[14] = 12;
      lepton_exchange[15] = 15;
      lepton_exchange[16] = 16;
      lepton_exchange[-11] = -13;
      lepton_exchange[-12] = -14;
      lepton_exchange[-13] = -11;
      lepton_exchange[-14] = -12;
      lepton_exchange[-15] = -15;
      lepton_exchange[-16] = -16;
    }
    else if (i_l == 2){
      lepton_exchange[11] = 15;
      lepton_exchange[12] = 16;
      lepton_exchange[13] = 13;
      lepton_exchange[14] = 14;
      lepton_exchange[15] = 11;
      lepton_exchange[16] = 12;
      lepton_exchange[-11] = -15;
      lepton_exchange[-12] = -16;
      lepton_exchange[-13] = -13;
      lepton_exchange[-14] = -14;
      lepton_exchange[-15] = -11;
      lepton_exchange[-16] = -12;
    }
    else if (i_l == 3){
      lepton_exchange[11] = 11;
      lepton_exchange[12] = 12;
      lepton_exchange[13] = 15;
      lepton_exchange[14] = 16;
      lepton_exchange[15] = 13;
      lepton_exchange[16] = 14;
      lepton_exchange[-11] = -11;
      lepton_exchange[-12] = -12;
      lepton_exchange[-13] = -15;
      lepton_exchange[-14] = -16;
      lepton_exchange[-15] = -13;
      lepton_exchange[-16] = -14;
    }
    else if (i_l == 4){
      lepton_exchange[11] = 13;
      lepton_exchange[12] = 14;
      lepton_exchange[13] = 15;
      lepton_exchange[14] = 16;
      lepton_exchange[15] = 11;
      lepton_exchange[16] = 12;
      lepton_exchange[-11] = -13;
      lepton_exchange[-12] = -14;
      lepton_exchange[-13] = -15;
      lepton_exchange[-14] = -16;
      lepton_exchange[-15] = -11;
      lepton_exchange[-16] = -12;
    }
    else if (i_l == 5){
      lepton_exchange[11] = 15;
      lepton_exchange[12] = 16;
      lepton_exchange[13] = 11;
      lepton_exchange[14] = 12;
      lepton_exchange[15] = 13;
      lepton_exchange[16] = 14;
      lepton_exchange[-11] = -15;
      lepton_exchange[-12] = -16;
      lepton_exchange[-13] = -11;
      lepton_exchange[-14] = -12;
      lepton_exchange[-15] = -13;
      lepton_exchange[-16] = -14;
    }
    else if (i_l == 6){
      logger << LOG_FATAL << "No allowed process specified." << endline_flush;
      //      use_basic_process = 1;
      exit(1);
    }
    
    for (int j_l = 0; j_l < 13; j_l++){process_exchange_counter[j_l] = 0;}
    for (int j_l = 0; j_l < 13; j_l++){process_counter[j_l] = 0;}

    for (int i_p = 1; i_p < type_hadron.size(); i_p++){
      process_exchange_counter[lepton_counter[lepton_exchange[type_hadron[i_p]]]]++;
      process_counter[lepton_counter[type_hadron[i_p]]]++;
    }
    
      for (int j_l = 0; j_l < 13; j_l++){
	logger << LOG_DEBUG_VERBOSE << "process_exchange_counter[" << setw(2) <<  i_l << "][" << setw(2) <<  j_l << "] = " << setw(2) << process_counter[j_l] << " --- " << setw(2) << basic_process_counter[j_l] << " = basic_process_counter[" << setw(2) <<  j_l << "]" << endline_flush;
      }
      logger.newLine(LOG_DEBUG_VERBOSE);
    
    if (process_exchange_counter == basic_process_counter){
      logger << LOG_DEBUG << "Permutation " << i_l << " is chosen:" << endline_flush;
      for (int j_l = 1; j_l < 7; j_l++){
	if (lepton_exchange[10 + j_l] != 10 + j_l){logger << LOG_DEBUG << "lepton_exchange[" << setw(3) << right << 10 + j_l << "] -> " << setw(3) << right << lepton_exchange[10 + j_l] << endline_flush;}
	if (lepton_exchange[10 + j_l] != 10 + j_l){logger << LOG_DEBUG << "lepton_exchange[" << setw(3) << right << -10 - j_l << "] -> " << setw(3) << right << lepton_exchange[-10 - j_l] << endline_flush;}
      }
      break;
    }
  }
  //  }

  for (int i_l = 11; i_l < 17; i_l++){
    lepton_exchange_inverse[lepton_exchange[i_l]] = i_l;
    lepton_exchange_inverse[lepton_exchange[-i_l]] = -i_l;
  }



  int first_lepton = 1;
  string new_process_class = "";
  for (int i_p = 1; i_p < type_hadron.size(); i_p++){
    if (abs(type_hadron[i_p]) > 10 && abs(type_hadron[i_p]) < 17){
      if (first_lepton){
	for (int i_l = 1; i_l < 13; i_l++){
	  for (int i_r = 0; i_r < process_counter[i_l]; i_r++){
	    new_process_class = new_process_class + name_particle[lepton_inverse[i_l]]; 
	  //    [lepton_counter[lepton_exchange[type_hadron[i_p]]]]++;
	  }
	}
	first_lepton = 0;
      }
      else {
      }
    }
    else {
      new_process_class = new_process_class + name_particle[type_hadron[i_p]];
    }
    if ((process_type == 1 && i_p == 1) || (process_type == 2 && i_p == 2)){new_process_class = new_process_class + "-";}
  }
  new_process_class = new_process_class + "+X";

  logger << LOG_DEBUG << setw(30) << "process_class    " << " = " << process_class << endline_flush;
  logger << LOG_DEBUG << setw(30) << "new_process_class" << " = " << new_process_class << endline_flush;

  process_class = new_process_class;

  //  logger.newLine(LOG_DEBUG);


  
  n_jet_born = 0;
  for (int i_s = 0; i_s < basic_process_class.size(); i_s++){
    if (basic_process_class[i_s] == 'j'){n_jet_born++;}
  }
  logger << LOG_DEBUG << setw(30) << "n_jet_born" << " = " << n_jet_born << endline_flush;

  n_photon_born = 0;
  for (int i_s = 0; i_s < basic_process_class.size(); i_s++){
    if (basic_process_class[i_s] == 'a'){n_photon_born++;}
  }
  logger << LOG_DEBUG << setw(30) << "n_photon_born" << " = " << n_photon_born << endline_flush;
  //  logger.newLine(LOG_DEBUG);

  logger << LOG_DEBUG << "New determination based on basic_type_hadron (using PDG representation):" << endline_flush;
  n_jet_born = 0;
  for (int i_p = 3; i_p < basic_type_hadron.size(); i_p++){
    if (basic_type_hadron[i_p] == 100){n_jet_born++;}
  }
  logger << LOG_DEBUG << setw(30) << "n_jet_born" << " = " << n_jet_born << endline_flush;

  n_photon_born = 0;
  for (int i_p = 3; i_p < basic_type_hadron.size(); i_p++){
    ///  for (int i_p = 0; i_p < basic_process_class.size(); i_p++){
    if (basic_type_hadron[i_p] == 22){n_photon_born++;}
  }
  logger << LOG_DEBUG << setw(30) << "n_photon_born" << " = " << n_photon_born << endline_flush;


  

  logger.newLine(LOG_DEBUG);
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}



void contribution_set::readin_subprocess(){
  Logger logger("contribution_set::readin_subprocess");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  basic_type_parton.resize(1);
  vector<vector<string> > particles_name(2);
  logger << LOG_DEBUG << setw(30) << left << "subprocess" << " = " << subprocess << endline_flush;

  readin_subprocess_from_name(subprocess, basic_type_parton[0], 1);
  //  determine_process(subprocess, particles_name, process_type, n_particle, basic_type_parton[0], code_particle);
  logger << LOG_DEBUG << setw(30) << left << "n_particle" << " = " << n_particle << endline_flush;
  logger << LOG_DEBUG << setw(30) << left << "process_type" << " = " << process_type << endline_flush;

  logger << LOG_DEBUG << "Check if input corresponds to process_class or basic_process_class:" << endline_flush;

  int basic_counter = 0;
  int counter = 0;
  for (int i_p = 3; i_p < 3 + n_particle_born; i_p++){
    if (basic_type_parton[0][i_p] == basic_type_hadron[i_p]){basic_counter++;}
    if (basic_type_parton[0][i_p] == type_hadron[i_p]){counter++;}
  }
  logger << LOG_DEBUG << "n_particle_born = " << n_particle_born << endline_flush;
  logger << LOG_DEBUG << "basic_counter = " << basic_counter << endline_flush;
  logger << LOG_DEBUG << "counter = " << counter << endline_flush;
  
  if (counter == n_particle_born && basic_counter == n_particle_born){
    logger << LOG_DEBUG << process_class << "  and  " << basic_process_class << "  are identical." << endline_flush;
    type_parton = basic_type_parton;
  }
  else if (basic_counter == n_particle_born){
    logger << LOG_DEBUG << "Subprocess  " << subprocess << "  contributes to  " << basic_process_class << " ." << endline_flush;
    type_parton = basic_type_parton;
    for (int i_p = 3; i_p < 3 + n_particle_born; i_p++){
      if (abs(type_parton[0][i_p]) > 10 && abs(type_parton[0][i_p]) < 17){
	type_parton[0][i_p] = lepton_exchange_inverse[type_parton[0][i_p]];
      }
    }
  }
  else if (counter == n_particle_born){
    logger << LOG_DEBUG << "Subprocess  " << subprocess << "  contributes to  " << process_class << " ." << endline_flush;
    type_parton = basic_type_parton;
    for (int i_p = 3; i_p < 3 + n_particle_born; i_p++){
      if (abs(basic_type_parton[0][i_p]) > 10 && abs(basic_type_parton[0][i_p]) < 17){
	basic_type_parton[0][i_p] = lepton_exchange[basic_type_parton[0][i_p]];
      }
    }
  }
  else {
    logger << LOG_FATAL << "Subprocess  " << subprocess << "  does not contribute to either  " << process_class << "  or  " << basic_process_class << " ." << endline_flush;
  }
  

  
  logger << LOG_DEBUG << "Basic partonic process:" << endline_flush;
  for (int i_p = 1; i_p < basic_type_parton[0].size(); i_p++){
    logger << LOG_DEBUG << setw(26) << "basic_type_parton[0]" << "[" << setw(2) << right << i_p << "]" << " = " << setw(5) << right << basic_type_parton[0][i_p] << "   " << setw(5) << left << name_particle[basic_type_parton[0][i_p]] << endline_flush;
  }
  
  //  logger.newLine(LOG_DEBUG);
  
  logger << LOG_DEBUG << "Partonic process:" << endline_flush;

  type_parton = basic_type_parton;
  for (int i_p = 1; i_p < type_parton[0].size(); i_p++){
    if (abs(type_parton[0][i_p]) > 10 && abs(type_parton[0][i_p]) < 17){
      type_parton[0][i_p] = lepton_exchange[type_parton[0][i_p]];
    } 
    logger << LOG_DEBUG << setw(26) << "type_parton[0]" << "[" << setw(2) << right << i_p << "]" << " = " << right << setw(5) << type_parton[0][i_p] << "   " << setw(5) << left << name_particle[type_parton[0][i_p]] << endline_flush;
  }
  logger.newLine(LOG_DEBUG);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


// temp_switch == 0: Basic hadronic process (Born-level particle content)
// temp_switch == 1: Partonic process
// temp_switch == 2: Hadronic process (with possibly different lepton flavours)
void contribution_set::readin_subprocess_from_name(string this_processname, vector<int> & this_type_parton, int temp_switch){
  Logger logger("contribution_set::readin_subprocess_from_name");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  /*
  if (this_processname[this_processname.size() - 1] == 'X'){switch_to_newscheme = 0;}
  else {switch_to_newscheme = 1;}
  logger << LOG_DEBUG_VERBOSE << "switch_to_newscheme = " << switch_to_newscheme << endline_flush;
  */

  string local_processname;
  string local_typename;
  if (temp_switch == 0){
    local_processname = "basic_process_class";
    local_typename = "basic_type_hadron";
  }
  else if (temp_switch == 1){
    local_processname = "subprocess";
    local_typename = "basic_type_parton";
  }
  else if (temp_switch == 2){
    local_processname = "process_class";
    local_typename = "type_hadron";
  }
  else {
    logger << LOG_FATAL << "Not defined!" << endline_flush;
    exit(1);
  }
  logger << LOG_DEBUG << "local_processname = " << local_processname << " = " << this_processname << endline_flush;
  
  vector<vector<string> > particles_name(2);
    
  if (switch_to_newscheme){newscheme_readin_subprocess_from_name(this_processname, this_type_parton, temp_switch, particles_name);}
  else {oldscheme_readin_subprocess_from_name(this_processname, this_type_parton, temp_switch, particles_name);}

  if (temp_switch == 0){  // basic hadron level
    n_particle_born = particles_name[1].size();
    logger << LOG_DEBUG << "n_particle_born = " << n_particle_born << endline_flush;
  }
  if (temp_switch == 1){  // parton level
    n_particle = particles_name[1].size();
    logger << LOG_DEBUG << "n_particle = " << n_particle << endline_flush;
  }

  if (particles_name[0].size() == 1){}
  else if (particles_name[0].size() == 2){this_type_parton.push_back(0);}
  process_type = particles_name[0].size();
  logger << LOG_DEBUG_VERBOSE << "process_type = " << process_type << endline_flush;
  for (int i = 0; i < 2; i++){
    for (int j = 0; j < particles_name[i].size(); j++){
      this_type_parton.push_back(code_particle[particles_name[i][j]]);
      logger << LOG_DEBUG << local_typename << " :   particles_name[" << right << setw(2) << i << "][" << setw(2) << j << "] = " << left << setw(5) << particles_name[i][j] << "   code_particle = " << right << setw(4) << code_particle[particles_name[i][j]] << endline_flush;
    }
  }


  stringstream temp_tp;
  for (int i_p = 1; i_p < this_type_parton.size(); i_p++){temp_tp << setw(4) << this_type_parton[i_p]; if (i_p == 2){temp_tp << " -> ";}}
  logger << LOG_DEBUG << "local_typename = " << local_typename << " = " << temp_tp.str() << "   this_type_parton.size() = " << this_type_parton.size() << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void contribution_set::newscheme_readin_subprocess_from_name(string this_processname, vector<int> & this_type_parton, int temp_switch, vector<vector<string> > & particles_name){
  Logger logger("contribution_set::newscheme_readin_subprocess_from_name");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int particle_counter = 0;
  int exit = 0;
  
  // Put spaces to avoid possible segmentation faults
  this_processname = this_processname + "     ";
  for (int i = 0; i < this_processname.size(); i++){
    if (particles_name[0].size() == 2 && particles_name[1].size() == 0){particle_counter = 1;}
    // particle counter switches from incoming to outgoing particles (could happen always after the second incoming one for collision processes).
    if (this_processname[i] == '_' || this_processname[i] == '-'){particle_counter++;}
    else if (this_processname[i] == 'p'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("px"); i++;}
      else {particles_name[particle_counter].push_back("p");}
    }
    else if (this_processname[i] == 'j'){particles_name[particle_counter].push_back("j");}
    // generic fermions should not appear by now:
    else if (this_processname[i] == 'f'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("fx"); i++;}
      else {particles_name[particle_counter].push_back("f");}
    }

    else if (this_processname[i] == 'd'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("dx"); i++;}
      else {particles_name[particle_counter].push_back("d");}
    }
    else if (this_processname[i] == 'u'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("ux"); i++;}
      else {particles_name[particle_counter].push_back("u");}
    }
    else if (this_processname[i] == 's'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("sx"); i++;}
      else {particles_name[particle_counter].push_back("s");}
    }
    else if (this_processname[i] == 'c'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("cx"); i++;}
      else {particles_name[particle_counter].push_back("c");}
    }
    else if (this_processname[i] == 'b'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("bx"); i++;}
      else {particles_name[particle_counter].push_back("b");}
    }
    else if (this_processname[i] == 't'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("tx"); i++;}
      else {particles_name[particle_counter].push_back("t");}
    }
    else if (this_processname[i] == 'e'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("ex"); i++;}
      else {particles_name[particle_counter].push_back("e");}
    }
    else if (this_processname[i] == 'm'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("mx"); i++;}
      else {particles_name[particle_counter].push_back("m");}
    }
    else if (this_processname[i] == 'y'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("yx"); i++;}
      else {particles_name[particle_counter].push_back("y");}
    }
    else if (this_processname[i] == 'n'){
      if      (this_processname[i + 1] == 'e'){
	if (this_processname[i + 2] == 'x'){particles_name[particle_counter].push_back("nex"); i += 2;}
	else {particles_name[particle_counter].push_back("ne"); i++;}
      }
      else if (this_processname[i + 1] == 'm'){
	if (this_processname[i + 2] == 'x'){particles_name[particle_counter].push_back("nmx"); i += 2;}
	else {particles_name[particle_counter].push_back("nm"); i++;}
      }
      else if (this_processname[i + 1] == 'y'){
	if (this_processname[i + 2] == 'x'){particles_name[particle_counter].push_back("nyx"); i += 2;}
	else {particles_name[particle_counter].push_back("nt"); i++;}
      }
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'g'){particles_name[particle_counter].push_back("g");}
    else if (this_processname[i] == 'w'){
      if (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("wx"); i++;}
      else {particles_name[particle_counter].push_back("w");}
    }
    else if (this_processname[i] == 'z'){particles_name[particle_counter].push_back("z");}
    else if (this_processname[i] == 'h'){particles_name[particle_counter].push_back("h");}
    else if (this_processname[i] == 'a'){
      if      (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("ax"); i++;}
      else if (this_processname[i + 1] == 'i'){particles_name[particle_counter].push_back("ai"); i++;}
      else {particles_name[particle_counter].push_back("a");}
    }
    //    else if (this_processname[i] == 'a'){particles_name[particle_counter].push_back("a");}
    //    else if (this_processname[i] == ' '){}
    //    else if (this_processname[i] == '+'){}
    //    else if (this_processname[i] == 'X'){}
    else {exit = 1; break;}
  }
  if (exit){} // ??? use of exit ???

  /*
  // remove the spaces that preserve from possible segmentation faults ???
  this_processname.erase(this_processname.end() - 5, this_processname.end());
  logger << LOG_DEBUG_VERBOSE << "end 'determine_process' for " << this_processname << endline_flush;
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void contribution_set::oldscheme_readin_subprocess_from_name(string this_processname, vector<int> & this_type_parton, int temp_switch, vector<vector<string> > & particles_name){
  Logger logger("contribution_set::oldscheme_readin_subprocess_from_name");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int particle_counter = 0;
  int exit = 0;

  // Put spaces to avoid possible segmentation faults
  this_processname = this_processname + "     ";
  for (int i = 0; i < this_processname.size(); i++){
    if (this_processname[i] == '_' || this_processname[i] == '-'){particle_counter++;}
    else if (this_processname[i] == 'p'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("p~"); i++;}
      else {particles_name[particle_counter].push_back("p");}
    }
    else if (this_processname[i] == 'j'){particles_name[particle_counter].push_back("j");}
    else if (this_processname[i] == 'f'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("f~"); i++;}
      else {particles_name[particle_counter].push_back("f");}
    }

    else if (this_processname[i] == 'd'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("d~"); i++;}
      else {particles_name[particle_counter].push_back("d");}
    }
    else if (this_processname[i] == 'u'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("u~"); i++;}
      else {particles_name[particle_counter].push_back("u");}
    }
    else if (this_processname[i] == 's'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("s~"); i++;}
      else {particles_name[particle_counter].push_back("s");}
    }
    else if (this_processname[i] == 'c'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("c~"); i++;}
      else {particles_name[particle_counter].push_back("c");}
    }
    else if (this_processname[i] == 'b'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("b~"); i++;}
      else {particles_name[particle_counter].push_back("b");}
    }
    else if (this_processname[i] == 't'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("t~"); i++;}
      else if (this_processname[i + 1] == 'a')
	if      (this_processname[i + 2] == 'm'){particles_name[particle_counter].push_back("tam"); i += 2;}
	else if (this_processname[i + 2] == 'p'){particles_name[particle_counter].push_back("tap"); i += 2;}
	else {exit = 1; break;}
      else {particles_name[particle_counter].push_back("t");}
    }
    else if (this_processname[i] == 'e'){
      if      (this_processname[i + 1] == 'm'){particles_name[particle_counter].push_back("em"); i++;}
      else if (this_processname[i + 1] == 'p'){particles_name[particle_counter].push_back("ep"); i++;}
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'm'){
      if      (this_processname[i + 1] == 'u' && this_processname[i + 2] == 'm'){particles_name[particle_counter].push_back("mum"); i += 2;}
      else if (this_processname[i + 1] == 'u' && this_processname[i + 2] == 'p'){particles_name[particle_counter].push_back("mup"); i += 2;}
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'v'){
      if      (this_processname[i + 1] == 'e'){
	if (this_processname[i + 2] == '~'){particles_name[particle_counter].push_back("ve~"); i += 2;}
	else {particles_name[particle_counter].push_back("ve"); i++;}
      }
      else if (this_processname[i + 1] == 'm'){
	if (this_processname[i + 2] == '~'){particles_name[particle_counter].push_back("vm~"); i += 2;}
	else {particles_name[particle_counter].push_back("vm"); i++;}
      }
      else if (this_processname[i + 1] == 't'){
	if (this_processname[i + 2] == '~'){particles_name[particle_counter].push_back("vt~"); i += 2;}
	else {particles_name[particle_counter].push_back("vt"); i++;}
      }
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'g'){particles_name[particle_counter].push_back("g");}
    else if (this_processname[i] == 'w'){
      if      (this_processname[i + 1] == 'm'){particles_name[particle_counter].push_back("wm"); i++;}
      else if (this_processname[i + 1] == 'p'){particles_name[particle_counter].push_back("wp"); i++;}
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'z'){particles_name[particle_counter].push_back("z");}
    else if (this_processname[i] == 'h'){particles_name[particle_counter].push_back("h");}
    else if (this_processname[i] == 'a'){
      if      (this_processname[i + 1] == 'x'){particles_name[particle_counter].push_back("ax"); i++;}
      else if (this_processname[i + 1] == 'i'){particles_name[particle_counter].push_back("ai"); i++;}
      else {particles_name[particle_counter].push_back("a");}
    }
    else if (this_processname[i] == ' '){}
    else if (this_processname[i] == '+'){}
    else if (this_processname[i] == 'X'){}
    else {exit = 1; break;}
  }
  if (exit){} // ??? use of exit ???

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::fill_code_particle(){
  Logger logger("fill_code_particle");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (switch_to_newscheme){newscheme_fill_code_particle();}
  else {oldscheme_fill_code_particle();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::newscheme_fill_code_particle(){
  Logger logger("newscheme_fill_code_particle");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  code_particle["d"  ] =     1;
  code_particle["u"  ] =     2;
  code_particle["s"  ] =     3;
  code_particle["c"  ] =     4;
  code_particle["b"  ] =     5;
  code_particle["t"  ] =     6;
  code_particle["dx" ] =    -1;
  code_particle["ux" ] =    -2;
  code_particle["sx" ] =    -3;
  code_particle["cx" ] =    -4;
  code_particle["bx" ] =    -5;
  code_particle["tx" ] =    -6;
  code_particle["e"  ] =    11;
  code_particle["m"  ] =    13;
  code_particle["y"  ] =    15;
  code_particle["ex" ] =   -11;
  code_particle["mx" ] =   -13;
  code_particle["yx" ] =   -15;
  code_particle["ne" ] =    12;
  code_particle["nm" ] =    14;
  code_particle["nt" ] =    16;
  code_particle["nex"] =   -12;
  code_particle["nmx"] =   -14;
  code_particle["ntx"] =   -16;
  code_particle["g"  ] =     0;
  code_particle["a"  ] =    22;
  /*
  code_particle["a"  ] =  2002;
  code_particle["ai" ] = -2002;
  code_particle["ax" ] =    22;
  */
  code_particle["wx" ] =   -24;
  code_particle["w"  ] =    24;
  code_particle["z"  ] =    23;
  code_particle["h"  ] =    25;
  code_particle["p"  ] =   101;
  code_particle["px" ] =  -101;
  code_particle["j"  ] =   100;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::oldscheme_fill_code_particle(){
  Logger logger("oldscheme_fill_code_particle");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  code_particle["d"  ] =     1;
  code_particle["u"  ] =     2;
  code_particle["s"  ] =     3;
  code_particle["c"  ] =     4;
  code_particle["b"  ] =     5;
  code_particle["t"  ] =     6;
  code_particle["d~" ] =    -1;
  code_particle["u~" ] =    -2;
  code_particle["s~" ] =    -3;
  code_particle["c~" ] =    -4;
  code_particle["b~" ] =    -5;
  code_particle["t~" ] =    -6;
  code_particle["em" ] =    11;
  code_particle["mum"] =    13;
  code_particle["tam"] =    15;
  code_particle["ep" ] =   -11;
  code_particle["mup"] =   -13;
  code_particle["tap"] =   -15;
  code_particle["ve" ] =    12;
  code_particle["vm" ] =    14;
  code_particle["vt" ] =    16;
  code_particle["ve~"] =   -12;
  code_particle["vm~"] =   -14;
  code_particle["vt~"] =   -16;
  code_particle["g"  ] =     0;
  code_particle["a"  ] =    22;
  /*
  code_particle["a"  ] =  2002;
  code_particle["ai" ] = -2002;
  code_particle["ax" ] =    22;
  */
  code_particle["wp" ] =   -24;
  code_particle["wm" ] =    24;
  code_particle["z"  ] =    23;
  code_particle["h"  ] =    25;

  code_particle["q"  ] =    10;
  code_particle["p"  ] =   101;
  code_particle["p~" ] =  -101;
  //  code_particle["jet"] =   100;
  code_particle["j"  ] =   100;
  /*
  code_particle["d"]   = 1;
  code_particle["u"]   = 2;
  code_particle["s"]   = 3;
  code_particle["c"]   = 4;
  code_particle["b"]   = 5;
  code_particle["t"]   = 6;
  code_particle["d~"]  = -1;
  code_particle["u~"]  = -2;
  code_particle["s~"]  = -3;
  code_particle["c~"]  = -4;
  code_particle["b~"]  = -5;
  code_particle["t~"]  = -6;
  code_particle["em"]  = 11;
  code_particle["mum"] = 13;
  code_particle["tam"] = 15;
  code_particle["ep"]  = -11;
  code_particle["mup"] = -13;
  code_particle["tap"] = -15;
  code_particle["ve"]  = 12;
  code_particle["vm"]  = 14;
  code_particle["vt"]  = 16;
  code_particle["ve~"] = -12;
  code_particle["vm~"] = -14;
  code_particle["vt~"] = -16;
  code_particle["g"]   = 0;
  code_particle["a"]   = 22;
  code_particle["a~"]  = -22;
  code_particle["wp"]  = -24;
  code_particle["wm"]  = 24;
  code_particle["z"]   = 23;
  code_particle["h"]   = 25;
  code_particle["p"]  = 101;
  code_particle["p~"]  = -101;
  code_particle["j"]  = 100;
  //  code_particle["jet"]  = 100;
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}



void contribution_set::fill_name_particle(){
  Logger logger("fill_name_particle");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (switch_to_newscheme){newscheme_fill_name_particle();}
  else {oldscheme_fill_name_particle();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::newscheme_fill_name_particle(){
  Logger logger("newscheme_fill_name_particle");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  name_particle[    0] = "g";
  name_particle[   21] = "g";
  name_particle[    7] = "a";
  name_particle[   22] = "a";
  /*
  name_particle[ 2002] = "a";
  name_particle[-2002] = "ai";
  name_particle[   22] = "ax";
  */
  name_particle[  -24] = "wx";
  name_particle[   24] = "w";
  name_particle[   23] = "z";
  name_particle[   25] = "h";
  name_particle[    1] = "d";
  name_particle[    2] = "u";
  name_particle[    3] = "s";
  name_particle[    4] = "c";
  name_particle[    5] = "b";
  name_particle[    6] = "t";
  name_particle[   -1] = "dx";
  name_particle[   -2] = "ux";
  name_particle[   -3] = "sx";
  name_particle[   -4] = "cx";
  name_particle[   -5] = "bx";
  name_particle[   -6] = "tx";
  name_particle[   11] = "e";
  name_particle[   12] = "ne";
  name_particle[   13] = "m";
  name_particle[   14] = "nm";
  name_particle[   15] = "y";
  name_particle[   16] = "ny";
  name_particle[  -11] = "ex";
  name_particle[  -12] = "nex";
  name_particle[  -13] = "mx";
  name_particle[  -14] = "nmx";
  name_particle[  -15] = "yx";
  name_particle[  -16] = "nyx";
  name_particle[  101] = "p";
  name_particle[ -101] = "px";
  name_particle[  100] = "j";

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void contribution_set::oldscheme_fill_name_particle(){
  Logger logger("oldscheme_fill_name_particle");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  name_particle[    0] = "g";
  name_particle[   21] = "g";
  name_particle[    7] = "a";
  name_particle[   22] = "a";
  /*
  name_particle[ 2002] = "a";
  name_particle[-2002] = "ai";
  name_particle[   22] = "ax";
  */
  name_particle[  -24] = "wp";
  name_particle[   24] = "wm";
  name_particle[   23] = "z";
  name_particle[   25] = "h";
  name_particle[    1] = "d";
  name_particle[    2] = "u";
  name_particle[    3] = "s";
  name_particle[    4] = "c";
  name_particle[    5] = "b";
  name_particle[    6] = "t";
  name_particle[   -1] = "d~";
  name_particle[   -2] = "u~";
  name_particle[   -3] = "s~";
  name_particle[   -4] = "c~";
  name_particle[   -5] = "b~";
  name_particle[   -6] = "t~";
  name_particle[   11] = "em";
  name_particle[   12] = "ve";
  name_particle[   13] = "mum";
  name_particle[   14] = "vm";
  name_particle[   15] = "tam";
  name_particle[   16] = "vt";
  name_particle[  -11] = "ep";
  name_particle[  -12] = "ve~";
  name_particle[  -13] = "mup";
  name_particle[  -14] = "vm~";
  name_particle[  -15] = "tap";
  name_particle[  -16] = "vt~";

  name_particle[   10] = "q";
  name_particle[  101] = "p";
  name_particle[ -101] = "p~";
  name_particle[  100] = "jet";
  /*
  name_particle[  0] = "g";
  name_particle[ 22] = "a";
  name_particle[-22] = "a~";
  name_particle[-24] = "wp";
  name_particle[ 24] = "wm";
  name_particle[ 23] = "z";
  name_particle[ 25] = "h";
  name_particle[  1] = "d";
  name_particle[  2] = "u";
  name_particle[  3] = "s";
  name_particle[  4] = "c";
  name_particle[  5] = "b";
  name_particle[  6] = "t";
  name_particle[ -1] = "d~";
  name_particle[ -2] = "u~";
  name_particle[ -3] = "s~";
  name_particle[ -4] = "c~";
  name_particle[ -5] = "b~";
  name_particle[ -6] = "t~";
  name_particle[ 11] = "em";
  name_particle[ 12] = "ve";
  name_particle[ 13] = "mum";
  name_particle[ 14] = "vm";
  name_particle[ 15] = "tam";
  name_particle[ 16] = "vt";
  name_particle[-11] = "ep";
  name_particle[-12] = "ve~";
  name_particle[-13] = "mup";
  name_particle[-14] = "vm~";
  name_particle[-15] = "tap";
  name_particle[-16] = "vt~";
  name_particle[101] = "p";
  name_particle[-101] = "p~";
  name_particle[100] = "j";
  //  name_particle[100] = "jet";
  */
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


string contribution_set::output_parton_content(){
  static Logger logger("contribution_set::output");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream s;
  //  s << "Overview of parton content and features:" << endline;
  s << "Parton content:" << endline;
  s << endline;
  if (n_ps > 1){s << setw(10) << "";}
  s << setw(8) << "";
  s << "   " << setw(4) << "type";
  s << "   " << setw(11) << "mass";
  s << "   " << setw(11) << "mass2";
  s << "   " << setw(11) << "charge";
  s << "   " << setw(11) << "charge2";
  s << "   " << setw(11) << "casimir";
  s << "   " << setw(11) << "is_massive";
  s << "   " << setw(11) << "is_charged";
  s << "   " << setw(11) << "is_coloured" << endline;
  for (int i_a = 0; i_a < n_ps; i_a++){
    for (int i_p = 1; i_p < type_parton[i_a].size(); i_p++){
      if (n_ps > 1){s << setw(10) << dipole[i_a].name();}
      s << "[" << setw(2) << i_a << "]" << "[" << setw(2) << i_p << "]";
      s << "   " << setw(4) << type_parton[i_a][i_p];
      s << "   " << setw(11) << setprecision(8) << mass_parton[i_a][i_p];
      s << "   " << setw(11) << setprecision(8) << mass2_parton[i_a][i_p];
      s << "   " << setw(11) << setprecision(8) << charge_parton[i_a][i_p];
      s << "   " << setw(11) << setprecision(8) << charge2_parton[i_a][i_p];
      s << "   " << setw(11) << setprecision(8) << casimir_parton[i_a][i_p];
      s << "   " << setw(11) << is_massive_parton[i_a][i_p];
      s << "   " << setw(11) << is_charged_parton[i_a][i_p];
      s << "   " << setw(11) << is_coloured_parton[i_a][i_p] << endline;
    }
    if (i_a < n_ps - 1){s << endline;}
  }
   
  logger << LOG_DEBUG_VERBOSE << "finished - " << s.str() << endline_flush;
  return s.str();
}
