#include "header.hpp"

void observable_set::determine_collinear_QCD(){
  Logger logger("observable_set::determine_collinear_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "Collinear-dipole determination" << endline << endline_flush;
  logger.newLine(LOG_DEBUG);
  
  vector<string> pa_name(csi->type_parton[0].size(), "");
  if (csi->type_parton[0][1] >= -10 && csi->type_parton[0][1] <= 10){pa_name[1] = "a";}
  if (csi->type_parton[0][2] >= -10 && csi->type_parton[0][2] <= 10){pa_name[2] = "b";}
  for (int i_p = 3; i_p < pa_name.size(); i_p++){if (csi->type_parton[0][i_p] >= -10 && csi->type_parton[0][i_p] <= 10){pa_name[i_p] = char(105 + i_p - 3);}}

  int temp_type_correction = 1;

  for (int temp_no_emitter = 1; temp_no_emitter < 3; temp_no_emitter++){
    if (pa_name[temp_no_emitter] == ""){continue;}
    string temp_name;
    vector<string> temp_all_name(csi->combination_pdf.size());
    int temp_type;
    vector<int> temp_in_collinear(3, 0);
    temp_in_collinear[temp_no_emitter] = 1;
    vector<vector<int> > temp_pdf_new;
    double temp_charge_factor = 1.;
    double temp_charge_factor_fi = 1.;
    for (int i_t = 0; i_t < 2; i_t++){
      temp_pdf_new = csi->combination_pdf;
      if (csi->combination_pdf[0][temp_no_emitter] == 0){
	if (i_t == 0){
	  temp_type = 0; // hard process with g from g -> g g splitting
	  temp_in_collinear[0] = 1;
	  temp_name = "C_" + pa_name[temp_no_emitter] + "^{gg}";
	  for (int i_x = 0; i_x < csi->combination_pdf.size(); i_x++){temp_all_name[i_x] = "C_" + pa_name[temp_no_emitter] + "^{gg}";}
	}
	else {
	  temp_type = 2; // hard process with a from q -> g q splitting
	  temp_in_collinear[0] = 0;
	  temp_name = "C_" + pa_name[temp_no_emitter] + "^{qg}";
	  for (int i_x = 0; i_x < csi->combination_pdf.size(); i_x++){temp_pdf_new[i_x][temp_no_emitter] = 10;}
	  for (int i_x = 0; i_x < csi->combination_pdf.size(); i_x++){temp_all_name[i_x] = "C_" + pa_name[temp_no_emitter] + "^{qg}";}
	}
      }
      else if (csi->combination_pdf[0][temp_no_emitter] != 0){
	if (i_t == 0){
	  temp_type = 3; // hard process with q from g -> q qx splitting
	  temp_in_collinear[0] = 0;
	  temp_name = "C_" + pa_name[temp_no_emitter] + "^{g" + csi->name_particle[csi->combination_pdf[0][temp_no_emitter]] + "}";
	  for (int i_x = 0; i_x < csi->combination_pdf.size(); i_x++){temp_pdf_new[i_x][temp_no_emitter] = 0;}
	  for (int i_x = 0; i_x < csi->combination_pdf.size(); i_x++){temp_all_name[i_x] = "C_" + pa_name[temp_no_emitter] + "^{g" + csi->name_particle[csi->combination_pdf[i_x][temp_no_emitter]] + "}";}
	}
	else {
	  temp_type = 1; // hard process with q from q -> q g splitting
	  temp_in_collinear[0] = 1;
	  temp_name = "C_" + pa_name[temp_no_emitter] + "^{" + csi->name_particle[csi->combination_pdf[0][temp_no_emitter]] + csi->name_particle[csi->combination_pdf[0][temp_no_emitter]] + "}";
	  for (int i_x = 0; i_x < csi->combination_pdf.size(); i_x++){temp_all_name[i_x] = "C_" + pa_name[temp_no_emitter] + "^{" + csi->name_particle[csi->combination_pdf[i_x][temp_no_emitter]] + csi->name_particle[csi->combination_pdf[i_x][temp_no_emitter]] + "}";}
	}
      }

      int flag = (*CA_collinear).size();
      for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){if (temp_no_emitter == (*CA_collinear)[i_c][0].no_emitter() && temp_type == (*CA_collinear)[i_c][0].type()){flag = i_c; break;}}
      if (flag == (*CA_collinear).size()){(*CA_collinear).push_back(vector<collinear_set> ());}
      for (int temp_no_spectator = 0; temp_no_spectator < csi->type_parton[0].size(); temp_no_spectator++){
	if ((temp_no_spectator > 0 && pa_name[temp_no_spectator] == "") || temp_no_spectator == temp_no_emitter){continue;}
	vector<int> temp_pair(2);
	if (temp_no_emitter < temp_no_spectator){
	  temp_pair[0] = temp_no_emitter;
	  temp_pair[1] = temp_no_spectator;
	}
	else {
	  temp_pair[0] = temp_no_spectator;
	  temp_pair[1] = temp_no_emitter;
	}

	int temp_massive = -1;
	if (csi->mass_parton[0][temp_no_emitter] == 0. && csi->mass_parton[0][temp_no_spectator] == 0.){temp_massive = 0;}
	else if (csi->mass_parton[0][temp_no_emitter] != 0. && csi->mass_parton[0][temp_no_spectator] == 0.){temp_massive = 1;}
	else if (csi->mass_parton[0][temp_no_emitter] == 0. && csi->mass_parton[0][temp_no_spectator] != 0.){temp_massive = 2;}
	else if (csi->mass_parton[0][temp_no_emitter] != 0. && csi->mass_parton[0][temp_no_spectator] != 0.){temp_massive = 3;}
	else {logger << LOG_FATAL << "Should not happen!" << endline_flush; exit(1);}

	vector<string> temp_all_name_spectator = temp_all_name;
	for (int i_x = 0; i_x < temp_all_name_spectator.size(); i_x++){temp_all_name_spectator[i_x] = temp_all_name_spectator[i_x] + "(" + pa_name[temp_no_spectator] + ")";}
	string temp_name_spectator = temp_name + "(" + pa_name[temp_no_spectator] + ")";
	(*CA_collinear)[flag].push_back(collinear_set(temp_name_spectator, temp_all_name_spectator, temp_type, temp_in_collinear, csi->no_process_parton[0], csi->type_parton[0], temp_pdf_new, temp_charge_factor, temp_charge_factor_fi, temp_no_emitter, temp_no_spectator, temp_pair, temp_type_correction, temp_massive));
      }
    }
  }

  logger.newLine(LOG_DEBUG);
  logger << LOG_DEBUG << "Before selection of contributing collinear 'dipoles':" << endline_flush;
  logger.newLine(LOG_DEBUG);
  logger << LOG_DEBUG << output_collinear() << endline_flush;
  logger.newLine(LOG_DEBUG);
  /////  determination_collinear_splitting();
  logger << LOG_DEBUG << "Before filling CA_combination_pdf for collinear 'dipoles'" << endline_flush;
  logger.newLine(LOG_DEBUG);

  fill_CA_combination_pdf();

  determine_CA_list_combination_pdf();

  
  logger << LOG_DEBUG  << "After filling CA_combination_pdf for collinear 'dipoles'" << endline_flush;
  logger.newLine(LOG_DEBUG);
  logger << LOG_DEBUG << "Before filling CA_Q2f for collinear 'dipoles'" << endline_flush;
  logger.newLine(LOG_DEBUG);

  CA_Q2f.resize((*CA_collinear).size());
  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    CA_Q2f[i_c].resize(CA_combination_pdf[i_c].size());
    for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
      for (int i_x = 0; i_x < CA_combination_pdf[i_c][i_i].size(); i_x++){
	CA_Q2f[i_c][i_i].push_back(1.);
      }
    }
  }
  logger << LOG_DEBUG << "After filling CA_Q2f for collinear 'dipoles'" << endline_flush;
  logger.newLine(LOG_DEBUG);
  // QT_Q2f nd CA_C2f should be made a single variable later !!!
  /*
  QT_Q2f = CA_Q2f;
  if (list_combination_pdf.size() == (*CA_collinear).size() + 1){QT_Q2f.push_back(QT_Q2f[0]);}
  */
  // fill endpoint component first (needs to be checked anyway !!!)
  QT_Q2f.resize((*CA_collinear).size() + 1);
  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){QT_Q2f[i_c + 1] = CA_Q2f[i_c];}
  if ((*CA_collinear).size() > 0){QT_Q2f[0] = CA_Q2f[0];}
  
  // New position !!!
  determination_collinear_splitting();
  
  logger << LOG_DEBUG << "After determination of collinear_splitting" << endline_flush;
  logger.newLine(LOG_DEBUG);
  logger << LOG_DEBUG << "Before selection of contributing collinear 'dipoles'" << endline_flush;
  logger.newLine(LOG_DEBUG);

  selection_collinear();

  logger.newLine(LOG_DEBUG);
  logger << LOG_DEBUG << "After selection of contributing collinear 'dipoles':" << endline_flush;
  logger.newLine(LOG_DEBUG);

  logger << LOG_INFO << output_collinear() << endline_flush;
  logger << LOG_INFO << output_collinear_pdf() << endline_flush;
  logger << LOG_INFO << output_collinear_splitting() << endline_flush;
  logger << LOG_INFO << output_collinear_pa_name(temp_type_correction, pa_name) << endline_flush;
  logger.newLine(LOG_INFO);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::initialization_collinear_QCD(){
  Logger logger("observable_set::initialization_collinear_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  Kbar.resize(4, vector<double> (3, 0.));
  Kt.resize(4, vector<double> (3, 0.));
  P.resize(4, vector<double> (3, 0.));
  Kbar_plus.resize(4, vector<double> (3, 0.));
  Kt_plus.resize(4, vector<double> (3, 0.));
  P_plus.resize(4, vector<double> (3, 0.));
  intKbar_plus.resize(4, vector<double> (3, 0.));
  intKt_plus.resize(4, vector<double> (3, 0.));
  intP_plus.resize(4, vector<double> (3, 0.));
  Kbar_delta.resize(4, 0.);
  Kt_delta.resize(4, 0.);
  P_delta.resize(4, 0.);

  alpha_S_2pi = alpha_S * inv2pi;

  iT2_ap.resize(3);
  gamma_i_T2_i.resize((*CA_collinear).size());

  ln_papi.resize(3, vector<double> (csi->type_parton[0].size()));
  CA_value_ln_muF_papi.resize(CA_value_log_mu2_fact.size());
  value_dataP.resize(CA_value_log_mu2_fact.size());

  type.resize((*CA_collinear).size());
  no_emitter.resize((*CA_collinear).size());
  no_spectator.resize((*CA_collinear).size());
  collinear_singularity.resize((*CA_collinear).size());
  ppair.resize((*CA_collinear).size());

  // calculate all needed momentum-independent (splitting) functions
  if (CA_dipole_splitting[0][1] == 1 || CA_dipole_splitting[0][2] == 1){    // g -> g (g) splitting (0)
    Kbar_delta[0] = CS_QCD_Kbar_gg_delta;
    Kt_delta[0] = CS_QCD_Kt_gg_delta;
    P_delta[0] = CS_QCD_P_gg_delta;
  }
  if (CA_dipole_splitting[1][1] == 1 || CA_dipole_splitting[1][2] == 1){    // q -> q (g) splitting
    Kbar_delta[1] = CS_QCD_Kbar_qq_delta;
    Kt_delta[1] = CS_QCD_Kt_qq_delta;
    P_delta[1] = CS_QCD_P_qq_delta;
  }

  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      if ((*CA_collinear)[i_c][j_c].no_spectator() == 0){continue;}
      bool flag = false;
      for (int i_p = 0; i_p < pair.size(); i_p++){
	if ((*CA_collinear)[i_c][j_c].pair() == pair[i_p]){flag = true; break;}
      }
      if (!flag){pair.push_back((*CA_collinear)[i_c][j_c].pair());}
    }
  }

  for (int sd = 0; sd < CA_value_ln_muF_papi.size(); sd++){
    CA_value_ln_muF_papi[sd].resize(CA_value_log_mu2_fact[sd].size(), vector<vector<double> > (3, vector<double> (csi->type_parton[0].size())));
  }
  for (int sd = 0; sd < CA_value_ln_muF_papi.size(); sd++){
    value_dataP[sd].resize(CA_value_log_mu2_fact[sd].size(), vector<vector<vector<double> > > (3, vector<vector<double> > ((*CA_collinear).size())));
    for (int ss = 0; ss < CA_value_ln_muF_papi[sd].size(); ss++){
      for (int i_x = 0; i_x < 3; i_x++){
	for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
	  value_dataP[sd][ss][i_x][i_c].resize((*CA_collinear)[i_c].size(), 0.);
	}
      }
    }
  }

  for (int i_em = 1; i_em < 3; i_em++){
    if (csi->type_parton[0][i_em] == 0){iT2_ap[i_em] = 1. / C_A;}
    else {iT2_ap[i_em] = 1. / C_F;}
  }

  for (int i_c = 0; i_c < gamma_i_T2_i.size(); i_c++){
    gamma_i_T2_i[i_c].resize((*CA_collinear)[i_c].size());
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      if ((*CA_collinear)[i_c][j_c].type_parton()[(*CA_collinear)[i_c][j_c].no_spectator()] == 0){gamma_i_T2_i[i_c][j_c] = CS_QCD_gamma_g / C_A;}
      else {gamma_i_T2_i[i_c][j_c] = CS_QCD_gamma_q / C_F;}
    }
  }

  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    type[i_c].resize((*CA_collinear)[i_c].size());
    no_emitter[i_c].resize((*CA_collinear)[i_c].size());
    no_spectator[i_c].resize((*CA_collinear)[i_c].size());
    collinear_singularity[i_c].resize((*CA_collinear)[i_c].size());
    ppair[i_c].resize((*CA_collinear)[i_c].size());
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      type[i_c][j_c] = (*CA_collinear)[i_c][j_c].type();
      no_emitter[i_c][j_c] = (*CA_collinear)[i_c][j_c].no_emitter();
      no_spectator[i_c][j_c] = (*CA_collinear)[i_c][j_c].no_spectator();
      collinear_singularity[i_c][j_c] = (*CA_collinear)[i_c][j_c].in_collinear()[0];
      ppair[i_c][j_c] = (*CA_collinear)[i_c][j_c].pair();
    }
  }


  // Additional initialization for massive case
  if (massive_QCD){
    P_reg.resize(4, vector<double> (3, 0.));
    gamma_a_T2_ap.resize(3);
    for (int i_em = 1; i_em < 3; i_em++){
      if (csi->type_parton[0][i_em] == 0){gamma_a_T2_ap[i_em] = CS_QCD_gamma_g / C_A;}
      else {gamma_a_T2_ap[i_em] = CS_QCD_gamma_q / C_F;}
    }

    // Check meaning of n_max_spectator (looks a bit weird) !!!
    static int n_max_spectator = 0;
    for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
      if ((*CA_collinear)[i_c].size() > n_max_spectator){n_max_spectator = (*CA_collinear)[i_c].size();}
    }
    // Seems to be problematic if csi->type_parton[0].size() > n_max_spectator !!!
    if (n_max_spectator < csi->type_parton[0].size()){n_max_spectator = csi->type_parton[0].size();}
    // Probably this could be always used !!! ???

    Kit.resize(4, vector<vector<double> > (3, vector<double> (n_max_spectator, 0.)));
    intKit_plus.resize(4, vector<vector<double> > (3, vector<double> (n_max_spectator, 0.)));
    Kit_plus_x.resize(4, vector<vector<double> > (3, vector<double> (n_max_spectator, 0.)));
    Kit_plus_1.resize(4, vector<vector<double> > (3, vector<double> (n_max_spectator, 0.)));
    Kit_plus_outside_x.resize(4, vector<vector<double> > (3, vector<double> (n_max_spectator, 0.)));
    Kit_plus_outside_1.resize(4, vector<vector<double> > (3, vector<double> (n_max_spectator, 0.)));
    Kit_delta.resize(4, vector<vector<double> > (3, vector<double> (n_max_spectator, 0.)));
    m_Q.resize(csi->type_parton[0].size(), 0.);
    m2_Q.resize(csi->type_parton[0].size(), 0.);
    sall_ja.resize(3, vector<double> (csi->type_parton[0].size(), 0.));
    sall_ja_x.resize(3, vector<double> (csi->type_parton[0].size(), 0.));
    mu2_Q.resize(3, vector<double> (csi->type_parton[0].size(), 0.));
    mu2_Q_x.resize(3, vector<double> (csi->type_parton[0].size(), 0.));

    for (int i_p = 3; i_p < csi->type_parton[0].size(); i_p++){
      //      if (i_p < 3 && msi->M2_pdg[abs(csi->type_parton[0][i_p])] != 0.){logger << LOG_FATAL << "Incoming massive partons are not supported!" << endline_flush; int_end = 1; exit(1);}
      //      if (msi->M2_pdg[abs(csi->type_parton[0][i_p])] != 0.){
      if (csi->mass_parton[0][i_p] != 0.){
	m_Q[i_p] = csi->mass_parton[0][i_p];
	m2_Q[i_p] = csi->mass2_parton[0][i_p];
      }
    }

    for (int i_p = 0; i_p < pair.size(); i_p++){
      int pair_em = pair[i_p][0];
      int pair_sp = pair[i_p][1];
      // Shouldn't this situation throw an error message instead ???
      //      if (m2_Q[pair_em] > 0.){logger << LOG_FATAL << "Emitter may not be massive!" << endline_flush; exit(1);}
      if (m2_Q[pair_em] > 0.){return;}

      if (m2_Q[pair_sp] > 0.){
	for (int i_dt = 0; i_dt < 4; i_dt++){
	  Kit[i_dt][pair_em][pair_sp] = 0.;
	  Kit_plus_x[i_dt][pair_em][pair_sp] = 0.;
	  Kit_plus_1[i_dt][pair_em][pair_sp] = 0.;
	  intKit_plus[i_dt][pair_em][pair_sp] = 0.;
	  Kit_plus_outside_x[i_dt][pair_em][pair_sp] = 0.;
	  Kit_plus_outside_1[i_dt][pair_em][pair_sp] = 0.;
	  Kit_delta[i_dt][pair_em][pair_sp] = 0.;
	}
      }
    }
  }
 
  for (int i_p = 0; i_p < pair.size(); i_p++){logger << LOG_DEBUG << "pair[" << i_p << "] = " << "(" << pair[i_p][0] << ", " << pair[i_p][1] << ")" << endline_flush;}
    
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
  

void observable_set::calculate_collinear_QCD(){
  Logger logger("observable_set::calculate_collinear_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  static int initialization = 1;
  if (initialization == 1){
    initialization_collinear_QCD();
    
    initialization = 0;
    logger << LOG_DEBUG_VERBOSE << "initialization finished!" << endline_flush;
  }

  for (int i_em = 1; i_em < 3; i_em++){
    if (CA_dipole_splitting[0][i_em] == 1){      // g -> g (g) splitting
      Kbar[0][i_em] = CS_QCD_Kbar_gg(psi->z_coll[i_em]);
      Kt[0][i_em] = CS_QCD_Kt_gg(psi->z_coll[i_em]);
      P[0][i_em] = CS_QCD_P_gg(psi->z_coll[i_em]);
      if (massive_QCD){P_reg[0][i_em] = CS_QCD_P_gg_reg(psi->z_coll[i_em]);}
      if (CA_dipole_splitting[0][0] == 1){
	Kbar_plus[0][i_em] = CS_QCD_Kbar_gg_plus(psi->z_coll[i_em]);
	Kt_plus[0][i_em] = CS_QCD_Kt_gg_plus(psi->z_coll[i_em]);
	P_plus[0][i_em] = CS_QCD_P_gg_plus(psi->z_coll[i_em]);
	intKbar_plus[0][i_em] = CS_QCD_intKbar_gg_plus(psi->x_pdf[i_em]);
	intKt_plus[0][i_em] = CS_QCD_intKt_gg_plus(psi->x_pdf[i_em]);
	intP_plus[0][i_em] = CS_QCD_intP_gg_plus(psi->x_pdf[i_em]);
      }
      else {logger << LOG_FATAL << "May not happen !!! g -> g splitting without irregular terms !!!" << endline_flush;}
    }
    if (CA_dipole_splitting[1][i_em] == 1){      // q -> q (g) splitting
      Kbar[1][i_em] = CS_QCD_Kbar_qq(psi->z_coll[i_em]);
      Kt[1][i_em] = CS_QCD_Kt_qq(psi->z_coll[i_em]);
      P[1][i_em] = CS_QCD_P_qq(psi->z_coll[i_em]);
      if (massive_QCD){P_reg[1][i_em] = CS_QCD_P_qq_reg(psi->z_coll[i_em]);}
      if (CA_dipole_splitting[1][0] == 1){
	Kbar_plus[1][i_em] = CS_QCD_Kbar_qq_plus(psi->z_coll[i_em]);
	Kt_plus[1][i_em] = CS_QCD_Kt_qq_plus(psi->z_coll[i_em]);
	P_plus[1][i_em] = CS_QCD_P_qq_plus(psi->z_coll[i_em]);
	intKbar_plus[1][i_em] = CS_QCD_intKbar_qq_plus(psi->x_pdf[i_em]);
	intKt_plus[1][i_em] = CS_QCD_intKt_qq_plus(psi->x_pdf[i_em]);
	intP_plus[1][i_em] = CS_QCD_intP_qq_plus(psi->x_pdf[i_em]);
      }
      else {logger << LOG_FATAL << "May not happen !!! q -> q splitting without irregular terms !!!" << endline_flush;}
    }
    if (CA_dipole_splitting[2][i_em] == 1){      // q -> g (q) splitting
      Kbar[2][i_em] = CS_QCD_Kbar_qg(psi->z_coll[i_em]);
      Kt[2][i_em] = CS_QCD_Kt_qg(psi->z_coll[i_em]);
      P[2][i_em] = CS_QCD_P_qg(psi->z_coll[i_em]);
      if (massive_QCD){P_reg[2][i_em] = P[2][i_em];}
    }
    if (CA_dipole_splitting[3][i_em] == 1){      // g -> q (qx) splitting
      Kbar[3][i_em] = CS_QCD_Kbar_gq(psi->z_coll[i_em]);
      Kt[3][i_em] = CS_QCD_Kt_gq(psi->z_coll[i_em]);
      P[3][i_em] = CS_QCD_P_gq(psi->z_coll[i_em]);
      if (massive_QCD){P_reg[3][i_em] = P[3][i_em];}
    }
  }


  // calculation of all Kbar, Kitalic, Ktilde, and P functions for KP terms:
  
  if (massive_QCD){calculate_collinear_QCD_CDST();}
  else {calculate_collinear_QCD_CS();}


  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int i_x = 0; i_x < 3; i_x++){
      double temp_sumK = accumulate(data_K[i_x][i_c].begin(), data_K[i_x][i_c].end(), 0.);
      if (switch_TSV){
	for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
	  for (int v_xf = 0; v_xf < value_logscale2_fact_papi[v_sf].size(); v_xf++){
	    if (switch_KP == 0){
	      // K + P terms
	      value_ME2_KP[v_sf][v_xf][i_x][i_c] = alpha_S_2pi * (temp_sumK + accumulate(value_data_P[v_sf][v_xf][i_x][i_c].begin(), value_data_P[v_sf][v_xf][i_x][i_c].end(), 0.));
	      value_ME2term_fact[i_c][i_x][v_sf][v_xf] = alpha_S_2pi * (temp_sumK + accumulate(value_data_P[v_sf][v_xf][i_x][i_c].begin(), value_data_P[v_sf][v_xf][i_x][i_c].end(), 0.));
	    }
	    else if (switch_KP == 1){
	      // P terms
	      value_ME2_KP[v_sf][v_xf][i_x][i_c] = alpha_S_2pi * (accumulate(value_data_P[v_sf][v_xf][i_x][i_c].begin(), value_data_P[v_sf][v_xf][i_x][i_c].end(), 0.));
	      value_ME2term_fact[i_c][i_x][v_sf][v_xf] = alpha_S_2pi * (accumulate(value_data_P[v_sf][v_xf][i_x][i_c].begin(), value_data_P[v_sf][v_xf][i_x][i_c].end(), 0.));
	    }
	    else if (switch_KP == 2){
	      // K terms
	      value_ME2_KP[v_sf][v_xf][i_x][i_c] = alpha_S_2pi * (temp_sumK);
	      value_ME2term_fact[i_c][i_x][v_sf][v_xf] = alpha_S_2pi * (temp_sumK);
	    }
	  }
	}
      }

      for (int sd = 0; sd < CA_value_ln_muF_papi.size(); sd++){
	for (int ss = 0; ss < CA_value_ln_muF_papi[sd].size(); ss++){
	  if (switch_KP == 0){
	    // K + P term
	    CA_value_ME2_KP[sd][ss][i_x][i_c] = alpha_S_2pi * (temp_sumK + accumulate(value_dataP[sd][ss][i_x][i_c].begin(), value_dataP[sd][ss][i_x][i_c].end(), 0.));
	  }
	  else if (switch_KP == 1){
	    // P terms
	    CA_value_ME2_KP[sd][ss][i_x][i_c] = alpha_S_2pi * (accumulate(value_dataP[sd][ss][i_x][i_c].begin(), value_dataP[sd][ss][i_x][i_c].end(), 0.));
	  }
	  else if (switch_KP == 2){
	    // K terms
	    CA_value_ME2_KP[sd][ss][i_x][i_c] = alpha_S_2pi * (temp_sumK);
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::calculate_collinear_QCD_CS(){
  Logger logger("observable_set::calculate_collinear_QCD_CS");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int i_p = 0; i_p < pair.size(); i_p++){
    ln_papi[pair[i_p][0]][pair[i_p][1]] = log(2 * esi->p_parton[0][pair[i_p][0]] * esi->p_parton[0][pair[i_p][1]]);
    if (switch_TSV){
      for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
	for (int v_xf = 0; v_xf < n_scale_dyn_fact[v_sf]; v_xf++){
	  value_logscale2_fact_papi[v_sf][v_xf][pair[i_p][0]][pair[i_p][1]] = value_central_logscale2_fact[v_sf] + value_relative_logscale2_fact[v_sf][v_xf] - ln_papi[pair[i_p][0]][pair[i_p][1]];
	}
      }
    }
    for (int sd = 0; sd < CA_value_ln_muF_papi.size(); sd++){
      for (int ss = 0; ss < CA_value_ln_muF_papi[sd].size(); ss++){
	CA_value_ln_muF_papi[sd][ss][pair[i_p][0]][pair[i_p][1]] = CA_value_log_mu2_fact[sd][ss] - ln_papi[pair[i_p][0]][pair[i_p][1]];
      }
    }
  }

  // Split calculation of K and P terms !!!
  
  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      // K terms
      data_K[0][i_c][j_c] = 0.;
      data_K[1][i_c][j_c] = 0.;
      data_K[2][i_c][j_c] = 0.;
      if (no_spectator[i_c][j_c] == 0){
	if (switch_off_CS_ii || switch_off_CS_if){
	  double temp_charge2_emitter = (-iT2_ap[(*CA_collinear)[i_c][j_c].no_emitter()]);
	  for (int k_c = 1; k_c < (*CA_collinear)[i_c].size(); k_c++){
	    if ((!switch_off_CS_ii && ((*CA_collinear)[i_c][k_c].no_emitter() < 3 && (*CA_collinear)[i_c][k_c].no_spectator() < 3)) ||
		(!switch_off_CS_if && ((*CA_collinear)[i_c][k_c].no_emitter() < 3 && (*CA_collinear)[i_c][k_c].no_spectator() > 2))){
	      data_K[0][i_c][j_c] += (Kbar[type[i_c][j_c]][no_emitter[i_c][j_c]] + Kbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][k_c] * temp_charge2_emitter;
	      data_K[1][i_c][j_c] += (-Kbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * CA_ME2_cf[i_c][k_c] * temp_charge2_emitter;
	      data_K[2][i_c][j_c] += (Kbar_delta[type[i_c][j_c]] - intKbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][k_c] * temp_charge2_emitter;
	    }
	  }
	}
	else {
	  data_K[0][i_c][j_c] += (Kbar[type[i_c][j_c]][no_emitter[i_c][j_c]] + Kbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][j_c];
	  data_K[1][i_c][j_c] += (-Kbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * CA_ME2_cf[i_c][j_c];
	  data_K[2][i_c][j_c] += (Kbar_delta[type[i_c][j_c]] - intKbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][j_c];
	}
      }
      else if (no_spectator[i_c][j_c] < 3){
	if (!switch_off_CS_ii){
	  data_K[0][i_c][j_c] += -iT2_ap[no_emitter[i_c][j_c]] * (Kt[type[i_c][j_c]][no_emitter[i_c][j_c]] + Kt_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][j_c];
	  data_K[1][i_c][j_c] += -iT2_ap[no_emitter[i_c][j_c]] * (-Kt_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * CA_ME2_cf[i_c][j_c];
	  data_K[2][i_c][j_c] += -iT2_ap[no_emitter[i_c][j_c]] * (Kt_delta[type[i_c][j_c]] - intKt_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][j_c];
	}
      }
      else if (no_spectator[i_c][j_c] > 2){
	if (!switch_off_CS_fi){
	  if (collinear_singularity[i_c][j_c] == 1){
	    data_K[0][i_c][j_c] += gamma_i_T2_i[i_c][j_c] * (1. / (1. - psi->z_coll[no_emitter[i_c][j_c]])) * CA_ME2_cf[i_c][j_c];
	    data_K[1][i_c][j_c] += -gamma_i_T2_i[i_c][j_c] * (1. / (1. - psi->z_coll[no_emitter[i_c][j_c]])) * psi->z_coll[no_emitter[i_c][j_c]] * CA_ME2_cf[i_c][j_c];
	    if (switch_off_intXplus){data_K[2][i_c][j_c] += gamma_i_T2_i[i_c][j_c] * CA_ME2_cf[i_c][j_c];}
	    else {data_K[2][i_c][j_c] += gamma_i_T2_i[i_c][j_c] * (1. + log(1. - psi->x_pdf[no_emitter[i_c][j_c]])) * CA_ME2_cf[i_c][j_c];}
	  }
	}
      }
      
      if (no_spectator[i_c][j_c] != 0){
	// P terms
	if ((!switch_off_CS_ii && ((*CA_collinear)[i_c][j_c].no_emitter() < 3 && (*CA_collinear)[i_c][j_c].no_spectator() < 3)) ||
	    (!switch_off_CS_if && ((*CA_collinear)[i_c][j_c].no_emitter() < 3 && (*CA_collinear)[i_c][j_c].no_spectator() > 2))){
	  if (switch_TSV){
	    for (int v_sf = 0; v_sf < value_logscale2_fact_papi.size(); v_sf++){
	      for (int v_xf = 0; v_xf < value_logscale2_fact_papi[v_sf].size(); v_xf++){
		value_data_P[v_sf][v_xf][0][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (P[type[i_c][j_c]][no_emitter[i_c][j_c]] + P_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * value_logscale2_fact_papi[v_sf][v_xf][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
		value_data_P[v_sf][v_xf][1][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (-P_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * value_logscale2_fact_papi[v_sf][v_xf][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
		value_data_P[v_sf][v_xf][2][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (P_delta[type[i_c][j_c]] - intP_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * value_logscale2_fact_papi[v_sf][v_xf][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
	      }
	    }
	  }
	  for (int sd = 0; sd < CA_value_ln_muF_papi.size(); sd++){
	    for (int ss = 0; ss < CA_value_ln_muF_papi[sd].size(); ss++){
	      value_dataP[sd][ss][0][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (P[type[i_c][j_c]][no_emitter[i_c][j_c]] + P_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_value_ln_muF_papi[sd][ss][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
	      value_dataP[sd][ss][1][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (-P_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * CA_value_ln_muF_papi[sd][ss][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
	      value_dataP[sd][ss][2][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (P_delta[type[i_c][j_c]] - intP_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_value_ln_muF_papi[sd][ss][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
	    }
	  }
	}
      }
    }
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_POINT){output_calculate_collinear_QCD_CS();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::calculate_collinear_QCD_CDST(){
  static Logger logger("observable_set::calculate_collinear_QCD_CDST");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int i_p = 0; i_p < pair.size(); i_p++){
    int pair_em = pair[i_p][0];
    int pair_sp = pair[i_p][1];
    // exception: 1 -- 2; however, in this case, for all relevant configurations the involved functions are symmetric!
    sall_ja[pair_em][pair_sp] = 2 * esi->p_parton[0][pair_em] * esi->p_parton[0][pair_sp];
    ln_papi[pair_em][pair_sp] = log(sall_ja[pair_em][pair_sp]);

    if (m2_Q[pair_sp] > 0.){
      // Only happens if no initial-initial dipole is discussed, i.e. pair_em and pair_sp really point at emitter and spectator, respectively.
      sall_ja_x[pair_em][pair_sp] = sall_ja[pair_em][pair_sp] / psi->z_coll[pair_em];
      mu2_Q[pair_em][pair_sp] = m2_Q[pair_sp] / sall_ja[pair_em][pair_sp];
      mu2_Q_x[pair_em][pair_sp] = m2_Q[pair_sp] / sall_ja_x[pair_em][pair_sp];

      // only for massive quarks as spectators
      for (int i_dt = 0; i_dt < 4; i_dt++){
	if      (i_dt == 0 && (CA_dipole_splitting[i_dt][1] == 1 || CA_dipole_splitting[i_dt][2] == 1)){
	  // g -> g (g) splitting
	  Kit[i_dt][pair_em][pair_sp] =
	    - 2 * log(2. - psi->z_coll[pair_em]) / (1. - psi->z_coll[pair_em]) // from second term in (6.58) (-> K^qq_q) [included from (6.60)]
	    + 2 * m2_Q[pair_sp] / (psi->z_coll[pair_em] * sall_ja_x[pair_em][pair_sp]) * log(m2_Q[pair_sp] / ((1. - psi->z_coll[pair_em]) * sall_ja_x[pair_em][pair_sp] + m2_Q[pair_sp])); // from (6.59) (-> K^qg_q) [included from (6.60)]
	  Kit_plus_x[i_dt][pair_em][pair_sp] =
	    + 2 * log(1. - psi->z_coll[pair_em]) / (1. - psi->z_coll[pair_em]) // from first term in (6.58)
	    + (1. - psi->z_coll[pair_em]) / (2 * pow(1. - psi->z_coll[pair_em] + mu2_Q_x[pair_em][pair_sp], 2)) // from first term in (5.58, J_gQ^a) included from (6.58)
	    - 2 / (1. - psi->z_coll[pair_em]) * (1. + log(1. - psi->z_coll[pair_em] + mu2_Q_x[pair_em][pair_sp])) // from second term in (5.58, J_gQ^a) included from (6.58)
	    ;
	  Kit_plus_1[i_dt][pair_em][pair_sp] =
	    + 2 * log(1. - psi->z_coll[pair_em]) / (1. - psi->z_coll[pair_em]) // from first term in (6.58)
	    + (1. - psi->z_coll[pair_em]) / (2 * pow(1. - psi->z_coll[pair_em] + mu2_Q[pair_em][pair_sp], 2)) // from first term in (5.58, J_gQ^a) included from (6.58)
	    - 2 / (1. - psi->z_coll[pair_em]) * (1. + log(1. - psi->z_coll[pair_em] + mu2_Q[pair_em][pair_sp])) // from second term in (5.58, J_gQ^a) included from (6.58)
	    ;
	  if (switch_off_intXplus){intKit_plus[i_dt][pair_em][pair_sp] = 0.;}
	  else {
	    intKit_plus[i_dt][pair_em][pair_sp] =
	      - pow(log(1. - psi->x_pdf[pair_em]), 2) // from first term in (6.58)
	      + .5 * (- mu2_Q[pair_em][pair_sp] / (1. - psi->x_pdf[pair_em] + mu2_Q[pair_em][pair_sp]) + mu2_Q[pair_em][pair_sp] / (1. + mu2_Q[pair_em][pair_sp]) - log((1. - psi->x_pdf[pair_em] + mu2_Q[pair_em][pair_sp]) / (1. + mu2_Q[pair_em][pair_sp]))) // from first term in (5.58) included from (6.58)
	      + 2 * (gsl_sf_dilog(-1. / mu2_Q[pair_em][pair_sp]) - gsl_sf_dilog(-(1. - psi->x_pdf[pair_em]) / mu2_Q[pair_em][pair_sp]) + log(1. - psi->x_pdf[pair_em]) * (1. + log(mu2_Q[pair_em][pair_sp]))) // from second term in (5.58) included from (6.58)
	      ;
	  }

	  // terms containing x-dependent pre-factor of (2/(1-psi->z_coll[pair_em]))_+
	  Kit_plus_outside_x[i_dt][pair_em][pair_sp] =
	    + log(((2. - psi->z_coll[pair_em]) * sall_ja_x[pair_em][pair_sp]) / ((2. - psi->z_coll[pair_em]) * sall_ja_x[pair_em][pair_sp] + m2_Q[pair_sp])) // from fourth term from (6.58)
	    + log(2. + mu2_Q_x[pair_em][pair_sp] - psi->z_coll[pair_em]) // from third term in (5.58) included from (6.58)
	    ;
	  Kit_plus_outside_1[i_dt][pair_em][pair_sp] =
	    + log(sall_ja[pair_em][pair_sp] / (sall_ja[pair_em][pair_sp] + m2_Q[pair_sp])) // from fourth term from (6.58)
	    + log(1. + mu2_Q[pair_em][pair_sp]) // from third term in (5.58) included from (6.58)
	    ;
	  Kit_delta[i_dt][pair_em][pair_sp] =
	    - CS_QCD_gamma_q / C_F // from fifth term from (6.58)
	    + mu2_Q[pair_em][pair_sp] * log(m2_Q[pair_sp] / (sall_ja[pair_em][pair_sp] + m2_Q[pair_sp])) // from sixth term from (6.58)
	    + .5 * m2_Q[pair_sp] / (sall_ja[pair_em][pair_sp] + m2_Q[pair_sp])// from seventh term from (6.58)
	    ;
	}
	else if (i_dt == 1 && (CA_dipole_splitting[i_dt][1] == 1 || CA_dipole_splitting[i_dt][2] == 1)){
	  // q -> q (g) splitting
	  Kit[i_dt][pair_em][pair_sp] = -2 * log(2. - psi->z_coll[pair_em]) / (1. - psi->z_coll[pair_em]);
	  Kit_plus_x[i_dt][pair_em][pair_sp] = 0.
	    + 2 * log(1. - psi->z_coll[pair_em]) / (1. - psi->z_coll[pair_em]) // from first term in (6.58)
	    + (1. - psi->z_coll[pair_em]) / (2 * pow(1. - psi->z_coll[pair_em] + mu2_Q_x[pair_em][pair_sp], 2)) // from first term in (5.58, J_gQ^a) included from (6.58)
	    - 2 / (1. - psi->z_coll[pair_em]) * (1. + log(1. - psi->z_coll[pair_em] + mu2_Q_x[pair_em][pair_sp])) // from second term in (5.58, J_gQ^a) included from (6.58)
	    ;

	  if (switch_off_intXplus){intKit_plus[i_dt][pair_em][pair_sp] = 0.;}
	  else {
	    Kit_plus_1[i_dt][pair_em][pair_sp] = 0.
	      + 2 * log(1. - psi->z_coll[pair_em]) / (1. - psi->z_coll[pair_em]) // from first term in (6.58)
	      + (1. - psi->z_coll[pair_em]) / (2 * pow(1. - psi->z_coll[pair_em] + mu2_Q[pair_em][pair_sp], 2)) // from first term in (5.58, J_gQ^a) included from (6.58)
	      - 2 / (1. - psi->z_coll[pair_em]) * (1. + log(1. - psi->z_coll[pair_em] + mu2_Q[pair_em][pair_sp])) // from second term in (5.58, J_gQ^a) included from (6.58)
	      ;
	  }
	  
	  intKit_plus[i_dt][pair_em][pair_sp] = 0.
	    - pow(log(1. - psi->x_pdf[pair_em]), 2) // from first term in (6.58)
	    + .5 * (- mu2_Q[pair_em][pair_sp] / (1. - psi->x_pdf[pair_em] + mu2_Q[pair_em][pair_sp]) + mu2_Q[pair_em][pair_sp] / (1. + mu2_Q[pair_em][pair_sp]) - log((1. - psi->x_pdf[pair_em] + mu2_Q[pair_em][pair_sp]) / (1. + mu2_Q[pair_em][pair_sp]))) // from first term in (5.58) included from (6.58)
	    + 2 * (gsl_sf_dilog(-1. / mu2_Q[pair_em][pair_sp]) - gsl_sf_dilog(-(1. - psi->x_pdf[pair_em]) / mu2_Q[pair_em][pair_sp]) + log(1. - psi->x_pdf[pair_em]) * (1. + log(mu2_Q[pair_em][pair_sp]))); // from second term in (5.58) included from (6.58)

	  // terms containing x-dependent pre-factor of (2/(1-psi->z_coll[pair_em]))_+
	  Kit_plus_outside_x[i_dt][pair_em][pair_sp] =
	    + log(((2. - psi->z_coll[pair_em]) * sall_ja_x[pair_em][pair_sp]) / ((2. - psi->z_coll[pair_em]) * sall_ja_x[pair_em][pair_sp] + m2_Q[pair_sp])) // from fourth term from (6.58)
	    + log(2. + mu2_Q_x[pair_em][pair_sp] - psi->z_coll[pair_em]) // from third term in (5.58) included from (6.58)
	    ;
	  Kit_plus_outside_1[i_dt][pair_em][pair_sp] =
	    + log(sall_ja[pair_em][pair_sp] / (sall_ja[pair_em][pair_sp] + m2_Q[pair_sp])) // from fourth term from (6.58)
	    + log(1. + mu2_Q[pair_em][pair_sp]) // from third term in (5.58) included from (6.58)
	    ;
	  Kit_delta[i_dt][pair_em][pair_sp] =
	    - CS_QCD_gamma_q / C_F // from fifth term from (6.58)
	    + mu2_Q[pair_em][pair_sp] * log(m2_Q[pair_sp] / (sall_ja[pair_em][pair_sp] + m2_Q[pair_sp])) // from sixth term from (6.58)
	    + .5 * m2_Q[pair_sp] / (sall_ja[pair_em][pair_sp] + m2_Q[pair_sp]) // from seventh term from (6.58)
	    ;
	}
	else if (i_dt == 2 && (CA_dipole_splitting[i_dt][1] == 1 || CA_dipole_splitting[i_dt][2] == 1)){
	  // q -> g (q) splitting
	  Kit[i_dt][pair_em][pair_sp] =
	    2 * C_F / C_A * m2_Q[pair_sp] / (psi->z_coll[pair_em] * sall_ja_x[pair_em][pair_sp]) * log(m2_Q[pair_sp] / ((1. - psi->z_coll[pair_em]) * sall_ja_x[pair_em][pair_sp] + m2_Q[pair_sp])); // from (6.59)
	}
	else if (i_dt == 3 && (CA_dipole_splitting[i_dt][1] == 1 || CA_dipole_splitting[i_dt][2] == 1)){
	  // g -> q (g) splitting
	  //	  Kit[i_dt][pair_em][pair_sp] = 0.;
	}
      }
    }

    if (switch_TSV){
      for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
	for (int v_xf = 0; v_xf < n_scale_dyn_fact[v_sf]; v_xf++){
	  value_logscale2_fact_papi[v_sf][v_xf][pair_em][pair_sp] = value_central_logscale2_fact[v_sf] + value_relative_logscale2_fact[v_sf][v_xf] - ln_papi[pair_em][pair_sp];
	}
      }
    }

    for (int sd = 0; sd < CA_value_ln_muF_papi.size(); sd++){
      for (int ss = 0; ss < CA_value_ln_muF_papi[sd].size(); ss++){
	CA_value_ln_muF_papi[sd][ss][pair_em][pair_sp] = CA_value_log_mu2_fact[sd][ss] - ln_papi[pair_em][pair_sp];
      }
    }
  }

  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      // K terms
      data_K[0][i_c][j_c] = 0.;
      data_K[1][i_c][j_c] = 0.;
      data_K[2][i_c][j_c] = 0.;
      if (no_spectator[i_c][j_c] == 0){
	if (switch_off_CS_ii || switch_off_CS_if){
	  double temp_charge2_emitter = (-iT2_ap[(*CA_collinear)[i_c][j_c].no_emitter()]);
	  for (int k_c = 1; k_c < (*CA_collinear)[i_c].size(); k_c++){
	    if ((!switch_off_CS_ii && ((*CA_collinear)[i_c][k_c].no_emitter() < 3 && (*CA_collinear)[i_c][k_c].no_spectator() < 3)) ||
		(!switch_off_CS_if && ((*CA_collinear)[i_c][k_c].no_emitter() < 3 && (*CA_collinear)[i_c][k_c].no_spectator() > 2))){
	      data_K[0][i_c][k_c] += (Kbar[type[i_c][j_c]][no_emitter[i_c][j_c]] + Kbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][k_c] * temp_charge2_emitter;
	      data_K[1][i_c][k_c] += (-Kbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * CA_ME2_cf[i_c][k_c] * temp_charge2_emitter;
	      data_K[2][i_c][k_c] += (Kbar_delta[type[i_c][j_c]] - intKbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][k_c] * temp_charge2_emitter;
	    }
	  }
	}
	else {
	  data_K[0][i_c][j_c] += (Kbar[type[i_c][j_c]][no_emitter[i_c][j_c]] + Kbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][j_c];
	  data_K[1][i_c][j_c] += (-Kbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * CA_ME2_cf[i_c][j_c];
	  data_K[2][i_c][j_c] += (Kbar_delta[type[i_c][j_c]] - intKbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][j_c];
	}
      }
      else if (no_spectator[i_c][j_c] < 3){
	if (!switch_off_CS_ii){
	  data_K[0][i_c][j_c] += -iT2_ap[no_emitter[i_c][j_c]] * (Kt[type[i_c][j_c]][no_emitter[i_c][j_c]] + Kt_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][j_c];// reg
	  data_K[1][i_c][j_c] += -iT2_ap[no_emitter[i_c][j_c]] * (-Kt_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * CA_ME2_cf[i_c][j_c];// plus
	  data_K[2][i_c][j_c] += -iT2_ap[no_emitter[i_c][j_c]] * (Kt_delta[type[i_c][j_c]] - intKt_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_ME2_cf[i_c][j_c];// delta
	}
      }
      else if (no_spectator[i_c][j_c] > 2){
	if (m2_Q[no_spectator[i_c][j_c]] == 0.){
	  if (!switch_off_CS_fi){
	    if (collinear_singularity[i_c][j_c] == 1){
	      data_K[0][i_c][j_c] += gamma_i_T2_i[i_c][j_c] * (1. / (1. - psi->z_coll[no_emitter[i_c][j_c]])) * CA_ME2_cf[i_c][j_c];
	      data_K[1][i_c][j_c] += -gamma_i_T2_i[i_c][j_c] * (1. / (1. - psi->z_coll[no_emitter[i_c][j_c]])) * psi->z_coll[no_emitter[i_c][j_c]] * CA_ME2_cf[i_c][j_c];
	      if (switch_off_intXplus){data_K[2][i_c][j_c] = gamma_i_T2_i[i_c][j_c] * CA_ME2_cf[i_c][j_c];}
	      else {data_K[2][i_c][j_c] += gamma_i_T2_i[i_c][j_c] * (1. + log(1. - psi->x_pdf[no_emitter[i_c][j_c]])) * CA_ME2_cf[i_c][j_c];}
	    }
	  }
	}
	else {
	  if (!switch_off_CS_fi){
	    // -> Kit
	    data_K[0][i_c][j_c] += -(Kit[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]
				    + Kit_plus_x[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]
				    + 2. / (1. - psi->z_coll[no_emitter[i_c][j_c]]) * Kit_plus_outside_x[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]
				    ) * CA_ME2_cf[i_c][j_c]; // reg
	    data_K[1][i_c][j_c] +=  -(
				     - Kit_plus_1[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]
				     - 2. / (1. - psi->z_coll[no_emitter[i_c][j_c]]) * Kit_plus_outside_1[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]
				     ) * psi->z_coll[no_emitter[i_c][j_c]] * CA_ME2_cf[i_c][j_c]; // plus
	    if (switch_off_intXplus){
	      data_K[2][i_c][j_c] += -(Kit_delta[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]) * CA_ME2_cf[i_c][j_c]; // delta
	    }
	    else {
	      data_K[2][i_c][j_c] += -(Kit_delta[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]
				      - intKit_plus[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]
				      - 2 * log(1. - psi->x_pdf[no_emitter[i_c][j_c]]) * Kit_plus_outside_1[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]
				      ) * CA_ME2_cf[i_c][j_c]; // delta
	    }
	  }
	  
	  if (!switch_off_CS_if){
	    // remainder from initial-final dipoles (only contributions from massive spectators)
	    // P -> P_reg (to be independent of convention; identical in the default convention)
	    data_K[0][i_c][j_c] += -iT2_ap[no_emitter[i_c][j_c]] * P_reg[type[i_c][j_c]][no_emitter[i_c][j_c]] * log(((1. - psi->z_coll[no_emitter[i_c][j_c]]) * sall_ja_x[no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]) / ((1. - psi->z_coll[no_emitter[i_c][j_c]]) * sall_ja_x[no_emitter[i_c][j_c]][no_spectator[i_c][j_c]] + m2_Q[no_spectator[i_c][j_c]])) * CA_ME2_cf[i_c][j_c]; // from (6.55)
	    // no explizit plus term in (6.55)
	    if (collinear_singularity[i_c][j_c] == 1){
	      // contributes only to irregular splittings
	      data_K[2][i_c][j_c] += -gamma_a_T2_ap[no_emitter[i_c][j_c]] * (log((sall_ja[no_emitter[i_c][j_c]][no_spectator[i_c][j_c]] - 2 * m_Q[no_spectator[i_c][j_c]] * sqrt(sall_ja[no_emitter[i_c][j_c]][no_spectator[i_c][j_c]] + m2_Q[no_spectator[i_c][j_c]]) + 2 * m2_Q[no_spectator[i_c][j_c]]) / sall_ja[no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]) + 2 * m_Q[no_spectator[i_c][j_c]] / (sqrt(sall_ja[no_emitter[i_c][j_c]][no_spectator[i_c][j_c]] + m2_Q[no_spectator[i_c][j_c]]) + m_Q[no_spectator[i_c][j_c]])) * CA_ME2_cf[i_c][j_c];  // from (6.55)
	      //	    data_K[2][i_c][i_ca] += -gamma_a_T2_ap[i_em] * (log((sall_ja[i_em][i_cs] - 2 * m_j * sqrt(sall_ja[i_em][i_cs] + m2_j) + 2 * m2_j) / sall_ja[i_em][i_cs]) + 2 * m_j / (sqrt(sall_ja[i_em][i_cs] + m2_j) + m_j)) * CA_ME2cc[i_c][i_ca];  // from (6.55)
	    }
	  }
	}
      }
      if (no_spectator[i_c][j_c] != 0){
	// P terms
	if ((!switch_off_CS_ii && ((*CA_collinear)[i_c][j_c].no_emitter() < 3 && (*CA_collinear)[i_c][j_c].no_spectator() < 3)) ||
	    (!switch_off_CS_if && ((*CA_collinear)[i_c][j_c].no_emitter() < 3 && (*CA_collinear)[i_c][j_c].no_spectator() > 2))){
	  if (switch_TSV){
	    for (int v_sf = 0; v_sf < value_logscale2_fact_papi.size(); v_sf++){
	      for (int v_xf = 0; v_xf < value_logscale2_fact_papi[v_sf].size(); v_xf++){
		value_data_P[v_sf][v_xf][0][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (P[type[i_c][j_c]][no_emitter[i_c][j_c]] + P_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * value_logscale2_fact_papi[v_sf][v_xf][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
		value_data_P[v_sf][v_xf][1][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (-P_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * value_logscale2_fact_papi[v_sf][v_xf][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
		value_data_P[v_sf][v_xf][2][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (P_delta[type[i_c][j_c]] - intP_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * value_logscale2_fact_papi[v_sf][v_xf][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
	      }
	    }
	  }
	  for (int sd = 0; sd < CA_value_ln_muF_papi.size(); sd++){
	    for (int ss = 0; ss < CA_value_ln_muF_papi[sd].size(); ss++){
	      value_dataP[sd][ss][0][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (P[type[i_c][j_c]][no_emitter[i_c][j_c]] + P_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_value_ln_muF_papi[sd][ss][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
	      value_dataP[sd][ss][1][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (-P_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * psi->z_coll[no_emitter[i_c][j_c]] * CA_value_ln_muF_papi[sd][ss][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
	      value_dataP[sd][ss][2][i_c][j_c] = iT2_ap[no_emitter[i_c][j_c]] * (P_delta[type[i_c][j_c]] - intP_plus[type[i_c][j_c]][no_emitter[i_c][j_c]]) * CA_value_ln_muF_papi[sd][ss][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] * CA_ME2_cf[i_c][j_c];
	    }
	  }
	}
      }
    }
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_POINT){output_calculate_collinear_QCD_CDST();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

