#include "header.hpp"

string observable_set::output_collinear(){
  static Logger logger("observable_set::output_collinear");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream temp;
  temp << "(output_collinear)" << endline;
  temp << endline;
  temp <<  "Overview of contributing collinear dipoles" << endline;
  temp << "===========================================" << endline;
  temp << endline;
  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      if (j_c == 0){
	if      ((*CA_collinear)[i_c][j_c].type_correction() == 1){temp << "QCD ";}
	else if ((*CA_collinear)[i_c][j_c].type_correction() == 2){temp << "QEW ";}
	temp << "collinear dipole " << i_c << ", " << j_c << ":   " << setw(15) << left << (*CA_collinear)[i_c][j_c].name() << ":   ";
	temp << "type_parton = ";
	for (int i_p = 1; i_p < (*CA_collinear)[i_c][j_c].type_parton().size(); i_p++){temp << (*CA_collinear)[i_c][j_c].type_parton()[i_p] << "   ";}
	temp << "no_process = " << (*CA_collinear)[i_c][j_c].no_prc() << "   ";
	temp << "no_pdf = " << (*CA_collinear)[i_c][j_c].no_pdf << "   ";
	temp << endline;
	for (int i_x = 0; i_x < (*CA_collinear)[i_c][j_c].all_name().size(); i_x++){
	  temp << setw(48) << "";
	  temp << "pdf contributions: " << setw(15) << left << (*CA_collinear)[i_c][j_c].all_name()[i_x] << ":   ";
	  for (int i_yxy = 0; i_yxy < 3; i_yxy++){temp << setw(2) << right << (*CA_collinear)[i_c][j_c].all_pdf()[i_x][i_yxy] << "  ";}
	  temp << endline;
	}
	temp << setw(48) << "";
	temp << "type = " << (*CA_collinear)[i_c][j_c].type() << "   ";
	temp << "in_collinear = ";
	for (int i_em = 0; i_em < 3; i_em++){temp << (*CA_collinear)[i_c][j_c].in_collinear()[i_em] << "   ";}
	temp << "no_emitter = " << (*CA_collinear)[i_c][j_c].no_emitter() << "   ";
	//	temp << "massive = " << (*CA_collinear)[i_c][j_c].massive() << "   ";
	temp << endline;
	temp << endline;
      }
      else {
	if ((*CA_collinear)[i_c][j_c].type_correction() == 1){
	  if ((*CA_collinear)[i_c][j_c].charge_factor() != (*CA_collinear)[i_c][0].charge_factor()){temp << "WARNING: (*CA_collinear)[" << i_c << "][" << j_c << "].charge_factor() = " << (*CA_collinear)[i_c][j_c].charge_factor() << " != " << (*CA_collinear)[i_c][0].charge_factor() << " = (*CA_collinear)[" << i_c << "][0].charge_factor()" << endline;}
	  if ((*CA_collinear)[i_c][j_c].charge_factor_fi() != (*CA_collinear)[i_c][0].charge_factor_fi()){temp << "WARNING: (*CA_collinear)[" << i_c << "][" << j_c << "].charge_factor_fi() = " << (*CA_collinear)[i_c][j_c].charge_factor_fi() << " != " << (*CA_collinear)[i_c][0].charge_factor_fi() << " = (*CA_collinear)[" << i_c << "][0].charge_factor_fi()" << endline;}
	}
	if ((*CA_collinear)[i_c][j_c].type() != (*CA_collinear)[i_c][0].type()){temp << "WARNING: (*CA_collinear)[" << i_c << "][" << j_c << "].type() = " << (*CA_collinear)[i_c][j_c].type() << " != " << (*CA_collinear)[i_c][0].type() << " = (*CA_collinear)[" << i_c << "][0].type()" << endline;}
	if ((*CA_collinear)[i_c][j_c].in_collinear() != (*CA_collinear)[i_c][0].in_collinear()){
	  for (int i_em = 0; i_em < 3; i_em++){
	    temp << "WARNING: (*CA_collinear)[" << i_c << "][" << j_c << "].in_collinear()[" << i_em << "] = " << (*CA_collinear)[i_c][j_c].in_collinear()[i_em] << " != " << (*CA_collinear)[i_c][0].in_collinear()[i_em] << " = (*CA_collinear)[" << i_c << "][0].in_collinear()[" << i_em << "]" << endline;
	  }
	}
	// 	if ((*CA_collinear)[i_c][j_c].massive() != (*CA_collinear)[i_c][0].massive()){temp << "WARNING: (*CA_collinear)[" << i_c << "][" << j_c << "].massive() = " << (*CA_collinear)[i_c][j_c].massive() << " != " << (*CA_collinear)[i_c][0].massive() << " = (*CA_collinear)[" << i_c << "][0].massive()" << endline;}
      }
      temp << setw(29) << "" << setw(15) << left << (*CA_collinear)[i_c][j_c].name() << ":   ";
      //      temp << "no_emitter = " << (*CA_collinear)[i_c][j_c].no_emitter() << "   ";
      temp << "no_spectator = " << (*CA_collinear)[i_c][j_c].no_spectator() << "   ";
      //      temp << "pair = ";
      //      for (int i_p = 0; i_p < 2; i_p++){temp << (*CA_collinear)[i_c][j_c].pair()[i_p] << "   ";}
      temp << "massive = " << (*CA_collinear)[i_c][j_c].massive() << "   ";
      temp << "charge_factor = " << setw(11) << setprecision(8) << (*CA_collinear)[i_c][j_c].charge_factor() << "   ";
      if (CA_Q2f.size() > 0){
	temp << "charge_factor_fi / Qf2 = " << setw(11) << setprecision(8) << (*CA_collinear)[i_c][j_c].charge_factor_fi() / CA_Q2f[i_c][0][0] << "   ";
      }
      temp << endline;
    }
    for (int i_s = 0; i_s < 128; i_s++){temp << "-";} temp << endline;
  }

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return temp.str();
}


string observable_set::output_collinear_pdf(){
  static Logger logger("observable_set::output_collinear_pdf");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream temp;
  temp << "(output_collinear_pdf)" << endline;
  temp << endline;
  temp <<  "Original pdf contributions" << endline;
  temp << "===========================" << endline;
  temp << endline;
  for (int i1 = 0; i1 < csi->combination_pdf.size(); i1++){
    temp << " csi->combination_pdf[" << setw(2) << i1 << "] = ";
    for (int i = 0; i < 3; i++){temp << setw(4) << csi->combination_pdf[i1][i] << "   ";}
    temp << endline;
  }
  temp << endline;
  temp << "Collinear dipole pdf contributions" << endline;
  temp << "==================================" << endline;
  temp << endline;

  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
      for (int i_x = 0; i_x < CA_combination_pdf[i_c][i_i].size(); i_x++){
	if (i_x == 0){temp << setw(15) << left << (*CA_collinear)[i_c][0].all_name()[i_i] << ":   ";}
	else {temp << setw(19) << "";}
	temp << right;
	temp << "CA_Q2f[" << setw(2) << i_c << "][" << setw(2) << i_i << "][" << setw(2) << i_x << "] = " << setw(10) << setprecision(8) << CA_Q2f[i_c][i_i][i_x] << "     ";
	temp << "CA_combination_pdf[" << setw(2) << i_c << "][" << setw(2) << i_i << "][" << setw(2) << i_x << "] = ";
	for (int i_y = 0; i_y < CA_combination_pdf[i_c][i_i][i_x].size(); i_y++){temp << setw(2) << right << CA_combination_pdf[i_c][i_i][i_x][i_y] << "  ";}
	temp << endline;
      }
      if (i_i < CA_combination_pdf[i_c].size() - 1 && CA_combination_pdf[i_c][i_i].size() > 1){temp << endline;}
    }
    for (int i_s = 0; i_s < 128; i_s++){temp << "-";} temp << endline;
  }

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return temp.str();
}


string observable_set::output_collinear_splitting(){
  static Logger logger("observable_set::output_collinear_splitting");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream temp;
  temp << "(output_collinear_splitting)" << endline;
  temp << endline;
  temp << "CA_dipole_splitting:" << endline;
  for (int i_em = 0; i_em < 3; i_em++){
    temp << "i_em = " << i_em << ":   ";
    for (int i_dt = 0; i_dt < 4; i_dt++){temp << CA_dipole_splitting[i_dt][i_em] << "   ";}
    temp << endline;
  }

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return temp.str();
}


string observable_set::output_collinear_pa_name(int temp_type_correction, vector<string> & pa_name){
  static Logger logger("observable_set::output_collinear_pa_name");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream temp;
  temp << "(output_collinear_pa_name)" << endline;
  temp << endline;
  stringstream temp_tp;
  stringstream temp_name;
  for (int i_p = 1; i_p < csi->type_parton[0].size(); i_p++){
    temp_tp << setw(3) << csi->type_parton[0][i_p] << " ";
    temp_name << setw(3) << pa_name[i_p] << " ";
  }
  temp << "Collinear ";
  if      (temp_type_correction == 1){temp << "QCD ";}
  else if (temp_type_correction == 2){temp << "QEW ";}
  temp << " emission:" << endline;
  temp << "csi->type_parton[0] = " << temp_tp.str() << endline;
  temp << "pa_name             = " << temp_name.str() << endline;

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return temp.str();
}


string observable_set::output_testpoint_CA(){
  Logger logger("observable_set::output_testpoint_CA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if ((*CA_collinear).size() == 0){return "";}

  stringstream out_comparison;
  logger << LOG_DEBUG << "(*CA_collinear).size() = " << (*CA_collinear).size() << endline_flush;

  stringstream sstempmode;
  if (switch_KP == 0){sstempmode << "KP terms";}
  else if (switch_KP == 1){sstempmode << "P terms";}
  else if (switch_KP == 2){sstempmode << "K terms";}

  /*
  out_comparison << "Colour-correlated matrix elements evaluated at alpha_S(µR = " << setprecision(15) << scale_ren << ") = " << setprecision(15) << LHAPDF::alphasPDF(scale_ren) << "" << endline << endline;
  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      out_comparison << "Collinear " << i_c <<  ", " << j_c << ":   ";
      out_comparison << left << setw(26) << (*CA_collinear)[i_c][j_c].name() << ": " << "ME2_cf[" << i_c << "][" << j_c << "] = " << setw(23) << setprecision(15) << CA_ME2_cf[i_c][j_c] << "   charge_factor = " << setw(15) << setprecision(8) << (*CA_collinear)[i_c][j_c].charge_factor() << endline;
    }
    out_comparison << endline;
  }
  out_comparison << endline;
  */
  if (switch_TSV){
    out_comparison << "Colour-correlated matrix elements including correct (relative) factors of powers of alpha_S(µR)" << endline << endline;
    double rel_born_exponent = 1.;
    if (csi->type_correction == "QCD"){rel_born_exponent = 1. - 1. / double(csi->contribution_order_alpha_s);}
    else if (csi->type_correction == "QEW"){rel_born_exponent = 1.;}

    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      int v_sr = dynamic_scale_ren_TSV[i_s];
      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	int v_xr = no_value_ren_TSV[i_s][i_r];
	if (switch_output_testpoint_reference_only && (i_s != no_reference_TSV || i_r != no_scale_ren_reference_TSV)){continue;}
	stringstream sstemp;
	sstemp << "µR = " << setw(23) << setprecision(15) << value_scale_ren[0][v_sr][v_xr] << "   " << "alpha_S(µR) = " << setw(23) << setprecision(15) << LHAPDF::alphasPDF(*(pointer_scale_ren)[0][i_s][i_r]) ;
	out_comparison << "Scaleset " << i_s << " (µR " << i_r << "):   " << sstemp.str() << endline;
	out_comparison << endline;
	for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
	  for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
	    stringstream sstemp;
	    sstemp << "Collinear " << i_c <<  ", " << j_c << ":   ";
	    sstemp << left << setw(26) << (*CA_collinear)[i_c][j_c].name() << ": " << "ME2_cf[" << i_c << "][" << j_c << "] = ";
	    sstemp << setw(23) << setprecision(15) << CA_ME2_cf[i_c][j_c] * pow(*(pointer_relative_factor_alpha_S)[0][i_s][i_r], rel_born_exponent) << "   charge_factor = " << setw(15) << setprecision(8) << (*CA_collinear)[i_c][j_c].charge_factor();
	    out_comparison << sstemp.str() << endline;
	    //if (*(pointer_relative_factor_alpha_S)[0][i_s][i_r] != 1.){out_comparison << "pow(" << *(pointer_relative_factor_alpha_S)[0][i_s][i_r] << ", " << rel_born_exponent << ") = " << pow(*(pointer_relative_factor_alpha_S)[0][i_s][i_r], rel_born_exponent) << endline;}
	  }
	  out_comparison << endline;
	}
      }
    }
    out_comparison << endline;

    out_comparison << sstempmode.str() << " evaluated at alpha_S(µR = " << setprecision(15) << scale_ren << ")" << endline << endline;
    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      int v_sf = dynamic_scale_fact_TSV[i_s];
      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	int v_xf = no_value_fact_TSV[i_s][i_f];
	if (switch_output_testpoint_reference_only && (i_s != no_reference_TSV || i_f != no_scale_fact_reference_TSV)){continue;}
	stringstream sstemp;
	sstemp << "µF = " << left << setw(15) << setprecision(8) << value_scale_fact[0][v_sf][v_xf] << "   ";
	out_comparison << "Scaleset " << i_s << " (µF " << i_f << "):   " << sstemp.str() << endline;
	out_comparison << endline;
	for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
	  bool flag_first = true;
	  for (int i_x = 0; i_x < 3; i_x++){
	    if (value_ME2_KP[v_sf][v_xf][i_x][i_c] != 0.){
	      stringstream sstemp;
	      if      (i_x == 0){sstemp << left << setw(28) << "regular, regular []_+     : ";}
	      else if (i_x == 1){sstemp << left << setw(28) << "endpoint []_+             : ";}
	      else if (i_x == 2){sstemp << left << setw(28) << "endpoint, integrated []_+ : ";}
	      sstemp << setw(23) << setprecision(15) << value_ME2term_fact[i_c][i_x][v_sf][v_xf];
	      if (flag_first){out_comparison << "Collinear " << i_c <<  ":      " << left << setw(26) << (*CA_collinear)[i_c][0].name() << ": " << sstemp.str() << endline; flag_first = false;}
	      else {out_comparison << setw(46) << "" << sstemp.str() << endline;}
	    }
	  }
	  out_comparison << endline;
	}
      }
    }
    out_comparison << endline;

    out_comparison << sstempmode.str() << " including correct (relative) factors of powers of alpha_S(µR)" << endline << endline;
    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  if (switch_output_testpoint_reference_only && (i_s != no_reference_TSV || i_r != no_scale_ren_reference_TSV || i_f != no_scale_fact_reference_TSV)){continue;}
	  int v_sr = dynamic_scale_ren_TSV[i_s];
	  int v_sf = dynamic_scale_fact_TSV[i_s];
	  int v_xr = no_value_ren_TSV[i_s][i_r];
	  int v_xf = no_value_fact_TSV[i_s][i_f];
	  stringstream sstemp;
	  sstemp << "µR = " << left << setw(15) << setprecision(8) << value_scale_ren[0][v_sr][v_xr] << "   ";
	  sstemp << "µF = " << left << setw(15) << setprecision(8) << value_scale_fact[0][v_sf][v_xf] << "   ";
	  sstemp << "alpha_S(µR) = " << setw(23) << setprecision(15) << LHAPDF::alphasPDF(*(pointer_scale_ren)[0][i_s][i_r]);
	  out_comparison << "Scaleset " << i_s << " (µR " << i_r << ", µF " << i_f << ") :   " << sstemp.str() << endline;
	  out_comparison << endline;
	  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
	    bool flag_first = true;
	    for (int i_x = 0; i_x < 3; i_x++){
	      if (value_ME2_KP[v_sf][v_xf][i_x][i_c] != 0.){
		stringstream sstemp;
		if      (i_x == 0){sstemp << left << setw(28) << "regular, regular []_+     : ";}
		else if (i_x == 1){sstemp << left << setw(28) << "endpoint []_+             : ";}
		else if (i_x == 2){sstemp << left << setw(28) << "endpoint, integrated []_+ : ";}
		sstemp << setw(23) << setprecision(15) << value_ME2term_fact[i_c][i_x][v_sf][v_xf] * value_relative_factor_alpha_S[0][v_sr][v_xr];
		logger << LOG_DEBUG << sstemp.str() << endline_flush;
		if (flag_first){out_comparison << "Collinear " << i_c << ":      " << left << setw(26) << (*CA_collinear)[i_c][0].name() << ": " << sstemp.str() << endline; flag_first = false;}
		else {out_comparison << setw(46) << "" << sstemp.str() << endline;}
	      }
	    }
	    out_comparison << endline;
	  }
	}
      }
    }
    out_comparison << endline;

    // Sherpa comparison output switched off in general:
    //    output_testpoint_CA_Sherpa_output(out_comparison);

    //  static int x_q = 0;
    logger << LOG_DEBUG << " including PDF factors at µR and µF, alpha_S(µR)" << endline_flush;
    out_comparison << sstempmode.str() << " including PDF factors at µR and µF, alpha_S(µR)" << endline << endline;
    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  if (switch_output_testpoint_reference_only && (i_s != no_reference_TSV || i_r != no_scale_ren_reference_TSV || i_f != no_scale_fact_reference_TSV)){continue;}
	  int v_sr = dynamic_scale_ren_TSV[i_s];
	  int v_sf = dynamic_scale_fact_TSV[i_s];
	  int v_xr = no_value_ren_TSV[i_s][i_r];
	  int v_xf = no_value_fact_TSV[i_s][i_f];
	  stringstream sstemp;
	  sstemp << "µR = " << left << setw(23) << setprecision(15) << value_scale_ren[0][v_sr][v_xr] << "   ";
          sstemp << "µF = " << left << setw(23) << setprecision(15) << value_scale_fact[0][v_sf][v_xf] << "   ";
	  sstemp << "alpha_S(µR) = " << setw(23) << setprecision(15) << LHAPDF::alphasPDF(*(pointer_scale_ren)[0][i_s][i_r]);
	  out_comparison << "Scaleset " << i_s << " (µR " << i_r << ", µF " << i_f << "):   " << sstemp.str() << endline;
	  out_comparison << endline;
	  vector<double> temp_c(n_pc, 0.);
	  for (int i_c = 0; i_c < n_pc; i_c++){
	    out_comparison << "Collinear " << i_c << ":      " << left << setw(26) << (*CA_collinear)[i_c][0].name() << endline;
	    out_comparison << endline;
	    size_t x_l = (*CA_collinear)[i_c][0].no_pdf;
	    
	    for (int i_z = 0; i_z < n_pz; i_z++){
	      if (!(*CA_collinear)[i_c][0].in_collinear()[i_z]){continue;}
	      logger << LOG_DEBUG << "list_combination_pdf[" << x_l << "].size() = " << list_combination_pdf[x_l].size() << endline_flush;
	      for (int i_i = 0; i_i < list_combination_pdf[x_l].size(); i_i++){
		logger << LOG_DEBUG << "list_combination_pdf[" << x_l << "][" << i_i << "].size() = " << list_combination_pdf[x_l][i_i].size() << endline_flush;
		for (int i_x = 0; i_x < list_combination_pdf[x_l][i_i].size(); i_x++){
		  stringstream tempdirection;
		  int x_h = 0;
		  if (list_combination_pdf[x_l][i_i][i_x][0] == 1){x_h = 1; tempdirection << "(+)";}
		  else if (list_combination_pdf[x_l][i_i][i_x][0] == -1){x_h = 2; tempdirection << "(-)";}
		  stringstream temppdf;
		  temppdf << "pdf(" << left << setw(2) << csi->name_particle[list_combination_pdf[x_l][i_i][i_x][1]] << ", x1";
		  if (i_z == 1){temppdf << "/z1";}
		  else {temppdf << "   ";}
		  temppdf << ") x ";
		  temppdf << "pdf(" << left << setw(2) << csi->name_particle[list_combination_pdf[x_l][i_i][i_x][2]] << ", x2";
		  if (i_z == 2){temppdf << "/z2";}
		  else {temppdf << "   ";}
		  temppdf << ")";
		  temppdf << " x chargefactor";													       
		  out_comparison << tempdirection.str() << right << setw(48) << temppdf.str();
		  logger << LOG_DEBUG << "HERE list_combination_pdf[" << x_l << "][" << i_i << "].size() = " << list_combination_pdf[x_l][i_i].size() << endline_flush;
		  logger << LOG_DEBUG << "i_c = " << i_c << "   CA_Q2f.size() = " << CA_Q2f.size() << endline_flush;
		  logger << LOG_DEBUG << "i_c = " << i_c << "   i_x = " << i_x << "   CA_Q2f[" << i_c << "].size() = " << CA_Q2f[i_c].size() << endline_flush;
		  logger << LOG_DEBUG << "x_l = " << x_l << "   QT_Q2f.size() = " << QT_Q2f.size() << endline_flush;
		  logger << LOG_DEBUG << "x_l = " << x_l << "   i_i = " << i_i << "   QT_Q2f[" << x_l << "].size() = " << QT_Q2f[x_l].size() << endline_flush;
		  logger << LOG_DEBUG << "x_l = " << x_l << "   i_i = " << i_i << "   i_x = " << i_x << "   QT_Q2f[" << x_l << "][" << i_i << "].size() = " << QT_Q2f[x_l][i_i].size() << endline_flush;

		  logger << LOG_DEBUG << "pointer_pdf_factor_a.size() = " << pointer_pdf_factor_a.size() << endline_flush;
		  logger << LOG_DEBUG << "pointer_pdf_factor_a[" << i_c << "].size() = " << pointer_pdf_factor_a[i_c].size() << endline_flush;
		  logger << LOG_DEBUG << "pointer_pdf_factor_a[" << i_c << "][" << i_i << "].size() = " << pointer_pdf_factor_a[i_c][i_i].size() << endline_flush;
		  logger << LOG_DEBUG << "pointer_pdf_factor_a[" << i_c << "][" << i_i << "][" << i_x << "].size() = " << pointer_pdf_factor_a[i_c][i_i][i_x].size() << endline_flush;
		  logger << LOG_DEBUG << "pointer_pdf_factor_a[" << i_c << "][" << i_i << "][" << i_x << "][" << i_z << "].size() = " << pointer_pdf_factor_a[i_c][i_i][i_x][i_z].size() << endline_flush;
		  logger << LOG_DEBUG << "pointer_pdf_factor_a[" << i_c << "][" << i_i << "][" << i_x << "][" << i_z << "][" << i_s << "].size() = " << pointer_pdf_factor_a[i_c][i_i][i_x][i_z][i_s].size() << endline_flush;
		  logger << LOG_DEBUG << "pointer_pdf_factor_a[" << i_c << "][" << i_i << "][" << i_x << "][" << i_z << "][" << i_s << "][" << i_f << "].size() = " << pointer_pdf_factor_a[i_c][i_i][i_x][i_z][i_s][i_f].size() << endline_flush;

		  out_comparison << " = " << left << setw(23) << setprecision(15) << *(pointer_pdf_factor_a)[i_c][i_i][i_x][i_z][i_s][i_f][x_h] * *(pointer_pdf_factor_b)[i_c][i_i][i_x][i_z][i_s][i_f][x_h] * QT_Q2f[x_l][i_i][i_x];
		  logger << LOG_DEBUG << "x_l = " << x_l << "   i_i = " << i_i << "   i_x = " << i_x << "   QT_Q2f[" << x_l << "][" << i_i << "].size() = " << QT_Q2f[x_l][i_i].size() << endline_flush;
		  //		  out_comparison << " = " << left << setw(23) << setprecision(15) << *(pointer_pdf_factor_a)[i_c][i_i][i_x][i_z][i_s][i_f][x_h] * *(pointer_pdf_factor_b)[i_c][i_i][i_x][i_z][i_s][i_f][x_h] * CA_Q2f[i_c][i_i][i_x];
		  out_comparison << " = " << setw(23) << setprecision(15) << *(pointer_pdf_factor_a)[i_c][i_i][i_x][i_z][i_s][i_f][x_h];
		  out_comparison << " x " << setw(23) << setprecision(15) << *(pointer_pdf_factor_b)[i_c][i_i][i_x][i_z][i_s][i_f][x_h];
		  //		  out_comparison << " x " << setw(23) << setprecision(15) << CA_Q2f[i_c][i_i][i_x] << endline;
		  out_comparison << " x " << setw(23) << setprecision(15) << QT_Q2f[x_l][i_i][i_x] << endline;
		}
	      }
	      /*
	      for (int i_i = 0; i_i < list_combination_pdf[i_c].size(); i_i++){
		logger << LOG_DEBUG << "list_combination_pdf[" << i_c << "][" << i_i << "].size() = " << list_combination_pdf[i_c][i_i].size() << endline_flush;
		for (int i_x = 0; i_x < list_combination_pdf[i_c][i_i].size(); i_x++){
		  stringstream tempdirection;
		  int x_h = 0;
		  if (list_combination_pdf[i_c][i_i][i_x][0] == 1){x_h = 1; tempdirection << "(+)";}
		  else if (list_combination_pdf[i_c][i_i][i_x][0] == -1){x_h = 2; tempdirection << "(-)";}
		  stringstream temppdf;
		  temppdf << "pdf(" << left << setw(2) << csi->name_particle[list_combination_pdf[i_c][i_i][i_x][1]] << ", x1";
		  if (i_z == 1){temppdf << "/z1";}
		  else {temppdf << "   ";}
		  temppdf << ") x ";
		  temppdf << "pdf(" << left << setw(2) << csi->name_particle[list_combination_pdf[i_c][i_i][i_x][2]] << ", x2";
		  if (i_z == 2){temppdf << "/z2";}
		  else {temppdf << "   ";}
		  temppdf << ")";
		  temppdf << " x chargefactor";													       
		  out_comparison << tempdirection.str() << right << setw(48) << temppdf.str();
		  out_comparison << " = " << left << setw(23) << setprecision(15) << *(pointer_pdf_factor_a)[i_c][i_i][i_x][i_z][i_s][i_f][x_h] * *(pointer_pdf_factor_b)[i_c][i_i][i_x][i_z][i_s][i_f][x_h] * CA_Q2f[i_c][i_i][i_x];
		  out_comparison << " = " << setw(23) << setprecision(15) << *(pointer_pdf_factor_a)[i_c][i_i][i_x][i_z][i_s][i_f][x_h];
		  out_comparison << " x " << setw(23) << setprecision(15) << *(pointer_pdf_factor_b)[i_c][i_i][i_x][i_z][i_s][i_f][x_h];
		  out_comparison << " x " << setw(23) << setprecision(15) << CA_Q2f[i_c][i_i][i_x] << endline;
		}
	      }
	       */
	      /*
	      for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
		for (int i_x = 0; i_x < CA_combination_pdf[i_c][i_i].size(); i_x++){
		  stringstream tempdirection;
		  int x_h = 0;
		  if (CA_combination_pdf[i_c][i_i][i_x][0] == 1){x_h = 1; tempdirection << "(+)";}
		  else if (CA_combination_pdf[i_c][i_i][i_x][0] == -1){x_h = 2; tempdirection << "(-)";}
		  stringstream temppdf;
		  temppdf << "pdf(" << left << setw(2) << csi->name_particle[CA_combination_pdf[i_c][i_i][i_x][1]] << ", x1";
		  if (i_z == 1){temppdf << "/z1";}
		  else {temppdf << "   ";}
		  temppdf << ") x ";
		  temppdf << "pdf(" << left << setw(2) << csi->name_particle[CA_combination_pdf[i_c][i_i][i_x][2]] << ", x2";
		  if (i_z == 2){temppdf << "/z2";}
		  else {temppdf << "   ";}
		  temppdf << ")";
		  temppdf << " x chargefactor";													       
		  out_comparison << tempdirection.str() << right << setw(48) << temppdf.str();
		  out_comparison << " = " << left << setw(23) << setprecision(15) << *(pointer_pdf_factor_a)[i_c][i_i][i_x][i_z][i_s][i_f][x_h] * *(pointer_pdf_factor_b)[i_c][i_i][i_x][i_z][i_s][i_f][x_h] * CA_Q2f[i_c][i_i][i_x];
		  out_comparison << " = " << setw(23) << setprecision(15) << *(pointer_pdf_factor_a)[i_c][i_i][i_x][i_z][i_s][i_f][x_h];
		  out_comparison << " x " << setw(23) << setprecision(15) << *(pointer_pdf_factor_b)[i_c][i_i][i_x][i_z][i_s][i_f][x_h];
		  out_comparison << " x " << setw(23) << setprecision(15) << CA_Q2f[i_c][i_i][i_x] << endline;
		}
	      }
	       */
	      int x_h = 0;
	      if (i_z == 0 && (*CA_collinear)[i_c][0].in_collinear()[i_z] == 1){
		// alpha_S factor now included in definition of dipole_factor !!!
		double dipole_factor = (*(pointer_ME2term)[i_c][1][i_s][i_r][i_f] / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()] + *(pointer_ME2term)[i_c][2][i_s][i_r][i_f]) * *(pointer_relative_factor_alpha_S)[0][i_s][i_r];
		//double dipole_factor = *(pointer_ME2term)[i_c][1][i_s][i_r][i_f] / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()] + *(pointer_ME2term)[i_c][2][i_s][i_r][i_f];
		temp_c[i_c] += *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][x_h] * dipole_factor;
		out_comparison << setw(25) << "pdf_factor" << " = " << left << setw(23) << setprecision(15) << *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][x_h] << endline;  
		out_comparison << setw(25) << "dipole_factor" << " = " << left << setw(23) << setprecision(15) << dipole_factor;
		out_comparison << " = " << setw(23) << setprecision(15) << ((*(pointer_ME2term)[i_c][1][i_s][i_r][i_f] / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()]) * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]) << " (plus)";
		stringstream tempendpoint;
		tempendpoint << "delta";
		if (!switch_off_intXplus){tempendpoint << " + intXplus";}
		out_comparison << " + " << setw(23) << setprecision(15) << (*(pointer_ME2term)[i_c][2][i_s][i_r][i_f] * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]) << " (" << tempendpoint.str() << ")" << endline;
		out_comparison << setw(25) << "integrand (endpoint)" << " = " << left << setw(23) << setprecision(15) << *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][x_h] * dipole_factor << endline;
		out_comparison << endline;
	      }
	      else if ((*CA_collinear)[i_c][0].in_collinear()[i_z] == 1){ // always i_z == dipole_phasespace[i_c][4] !!!
		double dipole_factor = *(pointer_ME2term)[i_c][0][i_s][i_r][i_f] / psi->g_z_coll[i_z] * *(pointer_relative_factor_alpha_S)[0][i_s][i_r];
		temp_c[i_c] += *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][x_h] * dipole_factor;
		stringstream tempregular;
		tempregular << "regular";
		if ((*CA_collinear)[i_c][0].in_collinear()[0]){tempregular << " + plus";}
		out_comparison << setw(25) << "pdf_factor" << " = " << left << setw(23) << setprecision(15) << *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][x_h] << endline;  
		out_comparison << setw(25) << "dipole_factor" << " = " << setw(23) << setprecision(15) << dipole_factor << " (" << tempregular.str() << ")" << endline;
		out_comparison << setw(25) << "integrand (regular)" << " = " << left << setw(23) << setprecision(15) << *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][x_h] * dipole_factor << endline;
		out_comparison << endline;
	      }
	    }
	    out_comparison << "Collinear " << i_c << ":      " << left << setw(26) << (*CA_collinear)[i_c][0].name() << ": integrand (complete) = " << setw(23) << setprecision(15) << temp_c[i_c] << endline;
	    //	    out_comparison << "integrand (" << setw(12) << (*CA_collinear)[i_c][0].name() << ") " << " = " << setw(23) << setprecision(15) << temp_c[i_c] << endline;
	    out_comparison << endline;
	  }
	  //	  ps_integrand_TSV[i_s][i_r][i_f][x_h][0] = psi->ps_factor * rescaling_factor_alpha_e * accumulate(temp_c.begin(), temp_c.end(), 0.) * *(pointer_relative_factor_alpha_S)[0][i_s][i_r];
	  //	    out_comparison << "rescaling_factor_alpha_e = " << rescaling_factor_alpha_e << endline;
	  //	    out_comparison << "*(pointer_relative_factor_alpha_S)[0][i_s][i_r] = " << *(pointer_relative_factor_alpha_S)[0][i_s][i_r] << endline;
	  //	    out_comparison << "psi->ps_factor = " << psi->ps_factor << endline;
	  //	  }
	  /*
	  out_comparison << setw(25) << "integrand (complete)" << " = " << setw(23) << setprecision(15) << accumulate(temp_c.begin(), temp_c.end(), 0.) << endline;
	  out_comparison << endline;
	  */
	}
      }
    }
  }

  logger << LOG_DEBUG << "after calculate_pdf_LHAPDF_CA_collinear" << endline_flush;

  //  out_comparison << endline << "flux factor 1 / s^ = 1 / " << esi->p_parton[0][0].m2() << " = " << 1. / esi->p_parton[0][0].m2() << endline << endline; //psi->x_pdf[0] * 4. * pow(E, 2) <<

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return out_comparison.str();
}


string observable_set::output_testpoint_CA_Sherpa_output(){
  Logger logger("observable_set::output_testpoint_CA_Sherpa_output");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // only for debugging against Sherpa
  ///  vector<vector<vector<vector<vector<double> > > > > value_pdf_factor_1;
  ///  vector<vector<vector<vector<vector<double> > > > > value_pdf_factor_2;
  vector<vector<vector<vector<vector<vector<double> > > > > > value_pdf_factor_combination_1;
  vector<vector<vector<vector<vector<vector<double> > > > > > value_pdf_factor_combination_2;

  ///  vector<vector<vector<vector<vector<double*> > > > > pointer_pdf_factor_1;
  ///  vector<vector<vector<vector<vector<double*> > > > > pointer_pdf_factor_2;
  vector<vector<vector<vector<vector<vector<double*> > > > > > pointer_pdf_factor_combination_1;
  vector<vector<vector<vector<vector<vector<double*> > > > > > pointer_pdf_factor_combination_2;
  // end

  value_pdf_factor_combination_1.resize(n_pc, vector<vector<vector<vector<vector<double> > > > > (n_pz));
  value_pdf_factor_combination_2.resize(n_pc, vector<vector<vector<vector<vector<double> > > > > (n_pz));
  if (n_pc > 0){
    value_pdf_factor_combination_1[0][0].resize(max_dyn_fact + 1);
    value_pdf_factor_combination_2[0][0].resize(max_dyn_fact + 1);
  }
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    int v_sf = dynamic_scale_fact_TSV[i_s];
    if (n_pc > 0){
      value_pdf_factor_combination_1[0][0][v_sf].resize(value_relative_scale_fact[v_sf].size(), vector<vector<double> > (3));
      value_pdf_factor_combination_2[0][0][v_sf].resize(value_relative_scale_fact[v_sf].size(), vector<vector<double> > (3));
    }
  }
  for (int i_c = 0; i_c < n_pc; i_c++){
    for (int i_z = 0; i_z < n_pz; i_z++){
      value_pdf_factor_combination_1[i_c][i_z] = value_pdf_factor_combination_1[0][0];
      value_pdf_factor_combination_2[i_c][i_z] = value_pdf_factor_combination_2[0][0];
    }
  }
  logger << LOG_DEBUG << "before pointer_pdf_factor_1/2 for debugging against Sherpa" << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "Initialization phase of value_pdf_factor_combination_1:" << endline_flush;
  for (int i_c = 0; i_c < n_pc; i_c++){
    for (int i_z = 0; i_z < n_pz; i_z++){
      logger << LOG_DEBUG_VERBOSE << "max_dyn_fact = " << max_dyn_fact << endline_flush;
      for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
	value_pdf_factor_combination_1[i_c][i_z][v_sf].resize(n_scale_dyn_fact[v_sf], vector<vector<double> > (3));
	value_pdf_factor_combination_2[i_c][i_z][v_sf].resize(n_scale_dyn_fact[v_sf], vector<vector<double> > (3));
	logger << LOG_DEBUG_VERBOSE << "n_scale_dyn_fact[" << v_sf << "] = " << n_scale_dyn_fact[v_sf] << endline_flush;
	for (int i_m = 0; i_m < n_scale_dyn_fact[v_sf]; i_m++){
	  for (int i_h = 0; i_h < 3; i_h++){
	    value_pdf_factor_combination_1[i_c][i_z][v_sf][i_m][i_h].resize(CA_combination_pdf[i_c].size(), 0.);
	    value_pdf_factor_combination_2[i_c][i_z][v_sf][i_m][i_h].resize(CA_combination_pdf[i_c].size(), 0.);
	  }
	}
      }
    }
  }

  pointer_pdf_factor_combination_1.resize(n_pc, vector<vector<vector<vector<vector<double*> > > > > (n_pz, vector<vector<vector<vector<double*> > > > (n_set_TSV)));
  pointer_pdf_factor_combination_2.resize(n_pc, vector<vector<vector<vector<vector<double*> > > > > (n_pz, vector<vector<vector<vector<double*> > > > (n_set_TSV)));
  for (int i_c = 0; i_c < n_pc; i_c++){
    for (int i_z = 0; i_z < n_pz; i_z++){
      for (int i_s = 0; i_s < n_set_TSV; i_s++){
	logger << LOG_DEBUG_VERBOSE << "n_scale_fact_TSV[" << i_s << "] = " << n_scale_fact_TSV[i_s] << endline_flush;
	pointer_pdf_factor_combination_1[i_c][i_z][i_s].resize(n_scale_fact_TSV[i_s], vector<vector<double*> > (3));
	pointer_pdf_factor_combination_2[i_c][i_z][i_s].resize(n_scale_fact_TSV[i_s], vector<vector<double*> > (3));
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  for (int i_h = 0; i_h < 3; i_h++){
	    pointer_pdf_factor_combination_1[i_c][i_z][i_s][i_f][i_h].resize(CA_combination_pdf[i_c].size());
	    pointer_pdf_factor_combination_2[i_c][i_z][i_s][i_f][i_h].resize(CA_combination_pdf[i_c].size());
	    for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
	      pointer_pdf_factor_combination_1[i_c][i_z][i_s][i_f][i_h][i_i] = &value_pdf_factor_combination_1[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h][i_i];
	      pointer_pdf_factor_combination_2[i_c][i_z][i_s][i_f][i_h][i_i] = &value_pdf_factor_combination_2[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h][i_i];
	    }
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "Initialization phase of value_pdf_factor_combination_1: finished" << endline_flush;



  
  stringstream out_comparison;
  int temp_symmetry_factor = 1;
  for (int i_p = 1; i_p < 3; i_p++){
    if (csi->type_parton[0][i_p] == 0){temp_symmetry_factor *= 2 * 8;}
    else if (abs(csi->type_parton[0][i_p]) < 10){temp_symmetry_factor *= 2 * 3;}
    else if (csi->type_parton[0][i_p] == 22){temp_symmetry_factor *= 2 * 1;}
  }

  //  out_comparison << endline << endline << endline;
  out_comparison << "Comparison to Sherpa K+P terms" << endline << endline;

  static double alpha_S_2pi = alpha_S * inv2pi;
  static double alpha_e_2pi = msi->alpha_e * inv2pi;
  double alpha_x_2pi = 0.;
  if ((*CA_collinear)[0][0].type_correction() == 1){alpha_x_2pi = alpha_S_2pi;}
  else if ((*CA_collinear)[0][0].type_correction() == 2){alpha_x_2pi = alpha_e_2pi;}

  // Calculate Sherpa-relevant terms only here (if needed) !!!
  for (int i_v = 0; i_v < max_dyn_fact + 1; i_v++){
    for (int i_m = 0; i_m < n_scale_dyn_fact[i_v]; i_m++){
      for (int i_c = 0; i_c < n_pc; i_c++){
	for (int i_z = 0; i_z < n_pz; i_z++){
	  for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
	    // i_i counts different quarks/antiquarks in case of q->a r q->g splittings - otherwise only one component !!!
	    int direction = 1;
	    if ((*CA_collinear)[i_c][0].all_pdf()[i_i][0] == -1){direction = 2;}
	    for (int i_x = 0; i_x < CA_combination_pdf[i_c][i_i].size(); i_x++){
	      double temp_Sherpa_factor1 = value_pdf_factor_a[i_c][i_i][i_x][i_z][i_v][i_m][direction];
	      double temp_Sherpa_factor2 = value_pdf_factor_b[i_c][i_i][i_x][i_z][i_v][i_m][direction];
	      if ((*CA_collinear)[i_c][0].no_emitter() == 1){
		if ((*CA_collinear)[i_c][0].type_correction() == 2){temp_Sherpa_factor1 *= CA_Q2f[i_c][i_i][i_x];}
	      }
	      else if ((*CA_collinear)[i_c][0].no_emitter() == 2){
		if ((*CA_collinear)[i_c][0].type_correction() == 2){temp_Sherpa_factor2 *= CA_Q2f[i_c][i_i][i_x];}
	      }
	      if ((*CA_collinear)[i_c][0].no_emitter() == 1){
		value_pdf_factor_combination_1[i_c][i_z][i_v][i_m][direction][i_i] += temp_Sherpa_factor1;
		value_pdf_factor_combination_2[i_c][i_z][i_v][i_m][direction][i_i] = temp_Sherpa_factor2;
	      }
	      else if ((*CA_collinear)[i_c][0].no_emitter() == 2){
		value_pdf_factor_combination_1[i_c][i_z][i_v][i_m][direction][i_i] = temp_Sherpa_factor1;
		value_pdf_factor_combination_2[i_c][i_z][i_v][i_m][direction][i_i] += temp_Sherpa_factor2;
	      }
	    }
	    value_pdf_factor_combination_1[i_c][i_z][i_v][i_m][0][i_i] = value_pdf_factor_combination_1[i_c][i_z][i_v][i_m][1][i_i] + value_pdf_factor_combination_1[i_c][i_z][i_v][i_m][2][i_i];
	    value_pdf_factor_combination_2[i_c][i_z][i_v][i_m][0][i_i] = value_pdf_factor_combination_2[i_c][i_z][i_v][i_m][1][i_i] + value_pdf_factor_combination_2[i_c][i_z][i_v][i_m][2][i_i];
	  }
	}
      }
    }
  }
  for (int i_c = 0; i_c < n_pc; i_c++){
    for (int i_z = 0; i_z < n_pz; i_z++){
      for (int i_s = 0; i_s < n_set_TSV; i_s++){
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  for (int i_h = 0; i_h < 3; i_h++){
	    for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
	      pointer_pdf_factor_combination_1[i_c][i_z][i_s][i_f][i_h][i_i] = &value_pdf_factor_combination_1[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h][i_i];
	      pointer_pdf_factor_combination_2[i_c][i_z][i_s][i_f][i_h][i_i] = &value_pdf_factor_combination_2[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h][i_i];
	      if (*pointer_pdf_factor_combination_1[i_c][i_z][i_s][i_f][i_h][i_i] != 0.){logger << LOG_DEBUG_VERBOSE << "pointer_pdf_factor_combination_1[" << i_c << "][" << i_z << "][" << i_s << "][" << i_f << "][" << i_h << "][" << i_i << "] = " << *pointer_pdf_factor_combination_1[i_c][i_z][i_s][i_f][i_h][i_i] << endline_flush;}
	      if (*pointer_pdf_factor_combination_2[i_c][i_z][i_s][i_f][i_h][i_i] != 0.){logger << LOG_DEBUG_VERBOSE << "pointer_pdf_factor_combination_2[" << i_c << "][" << i_z << "][" << i_s << "][" << i_f << "][" << i_h << "][" << i_i << "] = " << *pointer_pdf_factor_combination_2[i_c][i_z][i_s][i_f][i_h][i_i] << endline_flush;}
	    }
	  }
	}
      }
    }
  }

  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    int v_sr = dynamic_scale_ren_TSV[i_s];
    int v_sf = dynamic_scale_fact_TSV[i_s];
    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
      int v_xr = no_value_ren_TSV[i_s][i_r];
      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	int v_xf = no_value_fact_TSV[i_s][i_f];
	vector<double> temp_Sherpa_KPterms_pdf((*CA_collinear).size(), 0.);
	vector<double> temp_Sherpa_KPterms((*CA_collinear).size(), 0.);
	vector<double> temp_Sherpa_KPterms_delta((*CA_collinear).size(), 0.);
	vector<double> temp_Sherpa_KPterms_endpoint((*CA_collinear).size(), 0.);
	vector<double> temp_Sherpa_KPterms_regular((*CA_collinear).size(), 0.);
	vector<double> temp_sum_c((*CA_collinear).size(), 0.);
	for (int i_c = 0; i_c < n_pc; i_c++){
	  double temp_c = 0.;
	  double temp_c_z = 0.;
	  for (int i_z = 0; i_z < n_pz; i_z++){
	    for (int i_h = 1; i_h < 3; i_h++){
	      if (i_z == 0 && (*CA_collinear)[i_c][0].in_collinear()[i_z] == 1){
		temp_c += *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][i_h] // added again for different usage
		  * (  *(pointer_ME2term)[i_c][1][i_s][i_r][i_f] / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()]
		       + *(pointer_ME2term)[i_c][2][i_s][i_r][i_f])
		  ;
	      }
	      else if ((*CA_collinear)[i_c][0].in_collinear()[i_z] == 1){
		temp_c_z += *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][i_h]  // added again for different usage
		  * *(pointer_ME2term)[i_c][0][i_s][i_r][i_f] / psi->g_z_coll[i_z]
		  ;
	      }
	    }
	  }
	  temp_sum_c[i_c] = (temp_c + temp_c_z) * *(pointer_relative_factor_alpha_S)[0][i_s][i_r];

	  stringstream sstemp;
	  sstemp << "Collinear " << setw(2) << right << i_c << ":   " << left << setw(26) << (*CA_collinear)[i_c][0].name();
	  sstemp << "mu_R = " << setw(15) << setprecision(8) << value_scale_ren[0][v_sr][v_xr] << "   ";
	  sstemp << "mu_F = " << setw(15) << setprecision(8) << value_scale_fact[0][v_sf][v_xf] << "   ";
	  sstemp << endline << endline;
	  int tablevel0 = 0;
	  int tablevel1 = tablevel0 + 56;
	  int tablevel2 = tablevel1 + 50;

	  for (int i_z = 0; i_z < 3; i_z++){
	    if (i_z == 0){

	      // endpoint []_+(1)   and   delta   (including []_+(int))

	      stringstream name_Sherpa_1;
	      name_Sherpa_1 << "kpc";
	      if ((*CA_collinear)[i_c][0].no_emitter() == 1){name_Sherpa_1 << "a";}
	      if ((*CA_collinear)[i_c][0].no_emitter() == 2){name_Sherpa_1 << "b";}
	      if ((*CA_collinear)[i_c][0].type() == 0 || (*CA_collinear)[i_c][0].type() == 3){name_Sherpa_1 << "[2]";}
	      if ((*CA_collinear)[i_c][0].type() == 1 || (*CA_collinear)[i_c][0].type() == 2){name_Sherpa_1 << "[0]";}

	      stringstream name_Sherpa_pdf_1;
	      name_Sherpa_pdf_1 << "f";
	      if ((*CA_collinear)[i_c][0].no_emitter() == 1){name_Sherpa_pdf_1 << "a";}
	      if ((*CA_collinear)[i_c][0].no_emitter() == 2){name_Sherpa_pdf_1 << "b";}
	      if ((*CA_collinear)[i_c][0].type() == 0 || (*CA_collinear)[i_c][0].type() == 3){name_Sherpa_pdf_1 << "g";}
	      if ((*CA_collinear)[i_c][0].type() == 1 || (*CA_collinear)[i_c][0].type() == 2){name_Sherpa_pdf_1 << "q";}
	      name_Sherpa_pdf_1 << " * f";
	      if ((*CA_collinear)[i_c][0].no_emitter() == 1){name_Sherpa_pdf_1 << "b";}
	      if ((*CA_collinear)[i_c][0].no_emitter() == 2){name_Sherpa_pdf_1 << "a";}

	      //  m_kpca[0]*faq
	      //  m_kpca[2]*fag
	      //  m_kpcb[0]*fbq
	      //  m_kpcb[2]*fbg

	      sstemp << left;

	      double temp_Munich_KP_endpoint = 0.;
	      double temp_Munich_kpc_endpoint = 0.;
	      double temp_Munich_KP_delta = 0.;
	      double temp_Munich_kpc_delta = 0.;

	      if (*(pointer_ME2term)[i_c][1][i_s][i_r][i_f] != 0){

		// endpoint []_+

		temp_Munich_KP_endpoint = *(pointer_ME2term)[i_c][1][i_s][i_r][i_f]
		  * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]
		  //		  		  * psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! factor shifted between different contributions !!!
		  * temp_symmetry_factor // !!! factor shifted between different contributions !!!
		  ;
		temp_Munich_kpc_endpoint = temp_Munich_KP_endpoint / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()]//;
		  / psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()]; // !!! check if correct here !!! related to g_z_coll !!! not here to compare with Sherpa !!
		temp_Sherpa_KPterms_endpoint[i_c] += temp_Munich_kpc_endpoint;
		///		  temp_Sherpa_KPterms[i_c] += temp_Munich_kpc_endpoint;
		sstemp << setw(tablevel0) << "" << left << name_Sherpa_1.str() << setw(20) << "_([]_+(1))" << " = " << setw(23) << setprecision(15) << temp_Munich_kpc_endpoint
		       << " = " << "K+P_factor / g_z_coll" << endline;
		//		       << " = " << "K+P_factor * pdf_factor / g_z_coll" << endline;

		// K+P_factor   []_+(1)

		string sum_KPterm = "";
		stringstream split_KPterm;
		int counter = 0;
		double check_sum_KPterm = 0.;
		for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
		  string name_Kterm;
		  string name_Pterm;
		  if ((*CA_collinear)[i_c][j_c].no_spectator() == 0){name_Kterm = "Kbar";}
		  else if ((*CA_collinear)[i_c][j_c].no_spectator() < 3){
		    stringstream temp;
		    temp << (*CA_collinear)[i_c][j_c].no_spectator();
		    name_Kterm = "Kt(" + temp.str() + ")";
		    name_Pterm = "P(" + temp.str() + ")";
		  }
		  else if ((*CA_collinear)[i_c][j_c].no_spectator() > 2){
		    stringstream temp;
		    temp << (*CA_collinear)[i_c][j_c].no_spectator();
		    name_Kterm = "gamma(" + temp.str() + ")";
		    name_Pterm = "P(" + temp.str() + ")";
		  }
		  if (data_K[1][i_c][j_c] != 0.){
		    if (counter > 0){sum_KPterm = sum_KPterm + " + ";}
		    counter++;
		    double temp_Sherpa_K_endpoint =
		      alpha_x_2pi
		      * data_K[1][i_c][j_c]
		      / psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! check if correct here !!! related to g_z_coll !!! not here to compare with Sherpa !!
		      * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]
		      //		      * psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! factor shifted between different contributions (contained in pdf_1/2) !!!
		      * temp_symmetry_factor // !!! factor shifted between different contributions !!!
		      ;
		    check_sum_KPterm += temp_Sherpa_K_endpoint;
		    sum_KPterm = sum_KPterm + name_Kterm;
		    split_KPterm << setw(tablevel2) << "" << left << setw(12) << name_Kterm << " = " << setw(23) << setprecision(15) << temp_Sherpa_K_endpoint << endline;
		  }
		  if (value_data_P[v_sf][v_xf][1][i_c][j_c] != 0.){
		    if (counter > 0){sum_KPterm = sum_KPterm + " + ";}
		    counter++;
		    double temp_Sherpa_P_endpoint =
		      alpha_x_2pi
		      * value_data_P[v_sf][v_xf][1][i_c][j_c]
		      / psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! check if correct here !!! related to g_z_coll !!! not here to compare with Sherpa !!
		      * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]
		      //		      * psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! factor shifted between different contributions (contained in pdf_1/2) !!!
		      * temp_symmetry_factor // !!! factor shifted between different contributions !!!
		      ;
		    check_sum_KPterm += temp_Sherpa_P_endpoint;
		    sum_KPterm = sum_KPterm + name_Pterm;
		    split_KPterm << setw(tablevel2) << "" << left << setw(12) << name_Pterm << " = " << setw(23) << setprecision(15) << temp_Sherpa_P_endpoint << endline;
		  }
		}
		sstemp << setw(tablevel1) << "" << setw(12) << "K+P_factor" << " = " << setw(23) << setprecision(15) << temp_Munich_KP_endpoint
		       << setw(9) << "" << " = " << sum_KPterm << endline << split_KPterm.str();
		sstemp << setw(tablevel1) << "" << setw(12) << "   check" << " = " << setw(23) << setprecision(15) << check_sum_KPterm << endline;
		sstemp << endline;

		// 1. / g_z_coll   []_+(1)

		sstemp << setw(tablevel1) << "" << setw(12) << "1/g_z_coll" << " = " << setw(23) << setprecision(15) <<
		  1. / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()] << endline;

		// check   []_+(1)

		sstemp << setw(tablevel0) << "" << left << setw(27) << "   check" << " = " << setw(23) << setprecision(15) <<
		  check_sum_KPterm
		  / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()]
		  //		  * temp_pdf_factor
		       << endline;

		sstemp << endline;
	      }

	      if (*(pointer_ME2term)[i_c][2][i_s][i_r][i_f] != 0){

		// delta + []_+(int)

		temp_Munich_KP_delta = *(pointer_ME2term)[i_c][2][i_s][i_r][i_f]
		  * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]
		  * temp_symmetry_factor // !!! factor shifted between different contributions !!!
		  ;
		temp_Munich_kpc_delta = temp_Munich_KP_delta;
		temp_Sherpa_KPterms_delta[i_c] += temp_Munich_kpc_delta;
		///		  temp_Sherpa_KPterms[i_c] += temp_Munich_kpc_delta;
		sstemp << setw(tablevel0) << "" << name_Sherpa_1.str() << setw(20) << "_(delta + []_+(int))" << " = " << setw(23) << setprecision(15) << temp_Munich_kpc_delta
		       << " = " << "K+P_factor" << endline;
		//		       << " = " << "K+P_factor * pdf_factor" << endline;

		// K+P_factor delta + []_+(int)

		string sum_KPterm = "";
		stringstream split_KPterm;
		int counter = 0;
		double check_sum_KPterm = 0.;
		for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
		  string name_Kterm;
		  string name_Pterm;
		  if ((*CA_collinear)[i_c][j_c].no_spectator() == 0.){name_Kterm = "Kbar";} // && data_K[2][i_c][j_c] != 0
		  else if ((*CA_collinear)[i_c][j_c].no_spectator() < 3){
		    stringstream temp;
		    temp << (*CA_collinear)[i_c][j_c].no_spectator();
		    name_Kterm = "Kt(" + temp.str() + ")";
		    name_Pterm = "P(" + temp.str() + ")";
		  }
		  else if ((*CA_collinear)[i_c][j_c].no_spectator() > 2){
		    stringstream temp;
		    temp << (*CA_collinear)[i_c][j_c].no_spectator();
		    name_Kterm = "gamma(" + temp.str() + ")";
		    name_Pterm = "P(" + temp.str() + ")";
		  }
		  if (data_K[2][i_c][j_c] != 0.){
		    if (counter > 0){sum_KPterm = sum_KPterm + " + ";}
		    counter++;
		    double temp_Sherpa_K_delta =
		      alpha_x_2pi
		      * data_K[2][i_c][j_c]
		      * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]
		      * temp_symmetry_factor
		      ;
		    check_sum_KPterm += temp_Sherpa_K_delta;
		    sum_KPterm = sum_KPterm + name_Kterm;
		    split_KPterm << setw(tablevel2) << "" << left << setw(12) << name_Kterm << " = " << setw(23) << setprecision(15) << temp_Sherpa_K_delta << endline;
		  }
		  if (value_data_P[v_sf][v_xf][2][i_c][j_c] != 0.){
		    if (counter > 0){sum_KPterm = sum_KPterm + " + ";}
		    counter++;
		    double temp_Sherpa_P_delta =
		      alpha_x_2pi
		      * value_data_P[v_sf][v_xf][2][i_c][j_c]
		      * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]
		      * temp_symmetry_factor
		      ;
		    logger << LOG_DEBUG << "alpha_x_2pi  = " << alpha_x_2pi  << endline_flush;
		    logger << LOG_DEBUG << "value_data_P[" << v_sf << "][" << v_xf << "][2][i_c][j_c]  = " << value_data_P[v_sf][v_xf][2][i_c][j_c]  << endline_flush;
		    logger << LOG_DEBUG << "*(pointer_relative_factor_alpha_S)[0][i_s][i_r]  = " << *(pointer_relative_factor_alpha_S)[0][i_s][i_r]  << endline_flush;
		    logger << LOG_DEBUG << "temp_symmetry_factor = " << temp_symmetry_factor << endline_flush;
		    logger << LOG_DEBUG << "temp_Sherpa_P_delta = " <<  temp_Sherpa_P_delta << endline_flush;
		    check_sum_KPterm += temp_Sherpa_P_delta;
		    sum_KPterm = sum_KPterm + name_Pterm;
		    split_KPterm << setw(tablevel2) << "" << left << setw(12) << name_Pterm << " = " << setw(23) << setprecision(15) << temp_Sherpa_P_delta << endline;
		  }
		}
		sstemp << setw(tablevel1) << "" << setw(12) << "K+P_factor" << " = " << setw(23) << setprecision(15) << temp_Munich_KP_delta
		       << " = " << setw(9) << "" << sum_KPterm << endline << split_KPterm.str();
		sstemp << setw(tablevel1) << "" << setw(12) << "   check" << " = " << setw(23) << setprecision(15) << check_sum_KPterm << endline;
		sstemp << endline;

		sstemp << setw(tablevel0) << "" << left << setw(27) << "   check" << " = " << setw(23) << setprecision(15) <<
		  check_sum_KPterm // / psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()]
		  //		  * temp_pdf_factor
		  //		  * *(pointer_pdf_factor_1)[i_c][i_z][i_s][i_f][0] * *(pointer_pdf_factor_2)[i_c][i_z][i_s][i_f][0]
		       << endline;

		sstemp << endline;
	      }

	      if (*(pointer_ME2term)[i_c][1][i_s][i_r][i_f] != 0. || *(pointer_ME2term)[i_c][2][i_s][i_r][i_f] != 0.){

		// pdf_factor   []_+(1)   and   delta + []_+(int)

		sstemp << setw(27) << name_Sherpa_1.str() << " = " << setw(23) << setprecision(15) << temp_Munich_kpc_endpoint + temp_Munich_kpc_delta;

		sstemp << " = ";
		if (*(pointer_ME2term)[i_c][1][i_s][i_r][i_f] != 0.){sstemp << name_Sherpa_1.str() << "_([]_+(1))"; }
		if (*(pointer_ME2term)[i_c][1][i_s][i_r][i_f] != 0. && *(pointer_ME2term)[i_c][2][i_s][i_r][i_f] != 0.){sstemp << " + ";}
		if (*(pointer_ME2term)[i_c][2][i_s][i_r][i_f] != 0.){sstemp << name_Sherpa_1.str() << "_(delta + []_+(int))";}
		sstemp << endline;
		sstemp << endline;

		//		sstemp << setw(tablevel1) << "" << setw(12) << "pdf_factor" << " = " << setw(23) << setprecision(15) <<
		sstemp << setw(tablevel0) << "" << setw(27) << name_Sherpa_pdf_1.str() << " = " << setw(23) << setprecision(15) <<
		  *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][0] << " = " << "sum_i[pdf(a)_i * pdf(b)_i]" << endline;
		
		double temp_pdf_factor = 0.;
		for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
		  if (*(pointer_pdf_factor_combination_1)[i_c][i_z][i_s][i_f][0][i_i] != 0. && *(pointer_pdf_factor_combination_2)[i_c][i_z][i_s][i_f][0][i_i] != 0.){
		    double temp_factor1 = *(pointer_pdf_factor_combination_1)[i_c][i_z][i_s][i_f][0][i_i];
		    double temp_factor2 = *(pointer_pdf_factor_combination_2)[i_c][i_z][i_s][i_f][0][i_i];
		    sstemp << setw(tablevel1) << "" << "pdf(a)*pdf(b)_{" << setw(12) << (*CA_collinear)[i_c][0].all_name()[i_i] << "} = " << setw(23) << setprecision(15) << temp_factor1 * temp_factor2 << endline;
		    sstemp << setw(tablevel2) << "" << "pdf(a)_" << i_i << " = " << setw(23) << setprecision(15) << temp_factor1 << endline;
		    sstemp << setw(tablevel2) << "" << "pdf(b)_" << i_i << " = " << setw(23) << setprecision(15) << temp_factor2 << endline;
		    temp_pdf_factor += temp_factor1 * temp_factor2;
		  }
		}
		/*
		double temp_pdf_factor = 0.;
		for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
		  temp_pdf_factor += *(pointer_pdf_factor_combination_1)[i_c][i_z][i_s][i_f][0][i_i] * *(pointer_pdf_factor_combination_2)[i_c][i_z][i_s][i_f][0][i_i];
		}
		*/
		temp_Sherpa_KPterms_pdf[i_c] += (temp_Sherpa_KPterms_delta[i_c] + temp_Sherpa_KPterms_endpoint[i_c]) * temp_pdf_factor;

		sstemp << setw(tablevel0) << "" << setw(27) << "   check" << " = " << setw(23) << setprecision(15) <<
		  temp_pdf_factor << endline;

		sstemp << endline;

		sstemp << endline;
	      }
	    }


	    else {

	      // regular + []_+(z)

	      if (i_z != (*CA_collinear)[i_c][0].no_emitter()){continue;}
	      if (*(pointer_ME2term)[i_c][0][i_s][i_r][i_f] != 0){
		stringstream name_Sherpa_z;
		name_Sherpa_z << "kpc";
		if ((*CA_collinear)[i_c][0].no_emitter() == 1){name_Sherpa_z << "a";}
		if ((*CA_collinear)[i_c][0].no_emitter() == 2){name_Sherpa_z << "b";}
		if ((*CA_collinear)[i_c][0].type() == 0 || (*CA_collinear)[i_c][0].type() == 3){name_Sherpa_z << "[3]";}
		if ((*CA_collinear)[i_c][0].type() == 1 || (*CA_collinear)[i_c][0].type() == 2){name_Sherpa_z << "[1]";}

		stringstream name_Sherpa_pdf_z;
		name_Sherpa_pdf_z << "f";
		if ((*CA_collinear)[i_c][0].no_emitter() == 1){name_Sherpa_pdf_z << "a";}
		if ((*CA_collinear)[i_c][0].no_emitter() == 2){name_Sherpa_pdf_z << "b";}
		if ((*CA_collinear)[i_c][0].type() == 0 || (*CA_collinear)[i_c][0].type() == 3){name_Sherpa_pdf_z << "gx";}
		if ((*CA_collinear)[i_c][0].type() == 1 || (*CA_collinear)[i_c][0].type() == 2){name_Sherpa_pdf_z << "qx";}
		name_Sherpa_pdf_z << " * f";
		if ((*CA_collinear)[i_c][0].no_emitter() == 1){name_Sherpa_pdf_z << "b";}
		if ((*CA_collinear)[i_c][0].no_emitter() == 2){name_Sherpa_pdf_z << "a";}

		//  m_kpca[0]*faqx
		//  m_kpca[2]*fagx
		//  m_kpcb[0]*fbqx
		//  m_kpcb[2]*fbgx

		double temp_Munich_KP_regular = 0.;
		double temp_Munich_kpc_regular = 0.;

		temp_Munich_KP_regular = *(pointer_ME2term)[i_c][0][i_s][i_r][i_f]
		  * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]
		  //		  * *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][0]
		  * temp_symmetry_factor // !!! factor shifted between different contributions !!!
		  ;
		temp_Munich_kpc_regular = temp_Munich_KP_regular / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()];
		temp_Sherpa_KPterms_regular[i_c] += temp_Munich_kpc_regular;
		///		  temp_Sherpa_KPterms[i_c] += temp_Munich_kpc_regular;

		//		sstemp << setw(tablevel0) << "" << left << setw(11) << "reg + []_+(z)" << " = " << setw(23) << setprecision(15) <<
		sstemp << setw(tablevel0) << "" << left << name_Sherpa_z.str() << setw(20) << "_(reg + []_+(z))" << " = " << setw(23) << setprecision(15) << temp_Munich_kpc_regular
		  * psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! factor shifted here from PDF's !!! compensated by g_z_coll !!! not here to compare with Sherpa !! -> reactivated !!!
		       << " = " << "K+P_factor / g_z_coll * psi->z_coll" << endline; // includes reactived factor !!!
		//			 << " = " << "K+P_factor / g_z_coll" << endline;
		//		       << " = " << "K+P_factor * pdf_factor / g_z_coll" << endline;

		// K+P_factor   regular + []_+(z)

		string sum_KPterm = "";
		stringstream split_KPterm;
		int counter = 0;
		double check_sum_KPterm = 0.;
		for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
		  string name_Kterm;
		  string name_Pterm;
		  if ((*CA_collinear)[i_c][j_c].no_spectator() == 0){name_Kterm = "Kbar"; }
		  else if ((*CA_collinear)[i_c][j_c].no_spectator() < 3){
		    stringstream temp;
		    temp << (*CA_collinear)[i_c][j_c].no_spectator();
		    name_Kterm = "Kt(" + temp.str() + ")";
		    name_Pterm = "P(" + temp.str() + ")";
		  }
		  else if ((*CA_collinear)[i_c][j_c].no_spectator() > 2){
		    stringstream temp;
		    temp << (*CA_collinear)[i_c][j_c].no_spectator();
		    name_Kterm = "gamma(" + temp.str() + ")";
		    name_Pterm = "P(" + temp.str() + ")";
		  }
		  if (data_K[0][i_c][j_c] != 0.){
		    if (counter > 0){sum_KPterm = sum_KPterm + " + ";}
		    counter++;
		    double temp_Sherpa_K_regular =
		      alpha_x_2pi
		      * data_K[0][i_c][j_c]
		      * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]
		      * psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! factor shifted here from PDF's !!! compensated by g_z_coll !!! not here to compare with Sherpa !! -> reactivated !!!
		      * temp_symmetry_factor // !!! factor shifted between different contributions !!!
		      ;
		    check_sum_KPterm += temp_Sherpa_K_regular;
		    sum_KPterm = sum_KPterm + name_Kterm;
		    split_KPterm << setw(tablevel2) << "" << left << setw(12) << name_Kterm << " = " << setw(23) << setprecision(15) << temp_Sherpa_K_regular << endline;
		  }
		  if (value_data_P[v_sf][v_xf][0][i_c][j_c] != 0.){
		    if (counter > 0){sum_KPterm = sum_KPterm + " + ";}
		    counter++;
		    double temp_Sherpa_P_regular =
		      alpha_x_2pi
		      * value_data_P[v_sf][v_xf][0][i_c][j_c]
		      * *(pointer_relative_factor_alpha_S)[0][i_s][i_r]
		      * psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! factor shifted here from PDF's !!! compensated by g_z_coll !!! not here to compare with Sherpa !! -> reactivated !!!
		      * temp_symmetry_factor // !!! factor shifted between different contributions !!!
		      ;
		    check_sum_KPterm += temp_Sherpa_P_regular;
		    sum_KPterm = sum_KPterm + name_Pterm;
		    split_KPterm << setw(tablevel2) << "" << left << setw(12) << name_Pterm << " = " << setw(23) << setprecision(15) << temp_Sherpa_P_regular << endline;
		  }
		}
		sstemp << setw(tablevel1) << "" << setw(12) << "K+P_factor" << " = " << setw(23) << setprecision(15) << temp_Munich_KP_regular
		  * psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! factor shifted here from PDF's !!! compensated by g_z_coll !!! not here to compare with Sherpa !! -> reactivated !!!
		       << setw(9) << "" << " = " << sum_KPterm << endline << split_KPterm.str();
		sstemp << setw(tablevel1) << "" << setw(12) << "   check" << " = " << setw(23) << setprecision(15) << check_sum_KPterm << endline;
		sstemp << endline;

		// 1. / g_z_coll   regular + []_+(z)

		sstemp << setw(tablevel1) << "" << setw(12) << "1/g_z_coll" << " = " << setw(23) << setprecision(15) <<
		  1. / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()] << endline;

		// z_coll   regular + []_+(z)
		sstemp << setw(tablevel1) << "" << setw(12) << "z_coll" << " = " << setw(23) << setprecision(15) <<
		  psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] << endline; // -> reactivated factor !!!

		// check   regular + []_+(z)

		sstemp << setw(tablevel0) << "" << left << setw(27) << "   check" << " = " << setw(23) << setprecision(15) <<
		  check_sum_KPterm
		  //		  * temp_pdf_factor
		  / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()]
		       << endline;
		sstemp << endline;

		sstemp << setw(27) << name_Sherpa_z.str() << " = " << setw(23) << setprecision(15) << temp_Munich_kpc_regular * psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()]; // !!! re-appearance maybe here ??? not checked !!! -> could be included into some previous definition (re-activation) !!!
		sstemp << " = ";
		if (*(pointer_ME2term)[i_c][0][i_s][i_r][i_f] != 0.){sstemp << name_Sherpa_z.str() << "_(reg + []_+(z))"; }
		sstemp << endline;
		sstemp << endline;


		// pdf_factor   regular + []_+(z)

		sstemp << setw(tablevel0) << "" << setw(27) << name_Sherpa_pdf_z.str() << " = " << setw(23) << setprecision(15) <<
		  //		sstemp << setw(tablevel1) << "" << setw(12) << "pdf_factor" << " = " << setw(23) << setprecision(15) <<
		  *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][0]
		  / psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! factor shifted between different contributions !!! but where does it re-appear ???
		       << " = " << "sum_i[pdf(a)_i * pdf(b)_i]" << endline;
		double temp_pdf_factor = 0.;
		for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
		  logger << LOG_DEBUG_VERBOSE << "pointer_pdf_factor_combination_1[" << i_c << "][" << i_z << "][" << i_s << "][" << i_f << "][0][" << i_i << "] = " << *pointer_pdf_factor_combination_1[i_c][i_z][i_s][i_f][0][i_i] << endline_flush;
		  logger << LOG_DEBUG_VERBOSE << "pointer_pdf_factor_combination_2[" << i_c << "][" << i_z << "][" << i_s << "][" << i_f << "][0][" << i_i << "] = " << *pointer_pdf_factor_combination_2[i_c][i_z][i_s][i_f][0][i_i] << endline_flush;

		  if (*(pointer_pdf_factor_combination_1)[i_c][i_z][i_s][i_f][0][i_i] != 0. && *(pointer_pdf_factor_combination_2)[i_c][i_z][i_s][i_f][0][i_i] != 0.){
		    double temp_factor1 = *(pointer_pdf_factor_combination_1)[i_c][i_z][i_s][i_f][0][i_i];
		    if ((*CA_collinear)[i_c][0].no_emitter() == 1){temp_factor1 /= psi->z_coll[1];}
		    double temp_factor2 = *(pointer_pdf_factor_combination_2)[i_c][i_z][i_s][i_f][0][i_i];
		    if ((*CA_collinear)[i_c][0].no_emitter() == 2){temp_factor2 /= psi->z_coll[2];}
		    sstemp << setw(tablevel1) << "" << "pdf(a)*pdf(b)_{" << setw(12) << (*CA_collinear)[i_c][0].all_name()[i_i] << "} = " << setw(23) << setprecision(15) << temp_factor1 * temp_factor2 << endline;
		    sstemp << setw(tablevel2) << "" << "pdf(a)_" << i_i << " = " << setw(23) << setprecision(15) << temp_factor1 << endline;
		    sstemp << setw(tablevel2) << "" << "pdf(b)_" << i_i << " = " << setw(23) << setprecision(15) << temp_factor2 << endline;
		    temp_pdf_factor += temp_factor1 * temp_factor2;
		  }
		}
		temp_Sherpa_KPterms_pdf[i_c] += (temp_Sherpa_KPterms_regular[i_c]) * temp_pdf_factor * psi->z_coll[(*CA_collinear)[i_c][0].no_emitter()] // !!! re-appearance maybe here ??? not checked !!! -> could be included into some previous definition (re-activation) !!!
		  ;
		sstemp << setw(tablevel0) << "" << setw(27) << "   check" << " = " << setw(23) << setprecision(15) <<
		  temp_pdf_factor << endline;
		sstemp << endline;

	      }
	    }
	  }
	  out_comparison << sstemp.str() << endline;

	}
	//	ps_integrand_TSV[i_s][i_r][i_f][i_h][0] = psi->ps_factor * rescaling_factor_alpha_e * accumulate(temp_c.begin(), temp_c.end(), 0.) * *(pointer_relative_factor_alpha_S)[0][i_s][i_r];

	out_comparison << left << endline;
	for (int i_c = 0; i_c < n_pc; i_c++){
	  out_comparison << "temp_Sherpa_KPterms[" << setw(12) << (*CA_collinear)[i_c][0].name() << "] = " << left << setw(23) << setprecision(15) << temp_Sherpa_KPterms_pdf[i_c] << endline;
	  out_comparison << "   check             " << setw(12) << "" << " = " << setw(23) << setprecision(15) <<
	    temp_sum_c[i_c]
	    * temp_symmetry_factor // !!! factor shifted between different contributions !!!
			 << endline;
	  out_comparison << endline;
	}

	out_comparison << left << endline;
	for (int i_c = 0; i_c < n_pc; i_c++){
	  out_comparison << "result[" << setw(12) << (*CA_collinear)[i_c][0].name() << "]" << " = " << left << setw(23) << setprecision(15) << psi->hcf / esi->p_parton[0][0].m2() * temp_Sherpa_KPterms_pdf[i_c] << " = " << "temp_Sherpa_KPterms[" << setw(12) << (*CA_collinear)[i_c][0].name() << "] * hcf * flux_factor * symmetry_factor" << endline;
	  out_comparison << left << setw(49) << "" << "temp_Sherpa_KPterms[" << setw(12) << (*CA_collinear)[i_c][0].name() << "] = " << left << setw(23) << setprecision(15) << temp_Sherpa_KPterms_pdf[i_c] << endline;
	  out_comparison << setw(49) << "" << setw(33) << "hcf" << " = " << setw(23) << setprecision(15) << psi->hcf << endline;
	  out_comparison << setw(49) << "" << setw(33) << "flux_factor" << " = " << setw(23) << setprecision(15) << 1. / esi->p_parton[0][0].m2() << endline;
	  out_comparison << setw(49) << "" << setw(33) << "symmetry_factor" << " = " << setw(23) << setprecision(15) << 1. / temp_symmetry_factor << endline;
	  out_comparison << endline;
	}
	out_comparison << left << endline;
	out_comparison << setw(15) << "hcf" << " = " << setw(23) << setprecision(15) << psi->hcf << " = " << "(hbar * c [GeV cm]) ^ 2 * fbarn [cm^2] / 2 / (2pi) ^ (3 * " << csi->n_particle << " - 4)" << endline;
 	out_comparison << setw(15) << "flux_factor" << " = " << setw(23) << setprecision(15) << 1. / esi->p_parton[0][0].m2() << " = " << "1 / s^" << " = 1 / " << esi->p_parton[0][0].m2() << endline;
	out_comparison << setw(15) << "symmetry_factor" << " = " << setw(23) << setprecision(15) << 1. / temp_symmetry_factor << " = 1 / " << temp_symmetry_factor << endline;
	out_comparison << endline;
	out_comparison << "not included: phase-space weight (apart from factor from linear collinear-emission mapping, where applicable)" << endline;
	out_comparison << endline;
	out_comparison << endline;
	out_comparison << endline;
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return out_comparison.str();
}


void observable_set::output_integrand_maximum_CA(){
  Logger logger("observable_set::output_integrand_maximum_CA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (fabs(integrand) > fabs(max_integrand)){
    ofstream out_maxevent;
    max_integrand = fabs(integrand);
    out_maxevent.open(filename_maxevent.c_str(), ofstream::out | ofstream::app);

    out_maxevent << right << setw(10) << psi->i_gen << right << setw(10) << psi->i_acc << "   max_integrand = " << this_psp_weight << "   " << "max_integrand / sigma_normalization = " << max_integrand / sigma_normalization << endline;

    output_integrand_maximum_psp();

    for (int ic = 1; ic < 3; ic++){
      out_maxevent << "z_coll[" << ic << "] = " << right << setw(23) << setprecision(15) << showpoint << psi->z_coll[ic] << endline;
    }

    for (int sd = 0; sd < value_mu_fact.size(); sd++){
      for (int ss = 0; ss < value_mu_fact[sd].size(); ss++){
	for (int i_a = 0; i_a < (*CA_collinear).size(); i_a++){
	  out_maxevent << "CA_value_pdf_factor[" << sd << "][" << ss << "][" << i_a << "][" << (*CA_collinear)[i_a][0].no_emitter() << "][0] = " << right << setw(23) << setprecision(15) << showpoint << CA_value_pdf_factor[sd][ss][i_a][(*CA_collinear)[i_a][0].no_emitter()][0] << endline;
	  out_maxevent << "CA_value_pdf_factor[" << sd << "][" << ss << "][" << i_a << "][0][0] = " << right << setw(23) << setprecision(15) << showpoint << CA_value_pdf_factor[sd][ss][i_a][0][0] << endline;
	}
      }
    }
    out_maxevent << endline;
    out_maxevent.close();
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

