#include "header.hpp"

string observable_set::output_testpoint_VA_ioperator(){
  Logger logger("observable_set::output_testpoint_VA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream out_comparison;
  out_comparison << setw(12) << " SK_ME2_I = " << setprecision(15) << setw(23) << VA_I_ME2 << endline;
  out_comparison << endline;
  for (int i_a = 0; i_a < (*VA_ioperator).size(); i_a++){
    for (int j_a = 0; j_a < (*VA_ioperator)[i_a].size(); j_a++){
      out_comparison << left << setw(26) << (*VA_ioperator)[i_a][j_a].name() << ": " << "I_ME2_cf[i_a = " << setw(2) << right << i_a << "][j_a = " << setw(2) << right << j_a << "] = " << setw(23) << setprecision(15) << VA_I_ME2_cf[i_a][j_a] << "   ME2_cf[" << setw(2) << right << i_a << "][" << setw(2) << right << j_a << "] = " << setw(23) << setprecision(15) << VA_ME2_cf[i_a][j_a] << endline;
    }
  }
  out_comparison << endline;
  out_comparison << endline;

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return out_comparison.str();
}


string observable_set::output_testpoint_VA_result(){
  Logger logger("observable_set::output_testpoint_VA_result");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream out_comparison;
  out_comparison << setw(12) << " ME2_born = " << setprecision(15) << setw(23) << VA_b_ME2 << endline;
  out_comparison << setw(12) << "ME2_V+X+I = " << setprecision(15) << setw(23) << (VA_V_ME2 + VA_X_ME2 + VA_I_ME2) << endline;
  out_comparison << setw(12) << "  ME2_V+X = " << setprecision(15) << setw(23) << (VA_V_ME2 + VA_X_ME2) << endline;
  out_comparison << endline;
  out_comparison << setw(12) << "    ME2_V = " << setprecision(15) << setw(23) << VA_V_ME2 << endline;
  out_comparison << setw(12) << "    ME2_X = " << setprecision(15) << setw(23) << VA_X_ME2 << endline;
  out_comparison << setw(12) << "    ME2_I = " << setprecision(15) << setw(23) << VA_I_ME2 << endline;
  out_comparison << endline;


  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return out_comparison.str();
}


string observable_set::output_testpoint_VA_integrand_TSV(){
  Logger logger("observable_set::output_testpoint_VA_integrand_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream out_comparison;
  //    calculate_pdf_LHAPDF_TSV();
  out_comparison << "V+X at renormalization scale µR, with/without corresponding alpha_S(µR) value:" << endline;
  out_comparison << endline;
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
      int i_f = 0.;
      if (switch_output_testpoint_reference_only && (i_s != no_reference_TSV || i_r != no_scale_ren_reference_TSV)){continue;}
      out_comparison << setw(12) << "  ME2_V+X (scaleset " << i_s << ", µR " << i_r << ") = " << setprecision(15) << setw(23) << setprecision(15) << setw(23) << (*(pointer_ME2term)[0][0][i_s][i_r][i_f] - VA_I_ME2) << "   " << setprecision(15) << setw(23) << (*(pointer_ME2term)[0][0][i_s][i_r][i_f] - VA_I_ME2) * *(pointer_relative_factor_alpha_S)[0][i_s][i_r] << endline;
    }
  }
  out_comparison << endline;

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return out_comparison.str();
}


string observable_set::output_testpoint_VA_Delta(int i, double & i_Delta, string & s_Delta){
  Logger logger("observable_set::output_testpoint_VA_Delta");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream out_comparison;
  if (i == 0){out_comparison << setw(23) << s_Delta << setw(23) << "ME2_V+X+I" << setw(23) << "ME2_V" << setw(23) << "ME2_X" << setw(23) << "ME2_I" << endline;}
  out_comparison << setprecision(5) << noshowpoint << setw(23) << i_Delta << setprecision(15) << setw(23) << showpoint << VA_V_ME2 + VA_X_ME2 + VA_I_ME2 << setprecision(15) << setw(23) << showpoint << VA_V_ME2 << setprecision(15) << setw(23) << showpoint << VA_X_ME2 << setprecision(15) << setw(23) << showpoint << VA_I_ME2;// << endline;

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return out_comparison.str();
}


void observable_set::output_integrand_maximum_VA(){
  Logger logger("observable_set::output_integrand_maximum_VA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (abs(this_psp_weight) > max_integrand){
    ofstream out_maxevent;
    out_maxevent.open(filename_maxevent.c_str(), ofstream::out | ofstream::app);

    max_integrand = abs(this_psp_weight);
    out_maxevent << right << setw(10) << psi->i_gen << right << setw(10) << psi->i_acc << "   max_integrand = " << this_psp_weight << "   " << "max_integrand / sigma_normalization = " << max_integrand / sigma_normalization << endline;

    output_integrand_maximum_psp();

    out_maxevent << "integrand = " << setw(23) << setprecision(15) << integrand << endline;
    out_maxevent << "ME2       = " << setw(23) << setprecision(15) << ME2 << endline;
    out_maxevent << "V_ME2     = " << setw(23) << setprecision(15) << VA_V_ME2 << endline;
    out_maxevent << "X_ME2     = " << setw(23) << setprecision(15) << VA_X_ME2 << endline;
    out_maxevent << "I_ME2     = " << setw(23) << setprecision(15) << VA_I_ME2 << endline;
    out_maxevent << "b_ME2     = " << setw(23) << setprecision(15) << VA_b_ME2 << endline;
    out_maxevent << "(V+X+I)_ME2 / b_ME2     = " << setw(23) << setprecision(15) << (VA_V_ME2 + VA_I_ME2 + VA_X_ME2) / VA_b_ME2 << endline;
    out_maxevent << endline;

    out_maxevent.close();
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


