#include "header.hpp"

string event_set::output_list_fiducialcut(){
  Logger logger("event_set::output_list_fiducialcut");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream temp_ss;
  temp_ss << "List of general fiducial cuts:" << endline;
  temp_ss << endline;
  for (int i_f = 0; i_f < fiducial_cut.size(); i_f++){
    stringstream temp_ss_fc;
    temp_ss_fc << "fiducial_cut[" << setw(2) << i_f << "]";
    string temp_s_fc = temp_ss_fc.str();
    temp_ss << temp_s_fc << " = " << fiducial_cut[i_f].output_fiducialcut(temp_s_fc.size());
    //    = " << fiducial_cut[i_f];
  }

  logger << LOG_DEBUG_VERBOSE << "finished - return" << temp_ss.str() << endline_flush;
  return temp_ss.str();
}


void event_set::output_phasespacepoints_check_selection(){
  Logger logger("event_set::output_phasespacepoints_check_selection");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  ofstream out_point_OL;
  static int counter = 0;
  static string filename_point_OL = "list.phasespacepoints.check.selection." + csi->subprocess + ".dat";
  logger << LOG_DEBUG << "filename_point_OL = " << filename_point_OL << endline_flush;
  static bool initialization = true;
  if (initialization){
    out_point_OL.open(filename_point_OL.c_str(), ofstream::out | ofstream::trunc);
    initialization = false;
  }
  else {
    out_point_OL.open(filename_point_OL.c_str(), ofstream::out | ofstream::app);
  }
  
  if (cut_ps[0] != -1){counter++;}
  out_point_OL << "! no_psp_gen = " << right << setw(7) << psi->i_gen << "   (" << setw(7) << counter << " passed)" << endline;
  for (int i_p = 1; i_p < particle_event[0][0].size(); i_p++){
    int x_p = i_p;
    if (i_p == 2){x_p = 1;}
    else if (i_p == 1){x_p = 2;}
    out_point_OL << left << "p(:," << i_p << ") = (/ "
		 << setw(23) << showpoint << setprecision(15) << particle_event[0][0][x_p].momentum.x1() << ", "
		 << setw(23) << showpoint << setprecision(15) << particle_event[0][0][x_p].momentum.x2() << ", "
		 << setw(23) << showpoint << setprecision(15) << particle_event[0][0][x_p].momentum.x3() << ", "
		 << setw(23) << showpoint << setprecision(15) << particle_event[0][0][x_p].momentum.x0() << " /)" <<endline;
  }
  if (cut_ps[0] == -1){out_point_OL << "ipass = 0" << endline;}
  else {out_point_OL << "ipass = 1" << endline;}
  out_point_OL << endline;
  out_point_OL.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


