#include "header.hpp"

void observable_set::determine_psp_weight_TSV(){
  Logger logger("observable_set::determine_psp_weight_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;
  if (!switch_TSV){return;}

  logger << LOG_DEBUG_VERBOSE << "csi->type_contribution = " << csi->type_contribution << endline_flush;

  static int x_q = 0;
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	for (int i_y = 0; i_y < max_n_integrand_TSV[i_s]; i_y++){
	  if (csi->class_contribution_QT_collinear && csi->class_contribution_order == 1){
	    ps_integrand_TSV[i_s][i_r][i_f][i_y][0] = psi->ps_factor * rescaling_factor_alpha_e
	      * value_fact_integrand_qTcut_TSV[x_q][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_y]
	      * *(pointer_relative_factor_alpha_S)[0][i_s][i_r];
	    for (int i_q = 0; i_q < n_qTcut; i_q++){
	      ps_integrand_qTcut_TSV[i_q][i_s][i_r][i_f][i_y][0] = psi->ps_factor * rescaling_factor_alpha_e
		* value_fact_integrand_qTcut_TSV[i_q][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_y]
		* *(pointer_relative_factor_alpha_S)[0][i_s][i_r];
	    }
	    logger << LOG_DEBUG_VERBOSE << "value_fact_integrand_qTcut_TSV[" << x_q << "][" << dynamic_scale_fact_TSV[i_s] << "][" << no_value_fact_TSV[i_s][i_f] << "][" << i_y << "] = " << value_fact_integrand_qTcut_TSV[x_q][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_y] << endline_flush;
	  }
	  // split from VT/VT2/CT2 !!! -> simplifications possible... ???
	  else if ((csi->class_contribution_QT_collinear && csi->class_contribution_order == 2) ||
		   csi->class_contribution_QT_virtual){
	    ps_integrand_TSV[i_s][i_r][i_f][i_y][0] = psi->ps_factor * rescaling_factor_alpha_e
	      * value_integrand_qTcut_TSV[x_q][dynamic_scale_ren_TSV[i_s]][dynamic_scale_fact_TSV[i_s]][no_value_ren_TSV[i_s][i_r]][no_value_fact_TSV[i_s][i_f]][i_y]
	      * *(pointer_relative_factor_alpha_S)[0][i_s][i_r];
	    // output_n_qTcut  or  n_qTcut ??? (difference between CT2 and the others...)
	    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
	      ps_integrand_qTcut_TSV[i_q][i_s][i_r][i_f][i_y][0] = psi->ps_factor * rescaling_factor_alpha_e
		* value_integrand_qTcut_TSV[i_q][dynamic_scale_ren_TSV[i_s]][dynamic_scale_fact_TSV[i_s]][no_value_ren_TSV[i_s][i_r]][no_value_fact_TSV[i_s][i_f]][i_y]
		* *(pointer_relative_factor_alpha_S)[0][i_s][i_r];
	    }
	    logger << LOG_DEBUG_VERBOSE << "value_integrand_qTcut_TSV[" << x_q << "][" << dynamic_scale_ren_TSV[i_s] << "][" << dynamic_scale_fact_TSV[i_s] << "][" << no_value_ren_TSV[i_s][i_r] << "][" << no_value_fact_TSV[i_s][i_f] << "][" << i_y << "] = " << value_integrand_qTcut_TSV[x_q][dynamic_scale_ren_TSV[i_s]][dynamic_scale_fact_TSV[i_s]][no_value_ren_TSV[i_s][i_r]][no_value_fact_TSV[i_s][i_f]][i_y] << endline_flush;
	  }
	  else if (n_pz == 1){ // Born, VA, RA, loop, RVA, RRA (no qTcut dependence -> affected only by esi->cut_ps) -> should become "else" !!!
	    for (int i_a = 0; i_a < n_ps; i_a++){
	      ps_integrand_TSV[i_s][i_r][i_f][i_y][i_a] = psi->ps_factor * rescaling_factor_alpha_e
		* *(pointer_ME2term)[i_a][0][i_s][i_r][i_f]
		* *(pointer_pdf_factor)[i_a][0][i_s][i_f][i_y]
		* *(pointer_relative_factor_alpha_S)[i_a][i_s][i_r];
	    }
	  }
	  else if (csi->class_contribution_CS_collinear){ // CA, RCA (no qTcut dependence -> affected only by esi->cut_ps)
	    //	  else { // CA, RCA (no qTcut dependence -> affected only by esi->cut_ps)
	    vector<double> temp_c(n_pc, 0.);
	    for (int i_c = 0; i_c < n_pc; i_c++){
	      for (int i_z = 0; i_z < n_pz; i_z++){
		// *(pointer_ME2term)[i_c][0]: regular
		// *(pointer_ME2term)[i_c][1]: plus
		// *(pointer_ME2term)[i_c][2]: delta
		if (i_z == 0 && (*CA_collinear)[i_c][0].in_collinear()[i_z] == 1){
		  temp_c[i_c] += *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][i_y]
		    * (  *(pointer_ME2term)[i_c][1][i_s][i_r][i_f] / psi->g_z_coll[(*CA_collinear)[i_c][0].no_emitter()]
			 + *(pointer_ME2term)[i_c][2][i_s][i_r][i_f]);
		}
		else if ((*CA_collinear)[i_c][0].in_collinear()[i_z] == 1){ // always i_z == dipole_phasespace[i_c][4] !!!
		  temp_c[i_c] += *(pointer_pdf_factor)[i_c][i_z][i_s][i_f][i_y]
		    * *(pointer_ME2term)[i_c][0][i_s][i_r][i_f] / psi->g_z_coll[i_z];
		}
	      }
	    }
	    ps_integrand_TSV[i_s][i_r][i_f][i_y][0] = psi->ps_factor * rescaling_factor_alpha_e * accumulate(temp_c.begin(), temp_c.end(), 0.) * *(pointer_relative_factor_alpha_S)[0][i_s][i_r];
	  }
	  else {
	    logger << LOG_FATAL << "Must not happen: All cases need to be treated above!" << endline_flush; exit(1);
	  }
	    
	  logger << LOG_DEBUG_VERBOSE << "ps_integrand_TSV[" << i_s << "][" << i_r << "][" << i_f << "][" << i_y << "][0] = " << ps_integrand_TSV[i_s][i_r][i_f][i_y][0] << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "ps_integrand_qTcut_TSV[" << x_q << "][" << i_s << "][" << i_r << "][" << i_f << "][" << i_y << "][0] = " << ps_integrand_qTcut_TSV[x_q][i_s][i_r][i_f][i_y][0] << endline_flush;
	}

	if (n_ps == 1 && n_pc == 1){integrand_TSV[i_s][i_r][i_f] = ps_integrand_TSV[i_s][i_r][i_f][0][0];}
	// What happens here for CT/CT2 ? Result ignored ???
	else {integrand_TSV[i_s][i_r][i_f] = accumulate(ps_integrand_TSV[i_s][i_r][i_f][0].begin(), ps_integrand_TSV[i_s][i_r][i_f][0].end(), 0.);}

	logger << LOG_DEBUG_VERBOSE << "integrand_TSV[" << i_s << "][" << i_r << "][" << i_f << "] = " << integrand_TSV[i_s][i_r][i_f] << endline_flush;

	if (csi->class_contribution_QT_collinear){
	  for (int i_q = 0; i_q < output_n_qTcut; i_q++){
	    integrand_qTcut_TSV[i_q][i_s][i_r][i_f] = ps_integrand_qTcut_TSV[i_q][i_s][i_r][i_f][0][0];
	  }
	  logger << LOG_DEBUG_VERBOSE << "integrand_qTcut_TSV[" << x_q << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << integrand_qTcut_TSV[x_q][i_s][i_r][i_f] << endline_flush;
	}
      }
    }
  }



  // scale-difference extension start
  // (filled with differences)
  // to be filled / extended in size:
  // ps_integrand_TSV
  // integrand_TSV
  // ps_integrand_qTcut_TSV (VT, CT, VT2, CT2, L2CT, L2VT)
  // integrand_qTcut_TSV (CT, CT2, L2CT)

  for (int i_s = 0; i_s < n_diff_set_TSV; i_s++){
    int i_es = n_set_TSV + i_s;
    for (int i_r = 0; i_r < n_scale_ren_TSV[i_es]; i_r++){
      for (int i_f = 0; i_f < n_scale_fact_TSV[i_es]; i_f++){
	for (int i_y = 0; i_y < max_n_integrand_TSV[i_es]; i_y++){
	  ps_integrand_TSV[i_es][i_r][i_f][i_y][0] = ps_integrand_TSV[no_diff_set_plus_TSV[i_s]][i_r][i_f][i_y][0] - ps_integrand_TSV[no_diff_set_minus_TSV[i_s]][i_r][i_f][i_y][0];
	  logger << LOG_DEBUG_VERBOSE << "ps_integrand_TSV[" << i_es << "][" << i_r << "][" << i_f << "][" << i_y << "][0] = " << ps_integrand_TSV[i_es][i_r][i_f][i_y][0] << endline_flush;
	  integrand_TSV[i_es][i_r][i_f] = integrand_TSV[no_diff_set_plus_TSV[i_s]][i_r][i_f] - integrand_TSV[no_diff_set_minus_TSV[i_s]][i_r][i_f];
	  logger << LOG_DEBUG_VERBOSE << "integrand_TSV[" << i_es << "][" << i_r << "][" << i_f << "] = " << integrand_TSV[i_es][i_r][i_f] << endline_flush;

	  if (csi->class_contribution_QT_collinear || csi->class_contribution_QT_virtual){
	    for (int i_q = 0; i_q < n_qTcut; i_q++){
	      ps_integrand_qTcut_TSV[i_q][i_es][i_r][i_f][i_y][0] = ps_integrand_qTcut_TSV[i_q][no_diff_set_plus_TSV[i_s]][i_r][i_f][i_y][0] - ps_integrand_qTcut_TSV[i_q][no_diff_set_minus_TSV[i_s]][i_r][i_f][i_y][0];
	      logger << LOG_DEBUG_VERBOSE << "ps_integrand_qTcut_TSV[" << x_q << "][" << i_es << "][" << i_r << "][" << i_f << "][" << i_y << "][0] = " << ps_integrand_qTcut_TSV[x_q][i_es][i_r][i_f][i_y][0] << endline_flush;
	    }
	  }

	  if (csi->class_contribution_QT_collinear){
	    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
	      integrand_qTcut_TSV[i_q][i_es][i_r][i_f] = integrand_qTcut_TSV[i_q][no_diff_set_plus_TSV[i_s]][i_r][i_f] - integrand_qTcut_TSV[i_q][no_diff_set_minus_TSV[i_s]][i_r][i_f];
	      logger << LOG_DEBUG_VERBOSE << "integrand_qTcut_TSV[" << x_q << "][" << i_es << "][" << i_r << "][" << i_f << "] = " << integrand_qTcut_TSV[x_q][i_es][i_r][i_f] << endline_flush;
	    }
	  }
	}
      }
    }
  }

  

  logger << LOG_DEBUG_VERBOSE << "active_qTcut = " << active_qTcut << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "csi->type_contribution = " << csi->type_contribution << endline_flush;

  if (!active_qTcut){ // Born, VA, CA, RA, VT, VT2, loop
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  sum_weight_TSV[i_s][i_r][i_f] += integrand_TSV[i_s][i_r][i_f];
	  sum_weight2_TSV[i_s][i_r][i_f] += pow(integrand_TSV[i_s][i_r][i_f], 2);
	}
      }
      if (switch_moment_TSV[i_s] > 0){
	for (int i_m = 0; i_m < n_moments; i_m++){
	  for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	      for (int i_y = 0; i_y < max_n_integrand_TSV[i_s]; i_y++){
		for (int i_a = 0; i_a < n_ps; i_a++){
		  logger << LOG_DEBUG_VERBOSE << "i_m = " << i_m << "   i_r = " << i_r << "   i_f = " << i_f << "   i_y = " << i_y << "   i_a = " << i_a << endline_flush;
		  logger << LOG_DEBUG_VERBOSE << "directed_moment.size() = " << directed_moment.size() << endline_flush;
		  ps_moment_TSV[i_s][i_m][i_r][i_f][i_y][i_a] = ps_integrand_TSV[i_s][i_r][i_f][i_y][i_a] * directed_moment[i_m][i_y][i_a];
		}
	      }
	      if (n_ps == 1){
		// if the moment is 'directed' in the sense of being different when the psp is rotated, the 2nd version must be used !!!
		  logger << LOG_DEBUG_VERBOSE << "moment_symm.size() = " << moment_symm.size() << endline_flush;
		  logger << LOG_DEBUG_VERBOSE << "moment_TSV[" << i_s << "].size() = " << moment_TSV[i_s].size() << endline_flush;
		if (moment_symm[i_m] == 0){moment_TSV[i_s][i_m][i_r][i_f] = ps_moment_TSV[i_s][i_m][i_r][i_f][0][0];}
		else if (moment_symm[i_m] == 1){moment_TSV[i_s][i_m][i_r][i_f] = ps_moment_TSV[i_s][i_m][i_r][i_f][1][0] + ps_moment_TSV[i_s][i_m][i_r][i_f][2][0];}
	      }
	      else {
		vector<double> temp_moment(max_n_integrand_TSV[i_s]);
		if (moment_symm[i_m] == 0){
		  moment_TSV[i_s][i_m][i_r][i_f] = accumulate(ps_moment_TSV[i_s][i_m][i_r][i_f][0].begin(), ps_moment_TSV[i_s][i_m][i_r][i_f][0].end(), 0.);
		}
		else if (moment_symm[i_m] == 1){
		  for (int i_y = 0; i_y < max_n_integrand_TSV[i_s]; i_y++){
		    temp_moment[i_y] = accumulate(ps_moment_TSV[i_s][i_m][i_r][i_f][i_y].begin(), ps_moment_TSV[i_s][i_m][i_r][i_f][i_y].end(), 0.);
		  }
		  moment_TSV[i_s][i_m][i_r][i_f] = accumulate(temp_moment.begin(), temp_moment.end(), 0.);
		}
	      }
	      logger << LOG_DEBUG_VERBOSE << "moment_TSV[i_s][" << i_m << "][i_r][i_f] = " << moment_TSV[i_s][i_m][i_r][i_f] << endline_flush;
	      sum_moment_TSV[i_s][i_m][i_r][i_f] += moment_TSV[i_s][i_m][i_r][i_f];
	      sum_moment2_TSV[i_s][i_m][i_r][i_f] += pow(moment_TSV[i_s][i_m][i_r][i_f], 2);
	    }
	  }
	}
      }
    }
  }
  else if (active_qTcut && csi->class_contribution_QT_collinear){
    for (int i_c = 0; i_c < n_qTcut; i_c++){
      for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
	for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	    sum_weight_qTcut_TSV[i_s][i_c][i_r][i_f] += integrand_qTcut_TSV[i_c][i_s][i_r][i_f];
	    sum_weight2_qTcut_TSV[i_s][i_c][i_r][i_f] += pow(integrand_qTcut_TSV[i_c][i_s][i_r][i_f], 2);;
	    logger << LOG_DEBUG_VERBOSE << "sum_weight_qTcut_TSV[" << i_s << "][" << i_c << "][" << i_r << "][" << i_f << "] = " << sum_weight_qTcut_TSV[i_s][i_c][i_r][i_f] << endline_flush;
	  }
	}
      }
    }

    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      if (switch_moment_TSV[i_s] > 0){
	for (int i_c = 0; i_c < n_qTcut; i_c++){
	  for (int i_m = 0; i_m < n_moments; i_m++){
	    // moments not included yet for qT subtraction	!!!
	  }
	}
      }
    }
  }
  else { // active_qTcut, but entering only via esi->cut_ps[i_a]: RT, RVA, RCA, RRA
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      if (n_ps == 1){ // only one phasespace: RT, RVA, RCA
	vector<vector<double> > temp_weight2(n_scale_ren_TSV[i_s], vector<double> (n_scale_ren_TSV[i_s], 0.));
	for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	    temp_weight2[i_r][i_f] += pow(integrand_TSV[i_s][i_r][i_f], 2);
	  }
	}
	for (int i_c = 0; i_c < n_qTcut; i_c++){
	  if (i_c <= esi->cut_ps[0]){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		sum_weight_qTcut_TSV[i_s][i_c][i_r][i_f] += integrand_TSV[i_s][i_r][i_f];
		sum_weight2_qTcut_TSV[i_s][i_c][i_r][i_f] += temp_weight2[i_r][i_f];
	      }
	    }
	  }
	}
	
	if (switch_moment_TSV[i_s] > 0){
	  for (int i_m = 0; i_m < n_moments; i_m++){
	    vector<vector<double> > temp_moment(n_scale_ren_TSV[i_s], vector<double> (n_scale_ren_TSV[i_s], 0.));
	    vector<vector<double> > temp_moment2(n_scale_ren_TSV[i_s], vector<double> (n_scale_ren_TSV[i_s], 0.));
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		vector<double> temp_moment_directed(3, 0.);
		for (int i_y = 0; i_y < max_n_integrand_TSV[i_s]; i_y++){
		  temp_moment_directed[i_y] = ps_integrand_TSV[i_s][i_r][i_f][i_y][0] * directed_moment[i_m][i_y][0];
		}
		if (moment_symm[i_m] == 0){temp_moment[i_r][i_f] = temp_moment_directed[0];}
		else if (moment_symm[i_m] == 1){temp_moment[i_r][i_f] = temp_moment_directed[1] + temp_moment_directed[2];}
		temp_moment2[i_r][i_f] = pow(temp_moment[i_r][i_f], 2);
	      }
	    }
	    for (int i_c = 0; i_c < n_qTcut; i_c++){
	      if (i_c <= esi->cut_ps[0]){
		for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
		  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		    sum_moment_qTcut_TSV[i_s][i_m][i_c][i_r][i_f] += temp_moment[i_r][i_f];
		    sum_moment2_qTcut_TSV[i_s][i_m][i_c][i_r][i_f] += temp_moment2[i_r][i_f];
		  }
		}
	      }
	    }
	  }
	}
      }
      else { // more than one phasespace: RRA
	vector<vector<double> > temp_weight(n_scale_ren_TSV[i_s], vector<double> (n_scale_ren_TSV[i_s], 0.));
	vector<vector<double> > temp_weight2(n_scale_ren_TSV[i_s], vector<double> (n_scale_ren_TSV[i_s], 0.));
	for (int i_c = 0; i_c < n_qTcut; i_c++){
	  if (i_c == 0 || change_cut[i_c] == 1){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		temp_weight[i_r][i_f] = 0.;
		for (int i_a = 0; i_a < n_ps; i_a++){
		  if (i_c <= esi->cut_ps[i_a]){
		    temp_weight[i_r][i_f] += ps_integrand_TSV[i_s][i_r][i_f][0][i_a];
		  }
		}
		temp_weight2[i_r][i_f] = pow(temp_weight[i_r][i_f], 2);
	      }
	    }
	  }
	  for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	      sum_weight_qTcut_TSV[i_s][i_c][i_r][i_f] += temp_weight[i_r][i_f];
	      sum_weight2_qTcut_TSV[i_s][i_c][i_r][i_f] += temp_weight2[i_r][i_f];
	    }
	  }
	}

	if (switch_moment_TSV[i_s] > 0){
	  for (int i_m = 0; i_m < n_moments; i_m++){
	    vector<vector<double> > temp_moment(n_scale_ren_TSV[i_s], vector<double> (n_scale_ren_TSV[i_s], 0.));
	    vector<vector<double> > temp_moment2(n_scale_ren_TSV[i_s], vector<double> (n_scale_ren_TSV[i_s], 0.));
	    for (int i_c = 0; i_c < n_qTcut; i_c++){
	      if (i_c == 0 || change_cut[i_c] == 1){
		for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
		  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		    vector<double> temp_moment_directed(3, 0.);
		    for (int i_a = 0; i_a < n_ps; i_a++){
		      if (i_c <= esi->cut_ps[i_a]){
			for (int i_y = 0; i_y < max_n_integrand_TSV[i_s]; i_y++){
			  temp_moment_directed[i_y] += ps_integrand_TSV[i_s][i_r][i_f][i_y][i_a] * directed_moment[i_m][i_y][i_a];
			}
		      }
		    }
		    if (moment_symm[i_m] == 0){temp_moment[i_r][i_f] = temp_moment_directed[0];}
		    else if (moment_symm[i_m] == 1){temp_moment[i_r][i_f] = temp_moment_directed[1] + temp_moment_directed[2];}
		    temp_moment2[i_r][i_f] = pow(temp_moment[i_r][i_f], 2);
		  }
		}
	      }
	      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
		for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		  sum_moment_qTcut_TSV[i_s][i_m][i_c][i_r][i_f] += temp_moment[i_r][i_f];
		  sum_moment2_qTcut_TSV[i_s][i_m][i_c][i_r][i_f] += temp_moment2[i_r][i_f];
		}
	      }
	    }
	  }
	}
      }
    }

    // reset change_cut for the next phase-space point:
    for (int i_c = 0; i_c < n_qTcut; i_c++){if (change_cut[i_c] == 1){change_cut[i_c] = 0;}}
  }

  logger << LOG_DEBUG_VERBOSE << "no_reference_TSV            = " << no_reference_TSV << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "no_scale_ren_reference_TSV  = " << no_scale_ren_reference_TSV << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "no_scale_fact_reference_TSV = " << no_scale_fact_reference_TSV << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "no_qTcut_reference_TSV      = " << no_qTcut_reference_TSV << endline_flush;

  if (no_reference_TSV > -1){
    if (csi->class_contribution_QT_collinear){
      integrand = integrand_qTcut_TSV[no_qTcut_reference_TSV][no_reference_TSV][no_scale_ren_reference_TSV][no_scale_fact_reference_TSV];
    }
    else {
      integrand = integrand_TSV[no_reference_TSV][no_scale_ren_reference_TSV][no_scale_fact_reference_TSV];
    }
    logger << LOG_DEBUG_VERBOSE << "after: integrand  = " << integrand << endline_flush;
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


// Relevant for CV variation and reference result:
void observable_set::determine_scale(){
  Logger logger("observable_set::determine_scale");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (dynamic_scale != 0){
    var_mu_fact = value_mu_fact[dynamic_scale][map_value_scale_fact];
    var_mu_ren = value_mu_ren[dynamic_scale][map_value_scale_ren];
    var_alpha_S_reference = value_alpha_S[dynamic_scale][map_value_scale_ren];
    var_rel_alpha_S = value_factor_alpha_S[dynamic_scale][map_value_scale_ren];
    logger << LOG_DEBUG_VERBOSE << "var_mu_fact = " << var_mu_fact << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "var_mu_ren = " << var_mu_ren << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "var_rel_alpha_S = " << var_rel_alpha_S << endline_flush;
  }

  if (switch_CV != 0){
    if (dynamic_scale_CV != 0){
      for (int s = 0; s < n_scales_CV; s++){
	var_mu_fact_CV[s] = value_mu_fact[dynamic_scale_CV][map_value_scale_fact_CV[s]];
	var_mu_ren_CV[s] = value_mu_ren[dynamic_scale_CV][map_value_scale_ren_CV[s]];
	var_alpha_S_CV[s] = value_alpha_S[dynamic_scale_CV][map_value_scale_ren_CV[s]];
	var_rel_alpha_S_CV[s] = value_factor_alpha_S[dynamic_scale_CV][map_value_scale_ren_CV[s]];
	logger << LOG_DEBUG_VERBOSE << "value_mu_fact[dynamic_scale_CV = " << dynamic_scale_CV << "][map_value_scale_fact_CV[s = " << s << "] = " << map_value_scale_fact_CV[s] << "] = " << setw(15) << value_mu_fact[dynamic_scale_CV][map_value_scale_fact_CV[s]] << endline_flush;
	logger << LOG_DEBUG_VERBOSE << "var_mu_fact[" << s << "] = " << setw(8) << var_mu_fact_CV[s] << "   var_mu_ren[" << s << "] = " << setw(8) << var_mu_ren_CV[s] << "   var_rel_alpha_S[" << s << "] = " << setw(15) << var_rel_alpha_S_CV[s] << endline_flush;
      }
    }
  }

  // only LOG_DEBUG_VERBOSE output:
  if (switch_TSV){
    for (int i_v = 0; i_v < max_dyn_ren + 1; i_v++){
      logger << LOG_DEBUG_VERBOSE << left << "DS: " << i_v << right << setw(25) << "rel_scale_ren" << setw(24) << "rel_scale_ren" << "²" << setw(25) << "rel_factor_alpha_S" << setw(25) << "scale_ren" << setw(24) << "scale_ren" << "²" << endline_flush;
      for (int i_m = 0; i_m < value_relative_scale_ren[i_v].size(); i_m++){
	logger << LOG_DEBUG_VERBOSE << setw(5) << "" << setw(25) << setprecision(15) << value_relative_scale_ren[i_v][i_m] << setw(25) << setprecision(15) << value_relative_scale2_ren[i_v][i_m] << setw(25) << setprecision(15) << value_relative_factor_alpha_S[0][i_v][i_m] << setw(25) << setprecision(15) << value_scale_ren[0][i_v][i_m] << setw(25) << setprecision(15) << value_scale2_ren[0][i_v][i_m] << endline_flush;
    }
      logger.newLine(LOG_DEBUG_VERBOSE);
    }
    logger.newLine(LOG_DEBUG_VERBOSE);
    for (int i_v = 0; i_v < max_dyn_fact + 1; i_v++){
      logger << LOG_DEBUG_VERBOSE << "DS: " << i_v << setw(25) << "rel_scale_fact" << setw(24) << "rel_scale_fact" << "²" << setw(23) << "log(rel_scale_fact" << "²)" << setw(25) << "scale_fact" << setw(24) << "scale_fact" << "²" << endline_flush;
      for (int i_m = 0; i_m < value_relative_scale_fact[i_v].size(); i_m++){
	logger << LOG_DEBUG_VERBOSE << setw(5) << "" << setw(25) << setprecision(15) << value_relative_scale_fact[i_v][i_m] << setw(25) << setprecision(15) << value_relative_scale2_fact[i_v][i_m] << setw(25) << setprecision(15) << value_relative_logscale2_fact[i_v][i_m] << setw(25) << setprecision(15) << value_scale_fact[0][i_v][i_m] << setw(25) << setprecision(15) << value_scale2_fact[0][i_v][i_m] << endline_flush;
      }
      logger.newLine(LOG_DEBUG_VERBOSE);
    }
    logger.newLine(LOG_DEBUG_VERBOSE);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_scale_CA(){
  Logger logger("observable_set::determine_scale_CA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int sd = 1; sd < value_mu_fact_rel.size(); sd++){
    if (value_mu_fact_rel[sd].size() != 0){
      for (int ss = 0; ss < value_mu_fact_rel[sd].size(); ss++){
	CA_value_log_mu2_fact[sd][ss] = 2 * log(value_mu_fact[sd][ss]);
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_scale_RA(int i_a){
  Logger logger("observable_set::determine_scale_RA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (dynamic_scale != 0){
    RA_mu_fact[i_a] = RA_value_mu_fact[i_a][dynamic_scale][map_value_scale_fact];
    RA_mu_ren[i_a] = RA_value_mu_ren[i_a][dynamic_scale][map_value_scale_ren];
    RA_alpha_S_reference[i_a]  = RA_value_alpha_S[i_a][dynamic_scale][map_value_scale_ren];
    RA_rel_alpha_S[i_a]  = RA_value_factor_alpha_S[i_a][dynamic_scale][map_value_scale_ren];
  }

  if (switch_CV != 0){
    if (dynamic_scale_CV != 0){
      for (int s = 0; s < n_scales_CV; s++){
	RA_mu_fact_CV[i_a][s] = RA_value_mu_fact[i_a][dynamic_scale_CV][map_value_scale_fact_CV[s]];
	RA_mu_ren_CV[i_a][s] = RA_value_mu_ren[i_a][dynamic_scale_CV][map_value_scale_ren_CV[s]];
	RA_alpha_S_CV[i_a][s] = RA_value_alpha_S[i_a][dynamic_scale_CV][map_value_scale_ren_CV[s]];
	RA_rel_alpha_S_CV[i_a][s] = RA_value_factor_alpha_S[i_a][dynamic_scale_CV][map_value_scale_ren_CV[s]];
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_integrand(){
  Logger logger("observable_set::determine_integrand");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "ME2 = " << ME2 << endline_flush;
  integrand = psi->ps_factor * rescaling_factor_alpha_e * pdf_factor[0] * var_rel_alpha_S * ME2;

  logger << LOG_DEBUG_VERBOSE << "integrand = " << integrand << "   pdf_factor[0] = " << pdf_factor[0] << "   var_rel_alpha_S = " << var_rel_alpha_S << "   psi->ps_factor = " << psi->ps_factor << "   rescaling_factor_alpha_e = " << rescaling_factor_alpha_e << "   ME2 = " << ME2 << endline_flush;

  logger << LOG_DEBUG_VERBOSE << setw(20) << "integrand" << " = " << setprecision(20) << setw(28) << integrand << "   " << double2hexastr(integrand) << endline_flush;
  logger << LOG_DEBUG_VERBOSE << setw(20) << "pdf_factor[0]" << " = " << setprecision(20) << setw(28) << pdf_factor[0] << "   " << double2hexastr(pdf_factor[0]) << endline_flush;
  logger << LOG_DEBUG_VERBOSE << setw(20) << "var_rel_alpha_S" << " = " << setprecision(20) << setw(28) << var_rel_alpha_S << "   " << double2hexastr(var_rel_alpha_S) << endline_flush;
  logger << LOG_DEBUG_VERBOSE << setw(20) << "psi->ps_factor * rescaling_factor_alpha_e" << " = " << setprecision(20) << setw(28) << psi->ps_factor * rescaling_factor_alpha_e << "   " << double2hexastr(psi->ps_factor * rescaling_factor_alpha_e) << endline_flush;
  logger << LOG_DEBUG_VERBOSE << setw(20) << "ME2" << " = " << setprecision(20) << setw(28) << ME2 << "   " << double2hexastr(ME2) << endline_flush;

  if (switch_CV != 0){
    for (int s = 0; s < n_scales_CV; s++){
      integrand_CV[s] = psi->ps_factor * rescaling_factor_alpha_e * pdf_factor_CV[s][0] * var_rel_alpha_S_CV[s] * ME2;
    }
  }

  if (switch_distribution != 0){
    for (int id = 0; id < 3; id++){
      integrand_D[id][0] = psi->ps_factor * rescaling_factor_alpha_e * pdf_factor[id] * var_rel_alpha_S * ME2;
      if (switch_CV != 0){
	for (int s = 0; s < n_scales_CV; s++){
	  integrand_D_CV[s][id][0] = psi->ps_factor * rescaling_factor_alpha_e * pdf_factor_CV[s][id] * var_rel_alpha_S_CV[s] * ME2;
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_integrand_VA(){
  Logger logger("observable_set::determined_integrand_VA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // !!! reference does not work here !!!

  integrand = psi->ps_factor * rescaling_factor_alpha_e * pdf_factor[0] * var_rel_alpha_S * (VA_V_ME2 + VA_X_ME2 + VA_I_ME2);
  if (switch_CV != 0){
    for (int s = 0; s < n_scales_CV; s++){
      integrand_CV[s] = psi->ps_factor * rescaling_factor_alpha_e * pdf_factor_CV[s][0] * var_rel_alpha_S_CV[s] * (VA_V_ME2 + VA_X_ME2_CV[s] + VA_I_ME2);
    }
  }

  if (switch_distribution != 0){
    for (int id = 0; id < 3; id++){
      integrand_D[id][0] = psi->ps_factor * rescaling_factor_alpha_e * pdf_factor[id] * var_rel_alpha_S * (VA_V_ME2 + VA_X_ME2 + VA_I_ME2);
      if (switch_CV != 0){
	for (int s = 0; s < n_scales_CV; s++){
	  integrand_D_CV[s][id][0] = psi->ps_factor * rescaling_factor_alpha_e * pdf_factor_CV[s][id] * var_rel_alpha_S_CV[s] * (VA_V_ME2 + VA_X_ME2_CV[s] + VA_I_ME2);
	}
      }
    }
  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_integrand_CA(){
  Logger logger("observable_set::determine_integrand_CA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int i_vf = 0; i_vf < value_mu_fact.size(); i_vf++){
    for (int i_mf = 0; i_mf < value_mu_fact[i_vf].size(); i_mf++){
      for (int i_a = 0; i_a < (*CA_collinear).size(); i_a++){
	double temp_z = CA_value_ME2_KP[i_vf][i_mf][0][i_a] / psi->g_z_coll[(*CA_collinear)[i_a][0].no_emitter()];
	CA_value_integrand[i_vf][i_mf][i_a] = temp_z * CA_value_pdf_factor[i_vf][i_mf][i_a][(*CA_collinear)[i_a][0].no_emitter()][0];
	if (switch_distribution != 0){
	  for (int i_d = 0; i_d < 3; i_d++){
	    CA_value_integrand_D[i_vf][i_mf][i_d][i_a] = temp_z * CA_value_pdf_factor[i_vf][i_mf][i_a][(*CA_collinear)[i_a][0].no_emitter()][i_d];
	  }
	}
	if ((*CA_collinear)[i_a][0].in_collinear()[0] == 1){
	  double temp_1 = (CA_value_ME2_KP[i_vf][i_mf][1][i_a] / psi->g_z_coll[(*CA_collinear)[i_a][0].no_emitter()] + CA_value_ME2_KP[i_vf][i_mf][2][i_a]);
	  CA_value_integrand[i_vf][i_mf][i_a] += temp_1 * CA_value_pdf_factor[i_vf][i_mf][i_a][0][0];
	  if (switch_distribution != 0){
	    for (int i_d = 0; i_d < 3; i_d ++){
	      CA_value_integrand_D[i_vf][i_mf][i_d][i_a] += temp_1 * CA_value_pdf_factor[i_vf][i_mf][i_a][0][i_d];
	    }
	  }
	}
      }
      CA_sum_value_integrand[i_vf][i_mf] = accumulate(CA_value_integrand[i_vf][i_mf].begin(), CA_value_integrand[i_vf][i_mf].end(), 0.);
      if (switch_distribution != 0){
	for (int i_y = 0; i_y < 3; i_y ++){
	  CA_sum_value_integrand_D[i_vf][i_mf][i_y] = accumulate(CA_value_integrand_D[i_vf][i_mf][i_y].begin(), CA_value_integrand_D[i_vf][i_mf][i_y].end(), 0.);
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "after CA_sum_value_integrand evaluation" << endline_flush;

  integrand = psi->ps_factor * rescaling_factor_alpha_e * value_factor_alpha_S[dynamic_scale][map_value_scale_ren] * CA_sum_value_integrand[dynamic_scale][map_value_scale_fact];

  logger << LOG_DEBUG_VERBOSE << "after integrand evaluation" << endline_flush;

  if (munich_isnan(integrand) || munich_isinf(integrand)) {
    logger << LOG_ERROR << "integrand is nan/inf" << endline_flush;
    int i_vf = dynamic_scale;
    int i_mf = map_value_scale_fact;
    for (int i_a = 0; i_a < (*CA_collinear).size(); i_a++){
      double temp_1 = psi->ps_factor * rescaling_factor_alpha_e * value_factor_alpha_S[i_vf][i_mf] * (CA_value_ME2_KP[i_vf][i_mf][1][i_a] / psi->g_z_coll[(*CA_collinear)[i_a][0].no_emitter()] + CA_value_ME2_KP[i_vf][i_mf][2][i_a]);
      logger << LOG_ERROR << i_a << ": temp_1 = " << temp_1 << endline_flush;
      logger << LOG_ERROR << value_factor_alpha_S[i_vf][i_mf] << ", " << CA_value_ME2_KP[i_vf][i_mf][1][i_a] << ", " << psi->g_z_coll[(*CA_collinear)[i_a][0].no_emitter()] << ", " << CA_value_ME2_KP[i_vf][i_mf][2][i_a] << endline_flush;
      logger << LOG_ERROR << "PDF factor = " << CA_value_pdf_factor[i_vf][i_mf][i_a][0][0] << endline_flush;
    }
  }

  if (switch_CV){
    for (int s = 0; s < n_scales_CV; s++){
      integrand_CV[s] = psi->ps_factor * rescaling_factor_alpha_e * value_factor_alpha_S[dynamic_scale_CV][map_value_scale_ren_CV[s]] * CA_sum_value_integrand[dynamic_scale_CV][map_value_scale_fact_CV[s]];
      logger << LOG_DEBUG_VERBOSE << "CA_sum_value_integrand[dynamic_scale_CV = " << dynamic_scale_CV << "][map_value_scale_fact_CV[" << s << "] = " << map_value_scale_fact_CV[s] << "] = " << CA_sum_value_integrand[dynamic_scale_CV][map_value_scale_fact_CV[s]] << endline_flush;
    }
  }

  if (switch_distribution != 0){
    for (int i_y = 0; i_y < 3; i_y++){
      integrand_D[i_y][0] = psi->ps_factor * rescaling_factor_alpha_e * value_factor_alpha_S[dynamic_scale][map_value_scale_ren] * CA_sum_value_integrand_D[dynamic_scale][map_value_scale_fact][i_y];
      if (switch_CV != 0){
	for (int s = 0; s < n_scales_CV; s++){
	  integrand_D_CV[s][i_y][0] = psi->ps_factor * rescaling_factor_alpha_e * value_factor_alpha_S[dynamic_scale_CV][map_value_scale_ren_CV[s]] * CA_sum_value_integrand_D[dynamic_scale_CV][map_value_scale_fact_CV[s]][i_y];
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_integrand_RA(){
  Logger logger("observable_set::determined_integrand_RA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int i_a = 0; i_a < n_ps; i_a++){
    var_RA_ME2[i_a] = RA_pdf_factor[i_a][0] * RA_rel_alpha_S[i_a] * RA_ME2[i_a];
    logger << LOG_DEBUG_VERBOSE << "RA_pdf_factor[" << i_a << "][0] = " << setw(23) << setprecision(15) << RA_pdf_factor[i_a][0] << "   RA_rel_alpha_S[" << i_a << "] = " << setw(23) << setprecision(15) << RA_rel_alpha_S[i_a] << "   RA_ME2[" << i_a << "] = " << setw(23) << setprecision(15) << RA_ME2[i_a] << endline_flush;
    if (switch_CV != 0){
      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	var_RA_ME2_CV[i_s][i_a] = RA_pdf_factor_CV[i_a][i_s][0] * RA_rel_alpha_S_CV[i_a][i_s] * RA_ME2[i_a];
      }
    }
    if (switch_distribution != 0){
      for (int i_y = 0; i_y < 3; i_y++){
	integrand_D[i_y][i_a] = RA_pdf_factor[i_a][i_y] * RA_rel_alpha_S[i_a] * RA_ME2[i_a] * psi->ps_factor * rescaling_factor_alpha_e;
	if (switch_CV != 0){
	  for (int i_s = 0; i_s < n_scales_CV; i_s++){
	    integrand_D_CV[i_s][i_y][i_a] = RA_pdf_factor_CV[i_a][i_s][i_y] * RA_rel_alpha_S_CV[i_a][i_s] * RA_ME2[i_a] * psi->ps_factor * rescaling_factor_alpha_e;
	  }
	}
      }
    }
  }

  integrand = accumulate(var_RA_ME2.begin(), var_RA_ME2.end(), 0.) * psi->ps_factor * rescaling_factor_alpha_e;

  logger << LOG_DEBUG_VERBOSE << "integrand = " << setw(24) << setprecision(15) << integrand << endline_flush;

  if (switch_CV != 0){
    for (int i_s = 0; i_s < n_scales_CV; i_s++){
      integrand_CV[i_s] = accumulate(var_RA_ME2_CV[i_s].begin(), var_RA_ME2_CV[i_s].end(), 0.) * psi->ps_factor * rescaling_factor_alpha_e;
    }
  }

  if (n_moments != 0){
    for (int i_m = 0; i_m < moment.size(); i_m++){
      for (int i_a = 0; i_a < moment[i_m].size(); i_a++){
	RA_ME2_moment[i_m][i_a] = var_RA_ME2[i_a] * moment[i_m][i_a];
	if (switch_CV != 0){
	  for (int i_s = 0; i_s < n_scales_CV; i_s++){
	    RA_ME2_moment_CV[i_s][i_m][i_a] = var_RA_ME2_CV[i_s][i_a] * moment[i_m][i_a];
	  }
	}
      }
      RA_integrand_moment[i_m] = accumulate(RA_ME2_moment[i_m].begin(), RA_ME2_moment[i_m].end(), 0.) * psi->ps_factor * rescaling_factor_alpha_e;

      if (switch_CV != 0){
	for (int i_s = 0; i_s < n_scales_CV; i_s++){
	  RA_integrand_moment_CV[i_s][i_m] = accumulate(RA_ME2_moment_CV[i_s][i_m].begin(), RA_ME2_moment_CV[i_s][i_m].end(), 0.) * psi->ps_factor * rescaling_factor_alpha_e;
	}
      }
    }
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_psp_weight(){
  Logger logger("observable_set::determine_psp_weight");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "psp_weight = " << setprecision(20) << setw(28) << integrand << "   " << double2hexastr(integrand) << endline_flush;

  this_psp_weight = integrand;
  this_psp_weight2 = pow(this_psp_weight, 2.);
  step_sum_weight += this_psp_weight;
  step_sum_weight2 += this_psp_weight2;

  logger << LOG_DEBUG_VERBOSE << "step_sum_weight = " << step_sum_weight << "   this_psp_weight = " << this_psp_weight << endline_flush;

  if (switch_CV != 0){
    for (int i_q = 0; i_q < n_qTcut; i_q++){
      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	if (i_q <= esi->cut_ps[0]){
	  this_psp_weight_CV[i_q][i_s] = integrand_CV[i_s];
	  this_psp_weight2_CV[i_q][i_s] = pow(this_psp_weight_CV[i_q][i_s], 2.);
	  step_sum_weight_CV[i_q][i_s] += this_psp_weight_CV[i_q][i_s];
	  step_sum_weight2_CV[i_q][i_s] += this_psp_weight2_CV[i_q][i_s];
	}
      }
    }
  }

  if (n_moments != 0){
    for (int i_m = 0; i_m < moment.size(); i_m++){
      for (int i_a = 0; i_a < moment[i_m].size(); i_a++){
	this_psp_moment[i_m] = this_psp_weight * moment[i_m][i_a];
	this_psp_moment2[i_m] = pow(this_psp_moment[i_m], 2.);
	step_sum_moment[i_m] += this_psp_moment[i_m];
	step_sum_moment2[i_m] += this_psp_moment2[i_m];
	if (switch_CV != 0){
	  for (int i_q = 0; i_q < n_qTcut; i_q++){
	    for (int i_s = 0; i_s < n_scales_CV; i_s++){
	      if (i_q <= esi->cut_ps[0]){
		this_psp_moment_CV[i_m][i_q][i_s] = this_psp_weight_CV[i_q][i_s] * moment[i_m][i_a];
		this_psp_moment2_CV[i_m][i_q][i_s] = pow(this_psp_moment_CV[i_m][i_q][i_s], 2.);
		step_sum_moment_CV[i_m][i_q][i_s] += this_psp_moment_CV[i_m][i_q][i_s];
		step_sum_moment2_CV[i_m][i_q][i_s] += this_psp_moment2_CV[i_m][i_q][i_s];
	      }
	    }
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_psp_weight_RA(){
  Logger logger("observable_set::determine_psp_weight_RA");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  this_psp_weight = integrand;
  this_psp_weight2 = pow(this_psp_weight, 2.);
  step_sum_weight += this_psp_weight;
  step_sum_weight2 += this_psp_weight2;

  if (switch_CV){
    for (int i_q = 0; i_q < n_qTcut; i_q++){
      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	var_R_integrand_cut[i_q][i_s] = 0.;
	var_A_integrand_cut[i_q][i_s] = 0.;
      }
    }
    for (int i_s = 0; i_s < n_scales_CV; i_s++){
      for (int i_a = 1; i_a < n_ps; i_a++){
	for (int i_q = 0; i_q < n_qTcut; i_q++){
	  if (i_q <= esi->cut_ps[i_a])
	    var_A_integrand_cut[i_q][i_s] += var_RA_ME2_CV[i_s][i_a];
	}
      }
      for (int i_q = 0; i_q < n_qTcut; i_q++){
	if (i_q <= esi->cut_ps[0])
	  var_R_integrand_cut[i_q][i_s] = var_RA_ME2_CV[i_s][0];
      }
    }
    for (int i_q = 0; i_q < n_qTcut; i_q++){
      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	this_psp_weight_CV[i_q][i_s] = (var_R_integrand_cut[i_q][i_s] + var_A_integrand_cut[i_q][i_s]) * psi->ps_factor * rescaling_factor_alpha_e;
	this_psp_weight2_CV[i_q][i_s] = pow(this_psp_weight_CV[i_q][i_s], 2);
	step_sum_weight_CV[i_q][i_s] += this_psp_weight_CV[i_q][i_s];
	step_sum_weight2_CV[i_q][i_s] += this_psp_weight2_CV[i_q][i_s];
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

