#include "header.hpp"

void observable_set::calculate_pdf_LHAPDF_TSV(){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;
  if (!switch_TSV){return;}

  logger << LOG_FATAL << "Should not be called any longer!" << endline_flush; exit(1);
  
  static int initialization = 1;
  static int hasPhoton = LHAPDF::hasPhoton();
  static vector<vector<double> > lhapdf_result;
  if (initialization == 1){
    if (hasPhoton == 0){lhapdf_result.resize(3, vector<double> (13));}
    else {lhapdf_result.resize(3, vector<double> (14));}
    initialization = 0;
  }

  for (int i_a = 0; i_a < n_ps; i_a++){
    if (esi->cut_ps[i_a] != -1){
      //    if (esi->cut_ps[relation_pc_ps[i_a]] != -1){
      for (int i_v = 0; i_v < max_dyn_fact + 1; i_v++){
	if (i_v == 0 && i_a > esi->first_non_cut_ps){value_pdf_factor[i_a][0][i_v] = value_pdf_factor[esi->first_non_cut_ps][0][i_v];}
	else {
	  for (int i_m = 0; i_m < n_scale_dyn_fact[i_v]; i_m++){
	    for (int i_h = 1; i_h < 3; i_h++){
	      value_pdf_factor[i_a][0][i_v][i_m][i_h] = 0.;
	      if (hasPhoton == 0){lhapdf_result[i_h] = LHAPDF::xfx(psi->x_pdf[i_h], value_scale_fact[i_a][i_v][i_m]);}
	      else {lhapdf_result[i_h] = LHAPDF::xfxphoton(psi->x_pdf[i_h], value_scale_fact[i_a][i_v][i_m]);}
	    }
	    for (int i_p = 0; i_p < csi->combination_pdf.size(); i_p++){
	      if (csi->coll_choice == 1){
		if      (csi->combination_pdf[i_p][0] ==  1){value_pdf_factor[i_a][0][i_v][i_m][1] += lhapdf_result[1][6 + csi->combination_pdf[i_p][1]] * lhapdf_result[2][6 + csi->combination_pdf[i_p][2]];}
		else if (csi->combination_pdf[i_p][0] == -1){value_pdf_factor[i_a][0][i_v][i_m][2] += lhapdf_result[1][6 + csi->combination_pdf[i_p][1]] * lhapdf_result[2][6 + csi->combination_pdf[i_p][2]];}
		else {logger << LOG_FATAL << "No valid pdf selection!" << endline_flush; exit(1);}
	      }
	      else if (csi->coll_choice == 2){
		if      (csi->combination_pdf[i_p][0] ==  1){value_pdf_factor[i_a][0][i_v][i_m][1] += lhapdf_result[1][6 + csi->combination_pdf[i_p][1]] * lhapdf_result[2][6 - csi->combination_pdf[i_p][2]];}
		else if (csi->combination_pdf[i_p][0] == -1){value_pdf_factor[i_a][0][i_v][i_m][2] += lhapdf_result[1][6 - csi->combination_pdf[i_p][1]] * lhapdf_result[2][6 + csi->combination_pdf[i_p][2]];}
		else {logger << LOG_FATAL << "No valid pdf selection!" << endline_flush; exit(1);}
	      }
	    }
	    for (int i_h = 1; i_h < 3; i_h++){value_pdf_factor[i_a][0][i_v][i_m][i_h] = value_pdf_factor[i_a][0][i_v][i_m][i_h] / psi->x_pdf[0];}
	    value_pdf_factor[i_a][0][i_v][i_m][0] = value_pdf_factor[i_a][0][i_v][i_m][1] + value_pdf_factor[i_a][0][i_v][i_m][2];
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

// PDF evaluation for collinear contributions might be shifted to the 'list' formulation one day !!!
void observable_set::calculate_pdf_LHAPDF_CA_collinear_TSV(){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_CA_collinear_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_FATAL << "Should not be called any longer!" << endline_flush; exit(1);

  if (!switch_TSV){return;}

  if (csi->coll_choice == 0){logger << LOG_FATAL << "parton--parton scattering CA contribution doesn't make sense!" << endline_flush; exit(1);}

  // Shift to separate initialization function !!!

  static int initialization = 1;
  ///  static vector<vector<vector<vector<vector<vector<double> > > > > > lhapdf_result(n_pc, vector<vector<vector<vector<vector<double> > > > > (max_dyn_fact + 1));
  static vector<vector<vector<vector<vector<vector<double> > > > > > lhapdf_result(n_ps, vector<vector<vector<vector<vector<double> > > > > (max_dyn_fact + 1));
  static vector<vector<int> > in_collinear((*CA_collinear).size());
  static vector<vector<vector<int> > > all_pdf((*CA_collinear).size());
  static int hasPhoton = LHAPDF::hasPhoton();

  // Introduce something like this ???
  //  static vector<int> max_emission(3, 0);

  if (initialization == 1){
    //    for (int i_a = 0; i_a < n_pc; i_a++){
    for (int i_a = 0; i_a < n_ps; i_a++){
      for (int i_v = 0; i_v < max_dyn_fact + 1; i_v++){
	logger << LOG_DEBUG_VERBOSE << "i_a = " << i_a << "   i_v = " << i_v << endline_flush;
	if (hasPhoton == 0){lhapdf_result[i_a][i_v].resize(n_scale_dyn_fact[i_v], vector<vector<vector<double> > > (3, vector<vector<double> > (2, vector<double> (13))));}
	else {lhapdf_result[i_a][i_v].resize(n_scale_dyn_fact[i_v], vector<vector<vector<double> > > (3, vector<vector<double> > (2, vector<double> (14))));}
	//	if (hasPhoton == 0){lhapdf_result[i_a][i_v].resize(n_scale_dyn_fact[i_v], vector<vector<vector<double> > > (3, vector<vector<double> > (3, vector<double> (13))));}
	//	else {lhapdf_result[i_a][i_v].resize(n_scale_dyn_fact[i_v], vector<vector<vector<double> > > (3, vector<vector<double> > (3, vector<double> (14))));}
      }
    }
    for (int i_a = 0; i_a < (*CA_collinear).size(); i_a++){
      logger << LOG_DEBUG_VERBOSE << "i_a = " << i_a << endline_flush;
      in_collinear[i_a] = (*CA_collinear)[i_a][0].in_collinear();
      all_pdf[i_a] = (*CA_collinear)[i_a][0].all_pdf();
    }
    initialization = 0;
    logger << LOG_DEBUG_VERBOSE << "initialization finished!" << endline_flush;
  }

  for (int i_a = 0; i_a < n_ps; i_a++){
    for (int i_v = 0; i_v < max_dyn_fact + 1; i_v++){
      logger << LOG_DEBUG_VERBOSE << "i_a = " << i_a << "   i_v = " << i_v << endline_flush;
      for (int i_m = 0; i_m < n_scale_dyn_fact[i_v]; i_m++){
	logger << LOG_DEBUG_VERBOSE << "value_scale_fact[" << i_a << "][" << i_v << "][" << i_m << "] = " << value_scale_fact[i_a][i_v][i_m] << endline_flush;
	for (int i_x = 1; i_x < 3; i_x++){
	  //	  for (int i_z = 0; i_z < i_x + 1; i_z += i_x){
	  //   for (int i_z = 0; i_z <= max_emission[i_x]; i_z++){
	  for (int i_z = 0; i_z < 2; i_z++){
	    if (hasPhoton == 0){lhapdf_result[i_a][i_v][i_m][i_x][i_z] = LHAPDF::xfx(psi->xz_pdf[i_x][i_z], value_scale_fact[i_a][i_v][i_m]);}
	    else {lhapdf_result[i_a][i_v][i_m][i_x][i_z] = LHAPDF::xfxphoton(psi->xz_pdf[i_x][i_z], value_scale_fact[i_a][i_v][i_m]);}
	    //	    if (hasPhoton == 0){lhapdf_result[i_a][i_v][i_m][i_x][i_z] = LHAPDF::xfx(all_xz_coll_pdf[i_x][i_z], value_scale_fact[i_a][i_v][i_m]);}
	    //	    else {lhapdf_result[i_a][i_v][i_m][i_x][i_z] = LHAPDF::xfxphoton(all_xz_coll_pdf[i_x][i_z], value_scale_fact[i_a][i_v][i_m]);}
	    /*
	    for (int i_p = 0; i_p < lhapdf_result[i_a][i_v][i_m][i_x][i_z].size(); i_p++){
	      logger << LOG_DEBUG_VERBOSE << "pdf[" << i_a << "][" << i_v << "][" << i_m << "][" << i_x << "][" << i_z << "][" << i_p << "] = " << setprecision(15) << setw(23) << lhapdf_result[i_a][i_v][i_m][i_x][i_z][i_p] << " / " << setprecision(15) << setw(17) << all_xz_coll_pdf[i_x][i_z] << " = " << lhapdf_result[i_a][i_v][i_m][i_x][i_z][i_p] / all_xz_coll_pdf[i_x][i_z] << endline_flush;
	      if (i_z == 0){
		logger << LOG_DEBUG_VERBOSE << "lhapdf_result[" << i_a << "][" << i_v << "][" << i_m << "][" << i_x << "][" << i_z << "][" << i_p << "] / " << setprecision(15) << setw(23) << all_xz_coll_pdf[i_x][i_z] << " = " << lhapdf_result[i_a][i_v][i_m][i_x][i_z][i_p] / all_xz_coll_pdf[i_x][i_z] << endline_flush;
	      }
	      else {
		logger << LOG_DEBUG_VERBOSE << "lhapdf_result[" << i_a << "][" << i_v << "][" << i_m << "][" << i_x << "][" << i_z << "][" << i_p << "] / " << setprecision(15) << setw(23) << all_xz_coll_pdf[i_x][i_z] << " divided by " << all_xz_coll_pdf[0][i_z] << " = " << lhapdf_result[i_a][i_v][i_m][i_x][i_z][i_p] / all_xz_coll_pdf[i_x][i_z] / all_xz_coll_pdf[0][i_z] << endline_flush;
		logger << LOG_DEBUG_VERBOSE << "lhapdf_result[" << i_a << "][" << i_v << "][" << i_m << "][" << i_x << "][" << i_z << "][" << i_p << "] / " << setprecision(15) << setw(23) << all_xz_coll_pdf[i_x][i_z] << " = " << lhapdf_result[i_a][i_v][i_m][i_x][i_z][i_p] / all_xz_coll_pdf[i_x][i_z] << endline_flush;
		logger << LOG_DEBUG_VERBOSE << "pdf[" << i_a << "][" << i_v << "][" << i_m << "][" << i_x << "][" << i_z << "][" << i_p << "] / " << setprecision(15) << setw(17) << all_xz_coll_pdf[i_x][i_z] << " divided by " << setprecision(15) << setw(17) << all_xz_coll_pdf[0][i_z] << " = " << lhapdf_result[i_a][i_v][i_m][i_x][i_z][i_p] / all_xz_coll_pdf[i_x][i_z] / all_xz_coll_pdf[0][i_z] << endline_flush;
	      }
	    }
	    */
 	  }
	}
      }
    }
  }


  // n_pc -> number of (dipole) contributions:
  for (int i_c = 0; i_c < n_pc; i_c++){
    logger << LOG_DEBUG << "esi->cut_ps[0] = " << esi->cut_ps[0] << endline_flush;
    if (esi->cut_ps[0] == -1){continue;}
    //    if (esi->cut_ps[i_c] == -1){continue;}
    // n_pz -> number of x1-x2 combinations for pdfs (like x1-x2, z1x1-x2, x1-z2x2, ...)
    for (int i_z = 0; i_z < n_pz; i_z++){
      if (in_collinear[i_c][i_z] == 0){continue;}
      logger << LOG_DEBUG_VERBOSE << "i_c = " << i_c << "   i_z = " << i_z << endline_flush;
      for (int i_v = 0; i_v < max_dyn_fact + 1; i_v++){
	// !!! check that this is calculated only if esi->cut_ps[...] == 0 !!!
	if (i_v == 0 && i_c > 0){
	  value_pdf_factor[i_c][i_z][i_v] = value_pdf_factor[0][i_z][i_v];
	}
	else {
	  int i_z1 = 0;
	  int i_z2 = 0;
	  /* ///
	  if      (i_z == 0){i_z1 = 0; i_z2 = 0;}
	  else if (i_z == 1){i_z1 = 1; i_z2 = 0;}
	  else if (i_z == 2){i_z1 = 0; i_z2 = 2;}
	  */
	  if (i_z == 1){i_z1 = 1;}
	  if (i_z == 2){i_z2 = 1;}
     logger << LOG_DEBUG_VERBOSE << "i_c = " << i_c << "   i_z = " << i_z << "   i_z1 = " << i_z1 << "   i_z2 = " << i_z2 << endline_flush;
 
	  for (int i_m = 0; i_m < n_scale_dyn_fact[i_v]; i_m++){
	    for (int i_h = 0; i_h < 3; i_h++){value_pdf_factor[i_c][i_z][i_v][i_m][i_h] = 0.;}
	    // i_i counts different quarks/antiquarks in case of q->a r q->g splittings - otherwise only one component !!!
	    for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){

	      double factor1 = 0.;
	      double factor2 = 0.;
	      //	      if (all_pdf[i_c][i_i][0] == -1){direction = 2;}
	      for (int i_x = 0; i_x < CA_combination_pdf[i_c][i_i].size(); i_x++){
		int direction = 1;
		if (CA_combination_pdf[i_c][i_i][i_x][0] == -1){direction = 2;}

		// ??? relation_pc_ps[i_c]
		// all_pdf[i_c][i_i][1] instead of CA_combination_pdf[i_c][i_i][i_x][1] ???
		if (all_pdf[i_c][i_i][1] == 7){factor1 = lhapdf_result[0][i_v][i_m][1][i_z1][13];}
		else if (csi->coll_choice == 1){factor1 = lhapdf_result[0][i_v][i_m][1][i_z1][6 + CA_combination_pdf[i_c][i_i][i_x][1]];}
		else if (csi->coll_choice == 2){
		  if      (CA_combination_pdf[i_c][i_i][i_x][0] ==  1){factor1 = lhapdf_result[0][i_v][i_m][1][i_z1][6 + CA_combination_pdf[i_c][i_i][i_x][1]];}
		  else if (CA_combination_pdf[i_c][i_i][i_x][0] == -1){factor1 = lhapdf_result[0][i_v][i_m][1][i_z1][6 - CA_combination_pdf[i_c][i_i][i_x][1]];}
		}
		if (CA_combination_pdf[i_c][i_i][i_x][2] == 7){factor2 = lhapdf_result[0][i_v][i_m][2][i_z2][13];}
		else if (csi->coll_choice == 1){factor2 = lhapdf_result[0][i_v][i_m][2][i_z2][6 + CA_combination_pdf[i_c][i_i][i_x][2]];}
		else if (csi->coll_choice == 2){
		  if      (CA_combination_pdf[i_c][i_i][i_x][0] ==  1){factor2 = lhapdf_result[0][i_v][i_m][2][i_z2][6 - CA_combination_pdf[i_c][i_i][i_x][2]];}
		  else if (CA_combination_pdf[i_c][i_i][i_x][0] == -1){factor2 = lhapdf_result[0][i_v][i_m][2][i_z2][6 + CA_combination_pdf[i_c][i_i][i_x][2]];}
		}
		value_pdf_factor_a[i_c][i_i][i_x][i_z][i_v][i_m][direction] = factor1 / psi->x_pdf[1];
		if (i_z1 == 1){value_pdf_factor_a[i_c][i_i][i_x][i_z][i_v][i_m][direction] *= psi->z_coll[1];}
		//		value_pdf_factor_a[i_c][i_i][i_x][i_z][i_v][i_m][0] = value_pdf_factor_a[i_c][i_i][i_x][i_z][i_v][i_m][direction];
		value_pdf_factor_b[i_c][i_i][i_x][i_z][i_v][i_m][direction] = factor2 / psi->x_pdf[2];
		if (i_z2 == 1){value_pdf_factor_b[i_c][i_i][i_x][i_z][i_v][i_m][direction] *= psi->z_coll[2];}
		//		if (i_z2 == 2){value_pdf_factor_b[i_c][i_i][i_x][i_z][i_v][i_m][direction] *= psi->z_coll[2];}
		//		value_pdf_factor_b[i_c][i_i][i_x][i_z][i_v][i_m][0] = value_pdf_factor_b[i_c][i_i][i_x][i_z][i_v][i_m][direction];
		value_pdf_factor[i_c][i_z][i_v][i_m][direction] += value_pdf_factor_a[i_c][i_i][i_x][i_z][i_v][i_m][direction] * value_pdf_factor_b[i_c][i_i][i_x][i_z][i_v][i_m][direction] * CA_Q2f[i_c][i_i][i_x];  // Charge factors added for QED (should always be 1 for QCD) !!!
	      }
	    }
	    value_pdf_factor[i_c][i_z][i_v][i_m][0] = value_pdf_factor[i_c][i_z][i_v][i_m][1] + value_pdf_factor[i_c][i_z][i_v][i_m][2];

	    for (int i_h = 0; i_h < 3; i_h++){
	      logger << LOG_DEBUG_VERBOSE << "value_pdf_factor[" << i_c << "][" << i_z << "][" << i_v << "][" << i_m << "][" << i_h << "] = " << value_pdf_factor[i_c][i_z][i_v][i_m][i_h] << endline_flush;
	    }
	  }
	}
      }
    }
  }

  // all_xz_coll_pdf: 0 - 0 : tau = x1 * x2
  //                  1 - 0 : x1 -> enters 1st pdf if ()_+ or delta distributions are present
  //                  2 - 0 : x2 -> enters 2nd pdf if ()_+ or delta distributions are present
  //                  0 - 1 : z1 -> collinear emission from a
  //                  1 - 1 : x1 / z1 -> enters 1st pdf for regular and ()_+ distributions
  //                  2 - 1 : empty - could be filled with (x1 / z1) * x2
  //                  0 - 2 : z2 -> collinear emission from b
  //                  1 - 2 : empty - could be filled with (x2 / z2) * x1
  //                  2 - 2 : x2 / z2 -> enters 1st pdf for regular and ()_+ distributions
  // should maybe replace psi->x_pdf, z_coll, and xz_coll_pdf later...

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
