#include "header.hpp"

void phasespace_set::calculate_initial_tau_IS_x1x2_IS(){
  Logger logger("phasespace_set::calculate_initial_tau_IS_x1x2_IS");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  random_MC_tau = rng.access_random_number(n_random_MC_tau);
  random_tau = rng.access_random_number(n_random_tau);

  //  for (int i = 0; i < random_MC_tau.size(); i++){logger << LOG_DEBUG_VERBOSE << "random_MC_tau[" << i << "] = " << setprecision(15) << random_MC_tau[i] << endline_flush;}
  //  for (int i = 0; i < random_tau.size(); i++){logger << LOG_DEBUG_VERBOSE << "random_tau[" << i << "] = " << random_tau[i] << endline_flush;}

  // speed-up by using intervals in general ???
  for (int j = 0; j < MC_tau.beta.size(); j++){if (random_MC_tau[0] <= MC_tau.beta[j]){MC_tau.channel = j; break;}}
  //  logger << LOG_DEBUG_VERBOSE << "MC_tau.channel = " << MC_tau.channel << endline_flush;
  if (MC_tau.channel == 0){
    for (int j = 0; j < IS_tau.beta.size(); j++){if (random_tau[0] <= IS_tau.beta[j]){IS_tau.channel = j; break;}}
    double random_IS_tau = (double(IS_tau.channel) + random_tau[1]) / double(IS_tau.beta.size());
    x_pdf[0] = h_propto_pot(random_IS_tau, tau_0, exp_pdf);
  }
  else {
    x_pdf[0] = c_propagator_Breit_Wigner(random_tau[0], abs(tau_MC_map[MC_tau.channel]), tau_0_s_had, s_had) / s_had;
    //    logger << LOG_DEBUG_VERBOSE << setw(20) << "x_pdf[0]" << " = " << setprecision(20) << setw(28) << x_pdf[0] << "   " << double2hexastr(x_pdf[0]) << endline_flush;
    //    logger << LOG_DEBUG_VERBOSE << setw(20) << "s_had" << " = " << setprecision(20) << setw(28) << s_had << "   " << setw(20) << "tau_0_s_had" << " = " << setprecision(20) << setw(28) << tau_0_s_had << "   " << setw(20) << "tau_0" << " = " << setprecision(20) << setw(28) << tau_0 << "   " << endline_flush;
    //    for (int j = 0; j < tau_MC_tau_gamma[0].size(); j++){logger << LOG_DEBUG_VERBOSE << "tau_MC_tau_gamma[0][" << j << "]" << " = " << setprecision(20) << setw(28) << tau_MC_tau_gamma[0][j] << "   " << double2hexastr(tau_MC_tau_gamma[0][j]) << endline_flush;}

    for (int j = 0; j < tau_MC_tau_gamma[0].size(); j++){
      if (x_pdf[0] <= tau_MC_tau_gamma[0][j]){IS_tau.channel = j; break;}
    }
    //    logger << LOG_DEBUG_VERBOSE << "IS_tau.channel = " << IS_tau.channel << endline_flush;
  }
  //  logger << LOG_DEBUG_VERBOSE << "x_pdf[0] = " << x_pdf[0] << endline_flush;

  double tau_s_had = x_pdf[0] * s_had;
  for (int j = 0; j < MC_tau.g_channel.size(); j++){
    if (j == 0){
      MC_tau.g_channel[j] = g_propto_pot(x_pdf[0], tau_0, exp_pdf) * (IS_tau.alpha[IS_tau.channel] * IS_tau.alpha.size());
    }
    else {
      if (tau_MC_map[j] < 0){MC_tau.g_channel[j] = s_had * g_propagator_Breit_Wigner(tau_s_had, -tau_MC_map[j], tau_0_s_had, s_had);}
    }
  }
  g_tau = 0.;
  for (int i = 0; i < MC_tau.g_channel.size(); i++){g_tau += MC_tau.alpha[i] * MC_tau.g_channel[i];}

  //  for (int i = 0; i < MC_tau.g_channel.size(); i++){logger << LOG_DEBUG_VERBOSE << setw(20) << "MC_tau.alpha[" << i << "]" << " = " << setprecision(20) << setw(28) << MC_tau.alpha[i] << "   " << double2hexastr(MC_tau.alpha[i]) << endline_flush;}
  //  logger << LOG_DEBUG_VERBOSE << "IS_tau.channel = " << IS_tau.channel << endline_flush;
  //  logger << LOG_DEBUG_VERBOSE << setw(20) << "IS_tau.alpha[" << IS_tau.channel << "]" << " = " << setprecision(20) << setw(28) << IS_tau.alpha[IS_tau.channel] << "   " << double2hexastr(IS_tau.alpha[IS_tau.channel]) << endline_flush;
  //  for (int i = 0; i < MC_tau.g_channel.size(); i++){logger << LOG_DEBUG_VERBOSE << setw(20) << "MC_tau.g_channel[" << i << "]" << " = " << setprecision(20) << setw(28) << MC_tau.g_channel[i] << "   " << double2hexastr(MC_tau.g_channel[i]) << endline_flush;}
  //  logger << LOG_DEBUG_VERBOSE << setw(20) << "g_tau" << " = " << setprecision(20) << setw(28) << g_tau << "   " << double2hexastr(g_tau) << endline_flush;

  random_x12 = rng.access_random_number(n_random_x12);

  for (int j = 0; j < IS_x1x2.beta.size(); j++){if (random_x12[0] <= IS_x1x2.beta[j]){IS_x1x2.channel = j; break;}}
  double random_x1x2 = (double(IS_x1x2.channel) + random_x12[1]) / double(IS_x1x2.beta.size());
  double min_x_pdf_1 = GSL_MAX_DBL(x_pdf[0], 1.e-7);
  x_pdf[1] = exp(random_x1x2 * log(min_x_pdf_1));
  x_pdf[2] = x_pdf[0] / x_pdf[1];
  g_x1x2 = 1. / (-log(min_x_pdf_1)) * (IS_x1x2.alpha[IS_x1x2.channel] * IS_x1x2.alpha.size());

  //  logger << LOG_DEBUG_VERBOSE << setw(20) << "g_x1x2" << " = " << setprecision(20) << setw(28) << g_x1x2 << "   " << double2hexastr(g_x1x2) << endline_flush;

  double sqrttau = sqrt(x_pdf[0]);
  xbp_all[0][1] = fourvector(sqrttau * E, 0., 0., sqrttau * E);
  xbp_all[0][2] = fourvector(sqrttau * E, 0., 0., -sqrttau * E);
  xbp_all[0][0] = xbp_all[0][1] + xbp_all[0][2];
  xbs_all[0][0] = 4. * x_pdf[0] * pow(E, 2);
  xbsqrts_all[0][0] = sqrt(xbs_all[0][0]);
  xbp_all[0][xb_max - 4] = xbp_all[0][0];
  xbs_all[0][xb_max - 4] = xbs_all[0][0];
  xbsqrts_all[0][xb_max - 4] = xbsqrts_all[0][0];

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void phasespace_set::calculate_initial_tau_IS_x1x2(){
  Logger logger("phasespace_set::calculate_initial_tau_IS_x1x2");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  random_MC_tau = rng.access_random_number(n_random_MC_tau);
  random_tau = rng.access_random_number(n_random_tau);

  for (int j = 0; j < MC_tau.beta.size(); j++){if (random_MC_tau[0] <= MC_tau.beta[j]){MC_tau.channel = j; break;}}
  if (MC_tau.channel == 0){
    for (int j = 0; j < IS_tau.beta.size(); j++){if (random_tau[0] <= IS_tau.beta[j]){IS_tau.channel = j; break;}}
    double random_IS_tau = (double(IS_tau.channel) + random_tau[1]) / double(IS_tau.beta.size());
    x_pdf[0] = h_propto_pot(random_IS_tau, tau_0, exp_pdf);
  }
  else {
    x_pdf[0] = c_propagator_Breit_Wigner(random_tau[0], abs(tau_MC_map[MC_tau.channel]), tau_0_s_had, s_had) / s_had;
    for (int j = 0; j < tau_MC_tau_gamma[0].size(); j++){
      if (x_pdf[0] <= tau_MC_tau_gamma[0][j]){
	IS_tau.channel = j;
	break;
      }
    }
  }
  double tau_s_had = x_pdf[0] * s_had;
  for (int j = 0; j < MC_tau.g_channel.size(); j++){
    if (j == 0){
      MC_tau.g_channel[j] = g_propto_pot(x_pdf[0], tau_0, exp_pdf) * (IS_tau.alpha[IS_tau.channel] * IS_tau.alpha.size());
    }
    else {
      if (tau_MC_map[j] < 0){MC_tau.g_channel[j] = s_had * g_propagator_Breit_Wigner(tau_s_had, -tau_MC_map[j], tau_0_s_had, s_had);}
    }
  }
  g_tau = 0.;
  for (int i = 0; i < MC_tau.g_channel.size(); i++){g_tau += MC_tau.alpha[i] * MC_tau.g_channel[i];}

  random_x12 = rng.access_random_number(n_random_x12);

  x_pdf[1] = exp(random_x12[0] * log(x_pdf[0]));
  x_pdf[2] = x_pdf[0] / x_pdf[1];
  g_x1x2 = 1. / (-log(x_pdf[0]));

  double sqrttau = sqrt(x_pdf[0]);
  xbp_all[0][1] = fourvector(sqrttau * E, 0., 0., sqrttau * E);
  xbp_all[0][2] = fourvector(sqrttau * E, 0., 0., -sqrttau * E);
  xbp_all[0][0] = xbp_all[0][1] + xbp_all[0][2];
  xbs_all[0][0] = 4. * x_pdf[0] * pow(E, 2);
  xbsqrts_all[0][0] = sqrt(xbs_all[0][0]);
  xbp_all[0][xb_max - 4] = xbp_all[0][0];
  xbs_all[0][xb_max - 4] = xbs_all[0][0];
  xbsqrts_all[0][xb_max - 4] = xbsqrts_all[0][0];

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void phasespace_set::calculate_initial_tau_x1x2_IS(){
  Logger logger("phasespace_set::calculate_initial_tau_x1x2_IS");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // adapt to switch off tau IS mapping !!!
  random_MC_tau = rng.access_random_number(n_random_MC_tau);
  random_tau = rng.access_random_number(n_random_tau);

  for (int j = 0; j < MC_tau.beta.size(); j++){if (random_MC_tau[0] <= MC_tau.beta[j]){MC_tau.channel = j; break;}}
  if (MC_tau.channel == 0){
    x_pdf[0] = h_propto_pot(random_tau[0], tau_0, exp_pdf);
  }
  else {
    x_pdf[0] = c_propagator_Breit_Wigner(random_tau[0], abs(tau_MC_map[MC_tau.channel]), tau_0_s_had, s_had) / s_had;
  }
  double tau_s_had = x_pdf[0] * s_had;
  for (int j = 0; j < MC_tau.g_channel.size(); j++){
    if (j == 0){
      MC_tau.g_channel[j] = g_propto_pot(x_pdf[0], tau_0, exp_pdf);
    }
    else {
      if (tau_MC_map[j] < 0){MC_tau.g_channel[j] = s_had * g_propagator_Breit_Wigner(tau_s_had, -tau_MC_map[j], tau_0_s_had, s_had);}
    }
  }
  g_tau = 0.;
  for (int i = 0; i < MC_tau.g_channel.size(); i++){g_tau += MC_tau.alpha[i] * MC_tau.g_channel[i];}

  random_x12 = rng.access_random_number(n_random_x12);

  for (int j = 0; j < IS_x1x2.beta.size(); j++){if (random_x12[0] <= IS_x1x2.beta[j]){IS_x1x2.channel = j; break;}}
  double random_x1x2 = (double(IS_x1x2.channel) + random_x12[1]) / double(IS_x1x2.beta.size());
  x_pdf[1] = exp(random_x1x2 * log(x_pdf[0]));
  x_pdf[2] = x_pdf[0] / x_pdf[1];
  g_x1x2 = 1. / (-log(x_pdf[0])) * (IS_x1x2.alpha[IS_x1x2.channel] * IS_x1x2.alpha.size());

  double sqrttau = sqrt(x_pdf[0]);
  xbp_all[0][1] = fourvector(sqrttau * E, 0., 0., sqrttau * E);
  xbp_all[0][2] = fourvector(sqrttau * E, 0., 0., -sqrttau * E);
  xbp_all[0][0] = xbp_all[0][1] + xbp_all[0][2];
  xbs_all[0][0] = 4. * x_pdf[0] * pow(E, 2);
  xbsqrts_all[0][0] = sqrt(xbs_all[0][0]);
  xbp_all[0][xb_max - 4] = xbp_all[0][0];
  xbs_all[0][xb_max - 4] = xbs_all[0][0];
  xbsqrts_all[0][xb_max - 4] = xbsqrts_all[0][0];

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void phasespace_set::calculate_initial_tau_x1x2(){
  Logger logger("phasespace_set::calculate_initial_tau_x1x2");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  random_MC_tau = rng.access_random_number(n_random_MC_tau);
  random_tau = rng.access_random_number(n_random_tau);

  for (int j = 0; j < MC_tau.beta.size(); j++){if (random_MC_tau[0] <= MC_tau.beta[j]){MC_tau.channel = j; break;}}
  if (MC_tau.channel == 0){x_pdf[0] = h_propto_pot(random_tau[0], tau_0, exp_pdf);}
  else {x_pdf[0] = c_propagator_Breit_Wigner(random_tau[0], abs(tau_MC_map[MC_tau.channel]), tau_0_s_had, s_had) / s_had;}
  double tau_s_had = x_pdf[0] * s_had;
  for (int j = 0; j < MC_tau.g_channel.size(); j++){
    if (j == 0){MC_tau.g_channel[j] = g_propto_pot(x_pdf[0], tau_0, exp_pdf);}
    else {if (tau_MC_map[j] < 0){MC_tau.g_channel[j] = s_had * g_propagator_Breit_Wigner(tau_s_had, -tau_MC_map[j], tau_0_s_had, s_had);}}
  }
  g_tau = 0.;
  for (int i = 0; i < MC_tau.g_channel.size(); i++){g_tau += MC_tau.alpha[i] * MC_tau.g_channel[i];}

  random_x12 = rng.access_random_number(n_random_x12);

  x_pdf[1] = exp(random_x12[0] * log(x_pdf[0]));
  x_pdf[2] = x_pdf[0] / x_pdf[1];
  g_x1x2 = 1. / (-log(x_pdf[0]));

  double sqrttau = sqrt(x_pdf[0]);
  xbp_all[0][1] = fourvector(sqrttau * E, 0., 0., sqrttau * E);
  xbp_all[0][2] = fourvector(sqrttau * E, 0., 0., -sqrttau * E);
  xbp_all[0][0] = xbp_all[0][1] + xbp_all[0][2];
  xbs_all[0][0] = 4. * x_pdf[0] * pow(E, 2);
  xbsqrts_all[0][0] = sqrt(xbs_all[0][0]);
  xbp_all[0][xb_max - 4] = xbp_all[0][0];
  xbs_all[0][xb_max - 4] = xbs_all[0][0];
  xbsqrts_all[0][xb_max - 4] = xbsqrts_all[0][0];

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void phasespace_set::calculate_initial_tau_fixed_x1x2_IS(){
  Logger logger("phasespace_set::calculate_initial_tau_fixed_x1x2_IS");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  x_pdf[0] = start_xbs_all[0][xb_max - 4] / s_had;
  g_tau = s_had;

  random_x12 = rng.access_random_number(n_random_x12);

  for (int j = 0; j < IS_x1x2.beta.size(); j++){if (random_x12[0] <= IS_x1x2.beta[j]){IS_x1x2.channel = j; break;}}
  double random_x1x2 = (double(IS_x1x2.channel) + random_x12[1]) / double(IS_x1x2.beta.size());
  x_pdf[1] = exp(random_x1x2 * log(x_pdf[0]));
  x_pdf[2] = x_pdf[0] / x_pdf[1];
  g_x1x2 = 1. / (-log(x_pdf[0])) * (IS_x1x2.alpha[IS_x1x2.channel] * IS_x1x2.alpha.size());

  double sqrttau = sqrt(x_pdf[0]);
  xbp_all[0][1] = fourvector(sqrttau * E, 0., 0., sqrttau * E);
  xbp_all[0][2] = fourvector(sqrttau * E, 0., 0., -sqrttau * E);
  xbp_all[0][0] = xbp_all[0][1] + xbp_all[0][2];
  xbs_all[0][0] = 4. * x_pdf[0] * pow(E, 2);
  xbsqrts_all[0][0] = sqrt(xbs_all[0][0]);
  xbp_all[0][xb_max - 4] = xbp_all[0][0];
  xbs_all[0][xb_max - 4] = xbs_all[0][0];
  xbsqrts_all[0][xb_max - 4] = xbsqrts_all[0][0];

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void phasespace_set::calculate_initial_tau_fixed_x1x2(){
  Logger logger("phasespace_set::calculate_initial_tau_fixed_x1x2");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  x_pdf[0] = start_xbs_all[0][xb_max - 4] / s_had;
  g_tau = s_had;

  random_x12 = rng.access_random_number(n_random_x12);

  x_pdf[1] = exp(random_x12[0] * log(x_pdf[0]));
  x_pdf[2] = x_pdf[0] / x_pdf[1];
  g_x1x2 = 1. / (-log(x_pdf[0]));

  double sqrttau = sqrt(x_pdf[0]);
  xbp_all[0][1] = fourvector(sqrttau * E, 0., 0., sqrttau * E);
  xbp_all[0][2] = fourvector(sqrttau * E, 0., 0., -sqrttau * E);
  xbp_all[0][0] = xbp_all[0][1] + xbp_all[0][2];
  xbs_all[0][0] = 4. * x_pdf[0] * pow(E, 2);
  xbsqrts_all[0][0] = sqrt(xbs_all[0][0]);
  xbp_all[0][xb_max - 4] = xbp_all[0][0];
  xbs_all[0][xb_max - 4] = xbs_all[0][0];
  xbsqrts_all[0][xb_max - 4] = xbsqrts_all[0][0];

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void phasespace_set::calculate_initial_collinear_z1z2_IS(){
  Logger logger("phasespace_set::calculate_initial_collinear_z1z2_IS");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int i_z = 1; i_z < 3; i_z++){
    vector<double> z_z1z2(2);
    z_z1z2 = rng.access_random_number(n_random_z);

    for (int j = 0; j < IS_z1z2[i_z].beta.size(); j++){
      if (z_z1z2[0] <= IS_z1z2[i_z].beta[j]){IS_z1z2[i_z].channel = j; break;}
    }
    double random_z1z2 = (double(IS_z1z2[i_z].channel) + z_z1z2[1]) / double(IS_z1z2[i_z].beta.size());
    z_coll[i_z] = exp(random_z1z2 * log(x_pdf[i_z]));
    g_z_coll[i_z] = 1. / (-log(x_pdf[i_z])) * (IS_z1z2[i_z].alpha[IS_z1z2[i_z].channel] * IS_z1z2[i_z].alpha.size());
  }

  set_xz_coll_pdf();
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
