#include "header.hpp"

randomvariable::randomvariable(){
  static Logger logger("randomvariable::randomvariable()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  manager = NULL;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


randomvariable::randomvariable(importancesampling_input input, string name, randommanager * _manager){
  static Logger logger("randomvariable::randomvariable (input)");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  manager = _manager;

  logger << LOG_DEBUG << input << endline_flush;

  input.name = name;
  logger << LOG_DEBUG_VERBOSE << "name = " << name << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "input.name = " << input.name << endline_flush;
  //  logger << LOG_DEBUG_VERBOSE << "manager->psi->filename_IS_MCweight = " << manager->psi->filename_IS_MCweight << endline_flush;
  //  logger << LOG_DEBUG_VERBOSE << "manager->psi->filename_IS_MCweight_in_contribution = " << manager->psi->filename_IS_MCweight_in_contribution << endline_flush;
  IS_PS = importancesampling_set(input, manager->psi->filename_weight_writeout, manager->psi->filename_weight_readin);
  //  IS_PS = importancesampling_set(input, manager->psi->filename_IS_MCweight, manager->psi->filename_IS_MCweight_in_contribution);
  logger << LOG_DEBUG_VERBOSE << "name = " << name << endline_flush;

  // complicated way to re-determine counter of randomvariable !!!
  string number_s;
  for (int i_s = 2; i_s < name.size(); i_s++){
    if (name[i_s] == '_'){break;}
    else {number_s.push_back(name[i_s]);}
  }
  number = atoi(number_s.c_str());
  logger << LOG_DEBUG << name << "   " << number_s << "   " << number << endline_flush;

  IS_PS.channel = 0;

  if (IS_PS.n_gridsize == 1){imp_sampling = false;}
  else {imp_sampling = true;}

  used = false;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::psp_IS_optimization(double & psp_weight, double & psp_weight2) {
  static Logger logger("randomvariable::psp_IS_optimization");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (!imp_sampling){return;}
  if (!used){return;}

  IS_PS.psp_IS_optimization(psp_weight, psp_weight2);

  used = false;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::step_IS_optimization(int i_step_mode, bool enforce_step, int i_step){
  static Logger logger("randomvariable::step_IS_optimization");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  IS_PS.step_IS_optimization(i_step_mode, enforce_step, i_step);
  // Why is  result_IS_optimization  called here already ???
  result_IS_optimization(i_step_mode, enforce_step, i_step);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::result_IS_optimization(int i_step_mode, bool enforce_step, int i_step) {
  static Logger logger("randomvariable::result_IS_optimization");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  IS_PS.result_IS_optimization(i_step_mode, enforce_step, i_step);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


double randomvariable::get_random(){
  static Logger logger("randomvariable::get_random()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  double x_random;
  // Problem in used variable ???
  /*
  if (used && !end_optimization) {
    logger << LOG_FATAL << "randomvariable::get_random  (" << name << " used && !end_optimization) should never be called with used == true !" << endline_flush;
    exit(1);
  }
  */


  if (imp_sampling) {
    logger << LOG_DEBUG_VERBOSE << IS_PS.name << "   called: used = true." << endline_flush;
    used = true;
    logger << LOG_DEBUG_VERBOSE << "manager = " << manager << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "manager->psi = " << manager->psi << endline_flush;
									//    logger << LOG_DEBUG_VERBOSE << "manager->psi->rng = " << manager->psi->rng << endline_flush;
    double random = manager->psi->rng.access_random_number();
    double random_channel = manager->psi->rng.access_random_number();
    logger << LOG_DEBUG_VERBOSE << IS_PS.name << "   called: used = true." << endline_flush;


    // new implementation:
    IS_PS.channel = 0;
    if (IS_PS.is_gridsize_power_of_two){
      //    if (IS_PS.n_gridsize == 64){
      for (int i_b = IS_PS.n_gridsize / 2; i_b > 0; i_b /= 2){
	if (random_channel > IS_PS.beta[IS_PS.channel + i_b - 1]){IS_PS.channel += i_b;}
      }
    }
    else {
      int extra = 0;
      for (int i_b = IS_PS.n_gridsize / 2; i_b > 0; i_b /= 2){
	if (random_channel > IS_PS.beta[IS_PS.channel + i_b - 1]){IS_PS.channel += i_b;}
	if (i_b == 3){
	  for (int j_b = 0; j_b < 3 + extra; j_b++){
	    if (random_channel <= IS_PS.beta[IS_PS.channel + j_b]){
	      IS_PS.channel += j_b;
	      i_b = 0;
	      break;
	    }
	  }
	}
	if (i_b % 2){extra++;}
      }
    }

    // 'x' replaces the flatly generated random number:
    //  x = (double(IS_PS.channel) + random) / double(IS_PS.beta.size());
    x_random = (double(IS_PS.channel) + random) / IS_PS.n_gridsize;

    if (manager->psi->switch_IS_mode_phasespace == 1 || manager->psi->switch_IS_mode_phasespace == 3){
      //      g_IS = IS_PS.alpha[IS_PS.channel] * IS_PS.n_gridsize;
      manager->psi->MC_g_IS_global *= IS_PS.alpha[IS_PS.channel] * IS_PS.n_gridsize;
    }
  }
  else {x_random = manager->psi->rng.access_random_number();}

  if (!IS_PS.end_optimization){
    // It tells manager that this variable has been used at this phase-space point (can be used later)
    if (manager != NULL){manager->add_var_to_queue(this);}
  }

  // Can be removed later:
  //  g_IS = 1.0;
  return x_random;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


// Could also be directly accessed, without the detour via void randomvariable::get_random(double &x, double &g_IS) !!!

void randomvariable::get_g_IS(double r, double & g_IS) {
  static Logger logger("randomvariable::get_g_IS");
  //  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (r < 0. || r > 1. || munich_isnan(r)){g_IS = sqrt(-1.);}
  else {
    int temp_channel = (int)(r * IS_PS.n_gridsize);
    g_IS = IS_PS.alpha[temp_channel] * IS_PS.n_gridsize;
  }

  //  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::save_weights(ofstream & out_weights){
  static Logger logger("randomvariable::save_weights");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  out_weights << "variable " << setw(50) << IS_PS.name << endline;
  // Why such low precision ???
  for (int i_b = 0; i_b < IS_PS.n_gridsize; i_b++){out_weights << setprecision(8) << IS_PS.alpha[i_b] << endline;}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::readin_weights(vector<string> & readin) {
  static Logger logger("randomvariable::readin_weights");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (IS_PS.switch_optimization != 2 && IS_PS.switch_optimization != 3){return;}

  // check if correct !!!
  // find the correct section in the weights file
  int proc;
  for (proc=0; proc<readin.size(); proc++) {
    size_t pos=readin[proc].find("variable ");
    if (pos != string::npos) {
      pos += 9;
      string var_name=readin[proc].substr(pos,string::npos);
      int start_index = 0;
      for (int i = 0; i < var_name.size(); i++){
        if (var_name[i] != ' '){start_index = i; break;}
      }
      var_name=var_name.substr(start_index, var_name.size() - start_index);
      if (var_name == IS_PS.name) {
        logger << LOG_DEBUG << "weights found for " << var_name << endline_flush;
	//        logger << LOG_DEBUG_VERBOSE << "weights found for " << var_name << endline_flush;
        break;
      }
    }
  }

  if (proc == readin.size()){logger << LOG_FATAL << "could not read in weights for " << IS_PS.name << endline_flush; exit(1);}

  logger << LOG_DEBUG_VERBOSE << "reading weights for " << readin[proc] << endline_flush;
  proc++;

  for (int i_b = 0; i_b < IS_PS.n_gridsize; i_b++){
    IS_PS.alpha[i_b] = atof(readin[proc].c_str());
    proc++;
  }

  IS_PS.beta[0] = IS_PS.alpha[0];
  for (int i_b = 1; i_b < IS_PS.n_gridsize; i_b++){IS_PS.beta[i_b] = IS_PS.beta[i_b - 1] + IS_PS.alpha[i_b];}

  // Check for issues in read-in weights:
  if (fabs(IS_PS.beta[IS_PS.n_gridsize - 1] - 1) > 1e-6){
    for (int i_b = 0; i_b < IS_PS.n_gridsize; i_b++){
      logger << LOG_ERROR << "alpha[" << setw(4) << i_b << "] = " << IS_PS.alpha[i_b] << "   beta[" << setw(4) << i_b << "] = " << IS_PS.beta[i_b] << endline;
    }
    logger << LOG_FATAL << setw(50) << IS_PS.name << ": something went wrong in weight read-in, aborting.." << endline_flush; exit(1);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::proceeding_out(ofstream &out_proceeding) {
  static Logger logger("randomvariable::proceeding_out");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  IS_PS.proceeding_out(out_proceeding);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::proceeding_in(int & proc, vector<string> &readin) {
  static Logger logger("randomvariable::proceeding_in");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  IS_PS.proceeding_in(proc, readin);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::check_proceeding_in(int & int_end, int & temp_check_size, vector<string> & readin){
  static Logger logger("randomvariable::check_proceeding_in");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // new implementation:
  // check if usage of 'int_end' makes sense here !!!

  logger << LOG_DEBUG << "# " << IS_PS.name << "   temp_check_size (before) = " << temp_check_size << endline_flush;

  IS_PS.end_optimization = atoi(readin[temp_check_size].c_str());
  temp_check_size += 1;
  logger << LOG_DEBUG << "end_optimization = " << IS_PS.end_optimization << endline_flush;

  if (temp_check_size > readin.size()){
    int_end = 2;
    logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endline_flush;
    return;
  }
  else {
    logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endline_flush;
  }

  if (IS_PS.end_optimization != -1){
    //  Should be removed accordingly !!!
    //  s(3)
    ///    temp_check_size += 3;

    if (temp_check_size > readin.size()){
      int_end = 2;
      logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endline_flush;
      return;
    }
    else {
      logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endline_flush;
    }

    temp_check_size += IS_PS.n_gridsize;
    //  alpha(IS_PS.n_gridsize)
    if (temp_check_size > readin.size()){
      int_end = 2;
      logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endline_flush;
      return;
    }
    else {
      logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endline_flush;
    }
  }

  if (IS_PS.end_optimization == 0){
    temp_check_size += 2 + 4 * IS_PS.n_gridsize;
    //    temp_check_size += 3 * IS_PS.n_gridsize;
    if (temp_check_size > readin.size()){
      int_end = 2;
      logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endline_flush;
      return;
    }
    else {
      logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endline_flush;
    }

    if (IS_PS.switch_validation_optimization){
      temp_check_size += 2 + IS_PS.n_optimization_step + IS_PS.n_optimization_step * IS_PS.n_gridsize;
      if (temp_check_size > readin.size()){
	int_end = 2;
	logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endline_flush;
	return;
      }
      else {
	logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endline_flush;
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::proceeding_group_by_type_out(ofstream & out_proceeding){
  static Logger logger("randomvariable::proceeding_out");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  IS_PS.proceeding_group_by_type_out(out_proceeding);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void randomvariable::proceeding_group_by_type_in(int & proc, vector<string> & readin, bool switch_combination) {
  static Logger logger("randomvariable::proceeding_in");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  IS_PS.proceeding_group_by_type_in(proc, readin, switch_combination);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


ostream & operator << (ostream & s, const randomvariable & IS){
  s << IS.IS_PS;
  return s;
}

