#include "header.hpp"

void summary_generic::determine_format(int i_d, int i_o, vector<string> & selection_format_plot, vector<string> & selection_name_plot){
  Logger logger("summary_generic::determine_format");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  vector<string> format_plot;
  vector<string> name_plot;

  string temp_sdd = osi->extended_distribution[i_d].xdistribution_name + ".." + yorder[i_o]->resultdirectory;

  format_plot.push_back("plot");
  name_plot.push_back(temp_sdd + ".dat");

  format_plot.push_back("norm");
  name_plot.push_back(temp_sdd + ".dat");

  if (i_d >= osi->dat.size()){
    int i_ddd = i_d - osi->dat.size();

    // recombined distributions (essentially for validation)
    stringstream name_rec;
    name_rec << osi->dddat[i_ddd].distribution_2.xdistribution_name << ".from." << osi->dddat[i_ddd].name << ".." << yorder[i_o]->resultdirectory;

    format_plot.push_back("plot.rec");
    name_plot.push_back(name_rec.str() + ".dat");

    format_plot.push_back("norm.rec");
    name_plot.push_back(name_rec.str() + ".dat");

    for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
      stringstream name_split_bin;
      name_split_bin << "_" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << "-" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
      stringstream name_split_lt;
      name_split_lt << "_lt" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
      stringstream name_split_ge;
      name_split_ge << "_ge" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];

      format_plot.push_back("norm.norm.split");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("norm.plot.split");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.norm.split");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.plot.split");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


      format_plot.push_back("norm.norm.split_in_first");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("norm.plot.split_in_first");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.norm.split_in_first");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.plot.split_in_first");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


      format_plot.push_back("norm.two");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("norm.two");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.two");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.two");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


      format_plot.push_back("norm.ge_lt_in_first");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("norm.ge_lt_in_first");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.ge_lt_in_first");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.ge_lt_in_first");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
    }
    for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
      stringstream name_split_bin;
      name_split_bin << "_" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << "-" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
      stringstream name_split_lt;
      name_split_lt << "_lt" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
      stringstream name_split_ge;
      name_split_ge << "_ge" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];

      format_plot.push_back("norm.norm.split");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("norm.plot.split");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.norm.split");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.plot.split");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


      format_plot.push_back("norm.norm.split_in_second");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("norm.plot.split_in_second");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.norm.split_in_second");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.plot.split_in_second");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


      format_plot.push_back("norm.two");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("norm.two");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.two");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.two");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


      format_plot.push_back("norm.ge_lt_in_second");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("norm.ge_lt_in_second");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.ge_lt_in_second");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

      format_plot.push_back("plot.ge_lt_in_second");
      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
    }
  }

  int n_max_output_version = name_plot.size();
  logger << LOG_DEBUG << "n_max_output_version = " << n_max_output_version << endline_flush;

  //  vector<string> selection_format_plot;
  //  vector<string> selection_name_plot;

  for (size_t i_x = 0; i_x < format_plot.size(); i_x++){
    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
      if (format_plot[i_x] == output_distribution_format[i_d][i_f]){
	if      (format_plot[i_x] == "plot.plot.split_in_first" || format_plot[i_x] == "plot.plot.split_in_second"){selection_format_plot.push_back("plot.plot.split");}
	else if (format_plot[i_x] == "plot.norm.split_in_first" || format_plot[i_x] == "plot.norm.split_in_second"){selection_format_plot.push_back("plot.norm.split");}
	else if (format_plot[i_x] == "norm.plot.split_in_first" || format_plot[i_x] == "norm.plot.split_in_second"){selection_format_plot.push_back("norm.plot.split");}
	else if (format_plot[i_x] == "norm.norm.split_in_first" || format_plot[i_x] == "norm.norm.split_in_second"){selection_format_plot.push_back("norm.norm.split");}
	else if (format_plot[i_x] == "plot.ge_lt_in_first" || format_plot[i_x] == "plot.ge_lt_in_second"){selection_format_plot.push_back("plot.two");}
	else if (format_plot[i_x] == "norm.ge_lt_in_first" || format_plot[i_x] == "norm.ge_lt_in_second"){selection_format_plot.push_back("norm.two");}
	else {selection_format_plot.push_back(format_plot[i_x]);}
	selection_name_plot.push_back(name_plot[i_x]);
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_generic::determine_process_combination(){
  Logger logger("summary_generic::determine_process_combination");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  vector<string> subgroup;
  //  int plotmode = 0;

  logger << LOG_DEBUG << "final_resultdirectory = " << final_resultdirectory << endline_flush;

  readin_infile_process_combination();

  logger << LOG_DEBUG_VERBOSE << "osi->value_qTcut_distribution.size() = " << osi->value_qTcut_distribution.size() << endline_flush;

  scaleband_variable.resize(outpath_processcombination.size(), vector<vector<vector<double> > > (osi->extended_distribution.size(), vector<vector<double> > ()));
  for (int i_sb = 0; i_sb < outpath_processcombination.size(); i_sb++){
    logger << LOG_INFO << "Determination of scaleband for " << outpath_processcombination[i_sb] << endline_flush;
    system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_processcombination[i_sb]);
    
    logger << LOG_DEBUG << "osi->value_qTcut_distribution.size() = " << osi->value_qTcut_distribution.size() << endline_flush;
    for (int x_q = 0; x_q < osi->value_qTcut_distribution.size() + 1; x_q++){
      string directory_qTcut;
      string in_directory_qTcut;
      string out_directory_qTcut;
      if (x_q == osi->value_qTcut_distribution.size()){
	directory_qTcut = "";
	in_directory_qTcut = "";
	out_directory_qTcut = "";
      }
      else {
	stringstream qTcut_ss;
	qTcut_ss << "qTcut-" << osi->value_qTcut_distribution[x_q];
	directory_qTcut = "/" + qTcut_ss.str();
	in_directory_qTcut = "";
	out_directory_qTcut = directory_qTcut;
      }

      if (x_q != osi->value_qTcut_distribution.size()){
	for (int j_sb = 0; j_sb < inpath_scalevariation[0].size(); j_sb++){
	  system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_processcombination[i_sb] + "/" + inpath_scalevariation[0][j_sb] + directory_qTcut);
	}
      }

      string infilename;
      char LineBuffer[1024];
      string s0;
      vector<string> vs0, vs1(1);
      logger << LOG_DEBUG << "osi->extended_distribution.size() = " << osi->extended_distribution.size() << endline_flush;
      for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	logger << LOG_INFO << "Determination of scaleband for " << outpath_processcombination[i_sb] << " : " << osi->extended_distribution[i_d].xdistribution_name << endline_flush;

	logger << LOG_DEBUG << "switch_output_distribution[" << i_d << "] = " << switch_output_distribution[i_d] << endline_flush;
	if (!switch_output_distribution[i_d]){continue;}
	logger << LOG_DEBUG << "osi->extended_distribution[" << i_d << "].xdistribution_name = " << osi->extended_distribution[i_d].xdistribution_name << endline_flush;

	for (int i_o = 0; i_o < yorder.size(); i_o++){
	  if (!yorder[i_o]->active_qTcut && x_q < osi->value_qTcut_distribution.size()){continue;}

	  /*
	  vector<string> format_plot;
	  vector<string> name_plot;

	  string temp_sdd = osi->extended_distribution[i_d].xdistribution_name + ".." + yorder[i_o]->resultdirectory;

	  format_plot.push_back("plot");
	  name_plot.push_back(temp_sdd + ".dat");

	  format_plot.push_back("norm");
	  name_plot.push_back(temp_sdd + ".dat");

	  if (i_d >= osi->dat.size()){
	    int i_ddd = i_d - osi->dat.size();

	    // recombined distributions (essentially for validation)
	    stringstream name_rec;
	    name_rec << osi->dddat[i_ddd].distribution_2.xdistribution_name << ".from." << osi->dddat[i_ddd].name << ".." << yorder[i_o]->resultdirectory;

	    format_plot.push_back("plot.rec");
	    name_plot.push_back(name_rec.str() + ".dat");

	    format_plot.push_back("norm.rec");
	    name_plot.push_back(name_rec.str() + ".dat");

	    for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	      stringstream name_split_bin;
	      name_split_bin << "_" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << "-" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	      stringstream name_split_lt;
	      name_split_lt << "_lt" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
	      stringstream name_split_ge;
	      name_split_ge << "_ge" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];

	      format_plot.push_back("norm.norm.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.plot.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.norm.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.plot.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.norm.split_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.plot.split_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.norm.split_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.plot.split_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.ge_lt_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.ge_lt_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.ge_lt_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.ge_lt_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
	    }
	    for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	      stringstream name_split_bin;
	      name_split_bin << "_" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << "-" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	      stringstream name_split_lt;
	      name_split_lt << "_lt" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
	      stringstream name_split_ge;
	      name_split_ge << "_ge" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];

	      format_plot.push_back("norm.norm.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.plot.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.norm.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.plot.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.norm.split_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.plot.split_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.norm.split_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.plot.split_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.ge_lt_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.ge_lt_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.ge_lt_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.ge_lt_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
	    }
	  }

	  int n_max_output_version = name_plot.size();
	  logger << LOG_DEBUG << "n_max_output_version = " << n_max_output_version << endline_flush;

	  vector<string> selection_format_plot;
	  vector<string> selection_name_plot;

	  for (size_t i_x = 0; i_x < format_plot.size(); i_x++){
	    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
	      if (format_plot[i_x] == output_distribution_format[i_d][i_f]){
		if      (format_plot[i_x] == "plot.plot.split_in_first" || format_plot[i_x] == "plot.plot.split_in_second"){selection_format_plot.push_back("plot.plot.split");}
		else if (format_plot[i_x] == "plot.norm.split_in_first" || format_plot[i_x] == "plot.norm.split_in_second"){selection_format_plot.push_back("plot.norm.split");}
		else if (format_plot[i_x] == "norm.plot.split_in_first" || format_plot[i_x] == "norm.plot.split_in_second"){selection_format_plot.push_back("norm.plot.split");}
		else if (format_plot[i_x] == "norm.norm.split_in_first" || format_plot[i_x] == "norm.norm.split_in_second"){selection_format_plot.push_back("norm.norm.split");}
		else if (format_plot[i_x] == "plot.ge_lt_in_first" || format_plot[i_x] == "plot.ge_lt_in_second"){selection_format_plot.push_back("plot.two");}
		else if (format_plot[i_x] == "norm.ge_lt_in_first" || format_plot[i_x] == "norm.ge_lt_in_second"){selection_format_plot.push_back("norm.two");}
		else {selection_format_plot.push_back(format_plot[i_x]);}
		selection_name_plot.push_back(name_plot[i_x]);
	      }
	    }
	  }
	  */
	  vector<string> selection_format_plot;
	  vector<string> selection_name_plot;
	  determine_format(i_d, i_o, selection_format_plot, selection_name_plot);


	  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
	    logger << LOG_INFO << "output_distribution_format[" << setw(3) << i_d << "][" << setw(3) << i_f << "] = " << setw(20) << output_distribution_format[i_d][i_f] << "   " << "selection_format_plot[" << setw(3) << i_f << "] = " << setw(20) << selection_format_plot[i_f] << "   " << "selection_name_plot[" << setw(3) << i_f << "] = " << setw(20) << selection_name_plot[i_f] << endline_flush;
	  }

	  stringstream temp;
	  temp << "Output selection: " << osi->extended_distribution[i_d].xdistribution_name  << " : ";
	  for (size_t i_x = 0; i_x < selection_format_plot.size(); i_x++){
	    temp << selection_format_plot[i_x] << "." << selection_name_plot[i_x] << endline;
	  }
	  logger << LOG_INFO << temp.str() << endline_flush;
	  int n_output_version = selection_format_plot.size();

	  scaleband_variable[i_sb][i_d].resize(n_output_version);

	  for (int i_x = 0; i_x < n_output_version; i_x++){
	    logger << LOG_INFO << "selection_format_plot[" << setw(3) << i_x << "] = " << setw(20) << selection_format_plot[i_x] << "   selection_name_plot[" << setw(3) << i_x << "] = " << setw(20) << selection_name_plot[i_x] << endline_flush;

	    int switch_exist = 0;

	    vector<double> variable;
	    vector<vector<vector<double> > > combination_result(inpath_scalevariation[i_sb].size());
	    vector<vector<vector<double> > > combination_deviation(inpath_scalevariation[i_sb].size());
	    vector<vector<vector<double> > > combination_deviation2(inpath_scalevariation[i_sb].size());
	    vector<vector<vector<vector<double> > > > process_result(inpath_processcombination[0].size(), vector<vector<vector<double> > > (inpath_scalevariation[i_sb].size()));
	    vector<vector<vector<vector<double> > > > process_deviation(inpath_processcombination[0].size(), vector<vector<vector<double> > > (inpath_scalevariation[i_sb].size()));
	    vector<vector<vector<vector<double> > > > process_deviation2(inpath_processcombination[0].size(), vector<vector<vector<double> > > (inpath_scalevariation[i_sb].size()));

	    for (int i_v = 0; i_v < inpath_scalevariation[i_sb].size(); i_v++){
	      for (int i_p = 0; i_p < inpath_processcombination[0].size(); i_p++){
		vector<string> readin;
		vector<vector<string> > readin2;
		//		infilename = final_resultdirectory + "/" + inpath_processcombination[0][i_p] + "/" + inpath_scalevariation[i_sb][i_v] + directory_qTcut + "/" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];
		infilename = inpath_processcombination[0][i_p] + "/" + inpath_scalevariation[i_sb][i_v] + directory_qTcut + "/" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];
		logger << LOG_DEBUG << "i_d = " << setw(2) << i_d << "   i_v = " << setw(2) << i_v << "   i_o = " << setw(2) << i_o << "   infilename = " << infilename << endline_flush;

		ifstream inf(infilename.c_str());
		readin = vs0;
		while (inf.getline(LineBuffer, 1024)){readin.push_back(LineBuffer);}
		if (readin.size() == 0){continue;}
		else {switch_exist = 1;}
		for (int i_b = 0; i_b < readin.size(); i_b++){
		  if (readin[i_b][0] == char(35)){}
		  else {
		    readin2.push_back(vs0);
		    int start = 0;
		    for (int j = 0; j < readin[i_b].size(); j++){
		      if (readin[i_b][j] != ' '){
			if (start == 0){start = 1; readin2[readin2.size() - 1].push_back(s0); readin2[readin2.size() - 1][readin2[readin2.size() - 1].size() - 1] = readin[i_b][j];}
			else {readin2[readin2.size() - 1][readin2[readin2.size() - 1].size() - 1] = readin2[readin2.size() - 1][readin2[readin2.size() - 1].size() - 1] + readin[i_b][j];}
		      }
		      else if ((readin[i_b][j] == ' ') && (start == 1)){start = 0;}
		    }
		  }
		  if (i_b == 0 || i_b == readin.size() - 1){logger << LOG_DEBUG_VERBOSE << "i_b = " << setw(2) << i_b << "   (" << readin.size() << " - " << readin2.size() << ")" << endline_flush;}
		}
		logger << LOG_DEBUG << "readin.size() = " << readin.size() << "   switch_exist = " << switch_exist << endline_flush;

		if (i_v == 0){variable.resize(readin2.size());}
		vector<vector<double> > data(readin2.size());
		vector<vector<double> > result(readin2.size());
		vector<vector<double> > deviation(readin2.size());
		vector<vector<double> > deviation2(readin2.size());
		for (int i_b = 0; i_b < readin2.size(); i_b++){
		  data[i_b].resize(readin2[i_b].size());
		  result[i_b].resize((readin2[i_b].size() - 1) / 2);
		  deviation[i_b].resize((readin2[i_b].size() - 1) / 2);
		  deviation2[i_b].resize((readin2[i_b].size() - 1) / 2);
		}

		for (int i_b = 0; i_b < readin2.size(); i_b++){
		  for (int j = 0; j < readin2[i_b].size(); j++){
		    data[i_b][j] = atof(readin2[i_b][j].c_str());
		  }
		}
		for (int i_b = 0; i_b < result.size(); i_b++){
		  if (i_v == 0){variable[i_b] = data[i_b][0];}
		  for (int j = 0; j < result[i_b].size(); j++){
		    result[i_b][j] = data[i_b][j * 2 + 1];
		    deviation[i_b][j] = data[i_b][j * 2 + 2];
		    deviation2[i_b][j] = pow(deviation[i_b][j], 2);
		  }
		}
		process_result[i_p][i_v] = result;
		process_deviation[i_p][i_v] = deviation;
		process_deviation2[i_p][i_v] = deviation2;
		logger << LOG_DEBUG << "i_d = " << setw(2) << i_d << "   i_v = " << setw(2) << i_v << "   i_o = " << setw(2) << i_o << "   infilename = " << infilename << "   " << readin.size() << " " << readin2.size() << endline_flush;
	      }
	    }

	    //	    logger << LOG_INFO << "switch_exist = " << switch_exist << endline_flush;
	    if (!switch_exist){continue;}

	    //	    logger << LOG_INFO << "combination_result.size() = " << combination_result.size() << endline_flush;
	    for (int i_v = 0; i_v < inpath_scalevariation[i_sb].size(); i_v++){
	      //	      logger << LOG_INFO << "inpath_scalevariation[" << i_sb << "].size() = " << inpath_scalevariation[i_sb].size() << endline_flush;
	      combination_result[i_v].resize(variable.size(), vector<double> (process_result[0][i_v][0].size(), 0.));
	      combination_deviation[i_v].resize(variable.size(), vector<double> (process_deviation[0][i_v][0].size(), 0.));
	      combination_deviation2[i_v].resize(variable.size(), vector<double> (process_deviation2[0][i_v][0].size(), 0.));
	      
	      //	      logger << LOG_INFO << "inpath_processcombination[0].size() = " << inpath_processcombination[0].size() << endline_flush;
	      //	      logger << LOG_INFO << "variable.size() = " << variable.size() << endline_flush;
	      //	      logger << LOG_INFO << "combination_result[" << i_v << "].size() = " << combination_result[i_v].size() << endline_flush;
	      for (int i_b = 0; i_b < variable.size(); i_b++){
		//		logger << LOG_INFO << "combination_result[" << i_v << "][" << i_b << "].size() = " << combination_result[i_v][i_b].size() << endline_flush;
		for (int i_s = 0; i_s < combination_result[i_v][i_b].size(); i_s++){
		  for (int i_p = 0; i_p < inpath_processcombination[0].size(); i_p++){
		    //		    logger << LOG_INFO << "process_result[" << setw(2) << i_p << "][" << setw(2) << i_v << "][" << setw(2) << i_b << "][" << setw(2) << i_s << "] = " << process_result[i_p][i_v][i_b][i_s] << endline_flush;
		    if (inpath_combination[0][i_p] == "+"){
		      combination_result[i_v][i_b][i_s] += process_result[i_p][i_v][i_b][i_s];
		      combination_deviation2[i_v][i_b][i_s] += process_deviation2[i_p][i_v][i_b][i_s];
		    }
		    else if (inpath_combination[0][i_p] == "-"){
		      combination_result[i_v][i_b][i_s] -= process_result[i_p][i_v][i_b][i_s];
		      combination_deviation2[i_v][i_b][i_s] += process_deviation2[i_p][i_v][i_b][i_s];
		    }
		    else if (inpath_combination[0][i_p] == "+x"){
		      combination_result[i_v][i_b][i_s] += process_result[i_p][i_v][i_b][i_s];
		    }
		    else if (inpath_combination[0][i_p] == "-x"){
		      combination_result[i_v][i_b][i_s] -= process_result[i_p][i_v][i_b][i_s];
		    }
		  }
		  combination_deviation[i_v][i_b][i_s] = sqrt(combination_deviation2[i_v][i_b][i_s]);
		  logger << LOG_INFO << "combination_result[" << setw(2) << i_v << "][" << setw(2) << i_b << "][" << setw(2) << i_s << "] = " << setw(15) << setprecision(8) <<combination_result[i_v][i_b][i_s] << " +- " << setw(15) << setprecision(8) << combination_deviation[i_v][i_b][i_s] << endline_flush;
		}
	      }
	      scaleband_variable[i_sb][i_d][i_x] = variable;

	      string combination_outfilename = final_resultdirectory + "/" + outpath_processcombination[0] + "/" + inpath_scalevariation[i_sb][i_v] + directory_qTcut + "/" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];
	      logger << LOG_INFO << "combination_outfilename = " << combination_outfilename << endline;
	      ofstream outf;
	      outf.open(combination_outfilename.c_str(), ofstream::out | ofstream::trunc);
	      for (int i_b = 0; i_b < variable.size(); i_b++){
		outf << setw(16) << setprecision(8) << variable[i_b];
		for (int i_s = 0; i_s < combination_result[i_v][i_b].size(); i_s++){
		  outf << setw(16) << setprecision(8) << combination_result[i_v][i_b][i_s] << "   " << setw(16) << setprecision(8) << combination_deviation[i_v][i_b][i_s];
		}
		outf << endline;
	      }
	      outf.close();
	    }
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


