#include "header.hpp"

#include "ppaa02.phasespace.set.hpp"

void ppaa02_phasespace_set::ax_psp_220_ddx_aaddx(int x_a){
  static Logger logger("ppaa02_phasespace_set::ax_psp_220_ddx_aaddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(15);
  needed_v_smin[x_a].resize(15);
  needed_v_smin[x_a][  0] = {   6,   11,   13,   18,   21,   25,   31,   38,    3}; //   9
  needed_v_smin[x_a][  1] = {   7,    9,   23,   26,   34,   36,    1,    4}; //   8
  needed_v_smin[x_a][  2] = {   8,   10,   14,   16,   20,   22,   28,   39,    0}; //   9
  needed_v_smin[x_a][  3] = {  10,   16}; //   2
  needed_v_smin[x_a][  4] = {  11,   31,    3,    6,   25}; //   5
  needed_v_smin[x_a][  5] = {  12,   19,   20,   24,   32,   33,   37,   39,    2}; //   9
  needed_v_smin[x_a][  6] = {  12,   32,   37}; //   3
  needed_v_smin[x_a][  7] = {  13,   18}; //   2
  needed_v_smin[x_a][  8] = {  14,   28,    0,    8,   22}; //   5
  needed_v_smin[x_a][  9] = {  15,   17,   21,   27,   29,   30,   35,   38,    5}; //   9
  needed_v_smin[x_a][ 10] = {  15,   29,   35}; //   3
  needed_v_smin[x_a][ 11] = {  17,   30,    5,   27}; //   4
  needed_v_smin[x_a][ 12] = {  19,   33,    2,   24}; //   4
  needed_v_smin[x_a][ 13] = {   1,    9,   23,   34}; //   4
  needed_v_smin[x_a][ 14] = {   4,    7,   26,   36}; //   4

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  needed_v_smax[x_a][  0] = {   6,   11,   13,   18,   25,   31,    3}; //   7
  needed_v_smax[x_a][  1] = {   7,    9,   23,   26,   34,   36,    1,    4}; //   8
  needed_v_smax[x_a][  2] = {   8,   10,   14,   16,   20,   22,   28,    0}; //   8
  needed_v_smax[x_a][  3] = {  10,   13,   16,   18}; //   4
  needed_v_smax[x_a][  4] = {  11,   12,   31,   32,    3,    4,    6,    7,   25,   26,   36,   37}; //  12
  needed_v_smax[x_a][  5] = {  12,   19,   24,   32,   33,   37,   39,    2}; //   8
  needed_v_smax[x_a][  6] = {  14,   15,   28,   29,    0,    1,    8,    9,   22,   23,   34,   35}; //  12
  needed_v_smax[x_a][  7] = {  15,   17,   21,   27,   29,   30,   35,   38,    5}; //   9
  needed_v_smax[x_a][  8] = {  17,   19,   30,   33,    2,    5,   24,   27}; //   8
  needed_v_smax[x_a][  9] = {  20}; //   1
  needed_v_smax[x_a][ 10] = {  21,   38}; //   2
  needed_v_smax[x_a][ 11] = {  39}; //   1

  g_p[x_a].resize(16);
  needed_g_p[x_a].resize(16);
  needed_g_p[x_a][0] = {   6,   11,   13,   18,   25,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   7,    9,   23,   26,   34,   36}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   8,   10,   14,   16,   20,   22,   28}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {  10,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  11,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {  12,   19,   24,   32,   33,   37,   39}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {  12,   32}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][7] = {  13,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax3");
  needed_g_p[x_a][8] = {  14,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][9] = {  15,   17,   21,   27,   29,   30,   35,   38}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][10] = {  15,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax6");
  needed_g_p[x_a][11] = {  17,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][12] = {  19,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax8");
  needed_g_p[x_a][13] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax9");
  needed_g_p[x_a][14] = {  21,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][15] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax11");

  g_f[x_a].resize(13);
  needed_g_f[x_a].resize(13);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   0,    8,   22}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax6");
  needed_g_f[x_a][2] = {   1,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][3] = {   1,    9,   23,   34}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax6");
  needed_g_f[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][5] = {   2,   24}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax8");
  needed_g_f[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][7] = {   3,    6,   25}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][8] = {   4,    7,   26,   36}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax4");
  needed_g_f[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][10] = {   5,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][11] = {  35}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax6");
  needed_g_f[x_a][12] = {  37}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");

  g_t[x_a].resize(28);
  needed_g_t[x_a].resize(28);
  needed_g_t[x_a][0] = {   0,    1,   22,   23,   28,   29,   34,   35}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][5] = {   2,    5,   24,   27,   30,   33}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][8] = {   3,    4,   25,   26,   31,   32,   36,   37}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][9] = {   3,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][10] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][11] = {   4,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][12] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_32");
  needed_g_t[x_a][13] = {   5,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][14] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][15] = {   6,    7,   11,   12}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][16] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__20_32");
  needed_g_t[x_a][17] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][18] = {   8,    9,   14,   15}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][19] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__24_32");
  needed_g_t[x_a][20] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_8");
  needed_g_t[x_a][21] = {  10,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][22] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][23] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__40_16");
  needed_g_t[x_a][24] = {  36}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__48_4");
  needed_g_t[x_a][25] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__36_16");
  needed_g_t[x_a][26] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][27] = {  39}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(17);
  needed_g_d[x_a].resize(17);
  needed_g_d[x_a][0] = {   6,   11,   13,   18,   21,   25,   31,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][1] = {   7,    9,   23,   26,   34,   36}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {   8,   10,   14,   16,   20,   22,   28,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  10,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {  11,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][5] = {  12,   32}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][6] = {  12,   19,   20,   24,   32,   33,   37,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][7] = {  13,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {  14,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][9] = {  15,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][10] = {  15,   17,   21,   27,   29,   30,   35,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][11] = {  16,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][12] = {  17,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][13] = {  17,   30}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][14] = {  19,   33}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][15] = {  20}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][16] = {  21}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(40);
  c_f[x_a].resize(40);
  c_t[x_a].resize(40);
  c_d[x_a].resize(40);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  6,   7}; //   2
  c_t[x_a][3] = {  8,   9,  10}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  2,   8}; //   2
  c_t[x_a][4] = {  8,  11,  12}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  9,  10}; //   2
  c_t[x_a][5] = {  5,  13,  14}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  7}; //   1
  c_t[x_a][6] = { 15,  16}; //   2
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1}; //   1
  c_f[x_a][7] = {  8}; //   1
  c_t[x_a][7] = { 15,  17}; //   2
  c_d[x_a][7] = {  1}; //   1

  c_p[x_a][8] = {  2}; //   1
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = { 18,  19}; //   2
  c_d[x_a][8] = {  2}; //   1

  c_p[x_a][9] = {  1}; //   1
  c_f[x_a][9] = {  3}; //   1
  c_t[x_a][9] = { 18,  20}; //   2
  c_d[x_a][9] = {  1}; //   1

  c_p[x_a][10] = {  2,   3}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 21}; //   1
  c_d[x_a][10] = {  3,   2}; //   2

  c_p[x_a][11] = {  0,   4}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 15}; //   1
  c_d[x_a][11] = {  4,   0}; //   2

  c_p[x_a][12] = {  5,   6}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 15}; //   1
  c_d[x_a][12] = {  5,   6}; //   2

  c_p[x_a][13] = {  0,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 21}; //   1
  c_d[x_a][13] = {  7,   0}; //   2

  c_p[x_a][14] = {  2,   8}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 18}; //   1
  c_d[x_a][14] = {  8,   2}; //   2

  c_p[x_a][15] = {  9,  10}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 18}; //   1
  c_d[x_a][15] = {  9,  10}; //   2

  c_p[x_a][16] = {  2,   3}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 11,   3,   2}; //   3

  c_p[x_a][17] = {  9,  11}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 12,  13,  10}; //   3

  c_p[x_a][18] = {  0,   7}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 11,   7,   0}; //   3

  c_p[x_a][19] = {  5,  12}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 12,  14,   6}; //   3

  c_p[x_a][20] = {  2,  13}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 15,   6,   2}; //   3

  c_p[x_a][21] = {  9,  14}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 16,   0,  10}; //   3

  c_p[x_a][22] = {  2}; //   1
  c_f[x_a][22] = {  1}; //   1
  c_t[x_a][22] = {  0,   1}; //   2
  c_d[x_a][22] = {  2}; //   1

  c_p[x_a][23] = {  1}; //   1
  c_f[x_a][23] = {  3}; //   1
  c_t[x_a][23] = {  0,   3}; //   2
  c_d[x_a][23] = {  1}; //   1

  c_p[x_a][24] = {  5}; //   1
  c_f[x_a][24] = {  5}; //   1
  c_t[x_a][24] = {  5,   6}; //   2
  c_d[x_a][24] = {  6}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = {  7}; //   1
  c_t[x_a][25] = {  8,   9}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  1}; //   1
  c_f[x_a][26] = {  8}; //   1
  c_t[x_a][26] = {  8,  11}; //   2
  c_d[x_a][26] = {  1}; //   1

  c_p[x_a][27] = {  9}; //   1
  c_f[x_a][27] = { 10}; //   1
  c_t[x_a][27] = {  5,  13}; //   2
  c_d[x_a][27] = { 10}; //   1

  c_p[x_a][28] = {  2,   8}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = {  8,   2}; //   2

  c_p[x_a][29] = {  9,  10}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = {  9,  10}; //   2

  c_p[x_a][30] = {  9,  11}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  5}; //   1
  c_d[x_a][30] = { 13,  10}; //   2

  c_p[x_a][31] = {  0,   4}; //   2
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  8}; //   1
  c_d[x_a][31] = {  4,   0}; //   2

  c_p[x_a][32] = {  5,   6}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  8}; //   1
  c_d[x_a][32] = {  5,   6}; //   2

  c_p[x_a][33] = {  5,  12}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  5}; //   1
  c_d[x_a][33] = { 14,   6}; //   2

  c_p[x_a][34] = {  1}; //   1
  c_f[x_a][34] = {  3}; //   1
  c_t[x_a][34] = {  0,  22}; //   2
  c_d[x_a][34] = {  1}; //   1

  c_p[x_a][35] = {  9}; //   1
  c_f[x_a][35] = { 11}; //   1
  c_t[x_a][35] = {  0,  23}; //   2
  c_d[x_a][35] = { 10}; //   1

  c_p[x_a][36] = {  1}; //   1
  c_f[x_a][36] = {  8}; //   1
  c_t[x_a][36] = {  8,  24}; //   2
  c_d[x_a][36] = {  1}; //   1

  c_p[x_a][37] = {  5}; //   1
  c_f[x_a][37] = { 12}; //   1
  c_t[x_a][37] = {  8,  25}; //   2
  c_d[x_a][37] = {  6}; //   1

  c_p[x_a][38] = {  9,  14}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 26}; //   1
  c_d[x_a][38] = {  0,  10}; //   2

  c_p[x_a][39] = {  5,  15}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 27}; //   1
  c_d[x_a][39] = {  2,   6}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    1: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel    2: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    3: 1111(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel    4: 1111(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel    5: 1111(1, 2, 16, 32, 8, 4;   0,   0,   0)
// channel    6: 2v11(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel    7: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    8: 2v11(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel    9: 2v11(1, 2, 16, 32, 8, 4;   0,   0,   0)
// channel   10: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   11: 3yv1(1, 2, 32, 4, 16, 8;   0,   0,   0)
// channel   12: 3yv1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   13: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   14: 3yv1(1, 2, 32, 8, 16, 4;   0,   0,   0)
// channel   15: 3yv1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel   16: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel   17: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   18: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel   19: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   20: 42vv(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   21: 42vv(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   22: 12v1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   23: 12v1(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel   24: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   25: 12v1(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   26: 12v1(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel   27: 12v1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel   28: 13yv(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   29: 13yv(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   30: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   31: 13yv(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   32: 13yv(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   33: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   34: 112v(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   35: 112v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   36: 112v(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   37: 112v(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   38: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   39: 2v2v(1, 2, 8, 16, 4, 32;   0,   0,   0)
