#include "header.hpp"

#include "ppeeexex04.phasespace.set.hpp"

void ppeeexex04_phasespace_set::ax_psp_240_gg_ememepep(int x_a){
  static Logger logger("ppeeexex04_phasespace_set::ax_psp_240_gg_ememepep");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(12);
  needed_v_smin[x_a].resize(12);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  33
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 33);
  int needed_v_smin_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   4,    5,    6,    7}; //   4
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  33
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 33);
  int needed_v_smin_4[] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 4);
  int needed_v_smin_6[] = {  16,   17,   18,   19,   20,   21,   22,   23,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  33
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 33);
  int needed_v_smin_7[] = {  16,   17,   18,   19}; //   4
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 4);
  int needed_v_smin_8[] = {  20,   21,   22,   23}; //   4
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 4);
  int needed_v_smin_9[] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  33
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 33);
  int needed_v_smin_10[] = {  24,   25,   26,   27}; //   4
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 4);
  int needed_v_smin_11[] = {  28,   29,   30,   31}; //   4
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 4);

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57}; //  25
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 25);
  int needed_v_smax_1[] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 8);
  int needed_v_smax_2[] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 8);
  int needed_v_smax_3[] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65}; //  25
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 25);
  int needed_v_smax_4[] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 8);
  int needed_v_smax_5[] = {  16,   17,   18,   19,   20,   21,   22,   23,   66,   67,   68,   69,   70,   71,   72,   73}; //  16
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 16);
  int needed_v_smax_6[] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 8);
  int needed_v_smax_7[] = {  24,   25,   26,   27,   28,   29,   30,   31,   74,   75,   76,   77,   78,   79,   80,   81}; //  16
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 16);
  int needed_v_smax_8[] = {  32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57}; //  17
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 17);
  int needed_v_smax_9[] = {  41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65}; //  17
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 17);
  int needed_v_smax_10[] = {  66,   67,   68,   69,   70,   71,   72,   73}; //   8
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 8);
  int needed_v_smax_11[] = {  74,   75,   76,   77,   78,   79,   80,   81}; //   8
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 8);

  g_p[x_a].resize(24);
  needed_g_p[x_a].resize(24);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   32,   33,   34,   35,   50,   51,   52,   53}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    3,    6,    7,   36,   37,   38,   39,   40,   54,   55,   56,   57}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   8,    9,   12,   13,   41,   42,   43,   44,   58,   59,   60,   61}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {  10,   11,   14,   15,   45,   46,   47,   48,   49,   62,   63,   64,   65}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][7] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][8] = {  16,   17,   20,   21,   66,   67,   68,   69}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][9] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][10] = {  18,   19,   22,   23,   70,   71,   72,   73}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax5");
  needed_g_p[x_a][11] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][12] = {  24,   25,   28,   29,   74,   75,   76,   77}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax6");
  needed_g_p[x_a][14] = {  26,   27,   30,   31,   78,   79,   80,   81}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax7");
  needed_g_p[x_a][15] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax4");
  needed_g_p[x_a][16] = {  32,   33,   36,   37,   50,   51,   54,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][17] = {  34,   35,   38,   39,   40,   52,   53,   56,   57}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax8");
  needed_g_p[x_a][18] = {  41,   42,   45,   46,   58,   59,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax9");
  needed_g_p[x_a][19] = {  43,   44,   47,   48,   49,   60,   61,   64,   65}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax9");
  needed_g_p[x_a][20] = {  66,   67,   70,   71}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax10");
  needed_g_p[x_a][21] = {  68,   69,   72,   73}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax10");
  needed_g_p[x_a][22] = {  74,   75,   78,   79}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax11");
  needed_g_p[x_a][23] = {  76,   77,   80,   81}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(8);
  needed_g_t[x_a].resize(8);
  needed_g_t[x_a][0] = {  50,   52,   54,   56}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_24");
  needed_g_t[x_a][1] = {  51,   53,   55,   57}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__36_24");
  needed_g_t[x_a][2] = {  58,   60,   62,   64}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][3] = {  59,   61,   63,   65}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__20_40");
  needed_g_t[x_a][4] = {  66,   68,   70,   72}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");
  needed_g_t[x_a][5] = {  67,   69,   71,   73}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__40_20");
  needed_g_t[x_a][6] = {  74,   76,   78,   80}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");
  needed_g_t[x_a][7] = {  75,   77,   79,   81}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__24_36");

  g_d[x_a].resize(18);
  needed_g_d[x_a].resize(18);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  33
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][6] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  33
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][7] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][9] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][11] = {  16,   17,   18,   19,   20,   21,   22,   23,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  33
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][12] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][13] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  33
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  32,   33,   34,   35,   36,   37,   38,   39,   40}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][17] = {  41,   42,   43,   44,   45,   46,   47,   48,   49}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(82);
  c_f[x_a].resize(82);
  c_t[x_a].resize(82);
  c_d[x_a].resize(82);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  2,   1}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  2,   1}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   3}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   3}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  2,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  3,   4,   2}; //   3

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  3,   4,   2}; //   3

  c_p[x_a][8] = {  4,   5}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   5,   6}; //   3

  c_p[x_a][9] = {  4,   5}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,   5,   6}; //   3

  c_p[x_a][10] = {  6,   5}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,   5,   6}; //   3

  c_p[x_a][11] = {  6,   5}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,   5,   6}; //   3

  c_p[x_a][12] = {  4,   7}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  7,   8,   6}; //   3

  c_p[x_a][13] = {  4,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  7,   8,   6}; //   3

  c_p[x_a][14] = {  6,   7}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  7,   8,   6}; //   3

  c_p[x_a][15] = {  6,   7}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  7,   8,   6}; //   3

  c_p[x_a][16] = {  8,   9}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  9,  10,  11}; //   3

  c_p[x_a][17] = {  8,   9}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  9,  10,  11}; //   3

  c_p[x_a][18] = { 10,   9}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  9,  10,  11}; //   3

  c_p[x_a][19] = { 10,   9}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  9,  10,  11}; //   3

  c_p[x_a][20] = {  8,  11}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  3,  12,  11}; //   3

  c_p[x_a][21] = {  8,  11}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  3,  12,  11}; //   3

  c_p[x_a][22] = { 10,  11}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  3,  12,  11}; //   3

  c_p[x_a][23] = { 10,  11}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  3,  12,  11}; //   3

  c_p[x_a][24] = { 12,  13}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  9,  13,  14}; //   3

  c_p[x_a][25] = { 12,  13}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = {  9,  13,  14}; //   3

  c_p[x_a][26] = { 14,  13}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = {  9,  13,  14}; //   3

  c_p[x_a][27] = { 14,  13}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = {  9,  13,  14}; //   3

  c_p[x_a][28] = { 12,  15}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = {  7,  15,  14}; //   3

  c_p[x_a][29] = { 12,  15}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = {  7,  15,  14}; //   3

  c_p[x_a][30] = { 14,  15}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = {  7,  15,  14}; //   3

  c_p[x_a][31] = { 14,  15}; //   2
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = {  7,  15,  14}; //   3

  c_p[x_a][32] = {  0,  16}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 16,  14,   2}; //   3

  c_p[x_a][33] = {  0,  16}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 16,  14,   2}; //   3

  c_p[x_a][34] = {  0,  17}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 16,  14,   2}; //   3

  c_p[x_a][35] = {  0,  17}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 16,  14,   2}; //   3

  c_p[x_a][36] = {  2,  16}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 16,  14,   2}; //   3

  c_p[x_a][37] = {  2,  16}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 16,  14,   2}; //   3

  c_p[x_a][38] = {  2,  17}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 16,  14,   2}; //   3

  c_p[x_a][39] = {  2,  17}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 16,  14,   2}; //   3

  c_p[x_a][40] = {  2,  17}; //   2
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 16,  14,   2}; //   3

  c_p[x_a][41] = {  4,  18}; //   2
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 17,  11,   6}; //   3

  c_p[x_a][42] = {  4,  18}; //   2
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 17,  11,   6}; //   3

  c_p[x_a][43] = {  4,  19}; //   2
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = { 17,  11,   6}; //   3

  c_p[x_a][44] = {  4,  19}; //   2
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = { 17,  11,   6}; //   3

  c_p[x_a][45] = {  6,  18}; //   2
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = { 17,  11,   6}; //   3

  c_p[x_a][46] = {  6,  18}; //   2
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = { 17,  11,   6}; //   3

  c_p[x_a][47] = {  6,  19}; //   2
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = { 17,  11,   6}; //   3

  c_p[x_a][48] = {  6,  19}; //   2
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {}; //   0
  c_d[x_a][48] = { 17,  11,   6}; //   3

  c_p[x_a][49] = {  6,  19}; //   2
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {}; //   0
  c_d[x_a][49] = { 17,  11,   6}; //   3

  c_p[x_a][50] = {  0,  16}; //   2
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  0}; //   1
  c_d[x_a][50] = { 14,   2}; //   2

  c_p[x_a][51] = {  0,  16}; //   2
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  1}; //   1
  c_d[x_a][51] = { 14,   2}; //   2

  c_p[x_a][52] = {  0,  17}; //   2
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  0}; //   1
  c_d[x_a][52] = { 14,   2}; //   2

  c_p[x_a][53] = {  0,  17}; //   2
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  1}; //   1
  c_d[x_a][53] = { 14,   2}; //   2

  c_p[x_a][54] = {  2,  16}; //   2
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  0}; //   1
  c_d[x_a][54] = { 14,   2}; //   2

  c_p[x_a][55] = {  2,  16}; //   2
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  1}; //   1
  c_d[x_a][55] = { 14,   2}; //   2

  c_p[x_a][56] = {  2,  17}; //   2
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  0}; //   1
  c_d[x_a][56] = { 14,   2}; //   2

  c_p[x_a][57] = {  2,  17}; //   2
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  1}; //   1
  c_d[x_a][57] = { 14,   2}; //   2

  c_p[x_a][58] = {  4,  18}; //   2
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  2}; //   1
  c_d[x_a][58] = { 11,   6}; //   2

  c_p[x_a][59] = {  4,  18}; //   2
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  3}; //   1
  c_d[x_a][59] = { 11,   6}; //   2

  c_p[x_a][60] = {  4,  19}; //   2
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  2}; //   1
  c_d[x_a][60] = { 11,   6}; //   2

  c_p[x_a][61] = {  4,  19}; //   2
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  3}; //   1
  c_d[x_a][61] = { 11,   6}; //   2

  c_p[x_a][62] = {  6,  18}; //   2
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  2}; //   1
  c_d[x_a][62] = { 11,   6}; //   2

  c_p[x_a][63] = {  6,  18}; //   2
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  3}; //   1
  c_d[x_a][63] = { 11,   6}; //   2

  c_p[x_a][64] = {  6,  19}; //   2
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  2}; //   1
  c_d[x_a][64] = { 11,   6}; //   2

  c_p[x_a][65] = {  6,  19}; //   2
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  3}; //   1
  c_d[x_a][65] = { 11,   6}; //   2

  c_p[x_a][66] = {  8,  20}; //   2
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  4}; //   1
  c_d[x_a][66] = {  6,  11}; //   2

  c_p[x_a][67] = {  8,  20}; //   2
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  5}; //   1
  c_d[x_a][67] = {  6,  11}; //   2

  c_p[x_a][68] = {  8,  21}; //   2
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  4}; //   1
  c_d[x_a][68] = {  6,  11}; //   2

  c_p[x_a][69] = {  8,  21}; //   2
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  5}; //   1
  c_d[x_a][69] = {  6,  11}; //   2

  c_p[x_a][70] = { 10,  20}; //   2
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  4}; //   1
  c_d[x_a][70] = {  6,  11}; //   2

  c_p[x_a][71] = { 10,  20}; //   2
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  5}; //   1
  c_d[x_a][71] = {  6,  11}; //   2

  c_p[x_a][72] = { 10,  21}; //   2
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  4}; //   1
  c_d[x_a][72] = {  6,  11}; //   2

  c_p[x_a][73] = { 10,  21}; //   2
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  5}; //   1
  c_d[x_a][73] = {  6,  11}; //   2

  c_p[x_a][74] = { 12,  22}; //   2
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  6}; //   1
  c_d[x_a][74] = {  2,  14}; //   2

  c_p[x_a][75] = { 12,  22}; //   2
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  7}; //   1
  c_d[x_a][75] = {  2,  14}; //   2

  c_p[x_a][76] = { 12,  23}; //   2
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  6}; //   1
  c_d[x_a][76] = {  2,  14}; //   2

  c_p[x_a][77] = { 12,  23}; //   2
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  7}; //   1
  c_d[x_a][77] = {  2,  14}; //   2

  c_p[x_a][78] = { 14,  22}; //   2
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {  6}; //   1
  c_d[x_a][78] = {  2,  14}; //   2

  c_p[x_a][79] = { 14,  22}; //   2
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = {  7}; //   1
  c_d[x_a][79] = {  2,  14}; //   2

  c_p[x_a][80] = { 14,  23}; //   2
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {  6}; //   1
  c_d[x_a][80] = {  2,  14}; //   2

  c_p[x_a][81] = { 14,  23}; //   2
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  7}; //   1
  c_d[x_a][81] = {  2,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
