#include "header.hpp"

#include "ppeeexnex04.phasespace.set.hpp"

void ppeeexnex04_phasespace_set::ax_psp_240_dxcx_ememepvexdxsx(int x_a){
  static Logger logger("ppeeexnex04_phasespace_set::ax_psp_240_dxcx_ememepvexdxsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(33);
  needed_v_smin[x_a].resize(33);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13,   18,   19,   20,   21,   22,   28,   29,   34,   35,   38,   39,   42,   43,   46,   47,   48,   49,   54,   55,   56,   57,   62,   63}; //  30
  needed_v_smin[x_a][  1] = {   0,   20}; //   2
  needed_v_smin[x_a][  2] = {   0,    3,   20,   23}; //   4
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smin[x_a][  4] = {   1,    2,   21,   22}; //   4
  needed_v_smin[x_a][  5] = {   1,    2,    5,    6,   21,   22,   25,   26}; //   8
  needed_v_smin[x_a][  6] = {   3,   10,   11,   14,   15,   16,   17,   23,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   50,   51,   52,   53,   58,   59,   60,   61}; //  26
  needed_v_smin[x_a][  7] = {   3,   23}; //   2
  needed_v_smin[x_a][  8] = {   4,    5,    6,   10,   11,   14,   15,   16,   17,   24,   25,   26,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   50,   51,   52,   53,   58,   59,   60,   61}; //  30
  needed_v_smin[x_a][  9] = {   4,   24}; //   2
  needed_v_smin[x_a][ 10] = {   4,    7,   24,   27}; //   4
  needed_v_smin[x_a][ 11] = {   5,    6,   25,   26}; //   4
  needed_v_smin[x_a][ 12] = {   7,    8,    9,   12,   13,   18,   19,   27,   28,   29,   34,   35,   38,   39,   42,   43,   46,   47,   48,   49,   54,   55,   56,   57,   62,   63}; //  26
  needed_v_smin[x_a][ 13] = {   7,   27}; //   2
  needed_v_smin[x_a][ 14] = {   8,    9,   28,   29}; //   4
  needed_v_smin[x_a][ 15] = {  10,   11,   30,   31}; //   4
  needed_v_smin[x_a][ 16] = {  12,   13,   54,   55,   62,   63}; //   6
  needed_v_smin[x_a][ 17] = {  12,   13,   54,   55,   62,   63}; //   6
  needed_v_smin[x_a][ 18] = {  14,   15,   32,   33,   40,   41,   52,   53,   60,   61}; //  10
  needed_v_smin[x_a][ 19] = {  14,   15,   52,   53,   60,   61}; //   6
  needed_v_smin[x_a][ 20] = {  16,   17,   50,   51,   58,   59}; //   6
  needed_v_smin[x_a][ 21] = {  16,   17,   50,   51,   58,   59}; //   6
  needed_v_smin[x_a][ 22] = {  18,   19,   34,   35,   42,   43,   48,   49,   56,   57}; //  10
  needed_v_smin[x_a][ 23] = {  18,   19,   48,   49,   56,   57}; //   6
  needed_v_smin[x_a][ 24] = {  40,   41,   44,   45}; //   4
  needed_v_smin[x_a][ 25] = {  42,   43,   46,   47}; //   4
  needed_v_smin[x_a][ 26] = {  32,   33}; //   2
  needed_v_smin[x_a][ 27] = {  34,   35}; //   2
  needed_v_smin[x_a][ 28] = {  36,   37,   38,   39}; //   4
  needed_v_smin[x_a][ 29] = {  36,   37}; //   2
  needed_v_smin[x_a][ 30] = {  38,   39}; //   2
  needed_v_smin[x_a][ 31] = {  44,   45}; //   2
  needed_v_smin[x_a][ 32] = {  46,   47}; //   2

  v_smax[x_a].resize(35);
  needed_v_smax[x_a].resize(35);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13,   20,   21,   22,   28,   29,   48,   49,   56,   57}; //  16
  needed_v_smax[x_a][  1] = {   0,    3,   20,   23}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  needed_v_smax[x_a][  4] = {   1,    2,    5,    6,   21,   22,   25,   26}; //   8
  needed_v_smax[x_a][  5] = {   3,   10,   11,   14,   15,   23,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   50,   51,   58,   59}; //  20
  needed_v_smax[x_a][  6] = {   4,    5,    6,   16,   17,   24,   25,   26,   52,   53,   60,   61}; //  12
  needed_v_smax[x_a][  7] = {   4,    7,   24,   27}; //   4
  needed_v_smax[x_a][  8] = {   7,   18,   19,   27,   34,   35,   38,   39,   42,   43,   46,   47,   54,   55,   62,   63}; //  16
  needed_v_smax[x_a][  9] = {   8,    9,   28,   29,   48,   49,   56,   57}; //   8
  needed_v_smax[x_a][ 10] = {  10,   11,   30,   31,   36,   37,   44,   45,   50,   51,   58,   59}; //  12
  needed_v_smax[x_a][ 11] = {  12,   13}; //   2
  needed_v_smax[x_a][ 12] = {  12,   13}; //   2
  needed_v_smax[x_a][ 13] = {  14,   15,   32,   33,   40,   41}; //   6
  needed_v_smax[x_a][ 14] = {  14,   15,   32,   33,   40,   41}; //   6
  needed_v_smax[x_a][ 15] = {  16,   17}; //   2
  needed_v_smax[x_a][ 16] = {  16,   17}; //   2
  needed_v_smax[x_a][ 17] = {  18,   19,   34,   35,   42,   43}; //   6
  needed_v_smax[x_a][ 18] = {  18,   19,   34,   35,   42,   43}; //   6
  needed_v_smax[x_a][ 19] = {  38,   39,   46,   47,   54,   55,   62,   63}; //   8
  needed_v_smax[x_a][ 20] = {  40,   41}; //   2
  needed_v_smax[x_a][ 21] = {  42,   43}; //   2
  needed_v_smax[x_a][ 22] = {  44,   45}; //   2
  needed_v_smax[x_a][ 23] = {  46,   47}; //   2
  needed_v_smax[x_a][ 24] = {  48,   49,   56,   57}; //   4
  needed_v_smax[x_a][ 25] = {  50,   51,   58,   59}; //   4
  needed_v_smax[x_a][ 26] = {  52,   53,   60,   61}; //   4
  needed_v_smax[x_a][ 27] = {  52,   53,   60,   61}; //   4
  needed_v_smax[x_a][ 28] = {  54,   55,   62,   63}; //   4
  needed_v_smax[x_a][ 29] = {  32,   33,   36,   37}; //   4
  needed_v_smax[x_a][ 30] = {  34,   35,   38,   39}; //   4
  needed_v_smax[x_a][ 31] = {  36,   37}; //   2
  needed_v_smax[x_a][ 32] = {  38,   39}; //   2
  needed_v_smax[x_a][ 33] = {  44,   45}; //   2
  needed_v_smax[x_a][ 34] = {  46,   47}; //   2

  g_p[x_a].resize(46);
  needed_g_p[x_a].resize(46);
  needed_g_p[x_a][0] = {   0,    2,    9,   13,   20,   22,   29,   49,   57}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    3,   20,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    8,   12,   21,   28,   48,   56}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][5] = {   1,    2,   21,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   1,    2,    5,    6,   21,   22,   25,   26}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax2");
  needed_g_p[x_a][7] = {   3,   10,   11,   14,   15,   23,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   50,   51,   58,   59}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax1");
  needed_g_p[x_a][9] = {   4,    6,   17,   24,   26,   53,   61}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax6");
  needed_g_p[x_a][10] = {   4,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][11] = {   4,    7,   24,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax2");
  needed_g_p[x_a][12] = {   5,   16,   25,   52,   60}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][13] = {   5,    6,   25,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax4");
  needed_g_p[x_a][14] = {   7,   18,   19,   27,   34,   35,   38,   39,   42,   43,   46,   47,   54,   55,   62,   63}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax8");
  needed_g_p[x_a][15] = {   7,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax7");
  needed_g_p[x_a][16] = {   8,    9,   28,   29,   48,   49,   56,   57}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax9");
  needed_g_p[x_a][17] = {   8,    9,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax2");
  needed_g_p[x_a][18] = {  10,   30,   36,   44,   50,   58}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax10");
  needed_g_p[x_a][19] = {  10,   11,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax2");
  needed_g_p[x_a][20] = {  11,   31,   37,   45,   51,   59}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax10");
  needed_g_p[x_a][21] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][22] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax12");
  needed_g_p[x_a][23] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax3");
  needed_g_p[x_a][24] = {  14,   15,   32,   33,   40,   41}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax13");
  needed_g_p[x_a][25] = {  14,   32,   40}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax14");
  needed_g_p[x_a][26] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax3");
  needed_g_p[x_a][27] = {  15,   33,   41}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax14");
  needed_g_p[x_a][28] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax15");
  needed_g_p[x_a][29] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax16");
  needed_g_p[x_a][30] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax3");
  needed_g_p[x_a][31] = {  18,   19,   34,   35,   42,   43}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax17");
  needed_g_p[x_a][32] = {  18,   34,   42}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax18");
  needed_g_p[x_a][33] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax3");
  needed_g_p[x_a][34] = {  19,   35,   43}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax18");
  needed_g_p[x_a][35] = {  38,   46,   54,   62}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax19");
  needed_g_p[x_a][36] = {  39,   47,   55,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax19");
  needed_g_p[x_a][37] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax20");
  needed_g_p[x_a][38] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax21");
  needed_g_p[x_a][39] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax22");
  needed_g_p[x_a][40] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax23");
  needed_g_p[x_a][41] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax24");
  needed_g_p[x_a][42] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax25");
  needed_g_p[x_a][43] = {  52,   53,   60,   61}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax26");
  needed_g_p[x_a][44] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax27");
  needed_g_p[x_a][45] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax28");

  g_f[x_a].resize(17);
  needed_g_f[x_a].resize(17);
  needed_g_f[x_a][0] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax29");
  needed_g_f[x_a][2] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax30");
  needed_g_f[x_a][3] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax31");
  needed_g_f[x_a][4] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax29");
  needed_g_f[x_a][5] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax32");
  needed_g_f[x_a][6] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax30");
  needed_g_f[x_a][7] = {  44,   45}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax33");
  needed_g_f[x_a][8] = {  46,   47}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax34");
  needed_g_f[x_a][9] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax3");
  needed_g_f[x_a][10] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax3");
  needed_g_f[x_a][11] = {  52,   53,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax3");
  needed_g_f[x_a][12] = {  54,   55,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax3");
  needed_g_f[x_a][13] = {  56,   57}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax24");
  needed_g_f[x_a][14] = {  58,   59}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax25");
  needed_g_f[x_a][15] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax27");
  needed_g_f[x_a][16] = {  62,   63}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax28");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][1] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][2] = {  32,   33,   36,   37}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][3] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__168_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__168_64");
  needed_g_t[x_a][4] = {  34,   35,   38,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_228");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_228");
  needed_g_t[x_a][5] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__164_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__164_64");
  needed_g_t[x_a][6] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_192");
  needed_g_t[x_a][7] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__21_42__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__21_42__64_128");
  needed_g_t[x_a][8] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_192");
  needed_g_t[x_a][9] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__25_38__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__25_38__64_128");
  needed_g_t[x_a][10] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__84_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__84_168");
  needed_g_t[x_a][11] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__88_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__88_164");
  needed_g_t[x_a][12] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_212");
  needed_g_t[x_a][13] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_42__84_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_42__84_128");
  needed_g_t[x_a][14] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_216");
  needed_g_t[x_a][15] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_38__88_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_38__88_128");
  needed_g_t[x_a][16] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_164");
  needed_g_t[x_a][17] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_148");
  needed_g_t[x_a][18] = {  52,   53,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_168");
  needed_g_t[x_a][19] = {  54,   55,   62,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_152");
  needed_g_t[x_a][20] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__128_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__128_36");
  needed_g_t[x_a][21] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_42__128_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_42__128_20");
  needed_g_t[x_a][22] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_22__128_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_22__128_40");
  needed_g_t[x_a][23] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__128_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__128_24");

  g_d[x_a].resize(26);
  needed_g_d[x_a].resize(26);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,    3,   20,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    8,    9,   12,   13,   18,   19,   20,   21,   22,   28,   29,   34,   35,   38,   39,   42,   43,   46,   47,   48,   49,   54,   55,   56,   57,   62,   63}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   1,    2,    5,    6,   21,   22,   25,   26}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   1,    2,   21,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][6] = {   3,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][7] = {   3,   10,   11,   14,   15,   16,   17,   23,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   50,   51,   52,   53,   58,   59,   60,   61}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][8] = {   4,    7,   24,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][10] = {   4,    5,    6,   10,   11,   14,   15,   16,   17,   24,   25,   26,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   50,   51,   52,   53,   58,   59,   60,   61}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][11] = {   5,    6,   25,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][12] = {   7,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][13] = {   7,    8,    9,   12,   13,   18,   19,   27,   28,   29,   34,   35,   38,   39,   42,   43,   46,   47,   48,   49,   54,   55,   56,   57,   62,   63}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][14] = {   8,    9,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][15] = {  10,   11,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][16] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__36_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__36_152");
  needed_g_d[x_a][17] = {  12,   13,   54,   55}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_152__128_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_152__128_24");
  needed_g_d[x_a][18] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__20_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__20_168");
  needed_g_d[x_a][19] = {  14,   15,   32,   33,   40,   41,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_168__128_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_168__128_40");
  needed_g_d[x_a][20] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__40_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__40_148");
  needed_g_d[x_a][21] = {  16,   17,   50,   51}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][22] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][23] = {  18,   19,   34,   35,   42,   43,   48,   49}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][24] = {  40,   41,   44,   45}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][25] = {  42,   43,   46,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   5,   6,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   4,   5,   3}; //   4

  c_p[x_a][2] = {  0,   5,   6,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  7,   8,   2,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   1,   6,   7}; //   4

  c_p[x_a][4] = {  9,  10,  11,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   8,   9,  10}; //   4

  c_p[x_a][5] = { 12,  13,   6,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   4,  11,  10}; //   4

  c_p[x_a][6] = {  9,  13,   6,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  0,   4,  11,  10}; //   4

  c_p[x_a][7] = { 14,  15,  11,   3}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  0,   8,  12,  13}; //   4

  c_p[x_a][8] = {  4,  16,  17,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  0,  14,  13,   3}; //   4

  c_p[x_a][9] = {  0,  16,  17,   3}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  0,  14,  13,   3}; //   4

  c_p[x_a][10] = {  7,  18,  19,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  0,  15,  10,   7}; //   4

  c_p[x_a][11] = {  7,  20,  19,   3}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  0,  15,  10,   7}; //   4

  c_p[x_a][12] = {  4,  21,  22,  23}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 16,  13,  17,   3}; //   4

  c_p[x_a][13] = {  0,  21,  22,  23}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 16,  13,  17,   3}; //   4

  c_p[x_a][14] = {  7,  24,  25,  26}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 18,  10,  19,   7}; //   4

  c_p[x_a][15] = {  7,  24,  27,  26}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 18,  10,  19,   7}; //   4

  c_p[x_a][16] = { 12,  28,  29,  30}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 20,   7,  21,  10}; //   4

  c_p[x_a][17] = {  9,  28,  29,  30}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 20,   7,  21,  10}; //   4

  c_p[x_a][18] = { 14,  31,  32,  33}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 22,   3,  23,  13}; //   4

  c_p[x_a][19] = { 14,  31,  34,  33}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 22,   3,  23,  13}; //   4

  c_p[x_a][20] = {  0,   1,   2}; //   3
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  0,   1}; //   2
  c_d[x_a][20] = {  1,   2,   3}; //   3

  c_p[x_a][21] = {  4,   5,   6}; //   3
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  0,   1}; //   2
  c_d[x_a][21] = {  4,   5,   3}; //   3

  c_p[x_a][22] = {  0,   5,   6}; //   3
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  0,   1}; //   2
  c_d[x_a][22] = {  4,   5,   3}; //   3

  c_p[x_a][23] = {  7,   8,   2}; //   3
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  0,   1}; //   2
  c_d[x_a][23] = {  1,   6,   7}; //   3

  c_p[x_a][24] = {  9,  10,  11}; //   3
  c_f[x_a][24] = {  0}; //   1
  c_t[x_a][24] = {  0,   1}; //   2
  c_d[x_a][24] = {  8,   9,  10}; //   3

  c_p[x_a][25] = { 12,  13,   6}; //   3
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  0,   1}; //   2
  c_d[x_a][25] = {  4,  11,  10}; //   3

  c_p[x_a][26] = {  9,  13,   6}; //   3
  c_f[x_a][26] = {  0}; //   1
  c_t[x_a][26] = {  0,   1}; //   2
  c_d[x_a][26] = {  4,  11,  10}; //   3

  c_p[x_a][27] = { 14,  15,  11}; //   3
  c_f[x_a][27] = {  0}; //   1
  c_t[x_a][27] = {  0,   1}; //   2
  c_d[x_a][27] = {  8,  12,  13}; //   3

  c_p[x_a][28] = {  4,  16,  17}; //   3
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  0,   1}; //   2
  c_d[x_a][28] = { 14,  13,   3}; //   3

  c_p[x_a][29] = {  0,  16,  17}; //   3
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  0,   1}; //   2
  c_d[x_a][29] = { 14,  13,   3}; //   3

  c_p[x_a][30] = {  7,  18,  19}; //   3
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  0,   1}; //   2
  c_d[x_a][30] = { 15,  10,   7}; //   3

  c_p[x_a][31] = {  7,  20,  19}; //   3
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  0,   1}; //   2
  c_d[x_a][31] = { 15,  10,   7}; //   3

  c_p[x_a][32] = {  7,  24,  25}; //   3
  c_f[x_a][32] = {  1}; //   1
  c_t[x_a][32] = {  2,   3}; //   2
  c_d[x_a][32] = { 10,  19,   7}; //   3

  c_p[x_a][33] = {  7,  24,  27}; //   3
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = {  2,   3}; //   2
  c_d[x_a][33] = { 10,  19,   7}; //   3

  c_p[x_a][34] = { 14,  31,  32}; //   3
  c_f[x_a][34] = {  2}; //   1
  c_t[x_a][34] = {  4,   5}; //   2
  c_d[x_a][34] = {  3,  23,  13}; //   3

  c_p[x_a][35] = { 14,  31,  34}; //   3
  c_f[x_a][35] = {  2}; //   1
  c_t[x_a][35] = {  4,   5}; //   2
  c_d[x_a][35] = {  3,  23,  13}; //   3

  c_p[x_a][36] = {  7,  18}; //   2
  c_f[x_a][36] = {  3,   4}; //   2
  c_t[x_a][36] = {  2,   6,   7}; //   3
  c_d[x_a][36] = { 10,   7}; //   2

  c_p[x_a][37] = {  7,  20}; //   2
  c_f[x_a][37] = {  3,   4}; //   2
  c_t[x_a][37] = {  2,   6,   7}; //   3
  c_d[x_a][37] = { 10,   7}; //   2

  c_p[x_a][38] = { 14,  35}; //   2
  c_f[x_a][38] = {  5,   6}; //   2
  c_t[x_a][38] = {  4,   8,   9}; //   3
  c_d[x_a][38] = {  3,  13}; //   2

  c_p[x_a][39] = { 14,  36}; //   2
  c_f[x_a][39] = {  5,   6}; //   2
  c_t[x_a][39] = {  4,   8,   9}; //   3
  c_d[x_a][39] = {  3,  13}; //   2

  c_p[x_a][40] = {  7,  24,  25,  37}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 10}; //   1
  c_d[x_a][40] = { 24,  10,  19,   7}; //   4

  c_p[x_a][41] = {  7,  24,  27,  37}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 10}; //   1
  c_d[x_a][41] = { 24,  10,  19,   7}; //   4

  c_p[x_a][42] = { 14,  31,  32,  38}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 11}; //   1
  c_d[x_a][42] = { 25,   3,  23,  13}; //   4

  c_p[x_a][43] = { 14,  31,  34,  38}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 11}; //   1
  c_d[x_a][43] = { 25,   3,  23,  13}; //   4

  c_p[x_a][44] = {  7,  18,  39}; //   3
  c_f[x_a][44] = {  7}; //   1
  c_t[x_a][44] = { 12,  13}; //   2
  c_d[x_a][44] = { 24,  10,   7}; //   3

  c_p[x_a][45] = {  7,  20,  39}; //   3
  c_f[x_a][45] = {  7}; //   1
  c_t[x_a][45] = { 12,  13}; //   2
  c_d[x_a][45] = { 24,  10,   7}; //   3

  c_p[x_a][46] = { 14,  35,  40}; //   3
  c_f[x_a][46] = {  8}; //   1
  c_t[x_a][46] = { 14,  15}; //   2
  c_d[x_a][46] = { 25,   3,  13}; //   3

  c_p[x_a][47] = { 14,  36,  40}; //   3
  c_f[x_a][47] = {  8}; //   1
  c_t[x_a][47] = { 14,  15}; //   2
  c_d[x_a][47] = { 25,   3,  13}; //   3

  c_p[x_a][48] = {  4,  16,  41}; //   3
  c_f[x_a][48] = {  9}; //   1
  c_t[x_a][48] = {  0,  16}; //   2
  c_d[x_a][48] = { 23,  13,   3}; //   3

  c_p[x_a][49] = {  0,  16,  41}; //   3
  c_f[x_a][49] = {  9}; //   1
  c_t[x_a][49] = {  0,  16}; //   2
  c_d[x_a][49] = { 23,  13,   3}; //   3

  c_p[x_a][50] = {  7,  18,  42}; //   3
  c_f[x_a][50] = { 10}; //   1
  c_t[x_a][50] = {  0,  17}; //   2
  c_d[x_a][50] = { 21,  10,   7}; //   3

  c_p[x_a][51] = {  7,  20,  42}; //   3
  c_f[x_a][51] = { 10}; //   1
  c_t[x_a][51] = {  0,  17}; //   2
  c_d[x_a][51] = { 21,  10,   7}; //   3

  c_p[x_a][52] = { 12,  43,  44}; //   3
  c_f[x_a][52] = { 11}; //   1
  c_t[x_a][52] = {  0,  18}; //   2
  c_d[x_a][52] = { 19,   7,  10}; //   3

  c_p[x_a][53] = {  9,  43,  44}; //   3
  c_f[x_a][53] = { 11}; //   1
  c_t[x_a][53] = {  0,  18}; //   2
  c_d[x_a][53] = { 19,   7,  10}; //   3

  c_p[x_a][54] = { 14,  35,  45}; //   3
  c_f[x_a][54] = { 12}; //   1
  c_t[x_a][54] = {  0,  19}; //   2
  c_d[x_a][54] = { 17,   3,  13}; //   3

  c_p[x_a][55] = { 14,  36,  45}; //   3
  c_f[x_a][55] = { 12}; //   1
  c_t[x_a][55] = {  0,  19}; //   2
  c_d[x_a][55] = { 17,   3,  13}; //   3

  c_p[x_a][56] = {  4,  16}; //   2
  c_f[x_a][56] = { 13,   9}; //   2
  c_t[x_a][56] = {  0,  16,  20}; //   3
  c_d[x_a][56] = { 13,   3}; //   2

  c_p[x_a][57] = {  0,  16}; //   2
  c_f[x_a][57] = { 13,   9}; //   2
  c_t[x_a][57] = {  0,  16,  20}; //   3
  c_d[x_a][57] = { 13,   3}; //   2

  c_p[x_a][58] = {  7,  18}; //   2
  c_f[x_a][58] = { 14,  10}; //   2
  c_t[x_a][58] = {  0,  17,  21}; //   3
  c_d[x_a][58] = { 10,   7}; //   2

  c_p[x_a][59] = {  7,  20}; //   2
  c_f[x_a][59] = { 14,  10}; //   2
  c_t[x_a][59] = {  0,  17,  21}; //   3
  c_d[x_a][59] = { 10,   7}; //   2

  c_p[x_a][60] = { 12,  43}; //   2
  c_f[x_a][60] = { 15,  11}; //   2
  c_t[x_a][60] = {  0,  18,  22}; //   3
  c_d[x_a][60] = {  7,  10}; //   2

  c_p[x_a][61] = {  9,  43}; //   2
  c_f[x_a][61] = { 15,  11}; //   2
  c_t[x_a][61] = {  0,  18,  22}; //   3
  c_d[x_a][61] = {  7,  10}; //   2

  c_p[x_a][62] = { 14,  35}; //   2
  c_f[x_a][62] = { 16,  12}; //   2
  c_t[x_a][62] = {  0,  19,  23}; //   3
  c_d[x_a][62] = {  3,  13}; //   2

  c_p[x_a][63] = { 14,  36}; //   2
  c_f[x_a][63] = { 16,  12}; //   2
  c_t[x_a][63] = {  0,  19,  23}; //   3
  c_d[x_a][63] = {  3,  13}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  23,   0,  24,   0,   0)
// channel    1: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;   0,   0,  24,   0,   0)
// channel    2: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  23,   0,  24,   0,   0)
// channel    3: 15yyyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel    4: 15yyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel    5: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel    6: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel    7: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  24,   0,   0)
// channel    8: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;   0,  24,  24,   0,   0)
// channel    9: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  23,  24,  24,   0,   0)
// channel   10: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   11: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   12: 152vyv(1, 2, 64, 4, 32, 128, 8, 16;   0,   0,  24,   0,   0)
// channel   13: 152vyv(1, 2, 64, 4, 32, 128, 8, 16;  23,   0,  24,   0,   0)
// channel   14: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   15: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   16: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   17: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   18: 152vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,   0,   0,   0)
// channel   19: 152vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  23,   0,   0)
// channel   20: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  23,   0,  24,   0,   0)
// channel   21: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;   0,   0,  24,   0,   0)
// channel   22: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  23,   0,  24,   0,   0)
// channel   23: 114yyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   24: 114yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel   25: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel   26: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel   27: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  24,   0,   0)
// channel   28: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;   0,  24,  24,   0,   0)
// channel   29: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  23,  24,  24,   0,   0)
// channel   30: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   31: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   32: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   33: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   34: 2v13yv(1, 2, 8, 16, 64, 128, 4, 32;  24,   0,   0,   0,   0)
// channel   35: 2v13yv(1, 2, 8, 16, 64, 128, 4, 32;  24,   0,  23,   0,   0)
// channel   36: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   37: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,  23,   0,   0,   0)
// channel   38: 2v112v(1, 2, 8, 16, 64, 128, 4, 32;  24,   0,   0,   0,   0)
// channel   39: 2v112v(1, 2, 8, 16, 64, 128, 4, 32;  24,  23,   0,   0,   0)
// channel   40: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   41: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   42: 3yv3yv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,   0,   0,   0)
// channel   43: 3yv3yv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  23,   0,   0)
// channel   44: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   45: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,  23,   0,   0,   0)
// channel   46: 3yv12v(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,   0,   0,   0)
// channel   47: 3yv12v(1, 2, 64, 8, 16, 128, 4, 32;  24,  23,   0,   0,   0)
// channel   48: 13yv2v(1, 2, 64, 128, 4, 32, 8, 16;   0,  24,   0,   0,   0)
// channel   49: 13yv2v(1, 2, 64, 128, 4, 32, 8, 16;  23,  24,   0,   0,   0)
// channel   50: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   51: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   52: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   53: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
// channel   54: 13yv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   55: 13yv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  23,   0,   0,   0)
// channel   56: 112v2v(1, 2, 64, 128, 4, 32, 8, 16;   0,  24,   0,   0,   0)
// channel   57: 112v2v(1, 2, 64, 128, 4, 32, 8, 16;  23,  24,   0,   0,   0)
// channel   58: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   59: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   60: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   61: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
// channel   62: 112v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   63: 112v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  23,   0,   0,   0)
