#include "header.hpp"

#include "ppeex02.phasespace.set.hpp"

void ppeex02_phasespace_set::ac_psp_320_gg_emepg(int x_a, int channel){
  static Logger logger("ppeex02_phasespace_set::ac_psp_320_gg_emepg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 1));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0,  28,   2,   1,  16,  12, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,  36,  28,   2,   1,  16,  12, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel_opt(x_a,   0,  28,   1,   2,  16,  12, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,  36,  28,   1,   2,  16,  12, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  12,   4,   8, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  28,  16,  12, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
  }

  /*
  if      (channel ==    0){ac_channel_2v1(r, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  else if (channel ==    1){ac_channel_2v1(r, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  else if (channel ==    2){ac_channel_2v1(r, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36, psi);}
  else if (channel ==    3){ac_channel_2v1(r, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0, psi);}
  else if (channel ==    4){ac_channel_2v1(r, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0, psi);}
  else if (channel ==    5){ac_channel_2v1(r, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36, psi);}
  else if (channel ==    6){ac_channel_3yv(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  else if (channel ==    7){ac_channel_3yv(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  else if (channel ==    8){ac_channel_3yv(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36, psi);}
  else if (channel ==    9){ac_channel_3yv(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0, psi);}
  else if (channel ==   10){ac_channel_3yv(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0, psi);}
  else if (channel ==   11){ac_channel_3yv(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36, psi);}
  else if (channel ==   12){ac_channel_12v(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  else if (channel ==   13){ac_channel_12v(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  else if (channel ==   14){ac_channel_12v(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36, psi);}
  else if (channel ==   15){ac_channel_12v(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0, psi);}
  else if (channel ==   16){ac_channel_12v(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0, psi);}
  else if (channel ==   17){ac_channel_12v(r, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36, psi);}
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
