#include "header.hpp"

#include "ppeex02.phasespace.set.hpp"

void ppeex02_phasespace_set::ax_psp_220_ddx_emepgg(int x_a){
  static Logger logger("ppeex02_phasespace_set::ax_psp_220_ddx_emepgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(4);
  needed_v_smin[x_a].resize(4);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  needed_v_smin[x_a][  1] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,    4,    5,   10,   11}; //   6
  needed_v_smin[x_a][  3] = {   2,    3,    6,    7,    8,    9}; //   6

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   14,   15}; //  14
  needed_v_smax[x_a][  1] = {  12,   13}; //   2
  needed_v_smax[x_a][  2] = {  12,   13}; //   2
  needed_v_smax[x_a][  3] = {  14,   15}; //   2
  needed_v_smax[x_a][  4] = {   0,    1,    4,    5,   10,   11}; //   6
  needed_v_smax[x_a][  5] = {   2,    3,    6,    7,    8,    9}; //   6

  g_p[x_a].resize(6);
  needed_g_p[x_a].resize(6);
  needed_g_p[x_a][0] = {   0,    2,    4,    6,    8,   10,   14}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    3,    5,    7,    9,   11,   15}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax2");
  needed_g_p[x_a][4] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax2");
  needed_g_p[x_a][5] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax3");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1,    4,    5,   10,   11}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax4");
  needed_g_f[x_a][1] = {   2,    3,    6,    7,    8,    9}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax5");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][4] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][5] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][6] = {   6,    7,    8,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][7] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][8] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][9] = {  10,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][10] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][11] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(16);
  c_f[x_a].resize(16);
  c_t[x_a].resize(16);
  c_d[x_a].resize(16);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  1}; //   1
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  4,   5}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  4,   5}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  1}; //   1
  c_t[x_a][6] = {  6,   7}; //   2
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1}; //   1
  c_f[x_a][7] = {  1}; //   1
  c_t[x_a][7] = {  6,   7}; //   2
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  6,   8}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  1}; //   1
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  6,   8}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  4,   9}; //   2
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  4,   9}; //   2
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  2,   3}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 10}; //   1
  c_d[x_a][12] = {  0,   1}; //   2

  c_p[x_a][13] = {  2,   4}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 10}; //   1
  c_d[x_a][13] = {  0,   1}; //   2

  c_p[x_a][14] = {  0,   5}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 11}; //   1
  c_d[x_a][14] = {  1,   0}; //   2

  c_p[x_a][15] = {  1,   5}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 11}; //   1
  c_d[x_a][15] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    1: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
// channel    2: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel    3: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
// channel    4: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    5: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel    6: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel    7: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel    8: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    9: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   10: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel   11: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
// channel   12: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   13: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
// channel   14: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   15: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
