#include "header.hpp"

#include "ppeex02.phasespace.set.hpp"

void ppeex02_phasespace_set::ax_psp_220_gg_emepbbx(int x_a){
  static Logger logger("ppeex02_phasespace_set::ax_psp_220_gg_emepbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  needed_v_smin[x_a][  1] = {   0,    1,    4,    5,   12,   13,   10,   11}; //   8
  needed_v_smin[x_a][  2] = {   2,    3,    6,    7,   14,   15,    8,    9}; //   8

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  needed_v_smax[x_a][  1] = {   0,    1,    4,    5,   12,   13,   10,   11}; //   8
  needed_v_smax[x_a][  2] = {   2,    3,    6,    7,   14,   15,    8,    9}; //   8

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   0,    2,    4,    6,    8,   10,   12,   14}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    4,    5,   12,   13}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    3,    5,    7,    9,   11,   13,   15}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   2,    3,    6,    7,   14,   15}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   8,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {  10,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(6);
  needed_g_t[x_a].resize(6);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][1] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][2] = {   8,    9,   14,   15}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][3] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][4] = {  10,   11,   12,   13}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][5] = {  10,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");

  g_d[x_a].resize(5);
  needed_g_d[x_a].resize(5);
  needed_g_d[x_a][0] = {   0,    1,    4,    5,   12,   13}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   2,    3,    6,    7,   14,   15}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");

  c_p[x_a].resize(16);
  c_f[x_a].resize(16);
  c_t[x_a].resize(16);
  c_d[x_a].resize(16);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  2,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1}; //   2

  c_p[x_a][2] = {  0,   3}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  1}; //   1
  c_d[x_a][2] = {  2,   1}; //   2

  c_p[x_a][3] = {  2,   3}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  1}; //   1
  c_d[x_a][3] = {  2,   1}; //   2

  c_p[x_a][4] = {  0,   1}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  3,   0,   1}; //   3

  c_p[x_a][5] = {  2,   1}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  3,   0,   1}; //   3

  c_p[x_a][6] = {  0,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  4,   2,   1}; //   3

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  4,   2,   1}; //   3

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  2,   3}; //   2
  c_d[x_a][8] = {  1}; //   1

  c_p[x_a][9] = {  2}; //   1
  c_f[x_a][9] = {  0}; //   1
  c_t[x_a][9] = {  2,   3}; //   2
  c_d[x_a][9] = {  1}; //   1

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  1}; //   1
  c_t[x_a][10] = {  4,   5}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  2}; //   1
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  4,   5}; //   2
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  0,   1}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  4}; //   1
  c_d[x_a][12] = {  0,   1}; //   2

  c_p[x_a][13] = {  2,   1}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  4}; //   1
  c_d[x_a][13] = {  0,   1}; //   2

  c_p[x_a][14] = {  0,   3}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  2}; //   1
  c_d[x_a][14] = {  2,   1}; //   2

  c_p[x_a][15] = {  2,   3}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  2}; //   1
  c_d[x_a][15] = {  2,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    1: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel    2: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel    3: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel    4: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    5: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel    6: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel    7: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
// channel    8: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    9: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel   10: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   11: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel   12: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   13: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   14: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel   15: 13yv(1, 2, 32, 16, 4, 8;  23,   0,   0)
