#include "header.hpp"

#include "ppeex02.phasespace.set.hpp"

void ppeex02_phasespace_set::ax_psp_320_gg_emepg(int x_a){
  static Logger logger("ppeex02_phasespace_set::ax_psp_320_gg_emepg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(1);
  needed_v_smin[x_a].resize(1);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  18
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 18);

  v_smax[x_a].resize(1);
  needed_v_smax[x_a].resize(1);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  18
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 18);

  g_p[x_a].resize(2);
  needed_g_p[x_a].resize(2);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,   12,   13,   14}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    4,    5,    9,   10,   11,   15,   16,   17}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {   0,    1,    3,    4}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");
  needed_g_t[x_a][1] = {   2,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__16_12");
  needed_g_t[x_a][2] = {  12,   13,   15,   16}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][3] = {  14,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_12");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");

  c_p[x_a].resize(18);
  c_f[x_a].resize(18);
  c_t[x_a].resize(18);
  c_d[x_a].resize(18);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  1}; //   1
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  1}; //   1
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  1}; //   1
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  1,   0}; //   2

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  1,   0}; //   2

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  1,   0}; //   2

  c_p[x_a][9] = {  1}; //   1
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  1,   0}; //   2

  c_p[x_a][10] = {  1}; //   1
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  1,   0}; //   2

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  1,   0}; //   2

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  2}; //   1
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  2}; //   1
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  0}; //   1
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  3}; //   1
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  1}; //   1
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  2}; //   1
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  1}; //   1
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = {  0}; //   1

  c_p[x_a][17] = {  1}; //   1
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  3}; //   1
  c_d[x_a][17] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
