#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ac_psp_330_gg_emepag(int x_a, int channel){
  static Logger logger("ppeexa03_phasespace_set::ac_psp_330_gg_emepag");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  1] = smin_opt[x_a][24];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,   0,  24, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,  23,  28, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,  36,  44, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  4], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,  36,  28, v_smin[x_a][  4], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  5] = smin_opt[x_a][20];
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  5], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  6], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,  23,  28, v_smin[x_a][  6], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 11));
    }
    else if (c_p[x_a][channel][i_p] ==  12){
      v_smin[x_a][  7] = smin_opt[x_a][48];
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 12));
    }
    else if (c_p[x_a][channel][i_p] ==  13){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 13));
    }
    else if (c_p[x_a][channel][i_p] ==  14){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 14));
    }
    else if (c_p[x_a][channel][i_p] ==  15){
      v_smin[x_a][  7] = smin_opt[x_a][48];
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,  36,  48, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 15));
    }
    else if (c_p[x_a][channel][i_p] ==  16){
      v_smin[x_a][  7] = smin_opt[x_a][48];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  7], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 16));
    }
    else if (c_p[x_a][channel][i_p] ==  17){
      v_smin[x_a][  7] = smin_opt[x_a][48];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_propagator(x_a,  36,  48, v_smin[x_a][  7], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 17));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][  4], v_smax[x_a][  2], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 1, 1));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0,  60,   2,   1,  32,  28, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0,  28,   1,  34,  12,  16, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel_opt(x_a,  36,  28,   1,  34,  12,  16, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,  36,  60,   2,   1,  32,  28, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel_opt(x_a,   0,  60,   2,   1,  16,  44, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel_opt(x_a,   0,  44,   1,  18,  12,  32, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel_opt(x_a,  36,  60,   2,   1,  16,  44, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel_opt(x_a,  36,  44,   1,  18,  12,  32, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  32,  28, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel_opt(x_a,   0,  28,   2,  33,  16,  12, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel_opt(x_a,  36,  28,   2,  33,  16,  12, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel_opt(x_a,  36,  60,   1,   2,  32,  28, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  16,  44, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
    else if (c_t[x_a][channel][i_t] ==  13){
      c_tchannel_opt(x_a,   0,  44,   2,  17,  32,  12, random_manager.get_random(x_a, 2, 13), random_manager.get_random(x_a, 3, 13));
    }
    else if (c_t[x_a][channel][i_t] ==  14){
      c_tchannel_opt(x_a,  36,  60,   1,   2,  16,  44, random_manager.get_random(x_a, 2, 14), random_manager.get_random(x_a, 3, 14));
    }
    else if (c_t[x_a][channel][i_t] ==  15){
      c_tchannel_opt(x_a,  36,  44,   2,  17,  32,  12, random_manager.get_random(x_a, 2, 15), random_manager.get_random(x_a, 3, 15));
    }
    else if (c_t[x_a][channel][i_t] ==  16){
      c_tchannel_opt(x_a,   0,  44,   2,  17,  12,  32, random_manager.get_random(x_a, 2, 16), random_manager.get_random(x_a, 3, 16));
    }
    else if (c_t[x_a][channel][i_t] ==  17){
      c_tchannel_opt(x_a,  36,  44,   2,  17,  12,  32, random_manager.get_random(x_a, 2, 17), random_manager.get_random(x_a, 3, 17));
    }
    else if (c_t[x_a][channel][i_t] ==  18){
      c_tchannel_opt(x_a,   0,  28,   2,  33,  12,  16, random_manager.get_random(x_a, 2, 18), random_manager.get_random(x_a, 3, 18));
    }
    else if (c_t[x_a][channel][i_t] ==  19){
      c_tchannel_opt(x_a,  36,  28,   2,  33,  12,  16, random_manager.get_random(x_a, 2, 19), random_manager.get_random(x_a, 3, 19));
    }
    else if (c_t[x_a][channel][i_t] ==  20){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  12,  48, random_manager.get_random(x_a, 2, 20), random_manager.get_random(x_a, 3, 20));
    }
    else if (c_t[x_a][channel][i_t] ==  21){
      c_tchannel_opt(x_a,  36,  60,   1,   2,  12,  48, random_manager.get_random(x_a, 2, 21), random_manager.get_random(x_a, 3, 21));
    }
    else if (c_t[x_a][channel][i_t] ==  22){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  48,  12, random_manager.get_random(x_a, 2, 22), random_manager.get_random(x_a, 3, 22));
    }
    else if (c_t[x_a][channel][i_t] ==  23){
      c_tchannel_opt(x_a,  36,  60,   1,   2,  48,  12, random_manager.get_random(x_a, 2, 23), random_manager.get_random(x_a, 3, 23));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  12,   4,   8, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  28,   4,  24, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  24,   8,  16, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  44,  32,  12, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  28,  16,  12, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  28,   8,  20, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  20,   4,  16, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  60,  32,  28, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a,  60,  12,  48, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  48,  16,  32, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
  }

  /*
  if      (channel ==    0){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    1){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==    2){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    3){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==    4){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==    5){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36, psi);}
  else if (channel ==    6){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==    7){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==    8){ac_channel_2v11(r, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    9){ac_channel_2v11(r, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==   10){ac_channel_2v11(r, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   11){ac_channel_2v11(r, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==   12){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   13){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   14){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==   15){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   16){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   17){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  else if (channel ==   18){ac_channel_3yv1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   19){ac_channel_3yv1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==   20){ac_channel_3yv1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   21){ac_channel_3yv1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==   22){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   23){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   24){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   25){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==   26){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   27){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   28){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,   0, psi);}
  else if (channel ==   29){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==   30){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   31){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   32){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==   33){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   34){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   35){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  else if (channel ==   36){ac_channel_4yyv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   37){ac_channel_4yyv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   38){ac_channel_4yyv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==   39){ac_channel_4yyv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   40){ac_channel_4yyv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   41){ac_channel_4yyv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  else if (channel ==   42){ac_channel_4yyv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   43){ac_channel_4yyv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   44){ac_channel_4yyv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   45){ac_channel_4yyv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==   46){ac_channel_4yyv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   47){ac_channel_4yyv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   48){ac_channel_4yyv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,   0, psi);}
  else if (channel ==   49){ac_channel_4yyv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==   50){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   51){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   52){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   53){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==   54){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   55){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   56){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,   0, psi);}
  else if (channel ==   57){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==   58){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   59){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   60){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==   61){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   62){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   63){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  else if (channel ==   64){ac_channel_42vv(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   65){ac_channel_42vv(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   66){ac_channel_42vv(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   67){ac_channel_42vv(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   68){ac_channel_42vv(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   69){ac_channel_42vv(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==   70){ac_channel_42vv(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  23,   0, psi);}
  else if (channel ==   71){ac_channel_42vv(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  23,  36, psi);}
  else if (channel ==   72){ac_channel_12v1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   73){ac_channel_12v1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==   74){ac_channel_12v1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   75){ac_channel_12v1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==   76){ac_channel_12v1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   77){ac_channel_12v1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36, psi);}
  else if (channel ==   78){ac_channel_12v1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   79){ac_channel_12v1(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==   80){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   81){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   82){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   83){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==   84){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   85){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   86){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,   0, psi);}
  else if (channel ==   87){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==   88){ac_channel_13yv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   89){ac_channel_13yv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   90){ac_channel_13yv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==   91){ac_channel_13yv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   92){ac_channel_13yv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   93){ac_channel_13yv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  else if (channel ==   94){ac_channel_13yv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   95){ac_channel_13yv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==   96){ac_channel_13yv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   97){ac_channel_13yv(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==   98){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   99){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==  100){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==  101){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==  102){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==  103){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==  104){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,   0, psi);}
  else if (channel ==  105){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==  106){ac_channel_13yv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==  107){ac_channel_13yv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==  108){ac_channel_13yv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==  109){ac_channel_13yv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==  110){ac_channel_13yv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==  111){ac_channel_13yv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  else if (channel ==  112){ac_channel_112v(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==  113){ac_channel_112v(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==  114){ac_channel_112v(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==  115){ac_channel_112v(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==  116){ac_channel_112v(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==  117){ac_channel_112v(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==  118){ac_channel_112v(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==  119){ac_channel_112v(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==  120){ac_channel_112v(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==  121){ac_channel_112v(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36, psi);}
  else if (channel ==  122){ac_channel_112v(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==  123){ac_channel_112v(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  else if (channel ==  124){ac_channel_2v2v(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==  125){ac_channel_2v2v(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==  126){ac_channel_2v2v(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==  127){ac_channel_2v2v(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  23,  36, psi);}
  else if (channel ==  128){ac_channel_2v2v(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==  129){ac_channel_2v2v(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  36, psi);}
  else if (channel ==  130){ac_channel_2v2v(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==  131){ac_channel_2v2v(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  36, psi);}
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
