#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_230_dxbx_emepadxbx(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_230_dxbx_emepadxbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(20);
  needed_v_smin[x_a].resize(20);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    6,    7,   12,   13,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   30,   31,   32,   33,   36,   37,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  needed_v_smin[x_a][  1] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  needed_v_smin[x_a][  2] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  needed_v_smin[x_a][  3] = {   6,    7,   12,   13,   22,   23,   52,   53,   18,   19}; //  10
  needed_v_smin[x_a][  4] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  needed_v_smin[x_a][  5] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  needed_v_smin[x_a][  6] = {  10,   11,   14,   15,    4,    5,    8,    9}; //   8
  needed_v_smin[x_a][  7] = {  12,   13}; //   2
  needed_v_smin[x_a][  8] = {  16,   17,   44,   45,   46,   47,   50,   51,    0,    1}; //  10
  needed_v_smin[x_a][  9] = {  16,   17,    0,    1,   44,   45}; //   6
  needed_v_smin[x_a][ 10] = {  20,   21,   26,   27,   36,   37,   46,   47,   32,   33,   50,   51}; //  12
  needed_v_smin[x_a][ 11] = {  24,   25,   28,   29,   34,   35,   38,   39}; //   8
  needed_v_smin[x_a][ 12] = {  26,   27,   20,   21,   32,   33}; //   6
  needed_v_smin[x_a][ 13] = {  30,   31,   48,   49,   52,   53,   54,   55,   42,   43}; //  10
  needed_v_smin[x_a][ 14] = {  30,   31,   42,   43,   54,   55}; //   6
  needed_v_smin[x_a][ 15] = {   2,    3,   40,   41}; //   4
  needed_v_smin[x_a][ 16] = {   2,    3,   40,   41}; //   4
  needed_v_smin[x_a][ 17] = {   6,    7,   18,   19,   22,   23}; //   6
  needed_v_smin[x_a][ 18] = {  36,   37}; //   2
  needed_v_smin[x_a][ 19] = {  48,   49}; //   2

  v_smax[x_a].resize(20);
  needed_v_smax[x_a].resize(20);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    6,    7,   12,   13,   18,   19,   20,   21,   22,   23,   26,   27,   32,   33,   36,   37,   40,   41,   42,   43,   46,   47,   50,   51,   54,   55}; //  30
  needed_v_smax[x_a][  1] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  needed_v_smax[x_a][  2] = {   4,    5,    8,    9,   10,   11,   14,   15,   24,   25,   28,   29,   34,   35,   38,   39}; //  16
  needed_v_smax[x_a][  3] = {   6,    7,   12,   13,   22,   23,   18,   19}; //   8
  needed_v_smax[x_a][  4] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  needed_v_smax[x_a][  5] = {  10,   11,   12,   13,   14,   15,   16,   17,    0,    1,    4,    5,    8,    9,   44,   45}; //  16
  needed_v_smax[x_a][  6] = {  16,   17,   44,   45}; //   4
  needed_v_smax[x_a][  7] = {  16,   17,   44,   45}; //   4
  needed_v_smax[x_a][  8] = {  20,   21,   26,   27,   36,   37,   46,   47,   32,   33}; //  10
  needed_v_smax[x_a][  9] = {  24,   25,   26,   27,   28,   29,   30,   31,   20,   21,   32,   33,   34,   35,   38,   39,   42,   43,   54,   55}; //  20
  needed_v_smax[x_a][ 10] = {  30,   31,   48,   49,   52,   53}; //   6
  needed_v_smax[x_a][ 11] = {  30,   31,   48,   49,   52,   53}; //   6
  needed_v_smax[x_a][ 12] = {  46,   47}; //   2
  needed_v_smax[x_a][ 13] = {  50,   51,    0,    1}; //   4
  needed_v_smax[x_a][ 14] = {  52,   53}; //   2
  needed_v_smax[x_a][ 15] = {  54,   55,   42,   43}; //   4
  needed_v_smax[x_a][ 16] = {   2,    3,   40,   41}; //   4
  needed_v_smax[x_a][ 17] = {   2,    3,    6,    7,   18,   19,   22,   23,   36,   37,   40,   41}; //  12
  needed_v_smax[x_a][ 18] = {  48,   49}; //   2
  needed_v_smax[x_a][ 19] = {  50,   51}; //   2

  g_p[x_a].resize(26);
  needed_g_p[x_a].resize(26);
  needed_g_p[x_a][0] = {   0,    2,    6,   12,   18,   20,   22,   26,   32,   36,   40,   42,   46,   50,   54}; //  15
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    3,    7,   13,   19,   21,   23,   27,   33,   37,   41,   43,   47,   51,   55}; //  15
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   4,   10,   24,   34}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   5,   11,   25,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   6,    7,   12,   13,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][7] = {   8,   14,   28,   38}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax2");
  needed_g_p[x_a][8] = {   9,   15,   29,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][9] = {  10,   11,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][10] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][11] = {  16,   17,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][12] = {  16,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax7");
  needed_g_p[x_a][13] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax5");
  needed_g_p[x_a][14] = {  17,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");
  needed_g_p[x_a][15] = {  20,   21,   26,   27,   36,   37,   46,   47}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][16] = {  24,   25,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][17] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][18] = {  30,   31,   48,   49,   52,   53}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][19] = {  30,   48,   52}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax11");
  needed_g_p[x_a][20] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax9");
  needed_g_p[x_a][21] = {  31,   49,   53}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");
  needed_g_p[x_a][22] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax12");
  needed_g_p[x_a][23] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax13");
  needed_g_p[x_a][24] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax14");
  needed_g_p[x_a][25] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax15");

  g_f[x_a].resize(15);
  needed_g_f[x_a].resize(15);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax13");
  needed_g_f[x_a][1] = {   0,    1,   44,   45}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax5");
  needed_g_f[x_a][2] = {   2,    3,   40,   41}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax16");
  needed_g_f[x_a][3] = {   2,    3,   40,   41}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax17");
  needed_g_f[x_a][4] = {   4,    5,    8,    9}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax5");
  needed_g_f[x_a][5] = {   6,    7,   18,   19,   22,   23}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax17");
  needed_g_f[x_a][6] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][7] = {  20,   21,   32,   33}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax9");
  needed_g_f[x_a][8] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][9] = {  34,   35,   38,   39}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax9");
  needed_g_f[x_a][10] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax17");
  needed_g_f[x_a][11] = {  42,   43}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax15");
  needed_g_f[x_a][12] = {  42,   43,   54,   55}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax9");
  needed_g_f[x_a][13] = {  48,   49}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax18");
  needed_g_f[x_a][14] = {  50,   51}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax19");

  g_t[x_a].resize(25);
  needed_g_t[x_a].resize(25);
  needed_g_t[x_a][0] = {   0,    1,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   44,   45}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,    1,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   2,    3,    6,    7}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][6] = {   4,    5,    8,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__32_28");
  needed_g_t[x_a][7] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][8] = {  18,   19,   22,   23,   36,   37,   40,   41}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][9] = {  18,   19,   22,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][10] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][11] = {  20,   21,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   38,   39,   42,   43,   54,   55}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][12] = {  20,   21,   32,   33}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][13] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][14] = {  34,   35,   38,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][15] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][16] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][17] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][18] = {  42,   43,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][19] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][20] = {  46,   47,   50,   51}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][21] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][22] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][23] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][24] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");

  g_d[x_a].resize(15);
  needed_g_d[x_a].resize(15);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    6,    7,   12,   13,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   30,   31,   32,   33,   36,   37,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   6,    7,   12,   13,   22,   23,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][5] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {  10,   11,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][9] = {  16,   17,   44,   45,   46,   47,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][10] = {  20,   21,   26,   27,   36,   37,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][11] = {  24,   25,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][12] = {  26,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][13] = {  30,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][14] = {  30,   31,   48,   49,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");

  c_p[x_a].resize(56);
  c_f[x_a].resize(56);
  c_t[x_a].resize(56);
  c_d[x_a].resize(56);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  1}; //   1
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  0,   1,   2}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  3,   4,   5}; //   3
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  3,   4,   5}; //   3
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  2,   3}; //   2
  c_f[x_a][4] = {  4}; //   1
  c_t[x_a][4] = {  0,   6}; //   2
  c_d[x_a][4] = {  1,   2}; //   2

  c_p[x_a][5] = {  2,   4}; //   2
  c_f[x_a][5] = {  4}; //   1
  c_t[x_a][5] = {  0,   6}; //   2
  c_d[x_a][5] = {  1,   2}; //   2

  c_p[x_a][6] = {  0,   5}; //   2
  c_f[x_a][6] = {  5}; //   1
  c_t[x_a][6] = {  3,   7}; //   2
  c_d[x_a][6] = {  3,   0}; //   2

  c_p[x_a][7] = {  1,   5}; //   2
  c_f[x_a][7] = {  5}; //   1
  c_t[x_a][7] = {  3,   7}; //   2
  c_d[x_a][7] = {  3,   0}; //   2

  c_p[x_a][8] = {  6,   7}; //   2
  c_f[x_a][8] = {  4}; //   1
  c_t[x_a][8] = {  0,   6}; //   2
  c_d[x_a][8] = {  4,   5}; //   2

  c_p[x_a][9] = {  6,   8}; //   2
  c_f[x_a][9] = {  4}; //   1
  c_t[x_a][9] = {  0,   6}; //   2
  c_d[x_a][9] = {  4,   5}; //   2

  c_p[x_a][10] = {  2,   3,   9}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  6,   1,   2}; //   3

  c_p[x_a][11] = {  2,   4,   9}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  6,   1,   2}; //   3

  c_p[x_a][12] = {  0,   5,  10}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  7,   3,   0}; //   3

  c_p[x_a][13] = {  1,   5,  10}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  7,   3,   0}; //   3

  c_p[x_a][14] = {  6,   7,   9}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  6,   4,   5}; //   3

  c_p[x_a][15] = {  6,   8,   9}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  6,   4,   5}; //   3

  c_p[x_a][16] = { 11,  12,  13}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = {  8,   0,   9}; //   3

  c_p[x_a][17] = { 11,  14,  13}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = {  8,   0,   9}; //   3

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  6,   5}; //   2
  c_t[x_a][18] = {  8,   9,  10}; //   3
  c_d[x_a][18] = {  0}; //   1

  c_p[x_a][19] = {  1}; //   1
  c_f[x_a][19] = {  6,   5}; //   2
  c_t[x_a][19] = {  8,   9,  10}; //   3
  c_d[x_a][19] = {  0}; //   1

  c_p[x_a][20] = {  0,  15}; //   2
  c_f[x_a][20] = {  7}; //   1
  c_t[x_a][20] = { 11,  12}; //   2
  c_d[x_a][20] = { 10,   0}; //   2

  c_p[x_a][21] = {  1,  15}; //   2
  c_f[x_a][21] = {  7}; //   1
  c_t[x_a][21] = { 11,  12}; //   2
  c_d[x_a][21] = { 10,   0}; //   2

  c_p[x_a][22] = {  0,   5}; //   2
  c_f[x_a][22] = {  5}; //   1
  c_t[x_a][22] = {  8,   9}; //   2
  c_d[x_a][22] = {  3,   0}; //   2

  c_p[x_a][23] = {  1,   5}; //   2
  c_f[x_a][23] = {  5}; //   1
  c_t[x_a][23] = {  8,   9}; //   2
  c_d[x_a][23] = {  3,   0}; //   2

  c_p[x_a][24] = {  2,   3,  16}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 11}; //   1
  c_d[x_a][24] = { 11,   1,   2}; //   3

  c_p[x_a][25] = {  2,   4,  16}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 11}; //   1
  c_d[x_a][25] = { 11,   1,   2}; //   3

  c_p[x_a][26] = {  0,  15,  17}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 11}; //   1
  c_d[x_a][26] = { 12,  10,   0}; //   3

  c_p[x_a][27] = {  1,  15,  17}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 11}; //   1
  c_d[x_a][27] = { 12,  10,   0}; //   3

  c_p[x_a][28] = {  6,   7,  16}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 11}; //   1
  c_d[x_a][28] = { 11,   4,   5}; //   3

  c_p[x_a][29] = {  6,   8,  16}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 11}; //   1
  c_d[x_a][29] = { 11,   4,   5}; //   3

  c_p[x_a][30] = { 18,  19,  20}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = { 11}; //   1
  c_d[x_a][30] = { 13,   0,  14}; //   3

  c_p[x_a][31] = { 18,  21,  20}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = { 11}; //   1
  c_d[x_a][31] = { 13,   0,  14}; //   3

  c_p[x_a][32] = {  0}; //   1
  c_f[x_a][32] = {  8,   7}; //   2
  c_t[x_a][32] = { 11,  12,  13}; //   3
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = {  1}; //   1
  c_f[x_a][33] = {  8,   7}; //   2
  c_t[x_a][33] = { 11,  12,  13}; //   3
  c_d[x_a][33] = {  0}; //   1

  c_p[x_a][34] = {  2,   3}; //   2
  c_f[x_a][34] = {  9}; //   1
  c_t[x_a][34] = { 11,  14}; //   2
  c_d[x_a][34] = {  1,   2}; //   2

  c_p[x_a][35] = {  2,   4}; //   2
  c_f[x_a][35] = {  9}; //   1
  c_t[x_a][35] = { 11,  14}; //   2
  c_d[x_a][35] = {  1,   2}; //   2

  c_p[x_a][36] = {  0,  15}; //   2
  c_f[x_a][36] = { 10}; //   1
  c_t[x_a][36] = {  8,  15}; //   2
  c_d[x_a][36] = { 10,   0}; //   2

  c_p[x_a][37] = {  1,  15}; //   2
  c_f[x_a][37] = { 10}; //   1
  c_t[x_a][37] = {  8,  15}; //   2
  c_d[x_a][37] = { 10,   0}; //   2

  c_p[x_a][38] = {  6,   7}; //   2
  c_f[x_a][38] = {  9}; //   1
  c_t[x_a][38] = { 11,  14}; //   2
  c_d[x_a][38] = {  4,   5}; //   2

  c_p[x_a][39] = {  6,   8}; //   2
  c_f[x_a][39] = {  9}; //   1
  c_t[x_a][39] = { 11,  14}; //   2
  c_d[x_a][39] = {  4,   5}; //   2

  c_p[x_a][40] = {  0}; //   1
  c_f[x_a][40] = {  2,   3}; //   2
  c_t[x_a][40] = {  8,  16,  17}; //   3
  c_d[x_a][40] = {  0}; //   1

  c_p[x_a][41] = {  1}; //   1
  c_f[x_a][41] = {  2,   3}; //   2
  c_t[x_a][41] = {  8,  16,  17}; //   3
  c_d[x_a][41] = {  0}; //   1

  c_p[x_a][42] = {  0}; //   1
  c_f[x_a][42] = { 11,  12}; //   2
  c_t[x_a][42] = { 11,  18,  19}; //   3
  c_d[x_a][42] = {  0}; //   1

  c_p[x_a][43] = {  1}; //   1
  c_f[x_a][43] = { 11,  12}; //   2
  c_t[x_a][43] = { 11,  18,  19}; //   3
  c_d[x_a][43] = {  0}; //   1

  c_p[x_a][44] = { 11,  12}; //   2
  c_f[x_a][44] = {  1}; //   1
  c_t[x_a][44] = {  0,   1}; //   2
  c_d[x_a][44] = {  0,   9}; //   2

  c_p[x_a][45] = { 11,  14}; //   2
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  0,   1}; //   2
  c_d[x_a][45] = {  0,   9}; //   2

  c_p[x_a][46] = {  0,  15,  22}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 20}; //   1
  c_d[x_a][46] = {  9,  10,   0}; //   3

  c_p[x_a][47] = {  1,  15,  22}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 20}; //   1
  c_d[x_a][47] = {  9,  10,   0}; //   3

  c_p[x_a][48] = { 18,  19}; //   2
  c_f[x_a][48] = { 13}; //   1
  c_t[x_a][48] = { 21,  22}; //   2
  c_d[x_a][48] = {  0,  14}; //   2

  c_p[x_a][49] = { 18,  21}; //   2
  c_f[x_a][49] = { 13}; //   1
  c_t[x_a][49] = { 21,  22}; //   2
  c_d[x_a][49] = {  0,  14}; //   2

  c_p[x_a][50] = {  0,  23}; //   2
  c_f[x_a][50] = { 14}; //   1
  c_t[x_a][50] = { 20,  23}; //   2
  c_d[x_a][50] = {  9,   0}; //   2

  c_p[x_a][51] = {  1,  23}; //   2
  c_f[x_a][51] = { 14}; //   1
  c_t[x_a][51] = { 20,  23}; //   2
  c_d[x_a][51] = {  9,   0}; //   2

  c_p[x_a][52] = { 18,  19,  24}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = { 24}; //   1
  c_d[x_a][52] = {  3,   0,  14}; //   3

  c_p[x_a][53] = { 18,  21,  24}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = { 24}; //   1
  c_d[x_a][53] = {  3,   0,  14}; //   3

  c_p[x_a][54] = {  0,  25}; //   2
  c_f[x_a][54] = { 12}; //   1
  c_t[x_a][54] = { 11,  18}; //   2
  c_d[x_a][54] = { 14,   0}; //   2

  c_p[x_a][55] = {  1,  25}; //   2
  c_f[x_a][55] = { 12}; //   1
  c_t[x_a][55] = { 11,  18}; //   2
  c_d[x_a][55] = { 14,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel    1: 2v111(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
// channel    2: 2v111(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel    3: 2v111(1, 2, 4, 8, 32, 64, 16;  23,   0,   0,   0)
// channel    4: 3yv11(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel    5: 3yv11(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
// channel    6: 3yv11(1, 2, 32, 4, 8, 64, 16;   0,   0,   0,   0)
// channel    7: 3yv11(1, 2, 32, 4, 8, 64, 16;  23,   0,   0,   0)
// channel    8: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel    9: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,  23,   0,   0)
// channel   10: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   11: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   12: 4yyv1(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel   13: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
// channel   14: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel   15: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,  23,   0,   0)
// channel   16: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   17: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
// channel   18: 12v11(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel   19: 12v11(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
// channel   20: 13yv1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   21: 13yv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   22: 13yv1(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel   23: 13yv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
// channel   24: 14yyv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   25: 14yyv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   26: 14yyv(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   27: 14yyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   28: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   29: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   30: 142vv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   31: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   32: 112v1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   33: 112v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   34: 113yv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   35: 113yv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   36: 113yv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   37: 113yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   38: 113yv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   39: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   40: 1112v(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   41: 1112v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   42: 1112v(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel   43: 1112v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
// channel   44: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   45: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
// channel   46: 2v3yv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   47: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   48: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel   49: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  23,   0,   0)
// channel   50: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   51: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   52: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   53: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   54: 12v2v(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   55: 12v2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
