#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_130_bbx_emepag(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_130_bbx_emepag");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(7);
  needed_v_smin[x_a].resize(7);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   16,   17,   18,   19}; //  12
  needed_v_smin[x_a][  1] = {   4,    5,   12,   13}; //   4
  needed_v_smin[x_a][  2] = {   4,    5,   12,   13}; //   4
  needed_v_smin[x_a][  3] = {   6,    7,   14,   15}; //   4
  needed_v_smin[x_a][  4] = {   6,    7,   14,   15}; //   4
  needed_v_smin[x_a][  5] = {   0,    1,    8,    9,   18,   19}; //   6
  needed_v_smin[x_a][  6] = {   2,    3,   10,   11,   16,   17}; //   6

  v_smax[x_a].resize(5);
  needed_v_smax[x_a].resize(5);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   16,   17,   18,   19}; //  12
  needed_v_smax[x_a][  1] = {   4,    5,   12,   13}; //   4
  needed_v_smax[x_a][  2] = {   4,    5,    6,    7,   12,   13,   14,   15,    0,    1,    8,    9,   18,   19}; //  14
  needed_v_smax[x_a][  3] = {   6,    7,   14,   15}; //   4
  needed_v_smax[x_a][  4] = {   2,    3,   10,   11,   16,   17}; //   6

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   0,    2,    8,   10,   16,   18}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    3,    9,   11,   17,   19}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   4,    5,   12,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   4,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   5,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   6,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][7] = {   7,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1,    8,    9,   18,   19}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax2");
  needed_g_f[x_a][1] = {   2,    3,   10,   11,   16,   17}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    1,    4,    5,    6,    7}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][4] = {   8,    9,   12,   13,   14,   15,   18,   19}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][5] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][6] = {  10,   11,   16,   17}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][7] = {  10,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][8] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][9] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");

  g_d[x_a].resize(5);
  needed_g_d[x_a].resize(5);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    8,    9,   10,   11,   16,   17,   18,   19}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,    5,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {   4,    5,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  1}; //   1
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  2,   3}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  1,   2}; //   2

  c_p[x_a][5] = {  2,   4}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  1,   2}; //   2

  c_p[x_a][6] = {  5,   6}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  3,   4}; //   2

  c_p[x_a][7] = {  5,   7}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  3,   4}; //   2

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  4,   5}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  1}; //   1
  c_f[x_a][9] = {  0}; //   1
  c_t[x_a][9] = {  4,   5}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  1}; //   1
  c_t[x_a][10] = {  6,   7}; //   2
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  6,   7}; //   2
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  2,   3}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  4}; //   1
  c_d[x_a][12] = {  1,   2}; //   2

  c_p[x_a][13] = {  2,   4}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  4}; //   1
  c_d[x_a][13] = {  1,   2}; //   2

  c_p[x_a][14] = {  5,   6}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  4}; //   1
  c_d[x_a][14] = {  3,   4}; //   2

  c_p[x_a][15] = {  5,   7}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  4}; //   1
  c_d[x_a][15] = {  3,   4}; //   2

  c_p[x_a][16] = {  0}; //   1
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  6,   8}; //   2
  c_d[x_a][16] = {  0}; //   1

  c_p[x_a][17] = {  1}; //   1
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  6,   8}; //   2
  c_d[x_a][17] = {  0}; //   1

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  0}; //   1
  c_t[x_a][18] = {  4,   9}; //   2
  c_d[x_a][18] = {  0}; //   1

  c_p[x_a][19] = {  1}; //   1
  c_f[x_a][19] = {  0}; //   1
  c_t[x_a][19] = {  4,   9}; //   2
  c_d[x_a][19] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    1: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
// channel    2: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel    3: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
// channel    4: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    5: 3yv1(1, 2, 4, 8, 16, 32;   0,  23,   0)
// channel    6: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel    7: 3yv1(1, 2, 8, 4, 16, 32;   0,  23,   0)
// channel    8: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    9: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel   10: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   11: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel   12: 13yv(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel   13: 13yv(1, 2, 32, 4, 8, 16;   0,  23,   0)
// channel   14: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel   15: 13yv(1, 2, 32, 8, 4, 16;   0,  23,   0)
// channel   16: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   17: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   18: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel   19: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
void ppeexa03_phasespace_set::ax_psp_330_bbx_emepag(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_330_bbx_emepag");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(8);
  needed_v_smin[x_a].resize(8);
  int needed_v_smin_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  20
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 20);
  int needed_v_smin_1[] = {   0,    1,    4,    5,    6,    7,   18,   19}; //   8
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 8);
  int needed_v_smin_2[] = {   2,    3}; //   2
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   2,    3}; //   2
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 2);
  int needed_v_smin_4[] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {  12,   13}; //   2
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 2);
  int needed_v_smin_6[] = {  12,   13}; //   2
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {  14,   15,   16,   17,   20,   21,   22,   23}; //   8
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 8);

  v_smax[x_a].resize(8);
  needed_v_smax[x_a].resize(8);
  int needed_v_smax_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   22,   23}; //  14
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 14);
  int needed_v_smax_1[] = {   0,    1,    4,    5,    6,    7,   18,   19}; //   8
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 8);
  int needed_v_smax_2[] = {   2,    3}; //   2
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 2);
  int needed_v_smax_3[] = {   2,    3,    8,    9,   10,   11,   12,   13}; //   8
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 8);
  int needed_v_smax_4[] = {  12,   13}; //   2
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 2);
  int needed_v_smax_5[] = {  14,   15,   16,   17,   20,   21}; //   6
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 6);
  int needed_v_smax_6[] = {  14,   15,   16,   17,   20,   21}; //   6
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 6);
  int needed_v_smax_7[] = {  22,   23}; //   2
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 2);

  g_p[x_a].resize(17);
  needed_g_p[x_a].resize(17);
  needed_g_p[x_a][0] = {   0,    4,    5,    8,    9,   18,   22}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    4,    6,   18,   19}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    6,    7,   10,   11,   19,   23}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][6] = {   5,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin1_smax1");
  needed_g_p[x_a][7] = {   8,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][8] = {   9,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin4_smax3");
  needed_g_p[x_a][9] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][10] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax3");
  needed_g_p[x_a][11] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax3");
  needed_g_p[x_a][12] = {  14,   15,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][13] = {  14,   16,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][14] = {  15,   17,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][15] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin7_smax5");
  needed_g_p[x_a][16] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax7");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][1] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][2] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][3] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   0,    1,    4,    5,    6,    7,   18,   19}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][1] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   2,    3,    8,    9,   10,   11,   12,   13}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][6] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][7] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][9] = {  14,   15,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][10] = {  14,   15,   16,   17,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  2,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1}; //   2

  c_p[x_a][2] = {  3,   4}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  2,   3,   4}; //   3

  c_p[x_a][3] = {  3,   5}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  2,   3,   4}; //   3

  c_p[x_a][4] = {  0,   1}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  5,   0,   1}; //   3

  c_p[x_a][5] = {  0,   6}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,   0,   1}; //   3

  c_p[x_a][6] = {  2,   1}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  5,   0,   1}; //   3

  c_p[x_a][7] = {  2,   6}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,   0,   1}; //   3

  c_p[x_a][8] = {  0,   7}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  2,   6,   1}; //   3

  c_p[x_a][9] = {  0,   8}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  2,   6,   1}; //   3

  c_p[x_a][10] = {  2,   7}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  2,   6,   1}; //   3

  c_p[x_a][11] = {  2,   8}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  2,   6,   1}; //   3

  c_p[x_a][12] = {  9,  10}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  2,   7,   8}; //   3

  c_p[x_a][13] = {  9,  11}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  2,   7,   8}; //   3

  c_p[x_a][14] = { 12,  13}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  9,   1,  10}; //   3

  c_p[x_a][15] = { 12,  14}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  9,   1,  10}; //   3

  c_p[x_a][16] = { 15,  13}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  9,   1,  10}; //   3

  c_p[x_a][17] = { 15,  14}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  9,   1,  10}; //   3

  c_p[x_a][18] = {  0,   1}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  1}; //   1
  c_d[x_a][18] = {  0,   1}; //   2

  c_p[x_a][19] = {  2,   1}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  1}; //   1
  c_d[x_a][19] = {  0,   1}; //   2

  c_p[x_a][20] = { 12,  13}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  2}; //   1
  c_d[x_a][20] = {  1,  10}; //   2

  c_p[x_a][21] = { 12,  14}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  2}; //   1
  c_d[x_a][21] = {  1,  10}; //   2

  c_p[x_a][22] = {  0,  16}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  3}; //   1
  c_d[x_a][22] = { 10,   1}; //   2

  c_p[x_a][23] = {  2,  16}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  3}; //   1
  c_d[x_a][23] = { 10,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
