#include "header.hpp"

#include "ppeexexne04.phasespace.set.hpp"

void ppeexexne04_phasespace_set::ax_psp_240_ddx_emepepvescx(int x_a){
  static Logger logger("ppeexexne04_phasespace_set::ax_psp_240_ddx_emepepvescx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(37);
  needed_v_smin[x_a].resize(37);
  needed_v_smin[x_a][  0] = {   0,    1,   20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   42,   43,   46,   47,   52,   53,   54,   55,   60,   61,   62,   63}; //  26
  needed_v_smin[x_a][  1] = {   0,    1}; //   2
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  3] = {   0,    2,    4,    5,    8,   10,   12,   13,   16,   17,   20,   21}; //  12
  needed_v_smin[x_a][  4] = {   1,    3,    6,    7,    9,   11,   14,   15,   18,   19,   22,   23}; //  12
  needed_v_smin[x_a][  5] = {   2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   24,   25,   26,   27,   32,   33,   34,   35,   40,   41,   44,   45,   48,   49,   50,   51,   56,   57,   58,   59}; //  30
  needed_v_smin[x_a][  6] = {   2,    3}; //   2
  needed_v_smin[x_a][  7] = {   4,    5,    6,    7}; //   4
  needed_v_smin[x_a][  8] = {   4,    5,    6,    7,   12,   13,   14,   15}; //   8
  needed_v_smin[x_a][  9] = {   8,    9,   16,   17,   18,   19,   24,   25,   26,   27,   32,   33,   34,   35,   40,   41,   44,   45,   48,   49,   50,   51,   56,   57,   58,   59}; //  26
  needed_v_smin[x_a][ 10] = {   8,    9}; //   2
  needed_v_smin[x_a][ 11] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][ 12] = {  10,   11,   12,   13,   14,   15,   20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   42,   43,   46,   47,   52,   53,   54,   55,   60,   61,   62,   63}; //  30
  needed_v_smin[x_a][ 13] = {  10,   11}; //   2
  needed_v_smin[x_a][ 14] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][ 15] = {  16,   17,   18,   19}; //   4
  needed_v_smin[x_a][ 16] = {  20,   21,   22,   23}; //   4
  needed_v_smin[x_a][ 17] = {  24,   25,   44,   45,   50,   51,   58,   59}; //   8
  needed_v_smin[x_a][ 18] = {  24,   25}; //   2
  needed_v_smin[x_a][ 19] = {  26,   27,   40,   41,   48,   49,   56,   57}; //   8
  needed_v_smin[x_a][ 20] = {  26,   27}; //   2
  needed_v_smin[x_a][ 21] = {  28,   29,   46,   47,   54,   55,   62,   63}; //   8
  needed_v_smin[x_a][ 22] = {  28,   29}; //   2
  needed_v_smin[x_a][ 23] = {  30,   31,   42,   43,   52,   53,   60,   61}; //   8
  needed_v_smin[x_a][ 24] = {  30,   31}; //   2
  needed_v_smin[x_a][ 25] = {  32,   33,   40,   41}; //   4
  needed_v_smin[x_a][ 26] = {  32,   33}; //   2
  needed_v_smin[x_a][ 27] = {  34,   35,   44,   45}; //   4
  needed_v_smin[x_a][ 28] = {  34,   35}; //   2
  needed_v_smin[x_a][ 29] = {  36,   37,   42,   43}; //   4
  needed_v_smin[x_a][ 30] = {  36,   37}; //   2
  needed_v_smin[x_a][ 31] = {  38,   39,   46,   47}; //   4
  needed_v_smin[x_a][ 32] = {  38,   39}; //   2
  needed_v_smin[x_a][ 33] = {  48,   49,   56,   57}; //   4
  needed_v_smin[x_a][ 34] = {  50,   51,   58,   59}; //   4
  needed_v_smin[x_a][ 35] = {  52,   53,   60,   61}; //   4
  needed_v_smin[x_a][ 36] = {  54,   55,   62,   63}; //   4

  v_smax[x_a].resize(46);
  needed_v_smax[x_a].resize(46);
  needed_v_smax[x_a][  0] = {   0,    1,   20,   21,   22,   23,   28,   29,   30,   31,   42,   43,   52,   53,   54,   55}; //  16
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  needed_v_smax[x_a][  3] = {   0,    2,    4,    5,    8,   10,   12,   13,   16,   17,   20,   21,   26,   27,   30,   31,   34,   35,   38,   39}; //  20
  needed_v_smax[x_a][  4] = {   1,    3,    6,    7,    9,   11,   14,   15,   18,   19,   22,   23,   24,   25,   28,   29,   32,   33,   36,   37}; //  20
  needed_v_smax[x_a][  5] = {   2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   44,   45,   56,   57,   58,   59}; //  16
  needed_v_smax[x_a][  6] = {   4,    5,    6,    7,   12,   13,   14,   15}; //   8
  needed_v_smax[x_a][  7] = {   8,    9,   16,   17,   18,   19,   24,   25,   26,   27,   40,   41,   48,   49,   50,   51}; //  16
  needed_v_smax[x_a][  8] = {   8,    9,   10,   11}; //   4
  needed_v_smax[x_a][  9] = {  10,   11,   12,   13,   14,   15,   36,   37,   38,   39,   46,   47,   60,   61,   62,   63}; //  16
  needed_v_smax[x_a][ 10] = {  16,   17,   18,   19,   40,   41}; //   6
  needed_v_smax[x_a][ 11] = {  20,   21,   22,   23,   42,   43}; //   6
  needed_v_smax[x_a][ 12] = {  24,   25,   50,   51}; //   4
  needed_v_smax[x_a][ 13] = {  24,   25}; //   2
  needed_v_smax[x_a][ 14] = {  26,   27,   48,   49}; //   4
  needed_v_smax[x_a][ 15] = {  26,   27}; //   2
  needed_v_smax[x_a][ 16] = {  28,   29,   54,   55}; //   4
  needed_v_smax[x_a][ 17] = {  28,   29}; //   2
  needed_v_smax[x_a][ 18] = {  30,   31,   52,   53}; //   4
  needed_v_smax[x_a][ 19] = {  30,   31}; //   2
  needed_v_smax[x_a][ 20] = {  32,   33}; //   2
  needed_v_smax[x_a][ 21] = {  32,   33}; //   2
  needed_v_smax[x_a][ 22] = {  34,   35}; //   2
  needed_v_smax[x_a][ 23] = {  34,   35}; //   2
  needed_v_smax[x_a][ 24] = {  36,   37}; //   2
  needed_v_smax[x_a][ 25] = {  36,   37}; //   2
  needed_v_smax[x_a][ 26] = {  38,   39}; //   2
  needed_v_smax[x_a][ 27] = {  38,   39}; //   2
  needed_v_smax[x_a][ 28] = {  40,   41,   56,   57}; //   4
  needed_v_smax[x_a][ 29] = {  40,   41}; //   2
  needed_v_smax[x_a][ 30] = {  42,   43,   60,   61}; //   4
  needed_v_smax[x_a][ 31] = {  42,   43}; //   2
  needed_v_smax[x_a][ 32] = {  44,   45,   56,   57,   58,   59}; //   6
  needed_v_smax[x_a][ 33] = {  44,   45}; //   2
  needed_v_smax[x_a][ 34] = {  44,   45}; //   2
  needed_v_smax[x_a][ 35] = {  46,   47,   60,   61,   62,   63}; //   6
  needed_v_smax[x_a][ 36] = {  46,   47}; //   2
  needed_v_smax[x_a][ 37] = {  46,   47}; //   2
  needed_v_smax[x_a][ 38] = {  48,   49,   50,   51}; //   4
  needed_v_smax[x_a][ 39] = {  48,   49,   50,   51}; //   4
  needed_v_smax[x_a][ 40] = {  52,   53,   54,   55}; //   4
  needed_v_smax[x_a][ 41] = {  52,   53,   54,   55}; //   4
  needed_v_smax[x_a][ 42] = {  56,   57,   58,   59}; //   4
  needed_v_smax[x_a][ 43] = {  58,   59}; //   2
  needed_v_smax[x_a][ 44] = {  60,   61,   62,   63}; //   4
  needed_v_smax[x_a][ 45] = {  62,   63}; //   2

  g_p[x_a].resize(75);
  needed_g_p[x_a].resize(75);
  needed_g_p[x_a][0] = {   0,    1,   20,   21,   22,   23,   28,   29,   30,   31,   42,   43,   52,   53,   54,   55}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    2,    4,    5,    8,   10,   12,   13,   16,   17,   20,   21}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    6,    7,    9,   11,   14,   15,   18,   19,   22,   23}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   2,    3,    5,    7,   33,   35,   45,   57,   59}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax5");
  needed_g_p[x_a][6] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][7] = {   4,    6,   32,   34,   44,   56,   58}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][8] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   4,    5,    6,    7,   12,   13,   14,   15}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][10] = {   8,    9,   16,   17,   18,   19,   24,   25,   26,   27,   40,   41,   48,   49,   50,   51}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax7");
  needed_g_p[x_a][11] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][12] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax2");
  needed_g_p[x_a][13] = {  10,   11,   13,   15,   37,   39,   47,   61,   63}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax9");
  needed_g_p[x_a][14] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax8");
  needed_g_p[x_a][15] = {  12,   14,   36,   38,   46,   60,   62}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][16] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax6");
  needed_g_p[x_a][17] = {  16,   18,   40}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax10");
  needed_g_p[x_a][18] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax2");
  needed_g_p[x_a][19] = {  17,   19,   41}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax10");
  needed_g_p[x_a][20] = {  20,   22,   42}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax11");
  needed_g_p[x_a][21] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin16_smax2");
  needed_g_p[x_a][22] = {  21,   23,   43}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax11");
  needed_g_p[x_a][23] = {  24,   25,   50,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax12");
  needed_g_p[x_a][24] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax13");
  needed_g_p[x_a][25] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax4");
  needed_g_p[x_a][26] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax13");
  needed_g_p[x_a][27] = {  26,   27,   48,   49}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax14");
  needed_g_p[x_a][28] = {  26}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax15");
  needed_g_p[x_a][29] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax3");
  needed_g_p[x_a][30] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax15");
  needed_g_p[x_a][31] = {  28,   29,   54,   55}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax16");
  needed_g_p[x_a][32] = {  28}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax17");
  needed_g_p[x_a][33] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax4");
  needed_g_p[x_a][34] = {  29}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax17");
  needed_g_p[x_a][35] = {  30,   31,   52,   53}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax18");
  needed_g_p[x_a][36] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax19");
  needed_g_p[x_a][37] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax3");
  needed_g_p[x_a][38] = {  31}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax19");
  needed_g_p[x_a][39] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax20");
  needed_g_p[x_a][40] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax21");
  needed_g_p[x_a][41] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin26_smax4");
  needed_g_p[x_a][42] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin27_smax22");
  needed_g_p[x_a][43] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax23");
  needed_g_p[x_a][44] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin28_smax3");
  needed_g_p[x_a][45] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax24");
  needed_g_p[x_a][46] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax25");
  needed_g_p[x_a][47] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin30_smax4");
  needed_g_p[x_a][48] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin31_smax26");
  needed_g_p[x_a][49] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax27");
  needed_g_p[x_a][50] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin32_smax3");
  needed_g_p[x_a][51] = {  40,   41,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax28");
  needed_g_p[x_a][52] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax29");
  needed_g_p[x_a][53] = {  42,   43,   60,   61}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax30");
  needed_g_p[x_a][54] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax31");
  needed_g_p[x_a][55] = {  44,   45,   56,   57,   58,   59}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax32");
  needed_g_p[x_a][56] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin27_smax33");
  needed_g_p[x_a][57] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax34");
  needed_g_p[x_a][58] = {  46,   47,   60,   61,   62,   63}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax35");
  needed_g_p[x_a][59] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin31_smax36");
  needed_g_p[x_a][60] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax37");
  needed_g_p[x_a][61] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax38");
  needed_g_p[x_a][62] = {  48,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax39");
  needed_g_p[x_a][63] = {  49,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax39");
  needed_g_p[x_a][64] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax38");
  needed_g_p[x_a][65] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin35_smax40");
  needed_g_p[x_a][66] = {  52,   54}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax41");
  needed_g_p[x_a][67] = {  53,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax41");
  needed_g_p[x_a][68] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin36_smax40");
  needed_g_p[x_a][69] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax42");
  needed_g_p[x_a][70] = {  58,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax43");
  needed_g_p[x_a][71] = {  58,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax42");
  needed_g_p[x_a][72] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin35_smax44");
  needed_g_p[x_a][73] = {  62,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax45");
  needed_g_p[x_a][74] = {  62,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin36_smax44");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {  48,   49,   50,   51}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][1] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][2] = {  56,   57,   58,   59}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][3] = {  60,   61,   62,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_232");

  g_d[x_a].resize(43);
  needed_g_d[x_a].resize(43);
  needed_g_d[x_a][0] = {   0,    2,    4,    5,    8,   10,   12,   13,   16,   17,   20,   21,   26,   27,   30,   31,   34,   35,   38,   39}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][1] = {   0,    2,    4,    5,    8,   10,   12,   13,   16,   17,   20,   21}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][2] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][3] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][4] = {   0,    1,   20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   42,   43,   46,   47,   52,   53,   54,   55,   60,   61,   62,   63}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][5] = {   1,    3,    6,    7,    9,   11,   14,   15,   18,   19,   22,   23,   24,   25,   28,   29,   32,   33,   36,   37}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][6] = {   1,    3,    6,    7,    9,   11,   14,   15,   18,   19,   22,   23}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][7] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][8] = {   2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   24,   25,   26,   27,   32,   33,   34,   35,   40,   41,   44,   45,   48,   49,   50,   51,   56,   57,   58,   59}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][9] = {   4,    5,    6,    7,   12,   13,   14,   15}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][10] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   8,    9,   16,   17,   18,   19,   24,   25,   26,   27,   32,   33,   34,   35,   40,   41,   44,   45,   48,   49,   50,   51,   56,   57,   58,   59}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][14] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][15] = {  10,   11,   12,   13,   14,   15,   20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   42,   43,   46,   47,   52,   53,   54,   55,   60,   61,   62,   63}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][16] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][17] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][18] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][19] = {  24,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][20] = {  24,   25,   44,   45,   50,   51,   58,   59}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][21] = {  26,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][22] = {  26,   27,   40,   41,   48,   49,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][23] = {  28,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][24] = {  28,   29,   46,   47,   54,   55,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][25] = {  30,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__20_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__20_168");
  needed_g_d[x_a][26] = {  30,   31,   42,   43,   52,   53,   60,   61}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_168__128_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_168__128_40");
  needed_g_d[x_a][27] = {  32,   33}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][28] = {  32,   33,   40,   41}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][29] = {  34,   35}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][30] = {  34,   35,   44,   45}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][31] = {  36,   37}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][32] = {  36,   37,   42,   43}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][33] = {  38,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__40_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__40_148");
  needed_g_d[x_a][34] = {  38,   39,   46,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][35] = {  40,   41}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__76_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__76_176");
  needed_g_d[x_a][36] = {  42,   43}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__84_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__84_168");
  needed_g_d[x_a][37] = {  44,   45}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__112_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__112_140");
  needed_g_d[x_a][38] = {  46,   47}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__104_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__104_148");
  needed_g_d[x_a][39] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__64_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__64_176");
  needed_g_d[x_a][40] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__128_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__128_112");
  needed_g_d[x_a][41] = {  52,   53,   60,   61}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_232__64_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_232__64_168");
  needed_g_d[x_a][42] = {  54,   55,   62,   63}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_232__128_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_232__128_104");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][1] = {  0,   1,   2,   4}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][2] = {  5,   6,   2,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   2,   7,   8}; //   5

  c_p[x_a][3] = {  5,   6,   2,   4}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   2,   7,   8}; //   5

  c_p[x_a][4] = {  7,   8,   9,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   1,   9,  10,   8}; //   5

  c_p[x_a][5] = {  5,   8,   9,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   1,   9,  10,   8}; //   5

  c_p[x_a][6] = {  7,   8,   9,   4}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  5,   6,   9,  10,   8}; //   5

  c_p[x_a][7] = {  5,   8,   9,   4}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,   6,   9,  10,   8}; //   5

  c_p[x_a][8] = { 10,  11,  12,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   1,  11,  12,  13}; //   5

  c_p[x_a][9] = { 10,  11,  12,   4}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  5,   6,  11,  12,  13}; //   5

  c_p[x_a][10] = { 13,  14,  12,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,   1,  11,  14,  15}; //   5

  c_p[x_a][11] = { 13,  14,  12,   4}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,  11,  14,  15}; //   5

  c_p[x_a][12] = { 15,  16,   9,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,   1,   9,  16,  15}; //   5

  c_p[x_a][13] = { 13,  16,   9,   3}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  0,   1,   9,  16,  15}; //   5

  c_p[x_a][14] = { 15,  16,   9,   4}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  5,   6,   9,  16,  15}; //   5

  c_p[x_a][15] = { 13,  16,   9,   4}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  5,   6,   9,  16,  15}; //   5

  c_p[x_a][16] = { 10,  17,  18,   3}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  0,   1,  17,   8,  13}; //   5

  c_p[x_a][17] = { 10,  19,  18,   3}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  0,   1,  17,   8,  13}; //   5

  c_p[x_a][18] = { 10,  17,  18,   4}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  5,   6,  17,   8,  13}; //   5

  c_p[x_a][19] = { 10,  19,  18,   4}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  5,   6,  17,   8,  13}; //   5

  c_p[x_a][20] = {  0,  20,  21,   3}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  0,   1,  18,  15,   4}; //   5

  c_p[x_a][21] = {  0,  22,  21,   3}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  0,   1,  18,  15,   4}; //   5

  c_p[x_a][22] = {  0,  20,  21,   4}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  5,   6,  18,  15,   4}; //   5

  c_p[x_a][23] = {  0,  22,  21,   4}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  5,   6,  18,  15,   4}; //   5

  c_p[x_a][24] = { 10,  23,  24,  25}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  5,  19,   8,  20,  13}; //   5

  c_p[x_a][25] = { 10,  23,  26,  25}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = {  5,  19,   8,  20,  13}; //   5

  c_p[x_a][26] = { 10,  27,  28,  29}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = {  0,  21,   8,  22,  13}; //   5

  c_p[x_a][27] = { 10,  27,  30,  29}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = {  0,  21,   8,  22,  13}; //   5

  c_p[x_a][28] = {  0,  31,  32,  33}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = {  5,  23,  15,  24,   4}; //   5

  c_p[x_a][29] = {  0,  31,  34,  33}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = {  5,  23,  15,  24,   4}; //   5

  c_p[x_a][30] = {  0,  35,  36,  37}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = {  0,  25,  15,  26,   4}; //   5

  c_p[x_a][31] = {  0,  35,  38,  37}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = {  0,  25,  15,  26,   4}; //   5

  c_p[x_a][32] = {  7,  39,  40,  41}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = {  5,  27,  13,  28,   8}; //   5

  c_p[x_a][33] = {  5,  39,  40,  41}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = {  5,  27,  13,  28,   8}; //   5

  c_p[x_a][34] = {  7,  42,  43,  44}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = {  0,  29,  13,  30,   8}; //   5

  c_p[x_a][35] = {  5,  42,  43,  44}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = {  0,  29,  13,  30,   8}; //   5

  c_p[x_a][36] = { 15,  45,  46,  47}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = {  5,  31,   4,  32,  15}; //   5

  c_p[x_a][37] = { 13,  45,  46,  47}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = {  5,  31,   4,  32,  15}; //   5

  c_p[x_a][38] = { 15,  48,  49,  50}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = {  0,  33,   4,  34,  15}; //   5

  c_p[x_a][39] = { 13,  48,  49,  50}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = {  0,  33,   4,  34,  15}; //   5

  c_p[x_a][40] = { 10,  17,  51,  52}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 35,  28,  22,   8,  13}; //   5

  c_p[x_a][41] = { 10,  19,  51,  52}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 35,  28,  22,   8,  13}; //   5

  c_p[x_a][42] = {  0,  20,  53,  54}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 36,  32,  26,  15,   4}; //   5

  c_p[x_a][43] = {  0,  22,  53,  54}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = { 36,  32,  26,  15,   4}; //   5

  c_p[x_a][44] = {  7,  55,  56,  57}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = { 37,  20,  30,  13,   8}; //   5

  c_p[x_a][45] = {  5,  55,  56,  57}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = { 37,  20,  30,  13,   8}; //   5

  c_p[x_a][46] = { 15,  58,  59,  60}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = { 38,  24,  34,   4,  15}; //   5

  c_p[x_a][47] = { 13,  58,  59,  60}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = { 38,  24,  34,   4,  15}; //   5

  c_p[x_a][48] = { 10,  27,  61,  62}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  0}; //   1
  c_d[x_a][48] = {  8,  39,  22,  13}; //   4

  c_p[x_a][49] = { 10,  27,  61,  63}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  0}; //   1
  c_d[x_a][49] = {  8,  39,  22,  13}; //   4

  c_p[x_a][50] = { 10,  23,  64,  62}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  0}; //   1
  c_d[x_a][50] = {  8,  40,  20,  13}; //   4

  c_p[x_a][51] = { 10,  23,  64,  63}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  0}; //   1
  c_d[x_a][51] = {  8,  40,  20,  13}; //   4

  c_p[x_a][52] = {  0,  35,  65,  66}; //   4
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  1}; //   1
  c_d[x_a][52] = { 15,  41,  26,   4}; //   4

  c_p[x_a][53] = {  0,  35,  65,  67}; //   4
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  1}; //   1
  c_d[x_a][53] = { 15,  41,  26,   4}; //   4

  c_p[x_a][54] = {  0,  31,  68,  66}; //   4
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  1}; //   1
  c_d[x_a][54] = { 15,  42,  24,   4}; //   4

  c_p[x_a][55] = {  0,  31,  68,  67}; //   4
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  1}; //   1
  c_d[x_a][55] = { 15,  42,  24,   4}; //   4

  c_p[x_a][56] = {  7,  55,  51,  69}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  2}; //   1
  c_d[x_a][56] = { 39,  22,  13,   8}; //   4

  c_p[x_a][57] = {  5,  55,  51,  69}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  2}; //   1
  c_d[x_a][57] = { 39,  22,  13,   8}; //   4

  c_p[x_a][58] = {  7,  55,  70,  71}; //   4
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  2}; //   1
  c_d[x_a][58] = { 40,  20,  13,   8}; //   4

  c_p[x_a][59] = {  5,  55,  70,  71}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  2}; //   1
  c_d[x_a][59] = { 40,  20,  13,   8}; //   4

  c_p[x_a][60] = { 15,  58,  53,  72}; //   4
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  3}; //   1
  c_d[x_a][60] = { 41,  26,   4,  15}; //   4

  c_p[x_a][61] = { 13,  58,  53,  72}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  3}; //   1
  c_d[x_a][61] = { 41,  26,   4,  15}; //   4

  c_p[x_a][62] = { 15,  58,  73,  74}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  3}; //   1
  c_d[x_a][62] = { 42,  24,   4,  15}; //   4

  c_p[x_a][63] = { 13,  58,  73,  74}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  3}; //   1
  c_d[x_a][63] = { 42,  24,   4,  15}; //   4

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 6yyyyv(1, 2, 64, 128, 16, 4, 8, 32;  24,   0,  24,   0,   0)
// channel    1: 6yyyyv(1, 2, 128, 64, 16, 4, 8, 32;  24,   0,  24,   0,   0)
// channel    2: 6yyyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel    3: 6yyyyv(1, 2, 128, 64, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel    4: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel    5: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel    6: 6yyyyv(1, 2, 128, 64, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel    7: 6yyyyv(1, 2, 128, 64, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel    8: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel    9: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   10: 6yyyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel   11: 6yyyyv(1, 2, 128, 64, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel   12: 6yyyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel   13: 6yyyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel   14: 6yyyyv(1, 2, 128, 64, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel   15: 6yyyyv(1, 2, 128, 64, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel   16: 6yy2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   17: 6yy2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   18: 6yy2vv(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   19: 6yy2vv(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   20: 6yy2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   21: 6yy2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   22: 6yy2vv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   23: 6yy2vv(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   24: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  24,   0,   0,   0,   0)
// channel   25: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  24,   0,  23,   0,   0)
// channel   26: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   27: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   28: 6y2vyv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,   0,   0,   0)
// channel   29: 6y2vyv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,  23,   0,   0)
// channel   30: 6y2vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   31: 6y2vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   32: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;   0,   0,  24,   0,   0)
// channel   33: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;  23,   0,  24,   0,   0)
// channel   34: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   35: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   36: 6y2vyv(1, 2, 128, 8, 32, 64, 4, 16;   0,   0,  24,   0,   0)
// channel   37: 6y2vyv(1, 2, 128, 8, 32, 64, 4, 16;  23,   0,  24,   0,   0)
// channel   38: 6y2vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   39: 6y2vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   40: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   41: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  24,  23,   0,   0,   0)
// channel   42: 63yvyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   43: 63yvyv(1, 2, 64, 4, 16, 128, 8, 32;  24,  23,   0,   0,   0)
// channel   44: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;   0,  24,   0,   0,   0)
// channel   45: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;  23,  24,   0,   0,   0)
// channel   46: 63yvyv(1, 2, 64, 8, 32, 128, 4, 16;   0,  24,   0,   0,   0)
// channel   47: 63yvyv(1, 2, 64, 8, 32, 128, 4, 16;  23,  24,   0,   0,   0)
// channel   48: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   49: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,  23,   0)
// channel   50: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  24,   0,   0,   0,   0)
// channel   51: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  24,   0,   0,  23,   0)
// channel   52: 2v4yyv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   53: 2v4yyv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,  23,   0)
// channel   54: 2v4yyv(1, 2, 4, 16, 128, 64, 8, 32;  24,   0,   0,   0,   0)
// channel   55: 2v4yyv(1, 2, 4, 16, 128, 64, 8, 32;  24,   0,   0,  23,   0)
// channel   56: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   57: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   58: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   59: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   60: 4yyv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   61: 4yyv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
// channel   62: 4yyv2v(1, 2, 128, 64, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   63: 4yyv2v(1, 2, 128, 64, 8, 32, 4, 16;  23,  24,   0,   0,   0)
