#include "header.hpp"

#include "ppeexexne04.phasespace.set.hpp"

void ppeexexne04_phasespace_set::ax_psp_240_usx_emepepveucx(int x_a){
  static Logger logger("ppeexexne04_phasespace_set::ax_psp_240_usx_emepepveucx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(33);
  needed_v_smin[x_a].resize(33);
  needed_v_smin[x_a][  0] = {   0,   10,   11,   14,   15,   18,   19,   20,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  26
  needed_v_smin[x_a][  1] = {   0,   20}; //   2
  needed_v_smin[x_a][  2] = {   0,    1,   20,   21}; //   4
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smin[x_a][  4] = {   1,    2,    3,    8,    9,   12,   13,   16,   17,   21,   22,   23,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  30
  needed_v_smin[x_a][  5] = {   1,   21}; //   2
  needed_v_smin[x_a][  6] = {   2,    3,   22,   23}; //   4
  needed_v_smin[x_a][  7] = {   2,    3,    6,    7,   22,   23,   26,   27}; //   8
  needed_v_smin[x_a][  8] = {   4,    8,    9,   12,   13,   16,   17,   24,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  26
  needed_v_smin[x_a][  9] = {   4,   24}; //   2
  needed_v_smin[x_a][ 10] = {   4,    5,   24,   25}; //   4
  needed_v_smin[x_a][ 11] = {   5,    6,    7,   10,   11,   14,   15,   18,   19,   25,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  30
  needed_v_smin[x_a][ 12] = {   5,   25}; //   2
  needed_v_smin[x_a][ 13] = {   6,    7,   26,   27}; //   4
  needed_v_smin[x_a][ 14] = {   8,    9,   28,   29}; //   4
  needed_v_smin[x_a][ 15] = {  10,   11,   30,   31}; //   4
  needed_v_smin[x_a][ 16] = {  12,   13,   32,   33,   40,   41,   52,   53,   60,   61}; //  10
  needed_v_smin[x_a][ 17] = {  12,   13,   52,   53,   60,   61}; //   6
  needed_v_smin[x_a][ 18] = {  14,   15,   34,   35,   42,   43,   54,   55,   62,   63}; //  10
  needed_v_smin[x_a][ 19] = {  14,   15,   54,   55,   62,   63}; //   6
  needed_v_smin[x_a][ 20] = {  16,   17,   48,   49,   56,   57}; //   6
  needed_v_smin[x_a][ 21] = {  16,   17,   48,   49,   56,   57}; //   6
  needed_v_smin[x_a][ 22] = {  18,   19,   50,   51,   58,   59}; //   6
  needed_v_smin[x_a][ 23] = {  18,   19,   50,   51,   58,   59}; //   6
  needed_v_smin[x_a][ 24] = {  40,   41,   44,   45}; //   4
  needed_v_smin[x_a][ 25] = {  42,   43,   46,   47}; //   4
  needed_v_smin[x_a][ 26] = {  32,   33}; //   2
  needed_v_smin[x_a][ 27] = {  34,   35}; //   2
  needed_v_smin[x_a][ 28] = {  36,   37,   38,   39}; //   4
  needed_v_smin[x_a][ 29] = {  36,   37}; //   2
  needed_v_smin[x_a][ 30] = {  38,   39}; //   2
  needed_v_smin[x_a][ 31] = {  44,   45}; //   2
  needed_v_smin[x_a][ 32] = {  46,   47}; //   2

  v_smax[x_a].resize(35);
  needed_v_smax[x_a].resize(35);
  needed_v_smax[x_a][  0] = {   0,   10,   11,   14,   15,   20,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   58,   59}; //  20
  needed_v_smax[x_a][  1] = {   0,    1,   20,   21}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  needed_v_smax[x_a][  4] = {   1,    2,    3,   16,   17,   21,   22,   23,   52,   53,   60,   61}; //  12
  needed_v_smax[x_a][  5] = {   2,    3,    6,    7,   22,   23,   26,   27}; //   8
  needed_v_smax[x_a][  6] = {   4,    8,    9,   12,   13,   24,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   56,   57}; //  20
  needed_v_smax[x_a][  7] = {   4,    5,   24,   25}; //   4
  needed_v_smax[x_a][  8] = {   5,    6,    7,   18,   19,   25,   26,   27,   54,   55,   62,   63}; //  12
  needed_v_smax[x_a][  9] = {   8,    9,   28,   29,   36,   37,   44,   45,   48,   49,   56,   57}; //  12
  needed_v_smax[x_a][ 10] = {  10,   11,   30,   31,   38,   39,   46,   47,   50,   51,   58,   59}; //  12
  needed_v_smax[x_a][ 11] = {  12,   13,   32,   33,   40,   41}; //   6
  needed_v_smax[x_a][ 12] = {  12,   13,   32,   33,   40,   41}; //   6
  needed_v_smax[x_a][ 13] = {  14,   15,   34,   35,   42,   43}; //   6
  needed_v_smax[x_a][ 14] = {  14,   15,   34,   35,   42,   43}; //   6
  needed_v_smax[x_a][ 15] = {  16,   17}; //   2
  needed_v_smax[x_a][ 16] = {  16,   17}; //   2
  needed_v_smax[x_a][ 17] = {  18,   19}; //   2
  needed_v_smax[x_a][ 18] = {  18,   19}; //   2
  needed_v_smax[x_a][ 19] = {  40,   41}; //   2
  needed_v_smax[x_a][ 20] = {  42,   43}; //   2
  needed_v_smax[x_a][ 21] = {  44,   45}; //   2
  needed_v_smax[x_a][ 22] = {  46,   47}; //   2
  needed_v_smax[x_a][ 23] = {  48,   49,   56,   57}; //   4
  needed_v_smax[x_a][ 24] = {  50,   51,   58,   59}; //   4
  needed_v_smax[x_a][ 25] = {  52,   53,   60,   61}; //   4
  needed_v_smax[x_a][ 26] = {  52,   53,   60,   61}; //   4
  needed_v_smax[x_a][ 27] = {  54,   55,   62,   63}; //   4
  needed_v_smax[x_a][ 28] = {  54,   55,   62,   63}; //   4
  needed_v_smax[x_a][ 29] = {  32,   33,   36,   37}; //   4
  needed_v_smax[x_a][ 30] = {  34,   35,   38,   39}; //   4
  needed_v_smax[x_a][ 31] = {  36,   37}; //   2
  needed_v_smax[x_a][ 32] = {  38,   39}; //   2
  needed_v_smax[x_a][ 33] = {  44,   45}; //   2
  needed_v_smax[x_a][ 34] = {  46,   47}; //   2

  g_p[x_a].resize(46);
  needed_g_p[x_a].resize(46);
  needed_g_p[x_a][0] = {   0,   10,   11,   14,   15,   20,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   58,   59}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,   17,   21,   23,   53,   61}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][5] = {   1,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax1");
  needed_g_p[x_a][6] = {   2,   16,   22,   52,   60}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][7] = {   2,    3,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   2,    3,    6,    7,   22,   23,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,    8,    9,   12,   13,   24,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   56,   57}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax6");
  needed_g_p[x_a][10] = {   4,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][11] = {   4,    5,   24,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax2");
  needed_g_p[x_a][12] = {   5,    7,   19,   25,   27,   55,   63}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax8");
  needed_g_p[x_a][13] = {   5,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax7");
  needed_g_p[x_a][14] = {   6,   18,   26,   54,   62}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][15] = {   6,    7,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax5");
  needed_g_p[x_a][16] = {   8,   28,   36,   44,   48,   56}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax9");
  needed_g_p[x_a][17] = {   8,    9,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax2");
  needed_g_p[x_a][18] = {   9,   29,   37,   45,   49,   57}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax9");
  needed_g_p[x_a][19] = {  10,   30,   38,   46,   50,   58}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax10");
  needed_g_p[x_a][20] = {  10,   11,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax2");
  needed_g_p[x_a][21] = {  11,   31,   39,   47,   51,   59}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax10");
  needed_g_p[x_a][22] = {  12,   13,   32,   33,   40,   41}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][23] = {  12,   32,   40}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax12");
  needed_g_p[x_a][24] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax3");
  needed_g_p[x_a][25] = {  13,   33,   41}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax12");
  needed_g_p[x_a][26] = {  14,   15,   34,   35,   42,   43}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax13");
  needed_g_p[x_a][27] = {  14,   34,   42}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax14");
  needed_g_p[x_a][28] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax3");
  needed_g_p[x_a][29] = {  15,   35,   43}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax14");
  needed_g_p[x_a][30] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax15");
  needed_g_p[x_a][31] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax16");
  needed_g_p[x_a][32] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax3");
  needed_g_p[x_a][33] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax17");
  needed_g_p[x_a][34] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax18");
  needed_g_p[x_a][35] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax3");
  needed_g_p[x_a][36] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax19");
  needed_g_p[x_a][37] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax20");
  needed_g_p[x_a][38] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax21");
  needed_g_p[x_a][39] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax22");
  needed_g_p[x_a][40] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax23");
  needed_g_p[x_a][41] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax24");
  needed_g_p[x_a][42] = {  52,   53,   60,   61}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax25");
  needed_g_p[x_a][43] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax26");
  needed_g_p[x_a][44] = {  54,   55,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax27");
  needed_g_p[x_a][45] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax28");

  g_f[x_a].resize(17);
  needed_g_f[x_a].resize(17);
  needed_g_f[x_a][0] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax29");
  needed_g_f[x_a][2] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax30");
  needed_g_f[x_a][3] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax31");
  needed_g_f[x_a][4] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax29");
  needed_g_f[x_a][5] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax32");
  needed_g_f[x_a][6] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax30");
  needed_g_f[x_a][7] = {  44,   45}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax33");
  needed_g_f[x_a][8] = {  46,   47}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax34");
  needed_g_f[x_a][9] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax3");
  needed_g_f[x_a][10] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax3");
  needed_g_f[x_a][11] = {  52,   53,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax3");
  needed_g_f[x_a][12] = {  54,   55,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax3");
  needed_g_f[x_a][13] = {  56,   57}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax23");
  needed_g_f[x_a][14] = {  58,   59}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax24");
  needed_g_f[x_a][15] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax26");
  needed_g_f[x_a][16] = {  62,   63}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax28");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][1] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][2] = {  32,   33,   36,   37}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][3] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__176_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__176_64");
  needed_g_t[x_a][4] = {  34,   35,   38,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][5] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__168_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__168_64");
  needed_g_t[x_a][6] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][7] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__13_50__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__13_50__64_128");
  needed_g_t[x_a][8] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_192");
  needed_g_t[x_a][9] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__21_42__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__21_42__64_128");
  needed_g_t[x_a][10] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__76_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__76_176");
  needed_g_t[x_a][11] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__84_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__84_168");
  needed_g_t[x_a][12] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][13] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_50__76_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_50__76_128");
  needed_g_t[x_a][14] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_212");
  needed_g_t[x_a][15] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_42__84_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_42__84_128");
  needed_g_t[x_a][16] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_140");
  needed_g_t[x_a][17] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_148");
  needed_g_t[x_a][18] = {  52,   53,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_176");
  needed_g_t[x_a][19] = {  54,   55,   62,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_168");
  needed_g_t[x_a][20] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_50__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_50__128_12");
  needed_g_t[x_a][21] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_42__128_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_42__128_20");
  needed_g_t[x_a][22] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__128_48");
  needed_g_t[x_a][23] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_22__128_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_22__128_40");

  g_d[x_a].resize(26);
  needed_g_d[x_a].resize(26);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,    1,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][2] = {   0,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][3] = {   0,   10,   11,   14,   15,   18,   19,   20,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {   1,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   1,    2,    3,    8,    9,   12,   13,   16,   17,   21,   22,   23,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][6] = {   2,    3,    6,    7,   22,   23,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   2,    3,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   4,    5,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][10] = {   4,    8,    9,   12,   13,   16,   17,   24,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][11] = {   5,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][12] = {   5,    6,    7,   10,   11,   14,   15,   18,   19,   25,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][13] = {   6,    7,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][14] = {   8,    9,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][15] = {  10,   11,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][16] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][17] = {  12,   13,   32,   33,   40,   41,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][18] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__20_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__20_168");
  needed_g_d[x_a][19] = {  14,   15,   34,   35,   42,   43,   54,   55}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_168__128_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_168__128_40");
  needed_g_d[x_a][20] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][21] = {  16,   17,   48,   49}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][22] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__40_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__40_148");
  needed_g_d[x_a][23] = {  18,   19,   50,   51}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][24] = {  40,   41,   44,   45}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][25] = {  42,   43,   46,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   5,   2,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   4,   5}; //   4

  c_p[x_a][2] = {  6,   7,   8,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   6,   7,   5}; //   4

  c_p[x_a][3] = {  4,   7,   8,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   6,   7,   5}; //   4

  c_p[x_a][4] = {  9,  10,  11,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   8,   9,  10}; //   4

  c_p[x_a][5] = { 12,  13,  11,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   8,  11,  12}; //   4

  c_p[x_a][6] = { 14,  15,   8,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  0,   6,  13,  12}; //   4

  c_p[x_a][7] = { 12,  15,   8,   3}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  0,   6,  13,  12}; //   4

  c_p[x_a][8] = {  9,  16,  17,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  0,  14,   5,  10}; //   4

  c_p[x_a][9] = {  9,  18,  17,   3}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  0,  14,   5,  10}; //   4

  c_p[x_a][10] = {  0,  19,  20,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  0,  15,  12,   3}; //   4

  c_p[x_a][11] = {  0,  21,  20,   3}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  0,  15,  12,   3}; //   4

  c_p[x_a][12] = {  9,  22,  23,  24}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 16,   5,  17,  10}; //   4

  c_p[x_a][13] = {  9,  22,  25,  24}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 16,   5,  17,  10}; //   4

  c_p[x_a][14] = {  0,  26,  27,  28}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 18,  12,  19,   3}; //   4

  c_p[x_a][15] = {  0,  26,  29,  28}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 18,  12,  19,   3}; //   4

  c_p[x_a][16] = {  6,  30,  31,  32}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 20,  10,  21,   5}; //   4

  c_p[x_a][17] = {  4,  30,  31,  32}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 20,  10,  21,   5}; //   4

  c_p[x_a][18] = { 14,  33,  34,  35}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 22,   3,  23,  12}; //   4

  c_p[x_a][19] = { 12,  33,  34,  35}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 22,   3,  23,  12}; //   4

  c_p[x_a][20] = {  0,   1,   2}; //   3
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  0,   1}; //   2
  c_d[x_a][20] = {  1,   2,   3}; //   3

  c_p[x_a][21] = {  4,   5,   2}; //   3
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  0,   1}; //   2
  c_d[x_a][21] = {  1,   4,   5}; //   3

  c_p[x_a][22] = {  6,   7,   8}; //   3
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  0,   1}; //   2
  c_d[x_a][22] = {  6,   7,   5}; //   3

  c_p[x_a][23] = {  4,   7,   8}; //   3
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  0,   1}; //   2
  c_d[x_a][23] = {  6,   7,   5}; //   3

  c_p[x_a][24] = {  9,  10,  11}; //   3
  c_f[x_a][24] = {  0}; //   1
  c_t[x_a][24] = {  0,   1}; //   2
  c_d[x_a][24] = {  8,   9,  10}; //   3

  c_p[x_a][25] = { 12,  13,  11}; //   3
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  0,   1}; //   2
  c_d[x_a][25] = {  8,  11,  12}; //   3

  c_p[x_a][26] = { 14,  15,   8}; //   3
  c_f[x_a][26] = {  0}; //   1
  c_t[x_a][26] = {  0,   1}; //   2
  c_d[x_a][26] = {  6,  13,  12}; //   3

  c_p[x_a][27] = { 12,  15,   8}; //   3
  c_f[x_a][27] = {  0}; //   1
  c_t[x_a][27] = {  0,   1}; //   2
  c_d[x_a][27] = {  6,  13,  12}; //   3

  c_p[x_a][28] = {  9,  16,  17}; //   3
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  0,   1}; //   2
  c_d[x_a][28] = { 14,   5,  10}; //   3

  c_p[x_a][29] = {  9,  18,  17}; //   3
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  0,   1}; //   2
  c_d[x_a][29] = { 14,   5,  10}; //   3

  c_p[x_a][30] = {  0,  19,  20}; //   3
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  0,   1}; //   2
  c_d[x_a][30] = { 15,  12,   3}; //   3

  c_p[x_a][31] = {  0,  21,  20}; //   3
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  0,   1}; //   2
  c_d[x_a][31] = { 15,  12,   3}; //   3

  c_p[x_a][32] = {  9,  22,  23}; //   3
  c_f[x_a][32] = {  1}; //   1
  c_t[x_a][32] = {  2,   3}; //   2
  c_d[x_a][32] = {  5,  17,  10}; //   3

  c_p[x_a][33] = {  9,  22,  25}; //   3
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = {  2,   3}; //   2
  c_d[x_a][33] = {  5,  17,  10}; //   3

  c_p[x_a][34] = {  0,  26,  27}; //   3
  c_f[x_a][34] = {  2}; //   1
  c_t[x_a][34] = {  4,   5}; //   2
  c_d[x_a][34] = { 12,  19,   3}; //   3

  c_p[x_a][35] = {  0,  26,  29}; //   3
  c_f[x_a][35] = {  2}; //   1
  c_t[x_a][35] = {  4,   5}; //   2
  c_d[x_a][35] = { 12,  19,   3}; //   3

  c_p[x_a][36] = {  9,  16}; //   2
  c_f[x_a][36] = {  3,   4}; //   2
  c_t[x_a][36] = {  2,   6,   7}; //   3
  c_d[x_a][36] = {  5,  10}; //   2

  c_p[x_a][37] = {  9,  18}; //   2
  c_f[x_a][37] = {  3,   4}; //   2
  c_t[x_a][37] = {  2,   6,   7}; //   3
  c_d[x_a][37] = {  5,  10}; //   2

  c_p[x_a][38] = {  0,  19}; //   2
  c_f[x_a][38] = {  5,   6}; //   2
  c_t[x_a][38] = {  4,   8,   9}; //   3
  c_d[x_a][38] = { 12,   3}; //   2

  c_p[x_a][39] = {  0,  21}; //   2
  c_f[x_a][39] = {  5,   6}; //   2
  c_t[x_a][39] = {  4,   8,   9}; //   3
  c_d[x_a][39] = { 12,   3}; //   2

  c_p[x_a][40] = {  9,  22,  23,  36}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 10}; //   1
  c_d[x_a][40] = { 24,   5,  17,  10}; //   4

  c_p[x_a][41] = {  9,  22,  25,  36}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 10}; //   1
  c_d[x_a][41] = { 24,   5,  17,  10}; //   4

  c_p[x_a][42] = {  0,  26,  27,  37}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 11}; //   1
  c_d[x_a][42] = { 25,  12,  19,   3}; //   4

  c_p[x_a][43] = {  0,  26,  29,  37}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 11}; //   1
  c_d[x_a][43] = { 25,  12,  19,   3}; //   4

  c_p[x_a][44] = {  9,  16,  38}; //   3
  c_f[x_a][44] = {  7}; //   1
  c_t[x_a][44] = { 12,  13}; //   2
  c_d[x_a][44] = { 24,   5,  10}; //   3

  c_p[x_a][45] = {  9,  18,  38}; //   3
  c_f[x_a][45] = {  7}; //   1
  c_t[x_a][45] = { 12,  13}; //   2
  c_d[x_a][45] = { 24,   5,  10}; //   3

  c_p[x_a][46] = {  0,  19,  39}; //   3
  c_f[x_a][46] = {  8}; //   1
  c_t[x_a][46] = { 14,  15}; //   2
  c_d[x_a][46] = { 25,  12,   3}; //   3

  c_p[x_a][47] = {  0,  21,  39}; //   3
  c_f[x_a][47] = {  8}; //   1
  c_t[x_a][47] = { 14,  15}; //   2
  c_d[x_a][47] = { 25,  12,   3}; //   3

  c_p[x_a][48] = {  9,  16,  40}; //   3
  c_f[x_a][48] = {  9}; //   1
  c_t[x_a][48] = {  0,  16}; //   2
  c_d[x_a][48] = { 21,   5,  10}; //   3

  c_p[x_a][49] = {  9,  18,  40}; //   3
  c_f[x_a][49] = {  9}; //   1
  c_t[x_a][49] = {  0,  16}; //   2
  c_d[x_a][49] = { 21,   5,  10}; //   3

  c_p[x_a][50] = {  0,  19,  41}; //   3
  c_f[x_a][50] = { 10}; //   1
  c_t[x_a][50] = {  0,  17}; //   2
  c_d[x_a][50] = { 23,  12,   3}; //   3

  c_p[x_a][51] = {  0,  21,  41}; //   3
  c_f[x_a][51] = { 10}; //   1
  c_t[x_a][51] = {  0,  17}; //   2
  c_d[x_a][51] = { 23,  12,   3}; //   3

  c_p[x_a][52] = {  6,  42,  43}; //   3
  c_f[x_a][52] = { 11}; //   1
  c_t[x_a][52] = {  0,  18}; //   2
  c_d[x_a][52] = { 17,  10,   5}; //   3

  c_p[x_a][53] = {  4,  42,  43}; //   3
  c_f[x_a][53] = { 11}; //   1
  c_t[x_a][53] = {  0,  18}; //   2
  c_d[x_a][53] = { 17,  10,   5}; //   3

  c_p[x_a][54] = { 14,  44,  45}; //   3
  c_f[x_a][54] = { 12}; //   1
  c_t[x_a][54] = {  0,  19}; //   2
  c_d[x_a][54] = { 19,   3,  12}; //   3

  c_p[x_a][55] = { 12,  44,  45}; //   3
  c_f[x_a][55] = { 12}; //   1
  c_t[x_a][55] = {  0,  19}; //   2
  c_d[x_a][55] = { 19,   3,  12}; //   3

  c_p[x_a][56] = {  9,  16}; //   2
  c_f[x_a][56] = { 13,   9}; //   2
  c_t[x_a][56] = {  0,  16,  20}; //   3
  c_d[x_a][56] = {  5,  10}; //   2

  c_p[x_a][57] = {  9,  18}; //   2
  c_f[x_a][57] = { 13,   9}; //   2
  c_t[x_a][57] = {  0,  16,  20}; //   3
  c_d[x_a][57] = {  5,  10}; //   2

  c_p[x_a][58] = {  0,  19}; //   2
  c_f[x_a][58] = { 14,  10}; //   2
  c_t[x_a][58] = {  0,  17,  21}; //   3
  c_d[x_a][58] = { 12,   3}; //   2

  c_p[x_a][59] = {  0,  21}; //   2
  c_f[x_a][59] = { 14,  10}; //   2
  c_t[x_a][59] = {  0,  17,  21}; //   3
  c_d[x_a][59] = { 12,   3}; //   2

  c_p[x_a][60] = {  6,  42}; //   2
  c_f[x_a][60] = { 15,  11}; //   2
  c_t[x_a][60] = {  0,  18,  22}; //   3
  c_d[x_a][60] = { 10,   5}; //   2

  c_p[x_a][61] = {  4,  42}; //   2
  c_f[x_a][61] = { 15,  11}; //   2
  c_t[x_a][61] = {  0,  18,  22}; //   3
  c_d[x_a][61] = { 10,   5}; //   2

  c_p[x_a][62] = { 14,  44}; //   2
  c_f[x_a][62] = { 16,  12}; //   2
  c_t[x_a][62] = {  0,  19,  23}; //   3
  c_d[x_a][62] = {  3,  12}; //   2

  c_p[x_a][63] = { 12,  44}; //   2
  c_f[x_a][63] = { 16,  12}; //   2
  c_t[x_a][63] = {  0,  19,  23}; //   3
  c_d[x_a][63] = {  3,  12}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 15yyyv(1, 2, 64, 128, 16, 4, 8, 32;  24,   0,  24,   0,   0)
// channel    1: 15yyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel    2: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel    3: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel    4: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel    5: 15yyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel    6: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel    7: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel    8: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel    9: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   10: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   11: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   12: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   13: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   14: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   15: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   16: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   17: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   18: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   19: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   20: 114yyv(1, 2, 64, 128, 16, 4, 8, 32;  24,   0,  24,   0,   0)
// channel   21: 114yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   22: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   23: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   24: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   25: 114yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel   26: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel   27: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel   28: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   29: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   30: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   31: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   32: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   33: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   34: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   35: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   36: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   37: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,  23,   0,   0,   0)
// channel   38: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   39: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,  23,   0,   0,   0)
// channel   40: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   41: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   42: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   43: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   44: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   45: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  24,  23,   0,   0,   0)
// channel   46: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   47: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,  23,   0,   0,   0)
// channel   48: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   49: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   50: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   51: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   52: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   53: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   54: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   55: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
// channel   56: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   57: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   58: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   59: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   60: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   61: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   62: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   63: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
