#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_240_dsx_emepmupvmdcx(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_240_dsx_emepmupvmdcx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  needed_v_smin[x_a][  1] = {   0,   10}; //   2
  needed_v_smin[x_a][  2] = {   0,   10}; //   2
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15}; //  12
  needed_v_smin[x_a][  4] = {   1,    2,   11,   12}; //   4
  needed_v_smin[x_a][  5] = {   1,    2,   11,   12}; //   4
  needed_v_smin[x_a][  6] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  needed_v_smin[x_a][  7] = {   3,   13}; //   2
  needed_v_smin[x_a][  8] = {   3,   13}; //   2
  needed_v_smin[x_a][  9] = {   4,    5,   14,   15}; //   4
  needed_v_smin[x_a][ 10] = {   6,    7,   16,   17,   20,   21,   26,   27,   30,   31}; //  10
  needed_v_smin[x_a][ 11] = {   6,    7,   26,   27,   30,   31}; //   6
  needed_v_smin[x_a][ 12] = {   8,    9,   24,   25,   28,   29}; //   6
  needed_v_smin[x_a][ 13] = {   8,    9,   24,   25,   28,   29}; //   6
  needed_v_smin[x_a][ 14] = {  20,   21,   22,   23}; //   4
  needed_v_smin[x_a][ 15] = {  16,   17}; //   2
  needed_v_smin[x_a][ 16] = {  18,   19}; //   2
  needed_v_smin[x_a][ 17] = {  18,   19}; //   2
  needed_v_smin[x_a][ 18] = {  22,   23}; //   2

  v_smax[x_a].resize(20);
  needed_v_smax[x_a].resize(20);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    8,    9,   10,   11,   12,   26,   27,   30,   31}; //  12
  needed_v_smax[x_a][  1] = {   0,   10}; //   2
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15}; //  12
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smax[x_a][  4] = {   1,    2,   11,   12}; //   4
  needed_v_smax[x_a][  5] = {   3,    4,    5,    6,    7,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   28,   29}; //  20
  needed_v_smax[x_a][  6] = {   3,   13}; //   2
  needed_v_smax[x_a][  7] = {   4,    5,   14,   15,   18,   19,   22,   23,   24,   25,   28,   29}; //  12
  needed_v_smax[x_a][  8] = {   6,    7,   16,   17,   20,   21}; //   6
  needed_v_smax[x_a][  9] = {   6,    7,   16,   17,   20,   21}; //   6
  needed_v_smax[x_a][ 10] = {   8,    9}; //   2
  needed_v_smax[x_a][ 11] = {   8,    9}; //   2
  needed_v_smax[x_a][ 12] = {  20,   21}; //   2
  needed_v_smax[x_a][ 13] = {  22,   23}; //   2
  needed_v_smax[x_a][ 14] = {  24,   25,   28,   29}; //   4
  needed_v_smax[x_a][ 15] = {  26,   27,   30,   31}; //   4
  needed_v_smax[x_a][ 16] = {  26,   27,   30,   31}; //   4
  needed_v_smax[x_a][ 17] = {  16,   17,   18,   19}; //   4
  needed_v_smax[x_a][ 18] = {  18,   19}; //   2
  needed_v_smax[x_a][ 19] = {  22,   23}; //   2

  g_p[x_a].resize(25);
  needed_g_p[x_a].resize(25);
  needed_g_p[x_a][0] = {   0,    2,    9,   10,   12,   27,   31}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    8,   11,   26,   30}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][5] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax2");
  needed_g_p[x_a][7] = {   3,    4,    5,    6,    7,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   28,   29}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   3,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][10] = {   4,   14,   18,   22,   24,   28}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax7");
  needed_g_p[x_a][11] = {   4,    5,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][12] = {   5,   15,   19,   23,   25,   29}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");
  needed_g_p[x_a][13] = {   6,    7,   16,   17,   20,   21}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {   6,   16,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");
  needed_g_p[x_a][15] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax3");
  needed_g_p[x_a][16] = {   7,   17,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][17] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][18] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax11");
  needed_g_p[x_a][19] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax3");
  needed_g_p[x_a][20] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax12");
  needed_g_p[x_a][21] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax13");
  needed_g_p[x_a][22] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax14");
  needed_g_p[x_a][23] = {  26,   27,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax15");
  needed_g_p[x_a][24] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax16");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {  10,   11,   12,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {  16,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax17");
  needed_g_f[x_a][2] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax18");
  needed_g_f[x_a][3] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax17");
  needed_g_f[x_a][4] = {  22,   23}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax19");
  needed_g_f[x_a][5] = {  24,   25,   28,   29}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax3");
  needed_g_f[x_a][6] = {  26,   27,   30,   31}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");
  needed_g_f[x_a][7] = {  28,   29}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax14");
  needed_g_f[x_a][8] = {  30,   31}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax16");

  g_t[x_a].resize(13);
  needed_g_t[x_a].resize(13);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][1] = {  10,   11,   12,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][2] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][3] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__176_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__176_64");
  needed_g_t[x_a][4] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][5] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__13_50__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__13_50__64_128");
  needed_g_t[x_a][6] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__76_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__76_176");
  needed_g_t[x_a][7] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][8] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_50__76_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_50__76_128");
  needed_g_t[x_a][9] = {  24,   25,   28,   29}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_140");
  needed_g_t[x_a][10] = {  26,   27,   30,   31}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_176");
  needed_g_t[x_a][11] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_50__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_50__128_12");
  needed_g_t[x_a][12] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__128_48");

  g_d[x_a].resize(15);
  needed_g_d[x_a].resize(15);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][2] = {   0,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][4] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][6] = {   3,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][7] = {   3,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][8] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][9] = {   4,    5,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][10] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][11] = {   6,    7,   16,   17,   20,   21,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][12] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][13] = {   8,    9,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][14] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(32);
  c_f[x_a].resize(32);
  c_t[x_a].resize(32);
  c_d[x_a].resize(32);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   5,   6,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   4,   5,   3}; //   4

  c_p[x_a][2] = {  0,   5,   6,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  7,   8,   9,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   6,   7,   8}; //   4

  c_p[x_a][4] = {  7,  10,  11,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   9,   3,   8}; //   4

  c_p[x_a][5] = {  7,  12,  11,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   9,   3,   8}; //   4

  c_p[x_a][6] = {  7,  13,  14,  15}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   3,  11,   8}; //   4

  c_p[x_a][7] = {  7,  13,  16,  15}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   3,  11,   8}; //   4

  c_p[x_a][8] = {  4,  17,  18,  19}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 12,   8,  13,   3}; //   4

  c_p[x_a][9] = {  0,  17,  18,  19}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 12,   8,  13,   3}; //   4

  c_p[x_a][10] = {  0,   1,   2}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = {  1,   2,   3}; //   3

  c_p[x_a][11] = {  4,   5,   6}; //   3
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  0,   1}; //   2
  c_d[x_a][11] = {  4,   5,   3}; //   3

  c_p[x_a][12] = {  0,   5,   6}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   1}; //   2
  c_d[x_a][12] = {  4,   5,   3}; //   3

  c_p[x_a][13] = {  7,   8,   9}; //   3
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = {  6,   7,   8}; //   3

  c_p[x_a][14] = {  7,  10,  11}; //   3
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  0,   1}; //   2
  c_d[x_a][14] = {  9,   3,   8}; //   3

  c_p[x_a][15] = {  7,  12,  11}; //   3
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  0,   1}; //   2
  c_d[x_a][15] = {  9,   3,   8}; //   3

  c_p[x_a][16] = {  7,  13,  14}; //   3
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  2,   3}; //   2
  c_d[x_a][16] = {  3,  11,   8}; //   3

  c_p[x_a][17] = {  7,  13,  16}; //   3
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  2,   3}; //   2
  c_d[x_a][17] = {  3,  11,   8}; //   3

  c_p[x_a][18] = {  7,  10}; //   2
  c_f[x_a][18] = {  2,   3}; //   2
  c_t[x_a][18] = {  2,   4,   5}; //   3
  c_d[x_a][18] = {  3,   8}; //   2

  c_p[x_a][19] = {  7,  12}; //   2
  c_f[x_a][19] = {  2,   3}; //   2
  c_t[x_a][19] = {  2,   4,   5}; //   3
  c_d[x_a][19] = {  3,   8}; //   2

  c_p[x_a][20] = {  7,  13,  14,  20}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  6}; //   1
  c_d[x_a][20] = { 14,   3,  11,   8}; //   4

  c_p[x_a][21] = {  7,  13,  16,  20}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  6}; //   1
  c_d[x_a][21] = { 14,   3,  11,   8}; //   4

  c_p[x_a][22] = {  7,  10,  21}; //   3
  c_f[x_a][22] = {  4}; //   1
  c_t[x_a][22] = {  7,   8}; //   2
  c_d[x_a][22] = { 14,   3,   8}; //   3

  c_p[x_a][23] = {  7,  12,  21}; //   3
  c_f[x_a][23] = {  4}; //   1
  c_t[x_a][23] = {  7,   8}; //   2
  c_d[x_a][23] = { 14,   3,   8}; //   3

  c_p[x_a][24] = {  7,  10,  22}; //   3
  c_f[x_a][24] = {  5}; //   1
  c_t[x_a][24] = {  0,   9}; //   2
  c_d[x_a][24] = { 13,   3,   8}; //   3

  c_p[x_a][25] = {  7,  12,  22}; //   3
  c_f[x_a][25] = {  5}; //   1
  c_t[x_a][25] = {  0,   9}; //   2
  c_d[x_a][25] = { 13,   3,   8}; //   3

  c_p[x_a][26] = {  4,  23,  24}; //   3
  c_f[x_a][26] = {  6}; //   1
  c_t[x_a][26] = {  0,  10}; //   2
  c_d[x_a][26] = { 11,   8,   3}; //   3

  c_p[x_a][27] = {  0,  23,  24}; //   3
  c_f[x_a][27] = {  6}; //   1
  c_t[x_a][27] = {  0,  10}; //   2
  c_d[x_a][27] = { 11,   8,   3}; //   3

  c_p[x_a][28] = {  7,  10}; //   2
  c_f[x_a][28] = {  7,   5}; //   2
  c_t[x_a][28] = {  0,   9,  11}; //   3
  c_d[x_a][28] = {  3,   8}; //   2

  c_p[x_a][29] = {  7,  12}; //   2
  c_f[x_a][29] = {  7,   5}; //   2
  c_t[x_a][29] = {  0,   9,  11}; //   3
  c_d[x_a][29] = {  3,   8}; //   2

  c_p[x_a][30] = {  4,  23}; //   2
  c_f[x_a][30] = {  8,   6}; //   2
  c_t[x_a][30] = {  0,  10,  12}; //   3
  c_d[x_a][30] = {  8,   3}; //   2

  c_p[x_a][31] = {  0,  23}; //   2
  c_f[x_a][31] = {  8,   6}; //   2
  c_t[x_a][31] = {  0,  10,  12}; //   3
  c_d[x_a][31] = {  8,   3}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 15yyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel    1: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel    2: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel    3: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel    4: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel    5: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel    6: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel    7: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel    8: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
// channel    9: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   10: 114yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   11: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   12: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   13: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   14: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   15: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   16: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   17: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   18: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   19: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,  23,   0,   0,   0)
// channel   20: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   21: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   22: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   23: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  24,  23,   0,   0,   0)
// channel   24: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   25: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   26: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   27: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   28: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   29: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   30: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   31: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
