#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_240_gu_emepmupvmgd(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_240_gu_emepmupvmgd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(24);
  needed_v_smin[x_a].resize(24);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33,   34,   35,   36,   38,   39,   40,   41,   42,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   58,   59,   60,   61,   62,   63,   64,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; // 100
  needed_v_smin[x_a][  1] = {   0,   10,   24,   34,   40,   50,   51,   62}; //   8
  needed_v_smin[x_a][  2] = {   0,   10,   24,   34,   40,   50,   51,   62}; //   8
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45,   50,   52,   53,   56,   58,   59}; //  24
  needed_v_smin[x_a][  4] = {   1,    2,   11,   12,   25,   26,   35,   36,   41,   42,   52,   53,   54,   55,   63,   64}; //  16
  needed_v_smin[x_a][  5] = {   1,    2,   11,   12,   25,   26,   35,   36,   41,   42,   52,   53,   54,   55,   63,   64}; //  16
  needed_v_smin[x_a][  6] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   27,   28,   29,   30,   31,   32,   33,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   56,   57,   58,   59,   60,   61,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  84
  needed_v_smin[x_a][  7] = {   3,   13,   27,   37,   43,   56,   57,   65}; //   8
  needed_v_smin[x_a][  8] = {   3,   13,   27,   37,   43,   56,   57,   65}; //   8
  needed_v_smin[x_a][  9] = {   4,    5,   14,   15,   30,   31,   38,   39,   44,   45,   58,   59,   60,   61,   66,   67,   84,   85,   86,   87,  104,  105,  106,  107}; //  24
  needed_v_smin[x_a][ 10] = {   6,    7,   16,   17,   20,   21,   46,   47,   70,   71,   74,   75,   78,   79,   94,   95,  100,  101}; //  18
  needed_v_smin[x_a][ 11] = {   6,    7,   16,   17,   46,   47,   70,   71,   94,   95,  100,  101}; //  12
  needed_v_smin[x_a][ 12] = {   8,    9,   18,   19,   22,   23,   48,   49,   68,   69,   72,   73,   76,   77,   92,   93,   96,   97}; //  18
  needed_v_smin[x_a][ 13] = {   8,    9,   18,   19,   48,   49,   68,   69,   92,   93,   96,   97}; //  12
  needed_v_smin[x_a][ 14] = {  20,   21,   78,   79,   74,   75}; //   6
  needed_v_smin[x_a][ 15] = {  22,   23,   76,   77,   72,   73}; //   6
  needed_v_smin[x_a][ 16] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   62,   63,   64,   65,   66,   67,   80,   81,   82,   83,  104,  105,  106,  107}; //  24
  needed_v_smin[x_a][ 17] = {  28,   29,   82,   83}; //   4
  needed_v_smin[x_a][ 18] = {  32,   33,   80,   81}; //   4
  needed_v_smin[x_a][ 19] = {  34,   35,   36,   37,   38,   39,   51,   54,   55,   57,   60,   61,   84,   85,   86,   87}; //  16
  needed_v_smin[x_a][ 20] = {  88,   89,   98,   99}; //   4
  needed_v_smin[x_a][ 21] = {  88,   89,   98,   99}; //   4
  needed_v_smin[x_a][ 22] = {  90,   91,  102,  103}; //   4
  needed_v_smin[x_a][ 23] = {  90,   91,  102,  103}; //   4

  v_smax[x_a].resize(34);
  needed_v_smax[x_a].resize(34);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    8,    9,   10,   11,   12,   18,   19,   22,   23,   24,   25,   26,   34,   35,   36,   40,   41,   42,   48,   49,   50,   51,   52,   53,   54,   55,   62,   63,   64,   70,   71,   74,   75,   78,   79,   82,   83,   86,   87,   90,   91,   94,   95,  100,  101,  102,  103,  106,  107}; //  52
  needed_v_smax[x_a][  1] = {   0,   10,   24,   34,   40,   50,   51,   62}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   24,   25,   26,   27,   30,   31,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   84,   85,   86,   87}; //  52
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   52,   53,   56,   58,   59,   68,   69,   70,   71,   92,   93,   94,   95,   96,   97,  100,  101}; //  48
  needed_v_smax[x_a][  4] = {   1,    2,   11,   12,   25,   26,   35,   36,   41,   42,   52,   53,   54,   55,   63,   64}; //  16
  needed_v_smax[x_a][  5] = {   3,    4,    5,    6,    7,   13,   14,   15,   16,   17,   20,   21,   27,   30,   31,   37,   38,   39,   43,   44,   45,   46,   47,   56,   57,   58,   59,   60,   61,   65,   66,   67,   68,   69,   72,   73,   76,   77,   80,   81,   84,   85,   88,   89,   92,   93,   96,   97,   98,   99,  104,  105}; //  52
  needed_v_smax[x_a][  6] = {   3,   13,   27,   37,   43,   56,   57,   65}; //   8
  needed_v_smax[x_a][  7] = {   4,    5,   14,   15,   30,   31,   38,   39,   44,   45,   58,   59,   60,   61,   66,   67,   68,   69,   72,   73,   76,   77,   84,   85,   88,   89,   92,   93,   96,   97,   98,   99,  104,  105}; //  34
  needed_v_smax[x_a][  8] = {   6,    7,   16,   17,   20,   21,   46,   47}; //   8
  needed_v_smax[x_a][  9] = {   6,    7,   16,   17,   46,   47}; //   6
  needed_v_smax[x_a][ 10] = {   8,    9,   18,   19,   22,   23,   48,   49}; //   8
  needed_v_smax[x_a][ 11] = {   8,    9,   18,   19,   48,   49}; //   6
  needed_v_smax[x_a][ 12] = {  20,   21,   28,   29}; //   4
  needed_v_smax[x_a][ 13] = {  20,   21,   28,   29}; //   4
  needed_v_smax[x_a][ 14] = {  22,   23,   32,   33}; //   4
  needed_v_smax[x_a][ 15] = {  22,   23,   32,   33}; //   4
  needed_v_smax[x_a][ 16] = {  24,   25,   26,   27,   30,   31,   62,   63,   64,   65,   66,   67}; //  12
  needed_v_smax[x_a][ 17] = {  28,   29,   32,   33}; //   4
  needed_v_smax[x_a][ 18] = {  28,   29}; //   2
  needed_v_smax[x_a][ 19] = {  32,   33}; //   2
  needed_v_smax[x_a][ 20] = {  68,   69,   72,   73,   76,   77,   92,   93,   96,   97}; //  10
  needed_v_smax[x_a][ 21] = {  70,   71,   74,   75,   78,   79,   86,   87,   90,   91,   94,   95,  100,  101,  102,  103,  106,  107}; //  18
  needed_v_smax[x_a][ 22] = {  70,   71,   74,   75,   78,   79,   94,   95,  100,  101}; //  10
  needed_v_smax[x_a][ 23] = {  76,   77,   80,   81,   72,   73}; //   6
  needed_v_smax[x_a][ 24] = {  78,   79,   82,   83,   74,   75}; //   6
  needed_v_smax[x_a][ 25] = {  80,   81}; //   2
  needed_v_smax[x_a][ 26] = {  80,   81}; //   2
  needed_v_smax[x_a][ 27] = {  82,   83}; //   2
  needed_v_smax[x_a][ 28] = {  82,   83}; //   2
  needed_v_smax[x_a][ 29] = { 104,  105,  106,  107}; //   4
  needed_v_smax[x_a][ 30] = {  34,   35,   36,   37,   38,   39,   51,   54,   55,   57,   60,   61,   84,   85,   86,   87,   88,   89,   90,   91,   98,   99,  102,  103}; //  24
  needed_v_smax[x_a][ 31] = {  88,   89,   98,   99}; //   4
  needed_v_smax[x_a][ 32] = {  90,   91,  102,  103}; //   4
  needed_v_smax[x_a][ 33] = { 104,  105,  106,  107}; //   4

  g_p[x_a].resize(45);
  needed_g_p[x_a].resize(45);
  needed_g_p[x_a][0] = {   0,    2,    9,   10,   12,   19,   23,   24,   26,   34,   36,   40,   42,   49,   50,   51,   53,   55,   62,   64,   71,   75,   79,   83,   87,   91,   95,  101,  103,  107}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   10,   24,   34,   40,   50,   51,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   10,   24,   34,   40,   50,   51,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    8,   11,   18,   22,   25,   35,   41,   48,   52,   54,   63,   70,   74,   78,   82,   86,   90,   94,  100,  102,  106}; //  22
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][5] = {   1,    2,   11,   12,   25,   26,   35,   36,   41,   42,   52,   53,   54,   55,   63,   64}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   1,    2,   11,   12,   25,   26,   35,   36,   41,   42,   52,   53,   54,   55,   63,   64}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax2");
  needed_g_p[x_a][7] = {   3,    4,    5,    6,    7,   13,   14,   15,   16,   17,   20,   21,   27,   30,   31,   37,   38,   39,   43,   44,   45,   46,   47,   56,   57,   58,   59,   60,   61,   65,   66,   67,   68,   69,   72,   73,   76,   77,   80,   81,   84,   85,   88,   89,   92,   93,   96,   97,   98,   99,  104,  105}; //  52
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   13,   27,   37,   43,   56,   57,   65}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   3,   13,   27,   37,   43,   56,   57,   65}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][10] = {   4,   14,   30,   38,   44,   58,   60,   66,   68,   72,   76,   84,   88,   92,   96,   98,  104}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax7");
  needed_g_p[x_a][11] = {   4,    5,   14,   15,   30,   31,   38,   39,   44,   45,   58,   59,   60,   61,   66,   67}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][12] = {   5,   15,   31,   39,   45,   59,   61,   67,   69,   73,   77,   85,   89,   93,   97,   99,  105}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");
  needed_g_p[x_a][13] = {   6,    7,   16,   17,   20,   21,   46,   47}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {   6,   16,   46}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");
  needed_g_p[x_a][15] = {   6,    7,   16,   17,   46,   47}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax3");
  needed_g_p[x_a][16] = {   7,   17,   47}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][17] = {   8,    9,   18,   19,   22,   23,   48,   49}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][18] = {   8,    9,   18,   19,   48,   49}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax11");
  needed_g_p[x_a][19] = {   8,    9,   18,   19,   48,   49}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax3");
  needed_g_p[x_a][20] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax12");
  needed_g_p[x_a][21] = {  20,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax13");
  needed_g_p[x_a][22] = {  21,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax13");
  needed_g_p[x_a][23] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax14");
  needed_g_p[x_a][24] = {  22,   23,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax15");
  needed_g_p[x_a][25] = {  24,   25,   26,   27,   30,   31,   62,   63,   64,   65,   66,   67}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax16");
  needed_g_p[x_a][26] = {  28,   29,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax17");
  needed_g_p[x_a][27] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax18");
  needed_g_p[x_a][28] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax12");
  needed_g_p[x_a][29] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax19");
  needed_g_p[x_a][30] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax14");
  needed_g_p[x_a][31] = {  33}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax19");
  needed_g_p[x_a][32] = {  68,   69,   72,   73,   76,   77,   92,   93}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax20");
  needed_g_p[x_a][33] = {  70,   71,   74,   75,   78,   79,   86,   87,   90,   91,   94,   95,  100,  101,  102,  103,  106,  107}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax21");
  needed_g_p[x_a][34] = {  70,   71,   74,   75,   78,   79,   94,   95}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax22");
  needed_g_p[x_a][35] = {  76,   77}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax23");
  needed_g_p[x_a][36] = {  78,   79}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax24");
  needed_g_p[x_a][37] = {  80,   81}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax25");
  needed_g_p[x_a][38] = {  80}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax26");
  needed_g_p[x_a][39] = {  80,   81}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax23");
  needed_g_p[x_a][40] = {  81}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax26");
  needed_g_p[x_a][41] = {  82,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax27");
  needed_g_p[x_a][42] = {  82,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax28");
  needed_g_p[x_a][43] = {  82,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax24");
  needed_g_p[x_a][44] = { 104,  105,  106,  107}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax29");

  g_f[x_a].resize(14);
  needed_g_f[x_a].resize(14);
  needed_g_f[x_a][0] = {  34,   35,   36,   37,   38,   39,   51,   54,   55,   57,   60,   61,   84,   85,   86,   87}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax30");
  needed_g_f[x_a][1] = {  50,   52,   53,   56,   58,   59}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][2] = {  68,   69,   92,   93,   96,   97}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax3");
  needed_g_f[x_a][3] = {  70,   71,   94,   95,  100,  101}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");
  needed_g_f[x_a][4] = {  72,   73}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax23");
  needed_g_f[x_a][5] = {  74,   75}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax24");
  needed_g_f[x_a][6] = {  84,   85,   86,   87}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax2");
  needed_g_f[x_a][7] = {  88,   89,   98,   99}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax31");
  needed_g_f[x_a][8] = {  88,   89,   98,   99}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax30");
  needed_g_f[x_a][9] = {  90,   91,  102,  103}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax32");
  needed_g_f[x_a][10] = {  90,   91,  102,  103}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax30");
  needed_g_f[x_a][11] = {  96,   97}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax20");
  needed_g_f[x_a][12] = { 100,  101}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax22");
  needed_g_f[x_a][13] = { 104,  105,  106,  107}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax33");

  g_t[x_a].resize(27);
  needed_g_t[x_a].resize(27);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   68,   69,   70,   71}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][1] = {  34,   35,   36,   37,   38,   39,   51,   54,   55,   57,   60,   61,   84,   85,   86,   87,   88,   89,   90,   91,   98,   99,  102,  103}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__128_124");
  needed_g_t[x_a][2] = {  34,   35,   36,   37,   38,   39,   84,   85,   86,   87}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__64_60");
  needed_g_t[x_a][3] = {  40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   52,   53,   56,   58,   59,   92,   93,   94,   95,   96,   97,  100,  101}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][4] = {  50,   52,   53,   56,   58,   59}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][5] = {  51,   54,   55,   57,   60,   61}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__129_2__64_60");
  needed_g_t[x_a][6] = {  62,   63,   64,   65,   66,   67,  104,  105,  106,  107}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][7] = {  68,   69}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__140_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__140_48");
  needed_g_t[x_a][8] = {  70,   71}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__176_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__176_12");
  needed_g_t[x_a][9] = {  72,   73,   76,   77,   80,   81}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][10] = {  72,   73}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_50__140_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_50__140_64");
  needed_g_t[x_a][11] = {  74,   75,   78,   79,   82,   83}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][12] = {  74,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_14__176_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_14__176_64");
  needed_g_t[x_a][13] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_66__12_48");
  needed_g_t[x_a][14] = {  86,   87}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_66__48_12");
  needed_g_t[x_a][15] = {  88,   89,   98,   99}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__48_76");
  needed_g_t[x_a][16] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_50__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_50__12_64");
  needed_g_t[x_a][17] = {  90,   91,  102,  103}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__12_112");
  needed_g_t[x_a][18] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_14__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_14__48_64");
  needed_g_t[x_a][19] = {  92,   93,   96,   97}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_140");
  needed_g_t[x_a][20] = {  94,   95,  100,  101}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_176");
  needed_g_t[x_a][21] = {  96,   97}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_50__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_50__128_12");
  needed_g_t[x_a][22] = {  98,   99}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_50__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_50__64_12");
  needed_g_t[x_a][23] = { 100,  101}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__128_48");
  needed_g_t[x_a][24] = { 102,  103}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_14__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_14__64_48");
  needed_g_t[x_a][25] = { 104,  105}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][26] = { 106,  107}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");

  g_d[x_a].resize(23);
  needed_g_d[x_a].resize(23);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,   10,   24,   34,   40,   50,   51,   62}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][2] = {   0,   10,   24,   34,   40,   50,   51,   62}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33,   34,   35,   36,   38,   39,   40,   41,   42,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   58,   59,   60,   61,   62,   63,   64,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; // 100
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][4] = {   1,    2,   11,   12,   25,   26,   35,   36,   41,   42,   52,   53,   54,   55,   63,   64}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   1,    2,   11,   12,   25,   26,   35,   36,   41,   42,   52,   53,   54,   55,   63,   64}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][6] = {   3,   13,   27,   37,   43,   56,   57,   65}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][7] = {   3,   13,   27,   37,   43,   56,   57,   65}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][8] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   27,   28,   29,   30,   31,   32,   33,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   56,   57,   58,   59,   60,   61,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  84
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][9] = {   4,    5,   14,   15,   30,   31,   38,   39,   44,   45,   58,   59,   60,   61,   66,   67}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][10] = {   6,    7,   16,   17,   46,   47}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][11] = {   6,    7,   16,   17,   20,   21,   46,   47,   70,   71,   74,   75,   78,   79,   94,   95}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][12] = {   8,    9,   18,   19,   48,   49}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][13] = {   8,    9,   18,   19,   22,   23,   48,   49,   68,   69,   72,   73,   76,   77,   92,   93}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][14] = {  10,   11,   12,   13,   14,   15,   16,   17,   18,   19}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][15] = {  20,   21,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__12_240");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__12_240");
  needed_g_d[x_a][16] = {  20,   21,   78,   79}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__64_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__64_176");
  needed_g_d[x_a][17] = {  22,   23,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__48_204");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__48_204");
  needed_g_d[x_a][18] = {  22,   23,   76,   77}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__64_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__64_140");
  needed_g_d[x_a][19] = {  24,   25,   26,   27,   30,   31}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__192_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__192_60");
  needed_g_d[x_a][20] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   62,   63,   64,   65,   66,   67,   80,   81,   82,   83,  104,  105,  106,  107}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][21] = {  28,   29,   82,   83}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__48_192");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__48_192");
  needed_g_d[x_a][22] = {  32,   33,   80,   81}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__12_192");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__12_192");

  c_p[x_a].resize(108);
  c_f[x_a].resize(108);
  c_t[x_a].resize(108);
  c_d[x_a].resize(108);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   5,   6,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   4,   5,   3}; //   4

  c_p[x_a][2] = {  0,   5,   6,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  7,   8,   9,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   6,   7,   8}; //   4

  c_p[x_a][4] = {  7,  10,  11,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   9,   3,   8}; //   4

  c_p[x_a][5] = {  7,  12,  11,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   9,   3,   8}; //   4

  c_p[x_a][6] = {  7,  13,  14,  15}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   3,  11,   8}; //   4

  c_p[x_a][7] = {  7,  13,  16,  15}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   3,  11,   8}; //   4

  c_p[x_a][8] = {  4,  17,  18,  19}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 12,   8,  13,   3}; //   4

  c_p[x_a][9] = {  0,  17,  18,  19}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 12,   8,  13,   3}; //   4

  c_p[x_a][10] = {  0,   1,   2,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 14,   0,   1,   2,   3}; //   5

  c_p[x_a][11] = {  4,   5,   6,   3}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 14,   0,   4,   5,   3}; //   5

  c_p[x_a][12] = {  0,   5,   6,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 14,   0,   4,   5,   3}; //   5

  c_p[x_a][13] = {  7,   8,   9,   3}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 14,   0,   6,   7,   8}; //   5

  c_p[x_a][14] = {  7,  10,  11,   3}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 14,   0,   9,   3,   8}; //   5

  c_p[x_a][15] = {  7,  12,  11,   3}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 14,   0,   9,   3,   8}; //   5

  c_p[x_a][16] = {  7,  13,  14,  15}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 14,  10,   3,  11,   8}; //   5

  c_p[x_a][17] = {  7,  13,  16,  15}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 14,  10,   3,  11,   8}; //   5

  c_p[x_a][18] = {  4,  17,  18,  19}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 14,  12,   8,  13,   3}; //   5

  c_p[x_a][19] = {  0,  17,  18,  19}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 14,  12,   8,  13,   3}; //   5

  c_p[x_a][20] = {  7,  13,  20,  21}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 15,   3,  16,  11,   8}; //   5

  c_p[x_a][21] = {  7,  13,  20,  22}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 15,   3,  16,  11,   8}; //   5

  c_p[x_a][22] = {  4,  17,  23,  24}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 17,   8,  18,  13,   3}; //   5

  c_p[x_a][23] = {  0,  17,  23,  24}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 17,   8,  18,  13,   3}; //   5

  c_p[x_a][24] = {  0,   1,   2,  25}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 19,  20,   1,   2,   3}; //   5

  c_p[x_a][25] = {  4,   5,   6,  25}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 19,  20,   4,   5,   3}; //   5

  c_p[x_a][26] = {  0,   5,   6,  25}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 19,  20,   4,   5,   3}; //   5

  c_p[x_a][27] = {  7,   8,   9,  25}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 19,  20,   6,   7,   8}; //   5

  c_p[x_a][28] = { 26,  27,  28,  21}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 15,   3,  21,   8,  20}; //   5

  c_p[x_a][29] = { 26,  27,  28,  22}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 15,   3,  21,   8,  20}; //   5

  c_p[x_a][30] = {  7,  10,  11,  25}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 19,  20,   9,   3,   8}; //   5

  c_p[x_a][31] = {  7,  12,  11,  25}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 19,  20,   9,   3,   8}; //   5

  c_p[x_a][32] = { 26,  29,  30,  24}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 17,   8,  22,   3,  20}; //   5

  c_p[x_a][33] = { 26,  31,  30,  24}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 17,   8,  22,   3,  20}; //   5

  c_p[x_a][34] = {  0,   1,   2}; //   3
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  1,   2}; //   2
  c_d[x_a][34] = {  1,   2,   3}; //   3

  c_p[x_a][35] = {  4,   5,   6}; //   3
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  1,   2}; //   2
  c_d[x_a][35] = {  4,   5,   3}; //   3

  c_p[x_a][36] = {  0,   5,   6}; //   3
  c_f[x_a][36] = {  0}; //   1
  c_t[x_a][36] = {  1,   2}; //   2
  c_d[x_a][36] = {  4,   5,   3}; //   3

  c_p[x_a][37] = {  7,   8,   9}; //   3
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  1,   2}; //   2
  c_d[x_a][37] = {  6,   7,   8}; //   3

  c_p[x_a][38] = {  7,  10,  11}; //   3
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  1,   2}; //   2
  c_d[x_a][38] = {  9,   3,   8}; //   3

  c_p[x_a][39] = {  7,  12,  11}; //   3
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  1,   2}; //   2
  c_d[x_a][39] = {  9,   3,   8}; //   3

  c_p[x_a][40] = {  0,   1,   2,   3}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  3}; //   1
  c_d[x_a][40] = {  0,   1,   2,   3}; //   4

  c_p[x_a][41] = {  4,   5,   6,   3}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  3}; //   1
  c_d[x_a][41] = {  0,   4,   5,   3}; //   4

  c_p[x_a][42] = {  0,   5,   6,   3}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  3}; //   1
  c_d[x_a][42] = {  0,   4,   5,   3}; //   4

  c_p[x_a][43] = {  7,   8,   9,   3}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  3}; //   1
  c_d[x_a][43] = {  0,   6,   7,   8}; //   4

  c_p[x_a][44] = {  7,  10,  11,   3}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  3}; //   1
  c_d[x_a][44] = {  0,   9,   3,   8}; //   4

  c_p[x_a][45] = {  7,  12,  11,   3}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  3}; //   1
  c_d[x_a][45] = {  0,   9,   3,   8}; //   4

  c_p[x_a][46] = {  7,  13,  14,  15}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  3}; //   1
  c_d[x_a][46] = { 10,   3,  11,   8}; //   4

  c_p[x_a][47] = {  7,  13,  16,  15}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  3}; //   1
  c_d[x_a][47] = { 10,   3,  11,   8}; //   4

  c_p[x_a][48] = {  4,  17,  18,  19}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  3}; //   1
  c_d[x_a][48] = { 12,   8,  13,   3}; //   4

  c_p[x_a][49] = {  0,  17,  18,  19}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  3}; //   1
  c_d[x_a][49] = { 12,   8,  13,   3}; //   4

  c_p[x_a][50] = {  0,   1,   2}; //   3
  c_f[x_a][50] = {  1}; //   1
  c_t[x_a][50] = {  3,   4}; //   2
  c_d[x_a][50] = {  1,   2,   3}; //   3

  c_p[x_a][51] = {  0,   1,   2}; //   3
  c_f[x_a][51] = {  0}; //   1
  c_t[x_a][51] = {  1,   5}; //   2
  c_d[x_a][51] = {  1,   2,   3}; //   3

  c_p[x_a][52] = {  4,   5,   6}; //   3
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  3,   4}; //   2
  c_d[x_a][52] = {  4,   5,   3}; //   3

  c_p[x_a][53] = {  0,   5,   6}; //   3
  c_f[x_a][53] = {  1}; //   1
  c_t[x_a][53] = {  3,   4}; //   2
  c_d[x_a][53] = {  4,   5,   3}; //   3

  c_p[x_a][54] = {  4,   5,   6}; //   3
  c_f[x_a][54] = {  0}; //   1
  c_t[x_a][54] = {  1,   5}; //   2
  c_d[x_a][54] = {  4,   5,   3}; //   3

  c_p[x_a][55] = {  0,   5,   6}; //   3
  c_f[x_a][55] = {  0}; //   1
  c_t[x_a][55] = {  1,   5}; //   2
  c_d[x_a][55] = {  4,   5,   3}; //   3

  c_p[x_a][56] = {  7,   8,   9}; //   3
  c_f[x_a][56] = {  1}; //   1
  c_t[x_a][56] = {  3,   4}; //   2
  c_d[x_a][56] = {  6,   7,   8}; //   3

  c_p[x_a][57] = {  7,   8,   9}; //   3
  c_f[x_a][57] = {  0}; //   1
  c_t[x_a][57] = {  1,   5}; //   2
  c_d[x_a][57] = {  6,   7,   8}; //   3

  c_p[x_a][58] = {  7,  10,  11}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  3,   4}; //   2
  c_d[x_a][58] = {  9,   3,   8}; //   3

  c_p[x_a][59] = {  7,  12,  11}; //   3
  c_f[x_a][59] = {  1}; //   1
  c_t[x_a][59] = {  3,   4}; //   2
  c_d[x_a][59] = {  9,   3,   8}; //   3

  c_p[x_a][60] = {  7,  10,  11}; //   3
  c_f[x_a][60] = {  0}; //   1
  c_t[x_a][60] = {  1,   5}; //   2
  c_d[x_a][60] = {  9,   3,   8}; //   3

  c_p[x_a][61] = {  7,  12,  11}; //   3
  c_f[x_a][61] = {  0}; //   1
  c_t[x_a][61] = {  1,   5}; //   2
  c_d[x_a][61] = {  9,   3,   8}; //   3

  c_p[x_a][62] = {  0,   1,   2,  25}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  6}; //   1
  c_d[x_a][62] = { 20,   1,   2,   3}; //   4

  c_p[x_a][63] = {  4,   5,   6,  25}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  6}; //   1
  c_d[x_a][63] = { 20,   4,   5,   3}; //   4

  c_p[x_a][64] = {  0,   5,   6,  25}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  6}; //   1
  c_d[x_a][64] = { 20,   4,   5,   3}; //   4

  c_p[x_a][65] = {  7,   8,   9,  25}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  6}; //   1
  c_d[x_a][65] = { 20,   6,   7,   8}; //   4

  c_p[x_a][66] = {  7,  10,  11,  25}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  6}; //   1
  c_d[x_a][66] = { 20,   9,   3,   8}; //   4

  c_p[x_a][67] = {  7,  12,  11,  25}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  6}; //   1
  c_d[x_a][67] = { 20,   9,   3,   8}; //   4

  c_p[x_a][68] = {  7,  10,  32}; //   3
  c_f[x_a][68] = {  2}; //   1
  c_t[x_a][68] = {  0,   7}; //   2
  c_d[x_a][68] = { 13,   3,   8}; //   3

  c_p[x_a][69] = {  7,  12,  32}; //   3
  c_f[x_a][69] = {  2}; //   1
  c_t[x_a][69] = {  0,   7}; //   2
  c_d[x_a][69] = { 13,   3,   8}; //   3

  c_p[x_a][70] = {  4,  33,  34}; //   3
  c_f[x_a][70] = {  3}; //   1
  c_t[x_a][70] = {  0,   8}; //   2
  c_d[x_a][70] = { 11,   8,   3}; //   3

  c_p[x_a][71] = {  0,  33,  34}; //   3
  c_f[x_a][71] = {  3}; //   1
  c_t[x_a][71] = {  0,   8}; //   2
  c_d[x_a][71] = { 11,   8,   3}; //   3

  c_p[x_a][72] = {  7,  10,  32}; //   3
  c_f[x_a][72] = {  4}; //   1
  c_t[x_a][72] = {  9,  10}; //   2
  c_d[x_a][72] = { 13,   3,   8}; //   3

  c_p[x_a][73] = {  7,  12,  32}; //   3
  c_f[x_a][73] = {  4}; //   1
  c_t[x_a][73] = {  9,  10}; //   2
  c_d[x_a][73] = { 13,   3,   8}; //   3

  c_p[x_a][74] = {  4,  33,  34}; //   3
  c_f[x_a][74] = {  5}; //   1
  c_t[x_a][74] = { 11,  12}; //   2
  c_d[x_a][74] = { 11,   8,   3}; //   3

  c_p[x_a][75] = {  0,  33,  34}; //   3
  c_f[x_a][75] = {  5}; //   1
  c_t[x_a][75] = { 11,  12}; //   2
  c_d[x_a][75] = { 11,   8,   3}; //   3

  c_p[x_a][76] = {  7,  10,  32,  35}; //   4
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  9}; //   1
  c_d[x_a][76] = { 18,  13,   3,   8}; //   4

  c_p[x_a][77] = {  7,  12,  32,  35}; //   4
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  9}; //   1
  c_d[x_a][77] = { 18,  13,   3,   8}; //   4

  c_p[x_a][78] = {  4,  33,  34,  36}; //   4
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 11}; //   1
  c_d[x_a][78] = { 16,  11,   8,   3}; //   4

  c_p[x_a][79] = {  0,  33,  34,  36}; //   4
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 11}; //   1
  c_d[x_a][79] = { 16,  11,   8,   3}; //   4

  c_p[x_a][80] = {  7,  37,  38,  39}; //   4
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {  9}; //   1
  c_d[x_a][80] = { 22,   3,  20,   8}; //   4

  c_p[x_a][81] = {  7,  37,  40,  39}; //   4
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  9}; //   1
  c_d[x_a][81] = { 22,   3,  20,   8}; //   4

  c_p[x_a][82] = {  4,  41,  42,  43}; //   4
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = { 11}; //   1
  c_d[x_a][82] = { 21,   8,  20,   3}; //   4

  c_p[x_a][83] = {  0,  41,  42,  43}; //   4
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = { 11}; //   1
  c_d[x_a][83] = { 21,   8,  20,   3}; //   4

  c_p[x_a][84] = {  7,  10}; //   2
  c_f[x_a][84] = {  6,   0}; //   2
  c_t[x_a][84] = {  1,   2,  13}; //   3
  c_d[x_a][84] = {  3,   8}; //   2

  c_p[x_a][85] = {  7,  12}; //   2
  c_f[x_a][85] = {  6,   0}; //   2
  c_t[x_a][85] = {  1,   2,  13}; //   3
  c_d[x_a][85] = {  3,   8}; //   2

  c_p[x_a][86] = {  4,  33}; //   2
  c_f[x_a][86] = {  6,   0}; //   2
  c_t[x_a][86] = {  1,   2,  14}; //   3
  c_d[x_a][86] = {  8,   3}; //   2

  c_p[x_a][87] = {  0,  33}; //   2
  c_f[x_a][87] = {  6,   0}; //   2
  c_t[x_a][87] = {  1,   2,  14}; //   3
  c_d[x_a][87] = {  8,   3}; //   2

  c_p[x_a][88] = {  7,  10}; //   2
  c_f[x_a][88] = {  7,   8}; //   2
  c_t[x_a][88] = {  1,  15,  16}; //   3
  c_d[x_a][88] = {  3,   8}; //   2

  c_p[x_a][89] = {  7,  12}; //   2
  c_f[x_a][89] = {  7,   8}; //   2
  c_t[x_a][89] = {  1,  15,  16}; //   3
  c_d[x_a][89] = {  3,   8}; //   2

  c_p[x_a][90] = {  4,  33}; //   2
  c_f[x_a][90] = {  9,  10}; //   2
  c_t[x_a][90] = {  1,  17,  18}; //   3
  c_d[x_a][90] = {  8,   3}; //   2

  c_p[x_a][91] = {  0,  33}; //   2
  c_f[x_a][91] = {  9,  10}; //   2
  c_t[x_a][91] = {  1,  17,  18}; //   3
  c_d[x_a][91] = {  8,   3}; //   2

  c_p[x_a][92] = {  7,  10,  32}; //   3
  c_f[x_a][92] = {  2}; //   1
  c_t[x_a][92] = {  3,  19}; //   2
  c_d[x_a][92] = { 13,   3,   8}; //   3

  c_p[x_a][93] = {  7,  12,  32}; //   3
  c_f[x_a][93] = {  2}; //   1
  c_t[x_a][93] = {  3,  19}; //   2
  c_d[x_a][93] = { 13,   3,   8}; //   3

  c_p[x_a][94] = {  4,  33,  34}; //   3
  c_f[x_a][94] = {  3}; //   1
  c_t[x_a][94] = {  3,  20}; //   2
  c_d[x_a][94] = { 11,   8,   3}; //   3

  c_p[x_a][95] = {  0,  33,  34}; //   3
  c_f[x_a][95] = {  3}; //   1
  c_t[x_a][95] = {  3,  20}; //   2
  c_d[x_a][95] = { 11,   8,   3}; //   3

  c_p[x_a][96] = {  7,  10}; //   2
  c_f[x_a][96] = { 11,   2}; //   2
  c_t[x_a][96] = {  3,  19,  21}; //   3
  c_d[x_a][96] = {  3,   8}; //   2

  c_p[x_a][97] = {  7,  12}; //   2
  c_f[x_a][97] = { 11,   2}; //   2
  c_t[x_a][97] = {  3,  19,  21}; //   3
  c_d[x_a][97] = {  3,   8}; //   2

  c_p[x_a][98] = {  7,  10}; //   2
  c_f[x_a][98] = {  7,   8}; //   2
  c_t[x_a][98] = {  1,  15,  22}; //   3
  c_d[x_a][98] = {  3,   8}; //   2

  c_p[x_a][99] = {  7,  12}; //   2
  c_f[x_a][99] = {  7,   8}; //   2
  c_t[x_a][99] = {  1,  15,  22}; //   3
  c_d[x_a][99] = {  3,   8}; //   2

  c_p[x_a][100] = {  4,  33}; //   2
  c_f[x_a][100] = { 12,   3}; //   2
  c_t[x_a][100] = {  3,  20,  23}; //   3
  c_d[x_a][100] = {  8,   3}; //   2

  c_p[x_a][101] = {  0,  33}; //   2
  c_f[x_a][101] = { 12,   3}; //   2
  c_t[x_a][101] = {  3,  20,  23}; //   3
  c_d[x_a][101] = {  8,   3}; //   2

  c_p[x_a][102] = {  4,  33}; //   2
  c_f[x_a][102] = {  9,  10}; //   2
  c_t[x_a][102] = {  1,  17,  24}; //   3
  c_d[x_a][102] = {  8,   3}; //   2

  c_p[x_a][103] = {  0,  33}; //   2
  c_f[x_a][103] = {  9,  10}; //   2
  c_t[x_a][103] = {  1,  17,  24}; //   3
  c_d[x_a][103] = {  8,   3}; //   2

  c_p[x_a][104] = {  7,  10,  44}; //   3
  c_f[x_a][104] = { 13}; //   1
  c_t[x_a][104] = {  6,  25}; //   2
  c_d[x_a][104] = { 20,   3,   8}; //   3

  c_p[x_a][105] = {  7,  12,  44}; //   3
  c_f[x_a][105] = { 13}; //   1
  c_t[x_a][105] = {  6,  25}; //   2
  c_d[x_a][105] = { 20,   3,   8}; //   3

  c_p[x_a][106] = {  4,  33,  44}; //   3
  c_f[x_a][106] = { 13}; //   1
  c_t[x_a][106] = {  6,  26}; //   2
  c_d[x_a][106] = { 20,   8,   3}; //   3

  c_p[x_a][107] = {  0,  33,  44}; //   3
  c_f[x_a][107] = { 13}; //   1
  c_t[x_a][107] = {  6,  26}; //   2
  c_d[x_a][107] = { 20,   8,   3}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 5yyyv1(1, 2, 128, 16, 32, 4, 8, 64;  23,   0,  24,   0,   0)
// channel    1: 5yyyv1(1, 2, 128, 32, 16, 4, 8, 64;   0,   0,  24,   0,   0)
// channel    2: 5yyyv1(1, 2, 128, 32, 16, 4, 8, 64;  23,   0,  24,   0,   0)
// channel    3: 5yyyv1(1, 2, 128, 8, 4, 16, 32, 64;  24,   0,  24,   0,   0)
// channel    4: 5y2vv1(1, 2, 128, 4, 8, 16, 32, 64;  24,   0,  24,   0,   0)
// channel    5: 5y2vv1(1, 2, 128, 4, 8, 16, 32, 64;  24,  23,  24,   0,   0)
// channel    6: 52vyv1(1, 2, 4, 8, 128, 16, 32, 64;  24,   0,   0,   0,   0)
// channel    7: 52vyv1(1, 2, 4, 8, 128, 16, 32, 64;  24,   0,  23,   0,   0)
// channel    8: 52vyv1(1, 2, 16, 32, 128, 4, 8, 64;   0,   0,  24,   0,   0)
// channel    9: 52vyv1(1, 2, 16, 32, 128, 4, 8, 64;  23,   0,  24,   0,   0)
// channel   10: 6yyyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   11: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   12: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   13: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   14: 6yy2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   15: 6yy2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   16: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   17: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   18: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   19: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   20: 62vyyv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   21: 62vyyv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,  23,   0)
// channel   22: 62vyyv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,   0,  24,   0)
// channel   23: 62vyyv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,   0,  24,   0)
// channel   24: 62vyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   25: 62vyyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   26: 62vyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   27: 62vyyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   28: 62v2vv(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,   0,   0)
// channel   29: 62v2vv(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,  23,   0)
// channel   30: 62v2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   31: 62v2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   32: 62v2vv(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,   0,  24,   0)
// channel   33: 62v2vv(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  24,   0)
// channel   34: 14yyv1(1, 2, 128, 16, 32, 4, 8, 64;  23,   0,  24,   0,   0)
// channel   35: 14yyv1(1, 2, 128, 32, 16, 4, 8, 64;   0,   0,  24,   0,   0)
// channel   36: 14yyv1(1, 2, 128, 32, 16, 4, 8, 64;  23,   0,  24,   0,   0)
// channel   37: 14yyv1(1, 2, 128, 8, 4, 16, 32, 64;  24,   0,  24,   0,   0)
// channel   38: 142vv1(1, 2, 128, 4, 8, 16, 32, 64;  24,   0,  24,   0,   0)
// channel   39: 142vv1(1, 2, 128, 4, 8, 16, 32, 64;  24,  23,  24,   0,   0)
// channel   40: 15yyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   41: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   42: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   43: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   44: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   45: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   46: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   47: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   48: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   49: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   50: 114yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   51: 114yyv(1, 2, 128, 64, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   52: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   53: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   54: 114yyv(1, 2, 128, 64, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   55: 114yyv(1, 2, 128, 64, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   56: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   57: 114yyv(1, 2, 128, 64, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   58: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   59: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   60: 1142vv(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   61: 1142vv(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   62: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   63: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   64: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   65: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   66: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   67: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   68: 3yv2v1(1, 2, 128, 4, 8, 16, 32, 64;  24,   0,   0,   0,   0)
// channel   69: 3yv2v1(1, 2, 128, 4, 8, 16, 32, 64;  24,  23,   0,   0,   0)
// channel   70: 3yv2v1(1, 2, 128, 16, 32, 4, 8, 64;   0,  24,   0,   0,   0)
// channel   71: 3yv2v1(1, 2, 128, 16, 32, 4, 8, 64;  23,  24,   0,   0,   0)
// channel   72: 3yv12v(1, 2, 128, 4, 8, 64, 16, 32;  24,   0,   0,   0,   0)
// channel   73: 3yv12v(1, 2, 128, 4, 8, 64, 16, 32;  24,  23,   0,   0,   0)
// channel   74: 3yv12v(1, 2, 128, 16, 32, 64, 4, 8;   0,  24,   0,   0,   0)
// channel   75: 3yv12v(1, 2, 128, 16, 32, 64, 4, 8;  23,  24,   0,   0,   0)
// channel   76: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   77: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   78: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   79: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   80: 42vv2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   81: 42vv2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   82: 42vv2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   83: 42vv2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   84: 12v2v1(1, 2, 128, 4, 8, 16, 32, 64;  24,   0,   0,   0,   0)
// channel   85: 12v2v1(1, 2, 128, 4, 8, 16, 32, 64;  24,  23,   0,   0,   0)
// channel   86: 12v2v1(1, 2, 128, 16, 32, 4, 8, 64;   0,  24,   0,   0,   0)
// channel   87: 12v2v1(1, 2, 128, 16, 32, 4, 8, 64;  23,  24,   0,   0,   0)
// channel   88: 12v12v(1, 2, 128, 4, 8, 64, 16, 32;  24,   0,   0,   0,   0)
// channel   89: 12v12v(1, 2, 128, 4, 8, 64, 16, 32;  24,  23,   0,   0,   0)
// channel   90: 12v12v(1, 2, 128, 16, 32, 64, 4, 8;   0,  24,   0,   0,   0)
// channel   91: 12v12v(1, 2, 128, 16, 32, 64, 4, 8;  23,  24,   0,   0,   0)
// channel   92: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   93: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   94: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   95: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   96: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   97: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   98: 112v2v(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   99: 112v2v(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel  100: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel  101: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel  102: 112v2v(1, 2, 128, 64, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel  103: 112v2v(1, 2, 128, 64, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel  104: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel  105: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel  106: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel  107: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
