#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_240_udx_emepmupvmccx(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_240_udx_emepmupvmccx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(16);
  needed_v_smin[x_a].resize(16);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    8,    9,   10,   11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  needed_v_smin[x_a][  1] = {   0,    1,   10,   11}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,   10,   11}; //   4
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    7,    8,    9,   10,   11,   12,   13,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  needed_v_smin[x_a][  4] = {   2,    3,   12,   13}; //   4
  needed_v_smin[x_a][  5] = {   2,    3,   12,   13}; //   4
  needed_v_smin[x_a][  6] = {   4,   14}; //   2
  needed_v_smin[x_a][  7] = {   4,   14}; //   2
  needed_v_smin[x_a][  8] = {   4,    5,    6,    7,    8,    9,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smin[x_a][  9] = {   5,    6,   15,   16}; //   4
  needed_v_smin[x_a][ 10] = {   5,    6,   15,   16}; //   4
  needed_v_smin[x_a][ 11] = {   7,   17}; //   2
  needed_v_smin[x_a][ 12] = {   7,   17}; //   2
  needed_v_smin[x_a][ 13] = {   8,    9,   18,   19,   24,   25,   30,   31}; //   8
  needed_v_smin[x_a][ 14] = {  20,   21,   22,   23}; //   4
  needed_v_smin[x_a][ 15] = {  26,   27,   28,   29}; //   4

  v_smax[x_a].resize(29);
  needed_v_smax[x_a].resize(29);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,   28,   29,   30,   31}; //  11
  needed_v_smax[x_a][  1] = {   0,    1}; //   2
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  4] = {   2,    3}; //   2
  needed_v_smax[x_a][  5] = {   4}; //   1
  needed_v_smax[x_a][  6] = {   4,    5,    6,    7,    8,    9}; //   6
  needed_v_smax[x_a][  7] = {   4,    5,    6,    7,    8,    9}; //   6
  needed_v_smax[x_a][  8] = {   5,    6}; //   2
  needed_v_smax[x_a][  9] = {   7,    8,    9,   10,   11,   12,   13,   22,   23,   24,   25}; //  11
  needed_v_smax[x_a][ 10] = {   7}; //   1
  needed_v_smax[x_a][ 11] = {   8,    9,   10,   11,   12,   13,   24,   25}; //   8
  needed_v_smax[x_a][ 12] = {  10,   11}; //   2
  needed_v_smax[x_a][ 13] = {  10,   11,   12,   13,   26,   27,   28,   29}; //   8
  needed_v_smax[x_a][ 14] = {  12,   13}; //   2
  needed_v_smax[x_a][ 15] = {  14,   15,   16,   17,   18,   19,   20,   21,   26,   27}; //  10
  needed_v_smax[x_a][ 16] = {  14,   15,   16,   26,   27}; //   5
  needed_v_smax[x_a][ 17] = {  14}; //   1
  needed_v_smax[x_a][ 18] = {  14,   15,   16,   17,   18,   19,   24,   25,   30,   31}; //  10
  needed_v_smax[x_a][ 19] = {  15,   16}; //   2
  needed_v_smax[x_a][ 20] = {  17,   18,   19,   20,   21}; //   5
  needed_v_smax[x_a][ 21] = {  17}; //   1
  needed_v_smax[x_a][ 22] = {  18,   19,   20,   21,   22,   23}; //   6
  needed_v_smax[x_a][ 23] = {  22,   23}; //   2
  needed_v_smax[x_a][ 24] = {  24,   25,   30,   31}; //   4
  needed_v_smax[x_a][ 25] = {  26,   27,   28,   29}; //   4
  needed_v_smax[x_a][ 26] = {  28,   29}; //   2
  needed_v_smax[x_a][ 27] = {  30,   31}; //   2
  needed_v_smax[x_a][ 28] = {  20,   21,   22,   23}; //   4

  g_p[x_a].resize(40);
  needed_g_p[x_a].resize(40);
  needed_g_p[x_a][0] = {   0,    2,    5,   28,   30}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    4,    6,   29,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax2");
  needed_g_p[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][9] = {   4,    5,    6,    7,    8,    9}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   5,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][11] = {   5,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax6");
  needed_g_p[x_a][12] = {   7,    8,    9,   10,   11,   12,   13,   22,   23,   24,   25}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax9");
  needed_g_p[x_a][13] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax10");
  needed_g_p[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax6");
  needed_g_p[x_a][15] = {   8,   10,   12,   24}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax11");
  needed_g_p[x_a][16] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax6");
  needed_g_p[x_a][17] = {   9,   11,   13,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");
  needed_g_p[x_a][18] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax12");
  needed_g_p[x_a][19] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax13");
  needed_g_p[x_a][20] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax14");
  needed_g_p[x_a][21] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax13");
  needed_g_p[x_a][22] = {  14,   15,   16,   17,   18,   19,   20,   21,   26,   27}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax15");
  needed_g_p[x_a][23] = {  14,   16,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][24] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax17");
  needed_g_p[x_a][25] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax18");
  needed_g_p[x_a][26] = {  15,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax16");
  needed_g_p[x_a][27] = {  15,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax19");
  needed_g_p[x_a][28] = {  15,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax18");
  needed_g_p[x_a][29] = {  17,   18,   19,   20,   21}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax20");
  needed_g_p[x_a][30] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax21");
  needed_g_p[x_a][31] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax18");
  needed_g_p[x_a][32] = {  18,   20,   22}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax22");
  needed_g_p[x_a][33] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax18");
  needed_g_p[x_a][34] = {  19,   21,   23}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax22");
  needed_g_p[x_a][35] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax23");
  needed_g_p[x_a][36] = {  24,   25,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax24");
  needed_g_p[x_a][37] = {  26,   27,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax25");
  needed_g_p[x_a][38] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax26");
  needed_g_p[x_a][39] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax27");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax28");
  needed_g_f[x_a][1] = {  24,   25,   30,   31}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax18");
  needed_g_f[x_a][2] = {  26,   27,   28,   29}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax13");

  g_t[x_a].resize(11);
  needed_g_t[x_a].resize(11);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,   26,   27,   28,   29}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][1] = {   4,    5,    6,    7,    8,    9,   24,   25,   30,   31}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][2] = {  10,   11,   12,   13}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][3] = {  14,   15,   16,   17,   18,   19}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][4] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][5] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__192_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__192_48");
  needed_g_t[x_a][6] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][7] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][8] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__192_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__192_12");
  needed_g_t[x_a][9] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][10] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");

  g_d[x_a].resize(14);
  needed_g_d[x_a].resize(14);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    7,    8,    9,   10,   11,   12,   13,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][1] = {   0,    1,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__64_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__64_140");
  needed_g_d[x_a][2] = {   0,    1,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,    4,    5,    6,    8,    9,   10,   11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][4] = {   2,    3,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__128_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__128_76");
  needed_g_d[x_a][5] = {   2,    3,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][6] = {   4,    5,    6,    7,    8,    9,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][7] = {   4,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   4,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   5,    6,   15,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][10] = {   5,    6,   15,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   7,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   7,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   8,    9,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");

  c_p[x_a].resize(32);
  c_f[x_a].resize(32);
  c_t[x_a].resize(32);
  c_d[x_a].resize(32);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   1,   2,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  0,   5,   6,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  4,   5,   6,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   4,   5,   3}; //   4

  c_p[x_a][4] = {  4,   7,   8,   9}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  1}; //   1
  c_d[x_a][4] = {  6,   7,   8,   3}; //   4

  c_p[x_a][5] = {  0,  10,  11,   9}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  1}; //   1
  c_d[x_a][5] = {  6,   9,  10,   3}; //   4

  c_p[x_a][6] = {  4,  10,  11,   9}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  1}; //   1
  c_d[x_a][6] = {  6,   9,  10,   3}; //   4

  c_p[x_a][7] = { 12,  13,  14,   9}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  1}; //   1
  c_d[x_a][7] = {  6,  11,  12,   0}; //   4

  c_p[x_a][8] = { 12,  15,  16,   9}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  1}; //   1
  c_d[x_a][8] = {  6,  13,   3,   0}; //   4

  c_p[x_a][9] = { 12,  17,  16,   9}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  1}; //   1
  c_d[x_a][9] = {  6,  13,   3,   0}; //   4

  c_p[x_a][10] = { 12,  15,  18,  19}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  2}; //   1
  c_d[x_a][10] = {  1,   2,   3,   0}; //   4

  c_p[x_a][11] = { 12,  17,  18,  19}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  2}; //   1
  c_d[x_a][11] = {  1,   2,   3,   0}; //   4

  c_p[x_a][12] = { 12,  15,  20,  21}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  2}; //   1
  c_d[x_a][12] = {  4,   5,   3,   0}; //   4

  c_p[x_a][13] = { 12,  17,  20,  21}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  2}; //   1
  c_d[x_a][13] = {  4,   5,   3,   0}; //   4

  c_p[x_a][14] = { 22,  23,  24,  25}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  3}; //   1
  c_d[x_a][14] = {  7,   8,   3,   6}; //   4

  c_p[x_a][15] = { 22,  26,  27,  28}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  3}; //   1
  c_d[x_a][15] = {  9,  10,   3,   6}; //   4

  c_p[x_a][16] = { 22,  23,  27,  28}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  3}; //   1
  c_d[x_a][16] = {  9,  10,   3,   6}; //   4

  c_p[x_a][17] = { 22,  29,  30,  31}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  3}; //   1
  c_d[x_a][17] = { 11,  12,   0,   6}; //   4

  c_p[x_a][18] = { 22,  29,  32,  33}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  3}; //   1
  c_d[x_a][18] = { 13,   3,   0,   6}; //   4

  c_p[x_a][19] = { 22,  29,  34,  33}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  3}; //   1
  c_d[x_a][19] = { 13,   3,   0,   6}; //   4

  c_p[x_a][20] = { 22,  29,  32}; //   3
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  4,   5}; //   2
  c_d[x_a][20] = {  3,   0,   6}; //   3

  c_p[x_a][21] = { 22,  29,  34}; //   3
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  4,   5}; //   2
  c_d[x_a][21] = {  3,   0,   6}; //   3

  c_p[x_a][22] = { 12,  35,  32}; //   3
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  4,   6}; //   2
  c_d[x_a][22] = {  3,   6,   0}; //   3

  c_p[x_a][23] = { 12,  35,  34}; //   3
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  4,   6}; //   2
  c_d[x_a][23] = {  3,   6,   0}; //   3

  c_p[x_a][24] = { 12,  15,  36}; //   3
  c_f[x_a][24] = {  1}; //   1
  c_t[x_a][24] = {  1,   7}; //   2
  c_d[x_a][24] = {  6,   3,   0}; //   3

  c_p[x_a][25] = { 12,  17,  36}; //   3
  c_f[x_a][25] = {  1}; //   1
  c_t[x_a][25] = {  1,   7}; //   2
  c_d[x_a][25] = {  6,   3,   0}; //   3

  c_p[x_a][26] = { 22,  26,  37}; //   3
  c_f[x_a][26] = {  2}; //   1
  c_t[x_a][26] = {  0,   8}; //   2
  c_d[x_a][26] = {  0,   3,   6}; //   3

  c_p[x_a][27] = { 22,  23,  37}; //   3
  c_f[x_a][27] = {  2}; //   1
  c_t[x_a][27] = {  0,   8}; //   2
  c_d[x_a][27] = {  0,   3,   6}; //   3

  c_p[x_a][28] = {  0,  38,  37}; //   3
  c_f[x_a][28] = {  2}; //   1
  c_t[x_a][28] = {  0,   9}; //   2
  c_d[x_a][28] = {  0,   6,   3}; //   3

  c_p[x_a][29] = {  4,  38,  37}; //   3
  c_f[x_a][29] = {  2}; //   1
  c_t[x_a][29] = {  0,   9}; //   2
  c_d[x_a][29] = {  0,   6,   3}; //   3

  c_p[x_a][30] = {  0,  39,  36}; //   3
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  1,  10}; //   2
  c_d[x_a][30] = {  6,   0,   3}; //   3

  c_p[x_a][31] = {  4,  39,  36}; //   3
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = {  1,  10}; //   2
  c_d[x_a][31] = {  6,   0,   3}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,   0,  24,   0)
// channel    1: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,   0,  24,   0)
// channel    2: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;   0,   0,   0,  24,   0)
// channel    3: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;  23,   0,   0,  24,   0)
// channel    4: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel    5: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel    6: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel    7: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel    8: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel    9: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   10: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   11: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   12: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   13: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   14: 4yyv2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  24,   0)
// channel   15: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,   0,   0,  24,   0)
// channel   16: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,  23,   0,  24,   0)
// channel   17: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   18: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   19: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,  24,   0)
// channel   20: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,   0,   0)
// channel   21: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,   0,   0)
// channel   22: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   23: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   24: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   25: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   26: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,  24,   0,   0)
// channel   27: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,  24,   0,   0)
// channel   28: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   29: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   30: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   31: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
