#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_240_udx_emepmupvmddx(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_240_udx_emepmupvmddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(21);
  needed_v_smin[x_a].resize(21);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  needed_v_smin[x_a][  1] = {   0,    6,   28,   46}; //   4
  needed_v_smin[x_a][  2] = {   0,    6,   28,   46}; //   4
  needed_v_smin[x_a][  3] = {   1,    2,    7,    8,   29,   30,   47,   48}; //   8
  needed_v_smin[x_a][  4] = {   1,    2,    7,    8,   29,   30,   47,   48}; //   8
  needed_v_smin[x_a][  5] = {   3,    4,    5,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  needed_v_smin[x_a][  6] = {   3,    9,   31,   49}; //   4
  needed_v_smin[x_a][  7] = {   3,    9,   31,   49}; //   4
  needed_v_smin[x_a][  8] = {   4,    5,   10,   11,   32,   33,   50,   51,   56,   57,   62,   63}; //  12
  needed_v_smin[x_a][  9] = {   6,    7,    8,    9,   10,   11,    0,    1,    2,    3,    4,    5}; //  12
  needed_v_smin[x_a][ 10] = {  12,   13,   20,   21,   38,   39,   40,   41,   16,   17}; //  10
  needed_v_smin[x_a][ 11] = {  12,   13,   16,   17,   20,   21}; //   6
  needed_v_smin[x_a][ 12] = {  14,   15,   22,   23,   26,   27,   44,   45,   18,   19}; //  10
  needed_v_smin[x_a][ 13] = {  14,   15,   18,   19,   22,   23}; //   6
  needed_v_smin[x_a][ 14] = {  24,   25,   34,   35,   38,   39,   42,   43}; //   8
  needed_v_smin[x_a][ 15] = {  24,   25,   42,   43,   34,   35}; //   6
  needed_v_smin[x_a][ 16] = {  26,   27,   44,   45}; //   4
  needed_v_smin[x_a][ 17] = {  28,   29,   30,   31,   32,   33,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   36,   37}; //  26
  needed_v_smin[x_a][ 18] = {  36,   37,   58,   59,   60,   61}; //   6
  needed_v_smin[x_a][ 19] = {  40,   41}; //   2
  needed_v_smin[x_a][ 20] = {  52,   53,   54,   55}; //   4

  v_smax[x_a].resize(36);
  needed_v_smax[x_a].resize(36);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,   14,   15,   18,   19,   22,   23,   24,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   40,   41,   60,   61,   62,   63}; //  31
  needed_v_smax[x_a][  1] = {   0,    6,   28}; //   3
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   28,   29,   30,   31,   32,   33}; //  18
  needed_v_smax[x_a][  3] = {   1,    2,    7,    8,   29,   30}; //   6
  needed_v_smax[x_a][  4] = {   3,    4,    5,    9,   10,   11,   12,   13,   16,   17,   20,   21,   31,   32,   33,   42,   43,   44,   45,   54,   55,   56,   57}; //  23
  needed_v_smax[x_a][  5] = {   3,    9,   31}; //   3
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11,   16,   17,   32,   33,   42,   43,   44,   45,   56,   57}; //  14
  needed_v_smax[x_a][  7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,    0,    1,    2,    3,    4,    5,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  needed_v_smax[x_a][  8] = {  12,   13,   20,   21}; //   4
  needed_v_smax[x_a][  9] = {  12,   13,   20,   21}; //   4
  needed_v_smax[x_a][ 10] = {  14,   15,   22,   23,   26,   27}; //   6
  needed_v_smax[x_a][ 11] = {  14,   15,   22,   23}; //   4
  needed_v_smax[x_a][ 12] = {  18,   19,   36,   37,   40,   41,   62,   63}; //   8
  needed_v_smax[x_a][ 13] = {  24,   25,   34,   35,   38,   39}; //   6
  needed_v_smax[x_a][ 14] = {  24,   25,   26,   27}; //   4
  needed_v_smax[x_a][ 15] = {  24,   25,   26,   27}; //   4
  needed_v_smax[x_a][ 16] = {  28,   29,   30,   31,   32,   33}; //   6
  needed_v_smax[x_a][ 17] = {  34,   35,   38,   39}; //   4
  needed_v_smax[x_a][ 18] = {  38,   39}; //   2
  needed_v_smax[x_a][ 19] = {  40,   41,   16,   17}; //   4
  needed_v_smax[x_a][ 20] = {  42,   43}; //   2
  needed_v_smax[x_a][ 21] = {  42,   43,   44,   45,   34,   35,   36,   37,   58,   59,   60,   61}; //  12
  needed_v_smax[x_a][ 22] = {  44,   45,   18,   19}; //   4
  needed_v_smax[x_a][ 23] = {  46,   47,   48,   49,   50,   51,   52,   53,   58,   59}; //  10
  needed_v_smax[x_a][ 24] = {  46,   47,   48,   58,   59}; //   5
  needed_v_smax[x_a][ 25] = {  46}; //   1
  needed_v_smax[x_a][ 26] = {  46,   47,   48,   49,   50,   51,   56,   57,   62,   63}; //  10
  needed_v_smax[x_a][ 27] = {  47,   48}; //   2
  needed_v_smax[x_a][ 28] = {  49,   50,   51,   52,   53}; //   5
  needed_v_smax[x_a][ 29] = {  49}; //   1
  needed_v_smax[x_a][ 30] = {  50,   51,   52,   53,   54,   55}; //   6
  needed_v_smax[x_a][ 31] = {  54,   55}; //   2
  needed_v_smax[x_a][ 32] = {  56,   57,   62,   63,   36,   37}; //   6
  needed_v_smax[x_a][ 33] = {  58,   59,   60,   61}; //   4
  needed_v_smax[x_a][ 34] = {  60,   61}; //   2
  needed_v_smax[x_a][ 35] = {  40,   41,   52,   53,   54,   55}; //   6

  g_p[x_a].resize(50);
  needed_g_p[x_a].resize(50);
  needed_g_p[x_a][0] = {   0,    2,    6,    8,   15,   19,   23,   25,   27,   28,   30,   35,   37,   39,   41,   61,   63}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    6,   28}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    6,   28}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    7,   14,   18,   22,   24,   26,   29,   34,   36,   38,   40,   60,   62}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][4] = {   1,    2,    7,    8,   29,   30}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   1,    2,    7,    8,   29,   30}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,    9,   10,   11,   12,   13,   16,   17,   20,   21,   31,   32,   33,   42,   43,   44,   45,   54,   55,   56,   57}; //  23
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    9,   31}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,    9,   31}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   10,   16,   32,   42,   44,   56}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][10] = {   4,    5,   10,   11,   32,   33}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   11,   17,   33,   43,   45,   57}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][12] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {  12,   13,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {  12,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");
  needed_g_p[x_a][15] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][16] = {  13,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][17] = {  14,   15,   22,   23,   26,   27}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][18] = {  14,   15,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax11");
  needed_g_p[x_a][19] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax7");
  needed_g_p[x_a][20] = {  18,   19,   36,   37,   40,   41,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax12");
  needed_g_p[x_a][21] = {  24,   25,   34,   35,   38,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax13");
  needed_g_p[x_a][22] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax14");
  needed_g_p[x_a][23] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax15");
  needed_g_p[x_a][24] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax14");
  needed_g_p[x_a][25] = {  28,   29,   30,   31,   32,   33}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax16");
  needed_g_p[x_a][26] = {  34,   35,   38,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax17");
  needed_g_p[x_a][27] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax18");
  needed_g_p[x_a][28] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax19");
  needed_g_p[x_a][29] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax20");
  needed_g_p[x_a][30] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax21");
  needed_g_p[x_a][31] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax22");
  needed_g_p[x_a][32] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax21");
  needed_g_p[x_a][33] = {  46,   47,   48,   49,   50,   51,   52,   53,   58,   59}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax23");
  needed_g_p[x_a][34] = {  46,   48,   59}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax24");
  needed_g_p[x_a][35] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax25");
  needed_g_p[x_a][36] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax26");
  needed_g_p[x_a][37] = {  47,   58}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax24");
  needed_g_p[x_a][38] = {  47,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax27");
  needed_g_p[x_a][39] = {  47,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax26");
  needed_g_p[x_a][40] = {  49,   50,   51,   52,   53}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax28");
  needed_g_p[x_a][41] = {  49}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax29");
  needed_g_p[x_a][42] = {  49}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax26");
  needed_g_p[x_a][43] = {  50,   52,   54}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax30");
  needed_g_p[x_a][44] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax26");
  needed_g_p[x_a][45] = {  51,   53,   55}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax30");
  needed_g_p[x_a][46] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax31");
  needed_g_p[x_a][47] = {  56,   57,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax32");
  needed_g_p[x_a][48] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax33");
  needed_g_p[x_a][49] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax34");

  g_f[x_a].resize(11);
  needed_g_f[x_a].resize(11);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][1] = {  16,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax19");
  needed_g_f[x_a][2] = {  16,   17,   20,   21}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax7");
  needed_g_f[x_a][3] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax22");
  needed_g_f[x_a][4] = {  18,   19,   22,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax7");
  needed_g_f[x_a][5] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax21");
  needed_g_f[x_a][6] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax32");
  needed_g_f[x_a][7] = {  36,   37,   58,   59,   60,   61}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax21");
  needed_g_f[x_a][8] = {  40,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax35");
  needed_g_f[x_a][9] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax35");
  needed_g_f[x_a][10] = {  56,   57,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax26");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  16,   17,   20,   21}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__12_112");
  needed_g_t[x_a][3] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_13__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_13__64_48");
  needed_g_t[x_a][4] = {  18,   19,   22,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__48_76");
  needed_g_t[x_a][5] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_49__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_49__64_12");
  needed_g_t[x_a][6] = {  24,   25,   26,   27,   34,   35,   36,   37,   58,   59,   60,   61}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][7] = {  28,   29,   30,   31,   32,   33,   56,   57,   62,   63}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][8] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__140_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__140_64");
  needed_g_t[x_a][9] = {  36,   37,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][10] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__49_14__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__49_14__64_128");
  needed_g_t[x_a][11] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__112_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__112_140");
  needed_g_t[x_a][12] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][13] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_14__112_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_14__112_128");
  needed_g_t[x_a][14] = {  42,   43,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][15] = {  46,   47,   48,   49,   50,   51}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][16] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][17] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__192_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__192_48");
  needed_g_t[x_a][18] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][19] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][20] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__192_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__192_12");
  needed_g_t[x_a][21] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");

  g_d[x_a].resize(18);
  needed_g_d[x_a].resize(18);
  needed_g_d[x_a][0] = {   0,    6,   28,   46}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][1] = {   0,    6,   28,   46}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   1,    2,    7,    8,   29,   30,   47,   48}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   1,    2,    7,    8,   29,   30,   47,   48}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   3,    9,   31,   49}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    9,   31,   49}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][7] = {   3,    4,    5,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][8] = {   4,    5,   10,   11,   32,   33,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][9] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][10] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][11] = {  12,   13,   20,   21,   38,   39,   40,   41}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][12] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][13] = {  14,   15,   22,   23,   26,   27,   44,   45}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][14] = {  24,   25,   42,   43}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__64_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__64_140");
  needed_g_d[x_a][15] = {  24,   25,   34,   35,   38,   39,   42,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][16] = {  26,   27,   44,   45}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__128_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__128_76");
  needed_g_d[x_a][17] = {  28,   29,   30,   31,   32,   33,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   9,  10}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  8,   2,   7}; //   3

  c_p[x_a][5] = {  6,  11,  10}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  8,   2,   7}; //   3

  c_p[x_a][6] = {  0,   1,   2,  12}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  9,   0,   1,   2}; //   4

  c_p[x_a][7] = {  3,   4,   5,  12}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  9,   3,   4,   2}; //   4

  c_p[x_a][8] = {  0,   4,   5,  12}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  9,   3,   4,   2}; //   4

  c_p[x_a][9] = {  6,   7,   8,  12}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  9,   5,   6,   7}; //   4

  c_p[x_a][10] = {  6,   9,  10,  12}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  9,   8,   2,   7}; //   4

  c_p[x_a][11] = {  6,  11,  10,  12}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  9,   8,   2,   7}; //   4

  c_p[x_a][12] = {  6,  13,  14,  15}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 10,   2,  11,   7}; //   4

  c_p[x_a][13] = {  6,  13,  16,  15}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 10,   2,  11,   7}; //   4

  c_p[x_a][14] = {  3,  17,  18,  19}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 12,   7,  13,   2}; //   4

  c_p[x_a][15] = {  0,  17,  18,  19}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 12,   7,  13,   2}; //   4

  c_p[x_a][16] = {  6,   9}; //   2
  c_f[x_a][16] = {  1,   2}; //   2
  c_t[x_a][16] = {  0,   2,   3}; //   3
  c_d[x_a][16] = {  2,   7}; //   2

  c_p[x_a][17] = {  6,  11}; //   2
  c_f[x_a][17] = {  1,   2}; //   2
  c_t[x_a][17] = {  0,   2,   3}; //   3
  c_d[x_a][17] = {  2,   7}; //   2

  c_p[x_a][18] = {  3,  20}; //   2
  c_f[x_a][18] = {  3,   4}; //   2
  c_t[x_a][18] = {  0,   4,   5}; //   3
  c_d[x_a][18] = {  7,   2}; //   2

  c_p[x_a][19] = {  0,  20}; //   2
  c_f[x_a][19] = {  3,   4}; //   2
  c_t[x_a][19] = {  0,   4,   5}; //   3
  c_d[x_a][19] = {  7,   2}; //   2

  c_p[x_a][20] = {  6,  13,  14}; //   3
  c_f[x_a][20] = {  2}; //   1
  c_t[x_a][20] = {  0,   2}; //   2
  c_d[x_a][20] = {  2,  11,   7}; //   3

  c_p[x_a][21] = {  6,  13,  16}; //   3
  c_f[x_a][21] = {  2}; //   1
  c_t[x_a][21] = {  0,   2}; //   2
  c_d[x_a][21] = {  2,  11,   7}; //   3

  c_p[x_a][22] = {  3,  17,  18}; //   3
  c_f[x_a][22] = {  4}; //   1
  c_t[x_a][22] = {  0,   4}; //   2
  c_d[x_a][22] = {  7,  13,   2}; //   3

  c_p[x_a][23] = {  0,  17,  18}; //   3
  c_f[x_a][23] = {  4}; //   1
  c_t[x_a][23] = {  0,   4}; //   2
  c_d[x_a][23] = {  7,  13,   2}; //   3

  c_p[x_a][24] = {  3,  21,  22,  23}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  6}; //   1
  c_d[x_a][24] = {  7,  14,  15,   2}; //   4

  c_p[x_a][25] = {  0,  21,  22,  23}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  6}; //   1
  c_d[x_a][25] = {  7,  14,  15,   2}; //   4

  c_p[x_a][26] = {  3,  17,  24,  23}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  6}; //   1
  c_d[x_a][26] = {  7,  16,  13,   2}; //   4

  c_p[x_a][27] = {  0,  17,  24,  23}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  6}; //   1
  c_d[x_a][27] = {  7,  16,  13,   2}; //   4

  c_p[x_a][28] = {  0,   1,   2,  25}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  7}; //   1
  c_d[x_a][28] = { 17,   0,   1,   2}; //   4

  c_p[x_a][29] = {  3,   4,   5,  25}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  7}; //   1
  c_d[x_a][29] = { 17,   3,   4,   2}; //   4

  c_p[x_a][30] = {  0,   4,   5,  25}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  7}; //   1
  c_d[x_a][30] = { 17,   3,   4,   2}; //   4

  c_p[x_a][31] = {  6,   7,   8,  25}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  7}; //   1
  c_d[x_a][31] = { 17,   5,   6,   7}; //   4

  c_p[x_a][32] = {  6,   9,  10,  25}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  7}; //   1
  c_d[x_a][32] = { 17,   8,   2,   7}; //   4

  c_p[x_a][33] = {  6,  11,  10,  25}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  7}; //   1
  c_d[x_a][33] = { 17,   8,   2,   7}; //   4

  c_p[x_a][34] = {  3,  21,  26}; //   3
  c_f[x_a][34] = {  5}; //   1
  c_t[x_a][34] = {  6,   8}; //   2
  c_d[x_a][34] = {  7,  15,   2}; //   3

  c_p[x_a][35] = {  0,  21,  26}; //   3
  c_f[x_a][35] = {  5}; //   1
  c_t[x_a][35] = {  6,   8}; //   2
  c_d[x_a][35] = {  7,  15,   2}; //   3

  c_p[x_a][36] = {  3,  20}; //   2
  c_f[x_a][36] = {  6,   7}; //   2
  c_t[x_a][36] = {  6,   9,  10}; //   3
  c_d[x_a][36] = {  7,   2}; //   2

  c_p[x_a][37] = {  0,  20}; //   2
  c_f[x_a][37] = {  6,   7}; //   2
  c_t[x_a][37] = {  6,   9,  10}; //   3
  c_d[x_a][37] = {  7,   2}; //   2

  c_p[x_a][38] = {  3,  21,  26,  27}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 11}; //   1
  c_d[x_a][38] = { 11,   7,  15,   2}; //   4

  c_p[x_a][39] = {  0,  21,  26,  27}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 11}; //   1
  c_d[x_a][39] = { 11,   7,  15,   2}; //   4

  c_p[x_a][40] = {  3,  20,  28}; //   3
  c_f[x_a][40] = {  8}; //   1
  c_t[x_a][40] = { 12,  13}; //   2
  c_d[x_a][40] = { 11,   7,   2}; //   3

  c_p[x_a][41] = {  0,  20,  28}; //   3
  c_f[x_a][41] = {  8}; //   1
  c_t[x_a][41] = { 12,  13}; //   2
  c_d[x_a][41] = { 11,   7,   2}; //   3

  c_p[x_a][42] = {  6,   9,  29,  30}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 14}; //   1
  c_d[x_a][42] = { 14,  15,   2,   7}; //   4

  c_p[x_a][43] = {  6,  11,  29,  30}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 14}; //   1
  c_d[x_a][43] = { 14,  15,   2,   7}; //   4

  c_p[x_a][44] = {  6,   9,  31,  32}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 14}; //   1
  c_d[x_a][44] = { 16,  13,   2,   7}; //   4

  c_p[x_a][45] = {  6,  11,  31,  32}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 14}; //   1
  c_d[x_a][45] = { 16,  13,   2,   7}; //   4

  c_p[x_a][46] = { 33,  34,  35,  36}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 15}; //   1
  c_d[x_a][46] = {  0,   1,   2,  17}; //   4

  c_p[x_a][47] = { 33,  37,  38,  39}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 15}; //   1
  c_d[x_a][47] = {  3,   4,   2,  17}; //   4

  c_p[x_a][48] = { 33,  34,  38,  39}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = { 15}; //   1
  c_d[x_a][48] = {  3,   4,   2,  17}; //   4

  c_p[x_a][49] = { 33,  40,  41,  42}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = { 15}; //   1
  c_d[x_a][49] = {  5,   6,   7,  17}; //   4

  c_p[x_a][50] = { 33,  40,  43,  44}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = { 15}; //   1
  c_d[x_a][50] = {  8,   2,   7,  17}; //   4

  c_p[x_a][51] = { 33,  40,  45,  44}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = { 15}; //   1
  c_d[x_a][51] = {  8,   2,   7,  17}; //   4

  c_p[x_a][52] = { 33,  40,  43}; //   3
  c_f[x_a][52] = {  9}; //   1
  c_t[x_a][52] = { 16,  17}; //   2
  c_d[x_a][52] = {  2,   7,  17}; //   3

  c_p[x_a][53] = { 33,  40,  45}; //   3
  c_f[x_a][53] = {  9}; //   1
  c_t[x_a][53] = { 16,  17}; //   2
  c_d[x_a][53] = {  2,   7,  17}; //   3

  c_p[x_a][54] = {  6,  46,  43}; //   3
  c_f[x_a][54] = {  9}; //   1
  c_t[x_a][54] = { 16,  18}; //   2
  c_d[x_a][54] = {  2,  17,   7}; //   3

  c_p[x_a][55] = {  6,  46,  45}; //   3
  c_f[x_a][55] = {  9}; //   1
  c_t[x_a][55] = { 16,  18}; //   2
  c_d[x_a][55] = {  2,  17,   7}; //   3

  c_p[x_a][56] = {  6,   9,  47}; //   3
  c_f[x_a][56] = { 10}; //   1
  c_t[x_a][56] = {  7,  19}; //   2
  c_d[x_a][56] = { 17,   2,   7}; //   3

  c_p[x_a][57] = {  6,  11,  47}; //   3
  c_f[x_a][57] = { 10}; //   1
  c_t[x_a][57] = {  7,  19}; //   2
  c_d[x_a][57] = { 17,   2,   7}; //   3

  c_p[x_a][58] = { 33,  37,  48}; //   3
  c_f[x_a][58] = {  7}; //   1
  c_t[x_a][58] = {  6,  20}; //   2
  c_d[x_a][58] = {  7,   2,  17}; //   3

  c_p[x_a][59] = { 33,  34,  48}; //   3
  c_f[x_a][59] = {  7}; //   1
  c_t[x_a][59] = {  6,  20}; //   2
  c_d[x_a][59] = {  7,   2,  17}; //   3

  c_p[x_a][60] = {  3,  49,  48}; //   3
  c_f[x_a][60] = {  7}; //   1
  c_t[x_a][60] = {  6,   9}; //   2
  c_d[x_a][60] = {  7,  17,   2}; //   3

  c_p[x_a][61] = {  0,  49,  48}; //   3
  c_f[x_a][61] = {  7}; //   1
  c_t[x_a][61] = {  6,   9}; //   2
  c_d[x_a][61] = {  7,  17,   2}; //   3

  c_p[x_a][62] = {  3,  20,  47}; //   3
  c_f[x_a][62] = { 10}; //   1
  c_t[x_a][62] = {  7,  21}; //   2
  c_d[x_a][62] = { 17,   7,   2}; //   3

  c_p[x_a][63] = {  0,  20,  47}; //   3
  c_f[x_a][63] = { 10}; //   1
  c_t[x_a][63] = {  7,  21}; //   2
  c_d[x_a][63] = { 17,   7,   2}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 16, 32, 4, 8, 64, 128;  23,   0,  24,   0,   0)
// channel    1: 4yyv11(1, 2, 32, 16, 4, 8, 64, 128;   0,   0,  24,   0,   0)
// channel    2: 4yyv11(1, 2, 32, 16, 4, 8, 64, 128;  23,   0,  24,   0,   0)
// channel    3: 4yyv11(1, 2, 8, 4, 16, 32, 64, 128;  24,   0,  24,   0,   0)
// channel    4: 42vv11(1, 2, 4, 8, 16, 32, 64, 128;  24,   0,  24,   0,   0)
// channel    5: 42vv11(1, 2, 4, 8, 16, 32, 64, 128;  24,  23,  24,   0,   0)
// channel    6: 5yyyv1(1, 2, 64, 16, 32, 4, 8, 128;  23,   0,  24,   0,   0)
// channel    7: 5yyyv1(1, 2, 64, 32, 16, 4, 8, 128;   0,   0,  24,   0,   0)
// channel    8: 5yyyv1(1, 2, 64, 32, 16, 4, 8, 128;  23,   0,  24,   0,   0)
// channel    9: 5yyyv1(1, 2, 64, 8, 4, 16, 32, 128;  24,   0,  24,   0,   0)
// channel   10: 5y2vv1(1, 2, 64, 4, 8, 16, 32, 128;  24,   0,  24,   0,   0)
// channel   11: 5y2vv1(1, 2, 64, 4, 8, 16, 32, 128;  24,  23,  24,   0,   0)
// channel   12: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  24,   0,   0,   0,   0)
// channel   13: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  24,   0,  23,   0,   0)
// channel   14: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  24,   0,   0)
// channel   15: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  24,   0,   0)
// channel   16: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  24,   0,   0,   0,   0)
// channel   17: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  24,  23,   0,   0,   0)
// channel   18: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;   0,  24,   0,   0,   0)
// channel   19: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;  23,  24,   0,   0,   0)
// channel   20: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  24,   0,   0,   0,   0)
// channel   21: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  24,   0,  23,   0,   0)
// channel   22: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  24,   0,   0)
// channel   23: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  24,   0,   0)
// channel   24: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,   0,  24,   0)
// channel   25: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,   0,  24,   0)
// channel   26: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;   0,   0,   0,  24,   0)
// channel   27: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;  23,   0,   0,  24,   0)
// channel   28: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   29: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   30: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   31: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   32: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   33: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   34: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   35: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   36: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;   0,  24,   0,   0,   0)
// channel   37: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;  23,  24,   0,   0,   0)
// channel   38: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   39: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   40: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;   0,  24,   0,   0,   0)
// channel   41: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;  23,  24,   0,   0,   0)
// channel   42: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   43: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   44: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   45: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   46: 4yyv2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  24,   0)
// channel   47: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,   0,   0,  24,   0)
// channel   48: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,  23,   0,  24,   0)
// channel   49: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   50: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   51: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,  24,   0)
// channel   52: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,   0,   0)
// channel   53: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,   0,   0)
// channel   54: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   55: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   56: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   57: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   58: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,  24,   0,   0)
// channel   59: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,  24,   0,   0)
// channel   60: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   61: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   62: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   63: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
