#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_240_uux_emepmupvmscx(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_240_uux_emepmupvmscx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(21);
  needed_v_smin[x_a].resize(21);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  needed_v_smin[x_a][  1] = {   0,    1}; //   2
  needed_v_smin[x_a][  2] = {   0,    1}; //   2
  needed_v_smin[x_a][  3] = {   0,    2,    3,    6,    8,    9}; //   6
  needed_v_smin[x_a][  4] = {   1,    4,    5,    7,   10,   11}; //   6
  needed_v_smin[x_a][  5] = {   2,    3,    4,    5}; //   4
  needed_v_smin[x_a][  6] = {   2,    3,    4,    5}; //   4
  needed_v_smin[x_a][  7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  needed_v_smin[x_a][  8] = {   6,    7}; //   2
  needed_v_smin[x_a][  9] = {   6,    7}; //   2
  needed_v_smin[x_a][ 10] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][ 11] = {  12,   13,   22,   23,   26,   27,   30,   31}; //   8
  needed_v_smin[x_a][ 12] = {  12,   13}; //   2
  needed_v_smin[x_a][ 13] = {  14,   15,   20,   21,   24,   25,   28,   29}; //   8
  needed_v_smin[x_a][ 14] = {  14,   15}; //   2
  needed_v_smin[x_a][ 15] = {  16,   17,   20,   21}; //   4
  needed_v_smin[x_a][ 16] = {  16,   17}; //   2
  needed_v_smin[x_a][ 17] = {  18,   19,   22,   23}; //   4
  needed_v_smin[x_a][ 18] = {  18,   19}; //   2
  needed_v_smin[x_a][ 19] = {  24,   25,   28,   29}; //   4
  needed_v_smin[x_a][ 20] = {  26,   27,   30,   31}; //   4

  v_smax[x_a].resize(26);
  needed_v_smax[x_a].resize(26);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   16,   17,   18,   19,   22,   23,   28,   29,   30,   31}; //  16
  needed_v_smax[x_a][  1] = {   0,    1}; //   2
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  needed_v_smax[x_a][  3] = {   0,    2,    3,    6,    8,    9,   14,   15,   18,   19}; //  10
  needed_v_smax[x_a][  4] = {   1,    4,    5,    7,   10,   11,   12,   13,   16,   17}; //  10
  needed_v_smax[x_a][  5] = {   2,    3,    4,    5}; //   4
  needed_v_smax[x_a][  6] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   24,   25,   26,   27}; //  16
  needed_v_smax[x_a][  7] = {   6,    7}; //   2
  needed_v_smax[x_a][  8] = {   8,    9,   10,   11,   20,   21}; //   6
  needed_v_smax[x_a][  9] = {  12,   13,   26,   27}; //   4
  needed_v_smax[x_a][ 10] = {  12,   13}; //   2
  needed_v_smax[x_a][ 11] = {  14,   15,   24,   25}; //   4
  needed_v_smax[x_a][ 12] = {  14,   15}; //   2
  needed_v_smax[x_a][ 13] = {  16,   17}; //   2
  needed_v_smax[x_a][ 14] = {  16,   17}; //   2
  needed_v_smax[x_a][ 15] = {  18,   19}; //   2
  needed_v_smax[x_a][ 16] = {  18,   19}; //   2
  needed_v_smax[x_a][ 17] = {  20,   21,   28,   29}; //   4
  needed_v_smax[x_a][ 18] = {  20,   21}; //   2
  needed_v_smax[x_a][ 19] = {  22,   23,   28,   29,   30,   31}; //   6
  needed_v_smax[x_a][ 20] = {  22,   23}; //   2
  needed_v_smax[x_a][ 21] = {  22,   23}; //   2
  needed_v_smax[x_a][ 22] = {  24,   25,   26,   27}; //   4
  needed_v_smax[x_a][ 23] = {  24,   25,   26,   27}; //   4
  needed_v_smax[x_a][ 24] = {  28,   29,   30,   31}; //   4
  needed_v_smax[x_a][ 25] = {  30,   31}; //   2

  g_p[x_a].resize(40);
  needed_g_p[x_a].resize(40);
  needed_g_p[x_a][0] = {   0,    1,    3,    5,   17,   19,   23,   29,   31}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    2,    3,    6,    8,    9}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    4,    5,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   2,    4,   16,   18,   22,   28,   30}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][6] = {   2,    3,    4,    5}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {   2,    3,    4,    5}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax2");
  needed_g_p[x_a][8] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   24,   25,   26,   27}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][9] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][11] = {   8,   10,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax8");
  needed_g_p[x_a][12] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax2");
  needed_g_p[x_a][13] = {   9,   11,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");
  needed_g_p[x_a][14] = {  12,   13,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][15] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][16] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax4");
  needed_g_p[x_a][17] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");
  needed_g_p[x_a][18] = {  14,   15,   24,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax11");
  needed_g_p[x_a][19] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax12");
  needed_g_p[x_a][20] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax3");
  needed_g_p[x_a][21] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");
  needed_g_p[x_a][22] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax13");
  needed_g_p[x_a][23] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax14");
  needed_g_p[x_a][24] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax4");
  needed_g_p[x_a][25] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax15");
  needed_g_p[x_a][26] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax16");
  needed_g_p[x_a][27] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax3");
  needed_g_p[x_a][28] = {  20,   21,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax17");
  needed_g_p[x_a][29] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax18");
  needed_g_p[x_a][30] = {  22,   23,   28,   29,   30,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax19");
  needed_g_p[x_a][31] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax20");
  needed_g_p[x_a][32] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax21");
  needed_g_p[x_a][33] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax22");
  needed_g_p[x_a][34] = {  24,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax23");
  needed_g_p[x_a][35] = {  25,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax23");
  needed_g_p[x_a][36] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax22");
  needed_g_p[x_a][37] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax24");
  needed_g_p[x_a][38] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax25");
  needed_g_p[x_a][39] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax24");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(2);
  needed_g_t[x_a].resize(2);
  needed_g_t[x_a][0] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][1] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");

  g_d[x_a].resize(25);
  needed_g_d[x_a].resize(25);
  needed_g_d[x_a][0] = {   0,    2,    3,    6,    8,    9,   14,   15,   18,   19}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][1] = {   0,    2,    3,    6,    8,    9}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][3] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][5] = {   1,    4,    5,    7,   10,   11,   12,   13,   16,   17}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][6] = {   1,    4,    5,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][7] = {   2,    3,    4,    5}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {   2,    3,    4,    5}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][9] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][11] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][12] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][13] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][14] = {  12,   13,   22,   23,   26,   27,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][15] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][16] = {  14,   15,   20,   21,   24,   25,   28,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][17] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][18] = {  16,   17,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][19] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][20] = {  18,   19,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][21] = {  20,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__76_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__76_176");
  needed_g_d[x_a][22] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__112_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__112_140");
  needed_g_d[x_a][23] = {  24,   25,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__64_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__64_176");
  needed_g_d[x_a][24] = {  26,   27,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__128_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__128_112");

  c_p[x_a].resize(32);
  c_f[x_a].resize(32);
  c_t[x_a].resize(32);
  c_d[x_a].resize(32);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][1] = {  0,   1,   2,   4}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][2] = {  5,   6,   7,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   7,   8,   4}; //   5

  c_p[x_a][3] = {  0,   6,   7,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   7,   8,   4}; //   5

  c_p[x_a][4] = {  5,   6,   7,   4}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  5,   6,   7,   8,   4}; //   5

  c_p[x_a][5] = {  0,   6,   7,   4}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,   6,   7,   8,   4}; //   5

  c_p[x_a][6] = {  8,   9,  10,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   1,   9,  10,  11}; //   5

  c_p[x_a][7] = {  8,   9,  10,   4}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,   6,   9,  10,  11}; //   5

  c_p[x_a][8] = {  8,  11,  12,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   1,  12,   4,  11}; //   5

  c_p[x_a][9] = {  8,  13,  12,   3}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,   1,  12,   4,  11}; //   5

  c_p[x_a][10] = {  8,  11,  12,   4}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  5,   6,  12,   4,  11}; //   5

  c_p[x_a][11] = {  8,  13,  12,   4}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,  12,   4,  11}; //   5

  c_p[x_a][12] = {  8,  14,  15,  16}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  5,  13,   4,  14,  11}; //   5

  c_p[x_a][13] = {  8,  14,  17,  16}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  5,  13,   4,  14,  11}; //   5

  c_p[x_a][14] = {  8,  18,  19,  20}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  0,  15,   4,  16,  11}; //   5

  c_p[x_a][15] = {  8,  18,  21,  20}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  0,  15,   4,  16,  11}; //   5

  c_p[x_a][16] = {  5,  22,  23,  24}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  5,  17,  11,  18,   4}; //   5

  c_p[x_a][17] = {  0,  22,  23,  24}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  5,  17,  11,  18,   4}; //   5

  c_p[x_a][18] = {  5,  25,  26,  27}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  0,  19,  11,  20,   4}; //   5

  c_p[x_a][19] = {  0,  25,  26,  27}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  0,  19,  11,  20,   4}; //   5

  c_p[x_a][20] = {  8,  11,  28,  29}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 21,  18,  16,   4,  11}; //   5

  c_p[x_a][21] = {  8,  13,  28,  29}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 21,  18,  16,   4,  11}; //   5

  c_p[x_a][22] = {  5,  30,  31,  32}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 22,  14,  20,  11,   4}; //   5

  c_p[x_a][23] = {  0,  30,  31,  32}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 22,  14,  20,  11,   4}; //   5

  c_p[x_a][24] = {  8,  18,  33,  34}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  4,  23,  16,  11}; //   4

  c_p[x_a][25] = {  8,  18,  33,  35}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  4,  23,  16,  11}; //   4

  c_p[x_a][26] = {  8,  14,  36,  34}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  4,  24,  14,  11}; //   4

  c_p[x_a][27] = {  8,  14,  36,  35}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  4,  24,  14,  11}; //   4

  c_p[x_a][28] = {  5,  30,  28,  37}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  1}; //   1
  c_d[x_a][28] = { 23,  16,  11,   4}; //   4

  c_p[x_a][29] = {  0,  30,  28,  37}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  1}; //   1
  c_d[x_a][29] = { 23,  16,  11,   4}; //   4

  c_p[x_a][30] = {  5,  30,  38,  39}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  1}; //   1
  c_d[x_a][30] = { 24,  14,  11,   4}; //   4

  c_p[x_a][31] = {  0,  30,  38,  39}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  1}; //   1
  c_d[x_a][31] = { 24,  14,  11,   4}; //   4

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 6yyyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel    1: 6yyyyv(1, 2, 128, 64, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel    2: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel    3: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel    4: 6yyyyv(1, 2, 128, 64, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel    5: 6yyyyv(1, 2, 128, 64, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel    6: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel    7: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel    8: 6yy2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel    9: 6yy2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   10: 6yy2vv(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   11: 6yy2vv(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   12: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  24,   0,   0,   0,   0)
// channel   13: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  24,   0,  23,   0,   0)
// channel   14: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   15: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   16: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;   0,   0,  24,   0,   0)
// channel   17: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;  23,   0,  24,   0,   0)
// channel   18: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   19: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   20: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   21: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  24,  23,   0,   0,   0)
// channel   22: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;   0,  24,   0,   0,   0)
// channel   23: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;  23,  24,   0,   0,   0)
// channel   24: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   25: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,  23,   0)
// channel   26: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  24,   0,   0,   0,   0)
// channel   27: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  24,   0,   0,  23,   0)
// channel   28: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   29: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   30: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   31: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;  23,  24,   0,   0,   0)
