#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_240_db_emepvevexdb(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_240_db_emepvevexdb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(39);
  needed_v_smin[x_a].resize(39);
  needed_v_smin[x_a][  0] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   31,   32,   33,   34,   40,   41,   45,   49,   50,   52,   53,   54,   55,   61,   62,   66,   70,   71,   73,   74,   75,   76,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  101,  102,  103,  104}; //  58
  needed_v_smin[x_a][  1] = {   0,    1,   14,   15,   33,   34,   54,   55}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   14,   15,   16,   17,   33,   34,   35,   36,   54,   55,   56,   57}; //  16
  needed_v_smin[x_a][  3] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   36,   37,   46,   47,   48,   51,   56,   57,   58,   67,   68,   69,   72,   77,  100,  105}; //  28
  needed_v_smin[x_a][  4] = {   2,    3,   16,   17,   35,   36,   56,   57}; //   8
  needed_v_smin[x_a][  5] = {   4,   18,   37,   58}; //   4
  needed_v_smin[x_a][  6] = {   4,    6,   18,   20,   37,   39,   58,   60}; //   8
  needed_v_smin[x_a][  7] = {   5,    6,   19,   20,   28,   29,   31,   32,   38,   39,   45,   49,   50,   52,   53,   59,   60,   66,   70,   71,   73,   74,   75,   76,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  101,  102,  103,  104}; //  50
  needed_v_smin[x_a][  8] = {   5,   19,   38,   59}; //   4
  needed_v_smin[x_a][  9] = {   5,   11,   19,   25,   38,   44,   59,   65}; //   8
  needed_v_smin[x_a][ 10] = {   6,   20,   39,   60}; //   4
  needed_v_smin[x_a][ 11] = {   7,    8,   21,   22,   40,   41,   61,   62}; //   8
  needed_v_smin[x_a][ 12] = {   7,    8,    9,   10,   21,   22,   23,   24,   40,   41,   42,   43,   61,   62,   63,   64}; //  16
  needed_v_smin[x_a][ 13] = {   9,   10,   11,   12,   13,   23,   24,   25,   26,   27,   30,   42,   43,   44,   46,   47,   48,   51,   63,   64,   65,   67,   68,   69,   72,   77,  100,  105}; //  28
  needed_v_smin[x_a][ 14] = {   9,   10,   23,   24,   42,   43,   63,   64}; //   8
  needed_v_smin[x_a][ 15] = {  11,   25,   44,   65}; //   4
  needed_v_smin[x_a][ 16] = {  12,   13,   26,   27,   46,   47,   48,   67,   68,   69}; //  10
  needed_v_smin[x_a][ 17] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13}; //  28
  needed_v_smin[x_a][ 18] = {  28,   29,   75,   76,   90,   91,   94,   95,   70,   71}; //  10
  needed_v_smin[x_a][ 19] = {  28,   29,   70,   71,   75,   76}; //   6
  needed_v_smin[x_a][ 20] = {  30,   77,   72}; //   3
  needed_v_smin[x_a][ 21] = {  30,   72,   77}; //   3
  needed_v_smin[x_a][ 22] = {  31,   32,   78,   79,   88,   89,   92,   93,   73,   74}; //  10
  needed_v_smin[x_a][ 23] = {  31,   32,   73,   74,   78,   79}; //   6
  needed_v_smin[x_a][ 24] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69}; //  32
  needed_v_smin[x_a][ 25] = {  45,   66}; //   2
  needed_v_smin[x_a][ 26] = {  49,   50,   80,   81,   88,   89,   98,   99,  103,  104}; //  10
  needed_v_smin[x_a][ 27] = {  49,   50,   98,   99,  103,  104}; //   6
  needed_v_smin[x_a][ 28] = {  51,  100,  105}; //   3
  needed_v_smin[x_a][ 29] = {  51,  100,  105}; //   3
  needed_v_smin[x_a][ 30] = {  52,   53,   82,   83,   90,   91,   96,   97,  101,  102}; //  10
  needed_v_smin[x_a][ 31] = {  52,   53,   96,   97,  101,  102}; //   6
  needed_v_smin[x_a][ 32] = {  80,   81}; //   2
  needed_v_smin[x_a][ 33] = {  82,   83}; //   2
  needed_v_smin[x_a][ 34] = {  84,   85,   86,   87}; //   4
  needed_v_smin[x_a][ 35] = {  84,   85}; //   2
  needed_v_smin[x_a][ 36] = {  86,   87}; //   2
  needed_v_smin[x_a][ 37] = {  92,   93}; //   2
  needed_v_smin[x_a][ 38] = {  94,   95}; //   2

  v_smax[x_a].resize(38);
  needed_v_smax[x_a].resize(38);
  needed_v_smax[x_a][  0] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   33,   34,   40,   41,   45,   49,   50,   54,   55,   61,   62,   66,   70,   71,   75,   76,   80,   81,   84,   85,   88,   89,   92,   93,   96,   97,  101,  102}; //  38
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   14,   15,   16,   17,   33,   34,   35,   36,   54,   55,   56,   57}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69}; //  60
  needed_v_smax[x_a][  3] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   36,   37,   46,   47,   48,   51,   56,   57,   58,   67,   68,   69,   72,   77}; //  26
  needed_v_smax[x_a][  4] = {   4,    6,   18,   20,   37,   39,   58,   60}; //   8
  needed_v_smax[x_a][  5] = {   5,    6,   19,   20,   31,   32,   38,   39,   52,   53,   59,   60,   73,   74,   78,   79,   82,   83,   86,   87,   90,   91,   94,   95,   98,   99,  103,  104}; //  28
  needed_v_smax[x_a][  6] = {   5,   11,   19,   25,   38,   44,   59,   65}; //   8
  needed_v_smax[x_a][  7] = {   7,    8,    9,   10,   21,   22,   23,   24,   40,   41,   42,   43,   61,   62,   63,   64}; //  16
  needed_v_smax[x_a][  8] = {   9,   10,   11,   23,   24,   25,   42,   43,   44,   63,   64,   65,  100,  105}; //  14
  needed_v_smax[x_a][  9] = {  12,   13,   26,   27,   46,   47,   48,   67,   68,   69,   72}; //  11
  needed_v_smax[x_a][ 10] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79}; //  43
  needed_v_smax[x_a][ 11] = {  28,   29,   75,   76}; //   4
  needed_v_smax[x_a][ 12] = {  28,   29,   75,   76}; //   4
  needed_v_smax[x_a][ 13] = {  30,   77}; //   2
  needed_v_smax[x_a][ 14] = {  30,   77}; //   2
  needed_v_smax[x_a][ 15] = {  31,   32,   78,   79}; //   4
  needed_v_smax[x_a][ 16] = {  31,   32,   78,   79}; //   4
  needed_v_smax[x_a][ 17] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105}; //  47
  needed_v_smax[x_a][ 18] = {  45,   66,   70,   71,   84,   85,   92,   93,   96,   97,  101,  102}; //  12
  needed_v_smax[x_a][ 19] = {  49,   50,   80,   81,   88,   89}; //   6
  needed_v_smax[x_a][ 20] = {  49,   50,   80,   81,   88,   89}; //   6
  needed_v_smax[x_a][ 21] = {  51}; //   1
  needed_v_smax[x_a][ 22] = {  51}; //   1
  needed_v_smax[x_a][ 23] = {  52,   53,   82,   83,   90,   91}; //   6
  needed_v_smax[x_a][ 24] = {  52,   53,   82,   83,   90,   91}; //   6
  needed_v_smax[x_a][ 25] = {  73,   74,   86,   87,   94,   95,   98,   99,  103,  104}; //  10
  needed_v_smax[x_a][ 26] = {  88,   89}; //   2
  needed_v_smax[x_a][ 27] = {  90,   91}; //   2
  needed_v_smax[x_a][ 28] = {  92,   93,   73,   74}; //   4
  needed_v_smax[x_a][ 29] = {  94,   95,   70,   71}; //   4
  needed_v_smax[x_a][ 30] = {  96,   97,  101,  102}; //   4
  needed_v_smax[x_a][ 31] = {  98,   99,  103,  104}; //   4
  needed_v_smax[x_a][ 32] = { 100,  105}; //   2
  needed_v_smax[x_a][ 33] = { 100,  105}; //   2
  needed_v_smax[x_a][ 34] = {  72}; //   1
  needed_v_smax[x_a][ 35] = {  80,   81,   84,   85,   94,   95}; //   6
  needed_v_smax[x_a][ 36] = {  82,   83,   86,   87,   92,   93}; //   6
  needed_v_smax[x_a][ 37] = {  84,   85,   86,   87}; //   4

  g_p[x_a].resize(57);
  needed_g_p[x_a].resize(57);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   33,   34,   40,   41,   45,   49,   50,   54,   55,   61,   62,   66,   70,   71,   75,   76,   80,   81,   84,   85,   88,   89,   92,   93,   96,   97,  101,  102}; //  38
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   14,   15,   33,   34,   54,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   14,   16,   33,   35,   54,   56}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   15,   17,   34,   36,   55,   57}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   36,   37,   46,   47,   48,   51,   56,   57,   58,   67,   68,   69,   72,   77}; //  26
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3,   16,   17,   35,   36,   56,   57}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {   4,   18,   37,   58}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   4,    6,   18,   20,   37,   39,   58,   60}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   5,    6,   19,   20,   32,   38,   39,   53,   59,   60,   74,   79,   83,   87,   91,   95,   99,  104}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   5,   19,   38,   59}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   5,   11,   19,   25,   38,   44,   59,   65}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   6,   20,   39,   60}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][12] = {   7,    8,   21,   22,   40,   41,   61,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][13] = {   7,    9,   21,   23,   40,   42,   61,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][14] = {   8,   10,   22,   24,   41,   43,   62,   64}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][15] = {   9,   10,   11,   23,   24,   25,   42,   43,   44,   63,   64,   65,  100,  105}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax8");
  needed_g_p[x_a][16] = {   9,   10,   23,   24,   42,   43,   63,   64}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][17] = {  11,   25,   44,   65}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][18] = {  12,   13,   26,   27,   46,   47,   48,   67,   68,   69,   72}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax9");
  needed_g_p[x_a][19] = {  12,   26,   46,   67}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax2");
  needed_g_p[x_a][20] = {  13,   27,   47,   68}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin16_smax2");
  needed_g_p[x_a][21] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax10");
  needed_g_p[x_a][22] = {  28,   29,   75,   76}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax11");
  needed_g_p[x_a][23] = {  28,   75}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax12");
  needed_g_p[x_a][24] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax10");
  needed_g_p[x_a][25] = {  29,   76}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax12");
  needed_g_p[x_a][26] = {  30,   77}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax13");
  needed_g_p[x_a][27] = {  30,   77}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax14");
  needed_g_p[x_a][28] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax10");
  needed_g_p[x_a][29] = {  31,   52,   73,   78,   82,   86,   90,   94,   98,  103}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][30] = {  31,   32,   78,   79}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax15");
  needed_g_p[x_a][31] = {  31,   32,   78,   79}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][32] = {  31,   32}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax10");
  needed_g_p[x_a][33] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin24_smax17");
  needed_g_p[x_a][34] = {  45,   66,   71,   85,   93,   97,  102}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax18");
  needed_g_p[x_a][35] = {  45,   66}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin25_smax2");
  needed_g_p[x_a][36] = {  48,   69}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin16_smax2");
  needed_g_p[x_a][37] = {  49,   50,   80,   81,   88,   89}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin26_smax19");
  needed_g_p[x_a][38] = {  49,   80,   88}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax20");
  needed_g_p[x_a][39] = {  49,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin27_smax17");
  needed_g_p[x_a][40] = {  50,   81,   89}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax20");
  needed_g_p[x_a][41] = {  51}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin28_smax21");
  needed_g_p[x_a][42] = {  51}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax22");
  needed_g_p[x_a][43] = {  51}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin29_smax17");
  needed_g_p[x_a][44] = {  52,   53,   82,   83,   90,   91}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin30_smax23");
  needed_g_p[x_a][45] = {  52,   53,   82,   83,   90,   91}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax24");
  needed_g_p[x_a][46] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin31_smax17");
  needed_g_p[x_a][47] = {  70,   84,   92,   96,  101}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax18");
  needed_g_p[x_a][48] = {  73,   74,   86,   87,   94,   95,   98,   99,  103,  104}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax25");
  needed_g_p[x_a][49] = {  88,   89}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax26");
  needed_g_p[x_a][50] = {  90,   91}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax27");
  needed_g_p[x_a][51] = {  92,   93}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax28");
  needed_g_p[x_a][52] = {  94,   95}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax29");
  needed_g_p[x_a][53] = {  96,   97}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin30_smax30");
  needed_g_p[x_a][54] = {  98,   99}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin26_smax31");
  needed_g_p[x_a][55] = { 100,  105}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax32");
  needed_g_p[x_a][56] = { 100}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin28_smax33");

  g_f[x_a].resize(21);
  needed_g_f[x_a].resize(21);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13}; //  14
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax10");
  needed_g_f[x_a][1] = {  54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax17");
  needed_g_f[x_a][2] = {  70,   71}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax29");
  needed_g_f[x_a][3] = {  70,   71,   75,   76}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax10");
  needed_g_f[x_a][4] = {  72}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax34");
  needed_g_f[x_a][5] = {  72,   77}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax10");
  needed_g_f[x_a][6] = {  73,   74}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax28");
  needed_g_f[x_a][7] = {  73,   74,   78,   79}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax10");
  needed_g_f[x_a][8] = {  80,   81}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax35");
  needed_g_f[x_a][9] = {  82,   83}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin33_smax36");
  needed_g_f[x_a][10] = {  84,   85,   86,   87}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin34_smax37");
  needed_g_f[x_a][11] = {  84,   85}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin35_smax35");
  needed_g_f[x_a][12] = {  86,   87}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin36_smax36");
  needed_g_f[x_a][13] = {  92,   93}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax36");
  needed_g_f[x_a][14] = {  94,   95}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin38_smax35");
  needed_g_f[x_a][15] = {  96,   97,  101,  102}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax17");
  needed_g_f[x_a][16] = {  98,   99,  103,  104}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax17");
  needed_g_f[x_a][17] = { 100,  105}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax17");
  needed_g_f[x_a][18] = { 101,  102}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax30");
  needed_g_f[x_a][19] = { 103,  104}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax31");
  needed_g_f[x_a][20] = { 105}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax33");

  g_t[x_a].resize(30);
  needed_g_t[x_a].resize(30);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79}; //  43
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105}; //  47
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][3] = {  54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__65_2__128_60");
  needed_g_t[x_a][4] = {  70,   71,   75,   76}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__12_112");
  needed_g_t[x_a][5] = {  70,   71}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_13__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_13__64_48");
  needed_g_t[x_a][6] = {  72,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__36_88");
  needed_g_t[x_a][7] = {  72}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_37__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_37__64_24");
  needed_g_t[x_a][8] = {  73,   74,   78,   79}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__48_76");
  needed_g_t[x_a][9] = {  73,   74}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_49__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_49__64_12");
  needed_g_t[x_a][10] = {  80,   81,   84,   85}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][11] = {  80,   81}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__176_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__176_64");
  needed_g_t[x_a][12] = {  82,   83,   86,   87}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][13] = {  82,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__140_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__140_64");
  needed_g_t[x_a][14] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_13__48_192");
  needed_g_t[x_a][15] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__13_50__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__13_50__64_128");
  needed_g_t[x_a][16] = {  86,   87}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_49__12_192");
  needed_g_t[x_a][17] = {  86,   87}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__49_14__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__49_14__64_128");
  needed_g_t[x_a][18] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__76_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__76_176");
  needed_g_t[x_a][19] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__112_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__112_140");
  needed_g_t[x_a][20] = {  92,   93}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__48_204");
  needed_g_t[x_a][21] = {  92,   93}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_50__76_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_50__76_128");
  needed_g_t[x_a][22] = {  94,   95}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__12_240");
  needed_g_t[x_a][23] = {  94,   95}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_14__112_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_14__112_128");
  needed_g_t[x_a][24] = {  96,   97,  101,  102}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__48_140");
  needed_g_t[x_a][25] = {  98,   99,  103,  104}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__12_176");
  needed_g_t[x_a][26] = { 100,  105}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_65__36_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_65__36_152");
  needed_g_t[x_a][27] = { 101,  102}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__65_50__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__65_50__128_12");
  needed_g_t[x_a][28] = { 103,  104}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__65_14__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__65_14__128_48");
  needed_g_t[x_a][29] = { 105}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__65_38__128_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__65_38__128_24");

  g_d[x_a].resize(32);
  needed_g_d[x_a].resize(32);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   14,   15,   16,   17,   33,   34,   35,   36,   54,   55,   56,   57}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,   14,   15,   33,   34,   54,   55}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   31,   32,   33,   34,   40,   41,   45,   49,   50,   52,   53,   54,   55,   61,   62,   66,   70,   71,   73,   74,   75,   76,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  101,  102,  103,  104}; //  58
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    3,   16,   17,   35,   36,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][4] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   36,   37,   46,   47,   48,   51,   56,   57,   58,   67,   68,   69,   72,   77,  100,  105}; //  28
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    6,   18,   20,   37,   39,   58,   60}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4,   18,   37,   58}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   5,   11,   19,   25,   38,   44,   59,   65}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   5,   19,   38,   59}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   5,    6,   19,   20,   28,   29,   31,   32,   38,   39,   45,   49,   50,   52,   53,   59,   60,   66,   70,   71,   73,   74,   75,   76,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  101,  102,  103,  104}; //  50
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6,   20,   39,   60}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   7,    8,    9,   10,   21,   22,   23,   24,   40,   41,   42,   43,   61,   62,   63,   64}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   7,    8,   21,   22,   40,   41,   61,   62}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   9,   10,   23,   24,   42,   43,   63,   64}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {   9,   10,   11,   12,   13,   23,   24,   25,   26,   27,   30,   42,   43,   44,   46,   47,   48,   51,   63,   64,   65,   67,   68,   69,   72,   77,  100,  105}; //  28
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  11,   25,   44,   65}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  12,   13,   26,   27,   46,   47,   48,   67,   68,   69}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][17] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  14
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][18] = {  28,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][19] = {  28,   29,   75,   76,   90,   91,   94,   95}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][20] = {  30}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][21] = {  30,   77}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][22] = {  31,   32}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][23] = {  31,   32,   78,   79,   88,   89,   92,   93}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][24] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][25] = {  45,   66}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][26] = {  49,   50}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][27] = {  49,   50,   80,   81,   88,   89,   98,   99}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][28] = {  51}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__36_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__36_152");
  needed_g_d[x_a][29] = {  51,  100}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_152__128_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_152__128_24");
  needed_g_d[x_a][30] = {  52,   53}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][31] = {  52,   53,   82,   83,   90,   91,   96,   97}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");

  c_p[x_a].resize(106);
  c_f[x_a].resize(106);
  c_t[x_a].resize(106);
  c_d[x_a].resize(106);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   2}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  0,   3,   4}; //   3

  c_p[x_a][3] = {  4,   5,   3}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  0,   3,   4}; //   3

  c_p[x_a][4] = {  4,   6,   7}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  5,   6,   4}; //   3

  c_p[x_a][5] = {  8,   9,  10}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  7,   8,   9}; //   3

  c_p[x_a][6] = {  8,  11,   7}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  5,  10,   9}; //   3

  c_p[x_a][7] = {  0,  12,  13}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = { 11,  12,   2}; //   3

  c_p[x_a][8] = {  0,  12,  14}; //   3
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  0,   1}; //   2
  c_d[x_a][8] = { 11,  12,   2}; //   3

  c_p[x_a][9] = { 15,  16,  13}; //   3
  c_f[x_a][9] = {  0}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = { 11,  13,  14}; //   3

  c_p[x_a][10] = { 15,  16,  14}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = { 11,  13,  14}; //   3

  c_p[x_a][11] = { 15,  17,  10}; //   3
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  0,   1}; //   2
  c_d[x_a][11] = {  7,  15,  14}; //   3

  c_p[x_a][12] = {  4,  18,  19}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   1}; //   2
  c_d[x_a][12] = { 16,  14,   4}; //   3

  c_p[x_a][13] = {  4,  18,  20}; //   3
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = { 16,  14,   4}; //   3

  c_p[x_a][14] = {  0,   1,   2,  21}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 17,   0,   1,   2}; //   4

  c_p[x_a][15] = {  0,   1,   3,  21}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 17,   0,   1,   2}; //   4

  c_p[x_a][16] = {  4,   5,   2,  21}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 17,   0,   3,   4}; //   4

  c_p[x_a][17] = {  4,   5,   3,  21}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 17,   0,   3,   4}; //   4

  c_p[x_a][18] = {  4,   6,   7,  21}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 17,   5,   6,   4}; //   4

  c_p[x_a][19] = {  8,   9,  10,  21}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 17,   7,   8,   9}; //   4

  c_p[x_a][20] = {  8,  11,   7,  21}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = { 17,   5,  10,   9}; //   4

  c_p[x_a][21] = {  0,  12,  13,  21}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 17,  11,  12,   2}; //   4

  c_p[x_a][22] = {  0,  12,  14,  21}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = { 17,  11,  12,   2}; //   4

  c_p[x_a][23] = { 15,  16,  13,  21}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = { 17,  11,  13,  14}; //   4

  c_p[x_a][24] = { 15,  16,  14,  21}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 17,  11,  13,  14}; //   4

  c_p[x_a][25] = { 15,  17,  10,  21}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = { 17,   7,  15,  14}; //   4

  c_p[x_a][26] = {  4,  18,  19,  21}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = { 17,  16,  14,   4}; //   4

  c_p[x_a][27] = {  4,  18,  20,  21}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = { 17,  16,  14,   4}; //   4

  c_p[x_a][28] = {  0,  22,  23,  24}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = { 18,   9,  19,   2}; //   4

  c_p[x_a][29] = {  0,  22,  25,  24}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = { 18,   9,  19,   2}; //   4

  c_p[x_a][30] = {  4,  26,  27,  28}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 20,  14,  21,   4}; //   4

  c_p[x_a][31] = { 29,  30,  31,  32}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 22,   2,  23,   9}; //   4

  c_p[x_a][32] = {  8,  30,  31,  32}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  0}; //   1
  c_d[x_a][32] = { 22,   2,  23,   9}; //   4

  c_p[x_a][33] = {  0,   1,   2,  33}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  2}; //   1
  c_d[x_a][33] = { 24,   0,   1,   2}; //   4

  c_p[x_a][34] = {  0,   1,   3,  33}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  2}; //   1
  c_d[x_a][34] = { 24,   0,   1,   2}; //   4

  c_p[x_a][35] = {  4,   5,   2,  33}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  2}; //   1
  c_d[x_a][35] = { 24,   0,   3,   4}; //   4

  c_p[x_a][36] = {  4,   5,   3,  33}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  2}; //   1
  c_d[x_a][36] = { 24,   0,   3,   4}; //   4

  c_p[x_a][37] = {  4,   6,   7,  33}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  2}; //   1
  c_d[x_a][37] = { 24,   5,   6,   4}; //   4

  c_p[x_a][38] = {  8,   9,  10,  33}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  2}; //   1
  c_d[x_a][38] = { 24,   7,   8,   9}; //   4

  c_p[x_a][39] = {  8,  11,   7,  33}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  2}; //   1
  c_d[x_a][39] = { 24,   5,  10,   9}; //   4

  c_p[x_a][40] = {  0,  12,  13,  33}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  2}; //   1
  c_d[x_a][40] = { 24,  11,  12,   2}; //   4

  c_p[x_a][41] = {  0,  12,  14,  33}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  2}; //   1
  c_d[x_a][41] = { 24,  11,  12,   2}; //   4

  c_p[x_a][42] = { 15,  16,  13,  33}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  2}; //   1
  c_d[x_a][42] = { 24,  11,  13,  14}; //   4

  c_p[x_a][43] = { 15,  16,  14,  33}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  2}; //   1
  c_d[x_a][43] = { 24,  11,  13,  14}; //   4

  c_p[x_a][44] = { 15,  17,  10,  33}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  2}; //   1
  c_d[x_a][44] = { 24,   7,  15,  14}; //   4

  c_p[x_a][45] = {  0,  34,  35,  33}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  2}; //   1
  c_d[x_a][45] = { 24,  25,   9,   2}; //   4

  c_p[x_a][46] = {  4,  18,  19,  33}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  2}; //   1
  c_d[x_a][46] = { 24,  16,  14,   4}; //   4

  c_p[x_a][47] = {  4,  18,  20,  33}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  2}; //   1
  c_d[x_a][47] = { 24,  16,  14,   4}; //   4

  c_p[x_a][48] = {  4,  18,  36,  33}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  2}; //   1
  c_d[x_a][48] = { 24,  16,  14,   4}; //   4

  c_p[x_a][49] = {  0,  37,  38,  39}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  2}; //   1
  c_d[x_a][49] = { 26,   9,  27,   2}; //   4

  c_p[x_a][50] = {  0,  37,  40,  39}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  2}; //   1
  c_d[x_a][50] = { 26,   9,  27,   2}; //   4

  c_p[x_a][51] = {  4,  41,  42,  43}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  2}; //   1
  c_d[x_a][51] = { 28,  14,  29,   4}; //   4

  c_p[x_a][52] = { 29,  44,  45,  46}; //   4
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  2}; //   1
  c_d[x_a][52] = { 30,   2,  31,   9}; //   4

  c_p[x_a][53] = {  8,  44,  45,  46}; //   4
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  2}; //   1
  c_d[x_a][53] = { 30,   2,  31,   9}; //   4

  c_p[x_a][54] = {  0,   1,   2}; //   3
  c_f[x_a][54] = {  1}; //   1
  c_t[x_a][54] = {  2,   3}; //   2
  c_d[x_a][54] = {  0,   1,   2}; //   3

  c_p[x_a][55] = {  0,   1,   3}; //   3
  c_f[x_a][55] = {  1}; //   1
  c_t[x_a][55] = {  2,   3}; //   2
  c_d[x_a][55] = {  0,   1,   2}; //   3

  c_p[x_a][56] = {  4,   5,   2}; //   3
  c_f[x_a][56] = {  1}; //   1
  c_t[x_a][56] = {  2,   3}; //   2
  c_d[x_a][56] = {  0,   3,   4}; //   3

  c_p[x_a][57] = {  4,   5,   3}; //   3
  c_f[x_a][57] = {  1}; //   1
  c_t[x_a][57] = {  2,   3}; //   2
  c_d[x_a][57] = {  0,   3,   4}; //   3

  c_p[x_a][58] = {  4,   6,   7}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  2,   3}; //   2
  c_d[x_a][58] = {  5,   6,   4}; //   3

  c_p[x_a][59] = {  8,   9,  10}; //   3
  c_f[x_a][59] = {  1}; //   1
  c_t[x_a][59] = {  2,   3}; //   2
  c_d[x_a][59] = {  7,   8,   9}; //   3

  c_p[x_a][60] = {  8,  11,   7}; //   3
  c_f[x_a][60] = {  1}; //   1
  c_t[x_a][60] = {  2,   3}; //   2
  c_d[x_a][60] = {  5,  10,   9}; //   3

  c_p[x_a][61] = {  0,  12,  13}; //   3
  c_f[x_a][61] = {  1}; //   1
  c_t[x_a][61] = {  2,   3}; //   2
  c_d[x_a][61] = { 11,  12,   2}; //   3

  c_p[x_a][62] = {  0,  12,  14}; //   3
  c_f[x_a][62] = {  1}; //   1
  c_t[x_a][62] = {  2,   3}; //   2
  c_d[x_a][62] = { 11,  12,   2}; //   3

  c_p[x_a][63] = { 15,  16,  13}; //   3
  c_f[x_a][63] = {  1}; //   1
  c_t[x_a][63] = {  2,   3}; //   2
  c_d[x_a][63] = { 11,  13,  14}; //   3

  c_p[x_a][64] = { 15,  16,  14}; //   3
  c_f[x_a][64] = {  1}; //   1
  c_t[x_a][64] = {  2,   3}; //   2
  c_d[x_a][64] = { 11,  13,  14}; //   3

  c_p[x_a][65] = { 15,  17,  10}; //   3
  c_f[x_a][65] = {  1}; //   1
  c_t[x_a][65] = {  2,   3}; //   2
  c_d[x_a][65] = {  7,  15,  14}; //   3

  c_p[x_a][66] = {  0,  34,  35}; //   3
  c_f[x_a][66] = {  1}; //   1
  c_t[x_a][66] = {  2,   3}; //   2
  c_d[x_a][66] = { 25,   9,   2}; //   3

  c_p[x_a][67] = {  4,  18,  19}; //   3
  c_f[x_a][67] = {  1}; //   1
  c_t[x_a][67] = {  2,   3}; //   2
  c_d[x_a][67] = { 16,  14,   4}; //   3

  c_p[x_a][68] = {  4,  18,  20}; //   3
  c_f[x_a][68] = {  1}; //   1
  c_t[x_a][68] = {  2,   3}; //   2
  c_d[x_a][68] = { 16,  14,   4}; //   3

  c_p[x_a][69] = {  4,  18,  36}; //   3
  c_f[x_a][69] = {  1}; //   1
  c_t[x_a][69] = {  2,   3}; //   2
  c_d[x_a][69] = { 16,  14,   4}; //   3

  c_p[x_a][70] = {  0,  47}; //   2
  c_f[x_a][70] = {  2,   3}; //   2
  c_t[x_a][70] = {  0,   4,   5}; //   3
  c_d[x_a][70] = {  9,   2}; //   2

  c_p[x_a][71] = {  0,  34}; //   2
  c_f[x_a][71] = {  2,   3}; //   2
  c_t[x_a][71] = {  0,   4,   5}; //   3
  c_d[x_a][71] = {  9,   2}; //   2

  c_p[x_a][72] = {  4,  18}; //   2
  c_f[x_a][72] = {  4,   5}; //   2
  c_t[x_a][72] = {  0,   6,   7}; //   3
  c_d[x_a][72] = { 14,   4}; //   2

  c_p[x_a][73] = { 29,  48}; //   2
  c_f[x_a][73] = {  6,   7}; //   2
  c_t[x_a][73] = {  0,   8,   9}; //   3
  c_d[x_a][73] = {  2,   9}; //   2

  c_p[x_a][74] = {  8,  48}; //   2
  c_f[x_a][74] = {  6,   7}; //   2
  c_t[x_a][74] = {  0,   8,   9}; //   3
  c_d[x_a][74] = {  2,   9}; //   2

  c_p[x_a][75] = {  0,  22,  23}; //   3
  c_f[x_a][75] = {  3}; //   1
  c_t[x_a][75] = {  0,   4}; //   2
  c_d[x_a][75] = {  9,  19,   2}; //   3

  c_p[x_a][76] = {  0,  22,  25}; //   3
  c_f[x_a][76] = {  3}; //   1
  c_t[x_a][76] = {  0,   4}; //   2
  c_d[x_a][76] = {  9,  19,   2}; //   3

  c_p[x_a][77] = {  4,  26,  27}; //   3
  c_f[x_a][77] = {  5}; //   1
  c_t[x_a][77] = {  0,   6}; //   2
  c_d[x_a][77] = { 14,  21,   4}; //   3

  c_p[x_a][78] = { 29,  30,  31}; //   3
  c_f[x_a][78] = {  7}; //   1
  c_t[x_a][78] = {  0,   8}; //   2
  c_d[x_a][78] = {  2,  23,   9}; //   3

  c_p[x_a][79] = {  8,  30,  31}; //   3
  c_f[x_a][79] = {  7}; //   1
  c_t[x_a][79] = {  0,   8}; //   2
  c_d[x_a][79] = {  2,  23,   9}; //   3

  c_p[x_a][80] = {  0,  37,  38}; //   3
  c_f[x_a][80] = {  8}; //   1
  c_t[x_a][80] = { 10,  11}; //   2
  c_d[x_a][80] = {  9,  27,   2}; //   3

  c_p[x_a][81] = {  0,  37,  40}; //   3
  c_f[x_a][81] = {  8}; //   1
  c_t[x_a][81] = { 10,  11}; //   2
  c_d[x_a][81] = {  9,  27,   2}; //   3

  c_p[x_a][82] = { 29,  44,  45}; //   3
  c_f[x_a][82] = {  9}; //   1
  c_t[x_a][82] = { 12,  13}; //   2
  c_d[x_a][82] = {  2,  31,   9}; //   3

  c_p[x_a][83] = {  8,  44,  45}; //   3
  c_f[x_a][83] = {  9}; //   1
  c_t[x_a][83] = { 12,  13}; //   2
  c_d[x_a][83] = {  2,  31,   9}; //   3

  c_p[x_a][84] = {  0,  47}; //   2
  c_f[x_a][84] = { 10,  11}; //   2
  c_t[x_a][84] = { 10,  14,  15}; //   3
  c_d[x_a][84] = {  9,   2}; //   2

  c_p[x_a][85] = {  0,  34}; //   2
  c_f[x_a][85] = { 10,  11}; //   2
  c_t[x_a][85] = { 10,  14,  15}; //   3
  c_d[x_a][85] = {  9,   2}; //   2

  c_p[x_a][86] = { 29,  48}; //   2
  c_f[x_a][86] = { 10,  12}; //   2
  c_t[x_a][86] = { 12,  16,  17}; //   3
  c_d[x_a][86] = {  2,   9}; //   2

  c_p[x_a][87] = {  8,  48}; //   2
  c_f[x_a][87] = { 10,  12}; //   2
  c_t[x_a][87] = { 12,  16,  17}; //   3
  c_d[x_a][87] = {  2,   9}; //   2

  c_p[x_a][88] = {  0,  37,  38,  49}; //   4
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = { 18}; //   1
  c_d[x_a][88] = { 23,   9,  27,   2}; //   4

  c_p[x_a][89] = {  0,  37,  40,  49}; //   4
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = { 18}; //   1
  c_d[x_a][89] = { 23,   9,  27,   2}; //   4

  c_p[x_a][90] = { 29,  44,  45,  50}; //   4
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = { 19}; //   1
  c_d[x_a][90] = { 19,   2,  31,   9}; //   4

  c_p[x_a][91] = {  8,  44,  45,  50}; //   4
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = { 19}; //   1
  c_d[x_a][91] = { 19,   2,  31,   9}; //   4

  c_p[x_a][92] = {  0,  47,  51}; //   3
  c_f[x_a][92] = { 13}; //   1
  c_t[x_a][92] = { 20,  21}; //   2
  c_d[x_a][92] = { 23,   9,   2}; //   3

  c_p[x_a][93] = {  0,  34,  51}; //   3
  c_f[x_a][93] = { 13}; //   1
  c_t[x_a][93] = { 20,  21}; //   2
  c_d[x_a][93] = { 23,   9,   2}; //   3

  c_p[x_a][94] = { 29,  48,  52}; //   3
  c_f[x_a][94] = { 14}; //   1
  c_t[x_a][94] = { 22,  23}; //   2
  c_d[x_a][94] = { 19,   2,   9}; //   3

  c_p[x_a][95] = {  8,  48,  52}; //   3
  c_f[x_a][95] = { 14}; //   1
  c_t[x_a][95] = { 22,  23}; //   2
  c_d[x_a][95] = { 19,   2,   9}; //   3

  c_p[x_a][96] = {  0,  47,  53}; //   3
  c_f[x_a][96] = { 15}; //   1
  c_t[x_a][96] = {  2,  24}; //   2
  c_d[x_a][96] = { 31,   9,   2}; //   3

  c_p[x_a][97] = {  0,  34,  53}; //   3
  c_f[x_a][97] = { 15}; //   1
  c_t[x_a][97] = {  2,  24}; //   2
  c_d[x_a][97] = { 31,   9,   2}; //   3

  c_p[x_a][98] = { 29,  48,  54}; //   3
  c_f[x_a][98] = { 16}; //   1
  c_t[x_a][98] = {  2,  25}; //   2
  c_d[x_a][98] = { 27,   2,   9}; //   3

  c_p[x_a][99] = {  8,  48,  54}; //   3
  c_f[x_a][99] = { 16}; //   1
  c_t[x_a][99] = {  2,  25}; //   2
  c_d[x_a][99] = { 27,   2,   9}; //   3

  c_p[x_a][100] = { 15,  55,  56}; //   3
  c_f[x_a][100] = { 17}; //   1
  c_t[x_a][100] = {  2,  26}; //   2
  c_d[x_a][100] = { 29,   4,  14}; //   3

  c_p[x_a][101] = {  0,  47}; //   2
  c_f[x_a][101] = { 18,  15}; //   2
  c_t[x_a][101] = {  2,  24,  27}; //   3
  c_d[x_a][101] = {  9,   2}; //   2

  c_p[x_a][102] = {  0,  34}; //   2
  c_f[x_a][102] = { 18,  15}; //   2
  c_t[x_a][102] = {  2,  24,  27}; //   3
  c_d[x_a][102] = {  9,   2}; //   2

  c_p[x_a][103] = { 29,  48}; //   2
  c_f[x_a][103] = { 19,  16}; //   2
  c_t[x_a][103] = {  2,  25,  28}; //   3
  c_d[x_a][103] = {  2,   9}; //   2

  c_p[x_a][104] = {  8,  48}; //   2
  c_f[x_a][104] = { 19,  16}; //   2
  c_t[x_a][104] = {  2,  25,  28}; //   3
  c_d[x_a][104] = {  2,   9}; //   2

  c_p[x_a][105] = { 15,  55}; //   2
  c_f[x_a][105] = { 20,  17}; //   2
  c_t[x_a][105] = {  2,  26,  29}; //   3
  c_d[x_a][105] = {  4,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 8, 16, 32, 64, 128;  23,   0,   0,   0,   0)
// channel    1: 4yyv11(1, 2, 4, 8, 16, 32, 64, 128;  23,   0,  23,   0,   0)
// channel    2: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   0,   0)
// channel    3: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   0,   0)
// channel    4: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   0,   0)
// channel    5: 4yyv11(1, 2, 16, 32, 4, 8, 64, 128;  23,   0,  23,   0,   0)
// channel    6: 4yyv11(1, 2, 32, 16, 4, 8, 64, 128;  23,   0,  23,   0,   0)
// channel    7: 4yyv11(1, 2, 8, 4, 16, 32, 64, 128;  23,   0,   0,   0,   0)
// channel    8: 4yyv11(1, 2, 8, 4, 16, 32, 64, 128;  23,   0,  23,   0,   0)
// channel    9: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   0)
// channel   10: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   0,   0)
// channel   11: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   0,   0)
// channel   12: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
// channel   13: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   0,   0)
// channel   14: 5yyyv1(1, 2, 64, 4, 8, 16, 32, 128;  23,   0,   0,   0,   0)
// channel   15: 5yyyv1(1, 2, 64, 4, 8, 16, 32, 128;  23,   0,  23,   0,   0)
// channel   16: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   0,   0)
// channel   17: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   0,   0)
// channel   18: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   0,   0)
// channel   19: 5yyyv1(1, 2, 64, 16, 32, 4, 8, 128;  23,   0,  23,   0,   0)
// channel   20: 5yyyv1(1, 2, 64, 32, 16, 4, 8, 128;  23,   0,  23,   0,   0)
// channel   21: 5yyyv1(1, 2, 64, 8, 4, 16, 32, 128;  23,   0,   0,   0,   0)
// channel   22: 5yyyv1(1, 2, 64, 8, 4, 16, 32, 128;  23,   0,  23,   0,   0)
// channel   23: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   0,   0)
// channel   24: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   0,   0)
// channel   25: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   0,   0)
// channel   26: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   0,   0)
// channel   27: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   0,   0)
// channel   28: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,   0,   0,   0)
// channel   29: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,  23,   0,   0)
// channel   30: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   0,  24,   0,   0)
// channel   31: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  23,   0,   0)
// channel   32: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  23,   0,   0)
// channel   33: 15yyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   5,   0)
// channel   34: 15yyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   5,   0)
// channel   35: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   0)
// channel   36: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   0)
// channel   37: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   0)
// channel   38: 15yyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   5,   0)
// channel   39: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   5,   0)
// channel   40: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   5,   0)
// channel   41: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   5,   0)
// channel   42: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   0)
// channel   43: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   0)
// channel   44: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   0)
// channel   45: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,  25,   5,   0)
// channel   46: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   0)
// channel   47: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   0)
// channel   48: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   0)
// channel   49: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   5,   0,   5,   0)
// channel   50: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   5,  23,   5,   0)
// channel   51: 152vyv(1, 2, 64, 4, 32, 128, 8, 16;  24,   6,  24,   5,   0)
// channel   52: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   5,  23,   5,   0)
// channel   53: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   5,  23,   5,   0)
// channel   54: 114yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   5)
// channel   55: 114yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   5)
// channel   56: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   5)
// channel   57: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   5)
// channel   58: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   5)
// channel   59: 114yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   5)
// channel   60: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   5)
// channel   61: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   5)
// channel   62: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   5)
// channel   63: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   5)
// channel   64: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   5)
// channel   65: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   5)
// channel   66: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,  25,   0,   5)
// channel   67: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   5)
// channel   68: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   5)
// channel   69: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   0,   5)
// channel   70: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  23,   0,   0,   0,   0)
// channel   71: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  23,  23,   0,   0,   0)
// channel   72: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
// channel   73: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,   0,   0)
// channel   74: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;  23,  23,   0,   0,   0)
// channel   75: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,   0,   0,   0)
// channel   76: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,  23,   0,   0)
// channel   77: 2v3yv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   0,  24,   0,   0)
// channel   78: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  23,   0,   0)
// channel   79: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  23,   0,   0)
// channel   80: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  23,   5,   0,   0,   0)
// channel   81: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  23,   5,  23,   0,   0)
// channel   82: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;   0,   5,  23,   0,   0)
// channel   83: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;  23,   5,  23,   0,   0)
// channel   84: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   5,   0)
// channel   85: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  23,  23,   0,   5,   0)
// channel   86: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;   0,  23,   0,   5,   0)
// channel   87: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;  23,  23,   0,   5,   0)
// channel   88: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  23,   5,   0,   0,   0)
// channel   89: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  23,   5,  23,   0,   0)
// channel   90: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;   0,   5,  23,   0,   0)
// channel   91: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;  23,   5,  23,   0,   0)
// channel   92: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   5,   0)
// channel   93: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  23,  23,   0,   5,   0)
// channel   94: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;   0,  23,   0,   5,   0)
// channel   95: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;  23,  23,   0,   5,   0)
// channel   96: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   5,   0,   5)
// channel   97: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   5,   0,   5)
// channel   98: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   5,   0,   5)
// channel   99: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   5,   0,   5)
// channel  100: 13yv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   6,   0,   6)
// channel  101: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   5,   5)
// channel  102: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   5,   5)
// channel  103: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   5,   5)
// channel  104: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   5,   5)
// channel  105: 112v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   6,   5)
