#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_050_bbx_emepvevexa(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_050_bbx_emepvevexa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(40);
  needed_v_smin[x_a].resize(40);
  needed_v_smin[x_a][  0] = {   0,    1,    7,    8,   12,   16,   17,   28,   29,   40,   41,   44,   45,   46,   47,   56,   57,   58,   67,   68,   69,   75,   76,   80,   84,   85,   87,   88,   91,   92,   93,   94,   95,   96,   98,   99,  100,  101,  104,  105,  106,  107,  109,  110}; //  44
  needed_v_smin[x_a][  1] = {   0,    1,   16,   17,   46,   47,   68,   69}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   68,   69,   70,   71}; //   8
  needed_v_smin[x_a][  3] = {   2,    3,    4,   13,   14,   15,   18,   19,   20,   21,   22,   42,   48,   49,   50,   51,   52,   59,   60,   61,   64,   65,   66,   70,   71,   72,   81,   82,   83,   86,   89,   97,  102,  103,  108}; //  35
  needed_v_smin[x_a][  4] = {   2,    3,   20,   21,   51,   52,   70,   71}; //   8
  needed_v_smin[x_a][  5] = {   4,   72}; //   2
  needed_v_smin[x_a][  6] = {   4,    6,   72,   74}; //   4
  needed_v_smin[x_a][  7] = {   5,    6,   12,   73,   74,   80,   84,   85,   87,   88,   95,   96,   98,   99,  106,  107,  109,  110}; //  18
  needed_v_smin[x_a][  8] = {   5,   73}; //   2
  needed_v_smin[x_a][  9] = {   5,   11,   73,   79}; //   4
  needed_v_smin[x_a][ 10] = {   6,   74}; //   2
  needed_v_smin[x_a][ 11] = {   7,    8,   28,   29,   57,   58,   75,   76}; //   8
  needed_v_smin[x_a][ 12] = {   7,    8,    9,   10,   75,   76,   77,   78}; //   8
  needed_v_smin[x_a][ 13] = {   9,   10,   11,   13,   14,   15,   30,   31,   32,   33,   36,   43,   48,   49,   50,   53,   54,   55,   59,   60,   61,   62,   63,   77,   78,   79,   81,   82,   83,   86,   89,   90,   97,  102,  108}; //  35
  needed_v_smin[x_a][ 14] = {   9,   10,   32,   33,   62,   63,   77,   78}; //   8
  needed_v_smin[x_a][ 15] = {  11,   79}; //   2
  needed_v_smin[x_a][ 16] = {  12,   80,   84,   85,   87,   88,  106,  107,  109,  110}; //  10
  needed_v_smin[x_a][ 17] = {  13,   14,   15,   81,   82,   83,   86,  108}; //   8
  needed_v_smin[x_a][ 18] = {  16,   17,   20,   21}; //   4
  needed_v_smin[x_a][ 19] = {  18,   19,   22,   48,   49,   50,   89,   97}; //   8
  needed_v_smin[x_a][ 20] = {  18,   19,   23,   24}; //   4
  needed_v_smin[x_a][ 21] = {  22,   25}; //   2
  needed_v_smin[x_a][ 22] = {  23,   24,   25,   26,   27,   40,   41,   43,   53,   54,   55,   56,   57,   58,   62,   63,   90,   91,   92,  100,  101}; //  21
  needed_v_smin[x_a][ 23] = {  23,   24,   25,   53,   54,   55,   90}; //   7
  needed_v_smin[x_a][ 24] = {  26,   27,   56,   91,   92,  100,  101}; //   7
  needed_v_smin[x_a][ 25] = {  26,   38}; //   2
  needed_v_smin[x_a][ 26] = {  27,   39}; //   2
  needed_v_smin[x_a][ 27] = {  28,   29,   32,   33}; //   4
  needed_v_smin[x_a][ 28] = {  30,   31,   36,   59,   60,   61,  102}; //   7
  needed_v_smin[x_a][ 29] = {  30,   31,   34,   35}; //   4
  needed_v_smin[x_a][ 30] = {  34,   35,   37,   38,   39,   42,   44,   45,   46,   47,   51,   52,   64,   65,   66,   67,   93,   94,  103,  104,  105}; //  21
  needed_v_smin[x_a][ 31] = {  34,   35,   37,   64,   65,   66,  103}; //   7
  needed_v_smin[x_a][ 32] = {  36,   37}; //   2
  needed_v_smin[x_a][ 33] = {  38,   39,   67,   93,   94,  104,  105}; //   7
  needed_v_smin[x_a][ 34] = {  40,   41}; //   2
  needed_v_smin[x_a][ 35] = {  42}; //   1
  needed_v_smin[x_a][ 36] = {  43}; //   1
  needed_v_smin[x_a][ 37] = {  44,   45}; //   2
  needed_v_smin[x_a][ 38] = {  95,   96}; //   2
  needed_v_smin[x_a][ 39] = {  98,   99}; //   2

  v_smax[x_a].resize(34);
  needed_v_smax[x_a].resize(34);
  needed_v_smax[x_a][  0] = {   0,    1,    7,    8,   12,   16,   17,   28,   29,   40,   41,   44,   45,   46,   47,   57,   58,   68,   69,   75,   76,   80,   84,   85,   95,   96,  100,  101,  104,  105,  106,  107}; //  32
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   16,   17,   20,   21,   46,   47,   51,   52,   68,   69,   70,   71}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,  106,  107,  108,  109,  110}; //  42
  needed_v_smax[x_a][  3] = {   2,    3,    4,   13,   14,   15,   18,   19,   20,   21,   22,   42,   48,   49,   50,   51,   52,   70,   71,   72,   81,   82,   83,   86,   89,   97,  102,  103,  108}; //  29
  needed_v_smax[x_a][  4] = {   4,    6,   72,   74}; //   4
  needed_v_smax[x_a][  5] = {   5,    6,   73,   74,   87,   88,   98,   99,  109,  110}; //  10
  needed_v_smax[x_a][  6] = {   5,   11,   73,   79}; //   4
  needed_v_smax[x_a][  7] = {   7,    8,    9,   10,   28,   29,   32,   33,   57,   58,   62,   63,   75,   76,   77,   78}; //  16
  needed_v_smax[x_a][  8] = {   9,   10,   11,   30,   31,   32,   33,   36,   59,   60,   61,   62,   63,   77,   78,   79}; //  16
  needed_v_smax[x_a][  9] = {  12,   80,   84,   85,   95,   96,  106,  107}; //   8
  needed_v_smax[x_a][ 10] = {  13,   14,   15,   81,   82,   83,   86,   97,  102,  108}; //  10
  needed_v_smax[x_a][ 11] = {  16,   17,   18,   19,   20,   21,   23,   24,   40,   41}; //  10
  needed_v_smax[x_a][ 12] = {  18,   19,   22,   23,   24,   25,   48,   49,   50,   53,   54,   55,   89,   90}; //  14
  needed_v_smax[x_a][ 13] = {  22,   25,   27,   39,   42}; //   5
  needed_v_smax[x_a][ 14] = {  23,   24,   25,   26,   27,   43,   53,   54,   55,   56,   90,   91,   92}; //  13
  needed_v_smax[x_a][ 15] = {  26,   27,   38,   39,   56,   67,   91,   92,   93,   94}; //  10
  needed_v_smax[x_a][ 16] = {  26,   36,   37,   38,   43}; //   5
  needed_v_smax[x_a][ 17] = {  28,   29,   30,   31,   32,   33,   34,   35,   44,   45}; //  10
  needed_v_smax[x_a][ 18] = {  30,   31,   34,   35,   36,   37,   59,   60,   61,   64,   65,   66}; //  12
  needed_v_smax[x_a][ 19] = {  34,   35,   37,   38,   39,   64,   65,   66,   67,   93,   94}; //  11
  needed_v_smax[x_a][ 20] = {  40,   41,  100,  101}; //   4
  needed_v_smax[x_a][ 21] = {  42,  103}; //   2
  needed_v_smax[x_a][ 22] = {  43}; //   1
  needed_v_smax[x_a][ 23] = {  44,   45,  104,  105}; //   4
  needed_v_smax[x_a][ 24] = {  46,   47,   51,   52}; //   4
  needed_v_smax[x_a][ 25] = {  48,   49,   50,   53,   54,   55,   89,   90}; //   8
  needed_v_smax[x_a][ 26] = {  56,   67,   91,   92,   93,   94}; //   6
  needed_v_smax[x_a][ 27] = {  57,   58,   62,   63}; //   4
  needed_v_smax[x_a][ 28] = {  59,   60,   61,   64,   65,   66}; //   6
  needed_v_smax[x_a][ 29] = {  87,   88,   98,   99,  109,  110}; //   6
  needed_v_smax[x_a][ 30] = { 100,  101,  104,  105,   98,   99}; //   6
  needed_v_smax[x_a][ 31] = { 102,  103}; //   2
  needed_v_smax[x_a][ 32] = {  95,   96}; //   2
  needed_v_smax[x_a][ 33] = {  97}; //   1

  g_p[x_a].resize(64);
  needed_g_p[x_a].resize(64);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   12,   16,   17,   28,   29,   40,   41,   44,   45,   46,   47,   57,   58,   68,   69,   75,   76,   80,   84,   85,   95,   96,  100,  101,  104,  105,  106,  107}; //  32
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   16,   17,   46,   47,   68,   69}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   68,   70}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   69,   71}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    4,   13,   14,   15,   18,   19,   20,   21,   22,   42,   48,   49,   50,   51,   52,   70,   71,   72,   81,   82,   83,   86,   89,   97,  102,  103,  108}; //  29
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3,   20,   21,   51,   52,   70,   71}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {   4,   72}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   4,    6,   72,   74}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   5,    6,   73,   74,   88,   99,  110}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   5,   73}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   5,   11,   73,   79}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   6,   74}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][12] = {   7,    8,   28,   29,   57,   58,   75,   76}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][13] = {   7,    9,   75,   77}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][14] = {   8,   10,   76,   78}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][15] = {   9,   10,   11,   30,   31,   32,   33,   36,   59,   60,   61,   62,   63,   77,   78,   79}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax8");
  needed_g_p[x_a][16] = {   9,   10,   32,   33,   62,   63,   77,   78}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][17] = {  11,   79}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][18] = {  12,   80,   85,   96,  107}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax9");
  needed_g_p[x_a][19] = {  12,   80}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin16_smax2");
  needed_g_p[x_a][20] = {  13,   14,   15,   81,   82,   83,   86,   97,  102,  108}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax10");
  needed_g_p[x_a][21] = {  13,   81}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax2");
  needed_g_p[x_a][22] = {  14,   82}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin17_smax2");
  needed_g_p[x_a][23] = {  15,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin17_smax2");
  needed_g_p[x_a][24] = {  16,   17,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax11");
  needed_g_p[x_a][25] = {  18,   19,   22,   48,   49,   50,   89}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin19_smax12");
  needed_g_p[x_a][26] = {  18,   19,   23,   24}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax11");
  needed_g_p[x_a][27] = {  22,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax13");
  needed_g_p[x_a][28] = {  23,   24,   25,   26,   27,   43,   53,   54,   55,   56,   90,   91,   92}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax14");
  needed_g_p[x_a][29] = {  23,   24,   25,   53,   54,   55,   90}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin23_smax12");
  needed_g_p[x_a][30] = {  26,   27,   56,   92}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin24_smax15");
  needed_g_p[x_a][31] = {  26,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax16");
  needed_g_p[x_a][32] = {  27,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin26_smax13");
  needed_g_p[x_a][33] = {  28,   29,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin27_smax17");
  needed_g_p[x_a][34] = {  30,   31,   36,   59,   60,   61}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin28_smax18");
  needed_g_p[x_a][35] = {  30,   31,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax17");
  needed_g_p[x_a][36] = {  34,   35,   37,   38,   39,   64,   65,   66,   67,   93,   94}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin30_smax19");
  needed_g_p[x_a][37] = {  34,   35,   37,   64,   65,   66}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin31_smax18");
  needed_g_p[x_a][38] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin32_smax16");
  needed_g_p[x_a][39] = {  38,   39,   67,   94}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin33_smax15");
  needed_g_p[x_a][40] = {  40,   41,  100,  101}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax20");
  needed_g_p[x_a][41] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax11");
  needed_g_p[x_a][42] = {  42,  103}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin30_smax21");
  needed_g_p[x_a][43] = {  42}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin35_smax13");
  needed_g_p[x_a][44] = {  43}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax22");
  needed_g_p[x_a][45] = {  43}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin36_smax16");
  needed_g_p[x_a][46] = {  44,   45,  104,  105}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin30_smax23");
  needed_g_p[x_a][47] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin37_smax17");
  needed_g_p[x_a][48] = {  46,   47,   51,   52}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin30_smax24");
  needed_g_p[x_a][49] = {  48,   49,   50,   53,   54,   55,   89,   90}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax25");
  needed_g_p[x_a][50] = {  56,   67,   91,   92,   93,   94}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax26");
  needed_g_p[x_a][51] = {  57,   58,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax27");
  needed_g_p[x_a][52] = {  59,   60,   61,   64,   65,   66}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax28");
  needed_g_p[x_a][53] = {  84,   95,  106}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax9");
  needed_g_p[x_a][54] = {  87,   98,  109}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][55] = {  87,   88,   98,   99,  109,  110}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax29");
  needed_g_p[x_a][56] = {  91}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax15");
  needed_g_p[x_a][57] = {  93}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax15");
  needed_g_p[x_a][58] = { 100}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax30");
  needed_g_p[x_a][59] = { 101}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin24_smax30");
  needed_g_p[x_a][60] = { 102}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin28_smax31");
  needed_g_p[x_a][61] = { 103}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin31_smax31");
  needed_g_p[x_a][62] = { 104}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax30");
  needed_g_p[x_a][63] = { 105}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin33_smax30");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {  84,   85,   87,   88,  106,  107,  109,  110}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax2");
  needed_g_f[x_a][1] = {  86,  108}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax2");
  needed_g_f[x_a][2] = {  95,   96}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin38_smax32");
  needed_g_f[x_a][3] = {  97}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax33");
  needed_g_f[x_a][4] = {  98,   99}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin39_smax30");

  g_t[x_a].resize(16);
  needed_g_t[x_a].resize(16);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   84,   85,   86,   87,   88}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__64_60");
  needed_g_t[x_a][1] = {  68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,  106,  107,  108,  109,  110}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__64_60");
  needed_g_t[x_a][2] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_66__12_48");
  needed_g_t[x_a][3] = {  86}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_66__36_24");
  needed_g_t[x_a][4] = {  87,   88}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_66__48_12");
  needed_g_t[x_a][5] = {  89,   90,   97}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__36_88");
  needed_g_t[x_a][6] = {  91,   92,   93,   94,   98,   99}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__48_76");
  needed_g_t[x_a][7] = {  95,   96}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__12_112");
  needed_g_t[x_a][8] = {  95,   96}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_13__48_64");
  needed_g_t[x_a][9] = {  97}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_37__24_64");
  needed_g_t[x_a][10] = {  98,   99}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_49__12_64");
  needed_g_t[x_a][11] = { 100,  101,  104,  105}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__48_76");
  needed_g_t[x_a][12] = { 102,  103}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__24_100");
  needed_g_t[x_a][13] = { 106,  107}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__48_12");
  needed_g_t[x_a][14] = { 108}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_65__24_36");
  needed_g_t[x_a][15] = { 109,  110}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__12_48");

  g_d[x_a].resize(47);
  needed_g_d[x_a].resize(47);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   68,   69,   70,   71}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,   16,   17,   46,   47,   68,   69}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    7,    8,   12,   16,   17,   28,   29,   40,   41,   44,   45,   46,   47,   56,   57,   58,   67,   68,   69,   75,   76,   80,   84,   85,   87,   88,   91,   92,   93,   94,   95,   96,   98,   99,  100,  101,  104,  105,  106,  107,  109,  110}; //  44
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    3,   20,   21,   51,   52,   70,   71}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][4] = {   2,    3,    4,   13,   14,   15,   18,   19,   20,   21,   22,   42,   48,   49,   50,   51,   52,   59,   60,   61,   64,   65,   66,   70,   71,   72,   81,   82,   83,   86,   89,   97,  102,  103,  108}; //  35
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    6,   72,   74}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4,   72}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   5,   11,   73,   79}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   5,   73}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   5,    6,   12,   73,   74,   80,   84,   85,   87,   88,   95,   96,   98,   99,  106,  107,  109,  110}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6,   74}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   7,    8,    9,   10,   75,   76,   77,   78}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   7,    8,   28,   29,   57,   58,   75,   76}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   9,   10,   32,   33,   62,   63,   77,   78}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {   9,   10,   11,   13,   14,   15,   30,   31,   32,   33,   36,   43,   48,   49,   50,   53,   54,   55,   59,   60,   61,   62,   63,   77,   78,   79,   81,   82,   83,   86,   89,   90,   97,  102,  108}; //  35
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  11,   79}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  12,   80}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][17] = {  13,   14,   15,   81,   82,   83}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][18] = {  16,   17,   18,   19,   20,   21,   23,   24,   40,   41}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__4_120");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__4_120");
  needed_g_d[x_a][19] = {  16,   17,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");
  needed_g_d[x_a][20] = {  18,   19,   23,   24}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__32_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__32_88");
  needed_g_d[x_a][21] = {  18,   19,   22,   48,   49,   50,   89}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][22] = {  22,   25,   27,   39,   42}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][23] = {  22,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__4_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__4_88");
  needed_g_d[x_a][24] = {  23,   24,   25,   53,   54,   55,   90}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__16_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__16_72");
  needed_g_d[x_a][25] = {  23,   24,   25,   26,   27,   40,   41,   43,   53,   54,   55,   56,   57,   58,   62,   63,   90,   91,   92,  100,  101}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][26] = {  26,   36,   37,   38,   43}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][27] = {  26,   38}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][28] = {  26,   27,   56,   91,   92,  100,  101}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__4_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__4_72");
  needed_g_d[x_a][29] = {  27,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][30] = {  28,   29,   30,   31,   32,   33,   34,   35,   44,   45}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__8_116");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__8_116");
  needed_g_d[x_a][31] = {  28,   29,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][32] = {  30,   31,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__16_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__16_100");
  needed_g_d[x_a][33] = {  30,   31,   36,   59,   60,   61,  102}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][34] = {  34,   35,   37,   64,   65,   66,  103}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__32_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__32_68");
  needed_g_d[x_a][35] = {  34,   35,   37,   38,   39,   42,   44,   45,   46,   47,   51,   52,   64,   65,   66,   67,   93,   94,  103,  104,  105}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][36] = {  36,   37}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__8_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__8_100");
  needed_g_d[x_a][37] = {  38,   39,   67,   93,   94,  104,  105}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__8_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__8_68");
  needed_g_d[x_a][38] = {  40,   41}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__72_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__72_48");
  needed_g_d[x_a][39] = {  42}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__68_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__68_24");
  needed_g_d[x_a][40] = {  43}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__36_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__36_72");
  needed_g_d[x_a][41] = {  44,   45}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__68_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__68_48");
  needed_g_d[x_a][42] = {  46,   47,   51,   52}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__68_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__68_56");
  needed_g_d[x_a][43] = {  48,   49,   50,   53,   54,   55}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][44] = {  56,   67}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][45] = {  57,   58,   62,   63}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__72_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__72_52");
  needed_g_d[x_a][46] = {  59,   60,   61,   64,   65,   66}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");

  c_p[x_a].resize(111);
  c_f[x_a].resize(111);
  c_t[x_a].resize(111);
  c_d[x_a].resize(111);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   3,   4}; //   3

  c_p[x_a][3] = {  4,   5,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   3,   4}; //   3

  c_p[x_a][4] = {  4,   6,   7}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  5,   6,   4}; //   3

  c_p[x_a][5] = {  8,   9,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  7,   8,   9}; //   3

  c_p[x_a][6] = {  8,  11,   7}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  5,  10,   9}; //   3

  c_p[x_a][7] = {  0,  12,  13}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 11,  12,   2}; //   3

  c_p[x_a][8] = {  0,  12,  14}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 11,  12,   2}; //   3

  c_p[x_a][9] = { 15,  16,  13}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 11,  13,  14}; //   3

  c_p[x_a][10] = { 15,  16,  14}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 11,  13,  14}; //   3

  c_p[x_a][11] = { 15,  17,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  7,  15,  14}; //   3

  c_p[x_a][12] = {  0,  18,  19}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 16,   9,   2}; //   3

  c_p[x_a][13] = {  4,  20,  21}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 17,  14,   4}; //   3

  c_p[x_a][14] = {  4,  20,  22}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 17,  14,   4}; //   3

  c_p[x_a][15] = {  4,  20,  23}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 17,  14,   4}; //   3

  c_p[x_a][16] = {  0,   1,  24}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 18,  19,   1,   2}; //   4

  c_p[x_a][17] = {  0,   1,  24}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 18,  19,   1,   2}; //   4

  c_p[x_a][18] = {  4,  25,  26}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 18,  20,  21,   4}; //   4

  c_p[x_a][19] = {  4,  25,  26}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 18,  20,  21,   4}; //   4

  c_p[x_a][20] = {  4,   5,  24}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 18,  19,   3,   4}; //   4

  c_p[x_a][21] = {  4,   5,  24}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 18,  19,   3,   4}; //   4

  c_p[x_a][22] = {  4,  25,  27}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 22,  23,  21,   4}; //   4

  c_p[x_a][23] = { 28,  29,  26}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 18,  20,  24,  25}; //   4

  c_p[x_a][24] = { 28,  29,  26}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 18,  20,  24,  25}; //   4

  c_p[x_a][25] = { 28,  29,  27}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 22,  23,  24,  25}; //   4

  c_p[x_a][26] = { 28,  30,  31}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 26,  27,  28,  25}; //   4

  c_p[x_a][27] = { 28,  30,  32}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 22,  29,  28,  25}; //   4

  c_p[x_a][28] = {  0,  12,  33}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 30,  31,  12,   2}; //   4

  c_p[x_a][29] = {  0,  12,  33}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 30,  31,  12,   2}; //   4

  c_p[x_a][30] = { 15,  34,  35}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 30,  32,  33,  14}; //   4

  c_p[x_a][31] = { 15,  34,  35}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 30,  32,  33,  14}; //   4

  c_p[x_a][32] = { 15,  16,  33}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 30,  31,  13,  14}; //   4

  c_p[x_a][33] = { 15,  16,  33}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 30,  31,  13,  14}; //   4

  c_p[x_a][34] = { 36,  37,  35}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 30,  32,  34,  35}; //   4

  c_p[x_a][35] = { 36,  37,  35}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 30,  32,  34,  35}; //   4

  c_p[x_a][36] = { 15,  34,  38}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 26,  36,  33,  14}; //   4

  c_p[x_a][37] = { 36,  37,  38}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 26,  36,  34,  35}; //   4

  c_p[x_a][38] = { 36,  39,  31}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 26,  27,  37,  35}; //   4

  c_p[x_a][39] = { 36,  39,  32}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 22,  29,  37,  35}; //   4

  c_p[x_a][40] = {  0,  40,  41}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 18,  38,  25,   2}; //   4

  c_p[x_a][41] = {  0,  40,  41}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 18,  38,  25,   2}; //   4

  c_p[x_a][42] = {  4,  42,  43}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 22,  39,  35,   4}; //   4

  c_p[x_a][43] = { 28,  44,  45}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = { 26,  40,  14,  25}; //   4

  c_p[x_a][44] = {  0,  46,  47}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = { 30,  41,  35,   2}; //   4

  c_p[x_a][45] = {  0,  46,  47}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = { 30,  41,  35,   2}; //   4

  c_p[x_a][46] = {  0,   1,  48}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = { 42,  35,   1,   2}; //   4

  c_p[x_a][47] = {  0,   1,  48}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = { 42,  35,   1,   2}; //   4

  c_p[x_a][48] = {  4,  25,  49}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {}; //   0
  c_d[x_a][48] = { 43,  14,  21,   4}; //   4

  c_p[x_a][49] = {  4,  25,  49}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {}; //   0
  c_d[x_a][49] = { 43,  14,  21,   4}; //   4

  c_p[x_a][50] = {  4,  25,  49}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {}; //   0
  c_d[x_a][50] = { 43,  14,  21,   4}; //   4

  c_p[x_a][51] = {  4,   5,  48}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {}; //   0
  c_d[x_a][51] = { 42,  35,   3,   4}; //   4

  c_p[x_a][52] = {  4,   5,  48}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {}; //   0
  c_d[x_a][52] = { 42,  35,   3,   4}; //   4

  c_p[x_a][53] = { 28,  29,  49}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {}; //   0
  c_d[x_a][53] = { 43,  14,  24,  25}; //   4

  c_p[x_a][54] = { 28,  29,  49}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {}; //   0
  c_d[x_a][54] = { 43,  14,  24,  25}; //   4

  c_p[x_a][55] = { 28,  29,  49}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {}; //   0
  c_d[x_a][55] = { 43,  14,  24,  25}; //   4

  c_p[x_a][56] = { 28,  30,  50}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {}; //   0
  c_d[x_a][56] = { 44,   2,  28,  25}; //   4

  c_p[x_a][57] = {  0,  12,  51}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {}; //   0
  c_d[x_a][57] = { 45,  25,  12,   2}; //   4

  c_p[x_a][58] = {  0,  12,  51}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {}; //   0
  c_d[x_a][58] = { 45,  25,  12,   2}; //   4

  c_p[x_a][59] = { 15,  34,  52}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {}; //   0
  c_d[x_a][59] = { 46,   4,  33,  14}; //   4

  c_p[x_a][60] = { 15,  34,  52}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {}; //   0
  c_d[x_a][60] = { 46,   4,  33,  14}; //   4

  c_p[x_a][61] = { 15,  34,  52}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {}; //   0
  c_d[x_a][61] = { 46,   4,  33,  14}; //   4

  c_p[x_a][62] = { 15,  16,  51}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {}; //   0
  c_d[x_a][62] = { 45,  25,  13,  14}; //   4

  c_p[x_a][63] = { 15,  16,  51}; //   3
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {}; //   0
  c_d[x_a][63] = { 45,  25,  13,  14}; //   4

  c_p[x_a][64] = { 36,  37,  52}; //   3
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {}; //   0
  c_d[x_a][64] = { 46,   4,  34,  35}; //   4

  c_p[x_a][65] = { 36,  37,  52}; //   3
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {}; //   0
  c_d[x_a][65] = { 46,   4,  34,  35}; //   4

  c_p[x_a][66] = { 36,  37,  52}; //   3
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {}; //   0
  c_d[x_a][66] = { 46,   4,  34,  35}; //   4

  c_p[x_a][67] = { 36,  39,  50}; //   3
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {}; //   0
  c_d[x_a][67] = { 44,   2,  37,  35}; //   4

  c_p[x_a][68] = {  0,   1,   2}; //   3
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  1}; //   1
  c_d[x_a][68] = {  0,   1,   2}; //   3

  c_p[x_a][69] = {  0,   1,   3}; //   3
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  1}; //   1
  c_d[x_a][69] = {  0,   1,   2}; //   3

  c_p[x_a][70] = {  4,   5,   2}; //   3
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  1}; //   1
  c_d[x_a][70] = {  0,   3,   4}; //   3

  c_p[x_a][71] = {  4,   5,   3}; //   3
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  1}; //   1
  c_d[x_a][71] = {  0,   3,   4}; //   3

  c_p[x_a][72] = {  4,   6,   7}; //   3
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  1}; //   1
  c_d[x_a][72] = {  5,   6,   4}; //   3

  c_p[x_a][73] = {  8,   9,  10}; //   3
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  1}; //   1
  c_d[x_a][73] = {  7,   8,   9}; //   3

  c_p[x_a][74] = {  8,  11,   7}; //   3
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  1}; //   1
  c_d[x_a][74] = {  5,  10,   9}; //   3

  c_p[x_a][75] = {  0,  12,  13}; //   3
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  1}; //   1
  c_d[x_a][75] = { 11,  12,   2}; //   3

  c_p[x_a][76] = {  0,  12,  14}; //   3
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  1}; //   1
  c_d[x_a][76] = { 11,  12,   2}; //   3

  c_p[x_a][77] = { 15,  16,  13}; //   3
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  1}; //   1
  c_d[x_a][77] = { 11,  13,  14}; //   3

  c_p[x_a][78] = { 15,  16,  14}; //   3
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {  1}; //   1
  c_d[x_a][78] = { 11,  13,  14}; //   3

  c_p[x_a][79] = { 15,  17,  10}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = {  1}; //   1
  c_d[x_a][79] = {  7,  15,  14}; //   3

  c_p[x_a][80] = {  0,  18,  19}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {  1}; //   1
  c_d[x_a][80] = { 16,   9,   2}; //   3

  c_p[x_a][81] = {  4,  20,  21}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  1}; //   1
  c_d[x_a][81] = { 17,  14,   4}; //   3

  c_p[x_a][82] = {  4,  20,  22}; //   3
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = {  1}; //   1
  c_d[x_a][82] = { 17,  14,   4}; //   3

  c_p[x_a][83] = {  4,  20,  23}; //   3
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = {  1}; //   1
  c_d[x_a][83] = { 17,  14,   4}; //   3

  c_p[x_a][84] = {  0,  53}; //   2
  c_f[x_a][84] = {  0}; //   1
  c_t[x_a][84] = {  0,   2}; //   2
  c_d[x_a][84] = {  9,   2}; //   2

  c_p[x_a][85] = {  0,  18}; //   2
  c_f[x_a][85] = {  0}; //   1
  c_t[x_a][85] = {  0,   2}; //   2
  c_d[x_a][85] = {  9,   2}; //   2

  c_p[x_a][86] = {  4,  20}; //   2
  c_f[x_a][86] = {  1}; //   1
  c_t[x_a][86] = {  0,   3}; //   2
  c_d[x_a][86] = { 14,   4}; //   2

  c_p[x_a][87] = { 54,  55}; //   2
  c_f[x_a][87] = {  0}; //   1
  c_t[x_a][87] = {  0,   4}; //   2
  c_d[x_a][87] = {  2,   9}; //   2

  c_p[x_a][88] = {  8,  55}; //   2
  c_f[x_a][88] = {  0}; //   1
  c_t[x_a][88] = {  0,   4}; //   2
  c_d[x_a][88] = {  2,   9}; //   2

  c_p[x_a][89] = {  4,  25,  49}; //   3
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = {  5}; //   1
  c_d[x_a][89] = { 14,  21,   4}; //   3

  c_p[x_a][90] = { 28,  29,  49}; //   3
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = {  5}; //   1
  c_d[x_a][90] = { 14,  24,  25}; //   3

  c_p[x_a][91] = { 28,  56,  50}; //   3
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = {  6}; //   1
  c_d[x_a][91] = {  2,  28,  25}; //   3

  c_p[x_a][92] = { 28,  30,  50}; //   3
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = {  6}; //   1
  c_d[x_a][92] = {  2,  28,  25}; //   3

  c_p[x_a][93] = { 36,  57,  50}; //   3
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = {  6}; //   1
  c_d[x_a][93] = {  2,  37,  35}; //   3

  c_p[x_a][94] = { 36,  39,  50}; //   3
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = {  6}; //   1
  c_d[x_a][94] = {  2,  37,  35}; //   3

  c_p[x_a][95] = {  0,  53}; //   2
  c_f[x_a][95] = {  2}; //   1
  c_t[x_a][95] = {  7,   8}; //   2
  c_d[x_a][95] = {  9,   2}; //   2

  c_p[x_a][96] = {  0,  18}; //   2
  c_f[x_a][96] = {  2}; //   1
  c_t[x_a][96] = {  7,   8}; //   2
  c_d[x_a][96] = {  9,   2}; //   2

  c_p[x_a][97] = {  4,  20}; //   2
  c_f[x_a][97] = {  3}; //   1
  c_t[x_a][97] = {  5,   9}; //   2
  c_d[x_a][97] = { 14,   4}; //   2

  c_p[x_a][98] = { 54,  55}; //   2
  c_f[x_a][98] = {  4}; //   1
  c_t[x_a][98] = {  6,  10}; //   2
  c_d[x_a][98] = {  2,   9}; //   2

  c_p[x_a][99] = {  8,  55}; //   2
  c_f[x_a][99] = {  4}; //   1
  c_t[x_a][99] = {  6,  10}; //   2
  c_d[x_a][99] = {  2,   9}; //   2

  c_p[x_a][100] = {  0,  40,  58}; //   3
  c_f[x_a][100] = {}; //   0
  c_t[x_a][100] = { 11}; //   1
  c_d[x_a][100] = { 28,  25,   2}; //   3

  c_p[x_a][101] = {  0,  40,  59}; //   3
  c_f[x_a][101] = {}; //   0
  c_t[x_a][101] = { 11}; //   1
  c_d[x_a][101] = { 28,  25,   2}; //   3

  c_p[x_a][102] = {  4,  20,  60}; //   3
  c_f[x_a][102] = {}; //   0
  c_t[x_a][102] = { 12}; //   1
  c_d[x_a][102] = { 33,  14,   4}; //   3

  c_p[x_a][103] = {  4,  42,  61}; //   3
  c_f[x_a][103] = {}; //   0
  c_t[x_a][103] = { 12}; //   1
  c_d[x_a][103] = { 34,  35,   4}; //   3

  c_p[x_a][104] = {  0,  46,  62}; //   3
  c_f[x_a][104] = {}; //   0
  c_t[x_a][104] = { 11}; //   1
  c_d[x_a][104] = { 37,  35,   2}; //   3

  c_p[x_a][105] = {  0,  46,  63}; //   3
  c_f[x_a][105] = {}; //   0
  c_t[x_a][105] = { 11}; //   1
  c_d[x_a][105] = { 37,  35,   2}; //   3

  c_p[x_a][106] = {  0,  53}; //   2
  c_f[x_a][106] = {  0}; //   1
  c_t[x_a][106] = {  1,  13}; //   2
  c_d[x_a][106] = {  9,   2}; //   2

  c_p[x_a][107] = {  0,  18}; //   2
  c_f[x_a][107] = {  0}; //   1
  c_t[x_a][107] = {  1,  13}; //   2
  c_d[x_a][107] = {  9,   2}; //   2

  c_p[x_a][108] = {  4,  20}; //   2
  c_f[x_a][108] = {  1}; //   1
  c_t[x_a][108] = {  1,  14}; //   2
  c_d[x_a][108] = { 14,   4}; //   2

  c_p[x_a][109] = { 54,  55}; //   2
  c_f[x_a][109] = {  0}; //   1
  c_t[x_a][109] = {  1,  15}; //   2
  c_d[x_a][109] = {  2,   9}; //   2

  c_p[x_a][110] = {  8,  55}; //   2
  c_f[x_a][110] = {  0}; //   1
  c_t[x_a][110] = {  1,  15}; //   2
  c_d[x_a][110] = {  2,   9}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   5)
// channel    1: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   5)
// channel    2: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   5)
// channel    3: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   5)
// channel    4: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   5)
// channel    5: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   5)
// channel    6: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   5)
// channel    7: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   5)
// channel    8: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   5)
// channel    9: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   5)
// channel   10: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   5)
// channel   11: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   5)
// channel   12: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,  23,  25,   5)
// channel   13: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   5)
// channel   14: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   5)
// channel   15: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  25,   5)
// channel   16: 5yyyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
// channel   17: 5yyyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,  23)
// channel   18: 5yyyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,   0)
// channel   19: 5yyyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,  23)
// channel   20: 5yyyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
// channel   21: 5yyyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  23)
// channel   22: 5yyyv(1, 2, 32, 4, 64, 8, 16;  24,  24,   0,  23)
// channel   23: 5yyyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,   0)
// channel   24: 5yyyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,  23)
// channel   25: 5yyyv(1, 2, 32, 4, 16, 8, 64;   0,  24,   0,  23)
// channel   26: 5yyyv(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,  23)
// channel   27: 5yyyv(1, 2, 32, 16, 4, 8, 64;   0,  23,   0,  23)
// channel   28: 5yyyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
// channel   29: 5yyyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,  23)
// channel   30: 5yyyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,   0)
// channel   31: 5yyyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,  23)
// channel   32: 5yyyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
// channel   33: 5yyyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  23)
// channel   34: 5yyyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,   0)
// channel   35: 5yyyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,  23)
// channel   36: 5yyyv(1, 2, 16, 8, 64, 4, 32;  24,  24,   0,  23)
// channel   37: 5yyyv(1, 2, 16, 8, 32, 4, 64;   0,  24,   0,  23)
// channel   38: 5yyyv(1, 2, 16, 32, 8, 4, 64;   0,  23,   0,  23)
// channel   39: 5yyyv(1, 2, 32, 16, 8, 4, 64;   0,  23,   0,  23)
// channel   40: 5y2vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
// channel   41: 5y2vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,  23)
// channel   42: 5y2vv(1, 2, 32, 4, 64, 8, 16;  24,   0,   0,  23)
// channel   43: 5y2vv(1, 2, 16, 4, 32, 8, 64;   0,  24,   0,  23)
// channel   44: 5y2vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   0)
// channel   45: 5y2vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,  23)
// channel   46: 52vyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
// channel   47: 52vyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,  23)
// channel   48: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,   0)
// channel   49: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  23)
// channel   50: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  25)
// channel   51: 52vyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
// channel   52: 52vyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  23)
// channel   53: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,   0)
// channel   54: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,  23)
// channel   55: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,  25)
// channel   56: 52vyv(1, 2, 16, 32, 4, 8, 64;   0,  23,  23,  25)
// channel   57: 52vyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
// channel   58: 52vyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,  23)
// channel   59: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,   0)
// channel   60: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  23)
// channel   61: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  25)
// channel   62: 52vyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
// channel   63: 52vyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  23)
// channel   64: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,   0)
// channel   65: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,  23)
// channel   66: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,  25)
// channel   67: 52vyv(1, 2, 16, 32, 8, 4, 64;   0,  23,  23,  25)
// channel   68: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   5)
// channel   69: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   5)
// channel   70: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   5)
// channel   71: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   5)
// channel   72: 14yyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   5)
// channel   73: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   5)
// channel   74: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   5)
// channel   75: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   5)
// channel   76: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   5)
// channel   77: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   5)
// channel   78: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   5)
// channel   79: 14yyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   5)
// channel   80: 142vv(1, 2, 64, 4, 8, 16, 32;  23,  23,  25,   5)
// channel   81: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   5)
// channel   82: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   5)
// channel   83: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  25,   5)
// channel   84: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   5,   5)
// channel   85: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   5,   5)
// channel   86: 2v2v1(1, 2, 4, 32, 8, 16, 64;  24,  24,   5,   6)
// channel   87: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   5,   5)
// channel   88: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   5,   5)
// channel   89: 2v3yv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,   6)
// channel   90: 2v3yv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,   6)
// channel   91: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,   0,  23,   5)
// channel   92: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,  23,  23,   5)
// channel   93: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,   0,  23,   5)
// channel   94: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,  23,  23,   5)
// channel   95: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,   0,   5,   5)
// channel   96: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,  23,   5,   5)
// channel   97: 2v12v(1, 2, 4, 32, 64, 8, 16;  24,  24,   6,   6)
// channel   98: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,  23,   5,   5)
// channel   99: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,  23,   5,   5)
// channel  100: 3yv2v(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   5)
// channel  101: 3yv2v(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   5)
// channel  102: 3yv2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  24,   6)
// channel  103: 3yv2v(1, 2, 32, 4, 64, 8, 16;  24,   0,  24,   6)
// channel  104: 3yv2v(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   5)
// channel  105: 3yv2v(1, 2, 8, 4, 64, 16, 32;  23,   0,  23,   5)
// channel  106: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   5,   5)
// channel  107: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   5,   5)
// channel  108: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,   5,   6)
// channel  109: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   5,   5)
// channel  110: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   5,   5)
