#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_140_ddx_emepvevexg(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_140_ddx_emepvevexg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(21);
  needed_v_smin[x_a].resize(21);
  needed_v_smin[x_a][  0] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   31,   32,   33,   34,   36,   37,   38,   39,   41,   42}; //  20
  needed_v_smin[x_a][  1] = {   0,    1,   14,   15}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   14,   15,   16,   17}; //   8
  needed_v_smin[x_a][  3] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   40}; //  13
  needed_v_smin[x_a][  4] = {   2,    3,   16,   17}; //   4
  needed_v_smin[x_a][  5] = {   4,   18}; //   2
  needed_v_smin[x_a][  6] = {   4,    6,   18,   20}; //   4
  needed_v_smin[x_a][  7] = {   5,    6,   19,   20,   28,   29,   31,   32,   33,   34,   36,   37,   38,   39,   41,   42}; //  16
  needed_v_smin[x_a][  8] = {   5,   19}; //   2
  needed_v_smin[x_a][  9] = {   5,   11,   19,   25}; //   4
  needed_v_smin[x_a][ 10] = {   6,   20}; //   2
  needed_v_smin[x_a][ 11] = {   7,    8,   21,   22}; //   4
  needed_v_smin[x_a][ 12] = {   7,    8,    9,   10,   21,   22,   23,   24}; //   8
  needed_v_smin[x_a][ 13] = {   9,   10,   11,   12,   13,   23,   24,   25,   26,   27,   30,   35,   40}; //  13
  needed_v_smin[x_a][ 14] = {   9,   10,   23,   24}; //   4
  needed_v_smin[x_a][ 15] = {  11,   25}; //   2
  needed_v_smin[x_a][ 16] = {  12,   13,   26,   27,   30,   40}; //   6
  needed_v_smin[x_a][ 17] = {  28,   29,   31,   32,   38,   39,   41,   42}; //   8
  needed_v_smin[x_a][ 18] = {  33,   34}; //   2
  needed_v_smin[x_a][ 19] = {  35}; //   1
  needed_v_smin[x_a][ 20] = {  36,   37}; //   2

  v_smax[x_a].resize(15);
  needed_v_smax[x_a].resize(15);
  needed_v_smax[x_a][  0] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   33,   34,   38,   39}; //  14
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   14,   15,   16,   17}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   38,   39,   40,   41,   42}; //  38
  needed_v_smax[x_a][  3] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   40}; //  13
  needed_v_smax[x_a][  4] = {   4,    6,   18,   20}; //   4
  needed_v_smax[x_a][  5] = {   5,    6,   19,   20,   31,   32,   36,   37,   41,   42}; //  10
  needed_v_smax[x_a][  6] = {   5,   11,   19,   25}; //   4
  needed_v_smax[x_a][  7] = {   7,    8,    9,   10,   21,   22,   23,   24}; //   8
  needed_v_smax[x_a][  8] = {   9,   10,   11,   23,   24,   25}; //   6
  needed_v_smax[x_a][  9] = {  12,   13,   26,   27,   30,   35,   40}; //   7
  needed_v_smax[x_a][ 10] = {  28,   29,   33,   34,   38,   39}; //   6
  needed_v_smax[x_a][ 11] = {  31,   32,   36,   37,   41,   42}; //   6
  needed_v_smax[x_a][ 12] = {  33,   34}; //   2
  needed_v_smax[x_a][ 13] = {  35}; //   1
  needed_v_smax[x_a][ 14] = {  36,   37}; //   2

  g_p[x_a].resize(25);
  needed_g_p[x_a].resize(25);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   33,   34,   38,   39}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   14,   16}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   15,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   40}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3,   16,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {   4,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   4,    6,   18,   20}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   5,    6,   19,   20,   32,   37,   42}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   5,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   5,   11,   19,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   6,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][12] = {   7,    8,   21,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][13] = {   7,    9,   21,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][14] = {   8,   10,   22,   24}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][15] = {   9,   10,   11,   23,   24,   25}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax8");
  needed_g_p[x_a][16] = {   9,   10,   23,   24}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][17] = {  11,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][18] = {  12,   13,   26,   27,   30,   35,   40}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax9");
  needed_g_p[x_a][19] = {  12,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax2");
  needed_g_p[x_a][20] = {  13,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin16_smax2");
  needed_g_p[x_a][21] = {  28,   33,   38}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax10");
  needed_g_p[x_a][22] = {  29,   34,   39}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax10");
  needed_g_p[x_a][23] = {  31,   36,   41}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][24] = {  31,   32,   36,   37,   41,   42}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {  28,   29,   31,   32,   38,   39,   41,   42}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax2");
  needed_g_f[x_a][1] = {  30,   40}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax2");
  needed_g_f[x_a][2] = {  33,   34}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax12");
  needed_g_f[x_a][3] = {  35}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax13");
  needed_g_f[x_a][4] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax14");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   28,   29,   30,   31,   32}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   38,   39,   40,   41,   42}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][3] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__36_24");
  needed_g_t[x_a][4] = {  31,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][5] = {  33,   34}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][6] = {  33,   34}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_64");
  needed_g_t[x_a][7] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_88");
  needed_g_t[x_a][8] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__24_64");
  needed_g_t[x_a][9] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][10] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][11] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][12] = {  40}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_36");
  needed_g_t[x_a][13] = {  41,   42}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");

  g_d[x_a].resize(17);
  needed_g_d[x_a].resize(17);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   14,   15,   16,   17}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   31,   32,   33,   34,   36,   37,   38,   39,   41,   42}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    3,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][4] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   40}; //  13
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    6,   18,   20}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   5,   11,   19,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   5,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   5,    6,   19,   20,   28,   29,   31,   32,   33,   34,   36,   37,   38,   39,   41,   42}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   7,    8,    9,   10,   21,   22,   23,   24}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   7,    8,   21,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   9,   10,   23,   24}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {   9,   10,   11,   12,   13,   23,   24,   25,   26,   27,   30,   35,   40}; //  13
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  11,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  12,   13,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");

  c_p[x_a].resize(43);
  c_f[x_a].resize(43);
  c_t[x_a].resize(43);
  c_d[x_a].resize(43);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   3,   4}; //   3

  c_p[x_a][3] = {  4,   5,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   3,   4}; //   3

  c_p[x_a][4] = {  4,   6,   7}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  5,   6,   4}; //   3

  c_p[x_a][5] = {  8,   9,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  7,   8,   9}; //   3

  c_p[x_a][6] = {  8,  11,   7}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  5,  10,   9}; //   3

  c_p[x_a][7] = {  0,  12,  13}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 11,  12,   2}; //   3

  c_p[x_a][8] = {  0,  12,  14}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 11,  12,   2}; //   3

  c_p[x_a][9] = { 15,  16,  13}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 11,  13,  14}; //   3

  c_p[x_a][10] = { 15,  16,  14}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 11,  13,  14}; //   3

  c_p[x_a][11] = { 15,  17,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  7,  15,  14}; //   3

  c_p[x_a][12] = {  4,  18,  19}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 16,  14,   4}; //   3

  c_p[x_a][13] = {  4,  18,  20}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 16,  14,   4}; //   3

  c_p[x_a][14] = {  0,   1,   2}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  1}; //   1
  c_d[x_a][14] = {  0,   1,   2}; //   3

  c_p[x_a][15] = {  0,   1,   3}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = {  0,   1,   2}; //   3

  c_p[x_a][16] = {  4,   5,   2}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  1}; //   1
  c_d[x_a][16] = {  0,   3,   4}; //   3

  c_p[x_a][17] = {  4,   5,   3}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  1}; //   1
  c_d[x_a][17] = {  0,   3,   4}; //   3

  c_p[x_a][18] = {  4,   6,   7}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  1}; //   1
  c_d[x_a][18] = {  5,   6,   4}; //   3

  c_p[x_a][19] = {  8,   9,  10}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  1}; //   1
  c_d[x_a][19] = {  7,   8,   9}; //   3

  c_p[x_a][20] = {  8,  11,   7}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  1}; //   1
  c_d[x_a][20] = {  5,  10,   9}; //   3

  c_p[x_a][21] = {  0,  12,  13}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  1}; //   1
  c_d[x_a][21] = { 11,  12,   2}; //   3

  c_p[x_a][22] = {  0,  12,  14}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  1}; //   1
  c_d[x_a][22] = { 11,  12,   2}; //   3

  c_p[x_a][23] = { 15,  16,  13}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  1}; //   1
  c_d[x_a][23] = { 11,  13,  14}; //   3

  c_p[x_a][24] = { 15,  16,  14}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  1}; //   1
  c_d[x_a][24] = { 11,  13,  14}; //   3

  c_p[x_a][25] = { 15,  17,  10}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  1}; //   1
  c_d[x_a][25] = {  7,  15,  14}; //   3

  c_p[x_a][26] = {  4,  18,  19}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  1}; //   1
  c_d[x_a][26] = { 16,  14,   4}; //   3

  c_p[x_a][27] = {  4,  18,  20}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  1}; //   1
  c_d[x_a][27] = { 16,  14,   4}; //   3

  c_p[x_a][28] = {  0,  21}; //   2
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  0,   2}; //   2
  c_d[x_a][28] = {  9,   2}; //   2

  c_p[x_a][29] = {  0,  22}; //   2
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  0,   2}; //   2
  c_d[x_a][29] = {  9,   2}; //   2

  c_p[x_a][30] = {  4,  18}; //   2
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  0,   3}; //   2
  c_d[x_a][30] = { 14,   4}; //   2

  c_p[x_a][31] = { 23,  24}; //   2
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  0,   4}; //   2
  c_d[x_a][31] = {  2,   9}; //   2

  c_p[x_a][32] = {  8,  24}; //   2
  c_f[x_a][32] = {  0}; //   1
  c_t[x_a][32] = {  0,   4}; //   2
  c_d[x_a][32] = {  2,   9}; //   2

  c_p[x_a][33] = {  0,  21}; //   2
  c_f[x_a][33] = {  2}; //   1
  c_t[x_a][33] = {  5,   6}; //   2
  c_d[x_a][33] = {  9,   2}; //   2

  c_p[x_a][34] = {  0,  22}; //   2
  c_f[x_a][34] = {  2}; //   1
  c_t[x_a][34] = {  5,   6}; //   2
  c_d[x_a][34] = {  9,   2}; //   2

  c_p[x_a][35] = {  4,  18}; //   2
  c_f[x_a][35] = {  3}; //   1
  c_t[x_a][35] = {  7,   8}; //   2
  c_d[x_a][35] = { 14,   4}; //   2

  c_p[x_a][36] = { 23,  24}; //   2
  c_f[x_a][36] = {  4}; //   1
  c_t[x_a][36] = {  9,  10}; //   2
  c_d[x_a][36] = {  2,   9}; //   2

  c_p[x_a][37] = {  8,  24}; //   2
  c_f[x_a][37] = {  4}; //   1
  c_t[x_a][37] = {  9,  10}; //   2
  c_d[x_a][37] = {  2,   9}; //   2

  c_p[x_a][38] = {  0,  21}; //   2
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  1,  11}; //   2
  c_d[x_a][38] = {  9,   2}; //   2

  c_p[x_a][39] = {  0,  22}; //   2
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  1,  11}; //   2
  c_d[x_a][39] = {  9,   2}; //   2

  c_p[x_a][40] = {  4,  18}; //   2
  c_f[x_a][40] = {  1}; //   1
  c_t[x_a][40] = {  1,  12}; //   2
  c_d[x_a][40] = { 14,   4}; //   2

  c_p[x_a][41] = { 23,  24}; //   2
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  1,  13}; //   2
  c_d[x_a][41] = {  2,   9}; //   2

  c_p[x_a][42] = {  8,  24}; //   2
  c_f[x_a][42] = {  0}; //   1
  c_t[x_a][42] = {  1,  13}; //   2
  c_d[x_a][42] = {  2,   9}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
// channel    1: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   0)
// channel    2: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   0)
// channel    3: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   0)
// channel    4: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   0)
// channel    5: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   0)
// channel    6: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   0)
// channel    7: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   0)
// channel    8: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   0)
// channel    9: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   0)
// channel   10: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   0)
// channel   11: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   0)
// channel   12: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
// channel   13: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   0)
// channel   14: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   15: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
// channel   16: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
// channel   17: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
// channel   18: 14yyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   0)
// channel   19: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   0)
// channel   20: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   0)
// channel   21: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
// channel   22: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
// channel   23: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
// channel   24: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
// channel   25: 14yyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   0)
// channel   26: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
// channel   27: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   0)
// channel   28: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
// channel   29: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,   0)
// channel   30: 2v2v1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
// channel   31: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,   0)
// channel   32: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   0,   0)
// channel   33: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
// channel   34: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,  23,   0,   0)
// channel   35: 2v12v(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,   0)
// channel   36: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,  23,   0,   0)
// channel   37: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,  23,   0,   0)
// channel   38: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   39: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   0,   0)
// channel   40: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
// channel   41: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   0,   0)
// channel   42: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   0,   0)
void ppeexnenex04_phasespace_set::ax_psp_340_ddx_emepvevexg(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_340_ddx_emepvevexg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(22);
  needed_v_smin[x_a].resize(22);
  int needed_v_smin_0[] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   50}; //  31
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 31);
  int needed_v_smin_1[] = {   0,    1}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 15);
  int needed_v_smin_4[] = {   2,    3}; //   2
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {   4}; //   1
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 1);
  int needed_v_smin_6[] = {   4,    6}; //   2
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   5,    6,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   50}; //  29
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 29);
  int needed_v_smin_8[] = {   5}; //   1
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 1);
  int needed_v_smin_9[] = {   5,   11}; //   2
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   6}; //   1
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 1);
  int needed_v_smin_11[] = {   7,    8}; //   2
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 2);
  int needed_v_smin_12[] = {   7,    8,    9,   10}; //   4
  needed_v_smin[x_a][ 12] = get_vector_from_array_int(needed_v_smin_12, 4);
  int needed_v_smin_13[] = {   9,   10,   11,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  needed_v_smin[x_a][ 13] = get_vector_from_array_int(needed_v_smin_13, 15);
  int needed_v_smin_14[] = {   9,   10}; //   2
  needed_v_smin[x_a][ 14] = get_vector_from_array_int(needed_v_smin_14, 2);
  int needed_v_smin_15[] = {  11}; //   1
  needed_v_smin[x_a][ 15] = get_vector_from_array_int(needed_v_smin_15, 1);
  int needed_v_smin_16[] = {  12,   13,   14,   15,   16,   17,   18}; //   7
  needed_v_smin[x_a][ 16] = get_vector_from_array_int(needed_v_smin_16, 7);
  int needed_v_smin_17[] = {  19,   20,   21,   22,   23,   24}; //   6
  needed_v_smin[x_a][ 17] = get_vector_from_array_int(needed_v_smin_17, 6);
  int needed_v_smin_18[] = {  25,   26,   27,   28,   29,   30,   43,   44,   49,   50}; //  10
  needed_v_smin[x_a][ 18] = get_vector_from_array_int(needed_v_smin_18, 10);
  int needed_v_smin_19[] = {  31,   32,   33}; //   3
  needed_v_smin[x_a][ 19] = get_vector_from_array_int(needed_v_smin_19, 3);
  int needed_v_smin_20[] = {  34,   35,   36,   37,   38,   39,   45,   46,   47,   48}; //  10
  needed_v_smin[x_a][ 20] = get_vector_from_array_int(needed_v_smin_20, 10);
  int needed_v_smin_21[] = {  40,   41,   42}; //   3
  needed_v_smin[x_a][ 21] = get_vector_from_array_int(needed_v_smin_21, 3);

  v_smax[x_a].resize(22);
  needed_v_smax[x_a].resize(22);
  int needed_v_smax_0[] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   43,   44,   47,   48}; //  21
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 21);
  int needed_v_smax_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  25
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 25);
  int needed_v_smax_3[] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33}; //  12
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 12);
  int needed_v_smax_4[] = {   4,    6}; //   2
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 2);
  int needed_v_smax_5[] = {   5,    6,   34,   35,   36,   37,   38,   39,   45,   46,   49,   50}; //  12
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 12);
  int needed_v_smax_6[] = {   5,   11}; //   2
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 2);
  int needed_v_smax_7[] = {   7,    8,    9,   10}; //   4
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 4);
  int needed_v_smax_8[] = {   9,   10,   11,   40,   41,   42}; //   6
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 6);
  int needed_v_smax_9[] = {  12,   13,   14,   15,   16,   17,   18,   47,   48}; //   9
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 9);
  int needed_v_smax_10[] = {  19,   20,   21,   22,   23,   24}; //   6
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 6);
  int needed_v_smax_11[] = {  25,   26,   27,   28,   29,   30,   43,   44}; //   8
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 8);
  int needed_v_smax_12[] = {  25,   26,   27,   28,   29,   30,   43,   44}; //   8
  needed_v_smax[x_a][ 12] = get_vector_from_array_int(needed_v_smax_12, 8);
  int needed_v_smax_13[] = {  31,   32,   33}; //   3
  needed_v_smax[x_a][ 13] = get_vector_from_array_int(needed_v_smax_13, 3);
  int needed_v_smax_14[] = {  31,   32,   33}; //   3
  needed_v_smax[x_a][ 14] = get_vector_from_array_int(needed_v_smax_14, 3);
  int needed_v_smax_15[] = {  34,   35,   36,   37,   38,   39,   45,   46}; //   8
  needed_v_smax[x_a][ 15] = get_vector_from_array_int(needed_v_smax_15, 8);
  int needed_v_smax_16[] = {  34,   35,   36,   37,   38,   39,   45,   46}; //   8
  needed_v_smax[x_a][ 16] = get_vector_from_array_int(needed_v_smax_16, 8);
  int needed_v_smax_17[] = {  40,   41,   42}; //   3
  needed_v_smax[x_a][ 17] = get_vector_from_array_int(needed_v_smax_17, 3);
  int needed_v_smax_18[] = {  40,   41,   42}; //   3
  needed_v_smax[x_a][ 18] = get_vector_from_array_int(needed_v_smax_18, 3);
  int needed_v_smax_19[] = {  47,   48}; //   2
  needed_v_smax[x_a][ 19] = get_vector_from_array_int(needed_v_smax_19, 2);
  int needed_v_smax_20[] = {  49,   50}; //   2
  needed_v_smax[x_a][ 20] = get_vector_from_array_int(needed_v_smax_20, 2);
  int needed_v_smax_21[] = {  49,   50}; //   2
  needed_v_smax[x_a][ 21] = get_vector_from_array_int(needed_v_smax_21, 2);

  g_p[x_a].resize(51);
  needed_g_p[x_a].resize(51);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   43,   44,   47,   48}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   4,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   5,    6,   37,   38,   39,   46,   50}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   5,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][12] = {   7,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][13] = {   7,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][14] = {   8,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][15] = {   9,   10,   11,   40,   41,   42}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax8");
  needed_g_p[x_a][16] = {   9,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][17] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][18] = {  12,   13,   14,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax9");
  needed_g_p[x_a][19] = {  12,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax2");
  needed_g_p[x_a][20] = {  13,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin16_smax2");
  needed_g_p[x_a][21] = {  14,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin16_smax2");
  needed_g_p[x_a][22] = {  15,   16,   17,   18,   48}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax9");
  needed_g_p[x_a][23] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin16_smax2");
  needed_g_p[x_a][24] = {  19,   20,   21,   22,   23,   24}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax10");
  needed_g_p[x_a][25] = {  19,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax2");
  needed_g_p[x_a][26] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin17_smax2");
  needed_g_p[x_a][27] = {  21}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin17_smax2");
  needed_g_p[x_a][28] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin17_smax2");
  needed_g_p[x_a][29] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin17_smax2");
  needed_g_p[x_a][30] = {  25,   26,   43,   44}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax11");
  needed_g_p[x_a][31] = {  25,   27,   29,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax12");
  needed_g_p[x_a][32] = {  26,   28,   30,   44}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax12");
  needed_g_p[x_a][33] = {  27,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin18_smax11");
  needed_g_p[x_a][34] = {  29,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin18_smax11");
  needed_g_p[x_a][35] = {  31}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax13");
  needed_g_p[x_a][36] = {  31,   32,   33}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax14");
  needed_g_p[x_a][37] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin19_smax13");
  needed_g_p[x_a][38] = {  33}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin19_smax13");
  needed_g_p[x_a][39] = {  34,   35,   36,   45,   49}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][40] = {  34,   37,   45,   46}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax15");
  needed_g_p[x_a][41] = {  34,   35,   36,   37,   38,   39,   45,   46}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][42] = {  35,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin20_smax15");
  needed_g_p[x_a][43] = {  36,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin20_smax15");
  needed_g_p[x_a][44] = {  40}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax17");
  needed_g_p[x_a][45] = {  40,   41,   42}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax18");
  needed_g_p[x_a][46] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin21_smax17");
  needed_g_p[x_a][47] = {  42}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin21_smax17");
  needed_g_p[x_a][48] = {  47,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax19");
  needed_g_p[x_a][49] = {  49,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax20");
  needed_g_p[x_a][50] = {  49,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax21");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {  43,   44}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][1] = {  45,   46}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][2] = {  47,   48}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][3] = {  49,   50}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");

  g_d[x_a].resize(27);
  needed_g_d[x_a].resize(27);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  25
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][3] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   50}; //  31
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][5] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][6] = {   4,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][8] = {   5,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][10] = {   5,    6,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   50}; //  29
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][11] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][12] = {   7,    8,    9,   10}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][13] = {   7,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][14] = {   9,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][15] = {   9,   10,   11,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][16] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][17] = {  12,   13,   14,   15,   16,   17,   18}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][18] = {  19,   20,   21,   22,   23,   24}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][19] = {  25,   26,   27,   28,   29,   30}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][20] = {  25,   26,   27,   28,   29,   30,   43,   44,   49,   50}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][21] = {  31,   32,   33}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][22] = {  31,   32,   33}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][23] = {  34,   35,   36,   37,   38,   39}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][24] = {  34,   35,   36,   37,   38,   39,   45,   46,   47,   48}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][25] = {  40,   41,   42}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][26] = {  40,   41,   42}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");

  c_p[x_a].resize(51);
  c_f[x_a].resize(51);
  c_t[x_a].resize(51);
  c_d[x_a].resize(51);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  4,   5,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   4,   5}; //   4

  c_p[x_a][3] = {  4,   5,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   4,   5}; //   4

  c_p[x_a][4] = {  4,   6,   7}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   6,   7,   5}; //   4

  c_p[x_a][5] = {  8,   9,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   8,   9,  10}; //   4

  c_p[x_a][6] = {  8,  11,   7}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   6,  11,  10}; //   4

  c_p[x_a][7] = {  0,  12,  13}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,  12,  13,   3}; //   4

  c_p[x_a][8] = {  0,  12,  14}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,  12,  13,   3}; //   4

  c_p[x_a][9] = { 15,  16,  13}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,  12,  14,  15}; //   4

  c_p[x_a][10] = { 15,  16,  14}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,  12,  14,  15}; //   4

  c_p[x_a][11] = { 15,  17,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,   8,  16,  15}; //   4

  c_p[x_a][12] = {  0,  18,  19}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,  17,  10,   3}; //   4

  c_p[x_a][13] = {  0,  18,  20}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  0,  17,  10,   3}; //   4

  c_p[x_a][14] = {  0,  18,  21}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  0,  17,  10,   3}; //   4

  c_p[x_a][15] = {  0,  22,  23}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  0,  17,  10,   3}; //   4

  c_p[x_a][16] = {  0,  22,  19}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  0,  17,  10,   3}; //   4

  c_p[x_a][17] = {  0,  22,  20}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  0,  17,  10,   3}; //   4

  c_p[x_a][18] = {  0,  22,  21}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  0,  17,  10,   3}; //   4

  c_p[x_a][19] = {  4,  24,  25}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  0,  18,  15,   5}; //   4

  c_p[x_a][20] = {  4,  24,  26}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  0,  18,  15,   5}; //   4

  c_p[x_a][21] = {  4,  24,  27}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  0,  18,  15,   5}; //   4

  c_p[x_a][22] = {  4,  24,  25}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  0,  18,  15,   5}; //   4

  c_p[x_a][23] = {  4,  24,  28}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  0,  18,  15,   5}; //   4

  c_p[x_a][24] = {  4,  24,  29}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  0,  18,  15,   5}; //   4

  c_p[x_a][25] = {  0,  30,  31}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 19,  10,  20,   3}; //   4

  c_p[x_a][26] = {  0,  30,  32}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 19,  10,  20,   3}; //   4

  c_p[x_a][27] = {  0,  33,  31}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 19,  10,  20,   3}; //   4

  c_p[x_a][28] = {  0,  33,  32}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 19,  10,  20,   3}; //   4

  c_p[x_a][29] = {  0,  34,  31}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 19,  10,  20,   3}; //   4

  c_p[x_a][30] = {  0,  34,  32}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 19,  10,  20,   3}; //   4

  c_p[x_a][31] = {  4,  35,  36}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 21,  15,  22,   5}; //   4

  c_p[x_a][32] = {  4,  37,  36}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 21,  15,  22,   5}; //   4

  c_p[x_a][33] = {  4,  38,  36}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 21,  15,  22,   5}; //   4

  c_p[x_a][34] = { 39,  40,  41}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 23,   3,  24,  10}; //   4

  c_p[x_a][35] = { 39,  42,  41}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 23,   3,  24,  10}; //   4

  c_p[x_a][36] = { 39,  43,  41}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 23,   3,  24,  10}; //   4

  c_p[x_a][37] = {  8,  40,  41}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 23,   3,  24,  10}; //   4

  c_p[x_a][38] = {  8,  42,  41}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 23,   3,  24,  10}; //   4

  c_p[x_a][39] = {  8,  43,  41}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 23,   3,  24,  10}; //   4

  c_p[x_a][40] = { 15,  44,  45}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 25,   5,  26,  15}; //   4

  c_p[x_a][41] = { 15,  46,  45}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 25,   5,  26,  15}; //   4

  c_p[x_a][42] = { 15,  47,  45}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 25,   5,  26,  15}; //   4

  c_p[x_a][43] = {  0,  30,  31}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  0}; //   1
  c_d[x_a][43] = { 10,  20,   3}; //   3

  c_p[x_a][44] = {  0,  30,  32}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  0}; //   1
  c_d[x_a][44] = { 10,  20,   3}; //   3

  c_p[x_a][45] = { 39,  40,  41}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  1}; //   1
  c_d[x_a][45] = {  3,  24,  10}; //   3

  c_p[x_a][46] = {  8,  40,  41}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  1}; //   1
  c_d[x_a][46] = {  3,  24,  10}; //   3

  c_p[x_a][47] = {  0,  18,  48}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  2}; //   1
  c_d[x_a][47] = { 24,  10,   3}; //   3

  c_p[x_a][48] = {  0,  22,  48}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  2}; //   1
  c_d[x_a][48] = { 24,  10,   3}; //   3

  c_p[x_a][49] = { 39,  49,  50}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  3}; //   1
  c_d[x_a][49] = { 20,   3,  10}; //   3

  c_p[x_a][50] = {  8,  49,  50}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  3}; //   1
  c_d[x_a][50] = { 20,   3,  10}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
