#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_240_gg_emepvmvmx(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_240_gg_emepvmvmx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(6);
  needed_v_smin[x_a].resize(6);
  int needed_v_smin_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  23
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 23);
  int needed_v_smin_1[] = {   0,    1}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   2,    3,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  21
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 21);
  int needed_v_smin_3[] = {   2}; //   1
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 1);
  int needed_v_smin_4[] = {   3}; //   1
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 1);
  int needed_v_smin_5[] = {   4,    5}; //   2
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 2);

  v_smax[x_a].resize(8);
  needed_v_smax[x_a].resize(8);
  int needed_v_smax_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18}; //  17
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 17);
  int needed_v_smax_1[] = {   0,    1}; //   2
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   2,    3,   19,   20,   21,   22,   23,   24}; //   8
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 8);
  int needed_v_smax_3[] = {   2}; //   1
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 1);
  int needed_v_smax_4[] = {   3}; //   1
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 1);
  int needed_v_smax_5[] = {   4,    5}; //   2
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18}; //  13
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 13);
  int needed_v_smax_7[] = {  19,   20,   21,   22,   23,   24}; //   6
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 6);

  g_p[x_a].resize(10);
  needed_g_p[x_a].resize(10);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    3,   22,   23,   24}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   6,    7,    8,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax6");
  needed_g_p[x_a][7] = {   9,   10,   11,   12,   16,   17,   18}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax6");
  needed_g_p[x_a][8] = {  19,   20,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][9] = {  19,   20,   21,   22,   23,   24}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(6);
  needed_g_t[x_a].resize(6);
  needed_g_t[x_a][0] = {  13,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][1] = {  14,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__12_48");
  needed_g_t[x_a][2] = {  15,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__12_48");
  needed_g_t[x_a][3] = {  19,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");
  needed_g_t[x_a][4] = {  20,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__48_12");
  needed_g_t[x_a][5] = {  21,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__48_12");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  23
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   2,    3,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][10] = {   6,    7,    8,    9,   10,   11,   12}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");

  c_p[x_a].resize(25);
  c_f[x_a].resize(25);
  c_t[x_a].resize(25);
  c_d[x_a].resize(25);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  2,   3}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  3,   4,   5}; //   3

  c_p[x_a][3] = {  2,   4}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   5}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  8,   9,   2}; //   3

  c_p[x_a][5] = {  0,   5}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  8,   9,   2}; //   3

  c_p[x_a][6] = {  0,   6}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = { 10,   5,   2}; //   3

  c_p[x_a][7] = {  0,   6}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 10,   5,   2}; //   3

  c_p[x_a][8] = {  0,   6}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 10,   5,   2}; //   3

  c_p[x_a][9] = {  0,   7}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 10,   5,   2}; //   3

  c_p[x_a][10] = {  0,   7}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 10,   5,   2}; //   3

  c_p[x_a][11] = {  0,   7}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 10,   5,   2}; //   3

  c_p[x_a][12] = {  0,   7}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 10,   5,   2}; //   3

  c_p[x_a][13] = {  0,   6}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  5,   2}; //   2

  c_p[x_a][14] = {  0,   6}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  1}; //   1
  c_d[x_a][14] = {  5,   2}; //   2

  c_p[x_a][15] = {  0,   6}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  2}; //   1
  c_d[x_a][15] = {  5,   2}; //   2

  c_p[x_a][16] = {  0,   7}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = {  5,   2}; //   2

  c_p[x_a][17] = {  0,   7}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  1}; //   1
  c_d[x_a][17] = {  5,   2}; //   2

  c_p[x_a][18] = {  0,   7}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  2}; //   1
  c_d[x_a][18] = {  5,   2}; //   2

  c_p[x_a][19] = {  8,   9}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  3}; //   1
  c_d[x_a][19] = {  2,   5}; //   2

  c_p[x_a][20] = {  8,   9}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  4}; //   1
  c_d[x_a][20] = {  2,   5}; //   2

  c_p[x_a][21] = {  8,   9}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  5}; //   1
  c_d[x_a][21] = {  2,   5}; //   2

  c_p[x_a][22] = {  2,   9}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  3}; //   1
  c_d[x_a][22] = {  2,   5}; //   2

  c_p[x_a][23] = {  2,   9}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  4}; //   1
  c_d[x_a][23] = {  2,   5}; //   2

  c_p[x_a][24] = {  2,   9}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  5}; //   1
  c_d[x_a][24] = {  2,   5}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
