#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_240_ddx_emepvmvmxbbx(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_240_ddx_emepvmvmxbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(28);
  needed_v_smin[x_a].resize(28);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   38,   39,   40,   41,   42,   43,   44,   45,   47,   48,   49,   50,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  58
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   30,   31,   40,   41}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   30,   31,   40,   41}; //   8
  needed_v_smin[x_a][  3] = {   0,    1,    4,    6,    8,    9,   12}; //   7
  needed_v_smin[x_a][  4] = {   2,    3,    5,    7,   10,   11,   13}; //   7
  needed_v_smin[x_a][  5] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   32,   33,   34,   35,   36,   37,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  50
  needed_v_smin[x_a][  6] = {   4,    5,   36,   46}; //   4
  needed_v_smin[x_a][  7] = {   4,    5,   36,   46}; //   4
  needed_v_smin[x_a][  8] = {   6,    7,   37,   51}; //   4
  needed_v_smin[x_a][  9] = {   6,    7,   37,   51}; //   4
  needed_v_smin[x_a][ 10] = {   8,    9,   10,   11,   38,   39,   52,   53}; //   8
  needed_v_smin[x_a][ 11] = {   8,    9,   10,   11,   38,   39,   52,   53}; //   8
  needed_v_smin[x_a][ 12] = {  12,   13,   58,   59,   64,   65}; //   6
  needed_v_smin[x_a][ 13] = {  14,   15,   24,   25,   28,   29,   49,   50}; //   8
  needed_v_smin[x_a][ 14] = {  14,   15}; //   2
  needed_v_smin[x_a][ 15] = {  16,   17,   22,   23,   26,   27,   47,   48}; //   8
  needed_v_smin[x_a][ 16] = {  16,   17}; //   2
  needed_v_smin[x_a][ 17] = {  18,   19,   22,   23,   34,   35,   44,   45}; //   8
  needed_v_smin[x_a][ 18] = {  18,   19}; //   2
  needed_v_smin[x_a][ 19] = {  20,   21,   24,   25,   32,   33,   42,   43}; //   8
  needed_v_smin[x_a][ 20] = {  20,   21}; //   2
  needed_v_smin[x_a][ 21] = {  26,   27,   47,   48}; //   4
  needed_v_smin[x_a][ 22] = {  28,   29,   49,   50}; //   4
  needed_v_smin[x_a][ 23] = {  30,   31,   36,   37,   38,   39,   40,   41,   46,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  24
  needed_v_smin[x_a][ 24] = {  32,   33,   42,   43}; //   4
  needed_v_smin[x_a][ 25] = {  34,   35,   44,   45}; //   4
  needed_v_smin[x_a][ 26] = {  54,   55,   56,   57}; //   4
  needed_v_smin[x_a][ 27] = {  60,   61,   62,   63}; //   4

  v_smax[x_a].resize(45);
  needed_v_smax[x_a].resize(45);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   22,   23,   26,   27,   28,   29,   30,   31,   38,   39,   42,   43,   44,   45,   56,   57,   58,   59}; //  32
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   30,   31}; //   6
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   30,   31,   36,   37,   38,   39}; //  20
  needed_v_smax[x_a][  3] = {   0,    1,    4,    6,    8,    9,   12,   16,   17,   20,   21}; //  11
  needed_v_smax[x_a][  4] = {   2,    3,    5,    7,   10,   11,   13,   14,   15,   18,   19}; //  11
  needed_v_smax[x_a][  5] = {   4,    5,    6,    7,   18,   19,   20,   21,   24,   25,   32,   33,   34,   35,   36,   37,   47,   48,   49,   50,   62,   63,   64,   65}; //  24
  needed_v_smax[x_a][  6] = {   4,    5,   36}; //   3
  needed_v_smax[x_a][  7] = {   6,    7,   37}; //   3
  needed_v_smax[x_a][  8] = {   8,    9,   10,   11,   38,   39}; //   6
  needed_v_smax[x_a][  9] = {  12,   13,   22,   23,   42,   43,   44,   45,   58,   59}; //  10
  needed_v_smax[x_a][ 10] = {  14,   15,   28,   29}; //   4
  needed_v_smax[x_a][ 11] = {  14,   15}; //   2
  needed_v_smax[x_a][ 12] = {  16,   17,   26,   27}; //   4
  needed_v_smax[x_a][ 13] = {  16,   17}; //   2
  needed_v_smax[x_a][ 14] = {  18,   19,   34,   35}; //   4
  needed_v_smax[x_a][ 15] = {  18,   19}; //   2
  needed_v_smax[x_a][ 16] = {  20,   21,   32,   33}; //   4
  needed_v_smax[x_a][ 17] = {  20,   21}; //   2
  needed_v_smax[x_a][ 18] = {  22,   23,   47,   48}; //   4
  needed_v_smax[x_a][ 19] = {  22,   23}; //   2
  needed_v_smax[x_a][ 20] = {  24,   25,   47,   48,   49,   50,   64,   65}; //   8
  needed_v_smax[x_a][ 21] = {  24,   25,   42,   43}; //   4
  needed_v_smax[x_a][ 22] = {  24,   25}; //   2
  needed_v_smax[x_a][ 23] = {  26,   27,   28,   29}; //   4
  needed_v_smax[x_a][ 24] = {  26,   27,   28,   29}; //   4
  needed_v_smax[x_a][ 25] = {  30,   31,   36,   37,   38,   39}; //   6
  needed_v_smax[x_a][ 26] = {  32,   33,   34,   35}; //   4
  needed_v_smax[x_a][ 27] = {  32,   33,   34,   35}; //   4
  needed_v_smax[x_a][ 28] = {  40,   41,   46,   51,   52,   53,   54,   55,   60,   61}; //  10
  needed_v_smax[x_a][ 29] = {  40,   41,   52,   53,   54,   55}; //   6
  needed_v_smax[x_a][ 30] = {  40,   41}; //   2
  needed_v_smax[x_a][ 31] = {  40,   41,   46,   51,   52,   53,   58,   59,   64,   65}; //  10
  needed_v_smax[x_a][ 32] = {  42,   43,   44,   45,   60,   61,   62,   63}; //   8
  needed_v_smax[x_a][ 33] = {  44,   45}; //   2
  needed_v_smax[x_a][ 34] = {  46,   51,   60,   61}; //   4
  needed_v_smax[x_a][ 35] = {  46}; //   1
  needed_v_smax[x_a][ 36] = {  47,   48,   49,   50,   54,   55,   56,   57}; //   8
  needed_v_smax[x_a][ 37] = {  49,   50}; //   2
  needed_v_smax[x_a][ 38] = {  51}; //   1
  needed_v_smax[x_a][ 39] = {  52,   53}; //   2
  needed_v_smax[x_a][ 40] = {  54,   55,   56,   57}; //   4
  needed_v_smax[x_a][ 41] = {  56,   57}; //   2
  needed_v_smax[x_a][ 42] = {  58,   59,   64,   65}; //   4
  needed_v_smax[x_a][ 43] = {  60,   61,   62,   63}; //   4
  needed_v_smax[x_a][ 44] = {  62,   63}; //   2

  g_p[x_a].resize(71);
  needed_g_p[x_a].resize(71);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   22,   23,   26,   27,   28,   29,   30,   31,   38,   39,   42,   43,   44,   45,   56,   57,   58,   59}; //  32
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   30,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   30}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    4,    6,    8,    9,   12}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,   31}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   2,    3,    5,    7,   10,   11,   13}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin4_smax4");
  needed_g_p[x_a][6] = {   4,    5,    6,    7,   19,   21,   25,   33,   35,   36,   37,   48,   50,   63,   65}; //  15
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax5");
  needed_g_p[x_a][7] = {   4,    5,   36}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][8] = {   4,    5,   36}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][9] = {   6,    7,   37}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   6,    7,   37}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   8,    9,   10,   11,   38,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][12] = {   8,   10,   38}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax2");
  needed_g_p[x_a][13] = {   9,   11,   39}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][14] = {  12,   13,   23,   43,   45,   59}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax9");
  needed_g_p[x_a][15] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin12_smax2");
  needed_g_p[x_a][16] = {  14,   15,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin13_smax10");
  needed_g_p[x_a][17] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax11");
  needed_g_p[x_a][18] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin14_smax4");
  needed_g_p[x_a][19] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax11");
  needed_g_p[x_a][20] = {  16,   17,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin15_smax12");
  needed_g_p[x_a][21] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax13");
  needed_g_p[x_a][22] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin16_smax3");
  needed_g_p[x_a][23] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax13");
  needed_g_p[x_a][24] = {  18,   20,   24,   32,   34,   47,   49,   62,   64}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][25] = {  18,   19,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin17_smax14");
  needed_g_p[x_a][26] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax15");
  needed_g_p[x_a][27] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin18_smax4");
  needed_g_p[x_a][28] = {  20,   21,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin19_smax16");
  needed_g_p[x_a][29] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax17");
  needed_g_p[x_a][30] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin20_smax3");
  needed_g_p[x_a][31] = {  22,   42,   44,   58}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax9");
  needed_g_p[x_a][32] = {  22,   23,   47,   48}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin15_smax18");
  needed_g_p[x_a][33] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin17_smax19");
  needed_g_p[x_a][34] = {  24,   25,   47,   48,   49,   50,   64,   65}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax20");
  needed_g_p[x_a][35] = {  24,   25,   42,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin19_smax21");
  needed_g_p[x_a][36] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin13_smax22");
  needed_g_p[x_a][37] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax23");
  needed_g_p[x_a][38] = {  26,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax24");
  needed_g_p[x_a][39] = {  27,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax24");
  needed_g_p[x_a][40] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax23");
  needed_g_p[x_a][41] = {  30,   31,   36,   37,   38,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax25");
  needed_g_p[x_a][42] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax26");
  needed_g_p[x_a][43] = {  32,   33,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax27");
  needed_g_p[x_a][44] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax26");
  needed_g_p[x_a][45] = {  40,   41,   46,   51,   52,   53,   54,   55,   60,   61}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax28");
  needed_g_p[x_a][46] = {  40,   41,   52,   53,   54,   55}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax29");
  needed_g_p[x_a][47] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax30");
  needed_g_p[x_a][48] = {  40}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax31");
  needed_g_p[x_a][49] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax31");
  needed_g_p[x_a][50] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax32");
  needed_g_p[x_a][51] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin17_smax33");
  needed_g_p[x_a][52] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax32");
  needed_g_p[x_a][53] = {  46,   51,   61}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax34");
  needed_g_p[x_a][54] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax35");
  needed_g_p[x_a][55] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax31");
  needed_g_p[x_a][56] = {  47,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax36");
  needed_g_p[x_a][57] = {  49,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin13_smax37");
  needed_g_p[x_a][58] = {  49,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax36");
  needed_g_p[x_a][59] = {  51}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax38");
  needed_g_p[x_a][60] = {  51}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax31");
  needed_g_p[x_a][61] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax39");
  needed_g_p[x_a][62] = {  52}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax31");
  needed_g_p[x_a][63] = {  53}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax31");
  needed_g_p[x_a][64] = {  54,   56}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax40");
  needed_g_p[x_a][65] = {  55,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax40");
  needed_g_p[x_a][66] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax41");
  needed_g_p[x_a][67] = {  58,   59,   64,   65}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax42");
  needed_g_p[x_a][68] = {  60}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax34");
  needed_g_p[x_a][69] = {  60,   61,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax43");
  needed_g_p[x_a][70] = {  62,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax44");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  54,   55,   56,   57}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax36");
  needed_g_f[x_a][1] = {  58,   59,   64,   65}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax31");
  needed_g_f[x_a][2] = {  60,   61,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax32");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {  26,   27,   28,   29,   54,   55,   56,   57}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][1] = {  30,   31,   36,   37,   38,   39,   58,   59,   64,   65}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][2] = {  32,   33,   34,   35,   60,   61,   62,   63}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][3] = {  40,   41,   46,   51,   52,   53}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][4] = {  42,   43,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][5] = {  47,   48,   49,   50}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][6] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__192_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__192_48");
  needed_g_t[x_a][7] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][8] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][9] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__192_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__192_12");
  needed_g_t[x_a][10] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][11] = {  64,   65}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");

  g_d[x_a].resize(30);
  needed_g_d[x_a].resize(30);
  needed_g_d[x_a][0] = {   0,    1,    4,    6,    8,    9,   12,   16,   17,   20,   21}; //  11
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][1] = {   0,    1,    4,    6,    8,    9,   12}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,   30,   31,   40,   41}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,   30,   31,   40,   41}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][4] = {   0,    1,    2,    3,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   38,   39,   40,   41,   42,   43,   44,   45,   47,   48,   49,   50,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  58
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][5] = {   2,    3,    5,    7,   10,   11,   13,   14,   15,   18,   19}; //  11
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][6] = {   2,    3,    5,    7,   10,   11,   13}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][7] = {   4,    5,   36,   46}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   4,    5,   36,   46}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   32,   33,   34,   35,   36,   37,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  50
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6,    7,   37,   51}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][11] = {   6,    7,   37,   51}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][12] = {   8,    9,   10,   11,   38,   39,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][13] = {   8,    9,   10,   11,   38,   39,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][14] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][15] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][16] = {  14,   15,   24,   25,   28,   29,   49,   50}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][17] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][18] = {  16,   17,   22,   23,   26,   27,   47,   48}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][19] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][20] = {  18,   19,   22,   23,   34,   35,   44,   45}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][21] = {  20,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][22] = {  20,   21,   24,   25,   32,   33,   42,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][23] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__76_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__76_176");
  needed_g_d[x_a][24] = {  24,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__112_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__112_140");
  needed_g_d[x_a][25] = {  26,   27,   47,   48}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__64_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__64_176");
  needed_g_d[x_a][26] = {  28,   29,   49,   50}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__128_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__128_112");
  needed_g_d[x_a][27] = {  30,   31,   36,   37,   38,   39,   40,   41,   46,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][28] = {  32,   33,   42,   43}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__64_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__64_140");
  needed_g_d[x_a][29] = {  34,   35,   44,   45}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__128_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__128_76");

  c_p[x_a].resize(66);
  c_f[x_a].resize(66);
  c_t[x_a].resize(66);
  c_d[x_a].resize(66);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][1] = {  0,   1,   4,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][2] = {  0,   1,   2,   5}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][3] = {  0,   1,   4,   5}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][4] = {  6,   7,   8,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   1,   7,   8,   9}; //   5

  c_p[x_a][5] = {  6,   7,   8,   5}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,   6,   7,   8,   9}; //   5

  c_p[x_a][6] = {  6,   9,  10,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   1,  10,  11,   9}; //   5

  c_p[x_a][7] = {  6,   9,  10,   5}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,   6,  10,  11,   9}; //   5

  c_p[x_a][8] = {  0,  11,  12,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   1,  12,  13,   4}; //   5

  c_p[x_a][9] = {  0,  11,  13,   3}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,   1,  12,  13,   4}; //   5

  c_p[x_a][10] = {  0,  11,  12,   5}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  5,   6,  12,  13,   4}; //   5

  c_p[x_a][11] = {  0,  11,  13,   5}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,  12,  13,   4}; //   5

  c_p[x_a][12] = {  0,  14,  15,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,   1,  14,   9,   4}; //   5

  c_p[x_a][13] = {  0,  14,  15,   5}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  5,   6,  14,   9,   4}; //   5

  c_p[x_a][14] = {  0,  16,  17,  18}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  5,  15,   9,  16,   4}; //   5

  c_p[x_a][15] = {  0,  16,  19,  18}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  5,  15,   9,  16,   4}; //   5

  c_p[x_a][16] = {  0,  20,  21,  22}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  0,  17,   9,  18,   4}; //   5

  c_p[x_a][17] = {  0,  20,  23,  22}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  0,  17,   9,  18,   4}; //   5

  c_p[x_a][18] = { 24,  25,  26,  27}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  5,  19,   4,  20,   9}; //   5

  c_p[x_a][19] = {  6,  25,  26,  27}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  5,  19,   4,  20,   9}; //   5

  c_p[x_a][20] = { 24,  28,  29,  30}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  0,  21,   4,  22,   9}; //   5

  c_p[x_a][21] = {  6,  28,  29,  30}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  0,  21,   4,  22,   9}; //   5

  c_p[x_a][22] = {  0,  31,  32,  33}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 23,  20,  18,   9,   4}; //   5

  c_p[x_a][23] = {  0,  14,  32,  33}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 23,  20,  18,   9,   4}; //   5

  c_p[x_a][24] = { 24,  34,  35,  36}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 24,  16,  22,   4,   9}; //   5

  c_p[x_a][25] = {  6,  34,  35,  36}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 24,  16,  22,   4,   9}; //   5

  c_p[x_a][26] = {  0,  20,  37,  38}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  9,  25,  18,   4}; //   4

  c_p[x_a][27] = {  0,  20,  37,  39}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  9,  25,  18,   4}; //   4

  c_p[x_a][28] = {  0,  16,  40,  38}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = {  9,  26,  16,   4}; //   4

  c_p[x_a][29] = {  0,  16,  40,  39}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = {  9,  26,  16,   4}; //   4

  c_p[x_a][30] = {  0,   1,   2,  41}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  1}; //   1
  c_d[x_a][30] = { 27,   2,   3,   4}; //   4

  c_p[x_a][31] = {  0,   1,   4,  41}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  1}; //   1
  c_d[x_a][31] = { 27,   2,   3,   4}; //   4

  c_p[x_a][32] = { 24,  28,  42,  43}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  2}; //   1
  c_d[x_a][32] = {  4,  28,  22,   9}; //   4

  c_p[x_a][33] = {  6,  28,  42,  43}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  2}; //   1
  c_d[x_a][33] = {  4,  28,  22,   9}; //   4

  c_p[x_a][34] = { 24,  25,  44,  43}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  2}; //   1
  c_d[x_a][34] = {  4,  29,  20,   9}; //   4

  c_p[x_a][35] = {  6,  25,  44,  43}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  2}; //   1
  c_d[x_a][35] = {  4,  29,  20,   9}; //   4

  c_p[x_a][36] = {  6,   7,   8,  41}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  1}; //   1
  c_d[x_a][36] = { 27,   7,   8,   9}; //   4

  c_p[x_a][37] = {  6,   9,  10,  41}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  1}; //   1
  c_d[x_a][37] = { 27,  10,  11,   9}; //   4

  c_p[x_a][38] = {  0,  11,  12,  41}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  1}; //   1
  c_d[x_a][38] = { 27,  12,  13,   4}; //   4

  c_p[x_a][39] = {  0,  11,  13,  41}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  1}; //   1
  c_d[x_a][39] = { 27,  12,  13,   4}; //   4

  c_p[x_a][40] = { 45,  46,  47,  48}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  3}; //   1
  c_d[x_a][40] = {  2,   3,   4,  27}; //   4

  c_p[x_a][41] = { 45,  46,  47,  49}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  3}; //   1
  c_d[x_a][41] = {  2,   3,   4,  27}; //   4

  c_p[x_a][42] = {  0,  31,  35,  50}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  4}; //   1
  c_d[x_a][42] = { 28,  22,   9,   4}; //   4

  c_p[x_a][43] = {  0,  14,  35,  50}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  4}; //   1
  c_d[x_a][43] = { 28,  22,   9,   4}; //   4

  c_p[x_a][44] = {  0,  31,  51,  52}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  4}; //   1
  c_d[x_a][44] = { 29,  20,   9,   4}; //   4

  c_p[x_a][45] = {  0,  14,  51,  52}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  4}; //   1
  c_d[x_a][45] = { 29,  20,   9,   4}; //   4

  c_p[x_a][46] = { 45,  53,  54,  55}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  3}; //   1
  c_d[x_a][46] = {  7,   8,   9,  27}; //   4

  c_p[x_a][47] = { 24,  34,  32,  56}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  5}; //   1
  c_d[x_a][47] = { 25,  18,   4,   9}; //   4

  c_p[x_a][48] = {  6,  34,  32,  56}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  5}; //   1
  c_d[x_a][48] = { 25,  18,   4,   9}; //   4

  c_p[x_a][49] = { 24,  34,  57,  58}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  5}; //   1
  c_d[x_a][49] = { 26,  16,   4,   9}; //   4

  c_p[x_a][50] = {  6,  34,  57,  58}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  5}; //   1
  c_d[x_a][50] = { 26,  16,   4,   9}; //   4

  c_p[x_a][51] = { 45,  53,  59,  60}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  3}; //   1
  c_d[x_a][51] = { 10,  11,   9,  27}; //   4

  c_p[x_a][52] = { 45,  46,  61,  62}; //   4
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  3}; //   1
  c_d[x_a][52] = { 12,  13,   4,  27}; //   4

  c_p[x_a][53] = { 45,  46,  61,  63}; //   4
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  3}; //   1
  c_d[x_a][53] = { 12,  13,   4,  27}; //   4

  c_p[x_a][54] = { 45,  46,  64}; //   3
  c_f[x_a][54] = {  0}; //   1
  c_t[x_a][54] = {  0,   6}; //   2
  c_d[x_a][54] = {  9,   4,  27}; //   3

  c_p[x_a][55] = { 45,  46,  65}; //   3
  c_f[x_a][55] = {  0}; //   1
  c_t[x_a][55] = {  0,   6}; //   2
  c_d[x_a][55] = {  9,   4,  27}; //   3

  c_p[x_a][56] = {  0,  66,  64}; //   3
  c_f[x_a][56] = {  0}; //   1
  c_t[x_a][56] = {  0,   7}; //   2
  c_d[x_a][56] = {  9,  27,   4}; //   3

  c_p[x_a][57] = {  0,  66,  65}; //   3
  c_f[x_a][57] = {  0}; //   1
  c_t[x_a][57] = {  0,   7}; //   2
  c_d[x_a][57] = {  9,  27,   4}; //   3

  c_p[x_a][58] = {  0,  31,  67}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  1,   8}; //   2
  c_d[x_a][58] = { 27,   9,   4}; //   3

  c_p[x_a][59] = {  0,  14,  67}; //   3
  c_f[x_a][59] = {  1}; //   1
  c_t[x_a][59] = {  1,   8}; //   2
  c_d[x_a][59] = { 27,   9,   4}; //   3

  c_p[x_a][60] = { 45,  68,  69}; //   3
  c_f[x_a][60] = {  2}; //   1
  c_t[x_a][60] = {  2,   9}; //   2
  c_d[x_a][60] = {  4,   9,  27}; //   3

  c_p[x_a][61] = { 45,  53,  69}; //   3
  c_f[x_a][61] = {  2}; //   1
  c_t[x_a][61] = {  2,   9}; //   2
  c_d[x_a][61] = {  4,   9,  27}; //   3

  c_p[x_a][62] = { 24,  70,  69}; //   3
  c_f[x_a][62] = {  2}; //   1
  c_t[x_a][62] = {  2,  10}; //   2
  c_d[x_a][62] = {  4,  27,   9}; //   3

  c_p[x_a][63] = {  6,  70,  69}; //   3
  c_f[x_a][63] = {  2}; //   1
  c_t[x_a][63] = {  2,  10}; //   2
  c_d[x_a][63] = {  4,  27,   9}; //   3

  c_p[x_a][64] = { 24,  34,  67}; //   3
  c_f[x_a][64] = {  1}; //   1
  c_t[x_a][64] = {  1,  11}; //   2
  c_d[x_a][64] = { 27,   4,   9}; //   3

  c_p[x_a][65] = {  6,  34,  67}; //   3
  c_f[x_a][65] = {  1}; //   1
  c_t[x_a][65] = {  1,  11}; //   2
  c_d[x_a][65] = { 27,   4,   9}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 6yyyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   5,   0)
// channel    1: 6yyyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   5,   0)
// channel    2: 6yyyyv(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,   0,   5,   0)
// channel    3: 6yyyyv(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,  23,   5,   0)
// channel    4: 6yyyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   5,   0)
// channel    5: 6yyyyv(1, 2, 128, 64, 16, 32, 4, 8;  23,   0,  23,   5,   0)
// channel    6: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   5,   0)
// channel    7: 6yyyyv(1, 2, 128, 64, 32, 16, 4, 8;  23,   0,  23,   5,   0)
// channel    8: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   5,   0)
// channel    9: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   5,   0)
// channel   10: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  23,   0,   0,   5,   0)
// channel   11: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  23,   0,  23,   5,   0)
// channel   12: 6yy2vv(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,  25,   5,   0)
// channel   13: 6yy2vv(1, 2, 128, 64, 4, 8, 16, 32;  23,  23,  25,   5,   0)
// channel   14: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  23,   5,   0,   5,   0)
// channel   15: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  23,   5,  23,   5,   0)
// channel   16: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   5,   0,   5,   0)
// channel   17: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   5,  23,   5,   0)
// channel   18: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;   0,   5,  23,   5,   0)
// channel   19: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;  23,   5,  23,   5,   0)
// channel   20: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   5,  23,   5,   0)
// channel   21: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   5,  23,   5,   0)
// channel   22: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   5,   5,   0)
// channel   23: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  23,  23,   5,   5,   0)
// channel   24: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;   0,  23,   5,   5,   0)
// channel   25: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;  23,  23,   5,   5,   0)
// channel   26: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  23,   5,   0,   0,   0)
// channel   27: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  23,   5,   0,  23,   0)
// channel   28: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  23,   5,   0,   0,   0)
// channel   29: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  23,   5,   0,  23,   0)
// channel   30: 2v4yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
// channel   31: 2v4yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
// channel   32: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;   0,   5,   0,  23,   0)
// channel   33: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;  23,   5,   0,  23,   0)
// channel   34: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;   0,   5,   0,  23,   0)
// channel   35: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;  23,   5,   0,  23,   0)
// channel   36: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
// channel   37: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
// channel   38: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
// channel   39: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
// channel   40: 4yyv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,   0,   0)
// channel   41: 4yyv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,  23,   0)
// channel   42: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   5,   0,   0)
// channel   43: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   5,   0,   0)
// channel   44: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,   5,   0,   0)
// channel   45: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  23,  23,   5,   0,   0)
// channel   46: 4yyv2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  23,   0)
// channel   47: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   5,   0,   0)
// channel   48: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   5,   0,   0)
// channel   49: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;   0,  23,   5,   0,   0)
// channel   50: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;  23,  23,   5,   0,   0)
// channel   51: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,  23,   0,  23,   0)
// channel   52: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  23,   0,   0,   0)
// channel   53: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  23,   0,  23,   0)
// channel   54: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,   0,   0)
// channel   55: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,  23,   0,   0)
// channel   56: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
// channel   57: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,  23,   0,   0)
// channel   58: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
// channel   59: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
// channel   60: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,  23,   0,   0)
// channel   61: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,  23,   0,   0)
// channel   62: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  23,   0,   0)
// channel   63: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  23,   0,   0)
// channel   64: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
// channel   65: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
