#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_050_aa_emepvmvmxa(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_050_aa_emepvmvmxa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(12);
  needed_v_smin[x_a].resize(12);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  needed_v_smin[x_a][  1] = {   0,    2,    9,   15,   19,   20}; //   6
  needed_v_smin[x_a][  2] = {   1,    3,    8,   14,   18,   21}; //   6
  needed_v_smin[x_a][  3] = {   2,    9,    0,   15}; //   4
  needed_v_smin[x_a][  4] = {   3,    8,    1,   14}; //   4
  needed_v_smin[x_a][  5] = {   4,   11,   16,   18,   21,   23}; //   6
  needed_v_smin[x_a][  6] = {   4,   11,   16,   23}; //   4
  needed_v_smin[x_a][  7] = {   5,   10,   17,   19,   20,   22}; //   6
  needed_v_smin[x_a][  8] = {   5,   10,   17,   22}; //   4
  needed_v_smin[x_a][  9] = {   6,    7,   12,   13}; //   4
  needed_v_smin[x_a][ 10] = {   6,   12}; //   2
  needed_v_smin[x_a][ 11] = {   7,   13}; //   2

  v_smax[x_a].resize(16);
  needed_v_smax[x_a].resize(16);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19}; //  20
  needed_v_smax[x_a][  1] = {   0,    2,    9,   15,   19}; //   5
  needed_v_smax[x_a][  2] = {   1,    3,    8,   14,   18}; //   5
  needed_v_smax[x_a][  3] = {   2,    4,    9,   11,    0,    7,   13,   15,   16,   23}; //  10
  needed_v_smax[x_a][  4] = {   3,    5,    8,   10,    1,    6,   12,   14,   17,   22}; //  10
  needed_v_smax[x_a][  5] = {   4,   11,   16}; //   3
  needed_v_smax[x_a][  6] = {   5,   10,   17}; //   3
  needed_v_smax[x_a][  7] = {  18}; //   1
  needed_v_smax[x_a][  8] = {  19}; //   1
  needed_v_smax[x_a][  9] = {  20,   22}; //   2
  needed_v_smax[x_a][ 10] = {  20,   22}; //   2
  needed_v_smax[x_a][ 11] = {  20}; //   1
  needed_v_smax[x_a][ 12] = {  21,   23}; //   2
  needed_v_smax[x_a][ 13] = {  21,   23}; //   2
  needed_v_smax[x_a][ 14] = {  21}; //   1
  needed_v_smax[x_a][ 15] = {   6,    7,   12,   13}; //   4

  g_p[x_a].resize(17);
  needed_g_p[x_a].resize(17);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    2,    9,   15,   19}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    3,    8,   14,   18}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   3,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   4,   11,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   4,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax3");
  needed_g_p[x_a][7] = {   5,   10,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][8] = {   5,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax4");
  needed_g_p[x_a][9] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax7");
  needed_g_p[x_a][10] = {  19}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax8");
  needed_g_p[x_a][11] = {  20,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax9");
  needed_g_p[x_a][12] = {  20,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");
  needed_g_p[x_a][13] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][14] = {  21,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax12");
  needed_g_p[x_a][15] = {  21,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax13");
  needed_g_p[x_a][16] = {  21}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax14");

  g_f[x_a].resize(7);
  needed_g_f[x_a].resize(7);
  needed_g_f[x_a][0] = {   0,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {   1,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][2] = {   6,    7,   12,   13}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax15");
  needed_g_f[x_a][3] = {   6,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax4");
  needed_g_f[x_a][4] = {   7,   13}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");
  needed_g_f[x_a][5] = {  16,   23}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax3");
  needed_g_f[x_a][6] = {  17,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax4");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    2,    4,   16}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__64_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__64_52");
  needed_g_t[x_a][2] = {   1,    3,    5,   17}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__64_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__64_56");
  needed_g_t[x_a][4] = {   6,    8,   10,   12,   14,   22}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_120");
  needed_g_t[x_a][5] = {   6,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_112");
  needed_g_t[x_a][6] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_5__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_5__64_48");
  needed_g_t[x_a][7] = {   7,    9,   11,   13,   15,   23}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_116");
  needed_g_t[x_a][8] = {   7,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_112");
  needed_g_t[x_a][9] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_9__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_9__64_48");
  needed_g_t[x_a][10] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__64_48");
  needed_g_t[x_a][11] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__64_48");
  needed_g_t[x_a][12] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__5_2__64_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__5_2__64_56");
  needed_g_t[x_a][13] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__9_2__64_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__9_2__64_52");
  needed_g_t[x_a][14] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__68_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__68_48");
  needed_g_t[x_a][15] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__72_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__72_48");
  needed_g_t[x_a][16] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__68_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__68_56");
  needed_g_t[x_a][17] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__72_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__72_52");
  needed_g_t[x_a][18] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__72_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__72_52");
  needed_g_t[x_a][19] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__68_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__68_56");
  needed_g_t[x_a][20] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__72_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__72_48");
  needed_g_t[x_a][21] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__68_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__68_48");

  g_d[x_a].resize(9);
  needed_g_d[x_a].resize(9);
  needed_g_d[x_a][0] = {   0,    2,    9,   15,   19,   20}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {   1,    3,    8,   14,   18,   21}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][3] = {   2,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][4] = {   3,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");
  needed_g_d[x_a][5] = {   4,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__68_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__68_48");
  needed_g_d[x_a][6] = {   4,   11,   16,   18,   21,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][7] = {   5,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__72_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__72_48");
  needed_g_d[x_a][8] = {   5,   10,   17,   19,   20,   22}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   2}; //   2
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  2,   1}; //   2

  c_p[x_a][2] = {  0,   1,   3}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   0,   1}; //   3

  c_p[x_a][3] = {  0,   2,   4}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  2}; //   1
  c_d[x_a][3] = {  4,   2,   1}; //   3

  c_p[x_a][4] = {  0,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  5,   6,   1}; //   3

  c_p[x_a][5] = {  0,   7,   8}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  2}; //   1
  c_d[x_a][5] = {  7,   8,   1}; //   3

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  2,   3}; //   2
  c_t[x_a][6] = {  4,   5,   6}; //   3
  c_d[x_a][6] = {  1}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {  2,   4}; //   2
  c_t[x_a][7] = {  7,   8,   9}; //   3
  c_d[x_a][7] = {  1}; //   1

  c_p[x_a][8] = {  0,   2,   4}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  4}; //   1
  c_d[x_a][8] = {  4,   2,   1}; //   3

  c_p[x_a][9] = {  0,   1,   3}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  7}; //   1
  c_d[x_a][9] = {  3,   0,   1}; //   3

  c_p[x_a][10] = {  0,   7,   8}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  4}; //   1
  c_d[x_a][10] = {  7,   8,   1}; //   3

  c_p[x_a][11] = {  0,   5,   6}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  7}; //   1
  c_d[x_a][11] = {  5,   6,   1}; //   3

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  2,   3}; //   2
  c_t[x_a][12] = {  4,   5,  10}; //   3
  c_d[x_a][12] = {  1}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {  2,   4}; //   2
  c_t[x_a][13] = {  7,   8,  11}; //   3
  c_d[x_a][13] = {  1}; //   1

  c_p[x_a][14] = {  0,   2}; //   2
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = {  4,  12}; //   2
  c_d[x_a][14] = {  2,   1}; //   2

  c_p[x_a][15] = {  0,   1}; //   2
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  7,  13}; //   2
  c_d[x_a][15] = {  0,   1}; //   2

  c_p[x_a][16] = {  0,   5}; //   2
  c_f[x_a][16] = {  5}; //   1
  c_t[x_a][16] = {  0,  14}; //   2
  c_d[x_a][16] = {  6,   1}; //   2

  c_p[x_a][17] = {  0,   7}; //   2
  c_f[x_a][17] = {  6}; //   1
  c_t[x_a][17] = {  2,  15}; //   2
  c_d[x_a][17] = {  8,   1}; //   2

  c_p[x_a][18] = {  0,   2,   9}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 16}; //   1
  c_d[x_a][18] = {  6,   2,   1}; //   3

  c_p[x_a][19] = {  0,   1,  10}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 17}; //   1
  c_d[x_a][19] = {  8,   0,   1}; //   3

  c_p[x_a][20] = { 11,  12,  13}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = { 18}; //   1
  c_d[x_a][20] = {  0,   1,   8}; //   3

  c_p[x_a][21] = { 14,  15,  16}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 19}; //   1
  c_d[x_a][21] = {  2,   1,   6}; //   3

  c_p[x_a][22] = { 11,  12}; //   2
  c_f[x_a][22] = {  6}; //   1
  c_t[x_a][22] = {  4,  20}; //   2
  c_d[x_a][22] = {  1,   8}; //   2

  c_p[x_a][23] = { 14,  15}; //   2
  c_f[x_a][23] = {  5}; //   1
  c_t[x_a][23] = {  7,  21}; //   2
  c_d[x_a][23] = {  1,   6}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv11(1, 2, 4, 16, 32, 64, 8;  23,   0,   0,   0)
// channel    1: 3yv11(1, 2, 8, 16, 32, 64, 4;  23,   0,   0,   0)
// channel    2: 4yyv1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
// channel    3: 4yyv1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
// channel    4: 42vv1(1, 2, 4, 64, 16, 32, 8;  23,   0,   0,   0)
// channel    5: 42vv1(1, 2, 8, 64, 16, 32, 4;  23,   0,   0,   0)
// channel    6: 12v11(1, 2, 4, 16, 32, 64, 8;  23,   0,   0,   0)
// channel    7: 12v11(1, 2, 8, 16, 32, 64, 4;  23,   0,   0,   0)
// channel    8: 14yyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
// channel    9: 14yyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
// channel   10: 142vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
// channel   11: 142vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   0)
// channel   12: 112v1(1, 2, 4, 64, 16, 32, 8;  23,   0,   0,   0)
// channel   13: 112v1(1, 2, 8, 64, 16, 32, 4;  23,   0,   0,   0)
// channel   14: 113yv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
// channel   15: 113yv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
// channel   16: 2v2v1(1, 2, 4, 64, 16, 32, 8;  23,   0,   0,   0)
// channel   17: 2v2v1(1, 2, 8, 64, 16, 32, 4;  23,   0,   0,   0)
// channel   18: 2v3yv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
// channel   19: 2v3yv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
// channel   20: 3yv2v(1, 2, 4, 16, 32, 8, 64;   0,  23,   0,   0)
// channel   21: 3yv2v(1, 2, 8, 16, 32, 4, 64;   0,  23,   0,   0)
// channel   22: 12v2v(1, 2, 4, 16, 32, 8, 64;   0,  23,   0,   0)
// channel   23: 12v2v(1, 2, 8, 16, 32, 4, 64;   0,  23,   0,   0)
