#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_050_bxa_emepvmvmxbx(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_050_bxa_emepvmvmxbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(27);
  needed_v_smin[x_a].resize(27);
  needed_v_smin[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   20,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51}; //  44
  needed_v_smin[x_a][  1] = {   8,    9,   10,   11,   26,   27,   48,   49}; //   8
  needed_v_smin[x_a][  2] = {  12,   13,   19,   20,   34,   35,   40,   41,   31,   38,   39}; //  11
  needed_v_smin[x_a][  3] = {  12,   13,   19,   20,    2,    3,   31,   34,   35,   38,   39,   40,   41}; //  13
  needed_v_smin[x_a][  4] = {  14,   15,   18,   21,   22,   25,   26,   27,   28,   29,   44,   45,   46,   47,   48,   49,   50,   51}; //  18
  needed_v_smin[x_a][  5] = {  14,   21}; //   2
  needed_v_smin[x_a][  6] = {  14,   21}; //   2
  needed_v_smin[x_a][  7] = {  15,   22}; //   2
  needed_v_smin[x_a][  8] = {  15,   22}; //   2
  needed_v_smin[x_a][  9] = {  16,   17,   23,   24,   32,   33,   42,   43,   30,   36,   37}; //  11
  needed_v_smin[x_a][ 10] = {  16,   17,   23,   24,    0,    1,   30,   32,   33,   36,   37,   42,   43}; //  13
  needed_v_smin[x_a][ 11] = {  18,   25,   44,   45,   46,   47}; //   6
  needed_v_smin[x_a][ 12] = {  28,   29,   50,   51}; //   4
  needed_v_smin[x_a][ 13] = {   0}; //   1
  needed_v_smin[x_a][ 14] = {   0}; //   1
  needed_v_smin[x_a][ 15] = {   1}; //   1
  needed_v_smin[x_a][ 16] = {   1}; //   1
  needed_v_smin[x_a][ 17] = {   2}; //   1
  needed_v_smin[x_a][ 18] = {   2}; //   1
  needed_v_smin[x_a][ 19] = {   3}; //   1
  needed_v_smin[x_a][ 20] = {   3}; //   1
  needed_v_smin[x_a][ 21] = {   4,    5}; //   2
  needed_v_smin[x_a][ 22] = {   4,    5}; //   2
  needed_v_smin[x_a][ 23] = {   6,    7}; //   2
  needed_v_smin[x_a][ 24] = {   6,    7}; //   2
  needed_v_smin[x_a][ 25] = {   8,    9}; //   2
  needed_v_smin[x_a][ 26] = {  10,   11}; //   2

  v_smax[x_a].resize(21);
  needed_v_smax[x_a].resize(21);
  needed_v_smax[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   20,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   48,   49}; //  38
  needed_v_smax[x_a][  1] = {   8,    9,   10,   11,   26,   27,   48,   49}; //   8
  needed_v_smax[x_a][  2] = {  12,   13,   19,   20,   34,   35,   40,   41,    2,    3,   31,   38,   39}; //  13
  needed_v_smax[x_a][  3] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,    0,    1,    2,    3,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  36
  needed_v_smax[x_a][  4] = {  14,   15,   21,   22,   28,   29,   46,   47,   50,   51}; //  10
  needed_v_smax[x_a][  5] = {  14,   21}; //   2
  needed_v_smax[x_a][  6] = {  15,   22}; //   2
  needed_v_smax[x_a][  7] = {  16,   17,   23,   24,   32,   33,   42,   43,    0,    1,   30,   36,   37}; //  13
  needed_v_smax[x_a][  8] = {  18,   25,   44,   45}; //   4
  needed_v_smax[x_a][  9] = {  26,   27,   48,   49}; //   4
  needed_v_smax[x_a][ 10] = {  28,   29,   50,   51}; //   4
  needed_v_smax[x_a][ 11] = {  28,   29,   50,   51}; //   4
  needed_v_smax[x_a][ 12] = {  46,   47}; //   2
  needed_v_smax[x_a][ 13] = {   0}; //   1
  needed_v_smax[x_a][ 14] = {   1}; //   1
  needed_v_smax[x_a][ 15] = {   2}; //   1
  needed_v_smax[x_a][ 16] = {   3}; //   1
  needed_v_smax[x_a][ 17] = {   4,    5}; //   2
  needed_v_smax[x_a][ 18] = {   4,    5,    8,    9}; //   4
  needed_v_smax[x_a][ 19] = {   6,    7}; //   2
  needed_v_smax[x_a][ 20] = {   6,    7,   10,   11}; //   4

  g_p[x_a].resize(22);
  needed_g_p[x_a].resize(22);
  needed_g_p[x_a][0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   20,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   48,   49}; //  38
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   8,    9,   10,   11,   26,   27,   48,   49}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin1_smax1");
  needed_g_p[x_a][2] = {  12,   13,   19,   20,   34,   35,   40,   41}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {  12,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  13,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][5] = {  14,   15,   21,   22,   29,   47,   51}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][6] = {  14,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {  14,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax3");
  needed_g_p[x_a][8] = {  15,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {  15,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax3");
  needed_g_p[x_a][10] = {  16,   17,   23,   24,   32,   33,   42,   43}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][11] = {  16,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax3");
  needed_g_p[x_a][12] = {  17,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax3");
  needed_g_p[x_a][13] = {  18,   25,   45}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax8");
  needed_g_p[x_a][14] = {  18,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin11_smax3");
  needed_g_p[x_a][15] = {  26,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax9");
  needed_g_p[x_a][16] = {  27,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax9");
  needed_g_p[x_a][17] = {  28,   46,   50}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][18] = {  28,   29,   50,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin12_smax10");
  needed_g_p[x_a][19] = {  28,   29,   50,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");
  needed_g_p[x_a][20] = {  44}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax8");
  needed_g_p[x_a][21] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");

  g_f[x_a].resize(19);
  needed_g_f[x_a].resize(19);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax13");
  needed_g_f[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax7");
  needed_g_f[x_a][2] = {   0,    1,   30,   32,   33,   36,   37,   42,   43}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax3");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax14");
  needed_g_f[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax7");
  needed_g_f[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax15");
  needed_g_f[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax2");
  needed_g_f[x_a][7] = {   2,    3,   31,   34,   35,   38,   39,   40,   41}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax16");
  needed_g_f[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax2");
  needed_g_f[x_a][10] = {   4,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax17");
  needed_g_f[x_a][11] = {   4,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax18");
  needed_g_f[x_a][12] = {   6,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax19");
  needed_g_f[x_a][13] = {   6,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax20");
  needed_g_f[x_a][14] = {   8,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax18");
  needed_g_f[x_a][15] = {  10,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax20");
  needed_g_f[x_a][16] = {  30,   36,   37}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][17] = {  31,   38,   39}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][18] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");

  g_t[x_a].resize(36);
  needed_g_t[x_a].resize(36);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,   33,   35,   37,   39,   41,   43}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_2__64_60");
  needed_g_t[x_a][1] = {   0,    1,   30,   32,   33,   36,   37}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__8_52");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__16_36");
  needed_g_t[x_a][3] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_81__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_81__4_32");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__32_20");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_97__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_97__4_16");
  needed_g_t[x_a][6] = {   2,    3,   31,   34,   35,   38,   39}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__4_56");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__16_40");
  needed_g_t[x_a][8] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_81__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_81__8_32");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__32_24");
  needed_g_t[x_a][10] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_97__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_97__8_16");
  needed_g_t[x_a][11] = {   4,    5,    8,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][12] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_10__48_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_10__48_68");
  needed_g_t[x_a][13] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_49__4_64");
  needed_g_t[x_a][14] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_49__4_64");
  needed_g_t[x_a][15] = {   6,    7,   10,   11}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][16] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_6__48_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_6__48_72");
  needed_g_t[x_a][17] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_49__8_64");
  needed_g_t[x_a][18] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_49__8_64");
  needed_g_t[x_a][19] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__4_112");
  needed_g_t[x_a][20] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__10_1__4_112");
  needed_g_t[x_a][21] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__8_112");
  needed_g_t[x_a][22] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__6_1__8_112");
  needed_g_t[x_a][23] = {  12,   13,   14,   15,   16,   17,   18,   44,   45,   46,   47}; //  11
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__64_60");
  needed_g_t[x_a][24] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_25__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_25__1_2__64_60");
  needed_g_t[x_a][25] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_65__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_65__4_48");
  needed_g_t[x_a][26] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_65__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_65__8_48");
  needed_g_t[x_a][27] = {  32,   34,   36,   38,   40,   42}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][28] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__4_48");
  needed_g_t[x_a][29] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__8_48");
  needed_g_t[x_a][30] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__4_56");
  needed_g_t[x_a][31] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__8_52");
  needed_g_t[x_a][32] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_66__12_48");
  needed_g_t[x_a][33] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_66__48_12");
  needed_g_t[x_a][34] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__12_112");
  needed_g_t[x_a][35] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__48_76");

  g_d[x_a].resize(16);
  needed_g_d[x_a].resize(16);
  needed_g_d[x_a][0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   20,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51}; //  44
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][1] = {   8,    9,   10,   11,   26,   27,   48,   49}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][2] = {  12,   13,   19,   20}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][3] = {  12,   13,   19,   20,   34,   35,   40,   41}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][4] = {  14,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][5] = {  14,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {  14,   15,   18,   21,   22,   25,   26,   27,   28,   29,   44,   45,   46,   47,   48,   49,   50,   51}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][7] = {  15,   22}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {  15,   22}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][9] = {  16,   17,   23,   24}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {  16,   17,   23,   24,   32,   33,   42,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][11] = {  18,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][12] = {  19,   20,   21,   22,   23,   24,   25}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][13] = {  26,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][14] = {  28,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][15] = {  28,   29,   50,   51}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(52);
  c_f[x_a].resize(52);
  c_t[x_a].resize(52);
  c_d[x_a].resize(52);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  3,   4,   2}; //   3
  c_t[x_a][1] = {  0,   1,   4,   5}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  5,   6,   7}; //   3
  c_t[x_a][2] = {  0,   6,   7,   8}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  8,   9,   7}; //   3
  c_t[x_a][3] = {  0,   6,   9,  10}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = { 10,  11}; //   2
  c_t[x_a][4] = { 11,  12,  13}; //   3
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = { 10,  11}; //   2
  c_t[x_a][5] = { 11,  12,  14}; //   3
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = { 12,  13}; //   2
  c_t[x_a][6] = { 15,  16,  17}; //   3
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = { 12,  13}; //   2
  c_t[x_a][7] = { 15,  16,  18}; //   3
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  0,   1}; //   2
  c_f[x_a][8] = { 14}; //   1
  c_t[x_a][8] = { 11,  19}; //   2
  c_d[x_a][8] = {  1,   0}; //   2

  c_p[x_a][9] = {  0,   1}; //   2
  c_f[x_a][9] = { 14}; //   1
  c_t[x_a][9] = { 11,  20}; //   2
  c_d[x_a][9] = {  1,   0}; //   2

  c_p[x_a][10] = {  0,   1}; //   2
  c_f[x_a][10] = { 15}; //   1
  c_t[x_a][10] = { 15,  21}; //   2
  c_d[x_a][10] = {  1,   0}; //   2

  c_p[x_a][11] = {  0,   1}; //   2
  c_f[x_a][11] = { 15}; //   1
  c_t[x_a][11] = { 15,  22}; //   2
  c_d[x_a][11] = {  1,   0}; //   2

  c_p[x_a][12] = {  0,   2,   3}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 23}; //   1
  c_d[x_a][12] = {  2,   3,   0}; //   3

  c_p[x_a][13] = {  0,   2,   4}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 23}; //   1
  c_d[x_a][13] = {  2,   3,   0}; //   3

  c_p[x_a][14] = {  5,   6,   7}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 23}; //   1
  c_d[x_a][14] = {  4,   5,   6}; //   3

  c_p[x_a][15] = {  5,   8,   9}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 23}; //   1
  c_d[x_a][15] = {  7,   8,   6}; //   3

  c_p[x_a][16] = {  0,  10,  11}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 23}; //   1
  c_d[x_a][16] = {  9,  10,   0}; //   3

  c_p[x_a][17] = {  0,  10,  12}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 23}; //   1
  c_d[x_a][17] = {  9,  10,   0}; //   3

  c_p[x_a][18] = {  0,  13,  14}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 23}; //   1
  c_d[x_a][18] = { 11,   6,   0}; //   3

  c_p[x_a][19] = {  0,   2,   3}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 12,   2,   3,   0}; //   4

  c_p[x_a][20] = {  0,   2,   4}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 12,   2,   3,   0}; //   4

  c_p[x_a][21] = {  5,   6,   7}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 12,   4,   5,   6}; //   4

  c_p[x_a][22] = {  5,   8,   9}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 12,   7,   8,   6}; //   4

  c_p[x_a][23] = {  0,  10,  11}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 12,   9,  10,   0}; //   4

  c_p[x_a][24] = {  0,  10,  12}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 12,   9,  10,   0}; //   4

  c_p[x_a][25] = {  0,  13,  14}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 12,  11,   6,   0}; //   4

  c_p[x_a][26] = {  0,   1,  15}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 13,   6,   1,   0}; //   4

  c_p[x_a][27] = {  0,   1,  16}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 13,   6,   1,   0}; //   4

  c_p[x_a][28] = { 17,  18,  19}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 14,   0,  15,   6}; //   4

  c_p[x_a][29] = {  5,  18,  19}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 14,   0,  15,   6}; //   4

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = { 16,   2}; //   2
  c_t[x_a][30] = { 24,   1,  25}; //   3
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  0}; //   1
  c_f[x_a][31] = { 17,   7}; //   2
  c_t[x_a][31] = { 24,   6,  26}; //   3
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  0,  10}; //   2
  c_f[x_a][32] = {  2}; //   1
  c_t[x_a][32] = { 27,   1}; //   2
  c_d[x_a][32] = { 10,   0}; //   2

  c_p[x_a][33] = {  0,  10}; //   2
  c_f[x_a][33] = {  2}; //   1
  c_t[x_a][33] = {  0,   1}; //   2
  c_d[x_a][33] = { 10,   0}; //   2

  c_p[x_a][34] = {  0,   2}; //   2
  c_f[x_a][34] = {  7}; //   1
  c_t[x_a][34] = { 27,   6}; //   2
  c_d[x_a][34] = {  3,   0}; //   2

  c_p[x_a][35] = {  0,   2}; //   2
  c_f[x_a][35] = {  7}; //   1
  c_t[x_a][35] = {  0,   6}; //   2
  c_d[x_a][35] = {  3,   0}; //   2

  c_p[x_a][36] = {  0}; //   1
  c_f[x_a][36] = { 16,   2}; //   2
  c_t[x_a][36] = { 27,   1,  28}; //   3
  c_d[x_a][36] = {  0}; //   1

  c_p[x_a][37] = {  0}; //   1
  c_f[x_a][37] = { 16,   2}; //   2
  c_t[x_a][37] = {  0,   1,  28}; //   3
  c_d[x_a][37] = {  0}; //   1

  c_p[x_a][38] = {  0}; //   1
  c_f[x_a][38] = { 17,   7}; //   2
  c_t[x_a][38] = { 27,   6,  29}; //   3
  c_d[x_a][38] = {  0}; //   1

  c_p[x_a][39] = {  0}; //   1
  c_f[x_a][39] = { 17,   7}; //   2
  c_t[x_a][39] = {  0,   6,  29}; //   3
  c_d[x_a][39] = {  0}; //   1

  c_p[x_a][40] = {  0,   2}; //   2
  c_f[x_a][40] = {  7}; //   1
  c_t[x_a][40] = { 27,  30}; //   2
  c_d[x_a][40] = {  3,   0}; //   2

  c_p[x_a][41] = {  0,   2}; //   2
  c_f[x_a][41] = {  7}; //   1
  c_t[x_a][41] = {  0,  30}; //   2
  c_d[x_a][41] = {  3,   0}; //   2

  c_p[x_a][42] = {  0,  10}; //   2
  c_f[x_a][42] = {  2}; //   1
  c_t[x_a][42] = { 27,  31}; //   2
  c_d[x_a][42] = { 10,   0}; //   2

  c_p[x_a][43] = {  0,  10}; //   2
  c_f[x_a][43] = {  2}; //   1
  c_t[x_a][43] = {  0,  31}; //   2
  c_d[x_a][43] = { 10,   0}; //   2

  c_p[x_a][44] = {  0,  20}; //   2
  c_f[x_a][44] = { 18}; //   1
  c_t[x_a][44] = { 23,  32}; //   2
  c_d[x_a][44] = {  6,   0}; //   2

  c_p[x_a][45] = {  0,  13}; //   2
  c_f[x_a][45] = { 18}; //   1
  c_t[x_a][45] = { 23,  32}; //   2
  c_d[x_a][45] = {  6,   0}; //   2

  c_p[x_a][46] = { 17,  21}; //   2
  c_f[x_a][46] = { 18}; //   1
  c_t[x_a][46] = { 23,  33}; //   2
  c_d[x_a][46] = {  0,   6}; //   2

  c_p[x_a][47] = {  5,  21}; //   2
  c_f[x_a][47] = { 18}; //   1
  c_t[x_a][47] = { 23,  33}; //   2
  c_d[x_a][47] = {  0,   6}; //   2

  c_p[x_a][48] = {  0,   1,  15}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = { 34}; //   1
  c_d[x_a][48] = {  6,   1,   0}; //   3

  c_p[x_a][49] = {  0,   1,  16}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = { 34}; //   1
  c_d[x_a][49] = {  6,   1,   0}; //   3

  c_p[x_a][50] = { 17,  18,  19}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = { 35}; //   1
  c_d[x_a][50] = {  0,  15,   6}; //   3

  c_p[x_a][51] = {  5,  18,  19}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = { 35}; //   1
  c_d[x_a][51] = {  0,  15,   6}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 11111(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,  23)
// channel    1: 11111(1, 2, 64, 32, 16, 4, 8;  23,   0,   0,  23)
// channel    2: 11111(1, 2, 64, 16, 32, 8, 4;  23,   0,   0,  23)
// channel    3: 11111(1, 2, 64, 32, 16, 8, 4;  23,   0,   0,  23)
// channel    4: 2v111(1, 2, 16, 32, 64, 4, 8;  23,   0,   5,   0)
// channel    5: 2v111(1, 2, 16, 32, 64, 4, 8;  23,   0,   5,  23)
// channel    6: 2v111(1, 2, 16, 32, 64, 8, 4;  23,   0,   5,   0)
// channel    7: 2v111(1, 2, 16, 32, 64, 8, 4;  23,   0,   5,  23)
// channel    8: 3yv11(1, 2, 64, 16, 32, 4, 8;  23,   5,   0,   0)
// channel    9: 3yv11(1, 2, 64, 16, 32, 4, 8;  23,   5,   0,  23)
// channel   10: 3yv11(1, 2, 64, 16, 32, 8, 4;  23,   5,   0,   0)
// channel   11: 3yv11(1, 2, 64, 16, 32, 8, 4;  23,   5,   0,  23)
// channel   12: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   5)
// channel   13: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   5)
// channel   14: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   5)
// channel   15: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   5)
// channel   16: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   5)
// channel   17: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   5)
// channel   18: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,  23,  25,   5)
// channel   19: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   5)
// channel   20: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   5)
// channel   21: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   5)
// channel   22: 5yyyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   5)
// channel   23: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   5)
// channel   24: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   5)
// channel   25: 5y2vv(1, 2, 64, 4, 8, 16, 32;  23,  23,  25,   5)
// channel   26: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   5,   0,   5)
// channel   27: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   5,  23,   5)
// channel   28: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   5,  23,   5)
// channel   29: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   5,  23,   5)
// channel   30: 12v11(1, 2, 64, 16, 32, 4, 8;  23,  25,   0,  23)
// channel   31: 12v11(1, 2, 64, 16, 32, 8, 4;  23,  25,   0,  23)
// channel   32: 13yv1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
// channel   33: 13yv1(1, 2, 64, 4, 16, 32, 8;  23,   0,  23,   0)
// channel   34: 13yv1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
// channel   35: 13yv1(1, 2, 64, 8, 16, 32, 4;  23,   0,  23,   0)
// channel   36: 112v1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
// channel   37: 112v1(1, 2, 64, 4, 16, 32, 8;  23,  23,   0,   0)
// channel   38: 112v1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
// channel   39: 112v1(1, 2, 64, 8, 16, 32, 4;  23,  23,   0,   0)
// channel   40: 113yv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   41: 113yv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
// channel   42: 113yv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
// channel   43: 113yv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
// channel   44: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   5,   5)
// channel   45: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   5,   5)
// channel   46: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   5,   5)
// channel   47: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   5,   5)
// channel   48: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   5,   0,   5)
// channel   49: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   5,  23,   5)
// channel   50: 2v3yv(1, 2, 16, 32, 64, 4, 8;   0,   5,  23,   5)
// channel   51: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   5,  23,   5)
