#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_050_ddx_emepvmvmxa(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_050_ddx_emepvmvmxa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(23);
  needed_v_smin[x_a].resize(23);
  needed_v_smin[x_a][  0] = {   0,    1,    4,    5,    6,    7,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  40
  needed_v_smin[x_a][  1] = {   0,    1,    6,    7,   18,   19,   22,   23}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,   22,   23}; //   4
  needed_v_smin[x_a][  3] = {   2,    3,   24,   25,   28,   29,   30,   31,   36,   37,   38,   39,   44,   45,   46,   47}; //  16
  needed_v_smin[x_a][  4] = {   2,   24}; //   2
  needed_v_smin[x_a][  5] = {   2,   24}; //   2
  needed_v_smin[x_a][  6] = {   3,   25}; //   2
  needed_v_smin[x_a][  7] = {   3,   25}; //   2
  needed_v_smin[x_a][  8] = {   4,    5,   10,   11,   20,   21,   26,   27}; //   8
  needed_v_smin[x_a][  9] = {   4,    5,   26,   27}; //   4
  needed_v_smin[x_a][ 10] = {   6,    7}; //   2
  needed_v_smin[x_a][ 11] = {   8,    9,   14,   15,   20,   21,   32,   33,   40,   41}; //  10
  needed_v_smin[x_a][ 12] = {   8,    9,   32,   33,   40,   41}; //   6
  needed_v_smin[x_a][ 13] = {   8,   12}; //   2
  needed_v_smin[x_a][ 14] = {   9,   13}; //   2
  needed_v_smin[x_a][ 15] = {  10,   11}; //   2
  needed_v_smin[x_a][ 16] = {  12,   13,   16,   17,   18,   19,   34,   35,   42,   43}; //  10
  needed_v_smin[x_a][ 17] = {  12,   13,   34,   35,   42,   43}; //   6
  needed_v_smin[x_a][ 18] = {  14,   15}; //   2
  needed_v_smin[x_a][ 19] = {  16,   17}; //   2
  needed_v_smin[x_a][ 20] = {  28,   29,   30,   31,   44,   45,   46,   47}; //   8
  needed_v_smin[x_a][ 21] = {  36,   37}; //   2
  needed_v_smin[x_a][ 22] = {  38,   39}; //   2

  v_smax[x_a].resize(23);
  needed_v_smax[x_a].resize(23);
  needed_v_smax[x_a][  0] = {   0,    1,    4,    5,    6,    7,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   36,   37,   40,   41,   42,   43,   44,   45}; //  30
  needed_v_smax[x_a][  1] = {   0,    1,    6,    7,   18,   19,   22,   23}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   44,   45,   46,   47}; //  20
  needed_v_smax[x_a][  3] = {   2,    3,   24,   25,   30,   31,   38,   39,   46,   47}; //  10
  needed_v_smax[x_a][  4] = {   2,   24}; //   2
  needed_v_smax[x_a][  5] = {   3,   25}; //   2
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11,   20,   21,   26,   27}; //   8
  needed_v_smax[x_a][  7] = {   6,    7,   14,   15}; //   4
  needed_v_smax[x_a][  8] = {   8,    9,   32,   33}; //   4
  needed_v_smax[x_a][  9] = {   8,    9,   12,   13,   32,   33,   34,   35}; //   8
  needed_v_smax[x_a][ 10] = {   8,   12}; //   2
  needed_v_smax[x_a][ 11] = {   9,   13}; //   2
  needed_v_smax[x_a][ 12] = {  10,   11,   16,   17}; //   4
  needed_v_smax[x_a][ 13] = {  12,   13,   34,   35}; //   4
  needed_v_smax[x_a][ 14] = {  14,   15,   40,   41}; //   4
  needed_v_smax[x_a][ 15] = {  16,   17,   42,   43}; //   4
  needed_v_smax[x_a][ 16] = {  18,   19}; //   2
  needed_v_smax[x_a][ 17] = {  20,   21}; //   2
  needed_v_smax[x_a][ 18] = {  28,   29,   36,   37,   44,   45}; //   6
  needed_v_smax[x_a][ 19] = {  30,   31,   38,   39,   46,   47}; //   6
  needed_v_smax[x_a][ 20] = {  32,   33,   34,   35}; //   4
  needed_v_smax[x_a][ 21] = {  40,   41,   42,   43,   38,   39}; //   6
  needed_v_smax[x_a][ 22] = {  36,   37}; //   2

  g_p[x_a].resize(37);
  needed_g_p[x_a].resize(37);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,    6,    7,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   36,   37,   40,   41,   42,   43,   44,   45}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    6,    7,   18,   19,   22,   23}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,   24,   25,   31,   39,   47}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][7] = {   3,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][9] = {   4,    5,   10,   11,   20,   21,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   5,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][13] = {   8,    9,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][14] = {   8,    9,   33}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax9");
  needed_g_p[x_a][15] = {   8,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][16] = {   9,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][17] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][18] = {  12,   13,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax13");
  needed_g_p[x_a][19] = {  12,   13,   35}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin17_smax9");
  needed_g_p[x_a][20] = {  14,   15,   40,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax14");
  needed_g_p[x_a][21] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax7");
  needed_g_p[x_a][22] = {  16,   17,   42,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax15");
  needed_g_p[x_a][23] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax12");
  needed_g_p[x_a][24] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax16");
  needed_g_p[x_a][25] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax17");
  needed_g_p[x_a][26] = {  28,   36,   44}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax18");
  needed_g_p[x_a][27] = {  29,   37,   45}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax18");
  needed_g_p[x_a][28] = {  30,   38,   46}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][29] = {  30,   31,   38,   39,   46,   47}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax19");
  needed_g_p[x_a][30] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][31] = {  32,   33,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax20");
  needed_g_p[x_a][32] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax9");
  needed_g_p[x_a][33] = {  40}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax21");
  needed_g_p[x_a][34] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax21");
  needed_g_p[x_a][35] = {  42}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax21");
  needed_g_p[x_a][36] = {  43}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin17_smax21");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  28,   29,   30,   31,   44,   45,   46,   47}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax2");
  needed_g_f[x_a][1] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax22");
  needed_g_f[x_a][2] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax21");

  g_t[x_a].resize(11);
  needed_g_t[x_a].resize(11);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,   28,   29,   30,   31}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  22,   23,   24,   25,   26,   27,   44,   45,   46,   47}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][3] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][4] = {  32,   33,   34,   35,   38,   39}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][5] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][6] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_64");
  needed_g_t[x_a][7] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][8] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][9] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][10] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");

  g_d[x_a].resize(26);
  needed_g_d[x_a].resize(26);
  needed_g_d[x_a][0] = {   0,    1,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    6,    7,   18,   19,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    4,    5,    6,    7,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   2,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   2,    3,   24,   25,   28,   29,   30,   31,   36,   37,   38,   39,   44,   45,   46,   47}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][6] = {   3,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   3,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   4,    5,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,    5,   10,   11,   20,   21,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][10] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__4_120");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__4_120");
  needed_g_d[x_a][11] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");
  needed_g_d[x_a][12] = {   8,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][13] = {   8,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][14] = {   8,    9,   32,   33,   40,   41}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__4_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__4_72");
  needed_g_d[x_a][15] = {   8,    9,   14,   15,   20,   21,   32,   33,   40,   41}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][16] = {   9,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][17] = {   9,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][18] = {  10,   11,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__8_116");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__8_116");
  needed_g_d[x_a][19] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][20] = {  12,   13,   34,   35,   42,   43}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__8_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__8_68");
  needed_g_d[x_a][21] = {  12,   13,   16,   17,   18,   19,   34,   35,   42,   43}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][22] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__72_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__72_48");
  needed_g_d[x_a][23] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__68_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__68_48");
  needed_g_d[x_a][24] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__68_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__68_56");
  needed_g_d[x_a][25] = {  20,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__72_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__72_52");

  c_p[x_a].resize(48);
  c_f[x_a].resize(48);
  c_t[x_a].resize(48);
  c_d[x_a].resize(48);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   6}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   5}; //   3

  c_p[x_a][3] = {  4,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  8,   9,   2}; //   3

  c_p[x_a][5] = {  0,   9,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   9,   2}; //   3

  c_p[x_a][6] = {  0,   1,  12}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = { 10,  11,   1,   2}; //   4

  c_p[x_a][7] = {  0,   1,  12}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 10,  11,   1,   2}; //   4

  c_p[x_a][8] = { 13,  14,  15}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 12,  13,  14,  15}; //   4

  c_p[x_a][9] = { 13,  14,  16}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 16,  17,  14,  15}; //   4

  c_p[x_a][10] = {  0,   9,  17}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 18,  19,   9,   2}; //   4

  c_p[x_a][11] = {  0,   9,  17}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 18,  19,   9,   2}; //   4

  c_p[x_a][12] = { 18,  19,  15}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 12,  13,  20,  21}; //   4

  c_p[x_a][13] = { 18,  19,  16}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 16,  17,  20,  21}; //   4

  c_p[x_a][14] = {  0,  20,  21}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 10,  22,  15,   2}; //   4

  c_p[x_a][15] = {  0,  20,  21}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 10,  22,  15,   2}; //   4

  c_p[x_a][16] = {  0,  22,  23}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 18,  23,  21,   2}; //   4

  c_p[x_a][17] = {  0,  22,  23}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 18,  23,  21,   2}; //   4

  c_p[x_a][18] = {  0,   1,  24}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 24,  21,   1,   2}; //   4

  c_p[x_a][19] = {  0,   1,  24}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 24,  21,   1,   2}; //   4

  c_p[x_a][20] = {  0,   9,  25}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 25,  15,   9,   2}; //   4

  c_p[x_a][21] = {  0,   9,  25}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 25,  15,   9,   2}; //   4

  c_p[x_a][22] = {  0,   1,   2}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  1}; //   1
  c_d[x_a][22] = {  0,   1,   2}; //   3

  c_p[x_a][23] = {  0,   1,   3}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  1}; //   1
  c_d[x_a][23] = {  0,   1,   2}; //   3

  c_p[x_a][24] = {  4,   5,   6}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  1}; //   1
  c_d[x_a][24] = {  3,   4,   5}; //   3

  c_p[x_a][25] = {  4,   7,   8}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  1}; //   1
  c_d[x_a][25] = {  6,   7,   5}; //   3

  c_p[x_a][26] = {  0,   9,  10}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  1}; //   1
  c_d[x_a][26] = {  8,   9,   2}; //   3

  c_p[x_a][27] = {  0,   9,  11}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  1}; //   1
  c_d[x_a][27] = {  8,   9,   2}; //   3

  c_p[x_a][28] = {  0,  26}; //   2
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  0,   2}; //   2
  c_d[x_a][28] = {  5,   2}; //   2

  c_p[x_a][29] = {  0,  27}; //   2
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  0,   2}; //   2
  c_d[x_a][29] = {  5,   2}; //   2

  c_p[x_a][30] = { 28,  29}; //   2
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  0,   3}; //   2
  c_d[x_a][30] = {  2,   5}; //   2

  c_p[x_a][31] = {  4,  29}; //   2
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  0,   3}; //   2
  c_d[x_a][31] = {  2,   5}; //   2

  c_p[x_a][32] = { 13,  30,  31}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  4}; //   1
  c_d[x_a][32] = {  2,  14,  15}; //   3

  c_p[x_a][33] = { 13,  14,  31}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  4}; //   1
  c_d[x_a][33] = {  2,  14,  15}; //   3

  c_p[x_a][34] = { 18,  32,  31}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  4}; //   1
  c_d[x_a][34] = {  2,  20,  21}; //   3

  c_p[x_a][35] = { 18,  19,  31}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  4}; //   1
  c_d[x_a][35] = {  2,  20,  21}; //   3

  c_p[x_a][36] = {  0,  26}; //   2
  c_f[x_a][36] = {  1}; //   1
  c_t[x_a][36] = {  5,   6}; //   2
  c_d[x_a][36] = {  5,   2}; //   2

  c_p[x_a][37] = {  0,  27}; //   2
  c_f[x_a][37] = {  1}; //   1
  c_t[x_a][37] = {  5,   6}; //   2
  c_d[x_a][37] = {  5,   2}; //   2

  c_p[x_a][38] = { 28,  29}; //   2
  c_f[x_a][38] = {  2}; //   1
  c_t[x_a][38] = {  4,   7}; //   2
  c_d[x_a][38] = {  2,   5}; //   2

  c_p[x_a][39] = {  4,  29}; //   2
  c_f[x_a][39] = {  2}; //   1
  c_t[x_a][39] = {  4,   7}; //   2
  c_d[x_a][39] = {  2,   5}; //   2

  c_p[x_a][40] = {  0,  20,  33}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  8}; //   1
  c_d[x_a][40] = { 14,  15,   2}; //   3

  c_p[x_a][41] = {  0,  20,  34}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  8}; //   1
  c_d[x_a][41] = { 14,  15,   2}; //   3

  c_p[x_a][42] = {  0,  22,  35}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  8}; //   1
  c_d[x_a][42] = { 20,  21,   2}; //   3

  c_p[x_a][43] = {  0,  22,  36}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  8}; //   1
  c_d[x_a][43] = { 20,  21,   2}; //   3

  c_p[x_a][44] = {  0,  26}; //   2
  c_f[x_a][44] = {  0}; //   1
  c_t[x_a][44] = {  1,   9}; //   2
  c_d[x_a][44] = {  5,   2}; //   2

  c_p[x_a][45] = {  0,  27}; //   2
  c_f[x_a][45] = {  0}; //   1
  c_t[x_a][45] = {  1,   9}; //   2
  c_d[x_a][45] = {  5,   2}; //   2

  c_p[x_a][46] = { 28,  29}; //   2
  c_f[x_a][46] = {  0}; //   1
  c_t[x_a][46] = {  1,  10}; //   2
  c_d[x_a][46] = {  2,   5}; //   2

  c_p[x_a][47] = {  4,  29}; //   2
  c_f[x_a][47] = {  0}; //   1
  c_t[x_a][47] = {  1,  10}; //   2
  c_d[x_a][47] = {  2,   5}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
// channel    1: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   0)
// channel    2: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   0)
// channel    3: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   0)
// channel    4: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   0)
// channel    5: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   0)
// channel    6: 5yyyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
// channel    7: 5yyyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,  23)
// channel    8: 5yyyv(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,  23)
// channel    9: 5yyyv(1, 2, 32, 16, 4, 8, 64;   0,  23,   0,  23)
// channel   10: 5yyyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
// channel   11: 5yyyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,  23)
// channel   12: 5yyyv(1, 2, 16, 32, 8, 4, 64;   0,  23,   0,  23)
// channel   13: 5yyyv(1, 2, 32, 16, 8, 4, 64;   0,  23,   0,  23)
// channel   14: 5y2vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
// channel   15: 5y2vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,  23)
// channel   16: 5y2vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   0)
// channel   17: 5y2vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,  23)
// channel   18: 52vyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
// channel   19: 52vyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,  23)
// channel   20: 52vyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
// channel   21: 52vyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,  23)
// channel   22: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   23: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
// channel   24: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   0)
// channel   25: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   0)
// channel   26: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
// channel   27: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
// channel   28: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
// channel   29: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,   0)
// channel   30: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,   0)
// channel   31: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   0,   0)
// channel   32: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,   0,  23,   0)
// channel   33: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,  23,  23,   0)
// channel   34: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,   0,  23,   0)
// channel   35: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,  23,  23,   0)
// channel   36: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
// channel   37: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,  23,   0,   0)
// channel   38: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,  23,   0,   0)
// channel   39: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,  23,   0,   0)
// channel   40: 3yv2v(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
// channel   41: 3yv2v(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   0)
// channel   42: 3yv2v(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   0)
// channel   43: 3yv2v(1, 2, 8, 4, 64, 16, 32;  23,   0,  23,   0)
// channel   44: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   45: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   0,   0)
// channel   46: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   0,   0)
// channel   47: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   0,   0)
