#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_140_ddx_emepvmvmxg(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_140_ddx_emepvmvmxg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(13);
  needed_v_smin[x_a].resize(13);
  needed_v_smin[x_a][  0] = {   0,    1,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  20
  needed_v_smin[x_a][  1] = {   0,    1,    6,    7}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,    6,    7}; //   4
  needed_v_smin[x_a][  3] = {   2,    3,    8,    9,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  16
  needed_v_smin[x_a][  4] = {   2,    8}; //   2
  needed_v_smin[x_a][  5] = {   2,    8}; //   2
  needed_v_smin[x_a][  6] = {   3,    9}; //   2
  needed_v_smin[x_a][  7] = {   3,    9}; //   2
  needed_v_smin[x_a][  8] = {   4,    5,   10,   11}; //   4
  needed_v_smin[x_a][  9] = {   4,    5,   10,   11}; //   4
  needed_v_smin[x_a][ 10] = {  12,   13,   14,   15,   20,   21,   22,   23}; //   8
  needed_v_smin[x_a][ 11] = {  16,   17}; //   2
  needed_v_smin[x_a][ 12] = {  18,   19}; //   2

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   0,    1,    4,    5,    6,    7,   10,   11,   12,   13,   16,   17,   20,   21}; //  14
  needed_v_smax[x_a][  1] = {   0,    1,    6,    7}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  20
  needed_v_smax[x_a][  3] = {   2,    3,    8,    9,   14,   15,   18,   19,   22,   23}; //  10
  needed_v_smax[x_a][  4] = {   2,    8}; //   2
  needed_v_smax[x_a][  5] = {   3,    9}; //   2
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11}; //   4
  needed_v_smax[x_a][  7] = {  12,   13,   16,   17,   20,   21}; //   6
  needed_v_smax[x_a][  8] = {  14,   15,   18,   19,   22,   23}; //   6
  needed_v_smax[x_a][  9] = {  16,   17}; //   2
  needed_v_smax[x_a][ 10] = {  18,   19}; //   2

  g_p[x_a].resize(16);
  needed_g_p[x_a].resize(16);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,    6,    7,   10,   11,   12,   13,   16,   17,   20,   21}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    6,    7}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    8,    9,   15,   19,   23}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][7] = {   3,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][9] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   5,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {  12,   16,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax7");
  needed_g_p[x_a][13] = {  13,   17,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax7");
  needed_g_p[x_a][14] = {  14,   18,   22}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][15] = {  14,   15,   18,   19,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  12,   13,   14,   15,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");
  needed_g_f[x_a][1] = {  16,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax9");
  needed_g_f[x_a][2] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax10");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   6,    7,    8,    9,   10,   11,   20,   21,   22,   23}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][3] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][4] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][5] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_64");
  needed_g_t[x_a][6] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][7] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][8] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][9] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   0,    1,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   2,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   2,    3,    8,    9,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][6] = {   3,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   3,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   6}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   5}; //   3

  c_p[x_a][3] = {  4,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  8,   9,   2}; //   3

  c_p[x_a][5] = {  0,   9,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   9,   2}; //   3

  c_p[x_a][6] = {  0,   1,   2}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  1}; //   1
  c_d[x_a][6] = {  0,   1,   2}; //   3

  c_p[x_a][7] = {  0,   1,   3}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  1}; //   1
  c_d[x_a][7] = {  0,   1,   2}; //   3

  c_p[x_a][8] = {  4,   5,   6}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  1}; //   1
  c_d[x_a][8] = {  3,   4,   5}; //   3

  c_p[x_a][9] = {  4,   7,   8}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  1}; //   1
  c_d[x_a][9] = {  6,   7,   5}; //   3

  c_p[x_a][10] = {  0,   9,  10}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  1}; //   1
  c_d[x_a][10] = {  8,   9,   2}; //   3

  c_p[x_a][11] = {  0,   9,  11}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  1}; //   1
  c_d[x_a][11] = {  8,   9,   2}; //   3

  c_p[x_a][12] = {  0,  12}; //   2
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   2}; //   2
  c_d[x_a][12] = {  5,   2}; //   2

  c_p[x_a][13] = {  0,  13}; //   2
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   2}; //   2
  c_d[x_a][13] = {  5,   2}; //   2

  c_p[x_a][14] = { 14,  15}; //   2
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  0,   3}; //   2
  c_d[x_a][14] = {  2,   5}; //   2

  c_p[x_a][15] = {  4,  15}; //   2
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  0,   3}; //   2
  c_d[x_a][15] = {  2,   5}; //   2

  c_p[x_a][16] = {  0,  12}; //   2
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  4,   5}; //   2
  c_d[x_a][16] = {  5,   2}; //   2

  c_p[x_a][17] = {  0,  13}; //   2
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  4,   5}; //   2
  c_d[x_a][17] = {  5,   2}; //   2

  c_p[x_a][18] = { 14,  15}; //   2
  c_f[x_a][18] = {  2}; //   1
  c_t[x_a][18] = {  6,   7}; //   2
  c_d[x_a][18] = {  2,   5}; //   2

  c_p[x_a][19] = {  4,  15}; //   2
  c_f[x_a][19] = {  2}; //   1
  c_t[x_a][19] = {  6,   7}; //   2
  c_d[x_a][19] = {  2,   5}; //   2

  c_p[x_a][20] = {  0,  12}; //   2
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  1,   8}; //   2
  c_d[x_a][20] = {  5,   2}; //   2

  c_p[x_a][21] = {  0,  13}; //   2
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  1,   8}; //   2
  c_d[x_a][21] = {  5,   2}; //   2

  c_p[x_a][22] = { 14,  15}; //   2
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  1,   9}; //   2
  c_d[x_a][22] = {  2,   5}; //   2

  c_p[x_a][23] = {  4,  15}; //   2
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  1,   9}; //   2
  c_d[x_a][23] = {  2,   5}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
// channel    1: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   0)
// channel    2: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   0)
// channel    3: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   0)
// channel    4: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   0)
// channel    5: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   0)
// channel    6: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel    7: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
// channel    8: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   0)
// channel    9: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   0)
// channel   10: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
// channel   11: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
// channel   12: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
// channel   13: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,   0)
// channel   14: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,   0)
// channel   15: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   0,   0)
// channel   16: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
// channel   17: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,  23,   0,   0)
// channel   18: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,  23,   0,   0)
// channel   19: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,  23,   0,   0)
// channel   20: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   21: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   0,   0)
// channel   22: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   0,   0)
// channel   23: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   0,   0)
void ppeexnmnmx04_phasespace_set::ax_psp_340_ddx_emepvmvmxg(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_340_ddx_emepvmvmxg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(13);
  needed_v_smin[x_a].resize(13);
  int needed_v_smin_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  31
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 31);
  int needed_v_smin_1[] = {   0,    1}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    1}; //   2
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   2,    3,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  29
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 29);
  int needed_v_smin_4[] = {   2}; //   1
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 1);
  int needed_v_smin_5[] = {   2}; //   1
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 1);
  int needed_v_smin_6[] = {   3}; //   1
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 1);
  int needed_v_smin_7[] = {   3}; //   1
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 1);
  int needed_v_smin_8[] = {   4,    5}; //   2
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   4,    5}; //   2
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   6,    7,    8,    9,   10,   11,   12}; //   7
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 7);
  int needed_v_smin_11[] = {  13,   14,   15,   16,   17,   18,   25,   26,   31,   32}; //  10
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 10);
  int needed_v_smin_12[] = {  19,   20,   21,   22,   23,   24,   27,   28,   29,   30}; //  10
  needed_v_smin[x_a][ 12] = get_vector_from_array_int(needed_v_smin_12, 10);

  v_smax[x_a].resize(15);
  needed_v_smax[x_a].resize(15);
  int needed_v_smax_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   25,   26,   29,   30}; //  21
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 21);
  int needed_v_smax_1[] = {   0,    1}; //   2
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12}; //  13
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 13);
  int needed_v_smax_3[] = {   2,    3,   19,   20,   21,   22,   23,   24,   27,   28,   31,   32}; //  12
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 12);
  int needed_v_smax_4[] = {   2}; //   1
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 1);
  int needed_v_smax_5[] = {   3}; //   1
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 1);
  int needed_v_smax_6[] = {   4,    5}; //   2
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 2);
  int needed_v_smax_7[] = {   6,    7,    8,    9,   10,   11,   12,   29,   30}; //   9
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 9);
  int needed_v_smax_8[] = {  13,   14,   15,   16,   17,   18,   25,   26}; //   8
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 8);
  int needed_v_smax_9[] = {  13,   14,   15,   16,   17,   18,   25,   26}; //   8
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 8);
  int needed_v_smax_10[] = {  19,   20,   21,   22,   23,   24,   27,   28}; //   8
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 8);
  int needed_v_smax_11[] = {  19,   20,   21,   22,   23,   24,   27,   28}; //   8
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 8);
  int needed_v_smax_12[] = {  29,   30}; //   2
  needed_v_smax[x_a][ 12] = get_vector_from_array_int(needed_v_smax_12, 2);
  int needed_v_smax_13[] = {  31,   32}; //   2
  needed_v_smax[x_a][ 13] = get_vector_from_array_int(needed_v_smax_13, 2);
  int needed_v_smax_14[] = {  31,   32}; //   2
  needed_v_smax[x_a][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);

  g_p[x_a].resize(31);
  needed_g_p[x_a].resize(31);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   25,   26,   29,   30}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,   22,   23,   24,   28,   32}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][9] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,    8,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax7");
  needed_g_p[x_a][13] = {   6,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin10_smax2");
  needed_g_p[x_a][15] = {   8,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin10_smax2");
  needed_g_p[x_a][16] = {   9,   10,   11,   12,   30}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax7");
  needed_g_p[x_a][17] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][18] = {  13,   14,   25,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][19] = {  13,   15,   17,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax9");
  needed_g_p[x_a][20] = {  14,   16,   18,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax9");
  needed_g_p[x_a][21] = {  15,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin11_smax8");
  needed_g_p[x_a][22] = {  17,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin11_smax8");
  needed_g_p[x_a][23] = {  19,   20,   21,   27,   31}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][24] = {  19,   22,   27,   28}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][25] = {  19,   20,   21,   22,   23,   24,   27,   28}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");
  needed_g_p[x_a][26] = {  20,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin12_smax10");
  needed_g_p[x_a][27] = {  21,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin12_smax10");
  needed_g_p[x_a][28] = {  29,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax12");
  needed_g_p[x_a][29] = {  31,   32}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax13");
  needed_g_p[x_a][30] = {  31,   32}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax14");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {  25,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][1] = {  27,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][2] = {  29,   30}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][3] = {  31,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");

  g_d[x_a].resize(16);
  needed_g_d[x_a].resize(16);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12}; //  13
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][3] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  31
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {   2,    3,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  29
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][9] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][11] = {   6,    7,    8,    9,   10,   11,   12}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][12] = {  13,   14,   15,   16,   17,   18}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][13] = {  13,   14,   15,   16,   17,   18,   25,   26,   31,   32}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][14] = {  19,   20,   21,   22,   23,   24}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][15] = {  19,   20,   21,   22,   23,   24,   27,   28,   29,   30}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(33);
  c_f[x_a].resize(33);
  c_t[x_a].resize(33);
  c_d[x_a].resize(33);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  4,   5,   6}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   4,   5,   6}; //   4

  c_p[x_a][3] = {  4,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   7,   8,   6}; //   4

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   9,  10,   3}; //   4

  c_p[x_a][5] = {  0,   9,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   9,  10,   3}; //   4

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,  11,   6,   3}; //   4

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,  11,   6,   3}; //   4

  c_p[x_a][8] = {  0,  12,  15}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,  11,   6,   3}; //   4

  c_p[x_a][9] = {  0,  16,  17}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,  11,   6,   3}; //   4

  c_p[x_a][10] = {  0,  16,  13}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,  11,   6,   3}; //   4

  c_p[x_a][11] = {  0,  16,  14}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,  11,   6,   3}; //   4

  c_p[x_a][12] = {  0,  16,  15}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,  11,   6,   3}; //   4

  c_p[x_a][13] = {  0,  18,  19}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 12,   6,  13,   3}; //   4

  c_p[x_a][14] = {  0,  18,  20}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 12,   6,  13,   3}; //   4

  c_p[x_a][15] = {  0,  21,  19}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 12,   6,  13,   3}; //   4

  c_p[x_a][16] = {  0,  21,  20}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 12,   6,  13,   3}; //   4

  c_p[x_a][17] = {  0,  22,  19}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 12,   6,  13,   3}; //   4

  c_p[x_a][18] = {  0,  22,  20}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 12,   6,  13,   3}; //   4

  c_p[x_a][19] = { 23,  24,  25}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 14,   3,  15,   6}; //   4

  c_p[x_a][20] = { 23,  26,  25}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 14,   3,  15,   6}; //   4

  c_p[x_a][21] = { 23,  27,  25}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 14,   3,  15,   6}; //   4

  c_p[x_a][22] = {  4,  24,  25}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 14,   3,  15,   6}; //   4

  c_p[x_a][23] = {  4,  26,  25}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 14,   3,  15,   6}; //   4

  c_p[x_a][24] = {  4,  27,  25}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 14,   3,  15,   6}; //   4

  c_p[x_a][25] = {  0,  18,  19}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  6,  13,   3}; //   3

  c_p[x_a][26] = {  0,  18,  20}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  6,  13,   3}; //   3

  c_p[x_a][27] = { 23,  24,  25}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  1}; //   1
  c_d[x_a][27] = {  3,  15,   6}; //   3

  c_p[x_a][28] = {  4,  24,  25}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  1}; //   1
  c_d[x_a][28] = {  3,  15,   6}; //   3

  c_p[x_a][29] = {  0,  12,  28}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  2}; //   1
  c_d[x_a][29] = { 15,   6,   3}; //   3

  c_p[x_a][30] = {  0,  16,  28}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  2}; //   1
  c_d[x_a][30] = { 15,   6,   3}; //   3

  c_p[x_a][31] = { 23,  29,  30}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  3}; //   1
  c_d[x_a][31] = { 13,   3,   6}; //   3

  c_p[x_a][32] = {  4,  29,  30}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  3}; //   1
  c_d[x_a][32] = { 13,   3,   6}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
