#include "header.hpp"

#include "ppemexmx04.phasespace.set.hpp"

void ppemexmx04_phasespace_set::ac_psp_240_gg_emmumepmup(int x_a, int channel){
  static Logger logger("ppemexmx04_phasespace_set::ac_psp_240_gg_emmumepmup");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][40];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  0] = smin_opt[x_a][40];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_propagator(x_a,  23,  40, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,  23,  20, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  5], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][40], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  3], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][40], 2);
      c_propagator(x_a,  23,  20, v_smin[x_a][  3], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][  0] = smin_opt[x_a][40];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][20], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  0], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][  0] = smin_opt[x_a][40];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][20], 2);
      c_propagator(x_a,  23,  40, v_smin[x_a][  0], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 11));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  20,  40, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,  36,  60,   1,   2,  20,  40, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  40,  20, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,  36,  60,   1,   2,  40,  20, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  60,   4,  56, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  56,  16,  40, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  40,   8,  32, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  44,   4,  40, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  60,   8,  52, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  52,  32,  20, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  20,   4,  16, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  60,  32,  28, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a,  28,   8,  20, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  60,  20,  40, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
  }

  /*
  if      (channel ==    0){ac_channel_4yyv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    1){ac_channel_4yyv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  else if (channel ==    2){ac_channel_4yyv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==    3){ac_channel_4yyv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  else if (channel ==    4){ac_channel_4yyv(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    5){ac_channel_4yyv(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  else if (channel ==    6){ac_channel_4yyv(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==    7){ac_channel_4yyv(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  else if (channel ==    8){ac_channel_4yyv(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    9){ac_channel_4yyv(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  else if (channel ==   10){ac_channel_4yyv(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   11){ac_channel_4yyv(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  else if (channel ==   12){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   13){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  else if (channel ==   14){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   15){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  else if (channel ==   16){ac_channel_42vv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   17){ac_channel_42vv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==   18){ac_channel_42vv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   19){ac_channel_42vv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  else if (channel ==   20){ac_channel_42vv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   21){ac_channel_42vv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36, psi);}
  else if (channel ==   22){ac_channel_42vv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25, psi);}
  else if (channel ==   23){ac_channel_42vv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0, psi);}
  else if (channel ==   24){ac_channel_42vv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36, psi);}
  else if (channel ==   25){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   26){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==   27){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   28){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  else if (channel ==   29){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   30){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36, psi);}
  else if (channel ==   31){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0, psi);}
  else if (channel ==   32){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36, psi);}
  else if (channel ==   33){ac_channel_2v2v(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   34){ac_channel_2v2v(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  else if (channel ==   35){ac_channel_2v2v(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  else if (channel ==   36){ac_channel_2v2v(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  else if (channel ==   37){ac_channel_2v2v(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  else if (channel ==   38){ac_channel_2v2v(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36, psi);}
  else if (channel ==   39){ac_channel_2v2v(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0, psi);}
  else if (channel ==   40){ac_channel_2v2v(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36, psi);}
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
