#include "header.hpp"

#include "ppemexmx04.phasespace.set.hpp"

void ppemexmx04_phasespace_set::ac_psp_050_bxa_emmumepmupbx(int x_a, int channel){
  static Logger logger("ppemexmx04_phasespace_set::ac_psp_050_bxa_emmumepmupbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][20];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][104], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  0] = smin_opt[x_a][20];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][104], 2);
      c_propagator(x_a,  23,  20, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  1] = smin_opt[x_a][40];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][84], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  1] = smin_opt[x_a][40];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][84], 2);
      c_propagator(x_a,  23,  40, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][84]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,   0,  84, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][104]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_propagator(x_a,   0, 104, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][  5], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  5], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  6], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 11));
    }
    else if (c_p[x_a][channel][i_p] ==  12){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][52]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][  8], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 12));
    }
    else if (c_p[x_a][channel][i_p] ==  13){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][  9], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 13));
    }
    else if (c_p[x_a][channel][i_p] ==  14){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  9], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 14));
    }
    else if (c_p[x_a][channel][i_p] ==  15){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][96], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][ 10], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 15));
    }
    else if (c_p[x_a][channel][i_p] ==  16){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 11], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 16));
    }
    else if (c_p[x_a][channel][i_p] ==  17){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][ 11], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 17));
    }
    else if (c_p[x_a][channel][i_p] ==  18){
      v_smin[x_a][  0] = smin_opt[x_a][20];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][104], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  0], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 18));
    }
    else if (c_p[x_a][channel][i_p] ==  19){
      v_smin[x_a][  0] = smin_opt[x_a][20];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][104], 2);
      c_propagator(x_a,  23,  20, v_smin[x_a][  0], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 19));
    }
    else if (c_p[x_a][channel][i_p] ==  20){
      v_smin[x_a][  1] = smin_opt[x_a][40];
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][84], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  1], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 20));
    }
    else if (c_p[x_a][channel][i_p] ==  21){
      v_smin[x_a][  1] = smin_opt[x_a][40];
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][84], 2);
      c_propagator(x_a,  23,  40, v_smin[x_a][  1], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 21));
    }
    else if (c_p[x_a][channel][i_p] ==  22){
      v_smin[x_a][  0] = smin_opt[x_a][20];
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][104]), 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  0], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 22));
    }
    else if (c_p[x_a][channel][i_p] ==  23){
      v_smin[x_a][  0] = smin_opt[x_a][20];
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][104]), 2);
      c_propagator(x_a,  23,  20, v_smin[x_a][  0], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 23));
    }
    else if (c_p[x_a][channel][i_p] ==  24){
      v_smin[x_a][  1] = smin_opt[x_a][40];
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][20], sqrtsmin_opt[x_a][84]), 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  1], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 24));
    }
    else if (c_p[x_a][channel][i_p] ==  25){
      v_smin[x_a][  1] = smin_opt[x_a][40];
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][20], sqrtsmin_opt[x_a][84]), 2);
      c_propagator(x_a,  23,  40, v_smin[x_a][  1], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 25));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][ 12] = smin_opt[x_a][24];
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][100], 2);
      c_timelikeinvariant(x_a,  24, v_smin[x_a][ 12], v_smax[x_a][ 13], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][96], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][ 13], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][ 11], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][ 14] = smin_opt[x_a][48];
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][76], 2);
      c_timelikeinvariant(x_a,  48, v_smin[x_a][ 14], v_smax[x_a][ 14], random_manager.get_random(x_a, 1, 3));
    }
    else if (c_f[x_a][channel][i_f] ==   4){
      v_smin[x_a][ 15] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][ 15], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 4));
    }
    else if (c_f[x_a][channel][i_f] ==   5){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][  9], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 5));
    }
    else if (c_f[x_a][channel][i_f] ==   6){
      v_smin[x_a][ 16] = smin_opt[x_a][12];
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][112], 2);
      c_timelikeinvariant(x_a,  12, v_smin[x_a][ 16], v_smax[x_a][ 15], random_manager.get_random(x_a, 1, 6));
    }
    else if (c_f[x_a][channel][i_f] ==   7){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][96], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][ 17], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 7));
    }
    else if (c_f[x_a][channel][i_f] ==   8){
      v_smin[x_a][ 18] = smin_opt[x_a][36];
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][88], 2);
      c_timelikeinvariant(x_a,  36, v_smin[x_a][ 18], v_smax[x_a][ 16], random_manager.get_random(x_a, 1, 8));
    }
    else if (c_f[x_a][channel][i_f] ==   9){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][ 19], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 9));
    }
    else if (c_f[x_a][channel][i_f] ==  10){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][ 20], v_smax[x_a][  6], random_manager.get_random(x_a, 1, 10));
    }
    else if (c_f[x_a][channel][i_f] ==  11){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 11));
    }
    else if (c_f[x_a][channel][i_f] ==  12){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][ 21], v_smax[x_a][  6], random_manager.get_random(x_a, 1, 12));
    }
    else if (c_f[x_a][channel][i_f] ==  13){
      v_smin[x_a][ 22] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][ 22], v_smax[x_a][  4], random_manager.get_random(x_a, 1, 13));
    }
    else if (c_f[x_a][channel][i_f] ==  14){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][  5], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 14));
    }
    else if (c_f[x_a][channel][i_f] ==  15){
      v_smin[x_a][ 23] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][56]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][ 23], v_smax[x_a][  4], random_manager.get_random(x_a, 1, 15));
    }
    else if (c_f[x_a][channel][i_f] ==  16){
      v_smin[x_a][ 24] = smin_opt[x_a][72];
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][20], sqrtsmin_opt[x_a][52]), 2);
      c_timelikeinvariant(x_a,  72, v_smin[x_a][ 24], v_smax[x_a][ 17], random_manager.get_random(x_a, 1, 16));
    }
    else if (c_f[x_a][channel][i_f] ==  17){
      v_smin[x_a][ 25] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][20] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  92, v_smin[x_a][ 25], v_smax[x_a][ 18], random_manager.get_random(x_a, 1, 17));
    }
    else if (c_f[x_a][channel][i_f] ==  18){
      v_smin[x_a][ 26] = smin_opt[x_a][96];
      v_smax[x_a][ 19] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], sqrtsmin_opt[x_a][28]), 2);
      c_timelikeinvariant(x_a,  96, v_smin[x_a][ 26], v_smax[x_a][ 19], random_manager.get_random(x_a, 1, 18));
    }
    else if (c_f[x_a][channel][i_f] ==  19){
      v_smin[x_a][ 27] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][20] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 20] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 27], v_smax[x_a][ 20], random_manager.get_random(x_a, 1, 19));
    }
    else if (c_f[x_a][channel][i_f] ==  20){
      v_smin[x_a][ 28] = smin_opt[x_a][68];
      v_smax[x_a][ 21] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][56]), 2);
      c_timelikeinvariant(x_a,  68, v_smin[x_a][ 28], v_smax[x_a][ 21], random_manager.get_random(x_a, 1, 20));
    }
    else if (c_f[x_a][channel][i_f] ==  21){
      v_smin[x_a][ 29] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][40] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 22] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 29], v_smax[x_a][ 22], random_manager.get_random(x_a, 1, 21));
    }
    else if (c_f[x_a][channel][i_f] ==  22){
      v_smin[x_a][ 30] = smin_opt[x_a][80];
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][44]), 2);
      c_timelikeinvariant(x_a,  80, v_smin[x_a][ 30], v_smax[x_a][ 23], random_manager.get_random(x_a, 1, 22));
    }
    else if (c_f[x_a][channel][i_f] ==  23){
      v_smin[x_a][ 31] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][40] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 31], v_smax[x_a][ 24], random_manager.get_random(x_a, 1, 23));
    }
    else if (c_f[x_a][channel][i_f] ==  24){
      v_smin[x_a][ 32] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][84], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  92, v_smin[x_a][ 32], v_smax[x_a][ 18], random_manager.get_random(x_a, 1, 24));
    }
    else if (c_f[x_a][channel][i_f] ==  25){
      v_smin[x_a][ 33] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][84], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 20] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 33], v_smax[x_a][ 20], random_manager.get_random(x_a, 1, 25));
    }
    else if (c_f[x_a][channel][i_f] ==  26){
      v_smin[x_a][ 34] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][104], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 22] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 34], v_smax[x_a][ 22], random_manager.get_random(x_a, 1, 26));
    }
    else if (c_f[x_a][channel][i_f] ==  27){
      v_smin[x_a][ 35] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][104], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 35], v_smax[x_a][ 24], random_manager.get_random(x_a, 1, 27));
    }
    else if (c_f[x_a][channel][i_f] ==  28){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][  6], v_smax[x_a][  6], random_manager.get_random(x_a, 1, 28));
    }
    else if (c_f[x_a][channel][i_f] ==  29){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][52]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][  8], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 29));
    }
    else if (c_f[x_a][channel][i_f] ==  30){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][96], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][ 10], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 30));
    }
    else if (c_f[x_a][channel][i_f] ==  31){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 1, 31));
    }
    else if (c_f[x_a][channel][i_f] ==  32){
      v_smin[x_a][ 36] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][20] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][60]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][ 36], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 32));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  64,  60, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0,  60,   2,  65,  32,  28, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel(x_a,   0,  28,  65,  34,   4,  24, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel(x_a,   0,  24,  34,  69,   8,  16, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel(x_a,  23,  24,  34,  69,   8,  16, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel_opt(x_a,  23, 124,   1,   2,  64,  60, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel_opt(x_a,   0,  60,   2,  65,   8,  52, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel(x_a,   0,  52,  65,  10,   4,  48, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel(x_a,   0,  48,  10,  69,  32,  16, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel(x_a,  23,  48,  10,  69,  32,  16, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel(x_a,   0,  28,  65,  34,  16,  12, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel(x_a,   0,  12,  34,  81,   8,   4, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel(x_a,  23,  12,  34,  81,   8,   4, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
    else if (c_t[x_a][channel][i_t] ==  13){
      c_tchannel(x_a,   0,  52,  65,  10,  16,  36, random_manager.get_random(x_a, 2, 13), random_manager.get_random(x_a, 3, 13));
    }
    else if (c_t[x_a][channel][i_t] ==  14){
      c_tchannel(x_a,   0,  36,  10,  81,  32,   4, random_manager.get_random(x_a, 2, 14), random_manager.get_random(x_a, 3, 14));
    }
    else if (c_t[x_a][channel][i_t] ==  15){
      c_tchannel(x_a,  23,  36,  10,  81,  32,   4, random_manager.get_random(x_a, 2, 15), random_manager.get_random(x_a, 3, 15));
    }
    else if (c_t[x_a][channel][i_t] ==  16){
      c_tchannel_opt(x_a,   0,  60,   2,  65,  16,  44, random_manager.get_random(x_a, 2, 16), random_manager.get_random(x_a, 3, 16));
    }
    else if (c_t[x_a][channel][i_t] ==  17){
      c_tchannel(x_a,   0,  44,  65,  18,   8,  36, random_manager.get_random(x_a, 2, 17), random_manager.get_random(x_a, 3, 17));
    }
    else if (c_t[x_a][channel][i_t] ==  18){
      c_tchannel(x_a,   0,  36,  18,  73,   4,  32, random_manager.get_random(x_a, 2, 18), random_manager.get_random(x_a, 3, 18));
    }
    else if (c_t[x_a][channel][i_t] ==  19){
      c_tchannel(x_a,  23,  36,  18,  73,   4,  32, random_manager.get_random(x_a, 2, 19), random_manager.get_random(x_a, 3, 19));
    }
    else if (c_t[x_a][channel][i_t] ==  20){
      c_tchannel(x_a,   0,  44,  65,  18,  32,  12, random_manager.get_random(x_a, 2, 20), random_manager.get_random(x_a, 3, 20));
    }
    else if (c_t[x_a][channel][i_t] ==  21){
      c_tchannel(x_a,   0,  12,  18,  97,   4,   8, random_manager.get_random(x_a, 2, 21), random_manager.get_random(x_a, 3, 21));
    }
    else if (c_t[x_a][channel][i_t] ==  22){
      c_tchannel(x_a,  23,  12,  18,  97,   4,   8, random_manager.get_random(x_a, 2, 22), random_manager.get_random(x_a, 3, 22));
    }
    else if (c_t[x_a][channel][i_t] ==  23){
      c_tchannel_opt(x_a,   0,  60,   2,  65,   4,  56, random_manager.get_random(x_a, 2, 23), random_manager.get_random(x_a, 3, 23));
    }
    else if (c_t[x_a][channel][i_t] ==  24){
      c_tchannel(x_a,   0,  56,  65,   6,   8,  48, random_manager.get_random(x_a, 2, 24), random_manager.get_random(x_a, 3, 24));
    }
    else if (c_t[x_a][channel][i_t] ==  25){
      c_tchannel(x_a,   0,  48,   6,  73,  16,  32, random_manager.get_random(x_a, 2, 25), random_manager.get_random(x_a, 3, 25));
    }
    else if (c_t[x_a][channel][i_t] ==  26){
      c_tchannel(x_a,  23,  48,   6,  73,  16,  32, random_manager.get_random(x_a, 2, 26), random_manager.get_random(x_a, 3, 26));
    }
    else if (c_t[x_a][channel][i_t] ==  27){
      c_tchannel(x_a,   0,  56,  65,   6,  32,  24, random_manager.get_random(x_a, 2, 27), random_manager.get_random(x_a, 3, 27));
    }
    else if (c_t[x_a][channel][i_t] ==  28){
      c_tchannel(x_a,   0,  24,   6,  97,  16,   8, random_manager.get_random(x_a, 2, 28), random_manager.get_random(x_a, 3, 28));
    }
    else if (c_t[x_a][channel][i_t] ==  29){
      c_tchannel(x_a,  23,  24,   6,  97,  16,   8, random_manager.get_random(x_a, 2, 29), random_manager.get_random(x_a, 3, 29));
    }
    else if (c_t[x_a][channel][i_t] ==  30){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  32,  92, random_manager.get_random(x_a, 2, 30), random_manager.get_random(x_a, 3, 30));
    }
    else if (c_t[x_a][channel][i_t] ==  31){
      c_tchannel_opt(x_a,   0,  92,   1,  34,  20,  72, random_manager.get_random(x_a, 2, 31), random_manager.get_random(x_a, 3, 31));
    }
    else if (c_t[x_a][channel][i_t] ==  32){
      c_tchannel(x_a,   0,  72,  34,  21,   8,  64, random_manager.get_random(x_a, 2, 32), random_manager.get_random(x_a, 3, 32));
    }
    else if (c_t[x_a][channel][i_t] ==  33){
      c_tchannel(x_a,  23,  72,  34,  21,   8,  64, random_manager.get_random(x_a, 2, 33), random_manager.get_random(x_a, 3, 33));
    }
    else if (c_t[x_a][channel][i_t] ==  34){
      c_tchannel_opt(x_a,   0, 124,   2,   1,   8, 116, random_manager.get_random(x_a, 2, 34), random_manager.get_random(x_a, 3, 34));
    }
    else if (c_t[x_a][channel][i_t] ==  35){
      c_tchannel_opt(x_a,   0, 116,   1,  10,  20,  96, random_manager.get_random(x_a, 2, 35), random_manager.get_random(x_a, 3, 35));
    }
    else if (c_t[x_a][channel][i_t] ==  36){
      c_tchannel(x_a,   0,  96,  10,  21,  32,  64, random_manager.get_random(x_a, 2, 36), random_manager.get_random(x_a, 3, 36));
    }
    else if (c_t[x_a][channel][i_t] ==  37){
      c_tchannel(x_a,  23,  96,  10,  21,  32,  64, random_manager.get_random(x_a, 2, 37), random_manager.get_random(x_a, 3, 37));
    }
    else if (c_t[x_a][channel][i_t] ==  38){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  16, 108, random_manager.get_random(x_a, 2, 38), random_manager.get_random(x_a, 3, 38));
    }
    else if (c_t[x_a][channel][i_t] ==  39){
      c_tchannel_opt(x_a,   0, 108,   1,  18,  40,  68, random_manager.get_random(x_a, 2, 39), random_manager.get_random(x_a, 3, 39));
    }
    else if (c_t[x_a][channel][i_t] ==  40){
      c_tchannel(x_a,   0,  68,  18,  41,   4,  64, random_manager.get_random(x_a, 2, 40), random_manager.get_random(x_a, 3, 40));
    }
    else if (c_t[x_a][channel][i_t] ==  41){
      c_tchannel(x_a,  23,  68,  18,  41,   4,  64, random_manager.get_random(x_a, 2, 41), random_manager.get_random(x_a, 3, 41));
    }
    else if (c_t[x_a][channel][i_t] ==  42){
      c_tchannel_opt(x_a,   0, 124,   2,   1,   4, 120, random_manager.get_random(x_a, 2, 42), random_manager.get_random(x_a, 3, 42));
    }
    else if (c_t[x_a][channel][i_t] ==  43){
      c_tchannel_opt(x_a,   0, 120,   1,   6,  40,  80, random_manager.get_random(x_a, 2, 43), random_manager.get_random(x_a, 3, 43));
    }
    else if (c_t[x_a][channel][i_t] ==  44){
      c_tchannel(x_a,   0,  80,   6,  41,  16,  64, random_manager.get_random(x_a, 2, 44), random_manager.get_random(x_a, 3, 44));
    }
    else if (c_t[x_a][channel][i_t] ==  45){
      c_tchannel(x_a,  23,  80,   6,  41,  16,  64, random_manager.get_random(x_a, 2, 45), random_manager.get_random(x_a, 3, 45));
    }
    else if (c_t[x_a][channel][i_t] ==  46){
      c_tchannel_opt(x_a,   0,  92,  34,   1,   8,  84, random_manager.get_random(x_a, 2, 46), random_manager.get_random(x_a, 3, 46));
    }
    else if (c_t[x_a][channel][i_t] ==  47){
      c_tchannel_opt(x_a,  23,  92,  34,   1,   8,  84, random_manager.get_random(x_a, 2, 47), random_manager.get_random(x_a, 3, 47));
    }
    else if (c_t[x_a][channel][i_t] ==  48){
      c_tchannel_opt(x_a,   0, 116,  10,   1,  32,  84, random_manager.get_random(x_a, 2, 48), random_manager.get_random(x_a, 3, 48));
    }
    else if (c_t[x_a][channel][i_t] ==  49){
      c_tchannel_opt(x_a,  23, 116,  10,   1,  32,  84, random_manager.get_random(x_a, 2, 49), random_manager.get_random(x_a, 3, 49));
    }
    else if (c_t[x_a][channel][i_t] ==  50){
      c_tchannel_opt(x_a,   0, 108,  18,   1,   4, 104, random_manager.get_random(x_a, 2, 50), random_manager.get_random(x_a, 3, 50));
    }
    else if (c_t[x_a][channel][i_t] ==  51){
      c_tchannel_opt(x_a,  23, 108,  18,   1,   4, 104, random_manager.get_random(x_a, 2, 51), random_manager.get_random(x_a, 3, 51));
    }
    else if (c_t[x_a][channel][i_t] ==  52){
      c_tchannel_opt(x_a,   0, 120,   6,   1,  16, 104, random_manager.get_random(x_a, 2, 52), random_manager.get_random(x_a, 3, 52));
    }
    else if (c_t[x_a][channel][i_t] ==  53){
      c_tchannel_opt(x_a,  23, 120,   6,   1,  16, 104, random_manager.get_random(x_a, 2, 53), random_manager.get_random(x_a, 3, 53));
    }
    else if (c_t[x_a][channel][i_t] ==  54){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  64,  60, random_manager.get_random(x_a, 2, 54), random_manager.get_random(x_a, 3, 54));
    }
    else if (c_t[x_a][channel][i_t] ==  55){
      c_tchannel(x_a,   0,  44,  65,  18,   4,  40, random_manager.get_random(x_a, 2, 55), random_manager.get_random(x_a, 3, 55));
    }
    else if (c_t[x_a][channel][i_t] ==  56){
      c_tchannel(x_a,   0,  52,  65,  10,  32,  20, random_manager.get_random(x_a, 2, 56), random_manager.get_random(x_a, 3, 56));
    }
    else if (c_t[x_a][channel][i_t] ==  57){
      c_tchannel(x_a,   0,  28,  65,  34,   8,  20, random_manager.get_random(x_a, 2, 57), random_manager.get_random(x_a, 3, 57));
    }
    else if (c_t[x_a][channel][i_t] ==  58){
      c_tchannel(x_a,   0,  56,  65,   6,  16,  40, random_manager.get_random(x_a, 2, 58), random_manager.get_random(x_a, 3, 58));
    }
    else if (c_t[x_a][channel][i_t] ==  59){
      c_tchannel_opt(x_a,   0,  60,  65,   2,   4,  56, random_manager.get_random(x_a, 2, 59), random_manager.get_random(x_a, 3, 59));
    }
    else if (c_t[x_a][channel][i_t] ==  60){
      c_tchannel_opt(x_a,   0,  60,  65,   2,  16,  44, random_manager.get_random(x_a, 2, 60), random_manager.get_random(x_a, 3, 60));
    }
    else if (c_t[x_a][channel][i_t] ==  61){
      c_tchannel_opt(x_a,   0,  60,  65,   2,   8,  52, random_manager.get_random(x_a, 2, 61), random_manager.get_random(x_a, 3, 61));
    }
    else if (c_t[x_a][channel][i_t] ==  62){
      c_tchannel_opt(x_a,   0,  60,  65,   2,  32,  28, random_manager.get_random(x_a, 2, 62), random_manager.get_random(x_a, 3, 62));
    }
    else if (c_t[x_a][channel][i_t] ==  63){
      c_tchannel_opt(x_a,   0,  60,   1,  66,  20,  40, random_manager.get_random(x_a, 2, 63), random_manager.get_random(x_a, 3, 63));
    }
    else if (c_t[x_a][channel][i_t] ==  64){
      c_tchannel_opt(x_a,   0,  60,   1,  66,  40,  20, random_manager.get_random(x_a, 2, 64), random_manager.get_random(x_a, 3, 64));
    }
    else if (c_t[x_a][channel][i_t] ==  65){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  20, 104, random_manager.get_random(x_a, 2, 65), random_manager.get_random(x_a, 3, 65));
    }
    else if (c_t[x_a][channel][i_t] ==  66){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  40,  84, random_manager.get_random(x_a, 2, 66), random_manager.get_random(x_a, 3, 66));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  20,   4,  16, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  40,   8,  32, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  84,  64,  20, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a, 104,  64,  40, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  60,   4,  56, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  56,  16,  40, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  44,   4,  40, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  60,   8,  52, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a,  52,  32,  20, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  60,  32,  28, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
    else if (c_d[x_a][channel][i_d] ==  11){
      c_decay(x_a,  28,   8,  20, random_manager.get_random(x_a, 4, 11), random_manager.get_random(x_a, 5, 11));
    }
    else if (c_d[x_a][channel][i_d] ==  12){
      c_decay(x_a, 124,  64,  60, random_manager.get_random(x_a, 4, 12), random_manager.get_random(x_a, 5, 12));
    }
    else if (c_d[x_a][channel][i_d] ==  13){
      c_decay(x_a, 124,  20, 104, random_manager.get_random(x_a, 4, 13), random_manager.get_random(x_a, 5, 13));
    }
    else if (c_d[x_a][channel][i_d] ==  14){
      c_decay(x_a, 124,  40,  84, random_manager.get_random(x_a, 4, 14), random_manager.get_random(x_a, 5, 14));
    }
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
