#include "header.hpp"

#include "ppemexmx04.phasespace.set.hpp"

void ppemexmx04_phasespace_set::ag_psp_240_gg_emmumepmup(int x_a, int zero){
  static Logger logger("ppemexmx04_phasespace_set::ag_psp_240_gg_emmumepmup");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][20] == nullvector){xbp_all[x_a][20] = xbp_all[x_a][4] + xbp_all[x_a][16];}
  if (xbs_all[x_a][20] == 0.){xbs_all[x_a][20] = xbp_all[x_a][20].m2();}
  if (xbs_all[x_a][20] < 0.){xbs_all[x_a][20] = 0.;}
  if (xbsqrts_all[x_a][20] == 0.){xbsqrts_all[x_a][20] = sqrt(xbs_all[x_a][20]);}
  if (xbp_all[x_a][40] == nullvector){xbp_all[x_a][40] = xbp_all[x_a][8] + xbp_all[x_a][32];}
  if (xbs_all[x_a][40] == 0.){xbs_all[x_a][40] = xbp_all[x_a][40].m2();}
  if (xbs_all[x_a][40] < 0.){xbs_all[x_a][40] = 0.;}
  if (xbsqrts_all[x_a][40] == 0.){xbsqrts_all[x_a][40] = sqrt(xbs_all[x_a][40]);}
  if (xbp_all[x_a][21] == nullvector){xbp_all[x_a][21] = xbp_all[x_a][1] - xbp_all[x_a][4] - xbp_all[x_a][16];}
  if (xbs_all[x_a][21] == 0.){xbs_all[x_a][21] = xbp_all[x_a][21].m2();}
  if (xbs_all[x_a][21] > 0.){xbs_all[x_a][21] = 0.;}
  if (xbp_all[x_a][28] == nullvector){xbp_all[x_a][28] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][28] == 0.){xbs_all[x_a][28] = xbp_all[x_a][28].m2();}
  if (xbs_all[x_a][28] < 0.){xbs_all[x_a][28] = 0.;}
  if (xbp_all[x_a][41] == nullvector){xbp_all[x_a][41] = xbp_all[x_a][1] - xbp_all[x_a][8] - xbp_all[x_a][32];}
  if (xbs_all[x_a][41] == 0.){xbs_all[x_a][41] = xbp_all[x_a][41].m2();}
  if (xbs_all[x_a][41] > 0.){xbs_all[x_a][41] = 0.;}
  if (xbp_all[x_a][44] == nullvector){xbp_all[x_a][44] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][32];}
  if (xbs_all[x_a][44] == 0.){xbs_all[x_a][44] = xbp_all[x_a][44].m2();}
  if (xbs_all[x_a][44] < 0.){xbs_all[x_a][44] = 0.;}
  if (xbp_all[x_a][52] == nullvector){xbp_all[x_a][52] = xbp_all[x_a][4] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][52] == 0.){xbs_all[x_a][52] = xbp_all[x_a][52].m2();}
  if (xbs_all[x_a][52] < 0.){xbs_all[x_a][52] = 0.;}
  if (xbp_all[x_a][56] == nullvector){xbp_all[x_a][56] = xbp_all[x_a][8] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][56] == 0.){xbs_all[x_a][56] = xbp_all[x_a][56].m2();}
  if (xbs_all[x_a][56] < 0.){xbs_all[x_a][56] = 0.;}
  if (xbp_all[x_a][60] == nullvector){xbp_all[x_a][60] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][60] == 0.){xbs_all[x_a][60] = xbp_all[x_a][60].m2();}
  if (xbs_all[x_a][60] < 0.){xbs_all[x_a][60] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][40]; // 33 times
  v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]); // 4 times
  v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]); // 4 times
  v_smin[x_a][  3] = smin_opt[x_a][20]; // 33 times
  v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][52]); // 4 times
  v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]); // 4 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2); // 25 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2); // 4 times
  v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2); // 4 times
  v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2); // 16 times
  v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2); // 4 times
  v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2); // 4 times
  v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][40], 2); // 17 times
  v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][20], 2); // 8 times

  //  vector<double> g_p(12);
  {g_p[x_a][  0] = g_propagator(x_a,   0,  40, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 12 times
  {g_p[x_a][  1] = g_propagator(x_a,   0,  56, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 3 */} // 4 times
  {g_p[x_a][  2] = g_propagator(x_a,  23,  40, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 13 times
  {g_p[x_a][  3] = g_propagator(x_a,   0,  44, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 3 */} // 4 times
  {g_p[x_a][  4] = g_propagator(x_a,   0,  20, v_smin[x_a][  3], v_smax[x_a][  3]); /* npp 2 */} // 8 times
  {g_p[x_a][  5] = g_propagator(x_a,   0,  52, v_smin[x_a][  4], v_smax[x_a][  4]); /* npp 3 */} // 4 times
  {g_p[x_a][  6] = g_propagator(x_a,  23,  20, v_smin[x_a][  3], v_smax[x_a][  3]); /* npp 2 */} // 8 times
  {g_p[x_a][  7] = g_propagator(x_a,   0,  28, v_smin[x_a][  5], v_smax[x_a][  5]); /* npp 3 */} // 4 times
  {g_p[x_a][  8] = g_propagator(x_a,   0,  20, v_smin[x_a][  3], v_smax[x_a][  6]); /* npp 2 */} // 8 times
  {g_p[x_a][  9] = g_propagator(x_a,  23,  20, v_smin[x_a][  3], v_smax[x_a][  6]); /* npp 2 */} // 9 times
  {g_p[x_a][ 10] = g_propagator(x_a,   0,  40, v_smin[x_a][  0], v_smax[x_a][  7]); /* npp 2 */} // 4 times
  {g_p[x_a][ 11] = g_propagator(x_a,  23,  40, v_smin[x_a][  0], v_smax[x_a][  7]); /* npp 2 */} // 4 times

  //  vector<double> g_f(0);

  //  vector<double> g_t(4);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  60,   1,   2,  20,  40); /* ntp 0 */} // 4 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,  36,  60,   1,   2,  20,  40); /* ntp 0 */} // 4 times
  {g_t[x_a][  2] = g_tchannel_opt(x_a,   0,  60,   1,   2,  40,  20); /* ntp 0 */} // 4 times
  {g_t[x_a][  3] = g_tchannel_opt(x_a,  36,  60,   1,   2,  40,  20); /* ntp 0 */} // 4 times

  //  vector<double> g_d(11);
  {g_d[x_a][  0] = g_decay(x_a,  60,   4,  56); /* ndp 4 */} // 4 times
  {g_d[x_a][  1] = g_decay(x_a,  56,  16,  40); /* ndp 3 */} // 4 times
  {g_d[x_a][  2] = g_decay(x_a,  40,   8,  32); /* ndp 2 */} // 33 times
  {g_d[x_a][  3] = g_decay(x_a,  60,  16,  44); /* ndp 4 */} // 4 times
  {g_d[x_a][  4] = g_decay(x_a,  44,   4,  40); /* ndp 3 */} // 4 times
  {g_d[x_a][  5] = g_decay(x_a,  60,   8,  52); /* ndp 4 */} // 4 times
  {g_d[x_a][  6] = g_decay(x_a,  52,  32,  20); /* ndp 3 */} // 4 times
  {g_d[x_a][  7] = g_decay(x_a,  20,   4,  16); /* ndp 2 */} // 33 times
  {g_d[x_a][  8] = g_decay(x_a,  60,  32,  28); /* ndp 4 */} // 4 times
  {g_d[x_a][  9] = g_decay(x_a,  28,   8,  20); /* ndp 3 */} // 4 times
  {g_d[x_a][ 10] = g_decay(x_a,  60,  20,  40); /* ndp 4 */} // 9 times


  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(12);
    inv_r[1].resize(0);
    inv_r[2].resize(4);
    inv_r[3].resize(4);
    inv_r[4].resize(11);
    inv_r[5].resize(11);

    {inv_propagator(x_a,   0,  40, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 12 times
    {inv_propagator(x_a,   0,  56, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][1]);} // 4 times
    {inv_propagator(x_a,  23,  40, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][2]);} // 13 times
    {inv_propagator(x_a,   0,  44, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][3]);} // 4 times
    {inv_propagator(x_a,   0,  20, v_smin[x_a][  3], v_smax[x_a][  3], inv_r[0][4]);} // 8 times
    {inv_propagator(x_a,   0,  52, v_smin[x_a][  4], v_smax[x_a][  4], inv_r[0][5]);} // 4 times
    {inv_propagator(x_a,  23,  20, v_smin[x_a][  3], v_smax[x_a][  3], inv_r[0][6]);} // 8 times
    {inv_propagator(x_a,   0,  28, v_smin[x_a][  5], v_smax[x_a][  5], inv_r[0][7]);} // 4 times
    {inv_propagator(x_a,   0,  20, v_smin[x_a][  3], v_smax[x_a][  6], inv_r[0][8]);} // 8 times
    {inv_propagator(x_a,  23,  20, v_smin[x_a][  3], v_smax[x_a][  6], inv_r[0][9]);} // 9 times
    {inv_propagator(x_a,   0,  40, v_smin[x_a][  0], v_smax[x_a][  7], inv_r[0][10]);} // 4 times
    {inv_propagator(x_a,  23,  40, v_smin[x_a][  0], v_smax[x_a][  7], inv_r[0][11]);} // 4 times


    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  20,  40, inv_r[2][0], inv_r[3][0]);} // 4 times
    {inv_tchannel_opt(x_a,  36,  60,   1,   2,  20,  40, inv_r[2][1], inv_r[3][1]);} // 4 times
    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  40,  20, inv_r[2][2], inv_r[3][2]);} // 4 times
    {inv_tchannel_opt(x_a,  36,  60,   1,   2,  40,  20, inv_r[2][3], inv_r[3][3]);} // 4 times

    {inv_decay(x_a,  60,   4,  56, inv_r[4][0], inv_r[5][0]);} // 4 times
    {inv_decay(x_a,  56,  16,  40, inv_r[4][1], inv_r[5][1]);} // 4 times
    {inv_decay(x_a,  40,   8,  32, inv_r[4][2], inv_r[5][2]);} // 33 times
    {inv_decay(x_a,  60,  16,  44, inv_r[4][3], inv_r[5][3]);} // 4 times
    {inv_decay(x_a,  44,   4,  40, inv_r[4][4], inv_r[5][4]);} // 4 times
    {inv_decay(x_a,  60,   8,  52, inv_r[4][5], inv_r[5][5]);} // 4 times
    {inv_decay(x_a,  52,  32,  20, inv_r[4][6], inv_r[5][6]);} // 4 times
    {inv_decay(x_a,  20,   4,  16, inv_r[4][7], inv_r[5][7]);} // 33 times
    {inv_decay(x_a,  60,  32,  28, inv_r[4][8], inv_r[5][8]);} // 4 times
    {inv_decay(x_a,  28,   8,  20, inv_r[4][9], inv_r[5][9]);} // 4 times
    {inv_decay(x_a,  60,  20,  40, inv_r[4][10], inv_r[5][10]);} // 9 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(41, vector<double> (8));
      vector<double> g_IS(41, 1.);
      for (int i_c = 0; i_c < 41; i_c++){
        int ran = 0;
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 8; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_p[x_a][  0] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_p[x_a][  0] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_IS[  2] * g_p[x_a][  2] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_IS[  3] * g_p[x_a][  2] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_IS[  4] * g_p[x_a][  0] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_IS[  5] * g_p[x_a][  0] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_IS[  6] * g_p[x_a][  2] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_IS[  7] * g_p[x_a][  2] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_IS[  8] * g_p[x_a][  4] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_IS[  9] * g_p[x_a][  4] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_IS[ 10] * g_p[x_a][  6] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_IS[ 11] * g_p[x_a][  6] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_IS[ 12] * g_p[x_a][  4] * g_p[x_a][  7] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_IS[ 13] * g_p[x_a][  4] * g_p[x_a][  7] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_IS[ 14] * g_p[x_a][  6] * g_p[x_a][  7] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_IS[ 15] * g_p[x_a][  6] * g_p[x_a][  7] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_IS[ 16] * g_p[x_a][  0] * g_p[x_a][  8] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_IS[ 17] * g_p[x_a][  0] * g_p[x_a][  8] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_IS[ 18] * g_p[x_a][  0] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_IS[ 19] * g_p[x_a][  0] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_IS[ 20] * g_p[x_a][  2] * g_p[x_a][  8] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_IS[ 21] * g_p[x_a][  2] * g_p[x_a][  8] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_IS[ 22] * g_p[x_a][  2] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_IS[ 23] * g_p[x_a][  2] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  24] != 0.){MC_phasespace.g_channel[zero +  24] = g_IS[ 24] * g_p[x_a][  2] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  25] != 0.){MC_phasespace.g_channel[zero +  25] = g_IS[ 25] * g_p[x_a][  0] * g_p[x_a][  8] * g_t[x_a][  0] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  26] != 0.){MC_phasespace.g_channel[zero +  26] = g_IS[ 26] * g_p[x_a][  0] * g_p[x_a][  8] * g_t[x_a][  1] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  27] != 0.){MC_phasespace.g_channel[zero +  27] = g_IS[ 27] * g_p[x_a][  0] * g_p[x_a][  9] * g_t[x_a][  0] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  28] != 0.){MC_phasespace.g_channel[zero +  28] = g_IS[ 28] * g_p[x_a][  0] * g_p[x_a][  9] * g_t[x_a][  1] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  29] != 0.){MC_phasespace.g_channel[zero +  29] = g_IS[ 29] * g_p[x_a][  2] * g_p[x_a][  8] * g_t[x_a][  0] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  30] != 0.){MC_phasespace.g_channel[zero +  30] = g_IS[ 30] * g_p[x_a][  2] * g_p[x_a][  8] * g_t[x_a][  1] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  31] != 0.){MC_phasespace.g_channel[zero +  31] = g_IS[ 31] * g_p[x_a][  2] * g_p[x_a][  9] * g_t[x_a][  0] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  32] != 0.){MC_phasespace.g_channel[zero +  32] = g_IS[ 32] * g_p[x_a][  2] * g_p[x_a][  9] * g_t[x_a][  1] * g_d[x_a][  7] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  33] != 0.){MC_phasespace.g_channel[zero +  33] = g_IS[ 33] * g_p[x_a][  4] * g_p[x_a][ 10] * g_t[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  34] != 0.){MC_phasespace.g_channel[zero +  34] = g_IS[ 34] * g_p[x_a][  4] * g_p[x_a][ 10] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  35] != 0.){MC_phasespace.g_channel[zero +  35] = g_IS[ 35] * g_p[x_a][  4] * g_p[x_a][ 11] * g_t[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  36] != 0.){MC_phasespace.g_channel[zero +  36] = g_IS[ 36] * g_p[x_a][  4] * g_p[x_a][ 11] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  37] != 0.){MC_phasespace.g_channel[zero +  37] = g_IS[ 37] * g_p[x_a][  6] * g_p[x_a][ 10] * g_t[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  38] != 0.){MC_phasespace.g_channel[zero +  38] = g_IS[ 38] * g_p[x_a][  6] * g_p[x_a][ 10] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  39] != 0.){MC_phasespace.g_channel[zero +  39] = g_IS[ 39] * g_p[x_a][  6] * g_p[x_a][ 11] * g_t[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  40] != 0.){MC_phasespace.g_channel[zero +  40] = g_IS[ 40] * g_p[x_a][  6] * g_p[x_a][ 11] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  7];}

    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(12, 1.);
      g_IS[1].resize(0, 1.);
      g_IS[2].resize(4, 1.);
      g_IS[3].resize(11, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_p[x_a][  4] * g_IS[0][  4] * g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_p[x_a][  4] * g_IS[0][  4] * g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  4] * g_IS[0][  4] * g_p[x_a][  7] * g_IS[0][  7] * g_d[x_a][  8] * g_IS[3][  8] * g_d[x_a][  9] * g_IS[3][  9] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  4] * g_IS[0][  4] * g_p[x_a][  7] * g_IS[0][  7] * g_d[x_a][  8] * g_IS[3][  8] * g_d[x_a][  9] * g_IS[3][  9] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][  7] * g_IS[0][  7] * g_d[x_a][  8] * g_IS[3][  8] * g_d[x_a][  9] * g_IS[3][  9] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][  7] * g_IS[0][  7] * g_d[x_a][  8] * g_IS[3][  8] * g_d[x_a][  9] * g_IS[3][  9] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  8] * g_IS[0][  8] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  8] * g_IS[0][  8] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  9] * g_IS[0][  9] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  9] * g_IS[0][  9] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  8] * g_IS[0][  8] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  8] * g_IS[0][  8] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  9] * g_IS[0][  9] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  9] * g_IS[0][  9] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  24] != 0.){MC_phasespace.g_channel[zero +  24] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  9] * g_IS[0][  9] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  25] != 0.){MC_phasespace.g_channel[zero +  25] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  8] * g_IS[0][  8] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  26] != 0.){MC_phasespace.g_channel[zero +  26] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  8] * g_IS[0][  8] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  27] != 0.){MC_phasespace.g_channel[zero +  27] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  9] * g_IS[0][  9] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  28] != 0.){MC_phasespace.g_channel[zero +  28] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  9] * g_IS[0][  9] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  29] != 0.){MC_phasespace.g_channel[zero +  29] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  8] * g_IS[0][  8] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  30] != 0.){MC_phasespace.g_channel[zero +  30] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  8] * g_IS[0][  8] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  31] != 0.){MC_phasespace.g_channel[zero +  31] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  9] * g_IS[0][  9] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  32] != 0.){MC_phasespace.g_channel[zero +  32] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  9] * g_IS[0][  9] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  33] != 0.){MC_phasespace.g_channel[zero +  33] = g_p[x_a][  4] * g_IS[0][  4] * g_p[x_a][ 10] * g_IS[0][ 10] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  34] != 0.){MC_phasespace.g_channel[zero +  34] = g_p[x_a][  4] * g_IS[0][  4] * g_p[x_a][ 10] * g_IS[0][ 10] * g_t[x_a][  3] * g_IS[2][  3] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  35] != 0.){MC_phasespace.g_channel[zero +  35] = g_p[x_a][  4] * g_IS[0][  4] * g_p[x_a][ 11] * g_IS[0][ 11] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  36] != 0.){MC_phasespace.g_channel[zero +  36] = g_p[x_a][  4] * g_IS[0][  4] * g_p[x_a][ 11] * g_IS[0][ 11] * g_t[x_a][  3] * g_IS[2][  3] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  37] != 0.){MC_phasespace.g_channel[zero +  37] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][ 10] * g_IS[0][ 10] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  38] != 0.){MC_phasespace.g_channel[zero +  38] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][ 10] * g_IS[0][ 10] * g_t[x_a][  3] * g_IS[2][  3] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  39] != 0.){MC_phasespace.g_channel[zero +  39] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][ 11] * g_IS[0][ 11] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  40] != 0.){MC_phasespace.g_channel[zero +  40] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][ 11] * g_IS[0][ 11] * g_t[x_a][  3] * g_IS[2][  3] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  7] * g_IS[3][  7];}
    }
  }

  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  2] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  2] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_p[x_a][  0] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_p[x_a][  0] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_p[x_a][  2] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_p[x_a][  2] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_p[x_a][  4] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_p[x_a][  4] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_p[x_a][  6] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_p[x_a][  6] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  4] * g_p[x_a][  7] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  4] * g_p[x_a][  7] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  6] * g_p[x_a][  7] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  6] * g_p[x_a][  7] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  0] * g_p[x_a][  8] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_p[x_a][  0] * g_p[x_a][  8] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_p[x_a][  0] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_p[x_a][  0] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_p[x_a][  2] * g_p[x_a][  8] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_p[x_a][  2] * g_p[x_a][  8] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_p[x_a][  2] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_p[x_a][  2] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  24] != 0.){MC_phasespace.g_channel[zero +  24] = g_p[x_a][  2] * g_p[x_a][  9] * g_d[x_a][ 10] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  25] != 0.){MC_phasespace.g_channel[zero +  25] = g_p[x_a][  0] * g_p[x_a][  8] * g_t[x_a][  0] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  26] != 0.){MC_phasespace.g_channel[zero +  26] = g_p[x_a][  0] * g_p[x_a][  8] * g_t[x_a][  1] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  27] != 0.){MC_phasespace.g_channel[zero +  27] = g_p[x_a][  0] * g_p[x_a][  9] * g_t[x_a][  0] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  28] != 0.){MC_phasespace.g_channel[zero +  28] = g_p[x_a][  0] * g_p[x_a][  9] * g_t[x_a][  1] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  29] != 0.){MC_phasespace.g_channel[zero +  29] = g_p[x_a][  2] * g_p[x_a][  8] * g_t[x_a][  0] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  30] != 0.){MC_phasespace.g_channel[zero +  30] = g_p[x_a][  2] * g_p[x_a][  8] * g_t[x_a][  1] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  31] != 0.){MC_phasespace.g_channel[zero +  31] = g_p[x_a][  2] * g_p[x_a][  9] * g_t[x_a][  0] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  32] != 0.){MC_phasespace.g_channel[zero +  32] = g_p[x_a][  2] * g_p[x_a][  9] * g_t[x_a][  1] * g_d[x_a][  7] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  33] != 0.){MC_phasespace.g_channel[zero +  33] = g_p[x_a][  4] * g_p[x_a][ 10] * g_t[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  34] != 0.){MC_phasespace.g_channel[zero +  34] = g_p[x_a][  4] * g_p[x_a][ 10] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  35] != 0.){MC_phasespace.g_channel[zero +  35] = g_p[x_a][  4] * g_p[x_a][ 11] * g_t[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  36] != 0.){MC_phasespace.g_channel[zero +  36] = g_p[x_a][  4] * g_p[x_a][ 11] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  37] != 0.){MC_phasespace.g_channel[zero +  37] = g_p[x_a][  6] * g_p[x_a][ 10] * g_t[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  38] != 0.){MC_phasespace.g_channel[zero +  38] = g_p[x_a][  6] * g_p[x_a][ 10] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  39] != 0.){MC_phasespace.g_channel[zero +  39] = g_p[x_a][  6] * g_p[x_a][ 11] * g_t[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  40] != 0.){MC_phasespace.g_channel[zero +  40] = g_p[x_a][  6] * g_p[x_a][ 11] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  7];}
  }

/*
  if (MC_phasespace.alpha[   0] != 0.){ag_channel_4yyv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (MC_phasespace.alpha[   1] != 0.){ag_channel_4yyv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  if (MC_phasespace.alpha[   2] != 0.){ag_channel_4yyv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (MC_phasespace.alpha[   3] != 0.){ag_channel_4yyv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  if (MC_phasespace.alpha[   4] != 0.){ag_channel_4yyv(g, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (MC_phasespace.alpha[   5] != 0.){ag_channel_4yyv(g, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  if (MC_phasespace.alpha[   6] != 0.){ag_channel_4yyv(g, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (MC_phasespace.alpha[   7] != 0.){ag_channel_4yyv(g, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  if (MC_phasespace.alpha[   8] != 0.){ag_channel_4yyv(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (MC_phasespace.alpha[   9] != 0.){ag_channel_4yyv(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  if (MC_phasespace.alpha[  10] != 0.){ag_channel_4yyv(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (MC_phasespace.alpha[  11] != 0.){ag_channel_4yyv(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  if (MC_phasespace.alpha[  12] != 0.){ag_channel_4yyv(g, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (MC_phasespace.alpha[  13] != 0.){ag_channel_4yyv(g, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  if (MC_phasespace.alpha[  14] != 0.){ag_channel_4yyv(g, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (MC_phasespace.alpha[  15] != 0.){ag_channel_4yyv(g, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  if (MC_phasespace.alpha[  16] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (MC_phasespace.alpha[  17] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  if (MC_phasespace.alpha[  18] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  if (MC_phasespace.alpha[  19] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  if (MC_phasespace.alpha[  20] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (MC_phasespace.alpha[  21] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36, psi);}
  if (MC_phasespace.alpha[  22] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25, psi);}
  if (MC_phasespace.alpha[  23] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0, psi);}
  if (MC_phasespace.alpha[  24] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36, psi);}
  if (MC_phasespace.alpha[  25] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (MC_phasespace.alpha[  26] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  if (MC_phasespace.alpha[  27] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  if (MC_phasespace.alpha[  28] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  if (MC_phasespace.alpha[  29] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (MC_phasespace.alpha[  30] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36, psi);}
  if (MC_phasespace.alpha[  31] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0, psi);}
  if (MC_phasespace.alpha[  32] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36, psi);}
  if (MC_phasespace.alpha[  33] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (MC_phasespace.alpha[  34] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  36, psi);}
  if (MC_phasespace.alpha[  35] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  if (MC_phasespace.alpha[  36] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36, psi);}
  if (MC_phasespace.alpha[  37] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (MC_phasespace.alpha[  38] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36, psi);}
  if (MC_phasespace.alpha[  39] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0, psi);}
  if (MC_phasespace.alpha[  40] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36, psi);}
  // channel    0: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,   0)
  // channel    1: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,  23)
  // channel    2: 4yyv(1, 2, 4, 16, 8, 32;  23,   0,   0)
  // channel    3: 4yyv(1, 2, 4, 16, 8, 32;  23,   0,  23)
  // channel    4: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
  // channel    5: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,  23)
  // channel    6: 4yyv(1, 2, 16, 4, 8, 32;  23,   0,   0)
  // channel    7: 4yyv(1, 2, 16, 4, 8, 32;  23,   0,  23)
  // channel    8: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,   0)
  // channel    9: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,  23)
  // channel   10: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,   0)
  // channel   11: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,  23)
  // channel   12: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
  // channel   13: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,  23)
  // channel   14: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,   0)
  // channel   15: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,  23)
  // channel   16: 42vv(1, 2, 4, 16, 8, 32;   0,   0,   0)
  // channel   17: 42vv(1, 2, 4, 16, 8, 32;   0,   0,  36)
  // channel   18: 42vv(1, 2, 4, 16, 8, 32;   0,  23,   0)
  // channel   19: 42vv(1, 2, 4, 16, 8, 32;   0,  23,  36)
  // channel   20: 42vv(1, 2, 4, 16, 8, 32;  23,   0,   0)
  // channel   21: 42vv(1, 2, 4, 16, 8, 32;  23,   0,  36)
  // channel   22: 42vv(1, 2, 4, 16, 8, 32;  23,  23,  25)
  // channel   23: 42vv(1, 2, 4, 16, 8, 32;  23,  23,   0)
  // channel   24: 42vv(1, 2, 4, 16, 8, 32;  23,  23,  36)
  // channel   25: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
  // channel   26: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,  36)
  // channel   27: 2v2v(1, 2, 4, 16, 8, 32;   0,  23,   0)
  // channel   28: 2v2v(1, 2, 4, 16, 8, 32;   0,  23,  36)
  // channel   29: 2v2v(1, 2, 4, 16, 8, 32;  23,   0,   0)
  // channel   30: 2v2v(1, 2, 4, 16, 8, 32;  23,   0,  36)
  // channel   31: 2v2v(1, 2, 4, 16, 8, 32;  23,  23,   0)
  // channel   32: 2v2v(1, 2, 4, 16, 8, 32;  23,  23,  36)
  // channel   33: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   0)
  // channel   34: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,  36)
  // channel   35: 2v2v(1, 2, 8, 32, 4, 16;   0,  23,   0)
  // channel   36: 2v2v(1, 2, 8, 32, 4, 16;   0,  23,  36)
  // channel   37: 2v2v(1, 2, 8, 32, 4, 16;  23,   0,   0)
  // channel   38: 2v2v(1, 2, 8, 32, 4, 16;  23,   0,  36)
  // channel   39: 2v2v(1, 2, 8, 32, 4, 16;  23,  23,   0)
  // channel   40: 2v2v(1, 2, 8, 32, 4, 16;  23,  23,  36)
*/

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
