#include "header.hpp"

#include "ppemexmx04.phasespace.set.hpp"

void ppemexmx04_phasespace_set::ax_psp_240_gg_emmumepmup(int x_a){
  static Logger logger("ppemexmx04_phasespace_set::ax_psp_240_gg_emmumepmup");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(6);
  needed_v_smin[x_a].resize(6);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  33
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 33);
  int needed_v_smin_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   4,    5,    6,    7}; //   4
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  33
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 33);
  int needed_v_smin_4[] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 4);

  v_smax[x_a].resize(8);
  needed_v_smax[x_a].resize(8);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  25
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 25);
  int needed_v_smax_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   4,    5,    6,    7}; //   4
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 4);
  int needed_v_smax_3[] = {   8,    9,   10,   11,   12,   13,   14,   15,   33,   34,   35,   36,   37,   38,   39,   40}; //  16
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 16);
  int needed_v_smax_4[] = {   8,    9,   10,   11}; //   4
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 4);
  int needed_v_smax_5[] = {  12,   13,   14,   15}; //   4
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 4);
  int needed_v_smax_6[] = {  16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  17
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 17);
  int needed_v_smax_7[] = {  33,   34,   35,   36,   37,   38,   39,   40}; //   8
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 8);

  g_p[x_a].resize(12);
  needed_g_p[x_a].resize(12);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   16,   17,   18,   19,   25,   26,   27,   28}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    3,    6,    7,   20,   21,   22,   23,   24,   29,   30,   31,   32}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   8,    9,   12,   13,   33,   34,   35,   36}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {  10,   11,   14,   15,   37,   38,   39,   40}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][7] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][8] = {  16,   17,   20,   21,   25,   26,   29,   30}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax6");
  needed_g_p[x_a][9] = {  18,   19,   22,   23,   24,   27,   28,   31,   32}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax6");
  needed_g_p[x_a][10] = {  33,   34,   37,   38}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax7");
  needed_g_p[x_a][11] = {  35,   36,   39,   40}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {  25,   27,   29,   31}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][1] = {  26,   28,   30,   32}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__20_40");
  needed_g_t[x_a][2] = {  33,   35,   37,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");
  needed_g_t[x_a][3] = {  34,   36,   38,   40}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__40_20");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  33
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][7] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  33
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][8] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][10] = {  16,   17,   18,   19,   20,   21,   22,   23,   24}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(41);
  c_f[x_a].resize(41);
  c_t[x_a].resize(41);
  c_d[x_a].resize(41);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  2,   1}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  2,   1}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   3}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   3}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  2,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  3,   4,   2}; //   3

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  3,   4,   2}; //   3

  c_p[x_a][8] = {  4,   5}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  5,   6,   7}; //   3

  c_p[x_a][9] = {  4,   5}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  5,   6,   7}; //   3

  c_p[x_a][10] = {  6,   5}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  5,   6,   7}; //   3

  c_p[x_a][11] = {  6,   5}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,   7}; //   3

  c_p[x_a][12] = {  4,   7}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  8,   9,   7}; //   3

  c_p[x_a][13] = {  4,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  8,   9,   7}; //   3

  c_p[x_a][14] = {  6,   7}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  8,   9,   7}; //   3

  c_p[x_a][15] = {  6,   7}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  8,   9,   7}; //   3

  c_p[x_a][16] = {  0,   8}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 10,   7,   2}; //   3

  c_p[x_a][17] = {  0,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 10,   7,   2}; //   3

  c_p[x_a][18] = {  0,   9}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 10,   7,   2}; //   3

  c_p[x_a][19] = {  0,   9}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 10,   7,   2}; //   3

  c_p[x_a][20] = {  2,   8}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 10,   7,   2}; //   3

  c_p[x_a][21] = {  2,   8}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 10,   7,   2}; //   3

  c_p[x_a][22] = {  2,   9}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 10,   7,   2}; //   3

  c_p[x_a][23] = {  2,   9}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 10,   7,   2}; //   3

  c_p[x_a][24] = {  2,   9}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 10,   7,   2}; //   3

  c_p[x_a][25] = {  0,   8}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  7,   2}; //   2

  c_p[x_a][26] = {  0,   8}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  1}; //   1
  c_d[x_a][26] = {  7,   2}; //   2

  c_p[x_a][27] = {  0,   9}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  7,   2}; //   2

  c_p[x_a][28] = {  0,   9}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  1}; //   1
  c_d[x_a][28] = {  7,   2}; //   2

  c_p[x_a][29] = {  2,   8}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = {  7,   2}; //   2

  c_p[x_a][30] = {  2,   8}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  1}; //   1
  c_d[x_a][30] = {  7,   2}; //   2

  c_p[x_a][31] = {  2,   9}; //   2
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = {  7,   2}; //   2

  c_p[x_a][32] = {  2,   9}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  1}; //   1
  c_d[x_a][32] = {  7,   2}; //   2

  c_p[x_a][33] = {  4,  10}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  2}; //   1
  c_d[x_a][33] = {  2,   7}; //   2

  c_p[x_a][34] = {  4,  10}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  3}; //   1
  c_d[x_a][34] = {  2,   7}; //   2

  c_p[x_a][35] = {  4,  11}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  2}; //   1
  c_d[x_a][35] = {  2,   7}; //   2

  c_p[x_a][36] = {  4,  11}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  3}; //   1
  c_d[x_a][36] = {  2,   7}; //   2

  c_p[x_a][37] = {  6,  10}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  2}; //   1
  c_d[x_a][37] = {  2,   7}; //   2

  c_p[x_a][38] = {  6,  10}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  3}; //   1
  c_d[x_a][38] = {  2,   7}; //   2

  c_p[x_a][39] = {  6,  11}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  2}; //   1
  c_d[x_a][39] = {  2,   7}; //   2

  c_p[x_a][40] = {  6,  11}; //   2
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  3}; //   1
  c_d[x_a][40] = {  2,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
