#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_040_dux_emmumepvmx(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_040_dux_emmumepvmx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(5);
  needed_v_smin[x_a].resize(5);
  needed_v_smin[x_a][  0] = {   0,    4,    5,    6,    7,    8,    9}; //   7
  needed_v_smin[x_a][  1] = {   0}; //   1
  needed_v_smin[x_a][  2] = {   1,    2,    3,    4,    5,    6,    7,    8,    9}; //   9
  needed_v_smin[x_a][  3] = {   1}; //   1
  needed_v_smin[x_a][  4] = {   2,    3}; //   2

  v_smax[x_a].resize(7);
  needed_v_smax[x_a].resize(7);
  needed_v_smax[x_a][  0] = {   0,    4,    5,    6,    7}; //   5
  needed_v_smax[x_a][  1] = {   0}; //   1
  needed_v_smax[x_a][  2] = {   1,    2,    3,    8,    9}; //   5
  needed_v_smax[x_a][  3] = {   1}; //   1
  needed_v_smax[x_a][  4] = {   2,    3}; //   2
  needed_v_smax[x_a][  5] = {   4,    5,    6,    7}; //   4
  needed_v_smax[x_a][  6] = {   8,    9}; //   2

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   0,    4,    5,    6,    7}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    3,    9}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   2,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   4,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax5");
  needed_g_p[x_a][7] = {   5,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax5");
  needed_g_p[x_a][8] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax6");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(2);
  needed_g_t[x_a].resize(2);
  needed_g_t[x_a][0] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][1] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");

  g_d[x_a].resize(9);
  needed_g_d[x_a].resize(9);
  needed_g_d[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][2] = {   0,    4,    5,    6,    7,    8,    9}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][5] = {   1,    2,    3,    4,    5,    6,    7,    8,    9}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(10);
  c_f[x_a].resize(10);
  c_t[x_a].resize(10);
  c_d[x_a].resize(10);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  2,   3}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  3,   4,   5}; //   3

  c_p[x_a][2] = {  4,   5}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  6,   7,   5}; //   3

  c_p[x_a][3] = {  2,   5}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   6}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  8,   5,   2}; //   3

  c_p[x_a][5] = {  0,   7}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  8,   5,   2}; //   3

  c_p[x_a][6] = {  0,   6}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  5,   2}; //   2

  c_p[x_a][7] = {  0,   7}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  5,   2}; //   2

  c_p[x_a][8] = {  4,   8}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  1}; //   1
  c_d[x_a][8] = {  2,   5}; //   2

  c_p[x_a][9] = {  2,   8}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  1}; //   1
  c_d[x_a][9] = {  2,   5}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv(1, 2, 4, 16, 8, 32;  24,   0,  24)
// channel    1: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,  24)
// channel    2: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,  24)
// channel    3: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,  24)
// channel    4: 42vv(1, 2, 4, 16, 8, 32;  24,   0,  24)
// channel    5: 42vv(1, 2, 4, 16, 8, 32;  24,  23,  24)
// channel    6: 2v2v(1, 2, 4, 16, 8, 32;  24,   0,   0)
// channel    7: 2v2v(1, 2, 4, 16, 8, 32;  24,  23,   0)
// channel    8: 2v2v(1, 2, 8, 32, 4, 16;   0,  24,   0)
// channel    9: 2v2v(1, 2, 8, 32, 4, 16;  23,  24,   0)
