#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_240_dxux_emmumepvmxdxdx(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_240_dxux_emmumepvmxdxdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(25);
  needed_v_smin[x_a].resize(25);
  needed_v_smin[x_a][  0] = {   0,    1,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  needed_v_smin[x_a][  1] = {   0,    1,   20,   21}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,   20,   21}; //   4
  needed_v_smin[x_a][  3] = {   0,    2,    4,    5,    8,    9,   20,   22,   24,   25,   28,   29}; //  12
  needed_v_smin[x_a][  4] = {   1,    3,    6,    7,   10,   11,   21,   23,   26,   27,   30,   31}; //  12
  needed_v_smin[x_a][  5] = {   2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  needed_v_smin[x_a][  6] = {   2,    3,   22,   23}; //   4
  needed_v_smin[x_a][  7] = {   2,    3,   22,   23}; //   4
  needed_v_smin[x_a][  8] = {   4,    5,    6,    7,   24,   25,   26,   27}; //   8
  needed_v_smin[x_a][  9] = {   4,    5,    6,    7,   24,   25,   26,   27}; //   8
  needed_v_smin[x_a][ 10] = {   8,    9,   10,   11,   28,   29,   30,   31}; //   8
  needed_v_smin[x_a][ 11] = {  12,   13,   34,   35,   40,   41,   54,   55,   62,   63}; //  10
  needed_v_smin[x_a][ 12] = {  12,   13,   54,   55,   62,   63}; //   6
  needed_v_smin[x_a][ 13] = {  14,   15,   32,   33,   42,   43,   52,   53,   60,   61}; //  10
  needed_v_smin[x_a][ 14] = {  14,   15,   52,   53,   60,   61}; //   6
  needed_v_smin[x_a][ 15] = {  16,   17,   42,   43,   46,   47,   50,   51,   58,   59}; //  10
  needed_v_smin[x_a][ 16] = {  16,   17,   50,   51,   58,   59}; //   6
  needed_v_smin[x_a][ 17] = {  18,   19,   40,   41,   44,   45,   48,   49,   56,   57}; //  10
  needed_v_smin[x_a][ 18] = {  18,   19,   48,   49,   56,   57}; //   6
  needed_v_smin[x_a][ 19] = {  32,   33}; //   2
  needed_v_smin[x_a][ 20] = {  34,   35}; //   2
  needed_v_smin[x_a][ 21] = {  36,   37,   38,   39}; //   4
  needed_v_smin[x_a][ 22] = {  36,   37,   38,   39}; //   4
  needed_v_smin[x_a][ 23] = {  44,   45}; //   2
  needed_v_smin[x_a][ 24] = {  46,   47}; //   2

  v_smax[x_a].resize(27);
  needed_v_smax[x_a].resize(27);
  needed_v_smax[x_a][  0] = {   0,    1,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   56,   57,   58,   59}; //  40
  needed_v_smax[x_a][  1] = {   0,    1,   20,   21}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smax[x_a][  3] = {   0,    2,    4,    5,    8,    9,   14,   15,   18,   19,   20,   22,   24,   25,   28,   29,   48,   49,   52,   53,   56,   57,   60,   61}; //  24
  needed_v_smax[x_a][  4] = {   1,    3,    6,    7,   10,   11,   12,   13,   16,   17,   21,   23,   26,   27,   30,   31,   50,   51,   54,   55,   58,   59,   62,   63}; //  24
  needed_v_smax[x_a][  5] = {   2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   22,   23,   24,   25,   26,   27,   52,   53,   54,   55,   60,   61,   62,   63}; //  24
  needed_v_smax[x_a][  6] = {   2,    3,   22,   23}; //   4
  needed_v_smax[x_a][  7] = {   4,    5,    6,    7,   24,   25,   26,   27}; //   8
  needed_v_smax[x_a][  8] = {   8,    9,   10,   11,   28,   29,   30,   31,   36,   37,   38,   39,   44,   45,   46,   47,   48,   49,   50,   51,   56,   57,   58,   59}; //  24
  needed_v_smax[x_a][  9] = {  12,   13,   34,   35,   40,   41}; //   6
  needed_v_smax[x_a][ 10] = {  12,   13,   34,   35,   40,   41}; //   6
  needed_v_smax[x_a][ 11] = {  14,   15,   32,   33,   42,   43}; //   6
  needed_v_smax[x_a][ 12] = {  14,   15,   32,   33,   42,   43}; //   6
  needed_v_smax[x_a][ 13] = {  16,   17}; //   2
  needed_v_smax[x_a][ 14] = {  16,   17}; //   2
  needed_v_smax[x_a][ 15] = {  18,   19}; //   2
  needed_v_smax[x_a][ 16] = {  18,   19}; //   2
  needed_v_smax[x_a][ 17] = {  40,   41}; //   2
  needed_v_smax[x_a][ 18] = {  42,   43}; //   2
  needed_v_smax[x_a][ 19] = {  44,   45,   48,   49,   56,   57}; //   6
  needed_v_smax[x_a][ 20] = {  46,   47,   50,   51,   58,   59}; //   6
  needed_v_smax[x_a][ 21] = {  52,   53,   54,   55,   60,   61,   62,   63}; //   8
  needed_v_smax[x_a][ 22] = {  52,   53,   60,   61}; //   4
  needed_v_smax[x_a][ 23] = {  54,   55,   62,   63}; //   4
  needed_v_smax[x_a][ 24] = {  32,   33,   34,   35,   36,   37,   38,   39}; //   8
  needed_v_smax[x_a][ 25] = {  36,   37,   38,   39}; //   4
  needed_v_smax[x_a][ 26] = {  44,   45,   46,   47}; //   4

  g_p[x_a].resize(35);
  needed_g_p[x_a].resize(35);
  needed_g_p[x_a][0] = {   0,    1,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   56,   57,   58,   59}; //  40
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    2,    4,    5,    8,    9}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    6,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   2,    3,    5,    7,   17,   19,   22,   23,   25,   27,   53,   55,   61,   63}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax5");
  needed_g_p[x_a][6] = {   2,    3,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][7] = {   2,    3,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][8] = {   4,    6,   16,   18,   24,   26,   52,   54,   60,   62}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][9] = {   4,    5,    6,    7,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   4,    5,    6,    7,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][11] = {   8,   10,   28,   30,   36,   38,   44,   46,   48,   50,   56,   58}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax8");
  needed_g_p[x_a][12] = {   8,    9,   10,   11,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax2");
  needed_g_p[x_a][13] = {   9,   11,   29,   31,   37,   39,   45,   47,   49,   51,   57,   59}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax8");
  needed_g_p[x_a][14] = {  12,   13,   34,   35,   40,   41}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][15] = {  12,   34,   40}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax10");
  needed_g_p[x_a][16] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax4");
  needed_g_p[x_a][17] = {  13,   35,   41}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax10");
  needed_g_p[x_a][18] = {  14,   15,   32,   33,   42,   43}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax11");
  needed_g_p[x_a][19] = {  14,   32,   42}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax12");
  needed_g_p[x_a][20] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax3");
  needed_g_p[x_a][21] = {  15,   33,   43}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax12");
  needed_g_p[x_a][22] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax13");
  needed_g_p[x_a][23] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][24] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax4");
  needed_g_p[x_a][25] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax15");
  needed_g_p[x_a][26] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax16");
  needed_g_p[x_a][27] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax3");
  needed_g_p[x_a][28] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax17");
  needed_g_p[x_a][29] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax18");
  needed_g_p[x_a][30] = {  44,   45,   48,   49}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax19");
  needed_g_p[x_a][31] = {  46,   47,   50,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax20");
  needed_g_p[x_a][32] = {  52,   53,   54,   55,   60,   61,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax21");
  needed_g_p[x_a][33] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax22");
  needed_g_p[x_a][34] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax23");

  g_f[x_a].resize(16);
  needed_g_f[x_a].resize(16);
  needed_g_f[x_a][0] = {  20,   22,   24,   25,   28,   29}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {  21,   23,   26,   27,   30,   31}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][2] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax24");
  needed_g_f[x_a][3] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax24");
  needed_g_f[x_a][4] = {  36,   37,   38,   39}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax25");
  needed_g_f[x_a][5] = {  36,   37,   38,   39}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax24");
  needed_g_f[x_a][6] = {  44,   45}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax26");
  needed_g_f[x_a][7] = {  46,   47}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax26");
  needed_g_f[x_a][8] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax3");
  needed_g_f[x_a][9] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax4");
  needed_g_f[x_a][10] = {  52,   53,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax3");
  needed_g_f[x_a][11] = {  54,   55,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax4");
  needed_g_f[x_a][12] = {  56,   57}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax19");
  needed_g_f[x_a][13] = {  58,   59}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax20");
  needed_g_f[x_a][14] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax22");
  needed_g_f[x_a][15] = {  62,   63}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax23");

  g_t[x_a].resize(23);
  needed_g_t[x_a].resize(23);
  needed_g_t[x_a][0] = {   0,    2,    4,    5,    8,    9,   14,   15,   18,   19,   20,   22,   24,   25,   28,   29,   48,   49,   52,   53,   56,   57,   60,   61}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][1] = {   1,    3,    6,    7,   10,   11,   12,   13,   16,   17,   21,   23,   26,   27,   30,   31,   50,   51,   54,   55,   58,   59,   62,   63}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__128_124");
  needed_g_t[x_a][2] = {  20,   22,   24,   25,   28,   29}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][3] = {  21,   23,   26,   27,   30,   31}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__129_2__64_60");
  needed_g_t[x_a][4] = {  32,   33,   34,   35,   36,   37,   38,   39}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][5] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__168_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__168_64");
  needed_g_t[x_a][6] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__104_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__104_128");
  needed_g_t[x_a][7] = {  36,   37,   38,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_192");
  needed_g_t[x_a][8] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__21_42__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__21_42__64_128");
  needed_g_t[x_a][9] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__21_42__128_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__21_42__128_64");
  needed_g_t[x_a][10] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__148_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__148_104");
  needed_g_t[x_a][11] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__84_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__84_168");
  needed_g_t[x_a][12] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_212");
  needed_g_t[x_a][13] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_42__148_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_42__148_64");
  needed_g_t[x_a][14] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_42__84_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_42__84_128");
  needed_g_t[x_a][15] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_148");
  needed_g_t[x_a][16] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__40_84");
  needed_g_t[x_a][17] = {  52,   53,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_168");
  needed_g_t[x_a][18] = {  54,   55,   62,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__20_104");
  needed_g_t[x_a][19] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_42__128_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_42__128_20");
  needed_g_t[x_a][20] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_42__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_42__64_20");
  needed_g_t[x_a][21] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_22__128_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_22__128_40");
  needed_g_t[x_a][22] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_22__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_22__64_40");

  g_d[x_a].resize(19);
  needed_g_d[x_a].resize(19);
  needed_g_d[x_a][0] = {   0,    2,    4,    5,    8,    9}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,    1,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][3] = {   0,    1,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {   1,    3,    6,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][5] = {   2,    3,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   2,    3,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][7] = {   2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][8] = {   4,    5,    6,    7,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {   4,    5,    6,    7,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][10] = {   8,    9,   10,   11,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][11] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][12] = {  12,   13,   34,   35,   40,   41,   54,   55}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][13] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__20_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__20_168");
  needed_g_d[x_a][14] = {  14,   15,   32,   33,   42,   43,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_168__128_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_168__128_40");
  needed_g_d[x_a][15] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][16] = {  16,   17,   42,   43,   46,   47,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][17] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__40_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__40_148");
  needed_g_d[x_a][18] = {  18,   19,   40,   41,   44,   45,   48,   49}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   2,   4}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  1}; //   1
  c_d[x_a][1] = {  4,   1,   2,   3}; //   4

  c_p[x_a][2] = {  5,   6,   7,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   5,   6,   7}; //   4

  c_p[x_a][3] = {  5,   6,   7,   4}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  1}; //   1
  c_d[x_a][3] = {  4,   5,   6,   7}; //   4

  c_p[x_a][4] = {  8,   9,  10,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   8,   9,   7}; //   4

  c_p[x_a][5] = {  5,   9,  10,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   8,   9,   7}; //   4

  c_p[x_a][6] = {  8,   9,  10,   4}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  1}; //   1
  c_d[x_a][6] = {  4,   8,   9,   7}; //   4

  c_p[x_a][7] = {  5,   9,  10,   4}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  1}; //   1
  c_d[x_a][7] = {  4,   8,   9,   7}; //   4

  c_p[x_a][8] = {  0,  11,  12,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  0,  10,   7,   3}; //   4

  c_p[x_a][9] = {  0,  13,  12,   3}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  0,  10,   7,   3}; //   4

  c_p[x_a][10] = {  0,  11,  12,   4}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  1}; //   1
  c_d[x_a][10] = {  4,  10,   7,   3}; //   4

  c_p[x_a][11] = {  0,  13,  12,   4}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  1}; //   1
  c_d[x_a][11] = {  4,  10,   7,   3}; //   4

  c_p[x_a][12] = {  0,  14,  15,  16}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  1}; //   1
  c_d[x_a][12] = { 11,   7,  12,   3}; //   4

  c_p[x_a][13] = {  0,  14,  17,  16}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  1}; //   1
  c_d[x_a][13] = { 11,   7,  12,   3}; //   4

  c_p[x_a][14] = {  0,  18,  19,  20}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 13,   7,  14,   3}; //   4

  c_p[x_a][15] = {  0,  18,  21,  20}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 13,   7,  14,   3}; //   4

  c_p[x_a][16] = {  8,  22,  23,  24}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  1}; //   1
  c_d[x_a][16] = { 15,   3,  16,   7}; //   4

  c_p[x_a][17] = {  5,  22,  23,  24}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  1}; //   1
  c_d[x_a][17] = { 15,   3,  16,   7}; //   4

  c_p[x_a][18] = {  8,  25,  26,  27}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 17,   3,  18,   7}; //   4

  c_p[x_a][19] = {  5,  25,  26,  27}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 17,   3,  18,   7}; //   4

  c_p[x_a][20] = {  0,   1,   2}; //   3
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  0,   2}; //   2
  c_d[x_a][20] = {  1,   2,   3}; //   3

  c_p[x_a][21] = {  0,   1,   2}; //   3
  c_f[x_a][21] = {  1}; //   1
  c_t[x_a][21] = {  1,   3}; //   2
  c_d[x_a][21] = {  1,   2,   3}; //   3

  c_p[x_a][22] = {  5,   6,   7}; //   3
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  0,   2}; //   2
  c_d[x_a][22] = {  5,   6,   7}; //   3

  c_p[x_a][23] = {  5,   6,   7}; //   3
  c_f[x_a][23] = {  1}; //   1
  c_t[x_a][23] = {  1,   3}; //   2
  c_d[x_a][23] = {  5,   6,   7}; //   3

  c_p[x_a][24] = {  8,   9,  10}; //   3
  c_f[x_a][24] = {  0}; //   1
  c_t[x_a][24] = {  0,   2}; //   2
  c_d[x_a][24] = {  8,   9,   7}; //   3

  c_p[x_a][25] = {  5,   9,  10}; //   3
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  0,   2}; //   2
  c_d[x_a][25] = {  8,   9,   7}; //   3

  c_p[x_a][26] = {  8,   9,  10}; //   3
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  1,   3}; //   2
  c_d[x_a][26] = {  8,   9,   7}; //   3

  c_p[x_a][27] = {  5,   9,  10}; //   3
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  1,   3}; //   2
  c_d[x_a][27] = {  8,   9,   7}; //   3

  c_p[x_a][28] = {  0,  11,  12}; //   3
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  0,   2}; //   2
  c_d[x_a][28] = { 10,   7,   3}; //   3

  c_p[x_a][29] = {  0,  13,  12}; //   3
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  0,   2}; //   2
  c_d[x_a][29] = { 10,   7,   3}; //   3

  c_p[x_a][30] = {  0,  11,  12}; //   3
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  1,   3}; //   2
  c_d[x_a][30] = { 10,   7,   3}; //   3

  c_p[x_a][31] = {  0,  13,  12}; //   3
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = {  1,   3}; //   2
  c_d[x_a][31] = { 10,   7,   3}; //   3

  c_p[x_a][32] = {  0,  18,  19}; //   3
  c_f[x_a][32] = {  2}; //   1
  c_t[x_a][32] = {  4,   5}; //   2
  c_d[x_a][32] = {  7,  14,   3}; //   3

  c_p[x_a][33] = {  0,  18,  21}; //   3
  c_f[x_a][33] = {  2}; //   1
  c_t[x_a][33] = {  4,   5}; //   2
  c_d[x_a][33] = {  7,  14,   3}; //   3

  c_p[x_a][34] = {  0,  14,  15}; //   3
  c_f[x_a][34] = {  3}; //   1
  c_t[x_a][34] = {  4,   6}; //   2
  c_d[x_a][34] = {  7,  12,   3}; //   3

  c_p[x_a][35] = {  0,  14,  17}; //   3
  c_f[x_a][35] = {  3}; //   1
  c_t[x_a][35] = {  4,   6}; //   2
  c_d[x_a][35] = {  7,  12,   3}; //   3

  c_p[x_a][36] = {  0,  11}; //   2
  c_f[x_a][36] = {  4,   5}; //   2
  c_t[x_a][36] = {  4,   7,   8}; //   3
  c_d[x_a][36] = {  7,   3}; //   2

  c_p[x_a][37] = {  0,  13}; //   2
  c_f[x_a][37] = {  4,   5}; //   2
  c_t[x_a][37] = {  4,   7,   8}; //   3
  c_d[x_a][37] = {  7,   3}; //   2

  c_p[x_a][38] = {  0,  11}; //   2
  c_f[x_a][38] = {  4,   5}; //   2
  c_t[x_a][38] = {  4,   7,   9}; //   3
  c_d[x_a][38] = {  7,   3}; //   2

  c_p[x_a][39] = {  0,  13}; //   2
  c_f[x_a][39] = {  4,   5}; //   2
  c_t[x_a][39] = {  4,   7,   9}; //   3
  c_d[x_a][39] = {  7,   3}; //   2

  c_p[x_a][40] = {  0,  14,  15,  28}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 10}; //   1
  c_d[x_a][40] = { 18,   7,  12,   3}; //   4

  c_p[x_a][41] = {  0,  14,  17,  28}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 10}; //   1
  c_d[x_a][41] = { 18,   7,  12,   3}; //   4

  c_p[x_a][42] = {  0,  18,  19,  29}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 11}; //   1
  c_d[x_a][42] = { 16,   7,  14,   3}; //   4

  c_p[x_a][43] = {  0,  18,  21,  29}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 11}; //   1
  c_d[x_a][43] = { 16,   7,  14,   3}; //   4

  c_p[x_a][44] = {  0,  11,  30}; //   3
  c_f[x_a][44] = {  6}; //   1
  c_t[x_a][44] = { 12,  13}; //   2
  c_d[x_a][44] = { 18,   7,   3}; //   3

  c_p[x_a][45] = {  0,  13,  30}; //   3
  c_f[x_a][45] = {  6}; //   1
  c_t[x_a][45] = { 12,  13}; //   2
  c_d[x_a][45] = { 18,   7,   3}; //   3

  c_p[x_a][46] = {  0,  11,  31}; //   3
  c_f[x_a][46] = {  7}; //   1
  c_t[x_a][46] = { 12,  14}; //   2
  c_d[x_a][46] = { 16,   7,   3}; //   3

  c_p[x_a][47] = {  0,  13,  31}; //   3
  c_f[x_a][47] = {  7}; //   1
  c_t[x_a][47] = { 12,  14}; //   2
  c_d[x_a][47] = { 16,   7,   3}; //   3

  c_p[x_a][48] = {  0,  11,  30}; //   3
  c_f[x_a][48] = {  8}; //   1
  c_t[x_a][48] = {  0,  15}; //   2
  c_d[x_a][48] = { 18,   7,   3}; //   3

  c_p[x_a][49] = {  0,  13,  30}; //   3
  c_f[x_a][49] = {  8}; //   1
  c_t[x_a][49] = {  0,  15}; //   2
  c_d[x_a][49] = { 18,   7,   3}; //   3

  c_p[x_a][50] = {  0,  11,  31}; //   3
  c_f[x_a][50] = {  9}; //   1
  c_t[x_a][50] = {  1,  16}; //   2
  c_d[x_a][50] = { 16,   7,   3}; //   3

  c_p[x_a][51] = {  0,  13,  31}; //   3
  c_f[x_a][51] = {  9}; //   1
  c_t[x_a][51] = {  1,  16}; //   2
  c_d[x_a][51] = { 16,   7,   3}; //   3

  c_p[x_a][52] = {  8,  32,  33}; //   3
  c_f[x_a][52] = { 10}; //   1
  c_t[x_a][52] = {  0,  17}; //   2
  c_d[x_a][52] = { 14,   3,   7}; //   3

  c_p[x_a][53] = {  5,  32,  33}; //   3
  c_f[x_a][53] = { 10}; //   1
  c_t[x_a][53] = {  0,  17}; //   2
  c_d[x_a][53] = { 14,   3,   7}; //   3

  c_p[x_a][54] = {  8,  32,  34}; //   3
  c_f[x_a][54] = { 11}; //   1
  c_t[x_a][54] = {  1,  18}; //   2
  c_d[x_a][54] = { 12,   3,   7}; //   3

  c_p[x_a][55] = {  5,  32,  34}; //   3
  c_f[x_a][55] = { 11}; //   1
  c_t[x_a][55] = {  1,  18}; //   2
  c_d[x_a][55] = { 12,   3,   7}; //   3

  c_p[x_a][56] = {  0,  11}; //   2
  c_f[x_a][56] = { 12,   8}; //   2
  c_t[x_a][56] = {  0,  15,  19}; //   3
  c_d[x_a][56] = {  7,   3}; //   2

  c_p[x_a][57] = {  0,  13}; //   2
  c_f[x_a][57] = { 12,   8}; //   2
  c_t[x_a][57] = {  0,  15,  19}; //   3
  c_d[x_a][57] = {  7,   3}; //   2

  c_p[x_a][58] = {  0,  11}; //   2
  c_f[x_a][58] = { 13,   9}; //   2
  c_t[x_a][58] = {  1,  16,  20}; //   3
  c_d[x_a][58] = {  7,   3}; //   2

  c_p[x_a][59] = {  0,  13}; //   2
  c_f[x_a][59] = { 13,   9}; //   2
  c_t[x_a][59] = {  1,  16,  20}; //   3
  c_d[x_a][59] = {  7,   3}; //   2

  c_p[x_a][60] = {  8,  32}; //   2
  c_f[x_a][60] = { 14,  10}; //   2
  c_t[x_a][60] = {  0,  17,  21}; //   3
  c_d[x_a][60] = {  3,   7}; //   2

  c_p[x_a][61] = {  5,  32}; //   2
  c_f[x_a][61] = { 14,  10}; //   2
  c_t[x_a][61] = {  0,  17,  21}; //   3
  c_d[x_a][61] = {  3,   7}; //   2

  c_p[x_a][62] = {  8,  32}; //   2
  c_f[x_a][62] = { 15,  11}; //   2
  c_t[x_a][62] = {  1,  18,  22}; //   3
  c_d[x_a][62] = {  3,   7}; //   2

  c_p[x_a][63] = {  5,  32}; //   2
  c_f[x_a][63] = { 15,  11}; //   2
  c_t[x_a][63] = {  1,  18,  22}; //   3
  c_d[x_a][63] = {  3,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 15yyyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel    1: 15yyyv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel    2: 15yyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel    3: 15yyyv(1, 2, 128, 64, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel    4: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel    5: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel    6: 15yyyv(1, 2, 128, 64, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel    7: 15yyyv(1, 2, 128, 64, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel    8: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel    9: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   10: 15y2vv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   11: 15y2vv(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   12: 152vyv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,   0,   0,   0)
// channel   13: 152vyv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,  23,   0,   0)
// channel   14: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   15: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   16: 152vyv(1, 2, 128, 8, 32, 64, 4, 16;   0,   0,  24,   0,   0)
// channel   17: 152vyv(1, 2, 128, 8, 32, 64, 4, 16;  23,   0,  24,   0,   0)
// channel   18: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   19: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   20: 114yyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   21: 114yyv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   22: 114yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel   23: 114yyv(1, 2, 128, 64, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel   24: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel   25: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel   26: 114yyv(1, 2, 128, 64, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel   27: 114yyv(1, 2, 128, 64, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel   28: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   29: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   30: 1142vv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   31: 1142vv(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   32: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   33: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   34: 2v13yv(1, 2, 4, 16, 128, 64, 8, 32;  24,   0,   0,   0,   0)
// channel   35: 2v13yv(1, 2, 4, 16, 128, 64, 8, 32;  24,   0,  23,   0,   0)
// channel   36: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   37: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,  23,   0,   0,   0)
// channel   38: 2v112v(1, 2, 4, 16, 128, 64, 8, 32;  24,   0,   0,   0,   0)
// channel   39: 2v112v(1, 2, 4, 16, 128, 64, 8, 32;  24,  23,   0,   0,   0)
// channel   40: 3yv3yv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,   0,   0,   0)
// channel   41: 3yv3yv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,  23,   0,   0)
// channel   42: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   43: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   44: 3yv12v(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,   0,   0,   0)
// channel   45: 3yv12v(1, 2, 128, 4, 16, 64, 8, 32;  24,  23,   0,   0,   0)
// channel   46: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   47: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,  23,   0,   0,   0)
// channel   48: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   49: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   50: 13yv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   51: 13yv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   52: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   53: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
// channel   54: 13yv2v(1, 2, 128, 64, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   55: 13yv2v(1, 2, 128, 64, 8, 32, 4, 16;  23,  24,   0,   0,   0)
// channel   56: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   57: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   58: 112v2v(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   59: 112v2v(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   60: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   61: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
// channel   62: 112v2v(1, 2, 128, 64, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   63: 112v2v(1, 2, 128, 64, 8, 32, 4, 16;  23,  24,   0,   0,   0)
