#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_050_dux_emmumepvmxa(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_050_dux_emmumepvmxa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(23);
  needed_v_smin[x_a].resize(23);
  needed_v_smin[x_a][  0] = {   0,    4,    5,    6,    7,   20,   21,   22,   25,   26,   27,   30,   31,   33,   34,   35,   39,   40,   41,   42,   43,   44,   45,   46,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   65,   66,   67,   68}; //  42
  needed_v_smin[x_a][  1] = {   0,    7,   27,   35}; //   4
  needed_v_smin[x_a][  2] = {   0,    7,   35}; //   3
  needed_v_smin[x_a][  3] = {   1,    2,    3,    4,    5,   10,   13,   14,   15,   16,   21,   22,   23,   24,   25,   26,   28,   29,   32,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   53,   54,   55,   56,   61,   62,   63,   64,   65,   66,   67,   68}; //  44
  needed_v_smin[x_a][  4] = {   1,   10,   32,   36}; //   4
  needed_v_smin[x_a][  5] = {   1,   10,   36}; //   3
  needed_v_smin[x_a][  6] = {   2,    3,   13,   14,   15,   16,   37,   38}; //   8
  needed_v_smin[x_a][  7] = {   2,    3,   15,   16,   37,   38}; //   6
  needed_v_smin[x_a][  8] = {   4,    5,   21,   22,   39,   40,   41,   42,   43,   44,   65,   66,   67,   68}; //  14
  needed_v_smin[x_a][  9] = {   6,   25,   26,   45,   46,   61,   62,   53,   54}; //   9
  needed_v_smin[x_a][ 10] = {   6,    8}; //   2
  needed_v_smin[x_a][ 11] = {   8,   23,   24,   28,   29,   32,   47,   48,   63,   64}; //  10
  needed_v_smin[x_a][ 12] = {   8,   28,   29,   47,   48,   63,   64}; //   7
  needed_v_smin[x_a][ 13] = {   9,   11,   12,   20,   30,   31,   49,   50,   57,   58}; //  10
  needed_v_smin[x_a][ 14] = {   9,   11,   12,   30,   31,   49,   50,   57,   58}; //   9
  needed_v_smin[x_a][ 15] = {   9,   17}; //   2
  needed_v_smin[x_a][ 16] = {  11,   12,   18,   19}; //   4
  needed_v_smin[x_a][ 17] = {  13,   14}; //   2
  needed_v_smin[x_a][ 18] = {  17,   18,   19,   27,   33,   34,   51,   52,   59,   60}; //  10
  needed_v_smin[x_a][ 19] = {  17,   18,   19,   33,   34,   51,   52,   59,   60}; //   9
  needed_v_smin[x_a][ 20] = {  20}; //   1
  needed_v_smin[x_a][ 21] = {  23,   24}; //   2
  needed_v_smin[x_a][ 22] = {  55,   56}; //   2

  v_smax[x_a].resize(27);
  needed_v_smax[x_a].resize(27);
  needed_v_smax[x_a][  0] = {   0,    4,    5,    6,    7,   21,   22,   25,   26,   27,   35,   39,   40,   41,   42,   45,   46,   53,   54,   57,   58,   59,   60,   65,   66}; //  25
  needed_v_smax[x_a][  1] = {   0,    7,   27,   35}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    7,   10,   15,   16,   21,   22,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   65,   66,   67,   68}; //  26
  needed_v_smax[x_a][  3] = {   1,    2,    3,   10,   13,   14,   15,   16,   32,   36,   37,   38,   43,   44,   55,   56,   61,   62,   63,   64,   67,   68}; //  22
  needed_v_smax[x_a][  4] = {   1,   10,   32,   36}; //   4
  needed_v_smax[x_a][  5] = {   2,    3,   13,   14,   15,   16,   37,   38}; //   8
  needed_v_smax[x_a][  6] = {   4,    5,   21,   22,   39,   40,   41,   42,   53,   54,   65,   66}; //  12
  needed_v_smax[x_a][  7] = {   6,    8,   25,   26,   28,   29,   45,   46,   47,   48}; //  10
  needed_v_smax[x_a][  8] = {   6,    8,   20}; //   3
  needed_v_smax[x_a][  9] = {   8,   23,   24,   28,   29,   47,   48}; //   7
  needed_v_smax[x_a][ 10] = {   9,   11,   12,   20,   30,   31,   49,   50}; //   8
  needed_v_smax[x_a][ 11] = {   9,   11,   12,   17,   18,   19,   30,   31,   33,   34,   49,   50,   51,   52}; //  14
  needed_v_smax[x_a][ 12] = {   9,   17}; //   2
  needed_v_smax[x_a][ 13] = {  11,   12,   13,   14,   18,   19,   23,   24}; //   8
  needed_v_smax[x_a][ 14] = {  17,   18,   19,   33,   34,   51,   52}; //   7
  needed_v_smax[x_a][ 15] = {  20}; //   1
  needed_v_smax[x_a][ 16] = {  23,   24}; //   2
  needed_v_smax[x_a][ 17] = {  25,   26,   28,   29,   45,   46,   47,   48}; //   8
  needed_v_smax[x_a][ 18] = {  27}; //   1
  needed_v_smax[x_a][ 19] = {  30,   31,   33,   34,   49,   50,   51,   52}; //   8
  needed_v_smax[x_a][ 20] = {  32}; //   1
  needed_v_smax[x_a][ 21] = {  43,   44,   55,   56,   61,   62,   67,   68}; //   8
  needed_v_smax[x_a][ 22] = {  57,   58}; //   2
  needed_v_smax[x_a][ 23] = {  57,   58,   59,   60,   55,   56}; //   6
  needed_v_smax[x_a][ 24] = {  59,   60}; //   2
  needed_v_smax[x_a][ 25] = {  61,   62,   63,   64,   53,   54}; //   6
  needed_v_smax[x_a][ 26] = {  63,   64}; //   2

  g_p[x_a].resize(45);
  needed_g_p[x_a].resize(45);
  needed_g_p[x_a][0] = {   0,    4,    5,    6,    7,   21,   22,   25,   26,   27,   35,   39,   40,   41,   42,   45,   46,   53,   54,   57,   58,   59,   60,   65,   66}; //  25
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    7,   27,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    7,   35}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   10,   14,   16,   32,   36,   38,   44,   56,   62,   64,   68}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][4] = {   1,   10,   32,   36}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   1,   10,   36}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax2");
  needed_g_p[x_a][6] = {   2,   13,   15,   37,   43,   55,   61,   63,   67}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][7] = {   2,    3,   13,   14,   15,   16,   37,   38}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   2,    3,   15,   16,   37,   38}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   21,   39,   41,   53,   65}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax6");
  needed_g_p[x_a][10] = {   4,    5,   21,   22,   39,   40}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   22,   40,   42,   54,   66}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax6");
  needed_g_p[x_a][12] = {   6,   25,   26,   45,   46}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax7");
  needed_g_p[x_a][13] = {   6,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {   8,   23,   24,   28,   29,   47,   48}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][15] = {   8,   28,   29,   47,   48}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax7");
  needed_g_p[x_a][16] = {   9,   11,   12,   20,   30,   31,   49,   50}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][17] = {   9,   12,   31,   50}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin14_smax11");
  needed_g_p[x_a][18] = {   9,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][19] = {  11,   30,   49}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][20] = {  11,   12,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax13");
  needed_g_p[x_a][21] = {  13,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax13");
  needed_g_p[x_a][22] = {  17,   18,   19,   33,   34,   51,   52}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax14");
  needed_g_p[x_a][23] = {  17,   19,   34,   52}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin19_smax11");
  needed_g_p[x_a][24] = {  18,   33,   51}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax11");
  needed_g_p[x_a][25] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax15");
  needed_g_p[x_a][26] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax8");
  needed_g_p[x_a][27] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax16");
  needed_g_p[x_a][28] = {  23,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax13");
  needed_g_p[x_a][29] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax16");
  needed_g_p[x_a][30] = {  25,   28,   45,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax17");
  needed_g_p[x_a][31] = {  26,   29,   46,   48}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax17");
  needed_g_p[x_a][32] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax18");
  needed_g_p[x_a][33] = {  30,   31,   33,   34,   49,   50,   51,   52}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax19");
  needed_g_p[x_a][34] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax20");
  needed_g_p[x_a][35] = {  43,   44,   55,   56,   61,   62,   67,   68}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax21");
  needed_g_p[x_a][36] = {  57,   58}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax22");
  needed_g_p[x_a][37] = {  57}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax23");
  needed_g_p[x_a][38] = {  58}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin14_smax23");
  needed_g_p[x_a][39] = {  59,   60}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax24");
  needed_g_p[x_a][40] = {  59}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax23");
  needed_g_p[x_a][41] = {  60}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin19_smax23");
  needed_g_p[x_a][42] = {  61,   62}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax25");
  needed_g_p[x_a][43] = {  63,   64}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax26");
  needed_g_p[x_a][44] = {  63,   64}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax25");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  41,   42,   43,   44,   65,   66,   67,   68}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax2");
  needed_g_f[x_a][1] = {  53,   54}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax25");
  needed_g_f[x_a][2] = {  55,   56}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax23");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,   41,   42,   43,   44}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  35,   36,   37,   38,   39,   40,   65,   66,   67,   68}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  41,   42}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__20_40");
  needed_g_t[x_a][3] = {  43,   44}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__40_20");
  needed_g_t[x_a][4] = {  45,   46,   47,   48,   53,   54}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_104");
  needed_g_t[x_a][5] = {  49,   50,   51,   52,   55,   56}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_84");
  needed_g_t[x_a][6] = {  53,   54}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_64");
  needed_g_t[x_a][7] = {  55,   56}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_64");
  needed_g_t[x_a][8] = {  57,   58,   59,   60}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_84");
  needed_g_t[x_a][9] = {  61,   62,   63,   64}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_104");
  needed_g_t[x_a][10] = {  65,   66}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_20");
  needed_g_t[x_a][11] = {  67,   68}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_40");

  g_d[x_a].resize(30);
  needed_g_d[x_a].resize(30);
  needed_g_d[x_a][0] = {   0,    7,   35}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    7,   27,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][2] = {   0,    4,    5,    6,    7,   20,   21,   22,   25,   26,   27,   30,   31,   33,   34,   35,   39,   40,   41,   42,   43,   44,   45,   46,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   65,   66,   67,   68}; //  42
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   1,   10,   36}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][4] = {   1,   10,   32,   36}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][5] = {   1,    2,    3,    4,    5,   10,   13,   14,   15,   16,   21,   22,   23,   24,   25,   26,   28,   29,   32,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   53,   54,   55,   56,   61,   62,   63,   64,   65,   66,   67,   68}; //  44
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {   2,    3,   15,   16,   37,   38}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   2,    3,   13,   14,   15,   16,   37,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {   4,    5,   21,   22,   39,   40}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][9] = {   6,    8,   20}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__4_120");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__4_120");
  needed_g_d[x_a][10] = {   6,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__16_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__16_104");
  needed_g_d[x_a][11] = {   6,   25,   26,   45,   46,   61,   62}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][12] = {   7,   10,   15,   16,   21,   22}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][13] = {   8,   28,   29,   47,   48,   63,   64}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__32_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__32_72");
  needed_g_d[x_a][14] = {   8,   23,   24,   28,   29,   32,   47,   48,   63,   64}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][15] = {   9,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__8_116");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__8_116");
  needed_g_d[x_a][16] = {   9,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__32_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__32_84");
  needed_g_d[x_a][17] = {   9,   11,   12,   30,   31,   49,   50,   57,   58}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__4_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__4_80");
  needed_g_d[x_a][18] = {   9,   11,   12,   20,   30,   31,   49,   50,   57,   58}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][19] = {  11,   12,   13,   14,   18,   19,   23,   24}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][20] = {  11,   12,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__8_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__8_84");
  needed_g_d[x_a][21] = {  13,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][22] = {  17,   18,   19,   33,   34,   51,   52,   59,   60}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__16_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__16_68");
  needed_g_d[x_a][23] = {  17,   18,   19,   27,   33,   34,   51,   52,   59,   60}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][24] = {  20}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__40_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__40_80");
  needed_g_d[x_a][25] = {  23,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__20_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__20_72");
  needed_g_d[x_a][26] = {  25,   26,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][27] = {  27}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__68_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__68_56");
  needed_g_d[x_a][28] = {  30,   31,   33,   34}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][29] = {  32}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__72_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__72_52");

  c_p[x_a].resize(69);
  c_f[x_a].resize(69);
  c_t[x_a].resize(69);
  c_d[x_a].resize(69);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  3,   4,   5}; //   3

  c_p[x_a][2] = {  6,   7,   8}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  6,   7,   5}; //   3

  c_p[x_a][3] = {  3,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  8,   5,   2}; //   3

  c_p[x_a][5] = {  0,  11,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   5,   2}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  9,  10,  11,   2}; //   4

  c_p[x_a][7] = {  0,   1,   2}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 12,   0,   1,   2}; //   4

  c_p[x_a][8] = { 14,  15,  13}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  9,  10,  13,  14}; //   4

  c_p[x_a][9] = { 16,  17,  18}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 15,  16,  17,  18}; //   4

  c_p[x_a][10] = {  3,   4,   5}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 12,   3,   4,   5}; //   4

  c_p[x_a][11] = { 16,  19,  20}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 19,  20,  17,  18}; //   4

  c_p[x_a][12] = { 16,  17,  20}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 19,  20,  17,  18}; //   4

  c_p[x_a][13] = {  6,   7,  21}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 19,  21,   7,   5}; //   4

  c_p[x_a][14] = {  3,   7,  21}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 19,  21,   7,   5}; //   4

  c_p[x_a][15] = {  6,   7,   8}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 12,   6,   7,   5}; //   4

  c_p[x_a][16] = {  3,   7,   8}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 12,   6,   7,   5}; //   4

  c_p[x_a][17] = { 22,  23,  18}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 15,  16,  22,  23}; //   4

  c_p[x_a][18] = { 22,  24,  20}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 19,  20,  22,  23}; //   4

  c_p[x_a][19] = { 22,  23,  20}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 19,  20,  22,  23}; //   4

  c_p[x_a][20] = { 16,  25,  26}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  9,  24,   2,  18}; //   4

  c_p[x_a][21] = {  0,   9,  10}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 12,   8,   5,   2}; //   4

  c_p[x_a][22] = {  0,  11,  10}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 12,   8,   5,   2}; //   4

  c_p[x_a][23] = { 14,  27,  28}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 19,  25,   5,  14}; //   4

  c_p[x_a][24] = { 14,  29,  28}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 19,  25,   5,  14}; //   4

  c_p[x_a][25] = {  0,  12,  30}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 26,   5,  11,   2}; //   4

  c_p[x_a][26] = {  0,  12,  31}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 26,   5,  11,   2}; //   4

  c_p[x_a][27] = {  0,   1,  32}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 27,  23,   1,   2}; //   4

  c_p[x_a][28] = { 14,  15,  30}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 26,   5,  13,  14}; //   4

  c_p[x_a][29] = { 14,  15,  31}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 26,   5,  13,  14}; //   4

  c_p[x_a][30] = { 16,  19,  33}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 28,   2,  17,  18}; //   4

  c_p[x_a][31] = { 16,  17,  33}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 28,   2,  17,  18}; //   4

  c_p[x_a][32] = {  3,   4,  34}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 29,  14,   4,   5}; //   4

  c_p[x_a][33] = { 22,  24,  33}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 28,   2,  22,  23}; //   4

  c_p[x_a][34] = { 22,  23,  33}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 28,   2,  22,  23}; //   4

  c_p[x_a][35] = {  0,   1,   2}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  1}; //   1
  c_d[x_a][35] = {  0,   1,   2}; //   3

  c_p[x_a][36] = {  3,   4,   5}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  1}; //   1
  c_d[x_a][36] = {  3,   4,   5}; //   3

  c_p[x_a][37] = {  6,   7,   8}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  1}; //   1
  c_d[x_a][37] = {  6,   7,   5}; //   3

  c_p[x_a][38] = {  3,   7,   8}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  1}; //   1
  c_d[x_a][38] = {  6,   7,   5}; //   3

  c_p[x_a][39] = {  0,   9,  10}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  1}; //   1
  c_d[x_a][39] = {  8,   5,   2}; //   3

  c_p[x_a][40] = {  0,  11,  10}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  1}; //   1
  c_d[x_a][40] = {  8,   5,   2}; //   3

  c_p[x_a][41] = {  0,   9}; //   2
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  0,   2}; //   2
  c_d[x_a][41] = {  5,   2}; //   2

  c_p[x_a][42] = {  0,  11}; //   2
  c_f[x_a][42] = {  0}; //   1
  c_t[x_a][42] = {  0,   2}; //   2
  c_d[x_a][42] = {  5,   2}; //   2

  c_p[x_a][43] = {  6,  35}; //   2
  c_f[x_a][43] = {  0}; //   1
  c_t[x_a][43] = {  0,   3}; //   2
  c_d[x_a][43] = {  2,   5}; //   2

  c_p[x_a][44] = {  3,  35}; //   2
  c_f[x_a][44] = {  0}; //   1
  c_t[x_a][44] = {  0,   3}; //   2
  c_d[x_a][44] = {  2,   5}; //   2

  c_p[x_a][45] = {  0,  12,  30}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  4}; //   1
  c_d[x_a][45] = {  5,  11,   2}; //   3

  c_p[x_a][46] = {  0,  12,  31}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  4}; //   1
  c_d[x_a][46] = {  5,  11,   2}; //   3

  c_p[x_a][47] = { 14,  15,  30}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  4}; //   1
  c_d[x_a][47] = {  5,  13,  14}; //   3

  c_p[x_a][48] = { 14,  15,  31}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  4}; //   1
  c_d[x_a][48] = {  5,  13,  14}; //   3

  c_p[x_a][49] = { 16,  19,  33}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  5}; //   1
  c_d[x_a][49] = {  2,  17,  18}; //   3

  c_p[x_a][50] = { 16,  17,  33}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  5}; //   1
  c_d[x_a][50] = {  2,  17,  18}; //   3

  c_p[x_a][51] = { 22,  24,  33}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  5}; //   1
  c_d[x_a][51] = {  2,  22,  23}; //   3

  c_p[x_a][52] = { 22,  23,  33}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  5}; //   1
  c_d[x_a][52] = {  2,  22,  23}; //   3

  c_p[x_a][53] = {  0,   9}; //   2
  c_f[x_a][53] = {  1}; //   1
  c_t[x_a][53] = {  4,   6}; //   2
  c_d[x_a][53] = {  5,   2}; //   2

  c_p[x_a][54] = {  0,  11}; //   2
  c_f[x_a][54] = {  1}; //   1
  c_t[x_a][54] = {  4,   6}; //   2
  c_d[x_a][54] = {  5,   2}; //   2

  c_p[x_a][55] = {  6,  35}; //   2
  c_f[x_a][55] = {  2}; //   1
  c_t[x_a][55] = {  5,   7}; //   2
  c_d[x_a][55] = {  2,   5}; //   2

  c_p[x_a][56] = {  3,  35}; //   2
  c_f[x_a][56] = {  2}; //   1
  c_t[x_a][56] = {  5,   7}; //   2
  c_d[x_a][56] = {  2,   5}; //   2

  c_p[x_a][57] = {  0,  36,  37}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  8}; //   1
  c_d[x_a][57] = { 17,  18,   2}; //   3

  c_p[x_a][58] = {  0,  36,  38}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  8}; //   1
  c_d[x_a][58] = { 17,  18,   2}; //   3

  c_p[x_a][59] = {  0,  39,  40}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  8}; //   1
  c_d[x_a][59] = { 22,  23,   2}; //   3

  c_p[x_a][60] = {  0,  39,  41}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  8}; //   1
  c_d[x_a][60] = { 22,  23,   2}; //   3

  c_p[x_a][61] = {  6,  35,  42}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  9}; //   1
  c_d[x_a][61] = { 11,   2,   5}; //   3

  c_p[x_a][62] = {  3,  35,  42}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  9}; //   1
  c_d[x_a][62] = { 11,   2,   5}; //   3

  c_p[x_a][63] = {  6,  43,  44}; //   3
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  9}; //   1
  c_d[x_a][63] = { 13,  14,   5}; //   3

  c_p[x_a][64] = {  3,  43,  44}; //   3
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  9}; //   1
  c_d[x_a][64] = { 13,  14,   5}; //   3

  c_p[x_a][65] = {  0,   9}; //   2
  c_f[x_a][65] = {  0}; //   1
  c_t[x_a][65] = {  1,  10}; //   2
  c_d[x_a][65] = {  5,   2}; //   2

  c_p[x_a][66] = {  0,  11}; //   2
  c_f[x_a][66] = {  0}; //   1
  c_t[x_a][66] = {  1,  10}; //   2
  c_d[x_a][66] = {  5,   2}; //   2

  c_p[x_a][67] = {  6,  35}; //   2
  c_f[x_a][67] = {  0}; //   1
  c_t[x_a][67] = {  1,  11}; //   2
  c_d[x_a][67] = {  2,   5}; //   2

  c_p[x_a][68] = {  3,  35}; //   2
  c_f[x_a][68] = {  0}; //   1
  c_t[x_a][68] = {  1,  11}; //   2
  c_d[x_a][68] = {  2,   5}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv1(1, 2, 4, 16, 8, 32, 64;  24,   0,  24,   0)
// channel    1: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,  24,   0)
// channel    2: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,  24,   0)
// channel    3: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,  24,   0)
// channel    4: 42vv1(1, 2, 4, 16, 8, 32, 64;  24,   0,  24,   0)
// channel    5: 42vv1(1, 2, 4, 16, 8, 32, 64;  24,  23,  24,   0)
// channel    6: 5yyyv(1, 2, 4, 16, 64, 8, 32;  24,  24,   0,  24)
// channel    7: 5yyyv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,  24)
// channel    8: 5yyyv(1, 2, 4, 16, 32, 8, 64;   0,  24,   0,  24)
// channel    9: 5yyyv(1, 2, 8, 32, 4, 16, 64;   0,  23,   0,  24)
// channel   10: 5yyyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,  24)
// channel   11: 5yyyv(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,  24)
// channel   12: 5yyyv(1, 2, 32, 8, 4, 16, 64;   0,  23,   0,  24)
// channel   13: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,  24)
// channel   14: 5yyyv(1, 2, 32, 64, 8, 4, 16;  23,   0,   0,  24)
// channel   15: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,  24)
// channel   16: 5yyyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,  24)
// channel   17: 5yyyv(1, 2, 8, 32, 16, 4, 64;   0,  23,   0,  24)
// channel   18: 5yyyv(1, 2, 32, 8, 16, 4, 64;   0,   0,   0,  24)
// channel   19: 5yyyv(1, 2, 32, 8, 16, 4, 64;   0,  23,   0,  24)
// channel   20: 5y2vv(1, 2, 4, 8, 32, 16, 64;   0,  24,   0,  24)
// channel   21: 5y2vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,  24)
// channel   22: 5y2vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,  24)
// channel   23: 5y2vv(1, 2, 32, 4, 16, 8, 64;   0,   0,   0,  24)
// channel   24: 5y2vv(1, 2, 32, 4, 16, 8, 64;   0,  23,   0,  24)
// channel   25: 52vyv(1, 2, 4, 16, 64, 8, 32;  24,  24,   0,  24)
// channel   26: 52vyv(1, 2, 4, 16, 64, 8, 32;  24,  24,  23,  24)
// channel   27: 52vyv(1, 2, 4, 64, 16, 8, 32;  24,   0,   0,  24)
// channel   28: 52vyv(1, 2, 4, 16, 32, 8, 64;   0,  24,   0,  24)
// channel   29: 52vyv(1, 2, 4, 16, 32, 8, 64;   0,  24,  23,  24)
// channel   30: 52vyv(1, 2, 8, 32, 4, 16, 64;   0,   0,  24,  24)
// channel   31: 52vyv(1, 2, 8, 32, 4, 16, 64;   0,  23,  24,  24)
// channel   32: 52vyv(1, 2, 8, 64, 32, 4, 16;  23,   0,   0,  24)
// channel   33: 52vyv(1, 2, 8, 32, 16, 4, 64;   0,   0,  24,  24)
// channel   34: 52vyv(1, 2, 8, 32, 16, 4, 64;   0,  23,  24,  24)
// channel   35: 14yyv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel   36: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,   0)
// channel   37: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,   0)
// channel   38: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,   0)
// channel   39: 142vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel   40: 142vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,   0)
// channel   41: 2v2v1(1, 2, 4, 16, 8, 32, 64;  24,   0,   0,   0)
// channel   42: 2v2v1(1, 2, 4, 16, 8, 32, 64;  24,  23,   0,   0)
// channel   43: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,  24,   0,   0)
// channel   44: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,  24,   0,   0)
// channel   45: 2v3yv(1, 2, 4, 16, 64, 8, 32;  24,  24,   0,   0)
// channel   46: 2v3yv(1, 2, 4, 16, 64, 8, 32;  24,  24,  23,   0)
// channel   47: 2v3yv(1, 2, 4, 16, 32, 8, 64;   0,  24,   0,   0)
// channel   48: 2v3yv(1, 2, 4, 16, 32, 8, 64;   0,  24,  23,   0)
// channel   49: 2v3yv(1, 2, 8, 32, 4, 16, 64;   0,   0,  24,   0)
// channel   50: 2v3yv(1, 2, 8, 32, 4, 16, 64;   0,  23,  24,   0)
// channel   51: 2v3yv(1, 2, 8, 32, 16, 4, 64;   0,   0,  24,   0)
// channel   52: 2v3yv(1, 2, 8, 32, 16, 4, 64;   0,  23,  24,   0)
// channel   53: 2v12v(1, 2, 4, 16, 64, 8, 32;  24,   0,   0,   0)
// channel   54: 2v12v(1, 2, 4, 16, 64, 8, 32;  24,  23,   0,   0)
// channel   55: 2v12v(1, 2, 8, 32, 64, 4, 16;   0,  24,   0,   0)
// channel   56: 2v12v(1, 2, 8, 32, 64, 4, 16;  23,  24,   0,   0)
// channel   57: 3yv2v(1, 2, 4, 16, 64, 8, 32;  24,   0,   0,   0)
// channel   58: 3yv2v(1, 2, 4, 16, 64, 8, 32;  24,   0,  23,   0)
// channel   59: 3yv2v(1, 2, 16, 4, 64, 8, 32;  24,   0,   0,   0)
// channel   60: 3yv2v(1, 2, 16, 4, 64, 8, 32;  24,   0,  23,   0)
// channel   61: 3yv2v(1, 2, 64, 8, 32, 4, 16;   0,  24,  24,   0)
// channel   62: 3yv2v(1, 2, 64, 8, 32, 4, 16;  23,  24,  24,   0)
// channel   63: 3yv2v(1, 2, 32, 8, 64, 4, 16;   0,   0,  24,   0)
// channel   64: 3yv2v(1, 2, 32, 8, 64, 4, 16;  23,   0,  24,   0)
// channel   65: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,   0,   0,   0)
// channel   66: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,  23,   0,   0)
// channel   67: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,  24,   0,   0)
// channel   68: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,  24,   0,   0)
