#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_050_uxa_emmumepvmxdx(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_050_uxa_emmumepvmxdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(31);
  needed_v_smin[x_a].resize(31);
  needed_v_smin[x_a][  0] = {   7,    8,   13,   14,   20,   21,   22,   23,   24,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   41,   44,   45,   46,   47,   48,   50,   51,   52,   53,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   54}; //  45
  needed_v_smin[x_a][  1] = {   9,   10,   11,   12,   15,   16,   17,   18,   19,   23,   24,   25,   29,   30,   31,   32,   33,   34,   37,   38,   39,   40,   42,   43,   47,   48,   49,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68}; //  42
  needed_v_smin[x_a][  2] = {  13,   14,   33,   34,   61,   62,   65,   66}; //   8
  needed_v_smin[x_a][  3] = {  15,   16,   17,   18,   31,   32,   59,   60,   63,   64}; //  10
  needed_v_smin[x_a][  4] = {  19,   25,   42,   43,   39,   40}; //   6
  needed_v_smin[x_a][  5] = {  19,   25,   43,    4,    5,    6,   39,   40,   42}; //   9
  needed_v_smin[x_a][  6] = {  20,   26,   41,   44,   35,   36,   50,   51}; //   8
  needed_v_smin[x_a][  7] = {  20,   26,   44,    0,   35,   36,   41,   50,   51}; //   9
  needed_v_smin[x_a][  8] = {  21,   22,   27,   28,   45,   46,   52,   53}; //   8
  needed_v_smin[x_a][  9] = {  21,   22,   27,   28,   45,   46,   52,   53}; //   8
  needed_v_smin[x_a][ 10] = {  23,   24,   29,   30,   47,   48,   54,   55,   56,   57,   58,   67,   68}; //  13
  needed_v_smin[x_a][ 11] = {   0,    4}; //   2
  needed_v_smin[x_a][ 12] = {   0}; //   1
  needed_v_smin[x_a][ 13] = {   1}; //   1
  needed_v_smin[x_a][ 14] = {   1}; //   1
  needed_v_smin[x_a][ 15] = {   1,    2,    3,   37,   38,   49}; //   6
  needed_v_smin[x_a][ 16] = {   2,    3}; //   2
  needed_v_smin[x_a][ 17] = {   2,    3}; //   2
  needed_v_smin[x_a][ 18] = {   4}; //   1
  needed_v_smin[x_a][ 19] = {   5,    6}; //   2
  needed_v_smin[x_a][ 20] = {   5,    6}; //   2
  needed_v_smin[x_a][ 21] = {   7,    8}; //   2
  needed_v_smin[x_a][ 22] = {   7,    8}; //   2
  needed_v_smin[x_a][ 23] = {   9,   10}; //   2
  needed_v_smin[x_a][ 24] = {   9,   10}; //   2
  needed_v_smin[x_a][ 25] = {  11,   12}; //   2
  needed_v_smin[x_a][ 26] = {  11,   12}; //   2
  needed_v_smin[x_a][ 27] = {  13,   14}; //   2
  needed_v_smin[x_a][ 28] = {  15,   16}; //   2
  needed_v_smin[x_a][ 29] = {  17,   18}; //   2
  needed_v_smin[x_a][ 30] = {  37,   38,   49}; //   3

  v_smax[x_a].resize(25);
  needed_v_smax[x_a].resize(25);
  needed_v_smax[x_a][  0] = {   7,    8,   13,   14,   20,   21,   22,   26,   27,   28,   33,   34,   35,   36,   41,   44,   45,   46,   50,   51,   52,   53,   57,   58,   61,   62}; //  26
  needed_v_smax[x_a][  1] = {   9,   10,   11,   12,   15,   16,   17,   18,   19,   23,   24,   25,   29,   30,   31,   32,   37,   38,   39,   40,   42,   43,   47,   48,   49,   54,   55,   56,   59,   60,   63,   64,   65,   66,   67,   68}; //  36
  needed_v_smax[x_a][  2] = {  13,   14,   33,   34,   61,   62}; //   6
  needed_v_smax[x_a][  3] = {  15,   16,   17,   18,   31,   32,   59,   60}; //   8
  needed_v_smax[x_a][  4] = {  19,   25,   42,   43,    4,    5,    6,   39,   40}; //   9
  needed_v_smax[x_a][  5] = {  19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   43,   44,   45,   46,   47,   48,    0,    1,    2,    3,    4,    5,    6,   35,   36,   37,   38,   39,   40,   41,   42,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   67,   68}; //  45
  needed_v_smax[x_a][  6] = {  20,   26,   41,   44,    0,   35,   36,   50,   51}; //   9
  needed_v_smax[x_a][  7] = {  21,   22,   27,   28,   45,   46,   52,   53}; //   8
  needed_v_smax[x_a][  8] = {  23,   24,   29,   30,   47,   48,   55,   56,   63,   64,   65,   66,   67,   68,   54}; //  15
  needed_v_smax[x_a][  9] = {  31,   32,   59,   60}; //   4
  needed_v_smax[x_a][ 10] = {  33,   34,   61,   62}; //   4
  needed_v_smax[x_a][ 11] = {  57,   58}; //   2
  needed_v_smax[x_a][ 12] = {  65,   66}; //   2
  needed_v_smax[x_a][ 13] = {   0,    4}; //   2
  needed_v_smax[x_a][ 14] = {   1}; //   1
  needed_v_smax[x_a][ 15] = {   1,    2,    3,   37,   38,   49}; //   6
  needed_v_smax[x_a][ 16] = {   2,    3}; //   2
  needed_v_smax[x_a][ 17] = {   5,    6}; //   2
  needed_v_smax[x_a][ 18] = {   7,    8}; //   2
  needed_v_smax[x_a][ 19] = {   7,    8,   13,   14}; //   4
  needed_v_smax[x_a][ 20] = {   9,   10}; //   2
  needed_v_smax[x_a][ 21] = {   9,   10,   15,   16}; //   4
  needed_v_smax[x_a][ 22] = {  11,   12}; //   2
  needed_v_smax[x_a][ 23] = {  11,   12,   17,   18}; //   4
  needed_v_smax[x_a][ 24] = {  63,   64}; //   2

  g_p[x_a].resize(19);
  needed_g_p[x_a].resize(19);
  needed_g_p[x_a][0] = {   7,   13,   21,   27,   33,   35,   45,   50,   52,   57,   61}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   8,   14,   20,   22,   26,   28,   34,   36,   41,   44,   46,   51,   53,   58,   62}; //  15
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   9,   10,   11,   12,   15,   16,   17,   18,   19,   23,   24,   25,   29,   30,   31,   32,   37,   38,   39,   40,   42,   43,   47,   48,   49,   54,   55,   56,   59,   60,   63,   64,   65,   66,   67,   68}; //  36
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][3] = {  13,   14,   33,   34,   61,   62}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {  15,   16,   17,   18,   31,   32,   59,   60}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {  19,   25,   42,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {  19,   25,   43}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax5");
  needed_g_p[x_a][7] = {  20,   26,   41,   44}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][8] = {  20,   26,   44}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax5");
  needed_g_p[x_a][9] = {  21,   22,   27,   28,   45,   46,   52,   53}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {  21,   22,   27,   28,   45,   46}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax5");
  needed_g_p[x_a][11] = {  23,   29,   47,   55,   63,   65,   67}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax8");
  needed_g_p[x_a][12] = {  23,   24,   29,   30,   47,   48}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax5");
  needed_g_p[x_a][13] = {  24,   30,   48,   56,   64,   66,   68}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");
  needed_g_p[x_a][14] = {  31,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");
  needed_g_p[x_a][15] = {  32,   60}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][16] = {  33,   34,   61,   62}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax10");
  needed_g_p[x_a][17] = {  57,   58}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax11");
  needed_g_p[x_a][18] = {  65,   66}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax12");

  g_f[x_a].resize(28);
  needed_g_f[x_a].resize(28);
  needed_g_f[x_a][0] = {   0,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax13");
  needed_g_f[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax6");
  needed_g_f[x_a][2] = {   0,   35,   36,   41,   50,   51}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax14");
  needed_g_f[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax15");
  needed_g_f[x_a][5] = {   1,    2,    3,   37,   38,   49}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax5");
  needed_g_f[x_a][6] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax16");
  needed_g_f[x_a][7] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax15");
  needed_g_f[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax4");
  needed_g_f[x_a][9] = {   4,    5,    6,   39,   40,   42}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][10] = {   5,    6}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax17");
  needed_g_f[x_a][11] = {   5,    6}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax4");
  needed_g_f[x_a][12] = {   7,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax18");
  needed_g_f[x_a][13] = {   7,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax19");
  needed_g_f[x_a][14] = {   9,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax20");
  needed_g_f[x_a][15] = {   9,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax21");
  needed_g_f[x_a][16] = {  11,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax22");
  needed_g_f[x_a][17] = {  11,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax23");
  needed_g_f[x_a][18] = {  13,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax19");
  needed_g_f[x_a][19] = {  15,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax21");
  needed_g_f[x_a][20] = {  17,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax23");
  needed_g_f[x_a][21] = {  35,   36,   50,   51}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax6");
  needed_g_f[x_a][22] = {  37,   38,   49}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax15");
  needed_g_f[x_a][23] = {  39,   40}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][24] = {  52,   53}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax5");
  needed_g_f[x_a][25] = {  54}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax8");
  needed_g_f[x_a][26] = {  54,   55,   56,   57,   58,   67,   68}; //   7
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax5");
  needed_g_f[x_a][27] = {  63,   64}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax24");

  g_t[x_a].resize(49);
  needed_g_t[x_a].resize(49);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   67,   68}; //  29
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__64_60");
  needed_g_t[x_a][1] = {   0,   35,   36,   41,   50,   51}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__8_52");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__4_48");
  needed_g_t[x_a][3] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_69__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_69__32_16");
  needed_g_t[x_a][4] = {   1,    2,    3,   37,   38,   49}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__8_36");
  needed_g_t[x_a][6] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__18_73__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__18_73__4_32");
  needed_g_t[x_a][7] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][8] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_97__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_97__4_8");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__18_97__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__18_97__4_8");
  needed_g_t[x_a][10] = {   4,    5,    6,   39,   40,   42}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__4_56");
  needed_g_t[x_a][11] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__8_48");
  needed_g_t[x_a][12] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_73__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_73__16_32");
  needed_g_t[x_a][13] = {   5,    6}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__32_24");
  needed_g_t[x_a][14] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_97__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_97__16_8");
  needed_g_t[x_a][15] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_97__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_97__16_8");
  needed_g_t[x_a][16] = {   7,    8,   13,   14}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][17] = {   7,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__20_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__20_96");
  needed_g_t[x_a][18] = {   7,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_21__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_21__32_64");
  needed_g_t[x_a][19] = {   9,   10,   15,   16}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][20] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__40_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__40_68");
  needed_g_t[x_a][21] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_41__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_41__4_64");
  needed_g_t[x_a][22] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__18_41__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__18_41__4_64");
  needed_g_t[x_a][23] = {  11,   12,   17,   18}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][24] = {  11,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__40_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__40_80");
  needed_g_t[x_a][25] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_41__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_41__16_64");
  needed_g_t[x_a][26] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_41__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_41__16_64");
  needed_g_t[x_a][27] = {  13,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__10_1__32_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__10_1__32_84");
  needed_g_t[x_a][28] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__4_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__4_104");
  needed_g_t[x_a][29] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__18_1__4_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__18_1__4_104");
  needed_g_t[x_a][30] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__16_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__16_104");
  needed_g_t[x_a][31] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__6_1__16_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__6_1__16_104");
  needed_g_t[x_a][32] = {  19,   20,   21,   22,   23,   24,   55,   56,   57,   58}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][33] = {  35,   36}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_65__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_65__32_20");
  needed_g_t[x_a][34] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_65__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_65__4_40");
  needed_g_t[x_a][35] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__18_65__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__18_65__4_40");
  needed_g_t[x_a][36] = {  39}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_65__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_65__16_40");
  needed_g_t[x_a][37] = {  40}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_65__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_65__16_40");
  needed_g_t[x_a][38] = {  49}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__4_40");
  needed_g_t[x_a][39] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__32_20");
  needed_g_t[x_a][40] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__32_28");
  needed_g_t[x_a][41] = {  54,   67,   68}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_65__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_65__40_20");
  needed_g_t[x_a][42] = {  54}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_42__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_42__4_16");
  needed_g_t[x_a][43] = {  55,   56}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__20_40");
  needed_g_t[x_a][44] = {  57,   58}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__40_20");
  needed_g_t[x_a][45] = {  59,   60,   63,   64}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_104");
  needed_g_t[x_a][46] = {  61,   62}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_84");
  needed_g_t[x_a][47] = {  63,   64}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_21__40_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_21__40_64");
  needed_g_t[x_a][48] = {  65,   66}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__40_84");

  g_d[x_a].resize(14);
  needed_g_d[x_a].resize(14);
  needed_g_d[x_a][0] = {   7,    8,   13,   14,   20,   21,   22,   23,   24,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   41,   44,   45,   46,   47,   48,   50,   51,   52,   53,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68}; //  44
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][1] = {   9,   10,   11,   12,   15,   16,   17,   18,   19,   23,   24,   25,   29,   30,   31,   32,   33,   34,   37,   38,   39,   40,   42,   43,   47,   48,   49,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68}; //  42
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][2] = {  13,   14,   33,   34,   61,   62,   65,   66}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][3] = {  15,   16,   17,   18,   31,   32,   59,   60}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][4] = {  19,   25,   43}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][5] = {  19,   25,   42,   43}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][6] = {  20,   26,   44}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][7] = {  20,   26,   41,   44}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][8] = {  21,   22,   27,   28,   45,   46}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  21,   22,   27,   28,   45,   46,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][10] = {  23,   24,   29,   30,   47,   48}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][11] = {  25,   26,   27,   28,   29,   30}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][12] = {  31,   32}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][13] = {  33,   34}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");

  c_p[x_a].resize(69);
  c_f[x_a].resize(69);
  c_t[x_a].resize(69);
  c_d[x_a].resize(69);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  3,   4,   5}; //   3
  c_t[x_a][1] = {  0,   4,   5,   6}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  6,   7,   5}; //   3
  c_t[x_a][2] = {  0,   4,   7,   8}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  6,   7,   5}; //   3
  c_t[x_a][3] = {  0,   4,   7,   9}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0,   8,   9}; //   3
  c_t[x_a][4] = {  0,  10,  11,  12}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = { 10,  11,   9}; //   3
  c_t[x_a][5] = {  0,  10,  13,  14}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = { 10,  11,   9}; //   3
  c_t[x_a][6] = {  0,  10,  13,  15}; //   4
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = { 12,  13}; //   2
  c_t[x_a][7] = { 16,  17,  18}; //   3
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  1}; //   1
  c_f[x_a][8] = { 12,  13}; //   2
  c_t[x_a][8] = { 16,  17,  18}; //   3
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  2}; //   1
  c_f[x_a][9] = { 14,  15}; //   2
  c_t[x_a][9] = { 19,  20,  21}; //   3
  c_d[x_a][9] = {  1}; //   1

  c_p[x_a][10] = {  2}; //   1
  c_f[x_a][10] = { 14,  15}; //   2
  c_t[x_a][10] = { 19,  20,  22}; //   3
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  2}; //   1
  c_f[x_a][11] = { 16,  17}; //   2
  c_t[x_a][11] = { 23,  24,  25}; //   3
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  2}; //   1
  c_f[x_a][12] = { 16,  17}; //   2
  c_t[x_a][12] = { 23,  24,  26}; //   3
  c_d[x_a][12] = {  1}; //   1

  c_p[x_a][13] = {  0,   3}; //   2
  c_f[x_a][13] = { 18}; //   1
  c_t[x_a][13] = { 16,  27}; //   2
  c_d[x_a][13] = {  2,   0}; //   2

  c_p[x_a][14] = {  1,   3}; //   2
  c_f[x_a][14] = { 18}; //   1
  c_t[x_a][14] = { 16,  27}; //   2
  c_d[x_a][14] = {  2,   0}; //   2

  c_p[x_a][15] = {  2,   4}; //   2
  c_f[x_a][15] = { 19}; //   1
  c_t[x_a][15] = { 19,  28}; //   2
  c_d[x_a][15] = {  3,   1}; //   2

  c_p[x_a][16] = {  2,   4}; //   2
  c_f[x_a][16] = { 19}; //   1
  c_t[x_a][16] = { 19,  29}; //   2
  c_d[x_a][16] = {  3,   1}; //   2

  c_p[x_a][17] = {  2,   4}; //   2
  c_f[x_a][17] = { 20}; //   1
  c_t[x_a][17] = { 23,  30}; //   2
  c_d[x_a][17] = {  3,   1}; //   2

  c_p[x_a][18] = {  2,   4}; //   2
  c_f[x_a][18] = { 20}; //   1
  c_t[x_a][18] = { 23,  31}; //   2
  c_d[x_a][18] = {  3,   1}; //   2

  c_p[x_a][19] = {  2,   5,   6}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 32}; //   1
  c_d[x_a][19] = {  4,   5,   1}; //   3

  c_p[x_a][20] = {  1,   7,   8}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = { 32}; //   1
  c_d[x_a][20] = {  6,   7,   0}; //   3

  c_p[x_a][21] = {  0,   9,  10}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 32}; //   1
  c_d[x_a][21] = {  8,   9,   0}; //   3

  c_p[x_a][22] = {  1,   9,  10}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 32}; //   1
  c_d[x_a][22] = {  8,   9,   0}; //   3

  c_p[x_a][23] = {  2,  11,  12}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 32}; //   1
  c_d[x_a][23] = { 10,   0,   1}; //   3

  c_p[x_a][24] = {  2,  13,  12}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 32}; //   1
  c_d[x_a][24] = { 10,   0,   1}; //   3

  c_p[x_a][25] = {  2,   5,   6}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 11,   4,   5,   1}; //   4

  c_p[x_a][26] = {  1,   7,   8}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 11,   6,   7,   0}; //   4

  c_p[x_a][27] = {  0,   9,  10}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 11,   8,   9,   0}; //   4

  c_p[x_a][28] = {  1,   9,  10}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 11,   8,   9,   0}; //   4

  c_p[x_a][29] = {  2,  11,  12}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 11,  10,   0,   1}; //   4

  c_p[x_a][30] = {  2,  13,  12}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 11,  10,   0,   1}; //   4

  c_p[x_a][31] = {  2,   4,  14}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 12,   0,   3,   1}; //   4

  c_p[x_a][32] = {  2,   4,  15}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 12,   0,   3,   1}; //   4

  c_p[x_a][33] = {  0,   3,  16}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 13,   1,   2,   0}; //   4

  c_p[x_a][34] = {  1,   3,  16}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 13,   1,   2,   0}; //   4

  c_p[x_a][35] = {  0}; //   1
  c_f[x_a][35] = { 21,   2}; //   2
  c_t[x_a][35] = {  0,   1,  33}; //   3
  c_d[x_a][35] = {  0}; //   1

  c_p[x_a][36] = {  1}; //   1
  c_f[x_a][36] = { 21,   2}; //   2
  c_t[x_a][36] = {  0,   1,  33}; //   3
  c_d[x_a][36] = {  0}; //   1

  c_p[x_a][37] = {  2}; //   1
  c_f[x_a][37] = { 22,   5}; //   2
  c_t[x_a][37] = {  0,   4,  34}; //   3
  c_d[x_a][37] = {  1}; //   1

  c_p[x_a][38] = {  2}; //   1
  c_f[x_a][38] = { 22,   5}; //   2
  c_t[x_a][38] = {  0,   4,  35}; //   3
  c_d[x_a][38] = {  1}; //   1

  c_p[x_a][39] = {  2}; //   1
  c_f[x_a][39] = { 23,   9}; //   2
  c_t[x_a][39] = {  0,  10,  36}; //   3
  c_d[x_a][39] = {  1}; //   1

  c_p[x_a][40] = {  2}; //   1
  c_f[x_a][40] = { 23,   9}; //   2
  c_t[x_a][40] = {  0,  10,  37}; //   3
  c_d[x_a][40] = {  1}; //   1

  c_p[x_a][41] = {  1,   7}; //   2
  c_f[x_a][41] = {  2}; //   1
  c_t[x_a][41] = {  0,   1}; //   2
  c_d[x_a][41] = {  7,   0}; //   2

  c_p[x_a][42] = {  2,   5}; //   2
  c_f[x_a][42] = {  9}; //   1
  c_t[x_a][42] = {  0,  10}; //   2
  c_d[x_a][42] = {  5,   1}; //   2

  c_p[x_a][43] = {  2,   5,   6}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  0}; //   1
  c_d[x_a][43] = {  4,   5,   1}; //   3

  c_p[x_a][44] = {  1,   7,   8}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  0}; //   1
  c_d[x_a][44] = {  6,   7,   0}; //   3

  c_p[x_a][45] = {  0,   9,  10}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  0}; //   1
  c_d[x_a][45] = {  8,   9,   0}; //   3

  c_p[x_a][46] = {  1,   9,  10}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  0}; //   1
  c_d[x_a][46] = {  8,   9,   0}; //   3

  c_p[x_a][47] = {  2,  11,  12}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  0}; //   1
  c_d[x_a][47] = { 10,   0,   1}; //   3

  c_p[x_a][48] = {  2,  13,  12}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  0}; //   1
  c_d[x_a][48] = { 10,   0,   1}; //   3

  c_p[x_a][49] = {  2}; //   1
  c_f[x_a][49] = { 22,   5}; //   2
  c_t[x_a][49] = {  0,   4,  38}; //   3
  c_d[x_a][49] = {  1}; //   1

  c_p[x_a][50] = {  0}; //   1
  c_f[x_a][50] = { 21,   2}; //   2
  c_t[x_a][50] = {  0,   1,  39}; //   3
  c_d[x_a][50] = {  0}; //   1

  c_p[x_a][51] = {  1}; //   1
  c_f[x_a][51] = { 21,   2}; //   2
  c_t[x_a][51] = {  0,   1,  39}; //   3
  c_d[x_a][51] = {  0}; //   1

  c_p[x_a][52] = {  0,   9}; //   2
  c_f[x_a][52] = { 24}; //   1
  c_t[x_a][52] = {  0,  40}; //   2
  c_d[x_a][52] = {  9,   0}; //   2

  c_p[x_a][53] = {  1,   9}; //   2
  c_f[x_a][53] = { 24}; //   1
  c_t[x_a][53] = {  0,  40}; //   2
  c_d[x_a][53] = {  9,   0}; //   2

  c_p[x_a][54] = {  2}; //   1
  c_f[x_a][54] = { 25,  26}; //   2
  c_t[x_a][54] = {  0,  41,  42}; //   3
  c_d[x_a][54] = {  1}; //   1

  c_p[x_a][55] = {  2,  11}; //   2
  c_f[x_a][55] = { 26}; //   1
  c_t[x_a][55] = { 32,  43}; //   2
  c_d[x_a][55] = {  0,   1}; //   2

  c_p[x_a][56] = {  2,  13}; //   2
  c_f[x_a][56] = { 26}; //   1
  c_t[x_a][56] = { 32,  43}; //   2
  c_d[x_a][56] = {  0,   1}; //   2

  c_p[x_a][57] = {  0,  17}; //   2
  c_f[x_a][57] = { 26}; //   1
  c_t[x_a][57] = { 32,  44}; //   2
  c_d[x_a][57] = {  1,   0}; //   2

  c_p[x_a][58] = {  1,  17}; //   2
  c_f[x_a][58] = { 26}; //   1
  c_t[x_a][58] = { 32,  44}; //   2
  c_d[x_a][58] = {  1,   0}; //   2

  c_p[x_a][59] = {  2,   4,  14}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = { 45}; //   1
  c_d[x_a][59] = {  0,   3,   1}; //   3

  c_p[x_a][60] = {  2,   4,  15}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = { 45}; //   1
  c_d[x_a][60] = {  0,   3,   1}; //   3

  c_p[x_a][61] = {  0,   3,  16}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = { 46}; //   1
  c_d[x_a][61] = {  1,   2,   0}; //   3

  c_p[x_a][62] = {  1,   3,  16}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = { 46}; //   1
  c_d[x_a][62] = {  1,   2,   0}; //   3

  c_p[x_a][63] = {  2,  11}; //   2
  c_f[x_a][63] = { 27}; //   1
  c_t[x_a][63] = { 45,  47}; //   2
  c_d[x_a][63] = {  0,   1}; //   2

  c_p[x_a][64] = {  2,  13}; //   2
  c_f[x_a][64] = { 27}; //   1
  c_t[x_a][64] = { 45,  47}; //   2
  c_d[x_a][64] = {  0,   1}; //   2

  c_p[x_a][65] = {  2,  11,  18}; //   3
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = { 48}; //   1
  c_d[x_a][65] = {  2,   0,   1}; //   3

  c_p[x_a][66] = {  2,  13,  18}; //   3
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = { 48}; //   1
  c_d[x_a][66] = {  2,   0,   1}; //   3

  c_p[x_a][67] = {  2,  11}; //   2
  c_f[x_a][67] = { 26}; //   1
  c_t[x_a][67] = {  0,  41}; //   2
  c_d[x_a][67] = {  0,   1}; //   2

  c_p[x_a][68] = {  2,  13}; //   2
  c_f[x_a][68] = { 26}; //   1
  c_t[x_a][68] = {  0,  41}; //   2
  c_d[x_a][68] = {  0,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 11111(1, 2, 64, 4, 16, 32, 8;  24,   0,   0,  24)
// channel    1: 11111(1, 2, 64, 8, 32, 4, 16;  24,   0,   0,  23)
// channel    2: 11111(1, 2, 64, 32, 8, 4, 16;  24,   0,   0,   0)
// channel    3: 11111(1, 2, 64, 32, 8, 4, 16;  24,   0,   0,  23)
// channel    4: 11111(1, 2, 64, 8, 32, 16, 4;  24,   0,   0,  23)
// channel    5: 11111(1, 2, 64, 32, 8, 16, 4;  24,   0,   0,   0)
// channel    6: 11111(1, 2, 64, 32, 8, 16, 4;  24,   0,   0,  23)
// channel    7: 2v111(1, 2, 4, 16, 64, 32, 8;   0,   0,   0,  24)
// channel    8: 2v111(1, 2, 4, 16, 64, 32, 8;  23,   0,   0,  24)
// channel    9: 2v111(1, 2, 8, 32, 64, 4, 16;  24,   0,   0,   0)
// channel   10: 2v111(1, 2, 8, 32, 64, 4, 16;  24,   0,   0,  23)
// channel   11: 2v111(1, 2, 8, 32, 64, 16, 4;  24,   0,   0,   0)
// channel   12: 2v111(1, 2, 8, 32, 64, 16, 4;  24,   0,   0,  23)
// channel   13: 3yv11(1, 2, 64, 4, 16, 32, 8;   0,   0,   0,  24)
// channel   14: 3yv11(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,  24)
// channel   15: 3yv11(1, 2, 64, 8, 32, 4, 16;  24,   0,   0,   0)
// channel   16: 3yv11(1, 2, 64, 8, 32, 4, 16;  24,   0,   0,  23)
// channel   17: 3yv11(1, 2, 64, 8, 32, 16, 4;  24,   0,   0,   0)
// channel   18: 3yv11(1, 2, 64, 8, 32, 16, 4;  24,   0,   0,  23)
// channel   19: 4yyv1(1, 2, 4, 16, 8, 32, 64;  24,   0,  24,   0)
// channel   20: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,  24,   0)
// channel   21: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,  24,   0)
// channel   22: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,  24,   0)
// channel   23: 42vv1(1, 2, 4, 16, 8, 32, 64;  24,   0,  24,   0)
// channel   24: 42vv1(1, 2, 4, 16, 8, 32, 64;  24,  23,  24,   0)
// channel   25: 5yyyv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel   26: 5yyyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,   0)
// channel   27: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,   0)
// channel   28: 5yyyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,   0)
// channel   29: 5y2vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel   30: 5y2vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,   0)
// channel   31: 52vyv(1, 2, 4, 16, 64, 8, 32;  24,   0,   0,   0)
// channel   32: 52vyv(1, 2, 4, 16, 64, 8, 32;  24,   0,  23,   0)
// channel   33: 52vyv(1, 2, 8, 32, 64, 4, 16;   0,   0,  24,   0)
// channel   34: 52vyv(1, 2, 8, 32, 64, 4, 16;  23,   0,  24,   0)
// channel   35: 12v11(1, 2, 64, 4, 16, 32, 8;   0,  24,   0,  24)
// channel   36: 12v11(1, 2, 64, 4, 16, 32, 8;  23,  24,   0,  24)
// channel   37: 12v11(1, 2, 64, 8, 32, 4, 16;  24,  24,   0,   0)
// channel   38: 12v11(1, 2, 64, 8, 32, 4, 16;  24,  24,   0,  23)
// channel   39: 12v11(1, 2, 64, 8, 32, 16, 4;  24,  24,   0,   0)
// channel   40: 12v11(1, 2, 64, 8, 32, 16, 4;  24,  24,   0,  23)
// channel   41: 13yv1(1, 2, 64, 32, 4, 16, 8;  23,   0,  24,   0)
// channel   42: 13yv1(1, 2, 64, 16, 8, 32, 4;  24,   0,  24,   0)
// channel   43: 14yyv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,  24)
// channel   44: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,  24)
// channel   45: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,  24)
// channel   46: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,  24)
// channel   47: 142vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,  24)
// channel   48: 142vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,  24)
// channel   49: 112v1(1, 2, 64, 4, 8, 32, 16;  24,  24,   0,   0)
// channel   50: 112v1(1, 2, 64, 32, 4, 16, 8;   0,  24,   0,   0)
// channel   51: 112v1(1, 2, 64, 32, 4, 16, 8;  23,  24,   0,   0)
// channel   52: 113yv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,   0)
// channel   53: 113yv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,   0)
// channel   54: 1112v(1, 2, 64, 4, 16, 8, 32;  24,  24,  24,   0)
// channel   55: 2v2v1(1, 2, 4, 16, 8, 32, 64;  24,   0,   0,   0)
// channel   56: 2v2v1(1, 2, 4, 16, 8, 32, 64;  24,  23,   0,   0)
// channel   57: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,  24,   0,   0)
// channel   58: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,  24,   0,   0)
// channel   59: 2v3yv(1, 2, 4, 16, 64, 8, 32;  24,   0,   0,   0)
// channel   60: 2v3yv(1, 2, 4, 16, 64, 8, 32;  24,   0,  23,   0)
// channel   61: 2v3yv(1, 2, 8, 32, 64, 4, 16;   0,   0,  24,   0)
// channel   62: 2v3yv(1, 2, 8, 32, 64, 4, 16;  23,   0,  24,   0)
// channel   63: 2v12v(1, 2, 4, 16, 64, 8, 32;  24,   0,   0,  24)
// channel   64: 2v12v(1, 2, 4, 16, 64, 8, 32;  24,  23,   0,  24)
// channel   65: 3yv2v(1, 2, 64, 4, 16, 8, 32;  24,   0,   0,  24)
// channel   66: 3yv2v(1, 2, 64, 4, 16, 8, 32;  24,  23,   0,  24)
// channel   67: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,  24)
// channel   68: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,  24)
