#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_gg_emmupvmvex(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_gg_emmupvmvex");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(6);
  needed_v_smin[x_a].resize(6);
  int needed_v_smin_0[] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  15
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 15);
  int needed_v_smin_1[] = {   0,    1}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   2}; //   1
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 1);
  int needed_v_smin_3[] = {   3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  15
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 15);
  int needed_v_smin_4[] = {   3,    4}; //   2
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {   5}; //   1
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 1);

  v_smax[x_a].resize(8);
  needed_v_smax[x_a].resize(8);
  int needed_v_smax_0[] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  12
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 12);
  int needed_v_smax_1[] = {   0,    1}; //   2
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   2}; //   1
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 1);
  int needed_v_smax_3[] = {   3,    4,    5,   15,   16,   17}; //   6
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 6);
  int needed_v_smax_4[] = {   3,    4}; //   2
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 2);
  int needed_v_smax_5[] = {   5}; //   1
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 1);
  int needed_v_smax_6[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14}; //   9
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 9);
  int needed_v_smax_7[] = {  15,   16,   17}; //   3
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 3);

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   3,    4,    5,   15,   16,   17}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][4] = {   3,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   6,    7,    8,    9,   10,   11,   12,   13,   14}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax6");
  needed_g_p[x_a][7] = {  15,   16,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax7");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(6);
  needed_g_t[x_a].resize(6);
  needed_g_t[x_a][0] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_24");
  needed_g_t[x_a][1] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__36_24");
  needed_g_t[x_a][2] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__36_24");
  needed_g_t[x_a][3] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");
  needed_g_t[x_a][4] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__24_36");
  needed_g_t[x_a][5] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__24_36");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");

  c_p[x_a].resize(18);
  c_f[x_a].resize(18);
  c_t[x_a].resize(18);
  c_d[x_a].resize(18);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   2}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  3,   4}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  3,   4}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  5,   6,   7}; //   3

  c_p[x_a][5] = {  3,   5}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  8,   9,   7}; //   3

  c_p[x_a][6] = {  0,   6}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = { 10,   7,   2}; //   3

  c_p[x_a][7] = {  0,   6}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 10,   7,   2}; //   3

  c_p[x_a][8] = {  0,   6}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 10,   7,   2}; //   3

  c_p[x_a][9] = {  0,   6}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 10,   7,   2}; //   3

  c_p[x_a][10] = {  0,   6}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 10,   7,   2}; //   3

  c_p[x_a][11] = {  0,   6}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 10,   7,   2}; //   3

  c_p[x_a][12] = {  0,   6}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  7,   2}; //   2

  c_p[x_a][13] = {  0,   6}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  1}; //   1
  c_d[x_a][13] = {  7,   2}; //   2

  c_p[x_a][14] = {  0,   6}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  2}; //   1
  c_d[x_a][14] = {  7,   2}; //   2

  c_p[x_a][15] = {  3,   7}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  3}; //   1
  c_d[x_a][15] = {  2,   7}; //   2

  c_p[x_a][16] = {  3,   7}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  4}; //   1
  c_d[x_a][16] = {  2,   7}; //   2

  c_p[x_a][17] = {  3,   7}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  5}; //   1
  c_d[x_a][17] = {  2,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
