#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_040_uux_emmupvmvex(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_040_uux_emmupvmvex");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(6);
  needed_v_smin[x_a].resize(6);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8}; //   6
  needed_v_smin[x_a][  1] = {   0,    1}; //   2
  needed_v_smin[x_a][  2] = {   2}; //   1
  needed_v_smin[x_a][  3] = {   3,    4,    5,    6,    7,    8}; //   6
  needed_v_smin[x_a][  4] = {   3,    4}; //   2
  needed_v_smin[x_a][  5] = {   5}; //   1

  v_smax[x_a].resize(8);
  needed_v_smax[x_a].resize(8);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7}; //   5
  needed_v_smax[x_a][  1] = {   0,    1}; //   2
  needed_v_smax[x_a][  2] = {   2}; //   1
  needed_v_smax[x_a][  3] = {   3,    4,    5,    8}; //   4
  needed_v_smax[x_a][  4] = {   3,    4}; //   2
  needed_v_smax[x_a][  5] = {   5}; //   1
  needed_v_smax[x_a][  6] = {   6,    7}; //   2
  needed_v_smax[x_a][  7] = {   8}; //   1

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   3,    4,    5,    8}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][4] = {   3,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax6");
  needed_g_p[x_a][7] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax7");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(1);
  needed_g_t[x_a].resize(1);
  needed_g_t[x_a][0] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    6,    7,    8}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   3,    4,    5,    6,    7,    8}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");

  c_p[x_a].resize(9);
  c_f[x_a].resize(9);
  c_t[x_a].resize(9);
  c_d[x_a].resize(9);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   2}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  3,   4}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  3,   4}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  5,   6,   7}; //   3

  c_p[x_a][5] = {  3,   5}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  8,   9,   7}; //   3

  c_p[x_a][6] = {  0,   6}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = { 10,   7,   2}; //   3

  c_p[x_a][7] = {  0,   6}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 10,   7,   2}; //   3

  c_p[x_a][8] = {  3,   7}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  2,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv(1, 2, 4, 32, 8, 16;  24,   0,   0)
// channel    1: 4yyv(1, 2, 4, 32, 8, 16;  24,   0,  23)
// channel    2: 4yyv(1, 2, 32, 4, 8, 16;  24,   0,  23)
// channel    3: 4yyv(1, 2, 8, 16, 4, 32;  24,   0,   0)
// channel    4: 4yyv(1, 2, 8, 16, 4, 32;  24,   0,  23)
// channel    5: 4yyv(1, 2, 16, 8, 4, 32;  24,   0,  23)
// channel    6: 42vv(1, 2, 4, 32, 8, 16;  24,  24,   0)
// channel    7: 42vv(1, 2, 4, 32, 8, 16;  24,  24,  23)
// channel    8: 2v2v(1, 2, 8, 16, 4, 32;  24,  24,   0)
