#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_bb_emmupvmvexbb(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_bb_emmupvmvexbb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(17);
  needed_v_smin[x_a].resize(17);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83}; //  60
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   18,   19,   20,   21,   38,   39,   40,   41,   58,   59,   60,   61}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   18,   19,   20,   21,   38,   39,   40,   41,   58,   59,   60,   61}; //  16
  needed_v_smin[x_a][  3] = {   4,    5,   22,   23,   42,   43,   62,   63}; //   8
  needed_v_smin[x_a][  4] = {   4,    5,   22,   23,   42,   43,   62,   63}; //   8
  needed_v_smin[x_a][  5] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83}; //  60
  needed_v_smin[x_a][  6] = {   6,    7,    8,    9,   24,   25,   26,   27,   44,   45,   46,   47,   64,   65,   66,   67}; //  16
  needed_v_smin[x_a][  7] = {   6,    7,    8,    9,   24,   25,   26,   27,   44,   45,   46,   47,   64,   65,   66,   67}; //  16
  needed_v_smin[x_a][  8] = {  10,   11,   28,   29,   48,   49,   68,   69}; //   8
  needed_v_smin[x_a][  9] = {  10,   11,   28,   29,   48,   49,   68,   69}; //   8
  needed_v_smin[x_a][ 10] = {  12,   13,   14,   15,   16,   17,   30,   31,   32,   33,   34,   35,   50,   51,   52,   53,   54,   55,   70,   71,   72,   73,   74,   75}; //  24
  needed_v_smin[x_a][ 11] = {  18,   19,   22,   24,   25,   28,   30,   31,   32,   38,   39,   42,   44,   45,   48,   50,   51,   52,    2,    3,    5,    8,    9,   11,   15,   16,   17,   58,   59,   62,   64,   65,   68,   70,   71,   72}; //  36
  needed_v_smin[x_a][ 12] = {  20,   21,   23,   26,   27,   29,   33,   34,   35,   40,   41,   43,   46,   47,   49,   53,   54,   55,    0,    1,    4,    6,    7,   10,   12,   13,   14,   60,   61,   63,   66,   67,   69,   73,   74,   75}; //  36
  needed_v_smin[x_a][ 13] = {  36,   57,   78,   80,   77,   82}; //   6
  needed_v_smin[x_a][ 14] = {  36,   57,   77,   78,   80,   82}; //   6
  needed_v_smin[x_a][ 15] = {  37,   56,   79,   81,   76,   83}; //   6
  needed_v_smin[x_a][ 16] = {  37,   56,   76,   79,   81,   83}; //   6

  v_smax[x_a].resize(17);
  needed_v_smax[x_a].resize(17);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79}; //  56
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   18,   19,   20,   21,   38,   39,   40,   41,   58,   59,   60,   61}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  72
  needed_v_smax[x_a][  3] = {   4,    5,   22,   23,   42,   43,   62,   63}; //   8
  needed_v_smax[x_a][  4] = {   6,    7,    8,    9,   10,   11,   24,   25,   26,   27,   28,   29,   44,   45,   46,   47,   48,   49,   64,   65,   66,   67,   68,   69,   80,   81,   82,   83}; //  28
  needed_v_smax[x_a][  5] = {   6,    7,    8,    9,   24,   25,   26,   27,   44,   45,   46,   47,   64,   65,   66,   67}; //  16
  needed_v_smax[x_a][  6] = {  10,   11,   28,   29,   48,   49,   68,   69}; //   8
  needed_v_smax[x_a][  7] = {  12,   13,   14,   15,   16,   17,   30,   31,   32,   33,   34,   35,   50,   51,   52,   53,   54,   55,   70,   71,   72,   73,   74,   75,   76,   77}; //  26
  needed_v_smax[x_a][  8] = {  18,   19,   22,   24,   25,   28,   30,   31,   32,   36,   38,   39,   42,   44,   45,   48,   50,   51,   52,   57,    2,    3,    5,    8,    9,   11,   15,   16,   17,   58,   59,   62,   64,   65,   68,   70,   71,   72,   77,   78,   80,   82}; //  42
  needed_v_smax[x_a][  9] = {  20,   21,   23,   26,   27,   29,   33,   34,   35,   37,   40,   41,   43,   46,   47,   49,   53,   54,   55,   56,    0,    1,    4,    6,    7,   10,   12,   13,   14,   60,   61,   63,   66,   67,   69,   73,   74,   75,   76,   79,   81,   83}; //  42
  needed_v_smax[x_a][ 10] = {  36,   57,   78}; //   3
  needed_v_smax[x_a][ 11] = {  36,   57,   78}; //   3
  needed_v_smax[x_a][ 12] = {  37,   56,   79}; //   3
  needed_v_smax[x_a][ 13] = {  37,   56,   79}; //   3
  needed_v_smax[x_a][ 14] = {  80,   81,   82,   83}; //   4
  needed_v_smax[x_a][ 15] = {  80,   77,   82}; //   3
  needed_v_smax[x_a][ 16] = {  81,   76,   83}; //   3

  g_p[x_a].resize(27);
  needed_g_p[x_a].resize(27);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79}; //  56
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   18,   19,   20,   21,   38,   39,   40,   41,   58,   59,   60,   61}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   18,   20,   38,   40,   58,   60}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   19,   21,   39,   41,   59,   61}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   4,    5,   22,   23,   42,   43,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   4,    5,   22,   23,   42,   43,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   6,    7,    8,    9,   10,   11,   24,   25,   26,   27,   28,   29,   44,   45,   46,   47,   48,   49,   64,   65,   66,   67,   68,   69,   80,   81,   82,   83}; //  28
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   6,    7,    8,    9,   24,   25,   26,   27,   44,   45,   46,   47,   64,   65,   66,   67}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   6,    8,   24,   26,   44,   46,   64,   66}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   7,    9,   25,   27,   45,   47,   65,   67}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {  10,   11,   28,   29,   48,   49,   68,   69}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {  10,   11,   28,   29,   48,   49,   68,   69}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {  12,   13,   14,   15,   16,   17,   30,   31,   32,   33,   34,   35,   50,   51,   52,   53,   54,   55,   70,   71,   72,   73,   74,   75,   76,   77}; //  26
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {  12,   15,   30,   33,   50,   53,   70,   73}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {  13,   16,   31,   34,   51,   54,   71,   74}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {  14,   17,   32,   35,   52,   55,   72,   75}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][16] = {  18,   19,   22,   24,   25,   28,   30,   31,   32,   38,   39,   42,   44,   45,   48,   50,   51,   52}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin11_smax8");
  needed_g_p[x_a][17] = {  20,   21,   23,   26,   27,   29,   33,   34,   35,   40,   41,   43,   46,   47,   49,   53,   54,   55}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin12_smax9");
  needed_g_p[x_a][18] = {  36,   57,   78}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin13_smax10");
  needed_g_p[x_a][19] = {  36,   57,   78}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax11");
  needed_g_p[x_a][20] = {  36,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin14_smax8");
  needed_g_p[x_a][21] = {  37,   56,   79}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax12");
  needed_g_p[x_a][22] = {  37,   56,   79}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax13");
  needed_g_p[x_a][23] = {  37,   56}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin16_smax9");
  needed_g_p[x_a][24] = {  80,   81,   82,   83}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][25] = {  80}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin13_smax15");
  needed_g_p[x_a][26] = {  81}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax16");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   60,   61,   63,   66,   67,   69,   73,   74,   75}; //  18
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax9");
  needed_g_f[x_a][1] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   58,   59,   62,   64,   65,   68,   70,   71,   72}; //  18
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][2] = {  76,   83}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax16");
  needed_g_f[x_a][3] = {  76,   79,   81,   83}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax9");
  needed_g_f[x_a][4] = {  77,   82}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax15");
  needed_g_f[x_a][5] = {  77,   78,   80,   82}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax8");

  g_t[x_a].resize(16);
  needed_g_t[x_a].resize(16);
  needed_g_t[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   20,   21,   23,   26,   27,   29,   33,   34,   35,   37,   76,   79}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    4,    6,    7,   10,   12,   13,   14}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__130_1__64_60");
  needed_g_t[x_a][2] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   18,   19,   22,   24,   25,   28,   30,   31,   32,   36,   77,   78}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][3] = {   2,    3,    5,    8,    9,   11,   15,   16,   17}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__66_1__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__66_1__128_60");
  needed_g_t[x_a][4] = {  38,   39,   42,   44,   45,   48,   50,   51,   52,   57,   58,   59,   62,   64,   65,   68,   70,   71,   72,   80,   82}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][5] = {  40,   41,   43,   46,   47,   49,   53,   54,   55,   56,   60,   61,   63,   66,   67,   69,   73,   74,   75,   81,   83}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__128_124");
  needed_g_t[x_a][6] = {  58,   59,   62,   64,   65,   68,   70,   71,   72}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__65_2__128_60");
  needed_g_t[x_a][7] = {  60,   61,   63,   66,   67,   69,   73,   74,   75}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__129_2__64_60");
  needed_g_t[x_a][8] = {  76,   79}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_130__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_130__36_88");
  needed_g_t[x_a][9] = {  76}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__130_37__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__130_37__64_24");
  needed_g_t[x_a][10] = {  77,   78}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_66__36_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_66__36_152");
  needed_g_t[x_a][11] = {  77}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__66_37__128_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__66_37__128_24");
  needed_g_t[x_a][12] = {  80,   82}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_65__36_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_65__36_152");
  needed_g_t[x_a][13] = {  81,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_129__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_129__36_88");
  needed_g_t[x_a][14] = {  82}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__65_38__128_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__65_38__128_24");
  needed_g_t[x_a][15] = {  83}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__129_38__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__129_38__64_24");

  g_d[x_a].resize(17);
  needed_g_d[x_a].resize(17);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   18,   19,   20,   21,   38,   39,   40,   41,   58,   59,   60,   61}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,   18,   19,   20,   21,   38,   39,   40,   41,   58,   59,   60,   61}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   4,    5,   22,   23,   42,   43,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   4,    5,   22,   23,   42,   43,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   6,    7,    8,    9,   24,   25,   26,   27,   44,   45,   46,   47,   64,   65,   66,   67}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   6,    7,    8,    9,   24,   25,   26,   27,   44,   45,   46,   47,   64,   65,   66,   67}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {  10,   11,   28,   29,   48,   49,   68,   69}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  10,   11,   28,   29,   48,   49,   68,   69}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {  12,   13,   14,   15,   16,   17,   30,   31,   32,   33,   34,   35,   50,   51,   52,   53,   54,   55,   70,   71,   72,   73,   74,   75}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {  18,   19,   22,   24,   25,   28,   30,   31,   32,   38,   39,   42,   44,   45,   48,   50,   51,   52}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][12] = {  20,   21,   23,   26,   27,   29,   33,   34,   35,   40,   41,   43,   46,   47,   49,   53,   54,   55}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][13] = {  36,   57}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__36_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__36_152");
  needed_g_d[x_a][14] = {  36,   57,   78,   80}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_152__128_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_152__128_24");
  needed_g_d[x_a][15] = {  37,   56}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][16] = {  37,   56,   79,   81}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");

  c_p[x_a].resize(84);
  c_f[x_a].resize(84);
  c_t[x_a].resize(84);
  c_d[x_a].resize(84);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   1,   2}; //   3
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  0,   1,   3}; //   3
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   4,   5}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   4,   5}; //   3
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  2,   3}; //   2
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  6,   7,   8}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  5,   6,   7}; //   3

  c_p[x_a][7] = {  6,   7,   9}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = {  5,   6,   7}; //   3

  c_p[x_a][8] = {  6,   7,   8}; //   3
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  2,   3}; //   2
  c_d[x_a][8] = {  5,   6,   7}; //   3

  c_p[x_a][9] = {  6,   7,   9}; //   3
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  2,   3}; //   2
  c_d[x_a][9] = {  5,   6,   7}; //   3

  c_p[x_a][10] = {  6,  10,  11}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = {  8,   9,   7}; //   3

  c_p[x_a][11] = {  6,  10,  11}; //   3
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  2,   3}; //   2
  c_d[x_a][11] = {  8,   9,   7}; //   3

  c_p[x_a][12] = {  0,  12,  13}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   1}; //   2
  c_d[x_a][12] = { 10,   7,   2}; //   3

  c_p[x_a][13] = {  0,  12,  14}; //   3
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = { 10,   7,   2}; //   3

  c_p[x_a][14] = {  0,  12,  15}; //   3
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  0,   1}; //   2
  c_d[x_a][14] = { 10,   7,   2}; //   3

  c_p[x_a][15] = {  0,  12,  13}; //   3
  c_f[x_a][15] = {  1}; //   1
  c_t[x_a][15] = {  2,   3}; //   2
  c_d[x_a][15] = { 10,   7,   2}; //   3

  c_p[x_a][16] = {  0,  12,  14}; //   3
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  2,   3}; //   2
  c_d[x_a][16] = { 10,   7,   2}; //   3

  c_p[x_a][17] = {  0,  12,  15}; //   3
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  2,   3}; //   2
  c_d[x_a][17] = { 10,   7,   2}; //   3

  c_p[x_a][18] = {  0,   1,   2,  16}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  2}; //   1
  c_d[x_a][18] = { 11,   0,   1,   2}; //   4

  c_p[x_a][19] = {  0,   1,   3,  16}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  2}; //   1
  c_d[x_a][19] = { 11,   0,   1,   2}; //   4

  c_p[x_a][20] = {  0,   1,   2,  17}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = { 12,   0,   1,   2}; //   4

  c_p[x_a][21] = {  0,   1,   3,  17}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 12,   0,   1,   2}; //   4

  c_p[x_a][22] = {  0,   4,   5,  16}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  2}; //   1
  c_d[x_a][22] = { 11,   3,   4,   2}; //   4

  c_p[x_a][23] = {  0,   4,   5,  17}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = { 12,   3,   4,   2}; //   4

  c_p[x_a][24] = {  6,   7,   8,  16}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  2}; //   1
  c_d[x_a][24] = { 11,   5,   6,   7}; //   4

  c_p[x_a][25] = {  6,   7,   9,  16}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  2}; //   1
  c_d[x_a][25] = { 11,   5,   6,   7}; //   4

  c_p[x_a][26] = {  6,   7,   8,  17}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = { 12,   5,   6,   7}; //   4

  c_p[x_a][27] = {  6,   7,   9,  17}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = { 12,   5,   6,   7}; //   4

  c_p[x_a][28] = {  6,  10,  11,  16}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  2}; //   1
  c_d[x_a][28] = { 11,   8,   9,   7}; //   4

  c_p[x_a][29] = {  6,  10,  11,  17}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = { 12,   8,   9,   7}; //   4

  c_p[x_a][30] = {  0,  12,  13,  16}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  2}; //   1
  c_d[x_a][30] = { 11,  10,   7,   2}; //   4

  c_p[x_a][31] = {  0,  12,  14,  16}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  2}; //   1
  c_d[x_a][31] = { 11,  10,   7,   2}; //   4

  c_p[x_a][32] = {  0,  12,  15,  16}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  2}; //   1
  c_d[x_a][32] = { 11,  10,   7,   2}; //   4

  c_p[x_a][33] = {  0,  12,  13,  17}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  0}; //   1
  c_d[x_a][33] = { 12,  10,   7,   2}; //   4

  c_p[x_a][34] = {  0,  12,  14,  17}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  0}; //   1
  c_d[x_a][34] = { 12,  10,   7,   2}; //   4

  c_p[x_a][35] = {  0,  12,  15,  17}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  0}; //   1
  c_d[x_a][35] = { 12,  10,   7,   2}; //   4

  c_p[x_a][36] = {  0,  18,  19,  20}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  2}; //   1
  c_d[x_a][36] = { 13,   7,  14,   2}; //   4

  c_p[x_a][37] = {  0,  21,  22,  23}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  0}; //   1
  c_d[x_a][37] = { 15,   7,  16,   2}; //   4

  c_p[x_a][38] = {  0,   1,   2,  16}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  4}; //   1
  c_d[x_a][38] = { 11,   0,   1,   2}; //   4

  c_p[x_a][39] = {  0,   1,   3,  16}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  4}; //   1
  c_d[x_a][39] = { 11,   0,   1,   2}; //   4

  c_p[x_a][40] = {  0,   1,   2,  17}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  5}; //   1
  c_d[x_a][40] = { 12,   0,   1,   2}; //   4

  c_p[x_a][41] = {  0,   1,   3,  17}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  5}; //   1
  c_d[x_a][41] = { 12,   0,   1,   2}; //   4

  c_p[x_a][42] = {  0,   4,   5,  16}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  4}; //   1
  c_d[x_a][42] = { 11,   3,   4,   2}; //   4

  c_p[x_a][43] = {  0,   4,   5,  17}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  5}; //   1
  c_d[x_a][43] = { 12,   3,   4,   2}; //   4

  c_p[x_a][44] = {  6,   7,   8,  16}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  4}; //   1
  c_d[x_a][44] = { 11,   5,   6,   7}; //   4

  c_p[x_a][45] = {  6,   7,   9,  16}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  4}; //   1
  c_d[x_a][45] = { 11,   5,   6,   7}; //   4

  c_p[x_a][46] = {  6,   7,   8,  17}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  5}; //   1
  c_d[x_a][46] = { 12,   5,   6,   7}; //   4

  c_p[x_a][47] = {  6,   7,   9,  17}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  5}; //   1
  c_d[x_a][47] = { 12,   5,   6,   7}; //   4

  c_p[x_a][48] = {  6,  10,  11,  16}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  4}; //   1
  c_d[x_a][48] = { 11,   8,   9,   7}; //   4

  c_p[x_a][49] = {  6,  10,  11,  17}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  5}; //   1
  c_d[x_a][49] = { 12,   8,   9,   7}; //   4

  c_p[x_a][50] = {  0,  12,  13,  16}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  4}; //   1
  c_d[x_a][50] = { 11,  10,   7,   2}; //   4

  c_p[x_a][51] = {  0,  12,  14,  16}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  4}; //   1
  c_d[x_a][51] = { 11,  10,   7,   2}; //   4

  c_p[x_a][52] = {  0,  12,  15,  16}; //   4
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  4}; //   1
  c_d[x_a][52] = { 11,  10,   7,   2}; //   4

  c_p[x_a][53] = {  0,  12,  13,  17}; //   4
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  5}; //   1
  c_d[x_a][53] = { 12,  10,   7,   2}; //   4

  c_p[x_a][54] = {  0,  12,  14,  17}; //   4
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  5}; //   1
  c_d[x_a][54] = { 12,  10,   7,   2}; //   4

  c_p[x_a][55] = {  0,  12,  15,  17}; //   4
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  5}; //   1
  c_d[x_a][55] = { 12,  10,   7,   2}; //   4

  c_p[x_a][56] = {  0,  21,  22,  23}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  5}; //   1
  c_d[x_a][56] = { 15,   7,  16,   2}; //   4

  c_p[x_a][57] = {  0,  18,  19,  20}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  4}; //   1
  c_d[x_a][57] = { 13,   7,  14,   2}; //   4

  c_p[x_a][58] = {  0,   1,   2}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  4,   6}; //   2
  c_d[x_a][58] = {  0,   1,   2}; //   3

  c_p[x_a][59] = {  0,   1,   3}; //   3
  c_f[x_a][59] = {  1}; //   1
  c_t[x_a][59] = {  4,   6}; //   2
  c_d[x_a][59] = {  0,   1,   2}; //   3

  c_p[x_a][60] = {  0,   1,   2}; //   3
  c_f[x_a][60] = {  0}; //   1
  c_t[x_a][60] = {  5,   7}; //   2
  c_d[x_a][60] = {  0,   1,   2}; //   3

  c_p[x_a][61] = {  0,   1,   3}; //   3
  c_f[x_a][61] = {  0}; //   1
  c_t[x_a][61] = {  5,   7}; //   2
  c_d[x_a][61] = {  0,   1,   2}; //   3

  c_p[x_a][62] = {  0,   4,   5}; //   3
  c_f[x_a][62] = {  1}; //   1
  c_t[x_a][62] = {  4,   6}; //   2
  c_d[x_a][62] = {  3,   4,   2}; //   3

  c_p[x_a][63] = {  0,   4,   5}; //   3
  c_f[x_a][63] = {  0}; //   1
  c_t[x_a][63] = {  5,   7}; //   2
  c_d[x_a][63] = {  3,   4,   2}; //   3

  c_p[x_a][64] = {  6,   7,   8}; //   3
  c_f[x_a][64] = {  1}; //   1
  c_t[x_a][64] = {  4,   6}; //   2
  c_d[x_a][64] = {  5,   6,   7}; //   3

  c_p[x_a][65] = {  6,   7,   9}; //   3
  c_f[x_a][65] = {  1}; //   1
  c_t[x_a][65] = {  4,   6}; //   2
  c_d[x_a][65] = {  5,   6,   7}; //   3

  c_p[x_a][66] = {  6,   7,   8}; //   3
  c_f[x_a][66] = {  0}; //   1
  c_t[x_a][66] = {  5,   7}; //   2
  c_d[x_a][66] = {  5,   6,   7}; //   3

  c_p[x_a][67] = {  6,   7,   9}; //   3
  c_f[x_a][67] = {  0}; //   1
  c_t[x_a][67] = {  5,   7}; //   2
  c_d[x_a][67] = {  5,   6,   7}; //   3

  c_p[x_a][68] = {  6,  10,  11}; //   3
  c_f[x_a][68] = {  1}; //   1
  c_t[x_a][68] = {  4,   6}; //   2
  c_d[x_a][68] = {  8,   9,   7}; //   3

  c_p[x_a][69] = {  6,  10,  11}; //   3
  c_f[x_a][69] = {  0}; //   1
  c_t[x_a][69] = {  5,   7}; //   2
  c_d[x_a][69] = {  8,   9,   7}; //   3

  c_p[x_a][70] = {  0,  12,  13}; //   3
  c_f[x_a][70] = {  1}; //   1
  c_t[x_a][70] = {  4,   6}; //   2
  c_d[x_a][70] = { 10,   7,   2}; //   3

  c_p[x_a][71] = {  0,  12,  14}; //   3
  c_f[x_a][71] = {  1}; //   1
  c_t[x_a][71] = {  4,   6}; //   2
  c_d[x_a][71] = { 10,   7,   2}; //   3

  c_p[x_a][72] = {  0,  12,  15}; //   3
  c_f[x_a][72] = {  1}; //   1
  c_t[x_a][72] = {  4,   6}; //   2
  c_d[x_a][72] = { 10,   7,   2}; //   3

  c_p[x_a][73] = {  0,  12,  13}; //   3
  c_f[x_a][73] = {  0}; //   1
  c_t[x_a][73] = {  5,   7}; //   2
  c_d[x_a][73] = { 10,   7,   2}; //   3

  c_p[x_a][74] = {  0,  12,  14}; //   3
  c_f[x_a][74] = {  0}; //   1
  c_t[x_a][74] = {  5,   7}; //   2
  c_d[x_a][74] = { 10,   7,   2}; //   3

  c_p[x_a][75] = {  0,  12,  15}; //   3
  c_f[x_a][75] = {  0}; //   1
  c_t[x_a][75] = {  5,   7}; //   2
  c_d[x_a][75] = { 10,   7,   2}; //   3

  c_p[x_a][76] = {  0,  12}; //   2
  c_f[x_a][76] = {  2,   3}; //   2
  c_t[x_a][76] = {  0,   8,   9}; //   3
  c_d[x_a][76] = {  7,   2}; //   2

  c_p[x_a][77] = {  0,  12}; //   2
  c_f[x_a][77] = {  4,   5}; //   2
  c_t[x_a][77] = {  2,  10,  11}; //   3
  c_d[x_a][77] = {  7,   2}; //   2

  c_p[x_a][78] = {  0,  18,  19}; //   3
  c_f[x_a][78] = {  5}; //   1
  c_t[x_a][78] = {  2,  10}; //   2
  c_d[x_a][78] = {  7,  14,   2}; //   3

  c_p[x_a][79] = {  0,  21,  22}; //   3
  c_f[x_a][79] = {  3}; //   1
  c_t[x_a][79] = {  0,   8}; //   2
  c_d[x_a][79] = {  7,  16,   2}; //   3

  c_p[x_a][80] = {  6,  24,  25}; //   3
  c_f[x_a][80] = {  5}; //   1
  c_t[x_a][80] = {  4,  12}; //   2
  c_d[x_a][80] = { 14,   2,   7}; //   3

  c_p[x_a][81] = {  6,  24,  26}; //   3
  c_f[x_a][81] = {  3}; //   1
  c_t[x_a][81] = {  5,  13}; //   2
  c_d[x_a][81] = { 16,   2,   7}; //   3

  c_p[x_a][82] = {  6,  24}; //   2
  c_f[x_a][82] = {  4,   5}; //   2
  c_t[x_a][82] = {  4,  12,  14}; //   3
  c_d[x_a][82] = {  2,   7}; //   2

  c_p[x_a][83] = {  6,  24}; //   2
  c_f[x_a][83] = {  2,   3}; //   2
  c_t[x_a][83] = {  5,  13,  15}; //   3
  c_d[x_a][83] = {  2,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   0,   5)
// channel    1: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   0,   5)
// channel    2: 4yyv11(1, 2, 4, 32, 8, 16, 128, 64;  24,   0,   0,   0,   5)
// channel    3: 4yyv11(1, 2, 4, 32, 8, 16, 128, 64;  24,   0,  23,   0,   5)
// channel    4: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   0,   5)
// channel    5: 4yyv11(1, 2, 32, 4, 8, 16, 128, 64;  24,   0,  23,   0,   5)
// channel    6: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   5)
// channel    7: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   0,   5)
// channel    8: 4yyv11(1, 2, 8, 16, 4, 32, 128, 64;  24,   0,   0,   0,   5)
// channel    9: 4yyv11(1, 2, 8, 16, 4, 32, 128, 64;  24,   0,  23,   0,   5)
// channel   10: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   0,   5)
// channel   11: 4yyv11(1, 2, 16, 8, 4, 32, 128, 64;  24,   0,  23,   0,   5)
// channel   12: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   5)
// channel   13: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   0,   5)
// channel   14: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  25,   0,   5)
// channel   15: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,   0,   0,   5)
// channel   16: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,  23,   0,   5)
// channel   17: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,  25,   0,   5)
// channel   18: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   5,   0)
// channel   19: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   5,   0)
// channel   20: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   5,   0)
// channel   21: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   5,   0)
// channel   22: 5yyyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   5,   0)
// channel   23: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   5,   0)
// channel   24: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   5,   0)
// channel   25: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   5,   0)
// channel   26: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   5,   0)
// channel   27: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   5,   0)
// channel   28: 5yyyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   5,   0)
// channel   29: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   5,   0)
// channel   30: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   5,   0)
// channel   31: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   5,   0)
// channel   32: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  25,   5,   0)
// channel   33: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   5,   0)
// channel   34: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   5,   0)
// channel   35: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  25,   5,   0)
// channel   36: 52vyv1(1, 2, 4, 32, 128, 8, 16, 64;  24,   6,  24,   5,   0)
// channel   37: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   6,  24,   5,   0)
// channel   38: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   0)
// channel   39: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   0)
// channel   40: 15yyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   5,   0)
// channel   41: 15yyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   5,   0)
// channel   42: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   0)
// channel   43: 15yyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   5,   0)
// channel   44: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   0)
// channel   45: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   0)
// channel   46: 15yyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   5,   0)
// channel   47: 15yyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   5,   0)
// channel   48: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   0)
// channel   49: 15yyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   5,   0)
// channel   50: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   0)
// channel   51: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   0)
// channel   52: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   0)
// channel   53: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   5,   0)
// channel   54: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   5,   0)
// channel   55: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  25,   5,   0)
// channel   56: 152vyv(1, 2, 128, 4, 32, 64, 8, 16;  24,   6,  24,   5,   0)
// channel   57: 152vyv(1, 2, 64, 4, 32, 128, 8, 16;  24,   6,  24,   5,   0)
// channel   58: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   5)
// channel   59: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   5)
// channel   60: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   5)
// channel   61: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   5)
// channel   62: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   5)
// channel   63: 114yyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   5)
// channel   64: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   5)
// channel   65: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   5)
// channel   66: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   5)
// channel   67: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   5)
// channel   68: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   5)
// channel   69: 114yyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   5)
// channel   70: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   5)
// channel   71: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   5)
// channel   72: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   0,   5)
// channel   73: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   5)
// channel   74: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   5)
// channel   75: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  25,   0,   5)
// channel   76: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   6,   5)
// channel   77: 2v2v11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,   0,   6,   5)
// channel   78: 2v3yv1(1, 2, 4, 32, 128, 8, 16, 64;  24,   6,  24,   0,   6)
// channel   79: 2v3yv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   6,  24,   0,   6)
// channel   80: 13yv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   6,   0,   6)
// channel   81: 13yv2v(1, 2, 128, 64, 8, 16, 4, 32;  24,  24,   6,   0,   6)
// channel   82: 112v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   6,   5)
// channel   83: 112v2v(1, 2, 128, 64, 8, 16, 4, 32;  24,  24,   0,   6,   5)
