#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_bbx_emmupvmvexgg(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_bbx_emmupvmvexgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(23);
  needed_v_smin[x_a].resize(23);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   18,   19,   20,   21,   36,   37,   38,   39,   56,   57,   69,   70}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   18,   19,   20,   21,   36,   37,   38,   39,   56,   57,   69,   70}; //  16
  needed_v_smin[x_a][  3] = {   4,    5,   22,   23,   40,   41,   58,   71}; //   8
  needed_v_smin[x_a][  4] = {   4,    5,   22,   23,   40,   41,   58,   71}; //   8
  needed_v_smin[x_a][  5] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  needed_v_smin[x_a][  6] = {   6,    7,    8,    9,   24,   25,   26,   27,   42,   43,   44,   45,   59,   60,   72,   73}; //  16
  needed_v_smin[x_a][  7] = {   6,    7,    8,    9,   24,   25,   26,   27,   42,   43,   44,   45,   59,   60,   72,   73}; //  16
  needed_v_smin[x_a][  8] = {  10,   11,   28,   29,   46,   47,   61,   74}; //   8
  needed_v_smin[x_a][  9] = {  10,   11,   28,   29,   46,   47,   61,   74}; //   8
  needed_v_smin[x_a][ 10] = {  12,   13,   14,   15,   16,   17,   30,   31,   32,   33,   34,   35,   48,   49,   50,   51,   52,   53,   62,   63,   64,   75,   76,   77,   78,   79,   86}; //  27
  needed_v_smin[x_a][ 11] = {  56,   57,   58,   59,   60,   61,   62,   63,   64,   69,   70,   71,   72,   73,   74,   75,   76,   77,   84,   85,   86,   67,   68}; //  23
  needed_v_smin[x_a][ 12] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   18,   19,   22,   24,   25,   28,   30,   31,   32,   38,   39,   41,   44,   45,   47,   51,   52,   53,   78}; //  28
  needed_v_smin[x_a][ 13] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   20,   21,   23,   26,   27,   29,   33,   34,   35,   36,   37,   40,   42,   43,   46,   48,   49,   50,   79}; //  28
  needed_v_smin[x_a][ 14] = {  54,   66}; //   2
  needed_v_smin[x_a][ 15] = {  54,   66}; //   2
  needed_v_smin[x_a][ 16] = {  55,   65}; //   2
  needed_v_smin[x_a][ 17] = {  55,   65}; //   2
  needed_v_smin[x_a][ 18] = {  67,   68,   84,   85}; //   4
  needed_v_smin[x_a][ 19] = {  80,   83}; //   2
  needed_v_smin[x_a][ 20] = {  80,   83}; //   2
  needed_v_smin[x_a][ 21] = {  81,   82}; //   2
  needed_v_smin[x_a][ 22] = {  81,   82}; //   2

  v_smax[x_a].resize(27);
  needed_v_smax[x_a].resize(27);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   62,   63,   64,   65,   66,   67,   68,   78,   79,   80,   81,   82,   83,   85,   86}; //  56
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   18,   19,   20,   21,   36,   37,   38,   39,   56,   57}; //  14
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   56,   57,   58,   59,   60,   61,   62,   63,   64,   78,   79}; //  65
  needed_v_smax[x_a][  3] = {   4,    5,   22,   23,   40,   41,   58}; //   7
  needed_v_smax[x_a][  4] = {   6,    7,    8,    9,   10,   11,   24,   25,   26,   27,   28,   29,   42,   43,   44,   45,   46,   47,   59,   60,   61}; //  21
  needed_v_smax[x_a][  5] = {   6,    7,    8,    9,   24,   25,   26,   27,   42,   43,   44,   45,   59,   60}; //  14
  needed_v_smax[x_a][  6] = {  10,   11,   28,   29,   46,   47,   61}; //   7
  needed_v_smax[x_a][  7] = {  12,   13,   14,   15,   16,   17,   30,   31,   32,   33,   34,   35,   48,   49,   50,   51,   52,   53,   54,   55,   62,   63,   64,   65,   66,   67,   68,   78,   79,   80,   81,   82,   83,   86}; //  34
  needed_v_smax[x_a][  8] = {  56,   57,   58,   59,   60,   61,   62,   63,   64}; //   9
  needed_v_smax[x_a][  9] = {  69,   70,   71,   72,   73,   74,   75,   76,   77,   84}; //  10
  needed_v_smax[x_a][ 10] = {  69,   70,   71,   75,   76,   77,   84}; //   7
  needed_v_smax[x_a][ 11] = {  69,   70}; //   2
  needed_v_smax[x_a][ 12] = {  69,   70,   71,   72,   73,   74,   75,   76,   77,   86}; //  10
  needed_v_smax[x_a][ 13] = {  71}; //   1
  needed_v_smax[x_a][ 14] = {  72,   73,   74}; //   3
  needed_v_smax[x_a][ 15] = {  72,   73}; //   2
  needed_v_smax[x_a][ 16] = {  74}; //   1
  needed_v_smax[x_a][ 17] = {  75,   76,   77,   84,   85}; //   5
  needed_v_smax[x_a][ 18] = {  85}; //   1
  needed_v_smax[x_a][ 19] = {  86,   67,   68}; //   3
  needed_v_smax[x_a][ 20] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   18,   19,   22,   24,   25,   28,   30,   31,   32,   38,   39,   41,   44,   45,   47,   51,   52,   53,   54,   66,   78,   80,   83}; //  32
  needed_v_smax[x_a][ 21] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   20,   21,   23,   26,   27,   29,   33,   34,   35,   36,   37,   40,   42,   43,   46,   48,   49,   50,   55,   65,   79,   81,   82}; //  32
  needed_v_smax[x_a][ 22] = {  54,   66}; //   2
  needed_v_smax[x_a][ 23] = {  55,   65}; //   2
  needed_v_smax[x_a][ 24] = {  67,   68,   84,   85}; //   4
  needed_v_smax[x_a][ 25] = {  80,   83}; //   2
  needed_v_smax[x_a][ 26] = {  81,   82}; //   2

  g_p[x_a].resize(36);
  needed_g_p[x_a].resize(36);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   62,   63,   64,   65,   66,   67,   68,   78,   79,   80,   81,   82,   83,   85,   86}; //  56
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   18,   19,   20,   21,   36,   37,   38,   39,   56,   57}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   18,   20,   36,   38,   56}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   19,   21,   37,   39,   57}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   4,    5,   22,   23,   40,   41,   58}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   4,    5,   22,   23,   40,   41,   58}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   6,    7,    8,    9,   10,   11,   24,   25,   26,   27,   28,   29,   42,   43,   44,   45,   46,   47,   59,   60,   61}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   6,    7,    8,    9,   24,   25,   26,   27,   42,   43,   44,   45,   59,   60}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   6,    8,   24,   26,   42,   44,   59}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   7,    9,   25,   27,   43,   45,   60}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {  10,   11,   28,   29,   46,   47,   61}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {  10,   11,   28,   29,   46,   47,   61}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {  12,   13,   14,   15,   16,   17,   30,   31,   32,   33,   34,   35,   48,   49,   50,   51,   52,   53,   54,   55,   62,   63,   64,   65,   66,   67,   68,   78,   79,   80,   81,   82,   83,   86}; //  34
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {  12,   15,   30,   33,   48,   51,   62}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {  13,   16,   31,   34,   49,   52,   63}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {  14,   17,   32,   35,   50,   53,   64}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][16] = {  56,   57,   58,   59,   60,   61,   62,   63,   64}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][17] = {  69,   70,   71,   72,   73,   74,   75,   76,   77,   84}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][18] = {  69,   70,   71,   75,   76,   77,   84}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax10");
  needed_g_p[x_a][19] = {  69,   70}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][20] = {  69}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax12");
  needed_g_p[x_a][21] = {  70}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax12");
  needed_g_p[x_a][22] = {  71}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax13");
  needed_g_p[x_a][23] = {  71}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax12");
  needed_g_p[x_a][24] = {  72,   73,   74}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax14");
  needed_g_p[x_a][25] = {  72,   73}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax15");
  needed_g_p[x_a][26] = {  72}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax12");
  needed_g_p[x_a][27] = {  73}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax12");
  needed_g_p[x_a][28] = {  74}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax16");
  needed_g_p[x_a][29] = {  74}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax12");
  needed_g_p[x_a][30] = {  75,   76,   77,   84,   85}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax17");
  needed_g_p[x_a][31] = {  75}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax12");
  needed_g_p[x_a][32] = {  76}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax12");
  needed_g_p[x_a][33] = {  77}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax12");
  needed_g_p[x_a][34] = {  85}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax18");
  needed_g_p[x_a][35] = {  86}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax19");

  g_f[x_a].resize(14);
  needed_g_f[x_a].resize(14);
  needed_g_f[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   18,   19,   22,   24,   25,   28,   30,   31,   32,   38,   39,   41,   44,   45,   47,   51,   52,   53,   78}; //  28
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax20");
  needed_g_f[x_a][1] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   20,   21,   23,   26,   27,   29,   33,   34,   35,   36,   37,   40,   42,   43,   46,   48,   49,   50,   79}; //  28
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax21");
  needed_g_f[x_a][2] = {  54,   66}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax22");
  needed_g_f[x_a][3] = {  54,   66}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax20");
  needed_g_f[x_a][4] = {  55,   65}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax23");
  needed_g_f[x_a][5] = {  55,   65}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax21");
  needed_g_f[x_a][6] = {  67,   68}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax19");
  needed_g_f[x_a][7] = {  67,   68,   84,   85}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax24");
  needed_g_f[x_a][8] = {  78,   79}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");
  needed_g_f[x_a][9] = {  80,   83}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax25");
  needed_g_f[x_a][10] = {  80,   83}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax20");
  needed_g_f[x_a][11] = {  81,   82}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax26");
  needed_g_f[x_a][12] = {  81,   82}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax21");
  needed_g_f[x_a][13] = {  86}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax12");

  g_t[x_a].resize(32);
  needed_g_t[x_a].resize(32);
  needed_g_t[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   54,   66}; //  11
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    4,    6,    7,   10,   12,   13,   14}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__130_1__64_60");
  needed_g_t[x_a][2] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   55,   65}; //  11
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__64_188");
  needed_g_t[x_a][3] = {   2,    3,    5,    8,    9,   11,   15,   16,   17}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__66_1__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__66_1__128_60");
  needed_g_t[x_a][4] = {  18,   19,   22,   24,   25,   28,   30,   31,   32,   38,   39,   41,   44,   45,   47,   51,   52,   53,   78,   80,   83}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__128_124");
  needed_g_t[x_a][5] = {  18,   19,   22,   24,   25,   28,   30,   31,   32,   78}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_129__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_129__64_60");
  needed_g_t[x_a][6] = {  20,   21,   23,   26,   27,   29,   33,   34,   35,   36,   37,   40,   42,   43,   46,   48,   49,   50,   79,   81,   82}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__64_188");
  needed_g_t[x_a][7] = {  20,   21,   23,   26,   27,   29,   33,   34,   35,   79}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__128_60");
  needed_g_t[x_a][8] = {  36,   37,   40,   42,   43,   46,   48,   49,   50}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__65_2__128_60");
  needed_g_t[x_a][9] = {  38,   39,   41,   44,   45,   47,   51,   52,   53}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__129_2__64_60");
  needed_g_t[x_a][10] = {  54,   66}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_130__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_130__36_88");
  needed_g_t[x_a][11] = {  54}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__130_37__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__130_37__64_24");
  needed_g_t[x_a][12] = {  55,   65}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_66__36_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_66__36_152");
  needed_g_t[x_a][13] = {  55}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__66_37__128_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__66_37__128_24");
  needed_g_t[x_a][14] = {  56,   57,   58,   59,   60,   61,   62,   63,   64,   86}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__192_60");
  needed_g_t[x_a][15] = {  65}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__66_37__24_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__66_37__24_128");
  needed_g_t[x_a][16] = {  66}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__130_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__130_37__24_64");
  needed_g_t[x_a][17] = {  67,   68,   84,   85}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__36_216");
  needed_g_t[x_a][18] = {  67,   68,   85}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_37__24_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_37__24_192");
  needed_g_t[x_a][19] = {  67}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__37_26__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__37_26__64_128");
  needed_g_t[x_a][20] = {  68}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__37_26__128_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__37_26__128_64");
  needed_g_t[x_a][21] = {  69,   70,   71,   72,   73,   74,   75,   76,   77}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__192_60");
  needed_g_t[x_a][22] = {  78}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__129_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__129_66__36_24");
  needed_g_t[x_a][23] = {  79}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__65_130__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__65_130__36_24");
  needed_g_t[x_a][24] = {  80,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_129__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_129__24_100");
  needed_g_t[x_a][25] = {  80}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__129_26__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__129_26__36_64");
  needed_g_t[x_a][26] = {  81,   82}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_65__24_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_65__24_164");
  needed_g_t[x_a][27] = {  81}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__65_26__36_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__65_26__36_128");
  needed_g_t[x_a][28] = {  82}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__65_26__128_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__65_26__128_36");
  needed_g_t[x_a][29] = {  83}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__129_26__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__129_26__64_36");
  needed_g_t[x_a][30] = {  84}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_37__192_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_37__192_24");
  needed_g_t[x_a][31] = {  86}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_193__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_193__24_36");

  g_d[x_a].resize(12);
  needed_g_d[x_a].resize(12);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   18,   19,   20,   21,   36,   37,   38,   39,   56,   57,   69,   70}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,   18,   19,   20,   21,   36,   37,   38,   39,   56,   57,   69,   70}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   4,    5,   22,   23,   40,   41,   58,   71}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   4,    5,   22,   23,   40,   41,   58,   71}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   6,    7,    8,    9,   24,   25,   26,   27,   42,   43,   44,   45,   59,   60,   72,   73}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   6,    7,    8,    9,   24,   25,   26,   27,   42,   43,   44,   45,   59,   60,   72,   73}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {  10,   11,   28,   29,   46,   47,   61,   74}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  10,   11,   28,   29,   46,   47,   61,   74}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {  12,   13,   14,   15,   16,   17,   30,   31,   32,   33,   34,   35,   48,   49,   50,   51,   52,   53,   62,   63,   64,   75,   76,   77}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {  56,   57,   58,   59,   60,   61,   62,   63,   64,   69,   70,   71,   72,   73,   74,   75,   76,   77,   84,   85,   86}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");

  c_p[x_a].resize(87);
  c_f[x_a].resize(87);
  c_t[x_a].resize(87);
  c_d[x_a].resize(87);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   1,   2}; //   3
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  0,   1,   3}; //   3
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   4,   5}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   4,   5}; //   3
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  2,   3}; //   2
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  6,   7,   8}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  5,   6,   7}; //   3

  c_p[x_a][7] = {  6,   7,   9}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = {  5,   6,   7}; //   3

  c_p[x_a][8] = {  6,   7,   8}; //   3
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  2,   3}; //   2
  c_d[x_a][8] = {  5,   6,   7}; //   3

  c_p[x_a][9] = {  6,   7,   9}; //   3
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  2,   3}; //   2
  c_d[x_a][9] = {  5,   6,   7}; //   3

  c_p[x_a][10] = {  6,  10,  11}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = {  8,   9,   7}; //   3

  c_p[x_a][11] = {  6,  10,  11}; //   3
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  2,   3}; //   2
  c_d[x_a][11] = {  8,   9,   7}; //   3

  c_p[x_a][12] = {  0,  12,  13}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   1}; //   2
  c_d[x_a][12] = { 10,   7,   2}; //   3

  c_p[x_a][13] = {  0,  12,  14}; //   3
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = { 10,   7,   2}; //   3

  c_p[x_a][14] = {  0,  12,  15}; //   3
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  0,   1}; //   2
  c_d[x_a][14] = { 10,   7,   2}; //   3

  c_p[x_a][15] = {  0,  12,  13}; //   3
  c_f[x_a][15] = {  1}; //   1
  c_t[x_a][15] = {  2,   3}; //   2
  c_d[x_a][15] = { 10,   7,   2}; //   3

  c_p[x_a][16] = {  0,  12,  14}; //   3
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  2,   3}; //   2
  c_d[x_a][16] = { 10,   7,   2}; //   3

  c_p[x_a][17] = {  0,  12,  15}; //   3
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  2,   3}; //   2
  c_d[x_a][17] = { 10,   7,   2}; //   3

  c_p[x_a][18] = {  0,   1,   2}; //   3
  c_f[x_a][18] = {  0}; //   1
  c_t[x_a][18] = {  4,   5}; //   2
  c_d[x_a][18] = {  0,   1,   2}; //   3

  c_p[x_a][19] = {  0,   1,   3}; //   3
  c_f[x_a][19] = {  0}; //   1
  c_t[x_a][19] = {  4,   5}; //   2
  c_d[x_a][19] = {  0,   1,   2}; //   3

  c_p[x_a][20] = {  0,   1,   2}; //   3
  c_f[x_a][20] = {  1}; //   1
  c_t[x_a][20] = {  6,   7}; //   2
  c_d[x_a][20] = {  0,   1,   2}; //   3

  c_p[x_a][21] = {  0,   1,   3}; //   3
  c_f[x_a][21] = {  1}; //   1
  c_t[x_a][21] = {  6,   7}; //   2
  c_d[x_a][21] = {  0,   1,   2}; //   3

  c_p[x_a][22] = {  0,   4,   5}; //   3
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  4,   5}; //   2
  c_d[x_a][22] = {  3,   4,   2}; //   3

  c_p[x_a][23] = {  0,   4,   5}; //   3
  c_f[x_a][23] = {  1}; //   1
  c_t[x_a][23] = {  6,   7}; //   2
  c_d[x_a][23] = {  3,   4,   2}; //   3

  c_p[x_a][24] = {  6,   7,   8}; //   3
  c_f[x_a][24] = {  0}; //   1
  c_t[x_a][24] = {  4,   5}; //   2
  c_d[x_a][24] = {  5,   6,   7}; //   3

  c_p[x_a][25] = {  6,   7,   9}; //   3
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  4,   5}; //   2
  c_d[x_a][25] = {  5,   6,   7}; //   3

  c_p[x_a][26] = {  6,   7,   8}; //   3
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  6,   7}; //   2
  c_d[x_a][26] = {  5,   6,   7}; //   3

  c_p[x_a][27] = {  6,   7,   9}; //   3
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  6,   7}; //   2
  c_d[x_a][27] = {  5,   6,   7}; //   3

  c_p[x_a][28] = {  6,  10,  11}; //   3
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  4,   5}; //   2
  c_d[x_a][28] = {  8,   9,   7}; //   3

  c_p[x_a][29] = {  6,  10,  11}; //   3
  c_f[x_a][29] = {  1}; //   1
  c_t[x_a][29] = {  6,   7}; //   2
  c_d[x_a][29] = {  8,   9,   7}; //   3

  c_p[x_a][30] = {  0,  12,  13}; //   3
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  4,   5}; //   2
  c_d[x_a][30] = { 10,   7,   2}; //   3

  c_p[x_a][31] = {  0,  12,  14}; //   3
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  4,   5}; //   2
  c_d[x_a][31] = { 10,   7,   2}; //   3

  c_p[x_a][32] = {  0,  12,  15}; //   3
  c_f[x_a][32] = {  0}; //   1
  c_t[x_a][32] = {  4,   5}; //   2
  c_d[x_a][32] = { 10,   7,   2}; //   3

  c_p[x_a][33] = {  0,  12,  13}; //   3
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = {  6,   7}; //   2
  c_d[x_a][33] = { 10,   7,   2}; //   3

  c_p[x_a][34] = {  0,  12,  14}; //   3
  c_f[x_a][34] = {  1}; //   1
  c_t[x_a][34] = {  6,   7}; //   2
  c_d[x_a][34] = { 10,   7,   2}; //   3

  c_p[x_a][35] = {  0,  12,  15}; //   3
  c_f[x_a][35] = {  1}; //   1
  c_t[x_a][35] = {  6,   7}; //   2
  c_d[x_a][35] = { 10,   7,   2}; //   3

  c_p[x_a][36] = {  0,   1,   2}; //   3
  c_f[x_a][36] = {  1}; //   1
  c_t[x_a][36] = {  6,   8}; //   2
  c_d[x_a][36] = {  0,   1,   2}; //   3

  c_p[x_a][37] = {  0,   1,   3}; //   3
  c_f[x_a][37] = {  1}; //   1
  c_t[x_a][37] = {  6,   8}; //   2
  c_d[x_a][37] = {  0,   1,   2}; //   3

  c_p[x_a][38] = {  0,   1,   2}; //   3
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  4,   9}; //   2
  c_d[x_a][38] = {  0,   1,   2}; //   3

  c_p[x_a][39] = {  0,   1,   3}; //   3
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  4,   9}; //   2
  c_d[x_a][39] = {  0,   1,   2}; //   3

  c_p[x_a][40] = {  0,   4,   5}; //   3
  c_f[x_a][40] = {  1}; //   1
  c_t[x_a][40] = {  6,   8}; //   2
  c_d[x_a][40] = {  3,   4,   2}; //   3

  c_p[x_a][41] = {  0,   4,   5}; //   3
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  4,   9}; //   2
  c_d[x_a][41] = {  3,   4,   2}; //   3

  c_p[x_a][42] = {  6,   7,   8}; //   3
  c_f[x_a][42] = {  1}; //   1
  c_t[x_a][42] = {  6,   8}; //   2
  c_d[x_a][42] = {  5,   6,   7}; //   3

  c_p[x_a][43] = {  6,   7,   9}; //   3
  c_f[x_a][43] = {  1}; //   1
  c_t[x_a][43] = {  6,   8}; //   2
  c_d[x_a][43] = {  5,   6,   7}; //   3

  c_p[x_a][44] = {  6,   7,   8}; //   3
  c_f[x_a][44] = {  0}; //   1
  c_t[x_a][44] = {  4,   9}; //   2
  c_d[x_a][44] = {  5,   6,   7}; //   3

  c_p[x_a][45] = {  6,   7,   9}; //   3
  c_f[x_a][45] = {  0}; //   1
  c_t[x_a][45] = {  4,   9}; //   2
  c_d[x_a][45] = {  5,   6,   7}; //   3

  c_p[x_a][46] = {  6,  10,  11}; //   3
  c_f[x_a][46] = {  1}; //   1
  c_t[x_a][46] = {  6,   8}; //   2
  c_d[x_a][46] = {  8,   9,   7}; //   3

  c_p[x_a][47] = {  6,  10,  11}; //   3
  c_f[x_a][47] = {  0}; //   1
  c_t[x_a][47] = {  4,   9}; //   2
  c_d[x_a][47] = {  8,   9,   7}; //   3

  c_p[x_a][48] = {  0,  12,  13}; //   3
  c_f[x_a][48] = {  1}; //   1
  c_t[x_a][48] = {  6,   8}; //   2
  c_d[x_a][48] = { 10,   7,   2}; //   3

  c_p[x_a][49] = {  0,  12,  14}; //   3
  c_f[x_a][49] = {  1}; //   1
  c_t[x_a][49] = {  6,   8}; //   2
  c_d[x_a][49] = { 10,   7,   2}; //   3

  c_p[x_a][50] = {  0,  12,  15}; //   3
  c_f[x_a][50] = {  1}; //   1
  c_t[x_a][50] = {  6,   8}; //   2
  c_d[x_a][50] = { 10,   7,   2}; //   3

  c_p[x_a][51] = {  0,  12,  13}; //   3
  c_f[x_a][51] = {  0}; //   1
  c_t[x_a][51] = {  4,   9}; //   2
  c_d[x_a][51] = { 10,   7,   2}; //   3

  c_p[x_a][52] = {  0,  12,  14}; //   3
  c_f[x_a][52] = {  0}; //   1
  c_t[x_a][52] = {  4,   9}; //   2
  c_d[x_a][52] = { 10,   7,   2}; //   3

  c_p[x_a][53] = {  0,  12,  15}; //   3
  c_f[x_a][53] = {  0}; //   1
  c_t[x_a][53] = {  4,   9}; //   2
  c_d[x_a][53] = { 10,   7,   2}; //   3

  c_p[x_a][54] = {  0,  12}; //   2
  c_f[x_a][54] = {  2,   3}; //   2
  c_t[x_a][54] = {  0,  10,  11}; //   3
  c_d[x_a][54] = {  7,   2}; //   2

  c_p[x_a][55] = {  0,  12}; //   2
  c_f[x_a][55] = {  4,   5}; //   2
  c_t[x_a][55] = {  2,  12,  13}; //   3
  c_d[x_a][55] = {  7,   2}; //   2

  c_p[x_a][56] = {  0,   1,   2,  16}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = { 14}; //   1
  c_d[x_a][56] = { 11,   0,   1,   2}; //   4

  c_p[x_a][57] = {  0,   1,   3,  16}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = { 14}; //   1
  c_d[x_a][57] = { 11,   0,   1,   2}; //   4

  c_p[x_a][58] = {  0,   4,   5,  16}; //   4
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = { 14}; //   1
  c_d[x_a][58] = { 11,   3,   4,   2}; //   4

  c_p[x_a][59] = {  6,   7,   8,  16}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = { 14}; //   1
  c_d[x_a][59] = { 11,   5,   6,   7}; //   4

  c_p[x_a][60] = {  6,   7,   9,  16}; //   4
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = { 14}; //   1
  c_d[x_a][60] = { 11,   5,   6,   7}; //   4

  c_p[x_a][61] = {  6,  10,  11,  16}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = { 14}; //   1
  c_d[x_a][61] = { 11,   8,   9,   7}; //   4

  c_p[x_a][62] = {  0,  12,  13,  16}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = { 14}; //   1
  c_d[x_a][62] = { 11,  10,   7,   2}; //   4

  c_p[x_a][63] = {  0,  12,  14,  16}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = { 14}; //   1
  c_d[x_a][63] = { 11,  10,   7,   2}; //   4

  c_p[x_a][64] = {  0,  12,  15,  16}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = { 14}; //   1
  c_d[x_a][64] = { 11,  10,   7,   2}; //   4

  c_p[x_a][65] = {  0,  12}; //   2
  c_f[x_a][65] = {  4,   5}; //   2
  c_t[x_a][65] = {  2,  12,  15}; //   3
  c_d[x_a][65] = {  7,   2}; //   2

  c_p[x_a][66] = {  0,  12}; //   2
  c_f[x_a][66] = {  2,   3}; //   2
  c_t[x_a][66] = {  0,  10,  16}; //   3
  c_d[x_a][66] = {  7,   2}; //   2

  c_p[x_a][67] = {  0,  12}; //   2
  c_f[x_a][67] = {  6,   7}; //   2
  c_t[x_a][67] = { 17,  18,  19}; //   3
  c_d[x_a][67] = {  7,   2}; //   2

  c_p[x_a][68] = {  0,  12}; //   2
  c_f[x_a][68] = {  6,   7}; //   2
  c_t[x_a][68] = { 17,  18,  20}; //   3
  c_d[x_a][68] = {  7,   2}; //   2

  c_p[x_a][69] = { 17,  18,  19,  20}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = { 21}; //   1
  c_d[x_a][69] = {  0,   1,   2,  11}; //   4

  c_p[x_a][70] = { 17,  18,  19,  21}; //   4
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = { 21}; //   1
  c_d[x_a][70] = {  0,   1,   2,  11}; //   4

  c_p[x_a][71] = { 17,  18,  22,  23}; //   4
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = { 21}; //   1
  c_d[x_a][71] = {  3,   4,   2,  11}; //   4

  c_p[x_a][72] = { 17,  24,  25,  26}; //   4
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = { 21}; //   1
  c_d[x_a][72] = {  5,   6,   7,  11}; //   4

  c_p[x_a][73] = { 17,  24,  25,  27}; //   4
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = { 21}; //   1
  c_d[x_a][73] = {  5,   6,   7,  11}; //   4

  c_p[x_a][74] = { 17,  24,  28,  29}; //   4
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = { 21}; //   1
  c_d[x_a][74] = {  8,   9,   7,  11}; //   4

  c_p[x_a][75] = { 17,  18,  30,  31}; //   4
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = { 21}; //   1
  c_d[x_a][75] = { 10,   7,   2,  11}; //   4

  c_p[x_a][76] = { 17,  18,  30,  32}; //   4
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = { 21}; //   1
  c_d[x_a][76] = { 10,   7,   2,  11}; //   4

  c_p[x_a][77] = { 17,  18,  30,  33}; //   4
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = { 21}; //   1
  c_d[x_a][77] = { 10,   7,   2,  11}; //   4

  c_p[x_a][78] = {  0,  12}; //   2
  c_f[x_a][78] = {  8,   0}; //   2
  c_t[x_a][78] = {  4,   5,  22}; //   3
  c_d[x_a][78] = {  7,   2}; //   2

  c_p[x_a][79] = {  0,  12}; //   2
  c_f[x_a][79] = {  8,   1}; //   2
  c_t[x_a][79] = {  6,   7,  23}; //   3
  c_d[x_a][79] = {  7,   2}; //   2

  c_p[x_a][80] = {  0,  12}; //   2
  c_f[x_a][80] = {  9,  10}; //   2
  c_t[x_a][80] = {  4,  24,  25}; //   3
  c_d[x_a][80] = {  7,   2}; //   2

  c_p[x_a][81] = {  0,  12}; //   2
  c_f[x_a][81] = { 11,  12}; //   2
  c_t[x_a][81] = {  6,  26,  27}; //   3
  c_d[x_a][81] = {  7,   2}; //   2

  c_p[x_a][82] = {  0,  12}; //   2
  c_f[x_a][82] = { 11,  12}; //   2
  c_t[x_a][82] = {  6,  26,  28}; //   3
  c_d[x_a][82] = {  7,   2}; //   2

  c_p[x_a][83] = {  0,  12}; //   2
  c_f[x_a][83] = {  9,  10}; //   2
  c_t[x_a][83] = {  4,  24,  29}; //   3
  c_d[x_a][83] = {  7,   2}; //   2

  c_p[x_a][84] = { 17,  18,  30}; //   3
  c_f[x_a][84] = {  7}; //   1
  c_t[x_a][84] = { 17,  30}; //   2
  c_d[x_a][84] = {  7,   2,  11}; //   3

  c_p[x_a][85] = {  0,  34,  30}; //   3
  c_f[x_a][85] = {  7}; //   1
  c_t[x_a][85] = { 17,  18}; //   2
  c_d[x_a][85] = {  7,  11,   2}; //   3

  c_p[x_a][86] = {  0,  12,  35}; //   3
  c_f[x_a][86] = { 13}; //   1
  c_t[x_a][86] = { 14,  31}; //   2
  c_d[x_a][86] = { 11,   7,   2}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   5,   5)
// channel    1: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   5,   5)
// channel    2: 4yyv11(1, 2, 4, 32, 8, 16, 128, 64;  24,   0,   0,   5,   5)
// channel    3: 4yyv11(1, 2, 4, 32, 8, 16, 128, 64;  24,   0,  23,   5,   5)
// channel    4: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   5,   5)
// channel    5: 4yyv11(1, 2, 32, 4, 8, 16, 128, 64;  24,   0,  23,   5,   5)
// channel    6: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   5,   5)
// channel    7: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   5,   5)
// channel    8: 4yyv11(1, 2, 8, 16, 4, 32, 128, 64;  24,   0,   0,   5,   5)
// channel    9: 4yyv11(1, 2, 8, 16, 4, 32, 128, 64;  24,   0,  23,   5,   5)
// channel   10: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   5,   5)
// channel   11: 4yyv11(1, 2, 16, 8, 4, 32, 128, 64;  24,   0,  23,   5,   5)
// channel   12: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   5,   5)
// channel   13: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   5,   5)
// channel   14: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  25,   5,   5)
// channel   15: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,   0,   5,   5)
// channel   16: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,  23,   5,   5)
// channel   17: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,  25,   5,   5)
// channel   18: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   5,   5)
// channel   19: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   5,   5)
// channel   20: 14yyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   5,   5)
// channel   21: 14yyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   5,   5)
// channel   22: 14yyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   5,   5)
// channel   23: 14yyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   5,   5)
// channel   24: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   5,   5)
// channel   25: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   5,   5)
// channel   26: 14yyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   5,   5)
// channel   27: 14yyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   5,   5)
// channel   28: 14yyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   5,   5)
// channel   29: 14yyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   5,   5)
// channel   30: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   5,   5)
// channel   31: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   5,   5)
// channel   32: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  25,   5,   5)
// channel   33: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   5,   5)
// channel   34: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   5,   5)
// channel   35: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  25,   5,   5)
// channel   36: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   5)
// channel   37: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   5)
// channel   38: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   5,   5)
// channel   39: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   5,   5)
// channel   40: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   5)
// channel   41: 114yyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   5,   5)
// channel   42: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   5)
// channel   43: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   5)
// channel   44: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   5,   5)
// channel   45: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   5,   5)
// channel   46: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   5)
// channel   47: 114yyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   5,   5)
// channel   48: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   5)
// channel   49: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   5)
// channel   50: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   5)
// channel   51: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   5,   5)
// channel   52: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   5,   5)
// channel   53: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  25,   5,   5)
// channel   54: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   5,   6,   5)
// channel   55: 2v2v11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,   5,   6,   5)
// channel   56: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   5)
// channel   57: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   5)
// channel   58: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   5)
// channel   59: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   5)
// channel   60: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   5)
// channel   61: 2v4yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   5)
// channel   62: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   5)
// channel   63: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   5)
// channel   64: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   0,   5)
// channel   65: 2v12v1(1, 2, 4, 32, 128, 8, 16, 64;  24,  24,   5,   6,   6)
// channel   66: 2v12v1(1, 2, 4, 32, 64, 8, 16, 128;  24,  24,   5,   6,   6)
// channel   67: 2v112v(1, 2, 4, 32, 64, 128, 8, 16;  24,  24,   6,   6,   6)
// channel   68: 2v112v(1, 2, 4, 32, 128, 64, 8, 16;  24,  24,   6,   6,   6)
// channel   69: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,   0,   5)
// channel   70: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,  23,   5)
// channel   71: 4yyv2v(1, 2, 32, 4, 8, 16, 64, 128;   0,  24,   0,  23,   5)
// channel   72: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,   0,   5)
// channel   73: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,  23,   5)
// channel   74: 4yyv2v(1, 2, 16, 8, 4, 32, 64, 128;   0,  24,   0,  23,   5)
// channel   75: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   5)
// channel   76: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  23,   5)
// channel   77: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  25,   5)
// channel   78: 12v2v1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   5,   5,   6)
// channel   79: 12v2v1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   5,   5,   6)
// channel   80: 12v12v(1, 2, 128, 4, 32, 64, 8, 16;  24,  24,   5,   6,   6)
// channel   81: 12v12v(1, 2, 64, 4, 32, 128, 8, 16;  24,  24,   5,   6,   6)
// channel   82: 112v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   5,   6,   5)
// channel   83: 112v2v(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   5,   6,   5)
// channel   84: 2v2v2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   6,   5)
// channel   85: 2v2v2v(1, 2, 4, 32, 64, 128, 8, 16;  24,   0,  24,   6,   6)
// channel   86: 2v2v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   6)
