#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_bdx_emmupvmvexbdx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_bdx_emmupvmvexbdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(17);
  needed_v_smin[x_a].resize(17);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  28
  needed_v_smin[x_a][  1] = {   0,    1,    9,   10,   19,   20,   28,   29}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    9,   10,   19,   20,   28,   29}; //   8
  needed_v_smin[x_a][  3] = {   2,   11,   21,   30}; //   4
  needed_v_smin[x_a][  4] = {   2,   11,   21,   30}; //   4
  needed_v_smin[x_a][  5] = {   3,    4,    5,    6,    7,    8,   12,   13,   14,   15,   16,   17,   18,   22,   23,   24,   25,   26,   27,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  28
  needed_v_smin[x_a][  6] = {   3,    4,   12,   13,   22,   23,   31,   32}; //   8
  needed_v_smin[x_a][  7] = {   3,    4,   12,   13,   22,   23,   31,   32}; //   8
  needed_v_smin[x_a][  8] = {   5,   14,   24,   33}; //   4
  needed_v_smin[x_a][  9] = {   5,   14,   24,   33}; //   4
  needed_v_smin[x_a][ 10] = {   6,    7,    8,   15,   16,   17,   25,   26,   34,   35}; //  10
  needed_v_smin[x_a][ 11] = {   9,   10,   11,   12,   13,   14,   15,   16,   17,    0,    1,    2,    3,    4,    5,    6,    7,    8}; //  18
  needed_v_smin[x_a][ 12] = {  18,   37,   36}; //   3
  needed_v_smin[x_a][ 13] = {  18,   36,   37}; //   3
  needed_v_smin[x_a][ 14] = {  19,   20,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33,   34,   35}; //  16
  needed_v_smin[x_a][ 15] = {  27,   38,   39}; //   3
  needed_v_smin[x_a][ 16] = {  27,   38,   39}; //   3

  v_smax[x_a].resize(16);
  needed_v_smax[x_a].resize(16);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   25,   26,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  27
  needed_v_smax[x_a][  1] = {   0,    1,    9,   10,   19,   20,   28,   29}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   19,   20,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33,   34,   35}; //  34
  needed_v_smax[x_a][  3] = {   2,   11,   21,   30}; //   4
  needed_v_smax[x_a][  4] = {   3,    4,    5,   12,   13,   14,   22,   23,   24,   27,   31,   32,   33}; //  13
  needed_v_smax[x_a][  5] = {   3,    4,   12,   13,   22,   23,   31,   32}; //   8
  needed_v_smax[x_a][  6] = {   5,   14,   24,   33}; //   4
  needed_v_smax[x_a][  7] = {   6,    7,    8,   15,   16,   17,   25,   26,   34,   35,   36,   38,   39}; //  13
  needed_v_smax[x_a][  8] = {   9,   10,   11,   12,   13,   14,   15,   16,   17,   18,    0,    1,    2,    3,    4,    5,    6,    7,    8,   36,   37}; //  21
  needed_v_smax[x_a][  9] = {  18,   37}; //   2
  needed_v_smax[x_a][ 10] = {  18,   37}; //   2
  needed_v_smax[x_a][ 11] = {  19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   38,   39}; //  19
  needed_v_smax[x_a][ 12] = {  27}; //   1
  needed_v_smax[x_a][ 13] = {  27}; //   1
  needed_v_smax[x_a][ 14] = {  38,   39}; //   2
  needed_v_smax[x_a][ 15] = {  36}; //   1

  g_p[x_a].resize(25);
  needed_g_p[x_a].resize(25);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   25,   26,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  27
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    9,   10,   19,   20,   28,   29}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    9,   19,   28}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,   10,   20,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,   11,   21,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   11,   21,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,   12,   13,   14,   22,   23,   24,   27,   31,   32,   33}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    4,   12,   13,   22,   23,   31,   32}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   12,   22,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   13,   23,   32}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {   5,   14,   24,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {   5,   14,   24,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,    8,   15,   16,   17,   25,   26,   34,   35,   36,   38,   39}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {   6,   15,   25,   34}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7,   16,   26,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {   8,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][16] = {   9,   10,   11,   12,   13,   14,   15,   16,   17}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin11_smax8");
  needed_g_p[x_a][17] = {  18,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin12_smax9");
  needed_g_p[x_a][18] = {  18,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax10");
  needed_g_p[x_a][19] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin13_smax8");
  needed_g_p[x_a][20] = {  19,   20,   21,   22,   23,   24,   25,   26}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][21] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][22] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax13");
  needed_g_p[x_a][23] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][24] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax14");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][1] = {  28,   29,   30,   31,   32,   33,   34,   35}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax11");
  needed_g_f[x_a][2] = {  36}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax15");
  needed_g_f[x_a][3] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax8");
  needed_g_f[x_a][4] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax11");
  needed_g_f[x_a][5] = {  39}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax14");

  g_t[x_a].resize(8);
  needed_g_t[x_a].resize(8);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   36,   37}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__130_1__64_60");
  needed_g_t[x_a][2] = {  19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   38,   39}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][3] = {  28,   29,   30,   31,   32,   33,   34,   35}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][4] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_130__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_130__36_88");
  needed_g_t[x_a][5] = {  36}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__130_37__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__130_37__64_24");
  needed_g_t[x_a][6] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_164");
  needed_g_t[x_a][7] = {  39}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__128_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__128_36");

  g_d[x_a].resize(17);
  needed_g_d[x_a].resize(17);
  needed_g_d[x_a][0] = {   0,    1,    9,   10,   19,   20,   28,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    9,   10,   19,   20,   28,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  28
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   2,   11,   21,   30}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,   11,   21,   30}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,    4,   12,   13,   22,   23,   31,   32}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    4,   12,   13,   22,   23,   31,   32}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   3,    4,    5,    6,    7,    8,   12,   13,   14,   15,   16,   17,   18,   22,   23,   24,   25,   26,   27,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  28
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {   5,   14,   24,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5,   14,   24,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   6,    7,    8,   15,   16,   17,   25,   26,   34,   35}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {   9,   10,   11,   12,   13,   14,   15,   16,   17}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][12] = {  18}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][13] = {  18,   37}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][14] = {  19,   20,   21,   22,   23,   24,   25,   26}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][15] = {  27}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][16] = {  27,   38}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");

  c_p[x_a].resize(40);
  c_f[x_a].resize(40);
  c_t[x_a].resize(40);
  c_d[x_a].resize(40);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   7,   9}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  5,   6,   7}; //   3

  c_p[x_a][5] = {  6,  10,  11}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  8,   9,   7}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = { 10,   7,   2}; //   3

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = { 10,   7,   2}; //   3

  c_p[x_a][8] = {  0,  12,  15}; //   3
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  0,   1}; //   2
  c_d[x_a][8] = { 10,   7,   2}; //   3

  c_p[x_a][9] = {  0,   1,   2,  16}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 11,   0,   1,   2}; //   4

  c_p[x_a][10] = {  0,   1,   3,  16}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 11,   0,   1,   2}; //   4

  c_p[x_a][11] = {  0,   4,   5,  16}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = { 11,   3,   4,   2}; //   4

  c_p[x_a][12] = {  6,   7,   8,  16}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 11,   5,   6,   7}; //   4

  c_p[x_a][13] = {  6,   7,   9,  16}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 11,   5,   6,   7}; //   4

  c_p[x_a][14] = {  6,  10,  11,  16}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 11,   8,   9,   7}; //   4

  c_p[x_a][15] = {  0,  12,  13,  16}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 11,  10,   7,   2}; //   4

  c_p[x_a][16] = {  0,  12,  14,  16}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 11,  10,   7,   2}; //   4

  c_p[x_a][17] = {  0,  12,  15,  16}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 11,  10,   7,   2}; //   4

  c_p[x_a][18] = {  0,  17,  18,  19}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 12,   7,  13,   2}; //   4

  c_p[x_a][19] = {  0,   1,   2,  20}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  2}; //   1
  c_d[x_a][19] = { 14,   0,   1,   2}; //   4

  c_p[x_a][20] = {  0,   1,   3,  20}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  2}; //   1
  c_d[x_a][20] = { 14,   0,   1,   2}; //   4

  c_p[x_a][21] = {  0,   4,   5,  20}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  2}; //   1
  c_d[x_a][21] = { 14,   3,   4,   2}; //   4

  c_p[x_a][22] = {  6,   7,   8,  20}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  2}; //   1
  c_d[x_a][22] = { 14,   5,   6,   7}; //   4

  c_p[x_a][23] = {  6,   7,   9,  20}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  2}; //   1
  c_d[x_a][23] = { 14,   5,   6,   7}; //   4

  c_p[x_a][24] = {  6,  10,  11,  20}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  2}; //   1
  c_d[x_a][24] = { 14,   8,   9,   7}; //   4

  c_p[x_a][25] = {  0,  12,  13,  20}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  2}; //   1
  c_d[x_a][25] = { 14,  10,   7,   2}; //   4

  c_p[x_a][26] = {  0,  12,  14,  20}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  2}; //   1
  c_d[x_a][26] = { 14,  10,   7,   2}; //   4

  c_p[x_a][27] = {  6,  21,  22,  23}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  2}; //   1
  c_d[x_a][27] = { 15,   2,  16,   7}; //   4

  c_p[x_a][28] = {  0,   1,   2}; //   3
  c_f[x_a][28] = {  1}; //   1
  c_t[x_a][28] = {  2,   3}; //   2
  c_d[x_a][28] = {  0,   1,   2}; //   3

  c_p[x_a][29] = {  0,   1,   3}; //   3
  c_f[x_a][29] = {  1}; //   1
  c_t[x_a][29] = {  2,   3}; //   2
  c_d[x_a][29] = {  0,   1,   2}; //   3

  c_p[x_a][30] = {  0,   4,   5}; //   3
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  2,   3}; //   2
  c_d[x_a][30] = {  3,   4,   2}; //   3

  c_p[x_a][31] = {  6,   7,   8}; //   3
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = {  2,   3}; //   2
  c_d[x_a][31] = {  5,   6,   7}; //   3

  c_p[x_a][32] = {  6,   7,   9}; //   3
  c_f[x_a][32] = {  1}; //   1
  c_t[x_a][32] = {  2,   3}; //   2
  c_d[x_a][32] = {  5,   6,   7}; //   3

  c_p[x_a][33] = {  6,  10,  11}; //   3
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = {  2,   3}; //   2
  c_d[x_a][33] = {  8,   9,   7}; //   3

  c_p[x_a][34] = {  0,  12,  13}; //   3
  c_f[x_a][34] = {  1}; //   1
  c_t[x_a][34] = {  2,   3}; //   2
  c_d[x_a][34] = { 10,   7,   2}; //   3

  c_p[x_a][35] = {  0,  12,  14}; //   3
  c_f[x_a][35] = {  1}; //   1
  c_t[x_a][35] = {  2,   3}; //   2
  c_d[x_a][35] = { 10,   7,   2}; //   3

  c_p[x_a][36] = {  0,  12}; //   2
  c_f[x_a][36] = {  2,   3}; //   2
  c_t[x_a][36] = {  0,   4,   5}; //   3
  c_d[x_a][36] = {  7,   2}; //   2

  c_p[x_a][37] = {  0,  17,  18}; //   3
  c_f[x_a][37] = {  3}; //   1
  c_t[x_a][37] = {  0,   4}; //   2
  c_d[x_a][37] = {  7,  13,   2}; //   3

  c_p[x_a][38] = {  0,  12,  24}; //   3
  c_f[x_a][38] = {  4}; //   1
  c_t[x_a][38] = {  2,   6}; //   2
  c_d[x_a][38] = { 16,   7,   2}; //   3

  c_p[x_a][39] = {  0,  12}; //   2
  c_f[x_a][39] = {  5,   4}; //   2
  c_t[x_a][39] = {  2,   6,   7}; //   3
  c_d[x_a][39] = {  7,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   0,   5)
// channel    1: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   0,   5)
// channel    2: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   0,   5)
// channel    3: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   5)
// channel    4: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   0,   5)
// channel    5: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   0,   5)
// channel    6: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   5)
// channel    7: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   0,   5)
// channel    8: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  25,   0,   5)
// channel    9: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   5,   0)
// channel   10: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   5,   0)
// channel   11: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   5,   0)
// channel   12: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   5,   0)
// channel   13: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   5,   0)
// channel   14: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   5,   0)
// channel   15: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   5,   0)
// channel   16: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   5,   0)
// channel   17: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  25,   5,   0)
// channel   18: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   6,  24,   5,   0)
// channel   19: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   20: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   21: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   22: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   23: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   24: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   25: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   26: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   27: 152vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
// channel   28: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   29: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   30: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   31: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   32: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   33: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   34: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   35: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   36: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   6,   5)
// channel   37: 2v3yv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   6,  24,   0,   6)
// channel   38: 13yv2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   39: 112v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
