#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_ddx_emmupvmvexgg(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_ddx_emmupvmvexgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(23);
  needed_v_smin[x_a].resize(23);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   60,   61,   62,   63,   64,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51,   62,   63}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51,   62,   63}; //  16
  needed_v_smin[x_a][  3] = {   4,    5,   20,   21,   36,   37,   52,   64}; //   8
  needed_v_smin[x_a][  4] = {   4,    5,   20,   21,   36,   37,   52,   64}; //   8
  needed_v_smin[x_a][  5] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   53,   54,   55,   56,   57,   58,   59,   60,   61,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  needed_v_smin[x_a][  6] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54,   65,   66}; //  16
  needed_v_smin[x_a][  7] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54,   65,   66}; //  16
  needed_v_smin[x_a][  8] = {  10,   11,   26,   27,   42,   43,   55,   67}; //   8
  needed_v_smin[x_a][  9] = {  10,   11,   26,   27,   42,   43,   55,   67}; //   8
  needed_v_smin[x_a][ 10] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   56,   57,   68,   69,   70,   71,   78}; //  19
  needed_v_smin[x_a][ 11] = {  50,   51,   52,   53,   54,   55,   56,   57,   62,   63,   64,   65,   66,   67,   68,   69,   76,   77,   78,   60,   61}; //  21
  needed_v_smin[x_a][ 12] = {   0,    1,    4,    6,    7,   10,   12,   13,   16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   37,   40,   41,   43,   46,   47,   70}; //  25
  needed_v_smin[x_a][ 13] = {   2,    3,    5,    8,    9,   11,   14,   15,   18,   19,   21,   24,   25,   27,   30,   31,   32,   33,   36,   38,   39,   42,   44,   45,   71}; //  25
  needed_v_smin[x_a][ 14] = {  48,   59}; //   2
  needed_v_smin[x_a][ 15] = {  48,   59}; //   2
  needed_v_smin[x_a][ 16] = {  49,   58}; //   2
  needed_v_smin[x_a][ 17] = {  49,   58}; //   2
  needed_v_smin[x_a][ 18] = {  60,   61,   76,   77}; //   4
  needed_v_smin[x_a][ 19] = {  72,   75}; //   2
  needed_v_smin[x_a][ 20] = {  72,   75}; //   2
  needed_v_smin[x_a][ 21] = {  73,   74}; //   2
  needed_v_smin[x_a][ 22] = {  73,   74}; //   2

  v_smax[x_a].resize(27);
  needed_v_smax[x_a].resize(27);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   60,   61,   70,   71,   72,   73,   74,   75,   77,   78}; //  49
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51}; //  14
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   50,   51,   52,   53,   54,   55,   56,   57,   70,   71}; //  58
  needed_v_smax[x_a][  3] = {   4,    5,   20,   21,   36,   37,   52}; //   7
  needed_v_smax[x_a][  4] = {   6,    7,    8,    9,   10,   11,   22,   23,   24,   25,   26,   27,   38,   39,   40,   41,   42,   43,   53,   54,   55}; //  21
  needed_v_smax[x_a][  5] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54}; //  14
  needed_v_smax[x_a][  6] = {  10,   11,   26,   27,   42,   43,   55}; //   7
  needed_v_smax[x_a][  7] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   48,   49,   56,   57,   58,   59,   60,   61,   70,   71,   72,   73,   74,   75,   78}; //  27
  needed_v_smax[x_a][  8] = {  50,   51,   52,   53,   54,   55,   56,   57}; //   8
  needed_v_smax[x_a][  9] = {  62,   63,   64,   65,   66,   67,   68,   69,   76}; //   9
  needed_v_smax[x_a][ 10] = {  62,   63,   64,   68,   69,   76}; //   6
  needed_v_smax[x_a][ 11] = {  62,   63}; //   2
  needed_v_smax[x_a][ 12] = {  62,   63,   64,   65,   66,   67,   68,   69,   78}; //   9
  needed_v_smax[x_a][ 13] = {  64}; //   1
  needed_v_smax[x_a][ 14] = {  65,   66,   67}; //   3
  needed_v_smax[x_a][ 15] = {  65,   66}; //   2
  needed_v_smax[x_a][ 16] = {  67}; //   1
  needed_v_smax[x_a][ 17] = {  68,   69,   76,   77}; //   4
  needed_v_smax[x_a][ 18] = {  77}; //   1
  needed_v_smax[x_a][ 19] = {  78,   60,   61}; //   3
  needed_v_smax[x_a][ 20] = {   0,    1,    4,    6,    7,   10,   12,   13,   16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   37,   40,   41,   43,   46,   47,   48,   59,   70,   72,   75}; //  29
  needed_v_smax[x_a][ 21] = {   2,    3,    5,    8,    9,   11,   14,   15,   18,   19,   21,   24,   25,   27,   30,   31,   32,   33,   36,   38,   39,   42,   44,   45,   49,   58,   71,   73,   74}; //  29
  needed_v_smax[x_a][ 22] = {  48,   59}; //   2
  needed_v_smax[x_a][ 23] = {  49,   58}; //   2
  needed_v_smax[x_a][ 24] = {  60,   61,   76,   77}; //   4
  needed_v_smax[x_a][ 25] = {  72,   75}; //   2
  needed_v_smax[x_a][ 26] = {  73,   74}; //   2

  g_p[x_a].resize(34);
  needed_g_p[x_a].resize(34);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   60,   61,   70,   71,   72,   73,   74,   75,   77,   78}; //  49
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   16,   18,   32,   34,   50}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   17,   19,   33,   35,   51}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   4,    5,   20,   21,   36,   37,   52}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   4,    5,   20,   21,   36,   37,   52}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   6,    7,    8,    9,   10,   11,   22,   23,   24,   25,   26,   27,   38,   39,   40,   41,   42,   43,   53,   54,   55}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   6,    8,   22,   24,   38,   40,   53}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   7,    9,   23,   25,   39,   41,   54}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {  10,   11,   26,   27,   42,   43,   55}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {  10,   11,   26,   27,   42,   43,   55}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   48,   49,   56,   57,   58,   59,   60,   61,   70,   71,   72,   73,   74,   75,   78}; //  27
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {  12,   14,   28,   30,   44,   46,   56}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {  13,   15,   29,   31,   45,   47,   57}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {  50,   51,   52,   53,   54,   55,   56,   57}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][16] = {  62,   63,   64,   65,   66,   67,   68,   69,   76}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][17] = {  62,   63,   64,   68,   69,   76}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax10");
  needed_g_p[x_a][18] = {  62,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][19] = {  62}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax12");
  needed_g_p[x_a][20] = {  63}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax12");
  needed_g_p[x_a][21] = {  64}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax13");
  needed_g_p[x_a][22] = {  64}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax12");
  needed_g_p[x_a][23] = {  65,   66,   67}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax14");
  needed_g_p[x_a][24] = {  65,   66}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax15");
  needed_g_p[x_a][25] = {  65}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax12");
  needed_g_p[x_a][26] = {  66}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax12");
  needed_g_p[x_a][27] = {  67}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax16");
  needed_g_p[x_a][28] = {  67}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax12");
  needed_g_p[x_a][29] = {  68,   69,   76,   77}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax17");
  needed_g_p[x_a][30] = {  68}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax12");
  needed_g_p[x_a][31] = {  69}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax12");
  needed_g_p[x_a][32] = {  77}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax18");
  needed_g_p[x_a][33] = {  78}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax19");

  g_f[x_a].resize(14);
  needed_g_f[x_a].resize(14);
  needed_g_f[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   37,   40,   41,   43,   46,   47,   70}; //  25
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax20");
  needed_g_f[x_a][1] = {   2,    3,    5,    8,    9,   11,   14,   15,   18,   19,   21,   24,   25,   27,   30,   31,   32,   33,   36,   38,   39,   42,   44,   45,   71}; //  25
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax21");
  needed_g_f[x_a][2] = {  48,   59}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax22");
  needed_g_f[x_a][3] = {  48,   59}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax20");
  needed_g_f[x_a][4] = {  49,   58}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax23");
  needed_g_f[x_a][5] = {  49,   58}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax21");
  needed_g_f[x_a][6] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax19");
  needed_g_f[x_a][7] = {  60,   61,   76,   77}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax24");
  needed_g_f[x_a][8] = {  70,   71}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");
  needed_g_f[x_a][9] = {  72,   75}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax25");
  needed_g_f[x_a][10] = {  72,   75}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax20");
  needed_g_f[x_a][11] = {  73,   74}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax26");
  needed_g_f[x_a][12] = {  73,   74}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax21");
  needed_g_f[x_a][13] = {  78}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax12");

  g_t[x_a].resize(32);
  needed_g_t[x_a].resize(32);
  needed_g_t[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   48,   59}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    4,    6,    7,   10,   12,   13}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {   2,    3,    5,    8,    9,   11,   14,   15,   49,   58}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][3] = {   2,    3,    5,    8,    9,   11,   14,   15}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__128_60");
  needed_g_t[x_a][4] = {  16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   37,   40,   41,   43,   46,   47,   70,   72,   75}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__128_124");
  needed_g_t[x_a][5] = {  16,   17,   20,   22,   23,   26,   28,   29,   70}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__64_60");
  needed_g_t[x_a][6] = {  18,   19,   21,   24,   25,   27,   30,   31,   32,   33,   36,   38,   39,   42,   44,   45,   71,   73,   74}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][7] = {  18,   19,   21,   24,   25,   27,   30,   31,   71}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__128_60");
  needed_g_t[x_a][8] = {  32,   33,   36,   38,   39,   42,   44,   45}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][9] = {  34,   35,   37,   40,   41,   43,   46,   47}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__129_2__64_60");
  needed_g_t[x_a][10] = {  48,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__36_88");
  needed_g_t[x_a][11] = {  48}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_37__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_37__64_24");
  needed_g_t[x_a][12] = {  49,   58}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__36_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__36_152");
  needed_g_t[x_a][13] = {  49}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_37__128_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_37__128_24");
  needed_g_t[x_a][14] = {  50,   51,   52,   53,   54,   55,   56,   57,   78}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][15] = {  58}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_37__24_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_37__24_128");
  needed_g_t[x_a][16] = {  59}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_37__24_64");
  needed_g_t[x_a][17] = {  60,   61,   76,   77}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_216");
  needed_g_t[x_a][18] = {  60,   61,   77}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__24_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__24_192");
  needed_g_t[x_a][19] = {  60}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__37_26__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__37_26__64_128");
  needed_g_t[x_a][20] = {  61}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__37_26__128_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__37_26__128_64");
  needed_g_t[x_a][21] = {  62,   63,   64,   65,   66,   67,   68,   69}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][22] = {  70}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_66__36_24");
  needed_g_t[x_a][23] = {  71}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_130__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_130__36_24");
  needed_g_t[x_a][24] = {  72,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__24_100");
  needed_g_t[x_a][25] = {  72}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_26__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_26__36_64");
  needed_g_t[x_a][26] = {  73,   74}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_164");
  needed_g_t[x_a][27] = {  73}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__36_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__36_128");
  needed_g_t[x_a][28] = {  74}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__128_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__128_36");
  needed_g_t[x_a][29] = {  75}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_26__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_26__64_36");
  needed_g_t[x_a][30] = {  76}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__192_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__192_24");
  needed_g_t[x_a][31] = {  78}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__24_36");

  g_d[x_a].resize(12);
  needed_g_d[x_a].resize(12);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51,   62,   63}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51,   62,   63}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   60,   61,   62,   63,   64,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   4,    5,   20,   21,   36,   37,   52,   64}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   4,    5,   20,   21,   36,   37,   52,   64}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54,   65,   66}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54,   65,   66}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   53,   54,   55,   56,   57,   58,   59,   60,   61,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {  10,   11,   26,   27,   42,   43,   55,   67}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  10,   11,   26,   27,   42,   43,   55,   67}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   56,   57,   68,   69}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {  50,   51,   52,   53,   54,   55,   56,   57,   62,   63,   64,   65,   66,   67,   68,   69,   76,   77,   78}; //  19
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");

  c_p[x_a].resize(79);
  c_f[x_a].resize(79);
  c_t[x_a].resize(79);
  c_d[x_a].resize(79);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   1,   2}; //   3
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  0,   1,   3}; //   3
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   4,   5}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   4,   5}; //   3
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  2,   3}; //   2
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  6,   7,   8}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  5,   6,   7}; //   3

  c_p[x_a][7] = {  6,   7,   9}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = {  5,   6,   7}; //   3

  c_p[x_a][8] = {  6,   7,   8}; //   3
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  2,   3}; //   2
  c_d[x_a][8] = {  5,   6,   7}; //   3

  c_p[x_a][9] = {  6,   7,   9}; //   3
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  2,   3}; //   2
  c_d[x_a][9] = {  5,   6,   7}; //   3

  c_p[x_a][10] = {  6,  10,  11}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = {  8,   9,   7}; //   3

  c_p[x_a][11] = {  6,  10,  11}; //   3
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  2,   3}; //   2
  c_d[x_a][11] = {  8,   9,   7}; //   3

  c_p[x_a][12] = {  0,  12,  13}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   1}; //   2
  c_d[x_a][12] = { 10,   7,   2}; //   3

  c_p[x_a][13] = {  0,  12,  14}; //   3
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = { 10,   7,   2}; //   3

  c_p[x_a][14] = {  0,  12,  13}; //   3
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = {  2,   3}; //   2
  c_d[x_a][14] = { 10,   7,   2}; //   3

  c_p[x_a][15] = {  0,  12,  14}; //   3
  c_f[x_a][15] = {  1}; //   1
  c_t[x_a][15] = {  2,   3}; //   2
  c_d[x_a][15] = { 10,   7,   2}; //   3

  c_p[x_a][16] = {  0,   1,   2}; //   3
  c_f[x_a][16] = {  0}; //   1
  c_t[x_a][16] = {  4,   5}; //   2
  c_d[x_a][16] = {  0,   1,   2}; //   3

  c_p[x_a][17] = {  0,   1,   3}; //   3
  c_f[x_a][17] = {  0}; //   1
  c_t[x_a][17] = {  4,   5}; //   2
  c_d[x_a][17] = {  0,   1,   2}; //   3

  c_p[x_a][18] = {  0,   1,   2}; //   3
  c_f[x_a][18] = {  1}; //   1
  c_t[x_a][18] = {  6,   7}; //   2
  c_d[x_a][18] = {  0,   1,   2}; //   3

  c_p[x_a][19] = {  0,   1,   3}; //   3
  c_f[x_a][19] = {  1}; //   1
  c_t[x_a][19] = {  6,   7}; //   2
  c_d[x_a][19] = {  0,   1,   2}; //   3

  c_p[x_a][20] = {  0,   4,   5}; //   3
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  4,   5}; //   2
  c_d[x_a][20] = {  3,   4,   2}; //   3

  c_p[x_a][21] = {  0,   4,   5}; //   3
  c_f[x_a][21] = {  1}; //   1
  c_t[x_a][21] = {  6,   7}; //   2
  c_d[x_a][21] = {  3,   4,   2}; //   3

  c_p[x_a][22] = {  6,   7,   8}; //   3
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  4,   5}; //   2
  c_d[x_a][22] = {  5,   6,   7}; //   3

  c_p[x_a][23] = {  6,   7,   9}; //   3
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  4,   5}; //   2
  c_d[x_a][23] = {  5,   6,   7}; //   3

  c_p[x_a][24] = {  6,   7,   8}; //   3
  c_f[x_a][24] = {  1}; //   1
  c_t[x_a][24] = {  6,   7}; //   2
  c_d[x_a][24] = {  5,   6,   7}; //   3

  c_p[x_a][25] = {  6,   7,   9}; //   3
  c_f[x_a][25] = {  1}; //   1
  c_t[x_a][25] = {  6,   7}; //   2
  c_d[x_a][25] = {  5,   6,   7}; //   3

  c_p[x_a][26] = {  6,  10,  11}; //   3
  c_f[x_a][26] = {  0}; //   1
  c_t[x_a][26] = {  4,   5}; //   2
  c_d[x_a][26] = {  8,   9,   7}; //   3

  c_p[x_a][27] = {  6,  10,  11}; //   3
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  6,   7}; //   2
  c_d[x_a][27] = {  8,   9,   7}; //   3

  c_p[x_a][28] = {  0,  12,  13}; //   3
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  4,   5}; //   2
  c_d[x_a][28] = { 10,   7,   2}; //   3

  c_p[x_a][29] = {  0,  12,  14}; //   3
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  4,   5}; //   2
  c_d[x_a][29] = { 10,   7,   2}; //   3

  c_p[x_a][30] = {  0,  12,  13}; //   3
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  6,   7}; //   2
  c_d[x_a][30] = { 10,   7,   2}; //   3

  c_p[x_a][31] = {  0,  12,  14}; //   3
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = {  6,   7}; //   2
  c_d[x_a][31] = { 10,   7,   2}; //   3

  c_p[x_a][32] = {  0,   1,   2}; //   3
  c_f[x_a][32] = {  1}; //   1
  c_t[x_a][32] = {  6,   8}; //   2
  c_d[x_a][32] = {  0,   1,   2}; //   3

  c_p[x_a][33] = {  0,   1,   3}; //   3
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = {  6,   8}; //   2
  c_d[x_a][33] = {  0,   1,   2}; //   3

  c_p[x_a][34] = {  0,   1,   2}; //   3
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  4,   9}; //   2
  c_d[x_a][34] = {  0,   1,   2}; //   3

  c_p[x_a][35] = {  0,   1,   3}; //   3
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  4,   9}; //   2
  c_d[x_a][35] = {  0,   1,   2}; //   3

  c_p[x_a][36] = {  0,   4,   5}; //   3
  c_f[x_a][36] = {  1}; //   1
  c_t[x_a][36] = {  6,   8}; //   2
  c_d[x_a][36] = {  3,   4,   2}; //   3

  c_p[x_a][37] = {  0,   4,   5}; //   3
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  4,   9}; //   2
  c_d[x_a][37] = {  3,   4,   2}; //   3

  c_p[x_a][38] = {  6,   7,   8}; //   3
  c_f[x_a][38] = {  1}; //   1
  c_t[x_a][38] = {  6,   8}; //   2
  c_d[x_a][38] = {  5,   6,   7}; //   3

  c_p[x_a][39] = {  6,   7,   9}; //   3
  c_f[x_a][39] = {  1}; //   1
  c_t[x_a][39] = {  6,   8}; //   2
  c_d[x_a][39] = {  5,   6,   7}; //   3

  c_p[x_a][40] = {  6,   7,   8}; //   3
  c_f[x_a][40] = {  0}; //   1
  c_t[x_a][40] = {  4,   9}; //   2
  c_d[x_a][40] = {  5,   6,   7}; //   3

  c_p[x_a][41] = {  6,   7,   9}; //   3
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  4,   9}; //   2
  c_d[x_a][41] = {  5,   6,   7}; //   3

  c_p[x_a][42] = {  6,  10,  11}; //   3
  c_f[x_a][42] = {  1}; //   1
  c_t[x_a][42] = {  6,   8}; //   2
  c_d[x_a][42] = {  8,   9,   7}; //   3

  c_p[x_a][43] = {  6,  10,  11}; //   3
  c_f[x_a][43] = {  0}; //   1
  c_t[x_a][43] = {  4,   9}; //   2
  c_d[x_a][43] = {  8,   9,   7}; //   3

  c_p[x_a][44] = {  0,  12,  13}; //   3
  c_f[x_a][44] = {  1}; //   1
  c_t[x_a][44] = {  6,   8}; //   2
  c_d[x_a][44] = { 10,   7,   2}; //   3

  c_p[x_a][45] = {  0,  12,  14}; //   3
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  6,   8}; //   2
  c_d[x_a][45] = { 10,   7,   2}; //   3

  c_p[x_a][46] = {  0,  12,  13}; //   3
  c_f[x_a][46] = {  0}; //   1
  c_t[x_a][46] = {  4,   9}; //   2
  c_d[x_a][46] = { 10,   7,   2}; //   3

  c_p[x_a][47] = {  0,  12,  14}; //   3
  c_f[x_a][47] = {  0}; //   1
  c_t[x_a][47] = {  4,   9}; //   2
  c_d[x_a][47] = { 10,   7,   2}; //   3

  c_p[x_a][48] = {  0,  12}; //   2
  c_f[x_a][48] = {  2,   3}; //   2
  c_t[x_a][48] = {  0,  10,  11}; //   3
  c_d[x_a][48] = {  7,   2}; //   2

  c_p[x_a][49] = {  0,  12}; //   2
  c_f[x_a][49] = {  4,   5}; //   2
  c_t[x_a][49] = {  2,  12,  13}; //   3
  c_d[x_a][49] = {  7,   2}; //   2

  c_p[x_a][50] = {  0,   1,   2,  15}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = { 14}; //   1
  c_d[x_a][50] = { 11,   0,   1,   2}; //   4

  c_p[x_a][51] = {  0,   1,   3,  15}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = { 14}; //   1
  c_d[x_a][51] = { 11,   0,   1,   2}; //   4

  c_p[x_a][52] = {  0,   4,   5,  15}; //   4
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = { 14}; //   1
  c_d[x_a][52] = { 11,   3,   4,   2}; //   4

  c_p[x_a][53] = {  6,   7,   8,  15}; //   4
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = { 14}; //   1
  c_d[x_a][53] = { 11,   5,   6,   7}; //   4

  c_p[x_a][54] = {  6,   7,   9,  15}; //   4
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = { 14}; //   1
  c_d[x_a][54] = { 11,   5,   6,   7}; //   4

  c_p[x_a][55] = {  6,  10,  11,  15}; //   4
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = { 14}; //   1
  c_d[x_a][55] = { 11,   8,   9,   7}; //   4

  c_p[x_a][56] = {  0,  12,  13,  15}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = { 14}; //   1
  c_d[x_a][56] = { 11,  10,   7,   2}; //   4

  c_p[x_a][57] = {  0,  12,  14,  15}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = { 14}; //   1
  c_d[x_a][57] = { 11,  10,   7,   2}; //   4

  c_p[x_a][58] = {  0,  12}; //   2
  c_f[x_a][58] = {  4,   5}; //   2
  c_t[x_a][58] = {  2,  12,  15}; //   3
  c_d[x_a][58] = {  7,   2}; //   2

  c_p[x_a][59] = {  0,  12}; //   2
  c_f[x_a][59] = {  2,   3}; //   2
  c_t[x_a][59] = {  0,  10,  16}; //   3
  c_d[x_a][59] = {  7,   2}; //   2

  c_p[x_a][60] = {  0,  12}; //   2
  c_f[x_a][60] = {  6,   7}; //   2
  c_t[x_a][60] = { 17,  18,  19}; //   3
  c_d[x_a][60] = {  7,   2}; //   2

  c_p[x_a][61] = {  0,  12}; //   2
  c_f[x_a][61] = {  6,   7}; //   2
  c_t[x_a][61] = { 17,  18,  20}; //   3
  c_d[x_a][61] = {  7,   2}; //   2

  c_p[x_a][62] = { 16,  17,  18,  19}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = { 21}; //   1
  c_d[x_a][62] = {  0,   1,   2,  11}; //   4

  c_p[x_a][63] = { 16,  17,  18,  20}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = { 21}; //   1
  c_d[x_a][63] = {  0,   1,   2,  11}; //   4

  c_p[x_a][64] = { 16,  17,  21,  22}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = { 21}; //   1
  c_d[x_a][64] = {  3,   4,   2,  11}; //   4

  c_p[x_a][65] = { 16,  23,  24,  25}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = { 21}; //   1
  c_d[x_a][65] = {  5,   6,   7,  11}; //   4

  c_p[x_a][66] = { 16,  23,  24,  26}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = { 21}; //   1
  c_d[x_a][66] = {  5,   6,   7,  11}; //   4

  c_p[x_a][67] = { 16,  23,  27,  28}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = { 21}; //   1
  c_d[x_a][67] = {  8,   9,   7,  11}; //   4

  c_p[x_a][68] = { 16,  17,  29,  30}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = { 21}; //   1
  c_d[x_a][68] = { 10,   7,   2,  11}; //   4

  c_p[x_a][69] = { 16,  17,  29,  31}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = { 21}; //   1
  c_d[x_a][69] = { 10,   7,   2,  11}; //   4

  c_p[x_a][70] = {  0,  12}; //   2
  c_f[x_a][70] = {  8,   0}; //   2
  c_t[x_a][70] = {  4,   5,  22}; //   3
  c_d[x_a][70] = {  7,   2}; //   2

  c_p[x_a][71] = {  0,  12}; //   2
  c_f[x_a][71] = {  8,   1}; //   2
  c_t[x_a][71] = {  6,   7,  23}; //   3
  c_d[x_a][71] = {  7,   2}; //   2

  c_p[x_a][72] = {  0,  12}; //   2
  c_f[x_a][72] = {  9,  10}; //   2
  c_t[x_a][72] = {  4,  24,  25}; //   3
  c_d[x_a][72] = {  7,   2}; //   2

  c_p[x_a][73] = {  0,  12}; //   2
  c_f[x_a][73] = { 11,  12}; //   2
  c_t[x_a][73] = {  6,  26,  27}; //   3
  c_d[x_a][73] = {  7,   2}; //   2

  c_p[x_a][74] = {  0,  12}; //   2
  c_f[x_a][74] = { 11,  12}; //   2
  c_t[x_a][74] = {  6,  26,  28}; //   3
  c_d[x_a][74] = {  7,   2}; //   2

  c_p[x_a][75] = {  0,  12}; //   2
  c_f[x_a][75] = {  9,  10}; //   2
  c_t[x_a][75] = {  4,  24,  29}; //   3
  c_d[x_a][75] = {  7,   2}; //   2

  c_p[x_a][76] = { 16,  17,  29}; //   3
  c_f[x_a][76] = {  7}; //   1
  c_t[x_a][76] = { 17,  30}; //   2
  c_d[x_a][76] = {  7,   2,  11}; //   3

  c_p[x_a][77] = {  0,  32,  29}; //   3
  c_f[x_a][77] = {  7}; //   1
  c_t[x_a][77] = { 17,  18}; //   2
  c_d[x_a][77] = {  7,  11,   2}; //   3

  c_p[x_a][78] = {  0,  12,  33}; //   3
  c_f[x_a][78] = { 13}; //   1
  c_t[x_a][78] = { 14,  31}; //   2
  c_d[x_a][78] = { 11,   7,   2}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   0,   0)
// channel    1: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   0,   0)
// channel    2: 4yyv11(1, 2, 4, 32, 8, 16, 128, 64;  24,   0,   0,   0,   0)
// channel    3: 4yyv11(1, 2, 4, 32, 8, 16, 128, 64;  24,   0,  23,   0,   0)
// channel    4: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   0,   0)
// channel    5: 4yyv11(1, 2, 32, 4, 8, 16, 128, 64;  24,   0,  23,   0,   0)
// channel    6: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   0)
// channel    7: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   0,   0)
// channel    8: 4yyv11(1, 2, 8, 16, 4, 32, 128, 64;  24,   0,   0,   0,   0)
// channel    9: 4yyv11(1, 2, 8, 16, 4, 32, 128, 64;  24,   0,  23,   0,   0)
// channel   10: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   0,   0)
// channel   11: 4yyv11(1, 2, 16, 8, 4, 32, 128, 64;  24,   0,  23,   0,   0)
// channel   12: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
// channel   13: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   0,   0)
// channel   14: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,   0,   0,   0)
// channel   15: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,  23,   0,   0)
// channel   16: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   0,   0)
// channel   17: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   0,   0)
// channel   18: 14yyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   0,   0)
// channel   19: 14yyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   0,   0)
// channel   20: 14yyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   0,   0)
// channel   21: 14yyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   0,   0)
// channel   22: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   0,   0)
// channel   23: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   0,   0)
// channel   24: 14yyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   0,   0)
// channel   25: 14yyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   0,   0)
// channel   26: 14yyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   0,   0)
// channel   27: 14yyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   0,   0)
// channel   28: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   0,   0)
// channel   29: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   0,   0)
// channel   30: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   0,   0)
// channel   31: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   0,   0)
// channel   32: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   33: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   34: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   35: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   36: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   37: 114yyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   38: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   39: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   40: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   41: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   42: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   43: 114yyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   44: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   45: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   46: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   47: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   48: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
// channel   49: 2v2v11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,   0,   0,   0)
// channel   50: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   51: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   52: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   53: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   54: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   55: 2v4yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   56: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   57: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   58: 2v12v1(1, 2, 4, 32, 128, 8, 16, 64;  24,  24,   0,   0,   0)
// channel   59: 2v12v1(1, 2, 4, 32, 64, 8, 16, 128;  24,  24,   0,   0,   0)
// channel   60: 2v112v(1, 2, 4, 32, 64, 128, 8, 16;  24,  24,   0,   0,   0)
// channel   61: 2v112v(1, 2, 4, 32, 128, 64, 8, 16;  24,  24,   0,   0,   0)
// channel   62: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,   0,   0)
// channel   63: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,  23,   0)
// channel   64: 4yyv2v(1, 2, 32, 4, 8, 16, 64, 128;   0,  24,   0,  23,   0)
// channel   65: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,   0,   0)
// channel   66: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,  23,   0)
// channel   67: 4yyv2v(1, 2, 16, 8, 4, 32, 64, 128;   0,  24,   0,  23,   0)
// channel   68: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   0)
// channel   69: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  23,   0)
// channel   70: 12v2v1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   0,   0)
// channel   71: 12v2v1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   0,   0)
// channel   72: 12v12v(1, 2, 128, 4, 32, 64, 8, 16;  24,  24,   0,   0,   0)
// channel   73: 12v12v(1, 2, 64, 4, 32, 128, 8, 16;  24,  24,   0,   0,   0)
// channel   74: 112v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   75: 112v2v(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   76: 2v2v2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   0)
// channel   77: 2v2v2v(1, 2, 4, 32, 64, 128, 8, 16;  24,   0,  24,   0,   0)
// channel   78: 2v2v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
