#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_050_ba_emmupvmvexb(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_050_ba_emmupvmvexb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(22);
  needed_v_smin[x_a].resize(22);
  needed_v_smin[x_a][  0] = {   6,   11,   12,   13,   14,   15,   16,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   33,   34,   37,   41,   42,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   43,   44,   45}; //  38
  needed_v_smin[x_a][  1] = {   7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   30,   31,   32,   35,   36,   38,   39,   40,   43,   44,   45,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   46,   47,   48}; //  38
  needed_v_smin[x_a][  2] = {   7,   26,   50,   52,   51}; //   5
  needed_v_smin[x_a][  3] = {   8,    9,   17,   18,   35,   36,   39,   40,   30,   31,   32,   38}; //  12
  needed_v_smin[x_a][  4] = {   8,    9,   17,   18,    3,    4,    5,   30,   31,   32,   35,   36,   38,   39,   40}; //  15
  needed_v_smin[x_a][  5] = {  10,   19}; //   2
  needed_v_smin[x_a][  6] = {  10,   19}; //   2
  needed_v_smin[x_a][  7] = {  11,   12,   20,   21,   33,   34,   41,   42,   27,   28,   29,   37}; //  12
  needed_v_smin[x_a][  8] = {  11,   12,   20,   21,    0,    1,    2,   27,   28,   29,   33,   34,   37,   41,   42}; //  15
  needed_v_smin[x_a][  9] = {  13,   22}; //   2
  needed_v_smin[x_a][ 10] = {  13,   22}; //   2
  needed_v_smin[x_a][ 11] = {  14,   15,   16,   23,   24,   25,   43,   44,   45,   46,   47,   48,   49,   53,   54,   55,   56,   57,   58}; //  19
  needed_v_smin[x_a][ 12] = {   0,    1,    3,    4}; //   4
  needed_v_smin[x_a][ 13] = {   0,    1}; //   2
  needed_v_smin[x_a][ 14] = {   2}; //   1
  needed_v_smin[x_a][ 15] = {   2}; //   1
  needed_v_smin[x_a][ 16] = {   3,    4}; //   2
  needed_v_smin[x_a][ 17] = {   5}; //   1
  needed_v_smin[x_a][ 18] = {   5}; //   1
  needed_v_smin[x_a][ 19] = {   6}; //   1
  needed_v_smin[x_a][ 20] = {   6}; //   1
  needed_v_smin[x_a][ 21] = {   7}; //   1

  v_smax[x_a].resize(18);
  needed_v_smax[x_a].resize(18);
  needed_v_smax[x_a][  0] = {   6,   11,   12,   13,   20,   21,   22,   27,   28,   29,   33,   34,   37,   41,   42,   46,   47,   48,   52,   56,   57,   58}; //  22
  needed_v_smax[x_a][  1] = {   7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   30,   31,   32,   35,   36,   38,   39,   40,   43,   44,   45,   49,   50,   51,   53,   54,   55}; //  31
  needed_v_smax[x_a][  2] = {   7,   26,   50}; //   3
  needed_v_smax[x_a][  3] = {   8,    9,   17,   18,   35,   36,   39,   40,    3,    4,    5,   30,   31,   32,   38}; //  15
  needed_v_smax[x_a][  4] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,    0,    1,    2,    3,    4,    5,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   53,   54,   55,   56,   57,   58}; //  53
  needed_v_smax[x_a][  5] = {  10,   19}; //   2
  needed_v_smax[x_a][  6] = {  11,   12,   20,   21,   33,   34,   41,   42,    0,    1,    2,   27,   28,   29,   37}; //  15
  needed_v_smax[x_a][  7] = {  13,   22}; //   2
  needed_v_smax[x_a][  8] = {  14,   15,   16,   23,   24,   25,   49,   51,   53,   54,   55,   43,   44,   45}; //  14
  needed_v_smax[x_a][  9] = {  26,   50}; //   2
  needed_v_smax[x_a][ 10] = {  52,   56,   57,   58,   46,   47,   48}; //   7
  needed_v_smax[x_a][ 11] = {  52,   51}; //   2
  needed_v_smax[x_a][ 12] = {   0,    1,    3,    4}; //   4
  needed_v_smax[x_a][ 13] = {   2}; //   1
  needed_v_smax[x_a][ 14] = {   5}; //   1
  needed_v_smax[x_a][ 15] = {   6}; //   1
  needed_v_smax[x_a][ 16] = {   6}; //   1
  needed_v_smax[x_a][ 17] = {   7}; //   1

  g_p[x_a].resize(20);
  needed_g_p[x_a].resize(20);
  needed_g_p[x_a][0] = {   6,   11,   12,   13,   20,   21,   22,   27,   28,   29,   33,   34,   37,   41,   42,   46,   47,   48,   52,   56,   57,   58}; //  22
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   30,   31,   32,   35,   36,   38,   39,   40,   43,   44,   45,   49,   50,   51,   53,   54,   55}; //  31
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][2] = {   7,   26,   50}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin2_smax2");
  needed_g_p[x_a][3] = {   8,    9,   17,   18,   35,   36,   39,   40}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   8,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   9,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][6] = {  10,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {  10,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax4");
  needed_g_p[x_a][8] = {  11,   12,   20,   21,   33,   34,   41,   42}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {  11,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax4");
  needed_g_p[x_a][10] = {  12,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax4");
  needed_g_p[x_a][11] = {  13,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][12] = {  13,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax4");
  needed_g_p[x_a][13] = {  14,   15,   16,   23,   24,   25,   49,   51,   53,   54,   55}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax8");
  needed_g_p[x_a][14] = {  14,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax4");
  needed_g_p[x_a][15] = {  15,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax4");
  needed_g_p[x_a][16] = {  16,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin11_smax4");
  needed_g_p[x_a][17] = {  26,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax9");
  needed_g_p[x_a][18] = {  52,   56,   57,   58}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax10");
  needed_g_p[x_a][19] = {  52}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin2_smax11");

  g_f[x_a].resize(18);
  needed_g_f[x_a].resize(18);
  needed_g_f[x_a][0] = {   0,    1,    3,    4}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax12");
  needed_g_f[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax6");
  needed_g_f[x_a][2] = {   0,    1,    2,   27,   28,   29,   33,   34,   37,   41,   42}; //  11
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax4");
  needed_g_f[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax13");
  needed_g_f[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax6");
  needed_g_f[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax3");
  needed_g_f[x_a][6] = {   3,    4,    5,   30,   31,   32,   35,   36,   38,   39,   40}; //  11
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][7] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax14");
  needed_g_f[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax3");
  needed_g_f[x_a][9] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax15");
  needed_g_f[x_a][10] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax16");
  needed_g_f[x_a][11] = {   7}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax17");
  needed_g_f[x_a][12] = {  27,   28,   29,   37}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax6");
  needed_g_f[x_a][13] = {  30,   31,   32,   38}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][14] = {  43,   44,   45}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax8");
  needed_g_f[x_a][15] = {  43,   44,   45,   46,   47,   48,   49,   53,   54,   55,   56,   57,   58}; //  13
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax4");
  needed_g_f[x_a][16] = {  46,   47,   48}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax10");
  needed_g_f[x_a][17] = {  51}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax11");

  g_t[x_a].resize(35);
  needed_g_t[x_a].resize(35);
  needed_g_t[x_a][0] = {   0,    3,   27,   30,   33,   35,   39,   41,   43,   46,   53,   56}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {   0,    1,    2,   27,   28,   29,   33,   34,   37}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__8_52");
  needed_g_t[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__4_48");
  needed_g_t[x_a][3] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_69__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_69__16_32");
  needed_g_t[x_a][4] = {   1,    2,    4,    5,   28,   31,   34,   36,   37,   38,   40,   42,   44,   45,   47,   48,   54,   57}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_2__64_60");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__32_20");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_97__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_97__16_4");
  needed_g_t[x_a][7] = {   3,    4,    5,   30,   31,   32,   35,   36,   38}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__4_56");
  needed_g_t[x_a][8] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__8_48");
  needed_g_t[x_a][9] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_73__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_73__32_16");
  needed_g_t[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__16_40");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_81__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_81__32_8");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][13] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_10__36_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_10__36_80");
  needed_g_t[x_a][14] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_37__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_37__16_64");
  needed_g_t[x_a][15] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][16] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__6_1__32_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__6_1__32_88");
  needed_g_t[x_a][17] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   49}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__64_60");
  needed_g_t[x_a][18] = {  27,   28,   29}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_65__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_65__16_36");
  needed_g_t[x_a][19] = {  29,   32,   55,   58}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_25__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_25__1_2__64_60");
  needed_g_t[x_a][20] = {  30,   31,   32}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_65__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_65__32_24");
  needed_g_t[x_a][21] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__16_36");
  needed_g_t[x_a][22] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__32_24");
  needed_g_t[x_a][23] = {  39,   40}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__4_56");
  needed_g_t[x_a][24] = {  41,   42}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__8_52");
  needed_g_t[x_a][25] = {  43,   44,   45,   53,   54,   55}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_65__24_36");
  needed_g_t[x_a][26] = {  43,   44}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__4_32");
  needed_g_t[x_a][27] = {  45}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__32_4");
  needed_g_t[x_a][28] = {  46,   47,   48,   56,   57,   58}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_65__36_24");
  needed_g_t[x_a][29] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__8_16");
  needed_g_t[x_a][30] = {  48}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__16_8");
  needed_g_t[x_a][31] = {  49}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_66__36_24");
  needed_g_t[x_a][32] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__36_88");
  needed_g_t[x_a][33] = {  51}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_37__24_64");
  needed_g_t[x_a][34] = {  52}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__36_88");

  g_d[x_a].resize(14);
  needed_g_d[x_a].resize(14);
  needed_g_d[x_a][0] = {   6,   11,   12,   13,   14,   15,   16,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   33,   34,   37,   41,   42,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58}; //  35
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {   7,   26,   50,   52}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][2] = {   7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   30,   31,   32,   35,   36,   38,   39,   40,   43,   44,   45,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58}; //  35
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   8,    9,   17,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][4] = {   8,    9,   17,   18,   35,   36,   39,   40}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][5] = {  10,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {  10,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {  11,   12,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {  11,   12,   20,   21,   33,   34,   41,   42}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][9] = {  13,   22}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][10] = {  13,   22}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][11] = {  14,   15,   16,   23,   24,   25}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][12] = {  17,   18,   19,   20,   21,   22,   23,   24,   25}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][13] = {  26}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");

  c_p[x_a].resize(59);
  c_f[x_a].resize(59);
  c_t[x_a].resize(59);
  c_d[x_a].resize(59);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1,   2}; //   3
  c_t[x_a][1] = {  4,   1,   2,   3}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  3,   4,   2}; //   3
  c_t[x_a][2] = {  4,   1,   5,   6}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   5,   6}; //   3
  c_t[x_a][3] = {  0,   7,   8,   9}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0,   5,   6}; //   3
  c_t[x_a][4] = {  4,   7,   8,   9}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  7,   8,   6}; //   3
  c_t[x_a][5] = {  4,   7,  10,  11}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  9,  10}; //   2
  c_t[x_a][6] = { 12,  13,  14}; //   3
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1,   2}; //   2
  c_f[x_a][7] = { 11}; //   1
  c_t[x_a][7] = { 15,  16}; //   2
  c_d[x_a][7] = {  1,   2}; //   2

  c_p[x_a][8] = {  1,   3,   4}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = { 17}; //   1
  c_d[x_a][8] = {  3,   4,   2}; //   3

  c_p[x_a][9] = {  1,   3,   5}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = { 17}; //   1
  c_d[x_a][9] = {  3,   4,   2}; //   3

  c_p[x_a][10] = {  1,   6,   7}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 17}; //   1
  c_d[x_a][10] = {  5,   6,   2}; //   3

  c_p[x_a][11] = {  0,   8,   9}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 17}; //   1
  c_d[x_a][11] = {  7,   8,   0}; //   3

  c_p[x_a][12] = {  0,   8,  10}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 17}; //   1
  c_d[x_a][12] = {  7,   8,   0}; //   3

  c_p[x_a][13] = {  0,  11,  12}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 17}; //   1
  c_d[x_a][13] = {  9,  10,   0}; //   3

  c_p[x_a][14] = {  1,  13,  14}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 17}; //   1
  c_d[x_a][14] = { 11,   0,   2}; //   3

  c_p[x_a][15] = {  1,  13,  15}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 17}; //   1
  c_d[x_a][15] = { 11,   0,   2}; //   3

  c_p[x_a][16] = {  1,  13,  16}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 17}; //   1
  c_d[x_a][16] = { 11,   0,   2}; //   3

  c_p[x_a][17] = {  1,   3,   4}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 12,   3,   4,   2}; //   4

  c_p[x_a][18] = {  1,   3,   5}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 12,   3,   4,   2}; //   4

  c_p[x_a][19] = {  1,   6,   7}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 12,   5,   6,   2}; //   4

  c_p[x_a][20] = {  0,   8,   9}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 12,   7,   8,   0}; //   4

  c_p[x_a][21] = {  0,   8,  10}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 12,   7,   8,   0}; //   4

  c_p[x_a][22] = {  0,  11,  12}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 12,   9,  10,   0}; //   4

  c_p[x_a][23] = {  1,  13,  14}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 12,  11,   0,   2}; //   4

  c_p[x_a][24] = {  1,  13,  15}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 12,  11,   0,   2}; //   4

  c_p[x_a][25] = {  1,  13,  16}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 12,  11,   0,   2}; //   4

  c_p[x_a][26] = {  1,   2,  17}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 13,   0,   1,   2}; //   4

  c_p[x_a][27] = {  0}; //   1
  c_f[x_a][27] = { 12,   2}; //   2
  c_t[x_a][27] = {  0,   1,  18}; //   3
  c_d[x_a][27] = {  0}; //   1

  c_p[x_a][28] = {  0}; //   1
  c_f[x_a][28] = { 12,   2}; //   2
  c_t[x_a][28] = {  4,   1,  18}; //   3
  c_d[x_a][28] = {  0}; //   1

  c_p[x_a][29] = {  0}; //   1
  c_f[x_a][29] = { 12,   2}; //   2
  c_t[x_a][29] = { 19,   1,  18}; //   3
  c_d[x_a][29] = {  0}; //   1

  c_p[x_a][30] = {  1}; //   1
  c_f[x_a][30] = { 13,   6}; //   2
  c_t[x_a][30] = {  0,   7,  20}; //   3
  c_d[x_a][30] = {  2}; //   1

  c_p[x_a][31] = {  1}; //   1
  c_f[x_a][31] = { 13,   6}; //   2
  c_t[x_a][31] = {  4,   7,  20}; //   3
  c_d[x_a][31] = {  2}; //   1

  c_p[x_a][32] = {  1}; //   1
  c_f[x_a][32] = { 13,   6}; //   2
  c_t[x_a][32] = { 19,   7,  20}; //   3
  c_d[x_a][32] = {  2}; //   1

  c_p[x_a][33] = {  0,   8}; //   2
  c_f[x_a][33] = {  2}; //   1
  c_t[x_a][33] = {  0,   1}; //   2
  c_d[x_a][33] = {  8,   0}; //   2

  c_p[x_a][34] = {  0,   8}; //   2
  c_f[x_a][34] = {  2}; //   1
  c_t[x_a][34] = {  4,   1}; //   2
  c_d[x_a][34] = {  8,   0}; //   2

  c_p[x_a][35] = {  1,   3}; //   2
  c_f[x_a][35] = {  6}; //   1
  c_t[x_a][35] = {  0,   7}; //   2
  c_d[x_a][35] = {  4,   2}; //   2

  c_p[x_a][36] = {  1,   3}; //   2
  c_f[x_a][36] = {  6}; //   1
  c_t[x_a][36] = {  4,   7}; //   2
  c_d[x_a][36] = {  4,   2}; //   2

  c_p[x_a][37] = {  0}; //   1
  c_f[x_a][37] = { 12,   2}; //   2
  c_t[x_a][37] = {  4,   1,  21}; //   3
  c_d[x_a][37] = {  0}; //   1

  c_p[x_a][38] = {  1}; //   1
  c_f[x_a][38] = { 13,   6}; //   2
  c_t[x_a][38] = {  4,   7,  22}; //   3
  c_d[x_a][38] = {  2}; //   1

  c_p[x_a][39] = {  1,   3}; //   2
  c_f[x_a][39] = {  6}; //   1
  c_t[x_a][39] = {  0,  23}; //   2
  c_d[x_a][39] = {  4,   2}; //   2

  c_p[x_a][40] = {  1,   3}; //   2
  c_f[x_a][40] = {  6}; //   1
  c_t[x_a][40] = {  4,  23}; //   2
  c_d[x_a][40] = {  4,   2}; //   2

  c_p[x_a][41] = {  0,   8}; //   2
  c_f[x_a][41] = {  2}; //   1
  c_t[x_a][41] = {  0,  24}; //   2
  c_d[x_a][41] = {  8,   0}; //   2

  c_p[x_a][42] = {  0,   8}; //   2
  c_f[x_a][42] = {  2}; //   1
  c_t[x_a][42] = {  4,  24}; //   2
  c_d[x_a][42] = {  8,   0}; //   2

  c_p[x_a][43] = {  1}; //   1
  c_f[x_a][43] = { 14,  15}; //   2
  c_t[x_a][43] = {  0,  25,  26}; //   3
  c_d[x_a][43] = {  2}; //   1

  c_p[x_a][44] = {  1}; //   1
  c_f[x_a][44] = { 14,  15}; //   2
  c_t[x_a][44] = {  4,  25,  26}; //   3
  c_d[x_a][44] = {  2}; //   1

  c_p[x_a][45] = {  1}; //   1
  c_f[x_a][45] = { 14,  15}; //   2
  c_t[x_a][45] = {  4,  25,  27}; //   3
  c_d[x_a][45] = {  2}; //   1

  c_p[x_a][46] = {  0}; //   1
  c_f[x_a][46] = { 16,  15}; //   2
  c_t[x_a][46] = {  0,  28,  29}; //   3
  c_d[x_a][46] = {  0}; //   1

  c_p[x_a][47] = {  0}; //   1
  c_f[x_a][47] = { 16,  15}; //   2
  c_t[x_a][47] = {  4,  28,  29}; //   3
  c_d[x_a][47] = {  0}; //   1

  c_p[x_a][48] = {  0}; //   1
  c_f[x_a][48] = { 16,  15}; //   2
  c_t[x_a][48] = {  4,  28,  30}; //   3
  c_d[x_a][48] = {  0}; //   1

  c_p[x_a][49] = {  1,  13}; //   2
  c_f[x_a][49] = { 15}; //   1
  c_t[x_a][49] = { 17,  31}; //   2
  c_d[x_a][49] = {  0,   2}; //   2

  c_p[x_a][50] = {  1,   2,  17}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = { 32}; //   1
  c_d[x_a][50] = {  0,   1,   2}; //   3

  c_p[x_a][51] = {  1,  13}; //   2
  c_f[x_a][51] = { 17}; //   1
  c_t[x_a][51] = { 32,  33}; //   2
  c_d[x_a][51] = {  0,   2}; //   2

  c_p[x_a][52] = {  0,  18,  19}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = { 34}; //   1
  c_d[x_a][52] = {  1,   2,   0}; //   3

  c_p[x_a][53] = {  1,  13}; //   2
  c_f[x_a][53] = { 15}; //   1
  c_t[x_a][53] = {  0,  25}; //   2
  c_d[x_a][53] = {  0,   2}; //   2

  c_p[x_a][54] = {  1,  13}; //   2
  c_f[x_a][54] = { 15}; //   1
  c_t[x_a][54] = {  4,  25}; //   2
  c_d[x_a][54] = {  0,   2}; //   2

  c_p[x_a][55] = {  1,  13}; //   2
  c_f[x_a][55] = { 15}; //   1
  c_t[x_a][55] = { 19,  25}; //   2
  c_d[x_a][55] = {  0,   2}; //   2

  c_p[x_a][56] = {  0,  18}; //   2
  c_f[x_a][56] = { 15}; //   1
  c_t[x_a][56] = {  0,  28}; //   2
  c_d[x_a][56] = {  2,   0}; //   2

  c_p[x_a][57] = {  0,  18}; //   2
  c_f[x_a][57] = { 15}; //   1
  c_t[x_a][57] = {  4,  28}; //   2
  c_d[x_a][57] = {  2,   0}; //   2

  c_p[x_a][58] = {  0,  18}; //   2
  c_f[x_a][58] = { 15}; //   1
  c_t[x_a][58] = { 19,  28}; //   2
  c_d[x_a][58] = {  2,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 11111(1, 2, 64, 4, 32, 16, 8;   0,   0,   0,  24)
// channel    1: 11111(1, 2, 64, 4, 32, 16, 8;  23,   0,   0,  24)
// channel    2: 11111(1, 2, 64, 32, 4, 16, 8;  23,   0,   0,  24)
// channel    3: 11111(1, 2, 64, 8, 16, 32, 4;   0,   0,   0,  24)
// channel    4: 11111(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,  24)
// channel    5: 11111(1, 2, 64, 16, 8, 32, 4;  23,   0,   0,  24)
// channel    6: 2v111(1, 2, 4, 32, 64, 16, 8;  24,   0,   6,  24)
// channel    7: 3yv11(1, 2, 64, 8, 16, 32, 4;  24,   6,   0,  24)
// channel    8: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   5)
// channel    9: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   5)
// channel   10: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   5)
// channel   11: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   5)
// channel   12: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   5)
// channel   13: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   5)
// channel   14: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   5)
// channel   15: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   5)
// channel   16: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  25,   5)
// channel   17: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   5)
// channel   18: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   5)
// channel   19: 5yyyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   5)
// channel   20: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   5)
// channel   21: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   5)
// channel   22: 5yyyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   5)
// channel   23: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   5)
// channel   24: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   5)
// channel   25: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  25,   5)
// channel   26: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,   6,  24,   5)
// channel   27: 12v11(1, 2, 64, 4, 32, 16, 8;  24,   0,   0,  24)
// channel   28: 12v11(1, 2, 64, 4, 32, 16, 8;  24,  23,   0,  24)
// channel   29: 12v11(1, 2, 64, 4, 32, 16, 8;  24,  25,   0,  24)
// channel   30: 12v11(1, 2, 64, 8, 16, 32, 4;  24,   0,   0,  24)
// channel   31: 12v11(1, 2, 64, 8, 16, 32, 4;  24,  23,   0,  24)
// channel   32: 12v11(1, 2, 64, 8, 16, 32, 4;  24,  25,   0,  24)
// channel   33: 13yv1(1, 2, 64, 16, 4, 32, 8;  24,   0,   0,   0)
// channel   34: 13yv1(1, 2, 64, 16, 4, 32, 8;  24,   0,  23,   0)
// channel   35: 13yv1(1, 2, 64, 32, 8, 16, 4;  24,   0,   0,   0)
// channel   36: 13yv1(1, 2, 64, 32, 8, 16, 4;  24,   0,  23,   0)
// channel   37: 112v1(1, 2, 64, 16, 4, 32, 8;  24,  23,   0,   0)
// channel   38: 112v1(1, 2, 64, 32, 8, 16, 4;  24,  23,   0,   0)
// channel   39: 113yv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
// channel   40: 113yv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
// channel   41: 113yv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
// channel   42: 113yv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
// channel   43: 1112v(1, 2, 64, 4, 32, 8, 16;  24,   0,  24,   0)
// channel   44: 1112v(1, 2, 64, 4, 32, 8, 16;  24,  23,  24,   0)
// channel   45: 1112v(1, 2, 64, 32, 4, 8, 16;  24,  23,  24,   0)
// channel   46: 1112v(1, 2, 64, 8, 16, 4, 32;  24,   0,  24,   0)
// channel   47: 1112v(1, 2, 64, 8, 16, 4, 32;  24,  23,  24,   0)
// channel   48: 1112v(1, 2, 64, 16, 8, 4, 32;  24,  23,  24,   0)
// channel   49: 2v2v1(1, 2, 4, 32, 8, 16, 64;  24,  24,   5,   6)
// channel   50: 2v3yv(1, 2, 4, 32, 64, 8, 16;  24,   6,  24,   6)
// channel   51: 2v12v(1, 2, 4, 32, 64, 8, 16;  24,  24,   6,  24)
// channel   52: 3yv2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   6,  24)
// channel   53: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,  24)
// channel   54: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,  24)
// channel   55: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  25,  24)
// channel   56: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   0,  24)
// channel   57: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  23,  24)
// channel   58: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  25,  24)
