#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

void ppenexa03_phasespace_set::ax_psp_230_ds_emvexadc(int x_a){
  static Logger logger("ppenexa03_phasespace_set::ax_psp_230_ds_emvexadc");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(13);
  needed_v_smin[x_a].resize(13);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    7,    9,   10,   11,   12,   13}; //  12
  needed_v_smin[x_a][  1] = {   0,    1,    6,   11,    5,   12}; //   6
  needed_v_smin[x_a][  2] = {   1,    0,    5}; //   3
  needed_v_smin[x_a][  3] = {   2,    7}; //   2
  needed_v_smin[x_a][  4] = {   2,    3,    7,    8}; //   4
  needed_v_smin[x_a][  5] = {   3,    8}; //   2
  needed_v_smin[x_a][  6] = {   3,    8}; //   2
  needed_v_smin[x_a][  7] = {   4,   13,   10}; //   3
  needed_v_smin[x_a][  8] = {   4,   10,   13}; //   3
  needed_v_smin[x_a][  9] = {  11,   12}; //   2
  needed_v_smin[x_a][ 10] = {   6}; //   1
  needed_v_smin[x_a][ 11] = {   9}; //   1
  needed_v_smin[x_a][ 12] = {   9}; //   1

  v_smax[x_a].resize(13);
  needed_v_smax[x_a].resize(13);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    5,    6,    7,    9,   10,   11,   12,   13}; //  11
  needed_v_smax[x_a][  1] = {   0,    1,    6,   11,    5}; //   5
  needed_v_smax[x_a][  2] = {   1,    2,    3,    4,    0,    5,    7,    8,   10,   13}; //  10
  needed_v_smax[x_a][  3] = {   2,    3,    7,    8}; //   4
  needed_v_smax[x_a][  4] = {   3,    8}; //   2
  needed_v_smax[x_a][  5] = {   4}; //   1
  needed_v_smax[x_a][  6] = {   4}; //   1
  needed_v_smax[x_a][  7] = {  11}; //   1
  needed_v_smax[x_a][  8] = {  12}; //   1
  needed_v_smax[x_a][  9] = {  13,   10}; //   2
  needed_v_smax[x_a][ 10] = {   6,    9}; //   2
  needed_v_smax[x_a][ 11] = {   9}; //   1
  needed_v_smax[x_a][ 12] = {  12}; //   1

  g_p[x_a].resize(13);
  needed_g_p[x_a].resize(13);
  needed_g_p[x_a][0] = {   0,    1,    2,    5,    6,    7,    9,   10,   11,   12,   13}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    6,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][5] = {   3,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   3,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax3");
  needed_g_p[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax6");
  needed_g_p[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][10] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][11] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][12] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax9");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {   0,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][2] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax10");
  needed_g_f[x_a][3] = {   7,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");
  needed_g_f[x_a][4] = {   9}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax11");
  needed_g_f[x_a][5] = {   9}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax10");
  needed_g_f[x_a][6] = {  10}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax9");
  needed_g_f[x_a][7] = {  10,   13}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax2");
  needed_g_f[x_a][8] = {  12}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax12");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    7,    8,   10,   13}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][1] = {   0,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][2] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][3] = {   6,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][4] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][5] = {   7,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][6] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][7] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][8] = {  10,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][9] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][10] = {  11,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][11] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   0,    1,    6,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    4,    5,    6,    7,    9,   10,   11,   12,   13}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][4] = {   2,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   3,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][6] = {   3,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][8] = {   4,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][9] = {  11,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(14);
  c_f[x_a].resize(14);
  c_t[x_a].resize(14);
  c_d[x_a].resize(14);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   1,   2}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  2,   0,   1}; //   3

  c_p[x_a][2] = {  0,   3,   4}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   1}; //   3

  c_p[x_a][3] = {  5,   6,   4}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  3,   5,   6}; //   3

  c_p[x_a][4] = {  7,   8,   9}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  7,   1,   8}; //   3

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  1,   0}; //   2
  c_t[x_a][5] = {  0,   1,   2}; //   3
  c_d[x_a][5] = {  1}; //   1

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {  2}; //   1
  c_t[x_a][6] = {  3,   4}; //   2
  c_d[x_a][6] = {  0,   1}; //   2

  c_p[x_a][7] = {  0,   3}; //   2
  c_f[x_a][7] = {  3}; //   1
  c_t[x_a][7] = {  0,   5}; //   2
  c_d[x_a][7] = {  4,   1}; //   2

  c_p[x_a][8] = {  5,   6}; //   2
  c_f[x_a][8] = {  3}; //   1
  c_t[x_a][8] = {  0,   5}; //   2
  c_d[x_a][8] = {  5,   6}; //   2

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  4,   5}; //   2
  c_t[x_a][9] = {  3,   6,   7}; //   3
  c_d[x_a][9] = {  1}; //   1

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  6,   7}; //   2
  c_t[x_a][10] = {  0,   8,   9}; //   3
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  0,   1,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 10}; //   1
  c_d[x_a][11] = {  9,   0,   1}; //   3

  c_p[x_a][12] = {  0,  11}; //   2
  c_f[x_a][12] = {  8}; //   1
  c_t[x_a][12] = { 10,  11}; //   2
  c_d[x_a][12] = {  9,   1}; //   2

  c_p[x_a][13] = {  0,  12}; //   2
  c_f[x_a][13] = {  7}; //   1
  c_t[x_a][13] = {  0,   8}; //   2
  c_d[x_a][13] = {  8,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 13yv1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
// channel    1: 14yyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
// channel    2: 14yyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel    3: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel    4: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
// channel    5: 112v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
// channel    6: 113yv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel    7: 113yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel    8: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel    9: 1112v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel   10: 1112v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
// channel   11: 2v3yv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel   12: 2v12v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel   13: 12v2v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
