#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

void ppenexa03_phasespace_set::ax_psp_130_gd_emvexau(int x_a){
  static Logger logger("ppenexa03_phasespace_set::ax_psp_130_gd_emvexau");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(6);
  needed_v_smin[x_a].resize(6);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    8,    9}; //   8
  needed_v_smin[x_a][  1] = {   0,    1}; //   2
  needed_v_smin[x_a][  2] = {   2,    6,    5,    8}; //   4
  needed_v_smin[x_a][  3] = {   3,    7}; //   2
  needed_v_smin[x_a][  4] = {   3,    7}; //   2
  needed_v_smin[x_a][  5] = {   4,    9}; //   2

  v_smax[x_a].resize(7);
  needed_v_smax[x_a].resize(7);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    5,    6,    8,    9}; //   7
  needed_v_smax[x_a][  1] = {   0,    1}; //   2
  needed_v_smax[x_a][  2] = {   2,    3,    6,    7,    5,    8}; //   6
  needed_v_smax[x_a][  3] = {   3,    7}; //   2
  needed_v_smax[x_a][  4] = {   4}; //   1
  needed_v_smax[x_a][  5] = {   4}; //   1
  needed_v_smax[x_a][  6] = {   9}; //   1

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   0,    1,    2,    5,    6,    8,    9}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   3,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   3,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][5] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax5");
  needed_g_p[x_a][7] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax6");

  g_f[x_a].resize(1);
  needed_g_f[x_a].resize(1);
  needed_g_f[x_a][0] = {   5,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");

  g_t[x_a].resize(5);
  needed_g_t[x_a].resize(5);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][1] = {   5,    6,    7,    8}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][2] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][3] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][4] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(9);
  needed_g_d[x_a].resize(9);
  needed_g_d[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    4,    5,    6,    8,    9}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   3,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][6] = {   3,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][8] = {   4,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(10);
  c_f[x_a].resize(10);
  c_t[x_a].resize(10);
  c_d[x_a].resize(10);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  2,   0,   1}; //   3

  c_p[x_a][2] = {  0,   2}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  3,   4,   1}; //   3

  c_p[x_a][3] = {  3,   4}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  3,   5,   6}; //   3

  c_p[x_a][4] = {  5,   6}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  7,   1,   8}; //   3

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  1,   2}; //   2
  c_d[x_a][5] = {  1}; //   1

  c_p[x_a][6] = {  0,   2}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  1}; //   1
  c_d[x_a][6] = {  4,   1}; //   2

  c_p[x_a][7] = {  3,   4}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  1}; //   1
  c_d[x_a][7] = {  5,   6}; //   2

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  1,   3}; //   2
  c_d[x_a][8] = {  1}; //   1

  c_p[x_a][9] = {  0,   7}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  4}; //   1
  c_d[x_a][9] = {  8,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv1(1, 2, 32, 4, 8, 16;  24,   0,   0)
// channel    1: 4yyv(1, 2, 16, 32, 4, 8;  24,   0,   0)
// channel    2: 4yyv(1, 2, 32, 16, 4, 8;  24,  24,   0)
// channel    3: 4yyv(1, 2, 32, 8, 4, 16;   0,  24,   0)
// channel    4: 42vv(1, 2, 4, 8, 16, 32;   0,  24,   0)
// channel    5: 12v1(1, 2, 32, 4, 8, 16;  24,   0,   0)
// channel    6: 13yv(1, 2, 32, 16, 4, 8;  24,  24,   0)
// channel    7: 13yv(1, 2, 32, 8, 4, 16;   0,  24,   0)
// channel    8: 112v(1, 2, 32, 16, 4, 8;  24,   0,   0)
// channel    9: 2v2v(1, 2, 16, 32, 4, 8;  24,   0,   0)
