#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

void ppenexa03_phasespace_set::ax_psp_040_uxa_emvexadx(int x_a){
  static Logger logger("ppenexa03_phasespace_set::ax_psp_040_uxa_emvexadx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   3,    5,    7,    8,   10,   11,   12,   13,   15,   16,   18,   19}; //  12
  needed_v_smin[x_a][  1] = {   4,   10,   18,   19}; //   4
  needed_v_smin[x_a][  2] = {   5,    8,   13,    3,   16}; //   5
  needed_v_smin[x_a][  3] = {   6,    9,   14,   17}; //   4
  needed_v_smin[x_a][  4] = {   6,    9,   14,   17}; //   4
  needed_v_smin[x_a][  5] = {   7,   12,   11,   15}; //   4
  needed_v_smin[x_a][  6] = {   0,    2}; //   2
  needed_v_smin[x_a][  7] = {   0,    2}; //   2
  needed_v_smin[x_a][  8] = {   1}; //   1
  needed_v_smin[x_a][  9] = {   1}; //   1
  needed_v_smin[x_a][ 10] = {   4}; //   1

  v_smax[x_a].resize(10);
  needed_v_smax[x_a].resize(10);
  needed_v_smax[x_a][  0] = {   3,    5,    7,    8,   11,   12,   13,   15,   16,   19}; //  10
  needed_v_smax[x_a][  1] = {   4,   10,   18}; //   3
  needed_v_smax[x_a][  2] = {   5,    6,    8,    9,   13,   14,    0,    2,    3,   16,   17}; //  11
  needed_v_smax[x_a][  3] = {   6,    9,   14,   17}; //   4
  needed_v_smax[x_a][  4] = {   7,   12,    1,   11,   15}; //   5
  needed_v_smax[x_a][  5] = {  10,   18}; //   2
  needed_v_smax[x_a][  6] = {  19}; //   1
  needed_v_smax[x_a][  7] = {   0,    2}; //   2
  needed_v_smax[x_a][  8] = {   1}; //   1
  needed_v_smax[x_a][  9] = {   4}; //   1

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   3,    5,    7,    8,   11,   12,   13,   15,   16,   19}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   4,   10,   18}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   5,    8,   13}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   6,    9,   14,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   6,    9,   14}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][5] = {   7,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {  10,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax5");
  needed_g_p[x_a][7] = {  19}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax6");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax7");
  needed_g_f[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax2");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax8");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax4");
  needed_g_f[x_a][4] = {   3,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][5] = {   4}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax9");
  needed_g_f[x_a][6] = {  11,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][7] = {  17}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,    2,   13,   14,   16,   17}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__32_28");
  needed_g_t[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__8_16");
  needed_g_t[x_a][3] = {   1,   11,   12,   15}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__17_6__32_8");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__33_6__16_8");
  needed_g_t[x_a][7] = {   3,    5,    6}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_6__48_8");
  needed_g_t[x_a][11] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][12] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_17__12_32");
  needed_g_t[x_a][13] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_33__12_16");
  needed_g_t[x_a][14] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__20_8");
  needed_g_t[x_a][15] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][16] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__48_12");

  g_d[x_a].resize(9);
  needed_g_d[x_a].resize(9);
  needed_g_d[x_a][0] = {   3,    5,    7,    8,   10,   11,   12,   13,   15,   16,   18,   19}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,   10,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {   5,    8,   13}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {   6,    9,   14}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {   6,    9,   14,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {   7}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][6] = {   7,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][7] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {  10}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0,   1}; //   2
  c_t[x_a][2] = {  0,   1,   6}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  4}; //   1
  c_t[x_a][3] = {  7,   8}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  1}; //   1
  c_f[x_a][4] = {  5}; //   1
  c_t[x_a][4] = {  9,  10}; //   2
  c_d[x_a][4] = {  1}; //   1

  c_p[x_a][5] = {  0,   2}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  7}; //   1
  c_d[x_a][5] = {  2,   0}; //   2

  c_p[x_a][6] = {  3,   4}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  7}; //   1
  c_d[x_a][6] = {  3,   4}; //   2

  c_p[x_a][7] = {  0,   5}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,   6,   0}; //   3

  c_p[x_a][8] = {  0,   2}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  7,   2,   0}; //   3

  c_p[x_a][9] = {  3,   4}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  7,   3,   4}; //   3

  c_p[x_a][10] = {  1,   6}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  8,   0,   1}; //   3

  c_p[x_a][11] = {  0}; //   1
  c_f[x_a][11] = {  6}; //   1
  c_t[x_a][11] = {  3,  11}; //   2
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  0,   5}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  3}; //   1
  c_d[x_a][12] = {  6,   0}; //   2

  c_p[x_a][13] = {  0,   2}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  2,   0}; //   2

  c_p[x_a][14] = {  3,   4}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  3,   4}; //   2

  c_p[x_a][15] = {  0}; //   1
  c_f[x_a][15] = {  6}; //   1
  c_t[x_a][15] = {  3,  12}; //   2
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  0}; //   1
  c_f[x_a][16] = {  4}; //   1
  c_t[x_a][16] = {  0,  13}; //   2
  c_d[x_a][16] = {  0}; //   1

  c_p[x_a][17] = {  3}; //   1
  c_f[x_a][17] = {  7}; //   1
  c_t[x_a][17] = {  0,  14}; //   2
  c_d[x_a][17] = {  4}; //   1

  c_p[x_a][18] = {  1,   6}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 15}; //   1
  c_d[x_a][18] = {  0,   1}; //   2

  c_p[x_a][19] = {  0,   7}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 16}; //   1
  c_d[x_a][19] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 32, 8, 16, 4;  24,   0,   0)
// channel    1: 1111(1, 2, 16, 32, 8, 4;   0,   0,  24)
// channel    2: 1111(1, 2, 32, 16, 8, 4;  24,   0,  24)
// channel    3: 2v11(1, 2, 4, 8, 16, 32;  24,   0,   0)
// channel    4: 2v11(1, 2, 16, 32, 8, 4;   0,   0,  24)
// channel    5: 3yv1(1, 2, 16, 4, 8, 32;  24,  24,   0)
// channel    6: 3yv1(1, 2, 8, 4, 16, 32;   0,  24,   0)
// channel    7: 4yyv(1, 2, 16, 32, 4, 8;  24,   0,   0)
// channel    8: 4yyv(1, 2, 32, 16, 4, 8;  24,  24,   0)
// channel    9: 4yyv(1, 2, 32, 8, 4, 16;   0,  24,   0)
// channel   10: 42vv(1, 2, 4, 8, 16, 32;   0,  24,   0)
// channel   11: 12v1(1, 2, 16, 4, 8, 32;  24,   0,   0)
// channel   12: 13yv(1, 2, 16, 32, 4, 8;  24,   0,   0)
// channel   13: 13yv(1, 2, 32, 16, 4, 8;  24,  24,  24)
// channel   14: 13yv(1, 2, 32, 8, 4, 16;   0,  24,  24)
// channel   15: 112v(1, 2, 16, 32, 4, 8;  24,   0,  24)
// channel   16: 112v(1, 2, 32, 16, 4, 8;  24,  24,  24)
// channel   17: 112v(1, 2, 32, 8, 4, 16;   0,  24,   0)
// channel   18: 2v2v(1, 2, 4, 8, 16, 32;   0,  24,   0)
// channel   19: 2v2v(1, 2, 16, 32, 4, 8;  24,   0,  24)
