#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_230_gg_epveadux(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_230_gg_epveadux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(14);
  needed_v_smin[x_a].resize(14);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45}; //  38
  needed_v_smin[x_a][  1] = {   0,    2,   11,   18,   27,   37,   40,   42}; //   8
  needed_v_smin[x_a][  2] = {   1,    4,   10,   19,   26,   36,   41,   43}; //   8
  needed_v_smin[x_a][  3] = {   2,   11,   27,    0,   37}; //   5
  needed_v_smin[x_a][  4] = {   3,    5,   12,   13,   22,   23,   28,   29,   20,   21,   34,   35}; //  12
  needed_v_smin[x_a][  5] = {   3,    6,   12,   14,   28,   30,   21,   23,   25,   35}; //  10
  needed_v_smin[x_a][  6] = {   4,   10,   26,    1,   36}; //   5
  needed_v_smin[x_a][  7] = {   5,    7,   13,   15,   29,   31,   20,   22,   24,   34}; //  10
  needed_v_smin[x_a][  8] = {   6,    7,   14,   15,   24,   25,   30,   31}; //   8
  needed_v_smin[x_a][  9] = {   6,    7,   14,   15,   24,   25,   30,   31}; //   8
  needed_v_smin[x_a][ 10] = {   8,   16,   18,   32,   39,   40,   42,   44}; //   8
  needed_v_smin[x_a][ 11] = {   8,   16,   32,   39,   44}; //   5
  needed_v_smin[x_a][ 12] = {   9,   17,   19,   33,   38,   41,   43,   45}; //   8
  needed_v_smin[x_a][ 13] = {   9,   17,   33,   38,   45}; //   5

  v_smax[x_a].resize(17);
  needed_v_smax[x_a].resize(17);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   38,   39,   40,   41}; //  28
  needed_v_smax[x_a][  1] = {   0,    2,   11,   18,   27,   37,   40}; //   7
  needed_v_smax[x_a][  2] = {   1,    4,   10,   19,   26,   36,   41}; //   7
  needed_v_smax[x_a][  3] = {   2,    3,    6,    9,   11,   12,   14,   17,   27,   28,   30,   33,    0,   21,   23,   25,   35,   37,   38,   45}; //  20
  needed_v_smax[x_a][  4] = {   3,    5,    6,    7,   12,   13,   14,   15,   22,   23,   24,   25,   28,   29,   30,   31,   20,   21,   34,   35}; //  20
  needed_v_smax[x_a][  5] = {   4,    5,    7,    8,   10,   13,   15,   16,   26,   29,   31,   32,    1,   20,   22,   24,   34,   36,   39,   44}; //  20
  needed_v_smax[x_a][  6] = {   6,    7,   14,   15,   24,   25,   30,   31}; //   8
  needed_v_smax[x_a][  7] = {   8,   16,   32,   42,   44}; //   5
  needed_v_smax[x_a][  8] = {   8,   16,   32,   42,   44}; //   5
  needed_v_smax[x_a][  9] = {   9,   17,   33,   43,   45}; //   5
  needed_v_smax[x_a][ 10] = {   9,   17,   33,   43,   45}; //   5
  needed_v_smax[x_a][ 11] = {  18,   40}; //   2
  needed_v_smax[x_a][ 12] = {  19,   41}; //   2
  needed_v_smax[x_a][ 13] = {  38}; //   1
  needed_v_smax[x_a][ 14] = {  39}; //   1
  needed_v_smax[x_a][ 15] = {  42}; //   1
  needed_v_smax[x_a][ 16] = {  43}; //   1

  g_p[x_a].resize(22);
  needed_g_p[x_a].resize(22);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   38,   39,   40,   41}; //  28
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    2,   11,   18,   27,   37,   40}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    4,   10,   19,   26,   36,   41}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   2,   11,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   3,    5,   12,   13,   22,   23,   28,   29}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax4");
  needed_g_p[x_a][5] = {   3,    6,   12,   14,   28,   30}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax3");
  needed_g_p[x_a][6] = {   4,   10,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   5,    7,   13,   15,   29,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {   6,    7,   14,   15,   24,   25,   30,   31}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][9] = {   6,    7,   14,   15,   24,   25,   30,   31}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax4");
  needed_g_p[x_a][10] = {   8,   16,   32,   42,   44}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][11] = {   8,   16,   32,   42,   44}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax8");
  needed_g_p[x_a][12] = {   8,   16,   32}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax5");
  needed_g_p[x_a][13] = {   9,   17,   33,   43,   45}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][14] = {   9,   17,   33,   43,   45}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax10");
  needed_g_p[x_a][15] = {   9,   17,   33}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax3");
  needed_g_p[x_a][16] = {  18,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax11");
  needed_g_p[x_a][17] = {  19,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax12");
  needed_g_p[x_a][18] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax13");
  needed_g_p[x_a][19] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax14");
  needed_g_p[x_a][20] = {  42}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax15");
  needed_g_p[x_a][21] = {  43}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax16");

  g_f[x_a].resize(7);
  needed_g_f[x_a].resize(7);
  needed_g_f[x_a][0] = {   0,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {   1,   36}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax5");
  needed_g_f[x_a][2] = {  20,   21,   34,   35}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][3] = {  20,   22,   24,   34}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][4] = {  21,   23,   25,   35}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax3");
  needed_g_f[x_a][5] = {  38,   45}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax3");
  needed_g_f[x_a][6] = {  39,   44}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax5");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    2,    3,    6,    9,   38}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__16_76");
  needed_g_t[x_a][2] = {   1,    4,    5,    7,    8,   39}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__16_44");
  needed_g_t[x_a][4] = {  20,   22,   24,   26,   29,   31,   32,   34,   36,   44}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][5] = {  20,   22,   24,   34}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][6] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_65__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_65__16_12");
  needed_g_t[x_a][7] = {  21,   23,   25,   27,   28,   30,   33,   35,   37,   45}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][8] = {  21,   23,   25,   35}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__64_28");
  needed_g_t[x_a][9] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_33__16_12");
  needed_g_t[x_a][10] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][11] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_66__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_66__16_12");
  needed_g_t[x_a][12] = {  36}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__16_44");
  needed_g_t[x_a][13] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__16_76");
  needed_g_t[x_a][14] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__80_12");
  needed_g_t[x_a][15] = {  39}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][16] = {  40}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][17] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__80_44");
  needed_g_t[x_a][18] = {  42}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][19] = {  43}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");
  needed_g_t[x_a][20] = {  44}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][21] = {  45}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__80_12");

  g_d[x_a].resize(18);
  needed_g_d[x_a].resize(18);
  needed_g_d[x_a][0] = {   0,    2,   11,   18,   27,   37,   40,   42}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45}; //  38
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   1,    4,   10,   19,   26,   36,   41,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   2,   11,   27}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][4] = {   3,    6,   12,   14,   28,   30}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][5] = {   3,    5,   12,   13,   22,   23,   28,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][6] = {   4,   10,   26}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][7] = {   5,    7,   13,   15,   29,   31}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {   6,    7,   14,   15,   24,   25,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][9] = {   6,    7,   14,   15,   24,   25,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][10] = {   8,   16,   32}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][11] = {   8,   16,   18,   32,   39,   40,   42,   44}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][12] = {   9,   17,   33}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][13] = {   9,   17,   19,   33,   38,   41,   43,   45}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][14] = {  10,   13,   15,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][15] = {  11,   12,   14,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][16] = {  18}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][17] = {  19}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");

  c_p[x_a].resize(46);
  c_f[x_a].resize(46);
  c_t[x_a].resize(46);
  c_d[x_a].resize(46);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   2}; //   2
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  2,   1}; //   2

  c_p[x_a][2] = {  0,   1,   3}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   0,   1}; //   3

  c_p[x_a][3] = {  0,   4,   5}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  4,   5,   1}; //   3

  c_p[x_a][4] = {  0,   2,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  2}; //   1
  c_d[x_a][4] = {  6,   2,   1}; //   3

  c_p[x_a][5] = {  0,   4,   7}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  2}; //   1
  c_d[x_a][5] = {  7,   5,   1}; //   3

  c_p[x_a][6] = {  8,   9,   5}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  4,   8,   9}; //   3

  c_p[x_a][7] = {  8,   9,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  2}; //   1
  c_d[x_a][7] = {  7,   8,   9}; //   3

  c_p[x_a][8] = { 10,  11,  12}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  2}; //   1
  c_d[x_a][8] = { 10,   1,  11}; //   3

  c_p[x_a][9] = { 13,  14,  15}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 12,   1,  13}; //   3

  c_p[x_a][10] = {  0,   2,   6}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 14,   6,   2,   1}; //   4

  c_p[x_a][11] = {  0,   1,   3}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 15,   3,   0,   1}; //   4

  c_p[x_a][12] = {  0,   4,   5}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 15,   4,   5,   1}; //   4

  c_p[x_a][13] = {  0,   4,   7}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 14,   7,   5,   1}; //   4

  c_p[x_a][14] = {  8,   9,   5}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 15,   4,   8,   9}; //   4

  c_p[x_a][15] = {  8,   9,   7}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 14,   7,   8,   9}; //   4

  c_p[x_a][16] = { 10,  11,  12}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 14,  10,   1,  11}; //   4

  c_p[x_a][17] = { 13,  14,  15}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 15,  12,   1,  13}; //   4

  c_p[x_a][18] = {  0,   1,  16}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 16,  11,   0,   1}; //   4

  c_p[x_a][19] = {  0,   2,  17}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 17,  13,   2,   1}; //   4

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = {  2,   3}; //   2
  c_t[x_a][20] = {  4,   5,   6}; //   3
  c_d[x_a][20] = {  1}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {  2,   4}; //   2
  c_t[x_a][21] = {  7,   8,   9}; //   3
  c_d[x_a][21] = {  1}; //   1

  c_p[x_a][22] = {  0,   4}; //   2
  c_f[x_a][22] = {  3}; //   1
  c_t[x_a][22] = {  4,   5}; //   2
  c_d[x_a][22] = {  5,   1}; //   2

  c_p[x_a][23] = {  0,   4}; //   2
  c_f[x_a][23] = {  4}; //   1
  c_t[x_a][23] = {  7,   8}; //   2
  c_d[x_a][23] = {  5,   1}; //   2

  c_p[x_a][24] = {  8,   9}; //   2
  c_f[x_a][24] = {  3}; //   1
  c_t[x_a][24] = {  4,   5}; //   2
  c_d[x_a][24] = {  8,   9}; //   2

  c_p[x_a][25] = {  8,   9}; //   2
  c_f[x_a][25] = {  4}; //   1
  c_t[x_a][25] = {  7,   8}; //   2
  c_d[x_a][25] = {  8,   9}; //   2

  c_p[x_a][26] = {  0,   2,   6}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  4}; //   1
  c_d[x_a][26] = {  6,   2,   1}; //   3

  c_p[x_a][27] = {  0,   1,   3}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  7}; //   1
  c_d[x_a][27] = {  3,   0,   1}; //   3

  c_p[x_a][28] = {  0,   4,   5}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  7}; //   1
  c_d[x_a][28] = {  4,   5,   1}; //   3

  c_p[x_a][29] = {  0,   4,   7}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  4}; //   1
  c_d[x_a][29] = {  7,   5,   1}; //   3

  c_p[x_a][30] = {  8,   9,   5}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  7}; //   1
  c_d[x_a][30] = {  4,   8,   9}; //   3

  c_p[x_a][31] = {  8,   9,   7}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  4}; //   1
  c_d[x_a][31] = {  7,   8,   9}; //   3

  c_p[x_a][32] = { 10,  11,  12}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  4}; //   1
  c_d[x_a][32] = { 10,   1,  11}; //   3

  c_p[x_a][33] = { 13,  14,  15}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  7}; //   1
  c_d[x_a][33] = { 12,   1,  13}; //   3

  c_p[x_a][34] = {  0}; //   1
  c_f[x_a][34] = {  2,   3}; //   2
  c_t[x_a][34] = {  4,   5,  10}; //   3
  c_d[x_a][34] = {  1}; //   1

  c_p[x_a][35] = {  0}; //   1
  c_f[x_a][35] = {  2,   4}; //   2
  c_t[x_a][35] = {  7,   8,  11}; //   3
  c_d[x_a][35] = {  1}; //   1

  c_p[x_a][36] = {  0,   2}; //   2
  c_f[x_a][36] = {  1}; //   1
  c_t[x_a][36] = {  4,  12}; //   2
  c_d[x_a][36] = {  2,   1}; //   2

  c_p[x_a][37] = {  0,   1}; //   2
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  7,  13}; //   2
  c_d[x_a][37] = {  0,   1}; //   2

  c_p[x_a][38] = {  0,  18}; //   2
  c_f[x_a][38] = {  5}; //   1
  c_t[x_a][38] = {  0,  14}; //   2
  c_d[x_a][38] = { 13,   1}; //   2

  c_p[x_a][39] = {  0,  19}; //   2
  c_f[x_a][39] = {  6}; //   1
  c_t[x_a][39] = {  2,  15}; //   2
  c_d[x_a][39] = { 11,   1}; //   2

  c_p[x_a][40] = {  0,   1,  16}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 16}; //   1
  c_d[x_a][40] = { 11,   0,   1}; //   3

  c_p[x_a][41] = {  0,   2,  17}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 17}; //   1
  c_d[x_a][41] = { 13,   2,   1}; //   3

  c_p[x_a][42] = { 10,  11,  20}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 18}; //   1
  c_d[x_a][42] = {  0,   1,  11}; //   3

  c_p[x_a][43] = { 13,  14,  21}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 19}; //   1
  c_d[x_a][43] = {  2,   1,  13}; //   3

  c_p[x_a][44] = { 10,  11}; //   2
  c_f[x_a][44] = {  6}; //   1
  c_t[x_a][44] = {  4,  20}; //   2
  c_d[x_a][44] = {  1,  11}; //   2

  c_p[x_a][45] = { 13,  14}; //   2
  c_f[x_a][45] = {  5}; //   1
  c_t[x_a][45] = {  7,  21}; //   2
  c_d[x_a][45] = {  1,  13}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv11(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
// channel    1: 3yv11(1, 2, 32, 4, 8, 16, 64;  24,   0,   0,   0)
// channel    2: 4yyv1(1, 2, 16, 64, 4, 8, 32;  24,   0,   0,   0)
// channel    3: 4yyv1(1, 2, 64, 16, 4, 8, 32;  24,  24,   0,   0)
// channel    4: 4yyv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel    5: 4yyv1(1, 2, 32, 16, 4, 8, 64;  24,  24,   0,   0)
// channel    6: 4yyv1(1, 2, 64, 8, 4, 16, 32;   0,  24,   0,   0)
// channel    7: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,  24,   0,   0)
// channel    8: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel    9: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,  24,   0,   0)
// channel   10: 5yyyv(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
// channel   11: 5yyyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
// channel   12: 5yyyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel   13: 5yyyv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
// channel   14: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel   15: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
// channel   16: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
// channel   17: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
// channel   18: 52vyv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel   19: 52vyv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
// channel   20: 12v11(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
// channel   21: 12v11(1, 2, 32, 4, 8, 16, 64;  24,   0,   0,   0)
// channel   22: 13yv1(1, 2, 64, 16, 4, 8, 32;  24,  24,   0,   0)
// channel   23: 13yv1(1, 2, 32, 16, 4, 8, 64;  24,  24,   0,   0)
// channel   24: 13yv1(1, 2, 64, 8, 4, 16, 32;   0,  24,   0,   0)
// channel   25: 13yv1(1, 2, 32, 8, 4, 16, 64;   0,  24,   0,   0)
// channel   26: 14yyv(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
// channel   27: 14yyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
// channel   28: 14yyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel   29: 14yyv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
// channel   30: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel   31: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
// channel   32: 142vv(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
// channel   33: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
// channel   34: 112v1(1, 2, 64, 16, 4, 8, 32;  24,   0,   0,   0)
// channel   35: 112v1(1, 2, 32, 16, 4, 8, 64;  24,   0,   0,   0)
// channel   36: 113yv(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
// channel   37: 113yv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
// channel   38: 2v2v1(1, 2, 16, 64, 4, 8, 32;  24,   0,   0,   0)
// channel   39: 2v2v1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel   40: 2v3yv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel   41: 2v3yv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
// channel   42: 3yv2v(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
// channel   43: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
// channel   44: 12v2v(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
// channel   45: 12v2v(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
