#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_230_uu_epveadu(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_230_uu_epveadu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(14);
  needed_v_smin[x_a].resize(14);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    5,    6,    8,    9,   10,   11,   12,   13,   15,   16,   17,   18,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  needed_v_smin[x_a][  1] = {   2,    5,   10,   11,   12,   17,   23,   26,    9,   16,   25}; //  11
  needed_v_smin[x_a][  2] = {   3,    6,   13,   18}; //   4
  needed_v_smin[x_a][  3] = {   4,    7,   14,   19}; //   4
  needed_v_smin[x_a][  4] = {   4,    7,   14,   19}; //   4
  needed_v_smin[x_a][  5] = {   5,   12,   10,   16}; //   4
  needed_v_smin[x_a][  6] = {   6,    7,   13,   14,    3,    4,   18,   19}; //   8
  needed_v_smin[x_a][  7] = {   8,   15,   22,   27,    0,   21}; //   6
  needed_v_smin[x_a][  8] = {   8,   15,    0,   21,   22,   27}; //   6
  needed_v_smin[x_a][  9] = {  23,   24,   25,   26}; //   4
  needed_v_smin[x_a][ 10] = {   1,   20}; //   2
  needed_v_smin[x_a][ 11] = {   1,   20}; //   2
  needed_v_smin[x_a][ 12] = {   2,    9,   11,   17}; //   4
  needed_v_smin[x_a][ 13] = {  24}; //   1

  v_smax[x_a].resize(16);
  needed_v_smax[x_a].resize(16);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    5,    6,    9,   10,   11,   12,   13,   16,   17,   18,   20,   21,   23,   25,   27}; //  19
  needed_v_smax[x_a][  1] = {   2,    5,   10,   11,   12,   17,   23,    9,   16}; //   9
  needed_v_smax[x_a][  2] = {   3,    4,    6,    7,   13,   14,   18,   19}; //   8
  needed_v_smax[x_a][  3] = {   4,    7,   14,   19}; //   4
  needed_v_smax[x_a][  4] = {   5,    6,    7,    8,   12,   13,   14,   15,    0,    3,    4,   10,   16,   18,   19,   21,   22,   27}; //  18
  needed_v_smax[x_a][  5] = {   8,   15,   22}; //   3
  needed_v_smax[x_a][  6] = {   8,   15,   22}; //   3
  needed_v_smax[x_a][  7] = {  23}; //   1
  needed_v_smax[x_a][  8] = {  24,   26}; //   2
  needed_v_smax[x_a][  9] = {  24,   26}; //   2
  needed_v_smax[x_a][ 10] = {  25}; //   1
  needed_v_smax[x_a][ 11] = {  26,   25}; //   2
  needed_v_smax[x_a][ 12] = {  27,    0,   21}; //   3
  needed_v_smax[x_a][ 13] = {   1,   20}; //   2
  needed_v_smax[x_a][ 14] = {   1,    2,    9,   11,   17,   20}; //   6
  needed_v_smax[x_a][ 15] = {  24}; //   1

  g_p[x_a].resize(16);
  needed_g_p[x_a].resize(16);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    5,    6,    9,   10,   11,   12,   13,   16,   17,   18,   20,   21,   23,   25,   27}; //  19
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    5,   10,   11,   12,   17,   23}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   3,    6,   13,   18}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   4,    7,   14,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,    7,   14,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][5] = {   5,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   6,    7,   13,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][7] = {   8,   15,   22}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {   8,   15,   22}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax6");
  needed_g_p[x_a][9] = {   8,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax4");
  needed_g_p[x_a][10] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][11] = {  24,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][12] = {  24,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax9");
  needed_g_p[x_a][13] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax10");
  needed_g_p[x_a][14] = {  26}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][15] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax12");

  g_f[x_a].resize(10);
  needed_g_f[x_a].resize(10);
  needed_g_f[x_a][0] = {   0,   21}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax12");
  needed_g_f[x_a][1] = {   0,   21,   22,   27}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax4");
  needed_g_f[x_a][2] = {   1,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax13");
  needed_g_f[x_a][3] = {   1,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax14");
  needed_g_f[x_a][4] = {   2,    9,   11,   17}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax14");
  needed_g_f[x_a][5] = {   3,    4,   18,   19}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][6] = {   9,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {  10,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][8] = {  24}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax15");
  needed_g_f[x_a][9] = {  25}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax11");

  g_t[x_a].resize(25);
  needed_g_t[x_a].resize(25);
  needed_g_t[x_a][0] = {   0,    3,    4,    5,    6,    7,    8,   22}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][7] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__32_28");
  needed_g_t[x_a][8] = {   9,   11,   17,   20}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][9] = {   9,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][10] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][11] = {  10,   12,   13,   14,   15,   16,   18,   19,   21,   27}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][12] = {  10,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][13] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][14] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__64_44");
  needed_g_t[x_a][15] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__32_28");
  needed_g_t[x_a][16] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][17] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__64_32");
  needed_g_t[x_a][18] = {  21,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][19] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__32_16");
  needed_g_t[x_a][20] = {  23,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__80_44");
  needed_g_t[x_a][21] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][22] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][23] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_81__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_81__12_32");
  needed_g_t[x_a][24] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    5,    6,    8,    9,   10,   11,   12,   13,   15,   16,   17,   18,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,    5,   10,   11,   12,   17,   23,   26}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   3,    6,   13,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {   4,    7,   14,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {   4,    7,   14,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {   5,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][6] = {   6,    7,   13,   14}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   8,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][8] = {   8,   15,   22,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][9] = {  23,   24,   25,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {  4}; //   1
  c_t[x_a][2] = {  3,   6}; //   2
  c_d[x_a][2] = {  1,   0}; //   2

  c_p[x_a][3] = {  0,   2}; //   2
  c_f[x_a][3] = {  5}; //   1
  c_t[x_a][3] = {  0,   7}; //   2
  c_d[x_a][3] = {  2,   0}; //   2

  c_p[x_a][4] = {  3,   4}; //   2
  c_f[x_a][4] = {  5}; //   1
  c_t[x_a][4] = {  0,   7}; //   2
  c_d[x_a][4] = {  3,   4}; //   2

  c_p[x_a][5] = {  0,   1,   5}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  5,   1,   0}; //   3

  c_p[x_a][6] = {  0,   2,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  6,   2,   0}; //   3

  c_p[x_a][7] = {  3,   4,   6}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  6,   3,   4}; //   3

  c_p[x_a][8] = {  7,   8,   9}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  7,   0,   8}; //   3

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  6,   4}; //   2
  c_t[x_a][9] = {  8,   9,  10}; //   3
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0,   1}; //   2
  c_f[x_a][10] = {  7}; //   1
  c_t[x_a][10] = { 11,  12}; //   2
  c_d[x_a][10] = {  1,   0}; //   2

  c_p[x_a][11] = {  0,   1}; //   2
  c_f[x_a][11] = {  4}; //   1
  c_t[x_a][11] = {  8,   9}; //   2
  c_d[x_a][11] = {  1,   0}; //   2

  c_p[x_a][12] = {  0,   1,   5}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 11}; //   1
  c_d[x_a][12] = {  5,   1,   0}; //   3

  c_p[x_a][13] = {  0,   2,   6}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 11}; //   1
  c_d[x_a][13] = {  6,   2,   0}; //   3

  c_p[x_a][14] = {  3,   4,   6}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 11}; //   1
  c_d[x_a][14] = {  6,   3,   4}; //   3

  c_p[x_a][15] = {  7,   8,   9}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 11}; //   1
  c_d[x_a][15] = {  7,   0,   8}; //   3

  c_p[x_a][16] = {  0}; //   1
  c_f[x_a][16] = {  6,   7}; //   2
  c_t[x_a][16] = { 11,  12,  13}; //   3
  c_d[x_a][16] = {  0}; //   1

  c_p[x_a][17] = {  0,   1}; //   2
  c_f[x_a][17] = {  4}; //   1
  c_t[x_a][17] = {  8,  14}; //   2
  c_d[x_a][17] = {  1,   0}; //   2

  c_p[x_a][18] = {  0,   2}; //   2
  c_f[x_a][18] = {  5}; //   1
  c_t[x_a][18] = { 11,  15}; //   2
  c_d[x_a][18] = {  2,   0}; //   2

  c_p[x_a][19] = {  3,   4}; //   2
  c_f[x_a][19] = {  5}; //   1
  c_t[x_a][19] = { 11,  15}; //   2
  c_d[x_a][19] = {  3,   4}; //   2

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = {  2,   3}; //   2
  c_t[x_a][20] = {  8,  16,  17}; //   3
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {  0,   1}; //   2
  c_t[x_a][21] = { 11,  18,  19}; //   3
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  7,   8}; //   2
  c_f[x_a][22] = {  1}; //   1
  c_t[x_a][22] = {  0,   1}; //   2
  c_d[x_a][22] = {  0,   8}; //   2

  c_p[x_a][23] = {  0,   1,  10}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 20}; //   1
  c_d[x_a][23] = {  9,   1,   0}; //   3

  c_p[x_a][24] = { 11,  12}; //   2
  c_f[x_a][24] = {  8}; //   1
  c_t[x_a][24] = { 21,  22}; //   2
  c_d[x_a][24] = {  0,   9}; //   2

  c_p[x_a][25] = {  0,  13}; //   2
  c_f[x_a][25] = {  9}; //   1
  c_t[x_a][25] = { 20,  23}; //   2
  c_d[x_a][25] = {  9,   0}; //   2

  c_p[x_a][26] = { 11,  12,  14}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 24}; //   1
  c_d[x_a][26] = {  1,   0,   9}; //   3

  c_p[x_a][27] = {  0,  15}; //   2
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = { 11,  18}; //   2
  c_d[x_a][27] = {  8,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  24,   0,   0,   0)
// channel    1: 2v111(1, 2, 4, 8, 32, 64, 16;  24,   0,   0,   0)
// channel    2: 3yv11(1, 2, 32, 4, 8, 64, 16;  24,   0,   0,   0)
// channel    3: 3yv11(1, 2, 16, 4, 8, 32, 64;  24,  24,   0,   0)
// channel    4: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,  24,   0,   0)
// channel    5: 4yyv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel    6: 4yyv1(1, 2, 32, 16, 4, 8, 64;  24,  24,   0,   0)
// channel    7: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,  24,   0,   0)
// channel    8: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel    9: 12v11(1, 2, 16, 4, 8, 32, 64;  24,   0,   0,   0)
// channel   10: 13yv1(1, 2, 64, 32, 4, 8, 16;  24,   0,   0,   0)
// channel   11: 13yv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel   12: 14yyv(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
// channel   13: 14yyv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
// channel   14: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
// channel   15: 142vv(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
// channel   16: 112v1(1, 2, 64, 32, 4, 8, 16;  24,   0,   0,   0)
// channel   17: 113yv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
// channel   18: 113yv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
// channel   19: 113yv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
// channel   20: 1112v(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
// channel   21: 1112v(1, 2, 64, 32, 16, 4, 8;  24,   0,   0,   0)
// channel   22: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel   23: 2v3yv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
// channel   24: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  24,   0,   0)
// channel   25: 2v12v(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
// channel   26: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
// channel   27: 12v2v(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
