#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_040_udx_epveaa(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_040_udx_epveaa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(9);
  needed_v_smin[x_a].resize(9);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   18,   19}; //  12
  needed_v_smin[x_a][  1] = {   2,    6,   14,    1,   13,   18}; //   6
  needed_v_smin[x_a][  2] = {   3,    7,   15,    0,   12,   19}; //   6
  needed_v_smin[x_a][  3] = {   4,    8,    9,   16}; //   4
  needed_v_smin[x_a][  4] = {   4,    9,   16}; //   3
  needed_v_smin[x_a][  5] = {   5,   10,   11,   17}; //   4
  needed_v_smin[x_a][  6] = {   5,   11,   17}; //   3
  needed_v_smin[x_a][  7] = {   8}; //   1
  needed_v_smin[x_a][  8] = {  10}; //   1

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   18,   19}; //  12
  needed_v_smax[x_a][  1] = {   2,    5,    6,   11,   14,   17,    1,   13,   18}; //   9
  needed_v_smax[x_a][  2] = {   3,    4,    7,    9,   15,   16,    0,   12,   19}; //   9
  needed_v_smax[x_a][  3] = {   4,    8,    9,   16}; //   4
  needed_v_smax[x_a][  4] = {   5,   10,   11,   17}; //   4
  needed_v_smax[x_a][  5] = {   8,   10}; //   2

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   18,   19}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    6,   14}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][2] = {   3,    7,   15}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   4,    8,    9,   16}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,    9,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][5] = {   5,   10,   11,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   5,   11,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax1");
  needed_g_p[x_a][7] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,   12,   19}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   1,   13,   18}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    3,    4}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   1,    2,    5}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][4] = {  12,   15,   16,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][5] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][6] = {  13,   14,   17,   18}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][7] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][8] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][9] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");

  g_d[x_a].resize(12);
  needed_g_d[x_a].resize(12);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   18,   19}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,    6,   14}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   3,    7,   15}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {   4,    9,   16}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {   4,    8,    9,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {   5,   11,   17}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][6] = {   5,   10,   11,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][7] = {   6,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   7,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {   8,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][11] = {  10}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  2}; //   1
  c_d[x_a][2] = {  1,   0}; //   2

  c_p[x_a][3] = {  0,   2}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  2,   0}; //   2

  c_p[x_a][4] = {  3,   4}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  3,   4}; //   2

  c_p[x_a][5] = {  5,   6}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  2}; //   1
  c_d[x_a][5] = {  5,   6}; //   2

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  7,   1,   0}; //   3

  c_p[x_a][7] = {  0,   2}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  8,   2,   0}; //   3

  c_p[x_a][8] = {  3,   7}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  9,  10,   4}; //   3

  c_p[x_a][9] = {  3,   4}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  8,   3,   4}; //   3

  c_p[x_a][10] = {  5,   8}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  9,  11,   6}; //   3

  c_p[x_a][11] = {  5,   6}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  7,   5,   6}; //   3

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  4,   5}; //   2
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {  1}; //   1
  c_t[x_a][13] = {  6,   7}; //   2
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  0,   1}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  6}; //   1
  c_d[x_a][14] = {  1,   0}; //   2

  c_p[x_a][15] = {  0,   2}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  4}; //   1
  c_d[x_a][15] = {  2,   0}; //   2

  c_p[x_a][16] = {  3,   4}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  4}; //   1
  c_d[x_a][16] = {  3,   4}; //   2

  c_p[x_a][17] = {  5,   6}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  6}; //   1
  c_d[x_a][17] = {  5,   6}; //   2

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  1}; //   1
  c_t[x_a][18] = {  6,   8}; //   2
  c_d[x_a][18] = {  0}; //   1

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = {  0}; //   1
  c_t[x_a][19] = {  4,   9}; //   2
  c_d[x_a][19] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v11(1, 2, 4, 8, 16, 32;  24,   0,   0)
// channel    1: 2v11(1, 2, 4, 8, 32, 16;  24,   0,   0)
// channel    2: 3yv1(1, 2, 32, 4, 8, 16;  24,  24,   0)
// channel    3: 3yv1(1, 2, 16, 4, 8, 32;  24,  24,   0)
// channel    4: 3yv1(1, 2, 8, 4, 16, 32;   0,  24,   0)
// channel    5: 3yv1(1, 2, 8, 4, 32, 16;   0,  24,   0)
// channel    6: 4yyv(1, 2, 16, 32, 4, 8;  24,  24,  24)
// channel    7: 4yyv(1, 2, 32, 16, 4, 8;  24,  24,  24)
// channel    8: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,  24)
// channel    9: 4yyv(1, 2, 32, 8, 4, 16;   0,  24,  24)
// channel   10: 4yyv(1, 2, 8, 16, 4, 32;   0,   0,  24)
// channel   11: 4yyv(1, 2, 16, 8, 4, 32;   0,  24,  24)
// channel   12: 12v1(1, 2, 32, 4, 8, 16;  24,   0,   0)
// channel   13: 12v1(1, 2, 16, 4, 8, 32;  24,   0,   0)
// channel   14: 13yv(1, 2, 16, 32, 4, 8;  24,  24,   0)
// channel   15: 13yv(1, 2, 32, 16, 4, 8;  24,  24,   0)
// channel   16: 13yv(1, 2, 32, 8, 4, 16;   0,  24,   0)
// channel   17: 13yv(1, 2, 16, 8, 4, 32;   0,  24,   0)
// channel   18: 112v(1, 2, 16, 32, 4, 8;  24,   0,   0)
// channel   19: 112v(1, 2, 32, 16, 4, 8;  24,   0,   0)
