#include "header.hpp"

#include "pph21.phasespace.set.hpp"

void pph21_phasespace_set::ax_psp_410_gg_huux(int x_a){
  static Logger logger("pph21_phasespace_set::ax_psp_410_gg_huux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   4,    5,    6,    0,    1}; //   5
  needed_v_smin[x_a][  1] = {   2}; //   1
  needed_v_smin[x_a][  2] = {   3}; //   1

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   4,    5,    6,    0,    1}; //   5
  needed_v_smax[x_a][  1] = {   2}; //   1
  needed_v_smax[x_a][  2] = {   3}; //   1

  g_p[x_a].resize(1);
  needed_g_p[x_a].resize(1);
  needed_g_p[x_a][0] = {   4,    5,    6}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][1] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][2] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");

  g_t[x_a].resize(8);
  needed_g_t[x_a].resize(8);
  needed_g_t[x_a][0] = {   0,    1,    6}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_24");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_8");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_16");
  needed_g_t[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_20");
  needed_g_t[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_16");
  needed_g_t[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_8");
  needed_g_t[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_24");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   4,    5,    6}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][1] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");

  c_p[x_a].resize(7);
  c_f[x_a].resize(7);
  c_t[x_a].resize(7);
  c_d[x_a].resize(7);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   2}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  3,   4}; //   2
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  2}; //   1
  c_t[x_a][3] = {  5,   6}; //   2
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  7}; //   1
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  1,   0}; //   2

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 111(1, 2, 4, 8, 16;   0,   0)
// channel    1: 111(1, 2, 4, 16, 8;   0,   0)
// channel    2: 111(1, 2, 8, 16, 4;   0,   0)
// channel    3: 111(1, 2, 16, 8, 4;   0,   0)
// channel    4: 2v1(1, 2, 8, 16, 4;   0,   0)
// channel    5: 3yv(1, 2, 4, 8, 16;   0,   0)
// channel    6: 12v(1, 2, 4, 8, 16;   0,   0)
