#include "header.hpp"

#include "ppnenex02.phasespace.set.hpp"

void ppnenex02_phasespace_set::ax_psp_320_gg_vevexg(int x_a){
  static Logger logger("ppnenex02_phasespace_set::ax_psp_320_gg_vevexg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(1);
  needed_v_smin[x_a].resize(1);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8}; //   9
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 9);

  v_smax[x_a].resize(1);
  needed_v_smax[x_a].resize(1);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8}; //   9
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 9);

  g_p[x_a].resize(1);
  needed_g_p[x_a].resize(1);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");
  needed_g_t[x_a][1] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__16_12");
  needed_g_t[x_a][2] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][3] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_12");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   3,    4,    5}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");

  c_p[x_a].resize(9);
  c_f[x_a].resize(9);
  c_t[x_a].resize(9);
  c_d[x_a].resize(9);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  1}; //   1
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  1,   0}; //   2

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  1,   0}; //   2

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  1,   0}; //   2

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  2}; //   1
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  2}; //   1
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  3}; //   1
  c_d[x_a][8] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
