#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_230_gbx_vevexagbx(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_230_gbx_vevexagbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(16);
  needed_v_smin[x_a].resize(16);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,    6,    7,   14,   15,   17}; //   9
  needed_v_smin[x_a][  2] = {   2,    6,    1}; //   3
  needed_v_smin[x_a][  3] = {   3,    7,   15,    0,   14,   17}; //   6
  needed_v_smin[x_a][  4] = {   4,    8,   11,   16,   24,   25,   28,   29,   21}; //   9
  needed_v_smin[x_a][  5] = {   4,    8,   16,   21,   24,   29}; //   6
  needed_v_smin[x_a][  6] = {   5,    9,   10,   23,   26,   27}; //   6
  needed_v_smin[x_a][  7] = {   5,    9,   23}; //   3
  needed_v_smin[x_a][  8] = {  10,   27}; //   2
  needed_v_smin[x_a][  9] = {  11,   28}; //   2
  needed_v_smin[x_a][ 10] = {  12,   19,   26}; //   3
  needed_v_smin[x_a][ 11] = {  12,   19}; //   2
  needed_v_smin[x_a][ 12] = {  13,   18,   25}; //   3
  needed_v_smin[x_a][ 13] = {  13,   18}; //   2
  needed_v_smin[x_a][ 14] = {  20,   22}; //   2
  needed_v_smin[x_a][ 15] = {  20,   22}; //   2

  v_smax[x_a].resize(19);
  needed_v_smax[x_a].resize(19);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  23
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,    6,    7,   14,   15,   17}; //   9
  needed_v_smax[x_a][  2] = {   2,    5,    6,    9,    1,   23}; //   6
  needed_v_smax[x_a][  3] = {   3,    4,    7,    8,   15,   16,    0,   14,   17,   21,   24,   29}; //  12
  needed_v_smax[x_a][  4] = {   4,    8,   11,   16}; //   4
  needed_v_smax[x_a][  5] = {   4,    8,   16}; //   3
  needed_v_smax[x_a][  6] = {   5,    9,   10}; //   3
  needed_v_smax[x_a][  7] = {   5,    9}; //   2
  needed_v_smax[x_a][  8] = {  10,   11}; //   2
  needed_v_smax[x_a][  9] = {  10,   11}; //   2
  needed_v_smax[x_a][ 10] = {  23,   26,   27}; //   3
  needed_v_smax[x_a][ 11] = {  24,   25,   28,   29,   21}; //   5
  needed_v_smax[x_a][ 12] = {  27,   28}; //   2
  needed_v_smax[x_a][ 13] = {  12,   19}; //   2
  needed_v_smax[x_a][ 14] = {  12,   13,   18,   19,   20,   22}; //   6
  needed_v_smax[x_a][ 15] = {  13,   18}; //   2
  needed_v_smax[x_a][ 16] = {  20,   22}; //   2
  needed_v_smax[x_a][ 17] = {  25}; //   1
  needed_v_smax[x_a][ 18] = {  26}; //   1

  g_p[x_a].resize(17);
  needed_g_p[x_a].resize(17);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  23
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,    6,    7,   14,   15}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   3,    7,   15}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,    8,   11,   16}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   4,    8,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax5");
  needed_g_p[x_a][6] = {   4,    8,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax3");
  needed_g_p[x_a][7] = {   5,    9,   10}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][8] = {   5,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");
  needed_g_p[x_a][9] = {   5,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][10] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax8");
  needed_g_p[x_a][11] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][12] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][13] = {  23,   26,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax10");
  needed_g_p[x_a][14] = {  24,   25,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax11");
  needed_g_p[x_a][15] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax12");
  needed_g_p[x_a][16] = {  28}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax12");

  g_f[x_a].resize(14);
  needed_g_f[x_a].resize(14);
  needed_g_f[x_a][0] = {   0,   14,   17}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][2] = {  12,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax13");
  needed_g_f[x_a][3] = {  12,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax14");
  needed_g_f[x_a][4] = {  13,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax15");
  needed_g_f[x_a][5] = {  13,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax14");
  needed_g_f[x_a][6] = {  17}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {  20,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax16");
  needed_g_f[x_a][8] = {  20,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax14");
  needed_g_f[x_a][9] = {  21}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax11");
  needed_g_f[x_a][10] = {  21,   24,   29}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax3");
  needed_g_f[x_a][11] = {  23}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax2");
  needed_g_f[x_a][12] = {  25}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax17");
  needed_g_f[x_a][13] = {  26}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax18");

  g_t[x_a].resize(26);
  needed_g_t[x_a].resize(26);
  needed_g_t[x_a][0] = {   0,    3,    4,   24}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__16_76");
  needed_g_t[x_a][2] = {   1,    2,    5,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__32_76");
  needed_g_t[x_a][4] = {  12,   13,   18,   19,   20,   22}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][5] = {  12,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][6] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_65__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_65__16_12");
  needed_g_t[x_a][7] = {  13,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][8] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_65__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_65__32_12");
  needed_g_t[x_a][9] = {  14,   15,   16,   17,   21,   29}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][10] = {  14,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][11] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][12] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][13] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][14] = {  20,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][15] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__16_32");
  needed_g_t[x_a][16] = {  21,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][17] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][18] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__32_16");
  needed_g_t[x_a][19] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][20] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__80_12");
  needed_g_t[x_a][21] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__80_44");
  needed_g_t[x_a][22] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_81__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_81__12_32");
  needed_g_t[x_a][23] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][24] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][25] = {  27,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");

  g_d[x_a].resize(13);
  needed_g_d[x_a].resize(13);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    6,    7,   14,   15}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   2,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][3] = {   3,    7,   15}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][4] = {   4,    8,   16}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][5] = {   4,    8,   11,   16,   24,   25,   28,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][6] = {   5,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__12_96");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__12_96");
  needed_g_d[x_a][7] = {   5,    9,   10,   23,   26,   27}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][8] = {   6,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][9] = {   7,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][10] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][11] = {  10,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__16_96");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__16_96");
  needed_g_d[x_a][12] = {  11,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");

  c_p[x_a].resize(30);
  c_f[x_a].resize(30);
  c_t[x_a].resize(30);
  c_d[x_a].resize(30);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  0,   1}; //   2

  c_p[x_a][2] = {  0,   1,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  2}; //   1
  c_d[x_a][2] = {  2,   0,   1}; //   3

  c_p[x_a][3] = {  0,   1,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  3,   0,   1}; //   3

  c_p[x_a][4] = {  4,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  4,   1,   5}; //   3

  c_p[x_a][5] = {  7,   8,   9}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  2}; //   1
  c_d[x_a][5] = {  6,   1,   7}; //   3

  c_p[x_a][6] = {  0,   1,   2}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  8,   2,   0,   1}; //   4

  c_p[x_a][7] = {  0,   1,   3}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  9,   3,   0,   1}; //   4

  c_p[x_a][8] = {  4,   5,   6}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  9,   4,   1,   5}; //   4

  c_p[x_a][9] = {  7,   8,   9}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  8,   6,   1,   7}; //   4

  c_p[x_a][10] = {  7,  10,  11}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 10,   1,  11,   7}; //   4

  c_p[x_a][11] = {  4,  12,  11}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 10,   1,  12,   5}; //   4

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  2,   3}; //   2
  c_t[x_a][12] = {  4,   5,   6}; //   3
  c_d[x_a][12] = {  1}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {  4,   5}; //   2
  c_t[x_a][13] = {  4,   7,   8}; //   3
  c_d[x_a][13] = {  1}; //   1

  c_p[x_a][14] = {  0,   1}; //   2
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  9,  10}; //   2
  c_d[x_a][14] = {  0,   1}; //   2

  c_p[x_a][15] = {  0,   1,   3}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  9}; //   1
  c_d[x_a][15] = {  3,   0,   1}; //   3

  c_p[x_a][16] = {  4,   5,   6}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  9}; //   1
  c_d[x_a][16] = {  4,   1,   5}; //   3

  c_p[x_a][17] = {  0}; //   1
  c_f[x_a][17] = {  6,   0}; //   2
  c_t[x_a][17] = {  9,  10,  11}; //   3
  c_d[x_a][17] = {  1}; //   1

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  4,   5}; //   2
  c_t[x_a][18] = {  4,   7,  12}; //   3
  c_d[x_a][18] = {  1}; //   1

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = {  2,   3}; //   2
  c_t[x_a][19] = {  4,   5,  13}; //   3
  c_d[x_a][19] = {  1}; //   1

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = {  7,   8}; //   2
  c_t[x_a][20] = {  4,  14,  15}; //   3
  c_d[x_a][20] = {  1}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {  9,  10}; //   2
  c_t[x_a][21] = {  9,  16,  17}; //   3
  c_d[x_a][21] = {  1}; //   1

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = {  7,   8}; //   2
  c_t[x_a][22] = {  4,  14,  18}; //   3
  c_d[x_a][22] = {  1}; //   1

  c_p[x_a][23] = {  0,  13}; //   2
  c_f[x_a][23] = { 11}; //   1
  c_t[x_a][23] = {  2,  19}; //   2
  c_d[x_a][23] = {  7,   1}; //   2

  c_p[x_a][24] = {  0,  14}; //   2
  c_f[x_a][24] = { 10}; //   1
  c_t[x_a][24] = {  0,  20}; //   2
  c_d[x_a][24] = {  5,   1}; //   2

  c_p[x_a][25] = {  0,  14}; //   2
  c_f[x_a][25] = { 12}; //   1
  c_t[x_a][25] = { 21,  22}; //   2
  c_d[x_a][25] = {  5,   1}; //   2

  c_p[x_a][26] = {  0,  13}; //   2
  c_f[x_a][26] = { 13}; //   1
  c_t[x_a][26] = { 23,  24}; //   2
  c_d[x_a][26] = {  7,   1}; //   2

  c_p[x_a][27] = {  0,  13,  15}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 25}; //   1
  c_d[x_a][27] = { 11,   7,   1}; //   3

  c_p[x_a][28] = {  0,  14,  16}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 25}; //   1
  c_d[x_a][28] = { 12,   5,   1}; //   3

  c_p[x_a][29] = {  0,  14}; //   2
  c_f[x_a][29] = { 10}; //   1
  c_t[x_a][29] = {  9,  16}; //   2
  c_d[x_a][29] = {  5,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel    1: 3yv11(1, 2, 64, 4, 8, 32, 16;  23,   0,   0,   0)
// channel    2: 4yyv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel    3: 4yyv1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
// channel    4: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,  23,   0,   0)
// channel    5: 42vv1(1, 2, 4, 8, 32, 64, 16;   0,  23,   0,   0)
// channel    6: 5yyyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel    7: 5yyyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel    8: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel    9: 5y2vv(1, 2, 16, 4, 8, 32, 64;   0,  23,   0,   0)
// channel   10: 52vyv(1, 2, 4, 8, 16, 32, 64;   0,   0,  23,   0)
// channel   11: 52vyv(1, 2, 4, 8, 32, 16, 64;   0,   0,  23,   0)
// channel   12: 12v11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   13: 12v11(1, 2, 64, 4, 8, 32, 16;  23,   0,   0,   0)
// channel   14: 13yv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   15: 14yyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   16: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   17: 112v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   18: 112v1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
// channel   19: 112v1(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
// channel   20: 1112v(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
// channel   21: 1112v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
// channel   22: 1112v(1, 2, 64, 32, 16, 4, 8;  23,   0,   0,   0)
// channel   23: 2v2v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   24: 2v2v1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
// channel   25: 2v12v(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
// channel   26: 2v12v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
// channel   27: 3yv2v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   28: 3yv2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   29: 12v2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
