#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_230_uux_vevexassx(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_230_uux_vevexassx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(17);
  needed_v_smin[x_a].resize(17);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19}; //  20
  needed_v_smin[x_a][  1] = {   0,    3,    6,    8}; //   4
  needed_v_smin[x_a][  2] = {   0,    8}; //   2
  needed_v_smin[x_a][  3] = {   1,    2,    7,    9}; //   4
  needed_v_smin[x_a][  4] = {   1,    9}; //   2
  needed_v_smin[x_a][  5] = {   2}; //   1
  needed_v_smin[x_a][  6] = {   3}; //   1
  needed_v_smin[x_a][  7] = {   4,    6,   12,   16}; //   4
  needed_v_smin[x_a][  8] = {   4}; //   1
  needed_v_smin[x_a][  9] = {   5,    7,   13,   17}; //   4
  needed_v_smin[x_a][ 10] = {   5}; //   1
  needed_v_smin[x_a][ 11] = {  10,   11,   14,   15,   18,   19}; //   6
  needed_v_smin[x_a][ 12] = {  12,   16}; //   2
  needed_v_smin[x_a][ 13] = {  13,   17}; //   2
  needed_v_smin[x_a][ 14] = {  10,   11,   18,   19}; //   4
  needed_v_smin[x_a][ 15] = {  14}; //   1
  needed_v_smin[x_a][ 16] = {  15}; //   1

  v_smax[x_a].resize(21);
  needed_v_smax[x_a].resize(21);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    6,    7,    8,    9,   11,   15,   16,   17,   19}; //  13
  needed_v_smax[x_a][  1] = {   0,    3,    6,    8}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    8,    9,   10,   11,   18,   19}; //   8
  needed_v_smax[x_a][  3] = {   1,    2,    7,    9}; //   4
  needed_v_smax[x_a][  4] = {   2,    4}; //   2
  needed_v_smax[x_a][  5] = {   3,    5}; //   2
  needed_v_smax[x_a][  6] = {   4,   12}; //   2
  needed_v_smax[x_a][  7] = {   4}; //   1
  needed_v_smax[x_a][  8] = {   5,   13}; //   2
  needed_v_smax[x_a][  9] = {   5}; //   1
  needed_v_smax[x_a][ 10] = {   6}; //   1
  needed_v_smax[x_a][ 11] = {   7}; //   1
  needed_v_smax[x_a][ 12] = {  10,   14,   18}; //   3
  needed_v_smax[x_a][ 13] = {  10,   14,   18}; //   3
  needed_v_smax[x_a][ 14] = {  11,   15,   19}; //   3
  needed_v_smax[x_a][ 15] = {  12,   13}; //   2
  needed_v_smax[x_a][ 16] = {  12,   13}; //   2
  needed_v_smax[x_a][ 17] = {  16}; //   1
  needed_v_smax[x_a][ 18] = {  16,   17,   14}; //   3
  needed_v_smax[x_a][ 19] = {  17}; //   1
  needed_v_smax[x_a][ 20] = {  15}; //   1

  g_p[x_a].resize(25);
  needed_g_p[x_a].resize(25);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    6,    7,    8,    9,   11,   15,   16,   17,   19}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    3,    6,    8}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    2,    7,    9}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   4,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");
  needed_g_p[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax4");
  needed_g_p[x_a][10] = {   5,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][12] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax5");
  needed_g_p[x_a][13] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax10");
  needed_g_p[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax11");
  needed_g_p[x_a][15] = {  10,   14,   18}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax12");
  needed_g_p[x_a][16] = {  10,   14,   18}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax13");
  needed_g_p[x_a][17] = {  11,   15,   19}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax14");
  needed_g_p[x_a][18] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax15");
  needed_g_p[x_a][19] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][20] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax15");
  needed_g_p[x_a][21] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax17");
  needed_g_p[x_a][22] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax18");
  needed_g_p[x_a][23] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax19");
  needed_g_p[x_a][24] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax18");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  10,   11,   18,   19}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax2");
  needed_g_f[x_a][1] = {  14}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax18");
  needed_g_f[x_a][2] = {  15}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax20");

  g_t[x_a].resize(11);
  needed_g_t[x_a].resize(11);
  needed_g_t[x_a][0] = {   0,    1,   10,   11}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][1] = {   8,    9,   18,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][2] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][3] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][4] = {  12,   13,   14}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][5] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][6] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][7] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][8] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][9] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");
  needed_g_t[x_a][10] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");

  g_d[x_a].resize(18);
  needed_g_d[x_a].resize(18);
  needed_g_d[x_a][0] = {   0,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][1] = {   0,    3,    6,    8}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   1,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__64_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__64_44");
  needed_g_d[x_a][4] = {   1,    2,    7,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   2,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][7] = {   3,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][10] = {   4,    6,   12,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][12] = {   5,    7,   13,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][13] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");
  needed_g_d[x_a][15] = {  10,   11,   14,   15,   18,   19}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][16] = {  12,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][17] = {  13,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   3,   4}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   3,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  5,   6,   4,   2}; //   4

  c_p[x_a][3] = {  0,   1,   6}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  7,   8,   1,   2}; //   4

  c_p[x_a][4] = {  7,   8,   9}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  5,   9,   2,  10}; //   4

  c_p[x_a][5] = { 10,  11,  12}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  7,  11,   2,  12}; //   4

  c_p[x_a][6] = {  0,   1,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = { 13,  10,   1,   2}; //   4

  c_p[x_a][7] = {  0,   3,  14}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 14,  12,   4,   2}; //   4

  c_p[x_a][8] = {  0,   1,   2}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  1}; //   1
  c_d[x_a][8] = {  0,   1,   2}; //   3

  c_p[x_a][9] = {  0,   3,   4}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  1}; //   1
  c_d[x_a][9] = {  3,   4,   2}; //   3

  c_p[x_a][10] = { 15,  16}; //   2
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   2}; //   2
  c_d[x_a][10] = {  2,  15}; //   2

  c_p[x_a][11] = {  0,  17}; //   2
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  0,   3}; //   2
  c_d[x_a][11] = { 15,   2}; //   2

  c_p[x_a][12] = {  7,  18,  19}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  4}; //   1
  c_d[x_a][12] = {  2,  16,  10}; //   3

  c_p[x_a][13] = { 10,  20,  19}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  4}; //   1
  c_d[x_a][13] = {  2,  17,  12}; //   3

  c_p[x_a][14] = { 15,  16}; //   2
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = {  4,   5}; //   2
  c_d[x_a][14] = {  2,  15}; //   2

  c_p[x_a][15] = {  0,  17}; //   2
  c_f[x_a][15] = {  2}; //   1
  c_t[x_a][15] = {  6,   7}; //   2
  c_d[x_a][15] = { 15,   2}; //   2

  c_p[x_a][16] = {  0,  21,  22}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  8}; //   1
  c_d[x_a][16] = { 16,  10,   2}; //   3

  c_p[x_a][17] = {  0,  23,  24}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  8}; //   1
  c_d[x_a][17] = { 17,  12,   2}; //   3

  c_p[x_a][18] = { 15,  16}; //   2
  c_f[x_a][18] = {  0}; //   1
  c_t[x_a][18] = {  1,   9}; //   2
  c_d[x_a][18] = {  2,  15}; //   2

  c_p[x_a][19] = {  0,  17}; //   2
  c_f[x_a][19] = {  0}; //   1
  c_t[x_a][19] = {  1,  10}; //   2
  c_d[x_a][19] = { 15,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel    1: 4yyv1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
// channel    2: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
// channel    3: 5yyyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel    4: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel    5: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel    6: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel    7: 52vyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
// channel    8: 14yyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel    9: 14yyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
// channel   10: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  23,   0,   0)
// channel   11: 2v2v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   12: 2v3yv(1, 2, 4, 8, 64, 16, 32;   0,   0,  23,   0)
// channel   13: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,   0,  23,   0)
// channel   14: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
// channel   15: 2v12v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
// channel   16: 3yv2v(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
// channel   17: 3yv2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   18: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  23,   0,   0)
// channel   19: 12v2v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
