#include "header.hpp"

#include "ppw01.phasespace.set.hpp"

void ppw01_phasespace_set::ag_psp_110_dux_wmg(int x_a, int zero){
  static Logger logger("ppw01_phasespace_set::ag_psp_110_dux_wmg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][5] == nullvector){xbp_all[x_a][5] = xbp_all[x_a][1] - xbp_all[x_a][4];}
  if (xbs_all[x_a][5] == 0.){xbs_all[x_a][5] = xbp_all[x_a][5].m2();}
  if (xbs_all[x_a][5] > 0.){xbs_all[x_a][5] = 0.;}
  if (xbp_all[x_a][9] == nullvector){xbp_all[x_a][9] = xbp_all[x_a][1] - xbp_all[x_a][8];}
  if (xbs_all[x_a][9] == 0.){xbs_all[x_a][9] = xbp_all[x_a][9].m2();}
  if (xbs_all[x_a][9] > 0.){xbs_all[x_a][9] = 0.;}
  if (xbp_all[x_a][12] == nullvector){xbp_all[x_a][12] = xbp_all[x_a][4] + xbp_all[x_a][8];}
  if (xbs_all[x_a][12] == 0.){xbs_all[x_a][12] = xbp_all[x_a][12].m2();}
  if (xbs_all[x_a][12] < 0.){xbs_all[x_a][12] = 0.;}



  //  vector<double> g_t(2);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  12,   1,   2,   4,   8); /* ntp 0 */} // 1 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,   0,  12,   1,   2,   8,   4); /* ntp 0 */} // 1 times


  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(0);
    inv_r[1].resize(0);
    inv_r[2].resize(2);
    inv_r[3].resize(2);
    inv_r[4].resize(0);
    inv_r[5].resize(0);



    {inv_tchannel_opt(x_a,   0,  12,   1,   2,   4,   8, inv_r[2][0], inv_r[3][0]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  12,   1,   2,   8,   4, inv_r[2][1], inv_r[3][1]);} // 1 times


    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(2, vector<double> (2));
      vector<double> g_IS(2, 1.);
      for (int i_c = 0; i_c < 2; i_c++){
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        int ran = 0;
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 2; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_t[x_a][  0];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_t[x_a][  1];}

    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(0, 1.);
      g_IS[1].resize(0, 1.);
      g_IS[2].resize(2, 1.);
      g_IS[3].resize(0, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_t[x_a][  0] * g_IS[2][  0];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_t[x_a][  1] * g_IS[2][  1];}
    }
  }

  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_t[x_a][  0];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_t[x_a][  1];}
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
