#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ag_psp_220_dxcx_wpwmuxsx(int x_a, int zero){
  static Logger logger("ppwxw02_phasespace_set::ag_psp_220_dxcx_wpwmuxsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][5] == nullvector){xbp_all[x_a][5] = xbp_all[x_a][1] - xbp_all[x_a][4];}
  if (xbs_all[x_a][5] == 0.){xbs_all[x_a][5] = xbp_all[x_a][5].m2();}
  if (xbs_all[x_a][5] > 0.){xbs_all[x_a][5] = 0.;}
  if (xbp_all[x_a][10] == nullvector){xbp_all[x_a][10] = xbp_all[x_a][2] - xbp_all[x_a][8];}
  if (xbs_all[x_a][10] == 0.){xbs_all[x_a][10] = xbp_all[x_a][10].m2();}
  if (xbs_all[x_a][10] > 0.){xbs_all[x_a][10] = 0.;}
  if (xbp_all[x_a][20] == nullvector){xbp_all[x_a][20] = xbp_all[x_a][4] + xbp_all[x_a][16];}
  if (xbs_all[x_a][20] == 0.){xbs_all[x_a][20] = xbp_all[x_a][20].m2();}
  if (xbs_all[x_a][20] < 0.){xbs_all[x_a][20] = 0.;}
  if (xbsqrts_all[x_a][20] == 0.){xbsqrts_all[x_a][20] = sqrt(xbs_all[x_a][20]);}
  if (xbp_all[x_a][40] == nullvector){xbp_all[x_a][40] = xbp_all[x_a][8] + xbp_all[x_a][32];}
  if (xbs_all[x_a][40] == 0.){xbs_all[x_a][40] = xbp_all[x_a][40].m2();}
  if (xbs_all[x_a][40] < 0.){xbs_all[x_a][40] = 0.;}
  if (xbsqrts_all[x_a][40] == 0.){xbsqrts_all[x_a][40] = sqrt(xbs_all[x_a][40]);}
  if (xbp_all[x_a][48] == nullvector){xbp_all[x_a][48] = xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][48] == 0.){xbs_all[x_a][48] = xbp_all[x_a][48].m2();}
  if (xbs_all[x_a][48] < 0.){xbs_all[x_a][48] = 0.;}
  if (xbsqrts_all[x_a][48] == 0.){xbsqrts_all[x_a][48] = sqrt(xbs_all[x_a][48]);}
  if (xbp_all[x_a][21] == nullvector){xbp_all[x_a][21] = xbp_all[x_a][1] - xbp_all[x_a][4] - xbp_all[x_a][16];}
  if (xbs_all[x_a][21] == 0.){xbs_all[x_a][21] = xbp_all[x_a][21].m2();}
  if (xbs_all[x_a][21] > 0.){xbs_all[x_a][21] = 0.;}
  if (xbp_all[x_a][42] == nullvector){xbp_all[x_a][42] = xbp_all[x_a][2] - xbp_all[x_a][8] - xbp_all[x_a][32];}
  if (xbs_all[x_a][42] == 0.){xbs_all[x_a][42] = xbp_all[x_a][42].m2();}
  if (xbs_all[x_a][42] > 0.){xbs_all[x_a][42] = 0.;}
  if (xbp_all[x_a][52] == nullvector){xbp_all[x_a][52] = xbp_all[x_a][4] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][52] == 0.){xbs_all[x_a][52] = xbp_all[x_a][52].m2();}
  if (xbs_all[x_a][52] < 0.){xbs_all[x_a][52] = 0.;}
  if (xbp_all[x_a][56] == nullvector){xbp_all[x_a][56] = xbp_all[x_a][8] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][56] == 0.){xbs_all[x_a][56] = xbp_all[x_a][56].m2();}
  if (xbs_all[x_a][56] < 0.){xbs_all[x_a][56] = 0.;}
  if (xbp_all[x_a][60] == nullvector){xbp_all[x_a][60] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][60] == 0.){xbs_all[x_a][60] = xbp_all[x_a][60].m2();}
  if (xbs_all[x_a][60] < 0.){xbs_all[x_a][60] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][20]; // 2 times
  v_smin[x_a][  1] = smin_opt[x_a][40]; // 2 times
  v_smin[x_a][  2] = smin_opt[x_a][48]; // 1 times
  v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]); // 1 times
  v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][52]); // 1 times
  v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]); // 1 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2); // 1 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2); // 2 times
  v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][40], 2); // 1 times
  v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2); // 1 times
  v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2); // 2 times
  v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2); // 1 times

  //  vector<double> g_p(3);
  {g_p[x_a][  0] = g_propagator(x_a,   0,  20, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 1 times
  {g_p[x_a][  1] = g_propagator(x_a,   0,  40, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 2 */} // 2 times
  {g_p[x_a][  2] = g_propagator(x_a,   0,  20, v_smin[x_a][  0], v_smax[x_a][  2]); /* npp 2 */} // 1 times

  //  vector<double> g_f(4);
  {g_f[x_a][  0] = g_timelikeinvariant(v_smin[x_a][  2], v_smax[x_a][  3]); /* nfp 2 */} // 1 times
  {g_f[x_a][  1] = g_timelikeinvariant(v_smin[x_a][  3], v_smax[x_a][  4]); /* nfp 3 */} // 1 times
  {g_f[x_a][  2] = g_timelikeinvariant(v_smin[x_a][  4], v_smax[x_a][  5]); /* nfp 3 */} // 1 times
  {g_f[x_a][  3] = g_timelikeinvariant(v_smin[x_a][  5], v_smax[x_a][  4]); /* nfp 3 */} // 1 times

  //  vector<double> g_t(7);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  60,   1,   2,   4,  56); /* ntp 0 */} // 2 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,   0,  56,   2,   5,   8,  48); /* ntp 1 */} // 1 times
  {g_t[x_a][  2] = g_tchannel(x_a,   0,  48,   5,  10,  16,  32); /* ntp 2 */} // 1 times
  {g_t[x_a][  3] = g_tchannel_opt(x_a,   0,  60,   2,   1,   8,  52); /* ntp 0 */} // 1 times
  {g_t[x_a][  4] = g_tchannel_opt(x_a,   0,  52,   1,  10,  20,  32); /* ntp 1 */} // 1 times
  {g_t[x_a][  5] = g_tchannel_opt(x_a,   0,  56,   2,   5,  40,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][  6] = g_tchannel_opt(x_a,   0,  60,   1,   2,  20,  40); /* ntp 0 */} // 1 times

  //  vector<double> g_d(2);
  {g_d[x_a][  0] = g_decay(x_a,  20,   4,  16); /* ndp 2 */} // 2 times
  {g_d[x_a][  1] = g_decay(x_a,  40,   8,  32); /* ndp 2 */} // 2 times


  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(3);
    inv_r[1].resize(4);
    inv_r[2].resize(7);
    inv_r[3].resize(7);
    inv_r[4].resize(2);
    inv_r[5].resize(2);

    {inv_propagator(x_a,   0,  20, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 1 times
    {inv_propagator(x_a,   0,  40, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][1]);} // 2 times
    {inv_propagator(x_a,   0,  20, v_smin[x_a][  0], v_smax[x_a][  2], inv_r[0][2]);} // 1 times

    {inv_timelikeinvariant(x_a,  48, v_smin[x_a][  2], v_smax[x_a][  3], inv_r[1][0]);} // 1 times
    {inv_timelikeinvariant(x_a,  56, v_smin[x_a][  3], v_smax[x_a][  4], inv_r[1][1]);} // 1 times
    {inv_timelikeinvariant(x_a,  52, v_smin[x_a][  4], v_smax[x_a][  5], inv_r[1][2]);} // 1 times
    {inv_timelikeinvariant(x_a,  56, v_smin[x_a][  5], v_smax[x_a][  4], inv_r[1][3]);} // 1 times

    {inv_tchannel_opt(x_a,   0,  60,   1,   2,   4,  56, inv_r[2][0], inv_r[3][0]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  56,   2,   5,   8,  48, inv_r[2][1], inv_r[3][1]);} // 1 times
    {inv_tchannel(x_a,   0,  48,   5,  10,  16,  32, inv_r[2][2], inv_r[3][2]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  60,   2,   1,   8,  52, inv_r[2][3], inv_r[3][3]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  52,   1,  10,  20,  32, inv_r[2][4], inv_r[3][4]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  56,   2,   5,  40,  16, inv_r[2][5], inv_r[3][5]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  20,  40, inv_r[2][6], inv_r[3][6]);} // 1 times

    {inv_decay(x_a,  20,   4,  16, inv_r[4][0], inv_r[5][0]);} // 2 times
    {inv_decay(x_a,  40,   8,  32, inv_r[4][1], inv_r[5][1]);} // 2 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(4, vector<double> (8));
      vector<double> g_IS(4, 1.);
      for (int i_c = 0; i_c < 4; i_c++){
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        int ran = 0;
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 8; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_f[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  2];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_p[x_a][  0] * g_f[x_a][  2] * g_t[x_a][  3] * g_t[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_IS[  2] * g_p[x_a][  1] * g_f[x_a][  3] * g_t[x_a][  0] * g_t[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_IS[  3] * g_p[x_a][  1] * g_p[x_a][  2] * g_t[x_a][  6] * g_d[x_a][  0] * g_d[x_a][  1];}

    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(3, 1.);
      g_IS[1].resize(4, 1.);
      g_IS[2].resize(7, 1.);
      g_IS[3].resize(2, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_IS[1][  0] * g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  1] * g_IS[2][  1] * g_t[x_a][  2] * g_IS[2][  2];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][  3] * g_IS[2][  3] * g_t[x_a][  4] * g_IS[2][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  1] * g_IS[0][  1] * g_f[x_a][  3] * g_IS[1][  3] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  5] * g_IS[2][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  1] * g_IS[0][  1] * g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][  6] * g_IS[2][  6] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1];}
    }
  }

  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  2];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_f[x_a][  2] * g_t[x_a][  3] * g_t[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  1] * g_f[x_a][  3] * g_t[x_a][  0] * g_t[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  1] * g_p[x_a][  2] * g_t[x_a][  6] * g_d[x_a][  0] * g_d[x_a][  1];}
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
