#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ag_psp_030_ba_wpwmb(int x_a, int zero){
  static Logger logger("ppwxw02_phasespace_set::ag_psp_030_ba_wpwmb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][6] == nullvector){xbp_all[x_a][6] = xbp_all[x_a][2] - xbp_all[x_a][4];}
  if (xbs_all[x_a][6] == 0.){xbs_all[x_a][6] = xbp_all[x_a][6].m2();}
  if (xbs_all[x_a][6] > 0.){xbs_all[x_a][6] = 0.;}
  if (xbp_all[x_a][9] == nullvector){xbp_all[x_a][9] = xbp_all[x_a][1] - xbp_all[x_a][8];}
  if (xbs_all[x_a][9] == 0.){xbs_all[x_a][9] = xbp_all[x_a][9].m2();}
  if (xbs_all[x_a][9] > 0.){xbs_all[x_a][9] = 0.;}
  if (xbp_all[x_a][10] == nullvector){xbp_all[x_a][10] = xbp_all[x_a][2] - xbp_all[x_a][8];}
  if (xbs_all[x_a][10] == 0.){xbs_all[x_a][10] = xbp_all[x_a][10].m2();}
  if (xbs_all[x_a][10] > 0.){xbs_all[x_a][10] = 0.;}
  if (xbp_all[x_a][12] == nullvector){xbp_all[x_a][12] = xbp_all[x_a][4] + xbp_all[x_a][8];}
  if (xbs_all[x_a][12] == 0.){xbs_all[x_a][12] = xbp_all[x_a][12].m2();}
  if (xbs_all[x_a][12] < 0.){xbs_all[x_a][12] = 0.;}
  if (xbp_all[x_a][17] == nullvector){xbp_all[x_a][17] = xbp_all[x_a][1] - xbp_all[x_a][16];}
  if (xbs_all[x_a][17] == 0.){xbs_all[x_a][17] = xbp_all[x_a][17].m2();}
  if (xbs_all[x_a][17] > 0.){xbs_all[x_a][17] = 0.;}
  if (xbp_all[x_a][18] == nullvector){xbp_all[x_a][18] = xbp_all[x_a][2] - xbp_all[x_a][16];}
  if (xbs_all[x_a][18] == 0.){xbs_all[x_a][18] = xbp_all[x_a][18].m2();}
  if (xbs_all[x_a][18] > 0.){xbs_all[x_a][18] = 0.;}
  if (xbp_all[x_a][20] == nullvector){xbp_all[x_a][20] = xbp_all[x_a][4] + xbp_all[x_a][16];}
  if (xbs_all[x_a][20] == 0.){xbs_all[x_a][20] = xbp_all[x_a][20].m2();}
  if (xbs_all[x_a][20] < 0.){xbs_all[x_a][20] = 0.;}
  if (xbp_all[x_a][28] == nullvector){xbp_all[x_a][28] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][28] == 0.){xbs_all[x_a][28] = xbp_all[x_a][28].m2();}
  if (xbs_all[x_a][28] < 0.){xbs_all[x_a][28] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][12]; // 12 times
  v_smin[x_a][  1] = smin_opt[x_a][20]; // 5 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2); // 12 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2); // 5 times

  //  vector<double> g_p(4);
  {g_p[x_a][  0] = g_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 2 times
  {g_p[x_a][  1] = g_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 2 times
  {g_p[x_a][  2] = g_propagator(x_a,  25,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 2 times
  {g_p[x_a][  3] = g_propagator(x_a,   6,  20, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 2 */} // 3 times

  //  vector<double> g_f(2);
  {g_f[x_a][  0] = g_timelikeinvariant(v_smin[x_a][  0], v_smax[x_a][  0]); /* nfp 2 */} // 6 times
  {g_f[x_a][  1] = g_timelikeinvariant(v_smin[x_a][  1], v_smax[x_a][  1]); /* nfp 2 */} // 2 times

  //  vector<double> g_t(10);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  28,   1,   2,  16,  12); /* ntp 0 */} // 2 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,  24,  12,   2,  17,   8,   4); /* ntp 1 */} // 3 times
  {g_t[x_a][  2] = g_tchannel_opt(x_a,  23,  28,   1,   2,  16,  12); /* ntp 0 */} // 2 times
  {g_t[x_a][  3] = g_tchannel_opt(x_a,  25,  28,   1,   2,  16,  12); /* ntp 0 */} // 2 times
  {g_t[x_a][  4] = g_tchannel_opt(x_a,   6,  28,   1,   2,   8,  20); /* ntp 0 */} // 3 times
  {g_t[x_a][  5] = g_tchannel_opt(x_a,   5,  20,   2,   9,  16,   4); /* ntp 1 */} // 1 times
  {g_t[x_a][  6] = g_tchannel_opt(x_a,  24,  20,   2,   9,   4,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][  7] = g_tchannel_opt(x_a,  24,  12,   2,  17,   4,   8); /* ntp 1 */} // 3 times
  {g_t[x_a][  8] = g_tchannel_opt(x_a,   5,  28,   2,   1,  16,  12); /* ntp 0 */} // 3 times
  {g_t[x_a][  9] = g_tchannel_opt(x_a,  24,  28,   2,   1,   8,  20); /* ntp 0 */} // 1 times

  //  vector<double> g_d(4);
  {g_d[x_a][  0] = g_decay(x_a,  12,   4,   8); /* ndp 2 */} // 6 times
  {g_d[x_a][  1] = g_decay(x_a,  20,   4,  16); /* ndp 2 */} // 3 times
  {g_d[x_a][  2] = g_decay(x_a,  28,  16,  12); /* ndp 3 */} // 3 times
  {g_d[x_a][  3] = g_decay(x_a,  28,   8,  20); /* ndp 3 */} // 1 times


  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(4);
    inv_r[1].resize(2);
    inv_r[2].resize(10);
    inv_r[3].resize(10);
    inv_r[4].resize(4);
    inv_r[5].resize(4);

    {inv_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 2 times
    {inv_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][1]);} // 2 times
    {inv_propagator(x_a,  25,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][2]);} // 2 times
    {inv_propagator(x_a,   6,  20, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][3]);} // 3 times

    {inv_timelikeinvariant(x_a,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[1][0]);} // 6 times
    {inv_timelikeinvariant(x_a,  20, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[1][1]);} // 2 times

    {inv_tchannel_opt(x_a,   0,  28,   1,   2,  16,  12, inv_r[2][0], inv_r[3][0]);} // 2 times
    {inv_tchannel_opt(x_a,  24,  12,   2,  17,   8,   4, inv_r[2][1], inv_r[3][1]);} // 3 times
    {inv_tchannel_opt(x_a,  23,  28,   1,   2,  16,  12, inv_r[2][2], inv_r[3][2]);} // 2 times
    {inv_tchannel_opt(x_a,  25,  28,   1,   2,  16,  12, inv_r[2][3], inv_r[3][3]);} // 2 times
    {inv_tchannel_opt(x_a,   6,  28,   1,   2,   8,  20, inv_r[2][4], inv_r[3][4]);} // 3 times
    {inv_tchannel_opt(x_a,   5,  20,   2,   9,  16,   4, inv_r[2][5], inv_r[3][5]);} // 1 times
    {inv_tchannel_opt(x_a,  24,  20,   2,   9,   4,  16, inv_r[2][6], inv_r[3][6]);} // 1 times
    {inv_tchannel_opt(x_a,  24,  12,   2,  17,   4,   8, inv_r[2][7], inv_r[3][7]);} // 3 times
    {inv_tchannel_opt(x_a,   5,  28,   2,   1,  16,  12, inv_r[2][8], inv_r[3][8]);} // 3 times
    {inv_tchannel_opt(x_a,  24,  28,   2,   1,   8,  20, inv_r[2][9], inv_r[3][9]);} // 1 times

    {inv_decay(x_a,  12,   4,   8, inv_r[4][0], inv_r[5][0]);} // 6 times
    {inv_decay(x_a,  20,   4,  16, inv_r[4][1], inv_r[5][1]);} // 3 times
    {inv_decay(x_a,  28,  16,  12, inv_r[4][2], inv_r[5][2]);} // 3 times
    {inv_decay(x_a,  28,   8,  20, inv_r[4][3], inv_r[5][3]);} // 1 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(17, vector<double> (5));
      vector<double> g_IS(17, 1.);
      for (int i_c = 0; i_c < 17; i_c++){
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        int ran = 0;
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 5; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  1];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_IS[  2] * g_f[x_a][  0] * g_t[x_a][  3] * g_t[x_a][  1];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_IS[  3] * g_f[x_a][  1] * g_t[x_a][  4] * g_t[x_a][  5];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_IS[  4] * g_f[x_a][  1] * g_t[x_a][  4] * g_t[x_a][  6];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_IS[  5] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  7];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_IS[  6] * g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  7];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_IS[  7] * g_f[x_a][  0] * g_t[x_a][  3] * g_t[x_a][  7];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_IS[  8] * g_p[x_a][  0] * g_t[x_a][  8] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_IS[  9] * g_p[x_a][  1] * g_t[x_a][  8] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_IS[ 10] * g_p[x_a][  2] * g_t[x_a][  8] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_IS[ 11] * g_p[x_a][  3] * g_t[x_a][  9] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_IS[ 12] * g_p[x_a][  0] * g_d[x_a][  2] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_IS[ 13] * g_p[x_a][  1] * g_d[x_a][  2] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_IS[ 14] * g_p[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_IS[ 15] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_IS[ 16] * g_p[x_a][  3] * g_t[x_a][  4] * g_d[x_a][  1];}

    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(4, 1.);
      g_IS[1].resize(2, 1.);
      g_IS[2].resize(10, 1.);
      g_IS[3].resize(4, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  1] * g_IS[2][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_t[x_a][  1] * g_IS[2][  1];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  3] * g_IS[2][  3] * g_t[x_a][  1] * g_IS[2][  1];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  4] * g_IS[2][  4] * g_t[x_a][  5] * g_IS[2][  5];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  4] * g_IS[2][  4] * g_t[x_a][  6] * g_IS[2][  6];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  7] * g_IS[2][  7];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_t[x_a][  7] * g_IS[2][  7];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  3] * g_IS[2][  3] * g_t[x_a][  7] * g_IS[2][  7];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][  8] * g_IS[2][  8] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][  8] * g_IS[2][  8] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][  8] * g_IS[2][  8] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  0] * g_IS[0][  0] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  2] * g_IS[0][  2] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][  4] * g_IS[2][  4] * g_d[x_a][  1] * g_IS[3][  1];}
    }
  }

  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  1];}
    if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_f[x_a][  0] * g_t[x_a][  3] * g_t[x_a][  1];}
    if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_f[x_a][  1] * g_t[x_a][  4] * g_t[x_a][  5];}
    if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_f[x_a][  1] * g_t[x_a][  4] * g_t[x_a][  6];}
    if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  7];}
    if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  7];}
    if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_f[x_a][  0] * g_t[x_a][  3] * g_t[x_a][  7];}
    if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_p[x_a][  0] * g_t[x_a][  8] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_p[x_a][  1] * g_t[x_a][  8] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_p[x_a][  2] * g_t[x_a][  8] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_p[x_a][  3] * g_t[x_a][  9] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  0] * g_d[x_a][  2] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  1] * g_d[x_a][  2] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  2] * g_d[x_a][  2] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  3] * g_t[x_a][  4] * g_d[x_a][  1];}
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
