#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_bb_wpwmbb(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_bb_wpwmbb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(9);
  needed_v_smin[x_a].resize(9);
  needed_v_smin[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35}; //  24
  needed_v_smin[x_a][  1] = {  10,   11,   12,   22,   23,   24,    7,    8,    9,   30,   31,   32}; //  12
  needed_v_smin[x_a][  2] = {  13,   14,   15,   25,   26,   27,    4,    5,    6,   33,   34,   35}; //  12
  needed_v_smin[x_a][  3] = {  16,   18,   20,   28,    1,    2}; //   6
  needed_v_smin[x_a][  4] = {  16,   28,    1,   18}; //   4
  needed_v_smin[x_a][  5] = {  17,   19,   21,   29,    0,    3}; //   6
  needed_v_smin[x_a][  6] = {  17,   29,    0,   19}; //   4
  needed_v_smin[x_a][  7] = {   2,   20}; //   2
  needed_v_smin[x_a][  8] = {   3,   21}; //   2

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35}; //  24
  needed_v_smax[x_a][  1] = {  10,   11,   12,   17,   22,   23,   24,   29,    0,    7,    8,    9,   19,   30,   31,   32}; //  16
  needed_v_smax[x_a][  2] = {  13,   14,   15,   16,   25,   26,   27,   28,    1,    4,    5,    6,   18,   33,   34,   35}; //  16
  needed_v_smax[x_a][  3] = {  16,   18,   20,   28,    1,    2}; //   6
  needed_v_smax[x_a][  4] = {  17,   19,   21,   29,    0,    3}; //   6
  needed_v_smax[x_a][  5] = {   2,    3,   20,   21}; //   4

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   4,    7,   10,   13,   22,   25,   30,   33}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   5,    8,   11,   14,   23,   26,   31,   34}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   6,    9,   12,   15,   24,   27,   32,   35}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin0_smax0");
  needed_g_p[x_a][3] = {  10,   11,   12,   22,   23,   24}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin1_smax1");
  needed_g_p[x_a][4] = {  13,   14,   15,   25,   26,   27}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin2_smax2");
  needed_g_p[x_a][5] = {  16,   18,   20,   28}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin3_smax3");
  needed_g_p[x_a][6] = {  16,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin4_smax2");
  needed_g_p[x_a][7] = {  17,   19,   21,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin5_smax4");
  needed_g_p[x_a][8] = {  17,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin6_smax1");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][1] = {   0,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax1");
  needed_g_f[x_a][2] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][3] = {   1,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");
  needed_g_f[x_a][4] = {   2,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][5] = {   3,   21}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][6] = {   4,    5,    6,   33,   34,   35}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][7] = {   7,    8,    9,   30,   31,   32}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,   19,   22,   23,   24,   29,   30,   31,   32}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][1] = {   0,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__8_36");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__17_10__32_4");
  needed_g_t[x_a][3] = {   1,   18,   25,   26,   27,   28,   33,   34,   35}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][4] = {   1,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__8_20");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__33_10__16_4");
  needed_g_t[x_a][6] = {   2,    3,   20,   21}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_52");
  needed_g_t[x_a][7] = {   2,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][8] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__9_34__4_16");
  needed_g_t[x_a][9] = {   3,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][10] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__9_18__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__9_18__4_32");
  needed_g_t[x_a][11] = {   4,    5,    6,   13,   14,   15,   16}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][12] = {   4,    5,    6}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_34__12_16");
  needed_g_t[x_a][13] = {   7,    8,    9,   10,   11,   12,   17}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][14] = {   7,    8,    9}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_18__12_32");
  needed_g_t[x_a][15] = {  30,   31,   32}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_17__12_32");
  needed_g_t[x_a][16] = {  33,   34,   35}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_33__12_16");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  10,   11,   12,   22,   23,   24}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {  13,   14,   15,   25,   26,   27}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {  16,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {  16,   18,   20,   28}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {  17,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][6] = {  17,   19,   21,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");

  c_p[x_a].resize(36);
  c_f[x_a].resize(36);
  c_t[x_a].resize(36);
  c_d[x_a].resize(36);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   4}; //   2
  c_t[x_a][2] = {  6,   7,   8}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   5}; //   2
  c_t[x_a][3] = {  6,   9,  10}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  6}; //   1
  c_t[x_a][4] = { 11,  12}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  6}; //   1
  c_t[x_a][5] = { 11,  12}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  2}; //   1
  c_f[x_a][6] = {  6}; //   1
  c_t[x_a][6] = { 11,  12}; //   2
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {  7}; //   1
  c_t[x_a][7] = { 13,  14}; //   2
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  1}; //   1
  c_f[x_a][8] = {  7}; //   1
  c_t[x_a][8] = { 13,  14}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  2}; //   1
  c_f[x_a][9] = {  7}; //   1
  c_t[x_a][9] = { 13,  14}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0,   3}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 13}; //   1
  c_d[x_a][10] = {  1,   0}; //   2

  c_p[x_a][11] = {  1,   3}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 13}; //   1
  c_d[x_a][11] = {  1,   0}; //   2

  c_p[x_a][12] = {  2,   3}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 13}; //   1
  c_d[x_a][12] = {  1,   0}; //   2

  c_p[x_a][13] = {  0,   4}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 11}; //   1
  c_d[x_a][13] = {  2,   0}; //   2

  c_p[x_a][14] = {  1,   4}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 11}; //   1
  c_d[x_a][14] = {  2,   0}; //   2

  c_p[x_a][15] = {  2,   4}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 11}; //   1
  c_d[x_a][15] = {  2,   0}; //   2

  c_p[x_a][16] = {  5,   6}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 11}; //   1
  c_d[x_a][16] = {  3,   4}; //   2

  c_p[x_a][17] = {  7,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 13}; //   1
  c_d[x_a][17] = {  5,   6}; //   2

  c_p[x_a][18] = {  5}; //   1
  c_f[x_a][18] = {  3}; //   1
  c_t[x_a][18] = {  3,   4}; //   2
  c_d[x_a][18] = {  4}; //   1

  c_p[x_a][19] = {  7}; //   1
  c_f[x_a][19] = {  1}; //   1
  c_t[x_a][19] = {  0,   1}; //   2
  c_d[x_a][19] = {  6}; //   1

  c_p[x_a][20] = {  5}; //   1
  c_f[x_a][20] = {  4}; //   1
  c_t[x_a][20] = {  6,   7}; //   2
  c_d[x_a][20] = {  4}; //   1

  c_p[x_a][21] = {  7}; //   1
  c_f[x_a][21] = {  5}; //   1
  c_t[x_a][21] = {  6,   9}; //   2
  c_d[x_a][21] = {  6}; //   1

  c_p[x_a][22] = {  0,   3}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = {  1,   0}; //   2

  c_p[x_a][23] = {  1,   3}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = {  1,   0}; //   2

  c_p[x_a][24] = {  2,   3}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  1,   0}; //   2

  c_p[x_a][25] = {  0,   4}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  3}; //   1
  c_d[x_a][25] = {  2,   0}; //   2

  c_p[x_a][26] = {  1,   4}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  3}; //   1
  c_d[x_a][26] = {  2,   0}; //   2

  c_p[x_a][27] = {  2,   4}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  3}; //   1
  c_d[x_a][27] = {  2,   0}; //   2

  c_p[x_a][28] = {  5,   6}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  3}; //   1
  c_d[x_a][28] = {  3,   4}; //   2

  c_p[x_a][29] = {  7,   8}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = {  5,   6}; //   2

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = {  7}; //   1
  c_t[x_a][30] = {  0,  15}; //   2
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  1}; //   1
  c_f[x_a][31] = {  7}; //   1
  c_t[x_a][31] = {  0,  15}; //   2
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  2}; //   1
  c_f[x_a][32] = {  7}; //   1
  c_t[x_a][32] = {  0,  15}; //   2
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = {  0}; //   1
  c_f[x_a][33] = {  6}; //   1
  c_t[x_a][33] = {  3,  16}; //   2
  c_d[x_a][33] = {  0}; //   1

  c_p[x_a][34] = {  1}; //   1
  c_f[x_a][34] = {  6}; //   1
  c_t[x_a][34] = {  3,  16}; //   2
  c_d[x_a][34] = {  0}; //   1

  c_p[x_a][35] = {  2}; //   1
  c_f[x_a][35] = {  6}; //   1
  c_t[x_a][35] = {  3,  16}; //   2
  c_d[x_a][35] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 16, 32, 4, 8;   0,   6,   5)
// channel    1: 1111(1, 2, 32, 16, 4, 8;   0,   6,   5)
// channel    2: 1111(1, 2, 8, 4, 16, 32;   6,   0,   5)
// channel    3: 1111(1, 2, 8, 4, 32, 16;   6,   0,   5)
// channel    4: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   5)
// channel    5: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   5)
// channel    6: 2v11(1, 2, 4, 8, 16, 32;  25,   0,   5)
// channel    7: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   5)
// channel    8: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   5)
// channel    9: 2v11(1, 2, 4, 8, 32, 16;  25,   0,   5)
// channel   10: 3yv1(1, 2, 32, 4, 8, 16;   0,   5,   0)
// channel   11: 3yv1(1, 2, 32, 4, 8, 16;  23,   5,   0)
// channel   12: 3yv1(1, 2, 32, 4, 8, 16;  25,   5,   0)
// channel   13: 3yv1(1, 2, 16, 4, 8, 32;   0,   5,   0)
// channel   14: 3yv1(1, 2, 16, 4, 8, 32;  23,   5,   0)
// channel   15: 3yv1(1, 2, 16, 4, 8, 32;  25,   5,   0)
// channel   16: 3yv1(1, 2, 8, 4, 16, 32;   6,   5,   0)
// channel   17: 3yv1(1, 2, 8, 4, 32, 16;   6,   5,   0)
// channel   18: 12v1(1, 2, 32, 4, 16, 8;   6,   0,   6)
// channel   19: 12v1(1, 2, 16, 4, 32, 8;   6,   0,   6)
// channel   20: 12v1(1, 2, 8, 4, 16, 32;   6,   6,   0)
// channel   21: 12v1(1, 2, 8, 4, 32, 16;   6,   6,   0)
// channel   22: 13yv(1, 2, 16, 32, 4, 8;   0,   5,   0)
// channel   23: 13yv(1, 2, 16, 32, 4, 8;  23,   5,   0)
// channel   24: 13yv(1, 2, 16, 32, 4, 8;  25,   5,   0)
// channel   25: 13yv(1, 2, 32, 16, 4, 8;   0,   5,   0)
// channel   26: 13yv(1, 2, 32, 16, 4, 8;  23,   5,   0)
// channel   27: 13yv(1, 2, 32, 16, 4, 8;  25,   5,   0)
// channel   28: 13yv(1, 2, 32, 8, 4, 16;   6,   5,   0)
// channel   29: 13yv(1, 2, 16, 8, 4, 32;   6,   5,   0)
// channel   30: 112v(1, 2, 16, 32, 4, 8;   0,   0,   5)
// channel   31: 112v(1, 2, 16, 32, 4, 8;  23,   0,   5)
// channel   32: 112v(1, 2, 16, 32, 4, 8;  25,   0,   5)
// channel   33: 112v(1, 2, 32, 16, 4, 8;   0,   0,   5)
// channel   34: 112v(1, 2, 32, 16, 4, 8;  23,   0,   5)
// channel   35: 112v(1, 2, 32, 16, 4, 8;  25,   0,   5)
