#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_bux_wpwmbux(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_bux_wpwmbux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(8);
  needed_v_smin[x_a].resize(8);
  needed_v_smin[x_a][  0] = {   2,    3,    4,    5,    6,    7,   11,   12,   14,   15}; //  10
  needed_v_smin[x_a][  1] = {   5,    6,    7,    2,    3,    4}; //   6
  needed_v_smin[x_a][  2] = {   8,   10,    1}; //   3
  needed_v_smin[x_a][  3] = {   8}; //   1
  needed_v_smin[x_a][  4] = {   9,   13,    0}; //   3
  needed_v_smin[x_a][  5] = {  11,   12,   14,   15}; //   4
  needed_v_smin[x_a][  6] = {  13,    0,    9}; //   3
  needed_v_smin[x_a][  7] = {   1,   10}; //   2

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   2,    3,    4,    5,    6,    7,   11,   12,   14,   15}; //  10
  needed_v_smax[x_a][  1] = {   5,    6,    7,    8,    2,    3,    4}; //   7
  needed_v_smax[x_a][  2] = {   8,   10,    1}; //   3
  needed_v_smax[x_a][  3] = {   9,   13,    0}; //   3
  needed_v_smax[x_a][  4] = {  11,   12,   13,    0,    9,   14,   15}; //   7
  needed_v_smax[x_a][  5] = {   1,   10}; //   2

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   2,    5,   11,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    6,   12,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   4,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin0_smax0");
  needed_g_p[x_a][3] = {   5,    6,    7}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin1_smax1");
  needed_g_p[x_a][4] = {   8,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin2_smax2");
  needed_g_p[x_a][5] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin3_smax1");
  needed_g_p[x_a][6] = {   9,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][7] = {  11,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][8] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax3");
  needed_g_f[x_a][1] = {   0,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][3] = {   1,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][4] = {   2,    3,    4}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][5] = {  14,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");

  g_t[x_a].resize(9);
  needed_g_t[x_a].resize(9);
  needed_g_t[x_a][0] = {   0,    9,   11,   12,   13,   14,   15}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][1] = {   0,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][3] = {   1,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_52");
  needed_g_t[x_a][4] = {   1,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__9_34__4_16");
  needed_g_t[x_a][6] = {   2,    3,    4,    5,    6,    7,    8}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][7] = {   2,    3,    4}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_34__12_16");
  needed_g_t[x_a][8] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   2,    3,    4,    5,    6,    7,   11,   12,   14,   15}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   5,    6,    7}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][2] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][3] = {   8,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][4] = {   9,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][5] = {  11,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {  13}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");

  c_p[x_a].resize(16);
  c_f[x_a].resize(16);
  c_t[x_a].resize(16);
  c_d[x_a].resize(16);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  4}; //   1
  c_t[x_a][2] = {  6,   7}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  4}; //   1
  c_t[x_a][3] = {  6,   7}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  2}; //   1
  c_f[x_a][4] = {  4}; //   1
  c_t[x_a][4] = {  6,   7}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0,   3}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  6}; //   1
  c_d[x_a][5] = {  1,   0}; //   2

  c_p[x_a][6] = {  1,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  6}; //   1
  c_d[x_a][6] = {  1,   0}; //   2

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  6}; //   1
  c_d[x_a][7] = {  1,   0}; //   2

  c_p[x_a][8] = {  4,   5}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  6}; //   1
  c_d[x_a][8] = {  2,   3}; //   2

  c_p[x_a][9] = {  6}; //   1
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = {  4}; //   1

  c_p[x_a][10] = {  4}; //   1
  c_f[x_a][10] = {  3}; //   1
  c_t[x_a][10] = {  3,   4}; //   2
  c_d[x_a][10] = {  3}; //   1

  c_p[x_a][11] = {  0,   7}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  5,   0}; //   2

  c_p[x_a][12] = {  1,   7}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  5,   0}; //   2

  c_p[x_a][13] = {  6,   8}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  6,   4}; //   2

  c_p[x_a][14] = {  0}; //   1
  c_f[x_a][14] = {  5}; //   1
  c_t[x_a][14] = {  0,   8}; //   2
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  1}; //   1
  c_f[x_a][15] = {  5}; //   1
  c_t[x_a][15] = {  0,   8}; //   2
  c_d[x_a][15] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    1: 1111(1, 2, 8, 4, 16, 32;   6,   0,   5)
// channel    2: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   5)
// channel    3: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   5)
// channel    4: 2v11(1, 2, 4, 8, 16, 32;  25,   0,   5)
// channel    5: 3yv1(1, 2, 16, 4, 8, 32;   0,   5,   0)
// channel    6: 3yv1(1, 2, 16, 4, 8, 32;  23,   5,   0)
// channel    7: 3yv1(1, 2, 16, 4, 8, 32;  25,   5,   0)
// channel    8: 3yv1(1, 2, 8, 4, 16, 32;   6,   5,   0)
// channel    9: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   10: 12v1(1, 2, 8, 4, 16, 32;   6,   6,   0)
// channel   11: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   12: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   13: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   14: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   15: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
