#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_ddx_wpwmuux(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_ddx_wpwmuux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(12);
  needed_v_smin[x_a].resize(12);
  needed_v_smin[x_a][  0] = {   1,    3,    9,   17}; //   4
  needed_v_smin[x_a][  1] = {   2,   10,   11,   13,   14,   15,   16,    0}; //   8
  needed_v_smin[x_a][  2] = {   3}; //   1
  needed_v_smin[x_a][  3] = {   4,    5,    6,    7,   13,   14,   15,   16}; //   8
  needed_v_smin[x_a][  4] = {   4,    5}; //   2
  needed_v_smin[x_a][  5] = {   6,    7}; //   2
  needed_v_smin[x_a][  6] = {   8,    9,   12,   17}; //   4
  needed_v_smin[x_a][  7] = {   8}; //   1
  needed_v_smin[x_a][  8] = {   0,   10,   11}; //   3
  needed_v_smin[x_a][  9] = {   1}; //   1
  needed_v_smin[x_a][ 10] = {   2}; //   1
  needed_v_smin[x_a][ 11] = {  12}; //   1

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  needed_v_smax[x_a][  0] = {   1,    3,    9}; //   3
  needed_v_smax[x_a][  1] = {   2,   10,   11,   13,   14,    0}; //   6
  needed_v_smax[x_a][  2] = {   3,    6,    7}; //   3
  needed_v_smax[x_a][  3] = {   4,    5,    6,    7,   15,   16}; //   6
  needed_v_smax[x_a][  4] = {   4,    5,    8}; //   3
  needed_v_smax[x_a][  5] = {   8,   12,   17}; //   3
  needed_v_smax[x_a][  6] = {   9}; //   1
  needed_v_smax[x_a][  7] = {  13,   14}; //   2
  needed_v_smax[x_a][  8] = {  15,   16}; //   2
  needed_v_smax[x_a][  9] = {  17}; //   1
  needed_v_smax[x_a][ 10] = {   0,   10,   11,   12}; //   4
  needed_v_smax[x_a][ 11] = {   1,    2}; //   2

  g_p[x_a].resize(14);
  needed_g_p[x_a].resize(14);
  needed_g_p[x_a][0] = {   1,    3,    9}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   2,   10,   11,   13,   14}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   4,    6,   15}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   5,    7,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][6] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax2");
  needed_g_p[x_a][7] = {   8,   12,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax4");
  needed_g_p[x_a][9] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][10] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax7");
  needed_g_p[x_a][11] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax7");
  needed_g_p[x_a][12] = {  15,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax8");
  needed_g_p[x_a][13] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   0,   10,   11}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax10");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax11");
  needed_g_f[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax11");
  needed_g_f[x_a][4] = {  12}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax10");

  g_t[x_a].resize(11);
  needed_g_t[x_a].resize(11);
  needed_g_t[x_a][0] = {   0,   10,   11,   12}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][1] = {   0,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_32");
  needed_g_t[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__24_32");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_8");
  needed_g_t[x_a][6] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__48_4");
  needed_g_t[x_a][7] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__36_16");
  needed_g_t[x_a][8] = {  13,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][9] = {  15,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");
  needed_g_t[x_a][10] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   1,    3,    9,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][1] = {   2,   10,   11,   13,   14,   15,   16}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {   3,    6,    7}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][3] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {   4,    5,    8}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][5] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {   4,    5,    6,    7,   13,   14,   15,   16}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][7] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][9] = {   8,    9,   12,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][10] = {   9}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");

  c_p[x_a].resize(18);
  c_f[x_a].resize(18);
  c_t[x_a].resize(18);
  c_d[x_a].resize(18);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2}; //   1
  c_t[x_a][1] = {  3,   4}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  1}; //   1
  c_f[x_a][2] = {  3}; //   1
  c_t[x_a][2] = {  3,   5}; //   2
  c_d[x_a][2] = {  1}; //   1

  c_p[x_a][3] = {  0,   2}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  2,   3,   0}; //   3

  c_p[x_a][4] = {  3,   4}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  4,   5,   6}; //   3

  c_p[x_a][5] = {  5,   4}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  4,   5,   6}; //   3

  c_p[x_a][6] = {  3,   6}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  2,   7,   6}; //   3

  c_p[x_a][7] = {  5,   6}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  2,   7,   6}; //   3

  c_p[x_a][8] = {  7,   8}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  4,   8,   9}; //   3

  c_p[x_a][9] = {  0,   9}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 10,   9,   0}; //   3

  c_p[x_a][10] = {  1}; //   1
  c_f[x_a][10] = {  1}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  0,   6}; //   2
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  7}; //   1
  c_f[x_a][12] = {  4}; //   1
  c_t[x_a][12] = {  0,   7}; //   2
  c_d[x_a][12] = {  9}; //   1

  c_p[x_a][13] = {  1,  10}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  8}; //   1
  c_d[x_a][13] = {  6,   1}; //   2

  c_p[x_a][14] = {  1,  11}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  8}; //   1
  c_d[x_a][14] = {  6,   1}; //   2

  c_p[x_a][15] = {  3,  12}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  9}; //   1
  c_d[x_a][15] = {  1,   6}; //   2

  c_p[x_a][16] = {  5,  12}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  9}; //   1
  c_d[x_a][16] = {  1,   6}; //   2

  c_p[x_a][17] = {  7,  13}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 10}; //   1
  c_d[x_a][17] = {  0,   9}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel    1: 2v11(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel    2: 2v11(1, 2, 16, 32, 8, 4;   0,   0,   0)
// channel    3: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    4: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    5: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel    6: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel    7: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
// channel    8: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel    9: 42vv(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   10: 12v1(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel   11: 112v(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   12: 112v(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   13: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   14: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
// channel   15: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   16: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   17: 2v2v(1, 2, 8, 16, 4, 32;   0,   0,   0)
