#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_dxux_wpwmdxux(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_dxux_wpwmdxux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   3,    4,    7,    8,   11,   12,   15,   16}; //   8
  needed_v_smin[x_a][  1] = {   5,   10,   13,   17,    2}; //   5
  needed_v_smin[x_a][  2] = {   6,    9,   14,   17,    0}; //   5
  needed_v_smin[x_a][  3] = {   6}; //   1
  needed_v_smin[x_a][  4] = {   7,    8,    3,    4}; //   4
  needed_v_smin[x_a][  5] = {  11,   12,   15,   16}; //   4
  needed_v_smin[x_a][  6] = {  13,    2,   10}; //   3
  needed_v_smin[x_a][  7] = {   0,    9,   14}; //   3
  needed_v_smin[x_a][  8] = {   1}; //   1
  needed_v_smin[x_a][  9] = {   1}; //   1
  needed_v_smin[x_a][ 10] = {   5}; //   1

  v_smax[x_a].resize(9);
  needed_v_smax[x_a].resize(9);
  needed_v_smax[x_a][  0] = {   3,    4,    7,    8,   11,   12,   15,   16}; //   8
  needed_v_smax[x_a][  1] = {   5,   10,   13,    2}; //   4
  needed_v_smax[x_a][  2] = {   6,    9,   14,   17,    0}; //   5
  needed_v_smax[x_a][  3] = {   6,    7,    8,    3,    4}; //   5
  needed_v_smax[x_a][  4] = {  11,   12,   13,    2,   10,   15,   16}; //   7
  needed_v_smax[x_a][  5] = {  17}; //   1
  needed_v_smax[x_a][  6] = {   0,    1,    9,   14}; //   4
  needed_v_smax[x_a][  7] = {   1}; //   1
  needed_v_smax[x_a][  8] = {   5}; //   1

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   3,    7,   11,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   4,    8,   12,   16}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   5,   10,   13}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   6,    9,   14,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   7,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][6] = {  11,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][8] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax5");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   0,    9,   14}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax6");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax7");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax6");
  needed_g_f[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][5] = {   2,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][6] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax3");
  needed_g_f[x_a][7] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][8] = {  15,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");

  g_t[x_a].resize(15);
  needed_g_t[x_a].resize(15);
  needed_g_t[x_a][0] = {   0,    1,    9,   14}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__32_16");
  needed_g_t[x_a][5] = {   2,   10,   11,   12,   13,   15,   16}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][8] = {   3,    4,    6,    7,    8}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][9] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__36_16");
  needed_g_t[x_a][12] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__24_32");
  needed_g_t[x_a][13] = {  15,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][14] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_24");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   3,    4,    7,    8,   11,   12,   15,   16}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   5,   10,   13,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][2] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][3] = {   6,    9,   14,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   7,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {  11,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {  13}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");

  c_p[x_a].resize(18);
  c_f[x_a].resize(18);
  c_t[x_a].resize(18);
  c_d[x_a].resize(18);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  6}; //   1
  c_t[x_a][3] = {  8,   9}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  1}; //   1
  c_f[x_a][4] = {  6}; //   1
  c_t[x_a][4] = {  8,   9}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  2}; //   1
  c_f[x_a][5] = {  7}; //   1
  c_t[x_a][5] = { 10,  11}; //   2
  c_d[x_a][5] = {  1}; //   1

  c_p[x_a][6] = {  3,   4}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  8}; //   1
  c_d[x_a][6] = {  2,   3}; //   2

  c_p[x_a][7] = {  0,   5}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  8}; //   1
  c_d[x_a][7] = {  4,   0}; //   2

  c_p[x_a][8] = {  1,   5}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  8}; //   1
  c_d[x_a][8] = {  4,   0}; //   2

  c_p[x_a][9] = {  3}; //   1
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = {  3}; //   1

  c_p[x_a][10] = {  2}; //   1
  c_f[x_a][10] = {  5}; //   1
  c_t[x_a][10] = {  5,   6}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  0,   6}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  5}; //   1
  c_d[x_a][11] = {  5,   0}; //   2

  c_p[x_a][12] = {  1,   6}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  5}; //   1
  c_d[x_a][12] = {  5,   0}; //   2

  c_p[x_a][13] = {  2,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  5}; //   1
  c_d[x_a][13] = {  6,   1}; //   2

  c_p[x_a][14] = {  3}; //   1
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = {  0,  12}; //   2
  c_d[x_a][14] = {  3}; //   1

  c_p[x_a][15] = {  0}; //   1
  c_f[x_a][15] = {  8}; //   1
  c_t[x_a][15] = {  5,  13}; //   2
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  1}; //   1
  c_f[x_a][16] = {  8}; //   1
  c_t[x_a][16] = {  5,  13}; //   2
  c_d[x_a][16] = {  0}; //   1

  c_p[x_a][17] = {  3,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 14}; //   1
  c_d[x_a][17] = {  1,   3}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    1: 1111(1, 2, 4, 32, 16, 8;   0,   0,   0)
// channel    2: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    3: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    4: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
// channel    5: 2v11(1, 2, 4, 32, 16, 8;   0,   0,   0)
// channel    6: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    7: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel    8: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel    9: 12v1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   10: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   11: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   12: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   13: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   14: 112v(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   15: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   16: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   17: 2v2v(1, 2, 4, 32, 8, 16;   0,   0,   0)
