#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_gg_wpwmddx(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_gg_wpwmddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(7);
  needed_v_smin[x_a].resize(7);
  needed_v_smin[x_a][  0] = {   2,    9,   15,   16,   26,   28,   29,   30}; //   8
  needed_v_smin[x_a][  1] = {   3,    4,   10,   16,   21,   27,   29,   30}; //   8
  needed_v_smin[x_a][  2] = {   4,   10,   21,    3,   27}; //   5
  needed_v_smin[x_a][  3] = {   5,    6,    7,    8,   11,   12,   13,   14,   17,   18,   19,   20,   22,   23,   24,   25,    0,    1}; //  18
  needed_v_smin[x_a][  4] = {   5,    6,   11,   12,   22,   23,    0,   19,   20}; //   9
  needed_v_smin[x_a][  5] = {   7,    8,   13,   14,   24,   25,    1,   17,   18}; //   9
  needed_v_smin[x_a][  6] = {   9,   15,   26,    2,   28}; //   5

  v_smax[x_a].resize(7);
  needed_v_smax[x_a].resize(7);
  needed_v_smax[x_a][  0] = {   2,    9,   15,   26,   28,   30}; //   6
  needed_v_smax[x_a][  1] = {   3,    4,   10,   16,   21,   27,   29}; //   7
  needed_v_smax[x_a][  2] = {   4,    5,    6,   10,   11,   12,   21,   22,   23,    0,    3,   19,   20,   27}; //  14
  needed_v_smax[x_a][  3] = {   5,    6,    7,    8,   11,   12,   13,   14,   17,   18,   19,   20,   22,   23,   24,   25,    0,    1}; //  18
  needed_v_smax[x_a][  4] = {   7,    8,    9,   13,   14,   15,   24,   25,   26,    1,    2,   17,   18,   28}; //  14
  needed_v_smax[x_a][  5] = {  16,   29}; //   2
  needed_v_smax[x_a][  6] = {  30}; //   1

  g_p[x_a].resize(10);
  needed_g_p[x_a].resize(10);
  needed_g_p[x_a][0] = {   2,    9,   15,   26,   28,   30}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    4,   10,   16,   21,   27,   29}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   4,   10,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   5,    7,   11,   13,   17,   19,   22,   24}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   5,    6,   11,   12,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][5] = {   6,    8,   12,   14,   18,   20,   23,   25}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][6] = {   7,    8,   13,   14,   24,   25}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   9,   15,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][8] = {  16,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax5");
  needed_g_p[x_a][9] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax6");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {   0,   19,   20}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");
  needed_g_f[x_a][2] = {   1,   17,   18}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][3] = {   2,   28}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][4] = {   3,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,   19,   20,   21,   22,   23,   27}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][1] = {   0,   19,   20}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__4_8");
  needed_g_t[x_a][3] = {   1,   17,   18,   24,   25,   26,   28}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][4] = {   1,   17,   18}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__8_4");
  needed_g_t[x_a][6] = {   2,    7,    8,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__20_8");
  needed_g_t[x_a][8] = {   3,    4,    5,    6}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__40_4");
  needed_g_t[x_a][10] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__40_4");
  needed_g_t[x_a][11] = {  28}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__20_8");
  needed_g_t[x_a][12] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][13] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   2,    9,   15,   16,   26,   28,   29,   30}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][1] = {   3,    4,   10,   16,   21,   27,   29,   30}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][2] = {   4,   10,   21}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][3] = {   5,    6,   11,   12,   22,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {   5,    6,    7,    8,   11,   12,   13,   14,   17,   18,   19,   20,   22,   23,   24,   25}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][5] = {   7,    8,   13,   14,   24,   25}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][6] = {   9,   15,   26}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][7] = {  10,   11,   12}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  13,   14,   15}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  16}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(31);
  c_f[x_a].resize(31);
  c_t[x_a].resize(31);
  c_d[x_a].resize(31);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   2}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  3}; //   1
  c_t[x_a][2] = {  6,   7}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  4}; //   1
  c_t[x_a][3] = {  8,   9}; //   2
  c_d[x_a][3] = {  1}; //   1

  c_p[x_a][4] = {  1,   2}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  8}; //   1
  c_d[x_a][4] = {  2,   1}; //   2

  c_p[x_a][5] = {  3,   4}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  8}; //   1
  c_d[x_a][5] = {  3,   4}; //   2

  c_p[x_a][6] = {  5,   4}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  8}; //   1
  c_d[x_a][6] = {  3,   4}; //   2

  c_p[x_a][7] = {  3,   6}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  6}; //   1
  c_d[x_a][7] = {  5,   4}; //   2

  c_p[x_a][8] = {  5,   6}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  6}; //   1
  c_d[x_a][8] = {  5,   4}; //   2

  c_p[x_a][9] = {  0,   7}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  6}; //   1
  c_d[x_a][9] = {  6,   0}; //   2

  c_p[x_a][10] = {  1,   2}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  7,   2,   1}; //   3

  c_p[x_a][11] = {  3,   4}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  7,   3,   4}; //   3

  c_p[x_a][12] = {  5,   4}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  7,   3,   4}; //   3

  c_p[x_a][13] = {  3,   6}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  8,   5,   4}; //   3

  c_p[x_a][14] = {  5,   6}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  8,   5,   4}; //   3

  c_p[x_a][15] = {  0,   7}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  8,   6,   0}; //   3

  c_p[x_a][16] = {  1,   8}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  9,   0,   1}; //   3

  c_p[x_a][17] = {  3}; //   1
  c_f[x_a][17] = {  2}; //   1
  c_t[x_a][17] = {  3,   4}; //   2
  c_d[x_a][17] = {  4}; //   1

  c_p[x_a][18] = {  5}; //   1
  c_f[x_a][18] = {  2}; //   1
  c_t[x_a][18] = {  3,   4}; //   2
  c_d[x_a][18] = {  4}; //   1

  c_p[x_a][19] = {  3}; //   1
  c_f[x_a][19] = {  1}; //   1
  c_t[x_a][19] = {  0,   1}; //   2
  c_d[x_a][19] = {  4}; //   1

  c_p[x_a][20] = {  5}; //   1
  c_f[x_a][20] = {  1}; //   1
  c_t[x_a][20] = {  0,   1}; //   2
  c_d[x_a][20] = {  4}; //   1

  c_p[x_a][21] = {  1,   2}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = {  2,   1}; //   2

  c_p[x_a][22] = {  3,   4}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = {  3,   4}; //   2

  c_p[x_a][23] = {  5,   4}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = {  3,   4}; //   2

  c_p[x_a][24] = {  3,   6}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  3}; //   1
  c_d[x_a][24] = {  5,   4}; //   2

  c_p[x_a][25] = {  5,   6}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  3}; //   1
  c_d[x_a][25] = {  5,   4}; //   2

  c_p[x_a][26] = {  0,   7}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  3}; //   1
  c_d[x_a][26] = {  6,   0}; //   2

  c_p[x_a][27] = {  1}; //   1
  c_f[x_a][27] = {  4}; //   1
  c_t[x_a][27] = {  0,  10}; //   2
  c_d[x_a][27] = {  1}; //   1

  c_p[x_a][28] = {  0}; //   1
  c_f[x_a][28] = {  3}; //   1
  c_t[x_a][28] = {  3,  11}; //   2
  c_d[x_a][28] = {  0}; //   1

  c_p[x_a][29] = {  1,   8}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 12}; //   1
  c_d[x_a][29] = {  0,   1}; //   2

  c_p[x_a][30] = {  0,   9}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = { 13}; //   1
  c_d[x_a][30] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel    1: 1111(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel    2: 2v11(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel    3: 2v11(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel    4: 3yv1(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel    5: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    6: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel    7: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel    8: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel    9: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   10: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   11: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   12: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   13: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel   14: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
// channel   15: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel   16: 42vv(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   17: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel   18: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel   19: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   20: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel   21: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   22: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   23: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   24: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel   25: 13yv(1, 2, 32, 16, 4, 8;  23,   0,   0)
// channel   26: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel   27: 112v(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   28: 112v(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel   29: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   30: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   0)
