#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_030_ba_wpwmb(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_030_ba_wpwmb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(2);
  needed_v_smin[x_a].resize(2);
  needed_v_smin[x_a][  0] = {   8,    9,   10,   12,   13,   14,    0,    1,    2,    5,    6,    7}; //  12
  needed_v_smin[x_a][  1] = {  11,   15,   16,    3,    4}; //   5

  v_smax[x_a].resize(2);
  needed_v_smax[x_a].resize(2);
  needed_v_smax[x_a][  0] = {   8,    9,   10,   12,   13,   14,    0,    1,    2,    5,    6,    7}; //  12
  needed_v_smax[x_a][  1] = {  11,   15,   16,    3,    4}; //   5

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   8,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   9,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {  10,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin0_smax0");
  needed_g_p[x_a][3] = {  11,   15,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin1_smax1");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1,    2,    5,    6,    7}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][1] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][1] = {   0,    1,    2}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_17__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_17__8_4");
  needed_g_t[x_a][2] = {   1,    6}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_2__16_12");
  needed_g_t[x_a][3] = {   2,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_25__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_25__1_2__16_12");
  needed_g_t[x_a][4] = {   3,    4,   16}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_20");
  needed_g_t[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_9__16_4");
  needed_g_t[x_a][6] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_9__4_16");
  needed_g_t[x_a][7] = {   5,    6,    7}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_17__4_8");
  needed_g_t[x_a][8] = {   8,    9,   10}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__16_12");
  needed_g_t[x_a][9] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__8_20");

  g_d[x_a].resize(4);
  needed_g_d[x_a].resize(4);
  needed_g_d[x_a][0] = {   8,    9,   10,   12,   13,   14}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  11,   15,   16}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][2] = {  12,   13,   14}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {  15}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");

  c_p[x_a].resize(17);
  c_f[x_a].resize(17);
  c_t[x_a].resize(17);
  c_d[x_a].resize(17);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  2,   1}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  3,   1}; //   2
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  4,   5}; //   2
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  1}; //   1
  c_t[x_a][4] = {  4,   6}; //   2
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   7}; //   2
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  2,   7}; //   2
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  3,   7}; //   2
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  8}; //   1
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  1}; //   1
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  8}; //   1
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  2}; //   1
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  8}; //   1
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  3}; //   1
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  9}; //   1
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  2,   0}; //   2

  c_p[x_a][13] = {  1}; //   1
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  2,   0}; //   2

  c_p[x_a][14] = {  2}; //   1
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  2,   0}; //   2

  c_p[x_a][15] = {  3}; //   1
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  3,   1}; //   2

  c_p[x_a][16] = {  3}; //   1
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  4}; //   1
  c_d[x_a][16] = {  1}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 111(1, 2, 16, 4, 8;   0,  24)
// channel    1: 111(1, 2, 16, 4, 8;  23,  24)
// channel    2: 111(1, 2, 16, 4, 8;  25,  24)
// channel    3: 111(1, 2, 8, 4, 16;   6,   5)
// channel    4: 111(1, 2, 8, 16, 4;   6,  24)
// channel    5: 111(1, 2, 16, 8, 4;   0,  24)
// channel    6: 111(1, 2, 16, 8, 4;  23,  24)
// channel    7: 111(1, 2, 16, 8, 4;  25,  24)
// channel    8: 2v1(1, 2, 4, 8, 16;   0,   5)
// channel    9: 2v1(1, 2, 4, 8, 16;  23,   5)
// channel   10: 2v1(1, 2, 4, 8, 16;  25,   5)
// channel   11: 2v1(1, 2, 4, 16, 8;   6,  24)
// channel   12: 3yv(1, 2, 16, 4, 8;   0,   5)
// channel   13: 3yv(1, 2, 16, 4, 8;  23,   5)
// channel   14: 3yv(1, 2, 16, 4, 8;  25,   5)
// channel   15: 3yv(1, 2, 8, 4, 16;   6,   5)
// channel   16: 12v(1, 2, 8, 4, 16;   6,   6)
