#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_320_gg_wpwmg(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_320_gg_wpwmg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  int needed_v_smin_0[] = {  30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,    9,   10,   11,   12,   13,   14,   24,   25,   26,   27,   28,   29}; //  63
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 63);
  int needed_v_smin_1[] = {  47,   48,   49,   76,   77,   78,   79,   80,   81,  102,  103,  104,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  21
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 21);
  int needed_v_smin_2[] = {  50,   51,   52,   53,   54,   55,   56,   57,   58,   82,   83,   84,    0,    1,    2,    3,    4,    5,    6,    7,    8}; //  21
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 21);

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  int needed_v_smax_0[] = {  30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,    9,   10,   11,   12,   13,   14,   24,   25,   26,   27,   28,   29}; //  63
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 63);
  int needed_v_smax_1[] = {  47,   48,   49,   76,   77,   78,   79,   80,   81,  102,  103,  104,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  21
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 21);
  int needed_v_smax_2[] = {  50,   51,   52,   53,   54,   55,   56,   57,   58,   82,   83,   84,    0,    1,    2,    3,    4,    5,    6,    7,    8}; //  21
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 21);

  g_p[x_a].resize(11);
  needed_g_p[x_a].resize(11);
  needed_g_p[x_a][0] = {  30,   31,   32,   33,   41,   42,   59,   60,   61,   62,   70,   71,   85,   86,   87,   88,   96,   97}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  34,   35,   36,   37,   63,   64,   65,   66,   89,   90,   91,   92}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {  38,   39,   40,   67,   68,   69,   93,   94,   95}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin0_smax0");
  needed_g_p[x_a][3] = {  43,   44,   72,   73,   98,   99}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin0_smax0");
  needed_g_p[x_a][4] = {  45,   46,   74,   75,  100,  101}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin0_smax0");
  needed_g_p[x_a][5] = {  47,   76,   77,  102}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][6] = {  48,   78,   79,  103}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin1_smax1");
  needed_g_p[x_a][7] = {  49,   80,   81,  104}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin1_smax1");
  needed_g_p[x_a][8] = {  50,   53,   54,   82}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][9] = {  51,   55,   56,   83}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin2_smax2");
  needed_g_p[x_a][10] = {  52,   57,   58,   84}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin2_smax2");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   9,   10,   11,   12,   13,   14,   24,   25,   26,   27,   28,   29}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][2] = {  15,   16,   17,   18,   19,   20,   21,   22,   23}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(36);
  needed_g_t[x_a].resize(36);
  needed_g_t[x_a][0] = {   0,    1,    6,   82}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_24");
  needed_g_t[x_a][1] = {   0,    1,    2,    4}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_8");
  needed_g_t[x_a][2] = {   2,    3,    7,   83}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__4_24");
  needed_g_t[x_a][3] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_5__16_8");
  needed_g_t[x_a][4] = {   4,    5,    8,   84}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__4_24");
  needed_g_t[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__2_5__16_8");
  needed_g_t[x_a][6] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_16");
  needed_g_t[x_a][7] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__2_5__8_16");
  needed_g_t[x_a][8] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_5__8_16");
  needed_g_t[x_a][9] = {   9,   10,   11,   12,   24,   25,   26,   27,   85,   86,   89,   90,   93,   96,   97,   98,  100}; //  17
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][10] = {   9,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_4");
  needed_g_t[x_a][11] = {  10,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__8_4");
  needed_g_t[x_a][12] = {  11,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__2_17__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__2_17__8_4");
  needed_g_t[x_a][13] = {  13,   29,   88,   92,   95,  101}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_12");
  needed_g_t[x_a][14] = {  14,   28,   87,   91,   94,   99}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__16_12");
  needed_g_t[x_a][15] = {  15,   16,   21,  102}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_20");
  needed_g_t[x_a][16] = {  15,   16,   17,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_4");
  needed_g_t[x_a][17] = {  17,   18,   22,  103}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__8_20");
  needed_g_t[x_a][18] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__2_9__16_4");
  needed_g_t[x_a][19] = {  19,   20,   23,  104}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__8_20");
  needed_g_t[x_a][20] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_9__16_4");
  needed_g_t[x_a][21] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_16");
  needed_g_t[x_a][22] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_9__4_16");
  needed_g_t[x_a][23] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__2_9__4_16");
  needed_g_t[x_a][24] = {  24,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_8");
  needed_g_t[x_a][25] = {  25,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__2_17__4_8");
  needed_g_t[x_a][26] = {  26,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__4_8");
  needed_g_t[x_a][27] = {  30,   31,   34,   35,   38,   41,   42,   43,   45}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");
  needed_g_t[x_a][28] = {  32,   36,   39,   44}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__2_1__16_12");
  needed_g_t[x_a][29] = {  33,   37,   40,   46}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__16_12");
  needed_g_t[x_a][30] = {  47}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_20");
  needed_g_t[x_a][31] = {  48}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__8_20");
  needed_g_t[x_a][32] = {  49}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__2_1__8_20");
  needed_g_t[x_a][33] = {  50}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_24");
  needed_g_t[x_a][34] = {  51}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__2_1__4_24");
  needed_g_t[x_a][35] = {  52}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__4_24");

  g_d[x_a].resize(6);
  needed_g_d[x_a].resize(6);
  needed_g_d[x_a][0] = {  30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101}; //  51
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  47,   48,   49,   76,   77,   78,   79,   80,   81,  102,  103,  104}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][2] = {  50,   51,   52,   53,   54,   55,   56,   57,   58,   82,   83,   84}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  53,   54,   55,   56,   57,   58}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {  59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  17
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {  76,   77,   78,   79,   80,   81}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");

  c_p[x_a].resize(105);
  c_f[x_a].resize(105);
  c_t[x_a].resize(105);
  c_d[x_a].resize(105);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  2,   1}; //   2
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  4,   1}; //   2
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  4,   5}; //   2
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   6}; //   2
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  2,   7}; //   2
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  4,   8}; //   2
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  9,  10}; //   2
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {  1}; //   1
  c_t[x_a][10] = {  9,  11}; //   2
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  9,  12}; //   2
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = {  1}; //   1
  c_t[x_a][12] = {  9,  10}; //   2
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = {  1}; //   1
  c_t[x_a][13] = { 13,  12}; //   2
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = { 14,  11}; //   2
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = {  2}; //   1
  c_t[x_a][15] = { 15,  16}; //   2
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {}; //   0
  c_f[x_a][16] = {  2}; //   1
  c_t[x_a][16] = { 15,  16}; //   2
  c_d[x_a][16] = {}; //   0

  c_p[x_a][17] = {}; //   0
  c_f[x_a][17] = {  2}; //   1
  c_t[x_a][17] = { 17,  16}; //   2
  c_d[x_a][17] = {}; //   0

  c_p[x_a][18] = {}; //   0
  c_f[x_a][18] = {  2}; //   1
  c_t[x_a][18] = { 17,  18}; //   2
  c_d[x_a][18] = {}; //   0

  c_p[x_a][19] = {}; //   0
  c_f[x_a][19] = {  2}; //   1
  c_t[x_a][19] = { 19,  16}; //   2
  c_d[x_a][19] = {}; //   0

  c_p[x_a][20] = {}; //   0
  c_f[x_a][20] = {  2}; //   1
  c_t[x_a][20] = { 19,  20}; //   2
  c_d[x_a][20] = {}; //   0

  c_p[x_a][21] = {}; //   0
  c_f[x_a][21] = {  2}; //   1
  c_t[x_a][21] = { 15,  21}; //   2
  c_d[x_a][21] = {}; //   0

  c_p[x_a][22] = {}; //   0
  c_f[x_a][22] = {  2}; //   1
  c_t[x_a][22] = { 17,  22}; //   2
  c_d[x_a][22] = {}; //   0

  c_p[x_a][23] = {}; //   0
  c_f[x_a][23] = {  2}; //   1
  c_t[x_a][23] = { 19,  23}; //   2
  c_d[x_a][23] = {}; //   0

  c_p[x_a][24] = {}; //   0
  c_f[x_a][24] = {  1}; //   1
  c_t[x_a][24] = {  9,  24}; //   2
  c_d[x_a][24] = {}; //   0

  c_p[x_a][25] = {}; //   0
  c_f[x_a][25] = {  1}; //   1
  c_t[x_a][25] = {  9,  25}; //   2
  c_d[x_a][25] = {}; //   0

  c_p[x_a][26] = {}; //   0
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  9,  26}; //   2
  c_d[x_a][26] = {}; //   0

  c_p[x_a][27] = {}; //   0
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  9,  24}; //   2
  c_d[x_a][27] = {}; //   0

  c_p[x_a][28] = {}; //   0
  c_f[x_a][28] = {  1}; //   1
  c_t[x_a][28] = { 14,  26}; //   2
  c_d[x_a][28] = {}; //   0

  c_p[x_a][29] = {}; //   0
  c_f[x_a][29] = {  1}; //   1
  c_t[x_a][29] = { 13,  25}; //   2
  c_d[x_a][29] = {}; //   0

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = { 27}; //   1
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  0}; //   1
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = { 27}; //   1
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  0}; //   1
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = { 28}; //   1
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = {  0}; //   1
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = { 29}; //   1
  c_d[x_a][33] = {  0}; //   1

  c_p[x_a][34] = {  1}; //   1
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 27}; //   1
  c_d[x_a][34] = {  0}; //   1

  c_p[x_a][35] = {  1}; //   1
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = { 27}; //   1
  c_d[x_a][35] = {  0}; //   1

  c_p[x_a][36] = {  1}; //   1
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 28}; //   1
  c_d[x_a][36] = {  0}; //   1

  c_p[x_a][37] = {  1}; //   1
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 29}; //   1
  c_d[x_a][37] = {  0}; //   1

  c_p[x_a][38] = {  2}; //   1
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 27}; //   1
  c_d[x_a][38] = {  0}; //   1

  c_p[x_a][39] = {  2}; //   1
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 28}; //   1
  c_d[x_a][39] = {  0}; //   1

  c_p[x_a][40] = {  2}; //   1
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 29}; //   1
  c_d[x_a][40] = {  0}; //   1

  c_p[x_a][41] = {  0}; //   1
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 27}; //   1
  c_d[x_a][41] = {  0}; //   1

  c_p[x_a][42] = {  0}; //   1
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 27}; //   1
  c_d[x_a][42] = {  0}; //   1

  c_p[x_a][43] = {  3}; //   1
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 27}; //   1
  c_d[x_a][43] = {  0}; //   1

  c_p[x_a][44] = {  3}; //   1
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 28}; //   1
  c_d[x_a][44] = {  0}; //   1

  c_p[x_a][45] = {  4}; //   1
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 27}; //   1
  c_d[x_a][45] = {  0}; //   1

  c_p[x_a][46] = {  4}; //   1
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 29}; //   1
  c_d[x_a][46] = {  0}; //   1

  c_p[x_a][47] = {  5}; //   1
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 30}; //   1
  c_d[x_a][47] = {  1}; //   1

  c_p[x_a][48] = {  6}; //   1
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = { 31}; //   1
  c_d[x_a][48] = {  1}; //   1

  c_p[x_a][49] = {  7}; //   1
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = { 32}; //   1
  c_d[x_a][49] = {  1}; //   1

  c_p[x_a][50] = {  8}; //   1
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = { 33}; //   1
  c_d[x_a][50] = {  2}; //   1

  c_p[x_a][51] = {  9}; //   1
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = { 34}; //   1
  c_d[x_a][51] = {  2}; //   1

  c_p[x_a][52] = { 10}; //   1
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = { 35}; //   1
  c_d[x_a][52] = {  2}; //   1

  c_p[x_a][53] = {  8}; //   1
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {}; //   0
  c_d[x_a][53] = {  3,   2}; //   2

  c_p[x_a][54] = {  8}; //   1
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {}; //   0
  c_d[x_a][54] = {  3,   2}; //   2

  c_p[x_a][55] = {  9}; //   1
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {}; //   0
  c_d[x_a][55] = {  3,   2}; //   2

  c_p[x_a][56] = {  9}; //   1
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {}; //   0
  c_d[x_a][56] = {  3,   2}; //   2

  c_p[x_a][57] = { 10}; //   1
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {}; //   0
  c_d[x_a][57] = {  3,   2}; //   2

  c_p[x_a][58] = { 10}; //   1
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {}; //   0
  c_d[x_a][58] = {  3,   2}; //   2

  c_p[x_a][59] = {  0}; //   1
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {}; //   0
  c_d[x_a][59] = {  4,   0}; //   2

  c_p[x_a][60] = {  0}; //   1
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {}; //   0
  c_d[x_a][60] = {  4,   0}; //   2

  c_p[x_a][61] = {  0}; //   1
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {}; //   0
  c_d[x_a][61] = {  4,   0}; //   2

  c_p[x_a][62] = {  0}; //   1
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {}; //   0
  c_d[x_a][62] = {  4,   0}; //   2

  c_p[x_a][63] = {  1}; //   1
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {}; //   0
  c_d[x_a][63] = {  4,   0}; //   2

  c_p[x_a][64] = {  1}; //   1
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {}; //   0
  c_d[x_a][64] = {  4,   0}; //   2

  c_p[x_a][65] = {  1}; //   1
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {}; //   0
  c_d[x_a][65] = {  4,   0}; //   2

  c_p[x_a][66] = {  1}; //   1
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {}; //   0
  c_d[x_a][66] = {  4,   0}; //   2

  c_p[x_a][67] = {  2}; //   1
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {}; //   0
  c_d[x_a][67] = {  4,   0}; //   2

  c_p[x_a][68] = {  2}; //   1
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {}; //   0
  c_d[x_a][68] = {  4,   0}; //   2

  c_p[x_a][69] = {  2}; //   1
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {}; //   0
  c_d[x_a][69] = {  4,   0}; //   2

  c_p[x_a][70] = {  0}; //   1
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {}; //   0
  c_d[x_a][70] = {  4,   0}; //   2

  c_p[x_a][71] = {  0}; //   1
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {}; //   0
  c_d[x_a][71] = {  4,   0}; //   2

  c_p[x_a][72] = {  3}; //   1
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {}; //   0
  c_d[x_a][72] = {  4,   0}; //   2

  c_p[x_a][73] = {  3}; //   1
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {}; //   0
  c_d[x_a][73] = {  4,   0}; //   2

  c_p[x_a][74] = {  4}; //   1
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {}; //   0
  c_d[x_a][74] = {  4,   0}; //   2

  c_p[x_a][75] = {  4}; //   1
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {}; //   0
  c_d[x_a][75] = {  4,   0}; //   2

  c_p[x_a][76] = {  5}; //   1
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {}; //   0
  c_d[x_a][76] = {  5,   1}; //   2

  c_p[x_a][77] = {  5}; //   1
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {}; //   0
  c_d[x_a][77] = {  5,   1}; //   2

  c_p[x_a][78] = {  6}; //   1
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {}; //   0
  c_d[x_a][78] = {  5,   1}; //   2

  c_p[x_a][79] = {  6}; //   1
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = {}; //   0
  c_d[x_a][79] = {  5,   1}; //   2

  c_p[x_a][80] = {  7}; //   1
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {}; //   0
  c_d[x_a][80] = {  5,   1}; //   2

  c_p[x_a][81] = {  7}; //   1
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {}; //   0
  c_d[x_a][81] = {  5,   1}; //   2

  c_p[x_a][82] = {  8}; //   1
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = {  0}; //   1
  c_d[x_a][82] = {  2}; //   1

  c_p[x_a][83] = {  9}; //   1
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = {  2}; //   1
  c_d[x_a][83] = {  2}; //   1

  c_p[x_a][84] = { 10}; //   1
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = {  4}; //   1
  c_d[x_a][84] = {  2}; //   1

  c_p[x_a][85] = {  0}; //   1
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = {  9}; //   1
  c_d[x_a][85] = {  0}; //   1

  c_p[x_a][86] = {  0}; //   1
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = {  9}; //   1
  c_d[x_a][86] = {  0}; //   1

  c_p[x_a][87] = {  0}; //   1
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = { 14}; //   1
  c_d[x_a][87] = {  0}; //   1

  c_p[x_a][88] = {  0}; //   1
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = { 13}; //   1
  c_d[x_a][88] = {  0}; //   1

  c_p[x_a][89] = {  1}; //   1
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = {  9}; //   1
  c_d[x_a][89] = {  0}; //   1

  c_p[x_a][90] = {  1}; //   1
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = {  9}; //   1
  c_d[x_a][90] = {  0}; //   1

  c_p[x_a][91] = {  1}; //   1
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = { 14}; //   1
  c_d[x_a][91] = {  0}; //   1

  c_p[x_a][92] = {  1}; //   1
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = { 13}; //   1
  c_d[x_a][92] = {  0}; //   1

  c_p[x_a][93] = {  2}; //   1
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = {  9}; //   1
  c_d[x_a][93] = {  0}; //   1

  c_p[x_a][94] = {  2}; //   1
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = { 14}; //   1
  c_d[x_a][94] = {  0}; //   1

  c_p[x_a][95] = {  2}; //   1
  c_f[x_a][95] = {}; //   0
  c_t[x_a][95] = { 13}; //   1
  c_d[x_a][95] = {  0}; //   1

  c_p[x_a][96] = {  0}; //   1
  c_f[x_a][96] = {}; //   0
  c_t[x_a][96] = {  9}; //   1
  c_d[x_a][96] = {  0}; //   1

  c_p[x_a][97] = {  0}; //   1
  c_f[x_a][97] = {}; //   0
  c_t[x_a][97] = {  9}; //   1
  c_d[x_a][97] = {  0}; //   1

  c_p[x_a][98] = {  3}; //   1
  c_f[x_a][98] = {}; //   0
  c_t[x_a][98] = {  9}; //   1
  c_d[x_a][98] = {  0}; //   1

  c_p[x_a][99] = {  3}; //   1
  c_f[x_a][99] = {}; //   0
  c_t[x_a][99] = { 14}; //   1
  c_d[x_a][99] = {  0}; //   1

  c_p[x_a][100] = {  4}; //   1
  c_f[x_a][100] = {}; //   0
  c_t[x_a][100] = {  9}; //   1
  c_d[x_a][100] = {  0}; //   1

  c_p[x_a][101] = {  4}; //   1
  c_f[x_a][101] = {}; //   0
  c_t[x_a][101] = { 13}; //   1
  c_d[x_a][101] = {  0}; //   1

  c_p[x_a][102] = {  5}; //   1
  c_f[x_a][102] = {}; //   0
  c_t[x_a][102] = { 15}; //   1
  c_d[x_a][102] = {  1}; //   1

  c_p[x_a][103] = {  6}; //   1
  c_f[x_a][103] = {}; //   0
  c_t[x_a][103] = { 17}; //   1
  c_d[x_a][103] = {  1}; //   1

  c_p[x_a][104] = {  7}; //   1
  c_f[x_a][104] = {}; //   0
  c_t[x_a][104] = { 19}; //   1
  c_d[x_a][104] = {  1}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
