#include "header.hpp"

#include "ppzz02.phasespace.set.hpp"

void ppzz02_phasespace_set::ax_psp_220_bb_zzbb(int x_a){
  static Logger logger("ppzz02_phasespace_set::ax_psp_220_bb_zzbb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(15);
  needed_v_smin[x_a].resize(15);
  needed_v_smin[x_a][  0] = {  12,   18,   22,   24,   30,   34,   37,   38,    5,    6}; //  10
  needed_v_smin[x_a][  1] = {  13,   19,   23,   25,   31,   35,   36,   39,    4,    7}; //  10
  needed_v_smin[x_a][  2] = {  14,   16,   20,   26,   28,   32,   36,   39,    0,   11}; //  10
  needed_v_smin[x_a][  3] = {  15,   17,   21,   27,   29,   33,   37,   38,    1,   10}; //  10
  needed_v_smin[x_a][  4] = {  16,   28,   11,   26}; //   4
  needed_v_smin[x_a][  5] = {  17,   29,   10,   27}; //   4
  needed_v_smin[x_a][  6] = {  18,   30,    5,   22}; //   4
  needed_v_smin[x_a][  7] = {  19,   31,    4,   23}; //   4
  needed_v_smin[x_a][  8] = {   0,   14,   20,   32}; //   4
  needed_v_smin[x_a][  9] = {   1,   15,   21,   33}; //   4
  needed_v_smin[x_a][ 10] = {   2,    3,    8,    9}; //   4
  needed_v_smin[x_a][ 11] = {   2,    3}; //   2
  needed_v_smin[x_a][ 12] = {   6,   12,   24,   34}; //   4
  needed_v_smin[x_a][ 13] = {   7,   13,   25,   35}; //   4
  needed_v_smin[x_a][ 14] = {   8,    9}; //   2

  v_smax[x_a].resize(13);
  needed_v_smax[x_a].resize(13);
  needed_v_smax[x_a][  0] = {  12,   18,   22,   24,   30,   34,   38,    5,    6}; //   9
  needed_v_smax[x_a][  1] = {  13,   19,   23,   25,   31,   35,   39,    4,    7}; //   9
  needed_v_smax[x_a][  2] = {  14,   16,   20,   26,   28,   32,   36,    0,   11}; //   9
  needed_v_smax[x_a][  3] = {  15,   17,   21,   27,   29,   33,   37,    1,   10}; //   9
  needed_v_smax[x_a][  4] = {  16,   18,   28,   30,    5,   11,   22,   26}; //   8
  needed_v_smax[x_a][  5] = {  17,   19,   29,   31,    4,   10,   23,   27}; //   8
  needed_v_smax[x_a][  6] = {  36}; //   1
  needed_v_smax[x_a][  7] = {  37}; //   1
  needed_v_smax[x_a][  8] = {  38}; //   1
  needed_v_smax[x_a][  9] = {  39}; //   1
  needed_v_smax[x_a][ 10] = {   0,    1,    2,    3,   14,   15,   20,   21,   32,   33}; //  10
  needed_v_smax[x_a][ 11] = {   2,    3,    8,    9}; //   4
  needed_v_smax[x_a][ 12] = {   6,    7,    8,    9,   12,   13,   24,   25,   34,   35}; //  10

  g_p[x_a].resize(12);
  needed_g_p[x_a].resize(12);
  needed_g_p[x_a][0] = {  12,   18,   22,   24,   30,   34,   38}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  13,   19,   23,   25,   31,   35,   39}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {  14,   16,   20,   26,   28,   32,   36}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {  15,   17,   21,   27,   29,   33,   37}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  16,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {  17,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {  18,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][7] = {  19,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  36}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax6");
  needed_g_p[x_a][9] = {  37}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax7");
  needed_g_p[x_a][10] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax8");
  needed_g_p[x_a][11] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax9");

  g_f[x_a].resize(15);
  needed_g_f[x_a].resize(15);
  needed_g_f[x_a][0] = {   0,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   0,   14,   20,   32}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax10");
  needed_g_f[x_a][2] = {   1,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][3] = {   1,   15,   21,   33}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax10");
  needed_g_f[x_a][4] = {   2,    3,    8,    9}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax11");
  needed_g_f[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax10");
  needed_g_f[x_a][6] = {   4,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {   4,   23}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][8] = {   5,    6}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][9] = {   5,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][10] = {   6,   12,   24,   34}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax12");
  needed_g_f[x_a][11] = {   7,   13,   25,   35}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax12");
  needed_g_f[x_a][12] = {   8,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax12");
  needed_g_f[x_a][13] = {  10,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][14] = {  11,   26}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");

  g_t[x_a].resize(42);
  needed_g_t[x_a].resize(42);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,   20,   21,   32,   33}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_32");
  needed_g_t[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__32_16");
  needed_g_t[x_a][8] = {   4,   10,   23,   27,   29,   31}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][9] = {   4,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][11] = {   5,   11,   22,   26,   28,   30}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][12] = {   5,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][13] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_4");
  needed_g_t[x_a][14] = {   6,    7,    8,    9,   24,   25,   34,   35}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][15] = {   6,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][16] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][17] = {   7,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][18] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_32");
  needed_g_t[x_a][19] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][20] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_32");
  needed_g_t[x_a][21] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__32_16");
  needed_g_t[x_a][22] = {  10,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][23] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][24] = {  11,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_24");
  needed_g_t[x_a][25] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__16_8");
  needed_g_t[x_a][26] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][27] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__20_32");
  needed_g_t[x_a][28] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__36_16");
  needed_g_t[x_a][29] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][30] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__24_32");
  needed_g_t[x_a][31] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__40_16");
  needed_g_t[x_a][32] = {  16,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][33] = {  17,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][34] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__24_32");
  needed_g_t[x_a][35] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__40_16");
  needed_g_t[x_a][36] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__20_32");
  needed_g_t[x_a][37] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__36_16");
  needed_g_t[x_a][38] = {  36}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_24");
  needed_g_t[x_a][39] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][40] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");
  needed_g_t[x_a][41] = {  39}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(8);
  needed_g_d[x_a].resize(8);
  needed_g_d[x_a][0] = {  12,   18,   22,   24,   30,   34,   37,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][1] = {  13,   19,   23,   25,   31,   35,   36,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][2] = {  14,   16,   20,   26,   28,   32,   36,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  15,   17,   21,   27,   29,   33,   37,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {  16,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {  17,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][6] = {  18,   30}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][7] = {  19,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");

  c_p[x_a].resize(40);
  c_f[x_a].resize(40);
  c_t[x_a].resize(40);
  c_d[x_a].resize(40);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  0,   5,   6}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  4,   5}; //   2
  c_t[x_a][3] = {  0,   5,   7}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  6,   7}; //   2
  c_t[x_a][4] = {  8,   9,  10}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  8,   9}; //   2
  c_t[x_a][5] = { 11,  12,  13}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  8,  10}; //   2
  c_t[x_a][6] = { 14,  15,  16}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  6,  11}; //   2
  c_t[x_a][7] = { 14,  17,  18}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  4,  12}; //   2
  c_t[x_a][8] = { 14,  19,  20}; //   3
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = {  4,  12}; //   2
  c_t[x_a][9] = { 14,  19,  21}; //   3
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {  2,  13}; //   2
  c_t[x_a][10] = {  8,  22,  23}; //   3
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  0,  14}; //   2
  c_t[x_a][11] = { 11,  24,  25}; //   3
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = { 10}; //   1
  c_t[x_a][12] = { 26,  27}; //   2
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  1}; //   1
  c_f[x_a][13] = { 11}; //   1
  c_t[x_a][13] = { 26,  28}; //   2
  c_d[x_a][13] = {  1}; //   1

  c_p[x_a][14] = {  2}; //   1
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = { 29,  30}; //   2
  c_d[x_a][14] = {  2}; //   1

  c_p[x_a][15] = {  3}; //   1
  c_f[x_a][15] = {  3}; //   1
  c_t[x_a][15] = { 29,  31}; //   2
  c_d[x_a][15] = {  3}; //   1

  c_p[x_a][16] = {  2,   4}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 32}; //   1
  c_d[x_a][16] = {  4,   2}; //   2

  c_p[x_a][17] = {  3,   5}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 33}; //   1
  c_d[x_a][17] = {  5,   3}; //   2

  c_p[x_a][18] = {  0,   6}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 32}; //   1
  c_d[x_a][18] = {  6,   0}; //   2

  c_p[x_a][19] = {  1,   7}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 33}; //   1
  c_d[x_a][19] = {  7,   1}; //   2

  c_p[x_a][20] = {  2}; //   1
  c_f[x_a][20] = {  1}; //   1
  c_t[x_a][20] = {  0,   1}; //   2
  c_d[x_a][20] = {  2}; //   1

  c_p[x_a][21] = {  3}; //   1
  c_f[x_a][21] = {  3}; //   1
  c_t[x_a][21] = {  0,   3}; //   2
  c_d[x_a][21] = {  3}; //   1

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = {  9}; //   1
  c_t[x_a][22] = { 11,  12}; //   2
  c_d[x_a][22] = {  0}; //   1

  c_p[x_a][23] = {  1}; //   1
  c_f[x_a][23] = {  7}; //   1
  c_t[x_a][23] = {  8,   9}; //   2
  c_d[x_a][23] = {  1}; //   1

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = { 10}; //   1
  c_t[x_a][24] = { 14,  15}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  1}; //   1
  c_f[x_a][25] = { 11}; //   1
  c_t[x_a][25] = { 14,  17}; //   2
  c_d[x_a][25] = {  1}; //   1

  c_p[x_a][26] = {  2}; //   1
  c_f[x_a][26] = { 14}; //   1
  c_t[x_a][26] = { 11,  24}; //   2
  c_d[x_a][26] = {  2}; //   1

  c_p[x_a][27] = {  3}; //   1
  c_f[x_a][27] = { 13}; //   1
  c_t[x_a][27] = {  8,  22}; //   2
  c_d[x_a][27] = {  3}; //   1

  c_p[x_a][28] = {  2,   4}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 11}; //   1
  c_d[x_a][28] = {  4,   2}; //   2

  c_p[x_a][29] = {  3,   5}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  8}; //   1
  c_d[x_a][29] = {  5,   3}; //   2

  c_p[x_a][30] = {  0,   6}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = { 11}; //   1
  c_d[x_a][30] = {  6,   0}; //   2

  c_p[x_a][31] = {  1,   7}; //   2
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  8}; //   1
  c_d[x_a][31] = {  7,   1}; //   2

  c_p[x_a][32] = {  2}; //   1
  c_f[x_a][32] = {  1}; //   1
  c_t[x_a][32] = {  0,  34}; //   2
  c_d[x_a][32] = {  2}; //   1

  c_p[x_a][33] = {  3}; //   1
  c_f[x_a][33] = {  3}; //   1
  c_t[x_a][33] = {  0,  35}; //   2
  c_d[x_a][33] = {  3}; //   1

  c_p[x_a][34] = {  0}; //   1
  c_f[x_a][34] = { 10}; //   1
  c_t[x_a][34] = { 14,  36}; //   2
  c_d[x_a][34] = {  0}; //   1

  c_p[x_a][35] = {  1}; //   1
  c_f[x_a][35] = { 11}; //   1
  c_t[x_a][35] = { 14,  37}; //   2
  c_d[x_a][35] = {  1}; //   1

  c_p[x_a][36] = {  2,   8}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 38}; //   1
  c_d[x_a][36] = {  1,   2}; //   2

  c_p[x_a][37] = {  3,   9}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 39}; //   1
  c_d[x_a][37] = {  0,   3}; //   2

  c_p[x_a][38] = {  0,  10}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 40}; //   1
  c_d[x_a][38] = {  3,   0}; //   2

  c_p[x_a][39] = {  1,  11}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 41}; //   1
  c_d[x_a][39] = {  2,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    1: 1111(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel    2: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel    3: 1111(1, 2, 4, 32, 16, 8;   0,   0,   0)
// channel    4: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    5: 1111(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel    6: 1111(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel    7: 1111(1, 2, 8, 4, 32, 16;   0,   0,   0)
// channel    8: 1111(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel    9: 1111(1, 2, 8, 32, 16, 4;   0,   0,   0)
// channel   10: 1111(1, 2, 16, 32, 8, 4;   0,   0,   0)
// channel   11: 1111(1, 2, 32, 16, 8, 4;   0,   0,   0)
// channel   12: 2v11(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel   13: 2v11(1, 2, 4, 32, 16, 8;   0,   0,   0)
// channel   14: 2v11(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel   15: 2v11(1, 2, 8, 32, 16, 4;   0,   0,   0)
// channel   16: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   17: 3yv1(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel   18: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   19: 3yv1(1, 2, 8, 4, 32, 16;   0,   0,   0)
// channel   20: 12v1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   21: 12v1(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel   22: 12v1(1, 2, 32, 4, 16, 8;   0,   0,   0)
// channel   23: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   24: 12v1(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   25: 12v1(1, 2, 8, 4, 32, 16;   0,   0,   0)
// channel   26: 12v1(1, 2, 32, 8, 16, 4;   0,   0,   0)
// channel   27: 12v1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel   28: 13yv(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel   29: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   30: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel   31: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   32: 112v(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   33: 112v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   34: 112v(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   35: 112v(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   36: 2v2v(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   37: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   38: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   39: 2v2v(1, 2, 8, 16, 4, 32;   0,   0,   0)
