#include "header.hpp"

#include "ppzz02.phasespace.set.hpp"

void ppzz02_phasespace_set::ax_psp_220_dxsx_zzdxsx(int x_a){
  static Logger logger("ppzz02_phasespace_set::ax_psp_220_dxsx_zzdxsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(15);
  needed_v_smin[x_a].resize(15);
  needed_v_smin[x_a][  0] = {   6,    9,   12,   18,    3}; //   5
  needed_v_smin[x_a][  1] = {   7,    8,   10,   19,    0}; //   5
  needed_v_smin[x_a][  2] = {   8}; //   1
  needed_v_smin[x_a][  3] = {   9}; //   1
  needed_v_smin[x_a][  4] = {  11,   15,   17,   19,    2}; //   5
  needed_v_smin[x_a][  5] = {  13,   14,   16,   18,    5}; //   5
  needed_v_smin[x_a][  6] = {  14,    5,   13}; //   3
  needed_v_smin[x_a][  7] = {  15,    2,   11}; //   3
  needed_v_smin[x_a][  8] = {   0,    7,   10}; //   3
  needed_v_smin[x_a][  9] = {   1,    4}; //   2
  needed_v_smin[x_a][ 10] = {   1}; //   1
  needed_v_smin[x_a][ 11] = {   3,    6,   12}; //   3
  needed_v_smin[x_a][ 12] = {   4}; //   1
  needed_v_smin[x_a][ 13] = {  16}; //   1
  needed_v_smin[x_a][ 14] = {  17}; //   1

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   6,    9,   12,    3}; //   4
  needed_v_smax[x_a][  1] = {   7,    8,   10,    0}; //   4
  needed_v_smax[x_a][  2] = {   8,    9}; //   2
  needed_v_smax[x_a][  3] = {  11,   15,   17,   19,    2}; //   5
  needed_v_smax[x_a][  4] = {  13,   14,   16,   18,    5}; //   5
  needed_v_smax[x_a][  5] = {  14,   15,    2,    5,   11,   13}; //   6
  needed_v_smax[x_a][  6] = {  18}; //   1
  needed_v_smax[x_a][  7] = {  19}; //   1
  needed_v_smax[x_a][  8] = {   0,    1,    7,   10,   16}; //   5
  needed_v_smax[x_a][  9] = {   1,    4}; //   2
  needed_v_smax[x_a][ 10] = {   3,    4,    6,   12,   17}; //   5

  g_p[x_a].resize(10);
  needed_g_p[x_a].resize(10);
  needed_g_p[x_a][0] = {   6,    9,   12}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   7,    8,   10}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax2");
  needed_g_p[x_a][4] = {  11,   15,   17,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][5] = {  13,   14,   16,   18}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][9] = {  19}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax7");

  g_f[x_a].resize(13);
  needed_g_f[x_a].resize(13);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   0,    7,   10}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax8");
  needed_g_f[x_a][2] = {   1,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax9");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax3");
  needed_g_f[x_a][5] = {   2,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][7] = {   3,    6,   12}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax10");
  needed_g_f[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax10");
  needed_g_f[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][10] = {   5,   13}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax5");
  needed_g_f[x_a][11] = {  16}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax8");
  needed_g_f[x_a][12] = {  17}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax10");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    1,   10,   16}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][5] = {   2,    5,   11,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][8] = {   3,    4,   12,   17}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][9] = {   3,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][10] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][11] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][12] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_32");
  needed_g_t[x_a][13] = {   5,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][14] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][15] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][16] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__20_32");
  needed_g_t[x_a][17] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][18] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__24_32");
  needed_g_t[x_a][19] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][20] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__40_16");
  needed_g_t[x_a][21] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__36_16");
  needed_g_t[x_a][22] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][23] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(8);
  needed_g_d[x_a].resize(8);
  needed_g_d[x_a][0] = {   6,    9,   12,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][1] = {   7,    8,   10,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][2] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][3] = {   9}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {  11,   15,   17,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][5] = {  13,   14,   16,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][6] = {  14}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][7] = {  15}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  6,   7}; //   2
  c_t[x_a][3] = {  8,   9,  10}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  2,   8}; //   2
  c_t[x_a][4] = {  8,  11,  12}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  9,  10}; //   2
  c_t[x_a][5] = {  5,  13,  14}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  7}; //   1
  c_t[x_a][6] = { 15,  16}; //   2
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1}; //   1
  c_f[x_a][7] = {  1}; //   1
  c_t[x_a][7] = { 17,  18}; //   2
  c_d[x_a][7] = {  1}; //   1

  c_p[x_a][8] = {  1,   2}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = { 19}; //   1
  c_d[x_a][8] = {  2,   1}; //   2

  c_p[x_a][9] = {  0,   3}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = { 19}; //   1
  c_d[x_a][9] = {  3,   0}; //   2

  c_p[x_a][10] = {  1}; //   1
  c_f[x_a][10] = {  1}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  4}; //   1
  c_f[x_a][11] = {  5}; //   1
  c_t[x_a][11] = {  5,   6}; //   2
  c_d[x_a][11] = {  4}; //   1

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  7}; //   1
  c_t[x_a][12] = {  8,   9}; //   2
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  5}; //   1
  c_f[x_a][13] = { 10}; //   1
  c_t[x_a][13] = {  5,  13}; //   2
  c_d[x_a][13] = {  5}; //   1

  c_p[x_a][14] = {  5,   6}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  5}; //   1
  c_d[x_a][14] = {  6,   5}; //   2

  c_p[x_a][15] = {  4,   7}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  5}; //   1
  c_d[x_a][15] = {  7,   4}; //   2

  c_p[x_a][16] = {  5}; //   1
  c_f[x_a][16] = { 11}; //   1
  c_t[x_a][16] = {  0,  20}; //   2
  c_d[x_a][16] = {  5}; //   1

  c_p[x_a][17] = {  4}; //   1
  c_f[x_a][17] = { 12}; //   1
  c_t[x_a][17] = {  8,  21}; //   2
  c_d[x_a][17] = {  4}; //   1

  c_p[x_a][18] = {  5,   8}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 22}; //   1
  c_d[x_a][18] = {  0,   5}; //   2

  c_p[x_a][19] = {  4,   9}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 23}; //   1
  c_d[x_a][19] = {  1,   4}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    1: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel    2: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    3: 1111(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel    4: 1111(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel    5: 1111(1, 2, 16, 32, 8, 4;   0,   0,   0)
// channel    6: 2v11(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel    7: 2v11(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel    8: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    9: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   10: 12v1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   11: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   12: 12v1(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   13: 12v1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel   14: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   15: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   16: 112v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   17: 112v(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   18: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   19: 2v2v(1, 2, 8, 16, 4, 32;   0,   0,   0)
