#include "header.hpp"

// 2-loop helicity amplitude coefficients for qq_bar -> Wgam/Zgam,
// see T. Gehrmann, L. Tancredi, 1112.1531

#include "pplla03.amplitude.set.hpp"

double_complex pplla03_amplitude_set::beta_2_1() {
  //  const double zeta2 = M_PI * M_PI/6;
  //  const double zeta3 = 1.20205690315959429;
  //  const double zeta4 = pow(M_PI,4)/90;
  //  const double dN_c=3;
  //  const double C_F=(dN_c * dN_c - 1.) / (2 * dN_c);
  //  double NF=(double)n_f;

  double_complex beta =
    (dN_c * dN_c - 1.) * pow(u, -2) * (
				       - 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
				       + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
				       + 1.0/4 * GHPLs2[2*4+2] * zeta2
				       - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
				       + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
				       + 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
				       + 1.0/4 * GHPLs1[2] * zeta3
				       + 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
				       - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
				       + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
				       + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
				       + 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
				       - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
				       + 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
				       - 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
				       + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
				       + 1.0/4 * GHPLs2[2*4+1] * zeta2
				       - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
				       + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
				       + 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
				       + 1.0/4 * GHPLs1[1] * zeta3
				       - 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
				       + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
				       - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
				       - 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
				       + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
				       - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
				       - 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
				       + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
				       - 1.0/2 * GHPLs2[0*4+1] * zeta2
				       - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
				       - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
				       )

    + (dN_c * dN_c - 1.) * pow(u, -2) * v * (
					     + 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
					     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
					     - 1.0/4 * GHPLs2[2*4+2] * zeta2
					     + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
					     - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
					     - 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
					     - 1.0/4 * GHPLs1[2] * zeta3
					     - 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
					     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
					     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
					     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
					     - 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
					     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
					     - 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
					     + 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
					     - 1.0/4 * GHPLs2[2*4+1] * zeta2
					     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
					     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					     - 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs1[1] * zeta3
					     + 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
					     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
					     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
					     + 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
					     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
					     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					     + 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
					     + 1.0/2 * GHPLs2[0*4+1] * zeta2
					     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
					     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
					     )

    + (dN_c * dN_c - 1.) * pow(u, -1) * (
					 - 1.0/2
					 + 1.0/2 * zeta2
					 + 1.0/2 * zeta3
					 - 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
					 + 1.0/2 * GHPLs3[0*4*4+3*4+2]
					 + 1.0/2 * GHPLs1[2] * zeta2
					 - 1.0/2 * GHPLs1[2] * HPLs2[0*2+0]
					 + 1.0/2 * GHPLs1[2] * HPLs2[0*2+1]
					 + 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
					 - 1.0/2 * GHPLs1[0] * zeta2
					 - 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
					 - 1.0/4 * HPLs1[1] * zeta2
					 + 1.0/4 * HPLs2[0*2+1]
					 + 1.0/2 * HPLs3[0*2*2+0*2+1]
					 - 1.0/4 * HPLs3[0*2*2+1*2+1]
					 )

    + (dN_c * dN_c - 1.) * pow(u, -1) * v * (
					     - 1.0/2 * zeta2
					     - 1.0/4 * zeta3
					     - 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
					     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
					     + 1.0/4 * GHPLs2[2*4+2] * zeta2
					     - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
					     + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
					     + 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
					     + 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
					     - 1.0/4 * GHPLs3[0*4*4+3*4+2]
					     - 1.0/4 * GHPLs1[2] * zeta2
					     + 1.0/4 * GHPLs1[2] * zeta3
					     + 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
					     + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
					     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
					     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
					     - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
					     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
					     + 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
					     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
					     - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
					     + 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
					     - 1.0/4 * GHPLs1[3] * HPLs1[0]
					     + 1.0/4 * GHPLs2[0*4+3]
					     + 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
					     - 1.0/4 * GHPLs3[0*4*4+3*4+0]
					     + 1.0/2 * GHPLs1[0] * zeta2
					     + 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
					     + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
					     - 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
					     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
					     + 1.0/4 * GHPLs2[2*4+1] * zeta2
					     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
					     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					     + 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
					     + 1.0/4 * GHPLs1[1] * zeta3
					     - 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
					     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
					     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
					     - 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
					     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
					     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					     - 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
					     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
					     - 1.0/2 * GHPLs2[0*4+1] * zeta2
					     - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
					     - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
					     + 1.0/4 * HPLs1[0] * zeta2
					     - 1.0/4 * HPLs2[0*2+0]
					     - 1.0/4 * HPLs3[0*2*2+0*2+0]
					     + 1.0/4 * HPLs3[0*2*2+1*2+0]
					     + 1.0/4 * HPLs1[1] * zeta2
					     - 1.0/4 * HPLs2[0*2+1]
					     - 1.0/4 * HPLs3[0*2*2+0*2+1]
					     + 1.0/4 * HPLs3[0*2*2+1*2+1]
					     )

    + (dN_c * dN_c - 1.) * pow(1. - u, -1) * (
					      - 1.0/4 * zeta2
					      + 1.0/4 * GHPLs1[3] * HPLs1[0]
					      - 1.0/4 * GHPLs2[0*4+3]
					      - 1.0/4 * GHPLs1[0] * HPLs1[0]
					      + 1.0/4 * HPLs2[0*2+0]
					      - 1.0/4 * HPLs2[0*2+1]
					      )

    + (dN_c * dN_c - 1.) * pow(1. - v, -1) * (
					      + 15.0/16 * zeta2
					      - 3.0/8 * zeta3
					      + 3.0/8 * GHPLs2[3*4+2] * HPLs1[0]
					      - 3.0/8 * GHPLs3[0*4*4+3*4+2]
					      - 3.0/8 * GHPLs1[2] * zeta2
					      + 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
					      - 3.0/8 * GHPLs1[2] * HPLs2[0*2+1]
					      - 3.0/8 * GHPLs2[0*4+2] * HPLs1[0]
					      - 1.0/8 * GHPLs1[3] * HPLs1[0]
					      + 1.0/8 * GHPLs2[0*4+3]
					      - 3.0/8 * GHPLs2[3*4+0] * HPLs1[0]
					      + 3.0/8 * GHPLs3[0*4*4+3*4+0]
					      + 15.0/16 * GHPLs1[0] * HPLs1[0]
					      - 3.0/8 * GHPLs1[0] * HPLs2[0*2+0]
					      - 263.0/96 * HPLs1[0]
					      - 3.0/8 * HPLs1[0] * zeta2
					      - 23.0/8 * HPLs2[0*2+0]
					      + 3.0/8 * HPLs3[0*2*2+0*2+0]
					      - 3.0/8 * HPLs3[0*2*2+1*2+0]
					      + 15.0/16 * HPLs2[0*2+1]
					      - 3.0/8 * HPLs3[0*2*2+0*2+1]
					      )

    + (dN_c * dN_c - 1.) * pow(u + v, -1) * (
					     - 1.0/16
					     - 1.0/16 * GHPLs1[0]
					     + 1.0/16 * HPLs1[0]
					     )

    + (dN_c * dN_c - 1.) * pow(1. - u - v, -1) * (
						  + 1.0/4 * zeta2
						  - 1.0/4 * GHPLs1[3] * HPLs1[0]
						  + 1.0/4 * GHPLs2[0*4+3]
						  + 1.0/4 * GHPLs1[0] * HPLs1[0]
						  - 1.0/4 * HPLs2[0*2+0]
						  + 1.0/4 * HPLs2[0*2+1]
						  )

    + (dN_c * dN_c - 1.) * (
			    - 85799.0/10368
			    + 39.0/32 * zeta4
			    + 7.0/36 * zeta2
			    + 611.0/144 * zeta3
			    + 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
			    - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
			    - 1.0/4 * GHPLs2[2*4+2] * zeta2
			    + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
			    - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
			    - 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
			    - 5.0/8 * GHPLs2[3*4+2] * HPLs1[0]
			    + 5.0/8 * GHPLs3[0*4*4+3*4+2]
			    + 5.0/8 * GHPLs1[2] * zeta2
			    - 1.0/4 * GHPLs1[2] * zeta3
			    - 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
			    - 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
			    + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
			    - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
			    + 5.0/8 * GHPLs1[2] * HPLs2[0*2+1]
			    - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
			    - 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
			    + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
			    + 5.0/8 * GHPLs2[0*4+2] * HPLs1[0]
			    - 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
			    + 1.0/4 * GHPLs3[3*4*4+2*4+3] * HPLs1[0]
			    - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+3]
			    - 1.0/4 * GHPLs2[2*4+3] * zeta2
			    + 1.0/4 * GHPLs2[2*4+3] * HPLs2[0*2+0]
			    - 1.0/4 * GHPLs2[2*4+3] * HPLs2[0*2+1]
			    - 1.0/4 * GHPLs3[0*4*4+2*4+3] * HPLs1[0]
			    + 1.0/2 * GHPLs3[3*4*4+3*4+3] * HPLs1[0]
			    - 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+3]
			    - GHPLs2[3*4+3] * zeta2
			    + 11.0/12 * GHPLs2[3*4+3] * HPLs1[0]
			    + 1.0/2 * GHPLs2[3*4+3] * HPLs2[0*2+0]
			    - 11.0/12 * GHPLs3[0*4*4+3*4+3]
			    - 1.0/2 * GHPLs3[0*4*4+3*4+3] * HPLs1[0]
			    + 1.0/2 * GHPLs4[0*4*4*4+0*4*4+3*4+3]
			    - 11.0/6 * GHPLs1[3] * zeta2
			    - 1.0/2 * GHPLs1[3] * zeta3
			    - 277.0/144 * GHPLs1[3] * HPLs1[0]
			    - 5.0/4 * GHPLs1[3] * HPLs1[0] * zeta2
			    - 11.0/12 * GHPLs1[3] * HPLs2[0*2+0]
			    + 3.0/4 * GHPLs1[3] * HPLs3[0*2*2+0*2+0]
			    - 1.0/4 * GHPLs1[3] * HPLs3[0*2*2+1*2+0]
			    + 1.0/4 * GHPLs1[3] * HPLs1[1] * zeta2
			    - 1.0/4 * GHPLs1[3] * HPLs3[0*2*2+0*2+1]
			    + 1.0/4 * GHPLs1[3] * HPLs3[0*2*2+1*2+1]
			    - 3.0/4 * GHPLs3[3*4*4+0*4+3] * HPLs1[0]
			    + 3.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+3]
			    + 277.0/144 * GHPLs2[0*4+3]
			    - 1.0/4 * GHPLs2[0*4+3] * zeta2
			    + 11.0/12 * GHPLs2[0*4+3] * HPLs1[0]
			    - 3.0/4 * GHPLs2[0*4+3] * HPLs2[0*2+0]
			    + 1.0/4 * GHPLs2[0*4+3] * HPLs2[0*2+1]
			    - 11.0/12 * GHPLs3[0*4*4+0*4+3]
			    + 1.0/2 * GHPLs3[0*4*4+0*4+3] * HPLs1[0]
			    - 1.0/2 * GHPLs3[3*4*4+2*4+0] * HPLs1[0]
			    + 1.0/2 * GHPLs4[0*4*4*4+3*4*4+2*4+0]
			    + 1.0/2 * GHPLs2[2*4+0] * zeta2
			    - 1.0/2 * GHPLs2[2*4+0] * HPLs2[0*2+0]
			    + 1.0/2 * GHPLs2[2*4+0] * HPLs2[0*2+1]
			    + 1.0/2 * GHPLs3[0*4*4+2*4+0] * HPLs1[0]
			    - 1.0/2 * GHPLs3[3*4*4+3*4+0] * HPLs1[0]
			    + 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+0]
			    - 1.0/2 * GHPLs2[3*4+0] * zeta2
			    + 3.0/8 * GHPLs2[3*4+0] * HPLs1[0]
			    - 1.0/2 * GHPLs2[3*4+0] * HPLs2[0*2+0]
			    - 3.0/8 * GHPLs3[0*4*4+3*4+0]
			    + 1.0/4 * GHPLs3[0*4*4+3*4+0] * HPLs1[0]
			    + 1.0/3 * GHPLs1[0]
			    - 7.0/6 * GHPLs1[0] * zeta2
			    + 10.0/9 * GHPLs1[0] * HPLs1[0]
			    - 1.0/4 * GHPLs1[0] * HPLs1[0] * zeta2
			    + 53.0/24 * GHPLs1[0] * HPLs2[0*2+0]
			    - 3.0/4 * GHPLs1[0] * HPLs3[0*2*2+0*2+0]
			    + 1.0/4 * GHPLs1[0] * HPLs3[0*2*2+1*2+0]
			    - 25.0/24 * GHPLs1[0] * HPLs2[0*2+1]
			    + 1.0/2 * GHPLs1[0] * HPLs3[0*2*2+0*2+1]
			    + 1.0/2 * GHPLs3[3*4*4+0*4+0] * HPLs1[0]
			    - 1.0/2 * GHPLs4[0*4*4*4+3*4*4+0*4+0]
			    - 11.0/12 * GHPLs2[0*4+0] * HPLs1[0]
			    + 1.0/2 * GHPLs2[0*4+0] * HPLs2[0*2+0]
			    + 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
			    - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
			    - 1.0/4 * GHPLs2[2*4+1] * zeta2
			    + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
			    - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
			    - 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
			    - 1.0/4 * GHPLs1[1] * zeta3
			    + 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
			    - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
			    + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
			    + 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
			    - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
			    + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
			    + 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
			    - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
			    + 1.0/2 * GHPLs2[0*4+1] * zeta2
			    + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
			    + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
			    - 529.0/432 * HPLs1[0]
			    - 59.0/48 * HPLs1[0] * zeta2
			    + 5.0/4 * HPLs1[0] * zeta3
			    + 119.0/144 * HPLs2[0*2+0]
			    - 5.0/4 * HPLs2[0*2+0] * zeta2
			    - 53.0/24 * HPLs3[0*2*2+0*2+0]
			    + 3.0/4 * HPLs4[0*2*2*2+0*2*2+0*2+0]
			    - 1.0/4 * HPLs4[0*2*2*2+1*2*2+0*2+0]
			    + 1.0/4 * HPLs2[1*2+0] * zeta2
			    + 31.0/24 * HPLs3[0*2*2+1*2+0]
			    - 1.0/4 * HPLs4[0*2*2*2+0*2*2+1*2+0]
			    + 1.0/4 * HPLs4[0*2*2*2+1*2*2+1*2+0]
			    - 25.0/24 * HPLs1[1] * zeta2
			    + 1.0/2 * HPLs1[1] * zeta3
			    + 31.0/36 * HPLs2[0*2+1]
			    + 1.0/2 * HPLs2[0*2+1] * zeta2
			    + 59.0/24 * HPLs3[0*2*2+0*2+1]
			    - 1.0/2 * HPLs4[0*2*2*2+0*2*2+0*2+1]
			    + 1.0/2 * HPLs4[0*2*2*2+1*2*2+0*2+1]
			    - 25.0/24 * HPLs3[0*2*2+1*2+1]
			    + 1.0/2 * HPLs4[0*2*2*2+0*2*2+1*2+1]
			    )

    + (dN_c * dN_c - 1.) * v * pow(1. - u, -2) * (
						  - 1.0/4 * zeta3
						  + 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
						  - 1.0/4 * GHPLs3[0*4*4+3*4+2]
						  - 1.0/4 * GHPLs1[2] * zeta2
						  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
						  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
						  - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
						  + 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
						  - 1.0/4 * GHPLs3[0*4*4+3*4+0]
						  + 1.0/2 * GHPLs1[0] * zeta2
						  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
						  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
						  + 1.0/4 * HPLs1[0] * zeta2
						  - 1.0/4 * HPLs3[0*2*2+0*2+0]
						  + 1.0/4 * HPLs3[0*2*2+1*2+0]
						  + 1.0/4 * HPLs1[1] * zeta2
						  - 1.0/4 * HPLs3[0*2*2+0*2+1]
						  + 1.0/4 * HPLs3[0*2*2+1*2+1]
						  )

    + (dN_c * dN_c - 1.) * v * pow(1. - u, -1) * (
						  + 1.0/2 * zeta2
						  + 3.0/8 * zeta3
						  - 3.0/8 * GHPLs2[3*4+2] * HPLs1[0]
						  + 3.0/8 * GHPLs3[0*4*4+3*4+2]
						  + 3.0/8 * GHPLs1[2] * zeta2
						  - 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						  + 3.0/8 * GHPLs1[2] * HPLs2[0*2+1]
						  + 3.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						  + 1.0/4 * GHPLs1[3] * HPLs1[0]
						  - 1.0/4 * GHPLs2[0*4+3]
						  - 3.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						  + 3.0/8 * GHPLs3[0*4*4+3*4+0]
						  - 3.0/4 * GHPLs1[0] * zeta2
						  - 3.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						  - 3.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						  - 3.0/8 * HPLs1[0] * zeta2
						  + 1.0/4 * HPLs2[0*2+0]
						  + 3.0/8 * HPLs3[0*2*2+0*2+0]
						  - 3.0/8 * HPLs3[0*2*2+1*2+0]
						  - 3.0/8 * HPLs1[1] * zeta2
						  + 1.0/4 * HPLs2[0*2+1]
						  + 3.0/8 * HPLs3[0*2*2+0*2+1]
						  - 3.0/8 * HPLs3[0*2*2+1*2+1]
						  )

    + (dN_c * dN_c - 1.) * u * pow(1. - v, -2) * (
						  - 13.0/48 * zeta2
						  + 1.0/8 * zeta3
						  - 1.0/8 * GHPLs2[3*4+2] * HPLs1[0]
						  + 1.0/8 * GHPLs3[0*4*4+3*4+2]
						  + 1.0/8 * GHPLs1[2] * zeta2
						  - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						  + 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
						  + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						  + 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						  - 1.0/8 * GHPLs3[0*4*4+3*4+0]
						  - 13.0/48 * GHPLs1[0] * HPLs1[0]
						  + 1.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						  + 163.0/288 * HPLs1[0]
						  + 1.0/8 * HPLs1[0] * zeta2
						  + 11.0/12 * HPLs2[0*2+0]
						  - 1.0/8 * HPLs3[0*2*2+0*2+0]
						  + 1.0/8 * HPLs3[0*2*2+1*2+0]
						  - 13.0/48 * HPLs2[0*2+1]
						  + 1.0/8 * HPLs3[0*2*2+0*2+1]
						  )

    + (dN_c * dN_c - 1.) * u * pow(1. - v, -1) * (
						  + 277.0/288
						  + 19.0/48 * zeta2
						  - 1.0/8 * zeta3
						  + 1.0/8 * GHPLs2[3*4+2] * HPLs1[0]
						  - 1.0/8 * GHPLs3[0*4*4+3*4+2]
						  - 1.0/8 * GHPLs1[2] * zeta2
						  + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						  - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
						  - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						  - 1.0/8 * GHPLs1[3] * HPLs1[0]
						  + 1.0/8 * GHPLs2[0*4+3]
						  - 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						  + 1.0/8 * GHPLs3[0*4*4+3*4+0]
						  - 19.0/48 * GHPLs1[0]
						  + 19.0/48 * GHPLs1[0] * HPLs1[0]
						  - 1.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						  - 31.0/288 * HPLs1[0]
						  - 1.0/8 * HPLs1[0] * zeta2
						  - 25.0/24 * HPLs2[0*2+0]
						  + 1.0/8 * HPLs3[0*2*2+0*2+0]
						  - 1.0/8 * HPLs3[0*2*2+1*2+0]
						  + 19.0/48 * HPLs2[0*2+1]
						  - 1.0/8 * HPLs3[0*2*2+0*2+1]
						  )

    + (dN_c * dN_c - 1.) * u * pow(u + v, -2) * (
						 + 1.0/16 * GHPLs1[0]
						 - 1.0/16 * HPLs1[0]
						 )

    + (dN_c * dN_c - 1.) * u * pow(u + v, -1) * (
						 - 5.0/16 * GHPLs1[0]
						 + 5.0/16 * HPLs1[0]
						 )

    + (dN_c * dN_c - 1.) * u * pow(1. - u - v, -1) * (
						      - 3.0/8 * zeta2
						      + 3.0/8 * GHPLs1[3] * HPLs1[0]
						      - 3.0/8 * GHPLs2[0*4+3]
						      - 3.0/8 * GHPLs1[0] * HPLs1[0]
						      + 3.0/8 * HPLs2[0*2+0]
						      - 3.0/8 * HPLs2[0*2+1]
						      )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -2) * (
						     + 1.0/4 * GHPLs3[3*4*4+2*4+2]
						     + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
						     + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
						     - 1.0/4 * GHPLs3[3*4*4+0*4+2]
						     + 1.0/4 * GHPLs3[3*4*4+2*4+1]
						     + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
						     - 1.0/2 * GHPLs1[1] * zeta2
						     - 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
						     - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
						     + 1.0/4 * GHPLs3[3*4*4+0*4+1]
						     )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -2) * v * (
							 - 1.0/4 * GHPLs3[3*4*4+2*4+2]
							 - 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
							 - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							 + 1.0/4 * GHPLs3[3*4*4+0*4+2]
							 - 1.0/4 * GHPLs3[3*4*4+2*4+1]
							 - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							 + 1.0/2 * GHPLs1[1] * zeta2
							 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
							 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							 - 1.0/4 * GHPLs3[3*4*4+0*4+1]
							 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -1) * (
						     - 1.0/2 * zeta2
						     + 1.0/2 * GHPLs2[3*4+2]
						     + 1.0/2 * GHPLs1[2] * HPLs1[0]
						     - 1.0/4 * HPLs2[0*2+1]
						     )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -1) * v * (
							 + 1.0/2 * zeta2
							 + 1.0/4 * GHPLs3[3*4*4+2*4+2]
							 + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
							 - 1.0/4 * GHPLs2[3*4+2]
							 - 1.0/4 * GHPLs1[2] * HPLs1[0]
							 + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							 - 1.0/4 * GHPLs3[3*4*4+0*4+2]
							 + 1.0/4 * GHPLs1[3]
							 - 1.0/4 * GHPLs2[3*4+0]
							 + 1.0/4 * GHPLs3[3*4*4+2*4+1]
							 + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							 - 1.0/2 * GHPLs1[1] * zeta2
							 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
							 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							 + 1.0/4 * GHPLs3[3*4*4+0*4+1]
							 + 1.0/4 * HPLs2[0*2+0]
							 + 1.0/4 * HPLs2[0*2+1]
							 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(1. - u, -1) * (
							  - 1.0/4 * GHPLs1[3]
							  - 1.0/4 * HPLs1[0]
							  )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(1. - v, -1) * (
							  - 3.0/8 * GHPLs2[3*4+2]
							  - 3.0/8 * GHPLs1[2] * HPLs1[0]
							  + 1.0/8 * GHPLs1[3]
							  + 3.0/8 * GHPLs2[3*4+0]
							  - 7.0/16 * HPLs1[0]
							  - 3.0/8 * HPLs2[0*2+0]
							  )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u + v, -1) * (
							 - 1.0/16
							 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(1. - u - v, -1) * (
							      + 1.0/4 * GHPLs1[3]
							      + 1.0/4 * HPLs1[0]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * (
					- 2867.0/864
					- 15.0/16 * zeta2
					+ 7.0/4 * zeta3
					- 1.0/4 * GHPLs3[3*4*4+2*4+2]
					- 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
					+ 5.0/8 * GHPLs2[3*4+2]
					+ 5.0/8 * GHPLs1[2] * HPLs1[0]
					- 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
					+ 1.0/4 * GHPLs3[3*4*4+0*4+2]
					- 1.0/4 * GHPLs3[3*4*4+2*4+3]
					- 1.0/4 * GHPLs2[2*4+3] * HPLs1[0]
					- 1.0/2 * GHPLs3[3*4*4+3*4+3]
					- 11.0/12 * GHPLs2[3*4+3]
					- 1.0/2 * GHPLs2[3*4+3] * HPLs1[0]
					+ 1.0/2 * GHPLs3[0*4*4+3*4+3]
					+ 277.0/144 * GHPLs1[3]
					- 1.0/4 * GHPLs1[3] * zeta2
					- 3.0/4 * GHPLs1[3] * HPLs2[0*2+0]
					+ 1.0/4 * GHPLs1[3] * HPLs2[0*2+1]
					+ 3.0/4 * GHPLs3[3*4*4+0*4+3]
					+ 1.0/2 * GHPLs2[0*4+3] * HPLs1[0]
					+ 1.0/2 * GHPLs3[3*4*4+2*4+0]
					+ 1.0/2 * GHPLs2[2*4+0] * HPLs1[0]
					+ 1.0/2 * GHPLs3[3*4*4+3*4+0]
					- 3.0/8 * GHPLs2[3*4+0]
					+ 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
					+ 1.0/2 * GHPLs1[0] * HPLs2[0*2+0]
					- 1.0/2 * GHPLs3[3*4*4+0*4+0]
					- 1.0/4 * GHPLs3[3*4*4+2*4+1]
					- 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
					+ 1.0/2 * GHPLs1[1] * zeta2
					+ 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
					+ 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
					- 1.0/4 * GHPLs3[3*4*4+0*4+1]
					+ 179.0/72 * HPLs1[0]
					- 1.0/4 * HPLs1[0] * zeta2
					+ 31.0/24 * HPLs2[0*2+0]
					- 3.0/4 * HPLs3[0*2*2+0*2+0]
					+ 1.0/4 * HPLs3[0*2*2+1*2+0]
					- 1.0/8 * HPLs2[0*2+1]
					+ 1.0/2 * HPLs3[0*2*2+0*2+1]
					)

    + (dN_c * dN_c - 1.) * ri * M_PI * v * pow(1. - u, -2) * (
							      + 1.0/2 * zeta2
							      - 1.0/4 * GHPLs2[3*4+2]
							      - 1.0/4 * GHPLs1[2] * HPLs1[0]
							      - 1.0/4 * GHPLs2[3*4+0]
							      + 1.0/4 * HPLs2[0*2+0]
							      + 1.0/4 * HPLs2[0*2+1]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * v * pow(1. - u, -1) * (
							      - 3.0/4 * zeta2
							      + 3.0/8 * GHPLs2[3*4+2]
							      + 3.0/8 * GHPLs1[2] * HPLs1[0]
							      - 1.0/4 * GHPLs1[3]
							      + 3.0/8 * GHPLs2[3*4+0]
							      - 3.0/8 * HPLs2[0*2+0]
							      - 3.0/8 * HPLs2[0*2+1]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - v, -2) * (
							      + 1.0/8 * GHPLs2[3*4+2]
							      + 1.0/8 * GHPLs1[2] * HPLs1[0]
							      - 1.0/8 * GHPLs2[3*4+0]
							      + 3.0/16 * HPLs1[0]
							      + 1.0/8 * HPLs2[0*2+0]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - v, -1) * (
							      + 1.0/16
							      - 1.0/8 * GHPLs2[3*4+2]
							      - 1.0/8 * GHPLs1[2] * HPLs1[0]
							      + 1.0/8 * GHPLs1[3]
							      + 1.0/8 * GHPLs2[3*4+0]
							      - 1.0/16 * HPLs1[0]
							      - 1.0/8 * HPLs2[0*2+0]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(u + v, -2) * (
							     + 1.0/16
							     )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(u + v, -1) * (
							     - 5.0/16
							     )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - u - v, -1) * (
								  - 3.0/8 * GHPLs1[3]
								  - 3.0/8 * HPLs1[0]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * (
							 + 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							 - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							 - 1.0/4 * GHPLs2[2*4+2] * zeta2
							 + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							 - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							 - 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							 + 3.0/8 * GHPLs1[2] * zeta2
							 - 1.0/4 * GHPLs1[2] * zeta3
							 + 1.0/4 * GHPLs1[2] * HPLs1[0]
							 - 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
							 - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							 + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							 - 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
							 - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							 + 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							 - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							 - 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							 + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							 - 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							 - 1.0/4 * GHPLs3[2*4*4+1*4+2]
							 + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							 + 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
							 + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							 + 1.0/8 * GHPLs3[2*4*4+1*4+0]
							 - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							 - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							 + 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							 - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							 + 1.0/4 * GHPLs2[2*4+1]
							 - 1.0/4 * GHPLs2[2*4+1] * zeta2
							 + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							 - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							 - 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							 - 1.0/4 * GHPLs1[1] * zeta2
							 - 1.0/4 * GHPLs1[1] * zeta3
							 - 1.0/4 * GHPLs1[1] * HPLs1[0]
							 + 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
							 + 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
							 - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							 + 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
							 + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							 - 1.0/4 * GHPLs1[1] * HPLs1[1]
							 + 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
							 - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							 + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							 + 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							 - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							 + 1.0/2 * GHPLs2[0*4+1] * zeta2
							 + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							 + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							 + 1.0/8 * GHPLs3[2*4*4+1*4+1]
							 - 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
							 - 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
							 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * v * (
							     - 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							     + 1.0/4 * GHPLs2[2*4+2] * zeta2
							     - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							     + 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							     - 3.0/8 * GHPLs1[2] * zeta2
							     + 1.0/4 * GHPLs1[2] * zeta3
							     - 1.0/8 * GHPLs1[2] * HPLs1[0]
							     + 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
							     + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							     + 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
							     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							     + 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							     + 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs3[2*4*4+1*4+2]
							     - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							     - 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
							     - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							     - 1.0/8 * GHPLs3[2*4*4+1*4+0]
							     + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							     + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							     - 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							     - 1.0/8 * GHPLs2[2*4+1]
							     + 1.0/4 * GHPLs2[2*4+1] * zeta2
							     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							     + 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							     + 1.0/4 * GHPLs1[1] * zeta2
							     + 1.0/4 * GHPLs1[1] * zeta3
							     + 1.0/8 * GHPLs1[1] * HPLs1[0]
							     - 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
							     - 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							     - 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
							     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							     + 1.0/8 * GHPLs1[1] * HPLs1[1]
							     - 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
							     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							     - 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							     - 1.0/2 * GHPLs2[0*4+1] * zeta2
							     - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							     - 1.0/8 * GHPLs3[2*4*4+1*4+1]
							     + 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
							     + 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 2) * (
								     - 1.0/8 * GHPLs1[2] * zeta2
								     - 1.0/8 * GHPLs1[2] * HPLs1[0]
								     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     + 5.0/8 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     - 1.0/8 * GHPLs2[2*4+1]
								     + 1.0/8 * GHPLs1[1] * HPLs1[0]
								     + 1.0/8 * GHPLs1[1] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 3) * (
								     + 1.0/8 * GHPLs1[2] * zeta2
								     + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     - 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     + 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     - 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     + 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     - 5.0/8 * GHPLs1[3] * zeta2
								     + 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     + 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     - 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(u + v, -1) * (
									  - 1.0/8 * GHPLs1[2] * HPLs1[0]
									  - 1.0/8 * GHPLs2[2*4+1]
									  + 1.0/8 * GHPLs1[1] * HPLs1[0]
									  + 1.0/8 * GHPLs1[1] * HPLs1[1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * (
							 + 1.0/2
							 - 3.0/8 * zeta2
							 - 1.0/2 * zeta3
							 + 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
							 - 1.0/2 * GHPLs3[0*4*4+3*4+2]
							 + 3.0/8 * GHPLs1[2]
							 - 2 * GHPLs1[2] * zeta2
							 - 5.0/8 * GHPLs1[2] * HPLs1[0]
							 + GHPLs1[2] * HPLs2[0*2+0]
							 + GHPLs1[2] * HPLs2[1*2+0]
							 - GHPLs1[2] * HPLs2[0*2+1]
							 - 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
							 + GHPLs3[2*4*4+1*4+2]
							 - GHPLs2[1*4+2] * HPLs1[0]
							 - GHPLs2[1*4+2] * HPLs1[1]
							 - 1.0/2 * GHPLs2[2*4+0] * HPLs1[0]
							 + 1.0/2 * GHPLs1[0] * zeta2
							 + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
							 - 1.0/2 * GHPLs3[2*4*4+1*4+0]
							 + 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
							 + 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
							 - 3.0/4 * GHPLs2[2*4+1]
							 + GHPLs1[1] * zeta2
							 + 3.0/4 * GHPLs1[1] * HPLs1[0]
							 - 1.0/2 * GHPLs1[1] * HPLs2[0*2+0]
							 - 1.0/2 * GHPLs1[1] * HPLs2[1*2+0]
							 + 3.0/4 * GHPLs1[1] * HPLs1[1]
							 - 1.0/2 * GHPLs3[2*4*4+1*4+1]
							 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[0]
							 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
							 - 1.0/8 * HPLs2[1*2+0]
							 - 3.0/8 * HPLs1[1]
							 + 1.0/4 * HPLs1[1] * zeta2
							 - 1.0/8 * HPLs2[0*2+1]
							 - 1.0/2 * HPLs3[0*2*2+0*2+1]
							 + 1.0/4 * HPLs3[0*2*2+1*2+1]
							 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * v * (
							     + 1.0/8 * zeta2
							     + 1.0/4 * zeta3
							     + 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							     - 1.0/4 * GHPLs2[2*4+2] * zeta2
							     + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							     - 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							     - 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
							     + 1.0/4 * GHPLs3[0*4*4+3*4+2]
							     - 3.0/8 * GHPLs1[2]
							     + 7.0/8 * GHPLs1[2] * zeta2
							     - 1.0/4 * GHPLs1[2] * zeta3
							     - 3.0/8 * GHPLs1[2] * HPLs1[0]
							     - 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
							     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							     - 1.0/2 * GHPLs1[2] * HPLs2[1*2+0]
							     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							     + 3.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							     - 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							     + 1.0/8 * GHPLs2[0*4+2]
							     - 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							     - 1.0/2 * GHPLs3[2*4*4+1*4+2]
							     + 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
							     + 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
							     - 1.0/4 * GHPLs2[2*4+3] * HPLs1[0]
							     + 1.0/4 * GHPLs3[0*4*4+2*4+3]
							     + 1.0/4 * GHPLs2[3*4+3] * HPLs1[0]
							     - 1.0/4 * GHPLs3[0*4*4+3*4+3]
							     - 5.0/4 * GHPLs1[3] * zeta2
							     + 3.0/8 * GHPLs1[3] * HPLs1[0]
							     + 1.0/4 * GHPLs1[3] * HPLs2[1*2+0]
							     + 1.0/4 * GHPLs1[3] * HPLs2[0*2+1]
							     + 1.0/4 * GHPLs3[2*4*4+0*4+3]
							     - 3.0/8 * GHPLs2[0*4+3]
							     - 1.0/4 * GHPLs2[0*4+3] * HPLs1[1]
							     + 1.0/8 * GHPLs2[2*4+0]
							     + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							     - 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
							     + 1.0/4 * GHPLs3[0*4*4+3*4+0]
							     - 1.0/2 * GHPLs1[0] * zeta2
							     - 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
							     - 1.0/8 * GHPLs1[0] * HPLs1[1]
							     - 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
							     + 1.0/8 * GHPLs3[2*4*4+1*4+0]
							     - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							     - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							     + 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							     - 3.0/8 * GHPLs2[2*4+1]
							     - 1.0/4 * GHPLs2[2*4+1] * zeta2
							     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							     - 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							     - 1.0/4 * GHPLs1[1] * zeta2
							     - 1.0/4 * GHPLs1[1] * zeta3
							     + 3.0/8 * GHPLs1[1] * HPLs1[0]
							     + 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
							     + 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							     + 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
							     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							     + 3.0/8 * GHPLs1[1] * HPLs1[1]
							     + 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
							     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							     + 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							     + 1.0/2 * GHPLs2[0*4+1] * zeta2
							     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							     + 1.0/8 * GHPLs3[2*4*4+1*4+1]
							     - 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
							     - 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
							     + 3.0/8 * HPLs1[0]
							     - 1.0/4 * HPLs1[0] * zeta2
							     + 1.0/8 * HPLs2[0*2+0]
							     + 1.0/4 * HPLs3[0*2*2+0*2+0]
							     - 1.0/4 * HPLs3[0*2*2+1*2+0]
							     + 3.0/8 * HPLs1[1]
							     - 1.0/4 * HPLs1[1] * zeta2
							     + 3.0/8 * HPLs2[0*2+1]
							     + 1.0/4 * HPLs3[0*2*2+0*2+1]
							     - 1.0/4 * HPLs3[0*2*2+1*2+1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(v, 2) * (
								     + 1.0/2 * zeta2
								     + 1.0/4 * GHPLs1[2] * zeta2
								     + 1.0/4 * GHPLs1[2] * HPLs1[0]
								     + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								     - 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs2[0*4+2]
								     - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								     - 1.0/4 * GHPLs3[2*4*4+1*4+2]
								     + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
								     + 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
								     - 1.0/4 * GHPLs2[2*4+3] * HPLs1[0]
								     + 1.0/4 * GHPLs3[0*4*4+2*4+3]
								     + 1.0/4 * GHPLs2[3*4+3] * HPLs1[0]
								     - 1.0/4 * GHPLs3[0*4*4+3*4+3]
								     - 5.0/4 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs1[0]
								     + 1.0/4 * GHPLs1[3] * HPLs2[1*2+0]
								     + 1.0/4 * GHPLs1[3] * HPLs2[0*2+1]
								     + 1.0/4 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3]
								     - 1.0/4 * GHPLs2[0*4+3] * HPLs1[1]
								     - 1.0/8 * GHPLs2[2*4+0]
								     + 1.0/8 * GHPLs1[0] * HPLs1[0]
								     + 1.0/8 * GHPLs1[0] * HPLs1[1]
								     + 1.0/4 * GHPLs2[2*4+1]
								     - 1.0/4 * GHPLs1[1] * HPLs1[0]
								     - 1.0/4 * GHPLs1[1] * HPLs1[1]
								     - 1.0/8 * HPLs2[0*2+0]
								     - 1.0/8 * HPLs2[0*2+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(v, 3) * (
								     - 1.0/8 * GHPLs1[2] * zeta2
								     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     + 5.0/8 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(1. - u, -1) * (
							      - 1.0/2 * zeta2
							      + 1.0/2 * GHPLs1[3] * HPLs1[0]
							      - 1.0/2 * GHPLs2[0*4+3]
							      - 1.0/2 * GHPLs1[0] * HPLs1[0]
							      + 1.0/2 * HPLs2[0*2+0]
							      - 1.0/2 * HPLs2[0*2+1]
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(1. - v, -1) * (
							      - 1.0/16 * zeta2
							      - 3.0/4 * zeta3
							      + 3.0/4 * GHPLs1[2] * zeta2
							      + 9.0/8 * GHPLs1[2] * HPLs1[0]
							      - 3.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							      - 9.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							      - 3.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							      - 3.0/8 * GHPLs2[0*4+2] * HPLs1[0]
							      - 9.0/8 * GHPLs3[2*4*4+1*4+2]
							      + 9.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							      + 9.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							      + 7.0/8 * GHPLs1[3] * HPLs1[0]
							      - 7.0/8 * GHPLs2[0*4+3]
							      + 3.0/4 * GHPLs2[2*4+0] * HPLs1[0]
							      - 3.0/8 * GHPLs1[0] * zeta2
							      + 1.0/16 * GHPLs1[0] * HPLs1[0]
							      + 3.0/4 * GHPLs1[0] * HPLs2[0*2+0]
							      + 3.0/8 * GHPLs1[0] * HPLs2[1*2+0]
							      + 9.0/8 * GHPLs3[2*4*4+1*4+0]
							      - 9.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							      - 9.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							      + 5.0/4 * GHPLs2[2*4+1]
							      - 5.0/4 * GHPLs1[1] * HPLs1[0]
							      - 5.0/4 * GHPLs1[1] * HPLs1[1]
							      - 65.0/32 * HPLs1[0]
							      + 9.0/8 * HPLs1[0] * zeta2
							      + 5.0/8 * HPLs2[0*2+0]
							      + 3.0/4 * HPLs3[1*2*2+0*2+0]
							      + 1.0/8 * HPLs2[1*2+0]
							      - 3.0/8 * HPLs1[1] * zeta2
							      + 1.0/16 * HPLs2[0*2+1]
							      + 3.0/4 * HPLs3[0*2*2+0*2+1]
							      + 3.0/8 * HPLs3[1*2*2+0*2+1]
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u + v, -2) * (
							     - 3.0/8 * GHPLs1[2] * zeta2
							     + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							     + 1.0/8 * GHPLs3[2*4*4+1*4+2]
							     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							     + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							     + 1.0/8 * GHPLs3[2*4*4+1*4+0]
							     - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							     - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							     + 3.0/8 * HPLs1[1] * zeta2
							     - 1.0/8 * HPLs3[1*2*2+0*2+1]
							     + 1.0/8 * HPLs3[0*2*2+1*2+1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u + v, -1) * (
							     + 1.0/16
							     - 3.0/8 * zeta2
							     + 3.0/2 * GHPLs1[2] * zeta2
							     - 1.0/2 * GHPLs1[2] * HPLs2[1*2+0]
							     + 1.0/2 * GHPLs1[2] * HPLs2[0*2+1]
							     - 1.0/2 * GHPLs3[2*4*4+1*4+2]
							     + 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
							     + 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
							     - 1.0/2 * GHPLs2[2*4+0] * HPLs1[0]
							     + 1.0/16 * GHPLs1[0]
							     - 1.0/2 * GHPLs3[2*4*4+1*4+0]
							     + 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
							     + 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
							     + 1.0/8 * GHPLs2[2*4+1]
							     - 1.0/8 * GHPLs1[1] * HPLs1[0]
							     - 1.0/8 * GHPLs1[1] * HPLs1[1]
							     - 1.0/16 * HPLs1[0]
							     + 1.0/8 * HPLs2[1*2+0]
							     - 3.0/2 * HPLs1[1] * zeta2
							     - 1.0/8 * HPLs2[0*2+1]
							     + 1.0/2 * HPLs3[1*2*2+0*2+1]
							     - 1.0/2 * HPLs3[0*2*2+1*2+1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(1. - u - v, -1) * (
								  - 1.0/2 * zeta2
								  + 1.0/2 * GHPLs1[3] * HPLs1[0]
								  - 1.0/2 * GHPLs2[0*4+3]
								  - 1.0/2 * GHPLs1[0] * HPLs1[0]
								  + 1.0/2 * HPLs2[0*2+0]
								  - 1.0/2 * HPLs2[0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * (
					    - 395.0/128
					    + 29.0/16 * zeta4
					    + 33.0/16 * zeta2
					    + 2 * zeta3
					    - 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
					    + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
					    + 1.0/4 * GHPLs2[2*4+2] * zeta2
					    - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
					    + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
					    + 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
					    + GHPLs2[3*4+2] * HPLs1[0]
					    - GHPLs3[0*4*4+3*4+2]
					    - 3.0/8 * GHPLs1[2]
					    - 7.0/4 * GHPLs1[2] * zeta2
					    + 1.0/4 * GHPLs1[2] * zeta3
					    + 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
					    + 11.0/8 * GHPLs1[2] * HPLs2[0*2+0]
					    - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
					    + 3.0/4 * GHPLs1[2] * HPLs2[1*2+0]
					    + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
					    - 5.0/8 * GHPLs1[2] * HPLs2[0*2+1]
					    + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
					    + 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
					    - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
					    - 3.0/8 * GHPLs2[0*4+2]
					    - 5.0/8 * GHPLs2[0*4+2] * HPLs1[0]
					    + 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
					    + 3.0/4 * GHPLs3[2*4*4+1*4+2]
					    - 3.0/4 * GHPLs2[1*4+2] * HPLs1[0]
					    - 3.0/4 * GHPLs2[1*4+2] * HPLs1[1]
					    - 1.0/4 * GHPLs3[3*4*4+2*4+3] * HPLs1[0]
					    + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+3]
					    + 1.0/4 * GHPLs2[2*4+3] * zeta2
					    - 1.0/4 * GHPLs2[2*4+3] * HPLs2[0*2+0]
					    + 1.0/4 * GHPLs2[2*4+3] * HPLs2[0*2+1]
					    + 1.0/4 * GHPLs3[0*4*4+2*4+3] * HPLs1[0]
					    - 1.0/2 * GHPLs3[3*4*4+3*4+3] * HPLs1[0]
					    + 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+3]
					    + GHPLs2[3*4+3] * zeta2
					    + 3.0/8 * GHPLs2[3*4+3] * HPLs1[0]
					    - 1.0/2 * GHPLs2[3*4+3] * HPLs2[0*2+0]
					    - 3.0/8 * GHPLs3[0*4*4+3*4+3]
					    + 1.0/2 * GHPLs3[0*4*4+3*4+3] * HPLs1[0]
					    - 1.0/2 * GHPLs4[0*4*4*4+0*4*4+3*4+3]
					    + 3.0/8 * GHPLs1[3] * zeta2
					    - 1.0/2 * GHPLs1[3] * zeta3
					    - 45.0/16 * GHPLs1[3] * HPLs1[0]
					    + 7.0/4 * GHPLs1[3] * HPLs1[0] * zeta2
					    - 3.0/4 * GHPLs1[3] * HPLs3[0*2*2+0*2+0]
					    + 1.0/4 * GHPLs1[3] * HPLs3[0*2*2+1*2+0]
					    - 1.0/4 * GHPLs1[3] * HPLs1[1] * zeta2
					    + 1.0/4 * GHPLs1[3] * HPLs3[0*2*2+0*2+1]
					    - 1.0/4 * GHPLs1[3] * HPLs3[0*2*2+1*2+1]
					    + 1.0/4 * GHPLs3[3*4*4+0*4+3] * HPLs1[0]
					    - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+3]
					    + 45.0/16 * GHPLs2[0*4+3]
					    - 1.0/4 * GHPLs2[0*4+3] * zeta2
					    + 3.0/4 * GHPLs2[0*4+3] * HPLs2[0*2+0]
					    - 1.0/4 * GHPLs2[0*4+3] * HPLs2[0*2+1]
					    - 1.0/2 * GHPLs3[0*4*4+0*4+3] * HPLs1[0]
					    - 3.0/8 * GHPLs2[2*4+0]
					    - 1.0/2 * GHPLs2[2*4+0] * zeta2
					    + 1.0/2 * GHPLs2[2*4+0] * HPLs2[0*2+0]
					    + 1.0/2 * GHPLs2[2*4+0] * HPLs2[1*2+0]
					    + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+0]
					    - 1.0/2 * GHPLs3[1*4*4+2*4+0] * HPLs1[0]
					    - 1.0/2 * GHPLs3[1*4*4+2*4+0] * HPLs1[1]
					    + 1.0/2 * GHPLs3[3*4*4+3*4+0] * HPLs1[0]
					    - 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+0]
					    + 1.0/2 * GHPLs2[3*4+0] * zeta2
					    - 3.0/8 * GHPLs2[3*4+0] * HPLs1[0]
					    + 1.0/2 * GHPLs2[3*4+0] * HPLs2[0*2+0]
					    + 3.0/8 * GHPLs3[0*4*4+3*4+0]
					    - 1.0/4 * GHPLs3[0*4*4+3*4+0] * HPLs1[0]
					    - 1.0/4 * GHPLs1[0]
					    + GHPLs1[0] * zeta2
					    + 15.0/8 * GHPLs1[0] * HPLs1[0]
					    - 1.0/4 * GHPLs1[0] * HPLs1[0] * zeta2
					    - 3.0/4 * GHPLs1[0] * HPLs2[0*2+0]
					    + 3.0/4 * GHPLs1[0] * HPLs3[0*2*2+0*2+0]
					    - 3.0/8 * GHPLs1[0] * HPLs2[1*2+0]
					    - 1.0/4 * GHPLs1[0] * HPLs3[0*2*2+1*2+0]
					    + 3.0/8 * GHPLs1[0] * HPLs1[1]
					    + 1.0/8 * GHPLs1[0] * HPLs2[0*2+1]
					    - 1.0/2 * GHPLs1[0] * HPLs3[0*2*2+0*2+1]
					    - 1.0/2 * GHPLs3[2*4*4+0*4+0] * HPLs1[0]
					    - 1.0/2 * GHPLs2[0*4+0] * HPLs2[0*2+0]
					    - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+0*4+0]
					    + 1.0/2 * GHPLs3[1*4*4+0*4+0] * HPLs1[0]
					    + 1.0/2 * GHPLs3[1*4*4+0*4+0] * HPLs1[1]
					    - 3.0/8 * GHPLs3[2*4*4+1*4+0]
					    + GHPLs2[1*4+0] * zeta2
					    + 3.0/8 * GHPLs2[1*4+0] * HPLs1[0]
					    - 1.0/2 * GHPLs2[1*4+0] * HPLs2[0*2+0]
					    - 1.0/2 * GHPLs2[1*4+0] * HPLs2[1*2+0]
					    + 3.0/8 * GHPLs2[1*4+0] * HPLs1[1]
					    - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+0]
					    + 1.0/2 * GHPLs3[1*4*4+1*4+0] * HPLs1[0]
					    + 1.0/2 * GHPLs3[1*4*4+1*4+0] * HPLs1[1]
					    - 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
					    + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
					    - 1.0/8 * GHPLs2[2*4+1]
					    + 1.0/4 * GHPLs2[2*4+1] * zeta2
					    - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
					    + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					    + 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
					    - 3.0/4 * GHPLs1[1] * zeta2
					    + 1.0/4 * GHPLs1[1] * zeta3
					    + 1.0/8 * GHPLs1[1] * HPLs1[0]
					    - 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
					    + 3.0/8 * GHPLs1[1] * HPLs2[0*2+0]
					    + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
					    + 3.0/8 * GHPLs1[1] * HPLs2[1*2+0]
					    - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
					    + 1.0/8 * GHPLs1[1] * HPLs1[1]
					    - 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
					    + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
					    - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					    - 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
					    + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
					    - 1.0/2 * GHPLs2[0*4+1] * zeta2
					    - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
					    - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
					    + 3.0/8 * GHPLs3[2*4*4+1*4+1]
					    - 3.0/8 * GHPLs2[1*4+1] * HPLs1[0]
					    - 3.0/8 * GHPLs2[1*4+1] * HPLs1[1]
					    + 27.0/16 * HPLs1[0]
					    - 3.0/2 * HPLs1[0] * zeta2
					    + HPLs1[0] * zeta3
					    - 41.0/16 * HPLs2[0*2+0]
					    + 7.0/4 * HPLs2[0*2+0] * zeta2
					    - 3.0/4 * HPLs4[0*2*2*2+0*2*2+0*2+0]
					    - 3.0/4 * HPLs3[1*2*2+0*2+0]
					    + 1.0/4 * HPLs4[0*2*2*2+1*2*2+0*2+0]
					    - 1.0/8 * HPLs2[1*2+0]
					    - 1.0/4 * HPLs2[1*2+0] * zeta2
					    + 1.0/4 * HPLs4[0*2*2*2+0*2*2+1*2+0]
					    - 1.0/4 * HPLs4[0*2*2*2+1*2*2+1*2+0]
					    + 3.0/8 * HPLs1[1]
					    + 5.0/4 * HPLs1[1] * zeta2
					    + 11.0/8 * HPLs2[0*2+1]
					    - 11.0/8 * HPLs3[0*2*2+0*2+1]
					    - 1.0/2 * HPLs4[1*2*2*2+0*2*2+0*2+1]
					    - 3.0/4 * HPLs3[1*2*2+0*2+1]
					    - 1.0/2 * HPLs4[0*2*2*2+1*2*2+0*2+1]
					    + 1.0/8 * HPLs3[0*2*2+1*2+1]
					    - 1.0/2 * HPLs4[0*2*2*2+0*2*2+1*2+1]
					    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * pow(1. - u, -2) * (
								  - 1.0/2 * zeta3
								  + 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
								  - 1.0/2 * GHPLs3[0*4*4+3*4+2]
								  - 1.0/2 * GHPLs1[2] * zeta2
								  + 1.0/2 * GHPLs1[2] * HPLs2[0*2+0]
								  - 1.0/2 * GHPLs1[2] * HPLs2[0*2+1]
								  - 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
								  + 1.0/2 * GHPLs2[3*4+0] * HPLs1[0]
								  - 1.0/2 * GHPLs3[0*4*4+3*4+0]
								  + GHPLs1[0] * zeta2
								  + 1.0/2 * GHPLs1[0] * HPLs2[0*2+0]
								  + 1.0/2 * GHPLs1[0] * HPLs2[0*2+1]
								  + 1.0/2 * HPLs1[0] * zeta2
								  - 1.0/2 * HPLs3[0*2*2+0*2+0]
								  + 1.0/2 * HPLs3[0*2*2+1*2+0]
								  + 1.0/2 * HPLs1[1] * zeta2
								  - 1.0/2 * HPLs3[0*2*2+0*2+1]
								  + 1.0/2 * HPLs3[0*2*2+1*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * pow(1. - u, -1) * (
								  + zeta2
								  + 1.0/4 * zeta3
								  - 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
								  + 1.0/4 * GHPLs3[0*4*4+3*4+2]
								  + 1.0/4 * GHPLs1[2] * zeta2
								  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
								  + 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								  + 1.0/2 * GHPLs1[3] * HPLs1[0]
								  - 1.0/2 * GHPLs2[0*4+3]
								  - 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
								  + 1.0/4 * GHPLs3[0*4*4+3*4+0]
								  - 1.0/2 * GHPLs1[0] * zeta2
								  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
								  - 1.0/4 * HPLs1[0] * zeta2
								  + 1.0/2 * HPLs2[0*2+0]
								  + 1.0/4 * HPLs3[0*2*2+0*2+0]
								  - 1.0/4 * HPLs3[0*2*2+1*2+0]
								  - 1.0/4 * HPLs1[1] * zeta2
								  + 1.0/2 * HPLs2[0*2+1]
								  + 1.0/4 * HPLs3[0*2*2+0*2+1]
								  - 1.0/4 * HPLs3[0*2*2+1*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * (
						+ 17.0/8 * zeta2
						+ 1.0/8 * GHPLs1[2] * zeta2
						+ 7.0/8 * GHPLs1[2] * HPLs1[0]
						+ 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						- 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						- 1.0/2 * GHPLs2[0*4+2]
						- 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						- 1.0/8 * GHPLs3[2*4*4+1*4+2]
						+ 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						+ 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						- 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
						+ 1.0/8 * GHPLs3[0*4*4+2*4+3]
						+ 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
						- 1.0/8 * GHPLs3[0*4*4+3*4+3]
						- 5.0/8 * GHPLs1[3] * zeta2
						- 5.0/8 * GHPLs1[3] * HPLs1[0]
						+ 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
						+ 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
						+ 1.0/8 * GHPLs3[2*4*4+0*4+3]
						+ 5.0/8 * GHPLs2[0*4+3]
						- 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
						- 1.0/2 * GHPLs2[2*4+0]
						+ 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						- 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						+ 1.0/8 * GHPLs3[0*4*4+3*4+0]
						+ 3.0/8 * GHPLs1[0] * HPLs1[0]
						- 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
						- 1.0/8 * GHPLs1[0] * HPLs2[1*2+0]
						+ 1.0/2 * GHPLs1[0] * HPLs1[1]
						- 1.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						+ 5.0/8 * GHPLs2[2*4+1]
						- 1.0/8 * GHPLs3[0*4*4+2*4+1]
						+ 1.0/2 * GHPLs1[1] * zeta2
						- 5.0/8 * GHPLs1[1] * HPLs1[0]
						+ 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
						+ 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
						- 5.0/8 * GHPLs1[1] * HPLs1[1]
						- 1.0/8 * GHPLs3[2*4*4+0*4+1]
						+ 1.0/8 * GHPLs2[0*4+1] * HPLs1[0]
						+ 1.0/8 * GHPLs2[0*4+1] * HPLs1[1]
						+ 1.0/8 * GHPLs3[2*4*4+1*4+1]
						- 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
						- 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
						- 5.0/8 * HPLs1[0] * zeta2
						- 5.0/8 * HPLs2[0*2+0]
						- 1.0/8 * HPLs3[1*2*2+0*2+0]
						- 1.0/4 * HPLs2[1*2+0]
						- 1.0/8 * HPLs3[0*2*2+1*2+0]
						- 1.0/8 * HPLs1[1] * zeta2
						- 5.0/8 * HPLs2[0*2+1]
						- 1.0/8 * HPLs3[0*2*2+0*2+1]
						- 1.0/8 * HPLs3[1*2*2+0*2+1]
						- 1.0/4 * HPLs3[0*2*2+1*2+1]
						)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(v, 2) * (
							- 1.0/2 * zeta2
							- 1.0/4 * GHPLs1[2] * zeta2
							- 1.0/8 * GHPLs1[2] * HPLs1[0]
							- 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							+ 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
							+ 1.0/8 * GHPLs2[0*4+2]
							+ 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							+ 1.0/4 * GHPLs3[2*4*4+1*4+2]
							- 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							- 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
							+ 1.0/4 * GHPLs2[2*4+3] * HPLs1[0]
							- 1.0/4 * GHPLs3[0*4*4+2*4+3]
							- 1.0/4 * GHPLs2[3*4+3] * HPLs1[0]
							+ 1.0/4 * GHPLs3[0*4*4+3*4+3]
							+ 5.0/4 * GHPLs1[3] * zeta2
							+ 1.0/8 * GHPLs1[3] * HPLs1[0]
							- 1.0/4 * GHPLs1[3] * HPLs2[1*2+0]
							- 1.0/4 * GHPLs1[3] * HPLs2[0*2+1]
							- 1.0/4 * GHPLs3[2*4*4+0*4+3]
							- 1.0/8 * GHPLs2[0*4+3]
							+ 1.0/4 * GHPLs2[0*4+3] * HPLs1[1]
							+ 1.0/8 * GHPLs2[2*4+0]
							- 1.0/8 * GHPLs1[0] * HPLs1[0]
							- 1.0/8 * GHPLs1[0] * HPLs1[1]
							- 1.0/8 * GHPLs2[2*4+1]
							+ 1.0/8 * GHPLs1[1] * HPLs1[0]
							+ 1.0/8 * GHPLs1[1] * HPLs1[1]
							+ 1.0/8 * HPLs2[0*2+0]
							+ 1.0/8 * HPLs2[0*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - v, -2) * (
								  + 39.0/16 * zeta2
								  + 9.0/4 * zeta3
								  + 2 * GHPLs2[3*4+2] * HPLs1[0]
								  - 2 * GHPLs3[0*4*4+3*4+2]
								  - 9.0/4 * GHPLs1[2] * zeta2
								  - 5.0/8 * GHPLs1[2] * HPLs1[0]
								  + 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								  + 19.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								  + 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
								  + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								  + 19.0/8 * GHPLs3[2*4*4+1*4+2]
								  - 19.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								  - 19.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								  - 21.0/8 * GHPLs1[3] * HPLs1[0]
								  + 21.0/8 * GHPLs2[0*4+3]
								  - 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
								  - 2 * GHPLs2[3*4+0] * HPLs1[0]
								  + 2 * GHPLs3[0*4*4+3*4+0]
								  + 17.0/8 * GHPLs1[0] * zeta2
								  + 7.0/16 * GHPLs1[0] * HPLs1[0]
								  - 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								  - 17.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  - 19.0/8 * GHPLs3[2*4*4+1*4+0]
								  + 19.0/8 * GHPLs2[1*4+0] * HPLs1[0]
								  + 19.0/8 * GHPLs2[1*4+0] * HPLs1[1]
								  - 21.0/8 * GHPLs2[2*4+1]
								  + 21.0/8 * GHPLs1[1] * HPLs1[0]
								  + 21.0/8 * GHPLs1[1] * HPLs1[1]
								  + 27.0/32 * HPLs1[0]
								  - 67.0/8 * HPLs1[0] * zeta2
								  - 21.0/8 * HPLs2[0*2+0]
								  + 2 * HPLs3[0*2*2+0*2+0]
								  - 1.0/4 * HPLs3[1*2*2+0*2+0]
								  - 2 * HPLs2[1*2+0]
								  + 2 * HPLs3[0*2*2+1*2+0]
								  + 17.0/8 * HPLs1[1] * zeta2
								  + 7.0/16 * HPLs2[0*2+1]
								  - 9.0/4 * HPLs3[0*2*2+0*2+1]
								  - 17.0/8 * HPLs3[1*2*2+0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - v, -1) * (
								  + 17.0/32
								  - 173.0/16 * zeta2
								  - 9.0/4 * zeta3
								  - 2 * GHPLs2[3*4+2] * HPLs1[0]
								  + 2 * GHPLs3[0*4*4+3*4+2]
								  + 9.0/8 * GHPLs1[2]
								  + 9.0/4 * GHPLs1[2] * zeta2
								  - 2 * GHPLs1[2] * HPLs1[0]
								  - 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								  - 19.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								  - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
								  + 17.0/8 * GHPLs2[0*4+2]
								  - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								  - 19.0/8 * GHPLs3[2*4*4+1*4+2]
								  + 19.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								  + 19.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								  + 37.0/8 * GHPLs1[3] * HPLs1[0]
								  - 37.0/8 * GHPLs2[0*4+3]
								  + 17.0/8 * GHPLs2[2*4+0]
								  + 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
								  + 2 * GHPLs2[3*4+0] * HPLs1[0]
								  - 2 * GHPLs3[0*4*4+3*4+0]
								  - 13.0/16 * GHPLs1[0]
								  - 17.0/8 * GHPLs1[0] * zeta2
								  - 35.0/16 * GHPLs1[0] * HPLs1[0]
								  + 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								  + 17.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  - 17.0/8 * GHPLs1[0] * HPLs1[1]
								  + 19.0/8 * GHPLs3[2*4*4+1*4+0]
								  - 19.0/8 * GHPLs2[1*4+0] * HPLs1[0]
								  - 19.0/8 * GHPLs2[1*4+0] * HPLs1[1]
								  + 1.0/4 * GHPLs2[2*4+1]
								  - 1.0/4 * GHPLs1[1] * HPLs1[0]
								  - 1.0/4 * GHPLs1[1] * HPLs1[1]
								  - 39.0/32 * HPLs1[0]
								  + 67.0/8 * HPLs1[0] * zeta2
								  + 37.0/8 * HPLs2[0*2+0]
								  - 2 * HPLs3[0*2*2+0*2+0]
								  + 1.0/4 * HPLs3[1*2*2+0*2+0]
								  + 9.0/4 * HPLs2[1*2+0]
								  - 2 * HPLs3[0*2*2+1*2+0]
								  - 9.0/8 * HPLs1[1]
								  - 17.0/8 * HPLs1[1] * zeta2
								  + 33.0/16 * HPLs2[0*2+1]
								  + 9.0/4 * HPLs3[0*2*2+0*2+1]
								  + 17.0/8 * HPLs3[1*2*2+0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(u + v, -2) * (
								 - 1.0/16 * GHPLs1[0]
								 + 1.0/16 * HPLs1[0]
								 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(u + v, -1) * (
								 - 7.0/16 * GHPLs1[0]
								 + 7.0/16 * HPLs1[0]
								 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - u - v, -1) * (
								      + 1.0/4 * zeta2
								      - 1.0/4 * GHPLs1[3] * HPLs1[0]
								      + 1.0/4 * GHPLs2[0*4+3]
								      + 1.0/4 * GHPLs1[0] * HPLs1[0]
								      - 1.0/4 * HPLs2[0*2+0]
								      + 1.0/4 * HPLs2[0*2+1]
								      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * (
						+ 5 * zeta2
						- 3.0/8 * GHPLs1[2]
						+ 3.0/2 * GHPLs1[2] * HPLs1[0]
						- 5.0/4 * GHPLs2[0*4+2]
						- 5.0/4 * GHPLs1[3] * HPLs1[0]
						+ 5.0/4 * GHPLs2[0*4+3]
						- 5.0/4 * GHPLs2[2*4+0]
						+ GHPLs1[0] * HPLs1[0]
						+ 5.0/4 * GHPLs1[0] * HPLs1[1]
						+ 5.0/4 * GHPLs2[2*4+1]
						- 5.0/4 * GHPLs1[1] * HPLs1[0]
						- 5.0/4 * GHPLs1[1] * HPLs1[1]
						+ 3.0/8 * HPLs1[0]
						- 5.0/4 * HPLs2[0*2+0]
						- 1.0/4 * HPLs2[1*2+0]
						+ 3.0/8 * HPLs1[1]
						- 3.0/2 * HPLs2[0*2+1]
						)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * v * (
						    - 3.0/2 * zeta2
						    - 1.0/8 * GHPLs1[2] * zeta2
						    - 3.0/8 * GHPLs1[2] * HPLs1[0]
						    - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						    + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						    + 3.0/8 * GHPLs2[0*4+2]
						    + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						    + 1.0/8 * GHPLs3[2*4*4+1*4+2]
						    - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						    - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						    + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
						    - 1.0/8 * GHPLs3[0*4*4+2*4+3]
						    - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
						    + 1.0/8 * GHPLs3[0*4*4+3*4+3]
						    + 5.0/8 * GHPLs1[3] * zeta2
						    + 3.0/8 * GHPLs1[3] * HPLs1[0]
						    - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
						    - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
						    - 1.0/8 * GHPLs3[2*4*4+0*4+3]
						    - 3.0/8 * GHPLs2[0*4+3]
						    + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
						    + 3.0/8 * GHPLs2[2*4+0]
						    - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						    + 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						    - 1.0/8 * GHPLs3[0*4*4+3*4+0]
						    - 3.0/8 * GHPLs1[0] * HPLs1[0]
						    + 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
						    + 1.0/8 * GHPLs1[0] * HPLs2[1*2+0]
						    - 3.0/8 * GHPLs1[0] * HPLs1[1]
						    + 1.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						    - 3.0/8 * GHPLs2[2*4+1]
						    + 1.0/8 * GHPLs3[0*4*4+2*4+1]
						    - 1.0/2 * GHPLs1[1] * zeta2
						    + 3.0/8 * GHPLs1[1] * HPLs1[0]
						    - 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
						    - 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
						    + 3.0/8 * GHPLs1[1] * HPLs1[1]
						    + 1.0/8 * GHPLs3[2*4*4+0*4+1]
						    - 1.0/8 * GHPLs2[0*4+1] * HPLs1[0]
						    - 1.0/8 * GHPLs2[0*4+1] * HPLs1[1]
						    - 1.0/8 * GHPLs3[2*4*4+1*4+1]
						    + 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
						    + 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
						    + 5.0/8 * HPLs1[0] * zeta2
						    + 3.0/8 * HPLs2[0*2+0]
						    + 1.0/8 * HPLs3[1*2*2+0*2+0]
						    + 1.0/8 * HPLs3[0*2*2+1*2+0]
						    + 1.0/8 * HPLs1[1] * zeta2
						    + 3.0/8 * HPLs2[0*2+1]
						    + 1.0/8 * HPLs3[0*2*2+0*2+1]
						    + 1.0/8 * HPLs3[1*2*2+0*2+1]
						    + 1.0/4 * HPLs3[0*2*2+1*2+1]
						    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -3) * (
									  - 9.0/4 * zeta2
									  - 15.0/4 * zeta3
									  - 15.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 15.0/4 * GHPLs3[0*4*4+3*4+2]
									  + 15.0/4 * GHPLs1[2] * zeta2
									  - 15.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  - 15.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  - 15.0/4 * GHPLs3[2*4*4+1*4+2]
									  + 15.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  + 15.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  + 9.0/4 * GHPLs1[3] * HPLs1[0]
									  - 9.0/4 * GHPLs2[0*4+3]
									  + 15.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  - 15.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 15.0/4 * GHPLs1[0] * zeta2
									  + 15.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 15.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  + 15.0/4 * GHPLs3[2*4*4+1*4+0]
									  - 15.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  - 15.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  + 9.0/4 * GHPLs2[2*4+1]
									  - 9.0/4 * GHPLs1[1] * HPLs1[0]
									  - 9.0/4 * GHPLs1[1] * HPLs1[1]
									  + 15 * HPLs1[0] * zeta2
									  + 9.0/4 * HPLs2[0*2+0]
									  - 15.0/4 * HPLs3[0*2*2+0*2+0]
									  + 9.0/4 * HPLs2[1*2+0]
									  - 15.0/4 * HPLs3[0*2*2+1*2+0]
									  - 15.0/4 * HPLs1[1] * zeta2
									  + 15.0/4 * HPLs3[0*2*2+0*2+1]
									  + 15.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -2) * (
									  + 69.0/4 * zeta2
									  + 15.0/4 * zeta3
									  + 15.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  - 15.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 9.0/8 * GHPLs1[2]
									  - 15.0/4 * GHPLs1[2] * zeta2
									  + 15.0/4 * GHPLs1[2] * HPLs1[0]
									  + 15.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 15.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  - 15.0/4 * GHPLs2[0*4+2]
									  + 15.0/4 * GHPLs3[2*4*4+1*4+2]
									  - 15.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  - 15.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  - 6 * GHPLs1[3] * HPLs1[0]
									  + 6 * GHPLs2[0*4+3]
									  - 15.0/4 * GHPLs2[2*4+0]
									  - 15.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 15.0/4 * GHPLs3[0*4*4+3*4+0]
									  + 9.0/8 * GHPLs1[0]
									  + 15.0/4 * GHPLs1[0] * zeta2
									  + 15.0/4 * GHPLs1[0] * HPLs1[0]
									  - 15.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  - 15.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  + 15.0/4 * GHPLs1[0] * HPLs1[1]
									  - 15.0/4 * GHPLs3[2*4*4+1*4+0]
									  + 15.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  + 15.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  + 3.0/2 * GHPLs2[2*4+1]
									  - 3.0/2 * GHPLs1[1] * HPLs1[0]
									  - 3.0/2 * GHPLs1[1] * HPLs1[1]
									  - 15 * HPLs1[0] * zeta2
									  - 6 * HPLs2[0*2+0]
									  + 15.0/4 * HPLs3[0*2*2+0*2+0]
									  - 9.0/4 * HPLs2[1*2+0]
									  + 15.0/4 * HPLs3[0*2*2+1*2+0]
									  + 9.0/8 * HPLs1[1]
									  + 15.0/4 * HPLs1[1] * zeta2
									  - 15.0/4 * HPLs2[0*2+1]
									  - 15.0/4 * HPLs3[0*2*2+0*2+1]
									  - 15.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -1) * (
									  - 15.0/2 * zeta2
									  + 3.0/8 * GHPLs1[2]
									  - 15.0/8 * GHPLs1[2] * HPLs1[0]
									  + 15.0/8 * GHPLs2[0*4+2]
									  + 15.0/8 * GHPLs1[3] * HPLs1[0]
									  - 15.0/8 * GHPLs2[0*4+3]
									  + 15.0/8 * GHPLs2[2*4+0]
									  - 3.0/8 * GHPLs1[0]
									  - 15.0/8 * GHPLs1[0] * HPLs1[0]
									  - 15.0/8 * GHPLs1[0] * HPLs1[1]
									  - 15.0/8 * GHPLs2[2*4+1]
									  + 15.0/8 * GHPLs1[1] * HPLs1[0]
									  + 15.0/8 * GHPLs1[1] * HPLs1[1]
									  + 15.0/8 * HPLs2[0*2+0]
									  - 3.0/8 * HPLs1[1]
									  + 15.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * (
							- 5.0/2 * zeta2
							- 5.0/8 * GHPLs1[2] * HPLs1[0]
							+ 5.0/8 * GHPLs2[0*4+2]
							+ 5.0/8 * GHPLs1[3] * HPLs1[0]
							- 5.0/8 * GHPLs2[0*4+3]
							+ 5.0/8 * GHPLs2[2*4+0]
							- 5.0/8 * GHPLs1[0] * HPLs1[0]
							- 5.0/8 * GHPLs1[0] * HPLs1[1]
							- 5.0/8 * GHPLs2[2*4+1]
							+ 5.0/8 * GHPLs1[1] * HPLs1[0]
							+ 5.0/8 * GHPLs1[1] * HPLs1[1]
							+ 5.0/8 * HPLs2[0*2+0]
							+ 5.0/8 * HPLs2[0*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -4) * (
									  + 9.0/4 * zeta3
									  + 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 9.0/4 * GHPLs1[2] * zeta2
									  + 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  - 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  + 9.0/4 * GHPLs1[0] * zeta2
									  - 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  - 9 * HPLs1[0] * zeta2
									  + 9.0/4 * HPLs3[0*2*2+0*2+0]
									  + 9.0/4 * HPLs3[0*2*2+1*2+0]
									  + 9.0/4 * HPLs1[1] * zeta2
									  - 9.0/4 * HPLs3[0*2*2+0*2+1]
									  - 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -3) * (
									  - 9 * zeta2
									  - 9.0/4 * zeta3
									  - 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  + 9.0/4 * GHPLs1[2] * zeta2
									  - 9.0/4 * GHPLs1[2] * HPLs1[0]
									  - 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs2[0*4+2]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  + 9.0/4 * GHPLs1[3] * HPLs1[0]
									  - 9.0/4 * GHPLs2[0*4+3]
									  + 9.0/4 * GHPLs2[2*4+0]
									  + 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 9.0/4 * GHPLs1[0] * zeta2
									  - 9.0/4 * GHPLs1[0] * HPLs1[0]
									  + 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs1[0] * HPLs1[1]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  - 9.0/4 * GHPLs2[2*4+1]
									  + 9.0/4 * GHPLs1[1] * HPLs1[0]
									  + 9.0/4 * GHPLs1[1] * HPLs1[1]
									  + 9 * HPLs1[0] * zeta2
									  + 9.0/4 * HPLs2[0*2+0]
									  - 9.0/4 * HPLs3[0*2*2+0*2+0]
									  - 9.0/4 * HPLs3[0*2*2+1*2+0]
									  - 9.0/4 * HPLs1[1] * zeta2
									  + 9.0/4 * HPLs2[0*2+1]
									  + 9.0/4 * HPLs3[0*2*2+0*2+1]
									  + 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -2) * (
									  + 9.0/2 * zeta2
									  + 9.0/8 * GHPLs1[2] * HPLs1[0]
									  - 9.0/8 * GHPLs2[0*4+2]
									  - 9.0/8 * GHPLs1[3] * HPLs1[0]
									  + 9.0/8 * GHPLs2[0*4+3]
									  - 9.0/8 * GHPLs2[2*4+0]
									  + 9.0/8 * GHPLs1[0] * HPLs1[0]
									  + 9.0/8 * GHPLs1[0] * HPLs1[1]
									  + 9.0/8 * GHPLs2[2*4+1]
									  - 9.0/8 * GHPLs1[1] * HPLs1[0]
									  - 9.0/8 * GHPLs1[1] * HPLs1[1]
									  - 9.0/8 * HPLs2[0*2+0]
									  - 9.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -1) * (
									  + 3.0/2 * zeta2
									  + 3.0/8 * GHPLs1[2] * HPLs1[0]
									  - 3.0/8 * GHPLs2[0*4+2]
									  - 3.0/8 * GHPLs1[3] * HPLs1[0]
									  + 3.0/8 * GHPLs2[0*4+3]
									  - 3.0/8 * GHPLs2[2*4+0]
									  + 3.0/8 * GHPLs1[0] * HPLs1[0]
									  + 3.0/8 * GHPLs1[0] * HPLs1[1]
									  + 3.0/8 * GHPLs2[2*4+1]
									  - 3.0/8 * GHPLs1[1] * HPLs1[0]
									  - 3.0/8 * GHPLs1[1] * HPLs1[1]
									  - 3.0/8 * HPLs2[0*2+0]
									  - 3.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * (
								     - 1.0/4 * GHPLs3[3*4*4+2*4+2]
								     - 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
								     + 1.0/4 * GHPLs1[2] * HPLs1[0]
								     - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/4 * GHPLs3[3*4*4+0*4+2]
								     - 1.0/4 * GHPLs2[1*4+2]
								     + 1.0/8 * GHPLs2[1*4+0]
								     - 1.0/4 * GHPLs3[3*4*4+2*4+1]
								     - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
								     + 1.0/4 * GHPLs1[1]
								     + 1.0/2 * GHPLs1[1] * zeta2
								     - 1.0/8 * GHPLs1[1] * HPLs1[0]
								     + 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
								     + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
								     - 1.0/4 * GHPLs3[3*4*4+0*4+1]
								     + 1.0/8 * GHPLs2[1*4+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * v * (
									 + 1.0/4 * GHPLs3[3*4*4+2*4+2]
									 + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
									 - 1.0/4 * GHPLs1[2] * HPLs1[0]
									 + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									 - 1.0/4 * GHPLs3[3*4*4+0*4+2]
									 + 1.0/4 * GHPLs2[1*4+2]
									 - 1.0/8 * GHPLs2[1*4+0]
									 + 1.0/4 * GHPLs3[3*4*4+2*4+1]
									 + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
									 - 1.0/8 * GHPLs1[1]
									 - 1.0/2 * GHPLs1[1] * zeta2
									 + 1.0/8 * GHPLs1[1] * HPLs1[0]
									 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
									 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
									 + 1.0/4 * GHPLs3[3*4*4+0*4+1]
									 - 1.0/8 * GHPLs2[1*4+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 2) * (
										 + 1.0/8 * GHPLs2[1*4+2]
										 - 1.0/8 * GHPLs2[2*4+3]
										 + 1.0/8 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3] * HPLs1[0]
										 + 1.0/8 * GHPLs1[3] * HPLs1[1]
										 - 1.0/8 * GHPLs2[0*4+3]
										 - 1.0/8 * GHPLs1[1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 3) * (
										 - 1.0/8 * GHPLs2[1*4+2]
										 + 1.0/8 * GHPLs2[2*4+3]
										 - 1.0/8 * GHPLs2[3*4+3]
										 - 1.0/8 * GHPLs1[3] * HPLs1[0]
										 - 1.0/8 * GHPLs1[3] * HPLs1[1]
										 + 1.0/8 * GHPLs2[0*4+3]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(u + v, -1) * (
										      - 1.0/8 * GHPLs1[1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * (
								     + 3.0/8
								     + 1.0/2 * zeta2
								     - 1.0/2 * GHPLs2[3*4+2]
								     - 3.0/2 * GHPLs1[2] * HPLs1[0]
								     + GHPLs2[1*4+2]
								     - 1.0/2 * GHPLs2[1*4+0]
								     - 3.0/4 * GHPLs1[1]
								     + 1.0/2 * GHPLs1[1] * HPLs1[0]
								     - 1.0/2 * GHPLs2[1*4+1]
								     + 1.0/8 * HPLs1[0]
								     + 1.0/4 * HPLs2[0*2+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * v * (
									 - 3.0/8
									 - 1.0/2 * zeta2
									 - 1.0/4 * GHPLs3[3*4*4+2*4+2]
									 - 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
									 + 1.0/4 * GHPLs2[3*4+2]
									 + 1.0/8 * GHPLs1[2]
									 + 1.0/2 * GHPLs1[2] * HPLs1[0]
									 - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									 + 1.0/4 * GHPLs3[3*4*4+0*4+2]
									 - 1.0/2 * GHPLs2[1*4+2]
									 + 1.0/4 * GHPLs2[2*4+3]
									 - 1.0/4 * GHPLs2[3*4+3]
									 - 3.0/8 * GHPLs1[3]
									 - 1.0/4 * GHPLs1[3] * HPLs1[0]
									 - 1.0/4 * GHPLs1[3] * HPLs1[1]
									 + 1.0/4 * GHPLs2[0*4+3]
									 + 1.0/4 * GHPLs2[3*4+0]
									 + 1.0/8 * GHPLs1[0]
									 + 1.0/8 * GHPLs2[1*4+0]
									 - 1.0/4 * GHPLs3[3*4*4+2*4+1]
									 - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
									 - 3.0/8 * GHPLs1[1]
									 + 1.0/2 * GHPLs1[1] * zeta2
									 - 1.0/8 * GHPLs1[1] * HPLs1[0]
									 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
									 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
									 - 1.0/4 * GHPLs3[3*4*4+0*4+1]
									 + 1.0/8 * GHPLs2[1*4+1]
									 - 1.0/4 * HPLs2[0*2+0]
									 - 1.0/8 * HPLs1[1]
									 - 1.0/4 * HPLs2[0*2+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(v, 2) * (
										 - 1.0/8 * GHPLs1[2]
										 - 1.0/4 * GHPLs2[1*4+2]
										 + 1.0/4 * GHPLs2[2*4+3]
										 - 1.0/4 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3]
										 - 1.0/4 * GHPLs1[3] * HPLs1[0]
										 - 1.0/4 * GHPLs1[3] * HPLs1[1]
										 + 1.0/4 * GHPLs2[0*4+3]
										 - 1.0/8 * GHPLs1[0]
										 + 1.0/4 * GHPLs1[1]
										 + 1.0/8 * HPLs1[0]
										 + 1.0/8 * HPLs1[1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(v, 3) * (
										 + 1.0/8 * GHPLs2[1*4+2]
										 - 1.0/8 * GHPLs2[2*4+3]
										 + 1.0/8 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3] * HPLs1[0]
										 + 1.0/8 * GHPLs1[3] * HPLs1[1]
										 - 1.0/8 * GHPLs2[0*4+3]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(1. - u, -1) * (
									  - 1.0/2 * GHPLs1[3]
									  - 1.0/2 * HPLs1[0]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(1. - v, -1) * (
									  - 3.0/4 * zeta2
									  + 3.0/4 * GHPLs1[2] * HPLs1[0]
									  - 9.0/8 * GHPLs2[1*4+2]
									  - 7.0/8 * GHPLs1[3]
									  - 3.0/8 * GHPLs1[0] * HPLs1[0]
									  + 9.0/8 * GHPLs2[1*4+0]
									  + 5.0/4 * GHPLs1[1]
									  - 1.0/16 * HPLs1[0]
									  + 3.0/8 * HPLs2[1*2+0]
									  - 3.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u + v, -2) * (
									 - 1.0/8 * GHPLs1[2] * HPLs1[0]
									 + 1.0/8 * GHPLs2[1*4+2]
									 + 1.0/8 * GHPLs2[1*4+0]
									 + 1.0/8 * HPLs2[0*2+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u + v, -1) * (
									 + 1.0/16
									 + 1.0/2 * GHPLs1[2] * HPLs1[0]
									 - 1.0/2 * GHPLs2[1*4+2]
									 - 1.0/2 * GHPLs2[1*4+0]
									 + 1.0/8 * GHPLs1[1]
									 - 1.0/8 * HPLs1[0]
									 - 1.0/2 * HPLs2[0*2+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(1. - u - v, -1) * (
									      - 1.0/2 * GHPLs1[3]
									      - 1.0/2 * HPLs1[0]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * (
							- 17.0/32
							+ 5.0/8 * zeta2
							+ zeta3
							+ 1.0/4 * GHPLs3[3*4*4+2*4+2]
							+ 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
							- GHPLs2[3*4+2]
							- 3.0/8 * GHPLs1[2]
							- 11.0/8 * GHPLs1[2] * HPLs1[0]
							+ 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							- 1.0/4 * GHPLs3[3*4*4+0*4+2]
							+ 3.0/4 * GHPLs2[1*4+2]
							+ 1.0/4 * GHPLs3[3*4*4+2*4+3]
							+ 1.0/4 * GHPLs2[2*4+3] * HPLs1[0]
							+ 1.0/2 * GHPLs3[3*4*4+3*4+3]
							- 3.0/8 * GHPLs2[3*4+3]
							+ 1.0/2 * GHPLs2[3*4+3] * HPLs1[0]
							- 1.0/2 * GHPLs3[0*4*4+3*4+3]
							+ 45.0/16 * GHPLs1[3]
							- 1.0/4 * GHPLs1[3] * zeta2
							+ 3.0/4 * GHPLs1[3] * HPLs2[0*2+0]
							- 1.0/4 * GHPLs1[3] * HPLs2[0*2+1]
							- 1.0/4 * GHPLs3[3*4*4+0*4+3]
							- 1.0/2 * GHPLs2[0*4+3] * HPLs1[0]
							- 1.0/2 * GHPLs2[2*4+0] * HPLs1[0]
							+ 1.0/2 * GHPLs3[1*4*4+2*4+0]
							- 1.0/2 * GHPLs3[3*4*4+3*4+0]
							+ 3.0/8 * GHPLs2[3*4+0]
							- 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
							- 3.0/8 * GHPLs1[0]
							+ 3.0/8 * GHPLs1[0] * HPLs1[0]
							- 1.0/2 * GHPLs1[0] * HPLs2[0*2+0]
							- 1.0/2 * GHPLs3[1*4*4+0*4+0]
							- 3.0/8 * GHPLs2[1*4+0]
							+ 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
							- 1.0/2 * GHPLs3[1*4*4+1*4+0]
							+ 1.0/4 * GHPLs3[3*4*4+2*4+1]
							+ 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							- 1.0/8 * GHPLs1[1]
							- 1.0/2 * GHPLs1[1] * zeta2
							- 3.0/8 * GHPLs1[1] * HPLs1[0]
							- 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
							- 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							+ 1.0/4 * GHPLs3[3*4*4+0*4+1]
							+ 3.0/8 * GHPLs2[1*4+1]
							+ 2 * HPLs1[0]
							- 1.0/4 * HPLs1[0] * zeta2
							+ 3.0/4 * HPLs3[0*2*2+0*2+0]
							- 3.0/8 * HPLs2[1*2+0]
							- 1.0/4 * HPLs3[0*2*2+1*2+0]
							+ 3.0/8 * HPLs1[1]
							+ 7.0/8 * HPLs2[0*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * pow(1. - u, -2) * (
									      + zeta2
									      - 1.0/2 * GHPLs2[3*4+2]
									      - 1.0/2 * GHPLs1[2] * HPLs1[0]
									      - 1.0/2 * GHPLs2[3*4+0]
									      + 1.0/2 * HPLs2[0*2+0]
									      + 1.0/2 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * pow(1. - u, -1) * (
									      - 1.0/2 * zeta2
									      + 1.0/4 * GHPLs2[3*4+2]
									      + 1.0/4 * GHPLs1[2] * HPLs1[0]
									      - 1.0/2 * GHPLs1[3]
									      + 1.0/4 * GHPLs2[3*4+0]
									      - 1.0/4 * HPLs2[0*2+0]
									      - 1.0/4 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * (
							    + 1.0/8 * zeta2
							    - 1.0/2 * GHPLs1[2]
							    - 1.0/8 * GHPLs2[1*4+2]
							    + 1.0/8 * GHPLs2[2*4+3]
							    - 1.0/8 * GHPLs2[3*4+3]
							    + 5.0/8 * GHPLs1[3]
							    - 1.0/8 * GHPLs1[3] * HPLs1[0]
							    - 1.0/8 * GHPLs1[3] * HPLs1[1]
							    + 1.0/8 * GHPLs2[0*4+3]
							    + 1.0/8 * GHPLs2[3*4+0]
							    - 1.0/2 * GHPLs1[0]
							    + 1.0/8 * GHPLs1[0] * HPLs1[0]
							    - 1.0/8 * GHPLs2[2*4+1]
							    + 5.0/8 * GHPLs1[1]
							    + 1.0/8 * GHPLs1[1] * HPLs1[1]
							    - 1.0/8 * GHPLs2[0*4+1]
							    + 1.0/8 * GHPLs2[1*4+1]
							    + 5.0/8 * HPLs1[0]
							    - 1.0/8 * HPLs2[0*2+0]
							    - 1.0/8 * HPLs2[1*2+0]
							    + 1.0/2 * HPLs1[1]
							    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(v, 2) * (
								    + 1.0/8 * GHPLs1[2]
								    + 1.0/4 * GHPLs2[1*4+2]
								    - 1.0/4 * GHPLs2[2*4+3]
								    + 1.0/4 * GHPLs2[3*4+3]
								    - 1.0/8 * GHPLs1[3]
								    + 1.0/4 * GHPLs1[3] * HPLs1[0]
								    + 1.0/4 * GHPLs1[3] * HPLs1[1]
								    - 1.0/4 * GHPLs2[0*4+3]
								    + 1.0/8 * GHPLs1[0]
								    - 1.0/8 * GHPLs1[1]
								    - 1.0/8 * HPLs1[0]
								    - 1.0/8 * HPLs1[1]
								    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - v, -2) * (
									      + 17.0/4 * zeta2
									      - 2 * GHPLs2[3*4+2]
									      - 9.0/4 * GHPLs1[2] * HPLs1[0]
									      + 19.0/8 * GHPLs2[1*4+2]
									      + 21.0/8 * GHPLs1[3]
									      + 2 * GHPLs2[3*4+0]
									      + 17.0/8 * GHPLs1[0] * HPLs1[0]
									      - 19.0/8 * GHPLs2[1*4+0]
									      - 21.0/8 * GHPLs1[1]
									      + 39.0/16 * HPLs1[0]
									      - 2 * HPLs2[0*2+0]
									      - 17.0/8 * HPLs2[1*2+0]
									      + 17.0/8 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - v, -1) * (
									      + 5.0/16
									      - 17.0/4 * zeta2
									      + 2 * GHPLs2[3*4+2]
									      + 17.0/8 * GHPLs1[2]
									      + 9.0/4 * GHPLs1[2] * HPLs1[0]
									      - 19.0/8 * GHPLs2[1*4+2]
									      - 37.0/8 * GHPLs1[3]
									      - 2 * GHPLs2[3*4+0]
									      + 17.0/8 * GHPLs1[0]
									      - 17.0/8 * GHPLs1[0] * HPLs1[0]
									      + 19.0/8 * GHPLs2[1*4+0]
									      + 1.0/4 * GHPLs1[1]
									      - 71.0/16 * HPLs1[0]
									      + 2 * HPLs2[0*2+0]
									      + 17.0/8 * HPLs2[1*2+0]
									      - 17.0/8 * HPLs1[1]
									      - 17.0/8 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(u + v, -2) * (
									     - 1.0/16
									     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(u + v, -1) * (
									     - 7.0/16
									     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - u - v, -1) * (
										  + 1.0/4 * GHPLs1[3]
										  + 1.0/4 * HPLs1[0]
										  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * (
							    - 3.0/8
							    - 5.0/4 * GHPLs1[2]
							    + 5.0/4 * GHPLs1[3]
							    - 5.0/4 * GHPLs1[0]
							    + 5.0/4 * GHPLs1[1]
							    + 5.0/4 * HPLs1[0]
							    + 5.0/4 * HPLs1[1]
							    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * v * (
								- 1.0/8 * zeta2
								+ 3.0/8 * GHPLs1[2]
								+ 1.0/8 * GHPLs2[1*4+2]
								- 1.0/8 * GHPLs2[2*4+3]
								+ 1.0/8 * GHPLs2[3*4+3]
								- 3.0/8 * GHPLs1[3]
								+ 1.0/8 * GHPLs1[3] * HPLs1[0]
								+ 1.0/8 * GHPLs1[3] * HPLs1[1]
								- 1.0/8 * GHPLs2[0*4+3]
								- 1.0/8 * GHPLs2[3*4+0]
								+ 3.0/8 * GHPLs1[0]
								- 1.0/8 * GHPLs1[0] * HPLs1[0]
								+ 1.0/8 * GHPLs2[2*4+1]
								- 3.0/8 * GHPLs1[1]
								- 1.0/8 * GHPLs1[1] * HPLs1[1]
								+ 1.0/8 * GHPLs2[0*4+1]
								- 1.0/8 * GHPLs2[1*4+1]
								- 3.0/8 * HPLs1[0]
								+ 1.0/8 * HPLs2[0*2+0]
								+ 1.0/8 * HPLs2[1*2+0]
								- 3.0/8 * HPLs1[1]
								)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -3) * (
										      - 15.0/2 * zeta2
										      + 15.0/4 * GHPLs2[3*4+2]
										      + 15.0/4 * GHPLs1[2] * HPLs1[0]
										      - 15.0/4 * GHPLs2[1*4+2]
										      - 9.0/4 * GHPLs1[3]
										      - 15.0/4 * GHPLs2[3*4+0]
										      - 15.0/4 * GHPLs1[0] * HPLs1[0]
										      + 15.0/4 * GHPLs2[1*4+0]
										      + 9.0/4 * GHPLs1[1]
										      - 9.0/4 * HPLs1[0]
										      + 15.0/4 * HPLs2[0*2+0]
										      + 15.0/4 * HPLs2[1*2+0]
										      - 15.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -2) * (
										      + 15.0/2 * zeta2
										      - 15.0/4 * GHPLs2[3*4+2]
										      - 15.0/4 * GHPLs1[2]
										      - 15.0/4 * GHPLs1[2] * HPLs1[0]
										      + 15.0/4 * GHPLs2[1*4+2]
										      + 6 * GHPLs1[3]
										      + 15.0/4 * GHPLs2[3*4+0]
										      - 15.0/4 * GHPLs1[0]
										      + 15.0/4 * GHPLs1[0] * HPLs1[0]
										      - 15.0/4 * GHPLs2[1*4+0]
										      + 3.0/2 * GHPLs1[1]
										      + 6 * HPLs1[0]
										      - 15.0/4 * HPLs2[0*2+0]
										      - 15.0/4 * HPLs2[1*2+0]
										      + 15.0/4 * HPLs1[1]
										      + 15.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -1) * (
										      + 15.0/8 * GHPLs1[2]
										      - 15.0/8 * GHPLs1[3]
										      + 15.0/8 * GHPLs1[0]
										      - 15.0/8 * GHPLs1[1]
										      - 15.0/8 * HPLs1[0]
										      - 15.0/8 * HPLs1[1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * (
								    + 5.0/8 * GHPLs1[2]
								    - 5.0/8 * GHPLs1[3]
								    + 5.0/8 * GHPLs1[0]
								    - 5.0/8 * GHPLs1[1]
								    - 5.0/8 * HPLs1[0]
								    - 5.0/8 * HPLs1[1]
								    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -4) * (
										      + 9.0/2 * zeta2
										      - 9.0/4 * GHPLs2[3*4+2]
										      - 9.0/4 * GHPLs1[2] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+2]
										      + 9.0/4 * GHPLs2[3*4+0]
										      + 9.0/4 * GHPLs1[0] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+0]
										      - 9.0/4 * HPLs2[0*2+0]
										      - 9.0/4 * HPLs2[1*2+0]
										      + 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -3) * (
										      - 9.0/2 * zeta2
										      + 9.0/4 * GHPLs2[3*4+2]
										      + 9.0/4 * GHPLs1[2]
										      + 9.0/4 * GHPLs1[2] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+2]
										      - 9.0/4 * GHPLs1[3]
										      - 9.0/4 * GHPLs2[3*4+0]
										      + 9.0/4 * GHPLs1[0]
										      - 9.0/4 * GHPLs1[0] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+0]
										      - 9.0/4 * GHPLs1[1]
										      - 9.0/4 * HPLs1[0]
										      + 9.0/4 * HPLs2[0*2+0]
										      + 9.0/4 * HPLs2[1*2+0]
										      - 9.0/4 * HPLs1[1]
										      - 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -2) * (
										      - 9.0/8 * GHPLs1[2]
										      + 9.0/8 * GHPLs1[3]
										      - 9.0/8 * GHPLs1[0]
										      + 9.0/8 * GHPLs1[1]
										      + 9.0/8 * HPLs1[0]
										      + 9.0/8 * HPLs1[1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -1) * (
										      - 3.0/8 * GHPLs1[2]
										      + 3.0/8 * GHPLs1[3]
										      - 3.0/8 * GHPLs1[0]
										      + 3.0/8 * GHPLs1[1]
										      + 3.0/8 * HPLs1[0]
										      + 3.0/8 * HPLs1[1]
										      )

    + C_F * dN_f * pow(1. - v, -1) * (
				    - 1.0/2 * zeta2
				    - 1.0/2 * GHPLs1[0] * HPLs1[0]
				    + 17.0/12 * HPLs1[0]
				    + HPLs2[0*2+0]
				    - 1.0/2 * HPLs2[0*2+1]
				    )

    + C_F * dN_f * (
		  + 4769.0/1296
		  + 1.0/36 * zeta2
		  - 13.0/36 * zeta3
		  - 1.0/3 * GHPLs2[3*4+3] * HPLs1[0]
		  + 1.0/3 * GHPLs3[0*4*4+3*4+3]
		  + 2.0/3 * GHPLs1[3] * zeta2
		  + 19.0/18 * GHPLs1[3] * HPLs1[0]
		  + 1.0/3 * GHPLs1[3] * HPLs2[0*2+0]
		  - 19.0/18 * GHPLs2[0*4+3]
		  - 1.0/3 * GHPLs2[0*4+3] * HPLs1[0]
		  + 1.0/3 * GHPLs3[0*4*4+0*4+3]
		  - 1.0/6 * GHPLs1[0]
		  + 1.0/3 * GHPLs1[0] * zeta2
		  - 5.0/9 * GHPLs1[0] * HPLs1[0]
		  - 2.0/3 * GHPLs1[0] * HPLs2[0*2+0]
		  + 1.0/3 * GHPLs1[0] * HPLs2[0*2+1]
		  + 1.0/3 * GHPLs2[0*4+0] * HPLs1[0]
		  - 4.0/27 * HPLs1[0]
		  + 7.0/12 * HPLs1[0] * zeta2
		  + 1.0/18 * HPLs2[0*2+0]
		  + 2.0/3 * HPLs3[0*2*2+0*2+0]
		  - 1.0/3 * HPLs3[0*2*2+1*2+0]
		  + 1.0/3 * HPLs1[1] * zeta2
		  - 5.0/9 * HPLs2[0*2+1]
		  - 2.0/3 * HPLs3[0*2*2+0*2+1]
		  + 1.0/3 * HPLs3[0*2*2+1*2+1]
		  )

    + C_F * dN_f * u * pow(1. - v, -2) * (
					+ 1.0/6 * zeta2
					+ 1.0/6 * GHPLs1[0] * HPLs1[0]
					- 13.0/36 * HPLs1[0]
					- 1.0/3 * HPLs2[0*2+0]
					+ 1.0/6 * HPLs2[0*2+1]
					)

    + C_F * dN_f * u * pow(1. - v, -1) * (
					- 19.0/36
					- 1.0/6 * zeta2
					+ 1.0/6 * GHPLs1[0]
					- 1.0/6 * GHPLs1[0] * HPLs1[0]
					+ 7.0/36 * HPLs1[0]
					+ 1.0/3 * HPLs2[0*2+0]
					- 1.0/6 * HPLs2[0*2+1]
					)

    + C_F * dN_f * ri * M_PI * (
			      + 119.0/108
			      + 1.0/4 * zeta2
			      + 1.0/3 * GHPLs2[3*4+3]
			      - 19.0/18 * GHPLs1[3]
			      - 19.0/18 * HPLs1[0]
			      - 1.0/3 * HPLs2[0*2+0]
			      );
  return beta;
}

double_complex pplla03_amplitude_set::beta_2_2() {
  //  const double zeta2 = M_PI * M_PI/6;
  //  const double zeta3 = 1.20205690315959429;
  //  const double zeta4 = pow(M_PI,4)/90;
  //  const double dN_c=3;
  //  const double C_F=(dN_c * dN_c - 1.) / (2 * dN_c);
  //  double NF=(double)n_f;

  double_complex beta =
    (dN_c * dN_c - 1.) * pow(u, -2) * (
				       + 1.0/2 * GHPLs2[2*4+2] * zeta2
				       - 13.0/24 * GHPLs2[2*4+2] * HPLs1[0]
				       - 1.0/2 * GHPLs2[2*4+2] * HPLs2[1*2+0]
				       - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
				       + 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
				       + 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
				       - 13.0/24 * GHPLs1[2] * zeta2
				       + 277.0/144 * GHPLs1[2] * HPLs1[0]
				       + 11.0/6 * GHPLs1[2] * HPLs2[0*2+0]
				       + 13.0/24 * GHPLs1[2] * HPLs2[1*2+0]
				       + 1.0/2 * GHPLs3[2*4*4+0*4+2] * HPLs1[0]
				       + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
				       - 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
				       - 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
				       + 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
				       - GHPLs2[1*4+2] * zeta2
				       + 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
				       - 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
				       + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
				       - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
				       - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
				       - 13.0/24 * GHPLs3[2*4*4+2*4+1]
				       + 1.0/2 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
				       + 277.0/144 * GHPLs2[2*4+1]
				       - GHPLs2[2*4+1] * zeta2
				       + 11.0/12 * GHPLs2[2*4+1] * HPLs1[0]
				       + 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
				       + 13.0/24 * GHPLs2[2*4+1] * HPLs1[1]
				       - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
				       + 3.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
				       - 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
				       - 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
				       - 67.0/24 * GHPLs1[1] * zeta2
				       - 3.0/4 * GHPLs1[1] * zeta3
				       - 277.0/144 * GHPLs1[1] * HPLs1[0]
				       - 11.0/6 * GHPLs1[1] * HPLs2[0*2+0]
				       - 35.0/24 * GHPLs1[1] * HPLs2[1*2+0]
				       - 277.0/144 * GHPLs1[1] * HPLs1[1]
				       + GHPLs1[1] * HPLs1[1] * zeta2
				       - 11.0/12 * GHPLs1[1] * HPLs2[0*2+1]
				       - 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
				       - 13.0/24 * GHPLs1[1] * HPLs2[1*2+1]
				       + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
				       - 1.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[0]
				       - 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
				       + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
				       + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
				       + 1.0/2 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
				       - 13.0/24 * GHPLs3[2*4*4+1*4+1]
				       - 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
				       - 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
				       - 1.0/2 * GHPLs2[1*4+1] * zeta2
				       + 13.0/24 * GHPLs2[1*4+1] * HPLs1[0]
				       + 13.0/24 * GHPLs2[1*4+1] * HPLs1[1]
				       + 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
				       + 1.0/2 * GHPLs2[1*4+1] * HPLs2[1*2+1]
				       - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
				       + 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
				       + 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
				       )

    + (dN_c * dN_c - 1.) * pow(u, -2) * v * (
					     - 1.0/2 * GHPLs2[2*4+2] * zeta2
					     + 13.0/24 * GHPLs2[2*4+2] * HPLs1[0]
					     + 1.0/2 * GHPLs2[2*4+2] * HPLs2[1*2+0]
					     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
					     - 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
					     - 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
					     + 13.0/24 * GHPLs1[2] * zeta2
					     - 277.0/144 * GHPLs1[2] * HPLs1[0]
					     - 11.0/6 * GHPLs1[2] * HPLs2[0*2+0]
					     - 13.0/24 * GHPLs1[2] * HPLs2[1*2+0]
					     - 1.0/2 * GHPLs3[2*4*4+0*4+2] * HPLs1[0]
					     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
					     + 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
					     + 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
					     - 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
					     + GHPLs2[1*4+2] * zeta2
					     - 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
					     + 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
					     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
					     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
					     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
					     + 13.0/24 * GHPLs3[2*4*4+2*4+1]
					     - 1.0/2 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
					     - 277.0/144 * GHPLs2[2*4+1]
					     + GHPLs2[2*4+1] * zeta2
					     - 11.0/12 * GHPLs2[2*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
					     - 13.0/24 * GHPLs2[2*4+1] * HPLs1[1]
					     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					     - 3.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
					     + 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
					     + 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
					     + 67.0/24 * GHPLs1[1] * zeta2
					     + 3.0/4 * GHPLs1[1] * zeta3
					     + 277.0/144 * GHPLs1[1] * HPLs1[0]
					     + 11.0/6 * GHPLs1[1] * HPLs2[0*2+0]
					     + 35.0/24 * GHPLs1[1] * HPLs2[1*2+0]
					     + 277.0/144 * GHPLs1[1] * HPLs1[1]
					     - GHPLs1[1] * HPLs1[1] * zeta2
					     + 11.0/12 * GHPLs1[1] * HPLs2[0*2+1]
					     + 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
					     + 13.0/24 * GHPLs1[1] * HPLs2[1*2+1]
					     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					     + 1.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[0]
					     + 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
					     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
					     - 1.0/2 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
					     + 13.0/24 * GHPLs3[2*4*4+1*4+1]
					     + 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
					     + 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
					     + 1.0/2 * GHPLs2[1*4+1] * zeta2
					     - 13.0/24 * GHPLs2[1*4+1] * HPLs1[0]
					     - 13.0/24 * GHPLs2[1*4+1] * HPLs1[1]
					     - 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
					     - 1.0/2 * GHPLs2[1*4+1] * HPLs2[1*2+1]
					     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
					     - 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
					     - 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
					     )

    + (dN_c * dN_c - 1.) * pow(u, -1) * (
					 + 1.0/2
					 - 10.0/3 * zeta2
					 - 3.0/4 * zeta3
					 - 13.0/24 * GHPLs2[2*4+2]
					 + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
					 + 277.0/144 * GHPLs1[2]
					 - 3.0/4 * GHPLs1[2] * zeta2
					 + 3.0/8 * GHPLs1[2] * HPLs1[0]
					 + 13.0/24 * GHPLs1[2] * HPLs1[1]
					 - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
					 + 1.0/4 * GHPLs3[2*4*4+1*4+2]
					 - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
					 - 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
					 + 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
					 + 1.0/4 * GHPLs3[2*4*4+1*4+0]
					 - 1.0/4 * GHPLs2[1*4+0] * HPLs1[0]
					 - 1.0/4 * GHPLs2[1*4+0] * HPLs1[1]
					 + 1.0/4 * GHPLs3[2*4*4+2*4+1]
					 - 13.0/24 * GHPLs2[2*4+1]
					 - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
					 - 1.0/4 * GHPLs2[2*4+1] * HPLs1[1]
					 - 1.0/4 * GHPLs1[1] * zeta2
					 + 13.0/24 * GHPLs1[1] * HPLs1[0]
					 + 13.0/24 * GHPLs1[1] * HPLs1[1]
					 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
					 + 1.0/4 * GHPLs1[1] * HPLs2[1*2+1]
					 - 1.0/4 * GHPLs3[2*4*4+1*4+1]
					 + 1.0/4 * GHPLs2[1*4+1] * HPLs1[0]
					 + 1.0/4 * GHPLs2[1*4+1] * HPLs1[1]
					 - 11.0/12 * HPLs2[1*2+0]
					 - 277.0/144 * HPLs1[1]
					 + HPLs1[1] * zeta2
					 - 11.0/12 * HPLs2[0*2+1]
					 - 1.0/4 * HPLs3[1*2*2+0*2+1]
					 - 13.0/24 * HPLs2[1*2+1]
					 + 1.0/4 * HPLs3[0*2*2+1*2+1]
					 )

    + (dN_c * dN_c - 1.) * pow(u, -1) * v * (
					     + 67.0/24 * zeta2
					     + 3.0/4 * zeta3
					     + 13.0/24 * GHPLs2[2*4+2]
					     + 1.0/2 * GHPLs2[2*4+2] * zeta2
					     - 25.0/24 * GHPLs2[2*4+2] * HPLs1[0]
					     - 1.0/2 * GHPLs2[2*4+2] * HPLs2[1*2+0]
					     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
					     + 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
					     + 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
					     - 277.0/144 * GHPLs1[2]
					     + 11.0/24 * GHPLs1[2] * zeta2
					     + 127.0/144 * GHPLs1[2] * HPLs1[0]
					     + 11.0/6 * GHPLs1[2] * HPLs2[0*2+0]
					     + 7.0/24 * GHPLs1[2] * HPLs2[1*2+0]
					     - 13.0/24 * GHPLs1[2] * HPLs1[1]
					     + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
					     + 1.0/2 * GHPLs3[2*4*4+0*4+2] * HPLs1[0]
					     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
					     - 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
					     - 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
					     - 3.0/4 * GHPLs3[2*4*4+1*4+2]
					     + 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
					     - GHPLs2[1*4+2] * zeta2
					     + 3.0/4 * GHPLs2[1*4+2] * HPLs1[0]
					     + 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
					     + 3.0/4 * GHPLs2[1*4+2] * HPLs1[1]
					     - 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
					     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
					     - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
					     - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
					     + 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
					     + 1.0/4 * GHPLs3[2*4*4+1*4+0]
					     - 1.0/4 * GHPLs2[1*4+0] * HPLs1[0]
					     - 1.0/4 * GHPLs2[1*4+0] * HPLs1[1]
					     - 25.0/24 * GHPLs3[2*4*4+2*4+1]
					     + 1.0/2 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
					     + 337.0/144 * GHPLs2[2*4+1]
					     - GHPLs2[2*4+1] * zeta2
					     + 17.0/12 * GHPLs2[2*4+1] * HPLs1[0]
					     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
					     + 25.0/24 * GHPLs2[2*4+1] * HPLs1[1]
					     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					     + 3.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
					     - 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
					     - 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
					     - 55.0/24 * GHPLs1[1] * zeta2
					     - 3.0/4 * GHPLs1[1] * zeta3
					     - 337.0/144 * GHPLs1[1] * HPLs1[0]
					     - 11.0/6 * GHPLs1[1] * HPLs2[0*2+0]
					     - 35.0/24 * GHPLs1[1] * HPLs2[1*2+0]
					     - 337.0/144 * GHPLs1[1] * HPLs1[1]
					     + GHPLs1[1] * HPLs1[1] * zeta2
					     - 17.0/12 * GHPLs1[1] * HPLs2[0*2+1]
					     - 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
					     - 25.0/24 * GHPLs1[1] * HPLs2[1*2+1]
					     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					     - 1.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
					     + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
					     + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
					     + 1.0/2 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
					     - 1.0/24 * GHPLs3[2*4*4+1*4+1]
					     - 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
					     - 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
					     - 1.0/2 * GHPLs2[1*4+1] * zeta2
					     + 1.0/24 * GHPLs2[1*4+1] * HPLs1[0]
					     + 1.0/24 * GHPLs2[1*4+1] * HPLs1[1]
					     + 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
					     + 1.0/2 * GHPLs2[1*4+1] * HPLs2[1*2+1]
					     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
					     + 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
					     + 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
					     + 277.0/144 * HPLs1[0]
					     + 11.0/6 * HPLs2[0*2+0]
					     + 35.0/24 * HPLs2[1*2+0]
					     + 277.0/144 * HPLs1[1]
					     - HPLs1[1] * zeta2
					     + 11.0/12 * HPLs2[0*2+1]
					     + 1.0/4 * HPLs3[1*2*2+0*2+1]
					     + 13.0/24 * HPLs2[1*2+1]
					     - 1.0/4 * HPLs3[0*2*2+1*2+1]
					     )

    + (dN_c * dN_c - 1.) * pow(1. - v, -1) * (
					      - 13.0/16 * zeta2
					      + 3.0/8 * GHPLs1[2] * zeta2
					      - 15.0/16 * GHPLs1[2] * HPLs1[0]
					      - 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
					      - 3.0/8 * GHPLs3[2*4*4+1*4+2]
					      + 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
					      + 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
					      + 3.0/8 * GHPLs2[2*4+0] * HPLs1[0]
					      + 3.0/8 * GHPLs3[2*4*4+1*4+0]
					      - 3.0/8 * GHPLs2[1*4+0] * HPLs1[0]
					      - 3.0/8 * GHPLs2[1*4+0] * HPLs1[1]
					      - 1.0/8 * GHPLs2[2*4+1]
					      + 1.0/8 * GHPLs1[1] * HPLs1[0]
					      + 1.0/8 * GHPLs1[1] * HPLs1[1]
					      + 263.0/96 * HPLs1[0]
					      + 11.0/4 * HPLs2[0*2+0]
					      + 13.0/16 * HPLs2[1*2+0]
					      )

    + (dN_c * dN_c - 1.) * (
			    + 133.0/288
			    - 41.0/48 * zeta2
			    - 3.0/8 * zeta3
			    - 13.0/48 * GHPLs2[2*4+2]
			    + 1.0/8 * GHPLs2[2*4+2] * HPLs1[0]
			    + 157.0/288 * GHPLs1[2]
			    - 3.0/4 * GHPLs1[2] * zeta2
			    + GHPLs1[2] * HPLs1[0]
			    + 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
			    + 13.0/48 * GHPLs1[2] * HPLs1[1]
			    - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
			    + 1.0/2 * GHPLs3[2*4*4+1*4+2]
			    - 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
			    - 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
			    - 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
			    - 1.0/4 * GHPLs3[2*4*4+1*4+0]
			    + 1.0/4 * GHPLs2[1*4+0] * HPLs1[0]
			    + 1.0/4 * GHPLs2[1*4+0] * HPLs1[1]
			    + 1.0/8 * GHPLs3[2*4*4+2*4+1]
			    - 13.0/48 * GHPLs2[2*4+1]
			    - 1.0/8 * GHPLs2[2*4+1] * HPLs1[0]
			    - 1.0/8 * GHPLs2[2*4+1] * HPLs1[1]
			    - 1.0/8 * GHPLs1[1] * zeta2
			    + 13.0/48 * GHPLs1[1] * HPLs1[0]
			    + 13.0/48 * GHPLs1[1] * HPLs1[1]
			    + 1.0/8 * GHPLs1[1] * HPLs2[0*2+1]
			    + 1.0/8 * GHPLs1[1] * HPLs2[1*2+1]
			    - 1.0/8 * GHPLs3[2*4*4+1*4+1]
			    + 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
			    + 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
			    - 73.0/32 * HPLs1[0]
			    - 11.0/4 * HPLs2[0*2+0]
			    - 61.0/48 * HPLs2[1*2+0]
			    - 157.0/288 * HPLs1[1]
			    + 1.0/2 * HPLs1[1] * zeta2
			    - 11.0/24 * HPLs2[0*2+1]
			    - 1.0/8 * HPLs3[1*2*2+0*2+1]
			    - 13.0/48 * HPLs2[1*2+1]
			    + 1.0/8 * HPLs3[0*2*2+1*2+1]
			    )

    + (dN_c * dN_c - 1.) * v * pow(1. - u, -1) * (
						  - 55.0/48 * zeta2
						  - 3.0/8 * zeta3
						  - 25.0/48 * GHPLs2[2*4+2]
						  + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
						  + 355.0/288 * GHPLs1[2]
						  - 1.0/2 * GHPLs1[2] * zeta2
						  + 17.0/24 * GHPLs1[2] * HPLs1[0]
						  + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						  + 25.0/48 * GHPLs1[2] * HPLs1[1]
						  - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
						  + 3.0/8 * GHPLs3[2*4*4+1*4+2]
						  - 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						  - 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						  - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						  - 1.0/8 * GHPLs3[2*4*4+1*4+0]
						  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						  + 1.0/4 * GHPLs3[2*4*4+2*4+1]
						  - 1.0/48 * GHPLs2[2*4+1]
						  - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
						  - 1.0/4 * GHPLs2[2*4+1] * HPLs1[1]
						  - 1.0/4 * GHPLs1[1] * zeta2
						  + 1.0/48 * GHPLs1[1] * HPLs1[0]
						  + 1.0/48 * GHPLs1[1] * HPLs1[1]
						  + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
						  + 1.0/4 * GHPLs1[1] * HPLs2[1*2+1]
						  - 1.0/4 * GHPLs3[2*4*4+1*4+1]
						  + 1.0/4 * GHPLs2[1*4+1] * HPLs1[0]
						  + 1.0/4 * GHPLs2[1*4+1] * HPLs1[1]
						  - 355.0/288 * HPLs1[0]
						  - 11.0/12 * HPLs2[0*2+0]
						  - 35.0/48 * HPLs2[1*2+0]
						  - 355.0/288 * HPLs1[1]
						  + 1.0/2 * HPLs1[1] * zeta2
						  - 17.0/24 * HPLs2[0*2+1]
						  - 1.0/8 * HPLs3[1*2*2+0*2+1]
						  - 25.0/48 * HPLs2[1*2+1]
						  + 1.0/8 * HPLs3[0*2*2+1*2+1]
						  )

    + (dN_c * dN_c - 1.) * u * pow(1. - v, -2) * (
						  - 13.0/48 * zeta2
						  + 1.0/8 * GHPLs1[2] * zeta2
						  - 13.0/48 * GHPLs1[2] * HPLs1[0]
						  - 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						  - 1.0/8 * GHPLs3[2*4*4+1*4+2]
						  + 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						  + 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						  + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						  + 1.0/8 * GHPLs3[2*4*4+1*4+0]
						  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						  + 163.0/288 * HPLs1[0]
						  + 11.0/12 * HPLs2[0*2+0]
						  + 13.0/48 * HPLs2[1*2+0]
						  )

    + (dN_c * dN_c - 1.) * u * pow(1. - v, -1) * (
						  + 277.0/288
						  + 13.0/48 * zeta2
						  - 19.0/48 * GHPLs1[2]
						  - 1.0/8 * GHPLs1[2] * zeta2
						  + 19.0/48 * GHPLs1[2] * HPLs1[0]
						  + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						  + 1.0/8 * GHPLs3[2*4*4+1*4+2]
						  - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						  - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						  - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						  - 1.0/8 * GHPLs3[2*4*4+1*4+0]
						  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						  + 1.0/8 * GHPLs2[2*4+1]
						  - 1.0/8 * GHPLs1[1] * HPLs1[0]
						  - 1.0/8 * GHPLs1[1] * HPLs1[1]
						  - 31.0/288 * HPLs1[0]
						  - 11.0/12 * HPLs2[0*2+0]
						  - 13.0/48 * HPLs2[1*2+0]
						  + 19.0/48 * HPLs1[1]
						  )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -2) * (
						     + 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
						     - 1.0/2 * GHPLs3[1*4*4+2*4+2]
						     + 3.0/8 * GHPLs1[2] * HPLs1[0]
						     + 1.0/2 * GHPLs3[1*4*4+0*4+2]
						     - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
						     + 1.0/2 * GHPLs3[1*4*4+1*4+2]
						     + 3.0/8 * GHPLs2[2*4+1]
						     - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
						     + 3.0/4 * GHPLs3[1*4*4+2*4+1]
						     + 277.0/144 * GHPLs1[1]
						     - 1.0/4 * GHPLs1[1] * zeta2
						     + 13.0/24 * GHPLs1[1] * HPLs1[0]
						     - 3.0/8 * GHPLs1[1] * HPLs1[1]
						     + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
						     - 1.0/4 * GHPLs3[1*4*4+0*4+1]
						     + 1.0/2 * GHPLs3[2*4*4+1*4+1]
						     - 13.0/24 * GHPLs2[1*4+1]
						     - 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
						     - 1.0/2 * GHPLs3[1*4*4+1*4+1]
						     )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -2) * v * (
							 - 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
							 + 1.0/2 * GHPLs3[1*4*4+2*4+2]
							 - 3.0/8 * GHPLs1[2] * HPLs1[0]
							 - 1.0/2 * GHPLs3[1*4*4+0*4+2]
							 + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							 - 1.0/2 * GHPLs3[1*4*4+1*4+2]
							 - 3.0/8 * GHPLs2[2*4+1]
							 + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							 - 3.0/4 * GHPLs3[1*4*4+2*4+1]
							 - 277.0/144 * GHPLs1[1]
							 + 1.0/4 * GHPLs1[1] * zeta2
							 - 13.0/24 * GHPLs1[1] * HPLs1[0]
							 + 3.0/8 * GHPLs1[1] * HPLs1[1]
							 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							 + 1.0/4 * GHPLs3[1*4*4+0*4+1]
							 - 1.0/2 * GHPLs3[2*4*4+1*4+1]
							 + 13.0/24 * GHPLs2[1*4+1]
							 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
							 + 1.0/2 * GHPLs3[1*4*4+1*4+1]
							 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -1) * (
						     + 277.0/144
						     - 1.0/4 * zeta2
						     + 3.0/8 * GHPLs1[2]
						     + 1.0/4 * GHPLs2[1*4+2]
						     + 1.0/4 * GHPLs2[1*4+0]
						     + 1.0/4 * GHPLs2[2*4+1]
						     - 13.0/24 * GHPLs1[1]
						     - 1.0/4 * GHPLs1[1] * HPLs1[1]
						     - 1.0/4 * GHPLs2[1*4+1]
						     + 11.0/12 * HPLs1[0]
						     - 3.0/8 * HPLs1[1]
						     + 1.0/4 * HPLs2[0*2+1]
						     )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -1) * v * (
							 - 277.0/144
							 + 1.0/4 * zeta2
							 + 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
							 - 1.0/2 * GHPLs3[1*4*4+2*4+2]
							 - 3.0/8 * GHPLs1[2]
							 + 5.0/8 * GHPLs1[2] * HPLs1[0]
							 + 1.0/2 * GHPLs3[1*4*4+0*4+2]
							 - 3.0/4 * GHPLs2[1*4+2]
							 - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							 + 1.0/2 * GHPLs3[1*4*4+1*4+2]
							 + 1.0/4 * GHPLs2[1*4+0]
							 - 1.0/8 * GHPLs2[2*4+1]
							 - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							 + 3.0/4 * GHPLs3[1*4*4+2*4+1]
							 + 337.0/144 * GHPLs1[1]
							 - 1.0/4 * GHPLs1[1] * zeta2
							 + 13.0/24 * GHPLs1[1] * HPLs1[0]
							 + 1.0/8 * GHPLs1[1] * HPLs1[1]
							 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							 - 1.0/4 * GHPLs3[1*4*4+0*4+1]
							 + 1.0/2 * GHPLs3[2*4*4+1*4+1]
							 - 1.0/24 * GHPLs2[1*4+1]
							 - 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
							 - 1.0/2 * GHPLs3[1*4*4+1*4+1]
							 - 13.0/24 * HPLs1[0]
							 + 3.0/8 * HPLs1[1]
							 - 1.0/4 * HPLs2[0*2+1]
							 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(1. - v, -1) * (
							  + 3.0/8 * GHPLs1[2] * HPLs1[0]
							  - 3.0/8 * GHPLs2[1*4+2]
							  + 3.0/8 * GHPLs2[1*4+0]
							  - 1.0/8 * GHPLs1[1]
							  + 9.0/16 * HPLs1[0]
							  )

    + (dN_c * dN_c - 1.) * ri * M_PI * (
					+ 289.0/288
					- 1.0/8 * zeta2
					+ 3.0/16 * GHPLs1[2]
					- 3.0/8 * GHPLs1[2] * HPLs1[0]
					+ 1.0/2 * GHPLs2[1*4+2]
					- 1.0/4 * GHPLs2[1*4+0]
					+ 1.0/8 * GHPLs2[2*4+1]
					- 13.0/48 * GHPLs1[1]
					- 1.0/8 * GHPLs1[1] * HPLs1[1]
					- 1.0/8 * GHPLs2[1*4+1]
					- 5.0/48 * HPLs1[0]
					- 3.0/16 * HPLs1[1]
					+ 1.0/8 * HPLs2[0*2+1]
					)

    + (dN_c * dN_c - 1.) * ri * M_PI * v * pow(1. - u, -1) * (
							      + 355.0/288
							      - 1.0/8 * zeta2
							      - 1.0/16 * GHPLs1[2]
							      - 1.0/8 * GHPLs1[2] * HPLs1[0]
							      + 3.0/8 * GHPLs2[1*4+2]
							      - 1.0/8 * GHPLs2[1*4+0]
							      + 1.0/4 * GHPLs2[2*4+1]
							      - 1.0/48 * GHPLs1[1]
							      - 1.0/4 * GHPLs1[1] * HPLs1[1]
							      - 1.0/4 * GHPLs2[1*4+1]
							      + 13.0/48 * HPLs1[0]
							      + 1.0/16 * HPLs1[1]
							      + 1.0/8 * HPLs2[0*2+1]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - v, -2) * (
							      + 1.0/8 * GHPLs1[2] * HPLs1[0]
							      - 1.0/8 * GHPLs2[1*4+2]
							      + 1.0/8 * GHPLs2[1*4+0]
							      + 3.0/16 * HPLs1[0]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - v, -1) * (
							      + 1.0/16
							      - 1.0/8 * GHPLs1[2] * HPLs1[0]
							      + 1.0/8 * GHPLs2[1*4+2]
							      - 1.0/8 * GHPLs2[1*4+0]
							      + 1.0/8 * GHPLs1[1]
							      - 3.0/16 * HPLs1[0]
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(1. - u - v, -1) * (
									       - 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
									       + 1.0/8 * GHPLs3[0*4*4+2*4+3]
									       - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
									       + 1.0/8 * GHPLs3[0*4*4+3*4+3]
									       - 7.0/8 * GHPLs1[3] * zeta2
									       + 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
									       + 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
									       + 1.0/8 * GHPLs3[2*4*4+0*4+3]
									       - 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
									       + 1.0/8 * GHPLs3[0*4*4+2*4+1]
									       - GHPLs1[1] * zeta2
									       + 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
									       + 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
									       + 1.0/8 * GHPLs3[2*4*4+0*4+1]
									       - 1.0/8 * GHPLs2[0*4+1] * HPLs1[0]
									       - 1.0/8 * GHPLs2[0*4+1] * HPLs1[1]
									       + 1.0/8 * GHPLs3[2*4*4+1*4+1]
									       - 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
									       - 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
									       )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * (
							 + 7.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							 - 7.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							 - 7.0/4 * GHPLs2[2*4+2] * zeta2
							 + 5.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							 + 5.0/4 * GHPLs2[2*4+2] * HPLs2[1*2+0]
							 - 1.0/2 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							 - 1.0/2 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							 + 5.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
							 - 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
							 - 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
							 + 1.0/2 * GHPLs3[3*4*4+3*4+2] * HPLs1[0]
							 - 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+2]
							 + 1.0/2 * GHPLs2[3*4+2] * zeta2
							 - 3.0/2 * GHPLs1[2] * zeta2
							 + 3.0/4 * GHPLs1[2] * zeta3
							 + 11.0/16 * GHPLs1[2] * HPLs1[0]
							 - 11.0/2 * GHPLs1[2] * HPLs1[0] * zeta2
							 + 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							 + 7.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							 + 1.0/2 * GHPLs1[2] * HPLs3[1*2*2+0*2+0]
							 + 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							 + 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							 + 5.0/4 * GHPLs1[2] * HPLs1[1] * zeta2
							 - 9.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							 - 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							 - 5.0/4 * GHPLs1[2] * HPLs3[1*2*2+0*2+1]
							 - 7.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							 + 7.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							 + 5.0/4 * GHPLs2[0*4+2] * zeta2
							 - 3.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							 - 5.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							 - 5.0/4 * GHPLs2[0*4+2] * HPLs2[1*2+0]
							 - 5.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
							 + 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
							 + 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
							 + 3.0/8 * GHPLs3[2*4*4+1*4+2]
							 - 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
							 + GHPLs2[1*4+2] * zeta2
							 - 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							 - 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
							 - 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							 + 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
							 - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
							 + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
							 + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
							 + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
							 - 1.0/8 * GHPLs3[0*4*4+2*4+3]
							 + 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
							 - 1.0/8 * GHPLs3[0*4*4+3*4+3]
							 + 7.0/8 * GHPLs1[3] * zeta2
							 - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
							 - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
							 - 1.0/8 * GHPLs3[2*4*4+0*4+3]
							 + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
							 - 7.0/4 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
							 + 5.0/4 * GHPLs4[0*4*4*4+2*4*4+2*4+1]
							 + 5.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							 - 5.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							 + 11.0/16 * GHPLs2[2*4+1]
							 - 5 * GHPLs2[2*4+1] * zeta2
							 + 7.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							 + 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
							 + 3.0/2 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							 + 5.0/4 * GHPLs4[2*4*4*4+0*4*4+2*4+1]
							 - 7.0/8 * GHPLs3[0*4*4+2*4+1]
							 - 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							 - 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[1]
							 - 3.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
							 + 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
							 + 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
							 + 25.0/4 * GHPLs1[1] * zeta2
							 + GHPLs1[1] * zeta3
							 - 11.0/16 * GHPLs1[1] * HPLs1[0]
							 + 6 * GHPLs1[1] * HPLs1[0] * zeta2
							 - 1.0/2 * GHPLs1[1] * HPLs2[0*2+0]
							 - 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							 - 1.0/2 * GHPLs1[1] * HPLs3[1*2*2+0*2+0]
							 - 1.0/2 * GHPLs1[1] * HPLs2[1*2+0]
							 - 5.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							 - 11.0/16 * GHPLs1[1] * HPLs1[1]
							 + 5 * GHPLs1[1] * HPLs1[1] * zeta2
							 - 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							 - 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
							 - 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							 + 5.0/4 * GHPLs4[2*4*4*4+2*4*4+0*4+1]
							 - 7.0/8 * GHPLs3[2*4*4+0*4+1]
							 - GHPLs3[2*4*4+0*4+1] * HPLs1[0]
							 - 5.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[1]
							 + 5.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							 - 5.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							 - 15.0/4 * GHPLs2[0*4+1] * zeta2
							 + 7.0/8 * GHPLs2[0*4+1] * HPLs1[0]
							 + 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							 + 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+0]
							 + 7.0/8 * GHPLs2[0*4+1] * HPLs1[1]
							 + 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							 + 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+1]
							 + 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
							 - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
							 - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
							 - 7.0/4 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
							 - 1.0/2 * GHPLs3[2*4*4+1*4+1]
							 + 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
							 + 7.0/4 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
							 + 5.0/4 * GHPLs4[0*4*4*4+2*4*4+1*4+1]
							 - 3.0/4 * GHPLs2[1*4+1] * zeta2
							 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[0]
							 - 5.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+0]
							 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
							 - 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
							 - 7.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+1]
							 + 5.0/4 * GHPLs4[2*4*4*4+0*4*4+1*4+1]
							 - 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[0]
							 - 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[1]
							 - 3.0/4 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
							 + 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
							 + 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
							 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * v * (
							     - 7.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							     + 7.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							     + 7.0/4 * GHPLs2[2*4+2] * zeta2
							     - 5.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							     - 5.0/4 * GHPLs2[2*4+2] * HPLs2[1*2+0]
							     + 1.0/2 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							     + 1.0/2 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							     - 5.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
							     + 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
							     - 1.0/2 * GHPLs3[3*4*4+3*4+2] * HPLs1[0]
							     + 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+2]
							     - 1.0/2 * GHPLs2[3*4+2] * zeta2
							     + 7.0/4 * GHPLs1[2] * zeta2
							     - 3.0/4 * GHPLs1[2] * zeta3
							     - 15.0/16 * GHPLs1[2] * HPLs1[0]
							     + 11.0/2 * GHPLs1[2] * HPLs1[0] * zeta2
							     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							     - 7.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							     - 1.0/2 * GHPLs1[2] * HPLs3[1*2*2+0*2+0]
							     - 5.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							     - 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							     - 5.0/4 * GHPLs1[2] * HPLs1[1] * zeta2
							     + 9.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							     + 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							     + 5.0/4 * GHPLs1[2] * HPLs3[1*2*2+0*2+1]
							     + 7.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							     - 7.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							     - 5.0/4 * GHPLs2[0*4+2] * zeta2
							     + 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							     + 5.0/4 * GHPLs2[0*4+2] * HPLs2[1*2+0]
							     + 5.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
							     - 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
							     - 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
							     - 5.0/8 * GHPLs3[2*4*4+1*4+2]
							     + 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
							     - GHPLs2[1*4+2] * zeta2
							     + 5.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							     + 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
							     + 5.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							     - 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
							     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
							     - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
							     - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
							     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
							     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
							     + 5.0/8 * GHPLs2[3*4+3] * HPLs1[0]
							     - 5.0/8 * GHPLs3[0*4*4+3*4+3]
							     + 11.0/8 * GHPLs1[3] * zeta2
							     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
							     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
							     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
							     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
							     + 7.0/4 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs4[0*4*4*4+2*4*4+2*4+1]
							     - 5.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							     - 15.0/16 * GHPLs2[2*4+1]
							     + 5 * GHPLs2[2*4+1] * zeta2
							     - 7.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
							     - 3.0/2 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							     - 5.0/4 * GHPLs4[2*4*4*4+0*4*4+2*4+1]
							     + 3.0/8 * GHPLs3[0*4*4+2*4+1]
							     + 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[1]
							     + 3.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
							     - 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
							     - 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
							     - 9.0/4 * GHPLs1[1] * zeta2
							     - GHPLs1[1] * zeta3
							     + 15.0/16 * GHPLs1[1] * HPLs1[0]
							     - 6 * GHPLs1[1] * HPLs1[0] * zeta2
							     + 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							     + 1.0/2 * GHPLs1[1] * HPLs3[1*2*2+0*2+0]
							     + 5.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							     + 15.0/16 * GHPLs1[1] * HPLs1[1]
							     - 5 * GHPLs1[1] * HPLs1[1] * zeta2
							     + 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							     + 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
							     + 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							     - 5.0/4 * GHPLs4[2*4*4*4+2*4*4+0*4+1]
							     + 3.0/8 * GHPLs3[2*4*4+0*4+1]
							     + GHPLs3[2*4*4+0*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[1]
							     - 5.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							     + 15.0/4 * GHPLs2[0*4+1] * zeta2
							     - 3.0/8 * GHPLs2[0*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+0]
							     - 3.0/8 * GHPLs2[0*4+1] * HPLs1[1]
							     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+1]
							     - 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
							     + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
							     + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
							     + 7.0/4 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
							     - 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
							     - 7.0/4 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
							     - 5.0/4 * GHPLs4[0*4*4*4+2*4*4+1*4+1]
							     + 3.0/4 * GHPLs2[1*4+1] * zeta2
							     + 5.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+0]
							     + 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
							     + 7.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+1]
							     - 5.0/4 * GHPLs4[2*4*4*4+0*4*4+1*4+1]
							     + 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[1]
							     + 3.0/4 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
							     - 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
							     - 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 2) * (
								     - 1.0/8 * GHPLs1[2] * zeta2
								     + 1.0/8 * GHPLs1[2] * HPLs1[0]
								     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     + 5.0/8 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+1]
								     - 1.0/8 * GHPLs1[1] * HPLs1[0]
								     - 1.0/8 * GHPLs1[1] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 3) * (
								     - 1.0/8 * GHPLs1[2] * zeta2
								     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     + 5.0/8 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(1. - u - v, -1) * (
									       - 1.0/8 * zeta2
									       + 5.0/8 * GHPLs2[2*4+3] * HPLs1[0]
									       - 5.0/8 * GHPLs3[0*4*4+2*4+3]
									       + 5.0/8 * GHPLs2[3*4+3] * HPLs1[0]
									       - 5.0/8 * GHPLs3[0*4*4+3*4+3]
									       + 35.0/8 * GHPLs1[3] * zeta2
									       + 1.0/8 * GHPLs1[3] * HPLs1[0]
									       - 5.0/8 * GHPLs1[3] * HPLs2[1*2+0]
									       - 5.0/8 * GHPLs1[3] * HPLs2[0*2+1]
									       - 5.0/8 * GHPLs3[2*4*4+0*4+3]
									       - 1.0/8 * GHPLs2[0*4+3]
									       + 5.0/8 * GHPLs2[0*4+3] * HPLs1[1]
									       - 1.0/8 * GHPLs1[0] * HPLs1[0]
									       - 5.0/8 * GHPLs3[0*4*4+2*4+1]
									       + 5 * GHPLs1[1] * zeta2
									       - 5.0/8 * GHPLs1[1] * HPLs2[0*2+0]
									       - 5.0/8 * GHPLs1[1] * HPLs2[1*2+0]
									       - 5.0/8 * GHPLs3[2*4*4+0*4+1]
									       + 5.0/8 * GHPLs2[0*4+1] * HPLs1[0]
									       + 5.0/8 * GHPLs2[0*4+1] * HPLs1[1]
									       - 5.0/8 * GHPLs3[2*4*4+1*4+1]
									       + 5.0/8 * GHPLs2[1*4+1] * HPLs1[0]
									       + 5.0/8 * GHPLs2[1*4+1] * HPLs1[1]
									       + 1.0/8 * HPLs2[0*2+0]
									       - 1.0/8 * HPLs2[0*2+1]
									       )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * (
							 - 1.0/2
							 + 47.0/8 * zeta2
							 + 7.0/4 * zeta3
							 - 3.0/2 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							 + 3.0/2 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							 - 5.0/4 * GHPLs2[2*4+2]
							 + 3.0/2 * GHPLs2[2*4+2] * zeta2
							 - 3.0/2 * GHPLs2[2*4+2] * HPLs1[0]
							 - 3.0/2 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							 - 3.0/2 * GHPLs2[2*4+2] * HPLs2[1*2+0]
							 + 5.0/4 * GHPLs3[0*4*4+2*4+2]
							 - 3.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
							 + 3.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
							 + 3.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
							 + 3 * GHPLs2[3*4+2] * HPLs1[0]
							 - 3 * GHPLs3[0*4*4+3*4+2]
							 + 23.0/16 * GHPLs1[2]
							 - 13.0/2 * GHPLs1[2] * zeta2
							 - 3.0/2 * GHPLs1[2] * zeta3
							 + 13.0/8 * GHPLs1[2] * HPLs1[0]
							 + 6 * GHPLs1[2] * HPLs1[0] * zeta2
							 + 3 * GHPLs1[2] * HPLs2[0*2+0]
							 - 3.0/2 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							 + 5.0/4 * GHPLs1[2] * HPLs2[1*2+0]
							 - 3.0/2 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							 + 5.0/4 * GHPLs1[2] * HPLs1[1]
							 - 3.0/2 * GHPLs1[2] * HPLs1[1] * zeta2
							 + GHPLs1[2] * HPLs2[0*2+1]
							 + 3.0/2 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							 + 3.0/2 * GHPLs1[2] * HPLs3[1*2*2+0*2+1]
							 + 5.0/4 * GHPLs3[2*4*4+0*4+2]
							 + 3.0/2 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							 - 3.0/2 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							 - 3.0/4 * GHPLs2[0*4+2]
							 - 3.0/2 * GHPLs2[0*4+2] * zeta2
							 - 7.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							 + 3.0/2 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							 + 3.0/2 * GHPLs2[0*4+2] * HPLs2[1*2+0]
							 - 5.0/4 * GHPLs2[0*4+2] * HPLs1[1]
							 + 3.0/2 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
							 - 3.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
							 - 3.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
							 - 1.0/4 * GHPLs3[2*4*4+1*4+2]
							 + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							 + 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
							 - 1.0/2 * GHPLs2[2*4+3] * HPLs1[0]
							 + 1.0/2 * GHPLs3[0*4*4+2*4+3]
							 - 3 * GHPLs1[3] * zeta2
							 - 1.0/8 * GHPLs1[3] * HPLs1[0]
							 + 1.0/2 * GHPLs1[3] * HPLs2[1*2+0]
							 + 1.0/2 * GHPLs1[3] * HPLs2[0*2+1]
							 + 1.0/2 * GHPLs3[2*4*4+0*4+3]
							 + 1.0/8 * GHPLs2[0*4+3]
							 - 1.0/2 * GHPLs2[0*4+3] * HPLs1[1]
							 + 5.0/4 * GHPLs3[2*4*4+2*4+0]
							 - 3.0/4 * GHPLs2[2*4+0]
							 - GHPLs2[2*4+0] * HPLs1[0]
							 - 5.0/4 * GHPLs2[2*4+0] * HPLs1[1]
							 - 1.0/2 * GHPLs2[3*4+0] * HPLs1[0]
							 + 1.0/2 * GHPLs3[0*4*4+3*4+0]
							 - 5.0/2 * GHPLs1[0] * zeta2
							 + 1.0/8 * GHPLs1[0] * HPLs1[0]
							 + 3.0/4 * GHPLs1[0] * HPLs1[1]
							 + 5.0/4 * GHPLs1[0] * HPLs2[0*2+1]
							 + 5.0/4 * GHPLs1[0] * HPLs2[1*2+1]
							 - GHPLs3[2*4*4+1*4+0]
							 + GHPLs2[1*4+0] * HPLs1[0]
							 + GHPLs2[1*4+0] * HPLs1[1]
							 - 3.0/2 * GHPLs3[2*4*4+2*4+1]
							 + 3.0/2 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
							 - 3.0/2 * GHPLs4[0*4*4*4+2*4*4+2*4+1]
							 - 3.0/2 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							 + 3.0/2 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							 + 13.0/8 * GHPLs2[2*4+1]
							 + 6 * GHPLs2[2*4+1] * zeta2
							 + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							 - 3.0/2 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							 + 3.0/2 * GHPLs2[2*4+1] * HPLs1[1]
							 - 3.0/2 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							 - 3.0/2 * GHPLs4[2*4*4*4+0*4*4+2*4+1]
							 + 7.0/4 * GHPLs3[0*4*4+2*4+1]
							 + 3.0/2 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							 + 3.0/2 * GHPLs3[0*4*4+2*4+1] * HPLs1[1]
							 + 3.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
							 - 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
							 - 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
							 - 5 * GHPLs1[1] * zeta2
							 - 3.0/2 * GHPLs1[1] * zeta3
							 - 13.0/8 * GHPLs1[1] * HPLs1[0]
							 - 6 * GHPLs1[1] * HPLs1[0] * zeta2
							 + 1.0/2 * GHPLs1[1] * HPLs2[0*2+0]
							 + 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							 - 3.0/4 * GHPLs1[1] * HPLs2[1*2+0]
							 + 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							 - 13.0/8 * GHPLs1[1] * HPLs1[1]
							 - 6 * GHPLs1[1] * HPLs1[1] * zeta2
							 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							 + 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							 - 3.0/2 * GHPLs1[1] * HPLs2[1*2+1]
							 + 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							 - 3.0/2 * GHPLs4[2*4*4*4+2*4*4+0*4+1]
							 + 7.0/4 * GHPLs3[2*4*4+0*4+1]
							 + 3.0/2 * GHPLs3[2*4*4+0*4+1] * HPLs1[0]
							 + 3.0/2 * GHPLs3[2*4*4+0*4+1] * HPLs1[1]
							 - 3.0/2 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							 + 3.0/2 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							 + 9.0/2 * GHPLs2[0*4+1] * zeta2
							 - 7.0/4 * GHPLs2[0*4+1] * HPLs1[0]
							 - 3.0/2 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							 - 3.0/2 * GHPLs2[0*4+1] * HPLs2[1*2+0]
							 - 7.0/4 * GHPLs2[0*4+1] * HPLs1[1]
							 - 3.0/2 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							 - 3.0/2 * GHPLs2[0*4+1] * HPLs2[1*2+1]
							 + 3.0/2 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
							 - 1.0/2 * GHPLs3[2*4*4+1*4+1]
							 - 3.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
							 - 3.0/2 * GHPLs4[0*4*4*4+2*4*4+1*4+1]
							 + 3.0/2 * GHPLs2[1*4+1] * zeta2
							 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[0]
							 + 3.0/2 * GHPLs2[1*4+1] * HPLs2[1*2+0]
							 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
							 + 3.0/2 * GHPLs2[1*4+1] * HPLs2[1*2+1]
							 - 3.0/2 * GHPLs4[2*4*4*4+0*4*4+1*4+1]
							 + 3.0/2 * GHPLs3[0*4*4+1*4+1] * HPLs1[0]
							 + 3.0/2 * GHPLs3[0*4*4+1*4+1] * HPLs1[1]
							 + 3.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
							 - 3.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
							 - 3.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
							 + 1.0/2 * HPLs1[0] * zeta2
							 - 1.0/8 * HPLs2[0*2+0]
							 - 23.0/16 * HPLs1[1]
							 + 25.0/4 * HPLs1[1] * zeta2
							 - 9.0/4 * HPLs2[0*2+1]
							 - 3 * HPLs3[0*2*2+0*2+1]
							 - 3.0/2 * HPLs3[1*2*2+0*2+1]
							 - 5.0/4 * HPLs2[1*2+1]
							 - 3.0/2 * HPLs3[0*2*2+1*2+1]
							 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * v * (
							     - 51.0/8 * zeta2
							     - zeta3
							     + 7.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							     - 7.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							     + 5.0/4 * GHPLs2[2*4+2]
							     - 7.0/4 * GHPLs2[2*4+2] * zeta2
							     + 3.0/2 * GHPLs2[2*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							     + 5.0/4 * GHPLs2[2*4+2] * HPLs2[1*2+0]
							     - 1.0/2 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							     - 5.0/4 * GHPLs3[0*4*4+2*4+2]
							     - 1.0/2 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
							     - 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
							     - 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
							     + 1.0/2 * GHPLs3[3*4*4+3*4+2] * HPLs1[0]
							     - 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+2]
							     + 1.0/2 * GHPLs2[3*4+2] * zeta2
							     - 5.0/4 * GHPLs2[3*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs3[0*4*4+3*4+2]
							     - 23.0/16 * GHPLs1[2]
							     + 15.0/4 * GHPLs1[2] * zeta2
							     + 3.0/4 * GHPLs1[2] * zeta3
							     - 1.0/16 * GHPLs1[2] * HPLs1[0]
							     - 11.0/2 * GHPLs1[2] * HPLs1[0] * zeta2
							     - 9.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							     + 7.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							     + 1.0/2 * GHPLs1[2] * HPLs3[1*2*2+0*2+0]
							     + 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							     + 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							     - 5.0/4 * GHPLs1[2] * HPLs1[1]
							     + 5.0/4 * GHPLs1[2] * HPLs1[1] * zeta2
							     - 17.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							     - 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							     - 5.0/4 * GHPLs1[2] * HPLs3[1*2*2+0*2+1]
							     - 5.0/4 * GHPLs3[2*4*4+0*4+2]
							     - 7.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							     + 7.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							     + 1.0/2 * GHPLs2[0*4+2]
							     + 5.0/4 * GHPLs2[0*4+2] * zeta2
							     + 3.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							     - 5.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							     - 5.0/4 * GHPLs2[0*4+2] * HPLs2[1*2+0]
							     + 5.0/4 * GHPLs2[0*4+2] * HPLs1[1]
							     - 5.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
							     + 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
							     + 15.0/8 * GHPLs3[2*4*4+1*4+2]
							     - 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
							     + GHPLs2[1*4+2] * zeta2
							     - 15.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							     - 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
							     - 15.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							     + 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
							     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
							     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
							     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
							     - 3.0/8 * GHPLs2[2*4+3] * HPLs1[0]
							     + 3.0/8 * GHPLs3[0*4*4+2*4+3]
							     - 3.0/8 * GHPLs2[3*4+3] * HPLs1[0]
							     + 3.0/8 * GHPLs3[0*4*4+3*4+3]
							     - 21.0/8 * GHPLs1[3] * zeta2
							     + 11.0/8 * GHPLs1[3] * HPLs1[0]
							     + 3.0/8 * GHPLs1[3] * HPLs2[1*2+0]
							     + 3.0/8 * GHPLs1[3] * HPLs2[0*2+1]
							     + 3.0/8 * GHPLs3[2*4*4+0*4+3]
							     - 11.0/8 * GHPLs2[0*4+3]
							     - 3.0/8 * GHPLs2[0*4+3] * HPLs1[1]
							     - 5.0/4 * GHPLs3[2*4*4+2*4+0]
							     + 1.0/2 * GHPLs2[2*4+0]
							     + 3.0/4 * GHPLs2[2*4+0] * HPLs1[0]
							     + 5.0/4 * GHPLs2[2*4+0] * HPLs1[1]
							     - 5.0/4 * GHPLs2[3*4+0] * HPLs1[0]
							     + 5.0/4 * GHPLs3[0*4*4+3*4+0]
							     + 15.0/4 * GHPLs1[0] * zeta2
							     - 5.0/8 * GHPLs1[0] * HPLs1[0]
							     - 5.0/4 * GHPLs1[0] * HPLs2[0*2+0]
							     - 5.0/4 * GHPLs1[0] * HPLs2[1*2+0]
							     - 1.0/2 * GHPLs1[0] * HPLs1[1]
							     - 5.0/4 * GHPLs1[0] * HPLs2[0*2+1]
							     - 5.0/4 * GHPLs1[0] * HPLs2[1*2+1]
							     - 1.0/2 * GHPLs3[2*4*4+1*4+0]
							     + 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
							     + 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
							     + 3.0/2 * GHPLs3[2*4*4+2*4+1]
							     - 7.0/4 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs4[0*4*4*4+2*4*4+2*4+1]
							     + 5.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							     + 17.0/16 * GHPLs2[2*4+1]
							     - 5 * GHPLs2[2*4+1] * zeta2
							     - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							     + 7.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
							     - 3.0/2 * GHPLs2[2*4+1] * HPLs1[1]
							     + 3.0/2 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							     + 5.0/4 * GHPLs4[2*4*4*4+0*4*4+2*4+1]
							     - 11.0/8 * GHPLs3[0*4*4+2*4+1]
							     - 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[1]
							     - 3.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
							     + 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
							     + 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
							     + 9.0/4 * GHPLs1[1] * zeta2
							     + GHPLs1[1] * zeta3
							     - 17.0/16 * GHPLs1[1] * HPLs1[0]
							     + 6 * GHPLs1[1] * HPLs1[0] * zeta2
							     - 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
							     - 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							     - 1.0/2 * GHPLs1[1] * HPLs3[1*2*2+0*2+0]
							     + GHPLs1[1] * HPLs2[1*2+0]
							     - 5.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							     - 17.0/16 * GHPLs1[1] * HPLs1[1]
							     + 5 * GHPLs1[1] * HPLs1[1] * zeta2
							     + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							     - 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							     - 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
							     + 3.0/2 * GHPLs1[1] * HPLs2[1*2+1]
							     - 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							     + 5.0/4 * GHPLs4[2*4*4*4+2*4*4+0*4+1]
							     - 11.0/8 * GHPLs3[2*4*4+0*4+1]
							     - GHPLs3[2*4*4+0*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[1]
							     + 5.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							     - 15.0/4 * GHPLs2[0*4+1] * zeta2
							     + 11.0/8 * GHPLs2[0*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							     + 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+0]
							     + 11.0/8 * GHPLs2[0*4+1] * HPLs1[1]
							     + 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							     + 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+1]
							     + 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
							     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
							     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
							     - 7.0/4 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
							     + 3.0/4 * GHPLs3[2*4*4+1*4+1]
							     + 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
							     + 7.0/4 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
							     + 5.0/4 * GHPLs4[0*4*4*4+2*4*4+1*4+1]
							     - 3.0/4 * GHPLs2[1*4+1] * zeta2
							     - 3.0/4 * GHPLs2[1*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+0]
							     - 3.0/4 * GHPLs2[1*4+1] * HPLs1[1]
							     - 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
							     - 7.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+1]
							     + 5.0/4 * GHPLs4[2*4*4*4+0*4*4+1*4+1]
							     - 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[1]
							     - 3.0/4 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
							     + 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
							     + 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
							     + 23.0/16 * HPLs1[0]
							     - 6 * HPLs1[0] * zeta2
							     + 3.0/2 * HPLs2[0*2+0]
							     + 7.0/4 * HPLs3[0*2*2+0*2+0]
							     + 1.0/2 * HPLs3[1*2*2+0*2+0]
							     + 9.0/8 * HPLs2[1*2+0]
							     + 5.0/4 * HPLs3[0*2*2+1*2+0]
							     + 23.0/16 * HPLs1[1]
							     - 5 * HPLs1[1] * zeta2
							     + 11.0/8 * HPLs2[0*2+1]
							     + 7.0/4 * HPLs3[0*2*2+0*2+1]
							     + 1.0/4 * HPLs3[1*2*2+0*2+1]
							     + 5.0/4 * HPLs2[1*2+1]
							     + 3.0/2 * HPLs3[0*2*2+1*2+1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(v, 2) * (
								     - 1.0/2 * zeta2
								     - 1.0/4 * GHPLs1[2] * HPLs1[0]
								     + 1.0/8 * GHPLs2[0*4+2]
								     + 1.0/8 * GHPLs1[3] * HPLs1[0]
								     - 1.0/8 * GHPLs2[0*4+3]
								     + 1.0/8 * GHPLs2[2*4+0]
								     - 1.0/8 * GHPLs1[0] * HPLs1[0]
								     - 1.0/8 * GHPLs1[0] * HPLs1[1]
								     - 1.0/4 * GHPLs2[2*4+1]
								     + 1.0/4 * GHPLs1[1] * HPLs1[0]
								     + 1.0/4 * GHPLs1[1] * HPLs1[1]
								     + 1.0/8 * HPLs2[0*2+0]
								     + 1.0/8 * HPLs2[0*2+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(v, 3) * (
								     + 1.0/8 * GHPLs1[2] * zeta2
								     + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     - 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     + 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     - 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     + 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     - 5.0/8 * GHPLs1[3] * zeta2
								     + 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     + 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     - 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(1. - v, -1) * (
							      - 33.0/16 * zeta2
							      - 3.0/8 * zeta3
							      + 9.0/8 * GHPLs2[3*4+2] * HPLs1[0]
							      - 9.0/8 * GHPLs3[0*4*4+3*4+2]
							      - 3.0/4 * GHPLs1[2] * zeta2
							      - 1.0/16 * GHPLs1[2] * HPLs1[0]
							      + 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							      - 3.0/4 * GHPLs1[2] * HPLs2[0*2+1]
							      - 3.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							      + 5.0/4 * GHPLs1[3] * HPLs1[0]
							      - 5.0/4 * GHPLs2[0*4+3]
							      + 3.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							      - 9.0/8 * GHPLs2[3*4+0] * HPLs1[0]
							      + 9.0/8 * GHPLs3[0*4*4+3*4+0]
							      + 3.0/8 * GHPLs1[0] * zeta2
							      - 9.0/8 * GHPLs1[0] * HPLs1[0]
							      - 3.0/8 * GHPLs1[0] * HPLs2[0*2+0]
							      - 3.0/8 * GHPLs1[0] * HPLs2[1*2+0]
							      + 7.0/8 * GHPLs2[2*4+1]
							      - 7.0/8 * GHPLs1[1] * HPLs1[0]
							      - 7.0/8 * GHPLs1[1] * HPLs1[1]
							      + 65.0/32 * HPLs1[0]
							      - 9.0/4 * HPLs1[0] * zeta2
							      + 3.0/2 * HPLs2[0*2+0]
							      + 9.0/8 * HPLs3[0*2*2+0*2+0]
							      + 3.0/4 * HPLs3[1*2*2+0*2+0]
							      + 15.0/16 * HPLs2[1*2+0]
							      + 3.0/8 * HPLs3[0*2*2+1*2+0]
							      + 3.0/8 * HPLs1[1] * zeta2
							      - 9.0/8 * HPLs2[0*2+1]
							      - 3.0/8 * HPLs3[0*2*2+0*2+1]
							      - 3.0/8 * HPLs3[1*2*2+0*2+1]
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(1. - u - v, -1) * (
								  + 1.0/4 * zeta2
								  - 1.0/2 * GHPLs2[2*4+3] * HPLs1[0]
								  + 1.0/2 * GHPLs3[0*4*4+2*4+3]
								  - 1.0/2 * GHPLs2[3*4+3] * HPLs1[0]
								  + 1.0/2 * GHPLs3[0*4*4+3*4+3]
								  - 7.0/2 * GHPLs1[3] * zeta2
								  - 1.0/4 * GHPLs1[3] * HPLs1[0]
								  + 1.0/2 * GHPLs1[3] * HPLs2[1*2+0]
								  + 1.0/2 * GHPLs1[3] * HPLs2[0*2+1]
								  + 1.0/2 * GHPLs3[2*4*4+0*4+3]
								  + 1.0/4 * GHPLs2[0*4+3]
								  - 1.0/2 * GHPLs2[0*4+3] * HPLs1[1]
								  + 1.0/4 * GHPLs1[0] * HPLs1[0]
								  + 1.0/2 * GHPLs3[0*4*4+2*4+1]
								  - 4 * GHPLs1[1] * zeta2
								  + 1.0/2 * GHPLs1[1] * HPLs2[0*2+0]
								  + 1.0/2 * GHPLs1[1] * HPLs2[1*2+0]
								  + 1.0/2 * GHPLs3[2*4*4+0*4+1]
								  - 1.0/2 * GHPLs2[0*4+1] * HPLs1[0]
								  - 1.0/2 * GHPLs2[0*4+1] * HPLs1[1]
								  + 1.0/2 * GHPLs3[2*4*4+1*4+1]
								  - 1.0/2 * GHPLs2[1*4+1] * HPLs1[0]
								  - 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
								  - 1.0/4 * HPLs2[0*2+0]
								  + 1.0/4 * HPLs2[0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * (
					    + 33.0/32
					    - 47.0/16 * zeta2
					    - 7.0/4 * zeta3
					    + 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
					    - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
					    + 9.0/16 * GHPLs2[2*4+2]
					    - 1.0/4 * GHPLs2[2*4+2] * zeta2
					    + 3.0/4 * GHPLs2[2*4+2] * HPLs1[0]
					    + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
					    + 1.0/4 * GHPLs2[2*4+2] * HPLs2[1*2+0]
					    - 7.0/8 * GHPLs3[0*4*4+2*4+2]
					    + 1.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
					    - 1.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
					    - 1.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
					    - 21.0/8 * GHPLs2[3*4+2] * HPLs1[0]
					    + 21.0/8 * GHPLs3[0*4*4+3*4+2]
					    + 13.0/32 * GHPLs1[2]
					    + 5 * GHPLs1[2] * zeta2
					    + 1.0/4 * GHPLs1[2] * zeta3
					    - 13.0/8 * GHPLs1[2] * HPLs1[0]
					    - GHPLs1[2] * HPLs1[0] * zeta2
					    - 15.0/8 * GHPLs1[2] * HPLs2[0*2+0]
					    + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
					    - 7.0/8 * GHPLs1[2] * HPLs2[1*2+0]
					    + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
					    - 9.0/16 * GHPLs1[2] * HPLs1[1]
					    + 1.0/4 * GHPLs1[2] * HPLs1[1] * zeta2
					    - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
					    - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
					    - 1.0/4 * GHPLs1[2] * HPLs3[1*2*2+0*2+1]
					    - 7.0/8 * GHPLs3[2*4*4+0*4+2]
					    - 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
					    + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
					    + 7.0/8 * GHPLs2[0*4+2]
					    + 1.0/4 * GHPLs2[0*4+2] * zeta2
					    + 11.0/8 * GHPLs2[0*4+2] * HPLs1[0]
					    - 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
					    - 1.0/4 * GHPLs2[0*4+2] * HPLs2[1*2+0]
					    + 7.0/8 * GHPLs2[0*4+2] * HPLs1[1]
					    - 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
					    + 1.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
					    + 1.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
					    - 1.0/8 * GHPLs3[2*4*4+1*4+2]
					    + 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
					    + 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
					    + 1.0/4 * GHPLs2[3*4+3] * HPLs1[0]
					    - 1.0/4 * GHPLs3[0*4*4+3*4+3]
					    + 1.0/4 * GHPLs1[3] * zeta2
					    + 3.0/8 * GHPLs1[3] * HPLs1[0]
					    - 3.0/8 * GHPLs2[0*4+3]
					    - 7.0/8 * GHPLs3[2*4*4+2*4+0]
					    + 7.0/8 * GHPLs2[2*4+0]
					    + 5.0/8 * GHPLs2[2*4+0] * HPLs1[0]
					    + 7.0/8 * GHPLs2[2*4+0] * HPLs1[1]
					    + 7.0/8 * GHPLs2[3*4+0] * HPLs1[0]
					    - 7.0/8 * GHPLs3[0*4*4+3*4+0]
					    + 3.0/8 * GHPLs1[0]
					    + 11.0/8 * GHPLs1[0] * zeta2
					    - 1.0/2 * GHPLs1[0] * HPLs1[0]
					    + 3.0/8 * GHPLs1[0] * HPLs2[0*2+0]
					    + 3.0/8 * GHPLs1[0] * HPLs2[1*2+0]
					    - 7.0/8 * GHPLs1[0] * HPLs1[1]
					    - 7.0/8 * GHPLs1[0] * HPLs2[0*2+1]
					    - 7.0/8 * GHPLs1[0] * HPLs2[1*2+1]
					    + GHPLs3[2*4*4+1*4+0]
					    - GHPLs2[1*4+0] * HPLs1[0]
					    - GHPLs2[1*4+0] * HPLs1[1]
					    + 3.0/4 * GHPLs3[2*4*4+2*4+1]
					    - 1.0/4 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
					    + 1.0/4 * GHPLs4[0*4*4*4+2*4*4+2*4+1]
					    + 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
					    - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
					    - 41.0/16 * GHPLs2[2*4+1]
					    - GHPLs2[2*4+1] * zeta2
					    + 1.0/8 * GHPLs2[2*4+1] * HPLs1[0]
					    + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
					    - 3.0/4 * GHPLs2[2*4+1] * HPLs1[1]
					    + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					    + 1.0/4 * GHPLs4[2*4*4*4+0*4*4+2*4+1]
					    - 7.0/8 * GHPLs3[0*4*4+2*4+1]
					    - 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
					    - 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[1]
					    - 1.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
					    + 1.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
					    + 1.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
					    + GHPLs1[1] * zeta2
					    + 1.0/4 * GHPLs1[1] * zeta3
					    + 41.0/16 * GHPLs1[1] * HPLs1[0]
					    + GHPLs1[1] * HPLs1[0] * zeta2
					    - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
					    + 7.0/8 * GHPLs1[1] * HPLs2[1*2+0]
					    - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
					    + 41.0/16 * GHPLs1[1] * HPLs1[1]
					    + GHPLs1[1] * HPLs1[1] * zeta2
					    - 1.0/8 * GHPLs1[1] * HPLs2[0*2+1]
					    - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
					    + 3.0/4 * GHPLs1[1] * HPLs2[1*2+1]
					    - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					    + 1.0/4 * GHPLs4[2*4*4*4+2*4*4+0*4+1]
					    - 7.0/8 * GHPLs3[2*4*4+0*4+1]
					    - 1.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[0]
					    - 1.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[1]
					    + 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
					    - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
					    - 3.0/4 * GHPLs2[0*4+1] * zeta2
					    + 7.0/8 * GHPLs2[0*4+1] * HPLs1[0]
					    + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
					    + 1.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+0]
					    + 7.0/8 * GHPLs2[0*4+1] * HPLs1[1]
					    + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
					    + 1.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+1]
					    - 1.0/4 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
					    + GHPLs3[2*4*4+1*4+1]
					    + 1.0/4 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
					    + 1.0/4 * GHPLs4[0*4*4*4+2*4*4+1*4+1]
					    - 1.0/4 * GHPLs2[1*4+1] * zeta2
					    - GHPLs2[1*4+1] * HPLs1[0]
					    - 1.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+0]
					    - GHPLs2[1*4+1] * HPLs1[1]
					    - 1.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+1]
					    + 1.0/4 * GHPLs4[2*4*4*4+0*4*4+1*4+1]
					    - 1.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[0]
					    - 1.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[1]
					    - 1.0/4 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
					    + 1.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
					    + 1.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
					    - 65.0/32 * HPLs1[0]
					    + 5.0/2 * HPLs1[0] * zeta2
					    + 1.0/8 * HPLs2[0*2+0]
					    - 9.0/8 * HPLs3[0*2*2+0*2+0]
					    - 3.0/4 * HPLs3[1*2*2+0*2+0]
					    - 15.0/16 * HPLs2[1*2+0]
					    - 3.0/8 * HPLs3[0*2*2+1*2+0]
					    - 13.0/32 * HPLs1[1]
					    - 19.0/4 * HPLs1[1] * zeta2
					    + 2 * HPLs2[0*2+1]
					    + 15.0/8 * HPLs3[0*2*2+0*2+1]
					    + 9.0/8 * HPLs3[1*2*2+0*2+1]
					    + 9.0/16 * HPLs2[1*2+1]
					    + 3.0/4 * HPLs3[0*2*2+1*2+1]
					    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * pow(1. - u, -1) * (
								  - 7.0/16 * zeta2
								  - 5.0/16 * GHPLs2[2*4+2]
								  - 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
								  + 1.0/8 * GHPLs3[0*4*4+2*4+2]
								  + 1.0/8 * GHPLs2[3*4+2] * HPLs1[0]
								  - 1.0/8 * GHPLs3[0*4*4+3*4+2]
								  + 23.0/32 * GHPLs1[2]
								  - 5.0/8 * GHPLs1[2] * zeta2
								  + 1.0/8 * GHPLs1[2] * HPLs1[0]
								  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								  + 5.0/16 * GHPLs1[2] * HPLs1[1]
								  + 1.0/8 * GHPLs3[2*4*4+0*4+2]
								  + 3.0/8 * GHPLs2[0*4+2]
								  - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								  - 1.0/8 * GHPLs2[0*4+2] * HPLs1[1]
								  - 1.0/4 * GHPLs3[2*4*4+1*4+2]
								  + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
								  + 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
								  + 1.0/8 * GHPLs3[2*4*4+2*4+0]
								  + 3.0/8 * GHPLs2[2*4+0]
								  - 1.0/8 * GHPLs2[2*4+0] * HPLs1[1]
								  + 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
								  - 1.0/8 * GHPLs3[0*4*4+3*4+0]
								  - 1.0/8 * GHPLs1[0] * zeta2
								  - 3.0/8 * GHPLs1[0] * HPLs1[0]
								  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								  + 1.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  - 3.0/8 * GHPLs1[0] * HPLs1[1]
								  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
								  + 1.0/8 * GHPLs1[0] * HPLs2[1*2+1]
								  + 1.0/8 * GHPLs3[2*4*4+1*4+0]
								  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
								  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
								  - 1.0/4 * GHPLs3[2*4*4+2*4+1]
								  - 7.0/16 * GHPLs2[2*4+1]
								  + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
								  + 1.0/4 * GHPLs2[2*4+1] * HPLs1[1]
								  + 1.0/4 * GHPLs1[1] * zeta2
								  + 7.0/16 * GHPLs1[1] * HPLs1[0]
								  + 7.0/16 * GHPLs1[1] * HPLs1[1]
								  - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
								  - 1.0/4 * GHPLs1[1] * HPLs2[1*2+1]
								  + 1.0/4 * GHPLs3[2*4*4+1*4+1]
								  - 1.0/4 * GHPLs2[1*4+1] * HPLs1[0]
								  - 1.0/4 * GHPLs2[1*4+1] * HPLs1[1]
								  - 23.0/32 * HPLs1[0]
								  + 9.0/8 * HPLs1[0] * zeta2
								  - 3.0/8 * HPLs2[0*2+0]
								  - 1.0/4 * HPLs3[0*2*2+0*2+0]
								  - 1.0/8 * HPLs3[1*2*2+0*2+0]
								  - 9.0/16 * HPLs2[1*2+0]
								  + 1.0/8 * HPLs3[0*2*2+1*2+0]
								  - 23.0/32 * HPLs1[1]
								  + 5.0/8 * HPLs1[1] * zeta2
								  - 1.0/8 * HPLs2[0*2+1]
								  - 1.0/4 * HPLs3[0*2*2+0*2+1]
								  - 5.0/16 * HPLs2[1*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * (
						+ 33.0/8 * zeta2
						+ 1.0/2 * zeta3
						- 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
						+ 1.0/2 * GHPLs3[0*4*4+2*4+2]
						+ 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
						- 1.0/2 * GHPLs3[0*4*4+3*4+2]
						- 15.0/8 * GHPLs1[2] * zeta2
						+ 5.0/8 * GHPLs1[2] * HPLs1[0]
						+ 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						- 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						+ 1.0/2 * GHPLs1[2] * HPLs2[0*2+1]
						+ 1.0/2 * GHPLs3[2*4*4+0*4+2]
						- GHPLs2[0*4+2]
						- 5.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						- 1.0/2 * GHPLs2[0*4+2] * HPLs1[1]
						- 5.0/8 * GHPLs3[2*4*4+1*4+2]
						+ 5.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						+ 5.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						- 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
						+ 1.0/8 * GHPLs3[0*4*4+2*4+3]
						+ 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
						- 1.0/8 * GHPLs3[0*4*4+3*4+3]
						- 5.0/8 * GHPLs1[3] * zeta2
						- GHPLs1[3] * HPLs1[0]
						+ 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
						+ 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
						+ 1.0/8 * GHPLs3[2*4*4+0*4+3]
						+ GHPLs2[0*4+3]
						- 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
						+ 1.0/2 * GHPLs3[2*4*4+2*4+0]
						- GHPLs2[2*4+0]
						- 3.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						- 1.0/2 * GHPLs2[2*4+0] * HPLs1[1]
						+ 1.0/2 * GHPLs2[3*4+0] * HPLs1[0]
						- 1.0/2 * GHPLs3[0*4*4+3*4+0]
						- 7.0/4 * GHPLs1[0] * zeta2
						+ 9.0/8 * GHPLs1[0] * HPLs1[0]
						+ 3.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						+ 1.0/2 * GHPLs1[0] * HPLs2[1*2+0]
						+ GHPLs1[0] * HPLs1[1]
						+ 3.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						+ 1.0/2 * GHPLs1[0] * HPLs2[1*2+1]
						+ 1.0/8 * GHPLs3[2*4*4+1*4+0]
						- 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						- 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						- 1.0/2 * GHPLs3[2*4*4+2*4+1]
						+ 3.0/4 * GHPLs2[2*4+1]
						- 1.0/8 * GHPLs2[2*4+1] * HPLs1[0]
						+ 1.0/2 * GHPLs2[2*4+1] * HPLs1[1]
						+ 1.0/2 * GHPLs3[0*4*4+2*4+1]
						- 1.0/4 * GHPLs1[1] * zeta2
						- 3.0/4 * GHPLs1[1] * HPLs1[0]
						+ 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
						- 1.0/2 * GHPLs1[1] * HPLs2[1*2+0]
						- 3.0/4 * GHPLs1[1] * HPLs1[1]
						+ 1.0/8 * GHPLs1[1] * HPLs2[0*2+1]
						- 1.0/2 * GHPLs1[1] * HPLs2[1*2+1]
						+ 1.0/2 * GHPLs3[2*4*4+0*4+1]
						- 1.0/2 * GHPLs2[0*4+1] * HPLs1[0]
						- 1.0/2 * GHPLs2[0*4+1] * HPLs1[1]
						- 5.0/8 * GHPLs3[2*4*4+1*4+1]
						+ 5.0/8 * GHPLs2[1*4+1] * HPLs1[0]
						+ 5.0/8 * GHPLs2[1*4+1] * HPLs1[1]
						+ 15.0/8 * HPLs1[0] * zeta2
						- HPLs2[0*2+0]
						- 5.0/8 * HPLs3[0*2*2+0*2+0]
						- 1.0/8 * HPLs3[1*2*2+0*2+0]
						+ 1.0/8 * HPLs2[1*2+0]
						- 3.0/4 * HPLs3[0*2*2+1*2+0]
						+ 15.0/8 * HPLs1[1] * zeta2
						- 7.0/8 * HPLs2[0*2+1]
						- 5.0/8 * HPLs3[0*2*2+0*2+1]
						- 1.0/8 * HPLs3[1*2*2+0*2+1]
						- 3.0/4 * HPLs3[0*2*2+1*2+1]
						)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(v, 2) * (
							+ 1.0/2 * zeta2
							+ 1.0/4 * GHPLs1[2] * zeta2
							+ 1.0/8 * GHPLs1[2] * HPLs1[0]
							+ 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							- 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
							- 1.0/8 * GHPLs2[0*4+2]
							- 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							- 1.0/4 * GHPLs3[2*4*4+1*4+2]
							+ 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							+ 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
							- 1.0/4 * GHPLs2[2*4+3] * HPLs1[0]
							+ 1.0/4 * GHPLs3[0*4*4+2*4+3]
							+ 1.0/4 * GHPLs2[3*4+3] * HPLs1[0]
							- 1.0/4 * GHPLs3[0*4*4+3*4+3]
							- 5.0/4 * GHPLs1[3] * zeta2
							- 1.0/8 * GHPLs1[3] * HPLs1[0]
							+ 1.0/4 * GHPLs1[3] * HPLs2[1*2+0]
							+ 1.0/4 * GHPLs1[3] * HPLs2[0*2+1]
							+ 1.0/4 * GHPLs3[2*4*4+0*4+3]
							+ 1.0/8 * GHPLs2[0*4+3]
							- 1.0/4 * GHPLs2[0*4+3] * HPLs1[1]
							- 1.0/8 * GHPLs2[2*4+0]
							+ 1.0/8 * GHPLs1[0] * HPLs1[0]
							+ 1.0/8 * GHPLs1[0] * HPLs1[1]
							+ 1.0/8 * GHPLs2[2*4+1]
							- 1.0/8 * GHPLs1[1] * HPLs1[0]
							- 1.0/8 * GHPLs1[1] * HPLs1[1]
							- 1.0/8 * HPLs2[0*2+0]
							- 1.0/8 * HPLs2[0*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - v, -2) * (
								  - 9.0/16 * zeta2
								  + 3.0/8 * zeta3
								  + 7.0/8 * GHPLs2[3*4+2] * HPLs1[0]
								  - 7.0/8 * GHPLs3[0*4*4+3*4+2]
								  - 3.0/4 * GHPLs1[2] * zeta2
								  + 7.0/16 * GHPLs1[2] * HPLs1[0]
								  + 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								  + 1.0/2 * GHPLs1[2] * HPLs2[1*2+0]
								  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
								  - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								  + 1.0/2 * GHPLs3[2*4*4+1*4+2]
								  - 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
								  - 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
								  + 3.0/8 * GHPLs1[3] * HPLs1[0]
								  - 3.0/8 * GHPLs2[0*4+3]
								  + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
								  - 7.0/8 * GHPLs2[3*4+0] * HPLs1[0]
								  + 7.0/8 * GHPLs3[0*4*4+3*4+0]
								  + 5.0/8 * GHPLs1[0] * zeta2
								  - 5.0/8 * GHPLs1[0] * HPLs1[0]
								  - 5.0/8 * GHPLs1[0] * HPLs2[0*2+0]
								  - 5.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  - 1.0/2 * GHPLs3[2*4*4+1*4+0]
								  + 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
								  + 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
								  + 3.0/8 * GHPLs2[2*4+1]
								  - 3.0/8 * GHPLs1[1] * HPLs1[0]
								  - 3.0/8 * GHPLs1[1] * HPLs1[1]
								  + 27.0/32 * HPLs1[0]
								  - 11.0/4 * HPLs1[0] * zeta2
								  + 3.0/8 * HPLs2[0*2+0]
								  + 7.0/8 * HPLs3[0*2*2+0*2+0]
								  + 1.0/4 * HPLs3[1*2*2+0*2+0]
								  - 1.0/16 * HPLs2[1*2+0]
								  + 5.0/8 * HPLs3[0*2*2+1*2+0]
								  + 5.0/8 * HPLs1[1] * zeta2
								  - 5.0/8 * HPLs2[0*2+1]
								  - 5.0/8 * HPLs3[0*2*2+0*2+1]
								  - 5.0/8 * HPLs3[1*2*2+0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - v, -1) * (
								  + 17.0/32
								  - 35.0/16 * zeta2
								  - 3.0/8 * zeta3
								  - 7.0/8 * GHPLs2[3*4+2] * HPLs1[0]
								  + 7.0/8 * GHPLs3[0*4*4+3*4+2]
								  + 5.0/16 * GHPLs1[2]
								  + 3.0/4 * GHPLs1[2] * zeta2
								  - 11.0/16 * GHPLs1[2] * HPLs1[0]
								  - 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								  - 1.0/2 * GHPLs1[2] * HPLs2[1*2+0]
								  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
								  + 5.0/8 * GHPLs2[0*4+2]
								  + 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								  - 1.0/2 * GHPLs3[2*4*4+1*4+2]
								  + 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
								  + 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
								  + 1.0/2 * GHPLs1[3] * HPLs1[0]
								  - 1.0/2 * GHPLs2[0*4+3]
								  + 5.0/8 * GHPLs2[2*4+0]
								  - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
								  + 7.0/8 * GHPLs2[3*4+0] * HPLs1[0]
								  - 7.0/8 * GHPLs3[0*4*4+3*4+0]
								  - 5.0/8 * GHPLs1[0] * zeta2
								  - 1.0/2 * GHPLs1[0] * HPLs1[0]
								  + 5.0/8 * GHPLs1[0] * HPLs2[0*2+0]
								  + 5.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  - 5.0/8 * GHPLs1[0] * HPLs1[1]
								  + 1.0/2 * GHPLs3[2*4*4+1*4+0]
								  - 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
								  - 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
								  - 7.0/8 * GHPLs2[2*4+1]
								  + 7.0/8 * GHPLs1[1] * HPLs1[0]
								  + 7.0/8 * GHPLs1[1] * HPLs1[1]
								  - 39.0/32 * HPLs1[0]
								  + 11.0/4 * HPLs1[0] * zeta2
								  + 1.0/2 * HPLs2[0*2+0]
								  - 7.0/8 * HPLs3[0*2*2+0*2+0]
								  - 1.0/4 * HPLs3[1*2*2+0*2+0]
								  - 3.0/16 * HPLs2[1*2+0]
								  - 5.0/8 * HPLs3[0*2*2+1*2+0]
								  - 5.0/16 * HPLs1[1]
								  - 5.0/8 * HPLs1[1] * zeta2
								  + 3.0/4 * HPLs2[0*2+1]
								  + 5.0/8 * HPLs3[0*2*2+0*2+1]
								  + 5.0/8 * HPLs3[1*2*2+0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * (
						+ 5 * zeta2
						- 3.0/8 * GHPLs1[2]
						+ GHPLs1[2] * HPLs1[0]
						- 5.0/4 * GHPLs2[0*4+2]
						- 5.0/4 * GHPLs1[3] * HPLs1[0]
						+ 5.0/4 * GHPLs2[0*4+3]
						- 5.0/4 * GHPLs2[2*4+0]
						+ 3.0/2 * GHPLs1[0] * HPLs1[0]
						+ 5.0/4 * GHPLs1[0] * HPLs1[1]
						+ 5.0/4 * GHPLs2[2*4+1]
						- 5.0/4 * GHPLs1[1] * HPLs1[0]
						- 5.0/4 * GHPLs1[1] * HPLs1[1]
						+ 3.0/8 * HPLs1[0]
						- 5.0/4 * HPLs2[0*2+0]
						+ 1.0/4 * HPLs2[1*2+0]
						+ 3.0/8 * HPLs1[1]
						- HPLs2[0*2+1]
						)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * v * (
						    + 3.0/2 * zeta2
						    + 1.0/8 * GHPLs1[2] * zeta2
						    + 3.0/8 * GHPLs1[2] * HPLs1[0]
						    + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						    - 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						    - 3.0/8 * GHPLs2[0*4+2]
						    - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						    - 1.0/8 * GHPLs3[2*4*4+1*4+2]
						    + 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						    + 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						    - 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
						    + 1.0/8 * GHPLs3[0*4*4+2*4+3]
						    + 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
						    - 1.0/8 * GHPLs3[0*4*4+3*4+3]
						    - 5.0/8 * GHPLs1[3] * zeta2
						    - 3.0/8 * GHPLs1[3] * HPLs1[0]
						    + 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
						    + 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
						    + 1.0/8 * GHPLs3[2*4*4+0*4+3]
						    + 3.0/8 * GHPLs2[0*4+3]
						    - 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
						    - 3.0/8 * GHPLs2[2*4+0]
						    + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						    - 1.0/4 * GHPLs1[0] * zeta2
						    + 3.0/8 * GHPLs1[0] * HPLs1[0]
						    - 1.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						    + 3.0/8 * GHPLs1[0] * HPLs1[1]
						    - 1.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						    + 1.0/8 * GHPLs3[2*4*4+1*4+0]
						    - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						    - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						    + 3.0/8 * GHPLs2[2*4+1]
						    - 1.0/8 * GHPLs2[2*4+1] * HPLs1[0]
						    + 1.0/4 * GHPLs1[1] * zeta2
						    - 3.0/8 * GHPLs1[1] * HPLs1[0]
						    + 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
						    - 3.0/8 * GHPLs1[1] * HPLs1[1]
						    + 1.0/8 * GHPLs1[1] * HPLs2[0*2+1]
						    - 1.0/8 * GHPLs3[2*4*4+1*4+1]
						    + 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
						    + 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
						    - 1.0/8 * HPLs1[0] * zeta2
						    - 3.0/8 * HPLs2[0*2+0]
						    - 1.0/8 * HPLs3[0*2*2+0*2+0]
						    - 1.0/8 * HPLs3[1*2*2+0*2+0]
						    - 1.0/4 * HPLs3[0*2*2+1*2+0]
						    - 1.0/8 * HPLs1[1] * zeta2
						    - 3.0/8 * HPLs2[0*2+1]
						    - 1.0/8 * HPLs3[0*2*2+0*2+1]
						    - 1.0/8 * HPLs3[1*2*2+0*2+1]
						    - 1.0/4 * HPLs3[0*2*2+1*2+1]
						    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -3) * (
									  - 9.0/4 * zeta2
									  - 3.0/4 * zeta3
									  - 3.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 3.0/4 * GHPLs3[0*4*4+3*4+2]
									  + 3.0/4 * GHPLs1[2] * zeta2
									  - 3.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  - 3.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  - 3.0/4 * GHPLs3[2*4*4+1*4+2]
									  + 3.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  + 3.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  + 9.0/4 * GHPLs1[3] * HPLs1[0]
									  - 9.0/4 * GHPLs2[0*4+3]
									  + 3.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  - 3.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 3.0/4 * GHPLs1[0] * zeta2
									  + 3.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 3.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  + 3.0/4 * GHPLs3[2*4*4+1*4+0]
									  - 3.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  - 3.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  + 9.0/4 * GHPLs2[2*4+1]
									  - 9.0/4 * GHPLs1[1] * HPLs1[0]
									  - 9.0/4 * GHPLs1[1] * HPLs1[1]
									  + 3 * HPLs1[0] * zeta2
									  + 9.0/4 * HPLs2[0*2+0]
									  - 3.0/4 * HPLs3[0*2*2+0*2+0]
									  + 9.0/4 * HPLs2[1*2+0]
									  - 3.0/4 * HPLs3[0*2*2+1*2+0]
									  - 3.0/4 * HPLs1[1] * zeta2
									  + 3.0/4 * HPLs3[0*2*2+0*2+1]
									  + 3.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -2) * (
									  + 21.0/4 * zeta2
									  + 3.0/4 * zeta3
									  + 3.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  - 3.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 9.0/8 * GHPLs1[2]
									  - 3.0/4 * GHPLs1[2] * zeta2
									  + 3.0/4 * GHPLs1[2] * HPLs1[0]
									  + 3.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 3.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  - 3.0/4 * GHPLs2[0*4+2]
									  + 3.0/4 * GHPLs3[2*4*4+1*4+2]
									  - 3.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  - 3.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  - 3 * GHPLs1[3] * HPLs1[0]
									  + 3 * GHPLs2[0*4+3]
									  - 3.0/4 * GHPLs2[2*4+0]
									  - 3.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 3.0/4 * GHPLs3[0*4*4+3*4+0]
									  + 9.0/8 * GHPLs1[0]
									  + 3.0/4 * GHPLs1[0] * zeta2
									  + 3.0/4 * GHPLs1[0] * HPLs1[0]
									  - 3.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  - 3.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  + 3.0/4 * GHPLs1[0] * HPLs1[1]
									  - 3.0/4 * GHPLs3[2*4*4+1*4+0]
									  + 3.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  + 3.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  - 3.0/2 * GHPLs2[2*4+1]
									  + 3.0/2 * GHPLs1[1] * HPLs1[0]
									  + 3.0/2 * GHPLs1[1] * HPLs1[1]
									  - 3 * HPLs1[0] * zeta2
									  - 3 * HPLs2[0*2+0]
									  + 3.0/4 * HPLs3[0*2*2+0*2+0]
									  - 9.0/4 * HPLs2[1*2+0]
									  + 3.0/4 * HPLs3[0*2*2+1*2+0]
									  + 9.0/8 * HPLs1[1]
									  + 3.0/4 * HPLs1[1] * zeta2
									  - 3.0/4 * HPLs2[0*2+1]
									  - 3.0/4 * HPLs3[0*2*2+0*2+1]
									  - 3.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -1) * (
									  - 3.0/2 * zeta2
									  + 3.0/8 * GHPLs1[2]
									  - 3.0/8 * GHPLs1[2] * HPLs1[0]
									  + 3.0/8 * GHPLs2[0*4+2]
									  + 3.0/8 * GHPLs1[3] * HPLs1[0]
									  - 3.0/8 * GHPLs2[0*4+3]
									  + 3.0/8 * GHPLs2[2*4+0]
									  - 3.0/8 * GHPLs1[0]
									  - 3.0/8 * GHPLs1[0] * HPLs1[0]
									  - 3.0/8 * GHPLs1[0] * HPLs1[1]
									  - 3.0/8 * GHPLs2[2*4+1]
									  + 3.0/8 * GHPLs1[1] * HPLs1[0]
									  + 3.0/8 * GHPLs1[1] * HPLs1[1]
									  + 3.0/8 * HPLs2[0*2+0]
									  - 3.0/8 * HPLs1[1]
									  + 3.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * (
							- 1.0/2 * zeta2
							- 1.0/8 * GHPLs1[2] * HPLs1[0]
							+ 1.0/8 * GHPLs2[0*4+2]
							+ 1.0/8 * GHPLs1[3] * HPLs1[0]
							- 1.0/8 * GHPLs2[0*4+3]
							+ 1.0/8 * GHPLs2[2*4+0]
							- 1.0/8 * GHPLs1[0] * HPLs1[0]
							- 1.0/8 * GHPLs1[0] * HPLs1[1]
							- 1.0/8 * GHPLs2[2*4+1]
							+ 1.0/8 * GHPLs1[1] * HPLs1[0]
							+ 1.0/8 * GHPLs1[1] * HPLs1[1]
							+ 1.0/8 * HPLs2[0*2+0]
							+ 1.0/8 * HPLs2[0*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -4) * (
									  + 9.0/4 * zeta3
									  + 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 9.0/4 * GHPLs1[2] * zeta2
									  + 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  - 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  + 9.0/4 * GHPLs1[0] * zeta2
									  - 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  - 9 * HPLs1[0] * zeta2
									  + 9.0/4 * HPLs3[0*2*2+0*2+0]
									  + 9.0/4 * HPLs3[0*2*2+1*2+0]
									  + 9.0/4 * HPLs1[1] * zeta2
									  - 9.0/4 * HPLs3[0*2*2+0*2+1]
									  - 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -3) * (
									  - 9 * zeta2
									  - 9.0/4 * zeta3
									  - 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  + 9.0/4 * GHPLs1[2] * zeta2
									  - 9.0/4 * GHPLs1[2] * HPLs1[0]
									  - 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs2[0*4+2]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  + 9.0/4 * GHPLs1[3] * HPLs1[0]
									  - 9.0/4 * GHPLs2[0*4+3]
									  + 9.0/4 * GHPLs2[2*4+0]
									  + 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 9.0/4 * GHPLs1[0] * zeta2
									  - 9.0/4 * GHPLs1[0] * HPLs1[0]
									  + 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs1[0] * HPLs1[1]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  - 9.0/4 * GHPLs2[2*4+1]
									  + 9.0/4 * GHPLs1[1] * HPLs1[0]
									  + 9.0/4 * GHPLs1[1] * HPLs1[1]
									  + 9 * HPLs1[0] * zeta2
									  + 9.0/4 * HPLs2[0*2+0]
									  - 9.0/4 * HPLs3[0*2*2+0*2+0]
									  - 9.0/4 * HPLs3[0*2*2+1*2+0]
									  - 9.0/4 * HPLs1[1] * zeta2
									  + 9.0/4 * HPLs2[0*2+1]
									  + 9.0/4 * HPLs3[0*2*2+0*2+1]
									  + 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -2) * (
									  + 9.0/2 * zeta2
									  + 9.0/8 * GHPLs1[2] * HPLs1[0]
									  - 9.0/8 * GHPLs2[0*4+2]
									  - 9.0/8 * GHPLs1[3] * HPLs1[0]
									  + 9.0/8 * GHPLs2[0*4+3]
									  - 9.0/8 * GHPLs2[2*4+0]
									  + 9.0/8 * GHPLs1[0] * HPLs1[0]
									  + 9.0/8 * GHPLs1[0] * HPLs1[1]
									  + 9.0/8 * GHPLs2[2*4+1]
									  - 9.0/8 * GHPLs1[1] * HPLs1[0]
									  - 9.0/8 * GHPLs1[1] * HPLs1[1]
									  - 9.0/8 * HPLs2[0*2+0]
									  - 9.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -1) * (
									  + 3.0/2 * zeta2
									  + 3.0/8 * GHPLs1[2] * HPLs1[0]
									  - 3.0/8 * GHPLs2[0*4+2]
									  - 3.0/8 * GHPLs1[3] * HPLs1[0]
									  + 3.0/8 * GHPLs2[0*4+3]
									  - 3.0/8 * GHPLs2[2*4+0]
									  + 3.0/8 * GHPLs1[0] * HPLs1[0]
									  + 3.0/8 * GHPLs1[0] * HPLs1[1]
									  + 3.0/8 * GHPLs2[2*4+1]
									  - 3.0/8 * GHPLs1[1] * HPLs1[0]
									  - 3.0/8 * GHPLs1[1] * HPLs1[1]
									  - 3.0/8 * HPLs2[0*2+0]
									  - 3.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(1. - u - v, -1) * (
											   + 1.0/8 * GHPLs2[2*4+3]
											   + 1.0/8 * GHPLs2[3*4+3]
											   - 1.0/8 * GHPLs1[3] * HPLs1[0]
											   - 1.0/8 * GHPLs1[3] * HPLs1[1]
											   + 1.0/8 * GHPLs2[0*4+3]
											   + 1.0/8 * GHPLs2[2*4+1]
											   - 1.0/4 * GHPLs1[1] * HPLs1[0]
											   - 1.0/8 * GHPLs1[1] * HPLs1[1]
											   + 1.0/8 * GHPLs2[0*4+1]
											   + 1.0/8 * GHPLs2[1*4+1]
											   )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * (
								     - 7.0/4 * GHPLs3[3*4*4+2*4+2]
								     - 7.0/4 * GHPLs2[2*4+2] * HPLs1[0]
								     + 5.0/4 * GHPLs3[1*4*4+2*4+2]
								     - 1.0/2 * GHPLs3[3*4*4+3*4+2]
								     + 5.0/2 * GHPLs1[2] * zeta2
								     - 9.0/8 * GHPLs1[2] * HPLs1[0]
								     - 7.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								     - 5.0/4 * GHPLs1[2] * HPLs2[1*2+0]
								     + 5.0/4 * GHPLs1[2] * HPLs2[0*2+1]
								     + 7.0/4 * GHPLs3[3*4*4+0*4+2]
								     + 5.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								     - 5.0/4 * GHPLs3[1*4*4+0*4+2]
								     + 3.0/8 * GHPLs2[1*4+2]
								     + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/2 * GHPLs3[1*4*4+1*4+2]
								     - 1.0/8 * GHPLs2[2*4+3]
								     - 1.0/8 * GHPLs2[3*4+3]
								     + 1.0/8 * GHPLs1[3] * HPLs1[0]
								     + 1.0/8 * GHPLs1[3] * HPLs1[1]
								     - 1.0/8 * GHPLs2[0*4+3]
								     + 5.0/4 * GHPLs3[2*4*4+2*4+1]
								     - 5.0/4 * GHPLs3[3*4*4+2*4+1]
								     - 7.0/8 * GHPLs2[2*4+1]
								     - 3.0/2 * GHPLs2[2*4+1] * HPLs1[0]
								     - 5.0/4 * GHPLs2[2*4+1] * HPLs1[1]
								     + 5.0/4 * GHPLs3[0*4*4+2*4+1]
								     - 3.0/2 * GHPLs3[1*4*4+2*4+1]
								     + 11.0/16 * GHPLs1[1]
								     - 9.0/4 * GHPLs1[1] * zeta2
								     + 11.0/8 * GHPLs1[1] * HPLs1[0]
								     + 7.0/4 * GHPLs1[1] * HPLs2[0*2+0]
								     + 5.0/4 * GHPLs1[1] * HPLs2[1*2+0]
								     + 7.0/8 * GHPLs1[1] * HPLs1[1]
								     + 3.0/2 * GHPLs1[1] * HPLs2[0*2+1]
								     + 5.0/4 * GHPLs1[1] * HPLs2[1*2+1]
								     + 5.0/4 * GHPLs3[2*4*4+0*4+1]
								     - 5.0/4 * GHPLs3[3*4*4+0*4+1]
								     - 7.0/8 * GHPLs2[0*4+1]
								     - 5.0/4 * GHPLs2[0*4+1] * HPLs1[0]
								     - 5.0/4 * GHPLs2[0*4+1] * HPLs1[1]
								     + 1.0/4 * GHPLs3[1*4*4+0*4+1]
								     - 1.0/2 * GHPLs3[2*4*4+1*4+1]
								     - 1.0/2 * GHPLs2[1*4+1]
								     + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
								     + 5.0/4 * GHPLs3[0*4*4+1*4+1]
								     - 3.0/4 * GHPLs3[1*4*4+1*4+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * v * (
									 + 7.0/4 * GHPLs3[3*4*4+2*4+2]
									 + 7.0/4 * GHPLs2[2*4+2] * HPLs1[0]
									 - 5.0/4 * GHPLs3[1*4*4+2*4+2]
									 + 1.0/2 * GHPLs3[3*4*4+3*4+2]
									 - 5.0/2 * GHPLs1[2] * zeta2
									 + 9.0/8 * GHPLs1[2] * HPLs1[0]
									 + 7.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									 + 5.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									 - 5.0/4 * GHPLs1[2] * HPLs2[0*2+1]
									 - 7.0/4 * GHPLs3[3*4*4+0*4+2]
									 - 5.0/4 * GHPLs2[0*4+2] * HPLs1[0]
									 + 5.0/4 * GHPLs3[1*4*4+0*4+2]
									 - 5.0/8 * GHPLs2[1*4+2]
									 - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									 + 1.0/2 * GHPLs3[1*4*4+1*4+2]
									 - 1.0/8 * GHPLs2[2*4+3]
									 - 5.0/8 * GHPLs2[3*4+3]
									 + 1.0/8 * GHPLs1[3] * HPLs1[0]
									 + 1.0/8 * GHPLs1[3] * HPLs1[1]
									 - 1.0/8 * GHPLs2[0*4+3]
									 - 5.0/4 * GHPLs3[2*4*4+2*4+1]
									 + 5.0/4 * GHPLs3[3*4*4+2*4+1]
									 + 3.0/8 * GHPLs2[2*4+1]
									 + 3.0/2 * GHPLs2[2*4+1] * HPLs1[0]
									 + 5.0/4 * GHPLs2[2*4+1] * HPLs1[1]
									 - 5.0/4 * GHPLs3[0*4*4+2*4+1]
									 + 3.0/2 * GHPLs3[1*4*4+2*4+1]
									 - 15.0/16 * GHPLs1[1]
									 + 9.0/4 * GHPLs1[1] * zeta2
									 - 3.0/8 * GHPLs1[1] * HPLs1[0]
									 - 7.0/4 * GHPLs1[1] * HPLs2[0*2+0]
									 - 5.0/4 * GHPLs1[1] * HPLs2[1*2+0]
									 - 3.0/8 * GHPLs1[1] * HPLs1[1]
									 - 3.0/2 * GHPLs1[1] * HPLs2[0*2+1]
									 - 5.0/4 * GHPLs1[1] * HPLs2[1*2+1]
									 - 5.0/4 * GHPLs3[2*4*4+0*4+1]
									 + 5.0/4 * GHPLs3[3*4*4+0*4+1]
									 + 3.0/8 * GHPLs2[0*4+1]
									 + 5.0/4 * GHPLs2[0*4+1] * HPLs1[0]
									 + 5.0/4 * GHPLs2[0*4+1] * HPLs1[1]
									 - 1.0/4 * GHPLs3[1*4*4+0*4+1]
									 + 1.0/2 * GHPLs3[2*4*4+1*4+1]
									 - 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
									 - 5.0/4 * GHPLs3[0*4*4+1*4+1]
									 + 3.0/4 * GHPLs3[1*4*4+1*4+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 2) * (
										 + 1.0/8 * GHPLs2[1*4+2]
										 - 1.0/8 * GHPLs2[2*4+3]
										 + 1.0/8 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3] * HPLs1[0]
										 + 1.0/8 * GHPLs1[3] * HPLs1[1]
										 - 1.0/8 * GHPLs2[0*4+3]
										 + 1.0/8 * GHPLs1[1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 3) * (
										 + 1.0/8 * GHPLs2[1*4+2]
										 - 1.0/8 * GHPLs2[2*4+3]
										 + 1.0/8 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3] * HPLs1[0]
										 + 1.0/8 * GHPLs1[3] * HPLs1[1]
										 - 1.0/8 * GHPLs2[0*4+3]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(1. - u - v, -1) * (
											   - 5.0/8 * GHPLs2[2*4+3]
											   - 5.0/8 * GHPLs2[3*4+3]
											   - 1.0/8 * GHPLs1[3]
											   + 5.0/8 * GHPLs1[3] * HPLs1[0]
											   + 5.0/8 * GHPLs1[3] * HPLs1[1]
											   - 5.0/8 * GHPLs2[0*4+3]
											   - 5.0/8 * GHPLs2[2*4+1]
											   + 5.0/4 * GHPLs1[1] * HPLs1[0]
											   + 5.0/8 * GHPLs1[1] * HPLs1[1]
											   - 5.0/8 * GHPLs2[0*4+1]
											   - 5.0/8 * GHPLs2[1*4+1]
											   - 1.0/8 * HPLs1[0]
											   )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * (
								     + 23.0/16
								     + 1.0/4 * zeta2
								     + 3.0/2 * GHPLs3[3*4*4+2*4+2]
								     + 5.0/4 * GHPLs2[2*4+2]
								     + 3.0/2 * GHPLs2[2*4+2] * HPLs1[0]
								     - 3.0/2 * GHPLs3[1*4*4+2*4+2]
								     - 3 * GHPLs2[3*4+2]
								     - 2 * GHPLs1[2]
								     - 3 * GHPLs1[2] * zeta2
								     - 3 * GHPLs1[2] * HPLs1[0]
								     + 3.0/2 * GHPLs1[2] * HPLs2[0*2+0]
								     + 3.0/2 * GHPLs1[2] * HPLs2[1*2+0]
								     - 5.0/4 * GHPLs1[2] * HPLs1[1]
								     - 3.0/2 * GHPLs1[2] * HPLs2[0*2+1]
								     - 3.0/2 * GHPLs3[3*4*4+0*4+2]
								     + 5.0/4 * GHPLs2[0*4+2]
								     - 3.0/2 * GHPLs2[0*4+2] * HPLs1[0]
								     + 3.0/2 * GHPLs3[1*4*4+0*4+2]
								     - 1.0/4 * GHPLs2[1*4+2]
								     + 1.0/2 * GHPLs2[2*4+3]
								     + 1.0/8 * GHPLs1[3]
								     - 1.0/2 * GHPLs1[3] * HPLs1[0]
								     - 1.0/2 * GHPLs1[3] * HPLs1[1]
								     + 1.0/2 * GHPLs2[0*4+3]
								     + 5.0/4 * GHPLs2[2*4+0]
								     + 1.0/2 * GHPLs2[3*4+0]
								     - 3.0/4 * GHPLs1[0]
								     - 5.0/4 * GHPLs1[0] * HPLs1[1]
								     - GHPLs2[1*4+0]
								     - 3.0/2 * GHPLs3[2*4*4+2*4+1]
								     + 3.0/2 * GHPLs3[3*4*4+2*4+1]
								     + 1.0/4 * GHPLs2[2*4+1]
								     + 3.0/2 * GHPLs2[2*4+1] * HPLs1[0]
								     + 3.0/2 * GHPLs2[2*4+1] * HPLs1[1]
								     - 3.0/2 * GHPLs3[0*4*4+2*4+1]
								     + 3.0/2 * GHPLs3[1*4*4+2*4+1]
								     + 13.0/8 * GHPLs1[1]
								     + 3 * GHPLs1[1] * zeta2
								     - GHPLs1[1] * HPLs1[0]
								     - 3.0/2 * GHPLs1[1] * HPLs2[0*2+0]
								     - 3.0/2 * GHPLs1[1] * HPLs2[1*2+0]
								     - 1.0/4 * GHPLs1[1] * HPLs1[1]
								     - 3.0/2 * GHPLs1[1] * HPLs2[0*2+1]
								     - 3.0/2 * GHPLs1[1] * HPLs2[1*2+1]
								     - 3.0/2 * GHPLs3[2*4*4+0*4+1]
								     + 3.0/2 * GHPLs3[3*4*4+0*4+1]
								     + 7.0/4 * GHPLs2[0*4+1]
								     + 3.0/2 * GHPLs2[0*4+1] * HPLs1[0]
								     + 3.0/2 * GHPLs2[0*4+1] * HPLs1[1]
								     - 1.0/2 * GHPLs2[1*4+1]
								     - 3.0/2 * GHPLs3[0*4*4+1*4+1]
								     + 3.0/2 * GHPLs3[1*4*4+1*4+1]
								     + 1.0/8 * HPLs1[0]
								     + 2 * HPLs1[1]
								     + 11.0/4 * HPLs2[0*2+1]
								     + 5.0/4 * HPLs2[1*2+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * v * (
									 - 23.0/16
									 + 9.0/4 * zeta2
									 - 7.0/4 * GHPLs3[3*4*4+2*4+2]
									 - 5.0/4 * GHPLs2[2*4+2]
									 - 7.0/4 * GHPLs2[2*4+2] * HPLs1[0]
									 + 5.0/4 * GHPLs3[1*4*4+2*4+2]
									 - 1.0/2 * GHPLs3[3*4*4+3*4+2]
									 + 5.0/4 * GHPLs2[3*4+2]
									 + 7.0/4 * GHPLs1[2]
									 + 5.0/2 * GHPLs1[2] * zeta2
									 + 3.0/8 * GHPLs1[2] * HPLs1[0]
									 - 7.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									 - 5.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									 + 5.0/4 * GHPLs1[2] * HPLs1[1]
									 + 5.0/4 * GHPLs1[2] * HPLs2[0*2+1]
									 + 7.0/4 * GHPLs3[3*4*4+0*4+2]
									 - 5.0/4 * GHPLs2[0*4+2]
									 + 5.0/4 * GHPLs2[0*4+2] * HPLs1[0]
									 - 5.0/4 * GHPLs3[1*4*4+0*4+2]
									 + 15.0/8 * GHPLs2[1*4+2]
									 + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									 - 1.0/2 * GHPLs3[1*4*4+1*4+2]
									 + 3.0/8 * GHPLs2[2*4+3]
									 + 3.0/8 * GHPLs2[3*4+3]
									 - 11.0/8 * GHPLs1[3]
									 - 3.0/8 * GHPLs1[3] * HPLs1[0]
									 - 3.0/8 * GHPLs1[3] * HPLs1[1]
									 + 3.0/8 * GHPLs2[0*4+3]
									 - 5.0/4 * GHPLs2[2*4+0]
									 + 5.0/4 * GHPLs2[3*4+0]
									 + 1.0/2 * GHPLs1[0]
									 + 5.0/4 * GHPLs1[0] * HPLs1[0]
									 + 5.0/4 * GHPLs1[0] * HPLs1[1]
									 - 1.0/2 * GHPLs2[1*4+0]
									 + 5.0/4 * GHPLs3[2*4*4+2*4+1]
									 - 5.0/4 * GHPLs3[3*4*4+2*4+1]
									 + 1.0/8 * GHPLs2[2*4+1]
									 - 3.0/2 * GHPLs2[2*4+1] * HPLs1[0]
									 - 5.0/4 * GHPLs2[2*4+1] * HPLs1[1]
									 + 5.0/4 * GHPLs3[0*4*4+2*4+1]
									 - 3.0/2 * GHPLs3[1*4*4+2*4+1]
									 + 17.0/16 * GHPLs1[1]
									 - 9.0/4 * GHPLs1[1] * zeta2
									 + 3.0/8 * GHPLs1[1] * HPLs1[0]
									 + 7.0/4 * GHPLs1[1] * HPLs2[0*2+0]
									 + 5.0/4 * GHPLs1[1] * HPLs2[1*2+0]
									 - 1.0/8 * GHPLs1[1] * HPLs1[1]
									 + 3.0/2 * GHPLs1[1] * HPLs2[0*2+1]
									 + 5.0/4 * GHPLs1[1] * HPLs2[1*2+1]
									 + 5.0/4 * GHPLs3[2*4*4+0*4+1]
									 - 5.0/4 * GHPLs3[3*4*4+0*4+1]
									 - 11.0/8 * GHPLs2[0*4+1]
									 - 5.0/4 * GHPLs2[0*4+1] * HPLs1[0]
									 - 5.0/4 * GHPLs2[0*4+1] * HPLs1[1]
									 + 1.0/4 * GHPLs3[1*4*4+0*4+1]
									 - 1.0/2 * GHPLs3[2*4*4+1*4+1]
									 + 3.0/4 * GHPLs2[1*4+1]
									 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
									 + 5.0/4 * GHPLs3[0*4*4+1*4+1]
									 - 3.0/4 * GHPLs3[1*4*4+1*4+1]
									 - 7.0/4 * HPLs1[0]
									 - 7.0/4 * HPLs2[0*2+0]
									 - 5.0/4 * HPLs2[1*2+0]
									 - 7.0/4 * HPLs1[1]
									 - 3.0/2 * HPLs2[0*2+1]
									 - 5.0/4 * HPLs2[1*2+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(v, 2) * (
										 + 1.0/8 * GHPLs1[2]
										 - 1.0/8 * GHPLs1[3]
										 + 1.0/8 * GHPLs1[0]
										 - 1.0/4 * GHPLs1[1]
										 - 1.0/8 * HPLs1[0]
										 - 1.0/8 * HPLs1[1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(v, 3) * (
										 - 1.0/8 * GHPLs2[1*4+2]
										 + 1.0/8 * GHPLs2[2*4+3]
										 - 1.0/8 * GHPLs2[3*4+3]
										 - 1.0/8 * GHPLs1[3] * HPLs1[0]
										 - 1.0/8 * GHPLs1[3] * HPLs1[1]
										 + 1.0/8 * GHPLs2[0*4+3]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(1. - v, -1) * (
									  + 3.0/4 * zeta2
									  - 9.0/8 * GHPLs2[3*4+2]
									  - 3.0/4 * GHPLs1[2] * HPLs1[0]
									  - 5.0/4 * GHPLs1[3]
									  + 9.0/8 * GHPLs2[3*4+0]
									  + 3.0/8 * GHPLs1[0] * HPLs1[0]
									  + 7.0/8 * GHPLs1[1]
									  - 33.0/16 * HPLs1[0]
									  - 9.0/8 * HPLs2[0*2+0]
									  - 3.0/8 * HPLs2[1*2+0]
									  + 3.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(1. - u - v, -1) * (
									      + 1.0/2 * GHPLs2[2*4+3]
									      + 1.0/2 * GHPLs2[3*4+3]
									      + 1.0/4 * GHPLs1[3]
									      - 1.0/2 * GHPLs1[3] * HPLs1[0]
									      - 1.0/2 * GHPLs1[3] * HPLs1[1]
									      + 1.0/2 * GHPLs2[0*4+3]
									      + 1.0/2 * GHPLs2[2*4+1]
									      - GHPLs1[1] * HPLs1[0]
									      - 1.0/2 * GHPLs1[1] * HPLs1[1]
									      + 1.0/2 * GHPLs2[0*4+1]
									      + 1.0/2 * GHPLs2[1*4+1]
									      + 1.0/4 * HPLs1[0]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * (
							+ 25.0/32
							- 5.0/8 * zeta2
							- 1.0/4 * GHPLs3[3*4*4+2*4+2]
							- 7.0/8 * GHPLs2[2*4+2]
							- 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
							+ 1.0/4 * GHPLs3[1*4*4+2*4+2]
							+ 21.0/8 * GHPLs2[3*4+2]
							+ 23.0/16 * GHPLs1[2]
							+ 1.0/2 * GHPLs1[2] * zeta2
							+ 9.0/4 * GHPLs1[2] * HPLs1[0]
							- 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							- 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
							+ 7.0/8 * GHPLs1[2] * HPLs1[1]
							+ 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
							+ 1.0/4 * GHPLs3[3*4*4+0*4+2]
							- 7.0/8 * GHPLs2[0*4+2]
							+ 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							- 1.0/4 * GHPLs3[1*4*4+0*4+2]
							- 1.0/8 * GHPLs2[1*4+2]
							- 1.0/4 * GHPLs2[3*4+3]
							- 3.0/8 * GHPLs1[3]
							- 7.0/8 * GHPLs2[2*4+0]
							- 7.0/8 * GHPLs2[3*4+0]
							+ 7.0/8 * GHPLs1[0]
							- 3.0/8 * GHPLs1[0] * HPLs1[0]
							+ 7.0/8 * GHPLs1[0] * HPLs1[1]
							+ GHPLs2[1*4+0]
							+ 1.0/4 * GHPLs3[2*4*4+2*4+1]
							- 1.0/4 * GHPLs3[3*4*4+2*4+1]
							- 1.0/8 * GHPLs2[2*4+1]
							- 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							- 1.0/4 * GHPLs2[2*4+1] * HPLs1[1]
							+ 1.0/4 * GHPLs3[0*4*4+2*4+1]
							- 1.0/4 * GHPLs3[1*4*4+2*4+1]
							- 41.0/16 * GHPLs1[1]
							- 1.0/2 * GHPLs1[1] * zeta2
							+ 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
							+ 1.0/4 * GHPLs1[1] * HPLs2[1*2+0]
							+ 1.0/8 * GHPLs1[1] * HPLs1[1]
							+ 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							+ 1.0/4 * GHPLs1[1] * HPLs2[1*2+1]
							+ 1.0/4 * GHPLs3[2*4*4+0*4+1]
							- 1.0/4 * GHPLs3[3*4*4+0*4+1]
							- 7.0/8 * GHPLs2[0*4+1]
							- 1.0/4 * GHPLs2[0*4+1] * HPLs1[0]
							- 1.0/4 * GHPLs2[0*4+1] * HPLs1[1]
							+ GHPLs2[1*4+1]
							+ 1.0/4 * GHPLs3[0*4*4+1*4+1]
							- 1.0/4 * GHPLs3[1*4*4+1*4+1]
							+ 7.0/16 * HPLs1[0]
							+ 9.0/8 * HPLs2[0*2+0]
							+ 3.0/8 * HPLs2[1*2+0]
							- 23.0/16 * HPLs1[1]
							- 2 * HPLs2[0*2+1]
							- 7.0/8 * HPLs2[1*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * pow(1. - u, -1) * (
									      + 23.0/32
									      + 1.0/8 * GHPLs2[2*4+2]
									      - 1.0/8 * GHPLs2[3*4+2]
									      + 1.0/16 * GHPLs1[2]
									      - 1.0/4 * GHPLs1[2] * HPLs1[0]
									      - 1.0/8 * GHPLs1[2] * HPLs1[1]
									      + 1.0/8 * GHPLs2[0*4+2]
									      - 1.0/4 * GHPLs2[1*4+2]
									      + 1.0/8 * GHPLs2[2*4+0]
									      - 1.0/8 * GHPLs2[3*4+0]
									      + 3.0/8 * GHPLs1[0]
									      - 1.0/8 * GHPLs1[0] * HPLs1[0]
									      - 1.0/8 * GHPLs1[0] * HPLs1[1]
									      + 1.0/8 * GHPLs2[1*4+0]
									      - 1.0/4 * GHPLs2[2*4+1]
									      - 7.0/16 * GHPLs1[1]
									      + 1.0/4 * GHPLs1[1] * HPLs1[1]
									      + 1.0/4 * GHPLs2[1*4+1]
									      + 3.0/16 * HPLs1[0]
									      + 3.0/8 * HPLs2[0*2+0]
									      + 1.0/8 * HPLs2[1*2+0]
									      - 1.0/16 * HPLs1[1]
									      + 1.0/4 * HPLs2[0*2+1]
									      + 1.0/8 * HPLs2[1*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * (
							    - 9.0/8 * zeta2
							    + 1.0/2 * GHPLs2[2*4+2]
							    - 1.0/2 * GHPLs2[3*4+2]
							    - GHPLs1[2]
							    - 1.0/2 * GHPLs1[2] * HPLs1[0]
							    - 1.0/2 * GHPLs1[2] * HPLs1[1]
							    + 1.0/2 * GHPLs2[0*4+2]
							    - 5.0/8 * GHPLs2[1*4+2]
							    + 1.0/8 * GHPLs2[2*4+3]
							    - 1.0/8 * GHPLs2[3*4+3]
							    + GHPLs1[3]
							    - 1.0/8 * GHPLs1[3] * HPLs1[0]
							    - 1.0/8 * GHPLs1[3] * HPLs1[1]
							    + 1.0/8 * GHPLs2[0*4+3]
							    + 1.0/2 * GHPLs2[2*4+0]
							    - 1.0/2 * GHPLs2[3*4+0]
							    - GHPLs1[0]
							    - 1.0/2 * GHPLs1[0] * HPLs1[0]
							    - 1.0/2 * GHPLs1[0] * HPLs1[1]
							    + 1.0/8 * GHPLs2[1*4+0]
							    + 3.0/4 * GHPLs1[1]
							    + 1.0/2 * GHPLs2[0*4+1]
							    - 5.0/8 * GHPLs2[1*4+1]
							    + HPLs1[0]
							    + 1.0/2 * HPLs2[0*2+0]
							    + 1.0/2 * HPLs2[1*2+0]
							    + HPLs1[1]
							    + 1.0/2 * HPLs2[0*2+1]
							    + 1.0/2 * HPLs2[1*2+1]
							    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(v, 2) * (
								    - 1.0/8 * GHPLs1[2]
								    - 1.0/4 * GHPLs2[1*4+2]
								    + 1.0/4 * GHPLs2[2*4+3]
								    - 1.0/4 * GHPLs2[3*4+3]
								    + 1.0/8 * GHPLs1[3]
								    - 1.0/4 * GHPLs1[3] * HPLs1[0]
								    - 1.0/4 * GHPLs1[3] * HPLs1[1]
								    + 1.0/4 * GHPLs2[0*4+3]
								    - 1.0/8 * GHPLs1[0]
								    + 1.0/8 * GHPLs1[1]
								    + 1.0/8 * HPLs1[0]
								    + 1.0/8 * HPLs1[1]
								    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - v, -2) * (
									      + 5.0/4 * zeta2
									      - 7.0/8 * GHPLs2[3*4+2]
									      - 3.0/4 * GHPLs1[2] * HPLs1[0]
									      + 1.0/2 * GHPLs2[1*4+2]
									      - 3.0/8 * GHPLs1[3]
									      + 7.0/8 * GHPLs2[3*4+0]
									      + 5.0/8 * GHPLs1[0] * HPLs1[0]
									      - 1.0/2 * GHPLs2[1*4+0]
									      + 3.0/8 * GHPLs1[1]
									      - 9.0/16 * HPLs1[0]
									      - 7.0/8 * HPLs2[0*2+0]
									      - 5.0/8 * HPLs2[1*2+0]
									      + 5.0/8 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - v, -1) * (
									      + 5.0/16
									      - 5.0/4 * zeta2
									      + 7.0/8 * GHPLs2[3*4+2]
									      + 5.0/8 * GHPLs1[2]
									      + 3.0/4 * GHPLs1[2] * HPLs1[0]
									      - 1.0/2 * GHPLs2[1*4+2]
									      - 1.0/2 * GHPLs1[3]
									      - 7.0/8 * GHPLs2[3*4+0]
									      + 5.0/8 * GHPLs1[0]
									      - 5.0/8 * GHPLs1[0] * HPLs1[0]
									      + 1.0/2 * GHPLs2[1*4+0]
									      - 7.0/8 * GHPLs1[1]
									      - 5.0/16 * HPLs1[0]
									      + 7.0/8 * HPLs2[0*2+0]
									      + 5.0/8 * HPLs2[1*2+0]
									      - 5.0/8 * HPLs1[1]
									      - 5.0/8 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * (
							    - 3.0/8
							    - 5.0/4 * GHPLs1[2]
							    + 5.0/4 * GHPLs1[3]
							    - 5.0/4 * GHPLs1[0]
							    + 5.0/4 * GHPLs1[1]
							    + 5.0/4 * HPLs1[0]
							    + 5.0/4 * HPLs1[1]
							    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * v * (
								- 1.0/8 * zeta2
								- 3.0/8 * GHPLs1[2]
								- 1.0/8 * GHPLs2[1*4+2]
								+ 1.0/8 * GHPLs2[2*4+3]
								- 1.0/8 * GHPLs2[3*4+3]
								+ 3.0/8 * GHPLs1[3]
								- 1.0/8 * GHPLs1[3] * HPLs1[0]
								- 1.0/8 * GHPLs1[3] * HPLs1[1]
								+ 1.0/8 * GHPLs2[0*4+3]
								- 3.0/8 * GHPLs1[0]
								+ 1.0/8 * GHPLs2[1*4+0]
								+ 3.0/8 * GHPLs1[1]
								- 1.0/8 * GHPLs2[1*4+1]
								+ 3.0/8 * HPLs1[0]
								+ 3.0/8 * HPLs1[1]
								)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -3) * (
										      - 3.0/2 * zeta2
										      + 3.0/4 * GHPLs2[3*4+2]
										      + 3.0/4 * GHPLs1[2] * HPLs1[0]
										      - 3.0/4 * GHPLs2[1*4+2]
										      - 9.0/4 * GHPLs1[3]
										      - 3.0/4 * GHPLs2[3*4+0]
										      - 3.0/4 * GHPLs1[0] * HPLs1[0]
										      + 3.0/4 * GHPLs2[1*4+0]
										      + 9.0/4 * GHPLs1[1]
										      - 9.0/4 * HPLs1[0]
										      + 3.0/4 * HPLs2[0*2+0]
										      + 3.0/4 * HPLs2[1*2+0]
										      - 3.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -2) * (
										      + 3.0/2 * zeta2
										      - 3.0/4 * GHPLs2[3*4+2]
										      - 3.0/4 * GHPLs1[2]
										      - 3.0/4 * GHPLs1[2] * HPLs1[0]
										      + 3.0/4 * GHPLs2[1*4+2]
										      + 3 * GHPLs1[3]
										      + 3.0/4 * GHPLs2[3*4+0]
										      - 3.0/4 * GHPLs1[0]
										      + 3.0/4 * GHPLs1[0] * HPLs1[0]
										      - 3.0/4 * GHPLs2[1*4+0]
										      - 3.0/2 * GHPLs1[1]
										      + 3 * HPLs1[0]
										      - 3.0/4 * HPLs2[0*2+0]
										      - 3.0/4 * HPLs2[1*2+0]
										      + 3.0/4 * HPLs1[1]
										      + 3.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -1) * (
										      + 3.0/8 * GHPLs1[2]
										      - 3.0/8 * GHPLs1[3]
										      + 3.0/8 * GHPLs1[0]
										      - 3.0/8 * GHPLs1[1]
										      - 3.0/8 * HPLs1[0]
										      - 3.0/8 * HPLs1[1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * (
								    + 1.0/8 * GHPLs1[2]
								    - 1.0/8 * GHPLs1[3]
								    + 1.0/8 * GHPLs1[0]
								    - 1.0/8 * GHPLs1[1]
								    - 1.0/8 * HPLs1[0]
								    - 1.0/8 * HPLs1[1]
								    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -4) * (
										      + 9.0/2 * zeta2
										      - 9.0/4 * GHPLs2[3*4+2]
										      - 9.0/4 * GHPLs1[2] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+2]
										      + 9.0/4 * GHPLs2[3*4+0]
										      + 9.0/4 * GHPLs1[0] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+0]
										      - 9.0/4 * HPLs2[0*2+0]
										      - 9.0/4 * HPLs2[1*2+0]
										      + 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -3) * (
										      - 9.0/2 * zeta2
										      + 9.0/4 * GHPLs2[3*4+2]
										      + 9.0/4 * GHPLs1[2]
										      + 9.0/4 * GHPLs1[2] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+2]
										      - 9.0/4 * GHPLs1[3]
										      - 9.0/4 * GHPLs2[3*4+0]
										      + 9.0/4 * GHPLs1[0]
										      - 9.0/4 * GHPLs1[0] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+0]
										      - 9.0/4 * GHPLs1[1]
										      - 9.0/4 * HPLs1[0]
										      + 9.0/4 * HPLs2[0*2+0]
										      + 9.0/4 * HPLs2[1*2+0]
										      - 9.0/4 * HPLs1[1]
										      - 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -2) * (
										      - 9.0/8 * GHPLs1[2]
										      + 9.0/8 * GHPLs1[3]
										      - 9.0/8 * GHPLs1[0]
										      + 9.0/8 * GHPLs1[1]
										      + 9.0/8 * HPLs1[0]
										      + 9.0/8 * HPLs1[1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -1) * (
										      - 3.0/8 * GHPLs1[2]
										      + 3.0/8 * GHPLs1[3]
										      - 3.0/8 * GHPLs1[0]
										      + 3.0/8 * GHPLs1[1]
										      + 3.0/8 * HPLs1[0]
										      + 3.0/8 * HPLs1[1]
										      )

    + C_F * dN_f * pow(u, -2) * (
			       + 1.0/3 * GHPLs2[2*4+2] * HPLs1[0]
			       + 1.0/3 * GHPLs1[2] * zeta2
			       - 19.0/18 * GHPLs1[2] * HPLs1[0]
			       - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
			       - 1.0/3 * GHPLs1[2] * HPLs2[1*2+0]
			       + 1.0/3 * GHPLs3[2*4*4+2*4+1]
			       - 19.0/18 * GHPLs2[2*4+1]
			       - 1.0/3 * GHPLs2[2*4+1] * HPLs1[0]
			       - 1.0/3 * GHPLs2[2*4+1] * HPLs1[1]
			       + 1.0/3 * GHPLs1[1] * zeta2
			       + 19.0/18 * GHPLs1[1] * HPLs1[0]
			       + 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
			       + 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
			       + 19.0/18 * GHPLs1[1] * HPLs1[1]
			       + 1.0/3 * GHPLs1[1] * HPLs2[0*2+1]
			       + 1.0/3 * GHPLs1[1] * HPLs2[1*2+1]
			       + 1.0/3 * GHPLs3[2*4*4+1*4+1]
			       - 1.0/3 * GHPLs2[1*4+1] * HPLs1[0]
			       - 1.0/3 * GHPLs2[1*4+1] * HPLs1[1]
			       )

    + C_F * dN_f * pow(u, -2) * v * (
				   - 1.0/3 * GHPLs2[2*4+2] * HPLs1[0]
				   - 1.0/3 * GHPLs1[2] * zeta2
				   + 19.0/18 * GHPLs1[2] * HPLs1[0]
				   + 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				   + 1.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				   - 1.0/3 * GHPLs3[2*4*4+2*4+1]
				   + 19.0/18 * GHPLs2[2*4+1]
				   + 1.0/3 * GHPLs2[2*4+1] * HPLs1[0]
				   + 1.0/3 * GHPLs2[2*4+1] * HPLs1[1]
				   - 1.0/3 * GHPLs1[1] * zeta2
				   - 19.0/18 * GHPLs1[1] * HPLs1[0]
				   - 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
				   - 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
				   - 19.0/18 * GHPLs1[1] * HPLs1[1]
				   - 1.0/3 * GHPLs1[1] * HPLs2[0*2+1]
				   - 1.0/3 * GHPLs1[1] * HPLs2[1*2+1]
				   - 1.0/3 * GHPLs3[2*4*4+1*4+1]
				   + 1.0/3 * GHPLs2[1*4+1] * HPLs1[0]
				   + 1.0/3 * GHPLs2[1*4+1] * HPLs1[1]
				   )

    + C_F * dN_f * pow(u, -1) * (
			       + 2.0/3 * zeta2
			       + 1.0/3 * GHPLs2[2*4+2]
			       - 19.0/18 * GHPLs1[2]
			       - 1.0/3 * GHPLs1[2] * HPLs1[1]
			       + 1.0/3 * GHPLs2[2*4+1]
			       - 1.0/3 * GHPLs1[1] * HPLs1[0]
			       - 1.0/3 * GHPLs1[1] * HPLs1[1]
			       + 1.0/3 * HPLs2[1*2+0]
			       + 19.0/18 * HPLs1[1]
			       + 1.0/3 * HPLs2[0*2+1]
			       + 1.0/3 * HPLs2[1*2+1]
			       )

    + C_F * dN_f * pow(u, -1) * v * (
				   - 1.0/3 * zeta2
				   - 1.0/3 * GHPLs2[2*4+2]
				   + 1.0/3 * GHPLs2[2*4+2] * HPLs1[0]
				   + 19.0/18 * GHPLs1[2]
				   + 1.0/3 * GHPLs1[2] * zeta2
				   - 13.0/18 * GHPLs1[2] * HPLs1[0]
				   - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				   - 1.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				   + 1.0/3 * GHPLs1[2] * HPLs1[1]
				   + 1.0/3 * GHPLs3[2*4*4+2*4+1]
				   - 25.0/18 * GHPLs2[2*4+1]
				   - 1.0/3 * GHPLs2[2*4+1] * HPLs1[0]
				   - 1.0/3 * GHPLs2[2*4+1] * HPLs1[1]
				   + 1.0/3 * GHPLs1[1] * zeta2
				   + 25.0/18 * GHPLs1[1] * HPLs1[0]
				   + 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
				   + 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
				   + 25.0/18 * GHPLs1[1] * HPLs1[1]
				   + 1.0/3 * GHPLs1[1] * HPLs2[0*2+1]
				   + 1.0/3 * GHPLs1[1] * HPLs2[1*2+1]
				   + 1.0/3 * GHPLs3[2*4*4+1*4+1]
				   - 1.0/3 * GHPLs2[1*4+1] * HPLs1[0]
				   - 1.0/3 * GHPLs2[1*4+1] * HPLs1[1]
				   - 19.0/18 * HPLs1[0]
				   - 2.0/3 * HPLs2[0*2+0]
				   - 2.0/3 * HPLs2[1*2+0]
				   - 19.0/18 * HPLs1[1]
				   - 1.0/3 * HPLs2[0*2+1]
				   - 1.0/3 * HPLs2[1*2+1]
				   )

    + C_F * dN_f * pow(1. - v, -1) * (
				    + 1.0/2 * zeta2
				    + 1.0/2 * GHPLs1[2] * HPLs1[0]
				    - 17.0/12 * HPLs1[0]
				    - HPLs2[0*2+0]
				    - 1.0/2 * HPLs2[1*2+0]
				    )

    + C_F * dN_f * (
		  - 19.0/36
		  - 1.0/6 * zeta2
		  + 1.0/6 * GHPLs2[2*4+2]
		  - 7.0/36 * GHPLs1[2]
		  - 1.0/2 * GHPLs1[2] * HPLs1[0]
		  - 1.0/6 * GHPLs1[2] * HPLs1[1]
		  + 1.0/6 * GHPLs2[2*4+1]
		  - 1.0/6 * GHPLs1[1] * HPLs1[0]
		  - 1.0/6 * GHPLs1[1] * HPLs1[1]
		  + 5.0/4 * HPLs1[0]
		  + HPLs2[0*2+0]
		  + 2.0/3 * HPLs2[1*2+0]
		  + 7.0/36 * HPLs1[1]
		  + 1.0/6 * HPLs2[0*2+1]
		  + 1.0/6 * HPLs2[1*2+1]
		  )

    + C_F * dN_f * v * pow(1. - u, -1) * (
					+ 1.0/6 * zeta2
					+ 1.0/6 * GHPLs2[2*4+2]
					- 25.0/36 * GHPLs1[2]
					- 1.0/6 * GHPLs1[2] * HPLs1[0]
					- 1.0/6 * GHPLs1[2] * HPLs1[1]
					+ 1.0/6 * GHPLs2[2*4+1]
					- 1.0/6 * GHPLs1[1] * HPLs1[0]
					- 1.0/6 * GHPLs1[1] * HPLs1[1]
					+ 25.0/36 * HPLs1[0]
					+ 1.0/3 * HPLs2[0*2+0]
					+ 1.0/3 * HPLs2[1*2+0]
					+ 25.0/36 * HPLs1[1]
					+ 1.0/6 * HPLs2[0*2+1]
					+ 1.0/6 * HPLs2[1*2+1]
					)

    + C_F * dN_f * u * pow(1. - v, -2) * (
					+ 1.0/6 * zeta2
					+ 1.0/6 * GHPLs1[2] * HPLs1[0]
					- 13.0/36 * HPLs1[0]
					- 1.0/3 * HPLs2[0*2+0]
					- 1.0/6 * HPLs2[1*2+0]
					)

    + C_F * dN_f * u * pow(1. - v, -1) * (
					- 19.0/36
					- 1.0/6 * zeta2
					+ 1.0/6 * GHPLs1[2]
					- 1.0/6 * GHPLs1[2] * HPLs1[0]
					+ 7.0/36 * HPLs1[0]
					+ 1.0/3 * HPLs2[0*2+0]
					+ 1.0/6 * HPLs2[1*2+0]
					- 1.0/6 * HPLs1[1]
					)

    + C_F * dN_f * ri * M_PI * pow(u, -2) * (
					   - 19.0/18 * GHPLs1[1]
					   - 1.0/3 * GHPLs1[1] * HPLs1[0]
					   + 1.0/3 * GHPLs2[1*4+1]
					   )

    + C_F * dN_f * ri * M_PI * pow(u, -2) * v * (
					       + 19.0/18 * GHPLs1[1]
					       + 1.0/3 * GHPLs1[1] * HPLs1[0]
					       - 1.0/3 * GHPLs2[1*4+1]
					       )

    + C_F * dN_f * ri * M_PI * pow(u, -1) * (
					   - 19.0/18
					   + 1.0/3 * GHPLs1[1]
					   - 1.0/3 * HPLs1[0]
					   )

    + C_F * dN_f * ri * M_PI * pow(u, -1) * v * (
					       + 19.0/18
					       - 25.0/18 * GHPLs1[1]
					       - 1.0/3 * GHPLs1[1] * HPLs1[0]
					       + 1.0/3 * GHPLs2[1*4+1]
					       + 1.0/3 * HPLs1[0]
					       )

    + C_F * dN_f * ri * M_PI * (
			      - 13.0/36
			      + 1.0/6 * GHPLs1[1]
			      - 1.0/6 * HPLs1[0]
			      )

    + C_F * dN_f * ri * M_PI * v * pow(1. - u, -1) * (
						    - 25.0/36
						    + 1.0/6 * GHPLs1[1]
						    - 1.0/6 * HPLs1[0]
						    );
  return beta;
}

double_complex pplla03_amplitude_set::beta_2_3() {
  //  const double zeta2 = M_PI * M_PI/6;
  //  const double zeta3 = 1.20205690315959429;
  //  const double zeta4 = pow(M_PI,4)/90;
  //  const double dN_c=3;
  //  const double C_F=(dN_c * dN_c - 1.) / (2 * dN_c);
  //  double NF=(double)n_f;

  double_complex beta =
    (dN_c * dN_c - 1.) * u * pow(1. - v, -1) * (
						+ 81659.0/10368
						- 49.0/32 * zeta4
						+ 5.0/12 * zeta2
						- 389.0/144 * zeta3
						+ 2759.0/864 * HPLs1[0]
						+ 11.0/16 * HPLs1[0] * zeta2
						- 7.0/4 * HPLs1[0] * zeta3
						)

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - v, -1) * (
							      + 2759.0/864
							      + 11.0/16 * zeta2
							      - 7.0/4 * zeta3
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - v, -1) * (
								  + 255.0/128
								  - 11.0/8 * zeta4
								  + 29.0/16 * zeta2
								  - 15.0/8 * zeta3
								  - 3.0/32 * HPLs1[0]
								  + 3.0/4 * HPLs1[0] * zeta2
								  - 3.0/2 * HPLs1[0] * zeta3
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - v, -1) * (
									      - 3.0/32
									      + 3.0/4 * zeta2
									      - 3.0/2 * zeta3
									      )

    + C_F * dN_f * u * pow(1. - v, -1) * (
					- 4085.0/1296
					- 7.0/12 * zeta2
					+ 1.0/36 * zeta3
					- 119.0/108 * HPLs1[0]
					- 1.0/4 * HPLs1[0] * zeta2
					)

    + C_F * dN_f * ri * M_PI * u * pow(1. - v, -1) * (
						    - 119.0/108
						    - 1.0/4 * zeta2
						    );
  return beta;
}

double_complex pplla03_amplitude_set::beta_2_4() {
  //  const double zeta2 = M_PI * M_PI/6;
  //  const double zeta3 = 1.20205690315959429;
  //  const double zeta4 = pow(M_PI,4)/90;
  //  const double dN_c=3;
  //  const double CF=(dN_c * dN_c - 1.) / (2 * dN_c);
  //  double NF=(double)n_f;

  double_complex beta =
    C_F * pow(u, -2) * (
			+ 4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
			- 4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
			- 4 * GHPLs2[2*4+2] * zeta2
			+ 4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
			- 4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
			- 4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
			+ 2.0/3 * GHPLs1[2] * zeta2
			- 4 * GHPLs1[2] * zeta3
			+ GHPLs1[2] * HPLs1[0]
			- 4 * GHPLs1[2] * HPLs1[0] * zeta2
			- 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
			+ 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
			- 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
			- 4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
			- 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
			- 4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
			+ 4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
			- 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
			- 4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
			- 2.0/3 * GHPLs3[2*4*4+1*4+2]
			+ 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
			+ 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
			+ 4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
			- 4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
			+ GHPLs2[2*4+1]
			- 4 * GHPLs2[2*4+1] * zeta2
			+ 4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
			- 4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
			- 2.0/3 * GHPLs3[0*4*4+2*4+1]
			- 4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
			+ 8.0/3 * GHPLs1[1] * zeta2
			- 4 * GHPLs1[1] * zeta3
			- GHPLs1[1] * HPLs1[0]
			+ 4 * GHPLs1[1] * HPLs1[0] * zeta2
			+ 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
			- 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
			+ 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
			+ 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
			- GHPLs1[1] * HPLs1[1]
			+ 4 * GHPLs1[1] * HPLs1[1] * zeta2
			- 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
			+ 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
			- 2.0/3 * GHPLs3[2*4*4+0*4+1]
			+ 4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
			- 4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
			+ 8 * GHPLs2[0*4+1] * zeta2
			+ 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
			+ 4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
			+ 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
			+ 4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
			+ 2.0/3 * GHPLs3[2*4*4+1*4+1]
			- 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
			- 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
			)

    + C_F * pow(u, -2) * v * (
			      - 4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
			      + 4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
			      + 4 * GHPLs2[2*4+2] * zeta2
			      - 4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
			      + 4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
			      + 4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
			      - 2.0/3 * GHPLs1[2] * zeta2
			      + 4 * GHPLs1[2] * zeta3
			      - 2.0/3 * GHPLs1[2] * HPLs1[0]
			      + 4 * GHPLs1[2] * HPLs1[0] * zeta2
			      + 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
			      - 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
			      + 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
			      + 4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
			      + 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
			      + 4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
			      - 4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
			      + 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
			      + 4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
			      + 2.0/3 * GHPLs3[2*4*4+1*4+2]
			      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
			      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
			      - 4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
			      + 4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
			      - 2.0/3 * GHPLs2[2*4+1]
			      + 4 * GHPLs2[2*4+1] * zeta2
			      - 4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
			      + 4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
			      + 2.0/3 * GHPLs3[0*4*4+2*4+1]
			      + 4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
			      - 8.0/3 * GHPLs1[1] * zeta2
			      + 4 * GHPLs1[1] * zeta3
			      + 2.0/3 * GHPLs1[1] * HPLs1[0]
			      - 4 * GHPLs1[1] * HPLs1[0] * zeta2
			      - 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
			      + 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
			      - 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
			      - 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
			      + 2.0/3 * GHPLs1[1] * HPLs1[1]
			      - 4 * GHPLs1[1] * HPLs1[1] * zeta2
			      + 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
			      - 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
			      + 2.0/3 * GHPLs3[2*4*4+0*4+1]
			      - 4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
			      + 4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
			      - 8 * GHPLs2[0*4+1] * zeta2
			      - 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
			      - 4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
			      - 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
			      - 4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
			      - 2.0/3 * GHPLs3[2*4*4+1*4+1]
			      + 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
			      + 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
			      )

    + C_F * pow(u, -2) * pow(v, 2) * (
				      + 1.0/3 * GHPLs1[2] * HPLs1[0]
				      + 1.0/3 * GHPLs2[2*4+1]
				      - 1.0/3 * GHPLs1[1] * HPLs1[0]
				      - 1.0/3 * GHPLs1[1] * HPLs1[1]
				      )

    + C_F * pow(u, -2) * pow(v, 3) * (
				      - 2.0/3 * GHPLs1[2] * zeta2
				      - 2.0/3 * GHPLs1[2] * HPLs1[0]
				      - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				      + 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				      + 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
				      + 2.0/3 * GHPLs3[2*4*4+1*4+2]
				      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
				      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
				      + 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
				      - 2.0/3 * GHPLs3[0*4*4+2*4+3]
				      - 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
				      + 2.0/3 * GHPLs3[0*4*4+3*4+3]
				      + 10.0/3 * GHPLs1[3] * zeta2
				      - 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
				      - 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
				      - 2.0/3 * GHPLs3[2*4*4+0*4+3]
				      + 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
				      - 2.0/3 * GHPLs2[2*4+1]
				      + 2.0/3 * GHPLs1[1] * HPLs1[0]
				      + 2.0/3 * GHPLs1[1] * HPLs1[1]
				      )

    + C_F * pow(u, -2) * pow(v, 4) * (
				      + 2.0/3 * GHPLs1[2] * zeta2
				      + 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				      - 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				      - 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
				      - 2.0/3 * GHPLs3[2*4*4+1*4+2]
				      + 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
				      + 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
				      - 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
				      + 2.0/3 * GHPLs3[0*4*4+2*4+3]
				      + 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
				      - 2.0/3 * GHPLs3[0*4*4+3*4+3]
				      - 10.0/3 * GHPLs1[3] * zeta2
				      + 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
				      + 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
				      + 2.0/3 * GHPLs3[2*4*4+0*4+3]
				      - 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
				      )

    + C_F * pow(u, -1) * (
			  - 14.0/3 * zeta2
			  - 8 * zeta3
			  - 6 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
			  + 6 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
			  + 6 * GHPLs2[2*4+2] * zeta2
			  - 6 * GHPLs2[2*4+2] * HPLs2[0*2+0]
			  + 6 * GHPLs2[2*4+2] * HPLs2[0*2+1]
			  + 6 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
			  + 8 * GHPLs2[3*4+2] * HPLs1[0]
			  - 8 * GHPLs3[0*4*4+3*4+2]
			  + 5.0/3 * GHPLs1[2]
			  - 8 * GHPLs1[2] * zeta2
			  + 6 * GHPLs1[2] * zeta3
			  - 1.0/2 * GHPLs1[2] * HPLs1[0]
			  + 6 * GHPLs1[2] * HPLs1[0] * zeta2
			  + 9 * GHPLs1[2] * HPLs2[0*2+0]
			  - 6 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
			  + GHPLs1[2] * HPLs2[1*2+0]
			  + 6 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
			  - 7 * GHPLs1[2] * HPLs2[0*2+1]
			  + 6 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
			  + 6 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
			  - 6 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
			  - 2.0/3 * GHPLs2[0*4+2]
			  - 6 * GHPLs2[0*4+2] * HPLs1[0]
			  + 6 * GHPLs2[0*4+2] * HPLs2[0*2+0]
			  + GHPLs3[2*4*4+1*4+2]
			  - GHPLs2[1*4+2] * HPLs1[0]
			  - GHPLs2[1*4+2] * HPLs1[1]
			  - 2.0/3 * GHPLs2[2*4+0]
			  + 8 * GHPLs1[0] * zeta2
			  + 2.0/3 * GHPLs1[0] * HPLs1[1]
			  + 4 * GHPLs1[0] * HPLs2[0*2+1]
			  - 6 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
			  + 6 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
			  - 1.0/2 * GHPLs2[2*4+1]
			  + 6 * GHPLs2[2*4+1] * zeta2
			  - 6 * GHPLs2[2*4+1] * HPLs2[0*2+0]
			  + 6 * GHPLs2[2*4+1] * HPLs2[0*2+1]
			  + 2 * GHPLs3[0*4*4+2*4+1]
			  + 6 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
			  - 10 * GHPLs1[1] * zeta2
			  + 6 * GHPLs1[1] * zeta3
			  + 1.0/2 * GHPLs1[1] * HPLs1[0]
			  - 6 * GHPLs1[1] * HPLs1[0] * zeta2
			  - GHPLs1[1] * HPLs2[0*2+0]
			  + 6 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
			  - GHPLs1[1] * HPLs2[1*2+0]
			  - 6 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
			  + 1.0/2 * GHPLs1[1] * HPLs1[1]
			  - 6 * GHPLs1[1] * HPLs1[1] * zeta2
			  + 6 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
			  - 6 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
			  + 2 * GHPLs3[2*4*4+0*4+1]
			  - 6 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
			  + 6 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
			  - 12 * GHPLs2[0*4+1] * zeta2
			  - 2 * GHPLs2[0*4+1] * HPLs1[0]
			  - 6 * GHPLs2[0*4+1] * HPLs2[0*2+0]
			  - 2 * GHPLs2[0*4+1] * HPLs1[1]
			  - 6 * GHPLs2[0*4+1] * HPLs2[0*2+1]
			  - GHPLs3[2*4*4+1*4+1]
			  + GHPLs2[1*4+1] * HPLs1[0]
			  + GHPLs2[1*4+1] * HPLs1[1]
			  - 5.0/3 * HPLs1[1]
			  + 4 * HPLs1[1] * zeta2
			  - 4 * HPLs2[0*2+1]
			  - 8 * HPLs3[0*2*2+0*2+1]
			  + 4 * HPLs3[0*2*2+1*2+1]
			  )

    + C_F * pow(u, -1) * v * (
			      + 16.0/3 * zeta2
			      + 4 * zeta3
			      + 4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
			      - 4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
			      - 4 * GHPLs2[2*4+2] * zeta2
			      + 4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
			      - 4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
			      - 4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
			      - 4 * GHPLs2[3*4+2] * HPLs1[0]
			      + 4 * GHPLs3[0*4*4+3*4+2]
			      - 4.0/3 * GHPLs1[2]
			      + 14.0/3 * GHPLs1[2] * zeta2
			      - 4 * GHPLs1[2] * zeta3
			      + 1.0/2 * GHPLs1[2] * HPLs1[0]
			      - 4 * GHPLs1[2] * HPLs1[0] * zeta2
			      - 14.0/3 * GHPLs1[2] * HPLs2[0*2+0]
			      + 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
			      - 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
			      - 4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
			      + 4 * GHPLs1[2] * HPLs2[0*2+1]
			      - 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
			      - 4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
			      + 4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
			      + 2.0/3 * GHPLs2[0*4+2]
			      + 10.0/3 * GHPLs2[0*4+2] * HPLs1[0]
			      - 4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
			      - 2.0/3 * GHPLs3[2*4*4+1*4+2]
			      + 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
			      + 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
			      + 4 * GHPLs1[3] * HPLs1[0]
			      - 4 * GHPLs2[0*4+3]
			      + 2.0/3 * GHPLs2[2*4+0]
			      - 4 * GHPLs2[3*4+0] * HPLs1[0]
			      + 4 * GHPLs3[0*4*4+3*4+0]
			      - 8 * GHPLs1[0] * zeta2
			      - 2.0/3 * GHPLs1[0] * HPLs1[0]
			      - 4 * GHPLs1[0] * HPLs2[0*2+0]
			      - 2.0/3 * GHPLs1[0] * HPLs1[1]
			      - 4 * GHPLs1[0] * HPLs2[0*2+1]
			      + 4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
			      - 4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
			      - 1.0/6 * GHPLs2[2*4+1]
			      - 4 * GHPLs2[2*4+1] * zeta2
			      + 4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
			      - 4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
			      - 2.0/3 * GHPLs3[0*4*4+2*4+1]
			      - 4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
			      + 8.0/3 * GHPLs1[1] * zeta2
			      - 4 * GHPLs1[1] * zeta3
			      + 1.0/6 * GHPLs1[1] * HPLs1[0]
			      + 4 * GHPLs1[1] * HPLs1[0] * zeta2
			      + 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
			      - 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
			      + 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
			      + 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
			      + 1.0/6 * GHPLs1[1] * HPLs1[1]
			      + 4 * GHPLs1[1] * HPLs1[1] * zeta2
			      - 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
			      + 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
			      - 2.0/3 * GHPLs3[2*4*4+0*4+1]
			      + 4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
			      - 4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
			      + 8 * GHPLs2[0*4+1] * zeta2
			      + 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
			      + 4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
			      + 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
			      + 4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
			      + 2.0/3 * GHPLs3[2*4*4+1*4+1]
			      - 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
			      - 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
			      + 5.0/3 * HPLs1[0]
			      - 4 * HPLs1[0] * zeta2
			      + 10.0/3 * HPLs2[0*2+0]
			      + 4 * HPLs3[0*2*2+0*2+0]
			      - 2.0/3 * HPLs2[1*2+0]
			      - 4 * HPLs3[0*2*2+1*2+0]
			      + 4.0/3 * HPLs1[1]
			      - 4 * HPLs1[1] * zeta2
			      + 4 * HPLs2[0*2+1]
			      + 4 * HPLs3[0*2*2+0*2+1]
			      - 4 * HPLs3[0*2*2+1*2+1]
			      )

    + C_F * pow(u, -1) * pow(v, 2) * (
				      - 10.0/3 * zeta2
				      - 1.0/3 * GHPLs1[2]
				      - GHPLs1[2] * zeta2
				      - 7.0/3 * GHPLs1[2] * HPLs1[0]
				      - GHPLs1[2] * HPLs2[0*2+0]
				      + GHPLs1[2] * HPLs2[1*2+0]
				      + 2.0/3 * GHPLs2[0*4+2]
				      + GHPLs2[0*4+2] * HPLs1[0]
				      + GHPLs3[2*4*4+1*4+2]
				      - GHPLs2[1*4+2] * HPLs1[0]
				      - GHPLs2[1*4+2] * HPLs1[1]
				      + GHPLs2[2*4+3] * HPLs1[0]
				      - GHPLs3[0*4*4+2*4+3]
				      - GHPLs2[3*4+3] * HPLs1[0]
				      + GHPLs3[0*4*4+3*4+3]
				      + 5 * GHPLs1[3] * zeta2
				      + 2.0/3 * GHPLs1[3] * HPLs1[0]
				      - GHPLs1[3] * HPLs2[1*2+0]
				      - GHPLs1[3] * HPLs2[0*2+1]
				      - GHPLs3[2*4*4+0*4+3]
				      - 2.0/3 * GHPLs2[0*4+3]
				      + GHPLs2[0*4+3] * HPLs1[1]
				      + 2.0/3 * GHPLs2[2*4+0]
				      - 2.0/3 * GHPLs1[0] * HPLs1[1]
				      - 5.0/3 * GHPLs2[2*4+1]
				      + 5.0/3 * GHPLs1[1] * HPLs1[0]
				      + 5.0/3 * GHPLs1[1] * HPLs1[1]
				      + 1.0/3 * HPLs1[0]
				      + 2.0/3 * HPLs2[1*2+0]
				      + 1.0/3 * HPLs1[1]
				      + 2.0/3 * HPLs2[0*2+1]
				      )

    + C_F * pow(u, -1) * pow(v, 3) * (
				      + 8.0/3 * zeta2
				      + 2 * GHPLs1[2] * zeta2
				      + 4.0/3 * GHPLs1[2] * HPLs1[0]
				      + 2 * GHPLs1[2] * HPLs2[0*2+0]
				      - 2 * GHPLs1[2] * HPLs2[1*2+0]
				      - 2.0/3 * GHPLs2[0*4+2]
				      - 2 * GHPLs2[0*4+2] * HPLs1[0]
				      - 2 * GHPLs3[2*4*4+1*4+2]
				      + 2 * GHPLs2[1*4+2] * HPLs1[0]
				      + 2 * GHPLs2[1*4+2] * HPLs1[1]
				      - 2 * GHPLs2[2*4+3] * HPLs1[0]
				      + 2 * GHPLs3[0*4*4+2*4+3]
				      + 2 * GHPLs2[3*4+3] * HPLs1[0]
				      - 2 * GHPLs3[0*4*4+3*4+3]
				      - 10 * GHPLs1[3] * zeta2
				      - 2.0/3 * GHPLs1[3] * HPLs1[0]
				      + 2 * GHPLs1[3] * HPLs2[1*2+0]
				      + 2 * GHPLs1[3] * HPLs2[0*2+1]
				      + 2 * GHPLs3[2*4*4+0*4+3]
				      + 2.0/3 * GHPLs2[0*4+3]
				      - 2 * GHPLs2[0*4+3] * HPLs1[1]
				      - 2.0/3 * GHPLs2[2*4+0]
				      + 2.0/3 * GHPLs1[0] * HPLs1[0]
				      + 2.0/3 * GHPLs1[0] * HPLs1[1]
				      + 4.0/3 * GHPLs2[2*4+1]
				      - 4.0/3 * GHPLs1[1] * HPLs1[0]
				      - 4.0/3 * GHPLs1[1] * HPLs1[1]
				      - 2.0/3 * HPLs2[0*2+0]
				      - 2.0/3 * HPLs2[0*2+1]
				      )

    + C_F * pow(u, -1) * pow(v, 4) * (
				      - 2.0/3 * GHPLs1[2] * zeta2
				      - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				      + 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				      + 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
				      + 2.0/3 * GHPLs3[2*4*4+1*4+2]
				      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
				      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
				      + 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
				      - 2.0/3 * GHPLs3[0*4*4+2*4+3]
				      - 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
				      + 2.0/3 * GHPLs3[0*4*4+3*4+3]
				      + 10.0/3 * GHPLs1[3] * zeta2
				      - 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
				      - 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
				      - 2.0/3 * GHPLs3[2*4*4+0*4+3]
				      + 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
				      )

    + C_F * pow(1. - u, -1) * (
			       + 3 * zeta2
			       - 3 * GHPLs1[3] * HPLs1[0]
			       + 3 * GHPLs2[0*4+3]
			       + 3 * GHPLs1[0] * HPLs1[0]
			       - 3 * HPLs2[0*2+0]
			       + 3 * HPLs2[0*2+1]
			       )

    + C_F * pow(1. - u - v, -1) * (
				   - zeta2
				   + GHPLs1[3] * HPLs1[0]
				   - GHPLs2[0*4+3]
				   - GHPLs1[0] * HPLs1[0]
				   + HPLs2[0*2+0]
				   - HPLs2[0*2+1]
				   )

    + C_F * (
	     - 13.0/3 * zeta2
	     + 8 * zeta3
	     + 2 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
	     - 2 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
	     - 2 * GHPLs2[2*4+2] * zeta2
	     + 2 * GHPLs2[2*4+2] * HPLs2[0*2+0]
	     - 2 * GHPLs2[2*4+2] * HPLs2[0*2+1]
	     - 2 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
	     - 8 * GHPLs2[3*4+2] * HPLs1[0]
	     + 8 * GHPLs3[0*4*4+3*4+2]
	     - 11.0/6 * GHPLs1[2]
	     + 8 * GHPLs1[2] * zeta2
	     - 2 * GHPLs1[2] * zeta3
	     - 1.0/2 * GHPLs1[2] * HPLs1[0]
	     - 2 * GHPLs1[2] * HPLs1[0] * zeta2
	     - 9 * GHPLs1[2] * HPLs2[0*2+0]
	     + 2 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
	     - GHPLs1[2] * HPLs2[1*2+0]
	     - 2 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
	     + 7 * GHPLs1[2] * HPLs2[0*2+1]
	     - 2 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
	     - 2 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
	     + 2 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
	     + 5.0/3 * GHPLs2[0*4+2]
	     + 6 * GHPLs2[0*4+2] * HPLs1[0]
	     - 2 * GHPLs2[0*4+2] * HPLs2[0*2+0]
	     - GHPLs3[2*4*4+1*4+2]
	     + GHPLs2[1*4+2] * HPLs1[0]
	     + GHPLs2[1*4+2] * HPLs1[1]
	     + 6 * GHPLs1[3] * HPLs1[0]
	     - 6 * GHPLs2[0*4+3]
	     + 5.0/3 * GHPLs2[2*4+0]
	     + 5.0/3 * GHPLs1[0]
	     - 8 * GHPLs1[0] * zeta2
	     - 6 * GHPLs1[0] * HPLs1[0]
	     - 5.0/3 * GHPLs1[0] * HPLs1[1]
	     - 4 * GHPLs1[0] * HPLs2[0*2+1]
	     + 2 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
	     - 2 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
	     - 1.0/2 * GHPLs2[2*4+1]
	     - 2 * GHPLs2[2*4+1] * zeta2
	     + 2 * GHPLs2[2*4+1] * HPLs2[0*2+0]
	     - 2 * GHPLs2[2*4+1] * HPLs2[0*2+1]
	     - 2 * GHPLs3[0*4*4+2*4+1]
	     - 2 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
	     + 10 * GHPLs1[1] * zeta2
	     - 2 * GHPLs1[1] * zeta3
	     + 1.0/2 * GHPLs1[1] * HPLs1[0]
	     + 2 * GHPLs1[1] * HPLs1[0] * zeta2
	     + GHPLs1[1] * HPLs2[0*2+0]
	     - 2 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
	     + GHPLs1[1] * HPLs2[1*2+0]
	     + 2 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
	     + 1.0/2 * GHPLs1[1] * HPLs1[1]
	     + 2 * GHPLs1[1] * HPLs1[1] * zeta2
	     - 2 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
	     + 2 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
	     - 2 * GHPLs3[2*4*4+0*4+1]
	     + 2 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
	     - 2 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
	     + 4 * GHPLs2[0*4+1] * zeta2
	     + 2 * GHPLs2[0*4+1] * HPLs1[0]
	     + 2 * GHPLs2[0*4+1] * HPLs2[0*2+0]
	     + 2 * GHPLs2[0*4+1] * HPLs1[1]
	     + 2 * GHPLs2[0*4+1] * HPLs2[0*2+1]
	     + GHPLs3[2*4*4+1*4+1]
	     - GHPLs2[1*4+1] * HPLs1[0]
	     - GHPLs2[1*4+1] * HPLs1[1]
	     + 6 * HPLs2[0*2+0]
	     + 11.0/6 * HPLs1[1]
	     - 4 * HPLs1[1] * zeta2
	     + 8 * HPLs3[0*2*2+0*2+1]
	     - 4 * HPLs3[0*2*2+1*2+1]
	     )

    + C_F * v * pow(1. - u, -2) * (
				   + 3 * zeta3
				   - 3 * GHPLs2[3*4+2] * HPLs1[0]
				   + 3 * GHPLs3[0*4*4+3*4+2]
				   + 3 * GHPLs1[2] * zeta2
				   - 3 * GHPLs1[2] * HPLs2[0*2+0]
				   + 3 * GHPLs1[2] * HPLs2[0*2+1]
				   + 3 * GHPLs2[0*4+2] * HPLs1[0]
				   - 3 * GHPLs2[3*4+0] * HPLs1[0]
				   + 3 * GHPLs3[0*4*4+3*4+0]
				   - 6 * GHPLs1[0] * zeta2
				   - 3 * GHPLs1[0] * HPLs2[0*2+0]
				   - 3 * GHPLs1[0] * HPLs2[0*2+1]
				   - 3 * HPLs1[0] * zeta2
				   + 3 * HPLs3[0*2*2+0*2+0]
				   - 3 * HPLs3[0*2*2+1*2+0]
				   - 3 * HPLs1[1] * zeta2
				   + 3 * HPLs3[0*2*2+0*2+1]
				   - 3 * HPLs3[0*2*2+1*2+1]
				   )

    + C_F * v * pow(1. - u, -1) * (
				   - 6 * zeta2
				   - 5 * zeta3
				   + 5 * GHPLs2[3*4+2] * HPLs1[0]
				   - 5 * GHPLs3[0*4*4+3*4+2]
				   - 5 * GHPLs1[2] * zeta2
				   + 5 * GHPLs1[2] * HPLs2[0*2+0]
				   - 5 * GHPLs1[2] * HPLs2[0*2+1]
				   - 5 * GHPLs2[0*4+2] * HPLs1[0]
				   - 3 * GHPLs1[3] * HPLs1[0]
				   + 3 * GHPLs2[0*4+3]
				   + 5 * GHPLs2[3*4+0] * HPLs1[0]
				   - 5 * GHPLs3[0*4*4+3*4+0]
				   + 10 * GHPLs1[0] * zeta2
				   + 5 * GHPLs1[0] * HPLs2[0*2+0]
				   + 5 * GHPLs1[0] * HPLs2[0*2+1]
				   + 5 * HPLs1[0] * zeta2
				   - 3 * HPLs2[0*2+0]
				   - 5 * HPLs3[0*2*2+0*2+0]
				   + 5 * HPLs3[0*2*2+1*2+0]
				   + 5 * HPLs1[1] * zeta2
				   - 3 * HPLs2[0*2+1]
				   - 5 * HPLs3[0*2*2+0*2+1]
				   + 5 * HPLs3[0*2*2+1*2+1]
				   )

    + C_F * v * (
		 - 2 * zeta2
		 - 1.0/2 * GHPLs1[2]
		 - GHPLs1[2] * zeta2
		 - 5.0/3 * GHPLs1[2] * HPLs1[0]
		 - GHPLs1[2] * HPLs2[0*2+0]
		 + GHPLs1[2] * HPLs2[1*2+0]
		 + 1.0/3 * GHPLs2[0*4+2]
		 + GHPLs2[0*4+2] * HPLs1[0]
		 + GHPLs3[2*4*4+1*4+2]
		 - GHPLs2[1*4+2] * HPLs1[0]
		 - GHPLs2[1*4+2] * HPLs1[1]
		 + GHPLs2[2*4+3] * HPLs1[0]
		 - GHPLs3[0*4*4+2*4+3]
		 - GHPLs2[3*4+3] * HPLs1[0]
		 + GHPLs3[0*4*4+3*4+3]
		 + 5 * GHPLs1[3] * zeta2
		 + 2.0/3 * GHPLs1[3] * HPLs1[0]
		 - GHPLs1[3] * HPLs2[1*2+0]
		 - GHPLs1[3] * HPLs2[0*2+1]
		 - GHPLs3[2*4*4+0*4+3]
		 - 2.0/3 * GHPLs2[0*4+3]
		 + GHPLs2[0*4+3] * HPLs1[1]
		 + 1.0/3 * GHPLs2[2*4+0]
		 + 1.0/3 * GHPLs1[0]
		 + 1.0/3 * GHPLs1[0] * HPLs1[0]
		 - 1.0/3 * GHPLs1[0] * HPLs1[1]
		 - 2.0/3 * GHPLs2[2*4+1]
		 + 2.0/3 * GHPLs1[1] * HPLs1[0]
		 + 2.0/3 * GHPLs1[1] * HPLs1[1]
		 - 1.0/6 * HPLs1[0]
		 + 1.0/3 * HPLs2[0*2+0]
		 + HPLs2[1*2+0]
		 + 1.0/2 * HPLs1[1]
		 + 2.0/3 * HPLs2[0*2+1]
		 )

    + C_F * pow(v, 2) * (
			 + 22.0/3 * zeta2
			 + 1.0/3 * GHPLs1[2]
			 + 2 * GHPLs1[2] * zeta2
			 + 11.0/3 * GHPLs1[2] * HPLs1[0]
			 + 2 * GHPLs1[2] * HPLs2[0*2+0]
			 - 2 * GHPLs1[2] * HPLs2[1*2+0]
			 - 5.0/3 * GHPLs2[0*4+2]
			 - 2 * GHPLs2[0*4+2] * HPLs1[0]
			 - 2 * GHPLs3[2*4*4+1*4+2]
			 + 2 * GHPLs2[1*4+2] * HPLs1[0]
			 + 2 * GHPLs2[1*4+2] * HPLs1[1]
			 - 2 * GHPLs2[2*4+3] * HPLs1[0]
			 + 2 * GHPLs3[0*4*4+2*4+3]
			 + 2 * GHPLs2[3*4+3] * HPLs1[0]
			 - 2 * GHPLs3[0*4*4+3*4+3]
			 - 10 * GHPLs1[3] * zeta2
			 - 5.0/3 * GHPLs1[3] * HPLs1[0]
			 + 2 * GHPLs1[3] * HPLs2[1*2+0]
			 + 2 * GHPLs1[3] * HPLs2[0*2+1]
			 + 2 * GHPLs3[2*4*4+0*4+3]
			 + 5.0/3 * GHPLs2[0*4+3]
			 - 2 * GHPLs2[0*4+3] * HPLs1[1]
			 - 5.0/3 * GHPLs2[2*4+0]
			 + GHPLs1[0] * HPLs1[0]
			 + 5.0/3 * GHPLs1[0] * HPLs1[1]
			 + 3 * GHPLs2[2*4+1]
			 - 3 * GHPLs1[1] * HPLs1[0]
			 - 3 * GHPLs1[1] * HPLs1[1]
			 - 1.0/3 * HPLs1[0]
			 - HPLs2[0*2+0]
			 - 2.0/3 * HPLs2[1*2+0]
			 - 1.0/3 * HPLs1[1]
			 - 5.0/3 * HPLs2[0*2+1]
			 )

    + C_F * pow(v, 3) * (
			 - 8.0/3 * zeta2
			 - 2 * GHPLs1[2] * zeta2
			 - 2.0/3 * GHPLs1[2] * HPLs1[0]
			 - 2 * GHPLs1[2] * HPLs2[0*2+0]
			 + 2 * GHPLs1[2] * HPLs2[1*2+0]
			 + 2.0/3 * GHPLs2[0*4+2]
			 + 2 * GHPLs2[0*4+2] * HPLs1[0]
			 + 2 * GHPLs3[2*4*4+1*4+2]
			 - 2 * GHPLs2[1*4+2] * HPLs1[0]
			 - 2 * GHPLs2[1*4+2] * HPLs1[1]
			 + 2 * GHPLs2[2*4+3] * HPLs1[0]
			 - 2 * GHPLs3[0*4*4+2*4+3]
			 - 2 * GHPLs2[3*4+3] * HPLs1[0]
			 + 2 * GHPLs3[0*4*4+3*4+3]
			 + 10 * GHPLs1[3] * zeta2
			 + 2.0/3 * GHPLs1[3] * HPLs1[0]
			 - 2 * GHPLs1[3] * HPLs2[1*2+0]
			 - 2 * GHPLs1[3] * HPLs2[0*2+1]
			 - 2 * GHPLs3[2*4*4+0*4+3]
			 - 2.0/3 * GHPLs2[0*4+3]
			 + 2 * GHPLs2[0*4+3] * HPLs1[1]
			 + 2.0/3 * GHPLs2[2*4+0]
			 - 2.0/3 * GHPLs1[0] * HPLs1[0]
			 - 2.0/3 * GHPLs1[0] * HPLs1[1]
			 - 2.0/3 * GHPLs2[2*4+1]
			 + 2.0/3 * GHPLs1[1] * HPLs1[0]
			 + 2.0/3 * GHPLs1[1] * HPLs1[1]
			 + 2.0/3 * HPLs2[0*2+0]
			 + 2.0/3 * HPLs2[0*2+1]
			 )

    + C_F * u * pow(1. - v, -2) * (
				   + 2 * zeta2
				   - 2 * zeta3
				   - GHPLs1[2] * zeta2
				   + 3 * GHPLs1[2] * HPLs1[0]
				   - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				   - GHPLs1[2] * HPLs2[0*2+1]
				   - GHPLs2[0*4+2] * HPLs1[0]
				   - GHPLs2[2*4+0] * HPLs1[0]
				   - GHPLs1[0] * zeta2
				   - GHPLs1[0] * HPLs1[0]
				   + 2.0/3 * GHPLs1[0] * HPLs2[0*2+0]
				   + GHPLs1[0] * HPLs2[1*2+0]
				   + 4 * HPLs1[0]
				   + 3 * HPLs1[0] * zeta2
				   - 2.0/3 * HPLs2[0*2+0]
				   + 2.0/3 * HPLs3[1*2*2+0*2+0]
				   - 3 * HPLs2[1*2+0]
				   - 4.0/3 * HPLs3[0*2*2+1*2+0]
				   - HPLs1[1] * zeta2
				   - HPLs2[0*2+1]
				   + 2.0/3 * HPLs3[0*2*2+0*2+1]
				   + HPLs3[1*2*2+0*2+1]
				   )

    + C_F * u * pow(1. - v, -1) * (
				   + 2 * zeta3
				   + 4 * GHPLs1[2]
				   + GHPLs1[2] * zeta2
				   - 8.0/3 * GHPLs1[2] * HPLs1[0]
				   + 2 * GHPLs1[2] * HPLs2[0*2+0]
				   + GHPLs1[2] * HPLs2[0*2+1]
				   - GHPLs2[0*4+2]
				   + GHPLs2[0*4+2] * HPLs1[0]
				   - GHPLs2[2*4+0]
				   + GHPLs2[2*4+0] * HPLs1[0]
				   + GHPLs1[0] * zeta2
				   + 2.0/3 * GHPLs1[0] * HPLs1[0]
				   - 2 * GHPLs1[0] * HPLs2[0*2+0]
				   - GHPLs1[0] * HPLs2[1*2+0]
				   + GHPLs1[0] * HPLs1[1]
				   - 14.0/3 * HPLs1[0]
				   - 3 * HPLs1[0] * zeta2
				   - 1.0/3 * HPLs2[0*2+0]
				   - 2 * HPLs3[1*2*2+0*2+0]
				   + 8.0/3 * HPLs2[1*2+0]
				   - 4 * HPLs1[1]
				   + HPLs1[1] * zeta2
				   - 7.0/3 * HPLs2[0*2+1]
				   - 2 * HPLs3[0*2*2+0*2+1]
				   - HPLs3[1*2*2+0*2+1]
				   )

    + C_F * u * pow(1. - u - v, -1) * (
				       + 5.0/2 * zeta2
				       - 5.0/2 * GHPLs1[3] * HPLs1[0]
				       + 5.0/2 * GHPLs2[0*4+3]
				       + 5.0/2 * GHPLs1[0] * HPLs1[0]
				       - 5.0/2 * HPLs2[0*2+0]
				       + 5.0/2 * HPLs2[0*2+1]
				       )

    + C_F * u * (
		 - zeta2
		 - 5.0/6 * GHPLs1[2]
		 - 2.0/3 * GHPLs1[2] * zeta2
		 - 5.0/6 * GHPLs1[2] * HPLs1[0]
		 - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
		 + 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
		 + 1.0/2 * GHPLs2[0*4+2]
		 + 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
		 + 2.0/3 * GHPLs3[2*4*4+1*4+2]
		 - 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
		 - 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
		 + 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
		 - 2.0/3 * GHPLs3[0*4*4+2*4+3]
		 - 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
		 + 2.0/3 * GHPLs3[0*4*4+3*4+3]
		 + 10.0/3 * GHPLs1[3] * zeta2
		 + 1.0/2 * GHPLs1[3] * HPLs1[0]
		 - 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
		 - 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
		 - 2.0/3 * GHPLs3[2*4*4+0*4+3]
		 - 1.0/2 * GHPLs2[0*4+3]
		 + 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
		 + 1.0/2 * GHPLs2[2*4+0]
		 - 2.0/3 * GHPLs2[2*4+0] * HPLs1[0]
		 + 2.0/3 * GHPLs2[3*4+0] * HPLs1[0]
		 - 2.0/3 * GHPLs3[0*4*4+3*4+0]
		 - 1.0/6 * GHPLs1[0]
		 - 1.0/6 * GHPLs1[0] * HPLs1[0]
		 + 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
		 + 2.0/3 * GHPLs1[0] * HPLs2[1*2+0]
		 - 1.0/2 * GHPLs1[0] * HPLs1[1]
		 + 2.0/3 * GHPLs1[0] * HPLs2[0*2+1]
		 - 1.0/2 * GHPLs2[2*4+1]
		 + 2.0/3 * GHPLs3[0*4*4+2*4+1]
		 - 8.0/3 * GHPLs1[1] * zeta2
		 + 1.0/2 * GHPLs1[1] * HPLs1[0]
		 - 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
		 - 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
		 + 1.0/2 * GHPLs1[1] * HPLs1[1]
		 + 2.0/3 * GHPLs3[2*4*4+0*4+1]
		 - 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
		 - 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
		 - 2.0/3 * GHPLs3[2*4*4+1*4+1]
		 + 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
		 + 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
		 + 2.0/3 * HPLs1[0]
		 + 10.0/3 * HPLs1[0] * zeta2
		 + 3.0/2 * HPLs2[0*2+0]
		 + 2.0/3 * HPLs3[1*2*2+0*2+0]
		 + 1.0/3 * HPLs2[1*2+0]
		 + 2.0/3 * HPLs3[0*2*2+1*2+0]
		 + 5.0/6 * HPLs1[1]
		 + 2.0/3 * HPLs1[1] * zeta2
		 + 11.0/6 * HPLs2[0*2+1]
		 + 2.0/3 * HPLs3[0*2*2+0*2+1]
		 + 2.0/3 * HPLs3[1*2*2+0*2+1]
		 + 4.0/3 * HPLs3[0*2*2+1*2+1]
		 )

    + C_F * u * v * (
		     + 26.0/3 * zeta2
		     + 2.0/3 * GHPLs1[2]
		     + 2.0/3 * GHPLs1[2] * zeta2
		     + 9.0/2 * GHPLs1[2] * HPLs1[0]
		     + 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
		     - 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
		     - 11.0/6 * GHPLs2[0*4+2]
		     - 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
		     - 2.0/3 * GHPLs3[2*4*4+1*4+2]
		     + 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
		     + 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
		     - 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
		     + 2.0/3 * GHPLs3[0*4*4+2*4+3]
		     + 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
		     - 2.0/3 * GHPLs3[0*4*4+3*4+3]
		     - 10.0/3 * GHPLs1[3] * zeta2
		     - 5.0/2 * GHPLs1[3] * HPLs1[0]
		     + 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
		     + 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
		     + 2.0/3 * GHPLs3[2*4*4+0*4+3]
		     + 5.0/2 * GHPLs2[0*4+3]
		     - 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
		     - 11.0/6 * GHPLs2[2*4+0]
		     + 2.0/3 * GHPLs2[2*4+0] * HPLs1[0]
		     - 2.0/3 * GHPLs2[3*4+0] * HPLs1[0]
		     + 2.0/3 * GHPLs3[0*4*4+3*4+0]
		     - 1.0/3 * GHPLs1[0]
		     + 1.0/2 * GHPLs1[0] * HPLs1[0]
		     - 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
		     - 2.0/3 * GHPLs1[0] * HPLs2[1*2+0]
		     + 11.0/6 * GHPLs1[0] * HPLs1[1]
		     - 2.0/3 * GHPLs1[0] * HPLs2[0*2+1]
		     + 5.0/2 * GHPLs2[2*4+1]
		     - 2.0/3 * GHPLs3[0*4*4+2*4+1]
		     + 8.0/3 * GHPLs1[1] * zeta2
		     - 5.0/2 * GHPLs1[1] * HPLs1[0]
		     + 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
		     + 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
		     - 5.0/2 * GHPLs1[1] * HPLs1[1]
		     - 2.0/3 * GHPLs3[2*4*4+0*4+1]
		     + 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
		     + 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
		     + 2.0/3 * GHPLs3[2*4*4+1*4+1]
		     - 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
		     - 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
		     - 1.0/3 * HPLs1[0]
		     - 10.0/3 * HPLs1[0] * zeta2
		     - 11.0/6 * HPLs2[0*2+0]
		     - 2.0/3 * HPLs3[1*2*2+0*2+0]
		     - 2 * HPLs2[1*2+0]
		     - 2.0/3 * HPLs3[0*2*2+1*2+0]
		     - 2.0/3 * HPLs1[1]
		     - 2.0/3 * HPLs1[1] * zeta2
		     - 5.0/2 * HPLs2[0*2+1]
		     - 2.0/3 * HPLs3[0*2*2+0*2+1]
		     - 2.0/3 * HPLs3[1*2*2+0*2+1]
		     - 4.0/3 * HPLs3[0*2*2+1*2+1]
		     )

    + C_F * u * pow(v, 2) * (
			     - 20.0/3 * zeta2
			     - 2 * GHPLs1[2] * zeta2
			     - 5.0/3 * GHPLs1[2] * HPLs1[0]
			     - 2 * GHPLs1[2] * HPLs2[0*2+0]
			     + 2 * GHPLs1[2] * HPLs2[1*2+0]
			     + 5.0/3 * GHPLs2[0*4+2]
			     + 2 * GHPLs2[0*4+2] * HPLs1[0]
			     + 2 * GHPLs3[2*4*4+1*4+2]
			     - 2 * GHPLs2[1*4+2] * HPLs1[0]
			     - 2 * GHPLs2[1*4+2] * HPLs1[1]
			     + 2 * GHPLs2[2*4+3] * HPLs1[0]
			     - 2 * GHPLs3[0*4*4+2*4+3]
			     - 2 * GHPLs2[3*4+3] * HPLs1[0]
			     + 2 * GHPLs3[0*4*4+3*4+3]
			     + 10 * GHPLs1[3] * zeta2
			     + 5.0/3 * GHPLs1[3] * HPLs1[0]
			     - 2 * GHPLs1[3] * HPLs2[1*2+0]
			     - 2 * GHPLs1[3] * HPLs2[0*2+1]
			     - 2 * GHPLs3[2*4*4+0*4+3]
			     - 5.0/3 * GHPLs2[0*4+3]
			     + 2 * GHPLs2[0*4+3] * HPLs1[1]
			     + 5.0/3 * GHPLs2[2*4+0]
			     - 5.0/3 * GHPLs1[0] * HPLs1[0]
			     - 5.0/3 * GHPLs1[0] * HPLs1[1]
			     - 5.0/3 * GHPLs2[2*4+1]
			     + 5.0/3 * GHPLs1[1] * HPLs1[0]
			     + 5.0/3 * GHPLs1[1] * HPLs1[1]
			     + 5.0/3 * HPLs2[0*2+0]
			     + 5.0/3 * HPLs2[0*2+1]
			     )

    + C_F * pow(u, 2) * pow(1. - v, -3) * (
					   - 4 * GHPLs1[2] * HPLs1[0]
					   + 4.0/3 * GHPLs1[2] * HPLs2[0*2+0]
					   + 4 * GHPLs1[0] * HPLs1[0]
					   - 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
					   - 4.0/3 * HPLs3[1*2*2+0*2+0]
					   + 4 * HPLs2[1*2+0]
					   - 4.0/3 * HPLs3[0*2*2+1*2+0]
					   + 4 * HPLs2[0*2+1]
					   - 4.0/3 * HPLs3[0*2*2+0*2+1]
					   )

    + C_F * pow(u, 2) * pow(1. - v, -2) * (
					   - 4 * GHPLs1[2]
					   + 10.0/3 * GHPLs1[2] * HPLs1[0]
					   - 4.0/3 * GHPLs1[2] * HPLs2[0*2+0]
					   + 4 * GHPLs1[0]
					   - 10.0/3 * GHPLs1[0] * HPLs1[0]
					   + 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
					   + 4.0/3 * HPLs3[1*2*2+0*2+0]
					   - 10.0/3 * HPLs2[1*2+0]
					   + 4.0/3 * HPLs3[0*2*2+1*2+0]
					   + 4 * HPLs1[1]
					   - 10.0/3 * HPLs2[0*2+1]
					   + 4.0/3 * HPLs3[0*2*2+0*2+1]
					   )

    + C_F * pow(u, 2) * pow(1. - v, -1) * (
					   + 2.0/3 * GHPLs1[2]
					   - 2.0/3 * GHPLs1[2] * HPLs1[0]
					   - 2.0/3 * GHPLs1[0]
					   + 2.0/3 * GHPLs1[0] * HPLs1[0]
					   + 2.0/3 * HPLs2[1*2+0]
					   - 2.0/3 * HPLs1[1]
					   + 2.0/3 * HPLs2[0*2+1]
					   )

    + C_F * pow(u, 2) * (
			 + 6 * zeta2
			 + 1.0/3 * GHPLs1[2]
			 + 17.0/6 * GHPLs1[2] * HPLs1[0]
			 - 3.0/2 * GHPLs2[0*4+2]
			 - 3.0/2 * GHPLs1[3] * HPLs1[0]
			 + 3.0/2 * GHPLs2[0*4+3]
			 - 3.0/2 * GHPLs2[2*4+0]
			 - 1.0/3 * GHPLs1[0]
			 + 1.0/6 * GHPLs1[0] * HPLs1[0]
			 + 3.0/2 * GHPLs1[0] * HPLs1[1]
			 + 3.0/2 * GHPLs2[2*4+1]
			 - 3.0/2 * GHPLs1[1] * HPLs1[0]
			 - 3.0/2 * GHPLs1[1] * HPLs1[1]
			 - 3.0/2 * HPLs2[0*2+0]
			 - 4.0/3 * HPLs2[1*2+0]
			 - 1.0/3 * HPLs1[1]
			 - 17.0/6 * HPLs2[0*2+1]
			 )

    + C_F * pow(u, 2) * v * (
			     - 8 * zeta2
			     - 2.0/3 * GHPLs1[2] * zeta2
			     - 2 * GHPLs1[2] * HPLs1[0]
			     - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
			     + 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
			     + 2 * GHPLs2[0*4+2]
			     + 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
			     + 2.0/3 * GHPLs3[2*4*4+1*4+2]
			     - 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
			     - 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
			     + 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
			     - 2.0/3 * GHPLs3[0*4*4+2*4+3]
			     - 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
			     + 2.0/3 * GHPLs3[0*4*4+3*4+3]
			     + 10.0/3 * GHPLs1[3] * zeta2
			     + 2 * GHPLs1[3] * HPLs1[0]
			     - 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
			     - 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
			     - 2.0/3 * GHPLs3[2*4*4+0*4+3]
			     - 2 * GHPLs2[0*4+3]
			     + 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
			     + 2 * GHPLs2[2*4+0]
			     - 2.0/3 * GHPLs2[2*4+0] * HPLs1[0]
			     + 2.0/3 * GHPLs2[3*4+0] * HPLs1[0]
			     - 2.0/3 * GHPLs3[0*4*4+3*4+0]
			     - 2 * GHPLs1[0] * HPLs1[0]
			     + 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
			     + 2.0/3 * GHPLs1[0] * HPLs2[1*2+0]
			     - 2 * GHPLs1[0] * HPLs1[1]
			     + 2.0/3 * GHPLs1[0] * HPLs2[0*2+1]
			     - 2 * GHPLs2[2*4+1]
			     + 2.0/3 * GHPLs3[0*4*4+2*4+1]
			     - 8.0/3 * GHPLs1[1] * zeta2
			     + 2 * GHPLs1[1] * HPLs1[0]
			     - 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
			     - 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
			     + 2 * GHPLs1[1] * HPLs1[1]
			     + 2.0/3 * GHPLs3[2*4*4+0*4+1]
			     - 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
			     - 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
			     - 2.0/3 * GHPLs3[2*4*4+1*4+1]
			     + 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
			     + 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
			     + 10.0/3 * HPLs1[0] * zeta2
			     + 2 * HPLs2[0*2+0]
			     + 2.0/3 * HPLs3[1*2*2+0*2+0]
			     + 2.0/3 * HPLs3[0*2*2+1*2+0]
			     + 2.0/3 * HPLs1[1] * zeta2
			     + 2 * HPLs2[0*2+1]
			     + 2.0/3 * HPLs3[0*2*2+0*2+1]
			     + 2.0/3 * HPLs3[1*2*2+0*2+1]
			     + 4.0/3 * HPLs3[0*2*2+1*2+1]
			     )

    + C_F * pow(u, 3) * (
			 - 4 * zeta2
			 - GHPLs1[2] * HPLs1[0]
			 + GHPLs2[0*4+2]
			 + GHPLs1[3] * HPLs1[0]
			 - GHPLs2[0*4+3]
			 + GHPLs2[2*4+0]
			 - GHPLs1[0] * HPLs1[0]
			 - GHPLs1[0] * HPLs1[1]
			 - GHPLs2[2*4+1]
			 + GHPLs1[1] * HPLs1[0]
			 + GHPLs1[1] * HPLs1[1]
			 + HPLs2[0*2+0]
			 + HPLs2[0*2+1]
			 )

    + C_F * ri * M_PI * pow(u, -2) * (
				      - 4 * GHPLs3[3*4*4+2*4+2]
				      - 4 * GHPLs2[2*4+2] * HPLs1[0]
				      - 4 * GHPLs1[2] * HPLs2[0*2+0]
				      + 4 * GHPLs3[3*4*4+0*4+2]
				      - 2.0/3 * GHPLs2[1*4+2]
				      - 4 * GHPLs3[3*4*4+2*4+1]
				      - 2.0/3 * GHPLs2[2*4+1]
				      - 4 * GHPLs2[2*4+1] * HPLs1[0]
				      + GHPLs1[1]
				      + 8 * GHPLs1[1] * zeta2
				      + 4 * GHPLs1[1] * HPLs2[0*2+0]
				      + 2.0/3 * GHPLs1[1] * HPLs1[1]
				      + 4 * GHPLs1[1] * HPLs2[0*2+1]
				      - 4 * GHPLs3[3*4*4+0*4+1]
				      - 2.0/3 * GHPLs2[0*4+1]
				      + 2.0/3 * GHPLs2[1*4+1]
				      )

    + C_F * ri * M_PI * pow(u, -2) * v * (
					  + 4 * GHPLs3[3*4*4+2*4+2]
					  + 4 * GHPLs2[2*4+2] * HPLs1[0]
					  + 4 * GHPLs1[2] * HPLs2[0*2+0]
					  - 4 * GHPLs3[3*4*4+0*4+2]
					  + 2.0/3 * GHPLs2[1*4+2]
					  + 4 * GHPLs3[3*4*4+2*4+1]
					  + 2.0/3 * GHPLs2[2*4+1]
					  + 4 * GHPLs2[2*4+1] * HPLs1[0]
					  - 2.0/3 * GHPLs1[1]
					  - 8 * GHPLs1[1] * zeta2
					  - 4 * GHPLs1[1] * HPLs2[0*2+0]
					  - 2.0/3 * GHPLs1[1] * HPLs1[1]
					  - 4 * GHPLs1[1] * HPLs2[0*2+1]
					  + 4 * GHPLs3[3*4*4+0*4+1]
					  + 2.0/3 * GHPLs2[0*4+1]
					  - 2.0/3 * GHPLs2[1*4+1]
					  )

    + C_F * ri * M_PI * pow(u, -2) * pow(v, 2) * (
						  + 1.0/3 * GHPLs1[1]
						  )

    + C_F * ri * M_PI * pow(u, -2) * pow(v, 3) * (
						  + 2.0/3 * GHPLs2[1*4+2]
						  - 2.0/3 * GHPLs2[2*4+3]
						  + 2.0/3 * GHPLs2[3*4+3]
						  + 2.0/3 * GHPLs1[3] * HPLs1[0]
						  + 2.0/3 * GHPLs1[3] * HPLs1[1]
						  - 2.0/3 * GHPLs2[0*4+3]
						  - 2.0/3 * GHPLs1[1]
						  )

    + C_F * ri * M_PI * pow(u, -2) * pow(v, 4) * (
						  - 2.0/3 * GHPLs2[1*4+2]
						  + 2.0/3 * GHPLs2[2*4+3]
						  - 2.0/3 * GHPLs2[3*4+3]
						  - 2.0/3 * GHPLs1[3] * HPLs1[0]
						  - 2.0/3 * GHPLs1[3] * HPLs1[1]
						  + 2.0/3 * GHPLs2[0*4+3]
						  )

    + C_F * ri * M_PI * pow(u, -1) * (
				      + 5.0/3
				      + 8 * zeta2
				      + 6 * GHPLs3[3*4*4+2*4+2]
				      + 6 * GHPLs2[2*4+2] * HPLs1[0]
				      - 8 * GHPLs2[3*4+2]
				      - 2.0/3 * GHPLs1[2]
				      - 7 * GHPLs1[2] * HPLs1[0]
				      + 6 * GHPLs1[2] * HPLs2[0*2+0]
				      - 6 * GHPLs3[3*4*4+0*4+2]
				      + GHPLs2[1*4+2]
				      - 2.0/3 * GHPLs1[0]
				      + 6 * GHPLs3[3*4*4+2*4+1]
				      + 2 * GHPLs2[2*4+1]
				      + 6 * GHPLs2[2*4+1] * HPLs1[0]
				      - 1.0/2 * GHPLs1[1]
				      - 12 * GHPLs1[1] * zeta2
				      - GHPLs1[1] * HPLs1[0]
				      - 6 * GHPLs1[1] * HPLs2[0*2+0]
				      - 2 * GHPLs1[1] * HPLs1[1]
				      - 6 * GHPLs1[1] * HPLs2[0*2+1]
				      + 6 * GHPLs3[3*4*4+0*4+1]
				      + 2 * GHPLs2[0*4+1]
				      - GHPLs2[1*4+1]
				      + 2.0/3 * HPLs1[1]
				      + 4 * HPLs2[0*2+1]
				      )

    + C_F * ri * M_PI * pow(u, -1) * v * (
					  - 4.0/3
					  - 8 * zeta2
					  - 4 * GHPLs3[3*4*4+2*4+2]
					  - 4 * GHPLs2[2*4+2] * HPLs1[0]
					  + 4 * GHPLs2[3*4+2]
					  + 2.0/3 * GHPLs1[2]
					  + 4 * GHPLs1[2] * HPLs1[0]
					  - 4 * GHPLs1[2] * HPLs2[0*2+0]
					  + 4 * GHPLs3[3*4*4+0*4+2]
					  - 2.0/3 * GHPLs2[1*4+2]
					  - 4 * GHPLs1[3]
					  + 4 * GHPLs2[3*4+0]
					  + 2.0/3 * GHPLs1[0]
					  - 4 * GHPLs3[3*4*4+2*4+1]
					  - 2.0/3 * GHPLs2[2*4+1]
					  - 4 * GHPLs2[2*4+1] * HPLs1[0]
					  - 1.0/6 * GHPLs1[1]
					  + 8 * GHPLs1[1] * zeta2
					  + 4 * GHPLs1[1] * HPLs2[0*2+0]
					  + 2.0/3 * GHPLs1[1] * HPLs1[1]
					  + 4 * GHPLs1[1] * HPLs2[0*2+1]
					  - 4 * GHPLs3[3*4*4+0*4+1]
					  - 2.0/3 * GHPLs2[0*4+1]
					  + 2.0/3 * GHPLs2[1*4+1]
					  - 4 * HPLs2[0*2+0]
					  - 2.0/3 * HPLs1[1]
					  - 4 * HPLs2[0*2+1]
					  )

    + C_F * ri * M_PI * pow(u, -1) * pow(v, 2) * (
						  - 1.0/3
						  + 2.0/3 * GHPLs1[2]
						  + GHPLs2[1*4+2]
						  - GHPLs2[2*4+3]
						  + GHPLs2[3*4+3]
						  - 2.0/3 * GHPLs1[3]
						  + GHPLs1[3] * HPLs1[0]
						  + GHPLs1[3] * HPLs1[1]
						  - GHPLs2[0*4+3]
						  + 2.0/3 * GHPLs1[0]
						  - 5.0/3 * GHPLs1[1]
						  - 2.0/3 * HPLs1[0]
						  - 2.0/3 * HPLs1[1]
						  )

    + C_F * ri * M_PI * pow(u, -1) * pow(v, 3) * (
						  - 2.0/3 * GHPLs1[2]
						  - 2 * GHPLs2[1*4+2]
						  + 2 * GHPLs2[2*4+3]
						  - 2 * GHPLs2[3*4+3]
						  + 2.0/3 * GHPLs1[3]
						  - 2 * GHPLs1[3] * HPLs1[0]
						  - 2 * GHPLs1[3] * HPLs1[1]
						  + 2 * GHPLs2[0*4+3]
						  - 2.0/3 * GHPLs1[0]
						  + 4.0/3 * GHPLs1[1]
						  + 2.0/3 * HPLs1[0]
						  + 2.0/3 * HPLs1[1]
						  )

    + C_F * ri * M_PI * pow(u, -1) * pow(v, 4) * (
						  + 2.0/3 * GHPLs2[1*4+2]
						  - 2.0/3 * GHPLs2[2*4+3]
						  + 2.0/3 * GHPLs2[3*4+3]
						  + 2.0/3 * GHPLs1[3] * HPLs1[0]
						  + 2.0/3 * GHPLs1[3] * HPLs1[1]
						  - 2.0/3 * GHPLs2[0*4+3]
						  )

    + C_F * ri * M_PI * pow(1. - u, -1) * (
					   + 3 * GHPLs1[3]
					   + 3 * HPLs1[0]
					   )

    + C_F * ri * M_PI * pow(1. - u - v, -1) * (
					       - GHPLs1[3]
					       - HPLs1[0]
					       )

    + C_F * ri * M_PI * (
			 - 1.0/6
			 - 8 * zeta2
			 - 2 * GHPLs3[3*4*4+2*4+2]
			 - 2 * GHPLs2[2*4+2] * HPLs1[0]
			 + 8 * GHPLs2[3*4+2]
			 + 5.0/3 * GHPLs1[2]
			 + 7 * GHPLs1[2] * HPLs1[0]
			 - 2 * GHPLs1[2] * HPLs2[0*2+0]
			 + 2 * GHPLs3[3*4*4+0*4+2]
			 - GHPLs2[1*4+2]
			 - 6 * GHPLs1[3]
			 + 5.0/3 * GHPLs1[0]
			 - 2 * GHPLs3[3*4*4+2*4+1]
			 - 2 * GHPLs2[2*4+1]
			 - 2 * GHPLs2[2*4+1] * HPLs1[0]
			 - 1.0/2 * GHPLs1[1]
			 + 4 * GHPLs1[1] * zeta2
			 + GHPLs1[1] * HPLs1[0]
			 + 2 * GHPLs1[1] * HPLs2[0*2+0]
			 + 2 * GHPLs1[1] * HPLs1[1]
			 + 2 * GHPLs1[1] * HPLs2[0*2+1]
			 - 2 * GHPLs3[3*4*4+0*4+1]
			 - 2 * GHPLs2[0*4+1]
			 + GHPLs2[1*4+1]
			 - 6 * HPLs1[0]
			 - 5.0/3 * HPLs1[1]
			 - 4 * HPLs2[0*2+1]
			 )

    + C_F * ri * M_PI * v * pow(1. - u, -2) * (
					       - 6 * zeta2
					       + 3 * GHPLs2[3*4+2]
					       + 3 * GHPLs1[2] * HPLs1[0]
					       + 3 * GHPLs2[3*4+0]
					       - 3 * HPLs2[0*2+0]
					       - 3 * HPLs2[0*2+1]
					       )

    + C_F * ri * M_PI * v * pow(1. - u, -1) * (
					       + 10 * zeta2
					       - 5 * GHPLs2[3*4+2]
					       - 5 * GHPLs1[2] * HPLs1[0]
					       + 3 * GHPLs1[3]
					       - 5 * GHPLs2[3*4+0]
					       + 5 * HPLs2[0*2+0]
					       + 5 * HPLs2[0*2+1]
					       )

    + C_F * ri * M_PI * v * (
			     - 1.0/6
			     + 1.0/3 * GHPLs1[2]
			     + GHPLs2[1*4+2]
			     - GHPLs2[2*4+3]
			     + GHPLs2[3*4+3]
			     - 2.0/3 * GHPLs1[3]
			     + GHPLs1[3] * HPLs1[0]
			     + GHPLs1[3] * HPLs1[1]
			     - GHPLs2[0*4+3]
			     + 1.0/3 * GHPLs1[0]
			     - 2.0/3 * GHPLs1[1]
			     - 2.0/3 * HPLs1[0]
			     - 1.0/3 * HPLs1[1]
			     )

    + C_F * ri * M_PI * pow(v, 2) * (
				     + 1.0/3
				     - 5.0/3 * GHPLs1[2]
				     - 2 * GHPLs2[1*4+2]
				     + 2 * GHPLs2[2*4+3]
				     - 2 * GHPLs2[3*4+3]
				     + 5.0/3 * GHPLs1[3]
				     - 2 * GHPLs1[3] * HPLs1[0]
				     - 2 * GHPLs1[3] * HPLs1[1]
				     + 2 * GHPLs2[0*4+3]
				     - 5.0/3 * GHPLs1[0]
				     + 3 * GHPLs1[1]
				     + 5.0/3 * HPLs1[0]
				     + 5.0/3 * HPLs1[1]
				     )

    + C_F * ri * M_PI * pow(v, 3) * (
				     + 2.0/3 * GHPLs1[2]
				     + 2 * GHPLs2[1*4+2]
				     - 2 * GHPLs2[2*4+3]
				     + 2 * GHPLs2[3*4+3]
				     - 2.0/3 * GHPLs1[3]
				     + 2 * GHPLs1[3] * HPLs1[0]
				     + 2 * GHPLs1[3] * HPLs1[1]
				     - 2 * GHPLs2[0*4+3]
				     + 2.0/3 * GHPLs1[0]
				     - 2.0/3 * GHPLs1[1]
				     - 2.0/3 * HPLs1[0]
				     - 2.0/3 * HPLs1[1]
				     )

    + C_F * ri * M_PI * u * pow(1. - v, -2) * (
					       - 2 * zeta2
					       - GHPLs1[2] * HPLs1[0]
					       - GHPLs1[0] * HPLs1[0]
					       + 2 * HPLs1[0]
					       + HPLs2[1*2+0]
					       - HPLs2[0*2+1]
					       )

    + C_F * ri * M_PI * u * pow(1. - v, -1) * (
					       + 4
					       + 2 * zeta2
					       - GHPLs1[2]
					       + GHPLs1[2] * HPLs1[0]
					       - GHPLs1[0]
					       + GHPLs1[0] * HPLs1[0]
					       - 2 * HPLs1[0]
					       - HPLs2[1*2+0]
					       + HPLs1[1]
					       + HPLs2[0*2+1]
					       )

    + C_F * ri * M_PI * u * pow(1. - u - v, -1) * (
						   + 5.0/2 * GHPLs1[3]
						   + 5.0/2 * HPLs1[0]
						   )

    + C_F * ri * M_PI * u * (
			     - 1
			     - 2.0/3 * zeta2
			     + 1.0/2 * GHPLs1[2]
			     + 2.0/3 * GHPLs2[1*4+2]
			     - 2.0/3 * GHPLs2[2*4+3]
			     + 2.0/3 * GHPLs2[3*4+3]
			     - 1.0/2 * GHPLs1[3]
			     + 2.0/3 * GHPLs1[3] * HPLs1[0]
			     + 2.0/3 * GHPLs1[3] * HPLs1[1]
			     - 2.0/3 * GHPLs2[0*4+3]
			     - 2.0/3 * GHPLs2[3*4+0]
			     + 1.0/2 * GHPLs1[0]
			     - 2.0/3 * GHPLs1[0] * HPLs1[0]
			     + 2.0/3 * GHPLs2[2*4+1]
			     - 1.0/2 * GHPLs1[1]
			     - 2.0/3 * GHPLs1[1] * HPLs1[1]
			     + 2.0/3 * GHPLs2[0*4+1]
			     - 2.0/3 * GHPLs2[1*4+1]
			     - 1.0/2 * HPLs1[0]
			     + 2.0/3 * HPLs2[0*2+0]
			     + 2.0/3 * HPLs2[1*2+0]
			     - 1.0/2 * HPLs1[1]
			     )

    + C_F * ri * M_PI * u * v * (
				 + 1.0/3
				 + 2.0/3 * zeta2
				 - 11.0/6 * GHPLs1[2]
				 - 2.0/3 * GHPLs2[1*4+2]
				 + 2.0/3 * GHPLs2[2*4+3]
				 - 2.0/3 * GHPLs2[3*4+3]
				 + 5.0/2 * GHPLs1[3]
				 - 2.0/3 * GHPLs1[3] * HPLs1[0]
				 - 2.0/3 * GHPLs1[3] * HPLs1[1]
				 + 2.0/3 * GHPLs2[0*4+3]
				 + 2.0/3 * GHPLs2[3*4+0]
				 - 11.0/6 * GHPLs1[0]
				 + 2.0/3 * GHPLs1[0] * HPLs1[0]
				 - 2.0/3 * GHPLs2[2*4+1]
				 + 5.0/2 * GHPLs1[1]
				 + 2.0/3 * GHPLs1[1] * HPLs1[1]
				 - 2.0/3 * GHPLs2[0*4+1]
				 + 2.0/3 * GHPLs2[1*4+1]
				 + 5.0/2 * HPLs1[0]
				 - 2.0/3 * HPLs2[0*2+0]
				 - 2.0/3 * HPLs2[1*2+0]
				 + 11.0/6 * HPLs1[1]
				 )

    + C_F * ri * M_PI * u * pow(v, 2) * (
					 + 5.0/3 * GHPLs1[2]
					 + 2 * GHPLs2[1*4+2]
					 - 2 * GHPLs2[2*4+3]
					 + 2 * GHPLs2[3*4+3]
					 - 5.0/3 * GHPLs1[3]
					 + 2 * GHPLs1[3] * HPLs1[0]
					 + 2 * GHPLs1[3] * HPLs1[1]
					 - 2 * GHPLs2[0*4+3]
					 + 5.0/3 * GHPLs1[0]
					 - 5.0/3 * GHPLs1[1]
					 - 5.0/3 * HPLs1[0]
					 - 5.0/3 * HPLs1[1]
					 )

    + C_F * ri * M_PI * pow(u, 2) * (
				     - 3.0/2 * GHPLs1[2]
				     + 3.0/2 * GHPLs1[3]
				     - 3.0/2 * GHPLs1[0]
				     + 3.0/2 * GHPLs1[1]
				     + 3.0/2 * HPLs1[0]
				     + 3.0/2 * HPLs1[1]
				     )

    + C_F * ri * M_PI * pow(u, 2) * v * (
					 - 2.0/3 * zeta2
					 + 2 * GHPLs1[2]
					 + 2.0/3 * GHPLs2[1*4+2]
					 - 2.0/3 * GHPLs2[2*4+3]
					 + 2.0/3 * GHPLs2[3*4+3]
					 - 2 * GHPLs1[3]
					 + 2.0/3 * GHPLs1[3] * HPLs1[0]
					 + 2.0/3 * GHPLs1[3] * HPLs1[1]
					 - 2.0/3 * GHPLs2[0*4+3]
					 - 2.0/3 * GHPLs2[3*4+0]
					 + 2 * GHPLs1[0]
					 - 2.0/3 * GHPLs1[0] * HPLs1[0]
					 + 2.0/3 * GHPLs2[2*4+1]
					 - 2 * GHPLs1[1]
					 - 2.0/3 * GHPLs1[1] * HPLs1[1]
					 + 2.0/3 * GHPLs2[0*4+1]
					 - 2.0/3 * GHPLs2[1*4+1]
					 - 2 * HPLs1[0]
					 + 2.0/3 * HPLs2[0*2+0]
					 + 2.0/3 * HPLs2[1*2+0]
					 - 2 * HPLs1[1]
					 )

    + C_F * ri * M_PI * pow(u, 3) * (
				     + GHPLs1[2]
				     - GHPLs1[3]
				     + GHPLs1[0]
				     - GHPLs1[1]
				     - HPLs1[0]
				     - HPLs1[1]
				     );
  return beta;
}
