#include "header.hpp"

// 2-loop helicity amplitude coefficients for qq_bar -> Wgam/Zgam,
// see T. Gehrmann, L. Tancredi, 1112.1531

#include "pplla03.amplitude.set.hpp"

double_complex pplla03_amplitude_set::gamma_2_1(){
  //  const double zeta2 = M_PI * M_PI/6;
  //  const double zeta3 = 1.20205690315959429;
  //  const double zeta4 = pow(M_PI,4)/90;
  //  const double dN_c=3;
  //  const double C_F=(dN_c * dN_c - 1.) / (2 * dN_c);
  //  double NF=(double)n_f;

  double_complex gamma =
    (dN_c * dN_c - 1.) * pow(u, -2) * v * (
					   - 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
					   + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
					   + 1.0/4 * GHPLs2[2*4+2] * zeta2
					   - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
					   + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
					   + 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
					   + 1.0/4 * GHPLs1[2] * zeta3
					   + 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
					   - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
					   + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
					   + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
					   + 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
					   - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
					   + 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
					   - 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
					   + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
					   + 1.0/4 * GHPLs2[2*4+1] * zeta2
					   - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
					   + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					   + 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
					   + 1.0/4 * GHPLs1[1] * zeta3
					   - 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
					   + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
					   - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
					   - 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
					   + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
					   - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					   - 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
					   + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
					   - 1.0/2 * GHPLs2[0*4+1] * zeta2
					   - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
					   - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
					   )

    + (dN_c * dN_c - 1.) * pow(u, -2) * pow(v, 2) * (
						     + 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
						     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
						     - 1.0/4 * GHPLs2[2*4+2] * zeta2
						     + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
						     - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
						     - 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
						     - 1.0/4 * GHPLs1[2] * zeta3
						     - 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
						     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
						     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
						     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
						     - 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
						     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
						     - 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
						     + 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
						     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
						     - 1.0/4 * GHPLs2[2*4+1] * zeta2
						     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
						     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
						     - 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
						     - 1.0/4 * GHPLs1[1] * zeta3
						     + 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
						     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
						     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
						     + 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
						     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
						     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
						     + 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
						     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
						     + 1.0/2 * GHPLs2[0*4+1] * zeta2
						     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
						     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
						     )

    + (dN_c * dN_c - 1.) * pow(u, -1) * v * (
					     - 1.0/2
					     + 1.0/2 * zeta2
					     + 1.0/2 * zeta3
					     + 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
					     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
					     - 1.0/4 * GHPLs2[2*4+2] * zeta2
					     + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
					     - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
					     - 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
					     - 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
					     + 1.0/2 * GHPLs3[0*4*4+3*4+2]
					     + 1.0/2 * GHPLs1[2] * zeta2
					     - 1.0/4 * GHPLs1[2] * zeta3
					     - 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
					     - 1.0/2 * GHPLs1[2] * HPLs2[0*2+0]
					     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
					     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
					     + 1.0/2 * GHPLs1[2] * HPLs2[0*2+1]
					     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
					     - 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
					     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
					     + 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
					     - 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
					     - 1.0/2 * GHPLs1[0] * zeta2
					     - 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
					     + 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
					     - 1.0/4 * GHPLs2[2*4+1] * zeta2
					     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
					     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					     - 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs1[1] * zeta3
					     + 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
					     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
					     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
					     + 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
					     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
					     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					     + 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
					     + 1.0/2 * GHPLs2[0*4+1] * zeta2
					     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
					     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
					     - 1.0/4 * HPLs1[1] * zeta2
					     + 1.0/4 * HPLs2[0*2+1]
					     + 1.0/2 * HPLs3[0*2*2+0*2+1]
					     - 1.0/4 * HPLs3[0*2*2+1*2+1]
					     )

    + (dN_c * dN_c - 1.) * pow(u, -1) * pow(v, 2) * (
						     - 1.0/2 * zeta2
						     - 1.0/4 * zeta3
						     + 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
						     - 1.0/4 * GHPLs3[0*4*4+3*4+2]
						     - 1.0/4 * GHPLs1[2] * zeta2
						     + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
						     - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
						     - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
						     - 1.0/4 * GHPLs1[3] * HPLs1[0]
						     + 1.0/4 * GHPLs2[0*4+3]
						     + 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
						     - 1.0/4 * GHPLs3[0*4*4+3*4+0]
						     + 1.0/2 * GHPLs1[0] * zeta2
						     + 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
						     + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
						     + 1.0/4 * HPLs1[0] * zeta2
						     - 1.0/4 * HPLs2[0*2+0]
						     - 1.0/4 * HPLs3[0*2*2+0*2+0]
						     + 1.0/4 * HPLs3[0*2*2+1*2+0]
						     + 1.0/4 * HPLs1[1] * zeta2
						     - 1.0/4 * HPLs2[0*2+1]
						     - 1.0/4 * HPLs3[0*2*2+0*2+1]
						     + 1.0/4 * HPLs3[0*2*2+1*2+1]
						     )

    + (dN_c * dN_c - 1.) * pow(1. - u, -1) * (
					      + 1.0/8 * zeta2
					      - 1.0/8 * GHPLs1[3] * HPLs1[0]
					      + 1.0/8 * GHPLs2[0*4+3]
					      + 1.0/8 * GHPLs1[0] * HPLs1[0]
					      - 1.0/8 * HPLs2[0*2+0]
					      + 1.0/8 * HPLs2[0*2+1]
					      )

    + (dN_c * dN_c - 1.) * pow(1. - v, -1) * (
					      - 7.0/48 * zeta2
					      + 1.0/8 * zeta3
					      - 1.0/8 * GHPLs2[3*4+2] * HPLs1[0]
					      + 1.0/8 * GHPLs3[0*4*4+3*4+2]
					      + 1.0/8 * GHPLs1[2] * zeta2
					      - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
					      + 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
					      + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
					      + 1.0/8 * GHPLs1[3] * HPLs1[0]
					      - 1.0/8 * GHPLs2[0*4+3]
					      + 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
					      - 1.0/8 * GHPLs3[0*4*4+3*4+0]
					      - 7.0/48 * GHPLs1[0] * HPLs1[0]
					      + 1.0/8 * GHPLs1[0] * HPLs2[0*2+0]
					      + 163.0/288 * HPLs1[0]
					      + 1.0/8 * HPLs1[0] * zeta2
					      + 25.0/24 * HPLs2[0*2+0]
					      - 1.0/8 * HPLs3[0*2*2+0*2+0]
					      + 1.0/8 * HPLs3[0*2*2+1*2+0]
					      - 7.0/48 * HPLs2[0*2+1]
					      + 1.0/8 * HPLs3[0*2*2+0*2+1]
					      )

    + (dN_c * dN_c - 1.) * (
			    + 133.0/288
			    + 7.0/48 * zeta2
			    - 1.0/8 * zeta3
			    + 1.0/8 * GHPLs2[3*4+2] * HPLs1[0]
			    - 1.0/8 * GHPLs3[0*4*4+3*4+2]
			    - 1.0/8 * GHPLs1[2] * zeta2
			    + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
			    - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
			    - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
			    - 1.0/8 * GHPLs1[3] * HPLs1[0]
			    + 1.0/8 * GHPLs2[0*4+3]
			    - 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
			    + 1.0/8 * GHPLs3[0*4*4+3*4+0]
			    - 13.0/48 * GHPLs1[0]
			    + 7.0/48 * GHPLs1[0] * HPLs1[0]
			    - 1.0/8 * GHPLs1[0] * HPLs2[0*2+0]
			    - 31.0/288 * HPLs1[0]
			    - 1.0/8 * HPLs1[0] * zeta2
			    - 25.0/24 * HPLs2[0*2+0]
			    + 1.0/8 * HPLs3[0*2*2+0*2+0]
			    - 1.0/8 * HPLs3[0*2*2+1*2+0]
			    + 7.0/48 * HPLs2[0*2+1]
			    - 1.0/8 * HPLs3[0*2*2+0*2+1]
			    )

    + (dN_c * dN_c - 1.) * v * pow(1. - u, -2) * (
						  - 1.0/4 * zeta2
						  + 1.0/4 * zeta3
						  - 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
						  + 1.0/4 * GHPLs3[0*4*4+3*4+2]
						  + 1.0/4 * GHPLs1[2] * zeta2
						  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
						  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
						  + 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
						  + 1.0/4 * GHPLs1[3] * HPLs1[0]
						  - 1.0/4 * GHPLs2[0*4+3]
						  - 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
						  + 1.0/4 * GHPLs3[0*4*4+3*4+0]
						  - 1.0/2 * GHPLs1[0] * zeta2
						  - 1.0/4 * GHPLs1[0] * HPLs1[0]
						  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
						  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
						  - 1.0/4 * HPLs1[0] * zeta2
						  + 1.0/4 * HPLs2[0*2+0]
						  + 1.0/4 * HPLs3[0*2*2+0*2+0]
						  - 1.0/4 * HPLs3[0*2*2+1*2+0]
						  - 1.0/4 * HPLs1[1] * zeta2
						  - 1.0/4 * HPLs2[0*2+1]
						  + 1.0/4 * HPLs3[0*2*2+0*2+1]
						  - 1.0/4 * HPLs3[0*2*2+1*2+1]
						  )

    + (dN_c * dN_c - 1.) * v * pow(1. - u, -1) * (
						  - 1.0/8 * zeta2
						  - 3.0/8 * zeta3
						  + 3.0/8 * GHPLs2[3*4+2] * HPLs1[0]
						  - 3.0/8 * GHPLs3[0*4*4+3*4+2]
						  - 3.0/8 * GHPLs1[2] * zeta2
						  + 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						  - 3.0/8 * GHPLs1[2] * HPLs2[0*2+1]
						  - 3.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						  - 5.0/8 * GHPLs1[3] * HPLs1[0]
						  + 5.0/8 * GHPLs2[0*4+3]
						  + 3.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						  - 3.0/8 * GHPLs3[0*4*4+3*4+0]
						  - 1.0/8 * GHPLs1[0]
						  + 3.0/4 * GHPLs1[0] * zeta2
						  + 3.0/8 * GHPLs1[0] * HPLs1[0]
						  + 3.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						  + 3.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						  + 3.0/8 * HPLs1[0] * zeta2
						  - 5.0/8 * HPLs2[0*2+0]
						  - 3.0/8 * HPLs3[0*2*2+0*2+0]
						  + 3.0/8 * HPLs3[0*2*2+1*2+0]
						  + 3.0/8 * HPLs1[1] * zeta2
						  + 1.0/8 * HPLs2[0*2+1]
						  - 3.0/8 * HPLs3[0*2*2+0*2+1]
						  + 3.0/8 * HPLs3[0*2*2+1*2+1]
						  )

    + (dN_c * dN_c - 1.) * pow(v, 2) * pow(1. - u, -3) * (
							  - 1.0/4 * zeta3
							  + 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
							  - 1.0/4 * GHPLs3[0*4*4+3*4+2]
							  - 1.0/4 * GHPLs1[2] * zeta2
							  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
							  - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							  + 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
							  - 1.0/4 * GHPLs3[0*4*4+3*4+0]
							  + 1.0/2 * GHPLs1[0] * zeta2
							  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
							  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
							  + 1.0/4 * HPLs1[0] * zeta2
							  - 1.0/4 * HPLs3[0*2*2+0*2+0]
							  + 1.0/4 * HPLs3[0*2*2+1*2+0]
							  + 1.0/4 * HPLs1[1] * zeta2
							  - 1.0/4 * HPLs3[0*2*2+0*2+1]
							  + 1.0/4 * HPLs3[0*2*2+1*2+1]
							  )

    + (dN_c * dN_c - 1.) * pow(v, 2) * pow(1. - u, -2) * (
							  + 1.0/2 * zeta2
							  + 3.0/8 * zeta3
							  - 3.0/8 * GHPLs2[3*4+2] * HPLs1[0]
							  + 3.0/8 * GHPLs3[0*4*4+3*4+2]
							  + 3.0/8 * GHPLs1[2] * zeta2
							  - 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							  + 3.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							  + 3.0/8 * GHPLs2[0*4+2] * HPLs1[0]
							  + 1.0/4 * GHPLs1[3] * HPLs1[0]
							  - 1.0/4 * GHPLs2[0*4+3]
							  - 3.0/8 * GHPLs2[3*4+0] * HPLs1[0]
							  + 3.0/8 * GHPLs3[0*4*4+3*4+0]
							  - 3.0/4 * GHPLs1[0] * zeta2
							  - 3.0/8 * GHPLs1[0] * HPLs2[0*2+0]
							  - 3.0/8 * GHPLs1[0] * HPLs2[0*2+1]
							  - 3.0/8 * HPLs1[0] * zeta2
							  + 1.0/4 * HPLs2[0*2+0]
							  + 3.0/8 * HPLs3[0*2*2+0*2+0]
							  - 3.0/8 * HPLs3[0*2*2+1*2+0]
							  - 3.0/8 * HPLs1[1] * zeta2
							  + 1.0/4 * HPLs2[0*2+1]
							  + 3.0/8 * HPLs3[0*2*2+0*2+1]
							  - 3.0/8 * HPLs3[0*2*2+1*2+1]
							  )

    + (dN_c * dN_c - 1.) * pow(v, 2) * pow(1. - u, -1) * (
							  - 1.0/2 * zeta2
							  - 1.0/4 * zeta3
							  + 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
							  - 1.0/4 * GHPLs3[0*4*4+3*4+2]
							  - 1.0/4 * GHPLs1[2] * zeta2
							  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
							  - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							  - 1.0/4 * GHPLs1[3] * HPLs1[0]
							  + 1.0/4 * GHPLs2[0*4+3]
							  + 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
							  - 1.0/4 * GHPLs3[0*4*4+3*4+0]
							  + 1.0/2 * GHPLs1[0] * zeta2
							  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
							  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
							  + 1.0/4 * HPLs1[0] * zeta2
							  - 1.0/4 * HPLs2[0*2+0]
							  - 1.0/4 * HPLs3[0*2*2+0*2+0]
							  + 1.0/4 * HPLs3[0*2*2+1*2+0]
							  + 1.0/4 * HPLs1[1] * zeta2
							  - 1.0/4 * HPLs2[0*2+1]
							  - 1.0/4 * HPLs3[0*2*2+0*2+1]
							  + 1.0/4 * HPLs3[0*2*2+1*2+1]
							  )

    + (dN_c * dN_c - 1.) * u * pow(1. - v, -2) * (
						  + 13.0/48 * zeta2
						  - 1.0/8 * zeta3
						  + 1.0/8 * GHPLs2[3*4+2] * HPLs1[0]
						  - 1.0/8 * GHPLs3[0*4*4+3*4+2]
						  - 1.0/8 * GHPLs1[2] * zeta2
						  + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						  - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
						  - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						  - 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						  + 1.0/8 * GHPLs3[0*4*4+3*4+0]
						  + 13.0/48 * GHPLs1[0] * HPLs1[0]
						  - 1.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						  - 163.0/288 * HPLs1[0]
						  - 1.0/8 * HPLs1[0] * zeta2
						  - 11.0/12 * HPLs2[0*2+0]
						  + 1.0/8 * HPLs3[0*2*2+0*2+0]
						  - 1.0/8 * HPLs3[0*2*2+1*2+0]
						  + 13.0/48 * HPLs2[0*2+1]
						  - 1.0/8 * HPLs3[0*2*2+0*2+1]
						  )

    + (dN_c * dN_c - 1.) * u * pow(1. - v, -1) * (
						  - 277.0/288
						  - 19.0/48 * zeta2
						  + 1.0/8 * zeta3
						  - 1.0/8 * GHPLs2[3*4+2] * HPLs1[0]
						  + 1.0/8 * GHPLs3[0*4*4+3*4+2]
						  + 1.0/8 * GHPLs1[2] * zeta2
						  - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						  + 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
						  + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						  + 1.0/8 * GHPLs1[3] * HPLs1[0]
						  - 1.0/8 * GHPLs2[0*4+3]
						  + 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						  - 1.0/8 * GHPLs3[0*4*4+3*4+0]
						  + 19.0/48 * GHPLs1[0]
						  - 19.0/48 * GHPLs1[0] * HPLs1[0]
						  + 1.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						  + 31.0/288 * HPLs1[0]
						  + 1.0/8 * HPLs1[0] * zeta2
						  + 25.0/24 * HPLs2[0*2+0]
						  - 1.0/8 * HPLs3[0*2*2+0*2+0]
						  + 1.0/8 * HPLs3[0*2*2+1*2+0]
						  - 19.0/48 * HPLs2[0*2+1]
						  + 1.0/8 * HPLs3[0*2*2+0*2+1]
						  )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -2) * v * (
							 + 1.0/4 * GHPLs3[3*4*4+2*4+2]
							 + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
							 + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							 - 1.0/4 * GHPLs3[3*4*4+0*4+2]
							 + 1.0/4 * GHPLs3[3*4*4+2*4+1]
							 + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							 - 1.0/2 * GHPLs1[1] * zeta2
							 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
							 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							 + 1.0/4 * GHPLs3[3*4*4+0*4+1]
							 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -2) * pow(v, 2) * (
								 - 1.0/4 * GHPLs3[3*4*4+2*4+2]
								 - 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
								 - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								 + 1.0/4 * GHPLs3[3*4*4+0*4+2]
								 - 1.0/4 * GHPLs3[3*4*4+2*4+1]
								 - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
								 + 1.0/2 * GHPLs1[1] * zeta2
								 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
								 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
								 - 1.0/4 * GHPLs3[3*4*4+0*4+1]
								 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -1) * v * (
							 - 1.0/2 * zeta2
							 - 1.0/4 * GHPLs3[3*4*4+2*4+2]
							 - 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
							 + 1.0/2 * GHPLs2[3*4+2]
							 + 1.0/2 * GHPLs1[2] * HPLs1[0]
							 - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							 + 1.0/4 * GHPLs3[3*4*4+0*4+2]
							 - 1.0/4 * GHPLs3[3*4*4+2*4+1]
							 - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							 + 1.0/2 * GHPLs1[1] * zeta2
							 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
							 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							 - 1.0/4 * GHPLs3[3*4*4+0*4+1]
							 - 1.0/4 * HPLs2[0*2+1]
							 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -1) * pow(v, 2) * (
								 + 1.0/2 * zeta2
								 - 1.0/4 * GHPLs2[3*4+2]
								 - 1.0/4 * GHPLs1[2] * HPLs1[0]
								 + 1.0/4 * GHPLs1[3]
								 - 1.0/4 * GHPLs2[3*4+0]
								 + 1.0/4 * HPLs2[0*2+0]
								 + 1.0/4 * HPLs2[0*2+1]
								 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(1. - u, -1) * (
							  + 1.0/8 * GHPLs1[3]
							  + 1.0/8 * HPLs1[0]
							  )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(1. - v, -1) * (
							  + 1.0/8 * GHPLs2[3*4+2]
							  + 1.0/8 * GHPLs1[2] * HPLs1[0]
							  - 1.0/8 * GHPLs1[3]
							  - 1.0/8 * GHPLs2[3*4+0]
							  + 5.0/16 * HPLs1[0]
							  + 1.0/8 * HPLs2[0*2+0]
							  )

    + (dN_c * dN_c - 1.) * ri * M_PI * (
					+ 3.0/16
					- 1.0/8 * GHPLs2[3*4+2]
					- 1.0/8 * GHPLs1[2] * HPLs1[0]
					+ 1.0/8 * GHPLs1[3]
					+ 1.0/8 * GHPLs2[3*4+0]
					- 5.0/16 * HPLs1[0]
					- 1.0/8 * HPLs2[0*2+0]
					)

    + (dN_c * dN_c - 1.) * ri * M_PI * v * pow(1. - u, -2) * (
							      - 1.0/2 * zeta2
							      + 1.0/4 * GHPLs2[3*4+2]
							      + 1.0/4 * GHPLs1[2] * HPLs1[0]
							      - 1.0/4 * GHPLs1[3]
							      + 1.0/4 * GHPLs2[3*4+0]
							      - 1.0/4 * HPLs1[0]
							      - 1.0/4 * HPLs2[0*2+0]
							      - 1.0/4 * HPLs2[0*2+1]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * v * pow(1. - u, -1) * (
							      - 1.0/8
							      + 3.0/4 * zeta2
							      - 3.0/8 * GHPLs2[3*4+2]
							      - 3.0/8 * GHPLs1[2] * HPLs1[0]
							      + 5.0/8 * GHPLs1[3]
							      - 3.0/8 * GHPLs2[3*4+0]
							      + 3.0/8 * HPLs1[0]
							      + 3.0/8 * HPLs2[0*2+0]
							      + 3.0/8 * HPLs2[0*2+1]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(v, 2) * pow(1. - u, -3) * (
								      + 1.0/2 * zeta2
								      - 1.0/4 * GHPLs2[3*4+2]
								      - 1.0/4 * GHPLs1[2] * HPLs1[0]
								      - 1.0/4 * GHPLs2[3*4+0]
								      + 1.0/4 * HPLs2[0*2+0]
								      + 1.0/4 * HPLs2[0*2+1]
								      )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(v, 2) * pow(1. - u, -2) * (
								      - 3.0/4 * zeta2
								      + 3.0/8 * GHPLs2[3*4+2]
								      + 3.0/8 * GHPLs1[2] * HPLs1[0]
								      - 1.0/4 * GHPLs1[3]
								      + 3.0/8 * GHPLs2[3*4+0]
								      - 3.0/8 * HPLs2[0*2+0]
								      - 3.0/8 * HPLs2[0*2+1]
								      )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(v, 2) * pow(1. - u, -1) * (
								      + 1.0/2 * zeta2
								      - 1.0/4 * GHPLs2[3*4+2]
								      - 1.0/4 * GHPLs1[2] * HPLs1[0]
								      + 1.0/4 * GHPLs1[3]
								      - 1.0/4 * GHPLs2[3*4+0]
								      + 1.0/4 * HPLs2[0*2+0]
								      + 1.0/4 * HPLs2[0*2+1]
								      )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - v, -2) * (
							      - 1.0/8 * GHPLs2[3*4+2]
							      - 1.0/8 * GHPLs1[2] * HPLs1[0]
							      + 1.0/8 * GHPLs2[3*4+0]
							      - 3.0/16 * HPLs1[0]
							      - 1.0/8 * HPLs2[0*2+0]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - v, -1) * (
							      - 1.0/16
							      + 1.0/8 * GHPLs2[3*4+2]
							      + 1.0/8 * GHPLs1[2] * HPLs1[0]
							      - 1.0/8 * GHPLs1[3]
							      - 1.0/8 * GHPLs2[3*4+0]
							      + 1.0/16 * HPLs1[0]
							      + 1.0/8 * HPLs2[0*2+0]
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * v * (
							     + 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							     - 1.0/4 * GHPLs2[2*4+2] * zeta2
							     + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							     - 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							     + 3.0/8 * GHPLs1[2] * zeta2
							     - 1.0/4 * GHPLs1[2] * zeta3
							     + 1.0/4 * GHPLs1[2] * HPLs1[0]
							     - 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
							     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							     - 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
							     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							     + 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							     - 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							     - 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs3[2*4*4+1*4+2]
							     + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							     + 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
							     + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							     + 1.0/8 * GHPLs3[2*4*4+1*4+0]
							     - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							     - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							     + 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							     + 1.0/4 * GHPLs2[2*4+1]
							     - 1.0/4 * GHPLs2[2*4+1] * zeta2
							     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							     - 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							     - 1.0/4 * GHPLs1[1] * zeta2
							     - 1.0/4 * GHPLs1[1] * zeta3
							     - 1.0/4 * GHPLs1[1] * HPLs1[0]
							     + 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
							     + 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							     + 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
							     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							     - 1.0/4 * GHPLs1[1] * HPLs1[1]
							     + 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
							     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							     + 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							     + 1.0/2 * GHPLs2[0*4+1] * zeta2
							     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							     + 1.0/8 * GHPLs3[2*4*4+1*4+1]
							     - 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
							     - 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 2) * (
								     - 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
								     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
								     + 1.0/4 * GHPLs2[2*4+2] * zeta2
								     - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
								     + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
								     + 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
								     - 3.0/8 * GHPLs1[2] * zeta2
								     + 1.0/4 * GHPLs1[2] * zeta3
								     - 1.0/8 * GHPLs1[2] * HPLs1[0]
								     + 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
								     + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
								     + 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
								     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
								     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
								     + 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
								     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
								     + 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
								     + 1.0/4 * GHPLs3[2*4*4+1*4+2]
								     - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
								     - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
								     - 1.0/8 * GHPLs3[2*4*4+1*4+0]
								     + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
								     + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
								     - 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
								     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
								     - 1.0/8 * GHPLs2[2*4+1]
								     + 1.0/4 * GHPLs2[2*4+1] * zeta2
								     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
								     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
								     + 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
								     + 1.0/4 * GHPLs1[1] * zeta2
								     + 1.0/4 * GHPLs1[1] * zeta3
								     + 1.0/8 * GHPLs1[1] * HPLs1[0]
								     - 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
								     - 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
								     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
								     - 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
								     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
								     + 1.0/8 * GHPLs1[1] * HPLs1[1]
								     - 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
								     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
								     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
								     - 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
								     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
								     - 1.0/2 * GHPLs2[0*4+1] * zeta2
								     - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
								     - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
								     - 1.0/8 * GHPLs3[2*4*4+1*4+1]
								     + 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
								     + 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 3) * (
								     - 1.0/8 * GHPLs1[2] * zeta2
								     - 1.0/8 * GHPLs1[2] * HPLs1[0]
								     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     + 5.0/8 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     - 1.0/8 * GHPLs2[2*4+1]
								     + 1.0/8 * GHPLs1[1] * HPLs1[0]
								     + 1.0/8 * GHPLs1[1] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 4) * (
								     + 1.0/8 * GHPLs1[2] * zeta2
								     + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     - 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     + 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     - 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     + 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     - 5.0/8 * GHPLs1[3] * zeta2
								     + 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     + 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     - 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * (
							 + 1.0/8 * GHPLs1[2] * HPLs1[0]
							 + 1.0/8 * GHPLs2[2*4+1]
							 - 1.0/8 * GHPLs1[1] * HPLs1[0]
							 - 1.0/8 * GHPLs1[1] * HPLs1[1]
							 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * v * (
							     + 1.0/2
							     - 3.0/8 * zeta2
							     - 1.0/2 * zeta3
							     - 1.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							     + 1.0/4 * GHPLs2[2*4+2] * zeta2
							     - 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							     + 1.0/4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							     + 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
							     - 1.0/2 * GHPLs3[0*4*4+3*4+2]
							     + 3.0/8 * GHPLs1[2]
							     - 7.0/8 * GHPLs1[2] * zeta2
							     + 1.0/4 * GHPLs1[2] * zeta3
							     + 3.0/8 * GHPLs1[2] * HPLs1[0]
							     + 1.0/4 * GHPLs1[2] * HPLs1[0] * zeta2
							     + 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							     + 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
							     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							     - 5.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							     + 1.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							     + 1.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							     - 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							     - 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
							     + 1.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs3[2*4*4+1*4+2]
							     - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							     - 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
							     - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							     + 1.0/2 * GHPLs1[0] * zeta2
							     + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
							     - 1.0/8 * GHPLs3[2*4*4+1*4+0]
							     + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							     + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							     - 1.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							     + 1.0/4 * GHPLs2[2*4+1]
							     + 1.0/4 * GHPLs2[2*4+1] * zeta2
							     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							     + 1.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							     + 1.0/4 * GHPLs1[1] * zeta2
							     + 1.0/4 * GHPLs1[1] * zeta3
							     - 1.0/4 * GHPLs1[1] * HPLs1[0]
							     - 1.0/4 * GHPLs1[1] * HPLs1[0] * zeta2
							     - 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							     - 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
							     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							     - 1.0/4 * GHPLs1[1] * HPLs1[1]
							     - 1.0/4 * GHPLs1[1] * HPLs1[1] * zeta2
							     + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							     - 1.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							     + 1.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							     - 1.0/2 * GHPLs2[0*4+1] * zeta2
							     - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							     - 1.0/8 * GHPLs3[2*4*4+1*4+1]
							     + 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
							     + 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
							     - 1.0/8 * HPLs2[1*2+0]
							     - 3.0/8 * HPLs1[1]
							     + 1.0/4 * HPLs1[1] * zeta2
							     - 1.0/8 * HPLs2[0*2+1]
							     - 1.0/2 * HPLs3[0*2*2+0*2+1]
							     + 1.0/4 * HPLs3[0*2*2+1*2+1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(v, 2) * (
								     + 1.0/8 * zeta2
								     + 1.0/4 * zeta3
								     - 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
								     + 1.0/4 * GHPLs3[0*4*4+3*4+2]
								     - 3.0/8 * GHPLs1[2]
								     - 3.0/4 * GHPLs1[2] * HPLs1[0]
								     - 1.0/2 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
								     + 1.0/8 * GHPLs2[0*4+2]
								     + 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
								     + 1.0/4 * GHPLs3[2*4*4+1*4+2]
								     - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
								     + 1.0/4 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/4 * GHPLs3[0*4*4+2*4+3]
								     - 1.0/4 * GHPLs2[3*4+3] * HPLs1[0]
								     + 1.0/4 * GHPLs3[0*4*4+3*4+3]
								     + 5.0/4 * GHPLs1[3] * zeta2
								     + 3.0/8 * GHPLs1[3] * HPLs1[0]
								     - 1.0/4 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/4 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/4 * GHPLs3[2*4*4+0*4+3]
								     - 3.0/8 * GHPLs2[0*4+3]
								     + 1.0/4 * GHPLs2[0*4+3] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+0]
								     - 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
								     + 1.0/4 * GHPLs3[0*4*4+3*4+0]
								     - 1.0/2 * GHPLs1[0] * zeta2
								     - 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								     - 1.0/8 * GHPLs1[0] * HPLs1[1]
								     - 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
								     - 3.0/4 * GHPLs2[2*4+1]
								     + 3.0/4 * GHPLs1[1] * HPLs1[0]
								     + 3.0/4 * GHPLs1[1] * HPLs1[1]
								     + 3.0/8 * HPLs1[0]
								     - 1.0/4 * HPLs1[0] * zeta2
								     + 1.0/8 * HPLs2[0*2+0]
								     + 1.0/4 * HPLs3[0*2*2+0*2+0]
								     - 1.0/4 * HPLs3[0*2*2+1*2+0]
								     + 3.0/8 * HPLs1[1]
								     - 1.0/4 * HPLs1[1] * zeta2
								     + 3.0/8 * HPLs2[0*2+1]
								     + 1.0/4 * HPLs3[0*2*2+0*2+1]
								     - 1.0/4 * HPLs3[0*2*2+1*2+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(v, 3) * (
								     + 1.0/2 * zeta2
								     + 3.0/8 * GHPLs1[2] * zeta2
								     + 1.0/8 * GHPLs1[2] * HPLs1[0]
								     + 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     - 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs2[0*4+2]
								     - 3.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     - 3.0/8 * GHPLs3[2*4*4+1*4+2]
								     + 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     + 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     - 3.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     + 3.0/8 * GHPLs3[0*4*4+2*4+3]
								     + 3.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     - 3.0/8 * GHPLs3[0*4*4+3*4+3]
								     - 15.0/8 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs1[0]
								     + 3.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     + 3.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     + 3.0/8 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3]
								     - 3.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     - 1.0/8 * GHPLs2[2*4+0]
								     + 1.0/8 * GHPLs1[0] * HPLs1[0]
								     + 1.0/8 * GHPLs1[0] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+1]
								     - 1.0/8 * GHPLs1[1] * HPLs1[0]
								     - 1.0/8 * GHPLs1[1] * HPLs1[1]
								     - 1.0/8 * HPLs2[0*2+0]
								     - 1.0/8 * HPLs2[0*2+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(1. - u, -1) * (
							      + 1.0/4 * zeta2
							      - 1.0/4 * GHPLs1[3] * HPLs1[0]
							      + 1.0/4 * GHPLs2[0*4+3]
							      + 1.0/4 * GHPLs1[0] * HPLs1[0]
							      - 1.0/4 * HPLs2[0*2+0]
							      + 1.0/4 * HPLs2[0*2+1]
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(1. - v, -1) * (
							      + 15.0/16 * zeta2
							      + 3.0/4 * zeta3
							      + 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
							      - 1.0/2 * GHPLs3[0*4*4+3*4+2]
							      - 3.0/4 * GHPLs1[2] * zeta2
							      - 7.0/8 * GHPLs1[2] * HPLs1[0]
							      + 3.0/4 * GHPLs1[2] * HPLs2[0*2+0]
							      + 7.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							      + 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							      + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
							      + 7.0/8 * GHPLs3[2*4*4+1*4+2]
							      - 7.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							      - 7.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							      - 13.0/8 * GHPLs1[3] * HPLs1[0]
							      + 13.0/8 * GHPLs2[0*4+3]
							      - 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
							      - 1.0/2 * GHPLs2[3*4+0] * HPLs1[0]
							      + 1.0/2 * GHPLs3[0*4*4+3*4+0]
							      + 5.0/8 * GHPLs1[0] * zeta2
							      - 3.0/16 * GHPLs1[0] * HPLs1[0]
							      - 3.0/4 * GHPLs1[0] * HPLs2[0*2+0]
							      - 5.0/8 * GHPLs1[0] * HPLs2[1*2+0]
							      - 7.0/8 * GHPLs3[2*4*4+1*4+0]
							      + 7.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							      + 7.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							      - 2 * GHPLs2[2*4+1]
							      + 2 * GHPLs1[1] * HPLs1[0]
							      + 2 * GHPLs1[1] * HPLs1[1]
							      + 15.0/32 * HPLs1[0]
							      - 19.0/8 * HPLs1[0] * zeta2
							      - 11.0/8 * HPLs2[0*2+0]
							      + 1.0/2 * HPLs3[0*2*2+0*2+0]
							      - 1.0/4 * HPLs3[1*2*2+0*2+0]
							      - 9.0/8 * HPLs2[1*2+0]
							      + 1.0/2 * HPLs3[0*2*2+1*2+0]
							      + 5.0/8 * HPLs1[1] * zeta2
							      - 3.0/16 * HPLs2[0*2+1]
							      - 3.0/4 * HPLs3[0*2*2+0*2+1]
							      - 5.0/8 * HPLs3[1*2*2+0*2+1]
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * (
					    + 33.0/32
					    - 21.0/16 * zeta2
					    - 3.0/4 * zeta3
					    - 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
					    + 1.0/2 * GHPLs3[0*4*4+3*4+2]
					    + 3.0/8 * GHPLs1[2]
					    + 3.0/4 * GHPLs1[2] * zeta2
					    + 1.0/2 * GHPLs1[2] * HPLs1[0]
					    - 3.0/4 * GHPLs1[2] * HPLs2[0*2+0]
					    - 7.0/8 * GHPLs1[2] * HPLs2[1*2+0]
					    - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
					    - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
					    - 7.0/8 * GHPLs3[2*4*4+1*4+2]
					    + 7.0/8 * GHPLs2[1*4+2] * HPLs1[0]
					    + 7.0/8 * GHPLs2[1*4+2] * HPLs1[1]
					    + 2 * GHPLs1[3] * HPLs1[0]
					    - 2 * GHPLs2[0*4+3]
					    + 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
					    + 1.0/2 * GHPLs2[3*4+0] * HPLs1[0]
					    - 1.0/2 * GHPLs3[0*4*4+3*4+0]
					    - 3.0/16 * GHPLs1[0]
					    - 5.0/8 * GHPLs1[0] * zeta2
					    - 3.0/16 * GHPLs1[0] * HPLs1[0]
					    + 3.0/4 * GHPLs1[0] * HPLs2[0*2+0]
					    + 5.0/8 * GHPLs1[0] * HPLs2[1*2+0]
					    + 7.0/8 * GHPLs3[2*4*4+1*4+0]
					    - 7.0/8 * GHPLs2[1*4+0] * HPLs1[0]
					    - 7.0/8 * GHPLs2[1*4+0] * HPLs1[1]
					    + 13.0/8 * GHPLs2[2*4+1]
					    - 13.0/8 * GHPLs1[1] * HPLs1[0]
					    - 13.0/8 * GHPLs1[1] * HPLs1[1]
					    - 15.0/32 * HPLs1[0]
					    + 19.0/8 * HPLs1[0] * zeta2
					    + 7.0/4 * HPLs2[0*2+0]
					    - 1.0/2 * HPLs3[0*2*2+0*2+0]
					    + 1.0/4 * HPLs3[1*2*2+0*2+0]
					    + 9.0/8 * HPLs2[1*2+0]
					    - 1.0/2 * HPLs3[0*2*2+1*2+0]
					    - 3.0/8 * HPLs1[1]
					    - 5.0/8 * HPLs1[1] * zeta2
					    - 3.0/16 * HPLs2[0*2+1]
					    + 3.0/4 * HPLs3[0*2*2+0*2+1]
					    + 5.0/8 * HPLs3[1*2*2+0*2+1]
					    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * pow(1. - u, -2) * (
								  - 1.0/2 * zeta2
								  + 1.0/2 * zeta3
								  - 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
								  + 1.0/2 * GHPLs3[0*4*4+3*4+2]
								  + 1.0/2 * GHPLs1[2] * zeta2
								  - 1.0/2 * GHPLs1[2] * HPLs2[0*2+0]
								  + 1.0/2 * GHPLs1[2] * HPLs2[0*2+1]
								  + 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
								  + 1.0/2 * GHPLs1[3] * HPLs1[0]
								  - 1.0/2 * GHPLs2[0*4+3]
								  - 1.0/2 * GHPLs2[3*4+0] * HPLs1[0]
								  + 1.0/2 * GHPLs3[0*4*4+3*4+0]
								  - GHPLs1[0] * zeta2
								  - 1.0/2 * GHPLs1[0] * HPLs1[0]
								  - 1.0/2 * GHPLs1[0] * HPLs2[0*2+0]
								  - 1.0/2 * GHPLs1[0] * HPLs2[0*2+1]
								  - 1.0/2 * HPLs1[0] * zeta2
								  + 1.0/2 * HPLs2[0*2+0]
								  + 1.0/2 * HPLs3[0*2*2+0*2+0]
								  - 1.0/2 * HPLs3[0*2*2+1*2+0]
								  - 1.0/2 * HPLs1[1] * zeta2
								  - 1.0/2 * HPLs2[0*2+1]
								  + 1.0/2 * HPLs3[0*2*2+0*2+1]
								  - 1.0/2 * HPLs3[0*2*2+1*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * pow(1. - u, -1) * (
								  - 3.0/4 * zeta2
								  - 1.0/4 * zeta3
								  + 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
								  - 1.0/4 * GHPLs3[0*4*4+3*4+2]
								  - 1.0/4 * GHPLs1[2] * zeta2
								  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
								  - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								  - 3.0/4 * GHPLs1[3] * HPLs1[0]
								  + 3.0/4 * GHPLs2[0*4+3]
								  + 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
								  - 1.0/4 * GHPLs3[0*4*4+3*4+0]
								  - 1.0/4 * GHPLs1[0]
								  + 1.0/2 * GHPLs1[0] * zeta2
								  + 1.0/4 * GHPLs1[0] * HPLs1[0]
								  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
								  + 1.0/4 * HPLs1[0] * zeta2
								  - 3.0/4 * HPLs2[0*2+0]
								  - 1.0/4 * HPLs3[0*2*2+0*2+0]
								  + 1.0/4 * HPLs3[0*2*2+1*2+0]
								  + 1.0/4 * HPLs1[1] * zeta2
								  - 1.0/4 * HPLs2[0*2+1]
								  - 1.0/4 * HPLs3[0*2*2+0*2+1]
								  + 1.0/4 * HPLs3[0*2*2+1*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * (
						- 37.0/8 * zeta2
						+ 3.0/8 * GHPLs1[2]
						- 1.0/8 * GHPLs1[2] * zeta2
						- 7.0/4 * GHPLs1[2] * HPLs1[0]
						- 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						+ 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						+ 9.0/8 * GHPLs2[0*4+2]
						+ 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						+ 1.0/8 * GHPLs3[2*4*4+1*4+2]
						- 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						- 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						+ 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
						- 1.0/8 * GHPLs3[0*4*4+2*4+3]
						- 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
						+ 1.0/8 * GHPLs3[0*4*4+3*4+3]
						+ 5.0/8 * GHPLs1[3] * zeta2
						+ 5.0/4 * GHPLs1[3] * HPLs1[0]
						- 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
						- 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
						- 1.0/8 * GHPLs3[2*4*4+0*4+3]
						- 5.0/4 * GHPLs2[0*4+3]
						+ 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
						+ 9.0/8 * GHPLs2[2*4+0]
						- 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						+ 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						- 1.0/8 * GHPLs3[0*4*4+3*4+0]
						- 3.0/4 * GHPLs1[0] * HPLs1[0]
						+ 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
						+ 1.0/8 * GHPLs1[0] * HPLs2[1*2+0]
						- 9.0/8 * GHPLs1[0] * HPLs1[1]
						+ 1.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						- 5.0/4 * GHPLs2[2*4+1]
						+ 1.0/8 * GHPLs3[0*4*4+2*4+1]
						- 1.0/2 * GHPLs1[1] * zeta2
						+ 5.0/4 * GHPLs1[1] * HPLs1[0]
						- 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
						- 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
						+ 5.0/4 * GHPLs1[1] * HPLs1[1]
						+ 1.0/8 * GHPLs3[2*4*4+0*4+1]
						- 1.0/8 * GHPLs2[0*4+1] * HPLs1[0]
						- 1.0/8 * GHPLs2[0*4+1] * HPLs1[1]
						- 1.0/8 * GHPLs3[2*4*4+1*4+1]
						+ 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
						+ 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
						- 3.0/8 * HPLs1[0]
						+ 5.0/8 * HPLs1[0] * zeta2
						+ 5.0/4 * HPLs2[0*2+0]
						+ 1.0/8 * HPLs3[1*2*2+0*2+0]
						+ 1.0/2 * HPLs2[1*2+0]
						+ 1.0/8 * HPLs3[0*2*2+1*2+0]
						- 3.0/8 * HPLs1[1]
						+ 1.0/8 * HPLs1[1] * zeta2
						+ 3.0/2 * HPLs2[0*2+1]
						+ 1.0/8 * HPLs3[0*2*2+0*2+1]
						+ 1.0/8 * HPLs3[1*2*2+0*2+1]
						+ 1.0/4 * HPLs3[0*2*2+1*2+1]
						)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(v, 2) * pow(1. - u, -3) * (
									  - 1.0/2 * zeta3
									  + 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
									  - 1.0/2 * GHPLs3[0*4*4+3*4+2]
									  - 1.0/2 * GHPLs1[2] * zeta2
									  + 1.0/2 * GHPLs1[2] * HPLs2[0*2+0]
									  - 1.0/2 * GHPLs1[2] * HPLs2[0*2+1]
									  - 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
									  + 1.0/2 * GHPLs2[3*4+0] * HPLs1[0]
									  - 1.0/2 * GHPLs3[0*4*4+3*4+0]
									  + GHPLs1[0] * zeta2
									  + 1.0/2 * GHPLs1[0] * HPLs2[0*2+0]
									  + 1.0/2 * GHPLs1[0] * HPLs2[0*2+1]
									  + 1.0/2 * HPLs1[0] * zeta2
									  - 1.0/2 * HPLs3[0*2*2+0*2+0]
									  + 1.0/2 * HPLs3[0*2*2+1*2+0]
									  + 1.0/2 * HPLs1[1] * zeta2
									  - 1.0/2 * HPLs3[0*2*2+0*2+1]
									  + 1.0/2 * HPLs3[0*2*2+1*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(v, 2) * pow(1. - u, -2) * (
									  + zeta2
									  + 1.0/4 * zeta3
									  - 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 1.0/4 * GHPLs3[0*4*4+3*4+2]
									  + 1.0/4 * GHPLs1[2] * zeta2
									  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
									  + 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
									  + 1.0/2 * GHPLs1[3] * HPLs1[0]
									  - 1.0/2 * GHPLs2[0*4+3]
									  - 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 1.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 1.0/2 * GHPLs1[0] * zeta2
									  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
									  - 1.0/4 * HPLs1[0] * zeta2
									  + 1.0/2 * HPLs2[0*2+0]
									  + 1.0/4 * HPLs3[0*2*2+0*2+0]
									  - 1.0/4 * HPLs3[0*2*2+1*2+0]
									  - 1.0/4 * HPLs1[1] * zeta2
									  + 1.0/2 * HPLs2[0*2+1]
									  + 1.0/4 * HPLs3[0*2*2+0*2+1]
									  - 1.0/4 * HPLs3[0*2*2+1*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(v, 2) * pow(1. - u, -1) * (
									  + 5.0/4 * zeta2
									  + 1.0/4 * zeta3
									  - 1.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 1.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 3.0/8 * GHPLs1[2]
									  + 1.0/4 * GHPLs1[2] * zeta2
									  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
									  - 1.0/8 * GHPLs2[0*4+2]
									  + 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
									  - 1.0/8 * GHPLs2[2*4+0]
									  - 1.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 1.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 1.0/2 * GHPLs1[0] * zeta2
									  + 1.0/8 * GHPLs1[0] * HPLs1[0]
									  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 1.0/8 * GHPLs1[0] * HPLs1[1]
									  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
									  - 1.0/4 * GHPLs2[2*4+1]
									  + 1.0/4 * GHPLs1[1] * HPLs1[0]
									  + 1.0/4 * GHPLs1[1] * HPLs1[1]
									  + 3.0/8 * HPLs1[0]
									  - 1.0/4 * HPLs1[0] * zeta2
									  - 1.0/4 * HPLs2[0*2+0]
									  + 1.0/4 * HPLs3[0*2*2+0*2+0]
									  - 1.0/4 * HPLs2[1*2+0]
									  - 1.0/4 * HPLs3[0*2*2+1*2+0]
									  + 3.0/8 * HPLs1[1]
									  - 1.0/4 * HPLs1[1] * zeta2
									  + 1.0/4 * HPLs3[0*2*2+0*2+1]
									  - 1.0/4 * HPLs3[0*2*2+1*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(v, 2) * (
							+ 2 * zeta2
							+ 3.0/8 * GHPLs1[2] * zeta2
							+ 1.0/2 * GHPLs1[2] * HPLs1[0]
							+ 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							- 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							- 1.0/2 * GHPLs2[0*4+2]
							- 3.0/8 * GHPLs2[0*4+2] * HPLs1[0]
							- 3.0/8 * GHPLs3[2*4*4+1*4+2]
							+ 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							+ 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							- 3.0/8 * GHPLs2[2*4+3] * HPLs1[0]
							+ 3.0/8 * GHPLs3[0*4*4+2*4+3]
							+ 3.0/8 * GHPLs2[3*4+3] * HPLs1[0]
							- 3.0/8 * GHPLs3[0*4*4+3*4+3]
							- 15.0/8 * GHPLs1[3] * zeta2
							- 1.0/2 * GHPLs1[3] * HPLs1[0]
							+ 3.0/8 * GHPLs1[3] * HPLs2[1*2+0]
							+ 3.0/8 * GHPLs1[3] * HPLs2[0*2+1]
							+ 3.0/8 * GHPLs3[2*4*4+0*4+3]
							+ 1.0/2 * GHPLs2[0*4+3]
							- 3.0/8 * GHPLs2[0*4+3] * HPLs1[1]
							- 1.0/2 * GHPLs2[2*4+0]
							+ 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							- 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
							+ 1.0/8 * GHPLs3[0*4*4+3*4+0]
							+ 1.0/2 * GHPLs1[0] * HPLs1[0]
							- 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
							- 1.0/8 * GHPLs1[0] * HPLs2[1*2+0]
							+ 1.0/2 * GHPLs1[0] * HPLs1[1]
							- 1.0/8 * GHPLs1[0] * HPLs2[0*2+1]
							+ 1.0/2 * GHPLs2[2*4+1]
							- 1.0/8 * GHPLs3[0*4*4+2*4+1]
							+ 1.0/2 * GHPLs1[1] * zeta2
							- 1.0/2 * GHPLs1[1] * HPLs1[0]
							+ 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
							+ 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
							- 1.0/2 * GHPLs1[1] * HPLs1[1]
							- 1.0/8 * GHPLs3[2*4*4+0*4+1]
							+ 1.0/8 * GHPLs2[0*4+1] * HPLs1[0]
							+ 1.0/8 * GHPLs2[0*4+1] * HPLs1[1]
							+ 1.0/8 * GHPLs3[2*4*4+1*4+1]
							- 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
							- 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
							- 5.0/8 * HPLs1[0] * zeta2
							- 1.0/2 * HPLs2[0*2+0]
							- 1.0/8 * HPLs3[1*2*2+0*2+0]
							- 1.0/8 * HPLs3[0*2*2+1*2+0]
							- 1.0/8 * HPLs1[1] * zeta2
							- 1.0/2 * HPLs2[0*2+1]
							- 1.0/8 * HPLs3[0*2*2+0*2+1]
							- 1.0/8 * HPLs3[1*2*2+0*2+1]
							- 1.0/4 * HPLs3[0*2*2+1*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - v, -2) * (
								  - 63.0/16 * zeta2
								  - 15.0/4 * zeta3
								  - 7.0/2 * GHPLs2[3*4+2] * HPLs1[0]
								  + 7.0/2 * GHPLs3[0*4*4+3*4+2]
								  + 15.0/4 * GHPLs1[2] * zeta2
								  + 5.0/8 * GHPLs1[2] * HPLs1[0]
								  - 15.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								  - 31.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								  - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
								  - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								  - 31.0/8 * GHPLs3[2*4*4+1*4+2]
								  + 31.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								  + 31.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								  + 33.0/8 * GHPLs1[3] * HPLs1[0]
								  - 33.0/8 * GHPLs2[0*4+3]
								  + 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
								  + 7.0/2 * GHPLs2[3*4+0] * HPLs1[0]
								  - 7.0/2 * GHPLs3[0*4*4+3*4+0]
								  - 29.0/8 * GHPLs1[0] * zeta2
								  - 7.0/16 * GHPLs1[0] * HPLs1[0]
								  + 15.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								  + 29.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  + 31.0/8 * GHPLs3[2*4*4+1*4+0]
								  - 31.0/8 * GHPLs2[1*4+0] * HPLs1[0]
								  - 31.0/8 * GHPLs2[1*4+0] * HPLs1[1]
								  + 33.0/8 * GHPLs2[2*4+1]
								  - 33.0/8 * GHPLs1[1] * HPLs1[0]
								  - 33.0/8 * GHPLs1[1] * HPLs1[1]
								  - 27.0/32 * HPLs1[0]
								  + 115.0/8 * HPLs1[0] * zeta2
								  + 33.0/8 * HPLs2[0*2+0]
								  - 7.0/2 * HPLs3[0*2*2+0*2+0]
								  + 1.0/4 * HPLs3[1*2*2+0*2+0]
								  + 7.0/2 * HPLs2[1*2+0]
								  - 7.0/2 * HPLs3[0*2*2+1*2+0]
								  - 29.0/8 * HPLs1[1] * zeta2
								  - 7.0/16 * HPLs2[0*2+1]
								  + 15.0/4 * HPLs3[0*2*2+0*2+1]
								  + 29.0/8 * HPLs3[1*2*2+0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - v, -1) * (
								  - 17.0/32
								  + 293.0/16 * zeta2
								  + 15.0/4 * zeta3
								  + 7.0/2 * GHPLs2[3*4+2] * HPLs1[0]
								  - 7.0/2 * GHPLs3[0*4*4+3*4+2]
								  - 15.0/8 * GHPLs1[2]
								  - 15.0/4 * GHPLs1[2] * zeta2
								  + 7.0/2 * GHPLs1[2] * HPLs1[0]
								  + 15.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								  + 31.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								  + 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
								  - 29.0/8 * GHPLs2[0*4+2]
								  + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								  + 31.0/8 * GHPLs3[2*4*4+1*4+2]
								  - 31.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								  - 31.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								  - 61.0/8 * GHPLs1[3] * HPLs1[0]
								  + 61.0/8 * GHPLs2[0*4+3]
								  - 29.0/8 * GHPLs2[2*4+0]
								  - 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
								  - 7.0/2 * GHPLs2[3*4+0] * HPLs1[0]
								  + 7.0/2 * GHPLs3[0*4*4+3*4+0]
								  + 25.0/16 * GHPLs1[0]
								  + 29.0/8 * GHPLs1[0] * zeta2
								  + 59.0/16 * GHPLs1[0] * HPLs1[0]
								  - 15.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								  - 29.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  + 29.0/8 * GHPLs1[0] * HPLs1[1]
								  - 31.0/8 * GHPLs3[2*4*4+1*4+0]
								  + 31.0/8 * GHPLs2[1*4+0] * HPLs1[0]
								  + 31.0/8 * GHPLs2[1*4+0] * HPLs1[1]
								  - 1.0/4 * GHPLs2[2*4+1]
								  + 1.0/4 * GHPLs1[1] * HPLs1[0]
								  + 1.0/4 * GHPLs1[1] * HPLs1[1]
								  + 39.0/32 * HPLs1[0]
								  - 115.0/8 * HPLs1[0] * zeta2
								  - 61.0/8 * HPLs2[0*2+0]
								  + 7.0/2 * HPLs3[0*2*2+0*2+0]
								  - 1.0/4 * HPLs3[1*2*2+0*2+0]
								  - 15.0/4 * HPLs2[1*2+0]
								  + 7.0/2 * HPLs3[0*2*2+1*2+0]
								  + 15.0/8 * HPLs1[1]
								  + 29.0/8 * HPLs1[1] * zeta2
								  - 57.0/16 * HPLs2[0*2+1]
								  - 15.0/4 * HPLs3[0*2*2+0*2+1]
								  - 29.0/8 * HPLs3[1*2*2+0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * (
						- 11 * zeta2
						+ 3.0/4 * GHPLs1[2]
						- 3 * GHPLs1[2] * HPLs1[0]
						+ 11.0/4 * GHPLs2[0*4+2]
						+ 11.0/4 * GHPLs1[3] * HPLs1[0]
						- 11.0/4 * GHPLs2[0*4+3]
						+ 11.0/4 * GHPLs2[2*4+0]
						- 3.0/8 * GHPLs1[0]
						- 5.0/2 * GHPLs1[0] * HPLs1[0]
						- 11.0/4 * GHPLs1[0] * HPLs1[1]
						- 11.0/4 * GHPLs2[2*4+1]
						+ 11.0/4 * GHPLs1[1] * HPLs1[0]
						+ 11.0/4 * GHPLs1[1] * HPLs1[1]
						- 3.0/8 * HPLs1[0]
						+ 11.0/4 * HPLs2[0*2+0]
						+ 1.0/4 * HPLs2[1*2+0]
						- 3.0/4 * HPLs1[1]
						+ 3 * HPLs2[0*2+1]
						)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * v * (
						    + 4 * zeta2
						    + 1.0/8 * GHPLs1[2] * zeta2
						    + GHPLs1[2] * HPLs1[0]
						    + 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						    - 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						    - GHPLs2[0*4+2]
						    - 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						    - 1.0/8 * GHPLs3[2*4*4+1*4+2]
						    + 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						    + 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						    - 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
						    + 1.0/8 * GHPLs3[0*4*4+2*4+3]
						    + 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
						    - 1.0/8 * GHPLs3[0*4*4+3*4+3]
						    - 5.0/8 * GHPLs1[3] * zeta2
						    - GHPLs1[3] * HPLs1[0]
						    + 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
						    + 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
						    + 1.0/8 * GHPLs3[2*4*4+0*4+3]
						    + GHPLs2[0*4+3]
						    - 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
						    - GHPLs2[2*4+0]
						    + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						    - 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
						    + 1.0/8 * GHPLs3[0*4*4+3*4+0]
						    + GHPLs1[0] * HPLs1[0]
						    - 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
						    - 1.0/8 * GHPLs1[0] * HPLs2[1*2+0]
						    + GHPLs1[0] * HPLs1[1]
						    - 1.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						    + GHPLs2[2*4+1]
						    - 1.0/8 * GHPLs3[0*4*4+2*4+1]
						    + 1.0/2 * GHPLs1[1] * zeta2
						    - GHPLs1[1] * HPLs1[0]
						    + 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
						    + 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
						    - GHPLs1[1] * HPLs1[1]
						    - 1.0/8 * GHPLs3[2*4*4+0*4+1]
						    + 1.0/8 * GHPLs2[0*4+1] * HPLs1[0]
						    + 1.0/8 * GHPLs2[0*4+1] * HPLs1[1]
						    + 1.0/8 * GHPLs3[2*4*4+1*4+1]
						    - 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
						    - 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
						    - 5.0/8 * HPLs1[0] * zeta2
						    - HPLs2[0*2+0]
						    - 1.0/8 * HPLs3[1*2*2+0*2+0]
						    - 1.0/8 * HPLs3[0*2*2+1*2+0]
						    - 1.0/8 * HPLs1[1] * zeta2
						    - HPLs2[0*2+1]
						    - 1.0/8 * HPLs3[0*2*2+0*2+1]
						    - 1.0/8 * HPLs3[1*2*2+0*2+1]
						    - 1.0/4 * HPLs3[0*2*2+1*2+1]
						    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -3) * (
									  + 9.0/4 * zeta2
									  + 21.0/4 * zeta3
									  + 21.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  - 21.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 21.0/4 * GHPLs1[2] * zeta2
									  + 21.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 21.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  + 21.0/4 * GHPLs3[2*4*4+1*4+2]
									  - 21.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  - 21.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  - 9.0/4 * GHPLs1[3] * HPLs1[0]
									  + 9.0/4 * GHPLs2[0*4+3]
									  - 21.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 21.0/4 * GHPLs3[0*4*4+3*4+0]
									  + 21.0/4 * GHPLs1[0] * zeta2
									  - 21.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  - 21.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  - 21.0/4 * GHPLs3[2*4*4+1*4+0]
									  + 21.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  + 21.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  - 9.0/4 * GHPLs2[2*4+1]
									  + 9.0/4 * GHPLs1[1] * HPLs1[0]
									  + 9.0/4 * GHPLs1[1] * HPLs1[1]
									  - 21 * HPLs1[0] * zeta2
									  - 9.0/4 * HPLs2[0*2+0]
									  + 21.0/4 * HPLs3[0*2*2+0*2+0]
									  - 9.0/4 * HPLs2[1*2+0]
									  + 21.0/4 * HPLs3[0*2*2+1*2+0]
									  + 21.0/4 * HPLs1[1] * zeta2
									  - 21.0/4 * HPLs3[0*2*2+0*2+1]
									  - 21.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -2) * (
									  - 93.0/4 * zeta2
									  - 21.0/4 * zeta3
									  - 21.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 21.0/4 * GHPLs3[0*4*4+3*4+2]
									  + 9.0/8 * GHPLs1[2]
									  + 21.0/4 * GHPLs1[2] * zeta2
									  - 21.0/4 * GHPLs1[2] * HPLs1[0]
									  - 21.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  - 21.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  + 21.0/4 * GHPLs2[0*4+2]
									  - 21.0/4 * GHPLs3[2*4*4+1*4+2]
									  + 21.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  + 21.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  + 15.0/2 * GHPLs1[3] * HPLs1[0]
									  - 15.0/2 * GHPLs2[0*4+3]
									  + 21.0/4 * GHPLs2[2*4+0]
									  + 21.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  - 21.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 9.0/8 * GHPLs1[0]
									  - 21.0/4 * GHPLs1[0] * zeta2
									  - 21.0/4 * GHPLs1[0] * HPLs1[0]
									  + 21.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 21.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  - 21.0/4 * GHPLs1[0] * HPLs1[1]
									  + 21.0/4 * GHPLs3[2*4*4+1*4+0]
									  - 21.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  - 21.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  - 3 * GHPLs2[2*4+1]
									  + 3 * GHPLs1[1] * HPLs1[0]
									  + 3 * GHPLs1[1] * HPLs1[1]
									  + 21 * HPLs1[0] * zeta2
									  + 15.0/2 * HPLs2[0*2+0]
									  - 21.0/4 * HPLs3[0*2*2+0*2+0]
									  + 9.0/4 * HPLs2[1*2+0]
									  - 21.0/4 * HPLs3[0*2*2+1*2+0]
									  - 9.0/8 * HPLs1[1]
									  - 21.0/4 * HPLs1[1] * zeta2
									  + 21.0/4 * HPLs2[0*2+1]
									  + 21.0/4 * HPLs3[0*2*2+0*2+1]
									  + 21.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -1) * (
									  + 21.0/2 * zeta2
									  - 3.0/8 * GHPLs1[2]
									  + 21.0/8 * GHPLs1[2] * HPLs1[0]
									  - 21.0/8 * GHPLs2[0*4+2]
									  - 21.0/8 * GHPLs1[3] * HPLs1[0]
									  + 21.0/8 * GHPLs2[0*4+3]
									  - 21.0/8 * GHPLs2[2*4+0]
									  + 3.0/8 * GHPLs1[0]
									  + 21.0/8 * GHPLs1[0] * HPLs1[0]
									  + 21.0/8 * GHPLs1[0] * HPLs1[1]
									  + 21.0/8 * GHPLs2[2*4+1]
									  - 21.0/8 * GHPLs1[1] * HPLs1[0]
									  - 21.0/8 * GHPLs1[1] * HPLs1[1]
									  - 21.0/8 * HPLs2[0*2+0]
									  + 3.0/8 * HPLs1[1]
									  - 21.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * (
							+ 4 * zeta2
							+ GHPLs1[2] * HPLs1[0]
							- GHPLs2[0*4+2]
							- GHPLs1[3] * HPLs1[0]
							+ GHPLs2[0*4+3]
							- GHPLs2[2*4+0]
							+ GHPLs1[0] * HPLs1[0]
							+ GHPLs1[0] * HPLs1[1]
							+ GHPLs2[2*4+1]
							- GHPLs1[1] * HPLs1[0]
							- GHPLs1[1] * HPLs1[1]
							- HPLs2[0*2+0]
							- HPLs2[0*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -4) * (
									  - 9.0/4 * zeta3
									  - 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  + 9.0/4 * GHPLs1[2] * zeta2
									  - 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  + 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 9.0/4 * GHPLs1[0] * zeta2
									  + 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  + 9 * HPLs1[0] * zeta2
									  - 9.0/4 * HPLs3[0*2*2+0*2+0]
									  - 9.0/4 * HPLs3[0*2*2+1*2+0]
									  - 9.0/4 * HPLs1[1] * zeta2
									  + 9.0/4 * HPLs3[0*2*2+0*2+1]
									  + 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -3) * (
									  + 9 * zeta2
									  + 9.0/4 * zeta3
									  + 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 9.0/4 * GHPLs1[2] * zeta2
									  + 9.0/4 * GHPLs1[2] * HPLs1[0]
									  + 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs2[0*4+2]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  - 9.0/4 * GHPLs1[3] * HPLs1[0]
									  + 9.0/4 * GHPLs2[0*4+3]
									  - 9.0/4 * GHPLs2[2*4+0]
									  - 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  + 9.0/4 * GHPLs1[0] * zeta2
									  + 9.0/4 * GHPLs1[0] * HPLs1[0]
									  - 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs1[0] * HPLs1[1]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  + 9.0/4 * GHPLs2[2*4+1]
									  - 9.0/4 * GHPLs1[1] * HPLs1[0]
									  - 9.0/4 * GHPLs1[1] * HPLs1[1]
									  - 9 * HPLs1[0] * zeta2
									  - 9.0/4 * HPLs2[0*2+0]
									  + 9.0/4 * HPLs3[0*2*2+0*2+0]
									  + 9.0/4 * HPLs3[0*2*2+1*2+0]
									  + 9.0/4 * HPLs1[1] * zeta2
									  - 9.0/4 * HPLs2[0*2+1]
									  - 9.0/4 * HPLs3[0*2*2+0*2+1]
									  - 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -2) * (
									  - 9.0/2 * zeta2
									  - 9.0/8 * GHPLs1[2] * HPLs1[0]
									  + 9.0/8 * GHPLs2[0*4+2]
									  + 9.0/8 * GHPLs1[3] * HPLs1[0]
									  - 9.0/8 * GHPLs2[0*4+3]
									  + 9.0/8 * GHPLs2[2*4+0]
									  - 9.0/8 * GHPLs1[0] * HPLs1[0]
									  - 9.0/8 * GHPLs1[0] * HPLs1[1]
									  - 9.0/8 * GHPLs2[2*4+1]
									  + 9.0/8 * GHPLs1[1] * HPLs1[0]
									  + 9.0/8 * GHPLs1[1] * HPLs1[1]
									  + 9.0/8 * HPLs2[0*2+0]
									  + 9.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -1) * (
									  - 3.0/2 * zeta2
									  - 3.0/8 * GHPLs1[2] * HPLs1[0]
									  + 3.0/8 * GHPLs2[0*4+2]
									  + 3.0/8 * GHPLs1[3] * HPLs1[0]
									  - 3.0/8 * GHPLs2[0*4+3]
									  + 3.0/8 * GHPLs2[2*4+0]
									  - 3.0/8 * GHPLs1[0] * HPLs1[0]
									  - 3.0/8 * GHPLs1[0] * HPLs1[1]
									  - 3.0/8 * GHPLs2[2*4+1]
									  + 3.0/8 * GHPLs1[1] * HPLs1[0]
									  + 3.0/8 * GHPLs1[1] * HPLs1[1]
									  + 3.0/8 * HPLs2[0*2+0]
									  + 3.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * v * (
									 - 1.0/4 * GHPLs3[3*4*4+2*4+2]
									 - 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
									 + 1.0/4 * GHPLs1[2] * HPLs1[0]
									 - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									 + 1.0/4 * GHPLs3[3*4*4+0*4+2]
									 - 1.0/4 * GHPLs2[1*4+2]
									 + 1.0/8 * GHPLs2[1*4+0]
									 - 1.0/4 * GHPLs3[3*4*4+2*4+1]
									 - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
									 + 1.0/4 * GHPLs1[1]
									 + 1.0/2 * GHPLs1[1] * zeta2
									 - 1.0/8 * GHPLs1[1] * HPLs1[0]
									 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
									 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
									 - 1.0/4 * GHPLs3[3*4*4+0*4+1]
									 + 1.0/8 * GHPLs2[1*4+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 2) * (
										 + 1.0/4 * GHPLs3[3*4*4+2*4+2]
										 + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
										 - 1.0/4 * GHPLs1[2] * HPLs1[0]
										 + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
										 - 1.0/4 * GHPLs3[3*4*4+0*4+2]
										 + 1.0/4 * GHPLs2[1*4+2]
										 - 1.0/8 * GHPLs2[1*4+0]
										 + 1.0/4 * GHPLs3[3*4*4+2*4+1]
										 + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
										 - 1.0/8 * GHPLs1[1]
										 - 1.0/2 * GHPLs1[1] * zeta2
										 + 1.0/8 * GHPLs1[1] * HPLs1[0]
										 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
										 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
										 + 1.0/4 * GHPLs3[3*4*4+0*4+1]
										 - 1.0/8 * GHPLs2[1*4+1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 3) * (
										 + 1.0/8 * GHPLs2[1*4+2]
										 - 1.0/8 * GHPLs2[2*4+3]
										 + 1.0/8 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3] * HPLs1[0]
										 + 1.0/8 * GHPLs1[3] * HPLs1[1]
										 - 1.0/8 * GHPLs2[0*4+3]
										 - 1.0/8 * GHPLs1[1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 4) * (
										 - 1.0/8 * GHPLs2[1*4+2]
										 + 1.0/8 * GHPLs2[2*4+3]
										 - 1.0/8 * GHPLs2[3*4+3]
										 - 1.0/8 * GHPLs1[3] * HPLs1[0]
										 - 1.0/8 * GHPLs1[3] * HPLs1[1]
										 + 1.0/8 * GHPLs2[0*4+3]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * (
								     + 1.0/8 * GHPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * v * (
									 + 3.0/8
									 + 1.0/2 * zeta2
									 + 1.0/4 * GHPLs3[3*4*4+2*4+2]
									 + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
									 - 1.0/2 * GHPLs2[3*4+2]
									 - 3.0/4 * GHPLs1[2] * HPLs1[0]
									 + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									 - 1.0/4 * GHPLs3[3*4*4+0*4+2]
									 + 1.0/4 * GHPLs2[1*4+2]
									 - 1.0/8 * GHPLs2[1*4+0]
									 + 1.0/4 * GHPLs3[3*4*4+2*4+1]
									 + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
									 + 1.0/4 * GHPLs1[1]
									 - 1.0/2 * GHPLs1[1] * zeta2
									 + 1.0/8 * GHPLs1[1] * HPLs1[0]
									 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
									 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
									 + 1.0/4 * GHPLs3[3*4*4+0*4+1]
									 - 1.0/8 * GHPLs2[1*4+1]
									 + 1.0/8 * HPLs1[0]
									 + 1.0/4 * HPLs2[0*2+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(v, 2) * (
										 - 3.0/8
										 - 1.0/2 * zeta2
										 + 1.0/4 * GHPLs2[3*4+2]
										 + 1.0/8 * GHPLs1[2]
										 + 1.0/4 * GHPLs1[2] * HPLs1[0]
										 + 1.0/4 * GHPLs2[1*4+2]
										 - 1.0/4 * GHPLs2[2*4+3]
										 + 1.0/4 * GHPLs2[3*4+3]
										 - 3.0/8 * GHPLs1[3]
										 + 1.0/4 * GHPLs1[3] * HPLs1[0]
										 + 1.0/4 * GHPLs1[3] * HPLs1[1]
										 - 1.0/4 * GHPLs2[0*4+3]
										 + 1.0/4 * GHPLs2[3*4+0]
										 + 1.0/8 * GHPLs1[0]
										 - 3.0/4 * GHPLs1[1]
										 - 1.0/4 * HPLs2[0*2+0]
										 - 1.0/8 * HPLs1[1]
										 - 1.0/4 * HPLs2[0*2+1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(v, 3) * (
										 - 1.0/8 * GHPLs1[2]
										 - 3.0/8 * GHPLs2[1*4+2]
										 + 3.0/8 * GHPLs2[2*4+3]
										 - 3.0/8 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3]
										 - 3.0/8 * GHPLs1[3] * HPLs1[0]
										 - 3.0/8 * GHPLs1[3] * HPLs1[1]
										 + 3.0/8 * GHPLs2[0*4+3]
										 - 1.0/8 * GHPLs1[0]
										 + 1.0/8 * GHPLs1[1]
										 + 1.0/8 * HPLs1[0]
										 + 1.0/8 * HPLs1[1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(1. - u, -1) * (
									  + 1.0/4 * GHPLs1[3]
									  + 1.0/4 * HPLs1[0]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(1. - v, -1) * (
									  + 5.0/4 * zeta2
									  - 1.0/2 * GHPLs2[3*4+2]
									  - 3.0/4 * GHPLs1[2] * HPLs1[0]
									  + 7.0/8 * GHPLs2[1*4+2]
									  + 13.0/8 * GHPLs1[3]
									  + 1.0/2 * GHPLs2[3*4+0]
									  + 5.0/8 * GHPLs1[0] * HPLs1[0]
									  - 7.0/8 * GHPLs2[1*4+0]
									  - 2 * GHPLs1[1]
									  + 15.0/16 * HPLs1[0]
									  - 1.0/2 * HPLs2[0*2+0]
									  - 5.0/8 * HPLs2[1*2+0]
									  + 5.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * (
							+ 3.0/16
							- 5.0/4 * zeta2
							+ 1.0/2 * GHPLs2[3*4+2]
							+ 3.0/4 * GHPLs1[2] * HPLs1[0]
							- 7.0/8 * GHPLs2[1*4+2]
							- 2 * GHPLs1[3]
							- 1.0/2 * GHPLs2[3*4+0]
							- 5.0/8 * GHPLs1[0] * HPLs1[0]
							+ 7.0/8 * GHPLs2[1*4+0]
							+ 13.0/8 * GHPLs1[1]
							- 21.0/16 * HPLs1[0]
							+ 1.0/2 * HPLs2[0*2+0]
							+ 5.0/8 * HPLs2[1*2+0]
							- 5.0/8 * HPLs2[0*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * pow(1. - u, -2) * (
									      - zeta2
									      + 1.0/2 * GHPLs2[3*4+2]
									      + 1.0/2 * GHPLs1[2] * HPLs1[0]
									      - 1.0/2 * GHPLs1[3]
									      + 1.0/2 * GHPLs2[3*4+0]
									      - 1.0/2 * HPLs1[0]
									      - 1.0/2 * HPLs2[0*2+0]
									      - 1.0/2 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * pow(1. - u, -1) * (
									      - 1.0/4
									      + 1.0/2 * zeta2
									      - 1.0/4 * GHPLs2[3*4+2]
									      - 1.0/4 * GHPLs1[2] * HPLs1[0]
									      + 3.0/4 * GHPLs1[3]
									      - 1.0/4 * GHPLs2[3*4+0]
									      + 1.0/4 * HPLs1[0]
									      + 1.0/4 * HPLs2[0*2+0]
									      + 1.0/4 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * (
							    + 3.0/8
							    - 1.0/8 * zeta2
							    + 9.0/8 * GHPLs1[2]
							    + 1.0/8 * GHPLs2[1*4+2]
							    - 1.0/8 * GHPLs2[2*4+3]
							    + 1.0/8 * GHPLs2[3*4+3]
							    - 5.0/4 * GHPLs1[3]
							    + 1.0/8 * GHPLs1[3] * HPLs1[0]
							    + 1.0/8 * GHPLs1[3] * HPLs1[1]
							    - 1.0/8 * GHPLs2[0*4+3]
							    - 1.0/8 * GHPLs2[3*4+0]
							    + 9.0/8 * GHPLs1[0]
							    - 1.0/8 * GHPLs1[0] * HPLs1[0]
							    + 1.0/8 * GHPLs2[2*4+1]
							    - 5.0/4 * GHPLs1[1]
							    - 1.0/8 * GHPLs1[1] * HPLs1[1]
							    + 1.0/8 * GHPLs2[0*4+1]
							    - 1.0/8 * GHPLs2[1*4+1]
							    - 5.0/4 * HPLs1[0]
							    + 1.0/8 * HPLs2[0*2+0]
							    + 1.0/8 * HPLs2[1*2+0]
							    - 9.0/8 * HPLs1[1]
							    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(v, 2) * pow(1. - u, -3) * (
										      + zeta2
										      - 1.0/2 * GHPLs2[3*4+2]
										      - 1.0/2 * GHPLs1[2] * HPLs1[0]
										      - 1.0/2 * GHPLs2[3*4+0]
										      + 1.0/2 * HPLs2[0*2+0]
										      + 1.0/2 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(v, 2) * pow(1. - u, -2) * (
										      - 1.0/2 * zeta2
										      + 1.0/4 * GHPLs2[3*4+2]
										      + 1.0/4 * GHPLs1[2] * HPLs1[0]
										      - 1.0/2 * GHPLs1[3]
										      + 1.0/4 * GHPLs2[3*4+0]
										      - 1.0/4 * HPLs2[0*2+0]
										      - 1.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(v, 2) * pow(1. - u, -1) * (
										      - 3.0/8
										      - 1.0/2 * zeta2
										      + 1.0/4 * GHPLs2[3*4+2]
										      - 1.0/8 * GHPLs1[2]
										      + 1.0/4 * GHPLs1[2] * HPLs1[0]
										      + 1.0/4 * GHPLs2[3*4+0]
										      - 1.0/8 * GHPLs1[0]
										      - 1.0/4 * GHPLs1[1]
										      + 3.0/8 * HPLs1[0]
										      - 1.0/4 * HPLs2[0*2+0]
										      + 1.0/8 * HPLs1[1]
										      - 1.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(v, 2) * (
								    + 1.0/8 * zeta2
								    - 1.0/2 * GHPLs1[2]
								    - 3.0/8 * GHPLs2[1*4+2]
								    + 3.0/8 * GHPLs2[2*4+3]
								    - 3.0/8 * GHPLs2[3*4+3]
								    + 1.0/2 * GHPLs1[3]
								    - 3.0/8 * GHPLs1[3] * HPLs1[0]
								    - 3.0/8 * GHPLs1[3] * HPLs1[1]
								    + 3.0/8 * GHPLs2[0*4+3]
								    + 1.0/8 * GHPLs2[3*4+0]
								    - 1.0/2 * GHPLs1[0]
								    + 1.0/8 * GHPLs1[0] * HPLs1[0]
								    - 1.0/8 * GHPLs2[2*4+1]
								    + 1.0/2 * GHPLs1[1]
								    + 1.0/8 * GHPLs1[1] * HPLs1[1]
								    - 1.0/8 * GHPLs2[0*4+1]
								    + 1.0/8 * GHPLs2[1*4+1]
								    + 1.0/2 * HPLs1[0]
								    - 1.0/8 * HPLs2[0*2+0]
								    - 1.0/8 * HPLs2[1*2+0]
								    + 1.0/2 * HPLs1[1]
								    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - v, -2) * (
									      - 29.0/4 * zeta2
									      + 7.0/2 * GHPLs2[3*4+2]
									      + 15.0/4 * GHPLs1[2] * HPLs1[0]
									      - 31.0/8 * GHPLs2[1*4+2]
									      - 33.0/8 * GHPLs1[3]
									      - 7.0/2 * GHPLs2[3*4+0]
									      - 29.0/8 * GHPLs1[0] * HPLs1[0]
									      + 31.0/8 * GHPLs2[1*4+0]
									      + 33.0/8 * GHPLs1[1]
									      - 63.0/16 * HPLs1[0]
									      + 7.0/2 * HPLs2[0*2+0]
									      + 29.0/8 * HPLs2[1*2+0]
									      - 29.0/8 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - v, -1) * (
									      - 5.0/16
									      + 29.0/4 * zeta2
									      - 7.0/2 * GHPLs2[3*4+2]
									      - 29.0/8 * GHPLs1[2]
									      - 15.0/4 * GHPLs1[2] * HPLs1[0]
									      + 31.0/8 * GHPLs2[1*4+2]
									      + 61.0/8 * GHPLs1[3]
									      + 7.0/2 * GHPLs2[3*4+0]
									      - 29.0/8 * GHPLs1[0]
									      + 29.0/8 * GHPLs1[0] * HPLs1[0]
									      - 31.0/8 * GHPLs2[1*4+0]
									      - 1.0/4 * GHPLs1[1]
									      + 119.0/16 * HPLs1[0]
									      - 7.0/2 * HPLs2[0*2+0]
									      - 29.0/8 * HPLs2[1*2+0]
									      + 29.0/8 * HPLs1[1]
									      + 29.0/8 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * (
							    + 3.0/8
							    + 11.0/4 * GHPLs1[2]
							    - 11.0/4 * GHPLs1[3]
							    + 11.0/4 * GHPLs1[0]
							    - 11.0/4 * GHPLs1[1]
							    - 11.0/4 * HPLs1[0]
							    - 11.0/4 * HPLs1[1]
							    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * v * (
								+ 1.0/8 * zeta2
								- GHPLs1[2]
								- 1.0/8 * GHPLs2[1*4+2]
								+ 1.0/8 * GHPLs2[2*4+3]
								- 1.0/8 * GHPLs2[3*4+3]
								+ GHPLs1[3]
								- 1.0/8 * GHPLs1[3] * HPLs1[0]
								- 1.0/8 * GHPLs1[3] * HPLs1[1]
								+ 1.0/8 * GHPLs2[0*4+3]
								+ 1.0/8 * GHPLs2[3*4+0]
								- GHPLs1[0]
								+ 1.0/8 * GHPLs1[0] * HPLs1[0]
								- 1.0/8 * GHPLs2[2*4+1]
								+ GHPLs1[1]
								+ 1.0/8 * GHPLs1[1] * HPLs1[1]
								- 1.0/8 * GHPLs2[0*4+1]
								+ 1.0/8 * GHPLs2[1*4+1]
								+ HPLs1[0]
								- 1.0/8 * HPLs2[0*2+0]
								- 1.0/8 * HPLs2[1*2+0]
								+ HPLs1[1]
								)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -3) * (
										      + 21.0/2 * zeta2
										      - 21.0/4 * GHPLs2[3*4+2]
										      - 21.0/4 * GHPLs1[2] * HPLs1[0]
										      + 21.0/4 * GHPLs2[1*4+2]
										      + 9.0/4 * GHPLs1[3]
										      + 21.0/4 * GHPLs2[3*4+0]
										      + 21.0/4 * GHPLs1[0] * HPLs1[0]
										      - 21.0/4 * GHPLs2[1*4+0]
										      - 9.0/4 * GHPLs1[1]
										      + 9.0/4 * HPLs1[0]
										      - 21.0/4 * HPLs2[0*2+0]
										      - 21.0/4 * HPLs2[1*2+0]
										      + 21.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -2) * (
										      - 21.0/2 * zeta2
										      + 21.0/4 * GHPLs2[3*4+2]
										      + 21.0/4 * GHPLs1[2]
										      + 21.0/4 * GHPLs1[2] * HPLs1[0]
										      - 21.0/4 * GHPLs2[1*4+2]
										      - 15.0/2 * GHPLs1[3]
										      - 21.0/4 * GHPLs2[3*4+0]
										      + 21.0/4 * GHPLs1[0]
										      - 21.0/4 * GHPLs1[0] * HPLs1[0]
										      + 21.0/4 * GHPLs2[1*4+0]
										      - 3 * GHPLs1[1]
										      - 15.0/2 * HPLs1[0]
										      + 21.0/4 * HPLs2[0*2+0]
										      + 21.0/4 * HPLs2[1*2+0]
										      - 21.0/4 * HPLs1[1]
										      - 21.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -1) * (
										      - 21.0/8 * GHPLs1[2]
										      + 21.0/8 * GHPLs1[3]
										      - 21.0/8 * GHPLs1[0]
										      + 21.0/8 * GHPLs1[1]
										      + 21.0/8 * HPLs1[0]
										      + 21.0/8 * HPLs1[1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * (
								    - GHPLs1[2]
								    + GHPLs1[3]
								    - GHPLs1[0]
								    + GHPLs1[1]
								    + HPLs1[0]
								    + HPLs1[1]
								    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -4) * (
										      - 9.0/2 * zeta2
										      + 9.0/4 * GHPLs2[3*4+2]
										      + 9.0/4 * GHPLs1[2] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+2]
										      - 9.0/4 * GHPLs2[3*4+0]
										      - 9.0/4 * GHPLs1[0] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+0]
										      + 9.0/4 * HPLs2[0*2+0]
										      + 9.0/4 * HPLs2[1*2+0]
										      - 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -3) * (
										      + 9.0/2 * zeta2
										      - 9.0/4 * GHPLs2[3*4+2]
										      - 9.0/4 * GHPLs1[2]
										      - 9.0/4 * GHPLs1[2] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+2]
										      + 9.0/4 * GHPLs1[3]
										      + 9.0/4 * GHPLs2[3*4+0]
										      - 9.0/4 * GHPLs1[0]
										      + 9.0/4 * GHPLs1[0] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+0]
										      + 9.0/4 * GHPLs1[1]
										      + 9.0/4 * HPLs1[0]
										      - 9.0/4 * HPLs2[0*2+0]
										      - 9.0/4 * HPLs2[1*2+0]
										      + 9.0/4 * HPLs1[1]
										      + 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -2) * (
										      + 9.0/8 * GHPLs1[2]
										      - 9.0/8 * GHPLs1[3]
										      + 9.0/8 * GHPLs1[0]
										      - 9.0/8 * GHPLs1[1]
										      - 9.0/8 * HPLs1[0]
										      - 9.0/8 * HPLs1[1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -1) * (
										      + 3.0/8 * GHPLs1[2]
										      - 3.0/8 * GHPLs1[3]
										      + 3.0/8 * GHPLs1[0]
										      - 3.0/8 * GHPLs1[1]
										      - 3.0/8 * HPLs1[0]
										      - 3.0/8 * HPLs1[1]
										      )

    + C_F * dN_f * pow(1. - v, -1) * (
				    + 1.0/6 * zeta2
				    + 1.0/6 * GHPLs1[0] * HPLs1[0]
				    - 13.0/36 * HPLs1[0]
				    - 1.0/3 * HPLs2[0*2+0]
				    + 1.0/6 * HPLs2[0*2+1]
				    )

    + C_F * dN_f * (
		  - 19.0/36
		  - 1.0/6 * zeta2
		  + 1.0/6 * GHPLs1[0]
		  - 1.0/6 * GHPLs1[0] * HPLs1[0]
		  + 7.0/36 * HPLs1[0]
		  + 1.0/3 * HPLs2[0*2+0]
		  - 1.0/6 * HPLs2[0*2+1]
		  )

    + C_F * dN_f * u * pow(1. - v, -2) * (
					- 1.0/6 * zeta2
					- 1.0/6 * GHPLs1[0] * HPLs1[0]
					+ 13.0/36 * HPLs1[0]
					+ 1.0/3 * HPLs2[0*2+0]
					- 1.0/6 * HPLs2[0*2+1]
					)

    + C_F * dN_f * u * pow(1. - v, -1) * (
					+ 19.0/36
					+ 1.0/6 * zeta2
					- 1.0/6 * GHPLs1[0]
					+ 1.0/6 * GHPLs1[0] * HPLs1[0]
					- 7.0/36 * HPLs1[0]
					- 1.0/3 * HPLs2[0*2+0]
					+ 1.0/6 * HPLs2[0*2+1]
					);
  return gamma;
}

double_complex pplla03_amplitude_set::gamma_2_2(){
  //  const double zeta2 = M_PI * M_PI/6;
  //  const double zeta3 = 1.20205690315959429;
  //  const double zeta4 = pow(M_PI,4)/90;
  //  const double dN_c=3;
  //  const double C_F=(dN_c * dN_c - 1.) / (2 * dN_c);
  //  double NF=(double)n_f;

  double_complex gamma =
    (dN_c * dN_c - 1.) * pow(u, -2) * v * (
					   + 1.0/2 * GHPLs2[2*4+2] * zeta2
					   - 13.0/24 * GHPLs2[2*4+2] * HPLs1[0]
					   - 1.0/2 * GHPLs2[2*4+2] * HPLs2[1*2+0]
					   - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
					   + 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
					   + 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
					   - 13.0/24 * GHPLs1[2] * zeta2
					   + 277.0/144 * GHPLs1[2] * HPLs1[0]
					   + 11.0/6 * GHPLs1[2] * HPLs2[0*2+0]
					   + 13.0/24 * GHPLs1[2] * HPLs2[1*2+0]
					   + 1.0/2 * GHPLs3[2*4*4+0*4+2] * HPLs1[0]
					   + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
					   - 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
					   - 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
					   + 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
					   - GHPLs2[1*4+2] * zeta2
					   + 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
					   - 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
					   + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
					   - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
					   - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
					   - 13.0/24 * GHPLs3[2*4*4+2*4+1]
					   + 1.0/2 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
					   + 277.0/144 * GHPLs2[2*4+1]
					   - GHPLs2[2*4+1] * zeta2
					   + 11.0/12 * GHPLs2[2*4+1] * HPLs1[0]
					   + 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
					   + 13.0/24 * GHPLs2[2*4+1] * HPLs1[1]
					   - 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					   + 3.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
					   - 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
					   - 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
					   - 67.0/24 * GHPLs1[1] * zeta2
					   - 3.0/4 * GHPLs1[1] * zeta3
					   - 277.0/144 * GHPLs1[1] * HPLs1[0]
					   - 11.0/6 * GHPLs1[1] * HPLs2[0*2+0]
					   - 35.0/24 * GHPLs1[1] * HPLs2[1*2+0]
					   - 277.0/144 * GHPLs1[1] * HPLs1[1]
					   + GHPLs1[1] * HPLs1[1] * zeta2
					   - 11.0/12 * GHPLs1[1] * HPLs2[0*2+1]
					   - 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
					   - 13.0/24 * GHPLs1[1] * HPLs2[1*2+1]
					   + 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					   - 1.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[0]
					   - 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
					   + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
					   + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
					   + 1.0/2 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
					   - 13.0/24 * GHPLs3[2*4*4+1*4+1]
					   - 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
					   - 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
					   - 1.0/2 * GHPLs2[1*4+1] * zeta2
					   + 13.0/24 * GHPLs2[1*4+1] * HPLs1[0]
					   + 13.0/24 * GHPLs2[1*4+1] * HPLs1[1]
					   + 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
					   + 1.0/2 * GHPLs2[1*4+1] * HPLs2[1*2+1]
					   - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
					   + 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
					   + 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
					   )

    + (dN_c * dN_c - 1.) * pow(u, -2) * pow(v, 2) * (
						     - 1.0/2 * GHPLs2[2*4+2] * zeta2
						     + 13.0/24 * GHPLs2[2*4+2] * HPLs1[0]
						     + 1.0/2 * GHPLs2[2*4+2] * HPLs2[1*2+0]
						     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
						     - 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
						     - 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
						     + 13.0/24 * GHPLs1[2] * zeta2
						     - 277.0/144 * GHPLs1[2] * HPLs1[0]
						     - 11.0/6 * GHPLs1[2] * HPLs2[0*2+0]
						     - 13.0/24 * GHPLs1[2] * HPLs2[1*2+0]
						     - 1.0/2 * GHPLs3[2*4*4+0*4+2] * HPLs1[0]
						     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
						     + 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
						     + 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
						     - 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
						     + GHPLs2[1*4+2] * zeta2
						     - 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
						     + 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
						     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
						     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
						     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
						     + 13.0/24 * GHPLs3[2*4*4+2*4+1]
						     - 1.0/2 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
						     - 277.0/144 * GHPLs2[2*4+1]
						     + GHPLs2[2*4+1] * zeta2
						     - 11.0/12 * GHPLs2[2*4+1] * HPLs1[0]
						     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
						     - 13.0/24 * GHPLs2[2*4+1] * HPLs1[1]
						     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
						     - 3.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
						     + 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
						     + 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
						     + 67.0/24 * GHPLs1[1] * zeta2
						     + 3.0/4 * GHPLs1[1] * zeta3
						     + 277.0/144 * GHPLs1[1] * HPLs1[0]
						     + 11.0/6 * GHPLs1[1] * HPLs2[0*2+0]
						     + 35.0/24 * GHPLs1[1] * HPLs2[1*2+0]
						     + 277.0/144 * GHPLs1[1] * HPLs1[1]
						     - GHPLs1[1] * HPLs1[1] * zeta2
						     + 11.0/12 * GHPLs1[1] * HPLs2[0*2+1]
						     + 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
						     + 13.0/24 * GHPLs1[1] * HPLs2[1*2+1]
						     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
						     + 1.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[0]
						     + 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
						     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
						     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
						     - 1.0/2 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
						     + 13.0/24 * GHPLs3[2*4*4+1*4+1]
						     + 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
						     + 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
						     + 1.0/2 * GHPLs2[1*4+1] * zeta2
						     - 13.0/24 * GHPLs2[1*4+1] * HPLs1[0]
						     - 13.0/24 * GHPLs2[1*4+1] * HPLs1[1]
						     - 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
						     - 1.0/2 * GHPLs2[1*4+1] * HPLs2[1*2+1]
						     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
						     - 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
						     - 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
						     )

    + (dN_c * dN_c - 1.) * pow(u, -1) * (
					 - 1.0/8 * GHPLs1[2] * HPLs1[0]
					 - 1.0/8 * GHPLs2[2*4+1]
					 + 1.0/8 * GHPLs1[1] * HPLs1[0]
					 + 1.0/8 * GHPLs1[1] * HPLs1[1]
					 )

    + (dN_c * dN_c - 1.) * pow(u, -1) * v * (
					     + 1.0/2
					     - 10.0/3 * zeta2
					     - 3.0/4 * zeta3
					     - 13.0/24 * GHPLs2[2*4+2]
					     - 1.0/2 * GHPLs2[2*4+2] * zeta2
					     + 25.0/24 * GHPLs2[2*4+2] * HPLs1[0]
					     + 1.0/2 * GHPLs2[2*4+2] * HPLs2[1*2+0]
					     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
					     - 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
					     - 1.0/2 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
					     + 277.0/144 * GHPLs1[2]
					     - 5.0/24 * GHPLs1[2] * zeta2
					     - 205.0/144 * GHPLs1[2] * HPLs1[0]
					     - 11.0/6 * GHPLs1[2] * HPLs2[0*2+0]
					     - 13.0/24 * GHPLs1[2] * HPLs2[1*2+0]
					     + 13.0/24 * GHPLs1[2] * HPLs1[1]
					     - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
					     - 1.0/2 * GHPLs3[2*4*4+0*4+2] * HPLs1[0]
					     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
					     + 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
					     + 1.0/2 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
					     + 1.0/2 * GHPLs3[2*4*4+1*4+2]
					     - 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
					     + GHPLs2[1*4+2] * zeta2
					     - 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
					     - 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
					     - 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
					     + 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
					     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
					     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
					     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
					     + 25.0/24 * GHPLs3[2*4*4+2*4+1]
					     - 1.0/2 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
					     - 337.0/144 * GHPLs2[2*4+1]
					     + GHPLs2[2*4+1] * zeta2
					     - 17.0/12 * GHPLs2[2*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
					     - 25.0/24 * GHPLs2[2*4+1] * HPLs1[1]
					     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
					     - 3.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
					     + 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
					     + 3.0/4 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
					     + 55.0/24 * GHPLs1[1] * zeta2
					     + 3.0/4 * GHPLs1[1] * zeta3
					     + 337.0/144 * GHPLs1[1] * HPLs1[0]
					     + 11.0/6 * GHPLs1[1] * HPLs2[0*2+0]
					     + 35.0/24 * GHPLs1[1] * HPLs2[1*2+0]
					     + 337.0/144 * GHPLs1[1] * HPLs1[1]
					     - GHPLs1[1] * HPLs1[1] * zeta2
					     + 17.0/12 * GHPLs1[1] * HPLs2[0*2+1]
					     + 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
					     + 25.0/24 * GHPLs1[1] * HPLs2[1*2+1]
					     - 1.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
					     + 1.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[0]
					     + 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
					     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
					     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
					     - 1.0/2 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
					     + 1.0/24 * GHPLs3[2*4*4+1*4+1]
					     + 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
					     + 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
					     + 1.0/2 * GHPLs2[1*4+1] * zeta2
					     - 1.0/24 * GHPLs2[1*4+1] * HPLs1[0]
					     - 1.0/24 * GHPLs2[1*4+1] * HPLs1[1]
					     - 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
					     - 1.0/2 * GHPLs2[1*4+1] * HPLs2[1*2+1]
					     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
					     - 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
					     - 1.0/2 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
					     - 11.0/12 * HPLs2[1*2+0]
					     - 277.0/144 * HPLs1[1]
					     + HPLs1[1] * zeta2
					     - 11.0/12 * HPLs2[0*2+1]
					     - 1.0/4 * HPLs3[1*2*2+0*2+1]
					     - 13.0/24 * HPLs2[1*2+1]
					     + 1.0/4 * HPLs3[0*2*2+1*2+1]
					     )

    + (dN_c * dN_c - 1.) * pow(u, -1) * pow(v, 2) * (
						     + 67.0/24 * zeta2
						     + 3.0/4 * zeta3
						     + 13.0/24 * GHPLs2[2*4+2]
						     - 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
						     - 277.0/144 * GHPLs1[2]
						     + GHPLs1[2] * zeta2
						     - 25.0/24 * GHPLs1[2] * HPLs1[0]
						     - 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
						     - 13.0/24 * GHPLs1[2] * HPLs1[1]
						     + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
						     - 3.0/4 * GHPLs3[2*4*4+1*4+2]
						     + 3.0/4 * GHPLs2[1*4+2] * HPLs1[0]
						     + 3.0/4 * GHPLs2[1*4+2] * HPLs1[1]
						     + 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
						     + 1.0/4 * GHPLs3[2*4*4+1*4+0]
						     - 1.0/4 * GHPLs2[1*4+0] * HPLs1[0]
						     - 1.0/4 * GHPLs2[1*4+0] * HPLs1[1]
						     - 1.0/2 * GHPLs3[2*4*4+2*4+1]
						     + 5.0/12 * GHPLs2[2*4+1]
						     + 1.0/2 * GHPLs2[2*4+1] * HPLs1[0]
						     + 1.0/2 * GHPLs2[2*4+1] * HPLs1[1]
						     + 1.0/2 * GHPLs1[1] * zeta2
						     - 5.0/12 * GHPLs1[1] * HPLs1[0]
						     - 5.0/12 * GHPLs1[1] * HPLs1[1]
						     - 1.0/2 * GHPLs1[1] * HPLs2[0*2+1]
						     - 1.0/2 * GHPLs1[1] * HPLs2[1*2+1]
						     + 1.0/2 * GHPLs3[2*4*4+1*4+1]
						     - 1.0/2 * GHPLs2[1*4+1] * HPLs1[0]
						     - 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
						     + 277.0/144 * HPLs1[0]
						     + 11.0/6 * HPLs2[0*2+0]
						     + 35.0/24 * HPLs2[1*2+0]
						     + 277.0/144 * HPLs1[1]
						     - HPLs1[1] * zeta2
						     + 11.0/12 * HPLs2[0*2+1]
						     + 1.0/4 * HPLs3[1*2*2+0*2+1]
						     + 13.0/24 * HPLs2[1*2+1]
						     - 1.0/4 * HPLs3[0*2*2+1*2+1]
						     )

    + (dN_c * dN_c - 1.) * pow(1. - v, -1) * (
					      + 13.0/48 * zeta2
					      - 1.0/8 * GHPLs1[2] * zeta2
					      + 19.0/48 * GHPLs1[2] * HPLs1[0]
					      + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
					      + 1.0/8 * GHPLs3[2*4*4+1*4+2]
					      - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
					      - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
					      - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
					      - 1.0/8 * GHPLs3[2*4*4+1*4+0]
					      + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
					      + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
					      + 1.0/8 * GHPLs2[2*4+1]
					      - 1.0/8 * GHPLs1[1] * HPLs1[0]
					      - 1.0/8 * GHPLs1[1] * HPLs1[1]
					      - 391.0/288 * HPLs1[0]
					      - 11.0/12 * HPLs2[0*2+0]
					      - 13.0/48 * HPLs2[1*2+0]
					      )

    + (dN_c * dN_c - 1.) * (
			    + 1.0/2
			    - 13.0/48 * zeta2
			    - 1.0/8 * GHPLs1[2]
			    + 1.0/8 * GHPLs1[2] * zeta2
			    - 13.0/48 * GHPLs1[2] * HPLs1[0]
			    - 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
			    - 1.0/8 * GHPLs3[2*4*4+1*4+2]
			    + 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
			    + 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
			    + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
			    + 1.0/8 * GHPLs3[2*4*4+1*4+0]
			    - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
			    - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
			    + 391.0/288 * HPLs1[0]
			    + 11.0/12 * HPLs2[0*2+0]
			    + 13.0/48 * HPLs2[1*2+0]
			    + 1.0/8 * HPLs1[1]
			    )

    + (dN_c * dN_c - 1.) * v * pow(1. - u, -1) * (
						  + 277.0/288
						  + 55.0/48 * zeta2
						  + 3.0/8 * zeta3
						  + 25.0/48 * GHPLs2[2*4+2]
						  - 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
						  - 433.0/288 * GHPLs1[2]
						  + 1.0/2 * GHPLs1[2] * zeta2
						  - 7.0/12 * GHPLs1[2] * HPLs1[0]
						  - 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						  - 25.0/48 * GHPLs1[2] * HPLs1[1]
						  + 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
						  - 3.0/8 * GHPLs3[2*4*4+1*4+2]
						  + 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						  + 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						  + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						  + 1.0/8 * GHPLs3[2*4*4+1*4+0]
						  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						  - 1.0/4 * GHPLs3[2*4*4+2*4+1]
						  + 7.0/48 * GHPLs2[2*4+1]
						  + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
						  + 1.0/4 * GHPLs2[2*4+1] * HPLs1[1]
						  + 1.0/4 * GHPLs1[1] * zeta2
						  - 7.0/48 * GHPLs1[1] * HPLs1[0]
						  - 7.0/48 * GHPLs1[1] * HPLs1[1]
						  - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
						  - 1.0/4 * GHPLs1[1] * HPLs2[1*2+1]
						  + 1.0/4 * GHPLs3[2*4*4+1*4+1]
						  - 1.0/4 * GHPLs2[1*4+1] * HPLs1[0]
						  - 1.0/4 * GHPLs2[1*4+1] * HPLs1[1]
						  + 487.0/288 * HPLs1[0]
						  + 11.0/12 * HPLs2[0*2+0]
						  + 35.0/48 * HPLs2[1*2+0]
						  + 433.0/288 * HPLs1[1]
						  - 1.0/2 * HPLs1[1] * zeta2
						  + 17.0/24 * HPLs2[0*2+1]
						  + 1.0/8 * HPLs3[1*2*2+0*2+1]
						  + 25.0/48 * HPLs2[1*2+1]
						  - 1.0/8 * HPLs3[0*2*2+1*2+1]
						  )

    + (dN_c * dN_c - 1.) * pow(v, 2) * pow(1. - u, -2) * (
							  - 55.0/48 * zeta2
							  - 3.0/8 * zeta3
							  - 25.0/48 * GHPLs2[2*4+2]
							  + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
							  + 355.0/288 * GHPLs1[2]
							  - 1.0/2 * GHPLs1[2] * zeta2
							  + 17.0/24 * GHPLs1[2] * HPLs1[0]
							  + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							  + 25.0/48 * GHPLs1[2] * HPLs1[1]
							  - 1.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							  + 3.0/8 * GHPLs3[2*4*4+1*4+2]
							  - 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							  - 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							  - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							  - 1.0/8 * GHPLs3[2*4*4+1*4+0]
							  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							  + 1.0/4 * GHPLs3[2*4*4+2*4+1]
							  - 1.0/48 * GHPLs2[2*4+1]
							  - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							  - 1.0/4 * GHPLs2[2*4+1] * HPLs1[1]
							  - 1.0/4 * GHPLs1[1] * zeta2
							  + 1.0/48 * GHPLs1[1] * HPLs1[0]
							  + 1.0/48 * GHPLs1[1] * HPLs1[1]
							  + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							  + 1.0/4 * GHPLs1[1] * HPLs2[1*2+1]
							  - 1.0/4 * GHPLs3[2*4*4+1*4+1]
							  + 1.0/4 * GHPLs2[1*4+1] * HPLs1[0]
							  + 1.0/4 * GHPLs2[1*4+1] * HPLs1[1]
							  - 355.0/288 * HPLs1[0]
							  - 11.0/12 * HPLs2[0*2+0]
							  - 35.0/48 * HPLs2[1*2+0]
							  - 355.0/288 * HPLs1[1]
							  + 1.0/2 * HPLs1[1] * zeta2
							  - 17.0/24 * HPLs2[0*2+1]
							  - 1.0/8 * HPLs3[1*2*2+0*2+1]
							  - 25.0/48 * HPLs2[1*2+1]
							  + 1.0/8 * HPLs3[0*2*2+1*2+1]
							  )

    + (dN_c * dN_c - 1.) * pow(v, 2) * pow(1. - u, -1) * (
							  + 67.0/24 * zeta2
							  + 3.0/4 * zeta3
							  + 13.0/24 * GHPLs2[2*4+2]
							  - 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
							  - 277.0/144 * GHPLs1[2]
							  + GHPLs1[2] * zeta2
							  - 25.0/24 * GHPLs1[2] * HPLs1[0]
							  - 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
							  - 13.0/24 * GHPLs1[2] * HPLs1[1]
							  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
							  - 3.0/4 * GHPLs3[2*4*4+1*4+2]
							  + 3.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							  + 3.0/4 * GHPLs2[1*4+2] * HPLs1[1]
							  + 1.0/4 * GHPLs2[2*4+0] * HPLs1[0]
							  + 1.0/4 * GHPLs3[2*4*4+1*4+0]
							  - 1.0/4 * GHPLs2[1*4+0] * HPLs1[0]
							  - 1.0/4 * GHPLs2[1*4+0] * HPLs1[1]
							  - 1.0/2 * GHPLs3[2*4*4+2*4+1]
							  + 5.0/12 * GHPLs2[2*4+1]
							  + 1.0/2 * GHPLs2[2*4+1] * HPLs1[0]
							  + 1.0/2 * GHPLs2[2*4+1] * HPLs1[1]
							  + 1.0/2 * GHPLs1[1] * zeta2
							  - 5.0/12 * GHPLs1[1] * HPLs1[0]
							  - 5.0/12 * GHPLs1[1] * HPLs1[1]
							  - 1.0/2 * GHPLs1[1] * HPLs2[0*2+1]
							  - 1.0/2 * GHPLs1[1] * HPLs2[1*2+1]
							  + 1.0/2 * GHPLs3[2*4*4+1*4+1]
							  - 1.0/2 * GHPLs2[1*4+1] * HPLs1[0]
							  - 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
							  + 277.0/144 * HPLs1[0]
							  + 11.0/6 * HPLs2[0*2+0]
							  + 35.0/24 * HPLs2[1*2+0]
							  + 277.0/144 * HPLs1[1]
							  - HPLs1[1] * zeta2
							  + 11.0/12 * HPLs2[0*2+1]
							  + 1.0/4 * HPLs3[1*2*2+0*2+1]
							  + 13.0/24 * HPLs2[1*2+1]
							  - 1.0/4 * HPLs3[0*2*2+1*2+1]
							  )

    + (dN_c * dN_c - 1.) * u * pow(1. - v, -2) * (
						  + 13.0/48 * zeta2
						  - 1.0/8 * GHPLs1[2] * zeta2
						  + 13.0/48 * GHPLs1[2] * HPLs1[0]
						  + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						  + 1.0/8 * GHPLs3[2*4*4+1*4+2]
						  - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						  - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						  - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						  - 1.0/8 * GHPLs3[2*4*4+1*4+0]
						  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						  - 163.0/288 * HPLs1[0]
						  - 11.0/12 * HPLs2[0*2+0]
						  - 13.0/48 * HPLs2[1*2+0]
						  )

    + (dN_c * dN_c - 1.) * u * pow(1. - v, -1) * (
						  - 277.0/288
						  - 13.0/48 * zeta2
						  + 19.0/48 * GHPLs1[2]
						  + 1.0/8 * GHPLs1[2] * zeta2
						  - 19.0/48 * GHPLs1[2] * HPLs1[0]
						  - 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						  - 1.0/8 * GHPLs3[2*4*4+1*4+2]
						  + 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						  + 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						  + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						  + 1.0/8 * GHPLs3[2*4*4+1*4+0]
						  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						  - 1.0/8 * GHPLs2[2*4+1]
						  + 1.0/8 * GHPLs1[1] * HPLs1[0]
						  + 1.0/8 * GHPLs1[1] * HPLs1[1]
						  + 31.0/288 * HPLs1[0]
						  + 11.0/12 * HPLs2[0*2+0]
						  + 13.0/48 * HPLs2[1*2+0]
						  - 19.0/48 * HPLs1[1]
						  )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -2) * v * (
							 + 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
							 - 1.0/2 * GHPLs3[1*4*4+2*4+2]
							 + 3.0/8 * GHPLs1[2] * HPLs1[0]
							 + 1.0/2 * GHPLs3[1*4*4+0*4+2]
							 - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							 + 1.0/2 * GHPLs3[1*4*4+1*4+2]
							 + 3.0/8 * GHPLs2[2*4+1]
							 - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							 + 3.0/4 * GHPLs3[1*4*4+2*4+1]
							 + 277.0/144 * GHPLs1[1]
							 - 1.0/4 * GHPLs1[1] * zeta2
							 + 13.0/24 * GHPLs1[1] * HPLs1[0]
							 - 3.0/8 * GHPLs1[1] * HPLs1[1]
							 + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							 - 1.0/4 * GHPLs3[1*4*4+0*4+1]
							 + 1.0/2 * GHPLs3[2*4*4+1*4+1]
							 - 13.0/24 * GHPLs2[1*4+1]
							 - 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
							 - 1.0/2 * GHPLs3[1*4*4+1*4+1]
							 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -2) * pow(v, 2) * (
								 - 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
								 + 1.0/2 * GHPLs3[1*4*4+2*4+2]
								 - 3.0/8 * GHPLs1[2] * HPLs1[0]
								 - 1.0/2 * GHPLs3[1*4*4+0*4+2]
								 + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
								 - 1.0/2 * GHPLs3[1*4*4+1*4+2]
								 - 3.0/8 * GHPLs2[2*4+1]
								 + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
								 - 3.0/4 * GHPLs3[1*4*4+2*4+1]
								 - 277.0/144 * GHPLs1[1]
								 + 1.0/4 * GHPLs1[1] * zeta2
								 - 13.0/24 * GHPLs1[1] * HPLs1[0]
								 + 3.0/8 * GHPLs1[1] * HPLs1[1]
								 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
								 + 1.0/4 * GHPLs3[1*4*4+0*4+1]
								 - 1.0/2 * GHPLs3[2*4*4+1*4+1]
								 + 13.0/24 * GHPLs2[1*4+1]
								 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
								 + 1.0/2 * GHPLs3[1*4*4+1*4+1]
								 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -1) * (
						     - 1.0/8 * GHPLs1[1]
						     )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -1) * v * (
							 + 277.0/144
							 - 1.0/4 * zeta2
							 - 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
							 + 1.0/2 * GHPLs3[1*4*4+2*4+2]
							 + 3.0/8 * GHPLs1[2]
							 - 3.0/8 * GHPLs1[2] * HPLs1[0]
							 - 1.0/2 * GHPLs3[1*4*4+0*4+2]
							 + 1.0/2 * GHPLs2[1*4+2]
							 + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
							 - 1.0/2 * GHPLs3[1*4*4+1*4+2]
							 + 1.0/8 * GHPLs2[2*4+1]
							 + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							 - 3.0/4 * GHPLs3[1*4*4+2*4+1]
							 - 337.0/144 * GHPLs1[1]
							 + 1.0/4 * GHPLs1[1] * zeta2
							 - 13.0/24 * GHPLs1[1] * HPLs1[0]
							 - 1.0/8 * GHPLs1[1] * HPLs1[1]
							 - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							 + 1.0/4 * GHPLs3[1*4*4+0*4+1]
							 - 1.0/2 * GHPLs3[2*4*4+1*4+1]
							 + 1.0/24 * GHPLs2[1*4+1]
							 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
							 + 1.0/2 * GHPLs3[1*4*4+1*4+1]
							 + 11.0/12 * HPLs1[0]
							 - 3.0/8 * HPLs1[1]
							 + 1.0/4 * HPLs2[0*2+1]
							 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(u, -1) * pow(v, 2) * (
								 - 277.0/144
								 + 1.0/4 * zeta2
								 - 3.0/8 * GHPLs1[2]
								 + 1.0/4 * GHPLs1[2] * HPLs1[0]
								 - 3.0/4 * GHPLs2[1*4+2]
								 + 1.0/4 * GHPLs2[1*4+0]
								 - 1.0/2 * GHPLs2[2*4+1]
								 + 5.0/12 * GHPLs1[1]
								 + 1.0/2 * GHPLs1[1] * HPLs1[1]
								 + 1.0/2 * GHPLs2[1*4+1]
								 - 13.0/24 * HPLs1[0]
								 + 3.0/8 * HPLs1[1]
								 - 1.0/4 * HPLs2[0*2+1]
								 )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(1. - v, -1) * (
							  - 1.0/8 * GHPLs1[2] * HPLs1[0]
							  + 1.0/8 * GHPLs2[1*4+2]
							  - 1.0/8 * GHPLs2[1*4+0]
							  + 1.0/8 * GHPLs1[1]
							  - 3.0/16 * HPLs1[0]
							  )

    + (dN_c * dN_c - 1.) * ri * M_PI * (
					- 1.0/8
					+ 1.0/8 * GHPLs1[2] * HPLs1[0]
					- 1.0/8 * GHPLs2[1*4+2]
					+ 1.0/8 * GHPLs2[1*4+0]
					+ 3.0/16 * HPLs1[0]
					)

    + (dN_c * dN_c - 1.) * ri * M_PI * v * pow(1. - u, -1) * (
							      - 301.0/288
							      + 1.0/8 * zeta2
							      + 1.0/16 * GHPLs1[2]
							      + 1.0/8 * GHPLs1[2] * HPLs1[0]
							      - 3.0/8 * GHPLs2[1*4+2]
							      + 1.0/8 * GHPLs2[1*4+0]
							      - 1.0/4 * GHPLs2[2*4+1]
							      + 7.0/48 * GHPLs1[1]
							      + 1.0/4 * GHPLs1[1] * HPLs1[1]
							      + 1.0/4 * GHPLs2[1*4+1]
							      - 13.0/48 * HPLs1[0]
							      - 1.0/16 * HPLs1[1]
							      - 1.0/8 * HPLs2[0*2+1]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(v, 2) * pow(1. - u, -2) * (
								      + 355.0/288
								      - 1.0/8 * zeta2
								      - 1.0/16 * GHPLs1[2]
								      - 1.0/8 * GHPLs1[2] * HPLs1[0]
								      + 3.0/8 * GHPLs2[1*4+2]
								      - 1.0/8 * GHPLs2[1*4+0]
								      + 1.0/4 * GHPLs2[2*4+1]
								      - 1.0/48 * GHPLs1[1]
								      - 1.0/4 * GHPLs1[1] * HPLs1[1]
								      - 1.0/4 * GHPLs2[1*4+1]
								      + 13.0/48 * HPLs1[0]
								      + 1.0/16 * HPLs1[1]
								      + 1.0/8 * HPLs2[0*2+1]
								      )

    + (dN_c * dN_c - 1.) * ri * M_PI * pow(v, 2) * pow(1. - u, -1) * (
								      - 277.0/144
								      + 1.0/4 * zeta2
								      - 3.0/8 * GHPLs1[2]
								      + 1.0/4 * GHPLs1[2] * HPLs1[0]
								      - 3.0/4 * GHPLs2[1*4+2]
								      + 1.0/4 * GHPLs2[1*4+0]
								      - 1.0/2 * GHPLs2[2*4+1]
								      + 5.0/12 * GHPLs1[1]
								      + 1.0/2 * GHPLs1[1] * HPLs1[1]
								      + 1.0/2 * GHPLs2[1*4+1]
								      - 13.0/24 * HPLs1[0]
								      + 3.0/8 * HPLs1[1]
								      - 1.0/4 * HPLs2[0*2+1]
								      )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - v, -2) * (
							      - 1.0/8 * GHPLs1[2] * HPLs1[0]
							      + 1.0/8 * GHPLs2[1*4+2]
							      - 1.0/8 * GHPLs2[1*4+0]
							      - 3.0/16 * HPLs1[0]
							      )

    + (dN_c * dN_c - 1.) * ri * M_PI * u * pow(1. - v, -1) * (
							      - 1.0/16
							      + 1.0/8 * GHPLs1[2] * HPLs1[0]
							      - 1.0/8 * GHPLs2[1*4+2]
							      + 1.0/8 * GHPLs2[1*4+0]
							      - 1.0/8 * GHPLs1[1]
							      + 3.0/16 * HPLs1[0]
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(1. - u - v, -1) * (
									       - 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
									       + 1.0/8 * GHPLs3[0*4*4+2*4+3]
									       - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
									       + 1.0/8 * GHPLs3[0*4*4+3*4+3]
									       - 7.0/8 * GHPLs1[3] * zeta2
									       + 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
									       + 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
									       + 1.0/8 * GHPLs3[2*4*4+0*4+3]
									       - 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
									       + 1.0/8 * GHPLs3[0*4*4+2*4+1]
									       - GHPLs1[1] * zeta2
									       + 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
									       + 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
									       + 1.0/8 * GHPLs3[2*4*4+0*4+1]
									       - 1.0/8 * GHPLs2[0*4+1] * HPLs1[0]
									       - 1.0/8 * GHPLs2[0*4+1] * HPLs1[1]
									       + 1.0/8 * GHPLs3[2*4*4+1*4+1]
									       - 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
									       - 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
									       )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * (
							 + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
							 - 1.0/8 * GHPLs3[0*4*4+2*4+3]
							 + 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
							 - 1.0/8 * GHPLs3[0*4*4+3*4+3]
							 + 7.0/8 * GHPLs1[3] * zeta2
							 - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
							 - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
							 - 1.0/8 * GHPLs3[2*4*4+0*4+3]
							 + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
							 - 1.0/8 * GHPLs3[0*4*4+2*4+1]
							 + GHPLs1[1] * zeta2
							 - 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
							 - 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
							 - 1.0/8 * GHPLs3[2*4*4+0*4+1]
							 + 1.0/8 * GHPLs2[0*4+1] * HPLs1[0]
							 + 1.0/8 * GHPLs2[0*4+1] * HPLs1[1]
							 - 1.0/8 * GHPLs3[2*4*4+1*4+1]
							 + 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
							 + 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
							 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * v * (
							     + 7.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							     - 7.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							     - 7.0/4 * GHPLs2[2*4+2] * zeta2
							     + 5.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							     + 5.0/4 * GHPLs2[2*4+2] * HPLs2[1*2+0]
							     - 1.0/2 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							     - 1.0/2 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
							     - 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
							     - 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
							     + 1.0/2 * GHPLs3[3*4*4+3*4+2] * HPLs1[0]
							     - 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+2]
							     + 1.0/2 * GHPLs2[3*4+2] * zeta2
							     - 3.0/2 * GHPLs1[2] * zeta2
							     + 3.0/4 * GHPLs1[2] * zeta3
							     + 11.0/16 * GHPLs1[2] * HPLs1[0]
							     - 11.0/2 * GHPLs1[2] * HPLs1[0] * zeta2
							     + 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							     + 7.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							     + 1.0/2 * GHPLs1[2] * HPLs3[1*2*2+0*2+0]
							     + 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							     + 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							     + 5.0/4 * GHPLs1[2] * HPLs1[1] * zeta2
							     - 9.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							     - 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							     - 5.0/4 * GHPLs1[2] * HPLs3[1*2*2+0*2+1]
							     - 7.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							     + 7.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							     + 5.0/4 * GHPLs2[0*4+2] * zeta2
							     - 3.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							     - 5.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							     - 5.0/4 * GHPLs2[0*4+2] * HPLs2[1*2+0]
							     - 5.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
							     + 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
							     + 3.0/8 * GHPLs3[2*4*4+1*4+2]
							     - 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
							     + GHPLs2[1*4+2] * zeta2
							     - 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							     - 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
							     - 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							     + 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
							     - 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
							     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
							     + 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
							     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
							     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
							     + 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
							     - 1.0/8 * GHPLs3[0*4*4+3*4+3]
							     + 7.0/8 * GHPLs1[3] * zeta2
							     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
							     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
							     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
							     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
							     - 7.0/4 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs4[0*4*4*4+2*4*4+2*4+1]
							     + 5.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							     + 11.0/16 * GHPLs2[2*4+1]
							     - 5 * GHPLs2[2*4+1] * zeta2
							     + 7.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							     + 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
							     + 3.0/2 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							     + 5.0/4 * GHPLs4[2*4*4*4+0*4*4+2*4+1]
							     - 7.0/8 * GHPLs3[0*4*4+2*4+1]
							     - 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[1]
							     - 3.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
							     + 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
							     + 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
							     + 25.0/4 * GHPLs1[1] * zeta2
							     + GHPLs1[1] * zeta3
							     - 11.0/16 * GHPLs1[1] * HPLs1[0]
							     + 6 * GHPLs1[1] * HPLs1[0] * zeta2
							     - 1.0/2 * GHPLs1[1] * HPLs2[0*2+0]
							     - 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							     - 1.0/2 * GHPLs1[1] * HPLs3[1*2*2+0*2+0]
							     - 1.0/2 * GHPLs1[1] * HPLs2[1*2+0]
							     - 5.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							     - 11.0/16 * GHPLs1[1] * HPLs1[1]
							     + 5 * GHPLs1[1] * HPLs1[1] * zeta2
							     - 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							     - 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
							     - 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							     + 5.0/4 * GHPLs4[2*4*4*4+2*4*4+0*4+1]
							     - 7.0/8 * GHPLs3[2*4*4+0*4+1]
							     - GHPLs3[2*4*4+0*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[1]
							     + 5.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							     - 15.0/4 * GHPLs2[0*4+1] * zeta2
							     + 7.0/8 * GHPLs2[0*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							     + 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+0]
							     + 7.0/8 * GHPLs2[0*4+1] * HPLs1[1]
							     + 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							     + 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+1]
							     + 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
							     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
							     - 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
							     - 7.0/4 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
							     - 1.0/2 * GHPLs3[2*4*4+1*4+1]
							     + 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
							     + 7.0/4 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
							     + 5.0/4 * GHPLs4[0*4*4*4+2*4*4+1*4+1]
							     - 3.0/4 * GHPLs2[1*4+1] * zeta2
							     + 1.0/2 * GHPLs2[1*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+0]
							     + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
							     - 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
							     - 7.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+1]
							     + 5.0/4 * GHPLs4[2*4*4*4+0*4*4+1*4+1]
							     - 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[1]
							     - 3.0/4 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
							     + 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
							     + 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 2) * (
								     - 7.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
								     + 7.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
								     + 7.0/4 * GHPLs2[2*4+2] * zeta2
								     - 5.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
								     - 5.0/4 * GHPLs2[2*4+2] * HPLs2[1*2+0]
								     + 1.0/2 * GHPLs2[2*4+2] * HPLs2[0*2+1]
								     + 1.0/2 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
								     - 5.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
								     + 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
								     + 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
								     - 1.0/2 * GHPLs3[3*4*4+3*4+2] * HPLs1[0]
								     + 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+2]
								     - 1.0/2 * GHPLs2[3*4+2] * zeta2
								     + 7.0/4 * GHPLs1[2] * zeta2
								     - 3.0/4 * GHPLs1[2] * zeta3
								     - 15.0/16 * GHPLs1[2] * HPLs1[0]
								     + 11.0/2 * GHPLs1[2] * HPLs1[0] * zeta2
								     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     - 7.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
								     - 1.0/2 * GHPLs1[2] * HPLs3[1*2*2+0*2+0]
								     - 5.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     - 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
								     - 5.0/4 * GHPLs1[2] * HPLs1[1] * zeta2
								     + 9.0/8 * GHPLs1[2] * HPLs2[0*2+1]
								     + 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
								     + 5.0/4 * GHPLs1[2] * HPLs3[1*2*2+0*2+1]
								     + 7.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
								     - 7.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
								     - 5.0/4 * GHPLs2[0*4+2] * zeta2
								     + 1.0/2 * GHPLs2[0*4+2] * HPLs1[0]
								     + 5.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
								     + 5.0/4 * GHPLs2[0*4+2] * HPLs2[1*2+0]
								     + 5.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
								     - 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
								     - 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
								     - 5.0/8 * GHPLs3[2*4*4+1*4+2]
								     + 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
								     - GHPLs2[1*4+2] * zeta2
								     + 5.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     + 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
								     + 5.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     - 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
								     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
								     - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
								     - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     + 5.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     - 5.0/8 * GHPLs3[0*4*4+3*4+3]
								     + 11.0/8 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     + 7.0/4 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
								     - 5.0/4 * GHPLs4[0*4*4*4+2*4*4+2*4+1]
								     - 5.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
								     + 5.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
								     - 15.0/16 * GHPLs2[2*4+1]
								     + 5 * GHPLs2[2*4+1] * zeta2
								     - 7.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
								     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
								     - 3.0/2 * GHPLs2[2*4+1] * HPLs2[0*2+1]
								     - 5.0/4 * GHPLs4[2*4*4*4+0*4*4+2*4+1]
								     + 3.0/8 * GHPLs3[0*4*4+2*4+1]
								     + 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
								     + 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[1]
								     + 3.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
								     - 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
								     - 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
								     - 9.0/4 * GHPLs1[1] * zeta2
								     - GHPLs1[1] * zeta3
								     + 15.0/16 * GHPLs1[1] * HPLs1[0]
								     - 6 * GHPLs1[1] * HPLs1[0] * zeta2
								     + 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
								     + 1.0/2 * GHPLs1[1] * HPLs3[1*2*2+0*2+0]
								     + 5.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
								     + 15.0/16 * GHPLs1[1] * HPLs1[1]
								     - 5 * GHPLs1[1] * HPLs1[1] * zeta2
								     + 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
								     + 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
								     + 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
								     - 5.0/4 * GHPLs4[2*4*4*4+2*4*4+0*4+1]
								     + 3.0/8 * GHPLs3[2*4*4+0*4+1]
								     + GHPLs3[2*4*4+0*4+1] * HPLs1[0]
								     + 5.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[1]
								     - 5.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
								     + 5.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
								     + 15.0/4 * GHPLs2[0*4+1] * zeta2
								     - 3.0/8 * GHPLs2[0*4+1] * HPLs1[0]
								     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
								     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+0]
								     - 3.0/8 * GHPLs2[0*4+1] * HPLs1[1]
								     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
								     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+1]
								     - 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
								     + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
								     + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
								     + 7.0/4 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
								     - 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
								     - 7.0/4 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
								     - 5.0/4 * GHPLs4[0*4*4*4+2*4*4+1*4+1]
								     + 3.0/4 * GHPLs2[1*4+1] * zeta2
								     + 5.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+0]
								     + 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
								     + 7.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+1]
								     - 5.0/4 * GHPLs4[2*4*4*4+0*4*4+1*4+1]
								     + 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[0]
								     + 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[1]
								     + 3.0/4 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
								     - 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
								     - 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 3) * (
								     - 1.0/8 * GHPLs1[2] * zeta2
								     + 1.0/8 * GHPLs1[2] * HPLs1[0]
								     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     + 5.0/8 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+1]
								     - 1.0/8 * GHPLs1[1] * HPLs1[0]
								     - 1.0/8 * GHPLs1[1] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -2) * pow(v, 4) * (
								     - 1.0/8 * GHPLs1[2] * zeta2
								     - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     + 1.0/8 * GHPLs3[2*4*4+1*4+2]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
								     - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     + 1.0/8 * GHPLs3[0*4*4+3*4+3]
								     + 5.0/8 * GHPLs1[3] * zeta2
								     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
								     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(1. - u - v, -1) * (
									       - 1.0/8 * zeta2
									       + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
									       - 1.0/8 * GHPLs3[0*4*4+2*4+3]
									       + 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
									       - 1.0/8 * GHPLs3[0*4*4+3*4+3]
									       + 7.0/8 * GHPLs1[3] * zeta2
									       + 1.0/8 * GHPLs1[3] * HPLs1[0]
									       - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
									       - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
									       - 1.0/8 * GHPLs3[2*4*4+0*4+3]
									       - 1.0/8 * GHPLs2[0*4+3]
									       + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
									       - 1.0/8 * GHPLs1[0] * HPLs1[0]
									       - 1.0/8 * GHPLs3[0*4*4+2*4+1]
									       + GHPLs1[1] * zeta2
									       - 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
									       - 1.0/8 * GHPLs1[1] * HPLs2[1*2+0]
									       - 1.0/8 * GHPLs3[2*4*4+0*4+1]
									       + 1.0/8 * GHPLs2[0*4+1] * HPLs1[0]
									       + 1.0/8 * GHPLs2[0*4+1] * HPLs1[1]
									       - 1.0/8 * GHPLs3[2*4*4+1*4+1]
									       + 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
									       + 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
									       + 1.0/8 * HPLs2[0*2+0]
									       - 1.0/8 * HPLs2[0*2+1]
									       )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * (
							 + 1.0/8 * zeta2
							 - 1.0/4 * GHPLs1[2] * HPLs1[0]
							 - 1.0/8 * GHPLs1[3] * HPLs1[0]
							 + 1.0/8 * GHPLs2[0*4+3]
							 + 1.0/8 * GHPLs1[0] * HPLs1[0]
							 - 1.0/4 * GHPLs2[2*4+1]
							 + 1.0/4 * GHPLs1[1] * HPLs1[0]
							 + 1.0/4 * GHPLs1[1] * HPLs1[1]
							 - 1.0/8 * HPLs2[0*2+0]
							 + 1.0/8 * HPLs2[0*2+1]
							 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * v * (
							     - 1.0/2
							     + 47.0/8 * zeta2
							     + 7.0/4 * zeta3
							     - 7.0/4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
							     + 7.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
							     - 5.0/4 * GHPLs2[2*4+2]
							     + 7.0/4 * GHPLs2[2*4+2] * zeta2
							     - 3.0/2 * GHPLs2[2*4+2] * HPLs1[0]
							     - 5.0/4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
							     - 5.0/4 * GHPLs2[2*4+2] * HPLs2[1*2+0]
							     + 1.0/2 * GHPLs2[2*4+2] * HPLs2[0*2+1]
							     + 5.0/4 * GHPLs3[0*4*4+2*4+2]
							     + 1.0/2 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
							     - 5.0/4 * GHPLs4[2*4*4*4+1*4*4+2*4+2]
							     + 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs3[1*4*4+2*4+2] * HPLs1[1]
							     - 1.0/2 * GHPLs3[3*4*4+3*4+2] * HPLs1[0]
							     + 1.0/2 * GHPLs4[0*4*4*4+3*4*4+3*4+2]
							     - 1.0/2 * GHPLs2[3*4+2] * zeta2
							     + 3 * GHPLs2[3*4+2] * HPLs1[0]
							     - 3 * GHPLs3[0*4*4+3*4+2]
							     + 23.0/16 * GHPLs1[2]
							     - 5 * GHPLs1[2] * zeta2
							     - 3.0/4 * GHPLs1[2] * zeta3
							     + 7.0/16 * GHPLs1[2] * HPLs1[0]
							     + 11.0/2 * GHPLs1[2] * HPLs1[0] * zeta2
							     + 21.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							     - 7.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
							     - 1.0/2 * GHPLs1[2] * HPLs3[1*2*2+0*2+0]
							     + 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							     - 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
							     + 5.0/4 * GHPLs1[2] * HPLs1[1]
							     - 5.0/4 * GHPLs1[2] * HPLs1[1] * zeta2
							     + 13.0/8 * GHPLs1[2] * HPLs2[0*2+1]
							     + 5.0/4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
							     + 5.0/4 * GHPLs1[2] * HPLs3[1*2*2+0*2+1]
							     + 5.0/4 * GHPLs3[2*4*4+0*4+2]
							     + 7.0/4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
							     - 7.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
							     - 3.0/4 * GHPLs2[0*4+2]
							     - 5.0/4 * GHPLs2[0*4+2] * zeta2
							     - 3.0/2 * GHPLs2[0*4+2] * HPLs1[0]
							     + 5.0/4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
							     + 5.0/4 * GHPLs2[0*4+2] * HPLs2[1*2+0]
							     - 5.0/4 * GHPLs2[0*4+2] * HPLs1[1]
							     + 5.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+2]
							     - 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[0]
							     - 5.0/4 * GHPLs3[1*4*4+0*4+2] * HPLs1[1]
							     - 9.0/8 * GHPLs3[2*4*4+1*4+2]
							     + 1.0/4 * GHPLs3[2*4*4+1*4+2] * HPLs1[0]
							     - GHPLs2[1*4+2] * zeta2
							     + 9.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							     + 1.0/4 * GHPLs2[1*4+2] * HPLs2[1*2+0]
							     + 9.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							     - 1.0/4 * GHPLs2[1*4+2] * HPLs2[0*2+1]
							     + 1.0/2 * GHPLs4[2*4*4*4+1*4*4+1*4+2]
							     - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[0]
							     - 1.0/2 * GHPLs3[1*4*4+1*4+2] * HPLs1[1]
							     + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
							     - 1.0/8 * GHPLs3[0*4*4+2*4+3]
							     + 5.0/8 * GHPLs2[3*4+3] * HPLs1[0]
							     - 5.0/8 * GHPLs3[0*4*4+3*4+3]
							     + 11.0/8 * GHPLs1[3] * zeta2
							     - 1.0/8 * GHPLs1[3] * HPLs1[0]
							     - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
							     - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
							     - 1.0/8 * GHPLs3[2*4*4+0*4+3]
							     + 1.0/8 * GHPLs2[0*4+3]
							     + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
							     + 5.0/4 * GHPLs3[2*4*4+2*4+0]
							     - 3.0/4 * GHPLs2[2*4+0]
							     - 1.0/2 * GHPLs2[2*4+0] * HPLs1[0]
							     - 5.0/4 * GHPLs2[2*4+0] * HPLs1[1]
							     - 1.0/2 * GHPLs2[3*4+0] * HPLs1[0]
							     + 1.0/2 * GHPLs3[0*4*4+3*4+0]
							     - 5.0/2 * GHPLs1[0] * zeta2
							     + 1.0/8 * GHPLs1[0] * HPLs1[0]
							     + 3.0/4 * GHPLs1[0] * HPLs1[1]
							     + 5.0/4 * GHPLs1[0] * HPLs2[0*2+1]
							     + 5.0/4 * GHPLs1[0] * HPLs2[1*2+1]
							     - 1.0/2 * GHPLs3[2*4*4+1*4+0]
							     + 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
							     + 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
							     - 3.0/2 * GHPLs3[2*4*4+2*4+1]
							     + 7.0/4 * GHPLs3[2*4*4+2*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs4[0*4*4*4+2*4*4+2*4+1]
							     - 5.0/4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
							     + 7.0/16 * GHPLs2[2*4+1]
							     + 5 * GHPLs2[2*4+1] * zeta2
							     + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
							     - 7.0/4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
							     - 1.0/4 * GHPLs2[2*4+1] * HPLs2[1*2+0]
							     + 3.0/2 * GHPLs2[2*4+1] * HPLs1[1]
							     - 3.0/2 * GHPLs2[2*4+1] * HPLs2[0*2+1]
							     - 5.0/4 * GHPLs4[2*4*4*4+0*4*4+2*4+1]
							     + 11.0/8 * GHPLs3[0*4*4+2*4+1]
							     + 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs3[0*4*4+2*4+1] * HPLs1[1]
							     + 3.0/2 * GHPLs4[2*4*4*4+1*4*4+2*4+1]
							     - 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[0]
							     - 3.0/2 * GHPLs3[1*4*4+2*4+1] * HPLs1[1]
							     - 9.0/4 * GHPLs1[1] * zeta2
							     - GHPLs1[1] * zeta3
							     - 7.0/16 * GHPLs1[1] * HPLs1[0]
							     - 6 * GHPLs1[1] * HPLs1[0] * zeta2
							     + 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
							     + 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
							     + 1.0/2 * GHPLs1[1] * HPLs3[1*2*2+0*2+0]
							     - GHPLs1[1] * HPLs2[1*2+0]
							     + 5.0/4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
							     - 7.0/16 * GHPLs1[1] * HPLs1[1]
							     - 5 * GHPLs1[1] * HPLs1[1] * zeta2
							     - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
							     + 7.0/4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
							     + 1.0/4 * GHPLs1[1] * HPLs3[1*2*2+0*2+1]
							     - 3.0/2 * GHPLs1[1] * HPLs2[1*2+1]
							     + 3.0/2 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
							     - 5.0/4 * GHPLs4[2*4*4*4+2*4*4+0*4+1]
							     + 11.0/8 * GHPLs3[2*4*4+0*4+1]
							     + GHPLs3[2*4*4+0*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs3[2*4*4+0*4+1] * HPLs1[1]
							     - 5.0/4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
							     + 15.0/4 * GHPLs2[0*4+1] * zeta2
							     - 11.0/8 * GHPLs2[0*4+1] * HPLs1[0]
							     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
							     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+0]
							     - 11.0/8 * GHPLs2[0*4+1] * HPLs1[1]
							     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
							     - 5.0/4 * GHPLs2[0*4+1] * HPLs2[1*2+1]
							     - 1.0/4 * GHPLs4[2*4*4*4+1*4*4+0*4+1]
							     + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[0]
							     + 1.0/4 * GHPLs3[1*4*4+0*4+1] * HPLs1[1]
							     + 7.0/4 * GHPLs4[2*4*4*4+2*4*4+1*4+1]
							     - 3.0/4 * GHPLs3[2*4*4+1*4+1]
							     - 1.0/2 * GHPLs3[2*4*4+1*4+1] * HPLs1[0]
							     - 7.0/4 * GHPLs3[2*4*4+1*4+1] * HPLs1[1]
							     - 5.0/4 * GHPLs4[0*4*4*4+2*4*4+1*4+1]
							     + 3.0/4 * GHPLs2[1*4+1] * zeta2
							     + 3.0/4 * GHPLs2[1*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+0]
							     + 3.0/4 * GHPLs2[1*4+1] * HPLs1[1]
							     + 1.0/2 * GHPLs2[1*4+1] * HPLs2[0*2+1]
							     + 7.0/4 * GHPLs2[1*4+1] * HPLs2[1*2+1]
							     - 5.0/4 * GHPLs4[2*4*4*4+0*4*4+1*4+1]
							     + 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[0]
							     + 5.0/4 * GHPLs3[0*4*4+1*4+1] * HPLs1[1]
							     + 3.0/4 * GHPLs4[2*4*4*4+1*4*4+1*4+1]
							     - 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[0]
							     - 3.0/4 * GHPLs3[1*4*4+1*4+1] * HPLs1[1]
							     + 1.0/2 * HPLs1[0] * zeta2
							     - 1.0/8 * HPLs2[0*2+0]
							     - 23.0/16 * HPLs1[1]
							     + 25.0/4 * HPLs1[1] * zeta2
							     - 9.0/4 * HPLs2[0*2+1]
							     - 3 * HPLs3[0*2*2+0*2+1]
							     - 3.0/2 * HPLs3[1*2*2+0*2+1]
							     - 5.0/4 * HPLs2[1*2+1]
							     - 3.0/2 * HPLs3[0*2*2+1*2+1]
							     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(v, 2) * (
								     - 51.0/8 * zeta2
								     - zeta3
								     + 5.0/4 * GHPLs2[2*4+2]
								     + 3.0/2 * GHPLs2[2*4+2] * HPLs1[0]
								     - 5.0/4 * GHPLs3[0*4*4+2*4+2]
								     - 5.0/4 * GHPLs2[3*4+2] * HPLs1[0]
								     + 5.0/4 * GHPLs3[0*4*4+3*4+2]
								     - 23.0/16 * GHPLs1[2]
								     + 5 * GHPLs1[2] * zeta2
								     - 3.0/4 * GHPLs1[2] * HPLs1[0]
								     - 7.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								     + 1.0/4 * GHPLs1[2] * HPLs2[1*2+0]
								     - 5.0/4 * GHPLs1[2] * HPLs1[1]
								     - GHPLs1[2] * HPLs2[0*2+1]
								     - 5.0/4 * GHPLs3[2*4*4+0*4+2]
								     + 1.0/2 * GHPLs2[0*4+2]
								     + 7.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								     + 5.0/4 * GHPLs2[0*4+2] * HPLs1[1]
								     + 7.0/4 * GHPLs3[2*4*4+1*4+2]
								     - 7.0/4 * GHPLs2[1*4+2] * HPLs1[0]
								     - 7.0/4 * GHPLs2[1*4+2] * HPLs1[1]
								     + 1.0/4 * GHPLs2[2*4+3] * HPLs1[0]
								     - 1.0/4 * GHPLs3[0*4*4+2*4+3]
								     - 1.0/4 * GHPLs2[3*4+3] * HPLs1[0]
								     + 1.0/4 * GHPLs3[0*4*4+3*4+3]
								     + 5.0/4 * GHPLs1[3] * zeta2
								     + 11.0/8 * GHPLs1[3] * HPLs1[0]
								     - 1.0/4 * GHPLs1[3] * HPLs2[1*2+0]
								     - 1.0/4 * GHPLs1[3] * HPLs2[0*2+1]
								     - 1.0/4 * GHPLs3[2*4*4+0*4+3]
								     - 11.0/8 * GHPLs2[0*4+3]
								     + 1.0/4 * GHPLs2[0*4+3] * HPLs1[1]
								     - 5.0/4 * GHPLs3[2*4*4+2*4+0]
								     + 1.0/2 * GHPLs2[2*4+0]
								     + 3.0/4 * GHPLs2[2*4+0] * HPLs1[0]
								     + 5.0/4 * GHPLs2[2*4+0] * HPLs1[1]
								     - 5.0/4 * GHPLs2[3*4+0] * HPLs1[0]
								     + 5.0/4 * GHPLs3[0*4*4+3*4+0]
								     + 15.0/4 * GHPLs1[0] * zeta2
								     - 5.0/8 * GHPLs1[0] * HPLs1[0]
								     - 5.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								     - 5.0/4 * GHPLs1[0] * HPLs2[1*2+0]
								     - 1.0/2 * GHPLs1[0] * HPLs1[1]
								     - 5.0/4 * GHPLs1[0] * HPLs2[0*2+1]
								     - 5.0/4 * GHPLs1[0] * HPLs2[1*2+1]
								     - 1.0/2 * GHPLs3[2*4*4+1*4+0]
								     + 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
								     + 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
								     + 3.0/2 * GHPLs3[2*4*4+2*4+1]
								     + 3.0/8 * GHPLs2[2*4+1]
								     - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
								     - 3.0/2 * GHPLs2[2*4+1] * HPLs1[1]
								     - GHPLs3[0*4*4+2*4+1]
								     - 3.0/8 * GHPLs1[1] * HPLs1[0]
								     - 1.0/4 * GHPLs1[1] * HPLs2[0*2+0]
								     + GHPLs1[1] * HPLs2[1*2+0]
								     - 3.0/8 * GHPLs1[1] * HPLs1[1]
								     + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
								     + 3.0/2 * GHPLs1[1] * HPLs2[1*2+1]
								     - GHPLs3[2*4*4+0*4+1]
								     + GHPLs2[0*4+1] * HPLs1[0]
								     + GHPLs2[0*4+1] * HPLs1[1]
								     + 3.0/4 * GHPLs3[2*4*4+1*4+1]
								     - 3.0/4 * GHPLs2[1*4+1] * HPLs1[0]
								     - 3.0/4 * GHPLs2[1*4+1] * HPLs1[1]
								     + 23.0/16 * HPLs1[0]
								     - 6 * HPLs1[0] * zeta2
								     + 3.0/2 * HPLs2[0*2+0]
								     + 7.0/4 * HPLs3[0*2*2+0*2+0]
								     + 1.0/2 * HPLs3[1*2*2+0*2+0]
								     + 9.0/8 * HPLs2[1*2+0]
								     + 5.0/4 * HPLs3[0*2*2+1*2+0]
								     + 23.0/16 * HPLs1[1]
								     - 5 * HPLs1[1] * zeta2
								     + 11.0/8 * HPLs2[0*2+1]
								     + 7.0/4 * HPLs3[0*2*2+0*2+1]
								     + 1.0/4 * HPLs3[1*2*2+0*2+1]
								     + 5.0/4 * HPLs2[1*2+1]
								     + 3.0/2 * HPLs3[0*2*2+1*2+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, -1) * pow(v, 3) * (
								     - 1.0/2 * zeta2
								     - 3.0/8 * GHPLs1[2] * zeta2
								     - 1.0/8 * GHPLs1[2] * HPLs1[0]
								     - 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								     + 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
								     + 1.0/8 * GHPLs2[0*4+2]
								     + 3.0/8 * GHPLs2[0*4+2] * HPLs1[0]
								     + 3.0/8 * GHPLs3[2*4*4+1*4+2]
								     - 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
								     - 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
								     + 3.0/8 * GHPLs2[2*4+3] * HPLs1[0]
								     - 3.0/8 * GHPLs3[0*4*4+2*4+3]
								     - 3.0/8 * GHPLs2[3*4+3] * HPLs1[0]
								     + 3.0/8 * GHPLs3[0*4*4+3*4+3]
								     + 15.0/8 * GHPLs1[3] * zeta2
								     + 1.0/8 * GHPLs1[3] * HPLs1[0]
								     - 3.0/8 * GHPLs1[3] * HPLs2[1*2+0]
								     - 3.0/8 * GHPLs1[3] * HPLs2[0*2+1]
								     - 3.0/8 * GHPLs3[2*4*4+0*4+3]
								     - 1.0/8 * GHPLs2[0*4+3]
								     + 3.0/8 * GHPLs2[0*4+3] * HPLs1[1]
								     + 1.0/8 * GHPLs2[2*4+0]
								     - 1.0/8 * GHPLs1[0] * HPLs1[0]
								     - 1.0/8 * GHPLs1[0] * HPLs1[1]
								     - 1.0/8 * GHPLs2[2*4+1]
								     + 1.0/8 * GHPLs1[1] * HPLs1[0]
								     + 1.0/8 * GHPLs1[1] * HPLs1[1]
								     + 1.0/8 * HPLs2[0*2+0]
								     + 1.0/8 * HPLs2[0*2+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(1. - v, -1) * (
							      + 15.0/16 * zeta2
							      - 3.0/8 * zeta3
							      - 7.0/8 * GHPLs2[3*4+2] * HPLs1[0]
							      + 7.0/8 * GHPLs3[0*4*4+3*4+2]
							      + 3.0/4 * GHPLs1[2] * zeta2
							      + 7.0/16 * GHPLs1[2] * HPLs1[0]
							      - 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							      - 1.0/2 * GHPLs1[2] * HPLs2[1*2+0]
							      + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
							      + 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
							      - 1.0/2 * GHPLs3[2*4*4+1*4+2]
							      + 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
							      + 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
							      - 1.0/2 * GHPLs1[3] * HPLs1[0]
							      + 1.0/2 * GHPLs2[0*4+3]
							      - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							      + 7.0/8 * GHPLs2[3*4+0] * HPLs1[0]
							      - 7.0/8 * GHPLs3[0*4*4+3*4+0]
							      - 5.0/8 * GHPLs1[0] * zeta2
							      + 3.0/8 * GHPLs1[0] * HPLs1[0]
							      + 5.0/8 * GHPLs1[0] * HPLs2[0*2+0]
							      + 5.0/8 * GHPLs1[0] * HPLs2[1*2+0]
							      + 1.0/2 * GHPLs3[2*4*4+1*4+0]
							      - 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
							      - 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
							      - 1.0/8 * GHPLs2[2*4+1]
							      + 1.0/8 * GHPLs1[1] * HPLs1[0]
							      + 1.0/8 * GHPLs1[1] * HPLs1[1]
							      - 19.0/32 * HPLs1[0]
							      + 11.0/4 * HPLs1[0] * zeta2
							      - 3.0/4 * HPLs2[0*2+0]
							      - 7.0/8 * HPLs3[0*2*2+0*2+0]
							      - 1.0/4 * HPLs3[1*2*2+0*2+0]
							      - 9.0/16 * HPLs2[1*2+0]
							      - 5.0/8 * HPLs3[0*2*2+1*2+0]
							      - 5.0/8 * HPLs1[1] * zeta2
							      + 3.0/8 * HPLs2[0*2+1]
							      + 5.0/8 * HPLs3[0*2*2+0*2+1]
							      + 5.0/8 * HPLs3[1*2*2+0*2+1]
							      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * (
					    - 1.0/2
					    - 13.0/16 * zeta2
					    + 3.0/8 * zeta3
					    + 7.0/8 * GHPLs2[3*4+2] * HPLs1[0]
					    - 7.0/8 * GHPLs3[0*4*4+3*4+2]
					    - 1.0/4 * GHPLs1[2]
					    - 3.0/4 * GHPLs1[2] * zeta2
					    + 1.0/16 * GHPLs1[2] * HPLs1[0]
					    + 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
					    + 1.0/2 * GHPLs1[2] * HPLs2[1*2+0]
					    - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
					    - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
					    + 1.0/2 * GHPLs3[2*4*4+1*4+2]
					    - 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
					    - 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
					    + 3.0/8 * GHPLs1[3] * HPLs1[0]
					    - 3.0/8 * GHPLs2[0*4+3]
					    + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
					    - 7.0/8 * GHPLs2[3*4+0] * HPLs1[0]
					    + 7.0/8 * GHPLs3[0*4*4+3*4+0]
					    + 5.0/8 * GHPLs1[0] * zeta2
					    - 1.0/4 * GHPLs1[0] * HPLs1[0]
					    - 5.0/8 * GHPLs1[0] * HPLs2[0*2+0]
					    - 5.0/8 * GHPLs1[0] * HPLs2[1*2+0]
					    - 1.0/2 * GHPLs3[2*4*4+1*4+0]
					    + 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
					    + 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
					    + 5.0/8 * GHPLs2[2*4+1]
					    - 5.0/8 * GHPLs1[1] * HPLs1[0]
					    - 5.0/8 * GHPLs1[1] * HPLs1[1]
					    + 19.0/32 * HPLs1[0]
					    - 11.0/4 * HPLs1[0] * zeta2
					    + 5.0/8 * HPLs2[0*2+0]
					    + 7.0/8 * HPLs3[0*2*2+0*2+0]
					    + 1.0/4 * HPLs3[1*2*2+0*2+0]
					    + 9.0/16 * HPLs2[1*2+0]
					    + 5.0/8 * HPLs3[0*2*2+1*2+0]
					    + 1.0/4 * HPLs1[1]
					    + 5.0/8 * HPLs1[1] * zeta2
					    - 1.0/4 * HPLs2[0*2+1]
					    - 5.0/8 * HPLs3[0*2*2+0*2+1]
					    - 5.0/8 * HPLs3[1*2*2+0*2+1]
					    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * pow(1. - u, -1) * (
								  + 17.0/32
								  + 21.0/16 * zeta2
								  + 5.0/16 * GHPLs2[2*4+2]
								  + 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
								  - 1.0/8 * GHPLs3[0*4*4+2*4+2]
								  - 1.0/8 * GHPLs2[3*4+2] * HPLs1[0]
								  + 1.0/8 * GHPLs3[0*4*4+3*4+2]
								  - 29.0/32 * GHPLs1[2]
								  + 5.0/8 * GHPLs1[2] * zeta2
								  - 1.0/4 * GHPLs1[2] * HPLs1[0]
								  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
								  - 5.0/16 * GHPLs1[2] * HPLs1[1]
								  - 1.0/8 * GHPLs3[2*4*4+0*4+2]
								  - 1.0/2 * GHPLs2[0*4+2]
								  + 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								  + 1.0/8 * GHPLs2[0*4+2] * HPLs1[1]
								  + 1.0/4 * GHPLs3[2*4*4+1*4+2]
								  - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
								  - 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
								  + 1.0/8 * GHPLs1[3] * HPLs1[0]
								  - 1.0/8 * GHPLs2[0*4+3]
								  - 1.0/8 * GHPLs3[2*4*4+2*4+0]
								  - 1.0/2 * GHPLs2[2*4+0]
								  + 1.0/8 * GHPLs2[2*4+0] * HPLs1[1]
								  - 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
								  + 1.0/8 * GHPLs3[0*4*4+3*4+0]
								  + 3.0/8 * GHPLs1[0]
								  + 1.0/8 * GHPLs1[0] * zeta2
								  + 3.0/8 * GHPLs1[0] * HPLs1[0]
								  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
								  - 1.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  + 1.0/2 * GHPLs1[0] * HPLs1[1]
								  - 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
								  - 1.0/8 * GHPLs1[0] * HPLs2[1*2+1]
								  - 1.0/8 * GHPLs3[2*4*4+1*4+0]
								  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
								  + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
								  + 1.0/4 * GHPLs3[2*4*4+2*4+1]
								  + 3.0/16 * GHPLs2[2*4+1]
								  - 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
								  - 1.0/4 * GHPLs2[2*4+1] * HPLs1[1]
								  - 1.0/4 * GHPLs1[1] * zeta2
								  - 3.0/16 * GHPLs1[1] * HPLs1[0]
								  - 3.0/16 * GHPLs1[1] * HPLs1[1]
								  + 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
								  + 1.0/4 * GHPLs1[1] * HPLs2[1*2+1]
								  - 1.0/4 * GHPLs3[2*4*4+1*4+1]
								  + 1.0/4 * GHPLs2[1*4+1] * HPLs1[0]
								  + 1.0/4 * GHPLs2[1*4+1] * HPLs1[1]
								  + 23.0/32 * HPLs1[0]
								  - 9.0/8 * HPLs1[0] * zeta2
								  + 3.0/8 * HPLs2[0*2+0]
								  + 1.0/4 * HPLs3[0*2*2+0*2+0]
								  + 1.0/8 * HPLs3[1*2*2+0*2+0]
								  + 7.0/16 * HPLs2[1*2+0]
								  - 1.0/8 * HPLs3[0*2*2+1*2+0]
								  + 29.0/32 * HPLs1[1]
								  - 5.0/8 * HPLs1[1] * zeta2
								  + 1.0/4 * HPLs3[0*2*2+0*2+1]
								  + 5.0/16 * HPLs2[1*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * v * (
						- 53.0/8 * zeta2
						- 1.0/2 * zeta3
						+ 1.0/2 * GHPLs2[2*4+2] * HPLs1[0]
						- 1.0/2 * GHPLs3[0*4*4+2*4+2]
						- 1.0/2 * GHPLs2[3*4+2] * HPLs1[0]
						+ 1.0/2 * GHPLs3[0*4*4+3*4+2]
						+ 3.0/8 * GHPLs1[2]
						+ 15.0/8 * GHPLs1[2] * zeta2
						- GHPLs1[2] * HPLs1[0]
						- 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						+ 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						- 1.0/2 * GHPLs1[2] * HPLs2[0*2+1]
						- 1.0/2 * GHPLs3[2*4*4+0*4+2]
						+ 13.0/8 * GHPLs2[0*4+2]
						+ 5.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						+ 1.0/2 * GHPLs2[0*4+2] * HPLs1[1]
						+ 5.0/8 * GHPLs3[2*4*4+1*4+2]
						- 5.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						- 5.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						+ 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
						- 1.0/8 * GHPLs3[0*4*4+2*4+3]
						- 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
						+ 1.0/8 * GHPLs3[0*4*4+3*4+3]
						+ 5.0/8 * GHPLs1[3] * zeta2
						+ 13.0/8 * GHPLs1[3] * HPLs1[0]
						- 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
						- 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
						- 1.0/8 * GHPLs3[2*4*4+0*4+3]
						- 13.0/8 * GHPLs2[0*4+3]
						+ 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
						- 1.0/2 * GHPLs3[2*4*4+2*4+0]
						+ 13.0/8 * GHPLs2[2*4+0]
						+ 3.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						+ 1.0/2 * GHPLs2[2*4+0] * HPLs1[1]
						- 1.0/2 * GHPLs2[3*4+0] * HPLs1[0]
						+ 1.0/2 * GHPLs3[0*4*4+3*4+0]
						+ 7.0/4 * GHPLs1[0] * zeta2
						- 2 * GHPLs1[0] * HPLs1[0]
						- 3.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						- 1.0/2 * GHPLs1[0] * HPLs2[1*2+0]
						- 13.0/8 * GHPLs1[0] * HPLs1[1]
						- 3.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						- 1.0/2 * GHPLs1[0] * HPLs2[1*2+1]
						- 1.0/8 * GHPLs3[2*4*4+1*4+0]
						+ 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						+ 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						+ 1.0/2 * GHPLs3[2*4*4+2*4+1]
						- 11.0/8 * GHPLs2[2*4+1]
						+ 1.0/8 * GHPLs2[2*4+1] * HPLs1[0]
						- 1.0/2 * GHPLs2[2*4+1] * HPLs1[1]
						- 1.0/2 * GHPLs3[0*4*4+2*4+1]
						+ 1.0/4 * GHPLs1[1] * zeta2
						+ 11.0/8 * GHPLs1[1] * HPLs1[0]
						- 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
						+ 1.0/2 * GHPLs1[1] * HPLs2[1*2+0]
						+ 11.0/8 * GHPLs1[1] * HPLs1[1]
						- 1.0/8 * GHPLs1[1] * HPLs2[0*2+1]
						+ 1.0/2 * GHPLs1[1] * HPLs2[1*2+1]
						- 1.0/2 * GHPLs3[2*4*4+0*4+1]
						+ 1.0/2 * GHPLs2[0*4+1] * HPLs1[0]
						+ 1.0/2 * GHPLs2[0*4+1] * HPLs1[1]
						+ 5.0/8 * GHPLs3[2*4*4+1*4+1]
						- 5.0/8 * GHPLs2[1*4+1] * HPLs1[0]
						- 5.0/8 * GHPLs2[1*4+1] * HPLs1[1]
						- 3.0/8 * HPLs1[0]
						- 15.0/8 * HPLs1[0] * zeta2
						+ 13.0/8 * HPLs2[0*2+0]
						+ 5.0/8 * HPLs3[0*2*2+0*2+0]
						+ 1.0/8 * HPLs3[1*2*2+0*2+0]
						- 3.0/8 * HPLs2[1*2+0]
						+ 3.0/4 * HPLs3[0*2*2+1*2+0]
						- 3.0/8 * HPLs1[1]
						- 15.0/8 * HPLs1[1] * zeta2
						+ 5.0/4 * HPLs2[0*2+1]
						+ 5.0/8 * HPLs3[0*2*2+0*2+1]
						+ 1.0/8 * HPLs3[1*2*2+0*2+1]
						+ 3.0/4 * HPLs3[0*2*2+1*2+1]
						)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(v, 2) * pow(1. - u, -2) * (
									  - 7.0/16 * zeta2
									  - 5.0/16 * GHPLs2[2*4+2]
									  - 1.0/4 * GHPLs2[2*4+2] * HPLs1[0]
									  + 1.0/8 * GHPLs3[0*4*4+2*4+2]
									  + 1.0/8 * GHPLs2[3*4+2] * HPLs1[0]
									  - 1.0/8 * GHPLs3[0*4*4+3*4+2]
									  + 23.0/32 * GHPLs1[2]
									  - 5.0/8 * GHPLs1[2] * zeta2
									  + 1.0/8 * GHPLs1[2] * HPLs1[0]
									  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 5.0/16 * GHPLs1[2] * HPLs1[1]
									  + 1.0/8 * GHPLs3[2*4*4+0*4+2]
									  + 3.0/8 * GHPLs2[0*4+2]
									  - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
									  - 1.0/8 * GHPLs2[0*4+2] * HPLs1[1]
									  - 1.0/4 * GHPLs3[2*4*4+1*4+2]
									  + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  + 1.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  + 1.0/8 * GHPLs3[2*4*4+2*4+0]
									  + 3.0/8 * GHPLs2[2*4+0]
									  - 1.0/8 * GHPLs2[2*4+0] * HPLs1[1]
									  + 1.0/8 * GHPLs2[3*4+0] * HPLs1[0]
									  - 1.0/8 * GHPLs3[0*4*4+3*4+0]
									  - 1.0/8 * GHPLs1[0] * zeta2
									  - 3.0/8 * GHPLs1[0] * HPLs1[0]
									  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 1.0/8 * GHPLs1[0] * HPLs2[1*2+0]
									  - 3.0/8 * GHPLs1[0] * HPLs1[1]
									  + 1.0/4 * GHPLs1[0] * HPLs2[0*2+1]
									  + 1.0/8 * GHPLs1[0] * HPLs2[1*2+1]
									  + 1.0/8 * GHPLs3[2*4*4+1*4+0]
									  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
									  - 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
									  - 1.0/4 * GHPLs3[2*4*4+2*4+1]
									  - 7.0/16 * GHPLs2[2*4+1]
									  + 1.0/4 * GHPLs2[2*4+1] * HPLs1[0]
									  + 1.0/4 * GHPLs2[2*4+1] * HPLs1[1]
									  + 1.0/4 * GHPLs1[1] * zeta2
									  + 7.0/16 * GHPLs1[1] * HPLs1[0]
									  + 7.0/16 * GHPLs1[1] * HPLs1[1]
									  - 1.0/4 * GHPLs1[1] * HPLs2[0*2+1]
									  - 1.0/4 * GHPLs1[1] * HPLs2[1*2+1]
									  + 1.0/4 * GHPLs3[2*4*4+1*4+1]
									  - 1.0/4 * GHPLs2[1*4+1] * HPLs1[0]
									  - 1.0/4 * GHPLs2[1*4+1] * HPLs1[1]
									  - 23.0/32 * HPLs1[0]
									  + 9.0/8 * HPLs1[0] * zeta2
									  - 3.0/8 * HPLs2[0*2+0]
									  - 1.0/4 * HPLs3[0*2*2+0*2+0]
									  - 1.0/8 * HPLs3[1*2*2+0*2+0]
									  - 9.0/16 * HPLs2[1*2+0]
									  + 1.0/8 * HPLs3[0*2*2+1*2+0]
									  - 23.0/32 * HPLs1[1]
									  + 5.0/8 * HPLs1[1] * zeta2
									  - 1.0/8 * HPLs2[0*2+1]
									  - 1.0/4 * HPLs3[0*2*2+0*2+1]
									  - 5.0/16 * HPLs2[1*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(v, 2) * pow(1. - u, -1) * (
									  - 5.0/4 * zeta2
									  - 1.0/2 * zeta3
									  + 5.0/4 * GHPLs2[2*4+2]
									  + GHPLs2[2*4+2] * HPLs1[0]
									  - 3.0/4 * GHPLs3[0*4*4+2*4+2]
									  - 3.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 3.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 23.0/16 * GHPLs1[2]
									  + 13.0/4 * GHPLs1[2] * zeta2
									  - GHPLs1[2] * HPLs2[0*2+0]
									  - 5.0/4 * GHPLs1[2] * HPLs1[1]
									  - 1.0/2 * GHPLs1[2] * HPLs2[0*2+1]
									  - 3.0/4 * GHPLs3[2*4*4+0*4+2]
									  - 3.0/4 * GHPLs2[0*4+2]
									  + GHPLs2[0*4+2] * HPLs1[0]
									  + 3.0/4 * GHPLs2[0*4+2] * HPLs1[1]
									  + GHPLs3[2*4*4+1*4+2]
									  - GHPLs2[1*4+2] * HPLs1[0]
									  - GHPLs2[1*4+2] * HPLs1[1]
									  + 1.0/8 * GHPLs1[3] * HPLs1[0]
									  - 1.0/8 * GHPLs2[0*4+3]
									  - 3.0/4 * GHPLs3[2*4*4+2*4+0]
									  - 3.0/4 * GHPLs2[2*4+0]
									  + 1.0/2 * GHPLs2[2*4+0] * HPLs1[0]
									  + 3.0/4 * GHPLs2[2*4+0] * HPLs1[1]
									  - 3.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 3.0/4 * GHPLs3[0*4*4+3*4+0]
									  + 7.0/4 * GHPLs1[0] * zeta2
									  + 3.0/4 * GHPLs1[0] * HPLs1[0]
									  - GHPLs1[0] * HPLs2[0*2+0]
									  - 3.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  + 3.0/4 * GHPLs1[0] * HPLs1[1]
									  - GHPLs1[0] * HPLs2[0*2+1]
									  - 3.0/4 * GHPLs1[0] * HPLs2[1*2+1]
									  - 1.0/4 * GHPLs3[2*4*4+1*4+0]
									  + 1.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  + 1.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  + GHPLs3[2*4*4+2*4+1]
									  + 5.0/4 * GHPLs2[2*4+1]
									  - 1.0/2 * GHPLs2[2*4+1] * HPLs1[0]
									  - GHPLs2[2*4+1] * HPLs1[1]
									  - 1.0/2 * GHPLs3[0*4*4+2*4+1]
									  - 5.0/4 * GHPLs1[1] * HPLs1[0]
									  + 1.0/2 * GHPLs1[1] * HPLs2[1*2+0]
									  - 5.0/4 * GHPLs1[1] * HPLs1[1]
									  + 1.0/2 * GHPLs1[1] * HPLs2[0*2+1]
									  + GHPLs1[1] * HPLs2[1*2+1]
									  - 1.0/2 * GHPLs3[2*4*4+0*4+1]
									  + 1.0/2 * GHPLs2[0*4+1] * HPLs1[0]
									  + 1.0/2 * GHPLs2[0*4+1] * HPLs1[1]
									  + 23.0/16 * HPLs1[0]
									  - 17.0/4 * HPLs1[0] * zeta2
									  + 1.0/4 * HPLs2[0*2+0]
									  + HPLs3[0*2*2+0*2+0]
									  + 1.0/4 * HPLs3[1*2*2+0*2+0]
									  + 5.0/4 * HPLs2[1*2+0]
									  + 1.0/4 * HPLs3[0*2*2+1*2+0]
									  + 23.0/16 * HPLs1[1]
									  - 13.0/4 * HPLs1[1] * zeta2
									  + 1.0/4 * HPLs2[0*2+1]
									  + HPLs3[0*2*2+0*2+1]
									  + 5.0/4 * HPLs2[1*2+1]
									  + 1.0/2 * HPLs3[0*2*2+1*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(v, 2) * (
							- 2 * zeta2
							- 3.0/8 * GHPLs1[2] * zeta2
							- 1.0/2 * GHPLs1[2] * HPLs1[0]
							- 3.0/8 * GHPLs1[2] * HPLs2[0*2+0]
							+ 3.0/8 * GHPLs1[2] * HPLs2[1*2+0]
							+ 1.0/2 * GHPLs2[0*4+2]
							+ 3.0/8 * GHPLs2[0*4+2] * HPLs1[0]
							+ 3.0/8 * GHPLs3[2*4*4+1*4+2]
							- 3.0/8 * GHPLs2[1*4+2] * HPLs1[0]
							- 3.0/8 * GHPLs2[1*4+2] * HPLs1[1]
							+ 3.0/8 * GHPLs2[2*4+3] * HPLs1[0]
							- 3.0/8 * GHPLs3[0*4*4+2*4+3]
							- 3.0/8 * GHPLs2[3*4+3] * HPLs1[0]
							+ 3.0/8 * GHPLs3[0*4*4+3*4+3]
							+ 15.0/8 * GHPLs1[3] * zeta2
							+ 1.0/2 * GHPLs1[3] * HPLs1[0]
							- 3.0/8 * GHPLs1[3] * HPLs2[1*2+0]
							- 3.0/8 * GHPLs1[3] * HPLs2[0*2+1]
							- 3.0/8 * GHPLs3[2*4*4+0*4+3]
							- 1.0/2 * GHPLs2[0*4+3]
							+ 3.0/8 * GHPLs2[0*4+3] * HPLs1[1]
							+ 1.0/2 * GHPLs2[2*4+0]
							- 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
							+ 1.0/4 * GHPLs1[0] * zeta2
							- 1.0/2 * GHPLs1[0] * HPLs1[0]
							+ 1.0/8 * GHPLs1[0] * HPLs2[0*2+0]
							- 1.0/2 * GHPLs1[0] * HPLs1[1]
							+ 1.0/8 * GHPLs1[0] * HPLs2[0*2+1]
							- 1.0/8 * GHPLs3[2*4*4+1*4+0]
							+ 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
							+ 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
							- 1.0/2 * GHPLs2[2*4+1]
							+ 1.0/8 * GHPLs2[2*4+1] * HPLs1[0]
							- 1.0/4 * GHPLs1[1] * zeta2
							+ 1.0/2 * GHPLs1[1] * HPLs1[0]
							- 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
							+ 1.0/2 * GHPLs1[1] * HPLs1[1]
							- 1.0/8 * GHPLs1[1] * HPLs2[0*2+1]
							+ 1.0/8 * GHPLs3[2*4*4+1*4+1]
							- 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
							- 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
							+ 1.0/8 * HPLs1[0] * zeta2
							+ 1.0/2 * HPLs2[0*2+0]
							+ 1.0/8 * HPLs3[0*2*2+0*2+0]
							+ 1.0/8 * HPLs3[1*2*2+0*2+0]
							+ 1.0/4 * HPLs3[0*2*2+1*2+0]
							+ 1.0/8 * HPLs1[1] * zeta2
							+ 1.0/2 * HPLs2[0*2+1]
							+ 1.0/8 * HPLs3[0*2*2+0*2+1]
							+ 1.0/8 * HPLs3[1*2*2+0*2+1]
							+ 1.0/4 * HPLs3[0*2*2+1*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - v, -2) * (
								  - 15.0/16 * zeta2
								  - 3.0/8 * zeta3
								  - 7.0/8 * GHPLs2[3*4+2] * HPLs1[0]
								  + 7.0/8 * GHPLs3[0*4*4+3*4+2]
								  + 3.0/4 * GHPLs1[2] * zeta2
								  - 7.0/16 * GHPLs1[2] * HPLs1[0]
								  - 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								  - 1.0/2 * GHPLs1[2] * HPLs2[1*2+0]
								  + 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
								  + 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								  - 1.0/2 * GHPLs3[2*4*4+1*4+2]
								  + 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
								  + 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
								  + 9.0/8 * GHPLs1[3] * HPLs1[0]
								  - 9.0/8 * GHPLs2[0*4+3]
								  - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
								  + 7.0/8 * GHPLs2[3*4+0] * HPLs1[0]
								  - 7.0/8 * GHPLs3[0*4*4+3*4+0]
								  - 5.0/8 * GHPLs1[0] * zeta2
								  + 5.0/8 * GHPLs1[0] * HPLs1[0]
								  + 5.0/8 * GHPLs1[0] * HPLs2[0*2+0]
								  + 5.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  + 1.0/2 * GHPLs3[2*4*4+1*4+0]
								  - 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
								  - 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
								  + 9.0/8 * GHPLs2[2*4+1]
								  - 9.0/8 * GHPLs1[1] * HPLs1[0]
								  - 9.0/8 * GHPLs1[1] * HPLs1[1]
								  - 27.0/32 * HPLs1[0]
								  + 11.0/4 * HPLs1[0] * zeta2
								  + 9.0/8 * HPLs2[0*2+0]
								  - 7.0/8 * HPLs3[0*2*2+0*2+0]
								  - 1.0/4 * HPLs3[1*2*2+0*2+0]
								  + 25.0/16 * HPLs2[1*2+0]
								  - 5.0/8 * HPLs3[0*2*2+1*2+0]
								  - 5.0/8 * HPLs1[1] * zeta2
								  + 5.0/8 * HPLs2[0*2+1]
								  + 5.0/8 * HPLs3[0*2*2+0*2+1]
								  + 5.0/8 * HPLs3[1*2*2+0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * pow(1. - v, -1) * (
								  - 17.0/32
								  + 59.0/16 * zeta2
								  + 3.0/8 * zeta3
								  + 7.0/8 * GHPLs2[3*4+2] * HPLs1[0]
								  - 7.0/8 * GHPLs3[0*4*4+3*4+2]
								  - 17.0/16 * GHPLs1[2]
								  - 3.0/4 * GHPLs1[2] * zeta2
								  + 11.0/16 * GHPLs1[2] * HPLs1[0]
								  + 5.0/8 * GHPLs1[2] * HPLs2[0*2+0]
								  + 1.0/2 * GHPLs1[2] * HPLs2[1*2+0]
								  - 1.0/4 * GHPLs1[2] * HPLs2[0*2+1]
								  - 5.0/8 * GHPLs2[0*4+2]
								  - 1.0/4 * GHPLs2[0*4+2] * HPLs1[0]
								  + 1.0/2 * GHPLs3[2*4*4+1*4+2]
								  - 1.0/2 * GHPLs2[1*4+2] * HPLs1[0]
								  - 1.0/2 * GHPLs2[1*4+2] * HPLs1[1]
								  - 2 * GHPLs1[3] * HPLs1[0]
								  + 2 * GHPLs2[0*4+3]
								  - 5.0/8 * GHPLs2[2*4+0]
								  + 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
								  - 7.0/8 * GHPLs2[3*4+0] * HPLs1[0]
								  + 7.0/8 * GHPLs3[0*4*4+3*4+0]
								  + 3.0/4 * GHPLs1[0]
								  + 5.0/8 * GHPLs1[0] * zeta2
								  + 1.0/2 * GHPLs1[0] * HPLs1[0]
								  - 5.0/8 * GHPLs1[0] * HPLs2[0*2+0]
								  - 5.0/8 * GHPLs1[0] * HPLs2[1*2+0]
								  + 5.0/8 * GHPLs1[0] * HPLs1[1]
								  - 1.0/2 * GHPLs3[2*4*4+1*4+0]
								  + 1.0/2 * GHPLs2[1*4+0] * HPLs1[0]
								  + 1.0/2 * GHPLs2[1*4+0] * HPLs1[1]
								  - 5.0/8 * GHPLs2[2*4+1]
								  + 5.0/8 * GHPLs1[1] * HPLs1[0]
								  + 5.0/8 * GHPLs1[1] * HPLs1[1]
								  + 39.0/32 * HPLs1[0]
								  - 11.0/4 * HPLs1[0] * zeta2
								  - 2 * HPLs2[0*2+0]
								  + 7.0/8 * HPLs3[0*2*2+0*2+0]
								  + 1.0/4 * HPLs3[1*2*2+0*2+0]
								  - 21.0/16 * HPLs2[1*2+0]
								  + 5.0/8 * HPLs3[0*2*2+1*2+0]
								  + 17.0/16 * HPLs1[1]
								  + 5.0/8 * HPLs1[1] * zeta2
								  - 3.0/4 * HPLs2[0*2+1]
								  - 5.0/8 * HPLs3[0*2*2+0*2+1]
								  - 5.0/8 * HPLs3[1*2*2+0*2+1]
								  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * (
						- 3 * zeta2
						+ 3.0/4 * GHPLs1[2]
						- 1.0/2 * GHPLs1[2] * HPLs1[0]
						+ 3.0/4 * GHPLs2[0*4+2]
						+ 3.0/4 * GHPLs1[3] * HPLs1[0]
						- 3.0/4 * GHPLs2[0*4+3]
						+ 3.0/4 * GHPLs2[2*4+0]
						- 3.0/8 * GHPLs1[0]
						- GHPLs1[0] * HPLs1[0]
						- 3.0/4 * GHPLs1[0] * HPLs1[1]
						- 3.0/4 * GHPLs2[2*4+1]
						+ 3.0/4 * GHPLs1[1] * HPLs1[0]
						+ 3.0/4 * GHPLs1[1] * HPLs1[1]
						- 3.0/8 * HPLs1[0]
						+ 3.0/4 * HPLs2[0*2+0]
						- 1.0/4 * HPLs2[1*2+0]
						- 3.0/4 * HPLs1[1]
						+ 1.0/2 * HPLs2[0*2+1]
						)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * u * v * (
						    - zeta2
						    - 1.0/8 * GHPLs1[2] * zeta2
						    - 1.0/4 * GHPLs1[2] * HPLs1[0]
						    - 1.0/8 * GHPLs1[2] * HPLs2[0*2+0]
						    + 1.0/8 * GHPLs1[2] * HPLs2[1*2+0]
						    + 1.0/4 * GHPLs2[0*4+2]
						    + 1.0/8 * GHPLs2[0*4+2] * HPLs1[0]
						    + 1.0/8 * GHPLs3[2*4*4+1*4+2]
						    - 1.0/8 * GHPLs2[1*4+2] * HPLs1[0]
						    - 1.0/8 * GHPLs2[1*4+2] * HPLs1[1]
						    + 1.0/8 * GHPLs2[2*4+3] * HPLs1[0]
						    - 1.0/8 * GHPLs3[0*4*4+2*4+3]
						    - 1.0/8 * GHPLs2[3*4+3] * HPLs1[0]
						    + 1.0/8 * GHPLs3[0*4*4+3*4+3]
						    + 5.0/8 * GHPLs1[3] * zeta2
						    + 1.0/4 * GHPLs1[3] * HPLs1[0]
						    - 1.0/8 * GHPLs1[3] * HPLs2[1*2+0]
						    - 1.0/8 * GHPLs1[3] * HPLs2[0*2+1]
						    - 1.0/8 * GHPLs3[2*4*4+0*4+3]
						    - 1.0/4 * GHPLs2[0*4+3]
						    + 1.0/8 * GHPLs2[0*4+3] * HPLs1[1]
						    + 1.0/4 * GHPLs2[2*4+0]
						    - 1.0/8 * GHPLs2[2*4+0] * HPLs1[0]
						    + 1.0/4 * GHPLs1[0] * zeta2
						    - 1.0/4 * GHPLs1[0] * HPLs1[0]
						    + 1.0/8 * GHPLs1[0] * HPLs2[0*2+0]
						    - 1.0/4 * GHPLs1[0] * HPLs1[1]
						    + 1.0/8 * GHPLs1[0] * HPLs2[0*2+1]
						    - 1.0/8 * GHPLs3[2*4*4+1*4+0]
						    + 1.0/8 * GHPLs2[1*4+0] * HPLs1[0]
						    + 1.0/8 * GHPLs2[1*4+0] * HPLs1[1]
						    - 1.0/4 * GHPLs2[2*4+1]
						    + 1.0/8 * GHPLs2[2*4+1] * HPLs1[0]
						    - 1.0/4 * GHPLs1[1] * zeta2
						    + 1.0/4 * GHPLs1[1] * HPLs1[0]
						    - 1.0/8 * GHPLs1[1] * HPLs2[0*2+0]
						    + 1.0/4 * GHPLs1[1] * HPLs1[1]
						    - 1.0/8 * GHPLs1[1] * HPLs2[0*2+1]
						    + 1.0/8 * GHPLs3[2*4*4+1*4+1]
						    - 1.0/8 * GHPLs2[1*4+1] * HPLs1[0]
						    - 1.0/8 * GHPLs2[1*4+1] * HPLs1[1]
						    + 1.0/8 * HPLs1[0] * zeta2
						    + 1.0/4 * HPLs2[0*2+0]
						    + 1.0/8 * HPLs3[0*2*2+0*2+0]
						    + 1.0/8 * HPLs3[1*2*2+0*2+0]
						    + 1.0/4 * HPLs3[0*2*2+1*2+0]
						    + 1.0/8 * HPLs1[1] * zeta2
						    + 1.0/4 * HPLs2[0*2+1]
						    + 1.0/8 * HPLs3[0*2*2+0*2+1]
						    + 1.0/8 * HPLs3[1*2*2+0*2+1]
						    + 1.0/4 * HPLs3[0*2*2+1*2+1]
						    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -3) * (
									  + 9.0/4 * zeta2
									  + 9.0/4 * zeta3
									  + 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 9.0/4 * GHPLs1[2] * zeta2
									  + 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  - 9.0/4 * GHPLs1[3] * HPLs1[0]
									  + 9.0/4 * GHPLs2[0*4+3]
									  - 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  + 9.0/4 * GHPLs1[0] * zeta2
									  - 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  - 9.0/4 * GHPLs2[2*4+1]
									  + 9.0/4 * GHPLs1[1] * HPLs1[0]
									  + 9.0/4 * GHPLs1[1] * HPLs1[1]
									  - 9 * HPLs1[0] * zeta2
									  - 9.0/4 * HPLs2[0*2+0]
									  + 9.0/4 * HPLs3[0*2*2+0*2+0]
									  - 9.0/4 * HPLs2[1*2+0]
									  + 9.0/4 * HPLs3[0*2*2+1*2+0]
									  + 9.0/4 * HPLs1[1] * zeta2
									  - 9.0/4 * HPLs3[0*2*2+0*2+1]
									  - 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -2) * (
									  - 45.0/4 * zeta2
									  - 9.0/4 * zeta3
									  - 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  + 9.0/8 * GHPLs1[2]
									  + 9.0/4 * GHPLs1[2] * zeta2
									  - 9.0/4 * GHPLs1[2] * HPLs1[0]
									  - 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs2[0*4+2]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  + 9.0/2 * GHPLs1[3] * HPLs1[0]
									  - 9.0/2 * GHPLs2[0*4+3]
									  + 9.0/4 * GHPLs2[2*4+0]
									  + 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 9.0/8 * GHPLs1[0]
									  - 9.0/4 * GHPLs1[0] * zeta2
									  - 9.0/4 * GHPLs1[0] * HPLs1[0]
									  + 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs1[0] * HPLs1[1]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  + 9 * HPLs1[0] * zeta2
									  + 9.0/2 * HPLs2[0*2+0]
									  - 9.0/4 * HPLs3[0*2*2+0*2+0]
									  + 9.0/4 * HPLs2[1*2+0]
									  - 9.0/4 * HPLs3[0*2*2+1*2+0]
									  - 9.0/8 * HPLs1[1]
									  - 9.0/4 * HPLs1[1] * zeta2
									  + 9.0/4 * HPLs2[0*2+1]
									  + 9.0/4 * HPLs3[0*2*2+0*2+1]
									  + 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * pow(1. - v, -1) * (
									  + 9.0/2 * zeta2
									  - 3.0/8 * GHPLs1[2]
									  + 9.0/8 * GHPLs1[2] * HPLs1[0]
									  - 9.0/8 * GHPLs2[0*4+2]
									  - 9.0/8 * GHPLs1[3] * HPLs1[0]
									  + 9.0/8 * GHPLs2[0*4+3]
									  - 9.0/8 * GHPLs2[2*4+0]
									  + 3.0/8 * GHPLs1[0]
									  + 9.0/8 * GHPLs1[0] * HPLs1[0]
									  + 9.0/8 * GHPLs1[0] * HPLs1[1]
									  + 9.0/8 * GHPLs2[2*4+1]
									  - 9.0/8 * GHPLs1[1] * HPLs1[0]
									  - 9.0/8 * GHPLs1[1] * HPLs1[1]
									  - 9.0/8 * HPLs2[0*2+0]
									  + 3.0/8 * HPLs1[1]
									  - 9.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 2) * (
							+ 2 * zeta2
							+ 1.0/2 * GHPLs1[2] * HPLs1[0]
							- 1.0/2 * GHPLs2[0*4+2]
							- 1.0/2 * GHPLs1[3] * HPLs1[0]
							+ 1.0/2 * GHPLs2[0*4+3]
							- 1.0/2 * GHPLs2[2*4+0]
							+ 1.0/2 * GHPLs1[0] * HPLs1[0]
							+ 1.0/2 * GHPLs1[0] * HPLs1[1]
							+ 1.0/2 * GHPLs2[2*4+1]
							- 1.0/2 * GHPLs1[1] * HPLs1[0]
							- 1.0/2 * GHPLs1[1] * HPLs1[1]
							- 1.0/2 * HPLs2[0*2+0]
							- 1.0/2 * HPLs2[0*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -4) * (
									  - 9.0/4 * zeta3
									  - 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  + 9.0/4 * GHPLs1[2] * zeta2
									  - 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  + 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  - 9.0/4 * GHPLs1[0] * zeta2
									  + 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  + 9 * HPLs1[0] * zeta2
									  - 9.0/4 * HPLs3[0*2*2+0*2+0]
									  - 9.0/4 * HPLs3[0*2*2+1*2+0]
									  - 9.0/4 * HPLs1[1] * zeta2
									  + 9.0/4 * HPLs3[0*2*2+0*2+1]
									  + 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -3) * (
									  + 9 * zeta2
									  + 9.0/4 * zeta3
									  + 9.0/4 * GHPLs2[3*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs3[0*4*4+3*4+2]
									  - 9.0/4 * GHPLs1[2] * zeta2
									  + 9.0/4 * GHPLs1[2] * HPLs1[0]
									  + 9.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									  + 9.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									  - 9.0/4 * GHPLs2[0*4+2]
									  + 9.0/4 * GHPLs3[2*4*4+1*4+2]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									  - 9.0/4 * GHPLs2[1*4+2] * HPLs1[1]
									  - 9.0/4 * GHPLs1[3] * HPLs1[0]
									  + 9.0/4 * GHPLs2[0*4+3]
									  - 9.0/4 * GHPLs2[2*4+0]
									  - 9.0/4 * GHPLs2[3*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs3[0*4*4+3*4+0]
									  + 9.0/4 * GHPLs1[0] * zeta2
									  + 9.0/4 * GHPLs1[0] * HPLs1[0]
									  - 9.0/4 * GHPLs1[0] * HPLs2[0*2+0]
									  - 9.0/4 * GHPLs1[0] * HPLs2[1*2+0]
									  + 9.0/4 * GHPLs1[0] * HPLs1[1]
									  - 9.0/4 * GHPLs3[2*4*4+1*4+0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[0]
									  + 9.0/4 * GHPLs2[1*4+0] * HPLs1[1]
									  + 9.0/4 * GHPLs2[2*4+1]
									  - 9.0/4 * GHPLs1[1] * HPLs1[0]
									  - 9.0/4 * GHPLs1[1] * HPLs1[1]
									  - 9 * HPLs1[0] * zeta2
									  - 9.0/4 * HPLs2[0*2+0]
									  + 9.0/4 * HPLs3[0*2*2+0*2+0]
									  + 9.0/4 * HPLs3[0*2*2+1*2+0]
									  + 9.0/4 * HPLs1[1] * zeta2
									  - 9.0/4 * HPLs2[0*2+1]
									  - 9.0/4 * HPLs3[0*2*2+0*2+1]
									  - 9.0/4 * HPLs3[1*2*2+0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -2) * (
									  - 9.0/2 * zeta2
									  - 9.0/8 * GHPLs1[2] * HPLs1[0]
									  + 9.0/8 * GHPLs2[0*4+2]
									  + 9.0/8 * GHPLs1[3] * HPLs1[0]
									  - 9.0/8 * GHPLs2[0*4+3]
									  + 9.0/8 * GHPLs2[2*4+0]
									  - 9.0/8 * GHPLs1[0] * HPLs1[0]
									  - 9.0/8 * GHPLs1[0] * HPLs1[1]
									  - 9.0/8 * GHPLs2[2*4+1]
									  + 9.0/8 * GHPLs1[1] * HPLs1[0]
									  + 9.0/8 * GHPLs1[1] * HPLs1[1]
									  + 9.0/8 * HPLs2[0*2+0]
									  + 9.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * pow(u, 3) * pow(1. - v, -1) * (
									  - 3.0/2 * zeta2
									  - 3.0/8 * GHPLs1[2] * HPLs1[0]
									  + 3.0/8 * GHPLs2[0*4+2]
									  + 3.0/8 * GHPLs1[3] * HPLs1[0]
									  - 3.0/8 * GHPLs2[0*4+3]
									  + 3.0/8 * GHPLs2[2*4+0]
									  - 3.0/8 * GHPLs1[0] * HPLs1[0]
									  - 3.0/8 * GHPLs1[0] * HPLs1[1]
									  - 3.0/8 * GHPLs2[2*4+1]
									  + 3.0/8 * GHPLs1[1] * HPLs1[0]
									  + 3.0/8 * GHPLs1[1] * HPLs1[1]
									  + 3.0/8 * HPLs2[0*2+0]
									  + 3.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(1. - u - v, -1) * (
											   + 1.0/8 * GHPLs2[2*4+3]
											   + 1.0/8 * GHPLs2[3*4+3]
											   - 1.0/8 * GHPLs1[3] * HPLs1[0]
											   - 1.0/8 * GHPLs1[3] * HPLs1[1]
											   + 1.0/8 * GHPLs2[0*4+3]
											   + 1.0/8 * GHPLs2[2*4+1]
											   - 1.0/4 * GHPLs1[1] * HPLs1[0]
											   - 1.0/8 * GHPLs1[1] * HPLs1[1]
											   + 1.0/8 * GHPLs2[0*4+1]
											   + 1.0/8 * GHPLs2[1*4+1]
											   )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * (
								     - 1.0/8 * GHPLs2[2*4+3]
								     - 1.0/8 * GHPLs2[3*4+3]
								     + 1.0/8 * GHPLs1[3] * HPLs1[0]
								     + 1.0/8 * GHPLs1[3] * HPLs1[1]
								     - 1.0/8 * GHPLs2[0*4+3]
								     - 1.0/8 * GHPLs2[2*4+1]
								     + 1.0/4 * GHPLs1[1] * HPLs1[0]
								     + 1.0/8 * GHPLs1[1] * HPLs1[1]
								     - 1.0/8 * GHPLs2[0*4+1]
								     - 1.0/8 * GHPLs2[1*4+1]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * v * (
									 - 7.0/4 * GHPLs3[3*4*4+2*4+2]
									 - 7.0/4 * GHPLs2[2*4+2] * HPLs1[0]
									 + 5.0/4 * GHPLs3[1*4*4+2*4+2]
									 - 1.0/2 * GHPLs3[3*4*4+3*4+2]
									 + 5.0/2 * GHPLs1[2] * zeta2
									 - 9.0/8 * GHPLs1[2] * HPLs1[0]
									 - 7.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									 - 5.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									 + 5.0/4 * GHPLs1[2] * HPLs2[0*2+1]
									 + 7.0/4 * GHPLs3[3*4*4+0*4+2]
									 + 5.0/4 * GHPLs2[0*4+2] * HPLs1[0]
									 - 5.0/4 * GHPLs3[1*4*4+0*4+2]
									 + 3.0/8 * GHPLs2[1*4+2]
									 + 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									 - 1.0/2 * GHPLs3[1*4*4+1*4+2]
									 - 1.0/8 * GHPLs2[2*4+3]
									 - 1.0/8 * GHPLs2[3*4+3]
									 + 1.0/8 * GHPLs1[3] * HPLs1[0]
									 + 1.0/8 * GHPLs1[3] * HPLs1[1]
									 - 1.0/8 * GHPLs2[0*4+3]
									 + 5.0/4 * GHPLs3[2*4*4+2*4+1]
									 - 5.0/4 * GHPLs3[3*4*4+2*4+1]
									 - 7.0/8 * GHPLs2[2*4+1]
									 - 3.0/2 * GHPLs2[2*4+1] * HPLs1[0]
									 - 5.0/4 * GHPLs2[2*4+1] * HPLs1[1]
									 + 5.0/4 * GHPLs3[0*4*4+2*4+1]
									 - 3.0/2 * GHPLs3[1*4*4+2*4+1]
									 + 11.0/16 * GHPLs1[1]
									 - 9.0/4 * GHPLs1[1] * zeta2
									 + 11.0/8 * GHPLs1[1] * HPLs1[0]
									 + 7.0/4 * GHPLs1[1] * HPLs2[0*2+0]
									 + 5.0/4 * GHPLs1[1] * HPLs2[1*2+0]
									 + 7.0/8 * GHPLs1[1] * HPLs1[1]
									 + 3.0/2 * GHPLs1[1] * HPLs2[0*2+1]
									 + 5.0/4 * GHPLs1[1] * HPLs2[1*2+1]
									 + 5.0/4 * GHPLs3[2*4*4+0*4+1]
									 - 5.0/4 * GHPLs3[3*4*4+0*4+1]
									 - 7.0/8 * GHPLs2[0*4+1]
									 - 5.0/4 * GHPLs2[0*4+1] * HPLs1[0]
									 - 5.0/4 * GHPLs2[0*4+1] * HPLs1[1]
									 + 1.0/4 * GHPLs3[1*4*4+0*4+1]
									 - 1.0/2 * GHPLs3[2*4*4+1*4+1]
									 - 1.0/2 * GHPLs2[1*4+1]
									 + 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
									 + 5.0/4 * GHPLs3[0*4*4+1*4+1]
									 - 3.0/4 * GHPLs3[1*4*4+1*4+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 2) * (
										 + 7.0/4 * GHPLs3[3*4*4+2*4+2]
										 + 7.0/4 * GHPLs2[2*4+2] * HPLs1[0]
										 - 5.0/4 * GHPLs3[1*4*4+2*4+2]
										 + 1.0/2 * GHPLs3[3*4*4+3*4+2]
										 - 5.0/2 * GHPLs1[2] * zeta2
										 + 9.0/8 * GHPLs1[2] * HPLs1[0]
										 + 7.0/4 * GHPLs1[2] * HPLs2[0*2+0]
										 + 5.0/4 * GHPLs1[2] * HPLs2[1*2+0]
										 - 5.0/4 * GHPLs1[2] * HPLs2[0*2+1]
										 - 7.0/4 * GHPLs3[3*4*4+0*4+2]
										 - 5.0/4 * GHPLs2[0*4+2] * HPLs1[0]
										 + 5.0/4 * GHPLs3[1*4*4+0*4+2]
										 - 5.0/8 * GHPLs2[1*4+2]
										 - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
										 + 1.0/2 * GHPLs3[1*4*4+1*4+2]
										 - 1.0/8 * GHPLs2[2*4+3]
										 - 5.0/8 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3] * HPLs1[0]
										 + 1.0/8 * GHPLs1[3] * HPLs1[1]
										 - 1.0/8 * GHPLs2[0*4+3]
										 - 5.0/4 * GHPLs3[2*4*4+2*4+1]
										 + 5.0/4 * GHPLs3[3*4*4+2*4+1]
										 + 3.0/8 * GHPLs2[2*4+1]
										 + 3.0/2 * GHPLs2[2*4+1] * HPLs1[0]
										 + 5.0/4 * GHPLs2[2*4+1] * HPLs1[1]
										 - 5.0/4 * GHPLs3[0*4*4+2*4+1]
										 + 3.0/2 * GHPLs3[1*4*4+2*4+1]
										 - 15.0/16 * GHPLs1[1]
										 + 9.0/4 * GHPLs1[1] * zeta2
										 - 3.0/8 * GHPLs1[1] * HPLs1[0]
										 - 7.0/4 * GHPLs1[1] * HPLs2[0*2+0]
										 - 5.0/4 * GHPLs1[1] * HPLs2[1*2+0]
										 - 3.0/8 * GHPLs1[1] * HPLs1[1]
										 - 3.0/2 * GHPLs1[1] * HPLs2[0*2+1]
										 - 5.0/4 * GHPLs1[1] * HPLs2[1*2+1]
										 - 5.0/4 * GHPLs3[2*4*4+0*4+1]
										 + 5.0/4 * GHPLs3[3*4*4+0*4+1]
										 + 3.0/8 * GHPLs2[0*4+1]
										 + 5.0/4 * GHPLs2[0*4+1] * HPLs1[0]
										 + 5.0/4 * GHPLs2[0*4+1] * HPLs1[1]
										 - 1.0/4 * GHPLs3[1*4*4+0*4+1]
										 + 1.0/2 * GHPLs3[2*4*4+1*4+1]
										 - 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
										 - 5.0/4 * GHPLs3[0*4*4+1*4+1]
										 + 3.0/4 * GHPLs3[1*4*4+1*4+1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 3) * (
										 + 1.0/8 * GHPLs2[1*4+2]
										 - 1.0/8 * GHPLs2[2*4+3]
										 + 1.0/8 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3] * HPLs1[0]
										 + 1.0/8 * GHPLs1[3] * HPLs1[1]
										 - 1.0/8 * GHPLs2[0*4+3]
										 + 1.0/8 * GHPLs1[1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -2) * pow(v, 4) * (
										 + 1.0/8 * GHPLs2[1*4+2]
										 - 1.0/8 * GHPLs2[2*4+3]
										 + 1.0/8 * GHPLs2[3*4+3]
										 + 1.0/8 * GHPLs1[3] * HPLs1[0]
										 + 1.0/8 * GHPLs1[3] * HPLs1[1]
										 - 1.0/8 * GHPLs2[0*4+3]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(1. - u - v, -1) * (
											   - 1.0/8 * GHPLs2[2*4+3]
											   - 1.0/8 * GHPLs2[3*4+3]
											   - 1.0/8 * GHPLs1[3]
											   + 1.0/8 * GHPLs1[3] * HPLs1[0]
											   + 1.0/8 * GHPLs1[3] * HPLs1[1]
											   - 1.0/8 * GHPLs2[0*4+3]
											   - 1.0/8 * GHPLs2[2*4+1]
											   + 1.0/4 * GHPLs1[1] * HPLs1[0]
											   + 1.0/8 * GHPLs1[1] * HPLs1[1]
											   - 1.0/8 * GHPLs2[0*4+1]
											   - 1.0/8 * GHPLs2[1*4+1]
											   - 1.0/8 * HPLs1[0]
											   )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * (
								     + 1.0/8 * GHPLs1[3]
								     - 1.0/4 * GHPLs1[1]
								     + 1.0/8 * HPLs1[0]
								     )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * v * (
									 + 23.0/16
									 + 1.0/4 * zeta2
									 + 7.0/4 * GHPLs3[3*4*4+2*4+2]
									 + 5.0/4 * GHPLs2[2*4+2]
									 + 7.0/4 * GHPLs2[2*4+2] * HPLs1[0]
									 - 5.0/4 * GHPLs3[1*4*4+2*4+2]
									 + 1.0/2 * GHPLs3[3*4*4+3*4+2]
									 - 3 * GHPLs2[3*4+2]
									 - 2 * GHPLs1[2]
									 - 5.0/2 * GHPLs1[2] * zeta2
									 - 15.0/8 * GHPLs1[2] * HPLs1[0]
									 + 7.0/4 * GHPLs1[2] * HPLs2[0*2+0]
									 + 5.0/4 * GHPLs1[2] * HPLs2[1*2+0]
									 - 5.0/4 * GHPLs1[2] * HPLs1[1]
									 - 5.0/4 * GHPLs1[2] * HPLs2[0*2+1]
									 - 7.0/4 * GHPLs3[3*4*4+0*4+2]
									 + 5.0/4 * GHPLs2[0*4+2]
									 - 5.0/4 * GHPLs2[0*4+2] * HPLs1[0]
									 + 5.0/4 * GHPLs3[1*4*4+0*4+2]
									 - 9.0/8 * GHPLs2[1*4+2]
									 - 1.0/4 * GHPLs2[1*4+2] * HPLs1[0]
									 + 1.0/2 * GHPLs3[1*4*4+1*4+2]
									 - 1.0/8 * GHPLs2[2*4+3]
									 - 5.0/8 * GHPLs2[3*4+3]
									 + 1.0/8 * GHPLs1[3]
									 + 1.0/8 * GHPLs1[3] * HPLs1[0]
									 + 1.0/8 * GHPLs1[3] * HPLs1[1]
									 - 1.0/8 * GHPLs2[0*4+3]
									 + 5.0/4 * GHPLs2[2*4+0]
									 + 1.0/2 * GHPLs2[3*4+0]
									 - 3.0/4 * GHPLs1[0]
									 - 5.0/4 * GHPLs1[0] * HPLs1[1]
									 - 1.0/2 * GHPLs2[1*4+0]
									 - 5.0/4 * GHPLs3[2*4*4+2*4+1]
									 + 5.0/4 * GHPLs3[3*4*4+2*4+1]
									 - 1.0/8 * GHPLs2[2*4+1]
									 + 3.0/2 * GHPLs2[2*4+1] * HPLs1[0]
									 + 5.0/4 * GHPLs2[2*4+1] * HPLs1[1]
									 - 5.0/4 * GHPLs3[0*4*4+2*4+1]
									 + 3.0/2 * GHPLs3[1*4*4+2*4+1]
									 + 7.0/16 * GHPLs1[1]
									 + 9.0/4 * GHPLs1[1] * zeta2
									 - 3.0/8 * GHPLs1[1] * HPLs1[0]
									 - 7.0/4 * GHPLs1[1] * HPLs2[0*2+0]
									 - 5.0/4 * GHPLs1[1] * HPLs2[1*2+0]
									 + 1.0/8 * GHPLs1[1] * HPLs1[1]
									 - 3.0/2 * GHPLs1[1] * HPLs2[0*2+1]
									 - 5.0/4 * GHPLs1[1] * HPLs2[1*2+1]
									 - 5.0/4 * GHPLs3[2*4*4+0*4+1]
									 + 5.0/4 * GHPLs3[3*4*4+0*4+1]
									 + 11.0/8 * GHPLs2[0*4+1]
									 + 5.0/4 * GHPLs2[0*4+1] * HPLs1[0]
									 + 5.0/4 * GHPLs2[0*4+1] * HPLs1[1]
									 - 1.0/4 * GHPLs3[1*4*4+0*4+1]
									 + 1.0/2 * GHPLs3[2*4*4+1*4+1]
									 - 3.0/4 * GHPLs2[1*4+1]
									 - 1.0/2 * GHPLs2[1*4+1] * HPLs1[1]
									 - 5.0/4 * GHPLs3[0*4*4+1*4+1]
									 + 3.0/4 * GHPLs3[1*4*4+1*4+1]
									 + 1.0/8 * HPLs1[0]
									 + 2 * HPLs1[1]
									 + 11.0/4 * HPLs2[0*2+1]
									 + 5.0/4 * HPLs2[1*2+1]
									 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(v, 2) * (
										 - 23.0/16
										 + 9.0/4 * zeta2
										 - 5.0/4 * GHPLs2[2*4+2]
										 + 5.0/4 * GHPLs2[3*4+2]
										 + 7.0/4 * GHPLs1[2]
										 + 3.0/2 * GHPLs1[2] * HPLs1[0]
										 + 5.0/4 * GHPLs1[2] * HPLs1[1]
										 - 5.0/4 * GHPLs2[0*4+2]
										 + 7.0/4 * GHPLs2[1*4+2]
										 - 1.0/4 * GHPLs2[2*4+3]
										 + 1.0/4 * GHPLs2[3*4+3]
										 - 11.0/8 * GHPLs1[3]
										 + 1.0/4 * GHPLs1[3] * HPLs1[0]
										 + 1.0/4 * GHPLs1[3] * HPLs1[1]
										 - 1.0/4 * GHPLs2[0*4+3]
										 - 5.0/4 * GHPLs2[2*4+0]
										 + 5.0/4 * GHPLs2[3*4+0]
										 + 1.0/2 * GHPLs1[0]
										 + 5.0/4 * GHPLs1[0] * HPLs1[0]
										 + 5.0/4 * GHPLs1[0] * HPLs1[1]
										 - 1.0/2 * GHPLs2[1*4+0]
										 + 1.0/2 * GHPLs2[2*4+1]
										 + 3.0/8 * GHPLs1[1]
										 - 1.0/2 * GHPLs1[1] * HPLs1[1]
										 - GHPLs2[0*4+1]
										 + 3.0/4 * GHPLs2[1*4+1]
										 - 7.0/4 * HPLs1[0]
										 - 7.0/4 * HPLs2[0*2+0]
										 - 5.0/4 * HPLs2[1*2+0]
										 - 7.0/4 * HPLs1[1]
										 - 3.0/2 * HPLs2[0*2+1]
										 - 5.0/4 * HPLs2[1*2+1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, -1) * pow(v, 3) * (
										 + 1.0/8 * GHPLs1[2]
										 + 3.0/8 * GHPLs2[1*4+2]
										 - 3.0/8 * GHPLs2[2*4+3]
										 + 3.0/8 * GHPLs2[3*4+3]
										 - 1.0/8 * GHPLs1[3]
										 + 3.0/8 * GHPLs1[3] * HPLs1[0]
										 + 3.0/8 * GHPLs1[3] * HPLs1[1]
										 - 3.0/8 * GHPLs2[0*4+3]
										 + 1.0/8 * GHPLs1[0]
										 - 1.0/8 * GHPLs1[1]
										 - 1.0/8 * HPLs1[0]
										 - 1.0/8 * HPLs1[1]
										 )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(1. - v, -1) * (
									  - 5.0/4 * zeta2
									  + 7.0/8 * GHPLs2[3*4+2]
									  + 3.0/4 * GHPLs1[2] * HPLs1[0]
									  - 1.0/2 * GHPLs2[1*4+2]
									  + 1.0/2 * GHPLs1[3]
									  - 7.0/8 * GHPLs2[3*4+0]
									  - 5.0/8 * GHPLs1[0] * HPLs1[0]
									  + 1.0/2 * GHPLs2[1*4+0]
									  - 1.0/8 * GHPLs1[1]
									  + 15.0/16 * HPLs1[0]
									  + 7.0/8 * HPLs2[0*2+0]
									  + 5.0/8 * HPLs2[1*2+0]
									  - 5.0/8 * HPLs2[0*2+1]
									  )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * (
							- 1.0/4
							+ 5.0/4 * zeta2
							- 7.0/8 * GHPLs2[3*4+2]
							- 3.0/4 * GHPLs1[2] * HPLs1[0]
							+ 1.0/2 * GHPLs2[1*4+2]
							- 3.0/8 * GHPLs1[3]
							+ 7.0/8 * GHPLs2[3*4+0]
							+ 5.0/8 * GHPLs1[0] * HPLs1[0]
							- 1.0/2 * GHPLs2[1*4+0]
							+ 5.0/8 * GHPLs1[1]
							- 13.0/16 * HPLs1[0]
							- 7.0/8 * HPLs2[0*2+0]
							- 5.0/8 * HPLs2[1*2+0]
							+ 5.0/8 * HPLs2[0*2+1]
							)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * pow(1. - u, -1) * (
									      - 17.0/32
									      - 1.0/8 * GHPLs2[2*4+2]
									      + 1.0/8 * GHPLs2[3*4+2]
									      - 3.0/16 * GHPLs1[2]
									      + 1.0/4 * GHPLs1[2] * HPLs1[0]
									      + 1.0/8 * GHPLs1[2] * HPLs1[1]
									      - 1.0/8 * GHPLs2[0*4+2]
									      + 1.0/4 * GHPLs2[1*4+2]
									      - 1.0/8 * GHPLs1[3]
									      - 1.0/8 * GHPLs2[2*4+0]
									      + 1.0/8 * GHPLs2[3*4+0]
									      - 1.0/2 * GHPLs1[0]
									      + 1.0/8 * GHPLs1[0] * HPLs1[0]
									      + 1.0/8 * GHPLs1[0] * HPLs1[1]
									      - 1.0/8 * GHPLs2[1*4+0]
									      + 1.0/4 * GHPLs2[2*4+1]
									      + 3.0/16 * GHPLs1[1]
									      - 1.0/4 * GHPLs1[1] * HPLs1[1]
									      - 1.0/4 * GHPLs2[1*4+1]
									      - 1.0/16 * HPLs1[0]
									      - 3.0/8 * HPLs2[0*2+0]
									      - 1.0/8 * HPLs2[1*2+0]
									      + 3.0/16 * HPLs1[1]
									      - 1.0/4 * HPLs2[0*2+1]
									      - 1.0/8 * HPLs2[1*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * v * (
							    + 3.0/8
							    + 9.0/8 * zeta2
							    - 1.0/2 * GHPLs2[2*4+2]
							    + 1.0/2 * GHPLs2[3*4+2]
							    + 13.0/8 * GHPLs1[2]
							    + 1.0/2 * GHPLs1[2] * HPLs1[0]
							    + 1.0/2 * GHPLs1[2] * HPLs1[1]
							    - 1.0/2 * GHPLs2[0*4+2]
							    + 5.0/8 * GHPLs2[1*4+2]
							    - 1.0/8 * GHPLs2[2*4+3]
							    + 1.0/8 * GHPLs2[3*4+3]
							    - 13.0/8 * GHPLs1[3]
							    + 1.0/8 * GHPLs1[3] * HPLs1[0]
							    + 1.0/8 * GHPLs1[3] * HPLs1[1]
							    - 1.0/8 * GHPLs2[0*4+3]
							    - 1.0/2 * GHPLs2[2*4+0]
							    + 1.0/2 * GHPLs2[3*4+0]
							    + 13.0/8 * GHPLs1[0]
							    + 1.0/2 * GHPLs1[0] * HPLs1[0]
							    + 1.0/2 * GHPLs1[0] * HPLs1[1]
							    - 1.0/8 * GHPLs2[1*4+0]
							    - 11.0/8 * GHPLs1[1]
							    - 1.0/2 * GHPLs2[0*4+1]
							    + 5.0/8 * GHPLs2[1*4+1]
							    - 13.0/8 * HPLs1[0]
							    - 1.0/2 * HPLs2[0*2+0]
							    - 1.0/2 * HPLs2[1*2+0]
							    - 13.0/8 * HPLs1[1]
							    - 1.0/2 * HPLs2[0*2+1]
							    - 1.0/2 * HPLs2[1*2+1]
							    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(v, 2) * pow(1. - u, -2) * (
										      + 23.0/32
										      + 1.0/8 * GHPLs2[2*4+2]
										      - 1.0/8 * GHPLs2[3*4+2]
										      + 1.0/16 * GHPLs1[2]
										      - 1.0/4 * GHPLs1[2] * HPLs1[0]
										      - 1.0/8 * GHPLs1[2] * HPLs1[1]
										      + 1.0/8 * GHPLs2[0*4+2]
										      - 1.0/4 * GHPLs2[1*4+2]
										      + 1.0/8 * GHPLs2[2*4+0]
										      - 1.0/8 * GHPLs2[3*4+0]
										      + 3.0/8 * GHPLs1[0]
										      - 1.0/8 * GHPLs1[0] * HPLs1[0]
										      - 1.0/8 * GHPLs1[0] * HPLs1[1]
										      + 1.0/8 * GHPLs2[1*4+0]
										      - 1.0/4 * GHPLs2[2*4+1]
										      - 7.0/16 * GHPLs1[1]
										      + 1.0/4 * GHPLs1[1] * HPLs1[1]
										      + 1.0/4 * GHPLs2[1*4+1]
										      + 3.0/16 * HPLs1[0]
										      + 3.0/8 * HPLs2[0*2+0]
										      + 1.0/8 * HPLs2[1*2+0]
										      - 1.0/16 * HPLs1[1]
										      + 1.0/4 * HPLs2[0*2+1]
										      + 1.0/8 * HPLs2[1*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(v, 2) * pow(1. - u, -1) * (
										      - 23.0/16
										      + zeta2
										      - 3.0/4 * GHPLs2[2*4+2]
										      + 3.0/4 * GHPLs2[3*4+2]
										      + 1.0/2 * GHPLs1[2]
										      + GHPLs1[2] * HPLs1[0]
										      + 3.0/4 * GHPLs1[2] * HPLs1[1]
										      - 3.0/4 * GHPLs2[0*4+2]
										      + GHPLs2[1*4+2]
										      - 1.0/8 * GHPLs1[3]
										      - 3.0/4 * GHPLs2[2*4+0]
										      + 3.0/4 * GHPLs2[3*4+0]
										      - 3.0/4 * GHPLs1[0]
										      + 3.0/4 * GHPLs1[0] * HPLs1[0]
										      + 3.0/4 * GHPLs1[0] * HPLs1[1]
										      - 1.0/4 * GHPLs2[1*4+0]
										      + 1.0/2 * GHPLs2[2*4+1]
										      + 5.0/4 * GHPLs1[1]
										      - 1.0/2 * GHPLs1[1] * HPLs1[1]
										      - 1.0/2 * GHPLs2[0*4+1]
										      - 1.0/2 * HPLs1[0]
										      - 5.0/4 * HPLs2[0*2+0]
										      - 3.0/4 * HPLs2[1*2+0]
										      - 1.0/2 * HPLs1[1]
										      - HPLs2[0*2+1]
										      - 3.0/4 * HPLs2[1*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(v, 2) * (
								    + 1.0/8 * zeta2
								    + 1.0/2 * GHPLs1[2]
								    + 3.0/8 * GHPLs2[1*4+2]
								    - 3.0/8 * GHPLs2[2*4+3]
								    + 3.0/8 * GHPLs2[3*4+3]
								    - 1.0/2 * GHPLs1[3]
								    + 3.0/8 * GHPLs1[3] * HPLs1[0]
								    + 3.0/8 * GHPLs1[3] * HPLs1[1]
								    - 3.0/8 * GHPLs2[0*4+3]
								    + 1.0/2 * GHPLs1[0]
								    - 1.0/8 * GHPLs2[1*4+0]
								    - 1.0/2 * GHPLs1[1]
								    + 1.0/8 * GHPLs2[1*4+1]
								    - 1.0/2 * HPLs1[0]
								    - 1.0/2 * HPLs1[1]
								    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - v, -2) * (
									      - 5.0/4 * zeta2
									      + 7.0/8 * GHPLs2[3*4+2]
									      + 3.0/4 * GHPLs1[2] * HPLs1[0]
									      - 1.0/2 * GHPLs2[1*4+2]
									      - 9.0/8 * GHPLs1[3]
									      - 7.0/8 * GHPLs2[3*4+0]
									      - 5.0/8 * GHPLs1[0] * HPLs1[0]
									      + 1.0/2 * GHPLs2[1*4+0]
									      + 9.0/8 * GHPLs1[1]
									      - 15.0/16 * HPLs1[0]
									      + 7.0/8 * HPLs2[0*2+0]
									      + 5.0/8 * HPLs2[1*2+0]
									      - 5.0/8 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * pow(1. - v, -1) * (
									      - 5.0/16
									      + 5.0/4 * zeta2
									      - 7.0/8 * GHPLs2[3*4+2]
									      - 5.0/8 * GHPLs1[2]
									      - 3.0/4 * GHPLs1[2] * HPLs1[0]
									      + 1.0/2 * GHPLs2[1*4+2]
									      + 2 * GHPLs1[3]
									      + 7.0/8 * GHPLs2[3*4+0]
									      - 5.0/8 * GHPLs1[0]
									      + 5.0/8 * GHPLs1[0] * HPLs1[0]
									      - 1.0/2 * GHPLs2[1*4+0]
									      - 5.0/8 * GHPLs1[1]
									      + 29.0/16 * HPLs1[0]
									      - 7.0/8 * HPLs2[0*2+0]
									      - 5.0/8 * HPLs2[1*2+0]
									      + 5.0/8 * HPLs1[1]
									      + 5.0/8 * HPLs2[0*2+1]
									      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * (
							    + 3.0/8
							    + 3.0/4 * GHPLs1[2]
							    - 3.0/4 * GHPLs1[3]
							    + 3.0/4 * GHPLs1[0]
							    - 3.0/4 * GHPLs1[1]
							    - 3.0/4 * HPLs1[0]
							    - 3.0/4 * HPLs1[1]
							    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * u * v * (
								+ 1.0/8 * zeta2
								+ 1.0/4 * GHPLs1[2]
								+ 1.0/8 * GHPLs2[1*4+2]
								- 1.0/8 * GHPLs2[2*4+3]
								+ 1.0/8 * GHPLs2[3*4+3]
								- 1.0/4 * GHPLs1[3]
								+ 1.0/8 * GHPLs1[3] * HPLs1[0]
								+ 1.0/8 * GHPLs1[3] * HPLs1[1]
								- 1.0/8 * GHPLs2[0*4+3]
								+ 1.0/4 * GHPLs1[0]
								- 1.0/8 * GHPLs2[1*4+0]
								- 1.0/4 * GHPLs1[1]
								+ 1.0/8 * GHPLs2[1*4+1]
								- 1.0/4 * HPLs1[0]
								- 1.0/4 * HPLs1[1]
								)

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -3) * (
										      + 9.0/2 * zeta2
										      - 9.0/4 * GHPLs2[3*4+2]
										      - 9.0/4 * GHPLs1[2] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+2]
										      + 9.0/4 * GHPLs1[3]
										      + 9.0/4 * GHPLs2[3*4+0]
										      + 9.0/4 * GHPLs1[0] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+0]
										      - 9.0/4 * GHPLs1[1]
										      + 9.0/4 * HPLs1[0]
										      - 9.0/4 * HPLs2[0*2+0]
										      - 9.0/4 * HPLs2[1*2+0]
										      + 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -2) * (
										      - 9.0/2 * zeta2
										      + 9.0/4 * GHPLs2[3*4+2]
										      + 9.0/4 * GHPLs1[2]
										      + 9.0/4 * GHPLs1[2] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+2]
										      - 9.0/2 * GHPLs1[3]
										      - 9.0/4 * GHPLs2[3*4+0]
										      + 9.0/4 * GHPLs1[0]
										      - 9.0/4 * GHPLs1[0] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+0]
										      - 9.0/2 * HPLs1[0]
										      + 9.0/4 * HPLs2[0*2+0]
										      + 9.0/4 * HPLs2[1*2+0]
										      - 9.0/4 * HPLs1[1]
										      - 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * pow(1. - v, -1) * (
										      - 9.0/8 * GHPLs1[2]
										      + 9.0/8 * GHPLs1[3]
										      - 9.0/8 * GHPLs1[0]
										      + 9.0/8 * GHPLs1[1]
										      + 9.0/8 * HPLs1[0]
										      + 9.0/8 * HPLs1[1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 2) * (
								    - 1.0/2 * GHPLs1[2]
								    + 1.0/2 * GHPLs1[3]
								    - 1.0/2 * GHPLs1[0]
								    + 1.0/2 * GHPLs1[1]
								    + 1.0/2 * HPLs1[0]
								    + 1.0/2 * HPLs1[1]
								    )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -4) * (
										      - 9.0/2 * zeta2
										      + 9.0/4 * GHPLs2[3*4+2]
										      + 9.0/4 * GHPLs1[2] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+2]
										      - 9.0/4 * GHPLs2[3*4+0]
										      - 9.0/4 * GHPLs1[0] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+0]
										      + 9.0/4 * HPLs2[0*2+0]
										      + 9.0/4 * HPLs2[1*2+0]
										      - 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -3) * (
										      + 9.0/2 * zeta2
										      - 9.0/4 * GHPLs2[3*4+2]
										      - 9.0/4 * GHPLs1[2]
										      - 9.0/4 * GHPLs1[2] * HPLs1[0]
										      + 9.0/4 * GHPLs2[1*4+2]
										      + 9.0/4 * GHPLs1[3]
										      + 9.0/4 * GHPLs2[3*4+0]
										      - 9.0/4 * GHPLs1[0]
										      + 9.0/4 * GHPLs1[0] * HPLs1[0]
										      - 9.0/4 * GHPLs2[1*4+0]
										      + 9.0/4 * GHPLs1[1]
										      + 9.0/4 * HPLs1[0]
										      - 9.0/4 * HPLs2[0*2+0]
										      - 9.0/4 * HPLs2[1*2+0]
										      + 9.0/4 * HPLs1[1]
										      + 9.0/4 * HPLs2[0*2+1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -2) * (
										      + 9.0/8 * GHPLs1[2]
										      - 9.0/8 * GHPLs1[3]
										      + 9.0/8 * GHPLs1[0]
										      - 9.0/8 * GHPLs1[1]
										      - 9.0/8 * HPLs1[0]
										      - 9.0/8 * HPLs1[1]
										      )

    + (dN_c * dN_c - 1.) / (dN_c * dN_c) * ri * M_PI * pow(u, 3) * pow(1. - v, -1) * (
										      + 3.0/8 * GHPLs1[2]
										      - 3.0/8 * GHPLs1[3]
										      + 3.0/8 * GHPLs1[0]
										      - 3.0/8 * GHPLs1[1]
										      - 3.0/8 * HPLs1[0]
										      - 3.0/8 * HPLs1[1]
										      )

    + C_F * dN_f * pow(u, -2) * v * (
				   + 1.0/3 * GHPLs2[2*4+2] * HPLs1[0]
				   + 1.0/3 * GHPLs1[2] * zeta2
				   - 19.0/18 * GHPLs1[2] * HPLs1[0]
				   - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				   - 1.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				   + 1.0/3 * GHPLs3[2*4*4+2*4+1]
				   - 19.0/18 * GHPLs2[2*4+1]
				   - 1.0/3 * GHPLs2[2*4+1] * HPLs1[0]
				   - 1.0/3 * GHPLs2[2*4+1] * HPLs1[1]
				   + 1.0/3 * GHPLs1[1] * zeta2
				   + 19.0/18 * GHPLs1[1] * HPLs1[0]
				   + 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
				   + 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
				   + 19.0/18 * GHPLs1[1] * HPLs1[1]
				   + 1.0/3 * GHPLs1[1] * HPLs2[0*2+1]
				   + 1.0/3 * GHPLs1[1] * HPLs2[1*2+1]
				   + 1.0/3 * GHPLs3[2*4*4+1*4+1]
				   - 1.0/3 * GHPLs2[1*4+1] * HPLs1[0]
				   - 1.0/3 * GHPLs2[1*4+1] * HPLs1[1]
				   )

    + C_F * dN_f * pow(u, -2) * pow(v, 2) * (
					   - 1.0/3 * GHPLs2[2*4+2] * HPLs1[0]
					   - 1.0/3 * GHPLs1[2] * zeta2
					   + 19.0/18 * GHPLs1[2] * HPLs1[0]
					   + 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
					   + 1.0/3 * GHPLs1[2] * HPLs2[1*2+0]
					   - 1.0/3 * GHPLs3[2*4*4+2*4+1]
					   + 19.0/18 * GHPLs2[2*4+1]
					   + 1.0/3 * GHPLs2[2*4+1] * HPLs1[0]
					   + 1.0/3 * GHPLs2[2*4+1] * HPLs1[1]
					   - 1.0/3 * GHPLs1[1] * zeta2
					   - 19.0/18 * GHPLs1[1] * HPLs1[0]
					   - 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
					   - 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
					   - 19.0/18 * GHPLs1[1] * HPLs1[1]
					   - 1.0/3 * GHPLs1[1] * HPLs2[0*2+1]
					   - 1.0/3 * GHPLs1[1] * HPLs2[1*2+1]
					   - 1.0/3 * GHPLs3[2*4*4+1*4+1]
					   + 1.0/3 * GHPLs2[1*4+1] * HPLs1[0]
					   + 1.0/3 * GHPLs2[1*4+1] * HPLs1[1]
					   )

    + C_F * dN_f * pow(u, -1) * v * (
				   + 2.0/3 * zeta2
				   + 1.0/3 * GHPLs2[2*4+2]
				   - 1.0/3 * GHPLs2[2*4+2] * HPLs1[0]
				   - 19.0/18 * GHPLs1[2]
				   - 1.0/3 * GHPLs1[2] * zeta2
				   + 19.0/18 * GHPLs1[2] * HPLs1[0]
				   + 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				   + 1.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				   - 1.0/3 * GHPLs1[2] * HPLs1[1]
				   - 1.0/3 * GHPLs3[2*4*4+2*4+1]
				   + 25.0/18 * GHPLs2[2*4+1]
				   + 1.0/3 * GHPLs2[2*4+1] * HPLs1[0]
				   + 1.0/3 * GHPLs2[2*4+1] * HPLs1[1]
				   - 1.0/3 * GHPLs1[1] * zeta2
				   - 25.0/18 * GHPLs1[1] * HPLs1[0]
				   - 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
				   - 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
				   - 25.0/18 * GHPLs1[1] * HPLs1[1]
				   - 1.0/3 * GHPLs1[1] * HPLs2[0*2+1]
				   - 1.0/3 * GHPLs1[1] * HPLs2[1*2+1]
				   - 1.0/3 * GHPLs3[2*4*4+1*4+1]
				   + 1.0/3 * GHPLs2[1*4+1] * HPLs1[0]
				   + 1.0/3 * GHPLs2[1*4+1] * HPLs1[1]
				   + 1.0/3 * HPLs2[1*2+0]
				   + 19.0/18 * HPLs1[1]
				   + 1.0/3 * HPLs2[0*2+1]
				   + 1.0/3 * HPLs2[1*2+1]
				   )

    + C_F * dN_f * pow(u, -1) * pow(v, 2) * (
					   - 1.0/3 * zeta2
					   - 1.0/3 * GHPLs2[2*4+2]
					   + 19.0/18 * GHPLs1[2]
					   + 1.0/3 * GHPLs1[2] * HPLs1[0]
					   + 1.0/3 * GHPLs1[2] * HPLs1[1]
					   - 1.0/3 * GHPLs2[2*4+1]
					   + 1.0/3 * GHPLs1[1] * HPLs1[0]
					   + 1.0/3 * GHPLs1[1] * HPLs1[1]
					   - 19.0/18 * HPLs1[0]
					   - 2.0/3 * HPLs2[0*2+0]
					   - 2.0/3 * HPLs2[1*2+0]
					   - 19.0/18 * HPLs1[1]
					   - 1.0/3 * HPLs2[0*2+1]
					   - 1.0/3 * HPLs2[1*2+1]
					   )

    + C_F * dN_f * pow(1. - v, -1) * (
				    - 1.0/6 * zeta2
				    - 1.0/6 * GHPLs1[2] * HPLs1[0]
				    + 25.0/36 * HPLs1[0]
				    + 1.0/3 * HPLs2[0*2+0]
				    + 1.0/6 * HPLs2[1*2+0]
				    )

    + C_F * dN_f * (
		  + 1.0/6 * zeta2
		  + 1.0/6 * GHPLs1[2] * HPLs1[0]
		  - 25.0/36 * HPLs1[0]
		  - 1.0/3 * HPLs2[0*2+0]
		  - 1.0/6 * HPLs2[1*2+0]
		  )

    + C_F * dN_f * v * pow(1. - u, -1) * (
					- 19.0/36
					- 1.0/6 * zeta2
					- 1.0/6 * GHPLs2[2*4+2]
					+ 31.0/36 * GHPLs1[2]
					+ 1.0/6 * GHPLs1[2] * HPLs1[0]
					+ 1.0/6 * GHPLs1[2] * HPLs1[1]
					- 1.0/6 * GHPLs2[2*4+1]
					+ 1.0/6 * GHPLs1[1] * HPLs1[0]
					+ 1.0/6 * GHPLs1[1] * HPLs1[1]
					- 31.0/36 * HPLs1[0]
					- 1.0/3 * HPLs2[0*2+0]
					- 1.0/3 * HPLs2[1*2+0]
					- 31.0/36 * HPLs1[1]
					- 1.0/6 * HPLs2[0*2+1]
					- 1.0/6 * HPLs2[1*2+1]
					)

    + C_F * dN_f * pow(v, 2) * pow(1. - u, -2) * (
						+ 1.0/6 * zeta2
						+ 1.0/6 * GHPLs2[2*4+2]
						- 25.0/36 * GHPLs1[2]
						- 1.0/6 * GHPLs1[2] * HPLs1[0]
						- 1.0/6 * GHPLs1[2] * HPLs1[1]
						+ 1.0/6 * GHPLs2[2*4+1]
						- 1.0/6 * GHPLs1[1] * HPLs1[0]
						- 1.0/6 * GHPLs1[1] * HPLs1[1]
						+ 25.0/36 * HPLs1[0]
						+ 1.0/3 * HPLs2[0*2+0]
						+ 1.0/3 * HPLs2[1*2+0]
						+ 25.0/36 * HPLs1[1]
						+ 1.0/6 * HPLs2[0*2+1]
						+ 1.0/6 * HPLs2[1*2+1]
						)

    + C_F * dN_f * pow(v, 2) * pow(1. - u, -1) * (
						- 1.0/3 * zeta2
						- 1.0/3 * GHPLs2[2*4+2]
						+ 19.0/18 * GHPLs1[2]
						+ 1.0/3 * GHPLs1[2] * HPLs1[0]
						+ 1.0/3 * GHPLs1[2] * HPLs1[1]
						- 1.0/3 * GHPLs2[2*4+1]
						+ 1.0/3 * GHPLs1[1] * HPLs1[0]
						+ 1.0/3 * GHPLs1[1] * HPLs1[1]
						- 19.0/18 * HPLs1[0]
						- 2.0/3 * HPLs2[0*2+0]
						- 2.0/3 * HPLs2[1*2+0]
						- 19.0/18 * HPLs1[1]
						- 1.0/3 * HPLs2[0*2+1]
						- 1.0/3 * HPLs2[1*2+1]
						)

    + C_F * dN_f * u * pow(1. - v, -2) * (
					- 1.0/6 * zeta2
					- 1.0/6 * GHPLs1[2] * HPLs1[0]
					+ 13.0/36 * HPLs1[0]
					+ 1.0/3 * HPLs2[0*2+0]
					+ 1.0/6 * HPLs2[1*2+0]
					)

    + C_F * dN_f * u * pow(1. - v, -1) * (
					+ 19.0/36
					+ 1.0/6 * zeta2
					- 1.0/6 * GHPLs1[2]
					+ 1.0/6 * GHPLs1[2] * HPLs1[0]
					- 7.0/36 * HPLs1[0]
					- 1.0/3 * HPLs2[0*2+0]
					- 1.0/6 * HPLs2[1*2+0]
					+ 1.0/6 * HPLs1[1]
					)

    + C_F * dN_f * ri * M_PI * pow(u, -2) * v * (
					       - 19.0/18 * GHPLs1[1]
					       - 1.0/3 * GHPLs1[1] * HPLs1[0]
					       + 1.0/3 * GHPLs2[1*4+1]
					       )

    + C_F * dN_f * ri * M_PI * pow(u, -2) * pow(v, 2) * (
						       + 19.0/18 * GHPLs1[1]
						       + 1.0/3 * GHPLs1[1] * HPLs1[0]
						       - 1.0/3 * GHPLs2[1*4+1]
						       )

    + C_F * dN_f * ri * M_PI * pow(u, -1) * v * (
					       - 19.0/18
					       + 25.0/18 * GHPLs1[1]
					       + 1.0/3 * GHPLs1[1] * HPLs1[0]
					       - 1.0/3 * GHPLs2[1*4+1]
					       - 1.0/3 * HPLs1[0]
					       )

    + C_F * dN_f * ri * M_PI * pow(u, -1) * pow(v, 2) * (
						       + 19.0/18
						       - 1.0/3 * GHPLs1[1]
						       + 1.0/3 * HPLs1[0]
						       )

    + C_F * dN_f * ri * M_PI * v * pow(1. - u, -1) * (
						    + 25.0/36
						    - 1.0/6 * GHPLs1[1]
						    + 1.0/6 * HPLs1[0]
						    )

    + C_F * dN_f * ri * M_PI * pow(v, 2) * pow(1. - u, -2) * (
							    - 25.0/36
							    + 1.0/6 * GHPLs1[1]
							    - 1.0/6 * HPLs1[0]
							    )

    + C_F * dN_f * ri * M_PI * pow(v, 2) * pow(1. - u, -1) * (
							    + 19.0/18
							    - 1.0/3 * GHPLs1[1]
							    + 1.0/3 * HPLs1[0]
							    );
  return gamma;
}


double_complex pplla03_amplitude_set::gamma_2_3(){
  double_complex gamma = 0;
  return gamma;
}


double_complex pplla03_amplitude_set::gamma_2_4(){
  //  const double zeta2 = M_PI * M_PI/6;
  //  const double zeta3 = 1.20205690315959429;
  //  const double zeta4 = pow(M_PI,4)/90;
  //  const double dN_c=3;
  //  const double C_F=(dN_c * dN_c - 1.) / (2 * dN_c);
  //  double NF=(double)n_f;

  double_complex gamma =
    C_F * pow(u, -2) * v * (
			    + 4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
			    - 4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
			    - 4 * GHPLs2[2*4+2] * zeta2
			    + 4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
			    - 4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
			    - 4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
			    + 2.0/3 * GHPLs1[2] * zeta2
			    - 4 * GHPLs1[2] * zeta3
			    + GHPLs1[2] * HPLs1[0]
			    - 4 * GHPLs1[2] * HPLs1[0] * zeta2
			    - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
			    + 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
			    - 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
			    - 4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
			    - 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
			    - 4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
			    + 4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
			    - 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
			    - 4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
			    - 2.0/3 * GHPLs3[2*4*4+1*4+2]
			    + 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
			    + 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
			    + 4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
			    - 4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
			    + GHPLs2[2*4+1]
			    - 4 * GHPLs2[2*4+1] * zeta2
			    + 4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
			    - 4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
			    - 2.0/3 * GHPLs3[0*4*4+2*4+1]
			    - 4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
			    + 8.0/3 * GHPLs1[1] * zeta2
			    - 4 * GHPLs1[1] * zeta3
			    - GHPLs1[1] * HPLs1[0]
			    + 4 * GHPLs1[1] * HPLs1[0] * zeta2
			    + 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
			    - 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
			    + 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
			    + 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
			    - GHPLs1[1] * HPLs1[1]
			    + 4 * GHPLs1[1] * HPLs1[1] * zeta2
			    - 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
			    + 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
			    - 2.0/3 * GHPLs3[2*4*4+0*4+1]
			    + 4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
			    - 4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
			    + 8 * GHPLs2[0*4+1] * zeta2
			    + 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
			    + 4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
			    + 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
			    + 4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
			    + 2.0/3 * GHPLs3[2*4*4+1*4+1]
			    - 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
			    - 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
			    )

    + C_F * pow(u, -2) * pow(v, 2) * (
				      - 4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
				      + 4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
				      + 4 * GHPLs2[2*4+2] * zeta2
				      - 4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
				      + 4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
				      + 4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
				      - 2.0/3 * GHPLs1[2] * zeta2
				      + 4 * GHPLs1[2] * zeta3
				      - 2.0/3 * GHPLs1[2] * HPLs1[0]
				      + 4 * GHPLs1[2] * HPLs1[0] * zeta2
				      + 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				      - 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
				      + 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				      + 4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
				      + 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
				      + 4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
				      - 4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
				      + 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
				      + 4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
				      + 2.0/3 * GHPLs3[2*4*4+1*4+2]
				      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
				      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
				      - 4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
				      + 4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
				      - 2.0/3 * GHPLs2[2*4+1]
				      + 4 * GHPLs2[2*4+1] * zeta2
				      - 4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
				      + 4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
				      + 2.0/3 * GHPLs3[0*4*4+2*4+1]
				      + 4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
				      - 8.0/3 * GHPLs1[1] * zeta2
				      + 4 * GHPLs1[1] * zeta3
				      + 2.0/3 * GHPLs1[1] * HPLs1[0]
				      - 4 * GHPLs1[1] * HPLs1[0] * zeta2
				      - 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
				      + 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
				      - 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
				      - 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
				      + 2.0/3 * GHPLs1[1] * HPLs1[1]
				      - 4 * GHPLs1[1] * HPLs1[1] * zeta2
				      + 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
				      - 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
				      + 2.0/3 * GHPLs3[2*4*4+0*4+1]
				      - 4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
				      + 4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
				      - 8 * GHPLs2[0*4+1] * zeta2
				      - 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
				      - 4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
				      - 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
				      - 4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
				      - 2.0/3 * GHPLs3[2*4*4+1*4+1]
				      + 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
				      + 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
				      )

    + C_F * pow(u, -2) * pow(v, 3) * (
				      + 1.0/3 * GHPLs1[2] * HPLs1[0]
				      + 1.0/3 * GHPLs2[2*4+1]
				      - 1.0/3 * GHPLs1[1] * HPLs1[0]
				      - 1.0/3 * GHPLs1[1] * HPLs1[1]
				      )

    + C_F * pow(u, -2) * pow(v, 4) * (
				      - 2.0/3 * GHPLs1[2] * zeta2
				      - 2.0/3 * GHPLs1[2] * HPLs1[0]
				      - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				      + 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				      + 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
				      + 2.0/3 * GHPLs3[2*4*4+1*4+2]
				      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
				      - 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
				      + 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
				      - 2.0/3 * GHPLs3[0*4*4+2*4+3]
				      - 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
				      + 2.0/3 * GHPLs3[0*4*4+3*4+3]
				      + 10.0/3 * GHPLs1[3] * zeta2
				      - 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
				      - 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
				      - 2.0/3 * GHPLs3[2*4*4+0*4+3]
				      + 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
				      - 2.0/3 * GHPLs2[2*4+1]
				      + 2.0/3 * GHPLs1[1] * HPLs1[0]
				      + 2.0/3 * GHPLs1[1] * HPLs1[1]
				      )

    + C_F * pow(u, -2) * pow(v, 5) * (
				      + 2.0/3 * GHPLs1[2] * zeta2
				      + 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				      - 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				      - 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
				      - 2.0/3 * GHPLs3[2*4*4+1*4+2]
				      + 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
				      + 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
				      - 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
				      + 2.0/3 * GHPLs3[0*4*4+2*4+3]
				      + 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
				      - 2.0/3 * GHPLs3[0*4*4+3*4+3]
				      - 10.0/3 * GHPLs1[3] * zeta2
				      + 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
				      + 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
				      + 2.0/3 * GHPLs3[2*4*4+0*4+3]
				      - 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
				      )

    + C_F * pow(u, -1) * (
			  + 3.0/2 * GHPLs1[2] * HPLs1[0]
			  + 3.0/2 * GHPLs2[2*4+1]
			  - 3.0/2 * GHPLs1[1] * HPLs1[0]
			  - 3.0/2 * GHPLs1[1] * HPLs1[1]
			  )

    + C_F * pow(u, -1) * v * (
			      - 14.0/3 * zeta2
			      - 8 * zeta3
			      - 4 * GHPLs3[3*4*4+2*4+2] * HPLs1[0]
			      + 4 * GHPLs4[0*4*4*4+3*4*4+2*4+2]
			      + 4 * GHPLs2[2*4+2] * zeta2
			      - 4 * GHPLs2[2*4+2] * HPLs2[0*2+0]
			      + 4 * GHPLs2[2*4+2] * HPLs2[0*2+1]
			      + 4 * GHPLs3[0*4*4+2*4+2] * HPLs1[0]
			      + 8 * GHPLs2[3*4+2] * HPLs1[0]
			      - 8 * GHPLs3[0*4*4+3*4+2]
			      + 5.0/3 * GHPLs1[2]
			      - 23.0/3 * GHPLs1[2] * zeta2
			      + 4 * GHPLs1[2] * zeta3
			      + 4 * GHPLs1[2] * HPLs1[0] * zeta2
			      + 26.0/3 * GHPLs1[2] * HPLs2[0*2+0]
			      - 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+0]
			      - 1.0/3 * GHPLs1[2] * HPLs2[1*2+0]
			      + 4 * GHPLs1[2] * HPLs3[0*2*2+1*2+0]
			      - 8 * GHPLs1[2] * HPLs2[0*2+1]
			      + 4 * GHPLs1[2] * HPLs3[0*2*2+0*2+1]
			      + 4 * GHPLs3[3*4*4+0*4+2] * HPLs1[0]
			      - 4 * GHPLs4[0*4*4*4+3*4*4+0*4+2]
			      - 2.0/3 * GHPLs2[0*4+2]
			      - 22.0/3 * GHPLs2[0*4+2] * HPLs1[0]
			      + 4 * GHPLs2[0*4+2] * HPLs2[0*2+0]
			      - 1.0/3 * GHPLs3[2*4*4+1*4+2]
			      + 1.0/3 * GHPLs2[1*4+2] * HPLs1[0]
			      + 1.0/3 * GHPLs2[1*4+2] * HPLs1[1]
			      - 2.0/3 * GHPLs2[2*4+0]
			      + GHPLs2[2*4+0] * HPLs1[0]
			      + 8 * GHPLs1[0] * zeta2
			      + 2.0/3 * GHPLs1[0] * HPLs1[1]
			      + 4 * GHPLs1[0] * HPLs2[0*2+1]
			      + GHPLs3[2*4*4+1*4+0]
			      - GHPLs2[1*4+0] * HPLs1[0]
			      - GHPLs2[1*4+0] * HPLs1[1]
			      - 4 * GHPLs3[3*4*4+2*4+1] * HPLs1[0]
			      + 4 * GHPLs4[0*4*4*4+3*4*4+2*4+1]
			      + 4 * GHPLs2[2*4+1] * zeta2
			      - 4 * GHPLs2[2*4+1] * HPLs2[0*2+0]
			      + 4 * GHPLs2[2*4+1] * HPLs2[0*2+1]
			      + 2.0/3 * GHPLs3[0*4*4+2*4+1]
			      + 4 * GHPLs3[0*4*4+2*4+1] * HPLs1[0]
			      - 8.0/3 * GHPLs1[1] * zeta2
			      + 4 * GHPLs1[1] * zeta3
			      - 4 * GHPLs1[1] * HPLs1[0] * zeta2
			      - 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
			      + 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+0]
			      - 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
			      - 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+0]
			      - 4 * GHPLs1[1] * HPLs1[1] * zeta2
			      + 4 * GHPLs1[1] * HPLs3[0*2*2+0*2+1]
			      - 4 * GHPLs1[1] * HPLs3[0*2*2+1*2+1]
			      + 2.0/3 * GHPLs3[2*4*4+0*4+1]
			      - 4 * GHPLs3[3*4*4+0*4+1] * HPLs1[0]
			      + 4 * GHPLs4[0*4*4*4+3*4*4+0*4+1]
			      - 8 * GHPLs2[0*4+1] * zeta2
			      - 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
			      - 4 * GHPLs2[0*4+1] * HPLs2[0*2+0]
			      - 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
			      - 4 * GHPLs2[0*4+1] * HPLs2[0*2+1]
			      - 2.0/3 * GHPLs3[2*4*4+1*4+1]
			      + 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
			      + 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
			      - 5.0/3 * HPLs1[1]
			      + 4 * HPLs1[1] * zeta2
			      - 4 * HPLs2[0*2+1]
			      - 8 * HPLs3[0*2*2+0*2+1]
			      + 4 * HPLs3[0*2*2+1*2+1]
			      )

    + C_F * pow(u, -1) * pow(v, 2) * (
				      + 16.0/3 * zeta2
				      + 4 * zeta3
				      - 4 * GHPLs2[3*4+2] * HPLs1[0]
				      + 4 * GHPLs3[0*4*4+3*4+2]
				      - 4.0/3 * GHPLs1[2]
				      + 4 * GHPLs1[2] * zeta2
				      + 1.0/6 * GHPLs1[2] * HPLs1[0]
				      - 4 * GHPLs1[2] * HPLs2[0*2+0]
				      + 4 * GHPLs1[2] * HPLs2[0*2+1]
				      + 2.0/3 * GHPLs2[0*4+2]
				      + 4 * GHPLs2[0*4+2] * HPLs1[0]
				      + 4 * GHPLs1[3] * HPLs1[0]
				      - 4 * GHPLs2[0*4+3]
				      + 2.0/3 * GHPLs2[2*4+0]
				      - 4 * GHPLs2[3*4+0] * HPLs1[0]
				      + 4 * GHPLs3[0*4*4+3*4+0]
				      - 8 * GHPLs1[0] * zeta2
				      - 2.0/3 * GHPLs1[0] * HPLs1[0]
				      - 4 * GHPLs1[0] * HPLs2[0*2+0]
				      - 2.0/3 * GHPLs1[0] * HPLs1[1]
				      - 4 * GHPLs1[0] * HPLs2[0*2+1]
				      - 1.0/2 * GHPLs2[2*4+1]
				      + 1.0/2 * GHPLs1[1] * HPLs1[0]
				      + 1.0/2 * GHPLs1[1] * HPLs1[1]
				      + 5.0/3 * HPLs1[0]
				      - 4 * HPLs1[0] * zeta2
				      + 10.0/3 * HPLs2[0*2+0]
				      + 4 * HPLs3[0*2*2+0*2+0]
				      - 2.0/3 * HPLs2[1*2+0]
				      - 4 * HPLs3[0*2*2+1*2+0]
				      + 4.0/3 * HPLs1[1]
				      - 4 * HPLs1[1] * zeta2
				      + 4 * HPLs2[0*2+1]
				      + 4 * HPLs3[0*2*2+0*2+1]
				      - 4 * HPLs3[0*2*2+1*2+1]
				      )

    + C_F * pow(u, -1) * pow(v, 3) * (
				      - 10.0/3 * zeta2
				      - 1.0/3 * GHPLs1[2]
				      - 2 * GHPLs1[2] * zeta2
				      - 10.0/3 * GHPLs1[2] * HPLs1[0]
				      - 2 * GHPLs1[2] * HPLs2[0*2+0]
				      + 2 * GHPLs1[2] * HPLs2[1*2+0]
				      + 2.0/3 * GHPLs2[0*4+2]
				      + 2 * GHPLs2[0*4+2] * HPLs1[0]
				      + 2 * GHPLs3[2*4*4+1*4+2]
				      - 2 * GHPLs2[1*4+2] * HPLs1[0]
				      - 2 * GHPLs2[1*4+2] * HPLs1[1]
				      + 2 * GHPLs2[2*4+3] * HPLs1[0]
				      - 2 * GHPLs3[0*4*4+2*4+3]
				      - 2 * GHPLs2[3*4+3] * HPLs1[0]
				      + 2 * GHPLs3[0*4*4+3*4+3]
				      + 10 * GHPLs1[3] * zeta2
				      + 2.0/3 * GHPLs1[3] * HPLs1[0]
				      - 2 * GHPLs1[3] * HPLs2[1*2+0]
				      - 2 * GHPLs1[3] * HPLs2[0*2+1]
				      - 2 * GHPLs3[2*4*4+0*4+3]
				      - 2.0/3 * GHPLs2[0*4+3]
				      + 2 * GHPLs2[0*4+3] * HPLs1[1]
				      + 2.0/3 * GHPLs2[2*4+0]
				      - 2.0/3 * GHPLs1[0] * HPLs1[1]
				      - 8.0/3 * GHPLs2[2*4+1]
				      + 8.0/3 * GHPLs1[1] * HPLs1[0]
				      + 8.0/3 * GHPLs1[1] * HPLs1[1]
				      + 1.0/3 * HPLs1[0]
				      + 2.0/3 * HPLs2[1*2+0]
				      + 1.0/3 * HPLs1[1]
				      + 2.0/3 * HPLs2[0*2+1]
				      )

    + C_F * pow(u, -1) * pow(v, 4) * (
				      + 8.0/3 * zeta2
				      + 8.0/3 * GHPLs1[2] * zeta2
				      + 2.0/3 * GHPLs1[2] * HPLs1[0]
				      + 8.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				      - 8.0/3 * GHPLs1[2] * HPLs2[1*2+0]
				      - 2.0/3 * GHPLs2[0*4+2]
				      - 8.0/3 * GHPLs2[0*4+2] * HPLs1[0]
				      - 8.0/3 * GHPLs3[2*4*4+1*4+2]
				      + 8.0/3 * GHPLs2[1*4+2] * HPLs1[0]
				      + 8.0/3 * GHPLs2[1*4+2] * HPLs1[1]
				      - 8.0/3 * GHPLs2[2*4+3] * HPLs1[0]
				      + 8.0/3 * GHPLs3[0*4*4+2*4+3]
				      + 8.0/3 * GHPLs2[3*4+3] * HPLs1[0]
				      - 8.0/3 * GHPLs3[0*4*4+3*4+3]
				      - 40.0/3 * GHPLs1[3] * zeta2
				      - 2.0/3 * GHPLs1[3] * HPLs1[0]
				      + 8.0/3 * GHPLs1[3] * HPLs2[1*2+0]
				      + 8.0/3 * GHPLs1[3] * HPLs2[0*2+1]
				      + 8.0/3 * GHPLs3[2*4*4+0*4+3]
				      + 2.0/3 * GHPLs2[0*4+3]
				      - 8.0/3 * GHPLs2[0*4+3] * HPLs1[1]
				      - 2.0/3 * GHPLs2[2*4+0]
				      + 2.0/3 * GHPLs1[0] * HPLs1[0]
				      + 2.0/3 * GHPLs1[0] * HPLs1[1]
				      + 2.0/3 * GHPLs2[2*4+1]
				      - 2.0/3 * GHPLs1[1] * HPLs1[0]
				      - 2.0/3 * GHPLs1[1] * HPLs1[1]
				      - 2.0/3 * HPLs2[0*2+0]
				      - 2.0/3 * HPLs2[0*2+1]
				      )

    + C_F * pow(1. - u, -1) * (
			       - 3.0/2 * zeta2
			       + 3.0/2 * GHPLs1[3] * HPLs1[0]
			       - 3.0/2 * GHPLs2[0*4+3]
			       - 3.0/2 * GHPLs1[0] * HPLs1[0]
			       + 3.0/2 * HPLs2[0*2+0]
			       - 3.0/2 * HPLs2[0*2+1]
			       )

    + C_F * pow(1. - v, -1) * (
			       - zeta2
			       + 2 * zeta3
			       - 2 * GHPLs2[3*4+2] * HPLs1[0]
			       + 2 * GHPLs3[0*4*4+3*4+2]
			       - 2 * GHPLs1[2] * HPLs2[0*2+0]
			       + 2 * GHPLs1[2] * HPLs2[1*2+0]
			       + 2 * GHPLs1[2] * HPLs2[0*2+1]
			       + 2 * GHPLs2[0*4+2] * HPLs1[0]
			       + 2 * GHPLs3[2*4*4+1*4+2]
			       - 2 * GHPLs2[1*4+2] * HPLs1[0]
			       - 2 * GHPLs2[1*4+2] * HPLs1[1]
			       - GHPLs1[3] * HPLs1[0]
			       + GHPLs2[0*4+3]
			       - 2 * GHPLs2[2*4+0] * HPLs1[0]
			       + 2 * GHPLs2[3*4+0] * HPLs1[0]
			       - 2 * GHPLs3[0*4*4+3*4+0]
			       - 2 * GHPLs1[0] * HPLs1[0]
			       + 2 * GHPLs1[0] * HPLs2[0*2+0]
			       - 2 * GHPLs3[2*4*4+1*4+0]
			       + 2 * GHPLs2[1*4+0] * HPLs1[0]
			       + 2 * GHPLs2[1*4+0] * HPLs1[1]
			       - GHPLs2[2*4+1]
			       + GHPLs1[1] * HPLs1[0]
			       + GHPLs1[1] * HPLs1[1]
			       + 2 * HPLs1[0]
			       + 2 * HPLs1[0] * zeta2
			       - 1.0/3 * HPLs2[0*2+0]
			       - 2 * HPLs3[0*2*2+0*2+0]
			       - HPLs2[1*2+0]
			       + 2 * HPLs3[0*2*2+1*2+0]
			       - 2 * HPLs2[0*2+1]
			       + 2 * HPLs3[0*2*2+0*2+1]
			       )

    + C_F * (
	     + 5.0/2 * zeta2
	     - 2 * zeta3
	     + 2 * GHPLs2[3*4+2] * HPLs1[0]
	     - 2 * GHPLs3[0*4*4+3*4+2]
	     + 3.0/2 * GHPLs1[2]
	     - 5.0/2 * GHPLs1[2] * HPLs1[0]
	     + 2 * GHPLs1[2] * HPLs2[0*2+0]
	     - 2 * GHPLs1[2] * HPLs2[1*2+0]
	     - 2 * GHPLs1[2] * HPLs2[0*2+1]
	     - 2 * GHPLs2[0*4+2] * HPLs1[0]
	     - 2 * GHPLs3[2*4*4+1*4+2]
	     + 2 * GHPLs2[1*4+2] * HPLs1[0]
	     + 2 * GHPLs2[1*4+2] * HPLs1[1]
	     - 1.0/2 * GHPLs1[3] * HPLs1[0]
	     + 1.0/2 * GHPLs2[0*4+3]
	     + 2 * GHPLs2[2*4+0] * HPLs1[0]
	     - 2 * GHPLs2[3*4+0] * HPLs1[0]
	     + 2 * GHPLs3[0*4*4+3*4+0]
	     + 7.0/2 * GHPLs1[0] * HPLs1[0]
	     - 2 * GHPLs1[0] * HPLs2[0*2+0]
	     + 2 * GHPLs3[2*4*4+1*4+0]
	     - 2 * GHPLs2[1*4+0] * HPLs1[0]
	     - 2 * GHPLs2[1*4+0] * HPLs1[1]
	     - 3.0/2 * GHPLs2[2*4+1]
	     + 3.0/2 * GHPLs1[1] * HPLs1[0]
	     + 3.0/2 * GHPLs1[1] * HPLs1[1]
	     - 2 * HPLs1[0]
	     - 2 * HPLs1[0] * zeta2
	     - 7.0/6 * HPLs2[0*2+0]
	     + 2 * HPLs3[0*2*2+0*2+0]
	     + HPLs2[1*2+0]
	     - 2 * HPLs3[0*2*2+1*2+0]
	     - 3.0/2 * HPLs1[1]
	     + 7.0/2 * HPLs2[0*2+1]
	     - 2 * HPLs3[0*2*2+0*2+1]
	     )

    + C_F * v * pow(1. - u, -2) * (
				   + 3 * zeta2
				   - 3 * zeta3
				   + 3 * GHPLs2[3*4+2] * HPLs1[0]
				   - 3 * GHPLs3[0*4*4+3*4+2]
				   - 3 * GHPLs1[2] * zeta2
				   + 3 * GHPLs1[2] * HPLs2[0*2+0]
				   - 3 * GHPLs1[2] * HPLs2[0*2+1]
				   - 3 * GHPLs2[0*4+2] * HPLs1[0]
				   - 3 * GHPLs1[3] * HPLs1[0]
				   + 3 * GHPLs2[0*4+3]
				   + 3 * GHPLs2[3*4+0] * HPLs1[0]
				   - 3 * GHPLs3[0*4*4+3*4+0]
				   + 6 * GHPLs1[0] * zeta2
				   + 3 * GHPLs1[0] * HPLs1[0]
				   + 3 * GHPLs1[0] * HPLs2[0*2+0]
				   + 3 * GHPLs1[0] * HPLs2[0*2+1]
				   + 3 * HPLs1[0] * zeta2
				   - 3 * HPLs2[0*2+0]
				   - 3 * HPLs3[0*2*2+0*2+0]
				   + 3 * HPLs3[0*2*2+1*2+0]
				   + 3 * HPLs1[1] * zeta2
				   + 3 * HPLs2[0*2+1]
				   - 3 * HPLs3[0*2*2+0*2+1]
				   + 3 * HPLs3[0*2*2+1*2+1]
				   )

    + C_F * v * pow(1. - u, -1) * (
				   + zeta2
				   + 5 * zeta3
				   - 5 * GHPLs2[3*4+2] * HPLs1[0]
				   + 5 * GHPLs3[0*4*4+3*4+2]
				   + 5 * GHPLs1[2] * zeta2
				   - 5 * GHPLs1[2] * HPLs2[0*2+0]
				   + 5 * GHPLs1[2] * HPLs2[0*2+1]
				   + 5 * GHPLs2[0*4+2] * HPLs1[0]
				   + 8 * GHPLs1[3] * HPLs1[0]
				   - 8 * GHPLs2[0*4+3]
				   - 5 * GHPLs2[3*4+0] * HPLs1[0]
				   + 5 * GHPLs3[0*4*4+3*4+0]
				   + 3.0/2 * GHPLs1[0]
				   - 10 * GHPLs1[0] * zeta2
				   - 5 * GHPLs1[0] * HPLs1[0]
				   - 5 * GHPLs1[0] * HPLs2[0*2+0]
				   - 5 * GHPLs1[0] * HPLs2[0*2+1]
				   - 5 * HPLs1[0] * zeta2
				   + 8 * HPLs2[0*2+0]
				   + 5 * HPLs3[0*2*2+0*2+0]
				   - 5 * HPLs3[0*2*2+1*2+0]
				   - 5 * HPLs1[1] * zeta2
				   - 2 * HPLs2[0*2+1]
				   + 5 * HPLs3[0*2*2+0*2+1]
				   - 5 * HPLs3[0*2*2+1*2+1]
				   )

    + C_F * v * (
		 - 5.0/3 * zeta2
		 + GHPLs1[2]
		 + 1.0/3 * GHPLs2[0*4+2]
		 + 1.0/3 * GHPLs2[2*4+0]
		 + 1.0/6 * GHPLs1[0]
		 - 1.0/3 * GHPLs1[0] * HPLs1[1]
		 - 1.0/2 * HPLs1[0]
		 - 2.0/3 * HPLs2[0*2+0]
		 - HPLs1[1]
		 )

    + C_F * pow(v, 2) * pow(1. - u, -3) * (
					   + 3 * zeta3
					   - 3 * GHPLs2[3*4+2] * HPLs1[0]
					   + 3 * GHPLs3[0*4*4+3*4+2]
					   + 3 * GHPLs1[2] * zeta2
					   - 3 * GHPLs1[2] * HPLs2[0*2+0]
					   + 3 * GHPLs1[2] * HPLs2[0*2+1]
					   + 3 * GHPLs2[0*4+2] * HPLs1[0]
					   - 3 * GHPLs2[3*4+0] * HPLs1[0]
					   + 3 * GHPLs3[0*4*4+3*4+0]
					   - 6 * GHPLs1[0] * zeta2
					   - 3 * GHPLs1[0] * HPLs2[0*2+0]
					   - 3 * GHPLs1[0] * HPLs2[0*2+1]
					   - 3 * HPLs1[0] * zeta2
					   + 3 * HPLs3[0*2*2+0*2+0]
					   - 3 * HPLs3[0*2*2+1*2+0]
					   - 3 * HPLs1[1] * zeta2
					   + 3 * HPLs3[0*2*2+0*2+1]
					   - 3 * HPLs3[0*2*2+1*2+1]
					   )

    + C_F * pow(v, 2) * pow(1. - u, -2) * (
					   - 6 * zeta2
					   - 5 * zeta3
					   + 5 * GHPLs2[3*4+2] * HPLs1[0]
					   - 5 * GHPLs3[0*4*4+3*4+2]
					   - 5 * GHPLs1[2] * zeta2
					   + 5 * GHPLs1[2] * HPLs2[0*2+0]
					   - 5 * GHPLs1[2] * HPLs2[0*2+1]
					   - 5 * GHPLs2[0*4+2] * HPLs1[0]
					   - 3 * GHPLs1[3] * HPLs1[0]
					   + 3 * GHPLs2[0*4+3]
					   + 5 * GHPLs2[3*4+0] * HPLs1[0]
					   - 5 * GHPLs3[0*4*4+3*4+0]
					   + 10 * GHPLs1[0] * zeta2
					   + 5 * GHPLs1[0] * HPLs2[0*2+0]
					   + 5 * GHPLs1[0] * HPLs2[0*2+1]
					   + 5 * HPLs1[0] * zeta2
					   - 3 * HPLs2[0*2+0]
					   - 5 * HPLs3[0*2*2+0*2+0]
					   + 5 * HPLs3[0*2*2+1*2+0]
					   + 5 * HPLs1[1] * zeta2
					   - 3 * HPLs2[0*2+1]
					   - 5 * HPLs3[0*2*2+0*2+1]
					   + 5 * HPLs3[0*2*2+1*2+1]
					   )

    + C_F * pow(v, 2) * pow(1. - u, -1) * (
					   + 6 * zeta2
					   + 4 * zeta3
					   - 4 * GHPLs2[3*4+2] * HPLs1[0]
					   + 4 * GHPLs3[0*4*4+3*4+2]
					   - 3.0/2 * GHPLs1[2]
					   + 4 * GHPLs1[2] * zeta2
					   - 4 * GHPLs1[2] * HPLs2[0*2+0]
					   + 4 * GHPLs1[2] * HPLs2[0*2+1]
					   + 1.0/2 * GHPLs2[0*4+2]
					   + 4 * GHPLs2[0*4+2] * HPLs1[0]
					   + 7.0/2 * GHPLs1[3] * HPLs1[0]
					   - 7.0/2 * GHPLs2[0*4+3]
					   + 1.0/2 * GHPLs2[2*4+0]
					   - 4 * GHPLs2[3*4+0] * HPLs1[0]
					   + 4 * GHPLs3[0*4*4+3*4+0]
					   - 8 * GHPLs1[0] * zeta2
					   - 1.0/2 * GHPLs1[0] * HPLs1[0]
					   - 4 * GHPLs1[0] * HPLs2[0*2+0]
					   - 1.0/2 * GHPLs1[0] * HPLs1[1]
					   - 4 * GHPLs1[0] * HPLs2[0*2+1]
					   - GHPLs2[2*4+1]
					   + GHPLs1[1] * HPLs1[0]
					   + GHPLs1[1] * HPLs1[1]
					   + 3.0/2 * HPLs1[0]
					   - 4 * HPLs1[0] * zeta2
					   + 5.0/2 * HPLs2[0*2+0]
					   + 4 * HPLs3[0*2*2+0*2+0]
					   - HPLs2[1*2+0]
					   - 4 * HPLs3[0*2*2+1*2+0]
					   + 3.0/2 * HPLs1[1]
					   - 4 * HPLs1[1] * zeta2
					   + 7.0/2 * HPLs2[0*2+1]
					   + 4 * HPLs3[0*2*2+0*2+1]
					   - 4 * HPLs3[0*2*2+1*2+1]
					   )

    + C_F * pow(v, 2) * (
			 - 8 * zeta2
			 - GHPLs1[2]
			 - 2 * GHPLs1[2] * zeta2
			 - 37.0/6 * GHPLs1[2] * HPLs1[0]
			 - 2 * GHPLs1[2] * HPLs2[0*2+0]
			 + 2 * GHPLs1[2] * HPLs2[1*2+0]
			 + 3.0/2 * GHPLs2[0*4+2]
			 + 2 * GHPLs2[0*4+2] * HPLs1[0]
			 + 2 * GHPLs3[2*4*4+1*4+2]
			 - 2 * GHPLs2[1*4+2] * HPLs1[0]
			 - 2 * GHPLs2[1*4+2] * HPLs1[1]
			 + 2 * GHPLs2[2*4+3] * HPLs1[0]
			 - 2 * GHPLs3[0*4*4+2*4+3]
			 - 2 * GHPLs2[3*4+3] * HPLs1[0]
			 + 2 * GHPLs3[0*4*4+3*4+3]
			 + 10 * GHPLs1[3] * zeta2
			 + 13.0/6 * GHPLs1[3] * HPLs1[0]
			 - 2 * GHPLs1[3] * HPLs2[1*2+0]
			 - 2 * GHPLs1[3] * HPLs2[0*2+1]
			 - 2 * GHPLs3[2*4*4+0*4+3]
			 - 13.0/6 * GHPLs2[0*4+3]
			 + 2 * GHPLs2[0*4+3] * HPLs1[1]
			 + 3.0/2 * GHPLs2[2*4+0]
			 + 1.0/3 * GHPLs1[0]
			 + 1.0/2 * GHPLs1[0] * HPLs1[0]
			 - 3.0/2 * GHPLs1[0] * HPLs1[1]
			 - 7.0/2 * GHPLs2[2*4+1]
			 + 7.0/2 * GHPLs1[1] * HPLs1[0]
			 + 7.0/2 * GHPLs1[1] * HPLs1[1]
			 + 2.0/3 * HPLs1[0]
			 + 5.0/6 * HPLs2[0*2+0]
			 + 8.0/3 * HPLs2[1*2+0]
			 + HPLs1[1]
			 + 13.0/6 * HPLs2[0*2+1]
			 )

    + C_F * pow(v, 3) * (
			 + 28.0/3 * zeta2
			 + 4 * GHPLs1[2] * zeta2
			 + 7.0/3 * GHPLs1[2] * HPLs1[0]
			 + 4 * GHPLs1[2] * HPLs2[0*2+0]
			 - 4 * GHPLs1[2] * HPLs2[1*2+0]
			 - 7.0/3 * GHPLs2[0*4+2]
			 - 4 * GHPLs2[0*4+2] * HPLs1[0]
			 - 4 * GHPLs3[2*4*4+1*4+2]
			 + 4 * GHPLs2[1*4+2] * HPLs1[0]
			 + 4 * GHPLs2[1*4+2] * HPLs1[1]
			 - 4 * GHPLs2[2*4+3] * HPLs1[0]
			 + 4 * GHPLs3[0*4*4+2*4+3]
			 + 4 * GHPLs2[3*4+3] * HPLs1[0]
			 - 4 * GHPLs3[0*4*4+3*4+3]
			 - 20 * GHPLs1[3] * zeta2
			 - 7.0/3 * GHPLs1[3] * HPLs1[0]
			 + 4 * GHPLs1[3] * HPLs2[1*2+0]
			 + 4 * GHPLs1[3] * HPLs2[0*2+1]
			 + 4 * GHPLs3[2*4*4+0*4+3]
			 + 7.0/3 * GHPLs2[0*4+3]
			 - 4 * GHPLs2[0*4+3] * HPLs1[1]
			 - 7.0/3 * GHPLs2[2*4+0]
			 + 7.0/3 * GHPLs1[0] * HPLs1[0]
			 + 7.0/3 * GHPLs1[0] * HPLs1[1]
			 + 7.0/3 * GHPLs2[2*4+1]
			 - 7.0/3 * GHPLs1[1] * HPLs1[0]
			 - 7.0/3 * GHPLs1[1] * HPLs1[1]
			 - 7.0/3 * HPLs2[0*2+0]
			 - 7.0/3 * HPLs2[0*2+1]
			 )

    + C_F * u * pow(1. - v, -2) * (
				   - 2 * zeta2
				   + zeta3
				   - GHPLs2[3*4+2] * HPLs1[0]
				   + GHPLs3[0*4*4+3*4+2]
				   + 2 * GHPLs1[2] * zeta2
				   - 5 * GHPLs1[2] * HPLs1[0]
				   + 1.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				   - GHPLs1[2] * HPLs2[1*2+0]
				   + GHPLs1[2] * HPLs2[0*2+1]
				   + GHPLs2[0*4+2] * HPLs1[0]
				   - GHPLs3[2*4*4+1*4+2]
				   + GHPLs2[1*4+2] * HPLs1[0]
				   + GHPLs2[1*4+2] * HPLs1[1]
				   + GHPLs2[2*4+0] * HPLs1[0]
				   + GHPLs2[3*4+0] * HPLs1[0]
				   - GHPLs3[0*4*4+3*4+0]
				   + 3 * GHPLs1[0] * HPLs1[0]
				   - 1.0/3 * GHPLs1[0] * HPLs2[0*2+0]
				   + GHPLs3[2*4*4+1*4+0]
				   - GHPLs2[1*4+0] * HPLs1[0]
				   - GHPLs2[1*4+0] * HPLs1[1]
				   - 4 * HPLs1[0]
				   + HPLs1[0] * zeta2
				   + 2.0/3 * HPLs2[0*2+0]
				   - HPLs3[0*2*2+0*2+0]
				   - 4.0/3 * HPLs3[1*2*2+0*2+0]
				   + 5 * HPLs2[1*2+0]
				   - 1.0/3 * HPLs3[0*2*2+1*2+0]
				   + 3 * HPLs2[0*2+1]
				   - 1.0/3 * HPLs3[0*2*2+0*2+1]
				   )

    + C_F * u * pow(1. - v, -1) * (
				   + 4 * zeta2
				   - zeta3
				   + GHPLs2[3*4+2] * HPLs1[0]
				   - GHPLs3[0*4*4+3*4+2]
				   - 6 * GHPLs1[2]
				   - 2 * GHPLs1[2] * zeta2
				   + 19.0/3 * GHPLs1[2] * HPLs1[0]
				   - 1.0/3 * GHPLs1[2] * HPLs2[0*2+0]
				   + GHPLs1[2] * HPLs2[1*2+0]
				   - GHPLs1[2] * HPLs2[0*2+1]
				   - GHPLs2[0*4+2] * HPLs1[0]
				   + GHPLs3[2*4*4+1*4+2]
				   - GHPLs2[1*4+2] * HPLs1[0]
				   - GHPLs2[1*4+2] * HPLs1[1]
				   - GHPLs1[3] * HPLs1[0]
				   + GHPLs2[0*4+3]
				   - GHPLs2[2*4+0] * HPLs1[0]
				   - GHPLs2[3*4+0] * HPLs1[0]
				   + GHPLs3[0*4*4+3*4+0]
				   + 2 * GHPLs1[0]
				   - 7.0/3 * GHPLs1[0] * HPLs1[0]
				   + 1.0/3 * GHPLs1[0] * HPLs2[0*2+0]
				   - GHPLs3[2*4*4+1*4+0]
				   + GHPLs2[1*4+0] * HPLs1[0]
				   + GHPLs2[1*4+0] * HPLs1[1]
				   + GHPLs2[2*4+1]
				   - GHPLs1[1] * HPLs1[0]
				   - GHPLs1[1] * HPLs1[1]
				   + 14.0/3 * HPLs1[0]
				   - HPLs1[0] * zeta2
				   - 2.0/3 * HPLs2[0*2+0]
				   + HPLs3[0*2*2+0*2+0]
				   + 4.0/3 * HPLs3[1*2*2+0*2+0]
				   - 16.0/3 * HPLs2[1*2+0]
				   + 1.0/3 * HPLs3[0*2*2+1*2+0]
				   + 6 * HPLs1[1]
				   - 4.0/3 * HPLs2[0*2+1]
				   + 1.0/3 * HPLs3[0*2*2+0*2+1]
				   )

    + C_F * u * (
		 + zeta2
		 + 3.0/2 * GHPLs1[2]
		 + 1.0/6 * GHPLs1[2] * HPLs1[0]
		 - 1.0/2 * GHPLs2[0*4+2]
		 - 1.0/2 * GHPLs1[3] * HPLs1[0]
		 + 1.0/2 * GHPLs2[0*4+3]
		 - 1.0/2 * GHPLs2[2*4+0]
		 - 1.0/2 * GHPLs1[0]
		 + 5.0/6 * GHPLs1[0] * HPLs1[0]
		 + 1.0/2 * GHPLs1[0] * HPLs1[1]
		 + 1.0/2 * GHPLs2[2*4+1]
		 - 1.0/2 * GHPLs1[1] * HPLs1[0]
		 - 1.0/2 * GHPLs1[1] * HPLs1[1]
		 - 2.0/3 * HPLs1[0]
		 - 3.0/2 * HPLs2[0*2+0]
		 + 1.0/3 * HPLs2[1*2+0]
		 - 3.0/2 * HPLs1[1]
		 - 7.0/6 * HPLs2[0*2+1]
		 )

    + C_F * u * v * (
		     - 32.0/3 * zeta2
		     - GHPLs1[2]
		     - 2.0/3 * GHPLs1[2] * zeta2
		     - 19.0/3 * GHPLs1[2] * HPLs1[0]
		     - 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
		     + 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
		     + 7.0/3 * GHPLs2[0*4+2]
		     + 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
		     + 2.0/3 * GHPLs3[2*4*4+1*4+2]
		     - 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
		     - 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
		     + 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
		     - 2.0/3 * GHPLs3[0*4*4+2*4+3]
		     - 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
		     + 2.0/3 * GHPLs3[0*4*4+3*4+3]
		     + 10.0/3 * GHPLs1[3] * zeta2
		     + 3 * GHPLs1[3] * HPLs1[0]
		     - 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
		     - 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
		     - 2.0/3 * GHPLs3[2*4*4+0*4+3]
		     - 3 * GHPLs2[0*4+3]
		     + 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
		     + 7.0/3 * GHPLs2[2*4+0]
		     - 2.0/3 * GHPLs2[2*4+0] * HPLs1[0]
		     + 2.0/3 * GHPLs2[3*4+0] * HPLs1[0]
		     - 2.0/3 * GHPLs3[0*4*4+3*4+0]
		     + 2.0/3 * GHPLs1[0]
		     + 1.0/3 * GHPLs1[0] * HPLs1[0]
		     + 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
		     + 2.0/3 * GHPLs1[0] * HPLs2[1*2+0]
		     - 7.0/3 * GHPLs1[0] * HPLs1[1]
		     + 2.0/3 * GHPLs1[0] * HPLs2[0*2+1]
		     - 3 * GHPLs2[2*4+1]
		     + 2.0/3 * GHPLs3[0*4*4+2*4+1]
		     - 8.0/3 * GHPLs1[1] * zeta2
		     + 3 * GHPLs1[1] * HPLs1[0]
		     - 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
		     - 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
		     + 3 * GHPLs1[1] * HPLs1[1]
		     + 2.0/3 * GHPLs3[2*4*4+0*4+1]
		     - 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
		     - 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
		     - 2.0/3 * GHPLs3[2*4*4+1*4+1]
		     + 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
		     + 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
		     + 1.0/3 * HPLs1[0]
		     + 10.0/3 * HPLs1[0] * zeta2
		     + 7.0/3 * HPLs2[0*2+0]
		     + 2.0/3 * HPLs3[1*2*2+0*2+0]
		     + 10.0/3 * HPLs2[1*2+0]
		     + 2.0/3 * HPLs3[0*2*2+1*2+0]
		     + HPLs1[1]
		     + 2.0/3 * HPLs1[1] * zeta2
		     + 13.0/3 * HPLs2[0*2+1]
		     + 2.0/3 * HPLs3[0*2*2+0*2+1]
		     + 2.0/3 * HPLs3[1*2*2+0*2+1]
		     + 4.0/3 * HPLs3[0*2*2+1*2+1]
		     )

    + C_F * u * pow(v, 2) * (
			     + 44.0/3 * zeta2
			     + 8.0/3 * GHPLs1[2] * zeta2
			     + 11.0/3 * GHPLs1[2] * HPLs1[0]
			     + 8.0/3 * GHPLs1[2] * HPLs2[0*2+0]
			     - 8.0/3 * GHPLs1[2] * HPLs2[1*2+0]
			     - 11.0/3 * GHPLs2[0*4+2]
			     - 8.0/3 * GHPLs2[0*4+2] * HPLs1[0]
			     - 8.0/3 * GHPLs3[2*4*4+1*4+2]
			     + 8.0/3 * GHPLs2[1*4+2] * HPLs1[0]
			     + 8.0/3 * GHPLs2[1*4+2] * HPLs1[1]
			     - 8.0/3 * GHPLs2[2*4+3] * HPLs1[0]
			     + 8.0/3 * GHPLs3[0*4*4+2*4+3]
			     + 8.0/3 * GHPLs2[3*4+3] * HPLs1[0]
			     - 8.0/3 * GHPLs3[0*4*4+3*4+3]
			     - 40.0/3 * GHPLs1[3] * zeta2
			     - 11.0/3 * GHPLs1[3] * HPLs1[0]
			     + 8.0/3 * GHPLs1[3] * HPLs2[1*2+0]
			     + 8.0/3 * GHPLs1[3] * HPLs2[0*2+1]
			     + 8.0/3 * GHPLs3[2*4*4+0*4+3]
			     + 11.0/3 * GHPLs2[0*4+3]
			     - 8.0/3 * GHPLs2[0*4+3] * HPLs1[1]
			     - 11.0/3 * GHPLs2[2*4+0]
			     + 2.0/3 * GHPLs2[2*4+0] * HPLs1[0]
			     - 2.0/3 * GHPLs2[3*4+0] * HPLs1[0]
			     + 2.0/3 * GHPLs3[0*4*4+3*4+0]
			     + 11.0/3 * GHPLs1[0] * HPLs1[0]
			     - 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
			     - 2.0/3 * GHPLs1[0] * HPLs2[1*2+0]
			     + 11.0/3 * GHPLs1[0] * HPLs1[1]
			     - 2.0/3 * GHPLs1[0] * HPLs2[0*2+1]
			     + 11.0/3 * GHPLs2[2*4+1]
			     - 2.0/3 * GHPLs3[0*4*4+2*4+1]
			     + 8.0/3 * GHPLs1[1] * zeta2
			     - 11.0/3 * GHPLs1[1] * HPLs1[0]
			     + 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
			     + 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
			     - 11.0/3 * GHPLs1[1] * HPLs1[1]
			     - 2.0/3 * GHPLs3[2*4*4+0*4+1]
			     + 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
			     + 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
			     + 2.0/3 * GHPLs3[2*4*4+1*4+1]
			     - 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
			     - 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
			     - 10.0/3 * HPLs1[0] * zeta2
			     - 11.0/3 * HPLs2[0*2+0]
			     - 2.0/3 * HPLs3[1*2*2+0*2+0]
			     - 2.0/3 * HPLs3[0*2*2+1*2+0]
			     - 2.0/3 * HPLs1[1] * zeta2
			     - 11.0/3 * HPLs2[0*2+1]
			     - 2.0/3 * HPLs3[0*2*2+0*2+1]
			     - 2.0/3 * HPLs3[1*2*2+0*2+1]
			     - 4.0/3 * HPLs3[0*2*2+1*2+1]
			     )

    + C_F * pow(u, 2) * pow(1. - v, -3) * (
					   + 4 * GHPLs1[2] * HPLs1[0]
					   - 4.0/3 * GHPLs1[2] * HPLs2[0*2+0]
					   - 4 * GHPLs1[0] * HPLs1[0]
					   + 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
					   + 4.0/3 * HPLs3[1*2*2+0*2+0]
					   - 4 * HPLs2[1*2+0]
					   + 4.0/3 * HPLs3[0*2*2+1*2+0]
					   - 4 * HPLs2[0*2+1]
					   + 4.0/3 * HPLs3[0*2*2+0*2+1]
					   )

    + C_F * pow(u, 2) * pow(1. - v, -2) * (
					   + 4 * GHPLs1[2]
					   - 10.0/3 * GHPLs1[2] * HPLs1[0]
					   + 4.0/3 * GHPLs1[2] * HPLs2[0*2+0]
					   - 4 * GHPLs1[0]
					   + 10.0/3 * GHPLs1[0] * HPLs1[0]
					   - 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
					   - 4.0/3 * HPLs3[1*2*2+0*2+0]
					   + 10.0/3 * HPLs2[1*2+0]
					   - 4.0/3 * HPLs3[0*2*2+1*2+0]
					   - 4 * HPLs1[1]
					   + 10.0/3 * HPLs2[0*2+1]
					   - 4.0/3 * HPLs3[0*2*2+0*2+1]
					   )

    + C_F * pow(u, 2) * pow(1. - v, -1) * (
					   - 2.0/3 * GHPLs1[2]
					   + 2.0/3 * GHPLs1[2] * HPLs1[0]
					   + 2.0/3 * GHPLs1[0]
					   - 2.0/3 * GHPLs1[0] * HPLs1[0]
					   - 2.0/3 * HPLs2[1*2+0]
					   + 2.0/3 * HPLs1[1]
					   - 2.0/3 * HPLs2[0*2+1]
					   )

    + C_F * pow(u, 2) * (
			 - 6 * zeta2
			 - 1.0/3 * GHPLs1[2]
			 - 17.0/6 * GHPLs1[2] * HPLs1[0]
			 + 3.0/2 * GHPLs2[0*4+2]
			 + 3.0/2 * GHPLs1[3] * HPLs1[0]
			 - 3.0/2 * GHPLs2[0*4+3]
			 + 3.0/2 * GHPLs2[2*4+0]
			 + 1.0/3 * GHPLs1[0]
			 - 1.0/6 * GHPLs1[0] * HPLs1[0]
			 - 3.0/2 * GHPLs1[0] * HPLs1[1]
			 - 3.0/2 * GHPLs2[2*4+1]
			 + 3.0/2 * GHPLs1[1] * HPLs1[0]
			 + 3.0/2 * GHPLs1[1] * HPLs1[1]
			 + 3.0/2 * HPLs2[0*2+0]
			 + 4.0/3 * HPLs2[1*2+0]
			 + 1.0/3 * HPLs1[1]
			 + 17.0/6 * HPLs2[0*2+1]
			 )

    + C_F * pow(u, 2) * v * (
			     + 12 * zeta2
			     + 2.0/3 * GHPLs1[2] * zeta2
			     + 3 * GHPLs1[2] * HPLs1[0]
			     + 2.0/3 * GHPLs1[2] * HPLs2[0*2+0]
			     - 2.0/3 * GHPLs1[2] * HPLs2[1*2+0]
			     - 3 * GHPLs2[0*4+2]
			     - 2.0/3 * GHPLs2[0*4+2] * HPLs1[0]
			     - 2.0/3 * GHPLs3[2*4*4+1*4+2]
			     + 2.0/3 * GHPLs2[1*4+2] * HPLs1[0]
			     + 2.0/3 * GHPLs2[1*4+2] * HPLs1[1]
			     - 2.0/3 * GHPLs2[2*4+3] * HPLs1[0]
			     + 2.0/3 * GHPLs3[0*4*4+2*4+3]
			     + 2.0/3 * GHPLs2[3*4+3] * HPLs1[0]
			     - 2.0/3 * GHPLs3[0*4*4+3*4+3]
			     - 10.0/3 * GHPLs1[3] * zeta2
			     - 3 * GHPLs1[3] * HPLs1[0]
			     + 2.0/3 * GHPLs1[3] * HPLs2[1*2+0]
			     + 2.0/3 * GHPLs1[3] * HPLs2[0*2+1]
			     + 2.0/3 * GHPLs3[2*4*4+0*4+3]
			     + 3 * GHPLs2[0*4+3]
			     - 2.0/3 * GHPLs2[0*4+3] * HPLs1[1]
			     - 3 * GHPLs2[2*4+0]
			     + 2.0/3 * GHPLs2[2*4+0] * HPLs1[0]
			     - 2.0/3 * GHPLs2[3*4+0] * HPLs1[0]
			     + 2.0/3 * GHPLs3[0*4*4+3*4+0]
			     + 3 * GHPLs1[0] * HPLs1[0]
			     - 4.0/3 * GHPLs1[0] * HPLs2[0*2+0]
			     - 2.0/3 * GHPLs1[0] * HPLs2[1*2+0]
			     + 3 * GHPLs1[0] * HPLs1[1]
			     - 2.0/3 * GHPLs1[0] * HPLs2[0*2+1]
			     + 3 * GHPLs2[2*4+1]
			     - 2.0/3 * GHPLs3[0*4*4+2*4+1]
			     + 8.0/3 * GHPLs1[1] * zeta2
			     - 3 * GHPLs1[1] * HPLs1[0]
			     + 2.0/3 * GHPLs1[1] * HPLs2[0*2+0]
			     + 2.0/3 * GHPLs1[1] * HPLs2[1*2+0]
			     - 3 * GHPLs1[1] * HPLs1[1]
			     - 2.0/3 * GHPLs3[2*4*4+0*4+1]
			     + 2.0/3 * GHPLs2[0*4+1] * HPLs1[0]
			     + 2.0/3 * GHPLs2[0*4+1] * HPLs1[1]
			     + 2.0/3 * GHPLs3[2*4*4+1*4+1]
			     - 2.0/3 * GHPLs2[1*4+1] * HPLs1[0]
			     - 2.0/3 * GHPLs2[1*4+1] * HPLs1[1]
			     - 10.0/3 * HPLs1[0] * zeta2
			     - 3 * HPLs2[0*2+0]
			     - 2.0/3 * HPLs3[1*2*2+0*2+0]
			     - 2.0/3 * HPLs3[0*2*2+1*2+0]
			     - 2.0/3 * HPLs1[1] * zeta2
			     - 3 * HPLs2[0*2+1]
			     - 2.0/3 * HPLs3[0*2*2+0*2+1]
			     - 2.0/3 * HPLs3[1*2*2+0*2+1]
			     - 4.0/3 * HPLs3[0*2*2+1*2+1]
			     )

    + C_F * pow(u, 3) * (
			 + 4 * zeta2
			 + GHPLs1[2] * HPLs1[0]
			 - GHPLs2[0*4+2]
			 - GHPLs1[3] * HPLs1[0]
			 + GHPLs2[0*4+3]
			 - GHPLs2[2*4+0]
			 + GHPLs1[0] * HPLs1[0]
			 + GHPLs1[0] * HPLs1[1]
			 + GHPLs2[2*4+1]
			 - GHPLs1[1] * HPLs1[0]
			 - GHPLs1[1] * HPLs1[1]
			 - HPLs2[0*2+0]
			 - HPLs2[0*2+1]
			 )

    + C_F * ri * M_PI * pow(u, -2) * v * (
					  - 4 * GHPLs3[3*4*4+2*4+2]
					  - 4 * GHPLs2[2*4+2] * HPLs1[0]
					  - 4 * GHPLs1[2] * HPLs2[0*2+0]
					  + 4 * GHPLs3[3*4*4+0*4+2]
					  - 2.0/3 * GHPLs2[1*4+2]
					  - 4 * GHPLs3[3*4*4+2*4+1]
					  - 2.0/3 * GHPLs2[2*4+1]
					  - 4 * GHPLs2[2*4+1] * HPLs1[0]
					  + GHPLs1[1]
					  + 8 * GHPLs1[1] * zeta2
					  + 4 * GHPLs1[1] * HPLs2[0*2+0]
					  + 2.0/3 * GHPLs1[1] * HPLs1[1]
					  + 4 * GHPLs1[1] * HPLs2[0*2+1]
					  - 4 * GHPLs3[3*4*4+0*4+1]
					  - 2.0/3 * GHPLs2[0*4+1]
					  + 2.0/3 * GHPLs2[1*4+1]
					  )

    + C_F * ri * M_PI * pow(u, -2) * pow(v, 2) * (
						  + 4 * GHPLs3[3*4*4+2*4+2]
						  + 4 * GHPLs2[2*4+2] * HPLs1[0]
						  + 4 * GHPLs1[2] * HPLs2[0*2+0]
						  - 4 * GHPLs3[3*4*4+0*4+2]
						  + 2.0/3 * GHPLs2[1*4+2]
						  + 4 * GHPLs3[3*4*4+2*4+1]
						  + 2.0/3 * GHPLs2[2*4+1]
						  + 4 * GHPLs2[2*4+1] * HPLs1[0]
						  - 2.0/3 * GHPLs1[1]
						  - 8 * GHPLs1[1] * zeta2
						  - 4 * GHPLs1[1] * HPLs2[0*2+0]
						  - 2.0/3 * GHPLs1[1] * HPLs1[1]
						  - 4 * GHPLs1[1] * HPLs2[0*2+1]
						  + 4 * GHPLs3[3*4*4+0*4+1]
						  + 2.0/3 * GHPLs2[0*4+1]
						  - 2.0/3 * GHPLs2[1*4+1]
						  )

    + C_F * ri * M_PI * pow(u, -2) * pow(v, 3) * (
						  + 1.0/3 * GHPLs1[1]
						  )

    + C_F * ri * M_PI * pow(u, -2) * pow(v, 4) * (
						  + 2.0/3 * GHPLs2[1*4+2]
						  - 2.0/3 * GHPLs2[2*4+3]
						  + 2.0/3 * GHPLs2[3*4+3]
						  + 2.0/3 * GHPLs1[3] * HPLs1[0]
						  + 2.0/3 * GHPLs1[3] * HPLs1[1]
						  - 2.0/3 * GHPLs2[0*4+3]
						  - 2.0/3 * GHPLs1[1]
						  )

    + C_F * ri * M_PI * pow(u, -2) * pow(v, 5) * (
						  - 2.0/3 * GHPLs2[1*4+2]
						  + 2.0/3 * GHPLs2[2*4+3]
						  - 2.0/3 * GHPLs2[3*4+3]
						  - 2.0/3 * GHPLs1[3] * HPLs1[0]
						  - 2.0/3 * GHPLs1[3] * HPLs1[1]
						  + 2.0/3 * GHPLs2[0*4+3]
						  )

    + C_F * ri * M_PI * pow(u, -1) * (
				      + 3.0/2 * GHPLs1[1]
				      )

    + C_F * ri * M_PI * pow(u, -1) * v * (
					  + 5.0/3
					  + 8 * zeta2
					  + 4 * GHPLs3[3*4*4+2*4+2]
					  + 4 * GHPLs2[2*4+2] * HPLs1[0]
					  - 8 * GHPLs2[3*4+2]
					  - 2.0/3 * GHPLs1[2]
					  - 7 * GHPLs1[2] * HPLs1[0]
					  + 4 * GHPLs1[2] * HPLs2[0*2+0]
					  - 4 * GHPLs3[3*4*4+0*4+2]
					  - 1.0/3 * GHPLs2[1*4+2]
					  - 2.0/3 * GHPLs1[0]
					  + GHPLs2[1*4+0]
					  + 4 * GHPLs3[3*4*4+2*4+1]
					  + 2.0/3 * GHPLs2[2*4+1]
					  + 4 * GHPLs2[2*4+1] * HPLs1[0]
					  - 8 * GHPLs1[1] * zeta2
					  - 4 * GHPLs1[1] * HPLs2[0*2+0]
					  - 2.0/3 * GHPLs1[1] * HPLs1[1]
					  - 4 * GHPLs1[1] * HPLs2[0*2+1]
					  + 4 * GHPLs3[3*4*4+0*4+1]
					  + 2.0/3 * GHPLs2[0*4+1]
					  - 2.0/3 * GHPLs2[1*4+1]
					  + 2.0/3 * HPLs1[1]
					  + 4 * HPLs2[0*2+1]
					  )

    + C_F * ri * M_PI * pow(u, -1) * pow(v, 2) * (
						  - 4.0/3
						  - 8 * zeta2
						  + 4 * GHPLs2[3*4+2]
						  + 2.0/3 * GHPLs1[2]
						  + 4 * GHPLs1[2] * HPLs1[0]
						  - 4 * GHPLs1[3]
						  + 4 * GHPLs2[3*4+0]
						  + 2.0/3 * GHPLs1[0]
						  - 1.0/2 * GHPLs1[1]
						  - 4 * HPLs2[0*2+0]
						  - 2.0/3 * HPLs1[1]
						  - 4 * HPLs2[0*2+1]
						  )

    + C_F * ri * M_PI * pow(u, -1) * pow(v, 3) * (
						  - 1.0/3
						  + 2.0/3 * GHPLs1[2]
						  + 2 * GHPLs2[1*4+2]
						  - 2 * GHPLs2[2*4+3]
						  + 2 * GHPLs2[3*4+3]
						  - 2.0/3 * GHPLs1[3]
						  + 2 * GHPLs1[3] * HPLs1[0]
						  + 2 * GHPLs1[3] * HPLs1[1]
						  - 2 * GHPLs2[0*4+3]
						  + 2.0/3 * GHPLs1[0]
						  - 8.0/3 * GHPLs1[1]
						  - 2.0/3 * HPLs1[0]
						  - 2.0/3 * HPLs1[1]
						  )

    + C_F * ri * M_PI * pow(u, -1) * pow(v, 4) * (
						  - 2.0/3 * GHPLs1[2]
						  - 8.0/3 * GHPLs2[1*4+2]
						  + 8.0/3 * GHPLs2[2*4+3]
						  - 8.0/3 * GHPLs2[3*4+3]
						  + 2.0/3 * GHPLs1[3]
						  - 8.0/3 * GHPLs1[3] * HPLs1[0]
						  - 8.0/3 * GHPLs1[3] * HPLs1[1]
						  + 8.0/3 * GHPLs2[0*4+3]
						  - 2.0/3 * GHPLs1[0]
						  + 2.0/3 * GHPLs1[1]
						  + 2.0/3 * HPLs1[0]
						  + 2.0/3 * HPLs1[1]
						  )

    + C_F * ri * M_PI * pow(1. - u, -1) * (
					   - 3.0/2 * GHPLs1[3]
					   - 3.0/2 * HPLs1[0]
					   )

    + C_F * ri * M_PI * pow(1. - v, -1) * (
					   + 2 * GHPLs2[3*4+2]
					   + 2 * GHPLs2[1*4+2]
					   + GHPLs1[3]
					   - 2 * GHPLs2[3*4+0]
					   - 2 * GHPLs2[1*4+0]
					   - GHPLs1[1]
					   - HPLs1[0]
					   + 2 * HPLs2[0*2+0]
					   )

    + C_F * ri * M_PI * (
			 + 3.0/2
			 - 2 * GHPLs2[3*4+2]
			 - 2 * GHPLs2[1*4+2]
			 + 1.0/2 * GHPLs1[3]
			 + 2 * GHPLs2[3*4+0]
			 + 2 * GHPLs2[1*4+0]
			 - 3.0/2 * GHPLs1[1]
			 + 5.0/2 * HPLs1[0]
			 - 2 * HPLs2[0*2+0]
			 )

    + C_F * ri * M_PI * v * pow(1. - u, -2) * (
					       + 6 * zeta2
					       - 3 * GHPLs2[3*4+2]
					       - 3 * GHPLs1[2] * HPLs1[0]
					       + 3 * GHPLs1[3]
					       - 3 * GHPLs2[3*4+0]
					       + 3 * HPLs1[0]
					       + 3 * HPLs2[0*2+0]
					       + 3 * HPLs2[0*2+1]
					       )

    + C_F * ri * M_PI * v * pow(1. - u, -1) * (
					       + 3.0/2
					       - 10 * zeta2
					       + 5 * GHPLs2[3*4+2]
					       + 5 * GHPLs1[2] * HPLs1[0]
					       - 8 * GHPLs1[3]
					       + 5 * GHPLs2[3*4+0]
					       - 5 * HPLs1[0]
					       - 5 * HPLs2[0*2+0]
					       - 5 * HPLs2[0*2+1]
					       )

    + C_F * ri * M_PI * v * (
			     + 7.0/6
			     + 1.0/3 * GHPLs1[2]
			     + 1.0/3 * GHPLs1[0]
			     - 1.0/3 * HPLs1[1]
			     )

    + C_F * ri * M_PI * pow(v, 2) * pow(1. - u, -3) * (
						       - 6 * zeta2
						       + 3 * GHPLs2[3*4+2]
						       + 3 * GHPLs1[2] * HPLs1[0]
						       + 3 * GHPLs2[3*4+0]
						       - 3 * HPLs2[0*2+0]
						       - 3 * HPLs2[0*2+1]
						       )

    + C_F * ri * M_PI * pow(v, 2) * pow(1. - u, -2) * (
						       + 10 * zeta2
						       - 5 * GHPLs2[3*4+2]
						       - 5 * GHPLs1[2] * HPLs1[0]
						       + 3 * GHPLs1[3]
						       - 5 * GHPLs2[3*4+0]
						       + 5 * HPLs2[0*2+0]
						       + 5 * HPLs2[0*2+1]
						       )

    + C_F * ri * M_PI * pow(v, 2) * pow(1. - u, -1) * (
						       - 3.0/2
						       - 8 * zeta2
						       + 4 * GHPLs2[3*4+2]
						       + 1.0/2 * GHPLs1[2]
						       + 4 * GHPLs1[2] * HPLs1[0]
						       - 7.0/2 * GHPLs1[3]
						       + 4 * GHPLs2[3*4+0]
						       + 1.0/2 * GHPLs1[0]
						       - GHPLs1[1]
						       + 1.0/2 * HPLs1[0]
						       - 4 * HPLs2[0*2+0]
						       - 1.0/2 * HPLs1[1]
						       - 4 * HPLs2[0*2+1]
						       )

    + C_F * ri * M_PI * pow(v, 2) * (
				     - 2.0/3
				     + 3.0/2 * GHPLs1[2]
				     + 2 * GHPLs2[1*4+2]
				     - 2 * GHPLs2[2*4+3]
				     + 2 * GHPLs2[3*4+3]
				     - 13.0/6 * GHPLs1[3]
				     + 2 * GHPLs1[3] * HPLs1[0]
				     + 2 * GHPLs1[3] * HPLs1[1]
				     - 2 * GHPLs2[0*4+3]
				     + 3.0/2 * GHPLs1[0]
				     - 7.0/2 * GHPLs1[1]
				     - 13.0/6 * HPLs1[0]
				     - 3.0/2 * HPLs1[1]
				     )

    + C_F * ri * M_PI * pow(v, 3) * (
				     - 7.0/3 * GHPLs1[2]
				     - 4 * GHPLs2[1*4+2]
				     + 4 * GHPLs2[2*4+3]
				     - 4 * GHPLs2[3*4+3]
				     + 7.0/3 * GHPLs1[3]
				     - 4 * GHPLs1[3] * HPLs1[0]
				     - 4 * GHPLs1[3] * HPLs1[1]
				     + 4 * GHPLs2[0*4+3]
				     - 7.0/3 * GHPLs1[0]
				     + 7.0/3 * GHPLs1[1]
				     + 7.0/3 * HPLs1[0]
				     + 7.0/3 * HPLs1[1]
				     )

    + C_F * ri * M_PI * u * pow(1. - v, -2) * (
					       + GHPLs2[3*4+2]
					       + 2 * GHPLs1[2] * HPLs1[0]
					       - GHPLs2[1*4+2]
					       - GHPLs2[3*4+0]
					       + GHPLs2[1*4+0]
					       - 2 * HPLs1[0]
					       + HPLs2[0*2+0]
					       )

    + C_F * ri * M_PI * u * pow(1. - v, -1) * (
					       - 4
					       - GHPLs2[3*4+2]
					       - 2 * GHPLs1[2] * HPLs1[0]
					       + GHPLs2[1*4+2]
					       + GHPLs1[3]
					       + GHPLs2[3*4+0]
					       - GHPLs2[1*4+0]
					       + GHPLs1[1]
					       + 3 * HPLs1[0]
					       - HPLs2[0*2+0]
					       )

    + C_F * ri * M_PI * u * (
			     + 1
			     - 1.0/2 * GHPLs1[2]
			     + 1.0/2 * GHPLs1[3]
			     - 1.0/2 * GHPLs1[0]
			     + 1.0/2 * GHPLs1[1]
			     + 1.0/2 * HPLs1[0]
			     + 1.0/2 * HPLs1[1]
			     )

    + C_F * ri * M_PI * u * v * (
				 - 1.0/3
				 - 2.0/3 * zeta2
				 + 7.0/3 * GHPLs1[2]
				 + 2.0/3 * GHPLs2[1*4+2]
				 - 2.0/3 * GHPLs2[2*4+3]
				 + 2.0/3 * GHPLs2[3*4+3]
				 - 3 * GHPLs1[3]
				 + 2.0/3 * GHPLs1[3] * HPLs1[0]
				 + 2.0/3 * GHPLs1[3] * HPLs1[1]
				 - 2.0/3 * GHPLs2[0*4+3]
				 - 2.0/3 * GHPLs2[3*4+0]
				 + 7.0/3 * GHPLs1[0]
				 - 2.0/3 * GHPLs1[0] * HPLs1[0]
				 + 2.0/3 * GHPLs2[2*4+1]
				 - 3 * GHPLs1[1]
				 - 2.0/3 * GHPLs1[1] * HPLs1[1]
				 + 2.0/3 * GHPLs2[0*4+1]
				 - 2.0/3 * GHPLs2[1*4+1]
				 - 3 * HPLs1[0]
				 + 2.0/3 * HPLs2[0*2+0]
				 + 2.0/3 * HPLs2[1*2+0]
				 - 7.0/3 * HPLs1[1]
				 )

    + C_F * ri * M_PI * u * pow(v, 2) * (
					 + 2.0/3 * zeta2
					 - 11.0/3 * GHPLs1[2]
					 - 8.0/3 * GHPLs2[1*4+2]
					 + 8.0/3 * GHPLs2[2*4+3]
					 - 8.0/3 * GHPLs2[3*4+3]
					 + 11.0/3 * GHPLs1[3]
					 - 8.0/3 * GHPLs1[3] * HPLs1[0]
					 - 8.0/3 * GHPLs1[3] * HPLs1[1]
					 + 8.0/3 * GHPLs2[0*4+3]
					 + 2.0/3 * GHPLs2[3*4+0]
					 - 11.0/3 * GHPLs1[0]
					 + 2.0/3 * GHPLs1[0] * HPLs1[0]
					 - 2.0/3 * GHPLs2[2*4+1]
					 + 11.0/3 * GHPLs1[1]
					 + 2.0/3 * GHPLs1[1] * HPLs1[1]
					 - 2.0/3 * GHPLs2[0*4+1]
					 + 2.0/3 * GHPLs2[1*4+1]
					 + 11.0/3 * HPLs1[0]
					 - 2.0/3 * HPLs2[0*2+0]
					 - 2.0/3 * HPLs2[1*2+0]
					 + 11.0/3 * HPLs1[1]
					 )

    + C_F * ri * M_PI * pow(u, 2) * (
				     + 3.0/2 * GHPLs1[2]
				     - 3.0/2 * GHPLs1[3]
				     + 3.0/2 * GHPLs1[0]
				     - 3.0/2 * GHPLs1[1]
				     - 3.0/2 * HPLs1[0]
				     - 3.0/2 * HPLs1[1]
				     )

    + C_F * ri * M_PI * pow(u, 2) * v * (
					 + 2.0/3 * zeta2
					 - 3 * GHPLs1[2]
					 - 2.0/3 * GHPLs2[1*4+2]
					 + 2.0/3 * GHPLs2[2*4+3]
					 - 2.0/3 * GHPLs2[3*4+3]
					 + 3 * GHPLs1[3]
					 - 2.0/3 * GHPLs1[3] * HPLs1[0]
					 - 2.0/3 * GHPLs1[3] * HPLs1[1]
					 + 2.0/3 * GHPLs2[0*4+3]
					 + 2.0/3 * GHPLs2[3*4+0]
					 - 3 * GHPLs1[0]
					 + 2.0/3 * GHPLs1[0] * HPLs1[0]
					 - 2.0/3 * GHPLs2[2*4+1]
					 + 3 * GHPLs1[1]
					 + 2.0/3 * GHPLs1[1] * HPLs1[1]
					 - 2.0/3 * GHPLs2[0*4+1]
					 + 2.0/3 * GHPLs2[1*4+1]
					 + 3 * HPLs1[0]
					 - 2.0/3 * HPLs2[0*2+0]
					 - 2.0/3 * HPLs2[1*2+0]
					 + 3 * HPLs1[1]
					 )

    + C_F * ri * M_PI * pow(u, 3) * (
				     - GHPLs1[2]
				     + GHPLs1[3]
				     - GHPLs1[0]
				     + GHPLs1[1]
				     + HPLs1[0]
				     + HPLs1[1]
				     );
  return gamma;
}
